<?php

namespace HCM\Geral\Services;

use HCM\Geral\Repository\CboRepository;
use Zeedhi\Framework\DTO\Response\Message;
use Zeedhi\Framework\DTO\Response\Notification;
use Zeedhi\Framework\DTO\Response;

class CboService
{
    private $response;
    private $cboRepository;

    public function __construct(CboRepository $cboRepository)
    {
        $this->cboRepository = $cboRepository;
    }

    public function verificaNrCboDessaRow(Object $row): void
    {
        $cboDessaRowPossuiNrCboJaExistente = $row['__is_new'] && self::existeCboComEsseNrCbo($row['NRCBO']);

        if ($cboDessaRowPossuiNrCboJaExistente) {
            $msg = 'Existe item com esse mesmo Nr. CBO';

            $this->response->addNotification(new Notification($msg, Notification::TYPE_ERROR));
            $this->response->addMessage(new Message($msg, Message::TYPE_ERROR));
        }
    }

    public function existeCboComEsseNrCbo(Int $nrCbo): bool
    {
        $cbo = $this->cboRepository->findCboPorNumero($nrCbo);
        return !empty($cbo);
    }

    public function setResponseObject(Response $response): void
    {
        $this->response = $response;
    }
}