<?php
namespace CustomerPortal\Repositories;


class CallComment extends \Doctrine\ORM\EntityRepository {
    public function getCallComments($callID) {
        $query = "
            SELECT CC.ID AS ID, 'Criado dia '||TO_CHAR(CC.CREATED_AT, 'DD/MON/YYYY')||' por '||OP.NMOPERADOR AS NAME,
                   CC.DESCRIPTION AS DESCRIPTION, TO_CHAR(CC.CREATED_AT, 'DD/MM/YYYY HH:MM:SS') AS CREATED_AT
            FROM CALL_COMMENT CC
            LEFT JOIN OPERADOR OP ON OP.CDOPERADOR = CC.CREATED_BY
            WHERE CC.CALL = :CALL_ID
            ORDER BY CC.CREATED_AT DESC
        ";

        $params = array(
            "CALL_ID" => $callID
        );

        return $this->getEntityManager()->getConnection()->fetchAll($query, $params);
    }

    public function getSupportCallCommentsFromCRM($contatoId, $createdBy) {
        $query = "
            SELECT EV.NRSEQEVOLCONT AS ID, 'Criado dia '||TO_CHAR(EV.DTINCLUSAO, 'DD/MON/YYYY')||' por '||OP.NMOPERADOR AS NAME,
                   EV.TXEVOLCONT AS DESCRIPTION, TO_CHAR(EV.DTINCLUSAO, 'DD/MM/YYYY HH:MM:SS') AS CREATED_AT
            FROM EVOLCONT EV
            LEFT JOIN OPERADOR OP ON OP.CDOPERADOR <> :CREATED_BY
            WHERE EV.NRCONTATO = :CONTATO_ID AND EV.CDOPEREVOL <> :CREATED_BY
            ORDER BY EV.DTINCLUSAO DESC
        ";

        $params = array(
            "CONTATO_ID" => $contatoId,
            "CREATED_BY" => $createdBy
        );

        return $this->getEntityManager()->getConnection()->fetchAll($query, $params);
    }

    public function getProductCallCommentsFromSolicitacao($nrSoliServ, $createdBy) {
        $query = "
            SELECT 'Criado dia '||TO_CHAR(LFT.DTINCLUSAO, 'DD/MON/YYYY')||' por '||OP.NMOPERADOR AS NAME,
                    LFT.TXACAOLFTRAM||CHR(10)||CHR(10)||CHR(13)||LFT.DSALFASETRAM AS DESCRIPTION,
                     TO_CHAR(LFT.DTINCLUSAO, 'DD/MM/YYYY HH:MM:SS') AS CREATED_AT
            FROM LOGFASETRAM LFT
            LEFT JOIN OPERADOR OP ON OP.CDOPERADOR = LFT.CDOPERADOR
            WHERE LFT.NRSOLISERV = :NRSOLISERV AND LFT.CDOPERADOR <> :CREATED_BY
            ORDER BY LFT.DTINCLUSAO DESC
        ";

        $params = array(
            "NRSOLISERV" => $nrSoliServ,
            "CREATED_BY" => $createdBy
        );

        return $this->getEntityManager()->getConnection()->fetchAll($query, $params);
    }
} 