/*****************************************************************************
* Sistemas Integrados TECNISA                                                *
*                                                                            *
* Nome: 0099_GERSTP_PROXIMO_DIA                                              *
*                                                                            *
* Descrio:                                                                 *
* Calcula a data de um dia da semana                                         *
*                                                                            *
*                                                                            *
* Criao:                                                                   *
* 08/01/99 - Yoris L. de Souza                                               *
*                                                                            *
* Manutenes:                                                               *
******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE 
            o.name = 'PROXIMO_DIA'  and 
            type = 'P'                  and
            u.uid = o.uid               and 
            u.name = USER)
  DROP PROCEDURE PROXIMO_DIA
  GO

CREATE PROCEDURE PROXIMO_DIA
   @P_DIENTREGA   INT,
   @P_NROCORR     INT,
   @P_DTPROXIMA   DATETIME OUTPUT
AS
   DECLARE @V_CONTAUXI   NUMERIC(10);

BEGIN
  SET @V_CONTAUXI = 0;
  WHILE (@V_CONTAUXI <> @P_NROCORR)
  BEGIN
    SET @P_DTPROXIMA = DATEADD(DD,CASE
         WHEN (@P_DIENTREGA - DATEPART(DW,@P_DTPROXIMA)) > 0 THEN
              (@P_DIENTREGA - DATEPART(DW,@P_DTPROXIMA))
         ELSE
              7 + (@P_DIENTREGA - DATEPART(DW,@P_DTPROXIMA))
         END
         ,@P_DTPROXIMA);
    SET @V_CONTAUXI = @V_CONTAUXI + 1;
  END;
END;
GO

