/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_CLASSEVOO                                                */
/* Tabela : CLASSEVOO                                                         */
/*                                                                            */
/* Criao:                                                                   */
/* 04/05/2004 - David Moreno Ferreira                                         */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_CLASSEVOO' and
            type = 'TR'               and
            u.uid = o.uid             and
            u.name = USER)
   DROP TRIGGER DTULTATU_CLASSEVOO
GO

CREATE TRIGGER DTULTATU_CLASSEVOO
ON CLASSEVOO
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'CLASSEVOO', null, 'CDFILIAL='+ CDFILIAL+ ';'+
                                        'CDCIA='   + CDCIA   + ';'+
                                        'NRVOO='   + NRVOO   + ';'+
                                        'CDCLASSE='+ CDCLASSE+ ';'+
                                        'CDTRECHO='+ CDTRECHO+ ';', GETDATE() FROM DELETED)
   END
   ELSE BEGIN
      UPDATE CLASSEVOO
      SET DTULTATUCVOO = GETDATE()
      FROM INSERTED;
   END;
END;
GO

