// FILE: assets/js/utilities/HcmConsts.js
function HcmConsts () {

    /* Tipos de Movimento */
    this.TP_MOV_MENSAL = 1;
    this.TP_MOV_FERIAS = 2;
    this.TP_MOV_FERIAS_13SAL = 3;
    this.TP_MOV_13SAL = 4;
    this.TP_MOV_FERIAS_VENC_RESC = 5;
    this.TP_MOV_FERIAS_PROP_RESC = 6;
    this.TP_MOV_FERIAS_DOBRO_RESC = 7;
    this.TP_MOV_13SAL_RESC = 8;
    this.TP_MOV_AVISO_PREVIO_RESC = 9;
    this.TP_MOV_ADIANTAMENTO = 10;
    this.TP_MOV_FERIAS2 = 11;
    this.TP_MOV_FERIAS2_13SAL = 12;
    this.TP_MOV_PROV_FERIAS_VENC = 13;
    this.TP_MOV_PROV_FERIAS_PROP = 14;
    this.TP_MOV_PROV_13SAL = 15;
    this.TP_MOV_PROV_AVISO_PREVIO = 16;  
    this.TP_MOV_VALE_TRANSPORTE = 17;
    this.TP_MOV_SALARIO_MATERNIDADE = 18; 
    this.TP_MOV_PLR = 19;  
    this.TP_MOV_MEDIA_MENSAL = 20;  
    this.TP_MOV_BENEFICIO = 21;
    
    this.tipoVinculo = {
        "CLT": 1,
        "ESTAGIARIO": 2,
        "SOCIO": 3,
        "CONTRATO_TEMPORARIO": 9,
        "AUTONOMO": 10
    };
    
    this.TpEstrutura = {
        "CENTROCUSTO": 5,
        "DEPARTAMENTO": 3,
        "EMPRESA": 1,
        "EQUIPE": 6,
        "ESCOLA": 14,
        "FILIAL": 2,
        "PLANODESAUDE": 13,
        "PRODUTO": 12,
        "PROJETO": 9,
        "REGIAO": 8,
        "SECAO": 11,
        "SETOR": 4,
        "SINDICATO": 10,
        "TOMADORDESERVICOS": 7
    };
    
    this.FormaComu = {
        "TELPRINCIPAL": '01',
        "TELRESIDEN": '03',
        "TELCOMERC": '04',
        "CELPARTIC": '02',
        "CELCOMERC": '06',
        "FAX": 10,
        "EMAIL": '05'
    };

    this.GpeSitufunc = {
        SITUACAO_FUNCIONAL_NORMAL: 1,
        SITUACAO_FUNCIONAL_MATERNIDADE: 5,
        SITUACAO_FUNCIONAL_DOENCA_MAIOR_15: 6,
        SITUACAO_FUNCIONAL_ATESTADO: 12,
        SITUACAO_FUNCIONAL_DOENCA_MENOR_15: 15
    };

    this.GpeTpmovtransfm = {
        TRANSFERENCIA_SAIDA: 9
    };
    
    this.RelacionaParc = {
        "PAI": 2,
        "MAE": 1,
        "FILHO": 3,
        "CONJUGE": 4,
        "TUTELADO": 5,
        "PENSIONISTA": 6,
        "COMPANHEIRO": 7,
        "AVO": 9,
        "TIO": 12,
        "LIDER": 20,
        "INTERLOCUTOR": 25,
        "PARCEIRO": 61,
        "OUTROS": 100000
    };
    
    this.IdProgramacaoOcorrenciaConfirmada = {
        Confimada:  'S',
        Rejeitada:  'N',
        Pendente:   'P',
    };
    
    this.TpProgOcorrencia = {
        abonarSaida: 17,
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('HcmConsts', HcmConsts);
});

// FILE: assets/js/utilities/Messages.js
/**
 * Created by laraloures on 23/06/2016.
 */
function Messages() {

    this.EXEMPLE = 'Exemple';
    
    this.SUCCESS_MESSAGE_CODE = 10;
    this.ALERT_MESSAGE_CODE = 20;
    this.ERROR_MESSAGE_CODE = 30;
    
    this.TEXT_BREAK = '<br><br>';

    /* + ----------------------------------- +
     * | Error messages                      |
     * + ----------------------------------- + */
    this.CATCH_EXCEPTION_ERROR = function(error) {
        var msgError = error.replace(/[<>]/g,'');
        return 'Ocorreu um erro inesperado, contate o administrador informando o trecho abaixo: <br><br>' + msgError + '<br><br>';
    };
    this.PISO_MAIOR_QUE_TETO = 'O valor de Piso deve ser menor ou igual ao de Teto';
    this.SAVE_ROW_ERROR = 'Erro ao salvar o registro';
    this.REMOVE_ROW_ERROR = 'Erro ao excluir o registro';

    this.IMPORTACAO_ERROR = 'Erro ao realizar importação';
    this.EXPORTACAO_ERROR = 'Erro ao realizar a exportação';

    this.PROCESSO_ERROR = 'Erro ao realizar processo';

    this.CADASTRO_AUTOMATICO_ERRO = 'Cadastro automático finalizado com erros';
    this.EXCLUSAO_AUTOMATICA_ERRO = 'Exclusão automática finalizado com erros';

    this.DADOS_NAO_ENCONTRADOS_ERROR = 'Dados não encontrados';

    this.DUPLICATE_PRIMARY_KEY_ERROR = 'Impossível salvar.<br>O código já existe.';
    this.DUPLICATE_CODE_OR_NAME_ERROR = 'Impossível salvar.<br>O código ou o nome já existe.';
    
    this.SELECT_AT_LEAST_ONE_REGISTER_WARNING = 'Selecione ao menos um registro para prosseguir.';

    this.CPF_ERROR = 'CPF inválido';
    this.CPF_EXISTS = 'CPF já cadastrado para a pessoa ';
    this.PIS_PASEP_ERROR = 'PIS/PASEP inválido';
    this.FOTO_EXISTE_ERROR = 'Foto ja cadastrada';
    this.DT_NASC_ERROR = 'A data de nascimento não pode ser posterior ou igual a data atual';
    this.DTINI_POST_DTFIM_ERROR = 'A data final deve ser igual ou posterior à data inicial';
    this.DATA_POST_DTATUAL_ERROR = 'Data deve ser igual ou posterior à data atual';
    this.DATAINI_MES_COMPETENC_ERROR = 'Data inicial deve estar no mês da competencia';
    this.QTINI_POST_QTFIM_ERROR = 'A Qtd. Final  deve ser igual ou posterior a Qtd. Inicial';
    this.QTDIAS_GOZO_MAIOR_30_ERROR = "O gozo de férias não deve ter mais que 30 dias";
    this.INICIO_GOZO_RETROATIVO_ERROR = "O início do gozo não pode ser retroativo";
    this.DATA_ALTER_SALARIO_RETROATIVA_ERROR = "A data da alteração salarial não pode ser retroativa";
    this.ORGANIZACAO_NAO_POSSUI_MASCARA = "Impossível realizar operação. A organização não possui máscara cadastrada.";
    this.CODIGO_COM_LETRA = "O código possui letra. Deve conter apenas números.";
    this.FILE_UPLOAD_FAIL = "Não foi possível realizar o upload do(s) arquivo(s).";
    this.FILE_DOWNLOAD_FAIL = "Não foi possível realizar o download do(s) arquivo(s).";
    this.REGISTER_FILE_NOT_FOUND = "Não existem arquivos associados ao registro.";
    this.REMOVE_FILE_CONFIRMATION = "Deseja realmente remover o arquivo associado à etapa? Essa operação não pode ser desfeita.";
    this.REMOVE_FILE_FAIL = "Não foi possível remover o(s) arquivo(s)";
    this.FILE_EXTENSION_INVALID = "Atenção! Tipo de arquivo não suportado!";
    this.FILE_SUPORTED_LIST = " Os tipos de arquivo suportados são: ";
    this.SERVICE_UNAVAILABLE = "Serviço indisponível! Novas funcionalidades serão adicionadas em breve.";
    
    // ADMISSAO
    this.HCMOOOOO_GER_ADMISSAO_CONTRATOVERAMAR_DATANASC = "A idade do vínculo deve está na faixa de 18 a 29 anos."; 
    this.HCMOOOOO_GER_ADMISSAO_CONTRATOVERAMAR_TPADMISSAO = "O tipo de admissao deve ser 1 - Admissão de empregado no primeiro emprego (com registro)."; 
    this.HCMOOOOO_GER_ADMISSAO_CONTRATOVERAMAR_PRAZO = "O prazo desse tipo de contrato deve ser de, no máximo, 24 meses."; 
    this.HCMOOOOO_GER_ADMISSAO_CONTRATOVERAMAR_SALARIO = "O valor do salário deve ser menor ou igual a 1,5 do salário mínimo.";
    
    //PESSOA
    this.HCM00000_GER_PESSOA_IGUAL_PESSOARELAC_ERROR = "Favor informar uma pessoa relacionada diferente da pessoa a qual esta relacionando";
    this.HCM00000_GER_PESSOA_DTNASC_PESSOA_ERROR = "Favor informar a data de nascimento da pessoa";
    this.HCM00000_GER_PESSOA_DTNASC_PESSOA_PRINCIPAL_ERROR = "Favor informar a data de nascimento da pessoa principal.";
    this.HCM00000_GER_PESSOA_DTNASC_PESSOARELAC_ERROR = "Favor informar a data de nascimento da pessoa relacionada";
    this.HCM00000_GER_PESSOA_DTNASC_MAIOR_ERROR = "Filho(a) não deve ter data de nascimento maior que os Pais ou Avós";
    this.HCM00000_GPE_MOVIMENTACAO_DTFIM_TRANSF_SAIDA_ERROR = "Data fim da movimentação deve ser informada para transferências de saída";
    
    //ESTRUTURA
    this.HCM00044_VERIFICA_LOGO_EXISTENTE ="Atenção! Já existe uma logo para esta estrutura. Por favor, primeiro exclua a logo atual para prosseguir. ";

    //AVL
    this.HCM03000_AVL_APURACAO_SUCESSO = "Apuração Feita com Sucesso";
    this.HCM03000_AVL_APURACAO_FALHA = "Apuração Falhou";
    this.HCM03000_AVL_REVERTER_SUCESSO = "Revertido";
    this.HCM03000_AVL_REVERTER_FALHA = "Falha na reversão";
    this.HCM03000_AVL_PENDENTES_NOTIFICADOS = "Pendentes Notificados!";
    this.HCM03000_AVL_PENDENTES_FALHA = "Erro ao notificar os pendentes"; 
    this.HCM03000_AVL_APURACAO_FALHA = "Apuração Falhou";
    this.QUESTOES_VINCULADAS = "Este Nível de Avaliações possui Questões vinculadas a ele, deseja deletá-las e então deletar o nível?";
    this.HCM03000_AVL_CADASTRO_AUTOMATICO_QUESTIONARIO = "Deseja cadastrar esta resposta para todas as questões deste questionário?";
    this.HCM03000_AVL_QUESTOES_TIPO_VINCULADAS = "Este Tipo de Avaliações possui Questões vinculadas a ele, deseja deletá-las e então deletar o tipo?";
    this.HCM03000_AVL_FAIXA_VINCULADAS = "Este Critério de Resultado possui Faixas de Valores vinculadas a ele, deseja deletá-las e então deletar o critério?";
    this.HCM03000_AVL_IMPORTACAO = "Deseja importar Registros?";
    this.HCM03000_AVL_RETROCESSO_SUCESSO = "Retrocesso Feito com Sucesso";
    this.HCM03000_AVL_RETROCESSO_FALHA = "Retrocesso Falhou";
    this.HCMO3000_AVL_LIBERACAO = "Deseja liberar Avaliação?";
    
    // VAB
    this.HCM02000_VAB_PER_CALC_COMP_ERROR = 'O período do cálculo deve estar na competência';
    this.HCM02000_VAB_OBS_VALOR_BENEFICIARIO = 'O registro possui valor diferente da tabela de faixa etária';
    this.HCM02000_VAB_BENEFICIO_TABELA_PRI_INF = 'Tabela primária do benefício não informada';
    this.HCM02000_VAB_BENEFICIO_TABELA_SEC_INF = 'Tabela secundária do benefício não informada';
    this.HCM02000_VAB_BENEFICIO_TABELA_PRI_SEC_INF = 'Tabelas primária e secundária do benefício não informadas';
 
    this.HCM02014_VAB_BENEFICIARIO_EXISTENTE = "Beneficiário já cadastrado";
    this.HCM02014_VAB_DTNASCIMENTO_NAO_INFORMADA = "Data de nascimento da pessoa  não informada";
    this.HCM02014_VAB_BENEFICIO_FAIXA_TIT_NULL_VLR_MENS_TIT_NULL = 'Os campos "Faixa Etária Titular" <br>e "Valor Mensalidade" <br>não podem simultâneamente ficar vazios';
    this.HCM02014_VAB_BENEFICIO_FAIXA_DEP_NULL_VLR_MENS_DEP_NULL = 'Os campos "Faixa Etária Dependente" <br>e "Valor Mensalidade (Dependente)" <br>não podem simultâneamente ficar vazios';
    this.HCM02014_VAB_BENEFICIO_FIM_VIGENCIA_MENOR_INICIO_VIGENCIA = 'O campo "Fim Vigência" deve ser igual ou posterior ao campo "Início Vigência"';
    this.HCM02014_VAB_BENEFICIO_SUBSIDIADO100_TITULAR = 'Para ser subdiado em 100%, no benefício deve haver cadastrado "Evento Titular Empresa".';
    this.HCM02014_VAB_BENEFICIO_SUBSIDIADO100_DEPENDENTE = 'Para ser subdiado em 100%, no benefício deve haver cadastrado "Evento Dependente Empresa".';
    this.HCM02014_VAB_BENEFICIO_DTINSCRICAO_POR_IDATIVO = 'Para Inativar o beneficiário, o valor do campo "Dt Cancelamento" deve ser menor que a Competencia';
    
    this.HCM02012_VAB_RELATCUSTOMVALETRANSPORTE_INTEVALO_DATA_ERRO = 'O intervalo do campo "Início da Apuração" é maior que o intervalo do campo "Fim da Apuração"';

    // FPA
    this.HCM01000_FPA_CALCULO_APROVACALCULO_SUCESS = "Aprovação realizada com sucesso! <br>Fechamento gerado.";
    this.HCM01062_FPA_DESPESA_EXISTENTE_EM_EVENTCTBL = "Impossível excluir.<br>O registro existe em Associação Contábil";
    this.HCM01062_FPA_DUPLICATE_PRIMARY_KEY_ERROR = 'Impossível salvar.<br>A despesa já existe.';
    this.HCM01037_FPA_REGISTRO_EXISTENTE = "Impossível salvar.<br>O registro já existe.";
    this.HCM01037_FPA_REGISTROS_EXISTENTES = "Impossível salvar.<br>Todos os registros já existem.";
    this.HCM01037_FPA_TODOS_EVENTOS_SELECIONADO = "Impossível salvar todos os eventos.";
    this.HCM01037_FPA_FIM_VIGENCIA_MENOR_INICIO_VIGENCIA = 'O campo "Fim Vigência" deve ser igual ou posterior ao campo "Início Vigência"';
    this.HCM01037_FPA_DATA_INICIAL_MAIOR_QUE_FINAL = "Impossível que a data do fim da vigência seja anterior a data inicial da vigência";
    this.HCM01046_REQUIRED_CPF_ERROR = "Impossível salvar.<br>É necessário cadastrar o CPF para a pessoa do dependente.";
    this.HCM01077_FPA_VALOR_NULO = "Nenhum cadastro realizado!<br>Não foram encontrados valores para o tipo de incidência informada.";
    this.HCM01016_FPA_EXISTE_ITEM_GRUPO_INCIDENCIA = "O número do item já existe. Por favor escolha outro numero";
    this.HCM010011_FPA_EXISTE_CADASTRO_CBO = "O número do CBO já existe. Por favor escolha outro numero";

    
    // eSocial
    this.HCM09000_ESO_CALLED_EVENTO_ERROR = "Erro ao montar dados de envio para o evento informado";
    this.HCM09000_ESO_CARGAINI_EXISTS_ERROR = "Processo de carga inicial já realizado para a estrutura";
    this.HCM09000_ESO_CERTIFICADO_NOT_FOUND_ERROR = "Certificado do transmissor não encontrado. Favor carregar o certificado na tela 'Parametros do eSocial'.";
    this.HCM09000_ESO_CERTIFICADO_NOT_OPEN_ERROR = "Não foi possível ler o certificado do transmissor. Favor tentar novamente.";
    this.HCM09000_ESO_CERTIFICADO_VALIDADE_ERROR = "Certificado do transmissor com validade vencida. Favor carregar um novo certificado na tela 'Parametros do eSocial'.";
    this.HCM09000_ESO_ENVIOS_NOT_FOUND_ERROR = "Não foram encontrados itens para filtro informado";
    this.HCM09000_ESO_EXCLUSAO_ERROR = "Não é possível excluir eventos que já foram enviados";
    this.HCM09000_ESO_FILE_LOTE_NOT_FOUND_ERROR = "Arquivo de lote não encontrado para envio";
    this.HCM09000_ESO_GENERATE_CERT_KEY_ERROR = "Certificado inválido ou senha inválida";
    this.HCM09000_ESO_IDEVENTO_INVALID_ERROR = "Evento com ID inválido. Favor verificar a inscrição do empregador e seu tipo (CNPJ ou CPF), e reenviar o evento";
    this.HCM09000_ESO_INSCR_TRANSM_NOT_FOUND_ERROR = "O responsável pela transmissão informado, não possui inscrição";
    this.HCM09000_ESO_EVENTO_MATRIZ_ERROR = "O evento só pode ser enviado por uma estrutura que possua um CNPJ Matriz";
    this.HCM09000_ESO_LOTE_QTDE_ERROR = "O lote pode ser composto, no máximo, por 50 eventos";
    this.HCM09000_ESO_LOTE_STATUS_ERROR = "O lote só pode ser transmitido com eventos pendentes";
    this.HCM09000_ESO_RETIFICA_LOTE_STATUS_ERROR = "O lote só pode ser retificado com eventos de um mesmo tipo concluídos ou concluídos com advertência";
    this.HCM09000_ESO_LOTE_VAZIO_ERROR = "Não foram encontrados dados para envio do lote";
    this.HCM09000_ESO_PARAMETRO_NOT_FOUND_ERROR = "Parãmetro do eSocial não encontrado para a estrutura";
    this.HCM09000_ESO_PRODREST_OPER_ERROR = "Operação válida somente para o ambiente de Produção Restrita";
    this.HCM09000_ESO_SENHA_CERTIFICADO_NOT_FOUND_ERROR = "Senha do certificado do transmissor não encontrada. Favor informar a senha na tela 'Parametros do eSocial'.";
    this.HCM09000_ESO_TPINSCEMPREG_ERROR = "Tipo de inscrição do empregador inválido. O empregador deve ser pessoa júridica ou pessoa física"; 
    this.HCM09000_ESO_TPINSCTRANSM_ERROR = "Tipo de inscrição do responsável pela transmissão inválido. O responsável deve ser pessoa júridica ou pessoa física";
    this.HCM09000_ESO_UNIQUE_ENVIO_ERROR = "Já existe envio para o(s) evento(s) com os mesmos parâmetros";

    this.AVISO_ESO_PENSALIDADE_ADMISSAO_DATA_RETROATIVA = "Atenção! Admissão com data retroativa sujeita a penalidade do eSocial conforme Art. 47 da CLT – Lei 13.467/17.";
    this.AVISO_ESO_PENSALIDADE_AFASTAMENTO_FORA_PRAZO = "Atenção! Afastamento fora do prazo sujeito a penalidade do eSocial conforme Art. 201 da CLT.";
    this.AVISO_ESO_PENSALIDADE_AFASTAMENTO_GOZO_FERIAS_FORA_PRAZO = "Atenção! Afastamento fora do prazo sujeito a penalidade do eSocial conforme Art. 153 da Lei 7.855/89 .";
    this.AVISO_ESO_PENSALIDADE_REGISTRO_DATA = "Atenção! Registro com data sujeita a penalidade do eSocial conforme Art. 22 da CLT – Lei 8.213/91";
    this.AVISO_ESO_PENSALIDADE_DATA_RETROATIVA_PRAZO_10_DIAS ="Atenção! Aviso com data retroativa sujeita a penalidade do eSocial conforme prazo de envio de 10 dias contados a partir da data de comunicação.";
    this.AVISO_ESO_PENSALIDADE_RECISAO_DATA_RETROATIVA = "Atenção! Rescisão com data retroativa sujeita a penalidade do eSocial conforme prazo de envio de 10 dias contados a partir da data de desligamento do vínculo.";
    this.AVISO_ESO_PENSALIDADE_REINTEGRACAO_DATA_RETROATIVA = "Atenção! Reintegração com data retroativa sujeita a penalidade do eSocial (deve ser transmitida até o dia 15 do mês subsequente).";
    this.AVISO_ESO_PENSALIDADE_PROCESSO_DATA_RETROATIVA = "Atenção! Processo incluído com data retroativa sujeito a penalidade do eSocial (Deve ser transmitido até o dia 15 do mês subsequente).";
    this.AVISO_ESO_PENSALIDADE_FICHA_MEDICA_DATA_RETROATIVA = "Atenção! Ficha Médica incluída com data retroativa e sujeita a penalidade do eSocial (Deve ser transmitida até o dia 15 do mês subsequente).";
    this.AVISO_ESO_PENSALIDADE_TREINAMENTO_DATA_RETROATIVA = "Atenção! Treinamento incluído com data retroativa sujeito a penalidade do eSocial (Deve ser transmitido até o dia 15 do mês subsequente).";
    this.AVISO_ESO_PENSALIDADE_CONTRIBUICAO_SINDICAL = "Atenção! O evento relativo à contribuição sindical prevista nos arts. 579 e 580 da CLT, deve ser transmitido até o dia 07 de fevereiro de cada ano, para as empresas urbanas em atividade no mês de janeiro, ou até o dia 07 do mês subsequente ao que for obtido o registro ou a licença para o exercício da respectiva atividade. Em relação ao envio do evento pelos empregadores rurais, relativo à contribuição sindical prevista no Decreto-lei nº 1.166/1971, o prazo é o dia 07 de outubro de cada ano.";
    this.AVISO_ESO_PENSALIDADE_ALTERACAO_DATA_RETROATIVA = "Atenção! Alteração com data retroativa sujeita a penalidade do eSocial (Deve ser transmitida até o dia 15 do mês subsequente ).";
    this.AVISO_ESO_PENSALIDADE_PROCESSO_INCLUSAO = "Atenção! Processo de inclusão está sendo realizado após o dia 15 do mês subsequente à respectiva competência e estará sujeita a penalidade do eSocial.";
    this.AVISO_ESO_PENSALIDADE_PROCESSO_TRANSMISSAO = "Atenção! Processo de transmissão está sendo realizado após o dia 15 do mês subsequente à respectiva competência e estará sujeita a penalidade do eSocial.";
    this.AVISO_ESO_PENSALIDADE_FECHAMENTO_MENSAL = "Atenção! Fechamento Mensal está sendo realizado após o dia 15 do mês subsequente à respectiva competência e estará sujeita a penalidade do eSocial.";
    
    // GER
    this.AVISO_GER_PREENCHIMENTO_PARAM_FOLHA = 'Atenção! Os parâmetros de folha devem ser preenchidos antes dos parâmetros de férias!';
    this.AVISO_GER_APPROVAL_CONFIRMATION = 'Deseja realmente aprovar o documento?';
    this.AVISO_GER_REJECTION_CONFIRMATION = 'Deseja realmente recusar o documento?';
    
    // PTO
    this.PTO_SITUFREQPARAM_ORG_CLIENTE_INCLUIDA = 'Já foram incluídos registros da sua organização como parâmetros da situação de frequência.';
    this.PTO_PROGOCORRENCIA_OCOR_ALMOCO_SUCESS = 'A(s) ocorrência(s) foram cadastrada(s) com sucesso';
    this.HCM07003_PTO_MARCACAOPONTO_INSERT_OCORRENCIA_QUESTION = 'Deseja cadastrar ocorrência(s) relacionada à essa(s) marcação(ões)?';
    this.HCM07003_PTO_MARCACAOPONTO_CADAUTO_APENAS_UM_DESCANSO_PERMITIDO = 'Apenas um intervalo de descanso pode ser informado';
    this.HCM07003_PTO_MARCACAOPONTO_CADAUTO_PREENCHER_FILTERS = 'Por favor, preencha pelo menos os dias, um vínculo e/ou uma estrutura para prosseguir com o cadastro automático';
    this.HCM07003_PTO_MARCACAOPONTO_CADAUTO_PREENCHER_ITEMS = 'Adicione ao menos uma marcação para processeguir com o cadastro automático';
    this.HCM07003_PTO_MARCACAOPONTO_CADAUTO_CONFIRMATION_QUESTION = 'Deseja realizar o cadastro das marcações inseridas para os vínculos/estruturas selecionados?';
    this.HCM07003_PTO_MARCACAOPONTO_CADAUTO_CONFIRMATION_SUCCESS = 'O cadastro automático foi realizado com sucesso!';
    this.HCM07014_PTO_SITUACAOFREQUENCIA_REGISTER_WITHOUT_FILTERS_ADDED_CONFIRMATION = 'Atenção! Está sendo cadastrado um registro sem filtros de estruturas. Já existe um registro sem filtros cadastrado e desse modo ambos os eventos incindirão sobre a situação de frequência em questão. Deseja prosseguir?';
    
    //Documento Modelo
    this.HCM10010_GER_EMISSAODOC_NO_DSPTAH = "Houve uma falha ao recuperar o documento modelo salvo. Por favor, repita a operação.";
    this.HCM10010_GER_EMISSAODOC_GETCONTENTS_FAIL = "Não foi possível encontrar o documento.";
    this.HCM10010_GER_EMISSAODOC_PUTCONTENTS_FAIL = "Não foi possível salvar o documento no servidor.";
    this.HCM10010_GER_EMISSAODOC_NO_MNEMONIC = "Não existe nenhum mnemônico para o documento.";
    this.HCM10010_GER_EMISSAODOC_NO_RESULT = "O filtro selecionado não resultou em nenhum vínculo. Por favor, reveja o filtro.";
    this.HCM10010_GER_EMISSAODOC_NOT_ONE_DOT = "O nome de arquivo do documento modelo deve conter apenas um '.' (ponto).";
    this.HCM10010_GER_EMISSAODOC_MIDIASERVER_DOWN = "O servidor de arquivos está indisponível no momento. Por favor tente mais tarde. Se persistir avise a equipe de suporte.";
    this.HCM10010_GER_EMISSAODOC_NOT_FOUND_LIBREOFFICE = "Não foi possível concluir a conversão. Por favor, contate um administrador informando a seguinte mensagem: <br> 'LibreOffice não encontrado no sistema!'.";
    
    //HCM - Manual
    this.HCM_MANUAL_NO_MANUAL = "Em breve, disponibilizaremos a documentação complementar para este processo.";
    
    //Migracao
    this.HCM_MIG_START_CONFIRMATION = "Deseja realmente iniciar uma nova migração?";
    this.HCM_MIG_START_FAIL = "Não foi possível iniciar uma nova migração.";
    this.HCM_MIG_MODEL_FILE_NOT_FOUND = "O arquivo que contém o modelo das planilhas da migração não foi localizado. Verifique novamente as parametrizações ou entre em contato com os responsáveis para mais informações.";
    
    /* + ----------------------------------- +
     * | Successful messages                 |
     * + ----------------------------------- + */

    // VINCULO 
    this.HCM00000_GER_VINCULO_CANCELAADMISSAO_SUCESS = "A admissão do vinculo foi cancelada com sucesso";
    this.HCM00000_GER_VINCULO_APROVAADMISSAO_SUCESS = "A admissão do vinculo foi aprovada com sucesso";
    
    this.HCM0000_GER_PESSOA_APROVAADMISSAO = "Pessoa aprovada para admissão: ";
    this.HCM0000_GER_PESSOA_APROVAADMISSAO_ERRO = "Pessoa sem data de admissão: ";

    this.SAVE_ROW_SUCCESS = 'Registro salvo com sucesso';
    this.REMOVE_ROW_SUCCESS = 'Registro excluído com sucesso';

    this.OPERACAO_SUCESSO = "Operação realizada com sucesso.";
            
    this.CALCULO_SUCCESS = 'Cálculo finalizado com sucesso';
    this.RETROCESSO_SUCCESS = 'Retrocesso finalizado com sucesso';

    this.IMPORTACAO_SUCCESS = 'Importação realizada com sucesso';
    this.EXPORTACAO_SUCCESS = 'Exportação realizada com sucesso';

    this.PROGRAMACAO_SUCCESS = 'Programação finalizada com sucesso';
    this.SIMULACAO_SUCCESS = 'Simulação finalizada com sucesso';

    this.CADASTRO_AUTOMATICO_SUCCESS = 'Cadastro automático finalizado com sucesso';
    this.EXCLUSAO_AUTOMATICA_SUCCESS = 'Exclusão automática finalizado com sucesso';
    this.DEMONSTRATIVO_SEND_SUCCESS = 'Demonstrativo enviado com sucesso';

    this.HCM00000_GER_VERIF_ACTIVATE_SUCCESS = "A validação foi ativada com sucesso";
    this.HCM00000_GER_VERIF_DEACTIVATE_SUCCESS = "A validação foi desativada com sucesso";

    this.HCM09000_ESO_CARGAINICIAL_SUCCESS = "Geração de envios para Carga Inicial realizada com sucesso";
    this.HCM09000_ESO_CONSULTA_SUCCESS = "Consulta realizada com sucesso";
    this.HCM09000_ESO_TRANSMISSAO_SUCCESS = "Transmissão realizada com sucesso";
    this.HCM09000_ESO_FECHAMENTO_SUCCESS = "Fechamento realizado com sucesso";
    
    this.HCM01046_ERRO_CPF_IDADE_VINCULO = "Escolha um dependente com Idade e CPF cadastrados para esse tipo de Dependencia";
    
    this.HCM01020_EXPORTACAO_LOTE_CANCELADA_SUCCESS = "Cancelamento da exportação realizado com sucesso.";
    this.HCM01020_EXPORTACAO_LOTE_SUCCESS = "Exportação do lote realizada com sucesso.";

    /* + ----------------------------------- +
     * | Alert messages                      |
     * + ----------------------------------- + */
    this.DELETE_ROW = 'Deseja realmente excluir o registro?';
    this.SOFT_DELETE_ROW = 'Deseja realmente excluir o(s) registro(s)?<br><br>A exclusão apenas inativará o(s) registro(s).';
    this.REACTIVATE_ROW = 'Deseja realmente ativar novamente o(s) registro(s)?';
    this.SHOW_WANINGS_TITLE = 'As seguntes questões impediram a conclusão da operação:<br><br>';
    
    this.EXECUTAR_OPERACAO = "Deseja realmente que a operação seja executada ?";
    
    this.HCM09000_ESO_ENVIOAUTO_WARNING = "Ocorreram erros durante o processo. Favor verificar os eventos com erro e reenviá-los";
    this.HCM09000_ESO_FECHAMENTO_WARNING = "Ocorreram erros durante o processo. Favor verificar.";
    
    this.HCM01055_FPA_ADMISSAO_IDADE_MENOR_14 = "Idade menor que 14 anos";
    this.HCM01000_FPA_CANCELAMENTO_FERIAS_EXISTEM_VINCULOS_COM_LIQUIDO_FERIAS = "Foram encontrados um ou mais vínculos que possuem férias calculadas na respectiva competência <br /> (<vinculos>).  <br />Deseja prosseguir?";
    
    this.VINCULO_NAO_SELECIONADO = "Nenhum vínculo selecionado.";
    
    this.HCM07009_PTO_INTERVALO_SELECAO_AUSENTE = "Para marcar deve-se informar o intervalo de apuração.";
    
    this.HCM10010_GER_EMISSAODOC_NOTVALID = "Por favor, preencha todos os campos obrigatórios antes de Gerar um Documento.";
    
    /* + ----------------------------------- +
     * | Widgets information                 |
     * + ----------------------------------- + */
    this.HCM01059_FPA_CONTABILIZACAOMENSAL = 
        "Tela destinada a realizar contabilização para gerar resumo contábil e resumo de despesas de acordo com a informação do campo 'Forma de Contabilização'. <br/>"+
        "- A contabilização incluí vínculos ativos, vínculos rescindidos anteriormente com rescisão complementar na competência de processamento e que tenham lançamentos de PLR na competência <br/>"+
        "- Podem ser incluídos vínculos rescindidos anteriormente com lançamentos de benefícios na competência de processamento mediante a criação do valor de referência CONTAB_BENEF_RESC com valor 1 <br/>"+
        "- A contabilização depende dos cadastros realizados na tela 'Associação Contábil' <br/>"+
        "- A contabilização pode ser realizada em 3 tipos usando o valor de referência TIPO_CONTABILIZACAO com os seguintes valores: 1-Para realizar a contabilização independente da estrutura gerencial sumarizando somente pela estrutura legal / 2-Para sumarizar tanto pela estrutura legal como pela estrutura gerencial (casos em que uma única estrutura gerencial pode estar relacionada a várias legais) / 3-Para sumarizar de acordo com a hierarquia da estrutura gerencial (forma também realizada para organizações que não têm o valor de referência cadastrado)";
}

Configuration(function(ContextRegister) {
    ContextRegister.register('Messages', Messages);
});


// FILE: assets/js/utilities/RelatoriosHcmConfig.js
/*/mobile/assets/js/utilities/*/
/* jshint esversion: 6 */
function RelatoriosHcmConfig (localStorageEngine) {
/**  
 * Campos do params (este é um array contendo os seguintes campos):
 * field        nome do field em questão
 * param        nome do parâmetro do relatório
 * required     true / false. Opcioanl. Se true o campo em questão é requerido. Quando não informado a rotina assume false/não requerido
 * label        nome do field na tela. Quando não informado este usa o valor definido em DEFINITIONS
 * row          quando informado este campo cria uma row (simula um campo na tela). Usualemnte para se passar um parâmetro fixo ao relatório. Este tem preferência em relação a row de mesmo nome na tela.
 * row          acessa uma row diretamente, sem necessidade do nome do field
 * value        força um valor para o campo. Este tem preferência em relação ao que é difitado na tela.
 * valueField   valore que será exibido no campo quando se selecionar o relatório (valor default do campo).
 * 
 * Campos do config:
 * itemName     nome que será exibido na lista de relatórios
 * fileName     nome interno do relatório, sem a extensão.
 * order        ordem de exibição do relatório
 * download     opcional. Array que indica dados sobre o download do relatório em questão
 * format       opcional. Força a emissão do relatório no formato informado
 * 
 * Campos do download:
 * 
 */
    /*Campo de lista dos relatórios*/
    this.LISTNAME = 'NMRELATORIO_LIST';
    
    /*Definições de campos*/
    this.DEFINITION = {
        competencia:        { name: "DTMESCOMPETENCIA",     row: "DTMESCOMPETENCIA",        multi: false, label: "Data de Competência Inicial"  },
        competencia2:       { name: "DTMESCOMPETENCIA2",    row: "DTMESCOMPETENCIA2",       multi: false, label: "Data de Competência"          },
        tipomovimento1:     { name: "NMTIPOMOVIMENT_RES",   row: "NRTIPOMOVIMENT_RES",      multi: false, label: "Tipo de Movimento"            },
        tipomovimentoMulti: { name: "NMTIPOMOVIMENT_LIST",  row: "NRTIPOMOVIMENT_LIST",     multi: true,  label: "Tipo de Movimento"            },
        nrestrutlegal:      { name: "NMESTRUTLEGAL",        row: "NRESTRUTLEGAL",           multi: false, label: "Estrutura Legal"              },
        nrestrutlegal2:     { name: "NMESTRUTLEGAL2",       row: "NRESTRUTLEGAL2",          multi: false, label: "Estrutura Legal"              },
        nrestrutlegal3:     { name: "NMESTRUTLEGAL3",       row: "NRESTRUTLEGAL3",          multi: false, label: "Estrutura Legal"              },
        nrestrutgeren:      { name: "NMESTRUTGEREN",        row: "NRESTRUTGEREN",           multi: false, label: "Estrutura Gerencial"          },
        nrestrutgeren2:     { name: "NMESTRUTGEREN2",       row: "NRESTRUTGEREN2",          multi: false, label: "Estrutura Gerencial"          },
        nrestrutlegalMulti: { name: "NRESTRUTLEGAL_LIST",   row: "NRESTRUTLEGAL_LIST",      multi: true,  label: "Estrutura Legal"              },
        nrestrutgerenMulti: { name: "NRESTRUTGEREN_LIST",   row: "NRESTRUTGEREN_LIST",      multi: true,  label: "Estrutura Gerencial"          },
        nrestrutsind:       { name: "NMESTRUTSIND",         row: "NRESTRUTSIND",            multi: false, label: "Estrutura Sindical"           },
        tpestrut:           { name: "NMTIPOESTRUTURA",      row: "NRTIPOESTRUTURA",         multi: false, label: "Tipo Estrutura"               },
        tipohierarquia:     { name: "NMTIPOHIERARQORG",     row: "NRTIPOHIERARQORG",        multi: false, label: "Nome da Hierarquia"           },
        tipohierarquiaMulti:{ name: "NRTIPOHIERARQORG2",    row: "NRTIPOHIERARQORG2",       multi: true,  label: "Tipo de Hierarquia"           },
        nrestrutsupMulti:   { name: "NRESTRUTSUPERIOR",     row: "NRESTRUTSUPERIOR",        multi: true,  label: "Estrutura Superior"           },
        nrestrutsup:        { name: "NMESTRUTSUPERIOR",     row: "NRESTRUTSUPERIOR",        multi: false, label: "Estrutura Superior"           },
        nrvinculo:          { name: "NMVINCULOM",           row: "NRVINCULOM",              multi: false, label: "Vínculo"                      },
        nrvinculoResc:      { name: "NMVINCULOM_RESC",      row: "NRVINCULOM_RESC",         multi: false, label: "Vínculo Rescindido"           },
        nrvinculoMulti:     { name: "NRVINCULOM_LIST",      row: "NRVINCULOM_LIST",         multi: true,  label: "Vínculo"                      },
        nrvinculoRescMulti: { name: "NRVINCULOM_RESC_LIST", row: "NRVINCULOM_RESC_LIST",    multi: true,  label: "Vínculo Rescindido"           },
        ocupacao:           { name: "NMOCUPACAOH",          row: "NROCUPACAOM",             multi: false, label: "Ocupação"                     },
        tpvinculo:          { name: "NMTIPOVINCULOH",       row: "NRTIPOVINCULOM",          multi: false, label: "Tipo de Vinculo"              },
        tpvinculoEmpreg:    { name: "NMABREV",              row: "NRVINCULOEMPREG",         multi: false, label: "Vínculo Empregaticío"         },
        tpintegracao:       { name: "DSTIPOINTEGTRANSP",    row: "NRTIPOINTEGTRANSP",       multi: false, label: "Tipo de Integração"           },
        tpincidencia:       { name: "NMTIPOINCIDE",         row: "NRTIPOINCIDE",            multi: false, label: "Tipo de Incidência"           },
        tpvinculoMulti:     { name: "NMTIPOVINCULOH_LIST",  row: "NMTIPOVINCULOH_LIST",     multi: true,  label: "Tipo de Vinculo"              },
        grpincidencia:      { name: "NMGRPINCIDE",          row: "NRGRPINCIDE",             multi: false, label: "Grupo de Incidência"          },
        pessoa1:            { name: "NMPESSOA1",            row: "NRPESSOA1",               multi: false, label: "Pessoa"                       },
        pessoa2:            { name: "NMPESSOA2",            row: "NRPESSOA2",               multi: false, label: "Pessoa"                       },
        pessoa3:            { name: "NMPESSOA3",            row: "NRPESSOA3",               multi: false, label: "Pessoa"                       },
        pessoa4:            { name: "NMPESSOA4",            row: "NRPESSOA4",               multi: false, label: "Pessoa"                       },
        candidato:          { name: "NMCANDIDATO",          row: "NRCANDIDATO",             multi: false, label: "Candidato"                    },
        cdfornecedor:       { name: "NMRAZSOCFORN",         row: "CDFORNECED",              multi: false, label: "Fornecedor"                   },
        cdbanco:            { name: "NMBANCO",              row: "CDBANCO",                 multi: false, label: "Banco"                        },
        cdbancoMulti:       { name: "NMBANCO_LIST",         row: "CDBANCO_LIST",            multi: true,  label: "Banco"                        },
        tplinha:            { name: "DSTIPOLINHAVINC",      row: "NRTIPOLINHAVINC",         multi: false, label: "Tipo de Linha"                },
        nrperiodoapuracao:  { name: "DSPERIODOAPURACAO",    row: "NRPERIODOAPURACAO",       multi: false, label: "Periodo de Apuração"          },
        nrprocesso:         { name: "NMPROCESSO",           row: "NRPROCESSO",              multi: false, label: "Processo"                     },
        nrfase:             { name: "NMFASE",               row: "NRFASE",                  multi: false, label: "Fase"                         },
        nravaliacao:        { name: "NMAVALIACAO",          row: "NRAVALIACAO",             multi: false, label: "Avaliação"                    },
        nrbeneficio:        { name: "DSBENEFICIO",          row: "NRBENEFICIOM",            multi: false, label: "Beneficio"                    },
        nrbeneficioMulti:   { name: "NRBENEFICIOM_LIST",    row: "NRBENEFICIOM_LIST",       multi: true,  label: "Beneficio"                    },
        arquivo:            { name: "DSPATH",               row: "DSPATH",                  multi: false, label: "Arquivo"                      },
        nrperiodo:          { name: "NRPERIODO",            row: "NRPERIODO",               multi: false, label: "Período"                      },
        nrtpjornada:        { name: "DSTPJORNADA",          row: "NRTPJORNADA",             multi: false, label: "Tipo de Jornada"              },
        dtinicio:           { name: "DTINICIO",             row: "DTINICIO",                multi: false, label: "Data Inicial"                 },
        dtfim:              { name: "DTFIM",                row: "DTFIM",                   multi: false, label: "Data Final"                   },
        data1:              { name: "DATA1",                row: "DATA1",                   multi: false, label: "Data"                         },
        data2:              { name: "DATA2",                row: "DATA2",                   multi: false, label: "Data"                         },
        data3:              { name: "DATA3",                row: "DATA3",                   multi: false, label: "Data"                         },
        data4:              { name: "DATA4",                row: "DATA4",                   multi: false, label: "Data"                         },
        data5:              { name: "DATA5",                row: "DATA5",                   multi: false, label: "Data"                         },
        datahora1:          { name: "DATAHORA1",            row: "DATAHORA1",               multi: false, label: "Data Hora"                    },
        datahora2:          { name: "DATAHORA2",            row: "DATAHORA2",               multi: false, label: "Data Hora"                    },
        dtdocumento:        { name: "DTDOCUMENTO",          row: "DTDOCUMENTO",             multi: false, label: "Data do Documento"            },
        tpdocumento:        { name: "NMTPDOCUMENTO",        row: "NMTPDOCUMENTO",           multi: false, label: "Tipo de Documento"            },
        opcao1:             { name: "NMOPCOES1",            row: "NMOPCOES1",               multi: false, label: "Opções 1"                     },
        opcao2:             { name: "NMOPCOES2",            row: "NMOPCOES2",               multi: false, label: "Opções 2"                     },
        opcao3:             { name: "NMOPCOES3",            row: "NMOPCOES3",               multi: false, label: "Opções 3"                     },
        opcao4:             { name: "NMOPCOES4",            row: "NMOPCOES4",               multi: false, label: "Opções 4"                     },
        opcao5:             { name: "NMOPCOES5",            row: "NMOPCOES5",               multi: false, label: "Opções 5"                     },
        opcao6:             { name: "NMOPCOES6",            row: "NMOPCOES6",               multi: false, label: "Opções 6"                     },
        opcao7:             { name: "NMOPCOES7",            row: "NMOPCOES7",               multi: false, label: "Opções 7"                     },
        opcao8:             { name: "NMOPCOES8",            row: "NMOPCOES8",               multi: false, label: "Opções 8"                     },
        opcao9:             { name: "NMOPCOES9",            row: "NMOPCOES9",               multi: false, label: "Opções 9"                     },
        number1:            { name: "NUMBER1",              row: "NUMBER1",                 multi: false, label: "Numero 1"                     },
        number2:            { name: "NUMBER2",              row: "NUMBER2",                 multi: false, label: "Numero 2"                     },
        number3:            { name: "NUMBER3",              row: "NUMBER3",                 multi: false, label: "Numero 3"                     },
        number4:            { name: "NUMBER4",              row: "NUMBER4",                 multi: false, label: "Numero 4"                     },
        texto1:             { name: "TEXTO1",               row: "TEXTO1",                  multi: false, label: "Texto 1"                      },
        texto2:             { name: "TEXTO2",               row: "TEXTO2",                  multi: false, label: "Texto 2 maior"                },
        /*modalidade*/
        zebrado:            { name: "DSZEBRADO",            row: "DSZEBRADO",               multi: false, label: "Zebrado"                      },
        situacaoFunc:       { name: "NMSITUFUNCH",          row: "NRSITUFUNCM",             multi: false, label: "Situação Funcional"           },
        situacaoFuncMulti:  { name: "NRSITUFUNCH_LIST",     row: "NRSITUFUNCM_LIST",        multi: true,  label: "Situação Funcional"           },
        evento:             { name: "NMEVENTOH",            row: "NREVENTOM",               multi: false, label: "Evento"                       },
        eventoMulti:        { name: "NREVENTOM_LIST",       row: "NREVENTOM_LIST",          multi: true,  label: "Evento"                       },
        nrtreinamentoMulti: { name: "NRTREINAMENTO_LIST",   row: "NRTREINAMENTO_LIST",      multi: true,  label: "Treinamentos"                 },
        motivoResc:         { name: "NMMOTIVORESC",         row: "NRMOTIVORESC",            multi: false, label: "Motivo de Rescisão"           },
        motivoRescMulti:    { name: "NMMOTIVORESC_LIST",    row: "NRMOTIVORESC",            multi: true,  label: "Motivo de Rescisão"           },
        mensagemPadrao:     { name: "DSTITULOMENSAGEM",     row: "DSMENSAGEM",              multi: false, label: "Mensagem"                     },
        observacao:         { name: "DSOBSERVACAO",         row: "DSOBSERVACAO",            multi: false, label: "Observação"                   },
        tipoestruturamovimentacao: { name: "NMTIPOESTRUTURA_MOVIMENTACAO", row: "NRTIPOESTRUTURA_MOVIMENTACAO", multi: false, label: "Tipo Estrutura(Movimentação)" },
        estruturamovimentacao: { name: "NRESTRUTURAM_MOVIMENTACAO", row: "NRESTRUTURAM_MOVIMENTACAO", multi: true, label: "Estrutura Movimentação" }
    };
    
    /*Definições de campos*/
    this.DEFINITION_RCB = {
        competencia:        { name: "MESCOMPETENCIA",       row: "MESCOMPETENCIA",       multi: false, label: "Data de Competência" },
        nrestrutlegal:      { name: "NMESTRUTLEGAL",        row: "NRESTRUTLEGAL",         multi: false, label: "Estrutura Legal"     },
        nrestrutgeren:      { name: "NMESTRUTGEREN",        row: "NRESTRUTGEREN",        multi: false, label: "Estrutura Gerencial" },
        nrvinculo:          { name: "NRVINCULOM",           row: "NRVINCULOM",           multi: false, label: "Vínculo"             },
        number1:            { name: "NUMBER1",              row: "NUMBER1",              multi: false, label: "Numero 1"            },
        number2:            { name: "NUMBER2",              row: "NUMBER2",              multi: false, label: "Numero 2"            },
        number3:            { name: "NUMBER3",              row: "NUMBER3",              multi: false, label: "Numero 3"            },
        number4:            { name: "NUMBER4",              row: "NUMBER4",              multi: false, label: "Numero 4"            },
        data1:              { name: "DATA1",                row: "DATA1",                multi: false, label: "Data"                },
        data2:              { name: "DATA2",                row: "DATA2",                multi: false, label: "Data"                },
        tpestrut:           { name: "NRTIPOESTRUTURA",      row: "NRTIPOESTRUTURA",      multi: false, label: "Tipo Estrutura"      },
        tipomovimento:      { name: "NRTIPOMOVIMENT",       row: "NRTIPOMOVIMENT",       multi: false, label: "Tipo de Movimento"   },
        opcao1:             { name: "NMOPCOES1",            row: "NMOPCOES1",            multi: false, label: "Opções 1"            },
        opcao2:             { name: "NMOPCOES2",            row: "NMOPCOES2",            multi: false, label: "Opções 2"            },
        opcao3:             { name: "NMOPCOES3",            row: "NMOPCOES3",            multi: false, label: "Opções 3"            },
        opcao4:             { name: "NMOPCOES4",            row: "NMOPCOES4",            multi: false, label: "Opções 4"            },
        texto1:             { name: "TEXTO1",               row: "TEXTO1",               multi: false, label: "Texto 1"             },
        tpvinculoEmpreg:    { name: "NMABREV",              row: "NRVINCULOEMPREG",      multi: false, label: "Vínculo Empregaticío"},
        dtinicio:           { name: "DTINICIO",             row: "DTINICIO",             multi: false, label: "Data Inicial"        },
        dtfim:              { name: "DTFIM",                row: "DTFIM",                multi: false, label: "Data Final"          },
        dtdocumento:        { name: "DTDOCUMENTO",          row: "DTDOCUMENTO",          multi: false, label: "Data do Documento"   },
        opcao5:             { name: "NMOPCOES5",            row: "NMOPCOES5",            multi: false, label: "Opções 5"            },
        opcao6:             { name: "NMOPCOES6",            row: "NMOPCOES6",            multi: false, label: "Opções 6"            },
        opcao7:             { name: "NMOPCOES7",            row: "NMOPCOES7",            multi: false, label: "Opções 7"            },
        opcao8:             { name: "NMOPCOES8",            row: "NMOPCOES8",            multi: false, label: "Opções 8"            },
        opcao9:             { name: "NMOPCOES9",            row: "NMOPCOES9",            multi: false, label: "Opções 9"            },
        observacao:         { name: "DSOBSERVACAO",         row: "DSOBSERVACAO",         multi: false, label: "Observação"          },

        evento:             { name: "NMEVENTOH",            row: "NREVENTOM",            multi: false, label: "Evento" },
        tipomovimentoMulti: { name: "NMTIPOMOVIMENT_LIST",  row: "NRTIPOMOVIMENT_LIST",  multi: true,  label: "Tipo de Movimento"   },
        competencia2:       { name: "DTMESCOMPETENCIA2",    row: "DTMESCOMPETENCIA2",    multi: false, label: "Data de Competência" },
        nrestrutlegal2:     { name: "NMESTRUTLEGAL2",       row: "NRESTRUTLEGAL2",       multi: false, label: "Estrutura Legal"     },
        nrestrutlegalMulti: { name: "NRESTRUTLEGAL_LIST",   row: "NRESTRUTLEGAL_LIST",   multi: true,  label: "Estrutura Legal"     },
        nrestrutgerenMulti: { name: "NRESTRUTGEREN_LIST",   row: "NRESTRUTGEREN_LIST",   multi: true,  label: "Estrutura Gerencial" },
        nrestrutsind:       { name: "NMESTRUTSIND",         row: "NRESTRUTSIND",         multi: false, label: "Estrutura Sindical"  },
        tipohierarquia:     { name: "NMTIPOHIERARQORG",     row: "NRTIPOHIERARQORG",     multi: false, label: "Nome da Hierarquia"  },
        nrvinculoResc:      { name: "NMVINCULOM_RESC",      row: "NRVINCULOM_RESC",      multi: false, label: "Vínculo"             },
        nrvinculoMulti:     { name: "NRVINCULOM_LIST",      row: "NRVINCULOM_LIST",      multi: true,  label: "Vínculo"             },
        nrvinculoRescMulti: { name: "NRVINCULOM_RESC_LIST", row: "NRVINCULOM_RESC_LIST", multi: true,  label: "Vínculo"             },
        tpvinculo:          { name: "NMTIPOVINCULOH",       row: "NRTIPOVINCULOM",       multi: false, label: "Tipo de Vinculo"     },
        tpintegracao:       { name: "DSTIPOINTEGTRANSP",    row: "NRTIPOINTEGTRANSP",    multi: false, label: "Tipo de Integração"  },
        tpincidencia:       { name: "NMTIPOINCIDE",         row: "NRTIPOINCIDE",         multi: false, label: "Tipo de Incidência"  },
        tpvinculoMulti: { name: "NMTIPOVINCULOH_LIST", row: "NRTIPOVINCULOM", multi: true, label: "Tipo de Vinculo" },
        pessoa1: { name: "NMPESSOA1", row: "NRPESSOA1", multi: false, label: "Pessoa" },
        pessoa2: { name: "NMPESSOA2", row: "NRPESSOA2", multi: false, label: "Pessoa" },
        candidato: { name: "NMCANDIDATO", row: "NRCANDIDATO", multi: false, label: "Candidato" },
        cdfornecedor: { name: "NMRAZSOCFORN", row: "CDFORNECED", multi: false, label: "Fornecedor" },
        cdbanco: { name: "NMBANCO", row: "CDBANCO", multi: false, label: "Banco" },
        tplinha: { name: "DSTIPOLINHAVINC", row: "NRTIPOLINHAVINC", multi: false, label: "Tipo de Linha" },
        nrperiodoapuracao: { name: "DSPERIODOAPURACAO", row: "NRPERIODOAPURACAO", multi: false, label: "Periodo de Apuração" },
        nrprocesso: { name: "NMPROCESSO", row: "NRPROCESSO", multi: false, label: "Processo" },
        nrfase: { name: "NMFASE", row: "NRFASE", multi: false, label: "Fase" },
        nravaliacao: { name: "NMAVALIACAO", row: "NRAVALIACAO", multi: false, label: "Avaliação" },
        data3:              { name: "DATA3",                row: "DATA3",                   multi: false, label: "Data" },
        /*modalidade*/
        zebrado: { name: "DSZEBRADO", row: "DSZEBRADO", multi: false, label: "Zebrado" },
        situacaoFunc: { name: "NMSITUFUNCH", row: "NRSITUFUNCM", multi: false, label: "Situação Funcional" },
        eventoMulti: { name: "NREVENTOM_LIST", row: "NREVENTOM_LIST", multi: true, label: "Evento" },
        nrtreinamentoMulti: { name: "NRTREINAMENTO_LIST", row: "NRTREINAMENTO_LIST", multi: true, label: "Treinamentos" },
        motivoResc: { name: "NMMOTIVORESC", row: "NRMOTIVORESC", multi: false, label: "Motivo de Rescisão" }
    };
    
    /*Definições dos relatórios*/
    this.REPORTS = {
        VAB: {
            label: "Relatórios de Vale Transporte",
            /*Relatórios padrão*/
            0: {
                vale_transporte_solicitacao: {
                    config: {
                        itemName: "Solicitação de Vale Transporte",
                        fileName: "vale_transporte_solicitacao",
                        manual: "Em elaboração",
                        order: 30
                    },
                    params: [ {
					    field: this.DEFINITION.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    }, {
                        field: this.DEFINITION.nrvinculoMulti,
                        param: "P_VINCULO"
                    }, {
                        field: this.DEFINITION.nrestrutlegal,
                        param: "P_ESTRUTLEGAL"
                    }, {
                        field: this.DEFINITION.nrestrutgeren,
                        param: "P_ESTRUTGEREN"
                    }, {
                        field: this.DEFINITION.tpvinculo,
                        param: "P_TIPOVINCULO"
                    }, {
                        field: this.DEFINITION.tplinha,
                        param: "P_TIPOLINHA"
                    }, {
                        field: this.DEFINITION.cdfornecedor,
                        param: "P_FORNECEDOR"
                    } ]
                },
                vale_transporte_romaneio: {
                    config: {
                        itemName: "Romaneio de Vale Transporte",
                        fileName: "vale_transporte_romaneio",
                        order: 20
                    },
                    params: [ {
                        field: this.DEFINITION.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    }, {
                        field: this.DEFINITION.nrvinculoMulti,
                        param: "P_VINCULO"
                    }, {
                        field: this.DEFINITION.nrestrutlegal,
                        param: "P_ESTRUTLEGAL"
                    }, {
                        field: this.DEFINITION.nrestrutgeren,
                        param: "P_ESTRUTGEREN"
                    }, {
                        field: this.DEFINITION.tpvinculo,
                        param: "P_TIPOVINCULO"
                    }, {
                        field: this.DEFINITION.tplinha,
                        param: "P_TIPOLINHA"
                    }, {
                        field: this.DEFINITION.cdfornecedor,
                        param: "P_FORNECEDOR"
                    } ]
                },
                demonstrativo_pagamento_vale_transporte: {
                    config: {
                        itemName: "Demonstrativo de Pagamento de Vale Transporte",
                        fileName: "demonstrativo_pagamento_vale_transporte",
                        order: 10
                    },
                    params: [ {
                        field: this.DEFINITION.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    }, {
                        field: this.DEFINITION.nrvinculoMulti,
                        param: "P_VINCULO"
                    }, {
                        field: this.DEFINITION.nrestrutlegal,
                        param: "P_ESTRUTLEGAL"
                    }, {
                        field: this.DEFINITION.nrestrutgeren,
                        param: "P_ESTRUTGEREN"
                    }, {
                        field: this.DEFINITION.tpvinculo,
                        param: "P_TIPOVINCULO"
                    }, {
                        field: this.DEFINITION.tplinha,
                        param: "P_TIPOLINHA"
                    }, {
                        field: this.DEFINITION.cdfornecedor,
                        param: "P_FORNECEDOR"
                    }, {
                        field: this.DEFINITION.tipohierarquia,
                        param: "P_NRTIPOHIERARQ",
                        required: true
                    } ]
                }
            }
        },
        VAB_exp: {
            label: "Exportação de Vale/Benefício",
            0: {
                vale_alelo_beneficios: {
                    config: {
                        itemName: "Alelo Benefícios",
                        fileName: "vale_alelo_beneficios",
                        download: {
                            fileName: "alelo_beneficios",
                            format: "txt",
                            strFind: "*",
                            strReplace: " "
                         },
                        order : 4
                    },
                    params: [ {
                        field: this.DEFINITION.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    }, {
                        field: this.DEFINITION.pessoa1,
                        param: "P_PESSOARESP",
                        label: "Responsável pelo Recebimento",
                        required: true
                    }, {
                        field: this.DEFINITION.nrestrutlegal2,
                        param: "P_ESTRUTURARESP",
                        label: "Estrutura responsável para identificação da integração entre HCM e o Alelo",
                        required: true
                    }, {
                        field: this.DEFINITION.number1,
                        param: "P_NRCONTRATO",
                        label: "Número do Contrato",
                        required: true
                    }, {
                        field: this.DEFINITION.tpintegracao,
                        param: "P_NRTIPOINTEGTRANSP",
                        required: true
                    }, {
                        field: this.DEFINITION.nrvinculoMulti,
                        param: "P_NRVINCULO"
                    }, {
                        field: this.DEFINITION.nrestrutlegal,
                        param: "P_NRESTRUTLEGAL"
                    }, {
                        field: this.DEFINITION.nrestrutgeren,
                        param: "P_NRESTRUTGEREN"
                    }, {
                        field: this.DEFINITION.nrbeneficioMulti,
                        param: "P_NRBENEFICIO",
                        required: true
                    }]
                },
                vale_alelo: {
                    config: {
                        itemName: "Alelo Vale Transporte",
                        fileName: "vale_alelo",
                        download: {
                            fileName: "date('Ymd').'001'",
                            isEval: true,
                            format: "txt",
                            extension: "APS",
                            strFind: "*",
                            strReplace: " "
                        },
                        order : 5
                    },
                    params: [ {
                        field: this.DEFINITION.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    }, {
                        field: this.DEFINITION.tplinha,
                        param: "P_TPLINHA",
                        required: false
                    }, {
                        field: this.DEFINITION.nrvinculoMulti,
                        param: "P_NRVINCULO"
                    }, {
                        field: this.DEFINITION.nrestrutlegal,
                        param: "P_NRESTRUTLEGAL"
                    }, {
                        field: this.DEFINITION.nrestrutgeren,
                        param: "P_NRESTRUTGEREN"
                    }, {
                        field: this.DEFINITION.dtinicio,
                        param: "P_DTINICIO",
                        label: "Data inicial da admissão"
                    }, {
                        field: this.DEFINITION.dtfim,
                        param: "P_DTFINAL",
                        label: "Data final da admissão"
                    }, {
                        field: this.DEFINITION.opcao1,
                        param: "P_LEGALCARTAO",
                        label: "Considerar somente a Estrutura do Cartão"
                    }, {
                        field: this.DEFINITION.pessoa1,
                        param: "P_PESSOARESP",
                        label: "Responsável pelo Recebimento",
                        required: true
                    }, {
                        field: this.DEFINITION.nrestrutlegal2,
                        param: "P_ESTRUTURARESP",
                        label: "Estrutura responsável para identificação da integração entre HCM e o Alelo",
                        required: true
                    } ]
                },
                vale_melhorvt: {
                    config: {
                        itemName: "Melhor VT",
                        fileName: "vale_melhorvt",
                        download: {
                            fileName: "vale_melhorvt",
                            format: "txt"/*,
                            strFind: "*",
                            strReplace: " "*/
                         },
                        order : 10
                    },
                    params: [ {
                        field: this.DEFINITION.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    }, {
                        field: this.DEFINITION.tplinha,
                        param: "P_TPLINHA",
                        required: true
                    }, {
                        field: this.DEFINITION.nrvinculoMulti,
                        param: "P_NRVINCULO"
                    }, {
                        field: this.DEFINITION.nrestrutlegal,
                        param: "P_NRESTRUTLEGAL"
                    }, {
                        field: this.DEFINITION.nrestrutgeren,
                        param: "P_NRESTRUTGEREN"
                    }, {
                        field: this.DEFINITION.dtinicio,
                        param: "P_DTINICIO",
                        label: "Data inicial da admissão"
                    }, {
                        field: this.DEFINITION.dtfim,
                        param: "P_DTFINAL",
                        label: "Data final da admissão"
                    }, {
                        field: this.DEFINITION.opcao1,
                        param: "P_LEGALCARTAO",
                        label: "Considerar somente a Estrutura do Cartão"
                    } ]
                },
                vale_otimo: {
                    config: {
                        itemName: "Ótimo",
                        fileName: "vale_otimo",
                        download: {
                            fileName: "vale_otimo",
                            format: "txt"
                         },
                        order : 20
                    },
                    params: [ {
                        field: this.DEFINITION.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    }, {
                        field: this.DEFINITION.tplinha,
                        param: "P_TPLINHA",
                        required: true
                    }, {
                        field: this.DEFINITION.nrvinculoMulti,
                        param: "P_NRVINCULO"
                    }, {
                        field: this.DEFINITION.nrestrutlegal,
                        param: "P_NRESTRUTLEGAL"
                    }, {
                        field: this.DEFINITION.nrestrutgeren,
                        param: "P_NRESTRUTGEREN"
                    }, {
                        field: this.DEFINITION.dtinicio,
                        param: "P_DTINICIO",
                        label: "Data inicial da admissão"
                    }, {
                        field: this.DEFINITION.dtfim,
                        param: "P_DTFINAL",
                        label: "Data final da admissão"
                    }, {
                        field: this.DEFINITION.opcao1,
                        param: "P_LEGALCARTAO",
                        label: "Considerar somente a Estrutura do Cartão"
                    } ]
                },
                vale_passefacilbelem: {
                    config: {
                        itemName: "Passe Fácil Belem",
                        fileName: "vale_passefacilbelem",
                        download: {
                            fileName: "vale_passefacilbelem",
                            format: "txt"
                         },
                        order : 30
                    },
                    params: [ {
                        field: this.DEFINITION.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    }, {
                        field: this.DEFINITION.tplinha,
                        param: "P_TPLINHA",
                        required: true
                    }, {
                        field: this.DEFINITION.nrvinculoMulti,
                        param: "P_NRVINCULO"
                    }, {
                        field: this.DEFINITION.nrestrutlegal,
                        param: "P_NRESTRUTLEGAL"
                    }, {
                        field: this.DEFINITION.nrestrutgeren,
                        param: "P_NRESTRUTGEREN"
                    }, {
                        field: this.DEFINITION.dtinicio,
                        param: "P_DTINICIO",
                        label: "Data inicial da admissão"
                    }, {
                        field: this.DEFINITION.dtfim,
                        param: "P_DTFINAL",
                        label: "Data final da admissão"
                    }, {
                        field: this.DEFINITION.opcao1,
                        param: "P_LEGALCARTAO",
                        label: "Considerar somente a Estrutura do Cartão"
                    } ]
                },
                vale_riocard: {
                    config: {
                        itemName: "RioCard",
                        fileName: "vale_riocard",
                        download: {
                            fileName: "'PEDIDO_'.$row['CNPJLEGAL'].'_'.date('YMd_Hm')",
                            isEval: true, //Indica que o nome é dinâmico, vai usar códigos php
                            format: "txt"
                         },
                        order : 40
                    },
                    params: [ {
                        field: this.DEFINITION.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    }, {
                        field: this.DEFINITION.tplinha,
                        param: "P_TPLINHA",
                        required: true
                    }, {
                        field: this.DEFINITION.nrvinculoMulti,
                        param: "P_NRVINCULO"
                    }, {
                        field: this.DEFINITION.nrestrutlegal,
                        param: "P_NRESTRUTLEGAL",
                        required: true
                    }, {
                        field: this.DEFINITION.nrestrutgeren,
                        param: "P_NRESTRUTGEREN"
                    }, {
                        field: this.DEFINITION.dtinicio,
                        param: "P_DTINICIO",
                        label: "Data inicial da admissão"
                    }, {
                        field: this.DEFINITION.dtfim,
                        param: "P_DTFINAL",
                        label: "Data final da admissão"
                    }, {
                        field: this.DEFINITION.opcao1,
                        param: "P_LEGALCARTAO",
                        label: "Considerar somente a Estrutura do Cartão"
                    }, {
                        param: "P_VERLAYOUT",
                        row: "verlayout",
                        value: "01.00" //Versão do aquivo do RioCard
                    }, {
                        row: "CNPJLEGAL"
                    } ]
                },
                vale_sodexo_vt: {
                    config: {
                        itemName: "Sodexo Vale Transporte",
                        fileName: "vale_sodexo_vt",
                        download: {
                            fileName: "'SDXV5_'.str_pad($row['NUMBER1'], 8, '0', STR_PAD_LEFT)",
                            isEval: true, //Indica que o nome é dinâmico, vai usar códigos php (em fileName)
                            format: "txt",
                            //extension: "txt",
                            strFind: "*",
                            strReplace: " "
                        }, //TODO nome do arquivo
                        order: 41
                    },
                    params: [ {
                        field: this.DEFINITION.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    }, {
                        field: this.DEFINITION.nrestrutlegal2,
                        param: "P_ESTRUTURARESP",
                        label: "Estrutura responsável para identificação da integração entre HCM e a Sodexo",
                        required: true
                    }, {
                        field: this.DEFINITION.nrvinculoMulti,
                        param: "P_NRVINCULO"
                    }, {
                        field: this.DEFINITION.pessoa1,
                        param: "P_PESSOARESP",
                        label: "Responsável pelo departamento",
                        required: true
                    }, {
                        field: this.DEFINITION.nrestrutlegal,
                        param: "P_NRESTRUTLEGAL"
                    }, {
                        field: this.DEFINITION.nrestrutgeren,
                        param: "P_NRESTRUTGEREN"
                    }, {
                        field: this.DEFINITION.number1,
                        param: "P_CDCLIENTE",
                        label: "Código do contrato na Sodexo",
                        required: true
                    }, {
                        field: this.DEFINITION.data1,
                        param: "P_DTENTREGA",
                        label: "Data de entrega do pedido",
                        required: true
                    }, {
                        field: this.DEFINITION.data2,
                        param: "P_DTCREDITO",
                        label: "Data para crédito no cartão",
                        required: true
                    } ]
                },
                vale_sodexo_beneficios: {
                    config: {
                        itemName: "Sodexo Benefícios",
                        fileName: "vale_sodexo_beneficios",
                        download: {
                            fileName: "'SDXV5_'.str_pad($row['NUMBER1'], 8, '0', STR_PAD_LEFT)",
                            isEval: true, //Indica que o nome é dinâmico, vai usar códigos php (em fileName)
                            format: "txt",
                            //extension: "txt",
                            strFind: "*",
                            strReplace: " "
                        }, //TODO nome do arquivo
                        order: 42
                    },
                    params: [ {
                        field: this.DEFINITION.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    }, {
                        field: this.DEFINITION.nrestrutlegal2,
                        param: "P_ESTRUTURARESP",
                        label: "Estrutura responsável para identificação da integração entre HCM e a Sodexo",
                        required: true
                    }, {
                        field: this.DEFINITION.nrvinculoMulti,
                        param: "P_NRVINCULO"
                    }, {
                        field: this.DEFINITION.pessoa1,
                        param: "P_PESSOARESP",
                        label: "Responsável pelo departamento",
                        required: true
                    }, {
                        field: this.DEFINITION.nrestrutlegal,
                        param: "P_NRESTRUTLEGAL"
                    }, {
                        field: this.DEFINITION.nrestrutgeren,
                        param: "P_NRESTRUTGEREN"
                    }, {
                        field: this.DEFINITION.number1,
                        param: "P_CDCLIENTE",
                        label: "Código do contrato na Sodexo",
                        required: true
                    }, {
                        field: this.DEFINITION.data1,
                        param: "P_DTENTREGA",
                        label: "Data de entrega do pedido",
                        required: true
                    }, {
                        field: this.DEFINITION.data2,
                        param: "P_DTCREDITO",
                        label: "Data para crédito no cartão",
                        required: true
                    }, {
                        field: this.DEFINITION.tpintegracao,
                        param: "P_NRTIPOINTEGTRANSP",
                        required: true
                    } ]
                },
                vale_sptrans: {
                    config: {
                        itemName: "SPTrans",
                        fileName: "vale_sptrans",
                        download: {
                            fileName: "vale_sptrans",
                            format: "txt"
                         },
                        order : 50
                    },
                    params: [ {
                        field: this.DEFINITION.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    }, {
                        field: this.DEFINITION.tplinha,
                        param: "P_TPLINHA",
                        required: true
                    }, {
                        field: this.DEFINITION.nrvinculoMulti,
                        param: "P_NRVINCULO"
                    }, {
                        field: this.DEFINITION.nrestrutlegal,
                        param: "P_NRESTRUTLEGAL"
                    }, {
                        field: this.DEFINITION.nrestrutgeren,
                        param: "P_NRESTRUTGEREN"
                    }, {
                        field: this.DEFINITION.dtinicio,
                        param: "P_DTINICIO",
                        label: "Data inicial da admissão"
                    }, {
                        field: this.DEFINITION.dtfim,
                        param: "P_DTFINAL",
                        label: "Data final da admissão"
                    }, {
                        field: this.DEFINITION.opcao1,
                        param: "P_LEGALCARTAO",
                        label: "Considerar somente a Estrutura do Cartão"
                    }/*, {
                        field: this.DEFINITION.observacao,
                        param: "login",
                        label: "Login do usuário no SPTrans",
                        required: true
                    }*/ ]
                },
                vale_ticket_vt: {
                    config: {
                        itemName: "Ticket Vale Transporte",
                        fileName: "vale_ticket_vt",
                        download: {
                            fileName: "vale_ticket",
                            format: "txt",
                            //extension: "txt",
                            strFind: "@",
                            strReplace: "\r"
                        }, //TODO nome do arquivo
                        order: 55
                    },
                    params: [ {
                        field: this.DEFINITION.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    }, {
                        field: this.DEFINITION.tplinha,
                        param: "P_TPLINHA",
                        required: true
                    }, {
                        field: this.DEFINITION.nrestrutlegal2,
                        param: "P_ESTRUTURARESP",
                        label: "Estrutura responsável para identificação da integração entre HCM e o Ticket",
                        required: true
                    }, {
                        field: this.DEFINITION.nrestrutgerenMulti,
                        param: "P_ESTRUTDEP",
                        label: "Estrutura do Departamento",
                        required: true
                    }, {
                        field: this.DEFINITION.nrvinculoMulti,
                        param: "P_NRVINCULO"
                    }, {
                        field: this.DEFINITION.pessoa1,
                        param: "P_PESSOARESP",
                        label: "Responsável pela Unidade",
                        required: true
                    }, {
                        field: this.DEFINITION.nrestrutlegal,
                        param: "P_NRESTRUTLEGAL"
                    }, {
                        field: this.DEFINITION.data1,
                        param: "P_DTENTREGA",
                        label: "Data de entrega do pedido",
                        required: true
                    }]
                },
                vale_ticket_vr: {
                    config: {
                        itemName: "Ticket Vale Refeição/Alimentação",
                        fileName: "vale_ticket_vr",
                        download: {
                            fileName: "vale_ticket",
                            format: "txt",
                            //extension: "txt",
                            strFind: "@",
                            strReplace: "\r"
                        }, //TODO nome do arquivo
                        order: 56
                    },
                    params: [ {
                        field: this.DEFINITION.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    }, {
                        field: this.DEFINITION.nrestrutlegal2,
                        param: "P_ESTRUTURARESP",
                        label: "Estrutura responsável para identificação da integração entre HCM e o Ticket",
                        required: true
                    }, {
                        field: this.DEFINITION.nrvinculoMulti,
                        param: "P_NRVINCULO"
                    }, {
                        field: this.DEFINITION.pessoa1,
                        param: "P_PESSOARESP",
                        label: "Responsável pelo departamento",
                        required: true
                    }, {
                        field: this.DEFINITION.nrestrutlegal,
                        param: "P_NRESTRUTLEGAL"
                    }, {
                        field: this.DEFINITION.nrbeneficio,
                        param: "P_NRBENEFICIO",
                        required: true
                    }, {
                        field: this.DEFINITION.number1,
                        param: "P_CDCONTRATO",
                        label: "Código do contrato",
                        required: true
                    }, {
                        field: this.DEFINITION.opcao1,
                        param: "P_TPBENEFI",
                        label: "Tipo de Benefício",
                        valueField: "",
                        dataList: [ {
                            name: "Alimentação",
                            value: "A"
                        }, {
                            name: "Refeição",
                            value: "R"
                        } ],
                        required: true
                    }, {
                        field: this.DEFINITION.nrestrutgeren,
                        param: "P_NRESTRUTGEREN"
                    }, {
                        field: this.DEFINITION.data1,
                        param: "P_DTLIBERA",
                        label: "Data da  entrega do pedido",
                        required: true
                    }]
                },
                vale_rb_vt: {
                    config: {
                        itemName: "RB Vale Transporte",
                        fileName: "vale_rb_vt",
                        download: {
                            fileName: "date('dmY').'001'",
                            format: "txt",
                            isEval: true,
                            //extension: "txt",
                            strFind: "*",
                            strReplace: "\r"
                        }, //TODO nome do arquivo
                        order: 57
                    },
                    params: [ {
                        field: this.DEFINITION.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    }, {
                        field: this.DEFINITION.tplinha,
                        param: "P_TPLINHA",
                        required: true
                    }, {
                        field: this.DEFINITION.nrestrutlegal2,
                        param: "P_ESTRUTURARESP",
                        label: "Estrutura responsável para identificação da integração entre HCM e o RB",
                        required: true
                    }, {
                        field: this.DEFINITION.nrvinculoMulti,
                        param: "P_NRVINCULO"
                    }, {
                        field: this.DEFINITION.pessoa1,
                        param: "P_PESSOARESP",
                        label: "Responsável pelo departamento",
                        required: true
                    }, {
                        field: this.DEFINITION.nrestrutlegal,
                        param: "P_NRESTRUTLEGAL"
                    }, {
                        field: this.DEFINITION.nrestrutgeren,
                        param: "P_NRESTRUTGEREN"
                    }]
                },
                vale_suzantur: {
                    config: {
                        itemName: "Suzantur",
                        fileName: "vale_suzantur",
                        download: {
                            fileName: "vale_suzantur",
                            format: "txt"
                         },
                        order : 60
                    },
                    params: [ {
                        field: this.DEFINITION.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    }, {
                        field: this.DEFINITION.tplinha,
                        param: "P_TPLINHA",
                        required: true
                    }, {
                        field: this.DEFINITION.nrvinculoMulti,
                        param: "P_NRVINCULO"
                    }, {
                        field: this.DEFINITION.nrestrutlegal,
                        param: "P_NRESTRUTLEGAL"
                    }, {
                        field: this.DEFINITION.nrestrutgeren,
                        param: "P_NRESTRUTGEREN"
                    }, {
                        field: this.DEFINITION.dtinicio,
                        param: "P_DTINICIO",
                        label: "Data inicial da admissão"
                    }, {
                        field: this.DEFINITION.dtfim,
                        param: "P_DTFINAL",
                        label: "Data final da admissão"
                    }, {
                        field: this.DEFINITION.opcao1,
                        param: "P_LEGALCARTAO",
                        label: "Considerar somente a Estrutura do Cartão"
                    } ]
                },
                vale_transfacil: {
                    config: {
                        itemName: "Transfácil - Múltiplo",
                        fileName: "vale_transfacil",
                        download: {
                            fileName: "vale_transfacil",
                            format: "txt",
                            strFind: "*",
                            strReplace: " "
                         },
                        order : 70
                    },
                    params: [ {
                        field: this.DEFINITION.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    }, {
                        field: this.DEFINITION.tplinha,
                        param: "P_TPLINHA",
                        required: true
                    }, {
                        field: this.DEFINITION.nrvinculoMulti,
                        param: "P_NRVINCULO"
                    }, {
                        field: this.DEFINITION.nrestrutlegal,
                        param: "P_NRESTRUTLEGAL"
                    }, {
                        field: this.DEFINITION.nrestrutgeren,
                        param: "P_NRESTRUTGEREN"
                    }, {
                        field: this.DEFINITION.dtinicio,
                        param: "P_DTINICIO",
                        label: "Data inicial da admissão"
                    }, {
                        field: this.DEFINITION.dtfim,
                        param: "P_DTFINAL",
                        label: "Data final da admissão"
                    }, {
                        field: this.DEFINITION.opcao1,
                        param: "P_LEGALCARTAO",
                        label: "Considerar somente a Estrutura do Cartão"
                    } ]
                },
                vale_transfacil_val: {
                    config: {
                        itemName: "Transfácil - Valor",
                        fileName: "vale_transfacil_val",
                        download: {
                            fileName: "vale_transfacil_val",
                            format: "txt",
                            strFind: "*",
                            strReplace: " "
                         },
                        order : 80
                    },
                    params: [ {
                        field: this.DEFINITION.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    }, {
                        field: this.DEFINITION.tplinha,
                        param: "P_TPLINHA",
                        required: true
                    }, {
                        field: this.DEFINITION.nrvinculoMulti,
                        param: "P_NRVINCULO"
                    }, {
                        field: this.DEFINITION.nrestrutlegal,
                        param: "P_NRESTRUTLEGAL"
                    }, {
                        field: this.DEFINITION.nrestrutgeren,
                        param: "P_NRESTRUTGEREN"
                    }, {
                        field: this.DEFINITION.dtinicio,
                        param: "P_DTINICIO",
                        label: "Data inicial da admissão"
                    }, {
                        field: this.DEFINITION.dtfim,
                        param: "P_DTFINAL",
                        label: "Data final da admissão"
                    }, {
                        field: this.DEFINITION.opcao1,
                        param: "P_LEGALCARTAO",
                        label: "Considerar somente a Estrutura do Cartão"
                    } ]
                },
                vale_vb: {
                    config: {
                        itemName: "VB Serviços",
                        fileName: "vale_vb",
                        download: {
                            fileName: "vale_vb",
                            format: "txt"
                         },
                        order : 100
                    },
                    params: [ {
                        field: this.DEFINITION.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    }, {
                        field: this.DEFINITION.tplinha,
                        param: "P_TPLINHA",
                        required: true
                    }, {
                        field: this.DEFINITION.nrvinculo,
                        param: "P_NRVINCULO"
                    }, {
                        field: this.DEFINITION.nrestrutlegal,
                        param: "P_NRESTRUTLEGAL"
                    }, {
                        field: this.DEFINITION.nrestrutgeren,
                        param: "P_NRESTRUTGEREN"
                    }, {
                        field: this.DEFINITION.dtinicio,
                        param: "P_DTINICIO",
                        label: "Data inicial da admissão"
                    }, {
                        field: this.DEFINITION.dtfim,
                        param: "P_DTFINAL",
                        label: "Data final da admissão"
                    }, {
                        field: this.DEFINITION.opcao1,
                        param: "P_LEGALCARTAO",
                        label: "Considerar somente a Estrutura do Cartão"
                    }, {
                        field: this.DEFINITION.observacao,
                        param: "P_IDENTIFICADOR",
                        label: "Identificador da empresa na VB Serviços (Solicitado na central de atendimento)",
                        required: true
                    }, {
                        field: this.DEFINITION.pessoa1,
                        param: "P_PESSOARESP",
                        label: "Pessoa Responsável",
                        required: true
                    }, {
                        field: this.DEFINITION.nrestrutlegal2,
                        param: "P_ESTRUTURARESP",
                        label: "Estrutura responsável para identificação da integração entre HCM e o VB Serviços",
                        required: true
                    }, {
                        field: this.DEFINITION.cdfornecedor,
                        param: "P_FORNECEDOR",
                        required: true
                    } ]
                },
                vale_fortaleza_usuarios: {
                    config: {
                        itemName: "VTE Fortaleza - Usuários",
                        fileName: "vale_fortaleza_usuarios",
                        download: {
                            fileName: "vale_fortaleza_usuarios",
                            format: "txt",
                            extension: 'alp'
                         },
                        order : 110
                    },
                    params: [ {
                        field: this.DEFINITION.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    }, {
                        field: this.DEFINITION.tplinha,
                        param: "P_TPLINHA",
                        required: true
                    }, {
                        field: this.DEFINITION.nrvinculoMulti,
                        param: "P_NRVINCULO"
                    }, {
                        field: this.DEFINITION.nrestrutlegal,
                        param: "P_NRESTRUTLEGAL"
                    }, {
                        field: this.DEFINITION.nrestrutgeren,
                        param: "P_NRESTRUTGEREN"
                    }, {
                        field: this.DEFINITION.dtinicio,
                        param: "P_DTINICIO",
                        label: "Data inicial da admissão"
                    }, {
                        field: this.DEFINITION.dtfim,
                        param: "P_DTFINAL",
                        label: "Data final da admissão"
                    }, {
                        field: this.DEFINITION.opcao1,
                        param: "P_LEGALCARTAO",
                        label: "Considerar somente a Estrutura do Cartão"
                    } ]
                },
                vale_fortaleza: {
                    config: {
                        itemName: "VTE Fortaleza - Pedido",
                        fileName: "vale_fortaleza",
                        download: {
                            fileName: "vale_fortaleza",
                            format: "txt",
                            extension: 'alp'
                         },
                        order : 120
                    },
                    params: [ {
                        field: this.DEFINITION.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    }, {
                        field: this.DEFINITION.tplinha,
                        param: "P_TPLINHA",
                        required: true
                    }, {
                        field: this.DEFINITION.nrvinculoMulti,
                        param: "P_NRVINCULO"
                    }, {
                        field: this.DEFINITION.nrestrutlegal,
                        param: "P_NRESTRUTLEGAL"
                    }, {
                        field: this.DEFINITION.nrestrutgeren,
                        param: "P_NRESTRUTGEREN"
                    }, {
                        field: this.DEFINITION.dtinicio,
                        param: "P_DTINICIO",
                        label: "Data inicial da admissão"
                    }, {
                        field: this.DEFINITION.dtfim,
                        param: "P_DTFINAL",
                        label: "Data final da admissão"
                    }, {
                        field: this.DEFINITION.opcao1,
                        param: "P_LEGALCARTAO",
                        label: "Considerar somente a Estrutura do Cartão"
                    } ]
                },
                vale_direto: {	 
                    config: {	 
                        itemName: "Vale Transporte - Direto",	 
                        fileName: "vale_direto",	 
                        download: {	 
                            fileName: "vale_direto",	 
                            format: "txt",	 
                            //extension: "txt",	 
                            strFind: "@",	 
                            strReplace: "\r"	 
                        }, //TODO nome do arquivo	 
                        order: 130	 
                    },	 
                    params: [ {	 
                        field: this.DEFINITION.competencia,	 
                        param: "P_COMPETENCIA",	 
                        required: true	 
                    }, {	 
                        field: this.DEFINITION.tplinha,	 
                        param: "P_TPLINHA",	 
                        required: true	 
                    }, {	 
                        field: this.DEFINITION.nrestrutlegal,	 
                        param: "P_NRESTRUTLEGAL"	 
                    }, {	 
                        field: this.DEFINITION.nrestrutgeren,	 
                        param: "P_NRESTRUTGEREN"	 
                    }, {	 
                        field: this.DEFINITION.nrvinculoMulti,	 
                        param: "P_NRVINCULO"	 
                    }, {	 
                        field: this.DEFINITION.nrestrutlegal,	 
                        param: "P_NRESTRUTLEGAL"	 
                    }]
                }
            }
        },
        PTO: {
            label: "Relatório de Controle de Frequência",
            0: {
                cartao_ponto_3: {
                    config: {
                        itemName: "Cartão Ponto - Modelo 3",
                        fileName: "cartao_ponto_3",
                        order: 5,
                        sendEmail: true
                    },
                    params: [ {
                        field: this.DEFINITION.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    }, {
                        field: this.DEFINITION.nrvinculoMulti,
                        param: "P_VINCULO"
                    }, {
                        field: this.DEFINITION.nrestrutlegalMulti,
                        param: "P_ESTRUTLEGAL"
                    }, {
                        field: this.DEFINITION.nrestrutgerenMulti,
                        param: "P_ESTRUTGEREN"
                    }, {
                        field: this.DEFINITION.nrperiodoapuracao,
                        param: "P_NRPERIODOAPURACAO",
                        required: true
                    }, {
                        field: this.DEFINITION.tpvinculo,
                        param: "P_TPVINCULO",
                        required: true
                    } ]
                },
                folha_ponto: {
                    config: {
                        itemName: "Folha de Ponto",
                        fileName: "folha_ponto",
                        order: 10
                    },
                    params: [ {
                        field: this.DEFINITION.nrvinculoMulti,
                        param: "P_NRVINCULOM"
                    }, {
                        field: this.DEFINITION.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    } ]
                },
                ponto_demonstrativo: {
                    config: {
                        itemName: "Ponto Demonstrativo",
                        fileName: "ponto_demonstrativo",
                        order: 20,
                        sendEmail: true
                    },
                    params: [ {
                        field: this.DEFINITION.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    }, {
                        field: this.DEFINITION.nrvinculoMulti,
                        param: "P_VINCULO"
                    }, {
                        field: this.DEFINITION.nrestrutlegal,
                        param: "P_ESTRUTLEGAL"
                    }, {
                        field: this.DEFINITION.nrestrutgeren,
                        param: "P_ESTRUTGEREN"
                    }, {
                        field: this.DEFINITION.nrperiodoapuracao,
                        param: "P_PERIODO",
                        required: true
                    }, {
                        field: this.DEFINITION.tpvinculo,
                        param: "P_TPVINCULO",
                        required: true
                    }, {
                        field: this.DEFINITION.opcao1,
                        param: "P_NAOEXIGIMARC",
                        label: "Exibir Vínculos sem Marcação de Ponto"
                    } ]
                },
                absenteismo: {
                    config: {
                        itemName: "Relatório de Absenteísmo",
                        fileName: "absenteismo",
                        order: 30
                    },
                    params: [ {
                        field: this.DEFINITION.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    }, {
                        field: this.DEFINITION.nrvinculoMulti,
                        param: "P_VINCULO"
                    }, {
                        field: this.DEFINITION.nrestrutlegal,
                        param: "P_ESTRUTLEGAL"
                    }, {
                        field: this.DEFINITION.nrestrutgeren,
                        param: "P_ESTRUTGEREN"
                    }, {
                        field: this.DEFINITION.nrperiodoapuracao,
                        param: "P_PERIODO",
                        required: true
                    }, {
                        field: this.DEFINITION.tpvinculo,
                        param: "P_TPVINCULO",
                        required: true
                    } ]
                },
                saldo_banco_horas: {
                    config: {
                        itemName: "Saldo Banco de Horas",
                        fileName: "saldo_banco_horas",
                        order: 40
                    },
                    params: [ {
                        field: this.DEFINITION.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    }, {
                        field: this.DEFINITION.nrvinculoMulti,
                        param: "P_VINCULO"
                    }, {
                        field: this.DEFINITION.nrestrutlegal,
                        param: "P_ESTRUTLEGAL"
                    }, {
                        field: this.DEFINITION.nrestrutgeren,
                        param: "P_ESTRUTGEREN"
                    }, {
                        field: this.DEFINITION.nrperiodoapuracao,
                        param: "P_PERIODO",
                        required: true
                    }, {
                        field: this.DEFINITION.tpvinculo,
                        param: "P_TPVINCULO",
                        required: true
                    } ]
                }
            },
        },
        SST: {
            label: "Relatórios de EPI",
            0: {
                controle_entrega_epi: {
                    config: {
                        itemName: "Ficha de Controle de Entrega de EPI e Treinamento de Uso",
                        fileName: "controle_entrega_epi",
                        order: 10
                    },
                    params: [ {
                        field: this.DEFINITION.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    }, {
                        field: this.DEFINITION.nrvinculoMulti,
                        param: "P_VINCULO"
                    }, {
                        field: this.DEFINITION.tpvinculo,
                        param: "P_TIPOVINCULO"
                    }, {
                        field: this.DEFINITION.nrestrutlegal,
                        param: "P_ESTRUTLEGAL"
                    }, {
                        field: this.DEFINITION.nrestrutgeren,
                        param: "P_ESTRUTGEREN"
                    }, {
                        field: this.DEFINITION.dtinicio,
                        param: "P_DTINICIO"
                    }, {
                        field: this.DEFINITION.dtfim,
                        param: "P_DTFINAL"
                    }, {
                        field: this.DEFINITION.dtdocumento,
                        param: "P_DATADOCUMENTO"
                    } ]
                },
                recibo_epi: {
                    config: {
                        itemName: "Recibo de Entrega de EPI / Uniformes",
                        fileName: "recibo_epi",
                        order: 20
                    },
                    params: [ {
                        field: this.DEFINITION.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    }, {
                        field: this.DEFINITION.nrvinculoMulti,
                        param: "P_VINCULO"
                    }, {
                        field: this.DEFINITION.tpvinculo,
                        param: "P_TIPOVINCULO"
                    }, {
                        field: this.DEFINITION.nrestrutlegal,
                        param: "P_ESTRUTLEGAL"
                    }, {
                        field: this.DEFINITION.nrestrutgeren,
                        param: "P_ESTRUTGEREN"
                    }, {
                        field: this.DEFINITION.dtinicio,
                        param: "P_DTINICIO"
                    }, {
                        field: this.DEFINITION.dtfim,
                        param: "P_DTFINAL"
                    }, {
                        field: this.DEFINITION.dtdocumento,
                        param: "P_DATADOCUMENTO"
                    }, {
                        field: this.DEFINITION.nrestrutlegal,
                        param: "P_ESTRUTLEGAL"
                    }, {
                        field: this.DEFINITION.nrestrutgeren,
                        param: "P_ESTRUTGEREN"
                    } ]
                },
            }
        },
        SST_med: {
            label: "Relatórios de Medicina do Trabalho",
            0: {
                modelo_cat: {
                    config: {
                        itemName: "Modelo CAT (Comunicado de Acidente de Trabalho)",
                        fileName: "modelo_cat",
                        order: 30
                    },
                    params: [ {
                        field: this.DEFINITION.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    }, {
                        field: this.DEFINITION.nrvinculoMulti,
                        param: "P_VINCULO"
                    }, {
                        field: this.DEFINITION.dtinicio,
                        param: "P_DTINICIO",
                        label: "Data Inicial da Admissão"
                    }, {
                        field: this.DEFINITION.dtfim,
                        param: "P_DTFINAL",
                        label: "Data Final da Admissão"
                    }]
                },
                ppp: {
                    config: {
                        itemName: "Perfil Profissiográfico Previdenciário – PPP",
                        fileName: "ppp",
                        order: 60
                    },
                    params: [ {
                        field: this.DEFINITION.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    }, {
                        field: this.DEFINITION.nrvinculoMulti,
                        param: "P_VINCULO"
                    }, {
                        field: this.DEFINITION.pessoa3,
                        param: "P_PESSOAAMB",
                        required: true,
                        label: "Responsável pelos Registros Ambientais"
                    }, {
                        field: this.DEFINITION.pessoa4,
                        param: "P_PESSOABIO",
                        required: true,
                        label: "Responsável pela Monitoração Biológica"
                    }, {
                        field: this.DEFINITION.dtinicio,
                        param: "P_DTINICIO",
                        label: "Data Inicial da Admissão"
                    }, {
                        field: this.DEFINITION.dtfim,
                        param: "P_DTFINAL",
                        label: "Data Final da Admissão"
                    } ]
                }
            }
        },
        FPA_res: {
            label: "Relatórios de Rescisão",
            0: {
                trct: {
                    config: {
                        itemName: "Termo de Rescisão de Contrato de Trabalho",
                        fileName: "trct",
                        order: 10
                    },
                    params: [ {
                        field: this.DEFINITION.competencia,
                        param: "P_DTMESCOMPETENC",
                        required: true
                    }, {
                        field: this.DEFINITION.nrestrutlegal,
                        param: "P_NRESTRUTURA"
                    }, {
                        field: this.DEFINITION.nrestrutgeren,
                        param: "P_NRESTRUTGEREN"
                    }, {
                        field: this.DEFINITION.nrvinculoRescMulti,
                        param: "P_NRVINCULO"
                    }, {
                        field: this.DEFINITION.opcao1,
                        param: "P_IDTERMINO",
                        label: "Tipo Término de Contrato de Trabalho no Prazo",
                        valueField: "",
                        dataList: [ {
                            name: "",
                            value: ""
                        }, {
                            name: "Contrato de Trabalho por Prazo Determinado sem cláusula Assecuratória de Direito Recíproco de Rescisão Antecipada",
                            value: "1"
                        }, {
                            name: "Contrato de Trabalho por Prazo Determinado com cláusula Assecuratória de Direito Recíproco de Rescisão Antecipada",
                            value: "2"
                        }, {
                            name: "Término de Contrato Por Prazo Determinado",
                            value: "3"
                        } ],
                        required: false
                    } ]
                },
                trct_qh: {
                    config: {
                        itemName: "Termo de Rescisão de Contrato de Trabalho (com Quitação/Homologação)",
                        fileName: "trct_qh",
                        order: 20
                    },
                    params: [ {
                        field: this.DEFINITION.competencia,
                        param: "P_DTMESCOMPETENC",
                        required: true
                    }, {
                        field: this.DEFINITION.nrestrutlegal,
                        param: "P_NRESTRUTURA"
                    }, {
                        field: this.DEFINITION.nrestrutgeren,
                        param: "P_NRESTRUTGEREN"
                    }, {
                        field: this.DEFINITION.nrvinculoRescMulti,
                        param: "P_NRVINCULO"
                    }, {
                        field: this.DEFINITION.tpdocumento,
                        param: "P_DOCUMENTO",
                        valueField: "A"
                    }, {
                        field: this.DEFINITION.pessoa1,
                        param: "P_PESSOARESP",
                        label: "Pessoa Outorgado"
                    }, {
                        field: this.DEFINITION.opcao1,
                        param: "P_IDTERMINO",
                        label: "Tipo Término de Contrato de Trabalho no Prazo",
                        valueField: "",
                        dataList: [ {
                            name: "",
                            value: ""
                        }, {
                            name: "Contrato de Trabalho por Prazo Determinado sem cláusula Assecuratória de Direito Recíproco de Rescisão Antecipada",
                            value: "1"
                        }, {
                            name: "Contrato de Trabalho por Prazo Determinado com cláusula Assecuratória de Direito Recíproco de Rescisão Antecipada",
                            value: "2"
                        }, {
                            name: "Término de Contrato Por Prazo Determinado",
                            value: "3"
                        } ],
                        required: false
                    } ]
                },
                trct_qh_medias: {
                    config: {
                        itemName: "Termo de Rescisão de Contrato de Trabalho (com Quitação/Homologação/Acompanhamento)",
                        fileName: "trct_qh_medias",
                        order: 30
                    },
                    params: [ {
                        field: this.DEFINITION.competencia,
                        param: "P_DTMESCOMPETENC",
                        required: true
                    }, {
                        field: this.DEFINITION.nrestrutlegal,
                        param: "P_NRESTRUTURA"
                    }, {
                        field: this.DEFINITION.nrestrutgeren,
                        param: "P_ESTRUTGEREN"
                    }, {
                        field: this.DEFINITION.nrvinculoRescMulti,
                        param: "P_NRVINCULO"
                    }, {
                        field: this.DEFINITION.tpdocumento,
                        param: "P_DOCUMENTO",
                        valueField: "A"
                    }, {
                        field: this.DEFINITION.pessoa1,
                        param: "P_PESSOARESP",
                        label: "Pessoa Outorgado"
                    }, {
                        field: this.DEFINITION.opcao1,
                        param: "P_IDTERMINO",
                        label: "Tipo Término de Contrato de Trabalho no Prazo",
                        valueField: "",
                        dataList: [ {
                            name: "",
                            value: ""
                        }, {
                            name: "Contrato de Trabalho por Prazo Determinado sem cláusula Assecuratória de Direito Recíproco de Rescisão Antecipada",
                            value: "1"
                        }, {
                            name: "Contrato de Trabalho por Prazo Determinado com cláusula Assecuratória de Direito Recíproco de Rescisão Antecipada",
                            value: "2"
                        }, {
                            name: "Término de Contrato Por Prazo Determinado",
                            value: "3"
                        } ],
                        required: false
                    } ]
                },
                acordo_extincao_ct: {
                    config: {
                        itemName: "Termo de Acordo Para Extinção do Contrato de Trabalho",
                        fileName: "acordo_extincao_ct",
                        order: 35
                    },
                    params: [{
                        field: this.DEFINITION.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    },{
                        field: this.DEFINITION.nrvinculoMulti,
                        param: "P_VINCULO"
                    },{
                        field: this.DEFINITION.nrestrutlegal,
                        param: "P_ESTRUTLEGAL"
                    },{
                        field: this.DEFINITION.nrestrutgeren,
                        param: "P_ESTRUTGEREN"
                    },{
                        label: "Data Inicial de Rescisão",
                        field: this.DEFINITION.dtinicio,
                        param: "P_INICIO"
                    },{
                        label: "Data Final da Rescisão",
                        field: this.DEFINITION.dtfim,
                        param: "P_FINAL"
                    },{
                        label: "Data do Documento",
                        field: this.DEFINITION.dtdocumento,
                        param: "P_DTDOCUMENTO"
                    }]
                },
                thrct: {
                    config: {
                        itemName: "Termo de Homologação de Rescisão de Contrato de Trabalho",
                        fileName: "thrct",
                        order: 40
                    },
                    params: [ {
                        field: this.DEFINITION.competencia,
                        param: "P_DTMESCOMPETENC",
                        required: true
                    }, {
                        field: this.DEFINITION.nrestrutlegal,
                        param: "P_NRESTRUTURA"
                    }, {
                        field: this.DEFINITION.nrvinculoResc,
                        param: "P_NRVINCULO",
                        required: true
                    }, {
                        field: this.DEFINITION.tpdocumento,
                        param: "P_DOCUMENTO",
                        valueField: "A"
                    }, {
                        field: this.DEFINITION.pessoa1,
                        param: "P_PESSOARESP",
                        label: "Pessoa Outorgado"
                    } ]
                },
                tqrct: {
                    config: {
                        itemName: "Termo de Quitação de Rescisão de Contrato de Trabalho",
                        fileName: "tqrct",
                        order: 50
                    },
                    params: [ {
                        field: this.DEFINITION.competencia,
                        param: "P_DTMESCOMPETENC",
                        required: true
                    }, {
                        field: this.DEFINITION.nrestrutlegal,
                        param: "P_NRESTRUTURA"
                    }, {
                        field: this.DEFINITION.nrvinculoResc,
                        param: "P_NRVINCULO",
                        required: true
                    }, {
                        field: this.DEFINITION.tpdocumento,
                        param: "P_DOCUMENTO",
                        valueField: "A"
                    }, {
                        field: this.DEFINITION.pessoa1,
                        param: "P_PESSOARESP",
                        label: "Pessoa Outorgado"
                    } ]
                },
                termo_rescisao_nao_oficial: {
                    config: {
                        itemName: "Lançamentos de Rescisão",
                        fileName: "termo_rescisao_nao_oficial",
                        order: 51
                    },
                    params: [ {
                        field: this.DEFINITION.competencia,
                        param: "P_DTMESCOMPETENC",
                        required: true
                    }, {
                        field: this.DEFINITION.nrestrutlegal,
                        param: "P_NRESTRUTURA"
                    }, {
                        field: this.DEFINITION.nrvinculoResc,
                        param: "P_NRVINCULO",
                        required: true
                    } ]
                },
                medias_rescisao_mensal: {
                    config: {
                        itemName: "Médias Mensal na Rescisão",
                        fileName: "medias_rescisao_mensal",
                        order: 60
                    },
                    params: [ {
                        field: this.DEFINITION.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    }, {
                        field: this.DEFINITION.nrvinculoRescMulti,
                        param: "P_VINCULO"
                    }, {
                        field: this.DEFINITION.nrestrutlegal,
                        param: "P_ESTRUTLEGAL"
                    }, {
                        field: this.DEFINITION.nrestrutgeren,
                        param: "P_ESTRUTGEREN"
                    }, {
                        field: this.DEFINITION.dtinicio,
                        param: "P_INICIO",
                        label: "Data inicial da rescisão"
                    }, {
                        field: this.DEFINITION.dtfim,
                        param: "P_FINAL",
                        label: "Data final da rescisão"
                    } ]
                },
                medias_rescisao_aviso_prev: {
                    config: {
                        itemName: "Médias para Aviso Prévio na Rescisão",
                        fileName: "medias_rescisao_aviso_prev",
                        order: 70
                    },
                    params: [ {
                        field: this.DEFINITION.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    }, {
                        field: this.DEFINITION.nrvinculoRescMulti,
                        param: "P_VINCULO"
                    }, {
                        field: this.DEFINITION.nrestrutlegal,
                        param: "P_ESTRUTLEGAL"
                    }, {
                        field: this.DEFINITION.nrestrutgeren,
                        param: "P_ESTRUTGEREN"
                    }, {
                        field: this.DEFINITION.dtinicio,
                        param: "P_INICIO",
                        label: "Data inicial da rescisão"
                    }, {
                        field: this.DEFINITION.dtfim,
                        param: "P_FINAL",
                        label: "Data final da rescisão"
                    } ]
                },
                medias_rescisao_13: {
                    config: {
                        itemName: "Médias para 13 Salário na Rescisão",
                        fileName: "medias_rescisao_13",
                        order: 80
                    },
                    params: [ {
                        field: this.DEFINITION.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    }, {
                        field: this.DEFINITION.nrvinculoRescMulti,
                        param: "P_VINCULO"
                    }, {
                        field: this.DEFINITION.nrestrutlegal,
                        param: "P_ESTRUTLEGAL"
                    }, {
                        field: this.DEFINITION.nrestrutgeren,
                        param: "P_ESTRUTGEREN"
                    }, {
                        field: this.DEFINITION.dtinicio,
                        param: "P_INICIO",
                        label: "Data inicial da rescisão"
                    }, {
                        field: this.DEFINITION.dtfim,
                        param: "P_FINAL",
                        label: "Data final da rescisão"
                    } ]
                },
                medias_rescisao_ferias: {
                    config: {
                        itemName: "Médias para Férias na Rescisão",
                        fileName: "medias_rescisao_ferias",
                        order: 90
                    },
                    params: [ {
                        field: this.DEFINITION.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    }, {
                        field: this.DEFINITION.nrvinculoRescMulti,
                        param: "P_VINCULO"
                    }, {
                        field: this.DEFINITION.nrestrutlegal,
                        param: "P_ESTRUTLEGAL"
                    }, {
                        field: this.DEFINITION.nrestrutgeren,
                        param: "P_ESTRUTGEREN"
                    }, {
                        field: this.DEFINITION.dtinicio,
                        param: "P_INICIO",
                        label: "Data inicial da rescisão"
                    }, {
                        field: this.DEFINITION.dtfim,
                        param: "P_FINAL",
                        label: "Data final da rescisão"
                    } ]
                },
                aviso_previo_empregado: {
                    config: {
                        itemName: "Aviso Prévio do Empregado",
                        fileName: "aviso_previo_empregado",
                        order: 100
                    },
                    params: [ {
                        field: this.DEFINITION.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    }, {
                        field: this.DEFINITION.nrvinculoResc,
                        param: "P_NRVINCULOM",
                        required: true
                    }, {
                        field: this.DEFINITION.dtdocumento,
                        param: "P_DATADOCUMENTO",
                        label: "Data do aviso prévio"
                    }, {
                        field: this.DEFINITION.opcao2,
                        label: '2 Vias',
                        param: "P_2VIAS"
                    }]
                },
                aviso_previo_empregador: {
                    config: {
                        itemName: "Aviso Prévio do Empregador",
                        fileName: "aviso_previo_empregador",
                        order: 110
                    },
                    params: [ {
                        field: this.DEFINITION.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    }, {
                        field: this.DEFINITION.nrvinculoResc,
                        param: "P_NRVINCULOM",
                        required: true
                    }, {
                        field: this.DEFINITION.dtdocumento,
                        param: "P_DTAVISO",
                        label: "Data do aviso prévio"
                    }, {
                        field: this.DEFINITION.opcao2,
                        label: '2 Vias',
                        param: "P_2VIAS"
                    }, {
                        field: this.DEFINITION.opcao1,
                        param: "P_TIPOAVISO",
                        label: "Tipo de Aviso Prévio",
                        dataList: [ {
                            name: "Aviso Prévio Indenizado",
                            value: "S"
                        }, {
                            name: "Aviso Prévio Trabalhado",
                            value: "N"
                        } ],
                        required: true
                    } ]
                },
                aviso_previo_empregador_2: {
                    config: {
                        itemName: "Aviso Prévio do Empregador - Modelo 2",
                        fileName: "aviso_previo_empregador_2",
                        order: 113
                    },
                    params: [ {
                        field: this.DEFINITION.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    }, {
                        field: this.DEFINITION.nrestrutlegalMulti,
                        param: "P_ESTRUTLEGAL"
                    },{
                        field: this.DEFINITION.nrestrutgerenMulti,
                        param: "P_ESTRUTGEREN"
                    },{
                        field: this.DEFINITION.nrvinculoMulti,
                        param: "P_VINCULO"
                    },{
                        label: "Data do Documento",
                        field: this.DEFINITION.dtdocumento,
                        param: "P_DTDOCUMENTO"
                    }, {
                        field: this.DEFINITION.data1,
                        param: "P_DTAVISO",
                        label: "Data do aviso prévio",
                        required: true
                    },{
                        label: "Dias de aviso",
                        field: this.DEFINITION.number1,
                        param: "P_DIASAVISO",
                        required: true
                    }, {
                        label: "Mostrar Rodapé",
                        field: this.DEFINITION.opcao1,
                        valueField: "S",
                        param: "P_SHOWFOOTER"
                    } ]
                },
                aviso_previo_empregador_indenizado_2: {
                    config: {
                        itemName: "Aviso Prévio do Empregador Indenizado - Modelo 2",
                        fileName: "aviso_previo_empregador_indenizado_2",
                        order: 114
                    },
                    params: [ {
                        field: this.DEFINITION.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    }, {
                        field: this.DEFINITION.nrestrutlegalMulti,
                        param: "P_ESTRUTLEGAL"
                    },{
                        field: this.DEFINITION.nrestrutgerenMulti,
                        param: "P_ESTRUTGEREN"
                    },{
                        field: this.DEFINITION.nrvinculoMulti,
                        param: "P_VINCULO"
                    },{
                        label: "Data do Documento",
                        field: this.DEFINITION.dtdocumento,
                        param: "P_DTDOCUMENTO"
                    }, {
                        field: this.DEFINITION.data1,
                        param: "P_DTAVISO",
                        label: "Data do aviso prévio",
                        required: true
                    },{
                        label: "Dias de aviso",
                        field: this.DEFINITION.number1,
                        param: "P_DIASAVISO",
                        required: true
                    }, {
                        label: "Mostrar Rodapé",
                        field: this.DEFINITION.opcao1,
                        valueField: "S",
                        param: "P_SHOWFOOTER"
                    } ]
                },
                avisos_previos: {
                    config: {
                        itemName: "Aviso prévio - Informações adicionais",
                        fileName: "avisos_1024",
                        order: 115
                    },
                    params: [{
                        field: this.DEFINITION.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    },
                    {
                        field: this.DEFINITION.opcao2,
                        param: "P_RELATORIO",
                        required: true,
                        dataList: [ {
                                name: "Aviso Prévio do Empregador",
                                value: "aviso_empregador"
                            }, {
                                name: "Término de Contrato de Experiência",
                                value: "termino_contrato_exp"
                            } ],
                        label: "Relatório de Aviso"
                    },
                    {
                        field: this.DEFINITION.opcao1,
                        param: "P_INDENIZADO",
                        label: "Indenizado"
                    },
                    {
                        field: this.DEFINITION.nrvinculoMulti,
                        param: "P_VINCULO"
                    },
                    {
                        field: this.DEFINITION.nrestrutlegal,
                        param: "P_ESTRUTLEGAL"
                    },
                    {
                        field: this.DEFINITION.nrestrutgeren,
                        param: "P_ESTRUTGEREN"
                    },
                    {
                        field: this.DEFINITION.data1,
                        param: "P_DTFORMPERTENCE",
                        label: "Data de devolução dos pertences"
                    },
                    {
                        field: this.DEFINITION.data2,
                        param: "P_DTFORMFORMAL",
                        label: "Data da formalidade legal"
                    },
                    {
                        field: this.DEFINITION.data3,
                        param: "P_DTFORMEXAME",
                        label: "Data do exame demissional"
                    },
                    {
                        field: this.DEFINITION.data4,
                        param: "P_DTFORMPAGTO",
                        label: "Data do pagamento (banco)"
                    },
                    {
                        field: this.DEFINITION.data5,
                        param: "P_DTFORMEMISSAO",
                        label: "Data de Emissão",
                        required: true
                    },
                    {
                        field: this.DEFINITION.dtinicio,
                        param: "P_DATAINI",
                        label: "Data Inicial da Rescisão"
                    },
                    {
                        field: this.DEFINITION.dtfim,
                        param: "P_DATAFIM",
                        label: "Data Final da Rescisão"
                    },
                    {
                        label: "Dias de aviso",
                        field: this.DEFINITION.number4,
                        param: "P_DIASAVISO",
                        valueField: "30"
                    }
                  ]
                },
                comunicado_acerto_verbas_rescisorias: {
                    config: {
                        itemName: "Comunicado para Acerto de Verbas Rescisórias",
                        fileName: "comunicado_acerto_verbas_rescisorias",
                        order: 118
                    },
                    params: [{
                        field: this.DEFINITION.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    },{
                        field: this.DEFINITION.nrvinculoMulti,
                        param: "P_VINCULO"
                    },{
                        field: this.DEFINITION.nrestrutlegal,
                        param: "P_NRESTRUTLEGAL"
                    },{
                        field: this.DEFINITION.nrestrutgeren,
                        param: "P_NRESTRUTGEREN"
                    },{
                        label: "Data Inicial de Rescisão",
                        field: this.DEFINITION.dtinicio,
                        param: "P_DTINICIO"
                    },{
                        label: "Data Final de Rescisão",
                        field: this.DEFINITION.dtfim,
                        param: "P_DTFINAL"
                    },{
                        label: "Data do Documento",
                        field: this.DEFINITION.dtdocumento,
                        param: "P_DTDOCUMENTO"
                    },{
                        label: "Endereço para Exame Demissional (Estrutura Legal)",
                        field: this.DEFINITION.nrestrutlegal2,
                        param: "P_NRESTRUTEXAME"
                    },{
                        label: "Endereço para Recebimento das Verbas Rescisórias (Estrutura Legal)",
                        field: this.DEFINITION.nrestrutlegal3,
                        param: "P_NRESTRUTVERBAS"
                    },{
                        label: "Data/Hora para Exame Demissional",
                        field: this.DEFINITION.datahora1,
                        param: "P_DTHREXAME",
                        required: false
                    },{
                        label: "Data/Hora para Recebimento das Verbas Rescisórias",
                        field: this.DEFINITION.datahora2,
                        param: "P_DTHVERBAS",
                        required: false
                    },{
                        label: "Data do Depósito das Verbas Rescisórias",
                        field: this.DEFINITION.data1,
                        param: "P_DTDEPOSITO"
                    }]
                },
                funcionarios_demitidos_periodo: {
                    config: {
                        itemName: "Funcionários Demitidos no Período",
                        fileName: "funcionarios_demitidos_periodo",
                        order: 123
                    },
                    params: [ {
                        field: this.DEFINITION.competencia,
                        param: "P_DTMESCOMPETENC",
                        required: true
                    }, {
                        field: this.DEFINITION.nrestrutlegal,
                        param: "P_NRESTRUTURA"
                    }, {
                        field: this.DEFINITION.nrestrutgeren,
                        param: "P_NRESTRUTURAGEREN"
                    }, {
                        field: this.DEFINITION.dtinicio,
                        param: "P_DTINICIAL",
                        label: "Data inicial da rescisão",
                        required: true
                    }, {
                        field: this.DEFINITION.dtfim,
                        param: "P_DTFINAL",
                        label: "Data final da rescisão",
                        required: true
                    }, {
                        field: this.DEFINITION.zebrado,
                        param: "ZEBRADO"
                    }]
                },
                seguro_desemprego: {
                    config: {
                        itemName: "Seguro Desemprego (formulário contínuo)",
                        fileName: "seguro_desemprego",
                        order: 124
                    },
                    params: [ {
                        field: this.DEFINITION.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    }, {
                        field: this.DEFINITION.nrvinculoRescMulti,
                        param: "P_NRVINCULO"
                    }, {
                        field: this.DEFINITION.dtinicio,
                        param: "P_DATAINICIAL",
                        label: "Data inicial da rescisão"
                    }, {
                        field: this.DEFINITION.dtfim,
                        param: "P_DATAFINAL",
                        label: "Data final da rescisão"
                    }, {
                        field: this.DEFINITION.nrestrutlegal,
                        param: "P_NRESTRUTURALEGAL"
                    }, {
                        field: this.DEFINITION.nrestrutgeren,
                        param: "P_NRESTRUTURAGEREN"
                    }, {
                        field: this.DEFINITION.tipomovimento1,
                        param: "P_TIPOMOVIMENTO",
                        required: true,
                        descriptionField: "Mensal",
                        valueField: "1"
                    } ]
                },
                seguro_desemprego_laser: {
                    config: {
                        itemName: "Seguro Desemprego (laser modelo 1)",
                        fileName: "seguro_desemprego_laser",
                        order: 130
                    },
                    params: [ {
                        field: this.DEFINITION.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    }, {
                        field: this.DEFINITION.nrvinculoRescMulti,
                        param: "P_NRVINCULO"
                    }, {
                        field: this.DEFINITION.dtinicio,
                        param: "P_DATAINICIAL",
                        label: "Data inicial da rescisão"
                    }, {
                        field: this.DEFINITION.dtfim,
                        param: "P_DATAFINAL",
                        label: "Data final da rescisão"
                    }, {
                        field: this.DEFINITION.nrestrutlegal,
                        param: "P_NRESTRUTURALEGAL"
                    }, {
                        field: this.DEFINITION.nrestrutgeren,
                        param: "P_NRESTRUTURAGEREN"
                    }, {
                        field: this.DEFINITION.tipomovimento1,
                        param: "P_TIPOMOVIMENTO",
                        required: true,
                        descriptionField: "Mensal", valueField: "1"
                    } ]
                },
                seguro_desemprego_laser_2: {
                    config: {
                        itemName: "Seguro Desemprego (laser modelo 2)",
                        fileName: "seguro_desemprego_laser_2",
                        order: 140
                    },
                    params: [ {
                        field: this.DEFINITION.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    }, {
                        field: this.DEFINITION.nrvinculoRescMulti,
                        param: "P_NRVINCULO"
                    }, {
                        field: this.DEFINITION.dtinicio,
                        param: "P_DATAINICIAL",
                        label: "Data inicial da rescisão"
                    }, {
                        field: this.DEFINITION.dtfim,
                        param: "P_DATAFINAL",
                        label: "Data final da rescisão"
                    }, {
                        field: this.DEFINITION.nrestrutlegal,
                        param: "P_NRESTRUTURALEGAL"
                    }, {
                        field: this.DEFINITION.nrestrutgeren,
                        param: "P_NRESTRUTURAGEREN"
                    }, {
                        field: this.DEFINITION.tipomovimento1,
                        param: "P_TIPOMOVIMENTO",
                        required: true,
                        descriptionField: "Mensal", valueField: "1"
                    } ]
                },
                requisicao_seguro_desemprego: {
                    config: {
                        itemName: "Requisição de Seguro Desemprego",
                        fileName: "requisicao_seguro_desemprego",
                        notShow: false, //Campo opcional. Estão aqui para exemplo. TODO implementar estas alterações.
                        format: "pdf", //Campo opcional. Estão aqui para exemplo. TODO implementar estas alterações.
                        download: { //Campo opcional.
                            fileName: "requisicao_seguro_desemprego", //Requerido
                            format: "txt", //Requerido
                            extension: 'SD', //Campo opcional. Usa esta extensão no arquivo gerado. Se não informada usará a extensão do 'format'.
                            strFind: "*", //Campo opcional. String que será substituída pela strinf 'strReplace'
                            strReplace: " " ////Campo opcional.
                        },
                        order: 145
                    },
                    params: [ {
                        field: this.DEFINITION.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    }, {
                        field: this.DEFINITION.nrvinculoRescMulti,
                        param: "P_NRVINCULO"
                    }, {
                        field: this.DEFINITION.dtinicio,
                        param: "P_DTINICIAL",
                        label: "Data inicial da rescisão"
                    }, {
                        field: this.DEFINITION.dtfim,
                        param: "P_DTFINAL",
                        label: "Data final da rescisão"
                    }, {
                        field: this.DEFINITION.nrestrutlegal,
                        param: "P_ESTRUTEMPRESA",
                        required: true
                    }, {
                        field: this.DEFINITION.nrestrutgeren,
                        param: "P_NRESTRUTURAGEREN"
                    } ]
                },
                retratacao_pedido_demissao: {
                    config: {
                        itemName: "Retratação (modelo carta próprio punho)",
                        fileName: "retratacao_pedido_demissao",
                        order: 150
                    },
                    params: [ {
                        field: this.DEFINITION.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    }, {
                        field: this.DEFINITION.nrvinculoResc,
                        param: "P_VINCULO",
                        required: true
                    } ]
                },
                retratacao_dispensa: {
                    config: {
                        itemName: "Carta de Retratação",
                        fileName: "retratacao_dispensa",
                        order: 160
                    },
                    params: [ {
                        field: this.DEFINITION.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    }, {
                        field: this.DEFINITION.nrvinculoResc,
                        param: "P_VINCULO",
                        required: true
                    }, {
                        field: this.DEFINITION.dtdocumento,
                        param: "P_DTPERICIAINSS",
                        label: "Data da Perícia do INSS"
                    } ]
                },
                retratacao_aceite: {
                    config: {
                        itemName: "Carta de Aceite de Retratação",
                        fileName: "retratacao_aceite",
                        order: 170
                    },
                    params: [ {
                        field: this.DEFINITION.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    }, {
                        field: this.DEFINITION.nrvinculoResc,
                        param: "P_VINCULO",
                        required: true
                    } ]
                },
                carta_preposto: {
                    config: {
                        itemName: "Carta de Preposto",
                        fileName: "carta_preposto",
                        order: 180
                    },
                    params: [ {
                        field: this.DEFINITION.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    }, {
                        field: this.DEFINITION.nrvinculoRescMulti,
                        param: "P_VINCULO"
                    }, {
                        field: this.DEFINITION.nrestrutlegal,
                        param: "P_ESTRUTLEGAL"
                    }, {
                        field: this.DEFINITION.nrestrutgeren,
                        param: "P_ESTRUTGEREN"
                    }, {
                        field: this.DEFINITION.dtinicio,
                        param: "P_INICIO",
                        label: "Data inicial da rescisão"
                    }, {
                        field: this.DEFINITION.dtfim,
                        param: "P_FINAL",
                        label: "Data final da rescisão"
                    }, {
                        field: this.DEFINITION.pessoa1,
                        param: "P_PESSOUTOR",
                        label: "Pessoa Outorgado"
                    }, {
                        field: this.DEFINITION.dtdocumento,
                        param: "P_DATADOCUMENTO",
                        label: "Data do documento"
                    }, {
                        label: "Mostrar Rodapé",
                        field: this.DEFINITION.opcao1,
                        valueField: "N",
                        param: "P_SHOWFOOTER"
                    }]
                },
                carta_demissao_ca: {
                    config: {
                        itemName: "Carta de Demissão por Comum Acordo",
                        fileName: "carta_demissao_ca",
                        order: 190
                    },
                    params: [{
                        field: this.DEFINITION.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    },{
                        field: this.DEFINITION.nrvinculoMulti,
                        param: "P_VINCULO"
                    },{
                        field: this.DEFINITION.nrestrutlegal,
                        param: "P_ESTRUTLEGAL"
                    },{
                        field: this.DEFINITION.nrestrutgeren,
                        param: "P_ESTRUTGEREN"
                    },{
                        label: "Data Inicial de Rescisão",
                        field: this.DEFINITION.dtinicio,
                        param: "P_INICIO"
                    },{
                        label: "Data Final da Rescisão",
                        field: this.DEFINITION.dtfim,
                        param: "P_FINAL"
                    },{
                        label: "Data do Documento",
                        field: this.DEFINITION.dtdocumento,
                        param: "P_DTDOCUMENTO"
                    }]
                },
                carta_referencia: {
                    config: {
                        itemName: "Carta de Referência",
                        fileName: "carta_referencia",
                        order: 195
                    },
                    params: [{
                        field: this.DEFINITION.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    },{
                        field: this.DEFINITION.nrvinculoRescMulti,
                        param: "P_VINCULO"
                    },{
                        field: this.DEFINITION.nrestrutlegal,
                        param: "P_ESTRUTLEGAL"
                    },{
                        field: this.DEFINITION.nrestrutgeren,
                        param: "P_ESTRUTGEREN"
                    },{
                        label: "Data Inicial de Rescisão",
                        field: this.DEFINITION.dtinicio,
                        param: "P_INICIO"
                    },{
                        label: "Data Final da Rescisão",
                        field: this.DEFINITION.dtfim,
                        param: "P_FINAL"
                    },{
                        label: "Data do Documento",
                        field: this.DEFINITION.dtdocumento,
                        param: "P_DATADOCUMENTO"
                    }]
                },
                termino_contrato_experiencia: {
                    config: {
                        itemName: "Término do Contrato de Experiência Empregador",
                        fileName: "termino_contrato_experiencia",
                        order: 200
                    },
                    params: [{
                        field: this.DEFINITION.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    },{
                        field: this.DEFINITION.nrvinculoMulti,
                        param: "P_VINCULO"
                    },{
                        field: this.DEFINITION.nrestrutlegal,
                        param: "P_ESTRUTLEGAL"
                    },{
                        field: this.DEFINITION.nrestrutgeren,
                        param: "P_ESTRUTGEREN"
                    },{
                        field: this.DEFINITION.pessoa1,
                        param: "P_PESSOARESP",
                        label: "Pessoa Outorgado"
                    },{
                        field: this.DEFINITION.dtinicio,
                        param: "P_INICIO",
                        label: "Data inicial da rescisão"
                    }, {
                        field: this.DEFINITION.dtfim,
                        param: "P_FINAL",
                        label: "Data final da rescisão"
                    },{
                        label: "Data do Documento",
                        field: this.DEFINITION.dtdocumento,
                        param: "P_DTDOCUMENTO"
                    },{
                        field: this.DEFINITION.opcao2,
                        label: '2 Vias',
                        param: "P_2VIAS"
                    },{
                        field: this.DEFINITION.observacao,
                        param: "P_OBSERVACAO"
                    },{
                        label: "Mostrar Rodapé",
                        field: this.DEFINITION.opcao1,
                        valueField: "S",
                        param: "P_SHOWFOOTER"
                    }]
                },
                termino_contrato_experiencia_2: {
                    config: {
                        itemName: "Término do Contrato de Experiência Empregador - modelo 2",
                        fileName: "termino_contrato_experiencia_2",
                        order: 210
                    },
                    params: [{
                        field: this.DEFINITION.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    },{
                        field: this.DEFINITION.nrvinculoMulti,
                        param: "P_VINCULO"
                    },{
                        field: this.DEFINITION.nrestrutlegalMulti,
                        param: "P_ESTRUTLEGAL"
                    },{
                        field: this.DEFINITION.nrestrutgerenMulti,
                        param: "P_ESTRUTGEREN"
                    },{
                        label: "Data do Documento",
                        field: this.DEFINITION.dtdocumento,
                        param: "P_DTDOCUMENTO"
                    },{
                        label: "Data de Dispensa",
                        field: this.DEFINITION.data1,
                        param: "P_DTDISPENSA",
                        required: true
                    },{
                        label: "Data de Recebimento",
                        field: this.DEFINITION.datahora1,
                        param: "P_DTHRECEB",
                        required: true
                    },{
                        label: "Mostrar Rodapé",
                        field: this.DEFINITION.opcao1,
                        valueField: "S",
                        param: "P_SHOWFOOTER"
                    }]
                },
                declaracao_continuidade_beneficio: {
                    config: {
                        itemName: "Declaração para Continuidade de Benefício",
                        fileName: "declaracao_continuidade_beneficio",
                        order: 220
                    },
                    params: [ {
                        field: this.DEFINITION.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    },{
                        field: this.DEFINITION.nrvinculoMulti,
                        param: "P_VINCULO"
                    },{
                        field: this.DEFINITION.nrestrutlegal,
                        param: "P_NRESTRUTLEGAL",
                        required: false
                    },{
                        field: this.DEFINITION.nrestrutgeren,
                        param: "P_NRESTRUTGEREN",
                        required: false
                    },{
                        label: "Data do Documento",
                        field: this.DEFINITION.dtdocumento,
                        param: "P_DTDOCUMENTO"
                    },{
                        field: this.DEFINITION.dtinicio,
                        param: "P_DTINICIO",
                        label: "Data inicial da rescisão"
                    },{
                        field: this.DEFINITION.dtfim,
                        param: "P_DTFINAL",
                        label: "Data final da rescisão"
                    } ]
                },
                autorizacao_continuidade_beneficio: {
                    config: {
                        itemName: "Autorização para Continuidade de Benefício",
                        fileName: "autorizacao_continuidade_beneficio",
                        order: 230
                    },
                    params: [ {
                        field: this.DEFINITION.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    },{
                        field: this.DEFINITION.nrvinculoMulti,
                        param: "P_VINCULO"
                    },{
                        field: this.DEFINITION.nrestrutlegal,
                        param: "P_NRESTRUTLEGAL",
                        required: false
                    },{
                        field: this.DEFINITION.nrestrutgeren,
                        param: "P_NRESTRUTGEREN",
                        required: false
                    },{
                        label: "Data do Documento",
                        field: this.DEFINITION.dtdocumento,
                        param: "P_DTDOCUMENTO"
                    },{
                        field: this.DEFINITION.nrbeneficio,
                        param: "P_NRBENEFICIO"
                    },{
                        field: this.DEFINITION.pessoa1,
                        param: "P_PESSOACONTATO",
                        label: "Contato na operadora do benefício",
                        required: false
                    },{
                        field: this.DEFINITION.dtinicio,
                        param: "P_DTINICIO",
                        label: "Data inicial da rescisão"
                    },{
                        field: this.DEFINITION.dtfim,
                        param: "P_DTFINAL",
                        label: "Data final da rescisão"
                    } ]
                }
            },
            1157: {
                aviso_previo_empregador: {
                    config: {
                        itemName: "Aviso Prévio do Empregador",
                        fileName: "aviso_previo_empregador_1157",
                        order: 110
                    },
                    params: [ {
                        field: this.DEFINITION.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    }, {
                        field: this.DEFINITION.nrvinculoMulti,
                        param: "P_VINCULO",
                        required: true
                    }, {
                        field: this.DEFINITION.nrestrutlegal,
                        param: "P_ESTRUTLEGAL",
                        required: false
                    }, {
                        field: this.DEFINITION.nrestrutgeren,
                        param: "P_ESTRUTGEREN",
                        required: false
                    }, {
                        field: this.DEFINITION.dtinicio,
                        param: "P_INICIO",
                        label: "Data inicial da admissão"
                    }, {
                        field: this.DEFINITION.dtfinal,
                        param: "P_FINAL",
                        label: "Data inicial da admissão"
                    }, {
                        field: this.DEFINITION.dtdocumento,
                        param: "P_DTAVISO",
                        label: "Data do aviso prévio"
                    } ]
                }
            },
            1019: {
                carta_preposto_1019: {
                    config: {
                        itemName: "Carta de Preposto - Nutrisaude",
                        fileName: "carta_preposto_1019",
                        order: 180
                    },
                    params: [ {
                        field: this.DEFINITION.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    }, {
                        field: this.DEFINITION.nrvinculoRescMulti,
                        param: "P_VINCULO"
                    }, {
                        field: this.DEFINITION.nrestrutlegal,
                        param: "P_ESTRUTLEGAL"
                    }, {
                        field: this.DEFINITION.nrestrutgeren,
                        param: "P_ESTRUTGEREN"
                    }, {
                        field: this.DEFINITION.dtinicio,
                        param: "P_INICIO",
                        label: "Data inicial da rescisão"
                    }, {
                        field: this.DEFINITION.dtfim,
                        param: "P_FINAL",
                        label: "Data final da rescisão"
                    }, {
                        field: this.DEFINITION.pessoa1,
                        param: "P_PESSOUTOR",
                        label: "Pessoa Outorgado"
                    }, {
                        field: this.DEFINITION.dtdocumento,
                        param: "P_DATADOCUMENTO",
                        label: "Data do documento"
                    } ]
                }
            },
            2973: {
                aviso_previo_trabalhado_2973: {
                    config: {
                        itemName: "Aviso Prévio Trabalhado - Modelo 3",
                        fileName: "aviso_previo_trabalhado_2973",
                        order: 116
                    },
                    params: [
                        {
                            field: this.DEFINITION.competencia,
                            param: "P_COMPETENCIA",
                            required: true
                        },
                        {
                            field: this.DEFINITION.nrvinculoMulti,
                            param: "P_VINCULO"
                        },
                        {
                            field: this.DEFINITION.nrestrutlegal,
                            param: "P_NRESTRUTLEGAL"
                        },
                        {
                            field: this.DEFINITION.nrestrutgeren,
                            param: "P_NRESTRUTGEREN"
                        },
                        {
                            label: "Data Inicial de Rescisão",
                            field: this.DEFINITION.dtinicio,
                            param: "P_DTINICIO"
                        },
                        {
                            label: "Data Final da Rescisão",
                            field: this.DEFINITION.dtfim,
                            param: "P_DTFINAL"
                        },
                        {
                            label: "Data do Documento",
                            field: this.DEFINITION.dtdocumento,
                            param: "P_DTDOCUMENTO"
                        },
                        {
                            label: "Dias de aviso",
                            field: this.DEFINITION.number4,
                            param: "P_DIASAVISO"
                        }
                    ]
                },
                aviso_previo_indenizado_2973: {
                    config: {
                        itemName: "Aviso Prévio Indenizado - Modelo 3",
                        fileName: "aviso_previo_indenizado_2973",
                        order: 117
                    },
                    params: [
                        {
                            field: this.DEFINITION.competencia,
                            param: "P_COMPETENCIA",
                            required: true
                        },
                        {
                            field: this.DEFINITION.nrvinculoMulti,
                            param: "P_VINCULO"
                        },
                        {
                            field: this.DEFINITION.nrestrutlegal,
                            param: "P_NRESTRUTLEGAL"
                        },
                        {
                            field: this.DEFINITION.nrestrutgeren,
                            param: "P_NRESTRUTGEREN"
                        },
                        {
                            label: "Data Inicial de Rescisão",
                            field: this.DEFINITION.dtinicio,
                            param: "P_DTINICIO"
                        },
                        {
                            label: "Data Final da Rescisão",
                            field: this.DEFINITION.dtfim,
                            param: "P_DTFINAL"
                        },
                        {
                            label: "Data do Documento",
                            field: this.DEFINITION.dtdocumento,
                            param: "P_DTDOCUMENTO"
                        }
                    ]
                },
                comunicado_interrupcao_aviso_previo_2973: {
                    config: {
                        itemName: "Comunicado de Interrupção do Aviso Prévio",
                        fileName: "comunicado_interrupcao_aviso_previo_2973",
                        order: 119
                    },
                    params: [
                        {
                            field: this.DEFINITION.competencia,
                            param: "P_COMPETENCIA",
                            required: true
                        },
                        {
                            field: this.DEFINITION.nrvinculoMulti,
                            param: "P_VINCULO"
                        },
                        {
                            field: this.DEFINITION.nrestrutlegal,
                            param: "P_NRESTRUTLEGAL"
                        },
                        {
                            field: this.DEFINITION.nrestrutgeren,
                            param: "P_NRESTRUTGEREN"
                        },
                        {
                            label: "Data Inicial de Rescisão",
                            field: this.DEFINITION.dtinicio,
                            param: "P_DTINICIO"
                        },
                        {
                            label: "Data Final da Rescisão",
                            field: this.DEFINITION.dtfim,
                            param: "P_DTFINAL"
                        },
                        {
                            label: "Data do Documento",
                            field: this.DEFINITION.dtdocumento,
                            param: "P_DTDOCUMENTO"
                        }
                    ]
                },
                contrato_trabalho_regime_experiencia_extincao_2973: {
                    config: {
                        itemName: "Dispensa no Termino do Contrato de Experiência",
                        fileName: "contrato_trabalho_regime_experiencia_extincao_2973",
                        order: 120
                    },
                    params: [
                        {
                            field: this.DEFINITION.competencia,
                            param: "P_COMPETENCIA",
                            required: true
                        },
                        {
                            field: this.DEFINITION.nrvinculoMulti,
                            param: "P_VINCULO"
                        },
                        {
                            field: this.DEFINITION.nrestrutlegal,
                            param: "P_NRESTRUTLEGAL"
                        },
                        {
                            field: this.DEFINITION.nrestrutgeren,
                            param: "P_NRESTRUTGEREN"
                        },
                        {
                            label: "Data Inicial de Rescisão",
                            field: this.DEFINITION.dtinicio,
                            param: "P_DTINICIO"
                        },
                        {
                            label: "Data Final da Rescisão",
                            field: this.DEFINITION.dtfim,
                            param: "P_DTFINAL"
                        },
                        {
                            label: "Data do Documento",
                            field: this.DEFINITION.dtdocumento,
                            param: "P_DTDOCUMENTO"
                        }
                    ]
                },
                contrato_trabalho_regime_experiencia_rescisao_2973: {
                    config: {
                        itemName: "Dispensa Antecipada do Contrato de Experiência",
                        fileName: "contrato_trabalho_regime_experiencia_rescisao_2973",
                        order: 121
                    },
                    params: [
                        {
                            field: this.DEFINITION.competencia,
                            param: "P_COMPETENCIA",
                            required: true
                        },
                        {
                            field: this.DEFINITION.nrvinculoMulti,
                            param: "P_VINCULO"
                        },
                        {
                            field: this.DEFINITION.nrestrutlegal,
                            param: "P_NRESTRUTLEGAL"
                        },
                        {
                            field: this.DEFINITION.nrestrutgeren,
                            param: "P_NRESTRUTGEREN"
                        },
                        {
                            label: "Data Inicial de Rescisão",
                            field: this.DEFINITION.dtinicio,
                            param: "P_DTINICIO"
                        },
                        {
                            label: "Data Final da Rescisão",
                            field: this.DEFINITION.dtfim,
                            param: "P_DTFINAL"
                        },
                        {
                            label: "Data do Documento",
                            field: this.DEFINITION.dtdocumento,
                            param: "P_DTDOCUMENTO"
                        }
                    ]
                },
                comunicado_rescisao_contrato_trabalho_justa_causa_2973: {
                    config: {
                        itemName: "Dispensa por Justa Causa",
                        fileName: "comunicado_rescisao_contrato_trabalho_justa_causa_2973",
                        order: 122
                    },
                    params: [
                        {
                            field: this.DEFINITION.competencia,
                            param: "P_COMPETENCIA",
                            required: true
                        },
                        {
                            field: this.DEFINITION.nrvinculoMulti,
                            param: "P_VINCULO"
                        },
                        {
                            field: this.DEFINITION.nrestrutlegal,
                            param: "P_NRESTRUTLEGAL"
                        },
                        {
                            field: this.DEFINITION.nrestrutgeren,
                            param: "P_NRESTRUTGEREN"
                        },
                        {
                            label: "Data Inicial de Rescisão",
                            field: this.DEFINITION.dtinicio,
                            param: "P_DTINICIO"
                        },
                        {
                            label: "Data Final da Rescisão",
                            field: this.DEFINITION.dtfim,
                            param: "P_DTFINAL"
                        },
                        {
                            label: "Data do Documento",
                            field: this.DEFINITION.dtdocumento,
                            param: "P_DTDOCUMENTO"
                        },
                        {
                            field: this.DEFINITION.motivoResc,
                            param: "P_NRMOTIVORESC"
                        },
                        {
                            field: this.DEFINITION.nrestrutlegal2,
                            param: "P_NRESTRUTURAM",
                            label: "Estrutura / Local para comparecimento"
                        }
                    ]
                }
            }
        },
        FPA_fol: {
            label: "Relatórios de Folha",
            0: {
                medias_13_2: {
                    config: {
                        itemName: "Acompanhamento de 13º Salário",
                        fileName: "medias_13_2",
                        order: 10
                    },
                    params: [ {
                        field: this.DEFINITION.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    }, {
                        field: this.DEFINITION.nrvinculoMulti,
                        param: "P_VINCULO"
                    }, {
                        field: this.DEFINITION.nrestrutlegal,
                        param: "P_ESTRUTLEGAL"
                    },{
                        field: this.DEFINITION.nrestrutgeren,
                        param: "P_ESTRUTGEREN"
                    }]
                },
                advertencia: {
                    config: {
                        itemName: "Advertência Modelo 1",
                        fileName: "advertencia",
                        order: 20
                    },
                    params: [ {
                        field: this.DEFINITION.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    }, {
                        field: this.DEFINITION.nrvinculoMulti,
                        param: "P_VINCULO"
                    },{
                        field: this.DEFINITION.motivoResc,
                        param: "P_NRMOTIVORESC"
                    },{
                        field: this.DEFINITION.situacaoFunc,
                        param: "P_NRSITUFUNCM",
                        required: true
                    },{
                        field: this.DEFINITION.dtinicio,
                        param: "P_INICIO"
                    },{
                        field: this.DEFINITION.dtfim,
                        param: "P_FINAL"
                    },{
                        field: this.DEFINITION.dtdocumento,
                        param: "P_DATADOCUMENTO"
                    }]
                },
                advertencia2: {
                    config: {
                        itemName: "Advertência Modelo 2",
                        fileName: "advertencia2",
                        order: 21
                    },
                    params: [ {
                        field: this.DEFINITION.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    }, {
                        field: this.DEFINITION.nrvinculoMulti,
                        param: "P_VINCULO"
                    },{
                        field: this.DEFINITION.motivoRescMulti,
                        param: "P_NRMOTIVORESC"
                    },{
                        field: this.DEFINITION.situacaoFunc,
                        param: "P_NRSITUFUNCM",
                        required: true
                    },{
                        field: this.DEFINITION.dtinicio,
                        param: "P_INICIO"
                    },{
                        field: this.DEFINITION.dtfim,
                        param: "P_FINAL"
                    },{
                        field: this.DEFINITION.dtdocumento,
                        param: "P_DATADOCUMENTO"
                    }]
                },
                analitico_custo: {
                    config: {
                        itemName: "Analítico de Custo por Estrutura Gerencial",
                        fileName: "analitico_custo",
                        order: 25
                    },
                    params: [ {
                        field: this.DEFINITION.competencia,
                        param: "P_DTMESCOMPETENC",
                        required: true
                    }, {
                        field: this.DEFINITION.nrvinculoMulti,
                        param: "P_NRVINCULOM"
                    }, {
                        field: this.DEFINITION.nrestrutlegalMulti,
                        param: "P_NRESTRUTLEGAL"
                    }, {
                        field: this.DEFINITION.nrestrutgerenMulti,
                        param: "P_NRESTRUTGEREN"
                    }, {
                        row: "NRGRUPOINCID",
                        value: "37",
                        param: "P_NRGRUPOINCID"
                    }, {
                        field: this.DEFINITION.tipomovimento1,
                        param: "P_NRTIPOMOVIMENT",
                        descriptionField: "Mensal", valueField: "1",
                        required: true
                    } ]
                },
                analitico_custo_2: {
                    config: {
                        itemName: "Analítico de Custo por Estrutura Gerencial - Planilha",
                        fileName: "analitico_custo",
                        format: "xlsx",
                        order: 26
                    },
                    params: [ {
                        field: this.DEFINITION.competencia,
                        param: "P_DTMESCOMPETENC",
                        required: true
                    }, {
                        field: this.DEFINITION.nrvinculoMulti,
                        param: "P_NRVINCULOM"
                    }, {
                        field: this.DEFINITION.nrestrutlegalMulti,
                        param: "P_NRESTRUTLEGAL"
                    }, {
                        field: this.DEFINITION.nrestrutgerenMulti,
                        param: "P_NRESTRUTGEREN"
                    }, {
                        row: "NRGRUPOINCID",
                        value: "37",
                        param: "P_NRGRUPOINCID"
                    }, {
                        field: this.DEFINITION.tipomovimento1,
                        param: "P_NRTIPOMOVIMENT",
                        descriptionField: "Mensal", valueField: "1",
                        required: true
                    } ]
                },
                sintetico_custo: {
                    config: {
                        itemName: "Sintético do Analítico de Custo por Estrutura Gerencial",
                        fileName: "sintetico_custo",
                        order: 27
                    },
                    params: [ {
                        field: this.DEFINITION.competencia,
                        param: "P_DTMESCOMPETENC",
                        required: true
                    }, {
                        field: this.DEFINITION.nrestrutgerenMulti,
                        param: "P_NRESTRUTGEREN"
                    }, {
                        field: this.DEFINITION.nrestrutlegalMulti,
                        param: "P_NRESTRUTLEGAL"
                    }, {
                        row: "NRGRUPOINCID",
                        value: "37",
                        param: "P_NRGRUPOINCID"
                    }, {
                        field: this.DEFINITION.tipomovimento1,
                        param: "P_NRTIPOMOVIMENT",
                        descriptionField: "Mensal", valueField: "1",
                        required: true
                    } ]
                },
                sintetico_custo_2: {
                    config: {
                        itemName: "Sintético do Analítico de Custo por Estrutura Gerencial - Planilha",
                        fileName: "sintetico_custo",
                        format: 'xlsx',
                        order: 28
                    },
                    params: [ {
                        field: this.DEFINITION.competencia,
                        param: "P_DTMESCOMPETENC",
                        required: true
                    }, {
                        field: this.DEFINITION.nrestrutgerenMulti,
                        param: "P_NRESTRUTGEREN"
                    }, {
                        field: this.DEFINITION.nrestrutlegalMulti,
                        param: "P_NRESTRUTLEGAL"
                    }, {
                        row: "NRGRUPOINCID",
                        value: "37",
                        param: "P_NRGRUPOINCID"
                    }, {
                        field: this.DEFINITION.tipomovimento1,
                        param: "P_NRTIPOMOVIMENT",
                        descriptionField: "Mensal", valueField: "1",
                        required: true
                    } ]
                },
                analitico_por_tomador: {
                    config: {
                        itemName: "Analítico por Tomador - SEFIP",
                        fileName: "analitico_por_tomador",
                        order: 30
                    },
                    params: [ {
                        field: this.DEFINITION.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    }, {
                        field: this.DEFINITION.nrestrutlegal,
                        param: "P_ESTRUTLEGAL",
                        required: true
                    }, {
                        field: this.DEFINITION.opcao1,
                        param: "P_INCLUIR13",
                        label: "Incluir 13º Sal. no movimento",
                    }, {
                        field: this.DEFINITION.tpestrut,
                        param: "P_NRTIPOESTRUT",
                        label: "Estrutura do Tomador"
                    }]
                },
                comparacao_calculos_folha: {
                    config: {
                        itemName: "Comparação de Cálculos de Folha",
                        fileName: "comparacao_calculos_folha",
                        order: 50
                    },
                    params: [ {
                        field: this.DEFINITION.number1,
                        param: "P_NRCALCULOFOLHA_1",
                        label: "Número de Cálculo Folha - A",
                        required: true
                    }, {
                        field: this.DEFINITION.number2,
                        label: "Número de Cálculo Folha - B",
                        param: "P_NRCALCULOFOLHA_2",
                        required: true
                    }, {
                        field: this.DEFINITION.zebrado,
                        param: "ZEBRADO"
                    }]
                },
                comprovante_cesta_basica: {
                    config: {
                        itemName: "Comprovante de Entrega de Cesta Básica",
                        fileName: "comprovante_cesta_basica",
                        order: 60
                    },
                    params: [ {
                        field: this.DEFINITION.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    }, {
                        field: this.DEFINITION.nrvinculoMulti,
                        param: "P_VINCULO"
                    }, {
                        field: this.DEFINITION.nrestrutlegal,
                        param: "P_NRESTRUTLEGAL"
                    },{
                        field: this.DEFINITION.nrestrutgeren,
                        param: "P_NRESTRUTGEREN"
                    },{
                        field: this.DEFINITION.dtdocumento,
                        param: "P_DTDOCUMENTO"
                    }]
                },
                comprovante_cesta_basica2: {
                    config: {
                        itemName: "Comprovante de Entrega de Cesta Básica - Modelo 2",
                        fileName: "comprovante_cesta_basica2",
                        order: 62
                    },
                    params: [ {
                        field: this.DEFINITION.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    }, {
                        field: this.DEFINITION.nrvinculoMulti,
                        param: "P_VINCULO"
                    }, {
                        field: this.DEFINITION.nrestrutlegal,
                        param: "P_NRESTRUTLEGAL"
                    }, {
                        field: this.DEFINITION.nrestrutgeren,
                        param: "P_NRESTRUTGEREN"
                    }, {
                        field: this.DEFINITION.dtdocumento,
                        param: "P_DTDOCUMENTO"
                    } ]
                },
                ponto_demonstrativo: {
                    config: {
                        itemName: "Demonstrativo de Folha de Ponto",
                        fileName: "ponto_demonstrativo",
                        order: 70
                    },
                     params: [ {
                        field: this.DEFINITION.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    }, {
                        field: this.DEFINITION.nrvinculoMulti,
                        param: "P_VINCULO"
                    }, {
                        field: this.DEFINITION.nrestrutlegal,
                        param: "P_ESTRUTLEGAL"
                    }, {
                        field: this.DEFINITION.nrestrutgeren,
                        param: "P_ESTRUTGEREN"
                    }, {
                        field: this.DEFINITION.nrperiodoapuracao,
                        param: "P_PERIODO",
                        required: true
                    }, {
                        field: this.DEFINITION.tpvinculo,
                        param: "P_TPVINCULO",
                        required: true
                    }, {
                        field: this.DEFINITION.opcao1,
                        param: "P_NAOEXIGIMARC",
                        label: "Exibir Vínculos sem Marcação de Ponto"
                    } ]
                },
                demonstrativo_inss_esocial: {
                    config: {
                        itemName: "Demonstrativo de INSS Sistema x INSS eSocial",
                        fileName: "demonstrativo_inss_esocial",
                        order: 75
                    },
                    params: [ {
                        field: this.DEFINITION.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    }, {
                        field: this.DEFINITION.nrestrutlegalMulti,
                        param: "P_ESTRUTLEGAL"
                    },{
                        field: this.DEFINITION.nrestrutgerenMulti,
                        param: "P_ESTRUTGEREN"
                    }, {
                        field: this.DEFINITION.nrvinculoMulti,
                        param: "P_VINCULO"
                    },{
                        field: this.DEFINITION.tipomovimento1,
                        param: "P_TIPOMOVIMENTO",
                        required: true,
                        descriptionField: "Mensal", valueField: "1"
                    },{
                        field: this.DEFINITION.opcao1,
                        label: "Incluir 13º Sal. no movimento",
                        param: "P_INCLUIR13"
                    },{
                        field: this.DEFINITION.opcao2,
                        label: "Omitir Agrupamento Gerencial",
                        param: "P_OMITIRGEREN"
                    },{
                        field: this.DEFINITION.zebrado,
                        param: "ZEBRADO"
                    },{
                        field: this.DEFINITION.opcao3,
                        label: "Ignorar Ocorrencias de Cálculo",
                        param: "P_IGNORAOCORR"
                    } ]
                },
                eventos_relacionados_vinculo: {
                    config: {
                        itemName: "Eventos Relacionados do Vínculo",
                        fileName: "eventos_relacionados_vinculo",
                        order: 80
                    },
                    params: [ {
                        field: this.DEFINITION.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    }, {
                        field: this.DEFINITION.nrvinculoMulti,
                        param: "P_VINCULO"
                    }, {
                        field: this.DEFINITION.nrestrutlegal,
                        param: "P_NRESTRUTLEGAL"
                    },{
                        field: this.DEFINITION.nrestrutgeren,
                        param: "P_NRESTRUTGEREN"
                    },{
                        field: this.DEFINITION.opcao1,
                        label: "Incluir Vínculos Demitidos",
                        param: "P_INCLUIRDEMITIDO"
                    },{
                        field: this.DEFINITION.zebrado,
                        param: "ZEBRADO"
                    }]
                },
                ficha_financeira_grade: {
                    config: {
                        itemName: "Ficha Financeira em Grade",
                        fileName: "ficha_financeira_grade",
                        order: 120
                    },
                    params: [ {
                        field: this.DEFINITION.nrvinculoMulti,
                        param: "P_VINCULO",
                    },{
                        field: this.DEFINITION.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    }, {
                        field: this.DEFINITION.nrestrutlegal,
                        param: "P_ESTRUTLEGAL"
                    },{
                        field: this.DEFINITION.nrestrutgeren,
                        param: "P_ESTRUTGEREN"
                    }, {
                        field: this.DEFINITION.tipomovimento1,
                        param: "P_NRTPMOVIMENT",
                        descriptionField: "Mensal", valueField: "1",
                        required: true
                    },  {
                        field: this.DEFINITION.dtinicio,
                        param: "P_INICIO",
                        required: true,
                        label: "Período - Mês inicial"
                    }, {
                        field: this.DEFINITION.dtfim,
                        param: "P_FIM",
                        required: true,
                        label: "Período - Mês final"
                    }, {
                        field: this.DEFINITION.eventoMulti,
                        param: "P_NREVENTO"
                    },{
                        field: this.DEFINITION.opcao1,
                        label: "Incluir Vínculos Demitidos",
                        param: "P_INCLUIRDEMITIDO"
                    },{
                        field: this.DEFINITION.zebrado,
                        param: "ZEBRADO"
                    }]
                },
                ficha_financeira_grade_geren: {
                    config: {
                        itemName: "Ficha Financeira em Grade – Estrutura Gerencial",
                        fileName: "ficha_financeira_grade_geren",
                        order: 125
                    },
                    params: [{
                        field: this.DEFINITION.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    }, {
                        field: this.DEFINITION.nrestrutlegal,
                        param: "P_ESTRUTLEGAL"
                    },{
                        field: this.DEFINITION.nrestrutgeren,
                        param: "P_ESTRUTGEREN"
                    }, {
                        field: this.DEFINITION.tipomovimento1,
                        param: "P_NRTPMOVIMENT",
                        descriptionField: "Mensal", valueField: "1"
                    },  {
                        field: this.DEFINITION.dtinicio,
                        param: "P_INICIO",
                        required: true,
                        label: "Período - Mês inicial"
                    }, {
                        field: this.DEFINITION.dtfim,
                        param: "P_FIM",
                        required: true,
                        label: "Período - Mês final"
                    }, {
                        field: this.DEFINITION.eventoMulti,
                        param: "P_NREVENTO"
                    },{
                        field: this.DEFINITION.opcao1,
                        label: "Incluir Vínculos Demitidos",
                        param: "P_INCLUIRDEMITIDO"
                    },{
                        field: this.DEFINITION.zebrado,
                        param: "ZEBRADO"
                    }]
                },
                folha_analitica: {
                    config: {
                        itemName: "Folha Analítica",
                        fileName: "folha_analitica",
                        order: 130
                    },
                    params: [ {
                        field: this.DEFINITION.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    }, {
                        field: this.DEFINITION.nrestrutlegalMulti,
                        param: "P_ESTRUTURALEGAL"
                    }, {
                        field: this.DEFINITION.nrestrutgerenMulti,
                        param: "P_ESTRUTURAGEREN"
                    }, {
                        field: this.DEFINITION.tipomovimento1,
                        param: "P_TIPOMOVIMENTO",
                        required: true,
                        descriptionField: "Mensal", valueField: "1"
                    }, {
                        field: this.DEFINITION.opcao1,
                        label: "Omitir Vínculos",
                        param: "P_OMITIRVINCULOS"
                    }, {
                        field: this.DEFINITION.opcao2,
                        label: "Omitir Resumo Legal",
                        param: "P_OMITIRLEGAL"
                    }, {
                        field: this.DEFINITION.opcao3,
                        label: "Quebrar página por Gerencial",
                        param: "P_QUEBRARPAG"
                    }, {
                        field: this.DEFINITION.opcao4,
                        label: "Somente Vínculos Demitidos",
                        param: "P_SODEMITIDO"
                    }, {
                        field: this.DEFINITION.opcao5,
                        label: "Omitir Resumo Gerencial",
                        param: "P_OMITIRGEREN"
                    }, {
                        field: this.DEFINITION.zebrado,
                        param: "ZEBRADO"
                    }, {
                        field: this.DEFINITION.tpvinculoMulti,
                        param: "P_TIPOVINCULO",
                        required: true
                    }, {
                        field: this.DEFINITION.tpincidencia,
                        label: "Eventos Ocultos do Tipo de Incidencia ",
                        param: "P_NRTIPOINCIDE"
                    }, {
                    	field: this.DEFINITION.opcao6,
                    	label: "Ignorar Ocorrências de Cálculo",
                    	param: "P_IGNORAOCORR",
                    	valueField: "N"
                    } ]
                },
                folha_analitica_por_tipo_vinculo: {
                    config: {
                        itemName: "Folha Analítica por Tipo de Vínculo",
                        fileName: "folha_analitica_por_tipo_vinculo",
                        order: 140
                    },
                    params: [ {
                        field: this.DEFINITION.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    },{
                        field: this.DEFINITION.nrestrutlegalMulti,
                        param: "P_ESTRUTURALEGAL"
                    },{
                        field: this.DEFINITION.nrestrutgerenMulti,
                        param: "P_ESTRUTURAGEREN"
                    },{
                        field: this.DEFINITION.tipohierarquiaMulti,
                        param: "P_NRTIPOHIERARQ"
                    },{
                        field: this.DEFINITION.nrestrutsupMulti,
                        param: "P_NRESTRUTSUP"
                    },{
                        field: this.DEFINITION.tipomovimento1,
                        param: "P_TIPOMOVIMENTO",
                        required: true,
                        descriptionField: "Mensal", valueField: "1"
                    },{
                        field: this.DEFINITION.opcao2,
                        label: "Exibir Qde. Dependentes",
                        param: "P_IDDEPENDENTE"
                    },{
                        field: this.DEFINITION.opcao3,
                        label: "Somente Vínculos Demitidos",
                        param: "P_SODEMITIDO"
                    },{
                        field: this.DEFINITION.opcao4,
                        label: "Omitir resumos",
                        param: "P_OMITIRRESUMOS"
                    },{
                        field: this.DEFINITION.zebrado,
                        param: "ZEBRADO"
                    },{
                        field: this.DEFINITION.tpvinculoMulti,
                        param: "P_TIPOVINCULO",
                        required: true
                    },{
                        field: this.DEFINITION.tpincidencia,
                        label: "Eventos Ocultos do Tipo de Incidencia ",
                        param: "P_NRTIPOINCIDE"
                    },{
                        field: this.DEFINITION.opcao1,
                        label: "Ignorar Ocorrencias de Cálculo",
                        param: "P_IGNORAOCORR",
                        valueField: "S"
                    }]
                },
                folha_analitica_por_tipo_vinculo_geren: {
                    config: {
                        itemName: "Folha Analítica por Tipo de Vínculo (Gerencial)",
                        fileName: "folha_analitica_por_tipo_vinculo_geren",
                        order: 145
                    },
                    params: [ {
                        field: this.DEFINITION.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    },{
                        field: this.DEFINITION.nrestrutlegalMulti,
                        param: "P_ESTRUTURALEGAL"
                    },{
                        field: this.DEFINITION.nrestrutgerenMulti,
                        param: "P_ESTRUTURAGEREN"
                    },{
                        field: this.DEFINITION.tipomovimento1,
                        param: "P_TIPOMOVIMENTO",
                        required: true,
                        descriptionField: "Mensal", valueField: "1"
                    }, {
                        field: this.DEFINITION.opcao2,
                        label: "Exibir Qde. Dependentes",
                        param: "P_IDDEPENDENTE"
                    },{
                        field: this.DEFINITION.opcao3,
                        label: "Somente Vínculos Demitidos",
                        param: "P_SODEMITIDO"
                    },{
                        field: this.DEFINITION.zebrado,
                        param: "ZEBRADO"
                    },
                    {
                        field: this.DEFINITION.tpvinculo,
                        param: "P_TIPOVINCULO",
                        required: true
                    },{
                        field: this.DEFINITION.opcao1,
                        label: "Ignorar Ocorrencias de Cálculo",
                        param: "P_IGNORAOCORR",
                        valueField: "S"
                    }]
                },
                absenteismo: {
                    config: {
                        itemName: "Relatório de Absenteísmo",
                        fileName: "absenteismo",
                        order: 146
                    },
                    params: [ {
                        field: this.DEFINITION.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    }, {
                        field: this.DEFINITION.nrvinculoMulti,
                        param: "P_VINCULO"
                    }, {
                        field: this.DEFINITION.nrestrutlegal,
                        param: "P_ESTRUTLEGAL"
                    }, {
                        field: this.DEFINITION.nrestrutgeren,
                        param: "P_ESTRUTGEREN"
                    }, {
                        field: this.DEFINITION.nrperiodoapuracao,
                        param: "P_PERIODO",
                        required: true
                    }, {
                        field: this.DEFINITION.tpvinculo,
                        param: "P_TPVINCULO",
                        required: true
                    } ]
                },
                saldo_banco_horas: {
                    config: {
                        itemName: "Saldo Banco de Horas",
                        fileName: "saldo_banco_horas",
                        order: 147
                    },
                    params: [ {
                        field: this.DEFINITION.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    }, {
                        field: this.DEFINITION.nrvinculoMulti,
                        param: "P_VINCULO"
                    }, {
                        field: this.DEFINITION.nrestrutlegal,
                        param: "P_ESTRUTLEGAL"
                    }, {
                        field: this.DEFINITION.nrestrutgeren,
                        param: "P_ESTRUTGEREN"
                    }, {
                        field: this.DEFINITION.nrperiodoapuracao,
                        param: "P_PERIODO",
                        required: true
                    }, {
                        field: this.DEFINITION.tpvinculo,
                        param: "P_TPVINCULO",
                        required: true
                    } ]
                },
				hora_extra: {
                    config: {
                        itemName: "Resumo de Horas Extras",
                        fileName: "hora_extra",
                        order: 148
                    },
                    params: [ {
                        field: this.DEFINITION.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    },
					{
                        field: this.DEFINITION.nrvinculoMulti,
                        param: "P_VINCULO"
                    }, 									
					{
                        field: this.DEFINITION.nrestrutlegalMulti,
                        param: "P_ESTRUTLEGAL"
                    },
					{
                        field: this.DEFINITION.nrestrutgerenMulti,
                        param: "P_ESTRUTGEREN"
                    },
					{
                        field: this.DEFINITION.tipohierarquiaMulti,
                        param: "P_NRTIPOHIERARQ"
                    },
					{
                        field: this.DEFINITION.tipomovimento1,
                        param: "P_NRTPMOVIMENT",
                        required: true,
                        descriptionField: "Mensal", valueField: "1"
                    },
					{
                        field: this.DEFINITION.tpvinculoMulti,
                        param: "P_TIPOVINCULO",
                    }]
                },
                horas_homem_trabalho: {
                    config: {
                        itemName: "Horas Homem Trabalho",
                        fileName: "horas_homem_trabalho",
                        order: 150
                    },
                    params: [ {
                        field: this.DEFINITION.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    },{
                        field: this.DEFINITION.nrestrutlegal,
                        param: "P_ESTRUTLEGAL"
                    },{
                        field: this.DEFINITION.nrvinculoMulti,
                        param: "P_VINCULO"
                    },{
                        field: this.DEFINITION.nrestrutgeren,
                        param: "P_ESTRUTGEREN"
                    },{
                        field: this.DEFINITION.opcao1,
                        label: "Omitir Vínculos",
                        param: "P_OCULTAVINCULOS"
                    }]
                },
                informe_rendimentos: {
                    config: {
                        itemName: "Informe de Rendimentos - DIRF",
                        fileName: "informe_rendimentos",
                        order: 160
                    },
                    params: [ {
                        field: this.DEFINITION.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    },{
                        field: this.DEFINITION.nrestrutlegal,
                        param: "P_ESTRUTURARESP",
                        label: "Estrutura Responsável",
                        required: true
                    },{
                        field: this.DEFINITION.nrestrutgeren,
                        param: "P_ESTRUTGEREN"
                    },{
                        field: this.DEFINITION.nrvinculoMulti,
                        param: "P_VINCULO"
                    },{
                        field: this.DEFINITION.number1,
                        label: 'Ano de Referência',
                        required: true,
                        param: "P_ANOREF"
                    },{
                        field: this.DEFINITION.number2,
                        label: 'Ano de Calendário',
                        required: true,
                        param: "P_ANOCALEN"
                    }]
                },
                analitico_dirf: {
                    config: {
                        itemName: "Analítico - DIRF",
                        fileName: "analitico_dirf",
                        order: 165
                    },
                    params: [ {
                        field: this.DEFINITION.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    },{
                        field: this.DEFINITION.nrestrutlegal,
                        param: "P_ESTRUTURARESP",
                        label: "Estrutura Responsável",
                        required: true
                    }]
                },
                beneficio_plano_saude: {
                   config: {
                        itemName: "Benefício - Plano de Saúde",
                        fileName: "beneficio_plano_saude",
                        order: 166
                    },
                    params: [ {
                        field: this.DEFINITION.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    }, {
                        field: this.DEFINITION.nrvinculoMulti,
                        param: "P_VINCULO"
                    }, {
                        field: this.DEFINITION.nrestrutlegalMulti,
                        param: "P_NRESTRUTLEGAL"
                    }, {
                        field: this.DEFINITION.nrestrutlegalMulti,
                        param: "P_NRESTRUTGEREN"
                    }, {
                        field: this.DEFINITION.dtinicio,
                        param: "P_DTINICIO",
                        required: true
                    }, {
                        field: this.DEFINITION.dtfim,
                        param: "P_DTFINAL",
                        required: true
                    }]
                },
                lancamentos_evento_vinculo: {
                    config: {
                        itemName: "Lançamentos de Eventos por Vínculo",
                        fileName: "lancamentos_evento_vinculo",
                        order: 170
                    },
                    params: [ {
                        field: this.DEFINITION.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    }, {
                        field: this.DEFINITION.nrestrutlegal,
                        param: "P_ESTRUTLEGAL"
                    }, {
                        field: this.DEFINITION.nrestrutgeren,
                        param: "P_ESTRUTGEREN"
                    }, {
                        field: this.DEFINITION.tipomovimento1,
                        param: "P_TIPOMOVIMENTO",
                        required: true,
                        descriptionField: "Mensal", valueField: "1"
                    }, {
                        field: this.DEFINITION.nrvinculoMulti,
                        param: "P_VINCULO"
                    }, {
                        field: this.DEFINITION.eventoMulti,
                        param: "P_NREVENTO",
                        required: true
                    }, {
                        field: this.DEFINITION.opcao1,
                        label: "Incluir Eventos Zerados",
                        param: "P_INCLUIRZEROS"
                    }, {
                        field: this.DEFINITION.opcao2,
                        label: "Incluir Vínculos Demitidos",
                        param: "P_INCLUIRDEMITIDO"
                    }, {
                        field: this.DEFINITION.zebrado,
                        param: "ZEBRADO"
                    }, {
                    	field: this.DEFINITION.opcao4,
                    	label: "Ignorar Ocorrências de Cálculo",
                    	param: "P_IGNORAOCORR",
                    	valueField: "N"
                    } ]
                },
                lancamentos_evento_vinculo_por_sindicato: {
                    config: {
                        itemName: "Lançamentos de Eventos por Vínculo – Agrupado por Sindicato",
                        fileName: "lancamentos_evento_vinculo_por_sindicato",
                        order: 175
                    },
                    params: [ {
                        field: this.DEFINITION.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    }, {
                        field: this.DEFINITION.nrestrutlegal,
                        param: "P_ESTRUTLEGAL"
                    },{
                        field: this.DEFINITION.nrestrutgeren,
                        param: "P_ESTRUTGEREN"
                    }, {
                        field: this.DEFINITION.nrestrutsind,
                        param: "P_ESTRUTSIND"
                    }, {
                        field: this.DEFINITION.tipomovimento1,
                        param: "P_TIPOMOVIMENTO",
                        required: true,
                        descriptionField: "Mensal", valueField: "1"
                    }, {
                        field: this.DEFINITION.nrvinculoMulti,
                        param: "P_VINCULO"
                    }, {
                        field: this.DEFINITION.eventoMulti,
                        param: "P_NREVENTO",
                        required: true
                    },{
                        field: this.DEFINITION.opcao1,
                        label: "Incluir Eventos Zerados",
                        param: "P_INCLUIRZEROS"
                    }, {
                        field: this.DEFINITION.opcao2,
                        label: "Incluir Vínculos Demitidos",
                        param: "P_INCLUIRDEMITIDO"
                    }, {
                        field: this.DEFINITION.zebrado,
                        param: "ZEBRADO"
                    }, {
                    	field: this.DEFINITION.opcao4,
                    	label: "Ignorar Ocorrências de Cálculo",
                    	param: "P_IGNORAOCORR",
                    	valueField: "N"
                    } ]
                },
                liquidobanco: {
                    config: {
                        itemName: "Líquido Banco",
                        fileName: "liquidobanco",
                        order: 180
                    },
                    params: [ {
                        field: this.DEFINITION.competencia,
                        param: "P_DTMESCOMPETENC",
                        required: true
                    }, {
                        field: this.DEFINITION.nrestrutlegalMulti,
                        param: "P_NRESTRUTURA"
                    }, {
                        field: this.DEFINITION.nrestrutgerenMulti,
                        param: "P_NRESTRUTURAGEREN"
                    }, {
                        field: this.DEFINITION.tipomovimento1,
                        param: "P_NRTPMOVIMENT",
                        required: true,
                        descriptionField: "Mensal", valueField: "1"
                    }, {
                        field: this.DEFINITION.dtinicio,
                        param: "P_DTOCORRENCIA",
                        label: "Data de ocorrência/pagamento"
                    }, {
                        field: this.DEFINITION.evento,
                        param: "P_NREVENTO",
                        required: true,
                        label: "Evento do líquido (Ex.: 3030, 3040, 3050, etc.)",
                        descriptionField: "Líquido", valueField: "3030"
                    }, {
                        field: this.DEFINITION.opcao1,
                        label: "Omitir Vínculos",
                        param: "P_OMITIRVINC"
                    }, {
                        field: this.DEFINITION.opcao2,
                        label: "Omitir Agrupamento Gerencial",
                        param: "P_OMITIRGEREN"
                    }, {
                        field: this.DEFINITION.opcao3,
                        label: "Incluir Vínculos Demitidos",
                        param: "P_INCLUIRDEMITIDO"
                    }, {
                        field: this.DEFINITION.zebrado,
                        param: "ZEBRADO"
                    }, {
                    	field: this.DEFINITION.opcao4,
                    	label: "Ignorar Ocorrências de Cálculo",
                    	param: "P_IGNORAOCORR",
                    	valueField: "N"
                    } ]
                },
                liquidocaixa: {
                    config: {
                        itemName: "Líquido Caixa",
                        fileName: "liquidocaixa",
                        order: 190
                    },
                    params: [ {
                        field: this.DEFINITION.competencia,
                        param: "P_DTMESCOMPETENC",
                        required: true
                    }, {
                        field: this.DEFINITION.nrestrutlegalMulti,
                        param: "P_NRESTRUTURA"
                    }, {
                        field: this.DEFINITION.nrestrutgerenMulti,
                        param: "P_NRESTRUTURAGEREN"
                    }, {
                        field: this.DEFINITION.tipomovimento1,
                        param: "P_NRTPMOVIMENT",
                        required: true,
                        descriptionField: "Mensal", valueField: "1"
                    }, {
                        field: this.DEFINITION.dtinicio,
                        param: "P_DTOCORRENCIA",
                        label: "Data de ocorrência/pagamento"
                    }, {
                        field: this.DEFINITION.evento,
                        param: "P_NREVENTO",
                        required: true,
                        label: "Evento do líquido (Ex.: 3030, 3040, 3050, etc.)",
                        descriptionField: "Líquido", valueField: "3030"
                    }, {
                        field: this.DEFINITION.opcao1,
                        label: "Omitir Vínculos",
                        param: "P_OMITIRVINC"
                    }, {
                        field: this.DEFINITION.opcao2,
                        label: "Omitir Agrupamento Gerencial",
                        param: "P_OMITIRGEREN"
                    }, {
                        field: this.DEFINITION.opcao3,
                        label: "Incluir Vínculos Demitidos",
                        param: "P_INCLUIRDEMITIDO"
                    }, {
                        field: this.DEFINITION.zebrado,
                        param: "ZEBRADO"
                    }, {
                    	field: this.DEFINITION.opcao4,
                    	label: "Ignorar Ocorrências de Cálculo",
                    	param: "P_IGNORAOCORR",
                    	valueField: "N"
                    } ]
                },
                liquidobanco_por_banco: {
                    config: {
                        itemName: "Líquido do Banco - Agrupado por banco",
                        fileName: "liquidobanco_por_banco",
                        order: 210
                    },
                    params: [ {
                        field: this.DEFINITION.competencia,
                        param: "P_DTMESCOMPETENC",
                        required: true
                    }, {
                        field: this.DEFINITION.nrestrutlegalMulti,
                        param: "P_NRESTRUTURA"
                    }, {
                        field: this.DEFINITION.nrestrutgerenMulti,
                        param: "P_NRESTRUTURAGEREN"
                    }, {
                        field: this.DEFINITION.tipomovimento1,
                        param: "P_NRTPMOVIMENT",
                        required: true,
                        descriptionField: "Mensal", valueField: "1"
                    }, {
                        field: this.DEFINITION.dtinicio,
                        param: "P_DTOCORRENCIA",
                        required: false,
                        label: "Data de ocorrência/pagamento"
                    }, {
                        field: this.DEFINITION.evento,
                        param: "P_NREVENTO",
                        required: true,
                        label: "Evento do líquido (Ex.: 3030, 3040, 3050, etc.)",
                        descriptionField: "Líquido", valueField: "3030"
                    }, {
                        field: this.DEFINITION.opcao1,
                        label: "Omitir Vínculos",
                        param: "P_OMITIRVINC"
                    }, {
                        field: this.DEFINITION.opcao2,
                        label: "Omitir Agrupamento Gerencial",
                        param: "P_OMITIRGEREN"
                    }, {
                        field: this.DEFINITION.opcao3,
                        label: "Incluir Vínculos Demitidos",
                        param: "P_INCLUIRDEMITIDO"
                    }, {
                        field: this.DEFINITION.zebrado,
                        param: "ZEBRADO"
                    }, {
                    	field: this.DEFINITION.opcao4,
                    	label: "Ignorar Ocorrências de Cálculo",
                    	param: "P_IGNORAOCORR",
                    	valueField: "N"
                    } ]
                },
                liquido: {
                    config: {
                        itemName: "Líquido Geral",
                        fileName: "liquido",
                        order: 220
                    },
                    params: [ {
                        field: this.DEFINITION.competencia,
                        param: "P_DTMESCOMPETENC",
                        required: true
                    }, {
                        field: this.DEFINITION.nrestrutlegalMulti,
                        param: "P_NRESTRUTURA"
                    }, {
                        field: this.DEFINITION.nrestrutgerenMulti,
                        param: "P_NRESTRUTURAGEREN"
                    }, {
                        field: this.DEFINITION.tipomovimento1,
                        param: "P_NRTPMOVIMENT",
                        required: true,
                        descriptionField: "Mensal", valueField: "1"
                    }, {
                        field: this.DEFINITION.dtinicio,
                        param: "P_DTOCORRENCIA",
                        label: "Data de ocorrência/pagamento"
                    }, {
                        field: this.DEFINITION.evento,
                        param: "P_NREVENTO",
                        required: true,
                        label: "Evento do líquido (Ex.: 3030, 3040, 3050, etc.)"
                    }, {
                        field: this.DEFINITION.opcao1,
                        label: "Omitir Vínculos",
                        param: "P_OMITIRVINC"
                    }, {
                        field: this.DEFINITION.opcao2,
                        label: "Omitir Agrupamento Gerencial",
                        param: "P_OMITIRGEREN"
                    }, {
                        field: this.DEFINITION.opcao3,
                        label: "Incluir Vínculos Demitidos",
                        param: "P_INCLUIRDEMITIDO"
                    }, {
                        field: this.DEFINITION.zebrado,
                        param: "ZEBRADO"
                    }, {
                        field: this.DEFINITION.opcao4,
                        label: "Ignorar Ocorrências de Cálculo",
                        param: "P_IGNORAOCORR",
                        valueField: "N"
                    } ]
                },
                medias_geral: {
                   config: {
                       itemName: "Médias - Período Manual",
                       fileName: "medias_geral",
                       order: 230
                   },
                   params: [ {
                       field: this.DEFINITION.competencia,
                       param: "P_DTMESCOMPETENC",
                       required: true
                   },{
                       field: this.DEFINITION.nrvinculoMulti,
                       param: "P_NRVINCULOM"
                   },{
                       field: this.DEFINITION.nrestrutlegal,
                       param: "P_ESTRUTLEGAL"
                   },{
                       field: this.DEFINITION.nrestrutgeren,
                       param: "P_ESTRUTGEREN"
                   },{
                       field: this.DEFINITION.nrperiodo,
                       param: "P_PERIODO"
                   },{
                       field: this.DEFINITION.dtinicio,
                       param: "P_INICIO",
                       required: true
                   },{
                       field: this.DEFINITION.dtfim,
                       param: "P_FINAL",
                       required: true
                   },{
                        row: "P_IDFUNC",
                        param: "P_IDFUNC",
                        value: "MANUAL"
                    }]
               },
                medias_geral_periodo: {
                   config: {
                       itemName: "Médias - Período de Aquisição",
                       fileName: "medias_geral",
                       order: 235
                   },
                   params: [ {
                       field: this.DEFINITION.competencia,
                       param: "P_DTMESCOMPETENC",
                       required: true
                   },{
                       field: this.DEFINITION.nrvinculoMulti,
                       param: "P_NRVINCULOM"
                   },{
                       field: this.DEFINITION.nrestrutlegal,
                       param: "P_ESTRUTLEGAL"
                   },{
                       field: this.DEFINITION.nrestrutgeren,
                       param: "P_ESTRUTGEREN"
                   },{
                       field: this.DEFINITION.dtinicio,
                       label: "Dt. Período",
                       param: "P_INICIO",
                       required: true
                   },{
                        row: "P_IDFUNC",
                        param: "P_IDFUNC",
                        value: "PERIODO"
                    }]
               },
                medias_13: {
                    config: {
                        itemName: "Médias para o 13º Salário",
                        fileName: "medias_13",
                        order: 240
                    },
                    params: [ {
                        field: this.DEFINITION.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    },{
                        field: this.DEFINITION.nrestrutlegal,
                        param: "P_ESTRUTLEGAL"
                    },{
                        field: this.DEFINITION.nrestrutgeren,
                        param: "P_ESTRUTGEREN"
                    },{
                        field: this.DEFINITION.nrvinculoMulti,
                        param: "P_VINCULO"
                    },{
                        field: this.DEFINITION.opcao1,
                        label: 'Mostrar Simulação de Cálculo de Médias',
                        param: "P_MOSTRARSIMUL"
                    },{
                        field: this.DEFINITION.zebrado,
                        param: "ZEBRADO"
                    }]
                },
                provisao_13: {
                    config: {
                        itemName: "Provisão de 13º Salário",
                        fileName: "provisao_13",
                        order: 250
                    },
                    params: [ {
                        field: this.DEFINITION.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    },{
                        field: this.DEFINITION.nrestrutlegal,
                        param: "P_ESTRUTLEGAL"
                    },{
                        field: this.DEFINITION.nrestrutgeren,
                        param: "P_ESTRUTGEREN"
                    },{
                        field: this.DEFINITION.nrvinculoMulti,
                        param: "P_VINCULO"
                    },{
                        field: this.DEFINITION.tpvinculo,
                        param: "P_TIPOVINCULO"
                    },{
                        field: this.DEFINITION.tipohierarquiaMulti,
                        param: "P_NRTIPOHIERARQ"
                    },{
                        field: this.DEFINITION.nrestrutsupMulti,
                        param: "P_NRESTRUTSUP"
                    },{
                        field: this.DEFINITION.opcao1,
                        label: 'Omitir Vínculos',
                        param: "P_OMITIRVINCULOS"
                    },{
                        field: this.DEFINITION.opcao2,
                        label: 'Omitir Agrupamento Gerencial',
                        param: "P_OMITIRGERENC"
                    },{
                        field: this.DEFINITION.opcao3,
                        label: 'Mostrar Diferenças',
                        param: "P_MOSTARDIFERENCAS"
                    },{
                        field: this.DEFINITION.zebrado,
                        param: "ZEBRADO"
                    },{
                        field: this.DEFINITION.opcao4,
                        label: "Gerar Memória",
                        param: "P_SHOWMEMORIA"
                    }]
                },
                provisao_ferias: {
                    config: {
                        itemName: "Provisão de Férias",
                        fileName: "provisao_ferias",
                        order: 260
                    },
                    params: [ {
                        field: this.DEFINITION.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    },{
                        field: this.DEFINITION.nrestrutlegal,
                        param: "P_ESTRUTLEGAL"
                    },{
                        field: this.DEFINITION.nrestrutgeren,
                        param: "P_ESTRUTGEREN"
                    },{
                        field: this.DEFINITION.nrvinculoMulti,
                        param: "P_VINCULO"
                    },{
                        field: this.DEFINITION.tpvinculo,
                        param: "P_TIPOVINCULO"
                    },{
                        field: this.DEFINITION.tipohierarquiaMulti,
                        param: "P_NRTIPOHIERARQ"
                    },{
                        field: this.DEFINITION.nrestrutsupMulti,
                        param: "P_NRESTRUTSUP"
                    },{
                        field: this.DEFINITION.opcao1,
                        label: 'Omitir Vínculos',
                        param: "P_OMITIRVINCULOS"
                    },{
                        field: this.DEFINITION.opcao2,
                        label: 'Omitir Agrupamento Gerencial',
                        param: "P_OMITIRGERENC"
                    },{
                        field: this.DEFINITION.opcao3,
                        label: 'Mostrar Diferenças',
                        param: "P_MOSTARDIFERENCAS"
                    },{
                        field: this.DEFINITION.zebrado,
                        param: "ZEBRADO"
                    },{
                        field: this.DEFINITION.opcao4,
                        label: "Gerar Memória",
                        param: "P_SHOWMEMORIA"
                    }]
                },
                demonstrativo_pagamento_rpa_laser: {
                    config: {
                        itemName: "Recibo de Pagamento a Autônomo - RPA (Laser, via única)",
                        fileName: "demonstrativo_pagamento_rpa_laser",
                        order: 265
                    },
                    params: [ {
                        field: this.DEFINITION.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    }, {
                        field: this.DEFINITION.nrestrutlegalMulti,
                        param: "P_NRESTRUTLEGAL"
                    },{
                        field: this.DEFINITION.nrestrutgerenMulti,
                        param: "P_NRESTRUTGEREN"
                    }, {
                        field: this.DEFINITION.tipomovimento1,
                        param: "P_NRTIPOMOVIMENT",
                        required: true,
                        descriptionField: "Mensal", valueField: "1"
                    },  {
                        field: this.DEFINITION.nrvinculoMulti,
                        param: "P_NRVINCULO"
                    },{
                        field: this.DEFINITION.cdbancoMulti,
                        param: "P_CDBANCO"
                    }, {
                        field: this.DEFINITION.evento,
                        param: "P_EVENTO",
                        required: true,
                        label: "Apenas Recibos de Pagamentos com este evento:"
                    },{
                        field: this.DEFINITION.opcao1,
                        label: "Ignorar Ocorrencias de Cálculo",
                        param: "P_IGNORAOCORR"
                    }]
                },
                demonstrativo_pagamento_lab04: {
                    config: {
                        itemName: "Recibo de Pagamento de Salário (Lab04)",
                        fileName: "demonstrativo_pagamento_lab04",
                        order: 280
                    },
                    params: [ {
                        field: this.DEFINITION.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    }, {
                        field: this.DEFINITION.nrestrutlegal,
                        param: "P_NRESTRUTLEGAL"
                    },{
                        field: this.DEFINITION.nrestrutgeren,
                        param: "P_NRESTRUTGEREN"
                    }, {
                        field: this.DEFINITION.tipomovimento1,
                        param: "P_NRTIPOMOVIMENT",
                        required: true,
                        descriptionField: "Mensal", valueField: "1"
                    },  {
                        field: this.DEFINITION.nrvinculoMulti,
                        param: "P_NRVINCULO"
                    },{
                        field: this.DEFINITION.cdbancoMulti,
                        param: "P_CDBANCO"
                    }, {
                        field: this.DEFINITION.evento,
                        param: "P_EVENTO",
                        required: true,
                        label: "Apenas Recibos de Pagamentos com este evento:"
                    },{
                        field: this.DEFINITION.opcao1,
                        label: "Ignorar Ocorrencias de Cálculo",
                        param: "P_IGNORAOCORR"
                    }]
                },
                demonstrativo_pagamento_laser: {
                    config: {
                        itemName: "Recibo de Pagamento de Salário (Laser, 2 vias)",
                        fileName: "demonstrativo_pagamento_laser",
                        order: 290
                    },
                    params: [ {
                        field: this.DEFINITION.competencia,
                        param: "P_DTMESCOMPETENC",
                        required: true
                    },{
                        field: this.DEFINITION.nrestrutlegal,
                        param: "P_NRESTRUTURA"
                    },{
                        field: this.DEFINITION.nrestrutgeren,
                        param: "P_NRESTRUTGEREN"
                    },{
                        field: this.DEFINITION.tipomovimento1,
                        param: "P_NRTIPOMOVIMENT",
                        required: true,
                        descriptionField: "Mensal", valueField: "1"
                    },{
                        field: this.DEFINITION.nrvinculoMulti,
                        param: "P_NRVINCULO"
                    },{
                        field: this.DEFINITION.tipohierarquiaMulti,
                        param: "P_NRTIPOHIERARQ"
                    },{
                        field: this.DEFINITION.nrestrutsupMulti,
                        param: "P_NRESTRUTSUP"
                    },{
                        field: this.DEFINITION.eventoMulti,
                        param: "P_EVENTO",
                        label: "Apenas Recibos de Pagamentos com este evento:"
                    },
                    {
                        field: this.DEFINITION.cdbancoMulti,
                        param: "P_CDBANCO"
                    },
                    {
                        field: this.DEFINITION.opcao1,
                        label: "Ignorar Ocorrencias de Cálculo",
                        param: "P_IGNORAOCORR"
                    },{
                        field: this.DEFINITION.opcao2,
                        label: "Exibir Mensagem de Aniversariante",
                        param: "P_IDMSGANIVERSARIO"
                    },{
                        field: this.DEFINITION.zebrado,
                        param: "ZEBRADO"
                    },{
                        field: this.DEFINITION.observacao,
                        param: "P_MENSAGEM"
                    }]
                },
                demonstrativo_pagamento_via_unica: {
                    config: {
                        itemName: "Recibo de Pagamento de Salário (Laser, via única)",
                        fileName: "demonstrativo_pagamento_via_unica",
                        order: 300
                    },
                    params: [ {
                        field: this.DEFINITION.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    },{
                        field: this.DEFINITION.nrestrutlegalMulti,
                        param: "P_NRESTRUTLEGAL"
                    },{
                        field: this.DEFINITION.nrestrutgerenMulti,
                        param: "P_NRESTRUTGEREN"
                    },{
                        field: this.DEFINITION.tipomovimento1,
                        param: "P_NRTIPOMOVIMENT",
                        required: true,
                        descriptionField: "Mensal", valueField: "1"
                    },{
                        field: this.DEFINITION.nrvinculoMulti,
                        param: "P_NRVINCULO"
                    },{
                        field: this.DEFINITION.tipohierarquiaMulti,
                        param: "P_NRTIPOHIERARQ"
                    },{
                        field: this.DEFINITION.nrestrutsupMulti,
                        param: "P_NRESTRUTSUP"
                    },{
                        field: this.DEFINITION.cdbancoMulti,
                        param: "P_CDBANCO"
                    },{
                        field: this.DEFINITION.evento,
                        param: "P_EVENTO",
                        label: "Apenas Recibos de Pagamentos com este evento:"
                    },{
                        field: this.DEFINITION.opcao1,
                        label: "Ignorar Ocorrencias de Cálculo",
                        param: "P_IGNORAOCORR"
                    },{
                        field: this.DEFINITION.observacao,
                        param: "P_OBSERVACAO"
                    }]
                },
                relacao_contribuicoes_1008: {
                    config: {
                        itemName: "Relação de Contribuições",
                        fileName: "relacao_contribuicoes_1008",
                        order: 310
                    },
                    params: [ {
                        field: this.DEFINITION.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    }, {
                        field: this.DEFINITION.nrestrutlegal,
                        param: "P_ESTRUTLEGAL"
                    }, {
                        field: this.DEFINITION.nrestrutgeren,
                        param: "P_ESTRUTGEREN"
                    }, {
                        field: this.DEFINITION.nrestrutsind,
                        param: "P_ESTRUTSIND"
                    }, {
                        field: this.DEFINITION.tipohierarquiaMulti,
                        param: "P_NRTIPOHIERARQ"
                    }, {
                        field: this.DEFINITION.nrestrutsupMulti,
                        param: "P_NRESTRUTSUP"
                    }, {
                        field: this.DEFINITION.tipomovimento1,
                        param: "P_TIPOMOVIMENTO",
                        required: true,
                        descriptionField: "Mensal", valueField: "1"
                    }, {
                        field: this.DEFINITION.nrvinculoMulti,
                        param: "P_VINCULO"
                    }, {
                        field: this.DEFINITION.eventoMulti,
                        param: "P_NREVENTO",
                        label: "Eventos adicionais"
                    }, {
                        field: this.DEFINITION.opcao1,
                        label: "Usar exclusivamente eventos adicionais",
                        param: "P_EVENTOEXCLUSIVO"
                    }, {
                        field: this.DEFINITION.opcao2,
                        label: "Omitir Estruturas Gerenciais",
                        param: "P_OMITIRGEREN"
                    }, {
                        field: this.DEFINITION.opcao3,
                        label: "Omitir Vínculos",
                        param: "P_OMITIRVINC"
                    }, {
                    	field: this.DEFINITION.opcao4,
                    	label: "Ignorar Ocorrências de Cálculo",
                    	param: "P_IGNORAOCORR",
                    	valueField: "N"
                    } ]
                },
                relacao_salarios_inss: {
                    config: {
                        itemName: "Relação dos Salários de Contribuição - INSS",
                        fileName: "relacao_salarios_inss",
                        order: 320
                    },
                    params: [ {
                        field: this.DEFINITION.nrvinculoMulti,
                        param: "P_VINCULO",
                    }, {
                        field: this.DEFINITION.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    }, {
                        field: this.DEFINITION.nrestrutlegalMulti,
                        param: "P_ESTRUTLEGAL"
                    }, {
                        field: this.DEFINITION.nrestrutgerenMulti,
                        param: "P_ESTRUTGEREN"
                    }, {
                        field: this.DEFINITION.tipomovimento1,
                        param: "P_NRTPMOVIMENT",
                        descriptionField: "Mensal", valueField: "1",
                        required: true
                    }, {
                        field: this.DEFINITION.opcao1,
                        label: "Exibir Explicação",
                        param: "P_IDEXPLICACAO"
                    }, {
                    	field: this.DEFINITION.opcao4,
                    	label: "Ignorar Ocorrências de Cálculo",
                    	param: "P_IGNORAOCORR",
                    	valueField: "N"
                    } ]
                },
                requerimento_beneficio_incapacidade: {
                    config: {
                        itemName: "Requerimento de Benefício por Incapacidade",
                        fileName: "requerimento_beneficio_incapacidade",
                        order: 330
                    },
                    params: [ {
                        field: this.DEFINITION.nrvinculoMulti,
                        param: "P_NRVINCULO",
                    },{
                        field: this.DEFINITION.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    }, {
                        field: this.DEFINITION.nrestrutlegal,
                        param: "P_ESTRUTLEGAL"
                    },{
                        field: this.DEFINITION.nrestrutgeren,
                        param: "P_ESTRUTGEREN"
                    },{
                        field: this.DEFINITION.tipomovimento1,
                        param: "P_ATIV_VINC_PREV",
                        descriptionField: "Mensal", valueField: "1",
                        required: true
                    },{
                        field: this.DEFINITION.opcao1,
                        label: "Vínculado Previdência Social",
                        param: "P_ATIV_VINC_PREV",
                        required: true
                    },{
                        field: this.DEFINITION.data1,
                        param: "P_DTAFASTA",
                        label: "Data de afastamento",
                        required: true
                    },{
                        field: this.DEFINITION.situacaoFunc,
                        param: "P_TPAFASTA",
                        label: "Tipo de afastamento",
                        required: true
                    }
                    ]
                },
                resumo_contabilizacao_inss_vinc: {
                    config: {
                        itemName: "Resumo de Contabilização do INSS Vínculo",
                        fileName: "resumo_contabilizacao_inss_vinc",
                        order: 340
                    },
                    params: [ {
                        field: this.DEFINITION.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    },{
                        filed: this.DEFINITION.nrvinculoMulti,
                        required: false,
                        param: "P_VINCULO"
                    },{
                        field: this.DEFINITION.nrestrutlegal,
                        required: false,
                        param: "P_ESTRUTLEGAL"
                    },{
                        field: this.DEFINITION.nrestrutgeren,
                        required: false,
                        param: "P_ESTRUTGEEN"
                    },{
                        field: this.DEFINITION.tipomovimento1,
                        param: "P_NRTIPOMOVIMENT",
                        required: true,
                        descriptionField: "Mensal", valueField: "1"
                    },{
                        field: this.DEFINITION.number1,
                        label: 'Multa',
                        param: "P_MULTA"
                    },{
                        field: this.DEFINITION.number2,
                        param: "P_JUROS",
                        label: 'Juros'
                    },{
                        field: this.DEFINITION.opcao1,
                        label: "Incluir 13º Sal. no movimento",
                        param: "P_INCLUIR13"
                    },{
                        field: this.DEFINITION.opcao2,
                        label: "Incluir Vínculos Demitidos",
                        param: "P_INCLUIRDEMITIDOS",
                        valueField: "S"
                    },{
                        field: this.DEFINITION.opcao4,
                        label: "Gerar Memória",
                        param: "P_SHOWMEMORIA"
                    }]
                },
                resumo_contabilizacao_inss: {
                    config: {
                        itemName: "Resumo de Contabilização do INSS Tomador",
                        fileName: "resumo_contabilizacao_inss",
                        order: 350
                    },
                    params: [ {
                        field: this.DEFINITION.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    }, {
                        field: this.DEFINITION.nrestrutlegalMulti,
                        required: true,
                        param: "P_ESTRUTLEGAL"
                    },{
                        field: this.DEFINITION.tipomovimento1,
                        param: "P_NRTIPOMOVIMENT",
                        required: true,
                        descriptionField: "Mensal", valueField: "1"
                    },{
                        field: this.DEFINITION.number1,
                        label: 'Multa',
                        param: "P_MULTA"
                    },{
                        field: this.DEFINITION.number2,
                        param: "P_JUROS",
                        label: 'Juros'
                    },{
                        field: this.DEFINITION.opcao1,
                        label: "Incluir 13º Sal. no movimento",
                        param: "P_INCLUIR13"
                    },{
                        field: this.DEFINITION.opcao2,
                        label: "Incluir Vínculos Demitidos",
                        param: "P_INCLUIRDEMITIDOS",
                        valueField: "S"
                    },{
                        field: this.DEFINITION.tipohierarquia,
                        param: "P_TIPOHIERARQ"
                    },{
                        field: this.DEFINITION.opcao4,
                        label: "Gerar Memória",
                        param: "P_SHOWMEMORIA"
                    }]
                },
                resumo_contabilizacao_inss_geren: {
                    config: {
                        itemName: "Resumo de Contabilização do INSS Estrutura Gerencial",
                        fileName: "resumo_contabilizacao_inss_geren",
                        order: 360
                    },
                    params: [ {
                        field: this.DEFINITION.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    },{
                        field: this.DEFINITION.nrestrutlegal,
                        required: true,
                        param: "P_ESTRUTLEGAL"
                    },{
                        field: this.DEFINITION.nrestrutgeren,
                        param: "P_ESTRUTGEREN"
                    },{
                        field: this.DEFINITION.tipomovimento1,
                        param: "P_NRTIPOMOVIMENT",
                        required: true,
                        descriptionField: "Mensal", valueField: "1"
                    },{
                        field: this.DEFINITION.number1,
                        label: 'Multa',
                        param: "P_MULTA"
                    },{
                        field: this.DEFINITION.number2,
                        param: "P_JUROS",
                        label: 'Juros'
                    },{
                        field: this.DEFINITION.opcao1,
                        label: "Incluir 13º Sal. no movimento",
                        param: "P_INCLUIR13"
                    },{
                        field: this.DEFINITION.opcao2,
                        label: "Incluir Vínculos Demitidos",
                        param: "P_INCLUIRDEMITIDOS",
                        valueField: "S"
                    },{
                        field: this.DEFINITION.opcao4,
                        label: "Gerar Memória",
                        param: "P_SHOWMEMORIA"
                    }]
                },
                resumo_contabilizacao_inss_legal: {
                    config: {
                        itemName: "Resumo de Contabilização do INSS Estrutura Legal",
                        fileName: "resumo_contabilizacao_inss_legal",
                        order: 370
                    },
                    params: [ {
                        field: this.DEFINITION.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    },{
                        field: this.DEFINITION.nrestrutlegalMulti,
                        required: true,
                        param: "P_ESTRUTLEGAL"
                    },{
                        field: this.DEFINITION.nrestrutgerenMulti,
                        param: "P_ESTRUTGEREN"
                    },{
                        field: this.DEFINITION.tipomovimento1,
                        param: "P_NRTIPOMOVIMENT",
                        required: true,
                        descriptionField: "Mensal", valueField: "1"
                    },{
                        field: this.DEFINITION.number1,
                        label: 'Multa',
                        param: "P_MULTA"
                    },{
                        field: this.DEFINITION.number2,
                        param: "P_JUROS",
                        label: 'Juros'
                    },{
                        field: this.DEFINITION.opcao1,
                        label: "Incluir 13º Sal. no movimento",
                        param: "P_INCLUIR13"
                    },{
                        field: this.DEFINITION.opcao2,
                        label: "Incluir Vínculos Demitidos",
                        param: "P_INCLUIRDEMITIDOS",
                        valueField: "S"
                    },{
                        field: this.DEFINITION.opcao4,
                        label: "Gerar Memória",
                        param: "P_SHOWMEMORIA"
                    }]
                },
                resumo_contabilizacao_inss_vinc_xls: {
                    config: {
                        itemName: "Analítico de Contabilização Patronal do INSS Vínculo - Planilha",
                        fileName: "resumo_contabilizacao_inss_vinc",
                        format: "xlsx",
                        order: 371
                    },
                    params: [ {
                        field: this.DEFINITION.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    },{
                        filed: this.DEFINITION.nrvinculoMulti,
                        required: false,
                        param: "P_VINCULO"
                    },{
                        field: this.DEFINITION.nrestrutlegal,
                        required: false,
                        param: "P_ESTRUTLEGAL"
                    },{
                        field: this.DEFINITION.nrestrutgeren,
                        required: false,
                        param: "P_ESTRUTGEEN"
                    },{
                        field: this.DEFINITION.tipomovimento1,
                        param: "P_NRTIPOMOVIMENT",
                        required: true,
                        descriptionField: "Mensal", valueField: "1"
                    },{
                        field: this.DEFINITION.number1,
                        label: 'Multa',
                        param: "P_MULTA"
                    },{
                        field: this.DEFINITION.number2,
                        param: "P_JUROS",
                        label: 'Juros'
                    },{
                        field: this.DEFINITION.opcao1,
                        label: "Incluir 13º Sal. no movimento",
                        param: "P_INCLUIR13"
                    },{
                        field: this.DEFINITION.opcao2,
                        label: "Incluir Vínculos Demitidos",
                        param: "P_INCLUIRDEMITIDOS",
                        valueField: "S"
                    },{
                        param: "P_SHOWMEMORIA",
                        row: "showmemoria",
                        value: "S"
                    }]
                },
                resumo_contabilizacao_inss_xls: {
                    config: {
                        itemName: "Analítico de Contabilização Patronal do INSS Tomador - Planilha",
                        fileName: "resumo_contabilizacao_inss",
                        format: "xlsx",
                        order: 372
                    },
                    params: [ {
                        field: this.DEFINITION.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    }, {
                        field: this.DEFINITION.nrestrutlegalMulti,
                        required: true,
                        param: "P_ESTRUTLEGAL"
                    },{
                        field: this.DEFINITION.tipomovimento1,
                        param: "P_NRTIPOMOVIMENT",
                        required: true,
                        descriptionField: "Mensal", valueField: "1"
                    },{
                        field: this.DEFINITION.number1,
                        label: 'Multa',
                        param: "P_MULTA"
                    },{
                        field: this.DEFINITION.number2,
                        param: "P_JUROS",
                        label: 'Juros'
                    },{
                        field: this.DEFINITION.opcao1,
                        label: "Incluir 13º Sal. no movimento",
                        param: "P_INCLUIR13"
                    },{
                        field: this.DEFINITION.opcao2,
                        label: "Incluir Vínculos Demitidos",
                        param: "P_INCLUIRDEMITIDOS",
                        valueField: "S"
                    },{
                        field: this.DEFINITION.tipohierarquia,
                        param: "P_TIPOHIERARQ"
                    },{
                        param: "P_SHOWMEMORIA",
                        row: "showmemoria",
                        value: "S"
                    }]
                },
                resumo_contabilizacao_inss_geren_xls: {
                    config: {
                        itemName: "Analítico de Contabilização Patronal do INSS Estrutura Gerencial - Planilha",
                        fileName: "resumo_contabilizacao_inss_geren",
                        format: "xlsx",
                        order: 373
                    },
                    params: [ {
                        field: this.DEFINITION.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    },{
                        field: this.DEFINITION.nrestrutlegal,
                        required: true,
                        param: "P_ESTRUTLEGAL"
                    },{
                        field: this.DEFINITION.nrestrutgeren,
                        param: "P_ESTRUTGEREN"
                    },{
                        field: this.DEFINITION.tipomovimento1,
                        param: "P_NRTIPOMOVIMENT",
                        required: true,
                        descriptionField: "Mensal", valueField: "1"
                    },{
                        field: this.DEFINITION.number1,
                        label: 'Multa',
                        param: "P_MULTA"
                    },{
                        field: this.DEFINITION.number2,
                        param: "P_JUROS",
                        label: 'Juros'
                    },{
                        field: this.DEFINITION.opcao1,
                        label: "Incluir 13º Sal. no movimento",
                        param: "P_INCLUIR13"
                    },{
                        field: this.DEFINITION.opcao2,
                        label: "Incluir Vínculos Demitidos",
                        param: "P_INCLUIRDEMITIDOS",
                        valueField: "S"
                    },{
                        param: "P_SHOWMEMORIA",
                        row: "showmemoria",
                        value: "S"
                    }]
                },
                resumo_contabilizacao_inss_legal_xls: {
                    config: {
                        itemName: "Analítico de Contabilização Patronal do INSS Estrutura Legal - Planilha",
                        fileName: "resumo_contabilizacao_inss_legal",
                        format: "xlsx",
                        order: 374
                    },
                    params: [ {
                        field: this.DEFINITION.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    },{
                        field: this.DEFINITION.nrestrutlegalMulti,
                        required: true,
                        param: "P_ESTRUTLEGAL"
                    },{
                        field: this.DEFINITION.nrestrutgerenMulti,
                        param: "P_ESTRUTGEREN"
                    },{
                        field: this.DEFINITION.tipomovimento1,
                        param: "P_NRTIPOMOVIMENT",
                        required: true,
                        descriptionField: "Mensal", valueField: "1"
                    },{
                        field: this.DEFINITION.number1,
                        label: 'Multa',
                        param: "P_MULTA"
                    },{
                        field: this.DEFINITION.number2,
                        param: "P_JUROS",
                        label: 'Juros'
                    },{
                        field: this.DEFINITION.opcao1,
                        label: "Incluir 13º Sal. no movimento",
                        param: "P_INCLUIR13"
                    },{
                        field: this.DEFINITION.opcao2,
                        label: "Incluir Vínculos Demitidos",
                        param: "P_INCLUIRDEMITIDOS",
                        valueField: "S"
                    },{
                        param: "P_SHOWMEMORIA",
                        row: "showmemoria",
                        value: "S"
                    }]
                },
                resumo_folha_por_funcionario: {
                    config: {
                        itemName: "Resumo de Folha de Pagamento por Funcionario - Agrupado por Estruturas",
                        fileName: "resumo_folha_por_funcionario",
                        order: 380
                    },
                    params: [ {
                        field: this.DEFINITION.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    }, {
                        field: this.DEFINITION.nrestrutlegal,
                        param: "P_ESTRUTLEGAL",
                        required: true
                    }, {
                        field: this.DEFINITION.tipomovimento1,
                        param: "P_NRTPMOVIMENT",
                        required: true,
                        descriptionField: "Mensal", valueField: "1"
                    }, {
                        field: this.DEFINITION.nrvinculoMulti,
                        param: "P_VINCULO"
                    }, {
                        field: this.DEFINITION.opcao1,
                        label: "Incluir Vínculos Demitidos",
                        param: "P_INCLUIRDEMITIDO"
                    }, {
                    	field: this.DEFINITION.opcao4,
                    	label: "Ignorar Ocorrências de Cálculo",
                    	param: "P_IGNORAOCORR",
                    	valueField: "N"
                    } ]
                },
                resumo_impostos: {
                    config: {
                        itemName: "Resumo de Impostos",
                        fileName: "resumo_impostos",
                        order: 400
                    },
                    params: [ {
                        field: this.DEFINITION.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    }, {
                        field: this.DEFINITION.nrestrutlegalMulti,
                        param: "P_ESTRUTLEGAL"
                    }, {
                        field: this.DEFINITION.nrestrutgerenMulti,	 
                        param: "P_ESTRUTGEREN"	 
                    }, {
                        field: this.DEFINITION.nrvinculoMulti,
                        param: "P_VINCULO"
                    },{
                        field: this.DEFINITION.tipomovimento1,
                        param: "P_TIPOMOVIMENTO",
                        required: true,
                        descriptionField: "Mensal", valueField: "1"
                    },{
                        field: this.DEFINITION.opcao1,
                        label: "Incluir 13º Sal. no movimento",
                        param: "P_INCLUIR13"
                    },{
                        field: this.DEFINITION.opcao2,
                        label: "Omitir Agrupamento Gerencial",
                        param: "P_OMITIRGEREN"
                    },{
                        field: this.DEFINITION.zebrado,
                        param: "ZEBRADO"
                    },{
                        field: this.DEFINITION.opcao3,
                        label: "Ignorar Ocorrencias de Cálculo",
                        param: "P_IGNORAOCORR"
                    },{
                        field: this.DEFINITION.opcao4,
                        label: "Gerar Memória",
                        param: "P_SHOWMEMORIA"
                    } ]
                },
                resumo_irrf: {
                    config: {
                        itemName: "Resumo de IRRF",
                        fileName: "resumo_irrf",
                        order: 405
                    },
                    params: [ {
                        field: this.DEFINITION.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    }, {
                        field: this.DEFINITION.nrvinculoMulti,
                        param: "P_VINCULO"
                    }, {
                        field: this.DEFINITION.nrestrutlegalMulti,
                        param: "P_ESTRUTLEGAL"
                    },{
                        field: this.DEFINITION.nrestrutgerenMulti,
                        param: "P_ESTRUTGEREN"
                    }, {
                        field: this.DEFINITION.dtinicio,
                        param: "P_DTINICIO"
                    }, {
                        field: this.DEFINITION.dtfim,
                        param: "P_DTFINAL"
                    },{
                        field: this.DEFINITION.opcao1,
                        label: "Regime Caixa",
                        param: "P_IDREGIMECAIXA"
                    },{
                        field: this.DEFINITION.opcao2,
                        label: "Omitir Agrupamento Gerencial",
                        param: "P_OMITIRGEREN"
                    },{
                        field: this.DEFINITION.zebrado,
                        param: "ZEBRADO"
                    },{
                        field: this.DEFINITION.opcao3,
                        label: "Ignorar Ocorrencias de Cálculo",
                        param: "P_IGNORAOCORR"
                    },{
                        field: this.DEFINITION.opcao4,
                        label: "Gerar Memória",
                        param: "P_SHOWMEMORIA"
                    } ]
                },
                resumo_totais_folha: {
                    config: {
                        itemName: "Resumo dos Totais da Folha de Pagamento",
                        fileName: "resumo_totais_folha",
                        order: 410
                    },
                    params: [ {
                        field: this.DEFINITION.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    }, {
                        field: this.DEFINITION.nrestrutlegalMulti,
                        param: "P_ESTRUTLEGAL"
                    }, {
                        field: this.DEFINITION.nrestrutgerenMulti,
                        param: "P_ESTRUTGEREN"
                    }, {
                        field: this.DEFINITION.tipohierarquiaMulti,
                        param: "P_NRTIPOHIERARQ"
                    }, {
                        field: this.DEFINITION.nrestrutsupMulti,
                        param: "P_NRESTRUTSUP"
                    }, {
                        field: this.DEFINITION.tipomovimento1,
                        param: "P_TIPOMOVIMENTO",
                        required: true,
                        descriptionField: "Mensal", valueField: "1"
                    }, {
                        field: this.DEFINITION.tpvinculoMulti,
                        param: "P_TIPOVINCULO",
                        required: true
                    }, {
                        field: this.DEFINITION.opcao1,
                        label: "Incluir Vínculos Demitidos",
                        param: "P_INCLUIRDEMITIDO"
                    }, {
                        field: this.DEFINITION.zebrado,
                        param: "ZEBRADO"
                    }, {
                        field: this.DEFINITION.opcao3,
                        label: "Ignorar Ocorrencias de Cálculo",
                        param: "P_IGNORAOCORR"
                    }, {
                        field: this.DEFINITION.opcao4,
                        label: "Gerar Memória",
                        param: "P_SHOWMEMORIA"
                    }, {
                        field: this.DEFINITION.opcao2,
                        label: "Incluir 13º Sal. no movimento",
                        param: "P_INCLUIR13"
                    } ]
                },
                resumo_folha: {
                    config: {
                        itemName: "Resumo Folha",
                        fileName: "resumo_folha",
                        order: 420
                    },
                    params: [ {
                        field: this.DEFINITION.competencia,
                        param: "P_DTMESCOMPETENC",
                        required: true
                    },{
                        field: this.DEFINITION.nrestrutlegalMulti,
                        param: "P_NRESTRUTLEGAL"
                    },{
                        field: this.DEFINITION.nrestrutgerenMulti,
                        param: "P_NRESTRUTGEREN"
                    },{
                        field: this.DEFINITION.tipomovimento1,
                        param: "P_NRTIPOMOVIMENT",
                        required: true,
                        descriptionField: "Mensal", valueField: "1"
                    },{
                        field: this.DEFINITION.zebrado,
                        param: "ZEBRADO"
                    },{
                        field: this.DEFINITION.opcao3,
                        label: "Ignorar Ocorrencias de Cálculo",
                        param: "P_IGNORAOCORR"
                    }]
                },
                folha_analitica_sintetico: {
                    config: {
                        itemName: "Resumo Movimento",
                        fileName: "folha_analitica_sintetico",
                        order: 430
                    },
                    params: [ {
                        field: this.DEFINITION.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    }, {
                        field: this.DEFINITION.nrestrutlegalMulti,
                        param: "P_ESTRUTURALEGAL"
                    }, {
                        field: this.DEFINITION.nrestrutgerenMulti,
                        param: "P_ESTRUTURAGEREN"
                    }, {
                        field: this.DEFINITION.tipomovimento1,
                        param: "P_TIPOMOVIMENTO",
                        required: true,
                        descriptionField: "Mensal",valueField: "1"
                    },{
                        field: this.DEFINITION.tipohierarquiaMulti,
                        param: "P_NRTIPOHIERARQ"
                    },{
                        field: this.DEFINITION.nrestrutsupMulti,
                        param: "P_NRESTRUTSUP"
                    },{
                        field: this.DEFINITION.zebrado,
                        param: "ZEBRADO"
                    },{
                        field: this.DEFINITION.opcao1,
                        label: "Omitir Vínculos",
                        param: "P_OMITIRVINCULOS"
                    },{
                        field: this.DEFINITION.opcao2,
                        label: "Omitir Resumo Legal",
                        param: "P_OMITIRLEGAL"
                    },{
                        field: this.DEFINITION.opcao3,
                        label: "Incluir 13º Sal. no movimento",
                        param: "P_INCLUIR13"
                    },{
                        field: this.DEFINITION.opcao4,
                        label: "Omitir Data de Rescisão",
                        param: "P_OMITIRRESC"
                    },{
                        field: this.DEFINITION.opcao5,
                        label: "Somente Vínculos Demitidos",
                        param: "P_SODEMITIDO"
                    },{
                        field: this.DEFINITION.opcao6,
                        label: "Omitir Resumo Gerencial",
                        param: "P_OMITIRGEREN"
                    },{
                        field: this.DEFINITION.opcao7,
                        label: "Ignorar Ocorrencias de Cálculo",
                        param: "P_IGNORAOCORR"
                    },{
                        field: this.DEFINITION.opcao8,
                        label: "Mostrar Eventos Demonstrativos",
                        param: "P_MOSTRARDEMO"
                    },{
                        field: this.DEFINITION.tpincidencia,
                        label: "Eventos Ocultos do Tipo de Incidencia ",
                        param: "P_NRTIPOINCIDE"
                    }]
                },
                resumo_movimento_hierarquia: {
                    config: {
                        itemName: "Resumo Movimento - Hierarquia",
                        fileName: "resumo_movimento_hierarquia",
                        order: 435
                    },
                    params: [ {
                        field: this.DEFINITION.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    }, {
                        field: this.DEFINITION.nrestrutlegal,
                        param: "P_ESTRUTURALEGAL"
                    }, {
                        field: this.DEFINITION.tipomovimento1,
                        param: "P_TIPOMOVIMENTO",
                        required: true,
                        descriptionField: "Mensal",valueField: "1"
                    },{
                        field: this.DEFINITION.tipohierarquia,
                        param: "P_NRTIPOHIERARQ",
                        required: true
                    },{
                        field: this.DEFINITION.nrestrutsup,
                        param: "P_NRESTRUTSUP"
                    },{
                        field: this.DEFINITION.zebrado,
                        param: "ZEBRADO"
                    },{
                        field: this.DEFINITION.opcao1,
                        label: "Omitir Vínculos",
                        param: "P_OMITIRVINCULOS"
                    },{
                        field: this.DEFINITION.opcao2,
                        label: "Omitir Resumo Legal",
                        param: "P_OMITIRLEGAL"
                    },{
                        field: this.DEFINITION.opcao3,
                        label: "Incluir 13º Sal. no movimento",
                        param: "P_INCLUIR13"
                    },{
                        field: this.DEFINITION.opcao4,
                        label: "Omitir Data de Rescisão",
                        param: "P_OMITIRRESC"
                    },{
                        field: this.DEFINITION.opcao5,
                        label: "Somente Vínculos Demitidos",
                        param: "P_SODEMITIDO"
                    },{
                        field: this.DEFINITION.opcao6,
                        label: "Ignorar Ocorrencias de Cálculo",
                        param: "P_IGNORAOCORR"
                    },{
                        field: this.DEFINITION.opcao7,
                        label: "Mostrar Eventos Demonstrativos",
                        param: "P_MOSTRARDEMO"
                    },{
                        field: this.DEFINITION.tpincidencia,
                        label: "Eventos Ocultos do Tipo de Incidencia ",
                        param: "P_NRTIPOINCIDE"
                    }]
                }
            }
        },
        FPA_fer: {
            label: "Relatórios de Férias",
            0: {
                medias_ferias: {
                    config: {
                        itemName: "Médias para Cálculo de Férias",
                        fileName: "medias_ferias",
                        order: 10
                    },
                    params: [ {
                        field: this.DEFINITION.competencia,
                        param: "P_DTMESCOMPETENC",
                        required: true
                    },{
                        field: this.DEFINITION.nrestrutlegal,
                        param: "P_ESTRUTLEGAL"
                    },{
                        field: this.DEFINITION.nrestrutgeren,
                        param: "P_ESTRUTGEREN"
                    },{
                        field: this.DEFINITION.nrvinculoMulti,
                        param: "P_NRVINCULO"
                    },{
                        field: this.DEFINITION.tipomovimento1,
                        param: "P_NRTIPOMOVIMENT",
                        required: true,
                        descriptionField: "Mensal", valueField: "1"
                    },{
                        field: this.DEFINITION.dtinicio,
                        label: "Data Inicial de Gozo de Férias",
                        required: true,
                        param: "P_DTINIGOZO"
                    },{
                        field: this.DEFINITION.dtfim,
                        required: true,
                        label: "Data Final de Gozo de Férias",
                        param: "P_DTFIMGOZO"
                    },{
                        field: this.DEFINITION.opcao1,
                        label: 'Mostrar Simulação de Cálculo de Médias',
                        param: "P_MOSTRARSIMUL"
                    },{
                        field: this.DEFINITION.opcao2,
                        label: '2 Vias (Recibo de Férias)',
                        param: "P_OMITIRGERENC"
                    },{
                        field: this.DEFINITION.zebrado,
                        param: "ZEBRADO"
                    }]
                },
                acordo_antecipacao_ferias: {
                    config: {
                        itemName: "Acordo de Antecipação de Férias",
                        fileName: "acordo_antecipacao_ferias",
                        order: 15
                    },
                    params: [{
                        field: this.DEFINITION.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    },{
                        field: this.DEFINITION.nrvinculoMulti,
                        param: "P_VINCULO"
                    },{
                        field: this.DEFINITION.nrestrutlegal,
                        param: "P_ESTRUTLEGAL"
                    },{
                        field: this.DEFINITION.nrestrutgeren,
                        param: "P_ESTRUTGEREN"
                    },{
                        label: "Data Inicial de Gozo",
                        field: this.DEFINITION.dtinicio,
                        param: "P_INICIO",
                        required: true
                    },{
                        label: "Data Final de Gozo",
                        field: this.DEFINITION.dtfim,
                        param: "P_FINAL",
                        required: true
                    },{
                        label: "Data do Documento",
                        field: this.DEFINITION.dtdocumento,
                        param: "P_DTDOCUMENTO"
                    },{
                        label: "Data de Pagamento",
                        field: this.DEFINITION.data1,
                        param: "P_DTPAGA"
                    },{
                        label: "Data de Execução (adimplir)",
                        field: this.DEFINITION.data2,
                        param: "P_DTADIMP"
                    },{
                        label: "Mostrar Rodapé",
                        field: this.DEFINITION.opcao1,
                        valueField: "S",
                        param: "P_SHOWFOOTER"
                    },{
                        field: this.DEFINITION.opcao2,
                        param: "P_MODELO",
                        label: "Modelo do Relatório",
                        valueField: "1",
                        dataList: [ {
                            name: "Modelo 1 - Pagamento Parcelado",
                            value: "1"
                        }, {
                            name: "Modelo 2 - Pagamento Único",
                            value: "2"
                        } ],
                        required: true
                    }]
                },
                aviso_previo_ferias: {
                    config: {
                        itemName: "Aviso Prévio de Férias",
                        fileName: "aviso_previo_ferias",
                        order: 20
                    },
                    params: [ {
                        field: this.DEFINITION.competencia,
                        param: "P_DTMESCOMPETENC",
                        required: true
                    },{
                        field: this.DEFINITION.nrestrutlegalMulti,
                        param: "P_NRESTRUTURA"
                    },{
                        field: this.DEFINITION.nrestrutgerenMulti,
                        param: "P_NRESTRUTGEREN"
                    },{
                        field: this.DEFINITION.nrvinculoMulti,
                        param: "P_NRVINCULOM"
                    },{
                        field: this.DEFINITION.tipohierarquiaMulti,
                        param: "P_NRTIPOHIERARQ"
                    },{
                        field: this.DEFINITION.nrestrutsupMulti,
                        param: "P_NRESTRUTSUP"
                    },{
                        field: this.DEFINITION.dtinicio,
                        label: "Data Inicial de Gozo de Férias",
                        param: "P_DATAINICIAL"
                    },{
                        field: this.DEFINITION.dtfim,
                        label: "Data Final de Gozo de Férias",
                        param: "P_DATAFINAL"
                    },{
                        label: "Data do Documento",
                        field: this.DEFINITION.dtdocumento,
                        param: "P_DTDOCUMENTO"
                    },{
                        field: this.DEFINITION.opcao2,
                        label: '2 Vias',
                        param: "P_2VIAS"
                    }]
                },
                avisos_previos: {
                    config: {
                        itemName: "Aviso prévio - Informações adicionais",
                        fileName: "avisos_1024",
                        order: 23
                    },
                    params: [{
                        field: this.DEFINITION.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    },
                    {
                        field: this.DEFINITION.opcao2,
                        param: "P_RELATORIO",
                        required: true,
                        dataList: [ {
                                name: "Aviso Prévio do Empregador",
                                value: "aviso_empregador"
                            }, {
                                name: "Término de Contrato de Experiência",
                                value: "termino_contrato_exp"
                            } ],
                        label: "Relatório de Aviso"
                    },
                    {
                        field: this.DEFINITION.opcao1,
                        param: "P_INDENIZADO",
                        label: "Indenizado"
                    },
                    {
                        field: this.DEFINITION.nrvinculoMulti,
                        param: "P_VINCULO"
                    },
                    {
                        field: this.DEFINITION.nrestrutlegal,
                        param: "P_ESTRUTLEGAL"
                    },
                    {
                        field: this.DEFINITION.nrestrutgeren,
                        param: "P_ESTRUTGEREN"
                    },
                    {
                        field: this.DEFINITION.data1,
                        param: "P_DTFORMPERTENCE",
                        label: "Data de devolução dos pertences"
                    },
                    {
                        field: this.DEFINITION.data2,
                        param: "P_DTFORMFORMAL",
                        label: "Data da formalidade legal"
                    },
                    {
                        field: this.DEFINITION.data3,
                        param: "P_DTFORMEXAME",
                        label: "Data do exame demissional"
                    },
                    {
                        field: this.DEFINITION.data4,
                        param: "P_DTFORMPAGTO",
                        label: "Data do pagamento (banco)"
                    },
                    {
                        field: this.DEFINITION.data5,
                        param: "P_DTFORMEMISSAO",
                        label: "Data de Emissão",
                        required: true
                    },
                    {
                        field: this.DEFINITION.dtinicio,
                        param: "P_DATAINI",
                        label: "Data Inicial da Rescisão"
                    },
                    {
                        field: this.DEFINITION.dtfim,
                        param: "P_DATAFIM",
                        label: "Data Final da Rescisão"
                    },
                    {
                        label: "Dias de aviso",
                        field: this.DEFINITION.number4,
                        param: "P_DIASAVISO",
                        valueField: "30"
                    }
                  ]
                },
                controle_ferias: {
                    config: {
                        itemName: "Controle de Pagamento 1/3 de Férias",
                        fileName: "controle_ferias",
                        order: 25
                    },
                    params: [ {
                        field: this.DEFINITION.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    },{
                        field: this.DEFINITION.nrestrutlegal,
                        param: "P_ESTRUTLEGAL"
                    },{
                        field: this.DEFINITION.nrestrutgeren,
                        param: "P_ESTRUTGEREN"
                    },{
                        field: this.DEFINITION.nrvinculoMulti,
                        param: "P_NRVINCULO"
                    },{
                        field: this.DEFINITION.tipohierarquia,
                        param: "P_HIERARQUIA"
                    },{
                        field: this.DEFINITION.data1,
                        label: "Data Recibo/Lim. Prev. Fér.",
                        param: "P_DATALIMITE"
                    },{
                        field: this.DEFINITION.opcao1,
                        label: 'Exibir Vínculos Afastados',
                        param: "P_VINCAFAST",
                        valueField: "S"
                    },{
                        field: this.DEFINITION.opcao4,
                        label: 'Omitir Agrupamentos (Prev. Férias)',
                        param: "P_OMITIRAGRUP"
                    },{
                        field: this.DEFINITION.zebrado,
                        param: "ZEBRADO"
                    }]
                },
                previsao_ferias: {
                    config: {
                        itemName: "Previsão de Férias",
                        fileName: "previsao_ferias",
                        order: 30
                    },
                    params: [ {
                        field: this.DEFINITION.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    },{
                        field: this.DEFINITION.nrestrutlegalMulti,
                        param: "P_ESTRUTLEGAL"
                    },{
                        field: this.DEFINITION.nrestrutgerenMulti,
                        param: "P_ESTRUTGEREN"
                    },{
                        field: this.DEFINITION.nrvinculoMulti,
                        param: "P_NRVINCULO"
                    },{
                        field: this.DEFINITION.tipohierarquia,
                        param: "P_HIERARQUIA"
                    },{
                        field: this.DEFINITION.data1,
                        label: "Data Recibo/Lim. Prev. Fér.",
                        param: "P_DATALIMITE"
                    },{
                        field: this.DEFINITION.opcao1,
                        label: 'Exibir Vínculos Afastados',
                        param: "P_VINCAFAST",
                        valueField: "S"
                    },{
                        field: this.DEFINITION.opcao4,
                        label: 'Omitir Agrupamentos (Prev. Férias)',
                        param: "P_OMITIRAGRUP"
                    },{
                        field: this.DEFINITION.zebrado,
                        param: "ZEBRADO"
                    }]
                },
                faltas_periodo_aquisicao: {
                    config: {
                        itemName: "Faltas no Período de Aquisição",
                        fileName: "faltas_periodo_aquisicao",
                        order: 40
                    },
                    params: [ {
                        field: this.DEFINITION.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    },{
                        field: this.DEFINITION.nrestrutlegal,
                        param: "P_ESTRUTLEGAL"
                    },{
                        field: this.DEFINITION.nrestrutgeren,
                        param: "P_ESTRUTGEREN"
                    },{
                        field: this.DEFINITION.nrvinculoMulti,
                        param: "P_VINCULO"
                    },{
                        field: this.DEFINITION.data2,
                        label: "Data Inicial do Período Aquisitivo",
                        param: "P_DTINIAQUI"
                    },{
                        field: this.DEFINITION.data3,
                        label: "Data Final do Período Aquisitivo",
                        param: "P_DTFIMAQUI"
                    },{
                        field: this.DEFINITION.zebrado,
                        param: "ZEBRADO"
                    }]
                },
                recibo_ferias: {
                    config: {
                        itemName: "Recibo de Férias",
                        fileName: "recibo_ferias",
                        order: 50
                    },
                    params: [ {
                        field: this.DEFINITION.competencia,
                        param: "P_DTMESCOMPETENC",
                        required: true
                    },{
                        field: this.DEFINITION.nrestrutlegal,
                        param: "P_NRESTRUTURA"
                    },{
                        field: this.DEFINITION.nrestrutgeren,
                        param: "P_NRESTRUTGEREN"
                    },{
                        field: this.DEFINITION.tipohierarquiaMulti,
                        param: "P_NRTIPOHIERARQ"
                    },{
                        field: this.DEFINITION.nrestrutsupMulti,
                        param: "P_NRESTRUTSUP"
                    },{
                        field: this.DEFINITION.nrvinculoMulti,
                        param: "P_NRVINCULO"
                    },{
                        field: this.DEFINITION.data1,
                        label: "Data Recibo/Lim. Prev. Fér.",
                        param: "DATA_CALCULO_CONTRA_CHEQUE_FERIAS"
                    },{
                        field: this.DEFINITION.dtinicio,
                        label: "Data Inicial de Gozo de Férias",
                        param: "P_DATAINICIO"
                    },{
                        field: this.DEFINITION.dtfim,
                        label: "Data Final de Gozo de Férias",
                        param: "P_DATAFIM"
                    },{
                        field: this.DEFINITION.opcao2,
                        label: '2 Vias (Recibo de Férias)',
                        param: "P_2VIAS"
                    },{
                        field: this.DEFINITION.opcao3,
                        label: 'Somente Vínculos Ativos (Recibo de Férias)',
                        param: "P_SOMENTEATIVOS"
                    },{
                        field: this.DEFINITION.opcao4,
                        label: "Ignorar Ocorrencias de Cálculo",
                        param: "P_IGNORAOCORR",
                        valueField: "S"
                    },{
                        field: this.DEFINITION.mensagemPadrao,
                        label: 'Observação',
                        param: "P_OBSERVACAO"
                    }]
                },
                recibo_ferias_sintetico: {
                    config: {
                        itemName: "Recibo de Férias - Sintético",
                        fileName: "recibo_ferias_sintetico",
                        order: 55
                    },
                    params: [ {
                        field: this.DEFINITION.competencia,
                        param: "P_DTMESCOMPETENC",
                        required: true
                    },{
                        field: this.DEFINITION.nrestrutlegal,
                        param: "P_NRESTRUTURA"
                    },{
                        field: this.DEFINITION.nrestrutgeren,
                        param: "P_NRESTRUTGEREN"
                    },{
                        field: this.DEFINITION.tipohierarquiaMulti,
                        param: "P_NRTIPOHIERARQ"
                    },{
                        field: this.DEFINITION.nrestrutsupMulti,
                        param: "P_NRESTRUTSUP"
                    },{
                        field: this.DEFINITION.nrvinculoMulti,
                        param: "P_NRVINCULO"
                    },{
                        field: this.DEFINITION.data1,
                        label: "Data Recibo/Lim. Prev. Fér.",
                        param: "DATA_CALCULO_CONTRA_CHEQUE_FERIAS"
                    },{
                        field: this.DEFINITION.dtinicio,
                        label: "Data Inicial de Gozo de Férias",
                        param: "P_DATAINICIO"
                    },{
                        field: this.DEFINITION.dtfim,
                        label: "Data Final de Gozo de Férias",
                        param: "P_DATAFIM"
                    },{
                        field: this.DEFINITION.opcao2,
                        label: '2 Vias (Recibo de Férias)',
                        param: "P_2VIAS"
                    },{
                        field: this.DEFINITION.opcao3,
                        label: 'Somente Vínculos Ativos (Recibo de Férias)',
                        param: "P_SOMENTEATIVOS"
                    }]
                },
                medias_sal_familia: {
                    config: {
                        itemName: "Médias para Cálculo de Salário Família",
                        fileName: "medias_sal_familia",
                        order: 60
                    },
                    params: [ {
                        field: this.DEFINITION.competencia,
                        param: "P_DTMESCOMPETENC",
                        required: true
                    },{
                        field: this.DEFINITION.nrestrutlegal,
                        param: "P_ESTRUTLEGAL"
                    },{
                        field: this.DEFINITION.nrestrutgeren,
                        param: "P_ESTRUTGEREN"
                    },{
                        field: this.DEFINITION.nrvinculoMulti,
                        param: "P_NRVINCULO"
                    },{
                        field: this.DEFINITION.opcao1,
                        label: 'Ignora EVENTO',
                        param: "P_IGNORAEVENTO"
                    },{
                        field: this.DEFINITION.zebrado,
                        param: "ZEBRADO"
                    }]
                },
                medias_ferias_2: {
                    config: {
                        itemName: "Acompanhamento de Férias",
                        fileName: "medias_ferias_2",
                        order: 70
                    },
                    params: [ {
                        field: this.DEFINITION.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    },{
                        field: this.DEFINITION.nrestrutlegal,
                        param: "P_ESTRUTLEGAL"
                    },{
                        field: this.DEFINITION.nrestrutgeren,
                        param: "P_ESTRUTGEREN"
                    },{
                        field: this.DEFINITION.nrvinculoMulti,
                        param: "P_VINCULO"
                    },{
                        field: this.DEFINITION.dtinicio,
                        label: "Data Inicial de Gozo de Férias",
                        param: "P_INICIO"
                    },{
                        field: this.DEFINITION.dtfim,
                        label: "Data Final de Gozo de Férias",
                        param: "P_FINAL"
                    }]
                }
            },
            1311: {
                recibo_ferias: {
                    config: {
                        itemName: "Recibo de Férias",
                        fileName: "recibo_ferias_unificado",
                        order: 50
                    },
                    params: [ {
                        field: this.DEFINITION.competencia,
                        param: "P_DTMESCOMPETENC",
                        required: true
                    },{
                        field: this.DEFINITION.nrestrutlegal,
                        param: "P_NRESTRUTURA"
                    },{
                        field: this.DEFINITION.nrestrutgeren,
                        param: "P_NRESTRUTGEREN"
                    },{
                        field: this.DEFINITION.tipohierarquia,
                        param: "P_NRTIPOHIERARQ"
                    },{
                        field: this.DEFINITION.nrestrutsupMulti,
                        param: "P_NRESTRUTSUP"
                    },{
                        field: this.DEFINITION.nrvinculoMulti,
                        param: "P_NRVINCULO"
                    },{
                        field: this.DEFINITION.data1,
                        label: "Data Recibo/Lim. Prev. Fér.",
                        param: "DATA_CALCULO_CONTRA_CHEQUE_FERIAS"
                    },{
                        field: this.DEFINITION.dtinicio,
                        label: "Data Inicial de Gozo de Férias",
                        param: "P_DATAINICIO"
                    },{
                        field: this.DEFINITION.dtfim,
                        label: "Data Final de Gozo de Férias",
                        param: "P_DATAFIM"
                    },{
                        field: this.DEFINITION.opcao2,
                        label: '2 Vias (Recibo de Férias)',
                        param: "P_2VIAS"
                    },{
                        field: this.DEFINITION.opcao3,
                        label: 'Somente Vínculos Ativos (Recibo de Férias)',
                        param: "P_SOMENTEATIVOS"
                    }]
                },
                aviso_previo_ferias: {
                    config: {
                        itemName: "Aviso Prévio de Férias",
                        fileName: "aviso_previo_ferias_1311",
                        order: 20
                    },
                    params: [ {
                        field: this.DEFINITION.competencia,
                        param: "P_DTMESCOMPETENC",
                        required: true
                    },{
                        field: this.DEFINITION.nrestrutlegalMulti,
                        param: "P_NRESTRUTURA"
                    },{
                        field: this.DEFINITION.nrestrutgerenMulti,
                        param: "P_NRESTRUTGEREN"
                    },{
                        field: this.DEFINITION.nrvinculoMulti,
                        param: "P_NRVINCULOM"
                    },{
                        field: this.DEFINITION.tipohierarquia,
                        param: "P_NRTIPOHIERARQ"
                    },{
                        field: this.DEFINITION.nrestrutsupMulti,
                        param: "P_ESTRUTSUPER"
                    },{
                        field: this.DEFINITION.dtinicio,
                        label: "Data Inicial de Gozo de Férias",
                        param: "P_DATAINICIAL"
                    },{
                        field: this.DEFINITION.dtfim,
                        label: "Data Final de Gozo de Férias",
                        param: "P_DATAFINAL"
                    },{
                        field: this.DEFINITION.opcao2,
                        label: '2 Vias',
                        param: "P_2VIAS"
                    }]
                }
            }
        },
        FPA_adm: {
            label: "Relatório de Admissão",
            0: {
                abertura_cc: {
                    config: {
                        itemName: "Abertura de Conta Corrente",
                        fileName: "abertura_cc",
                        order: 0
                    },
                    params: [ {
                        field: this.DEFINITION.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    }, {
                        field: this.DEFINITION.nrvinculoMulti,
                        param: "P_VINCULO"
                    },{
                        field: this.DEFINITION.nrestrutlegal,
                        param: "P_ESTRUTLEGAL"
                    },{
                        field: this.DEFINITION.nrestrutgeren,
                        param: "P_ESTRUTGEREN"
                    },{
                        label: "Data Inicial da Admissão",
                        field: this.DEFINITION.dtinicio,
                        param: "P_INICIO"
                    },{
                        label: "Data Final da Admissão",
                        field: this.DEFINITION.dtfim,
                        param: "P_FINAL"
                    }]
                },
                etiqueta_contrato_intermitente: {
                    config: {
                        itemName: "Etiqueta Contrato Intermitente",
                        fileName: "etiqueta_contrato_intermitente",
                        order: 228
                    },
                    params: [{
                        field: this.DEFINITION.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    },{
                        field: this.DEFINITION.nrestrutlegal,
                        param: "P_NRESTRUTLEGAL"
                    },{
                        field: this.DEFINITION.nrvinculoMulti,
                        param: "P_VINCULO"
                    },{
                        field: this.DEFINITION.nrestrutgeren,
                        param: "P_ESTRUTGEREN"
                    },{
                        field: this.DEFINITION.dtinicio,
                        param: "P_DTINIADM",
                        label: "Data inicial de admissão"
                    },{
                        field: this.DEFINITION.dtfim,
                        param: "P_DTFIMADM",
                        label: "Data final de admissão"
                    }]
                },
                contrato_trabalho_regime_experiencia: {
                    config: {
                        itemName: "Contrato de Trabalho - Regime Experiência",
                        fileName: "contrato_trabalho_regime_experiencia",
                        order: 120
                    },
                    params: [ {
                        field: this.DEFINITION.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    }, {
                        field: this.DEFINITION.nrvinculoMulti,
                        param: "P_VINCULO"
                    },{
                        field: this.DEFINITION.nrestrutlegal,
                        param: "P_NRESTRUTLEGAL"
                    },{
                        field: this.DEFINITION.nrestrutgeren,
                        param: "P_NRESTRUTGEREN"
                    },{
                        field: this.DEFINITION.tipohierarquiaMulti,
                        param: "P_NRTIPOHIERARQ"
                    },{
                        field: this.DEFINITION.nrestrutsupMulti,
                        param: "P_NRESTRUTSUP"
                    },{
                        label: "Data Inicial da Admissão",
                        field: this.DEFINITION.dtinicio,
                        param: "P_DTINICIO"
                    },{
                        label: "Data Final da Admissão",
                        field: this.DEFINITION.dtfim,
                        param: "P_DTFINAL"
                    },{
                        label: "Mostrar Rodapé",
                        field: this.DEFINITION.opcao1,
                        valueField: "S",
                        param: "P_SHOWFOOTER"
                    }]
                },
                contrato_trabalho_regime_experiencia_turno: {
                    config: {
                        itemName: "Contrato de Trabalho - Regime Experiência - Turno",
                        fileName: "contrato_trabalho_regime_experiencia_turno",
                        order: 121
                    },
                    params: [ {
                        field: this.DEFINITION.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    }, {
                        field: this.DEFINITION.nrvinculoMulti,
                        param: "P_VINCULO"
                    },{
                        field: this.DEFINITION.nrestrutlegal,
                        param: "P_NRESTRUTLEGAL"
                    },{
                        field: this.DEFINITION.nrestrutgeren,
                        param: "P_NRESTRUTGEREN"
                    },{
                        field: this.DEFINITION.tipohierarquiaMulti,
                        param: "P_NRTIPOHIERARQ"
                    },{
                        field: this.DEFINITION.nrestrutsupMulti,
                        param: "P_NRESTRUTSUP"
                    },{
                        label: "Data Inicial da Admissão",
                        field: this.DEFINITION.dtinicio,
                        param: "P_DTINICIO"
                    },{
                        label: "Data Final da Admissão",
                        field: this.DEFINITION.dtfim,
                        param: "P_DTFINAL"
                    }]
                },
                contrato_trabalho_regime_experiencia_jornada: {
                    config: {
                        itemName: "Contrato de Trabalho - Regime Experiência - Jornada",
                        fileName: "contrato_trabalho_regime_experiencia_jornada",
                        order: 123
                    },
                    params: [
                        {
                            field: this.DEFINITION.competencia,
                            param: "P_COMPETENCIA",
                            required: true
                        }, {
                            field: this.DEFINITION.nrvinculoMulti,
                            param: "P_VINCULO"
                        }, {
                            field: this.DEFINITION.nrestrutlegalMulti,
                            param: "P_NRESTRUTLEGAL"
                        }, {
                            field: this.DEFINITION.nrestrutgerenMulti,
                            param: "P_NRESTRUTGEREN"
                        }, {
                            label: "Data do Documento",
                            field: this.DEFINITION.data1,
                            param: "P_DTDOCUMENTO"
                        }, {
                            label: "Data Inicial da Admissão",
                            field: this.DEFINITION.dtinicio,
                            param: "P_DTINICIO"
                        }, {
                            label: "Data Final da Admissão",
                            field: this.DEFINITION.dtfim,
                            param: "P_DTFINAL"
                        }, {
                            label: "Tipo de Jornada",
                            field: this.DEFINITION.nrtpjornada,
                            param: "P_NRTPJORNADA",
                            required: true
                        }
                    ]
                },
                contrato_trabalho_regime_experiencia_cargo_confianca: {
                    config: {
                        itemName: "Contrato de Trabalho - Regime Experiência - Cargo de Confiança",
                        fileName: "contrato_trabalho_regime_experiencia_cargo_confianca",
                        order: 124
                    },
                    params: [
                        {
                            field: this.DEFINITION.competencia,
                            param: "P_COMPETENCIA",
                            required: true
                        }, {
                            field: this.DEFINITION.nrvinculoMulti,
                            param: "P_VINCULO"
                        }, {
                            field: this.DEFINITION.nrestrutlegalMulti,
                            param: "P_NRESTRUTLEGAL"
                        }, {
                            field: this.DEFINITION.nrestrutgerenMulti,
                            param: "P_NRESTRUTGEREN"
                        }, {
                            label: "Data do Documento",
                            field: this.DEFINITION.data1,
                            param: "P_DTDOCUMENTO"
                        }, {
                            label: "Data Inicial da Admissão",
                            field: this.DEFINITION.dtinicio,
                            param: "P_DTINICIO"
                        }, {
                            label: "Data Final da Admissão",
                            field: this.DEFINITION.dtfim,
                            param: "P_DTFINAL"
                        }
                    ]
                },
                contrato_trabalho_regime_experiencia_horista: {
                    config: {
                        itemName: "Contrato de Trabalho - Regime Experiência - Horista",
                        fileName: "contrato_trabalho_regime_experiencia_horista",
                        order: 125
                    },
                    params: [
                        {
                            field: this.DEFINITION.competencia,
                            param: "P_COMPETENCIA",
                            required: true
                        }, {
                            field: this.DEFINITION.nrvinculoMulti,
                            param: "P_VINCULO"
                        }, {
                            field: this.DEFINITION.nrestrutlegalMulti,
                            param: "P_NRESTRUTLEGAL"
                        }, {
                            field: this.DEFINITION.nrestrutgerenMulti,
                            param: "P_NRESTRUTGEREN"
                        }, {
                            label: "Data do Documento",
                            field: this.DEFINITION.data1,
                            param: "P_DTDOCUMENTO"
                        }, {
                            label: "Data Inicial da Admissão",
                            field: this.DEFINITION.dtinicio,
                            param: "P_DTINICIO"
                        }, {
                            label: "Data Final da Admissão",
                            field: this.DEFINITION.dtfim,
                            param: "P_DTFINAL"
                        }
                    ]
                },
                contrato_trabalho_regime_experiencia_servico_externo: {
                    config: {
                        itemName: "Contrato de Trabalho - Regime Experiência - Serviço Externo",
                        fileName: "contrato_trabalho_regime_experiencia_servico_externo",
                        order: 126
                    },
                    params: [
                        {
                            field: this.DEFINITION.competencia,
                            param: "P_COMPETENCIA",
                            required: true
                        }, {
                            field: this.DEFINITION.nrvinculoMulti,
                            param: "P_VINCULO"
                        }, {
                            field: this.DEFINITION.nrestrutlegalMulti,
                            param: "P_NRESTRUTLEGAL"
                        }, {
                            field: this.DEFINITION.nrestrutgerenMulti,
                            param: "P_NRESTRUTGEREN"
                        }, {
                            label: "Data do Documento",
                            field: this.DEFINITION.data1,
                            param: "P_DTDOCUMENTO"
                        }, {
                            label: "Data Inicial da Admissão",
                            field: this.DEFINITION.dtinicio,
                            param: "P_DTINICIO"
                        }, {
                            label: "Data Final da Admissão",
                            field: this.DEFINITION.dtfim,
                            param: "P_DTFINAL"
                        }
                    ]
                },
                contrato_trabalho_regime_experiencia2: {
                    config: {
                        itemName: "Contrato de Trabalho - Regime Experiência - Modelo 2",
                        fileName: "contrato_trabalho_regime_experiencia2",
                        order: 127
                    },
                    params: [
                        {
                            field: this.DEFINITION.competencia,
                            param: "P_COMPETENCIA",
                            required: true
                        },
                        {
                            field: this.DEFINITION.nrvinculoMulti,
                            param: "P_VINCULO"
                        },
                        {
                            field: this.DEFINITION.nrestrutlegal,
                            param: "P_NRESTRUTLEGAL"
                        },
                        {
                            field: this.DEFINITION.nrestrutgeren,
                            param: "P_NRESTRUTGEREN"
                        },
                        {
                            label: "Data Inicial da Admissão",
                            field: this.DEFINITION.dtinicio,
                            param: "P_DTINICIO"
                        },
                        {
                            label: "Data Final da Admissão",
                            field: this.DEFINITION.dtfim,
                            param: "P_DTFINAL"
                        },
                        {
                            label: "Data do Documento",
                            field: this.DEFINITION.dtdocumento,
                            param: "P_DTDOCUMENTO"
                        }
                    ]
                },
                contrato_trabalho_obra_certa_1193: {
                    config: {
                        itemName: "Contrato de Trabalho",
                        fileName: "contrato_trabalho_obra_certa_1193",
                        order: 130
                    },
                    params: [ {
                        field: this.DEFINITION.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    }, {
                        field: this.DEFINITION.nrvinculoMulti,
                        param: "P_VINCULO"
                    },{
                        field: this.DEFINITION.nrestrutlegal,
                        param: "P_NRESTRUTLEGAL"
                    },{
                        field: this.DEFINITION.nrestrutgeren,
                        param: "P_ESTRUTGEREN"
                    },{
                        label: "Data Inicial da Admissão",
                        field: this.DEFINITION.dtinicio,
                        param: "P_DTINIADM"
                    },{
                        label: "Data Final da Admissão",
                        field: this.DEFINITION.dtfim,
                        param: "P_DTFIMADM"
                    }]
                },
                contrato_trabalho_temporario_1193: {
                    config: {
                        itemName: "Contrato de Trabalho Temporário",
                        fileName: "contrato_trabalho_temporario_1193",
                        order: 140
                    },
                    params: [ {
                        field: this.DEFINITION.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    }, {
                        field: this.DEFINITION.nrvinculoMulti,
                        param: "P_VINCULO"
                    },{
                        field: this.DEFINITION.nrestrutlegal,
                        param: "P_NRESTRUTLEGAL"
                    },{
                        field: this.DEFINITION.nrestrutgeren,
                        param: "P_ESTRUTGEREN"
                    },{
                        label: "Data Inicial da Admissão",
                        field: this.DEFINITION.dtinicio,
                        param: "P_DTINIADM"
                    },{
                        label: "Data Final da Admissão",
                        field: this.DEFINITION.dtfim,
                        param: "P_DTFIMADM"
                    }]
                },
                contrato_trabalho_12x36: {
                    config: {
                        itemName: "Contrato de Trabalho 12 x 36 - Modelo 1",
                        fileName: "contrato_trabalho_12x36",
                        order: 141
                    },
                    params: [ {
                        field: this.DEFINITION.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    }, {
                        field: this.DEFINITION.nrvinculoMulti,
                        param: "P_VINCULO"
                    }, {
                        field: this.DEFINITION.nrestrutlegalMulti,
                        param: "P_NRESTRUTLEGAL"
                    }, {
                        field: this.DEFINITION.nrestrutgerenMulti,
                        param: "P_NRESTRUTGEREN"
                    }, {
                        label: "Data do Documento",
                        field: this.DEFINITION.data1,
                        param: "P_DTDOCUMENTO"
                    }, {
                        label: "Data Inicial da Admissão",
                        field: this.DEFINITION.dtinicio,
                        param: "P_DTINICIO"
                    }, {
                        label: "Data Final da Admissão",
                        field: this.DEFINITION.dtfim,
                        param: "P_DTFINAL"
                    }]
                },
                contrato_diarista: {
                    config: {
                        itemName: "Contrato de Diarista",
                        fileName: "contrato_diarista",
                        order: 150 
                    },
                    params: [ {
                        field: this.DEFINITION.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    }, {
                        field: this.DEFINITION.nrvinculoMulti,
                        param: "P_VINCULO"
                    },{
                        field: this.DEFINITION.nrestrutlegal,
                        param: "P_ESTRUTLEGAL"
                    },{
                        field: this.DEFINITION.nrestrutgeren,
                        param: "P_ESTRUTGEREN"
                    },{
                        label: "Data Inicial da Admissão",
                        field: this.DEFINITION.dtinicio,
                        param: "P_DTINICIO"
                    },{
                        label: "Data Final da Admissão",
                        field: this.DEFINITION.dtfim,
                        param: "P_DTFINAL"
                    },{
                        label: "Data do Documento",
                        field: this.DEFINITION.data1,
                        param: "P_DTDOCUMENTO"
                    }]
                },
                controle_contrato_experiencia: {
                    config: {
                        itemName: "Controle de Contrato de Experiência",
                        fileName: "controle_contrato_experiencia",
                        order: 160
                    },
                    params: [ {
                        field: this.DEFINITION.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    }, {
                        field: this.DEFINITION.nrvinculoMulti,
                        param: "P_VINCULO"
                    },{
                        field: this.DEFINITION.nrestrutlegal,
                        param: "P_NRESTRUTLEGAL"
                    },{
                        field: this.DEFINITION.nrestrutgeren,
                        param: "P_NRESTRUTGEREN"
                    },{
                        field: this.DEFINITION.tipohierarquia,
                        param: "P_NRTIPOHIERARQ"
                    },{
                        label: "Inicio período Fim Contr. Exp. / Admissão",
                        field: this.DEFINITION.dtinicio,
                        param: "P_INICIO"
                    },{
                        label: "Fim período Fim Contr. Exp. / Admissão",
                        field: this.DEFINITION.dtfim,
                        param: "P_FINAL"
                    },{
                        label: "Usar a data de Admissão no filtro do período",
                        field: this.DEFINITION.opcao1,
                        param: "P_USARDTADMIS"
                    },{
                        field: this.DEFINITION.zebrado,
                        param: "ZEBRADO"
                    }]
                },
                prorrogacao_horas: {
                    config: {
                        itemName: "Acordo de Prorrogação de Horas",
                        fileName: "prorrogacao_horas",
                        order: 10
                    },
                    params: [ {
                        field: this.DEFINITION.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    }, {
                        field: this.DEFINITION.nrvinculoMulti,
                        param: "P_VINCULO"
                    },{
                        field: this.DEFINITION.nrestrutlegal,
                        param: "P_NRESTRUTLEGAL"
                    },{
                        field: this.DEFINITION.nrestrutgeren,
                        param: "P_ESTRUTGEREN"
                    },{
                        label: "Data Inicial da Admissão",
                        field: this.DEFINITION.dtinicio,
                        param: "P_DTINIADM"
                    },{
                        label: "Data Final da Admissão",
                        field: this.DEFINITION.dtfim,
                        param: "P_DTFIMADM"
                    },{
                        label: "Data do Documento",
                        field: this.DEFINITION.data1,
                        param: "P_DATADOCUMENTO"
                    },{
                    	label: "Mostrar Rodapé",
                    	field: this.DEFINITION.opcao1,
                    	valueField: "S",
                    	param: "P_SHOWFOOTER"
                    }]
                },
                prorrogacao_horas_turno: {
                    config: {
                        itemName: "Acordo de Prorrogação de Horas - Turno",
                        fileName: "prorrogacao_horas_turno",
                        order: 30
                    },
                    params: [ {
                        field: this.DEFINITION.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    }, {
                        field: this.DEFINITION.nrvinculoMulti,
                        param: "P_VINCULO"
                    },{
                        field: this.DEFINITION.nrestrutlegalMulti,
                        param: "P_NRESTRUTLEGAL"
                    },{
                        field: this.DEFINITION.nrestrutgerenMulti,
                        param: "P_ESTRUTGEREN"
                    },{
                        label: "Data Inicial da Admissão",
                        field: this.DEFINITION.dtinicio,
                        param: "P_DTINIADM"
                    },{
                        label: "Data Final da Admissão",
                        field: this.DEFINITION.dtfim,
                        param: "P_DTFIMADM"
                    },{
                        label: "Data do Documento",
                        field: this.DEFINITION.data1,
                        param: "P_DATADOCUMENTO"
                    },{
                    	label: "Mostrar Rodapé",
                    	field: this.DEFINITION.opcao1,
                    	valueField: "S",
                    	param: "P_SHOWFOOTER"
                    }]
                },
                acordo_horario_trabalho: {
                    config: {
                        itemName: "Acordo para Compensação e Prorrogação de Horário de Trabalho",
                        fileName: "acordo_horario_trabalho",
                        order: 40
                    },
                    params: [ {
                        field: this.DEFINITION.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    }, {
                        field: this.DEFINITION.nrvinculoMulti,
                        param: "P_VINCULO"
                    },{
                        field: this.DEFINITION.nrestrutlegalMulti,
                        param: "P_NRESTRUTLEGAL"
                    },{
                        field: this.DEFINITION.nrestrutgerenMulti,
                        param: "P_ESTRUTGEREN"
                    },{
                        label: "Data Inicial da Admissão",
                        field: this.DEFINITION.dtinicio,
                        param: "P_DTINIADM"
                    },{
                        label: "Data Final da Admissão",
                        field: this.DEFINITION.dtfim,
                        param: "P_DTFIMADM"
                    },{
                    	label: "Mostrar Rodapé",
                    	field: this.DEFINITION.opcao1,
                    	valueField: "S",
                    	param: "P_SHOWFOOTER"
                    }]
                },
                carta_adesao_assistencia_medica_1024: {
                    config: {
                        itemName: "Adesão Assistência Médica",
                        fileName: "carta_adesao_assistencia_medica_1024",
                        order: 50
                    },
                    params: [ {
                        field: this.DEFINITION.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    }, {
                        field: this.DEFINITION.nrvinculoMulti,
                        param: "P_VINCULO"
                    },{
                        field: this.DEFINITION.nrestrutlegal,
                        param: "P_NRESTRUTLEGAL"
                    },{
                        field: this.DEFINITION.nrestrutgeren,
                        param: "P_ESTRUTGEREN"
                    },{
                        label: "Data Inicial da Admissão",
                        field: this.DEFINITION.dtinicio,
                        param: "P_DTINICIO"
                    },{
                        label: "Data Final da Admissão",
                        field: this.DEFINITION.dtfim,
                        param: "P_DTFINAL"
                    },{
                        label: "Data do Documento",
                        field: this.DEFINITION.data1,
                        param: "P_DATADOCUMENTO"
                    }]
                },
                alteracao_horario: {
                    config: {
                        itemName: "Alteração de Horário",
                        fileName: "alteracao_horario",
                        order: 55
                    },
                    params: [ {
                        field: this.DEFINITION.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    },{
                        field: this.DEFINITION.nrvinculoMulti,
                        param: "P_VINCULO"
                    },{
                        field: this.DEFINITION.nrestrutlegal,
                        param: "P_ESTRUTLEGAL"
                    },{
                        field: this.DEFINITION.nrestrutgeren,
                        param: "P_ESTRUTGEREN"
                    },{
                        label: "Data do Documento",
                        field: this.DEFINITION.dtdocumento,
                        param: "P_DTDOCUMENTO"
                    },{
                        label: "Mostrar Rodapé",
                        field: this.DEFINITION.opcao1,
                        valueField: "S",
                        param: "P_SHOWFOOTER"
                    }]
                },
                autorizacao_uso_imagem: {
                    config: {
                        itemName: "Autorização de Uso de Imagem",
                        fileName: "autorizacao_uso_imagem",
                        order: 60
                    },
                    params: [ {
                        field: this.DEFINITION.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    }, {
                        field: this.DEFINITION.nrvinculoMulti,
                        param: "P_VINCULO"
                    },{
                        field: this.DEFINITION.nrestrutlegal,
                        param: "P_ESTRUTLEGAL"
                    },{
                        field: this.DEFINITION.nrestrutgeren,
                        param: "P_ESTRUTGEREN"
                    },{
                        label: "Data Inicial da Admissão",
                        field: this.DEFINITION.dtinicio,
                        param: "P_DTINICIO"
                    },{
                        label: "Data Final da Admissão",
                        field: this.DEFINITION.dtfim,
                        param: "P_DTFINAL"
                    },{
                        label: "Data do Documento",
                        field: this.DEFINITION.data1,
                        param: "P_DTDOCUMENTO"
                    }]
                },
                autorizacao_desconto_folha: {
                    config: {
                        itemName: "Autorização para Descontos em Folha de Pagamento",
                        fileName: "autorizacao_desconto_folha",
                        order: 70
                    },
                    params: [ {
                        field: this.DEFINITION.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    }, {
                        field: this.DEFINITION.nrvinculoMulti,
                        param: "P_VINCULO"
                    },{
                        field: this.DEFINITION.nrestrutlegal,
                        param: "P_NRESTRUTLEGAL"
                    },{
                        field: this.DEFINITION.nrestrutgeren,
                        param: "P_NRESTRUTGEREN"
                    },{
                        label: "Data Inicial da Admissão",
                        field: this.DEFINITION.dtinicio,
                        param: "P_DTINICIO"
                    },{
                        label: "Data Final da Admissão",
                        field: this.DEFINITION.dtfim,
                        param: "P_DTFINAL"
                    }]
                },
                autorizacao_desconto_folha2: {
                    config: {
                        itemName: "Autorização para Descontos em Folha de Pagamento - Modelo 2",
                        fileName: "autorizacao_desconto_folha2",
                        order: 71
                    },
                    params: [ {
                        field: this.DEFINITION.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    },{
                        field: this.DEFINITION.nrvinculoMulti,
                        param: "P_VINCULO"
                    },{
                        field: this.DEFINITION.nrestrutlegal,
                        param: "P_NRESTRUTLEGAL"
                    },{
                        field: this.DEFINITION.nrestrutgeren,
                        param: "P_NRESTRUTGEREN"
                    },{
                        label: "Data Inicial da Admissão",
                        field: this.DEFINITION.dtinicio,
                        param: "P_DTINICIO"
                    },{
                        label: "Data Final da Admissão",
                        field: this.DEFINITION.dtfim,
                        param: "P_DTFINAL"
                    },{
                        label: "Data do Documento",
                        field: this.DEFINITION.data1,
                        param: "P_DTDOCUMENTO"
                    }]
                },
                cartao_ponto: {
                    config: {
                        itemName: "Cartão Ponto",
                        fileName: "cartao_ponto",
                        order: 80
                    },
                    params: [ {
                        field: this.DEFINITION.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    }, {
                        field: this.DEFINITION.nrvinculoMulti,
                        param: "P_VINCULO"
                    },{
                        field: this.DEFINITION.nrestrutlegal,
                        param: "P_ESTRUTLEGAL"
                    },{
                        field: this.DEFINITION.nrestrutgeren,
                        param: "P_ESTRUTGEREN"
                    }]
                },
                cartao_ponto_2: {
                    config: {
                        itemName: "Cartão Ponto – Modelo 2",
                        fileName: "cartao_ponto_2",
                        order: 81
                    },
                    params: [ {
                        field: this.DEFINITION.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    }, {
                        field: this.DEFINITION.nrvinculoMulti,
                        param: "P_VINCULO"
                    },{
                        field: this.DEFINITION.nrestrutlegal,
                        param: "P_ESTRUTLEGAL"
                    },{
                        field: this.DEFINITION.nrestrutgeren,
                        param: "P_ESTRUTGEREN"
                    },{
                        field: this.DEFINITION.tipohierarquiaMulti,
                        param: "P_NRTIPOHIERARQ"
                    },{
                        field: this.DEFINITION.nrestrutsupMulti,
                        param: "P_NRESTRUTSUP"
                    },{
                        field: this.DEFINITION.number1,
                        param: "P_DTINIAPURACAO",
                        label: "Dia no inicio do período"
                    },{
                        field: this.DEFINITION.pessoa1,
                        param: "P_PESSOARESP",
                        label: "Supervisor"
                    }]
                },
                cartao_ponto_3: {
                    config: {
                        itemName: "Cartão Ponto – Modelo 3",
                        fileName: "cartao_ponto_3",
                        order: 82,
                        sendEmail: true
                    },
                    params: [ {
                        field: this.DEFINITION.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    }, {
                        field: this.DEFINITION.nrvinculoMulti,
                        param: "P_VINCULO"
                    }, {
                        field: this.DEFINITION.nrestrutlegalMulti,
                        param: "P_ESTRUTLEGAL"
                    }, {
                        field: this.DEFINITION.nrestrutgerenMulti,
                        param: "P_ESTRUTGEREN"
                    }, {
                        field: this.DEFINITION.nrperiodoapuracao,
                        param: "P_NRPERIODOAPURACAO",
                        required: true
                    }, {
                        field: this.DEFINITION.tpvinculo,
                        param: "P_TPVINCULO",
                        required: true
                    } ]
                },
                comprovante_devolucao_ctps_ps: {
                    config: {
                        itemName: "Comprovante de Devolução da Carteira do Trabalho e Previdência Social",
                        fileName: "comprovante_devolucao_ctps_ps",
                        order: 90
                    },
                    params: [ {
                        field: this.DEFINITION.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    }, {
                        field: this.DEFINITION.nrvinculoMulti,
                        param: "P_VINCULO"
                    },{
                        field: this.DEFINITION.nrestrutlegal,
                        param: "P_NRESTRUTLEGAL"
                    },{
                        field: this.DEFINITION.nrestrutgeren,
                        param: "P_ESTRUTGEREN"
                    },{
                        label: "Data Inicial da Admissão",
                        field: this.DEFINITION.dtinicio,
                        param: "P_DTINIADM"
                    },{
                        label: "Data Final da Admissão",
                        field: this.DEFINITION.dtfim,
                        param: "P_DTFIMADM"
                    },{
                        label: "Data do Documento",
                        field: this.DEFINITION.data1,
                        param: "P_DTDOCUMENTO"
                    }]
                },
                esocial_cqc: {
                    config: {
                        itemName: "Consulta Qualificação Cadastral - ESocial",
                        fileName: "esocial_cqc",
                        order: 100,
                        download: {
                            fileName: "esocial_cqc",
                            format: "txt"
                         }
                    },
                    params: [ {
                        field: this.DEFINITION.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    }, {
                        field: this.DEFINITION.nrvinculoMulti,
                        param: "P_NRVINCULO"
                    },{
                        field: this.DEFINITION.nrestrutlegal,
                        param: "P_NRESTRUTLEGAL"
                    },{
                        field: this.DEFINITION.nrestrutgeren,
                        param: "P_NRESTRUTGEREN"
                    },{
                        field: this.DEFINITION.nrestrutsind,
                        param: "P_NRESTRUTSIND"
                    },{
                        label: "Data Inicial da Admissão",
                        field: this.DEFINITION.dtinicio,
                        param: "P_DTINICIO"
                    },{
                        label: "Data Final da Admissão",
                        field: this.DEFINITION.dtfim,
                        param: "P_DTFINAL"
                    }]
                },
                contrato_emprego_intermitente: {
                    config: {
                        itemName: "Contrato de Emprego Intermitente",
                        fileName: "contrato_emprego_intermitente",
                        order: 105
                    },
                    params: [ {
                        field: this.DEFINITION.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    }, {
                        label: "Vínculo",
                        field: this.DEFINITION.nrvinculoMulti,
                        param: "P_VINCULO"
                    },{
                        field: this.DEFINITION.nrestrutlegal,
                        param: "P_ESTRUTLEGAL"
                    },
                    {
                        field: this.DEFINITION.nrestrutgeren,
                        param: "P_ESTRUTGEREN"
                    },
                    {
                        label: "Dia de pagamento",
                        field: this.DEFINITION.number1,
                        param: "P_DIAPAGAMENTO"
                    }]
                },
                contrato_emprego_intermitente2: {
                    config: {
                        itemName: "Contrato de Emprego Intermitente - Modelo 2",
                        fileName: "contrato_emprego_intermitente2",
                        order: 106
                    },
                    params: [ {
                        field: this.DEFINITION.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    }, {
                        field: this.DEFINITION.nrvinculoMulti,
                        param: "P_VINCULO"
                    }, {
                        field: this.DEFINITION.nrestrutlegalMulti,
                        param: "P_NRESTRUTLEGAL"
                    }, {
                        field: this.DEFINITION.nrestrutgerenMulti,
                        param: "P_NRESTRUTGEREN"
                    }, {
                        label: "Data do Documento",
                        field: this.DEFINITION.data1,
                        param: "P_DTDOCUMENTO"
                    }, {
                        label: "Data Inicial da Admissão",
                        field: this.DEFINITION.dtinicio,
                        param: "P_DTINICIO"
                    }, {
                        label: "Data Final da Admissão",
                        field: this.DEFINITION.dtfim,
                        param: "P_DTFINAL"
                    }, {
                        label: "Titular",
                        field: this.DEFINITION.pessoa1,
                        param: "P_PESSOARESP"
                    }]
                },
                contrato_veiculo_1024: {
                    config: {
                        itemName: "Contrato de Locação de Veículo",
                        fileName: "contrato_veiculo_1024",
                        order: 110
                    },
                    params: [ {
                        field: this.DEFINITION.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    }, {
                        label: "Locatária",
                        field: this.DEFINITION.pessoa1,
                        required: true,
                        param: "P_PESSOA"
                    },{
                        field: this.DEFINITION.nrestrutlegal,
                        required: true,
                        param: "P_ESTRUTLEGAL"
                    },{
                        label: "Data do Contrato de Locação",
                        field: this.DEFINITION.dtinicio,
                        param: "P_DATADOCUMENTO"
                    }]
                },
                contrato_verde_amarelo: {	 
                    config: {	 
                        itemName: "Contrato de Trabalho Verde e Amarelo",	 
                        fileName: "contrato_verde_amarelo",	 
                        order: 113	 
                    },	 
                    params: [{	 
                        field: this.DEFINITION.competencia,	 
                        param: "P_COMPETENCIA",	 
                        required: true	 
                    },{	 
                        field: this.DEFINITION.nrvinculoMulti,	 
                        param: "P_VINCULO"	 
                    },{	 
                        field: this.DEFINITION.nrestrutlegal,	 
                        param: "P_ESTRUTLEGAL"	 
                    },{	 
                        field: this.DEFINITION.nrestrutgeren,	 
                        param: "P_ESTRUTGEREN"	 
                    },{	 
                        label: "Data Inicial da Admissão",	 
                        field: this.DEFINITION.dtinicio,	 
                        param: "P_INICIO"	 
                    },{	 
                        label: "Data Final da Admissão",	 
                        field: this.DEFINITION.dtfim,	 
                        param: "P_FINAL"	 
                    },{	 
                        label: "Data do Documento",	 
                        field: this.DEFINITION.dtdocumento,	 
                        param: "P_DTDOCUMENTO"	 
                    },{	 
                        label: "Mostrar Rodapé",	 
                        field: this.DEFINITION.opcao1,	 
                        valueField: "S",	 
                        param: "P_SHOWFOOTER"	 
                    },	 
                    {	 
                        label: "Meses de Contrato",	 
                        field: this.DEFINITION.number1,	 
                        param: "P_MESESCONTRATO"	 
                    }]	 
                },
                controle_entrega_epi_1024: {
                    config: {
                        itemName: "Controle de Entrega de EPI",
                        fileName: "controle_entrega_epi_1024",
                        order: 170
                    },
                    params: [ {
                        field: this.DEFINITION.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    }, {
                        field: this.DEFINITION.nrvinculoMulti,
                        param: "P_VINCULO"
                    },{
                        field: this.DEFINITION.nrestrutlegal,
                        param: "P_ESTRUTLEGAL"
                    },{
                        field: this.DEFINITION.nrestrutgeren,
                        param: "P_ESTRUTGEREN"
                    },{
                        label: "Data Inicial da Admissão",
                        field: this.DEFINITION.dtinicio,
                        param: "P_DTINICIO"
                    },{
                        label: "Data Final da Admissão",
                        field: this.DEFINITION.dtfim,
                        param: "P_DTFINAL"
                    },{
                        field: this.DEFINITION.tipohierarquiaMulti,
                        param: "P_NRTIPOHIERARQ"
                    },{
                        field: this.DEFINITION.nrestrutsupMulti,
                        param: "P_NRESTRUTSUP"
                    }]
                },
                declaracao_recebimento_vale_transporte: {
                    config: {
                        itemName: "Declaração / Recebimento de Vale Transporte",
                        fileName: "declaracao_recebimento_vale_transporte",
                        order: 180
                    },
                    params: [ {
                        field: this.DEFINITION.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    }, {
                        field: this.DEFINITION.nrvinculoMulti,
                        param: "P_VINCULO"
                    },{
                        field: this.DEFINITION.nrestrutlegal,
                        param: "P_ESTRUTLEGAL"
                    },{
                        field: this.DEFINITION.nrestrutgeren,
                        param: "P_ESTRUTGEREN"
                    },{
                        label: "Data Inicial da Admissão",
                        field: this.DEFINITION.dtinicio,
                        param: "P_INICIO"
                    },{
                        label: "Data Final da Admissão",
                        field: this.DEFINITION.dtfim,
                        param: "P_FINAL"
                    },{
                        field: this.DEFINITION.zebrado,
                        param: "ZEBRADO"
                    }]
                },
                declaracao_trabalho: {
                    config: {
                        itemName: "Declaração de Trabalho",
                        fileName: "declaracao_trabalho",
                        order: 185
                    },
                    params: [{
                        field: this.DEFINITION.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    },{
                        field: this.DEFINITION.nrvinculoMulti,
                        param: "P_VINCULO"
                    },{
                        field: this.DEFINITION.nrestrutlegal,
                        param: "P_ESTRUTLEGAL"
                    },{
                        field: this.DEFINITION.nrestrutgeren,
                        param: "P_ESTRUTGEREN"
                    },{
                        label: "Data do Documento",
                        field: this.DEFINITION.dtdocumento,
                        param: "P_DTDOCUMENTO"
                    },{
                        label: "Mostrar Rodapé",
                        field: this.DEFINITION.opcao1,
                        valueField: "S",
                        param: "P_SHOWFOOTER"
                    }]
                },
                declaracao_encargos_familia_imposto_de_renda: {
                    config: {
                        itemName: "Declaração de Encargos de Família para Fins de Imposto de Renda",
                        fileName: "declaracao_encargos_familia_imposto_de_renda",
                        order: 190
                    },
                    params: [ {
                        field: this.DEFINITION.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    }, {
                        field: this.DEFINITION.nrvinculoMulti,
                        param: "P_VINCULO"
                    },{
                        field: this.DEFINITION.nrestrutlegal,
                        param: "P_NRESTRUTURA"
                    },{
                        field: this.DEFINITION.nrestrutgeren,
                        param: "P_NRESTRUTGEREN"
                    },{
                        label: "Data Inicial da Admissão",
                        field: this.DEFINITION.dtinicio,
                        param: "P_DTINICIO"
                    },{
                        label: "Data Final da Admissão",
                        field: this.DEFINITION.dtfim,
                        param: "P_DTFINAL"
                    },{  
                        field: this.DEFINITION.zebrado,	 
                        param: "ZEBRADO"	 
                    },{	 
                        label: "Mostrar Rodapé",	 
                        field: this.DEFINITION.opcao1,
                        valueField: "N",	 
                        param: "P_SHOWFOOTER"
                     }]
                },
                declaracao_vale_alimentacao: {
                    config: {
                        itemName: "Declaração de Vale Alimentação / Refeição",
                        fileName: "declaracao_vale_alimentacao",
                        order: 200
                    },
                    params: [ {
                        field: this.DEFINITION.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    }, {
                        field: this.DEFINITION.nrvinculoMulti,
                        param: "P_VINCULO"
                    },{
                        field: this.DEFINITION.nrestrutlegal,
                        param: "P_ESTRUTLEGAL"
                    },{
                        field: this.DEFINITION.nrestrutgeren,
                        param: "P_ESTRUTGEREN"
                    },{
                        label: "Data Inicial da Admissão",
                        field: this.DEFINITION.dtinicio,
                        param: "P_INICIO"
                    },{
                        label: "Data Final da Admissão",
                        field: this.DEFINITION.dtfim,
                        param: "P_FINAL"
                    },{
                        label: "Refeição servida na/pela empresa",
                        field: this.DEFINITION.opcao1,
                        param: "P_OPCREFEICAO"
                    }]
                },
                declaracao_vale_transporte: {
                    config: {
                        itemName: "Declaração e Termo de Compromisso - Opção pelo Vale Transporte",
                        fileName: "declaracao_vale_transporte",
                        order: 210
                    },
                    params: [ {
                        field: this.DEFINITION.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    }, {
                        field: this.DEFINITION.nrvinculoMulti,
                        param: "P_VINCULO"
                    },{
                        field: this.DEFINITION.nrestrutlegal,
                        param: "P_NRESTRUTURA"
                    },{
                        field: this.DEFINITION.nrestrutgeren,
                        param: "P_NRESTRUTGEREN"
                    },{
                        label: "Data Inicial da Admissão",
                        field: this.DEFINITION.dtinicio,
                        param: "P_DTINICIO"
                    },{
                        label: "Data Final da Admissão",
                        field: this.DEFINITION.dtfim,
                        param: "P_DTFINAL"
                    },{
                        label: "Data Declaração (vazio para data admissão)",
                        field: this.DEFINITION.data1,
                        param: "P_DTDOCUMENTO"
                    },{
                        label: "Desativar auto preenchimento das linhas",
                        field: this.DEFINITION.opcao1,
                        param: "P_DESATIVAAUTO"
                    },{	 
                        label: "Mostrar Rodapé",	 
                        field: this.DEFINITION.opcao2,	 
                        valueField: "N",	 
                        param: "P_SHOWFOOTER"	 
                    }  ]
                },
                declaracao_docs_compliance: {
                    config: {
                        itemName: "Declaração de conhecimento docs compliance",
                        fileName: "declaracao_docs_compliance",
                        order: 211
                    },
                    params: [
                        {
                            field: this.DEFINITION.competencia,
                            param: "P_COMPETENCIA",
                            required: true
                        },
                        {
                            field: this.DEFINITION.nrvinculoMulti,
                            param: "P_VINCULO"
                        },
                        {
                            field: this.DEFINITION.nrestrutlegal,
                            param: "P_NRESTRUTLEGAL"
                        },
                        {
                            field: this.DEFINITION.nrestrutgeren,
                            param: "P_NRESTRUTGEREN"
                        },
                        {
                            label: "Data Inicial da Admissão",
                            field: this.DEFINITION.dtinicio,
                            param: "P_DTINICIO"
                        },
                        {
                            label: "Data Final da Admissão",
                            field: this.DEFINITION.dtfim,
                            param: "P_DTFINAL"
                        },
                        {
                            label: "Data do Documento",
                            field: this.DEFINITION.dtdocumento,
                            param: "P_DTDOCUMENTO"
                        }
                    ]
                },
                desconto_contribuicao_sindical: {
                    config: {
                        itemName: "Desconto Contribuição Sindical",
                        fileName: "desconto_contribuicao_sindical",
                        order: 220
                    },
                    params: [ {
                        field: this.DEFINITION.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    }, {
                        field: this.DEFINITION.nrvinculoMulti,
                        param: "P_VINCULO"
                    },{
                        field: this.DEFINITION.nrestrutlegal,
                        param: "P_ESTRUTLEGAL"
                    },{
                        field: this.DEFINITION.nrestrutgeren,
                        param: "P_ESTRUTGEREN"
                    },{
                        label: "Data do Documento",
                        field: this.DEFINITION.data1,
                        param: "P_DTDOCUMENTO"
                    }]
                },
                etiqueta: {
                    config: {
                        itemName: "Etiqueta CTPS - modelo 1",
                        fileName: "etiqueta",
                        order: 230
                    },
                    params: [ {
                        field: this.DEFINITION.competencia,
                        param: "P_DTMESCOMPETENC",
                        required: true
                    }, {
                        field: this.DEFINITION.nrvinculoMulti,
                        param: "P_NRVINCULO"
                    },{
                        field: this.DEFINITION.nrestrutlegal,
                        param: "P_NRESTRUTLEGAL"
                    },{
                        field: this.DEFINITION.nrestrutgeren,
                        param: "P_ESTRUTGEREN"
                    },{
                        label: "Data Inicial da Admissão",
                        field: this.DEFINITION.dtinicio,
                        param: "P_DTINIADM"
                    },{
                        label: "Data Final da Admissão",
                        field: this.DEFINITION.dtfim,
                        param: "P_DTFIMADM"
                    }]
                },
                etiqueta2: {
                    config: {
                        itemName: "Etiqueta CTPS - modelo 2",
                        fileName: "etiqueta2",
                        order: 240
                    },
                    params: [ {
                        field: this.DEFINITION.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    }, {
                        field: this.DEFINITION.nrvinculoMulti,
                        param: "P_VINCULO"
                    },{
                        field: this.DEFINITION.nrestrutlegal,
                        param: "P_NRESTRUTLEGAL"
                    },{
                        field: this.DEFINITION.nrestrutgeren,
                        param: "P_ESTRUTGEREN"
                    },{
                        label: "Data Inicial da Admissão",
                        field: this.DEFINITION.dtinicio,
                        param: "P_DTINIADM"
                    },{
                        label: "Data Final da Admissão",
                        field: this.DEFINITION.dtfim,
                        param: "P_DTFIMADM"
                    }]
                },
                etiqueta3: {
                    config: {
                        itemName: "Etiqueta CTPS - modelo 3",
                        fileName: "etiqueta3",
                        order: 250
                    },
                    params: [ {
                        field: this.DEFINITION.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    }, {
                        field: this.DEFINITION.nrvinculoMulti,
                        param: "P_NRVINCULO"
                    },{
                        field: this.DEFINITION.nrestrutlegal,
                        param: "P_NRESTRUTLEGAL"
                    },{
                        field: this.DEFINITION.nrestrutgeren,
                        param: "P_ESTRUTGEREN"
                    },{
                        label: "Data Inicial da Admissão",
                        field: this.DEFINITION.dtinicio,
                        param: "P_DTINIADM"
                    },{
                        label: "Data Final da Admissão",
                        field: this.DEFINITION.dtfim,
                        param: "P_DTFIMADM"
                    }]
                },
                etiqueta4: {
                    config: {
                        itemName: "Etiqueta CTPS - modelo 4",
                        fileName: "etiqueta4",
                        order: 260
                    },
                    params: [ {
                        field: this.DEFINITION.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    }, {
                        field: this.DEFINITION.nrvinculoMulti,
                        param: "P_NRVINCULO"
                    },{
                        field: this.DEFINITION.nrestrutlegal,
                        param: "P_NRESTRUTLEGAL"
                    },{
                        field: this.DEFINITION.nrestrutgeren,
                        param: "P_ESTRUTGEREN"
                    },{
                        label: "Data Inicial da Admissão",
                        field: this.DEFINITION.dtinicio,
                        param: "P_DTINIADM"
                    },{
                        label: "Data Final da Admissão",
                        field: this.DEFINITION.dtfim,
                        param: "P_DTFIMADM"
                    }]
                },
                etiqueta6095: {
                    config: {
                        itemName: "Etiqueta CTPS - modelo 5 (PIMACO 6095 / LINK 8007)",
                        fileName: "etiqueta6095",
                        order: 270
                    },
                    params: [ {
                        field: this.DEFINITION.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    }, {
                        field: this.DEFINITION.nrvinculoMulti,
                        param: "P_VINCULO"
                    },{
                        field: this.DEFINITION.nrestrutlegal,
                        param: "P_NRESTRUTLEGAL"
                    },{
                        field: this.DEFINITION.nrestrutgeren,
                        param: "P_ESTRUTGEREN"
                    },{
                        label: "Data Inicial da Admissão",
                        field: this.DEFINITION.dtinicio,
                        param: "P_DTINIADM"
                    },{
                        label: "Data Final da Admissão",
                        field: this.DEFINITION.dtfim,
                        param: "P_DTFIMADM"
                    }]
                },
                etiqueta6095_6: {
                    config: {
                        itemName: "Etiqueta CTPS - modelo 6 (PIMACO 6095 / LINK 8007)",
                        fileName: "etiqueta6095_6",
                        order: 272
                    },
                    params: [ {
                        field: this.DEFINITION.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    }, {
                        field: this.DEFINITION.nrvinculoMulti,
                        param: "P_VINCULO"
                    },{
                        field: this.DEFINITION.nrestrutlegal,
                        param: "P_NRESTRUTLEGAL"
                    },{
                        field: this.DEFINITION.nrestrutgeren,
                        param: "P_ESTRUTGEREN"
                    },{
                        label: "Data Inicial da Admissão",
                        field: this.DEFINITION.dtinicio,
                        param: "P_DTINIADM"
                    },{
                        label: "Data Final da Admissão",
                        field: this.DEFINITION.dtfim,
                        param: "P_DTFIMADM"
                    }
                    ]
                },
                etiqueta_tranferencia6095: {
                    config: {
                        itemName: "Etiqueta de Transferência (PIMACO 6095 / LINK 8007)",
                        fileName: "etiqueta_tranferencia6095",
                        order: 273
                    },
                    params: [ 
                    {
                        field: this.DEFINITION.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    }, {
                        field: this.DEFINITION.nrvinculoMulti,
                        param: "P_VINCULO"
                    },{
                        field: this.DEFINITION.nrestrutlegal,
                        param: "P_NRESTRUTLEGAL"
                    },{
                        field: this.DEFINITION.nrestrutgeren,
                        param: "P_ESTRUTGEREN"
                    }
                  ]
                },
                etiqueta_contrato_exp: {
                    config: {
                        itemName: "Etiqueta Contrato Experiência - modelo 1",
                        fileName: "etiqueta_contrato_exp",
                        order: 275
                    },
                    params: [ {
                        field: this.DEFINITION.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    }, {
                        field: this.DEFINITION.nrvinculoMulti,
                        param: "P_VINCULO"
                    },{
                        field: this.DEFINITION.nrestrutlegal,
                        param: "P_NRESTRUTLEGAL"
                    },{
                        field: this.DEFINITION.nrestrutgeren,
                        param: "P_ESTRUTGEREN"
                    }]
                },
                etiqueta_ass_contrato_exp_6080: {
                    config: {
                        itemName: "Etiqueta de Assinatura de Contrato de Experiência (PIMACO 6080 / LINK 8018)",
                        fileName: "etiqueta_ass_contrato_exp_6080",
                        order: 280
                    },
                    params: [ {
                        field: this.DEFINITION.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    }, {
                        field: this.DEFINITION.nrvinculoMulti,
                        param: "P_VINCULO"
                    },{
                        field: this.DEFINITION.nrestrutlegal,
                        param: "P_NRESTRUTLEGAL"
                    },{
                        field: this.DEFINITION.nrestrutgeren,
                        param: "P_ESTRUTGEREN"
                    }]
                },
                etiqueta_cartao_ponto: {
                    config: {
                        itemName: "Etiqueta para Ponto Cartográfico",
                        fileName: "etiqueta_cartao_ponto",
                        order: 282
                    },
                    params: [ {
                        field: this.DEFINITION.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    }, {
                        field: this.DEFINITION.nrvinculoMulti,
                        param: "P_VINCULO"
                    },{
                        field: this.DEFINITION.nrestrutlegalMulti,
                        param: "P_ESTRUTLEGAL"
                    },{
                        field: this.DEFINITION.nrestrutgerenMulti,
                        param: "P_ESTRUTGEREN"
                    },{
                        label: "Dia inicial da apuração",
                        field: this.DEFINITION.number1,
                        param: "P_DIAS"
                    }]
                },
                etiqueta_cartao_ponto4360: {
                    config: {
                        itemName: "Etiqueta para Ponto Cartográfico (PIMACO A4360 / LINK 9011)",
                        fileName: "etiqueta_cartao_ponto4360",
                        order: 283
                    },
                    params: [ {
                        field: this.DEFINITION.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    }, {
                        field: this.DEFINITION.nrvinculoMulti,
                        param: "P_VINCULO"
                    },{
                        field: this.DEFINITION.nrestrutlegalMulti,
                        param: "P_ESTRUTLEGAL"
                    },{
                        field: this.DEFINITION.nrestrutgerenMulti,
                        param: "P_ESTRUTGEREN"
                    },{
                        label: "Dia inicial da apuração",
                        field: this.DEFINITION.number1,
                        param: "P_DIAS"
                    }]
                },
                etiqueta_fgts: {
                    config: {
                        itemName: "Etiqueta FGTS - modelo 1",
                        fileName: "etiqueta_fgts",
                        order: 284
                    },
                    params: [ {
                        field: this.DEFINITION.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    }, {
                        field: this.DEFINITION.nrvinculoMulti,
                        param: "P_VINCULO"
                    },{
                        field: this.DEFINITION.nrestrutlegal,
                        param: "P_NRESTRUTLEGAL"
                    },{
                        field: this.DEFINITION.nrestrutgeren,
                        param: "P_ESTRUTGEREN"
                    }]
                },
                etiqueta_ultimo_dia_trabalho_6080: {
                    config: {
                        itemName: "Etiqueta Último dia Trabalhado (PIMACO 6080 / LINK 8018)",
                        fileName: "etiqueta_ultimo_dia_trabalho_6080",
                        order: 285
                    },
                    params: [ {
                        field: this.DEFINITION.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    }, {
                        field: this.DEFINITION.nrvinculoRescMulti,
                        param: "P_VINCULO"
                    },{
                        field: this.DEFINITION.nrestrutlegal,
                        param: "P_NRESTRUTLEGAL"
                    },{
                        field: this.DEFINITION.nrestrutgeren,
                        param: "P_ESTRUTGEREN"
                    }]
                },
                registro_empregado: {
                    config: {
                        itemName: "Ficha de Registro do Empregado",
                        fileName: "registro_empregado",
                        order: 290
                    },
                    params: [ {
                        field: this.DEFINITION.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    }, {
                        field: this.DEFINITION.nrvinculoMulti,
                        param: "P_VINCULO"
                    },{
                        field: this.DEFINITION.nrestrutlegal,
                        param: "P_NRESTRUTURA"
                    },{
                        field: this.DEFINITION.nrestrutgeren,
                        param: "P_ESTRUTGEREN"
                    },{
                        field: this.DEFINITION.nrestrutsind,
                        param: "P_ESTRUTSIND"
                    },{
                        field: this.DEFINITION.tipohierarquiaMulti,
                        param: "P_NRTIPOHIERARQ"
                    },{
                        field: this.DEFINITION.nrestrutsupMulti,
                        param: "P_NRESTRUTSUP"
                    },{
                        label: "Data Inicial da Admissão",
                        field: this.DEFINITION.dtinicio,
                        param: "P_DTINICIO"
                    },{
                        label: "Data Final da Admissão",
                        field: this.DEFINITION.dtfim,
                        param: "P_DTFINAL"
                    },{
                        label: "Mostrar Informações Adicionais",
                        field: this.DEFINITION.opcao1,
                        param: "P_MOSTRARINFO",
                        valueField: "S"
                    },{
                        label: "Incluir Vínculos Demitidos",
                        field: this.DEFINITION.opcao2,
                        param: "P_INCLUIRDEMITIDO"
                    },{
                        field: this.DEFINITION.zebrado,
                        param: "ZEBRADO"
                    }]
                },
                registro_empregado_turno: {
                    config: {
                        itemName: "Ficha de Registro do Empregado - Turno",
                        fileName: "registro_empregado_turno",
                        order: 291
                    },
                    params: [ {
                        field: this.DEFINITION.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    }, {
                        field: this.DEFINITION.nrvinculoMulti,
                        param: "P_VINCULO"
                    },{
                        field: this.DEFINITION.nrestrutlegal,
                        param: "P_NRESTRUTURA"
                    },{
                        field: this.DEFINITION.nrestrutgeren,
                        param: "P_ESTRUTGEREN"
                    },{
                        field: this.DEFINITION.nrestrutsind,
                        param: "P_ESTRUTSIND"
                    },{
                        label: "Data Inicial da Admissão",
                        field: this.DEFINITION.dtinicio,
                        param: "P_DTINICIO"
                    },{
                        label: "Data Final da Admissão",
                        field: this.DEFINITION.dtfim,
                        param: "P_DTFINAL"
                    },{
                        label: "Mostrar Informações Adicionais",
                        field: this.DEFINITION.opcao1,
                        param: "P_MOSTRARINFO",
                        valueField: "S"
                    },{
                        label: "Incluir Vínculos Demitidos",
                        field: this.DEFINITION.opcao2,
                        param: "P_INCLUIRDEMITIDO"
                    },{
                        field: this.DEFINITION.zebrado,
                        param: "ZEBRADO"
                    }]
                },
                ficha_epi: {
                    config: {
                        itemName: "Ficha Individual de Controle de EPI",
                        fileName: "ficha_epi",
                        order: 292
                    },
                    params: [ {
                        field: this.DEFINITION.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    }, {
                        field: this.DEFINITION.nrvinculoMulti,
                        param: "P_VINCULO"
                    },{
                        field: this.DEFINITION.nrestrutlegal,
                        param: "P_ESTRUTLEGAL"
                    },{
                        field: this.DEFINITION.nrestrutgeren,
                        param: "P_ESTRUTGEREN"
                    },{
                        label: "Data Inicial da Admissão",
                        field: this.DEFINITION.dtinicio,
                        param: "P_INICIO"
                    },{
                        label: "Data Final da Admissão",
                        field: this.DEFINITION.dtfim,
                        param: "P_FINAL"
                    },{
                        label: "Mostrar Rodapé",
                        field: this.DEFINITION.opcao1,
                        param: "P_MOSTRARINFO",
                        valueField: "S"
                    },{
                        label: "Data do documento",
                        field: this.DEFINITION.data1,
                        param: "P_DTDOCUMENTO"
                    },{
                        field: this.DEFINITION.tipohierarquia,
                        param: "P_NRTIPOHIERARQ"
                    },{
                        field: this.DEFINITION.nrestrutsupMulti,
                        param: "P_NRESTRUTSUP"
                    } ]
                },
                ficha_salario_familia: {
                    config: {
                        itemName: "Ficha de Salário Família",
                        fileName: "ficha_salario_familia",
                        order: 300
                    },
                    params: [ {
                        field: this.DEFINITION.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    }, {
                        field: this.DEFINITION.nrvinculoMulti,
                        param: "P_VINCULO"
                    },{
                        field: this.DEFINITION.nrestrutlegal,
                        param: "P_ESTRUTLEGAL"
                    },{
                        field: this.DEFINITION.nrestrutgeren,
                        param: "P_ESTRUTGEREN"
                    },{
                        label: "Data Inicial da Admissão",
                        field: this.DEFINITION.dtinicio,
                        param: "P_DTINICIO"
                    },{
                        label: "Data Final da Admissão",
                        field: this.DEFINITION.dtfim,
                        param: "P_DTFINAL"
                    }]
                },
                folha_ponto: {
                    config: {
                        itemName: "Folha de Ponto",
                        fileName: "folha_ponto",
                        order: 310
                    },
                    params: [ {
                        field: this.DEFINITION.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    }, {
                        field: this.DEFINITION.nrvinculoMulti,
                        param: "P_NRVINCULOM"
                    },{
                        field: this.DEFINITION.nrestrutlegal,
                        param: "P_NRESTRUTURA"
                    },{
                        field: this.DEFINITION.nrestrutgeren,
                        param: "P_NRESTRUTGEREN"
                    },{
                        label: "Emitir com Detalhamento de Intervalo",
                        field: this.DEFINITION.opcao1,
                        param: "P_IDCOLUNAINTER"
                    }]
                },
                guia_medico_liffe_1024: {
                    config: {
                        itemName: "Guia de Encaminhamento",
                        fileName: "guia_medico_liffe_1024",
                        order: 315
                    },
                    params: [ {
                        field: this.DEFINITION.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    }, {
                        field: this.DEFINITION.nrvinculoMulti,
                        param: "P_VINCULO"
                    },{
                        field: this.DEFINITION.nrestrutlegal,
                        param: "P_ESTRUTLEGAL"
                    },{
                        field: this.DEFINITION.nrestrutgeren,
                        param: "P_ESTRUTGEREN"
                    },{
                        label: "Data Inicial da Admissão",
                        field: this.DEFINITION.dtinicio,
                        param: "P_DTINICIO"
                    },{
                        label: "Data Final da Admissão",
                        field: this.DEFINITION.dtfim,
                        param: "P_DTFINAL"
                    }]
                },
                ppp: {
                    config: {
                        itemName: "PPP - Perfil Profissiográfico Previdênciário",
                        fileName: "ppp",
                        order: 320
                    },
                    params: [ {
                        field: this.DEFINITION.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    }, {
                        field: this.DEFINITION.nrvinculoMulti,
                        param: "P_VINCULO"
                    },{
                        field: this.DEFINITION.nrestrutlegal,
                        param: "P_ESTRUTLEGAL"
                    },{
                        field: this.DEFINITION.nrestrutgeren,
                        param: "P_ESTRUTGEREN"
                    },{
                        label: "Data Inicial da Admissão",
                        field: this.DEFINITION.dtinicio,
                        param: "P_DTINICIO"
                    },{
                        label: "Data Final da Admissão",
                        field: this.DEFINITION.dtfim,
                        param: "P_DTFINAL"
                    },{
                        label: "Responsável pelos Registros Ambientais",
                        field: this.DEFINITION.pessoa3,
                        required: true,
                        param: "P_PESSOAAMB"
                    },{
                        label: "Responsável pela Monitoração Biológica",
                        field: this.DEFINITION.pessoa4,
                        required: true,
                        param: "P_PESSOABIO"
                    }]
                },
                questionario_qualidade_vida: {
                    config: {
                        itemName: "Questionário Qualidade de Vida do Trabalho",
                        fileName: "questionario_qualidade_vida",
                        order: 325
                    },
                    params: [ {
                        field: this.DEFINITION.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    },{
                        field: this.DEFINITION.nrvinculoMulti,
                        param: "P_VINCULO"
                    },{
                        field: this.DEFINITION.nrestrutlegal,
                        param: "P_NRESTRUTLEGAL"
                    },{
                        field: this.DEFINITION.nrestrutgeren,
                        param: "P_NRESTRUTGEREN"
                    },{
                        label: "Data Inicial da Admissão",
                        field: this.DEFINITION.dtinicio,
                        param: "P_DTINICIO"
                    },{
                        label: "Data Final da Admissão",
                        field: this.DEFINITION.dtfim,
                        param: "P_DTFINAL"
                    }]
                },
                recibo_cartao_saude: {
                    config: {
                        itemName: "Recibo de Entrega do Cartão do Plano de saude",
                        fileName: "recibo_cartao",
                        order: 333
                    },
                    params: [ {
                        field: this.DEFINITION.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    }, {
                        field: this.DEFINITION.nrvinculoMulti,
                        param: "P_VINCULO"
                    },{
                        field: this.DEFINITION.nrestrutlegal,
                        param: "P_ESTRUTLEGAL"
                    },{
                        field: this.DEFINITION.nrestrutgeren,
                        param: "P_ESTRUTGEREN"
                    },
                    {
                        field: this.DEFINITION.nrbeneficio,
                        param: "P_NRBENEFICIO"
                    },
                    {
                        row: "P_TPLANO",
                        param: "P_TPLANO",
                        value: "de saude"
                    },
                    {
                        label: "Data do Documento",
                        field: this.DEFINITION.dtdocumento,
                        param: "P_DTDOCUMENTO"
                    },{
                        label: "Mostrar Rodapé",
                        field: this.DEFINITION.opcao1,
                        valueField: "S",
                        param: "P_SHOWFOOTER"}
                    ]
                },
                recibo_cartao_odonto: {
                    config: {
                        itemName: "Recibo de Entrega do Cartão do Plano Odonto",
                        fileName: "recibo_cartao",
                        order: 334
                    },
                    params: [ {
                        field: this.DEFINITION.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    }, {
                        field: this.DEFINITION.nrvinculoMulti,
                        param: "P_VINCULO"
                    },{
                        field: this.DEFINITION.nrestrutlegal,
                        param: "P_ESTRUTLEGAL"
                    },{
                        field: this.DEFINITION.nrestrutgeren,
                        param: "P_ESTRUTGEREN"
                    },
                    {
                        field: this.DEFINITION.nrbeneficio,
                        param: "P_NRBENEFICIO"
                    },
                    {
                        row: "P_TPLANO",
                        param: "P_TPLANO",
                        value: "Odonto"
                    },
                    {
                        label: "Data do Documento",
                        field: this.DEFINITION.dtdocumento,
                        param: "P_DTDOCUMENTO"
                    },{
                        label: "Mostrar Rodapé",
                        field: this.DEFINITION.opcao1,
                        valueField: "S",
                        param: "P_SHOWFOOTER"}
                    ]
                },
                recibo_epi: {
                    config: {
                        itemName: "Recibo de Entrega de EPI/Uniformes",
                        fileName: "recibo_epi",
                        order: 330
                    },
                    params: [ {
                        field: this.DEFINITION.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    }, {
                        field: this.DEFINITION.nrvinculoMulti,
                        param: "P_VINCULO"
                    },{
                        field: this.DEFINITION.nrestrutlegal,
                        param: "P_ESTRUTLEGAL"
                    },{
                        field: this.DEFINITION.nrestrutgeren,
                        param: "P_ESTRUTGEREN"
                    },{
                        label: "Data Inicial da Admissão",
                        field: this.DEFINITION.dtinicio,
                        param: "P_DTINICIO"
                    },{
                        label: "Data Final da Admissão",
                        field: this.DEFINITION.dtfim,
                        param: "P_DTFINAL"
                    },{
                        label: "Data do Documento",
                        field: this.DEFINITION.data1,
                        param: "P_DATADOCUMENTO"
                    }]
                },
                entrega_cracha: {
                    config: {
                        itemName: "Recibo de Entrega de Crachá",
                        fileName: "entrega_cracha",
                        order: 335
                    },
                    params: [{
                        field: this.DEFINITION.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    },{
                        field: this.DEFINITION.nrvinculoMulti,
                        param: "P_VINCULO"
                    },{
                        field: this.DEFINITION.nrestrutlegalMulti,
                        param: "P_ESTRUTLEGAL"
                    },{
                        field: this.DEFINITION.nrestrutgerenMulti,
                        param: "P_ESTRUTGEREN"
                    },{
                        label: "Data do Documento",
                        field: this.DEFINITION.dtdocumento,
                        param: "P_DTDOCUMENTO"
                    },{
                        label: "Mostrar Rodapé",
                        field: this.DEFINITION.opcao1,
                        valueField: "S",
                        param: "P_SHOWFOOTER"
                    }]
                },
                requisicao_BEM: {
                    config: {
                        itemName: "Requerimento do Benefício Emergencial (B.E.M)",
                        fileName: "requisicao_BEM",
                        notShow: false, //Campo opcional. Estão aqui para exemplo. TODO implementar estas alterações.
                        format: "pdf", //Campo opcional. Estão aqui para exemplo. TODO implementar estas alterações.
                        download: { //Campo opcional.
                            fileName: "requisicao_BEM", //Requerido
                            format: "txt", //Requerido
                            extension: 'csv', //Campo opcional. Usa esta extensão no arquivo gerado. Se não informada usará a extensão do 'format'.
                            strFind: "@", //Campo opcional. String que será substituída pela strinf 'strReplace'
                            strReplace: "\r" ////Campo opcional.
                        },
                        order: 337
                    },
                    params: [ {
                        field: this.DEFINITION.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    }, {
                        field: this.DEFINITION.nrvinculoMulti,
                        param: "P_NRVINCULO"
                    }, {
                        field: this.DEFINITION.nrestrutlegalMulti,
                        param: "P_ESTRUTLEGAL"
                    },{
                        field: this.DEFINITION.nrestrutgerenMulti,
                        param: "P_ESTRUTGEREN"
                    },{
                        field: this.DEFINITION.dtinicio,
                        param: "P_DTINICIO",
                        label: "Data de início da situação funcional"
                    }, {
                        field: this.DEFINITION.dtfim,
                        param: "P_DTFINAL",
                        label: "Data de fim da situação funcional"
                    }, {
                        field: this.DEFINITION.opcao1,
                        param: "P_TPADESAO",
                        label: "Tipo de Adesão",
                        valueField: "",
                        dataList: [ {
                            name: "Suspensão do contrato",
                            value: "0"
                        }, {
                            name: "Redução da carga horária",
                            value: "1"
                        } ],
                        required: true
                    }, {
                        field: this.DEFINITION.data1,
                        label: "Data Acordo",
                        param: "P_DTACORDO",
                        required: true
                    }, {
                        field: this.DEFINITION.opcao2,
                        param: "P_PERREDU",
                        label: "Percentual Reducao Carga Horaria",
                        valueField: "",
                        dataList: [ {
                            name: " ",
                            value: ""
                        }, {
                            name: "25%",
                            value: "25"
                        }, {
                            name: "50%",
                            value: "50"
                        }, {
                            name: "70%",
                            value: "70"
                        }  ]
                    }, {
                        label: "Dias de duração do acordo",
                        field: this.DEFINITION.number1,
                        param: "P_NRMESES",
                        required: true
                    }, {
                        field: this.DEFINITION.situacaoFunc,
                        param: "P_NRSITUFUNCM",
                        required: true
                    }
                    ]
                },
                opcoes_BEM: {
                    config: {
                        itemName: "Opções do Benefício Emergencial (B.E.M)",
                        fileName: "opcoes_BEM",
                        notShow: false, //Campo opcional. Estão aqui para exemplo. TODO implementar estas alterações.
                        format: "pdf", //Campo opcional. Estão aqui para exemplo. TODO implementar estas alterações.
                        download: { //Campo opcional.
                            fileName: "opcoes_BEM", //Requerido
                            format: "txt", //Requerido
                            extension: 'csv', //Campo opcional. Usa esta extensão no arquivo gerado. Se não informada usará a extensão do 'format'.
                            strFind: "@", //Campo opcional. String que será substituída pela strinf 'strReplace'
                            strReplace: "\r" ////Campo opcional.
                        },
                        order: 338
                    },
                    params: [ {
                        field: this.DEFINITION.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    }, {
                        field: this.DEFINITION.nrvinculoMulti,
                        param: "P_NRVINCULO"
                    }, {
                        field: this.DEFINITION.nrestrutlegalMulti,
                        param: "P_ESTRUTLEGAL"
                    },{
                        field: this.DEFINITION.nrestrutgerenMulti,
                        param: "P_ESTRUTGEREN"
                    }, {
                        field: this.DEFINITION.situacaoFunc,
                        param: "P_NRSITUFUNCM",
                        required: true
                    }, {
                        field: this.DEFINITION.dtinicio,
                        param: "P_DTINICIO",
                        label: "Data de início da situação funcional"
                    }, {
                        field: this.DEFINITION.dtfim,
                        param: "P_DTFINAL",
                        label: "Data de fim da situação funcional"
                    }, {
                        field: this.DEFINITION.opcao9,
                        param: "P_OPCAO",
                        label: "Opção",
                        valueField: "",
                        dataList: [ {
                            name: "Cancelamento",
                            value: "C"
                        }, {
                            name: "Redução",
                            value: "R"
                        }, {
                            name: "Prorrogação",
                            value: "P"
                        } ],
                        required: true
                    }, {
                        field: this.DEFINITION.data1,
                        label: "Data Acordo",
                        param: "P_DTACORDO",
                        required: true
                    }, {
                        field: this.DEFINITION.data2,
                        label: "Data Antecipação",
                        param: "P_DTANTEC",
                        required: false
                    }, {
                        label: "Dias Prorrogação",
                        field: this.DEFINITION.number1,
                        param: "P_DIAPROR",
                        required: false
                    }
                    ]
                },
                resumo_cartao_ponto: {
                    config: {
                        itemName: "Resumo Mensal de Cartão de Ponto",
                        fileName: "resumo_cartao_ponto",
                        order: 340
                    },
                    params: [ {
                        field: this.DEFINITION.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    }, {
                        field: this.DEFINITION.nrvinculo,
                        param: "P_VINCULO"
                    },{
                        field: this.DEFINITION.nrestrutlegal,
                        param: "P_ESTRUTLEGAL"
                    },{
                        field: this.DEFINITION.nrestrutgeren,
                        param: "P_ESTRUTGEREN"
                    },{
                        label: "Nome da Hierarquia",
                        required: true,
                        field: this.DEFINITION.tipohierarquia,
                        param: "P_NRTIPOHIERARQ"
                    }]
                },
                termo_ciencia: {
                    config: {
                        itemName: "Termo de Ciência - Atestado Médico",
                        fileName: "termo_ciencia",
                        order: 350
                    },
                    params: [ {
                        field: this.DEFINITION.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    }, {
                        field: this.DEFINITION.nrvinculoMulti,
                        param: "P_VINCULO"
                    },{
                        field: this.DEFINITION.nrestrutlegal,
                        param: "P_ESTRUTLEGAL"
                    },{
                        field: this.DEFINITION.nrestrutgeren,
                        param: "P_ESTRUTGEREN"
                    },{
                        label: "Data Inicial da Admissão",
                        field: this.DEFINITION.dtinicio,
                        param: "P_DTINIADM"
                    },{
                        label: "Data Final da Admissão",
                        field: this.DEFINITION.dtfim,
                        param: "P_DTFIMADM"
                    },{
                        label: "Responsável Técnico de Enfermagem do Trabalho",
                        field: this.DEFINITION.pessoa1,
                        required: true,
                        param: "P_RESPONSAVEL"
                    },{
                        label: "Lim. de dias de At. para Avaliação Méd.",
                        field: this.DEFINITION.number1,
                        param: "P_DIAS"
                    }]
                },
                termo_responsabilidade: {
                    config: {
                        itemName: "Termo de Responsabilidade",
                        fileName: "termo_responsabilidade",
                        order: 353
                    },
                    params: [ {
                        field: this.DEFINITION.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    }, {
                        field: this.DEFINITION.nrvinculoMulti,
                        param: "P_VINCULO"
                    },{
                        field: this.DEFINITION.nrestrutlegal,
                        param: "P_ESTRUTLEGAL"
                    },{
                        field: this.DEFINITION.nrestrutgeren,
                        param: "P_ESTRUTGEREN"
                    },{
                        label: "Data do Documento",
                        field: this.DEFINITION.dtdocumento,
                        param: "P_DTDOCUMENTO"
                    },{
                        label: "Mostrar Rodapé",
                        field: this.DEFINITION.opcao1,
                        valueField: "S",
                        param: "P_SHOWFOOTER"}
                    ]
                },
                transferencia_empregado: {
                    config: {
                        itemName: "Transferência de Empregado",
                        fileName: "transferencia_empregado",
                        order: 355
                    },
                    params: [{
                        field: this.DEFINITION.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    },{
                        field: this.DEFINITION.nrvinculoMulti,
                        param: "P_VINCULO"
                    },{
                        field: this.DEFINITION.nrestrutlegal,
                        param: "P_ESTRUTLEGAL"
                    },{
                        field: this.DEFINITION.nrestrutgeren,
                        param: "P_ESTRUTGEREN"
                    },{
                        label: "Data do Documento",
                        field: this.DEFINITION.dtdocumento,
                        param: "P_DTDOCUMENTO"
                    },{
                        label: "Mostrar Rodapé",
                        field: this.DEFINITION.opcao1,
                        valueField: "S",
                        param: "P_SHOWFOOTER"
                    }]
                },
                termo_assistencia_medica: {
                    config: {
                        itemName: "Termo de Ciência Plano de Saúde Empresarial",
                        fileName: "termo_assistencia_medica",
                        order: 358
                    },
                    params: [{
                        field: this.DEFINITION.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    },{
                        field: this.DEFINITION.nrvinculoMulti,
                        param: "P_VINCULO"
                    },{
                        field: this.DEFINITION.nrestrutlegalMulti,
                        param: "P_ESTRUTLEGAL"
                    },{
                        field: this.DEFINITION.nrestrutgerenMulti,
                        param: "P_ESTRUTGEREN"
                    },{
                        label: "Data do Documento",
                        field: this.DEFINITION.dtdocumento,
                        param: "P_DTDOCUMENTO"
                    },{
                        label: "Mostrar Rodapé",
                        field: this.DEFINITION.opcao1,
                        valueField: "S",
                        param: "P_SHOWFOOTER"
                    }]
                },
                abertura_cc_ciencia: {
                    config: {
                        itemName: "Termo de Ciência de Abertura de Conta Corrente",
                        fileName: "abertura_cc_ciencia",
                        order: 360
                    },
                    params: [ {
                        field: this.DEFINITION.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    }, {
                        field: this.DEFINITION.nrvinculoMulti,
                        param: "P_VINCULO"
                    },{
                        field: this.DEFINITION.nrestrutlegal,
                        param: "P_ESTRUTLEGAL"
                    },{
                        field: this.DEFINITION.nrestrutgeren,
                        param: "P_ESTRUTGEREN"
                    },{
                        label: "Data Inicial da Admissão",
                        field: this.DEFINITION.dtinicio,
                        param: "P_DTINICIO"
                    },{
                        label: "Data Final da Admissão",
                        field: this.DEFINITION.dtfim,
                        param: "P_DTFINAL"
                    },{
                        label: "Banco",
                        field: this.DEFINITION.cdbanco,
                        required: true,
                        param: "P_BANCO"
                    }]
                },
                termo_confidencialidade: {
                    config: {
                        itemName: "Termo de Sigilo e Confidencialidade",
                        fileName: "termo_confidencialidade",
                        order: 362
                    },
                    params: [{
                        field: this.DEFINITION.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    },{
                        field: this.DEFINITION.nrvinculoMulti,
                        param: "P_VINCULO"
                    },{
                        field: this.DEFINITION.nrestrutlegal,
                        param: "P_ESTRUTLEGAL"
                    },{
                        field: this.DEFINITION.nrestrutgeren,
                        param: "P_ESTRUTGEREN"
                    },{
                        label: "Data Inicial da Admissão",
                        field: this.DEFINITION.dtinicio,
                        param: "P_INICIO"
                    },{
                        label: "Data Final da Admissão",
                        field: this.DEFINITION.dtfim,
                        param: "P_FINAL"
                    },{
                        label: "Data do Documento",
                        field: this.DEFINITION.dtdocumento,
                        param: "P_DTDOCUMENTO"
                    },{
                        label: "Mostrar Rodapé",
                        field: this.DEFINITION.opcao1,
                        valueField: "S",
                        param: "P_SHOWFOOTER"
                    }]
                },
                termo_prorrogacao: {
                    config: {
                        itemName: "Termo de Prorrogação de Contrato de Trabalho",
                        fileName: "termo_prorrogacao",
                        order: 370
                    },
                    params: [ {
                        field: this.DEFINITION.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    },{
                        field: this.DEFINITION.nrestrutlegalMulti,
                        param: "P_NRESTRUTLEGAL"
                    },{
                        field: this.DEFINITION.nrestrutgerenMulti,
                        param: "P_ESTRUTGEREN"
                    },{
                        field: this.DEFINITION.nrvinculoMulti,
                        param: "P_VINCULO"
                    }]
                }
            },
            1019:{
                contrato_trabalho_regime_experiencia: {
                    config: {
                        itemName: "Contrato de Trabalho - Regime Experiência",
                        fileName: "contrato_trabalho_regime_experiencia_1019",
                        order: 120
                    },
                    params: [ {
                        field: this.DEFINITION.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    }, {
                        field: this.DEFINITION.nrvinculoMulti,
                        param: "P_VINCULO"
                    },{
                        field: this.DEFINITION.nrestrutlegal,
                        param: "P_NRESTRUTLEGAL"
                    },{
                        field: this.DEFINITION.nrestrutgeren,
                        param: "P_NRESTRUTGEREN"
                    },{
                        field: this.DEFINITION.tipohierarquiaMulti,
                        param: "P_NRTIPOHIERARQ"
                    },{
                        field: this.DEFINITION.nrestrutsupMulti,
                        param: "P_NRESTRUTSUP"
                    },{
                        label: "Data Inicial da Admissão",
                        field: this.DEFINITION.dtinicio,
                        param: "P_DTINICIO"
                    },{
                        label: "Data Final da Admissão",
                        field: this.DEFINITION.dtfim,
                        param: "P_DTFINAL"
                    },{
                        label: "Mostrar Rodapé",
                        field: this.DEFINITION.opcao1,
                        valueField: "S",
                        param: "P_SHOWFOOTER"
                    }]
                }
            },
            1193: {
                etiqueta_contrato_obcerta_1193: {
                    config: {
                        itemName: "Etiqueta Contrato Obra Certa",
                        fileName: "etiqueta_contrato_obcerta_1193",
                        order: 226
                    },
                    params: [{
                        field: this.DEFINITION.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    },{
                        field: this.DEFINITION.nrestrutlegal,
                        param: "P_NRESTRUTLEGAL"
                    },{
                        field: this.DEFINITION.nrvinculoMulti,
                        param: "P_VINCULO"
                    },{
                        field: this.DEFINITION.nrestrutgeren,
                        param: "P_ESTRUTGEREN"
                    },{
                        field: this.DEFINITION.dtinicio,
                        param: "P_DTINIADM",
                        label: "Data inicial de admissão"
                    },{
                        field: this.DEFINITION.dtfim,
                        param: "P_DTFIMADM",
                        label: "Data final de admissão"
                    }]
                },
                etiqueta_contrato_temp_1193: {
                    config: {
                        itemName: "Etiqueta Contrato Temporario",
                        fileName: "etiqueta_contrato_temp_1193",
                        order: 229
                    },
                    params: [{
                        field: this.DEFINITION.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    },{
                        field: this.DEFINITION.nrestrutlegal,
                        param: "P_NRESTRUTLEGAL"
                    },{
                        field: this.DEFINITION.nrvinculoMulti,
                        param: "P_VINCULO"
                    },{
                        field: this.DEFINITION.nrestrutgeren,
                        param: "P_ESTRUTGEREN"
                    },{
                        field: this.DEFINITION.dtinicio,
                        param: "P_DTINIADM",
                        label: "Data inicial de admissão"
                    },{
                        field: this.DEFINITION.dtfim,
                        param: "P_DTFIMADM",
                        label: "Data final de admissão"
                    }]
                }
            },
            2025: {
                contrato_trabalho_regime_experiencia_2025: {
                    config: {
                        itemName: "Contrato de Trabalho a Título de Experiência (Giraffas)",
                        fileName: "contrato_trabalho_regime_experiencia_2025",
                        order: 121
                    },
                    params: [ {
                        field: this.DEFINITION.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    }, {
                        field: this.DEFINITION.nrvinculoMulti,
                        param: "P_VINCULO"
                    },{
                        field: this.DEFINITION.nrestrutlegal,
                        param: "P_NRESTRUTLEGAL"
                    },{
                        field: this.DEFINITION.nrestrutgeren,
                        param: "P_NRESTRUTGEREN"
                    },{
                        label: "Data Inicial da Admissão",
                        field: this.DEFINITION.dtinicio,
                        param: "P_INICIO"
                    },{
                        label: "Data Final da Admissão",
                        field: this.DEFINITION.dtfim,
                        param: "P_FINAL"
                    },{
                        label: "Data do Documento",
                        field: this.DEFINITION.dtdocumento,
                        param: "P_DTDOCUMENTO"
                    },{
                        label: "Mostrar Rodapé",
                        field: this.DEFINITION.opcao1,
                        valueField: "S",
                        param: "P_SHOWFOOTER"
                    }]
                }},
            2973: {
                contrato_trabalho_regime_experiencia_90_2973: {
                    config: {
                        itemName: "Contrato de Trabalho - Regime Experiência - 90hs",
                        fileName: "contrato_trabalho_regime_experiencia_90_2973",
                        order: 127
                    },
                    params: [
                        {
                            field: this.DEFINITION.competencia,
                            param: "P_COMPETENCIA",
                            required: true
                        }, {
                            field: this.DEFINITION.nrvinculoMulti,
                            param: "P_VINCULO"
                        }, {
                            field: this.DEFINITION.nrestrutlegalMulti,
                            param: "P_NRESTRUTLEGAL"
                        }, {
                            field: this.DEFINITION.nrestrutgerenMulti,
                            param: "P_NRESTRUTGEREN"
                        }, {
                            label: "Data do Documento",
                            field: this.DEFINITION.data1,
                            param: "P_DTDOCUMENTO"
                        }, {
                            label: "Data Inicial da Admissão",
                            field: this.DEFINITION.dtinicio,
                            param: "P_DTINICIO"
                        }, {
                            label: "Data Final da Admissão",
                            field: this.DEFINITION.dtfim,
                            param: "P_DTFINAL"
                        }
                    ]
                }
            }
        },
        FPA_ger: {
            label: "Relatórios Gerenciais - Geral",
            0: {
                resumo_inss: {
                    config: {
                        itemName: "Resumo de Contabilização de INSS",
                        fileName: "resumo_inss",
                        order: 10
                    },
                    params: [
                        {
                            field: this.DEFINITION.competencia,
                            param: "P_COMPETENCIA",
                            required: true
                        },
                        {
                            field: this.DEFINITION.tipomovimento1,
                            param: "P_NRTPMOVIMENT",
                            required: true,
                            descriptionField: "Mensal", valueField: "1"
                        },
                        {
                            field: this.DEFINITION.grpincidencia,
                            param: "P_GRUPO",
                            required: true
                        }
                    ]
                },
                alteracao_funcional: {
                    config: {
                        itemName: "Alteração Funcional",
                        fileName: "alteracao_funcional",
                        order: 20
                    },
                    params: [
                        {
                            field: this.DEFINITION.competencia,
                            param: "P_COMPETENCIA",
                            required: true
                        },
                        {
                            field: this.DEFINITION.nrvinculoMulti,
                            param: "P_VINCULO"
                        },
                        {
                            field: this.DEFINITION.nrestrutlegal,
                            param: "P_ESTRUTLEGAL"
                        },
                        {
                            field: this.DEFINITION.nrestrutgeren,
                            param: "P_ESTRUTGEREN"
                        },
                        {    
                            field: this.DEFINITION.competencia,
                            param: "P_COMPETENCIA",
                            required: true
                        },
                        {
                            field: this.DEFINITION.nrvinculoMulti,
                            param: "P_VINCULO"
                        },
                        {
                            field: this.DEFINITION.data1,
                            label: "Início da Vigência da Associação",
                            param: "P_INIVIGENCIA"
                        },
                        {
                            field: this.DEFINITION.data2,
                            label: "Fim da Vigência da Associação",
                            param: "P_FIMVIGENCIA"
                        },	 
                        {	 
                            field: this.DEFINITION.zebrado,	 
                            param: "ZEBRADO"	 
                        }
                    ]
                },
                etiqueta_contrato_reggeral_1193: {
                    config: {
                        itemName: "Etiqueta Contrato Registro Geral",
                        fileName: "etiqueta_contrato_reggeral_1193",
                        order: 227
                    },
                    params: [{
                        field: this.DEFINITION.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    },{
                        field: this.DEFINITION.nrestrutlegal,
                        param: "P_NRESTRUTLEGAL"
                    },{
                        field: this.DEFINITION.nrvinculoMulti,
                        param: "P_VINCULO"
                    },{
                        field: this.DEFINITION.nrestrutgeren,
                        param: "P_ESTRUTGEREN"
                    },{
                        field: this.DEFINITION.dtinicio,
                        param: "P_DTINIADM",
                        label: "Data inicial de admissão"
                    },{
                        field: this.DEFINITION.dtfim,
                        param: "P_DTFIMADM",
                        label: "Data final de admissão"
                    }]
                },
                etiqueta_contrato_diarista_1193: {
                    config: {
                        itemName: "Etiqueta Contrato Diarista",
                        fileName: "etiqueta_contrato_diarista_1193",
                        order: 225
                    },
                    params: [{
                        field: this.DEFINITION.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    },{
                        field: this.DEFINITION.nrestrutlegal,
                        param: "P_NRESTRUTLEGAL"
                    },{
                        field: this.DEFINITION.nrvinculoMulti,
                        param: "P_VINCULO"
                    },{
                        field: this.DEFINITION.nrestrutgeren,
                        param: "P_ESTRUTGEREN"
                    },{
                        field: this.DEFINITION.dtinicio,
                        param: "P_DTINIADM",
                        label: "Data inicial de admissão"
                    },{
                        field: this.DEFINITION.dtfim,
                        param: "P_DTFIMADM",
                        label: "Data final de admissão"
                    }]
                },
                relacao_eventos_estrutura_e_vinculo: {
                    config: {
                        itemName: "Eventos Associaos às Estruturas e Vínculos",
                        fileName: "relacao_eventos_estrutura_e_vinculo",
                        order: 50
                    },
                    params: [
                        {
                            field: this.DEFINITION.competencia,
                            param: "P_COMPETENCIA",
                            required: true
                        },
                        {
                            field: this.DEFINITION.nrvinculoMulti,
                            param: "P_VINCULO"
                        },
                        {
                            field: this.DEFINITION.nrestrutlegal,
                            param: "P_ESTRUTLEGAL"
                        },
                        {
                            field: this.DEFINITION.nrestrutgeren,
                            param: "P_ESTRUTGEREN"
                        },
                        {
                            label: "Incluir Vínculos Demitidos",
                            field: this.DEFINITION.opcao1,
                            param: "P_INCLUIRDEMITIDO"
                        },
                        {
                            field: this.DEFINITION.zebrado,
                            param: "ZEBRADO"
                        }
                    ]
                },
                evento_zerado_por_vinculo: {
                    config: {
                        itemName: "Eventos Zerados ou Negativos por Vínculo",
                        fileName: "evento_zerado_por_vinculo",
                        order: 60
                    },
                    params: [
                        {
                            field: this.DEFINITION.competencia,
                            param: "P_COMPETENCIA",
                            required: true
                        },
                        {
                            field: this.DEFINITION.nrvinculoMulti,
                            param: "P_VINCULO"
                        },
                        {
                            field: this.DEFINITION.nrestrutlegal,
                            param: "P_ESTRUTLEGAL"
                        },
                        {
                            field: this.DEFINITION.nrestrutgeren,
                            param: "P_ESTRUTGEREN"
                        },
                        {
                            field: this.DEFINITION.tipomovimento1,
                            param: "P_NRTPMOVIMENT",
                            required: true,
                            descriptionField: "Mensal", valueField: "1"
                        },
                        {
                            field: this.DEFINITION.evento,
                            param: "P_NREVENTO",
                            label: "Evento"
                        },
                        {
                            label: "Incluir Vínculos Demitidos",
                            field: this.DEFINITION.opcao1,
                            param: "P_INCLUIRDEMITIDO"
                        },
                        {
                            field: this.DEFINITION.zebrado,
                            param: "ZEBRADO"
                        }
                    ]
                },
                assoc_estrutura_evento: {
                    config: {
                        itemName: "Associação de Estruturas e Eventos",
                        fileName: "assoc_estrutura_evento",
                        order: 70
                    },
                    params: [
                        {
                            field: this.DEFINITION.competencia,
                            param: "P_COMPETENCIA",
                            required: true
                        },
                        {
                            field: this.DEFINITION.nrvinculo,
                            param: "P_VINCULO"
                        },
                        {
                            field: this.DEFINITION.data1,
                            label: "Início da Vigência da Associação",
                            param: "P_INIVIGENCIA"
                        },
                        {
                            field: this.DEFINITION.data2,
                            label: "Fim da Vigência da Associação",
                            param: "P_FIMVIGENCIA"
                        }
                    ]
                },
                estruturas_tipo_hierarquia: {
                    config: {
                        itemName: "Estruturas por Tipo de Hierarquia",
                        fileName: "estruturas_tipo_hierarquia",
                        order: 80
                    },
                    params: [
                        {
                            field: this.DEFINITION.competencia,
                            param: "P_COMPETENCIA",
                            required: true
                        },
                        {
                            field: this.DEFINITION.tpestrut,
                            param: "P_TIPOESTRUTURA",
                            required: true
                        },
                        {
                            field: this.DEFINITION.zebrado,
                            param: "ZEBRADO"
                        }
                    ]
                },
                tomadores: {
                    config: {
                        itemName: "Alteração Funcional - Tomador",
                        fileName: "tomadores",
                        order: 90
                    },
                    params: [
                        {
                            field: this.DEFINITION.competencia,
                            param: "P_COMPETENCIA",
                            required: true
                        },
                        {
                            field: this.DEFINITION.nrvinculoMulti,
                            param: "P_VINCULO"
                        },
                        {
                            field: this.DEFINITION.nrestrutlegal,
                            param: "P_ESTRUTLEGAL"
                        },
                        {
                            field: this.DEFINITION.nrestrutgeren,
                            param: "P_ESTRUTGEREN"
                        },
                        {
                            label: "Tipo de Estrutura do Tomador",
                            field: this.DEFINITION.tipohierarquia,
                            param: "P_NRTPTOMADOR"
                        },
                        {
                            label: "Incluir Vínculos Demitidos",
                            field: this.DEFINITION.opcao1,
                            param: "P_INCLUIRDEMITIDO"
                        },
                        {
                            label: "Omitir Vínculos",
                            field: this.DEFINITION.opcao2,
                            param: "P_OMITIRVINCULOS"
                        },
                        {
                            field: this.DEFINITION.zebrado,
                            param: "ZEBRADO"
                        }
                    ]
                },
                turn_over: {
                    config: {
                        itemName: "Turn Over",
                        fileName: "turn_over",
                        order: 100
                    },
                    params: [
                        {
                            field: this.DEFINITION.competencia,
                            param: "P_DTMESCOMPETENC",
                            required: true
                        },
                        {
                            field: this.DEFINITION.zebrado,
                            param: "ZEBRADO"
                        }
                    ]
                }
            }   
        },
        FPA_ger_vinc: {
            label: "Relatórios Gerenciais - Vínculo",
            0: {
                rateio_funcionarios_grade: {
                    config: {
                        itemName: "Rateio de Funcionários por Estruturas",
                        fileName: "rateio_funcionarios_grade",
                        order: 10
                    },
                    params: [
                        {
                            field: this.DEFINITION.competencia,
                            param: "P_COMPETENCIA",
                            required: true
                        },
                        {
                            field: this.DEFINITION.nrvinculoMulti,
                            param: "P_VINCULO"
                        },
                        {
                            field: this.DEFINITION.nrestrutlegal,
                            param: "P_ESTRUTLEGAL"
                        },
                        {
                            field: this.DEFINITION.nrestrutgeren,
                            param: "P_ESTRUTGEREN"
                        },
                        {
                            label: "Tipo de Estrutura",
                            field: this.DEFINITION.tipohierarquia,
                            param: "P_TIPOESTRUTURA",
                            required: true
                        },
                        {
                            field: this.DEFINITION.tipomovimento1,
                            param: "P_NRTPMOVIMENT",
                            required: true,
                            descriptionField: "Mensal", valueField: "1"
                        },
                        {
                            field: this.DEFINITION.grpincidencia,
                            param: "P_GRUPOINCIDE",
                            required: true
                        },
                        {
                            field: this.DEFINITION.data1,
                            label: "Data de Inicio - Admissão",
                            param: "P_INICIO",
                            required: true
                        },
                        {
                            field: this.DEFINITION.data2,
                            label: "Data de Fim - Admissão",
                            param: "P_FINAL",
                            required: true
                        }
                    ]
                },
                alteracao_salarial: {
                    config: {
                        itemName: "Histórico de Alterações Salariais",
                        fileName: "alteracao_salarial",
                        order: 20
                    },
                    params: [
                        {
                            field: this.DEFINITION.competencia,
                            param: "P_COMPETENCIA",
                            required: true
                        },
                        {
                            field: this.DEFINITION.nrvinculoMulti,
                            param: "P_VINCULO"
                        },
                        {
                            field: this.DEFINITION.nrestrutlegal,
                            param: "P_ESTRUTLEGAL"
                        },
                        {
                            field: this.DEFINITION.nrestrutgeren,
                            param: "P_ESTRUTGEREN"
                        },
                        
                        {
                            field: this.DEFINITION.data1,
                            label: "Inicio da Alteração Salarial",
                            param: "P_INICIO"
                        },
                        {
                            field: this.DEFINITION.data2,
                            label: "Fim da Alteração Salarial",
                            param: "P_FINAL"
                        },
                        {
                            label: "Incluir Vínculos Demitidos",
                            field: this.DEFINITION.opcao1,
                            param: "P_INCLUIRDEMITIDO"
                        },
                        {
                            field: this.DEFINITION.zebrado,
                            param: "ZEBRADO"
                        }
                    ]
                },
                funcionarios_admitidos_periodo: {
                    config: {
                        itemName: "Funcionários Admitidos",
                        fileName: "funcionarios_admitidos_periodo",
                        order: 30
                    },
                    params: [
                        {
                            field: this.DEFINITION.competencia,
                            param: "P_DTMESCOMPETENC",
                            required: true
                        },
                        {
                            field: this.DEFINITION.nrestrutlegal,
                            param: "P_NRESTRUTURA"
                        },
                        {
                            field: this.DEFINITION.nrestrutgeren,
                            param: "P_NRESTRUTURAGEREN"
                        },
                        
                        {
                            field: this.DEFINITION.data1,
                            label: "Inicio da Admissão",
                            param: "P_DTINICIAL"
                        },
                        {
                            field: this.DEFINITION.data2,
                            label: "Fim da Admissão",
                            param: "P_DTFINAL"
                        },
                        {
                            label: "Incluir Vínculos Demitidos",
                            field: this.DEFINITION.opcao1,
                            param: "P_INCLUIRDEMITIDO"
                        },
                        {
                            field: this.DEFINITION.zebrado,
                            param: "ZEBRADO"
                        }
                    ]
                },
                funcionarios_demitidos_periodo: {
                    config: {
                        itemName: "Funcionários Demitidos no Período",
                        fileName: "funcionarios_demitidos_periodo",
                        order: 40
                    },
                    params: [
                        {
                            field: this.DEFINITION.competencia,
                            param: "P_DTMESCOMPETENC",
                            required: true
                        },
                        {
                            field: this.DEFINITION.nrvinculo,
                            param: "P_VINCULO"
                        },
                        {
                            field: this.DEFINITION.nrestrutlegal,
                            param: "P_NRESTRUTURA"
                        },
                        {
                            field: this.DEFINITION.nrestrutgeren,
                            param: "P_NRESTRUTURAGEREN"
                        },
                        
                        {
                            field: this.DEFINITION.data1,
                            label: "Inicio da Rescisão",
                            param: "P_DTINICIAL",
                            required: true
                        },
                        {
                            field: this.DEFINITION.data2,
                            label: "Fim da Rescisão",
                            param: "P_DTFINAL",
                            required: true
                        },
                        {
                            field: this.DEFINITION.zebrado,
                            param: "ZEBRADO"
                        }
                    ]
                },
                relacao_funcionarios_ativos_mes: {
                    config: {
                        itemName: "Relação de Funcionários Ativos",
                        fileName: "relacao_funcionarios_ativos_mes",
                        order: 50
                    },
                    params: [
                        {
                            field: this.DEFINITION.competencia,
                            param: "P_COMPETENCIA",
                            required: true
                        },
                        {
                            field: this.DEFINITION.nrvinculoMulti,
                            param: "P_VINCULO"
                        },
                        {
                            field: this.DEFINITION.nrestrutlegal,
                            param: "P_ESTRUTLEGAL"
                        },
                        {
                            field: this.DEFINITION.nrestrutgeren,
                            param: "P_ESTRUTGEREN"
                        },
                        {
                            field: this.DEFINITION.nrestrutsup,
                            param: "P_ESTRUTHIERA"
                        },
                        {
                            label: "Tipo de Estrutura",
                            field: this.DEFINITION.tipohierarquia,
                            param: "P_TIPOHIERARQ",
                            required: true
                        },
                        {
                            field: this.DEFINITION.tpvinculoEmpreg,
                            param: "P_TIPOVINCULO"
                        },
                        {
                            field: this.DEFINITION.situacaoFunc,
                            param: "P_SITUACAO"
                        },
                        {
                            field: this.DEFINITION.data1,
                            label: "Inicio da Admissão",
                            param: "P_INICIO"
                        },
                        {
                            field: this.DEFINITION.data2,
                            label: "Fim da Admissão",
                            param: "P_FINAL"
                        },
                        {
                            label: "Incluir Vínculos Demitidos",
                            field: this.DEFINITION.opcao1,
                            param: "P_INCLUIRDEMITIDO"
                        },
                        {
                            field: this.DEFINITION.zebrado,
                            param: "ZEBRADO"
                        }
                    ]
                },
                relacao_funcionarios_ativos_mes_por_sindicato: {
                    config: {
                        itemName: "Relação de Funcionários Ativos - por sindicato",
                        fileName: "relacao_funcionarios_ativos_mes_por_sindicato",
                        order: 60
                    },
                    params: [
                        {
                            field: this.DEFINITION.competencia,
                            param: "P_COMPETENCIA",
                            required: true
                        },
                        {
                            field: this.DEFINITION.nrvinculoMulti,
                            param: "P_VINCULO"
                        },
                        {
                            field: this.DEFINITION.nrestrutlegal,
                            param: "P_ESTRUTLEGAL"
                        },
                        {
                            field: this.DEFINITION.nrestrutgeren,
                            param: "P_ESTRUTGEREN"
                        },
                        {
                            field: this.DEFINITION.nrestrutsind,
                            param: "P_ESTRUTSIND"
                        },
                        {
                            field: this.DEFINITION.tpvinculoEmpreg,
                            param: "P_TIPOVINCULO"
                        },
                        {
                            field: this.DEFINITION.situacaoFunc,
                            param: "P_SITUACAO"
                        },
                        {
                            field: this.DEFINITION.data1,
                            label: "Inicio da Admissão",
                            param: "P_INICIO"
                        },
                        {
                            field: this.DEFINITION.data2,
                            label: "Fim da Admissão",
                            param: "P_FINAL"
                        },
                        {
                            label: "Incluir Vínculos Demitidos",
                            field: this.DEFINITION.opcao1,
                            param: "P_INCLUIRDEMITIDO"
                        },
                        {
                            field: this.DEFINITION.zebrado,
                            param: "ZEBRADO"
                        }
                    ]
                },
                afastados_por_estrutura: {
                    config: {
                        itemName: "Relação de Funcionários por Situação Funcional",
                        fileName: "afastados_por_estrutura",
                        order: 70
                    },
                    params: [
                        {
                            field: this.DEFINITION.competencia,
                            param: "P_COMPETENCIA",
                            required: true
                        },
                        {
                            field: this.DEFINITION.nrvinculoMulti,
                            param: "P_VINCULO"
                        },
                        {
                            field: this.DEFINITION.nrestrutlegal,
                            param: "P_ESTRUTLEGAL"
                        },
                        {
                            field: this.DEFINITION.nrestrutgeren,
                            param: "P_ESTRUTGEREN"
                        },
                        {
                            field: this.DEFINITION.situacaoFuncMulti,
                            param: "P_SITUACAO"
                        },
                        {
                            field: this.DEFINITION.opcao1,
                            param: "P_TPFILTRAGEM",
                            label: "Status da Situação Funcional",
                            dataList: [ {
                                name: "Situação funcional atual",
                                value: "A"
                            }, {
                                name: "Situação funcional de retorno",
                                value: "R"
                            } ],
                            required: true
                        },
                        {
                            field: this.DEFINITION.data1,
                            label: "Data Inicial",
                            param: "P_INICIO"
                        },
                        {
                            field: this.DEFINITION.data2,
                            label: "Data Final",
                            param: "P_FINAL"
                        },
                        {
                            label: "Omitir Situação Normal",
                            field: this.DEFINITION.opcao2,
                            param: "P_OMITIR_SITU_NORMAL"
                        },
                        {
                            label: "Omitir descrição CID",
                            field: this.DEFINITION.opcao3,
                            param: "P_OMITIR_CID"
                        },
                        {
                            field: this.DEFINITION.zebrado,
                            param: "ZEBRADO"
                        }
                    ]
                },
                relacao_funcionario_banco: {
                    config: {
                        itemName: "Relação Funcionário - por banco",
                        fileName: "relacao_funcionario_banco",
                        order: 80
                    },
                    params: [
                        {
                            field: this.DEFINITION.competencia,
                            param: "P_COMPETENCIA",
                            required: true
                        },
                        {
                            field: this.DEFINITION.nrestrutlegal,
                            param: "P_ESTRUTLEGAL"
                        },
                        {
                            field: this.DEFINITION.nrestrutgeren,
                            param: "P_ESTRUTGEREN"
                        },
                        {
                            label: "Incluir Vínculos Demitidos",
                            field: this.DEFINITION.opcao1,
                            param: "P_INCLUIRDEMITIDO"
                        },
                        {
                            field: this.DEFINITION.zebrado,
                            param: "ZEBRADO"
                        }
                    ]
                },
                relacao_funcionario_por_estrutura: {
                    config: {
                        itemName: "Relação Funcionário - por estrutura",
                        fileName: "relacao_funcionario_por_estrutura",
                        order: 90
                    },
                    params: [
                        {
                            field: this.DEFINITION.competencia,
                            param: "P_COMPETENCIA",
                            required: true
                        },
                        {
                            field: this.DEFINITION.nrvinculoMulti,
                            param: "P_VINCULO"
                        },
                        {
                            field: this.DEFINITION.nrestrutlegal,
                            param: "P_ESTRUTLEGAL"
                        },
                        {
                            field: this.DEFINITION.nrestrutgeren,
                            param: "P_ESTRUTGEREN"
                        },
                        {
                            field: this.DEFINITION.nrestrutsup,
                            param: "P_ESTRUTHIERA"
                        },
                        {
                            label: "Tipo de Estrutura",
                            field: this.DEFINITION.tipohierarquia,
                            param: "P_TIPOHIERARQ",
                            required: true
                        },
                        {
                            field: this.DEFINITION.tpvinculoEmpreg,
                            param: "P_TIPOVINCULO"
                        },
                        {
                            field: this.DEFINITION.situacaoFunc,
                            param: "P_SITUACAO"
                        },
                        {
                            field: this.DEFINITION.ocupacao,
                            param: "P_OCUPACAO"
                        },
                        {
                            field: this.DEFINITION.data1,
                            label: "Inicio da Admissão",
                            param: "P_DTINICIO"
                        },
                        {
                            field: this.DEFINITION.data2,
                            label: "Fim da Admissão",
                            param: "P_DTFINAL"
                        },
                        {
                            label: "Ocultar Salario",
                            field: this.DEFINITION.opcao1,
                            param: "P_OCULTASALARIO"
                        },
                        {
                            label: "Incluir Vínculos Demitidos",
                            field: this.DEFINITION.opcao2,
                            param: "P_INCLUIRDEMITIDO"
                        },
                        {
                            field: this.DEFINITION.zebrado,
                            param: "ZEBRADO"
                        }
                    ]
                },
                relacao_funcionario_por_sindicato: {
                    config: {
                        itemName: "Relação Funcionário - por sindicato",
                        fileName: "relacao_funcionario_por_sindicato",
                        order: 100
                    },
                    params: [
                        {
                            field: this.DEFINITION.competencia,
                            param: "P_COMPETENCIA",
                            required: true
                        },
                        {
                            field: this.DEFINITION.nrvinculoMulti,
                            param: "P_VINCULO"
                        },
                        {
                            field: this.DEFINITION.nrestrutlegal,
                            param: "P_ESTRUTLEGAL"
                        },
                        {
                            field: this.DEFINITION.nrestrutgeren,
                            param: "P_ESTRUTGEREN"
                        },
                        {
                            label: "Incluir Vínculos Demitidos",
                            field: this.DEFINITION.opcao1,
                            param: "P_INCLUIRDEMITIDO"
                        },
                        {
                            field: this.DEFINITION.zebrado,
                            param: "ZEBRADO"
                        }
                    ]
                },
                aniversariantes: {
                    config: {
                        itemName: "Aniversariantes do Mês",
                        fileName: "aniversariantes",
                        order: 110
                    },
                    params: [
                        {
                            field: this.DEFINITION.competencia,
                            param: "P_COMPETENCIA",
                            required: true
                        },
                        {
                            field: this.DEFINITION.nrestrutlegal,
                            param: "P_ESTRUTLEGAL"
                        },
                        {
                            field: this.DEFINITION.nrestrutgeren,
                            param: "P_ESTRUTGEREN"
                        },
                        {
                            field: this.DEFINITION.zebrado,
                            param: "ZEBRADO"
                        }
                    ]
                }

            }   
        },
        BTL: {
            label: "Relatórios de Recrutamento e Seleção",
            0: {
                /*curriculo_candidato: {
                    config: {
                        itemName: "Currículo do Candidato",
                        fileName: "curriculo_candidato",
                        order: 10
                    },
                    [this.DEFINITION.competencia.name]: {
                        value: this.DEFINITION.competencia.value,
                        multi: this.DEFINITION.competencia.multi,
                        param: "P_COMPETENCIA",
                        required: true
                    },
                    [this.DEFINITION.candidato.name]: {
                        value: this.DEFINITION.candidato.value,
                        multi: this.DEFINITION.candidato.multi,
                        param: "P_NRPARCNEGOCIO"
                    }
                },*/
                avaliacao_questionario: {
                    config: {
                        itemName: "Avaliação e Questionário",
                        fileName: "avaliacao_questionario",
                        order: 30
                    },
                    params: [ {
                        field: this.DEFINITION.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    }, {
                        field: this.DEFINITION.candidato,
                        param: "P_NRPARCNEGOCIO",
                        required: true
                    }, {
                        field: this.DEFINITION.nrprocesso,
                        param: "P_NRPROCESSO",
                        required: true
                    }, {
                        field: this.DEFINITION.nrfase,
                        param: "P_NRFASE"
                    }, {
                        field: this.DEFINITION.nravaliacao,
                        param: "P_NRAVALIACAO",
                        required: true
                    } ]
                },
                avaliacao_psicologica: {
                    config: {
                        itemName: "Avaliação Pisicológica",
                        fileName: "avaliacao_psicologica",
                        order: 20
                    },
                    params: [ {
                        field: this.DEFINITION.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    }, 
                    {
                        field: this.DEFINITION.candidato,
                        param: "P_NRPARCNEGOCIOCAND",
                        required: true
                    }]
                }
            }
        }, 
        TRE: {
            label: "Relatório de Treinamento",
            /*Relatórios padrão*/
            0: {
                certificado_treinamento: {
                    config: {
                        itemName: "Certificados de Treinamento",
                        fileName: "certificado_treinamento",
                        order: 10
                    },
                    params: [ 
                    {
                        field: this.DEFINITION.nrtreinamentoMulti,
                        param: "P_NRTREINAMENTO",
                        required: true
                    },
                    {
                        field: this.DEFINITION.nrvinculoMulti,
                        param: "P_NRVINCULOM"
                    },
                    {
                        field: this.DEFINITION.nrestrutlegalMulti,
                        param: "P_NRESTRUTLEGAL"
                    },
                    {
                        field: this.DEFINITION.nrestrutgerenMulti,
                        param: "P_NRESTRUTGEREN"
                    },
                    {
                        field: this.DEFINITION.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    }]
                },
                convite_treinamento: {
                    config: {
                        itemName: "Convite de Treinamento",
                        fileName: "convite_treinamento",
                        order: 10
                    },
                    params: [ 
                    {
                        field: this.DEFINITION.nrtreinamentoMulti,
                        param: "P_NRTREINAMENTO",
                        required: true
                    },
                    {
                        field: this.DEFINITION.nrvinculoMulti,
                        param: "P_NRVINCULOM"
                    },
                    {
                        field: this.DEFINITION.nrestrutlegalMulti,
                        param: "P_NRESTRUTLEGAL"
                    },
                    {
                        field: this.DEFINITION.nrestrutgerenMulti,
                        param: "P_NRESTRUTGEREN"
                    },
                    {
                        field: this.DEFINITION.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    }]
                },
                participantes_treinamento: {
                    config: {
                        itemName: "Participantes do treinamento",
                        fileName: "participantes_treinamento",
                        order: 10
                    },
                    params: [ 
                    {
                        field: this.DEFINITION.nrtreinamentoMulti,
                        param: "P_NRTREINAMENTO",
                        required: true
                    },
                    {
                        field: this.DEFINITION.nrvinculoMulti,
                        param: "P_NRVINCULOM"
                    },
                    {
                        field: this.DEFINITION.nrestrutlegalMulti,
                        param: "P_NRESTRUTLEGAL"
                    },
                    {
                        field: this.DEFINITION.nrestrutgerenMulti,
                        param: "P_NRESTRUTGEREN"
                    },
                    {
                        field: this.DEFINITION.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    }]
                }
            },
        },
        REC: {
            label: "Guias de Recolhimento",
            /*Relatórios padrão*/
            0: {
                darf: {
                    config: {
                        itemName: "DARF",
                        fileName: "darf",
                        order: 10
                    },
                    params: [ 
                    {
                        field: this.DEFINITION.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    },
                    {
                        field: this.DEFINITION.nrvinculoMulti,
                        param: "P_NRVINCULOM"
                    },
                    {
                        field: this.DEFINITION.nrestrutlegal,
                        param: "P_NRESTRUTURA"
                    },
                    {
                        field: this.DEFINITION.nrestrutgeren,
                        param: "P_NRESTRUTGEREN"
                    },
                    {
                        field: this.DEFINITION.tipomovimentoMulti,
                        param: "P_NRTIPOMOVIMENT"
                    },
                    {
                        field: this.DEFINITION.number1,
                        param: "P_MULTA",
                        label: "Multa",
                        required: true
                    },
                    {
                        field: this.DEFINITION.number2,
                        param: "P_JUROSENCARGOS",
                        label: "Juros e Encargos",
                        required: true
                    },
                    {
                        field: this.DEFINITION.data1,
                        label: "Data de Vencimento",
                        param: "P_DTVENCIMENTO",
                        required: true
                    },
                    {
                        field: this.DEFINITION.data2,
                        label: "Período de Apuração",
                        param: "P_PERIODOAPURACAO",
                        required: true
                    },
                    {
                        field: this.DEFINITION.tpvinculoEmpreg,
                        param: "P_TIPOVINCULO"
                    },
                    {
                        label: "Emissão de Guias por Vínculo",
                        field: this.DEFINITION.opcao1,
                        valueField: "N",
                        param: "P_MOSTRARVINC"
                    },
                    {
                        label: "Agrupar por Matriz",
                        field: this.DEFINITION.opcao2,
                        valueField: "N",
                        param: "P_AGRUPARMATRIZ"
                    },
                    {
                        label: "Regime de Caixa",
                        field: this.DEFINITION.opcao3,
                        valueField: "N",
                        param: "P_IDREGIMECAIXA"
                    },
                    {
                        field: this.DEFINITION.opcao4,
                        label: "Gerar Memória",
                        param: "P_SHOWMEMORIA"
                    }]
                },
                darf_pis: {
                    config: {
                        itemName: "DARF - PIS",
                        fileName: "darf_pis",
                        order: 15
                    },
                    params: [ 
                    {
                        field: this.DEFINITION.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    },
                    {
                        field: this.DEFINITION.nrvinculoMulti,
                        param: "P_NRVINCULOM"
                    },
                    {
                        field: this.DEFINITION.nrestrutlegal,
                        param: "P_NRESTRUTURA"
                    },
                    {
                        field: this.DEFINITION.nrestrutgeren,
                        param: "P_NRESTRUTGEREN"
                    },
                    {
                        field: this.DEFINITION.tipomovimentoMulti,
                        param: "P_NRTIPOMOVIMENT"
                    },
                    {
                        field: this.DEFINITION.number1,
                        param: "P_MULTA",
                        label: "Multa",
                        required: true
                    },
                    {
                        field: this.DEFINITION.number2,
                        param: "P_JUROSENCARGOS",
                        label: "Juros e Encargos",
                        required: true
                    },
                    {
                        field: this.DEFINITION.data1,
                        label: "Data de Vencimento",
                        param: "P_DTVENCIMENTO",
                        required: true
                    },
                    {
                        field: this.DEFINITION.data2,
                        label: "Período de Apuração",
                        param: "P_PERIODOAPURACAO",
                        required: true
                    },
                    {
                        field: this.DEFINITION.tpvinculoEmpreg,
                        param: "P_TIPOVINCULO"
                    },
                    {
                        label: "Emissão de Guias por Vínculo",
                        field: this.DEFINITION.opcao1,
                        valueField: "N",
                        param: "P_MOSTRARVINC"
                    },
                    {
                        label: "Agrupar por Matriz",
                        field: this.DEFINITION.opcao2,
                        valueField: "N",
                        param: "P_AGRUPARMATRIZ"
                    },
                    {
                        label: "Regime de Caixa",
                        field: this.DEFINITION.opcao3,
                        valueField: "N",
                        param: "P_IDREGIMECAIXA"
                    }]
                },
                resumo_irrf: {
                    config: {
                        itemName: "Resumo de IRRF",
                        fileName: "resumo_irrf",
                        order: 18
                    },
                    params: [ {
                        field: this.DEFINITION.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    }, {
                        field: this.DEFINITION.nrvinculoMulti,
                        param: "P_VINCULO"
                    }, {
                        field: this.DEFINITION.nrestrutlegalMulti,
                        param: "P_ESTRUTLEGAL"
                    },{
                        field: this.DEFINITION.nrestrutgerenMulti,
                        param: "P_ESTRUTGEREN"
                    }, {
                        field: this.DEFINITION.dtinicio,
                        param: "P_DTINICIO"
                    }, {
                        field: this.DEFINITION.dtfim,
                        param: "P_DTFINAL"
                    },{
                        field: this.DEFINITION.opcao3,
                        label: "Regime de Caixa",
                        param: "P_IDREGIMECAIXA"
                    },{
                        field: this.DEFINITION.opcao4,
                        label: "Omitir Agrupamento Gerencial",
                        param: "P_OMITIRGEREN"
                    },{
                        field: this.DEFINITION.zebrado,
                        param: "ZEBRADO"
                    },{
                        field: this.DEFINITION.opcao5,
                        label: "Ignorar Ocorrencias de Cálculo",
                        param: "P_IGNORAOCORR"
                    } ]
                },
                gps: {
                    config: {
                        itemName: "GPS",
                        fileName: "gps",
                        order: 19
                    },
                    params: [ 
                    {
                        field: this.DEFINITION.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    },
                    {
                        field: this.DEFINITION.tpestrut,
                        param: "P_NRTIPOESTRUTURA",
                        required: true
                    },
                    {
                        field: this.DEFINITION.nrestrutlegal,
                        param: "P_NRESTRUTURA"
                    },
                    {
                        field: this.DEFINITION.nrestrutgeren,
                        param: "P_NRESTRUTGEREN"
                    },
                    {
                        field: this.DEFINITION.tipomovimento1,
                        param: "P_MOVIMENTO",
                        required: true,
                        descriptionField: "Mensal", valueField: "1"
                    },
                    {
                        field: this.DEFINITION.texto1,
                        param: "P_CDPAGTOGPS",
                        label: "Código do Pagamento"
                    },
                    {
                        field: this.DEFINITION.number1,
                        param: "P_CDIDENTIFIGPS",
                        label: "Identificador"
                    },
                    {
                        field: this.DEFINITION.number2,
                        param: "P_VRINSSGPS",
                        label: "Valor do INSS"
                    },
                    {
                        field: this.DEFINITION.number3,
                        param: "P_VROUTRASGPS",
                        label: "Valor de Outras Entidades"
                    },
                    {
                        field: this.DEFINITION.number4,
                        param: "P_VRMULTAGPS",
                        label: "ATM/Multa e Juros"
                    },
                    {
                        field: this.DEFINITION.opcao4,
                        label: "Gerar Memória",
                        param: "P_SHOWMEMORIA"
                    }]
                },
                gps_old: {
                    config: {
                        itemName: "GPS (versão antiga)",
                        fileName: "gps_old",
                        order: 20
                    },
                    params: [ 
                    {
                        field: this.DEFINITION.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    },
                    {
                        field: this.DEFINITION.tpestrut,
                        param: "P_NRTIPOESTRUTURA",
                        required: true
                    },
                    {
                        field: this.DEFINITION.nrestrutlegal,
                        param: "P_NRESTRUTURA"
                    },
                    {
                        field: this.DEFINITION.nrestrutgeren,
                        param: "P_NRESTRUTGEREN"
                    },
                    {
                        field: this.DEFINITION.tipomovimento1,
                        param: "P_MOVIMENTO",
                        required: true,
                        descriptionField: "Mensal", valueField: "1"
                    },
                    {
                        field: this.DEFINITION.texto1,
                        param: "P_CDPAGTOGPS",
                        label: "Código do Pagamento"
                    },
                    {
                        field: this.DEFINITION.number1,
                        param: "P_CDIDENTIFIGPS",
                        label: "Identificador"
                    },
                    {
                        field: this.DEFINITION.number2,
                        param: "P_VRINSSGPS",
                        label: "Valor do INSS"
                    },
                    {
                        field: this.DEFINITION.number3,
                        param: "P_VROUTRASGPS",
                        label: "Valor de Outras Entidades"
                    },
                    {
                        field: this.DEFINITION.number4,
                        param: "P_VRMULTAGPS",
                        label: "ATM/Multa e Juros"
                    },
                    {
                        label: "Emissão de Guias por Vínculo",
                        field: this.DEFINITION.opcao1,
                        valueField: "N",
                        param: "P_AGRUPARVINC"
                    }]
                },
                gps_formulario: {
                    config: {
                        itemName: "GPS (via formulário)",
                        fileName: "gps_formulario",
                        order: 30
                    },
                    params: [ 
                    {
                        field: this.DEFINITION.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    },
                    {
                        field: this.DEFINITION.nrestrutlegal,
                        param: "P_NRESTRUTURA"
                    },
                    {
                        field: this.DEFINITION.nrestrutgeren,
                        param: "P_NRESTRUTGEREN"
                    },
                    {
                        field: this.DEFINITION.nrvinculoMulti,
                        param: "P_NRVINCULOM"
                    },
                    {
                        field: this.DEFINITION.texto1,
                        param: "P_CDPAGTOGPS",
                        label: "Código do Pagamento",
                        required: true
                    },
                    {
                        field: this.DEFINITION.number1,
                        param: "P_CDIDENTIFIGPS",
                        label: "Identificador"
                    },
                    {
                        field: this.DEFINITION.number2,
                        param: "P_VRINSSGPS",
                        label: "Valor do INSS"
                    },
                    {
                        field: this.DEFINITION.number3,
                        param: "P_VROUTRASGPS",
                        label: "Valor de Outras Entidades"
                    },
                    {
                        field: this.DEFINITION.number4,
                        param: "P_VRMULTAGPS",
                        label: "ATM/Multa e Juros"
                    }]
                }
            }
        },
        GerCC: {
            label: "Geração de Conta-Corrente",
            0: {
                abertura_conta_bb_remessa: {
                    config: {
                        itemName: "Abertura de Contas Massificada - Remessa - MCI460",
                        fileName: "abertura_conta_bb_remessa",
                        download: {
                            fileName: "abertura_conta_bb_remessa",
                            format: "txt",
                            strFind: "@",
                            strReplace: "\r"
                         },
                        order: 10
                    },
                    params: [
                        {
                            field: this.DEFINITION.competencia,
                            param: "P_COMPETENCIA",
                            required: true
                        }, {
                            field: this.DEFINITION.nrestrutlegal2,
                            param: "P_NRESTRUTRESP",
                            label: "Empresa (estrutura responsável)",
                            required: true
                        }, {
                            field: this.DEFINITION.number1,
                            param: "P_CDMCI",
                            label: "Código MCI da empresa",
                            required: true
                        }, {
                            field: this.DEFINITION.texto1,
                            param: "P_AGENCIA",
                            label: "Agência de exportação",
                            required: true
                        }, {
                            field: this.DEFINITION.number3,
                            param: "P_NRPROCESSO",
                            label: "Número do processo",
                            required: true
                        }, {
                            field: this.DEFINITION.nrvinculoMulti,
                            param: "P_NRVINCULO"
                        }, {
                            field: this.DEFINITION.nrestrutlegal,
                            param: "P_NRESTRUTLEGAL"
                        }, {
                            field: this.DEFINITION.nrestrutgeren,
                            param: "P_NRESTRUTGEREN"
                        }]
                },
                importa_remessa : {
                    config: {
                        itemName: "Importação de Remessa de Retorno - MCI470",
                        fileName: "importa_remessa",
                        order: 20
                    },
                    params: [
                        {
                            field: this.DEFINITION.arquivo,
                            param: " ",
                            label: "Arquivo de retorno",
                            required: true
                        }]
                }
            }
        },
        RCB: {
            label: "Recibo de Pagamento",
            /*Relatórios padrão*/
            0: {
                folha_analitica_sintetico: {
                    config: {
                        itemName: "Resumo Movimento",
                        fileName: "folha_analitica_sintetico",
                    },
                    params: [ {
                        field: this.DEFINITION_RCB.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    }, {
                        field: this.DEFINITION_RCB.nrestrutlegal,
                        param: "P_ESTRUTURALEGAL"
                    }, {
                        field: this.DEFINITION_RCB.nrestrutgeren,
                        param: "P_ESTRUTURAGEREN"
                    },{
                        row: "P_TIPOMOVIMENTO",
                        param: "P_TIPOMOVIMENTO",
                        value: "1"
                    },{
                        row: "ZEBRADO",
                        param: "ZEBRADO",
                        value: "N"
                    },{
                        row: "P_OMITIRVINCULOS",
                        param: "P_OMITIRVINCULOS",
                        value: "N"
                    },{
                        row: "P_OMITIRLEGAL",
                        param: "P_OMITIRLEGAL",
                        value: "N"
                    },{
                        row: "P_INCLUIR13",
                        param: "P_INCLUIR13",
                        value: "N"
                    },{
                        row: "P_OMITIRRESC",
                        param: "P_OMITIRRESC",
                        value: "N"
                    },{
                        row: "P_SODEMITIDO",
                        param: "P_SODEMITIDO",
                        value: "N"
                    },{
                        row: "P_OMITIRGEREN",
                        param: "P_OMITIRGEREN",
                        value: "N"
                    },{
                        row: "P_IGNORAOCORR",
                        param: "P_IGNORAOCORR",
                        value: "N"
                    },{
                        row: "P_MOSTRARDEMO",
                        param: "P_MOSTRARDEMO",
                        value: "N"
                    }]
                },
                resumo_impostos: {
                    config: {
                        itemName: "Resumo de Impostos",
                        fileName: "resumo_impostos"
                    },
                    params: [ {
                        field: this.DEFINITION_RCB.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    },{
                        field: this.DEFINITION_RCB.nrestrutlegal,
                        param: "P_ESTRUTLEGAL"
                    }, {
                        field: this.DEFINITION_RCB.nrestrutgeren,
                        param: "P_ESTRUTGEREN"
                    },{
                        field: this.DEFINITION_RCB.nrvinculoMulti,
                        param: "P_VINCULO"
                    },{
                        row: "P_TIPOMOVIMENTO",
                        param: "P_TIPOMOVIMENTO",
                        value: "1"
                    },{
                        row: "P_INCLUIR13",
                        param: "P_INCLUIR13",
                        value: "N"
                    },{
                        row: "P_OMITIRGEREN",
                        param: "P_OMITIRGEREN",
                        value: "N"
                    },{
                        row: "ZEBRADO",
                        param: "ZEBRADO",
                        value: "N"
                    },{
                        row: "P_IGNORAOCORR",
                        param: "P_IGNORAOCORR",
                        value: "N"
                    } ]
                },
                resumo_irrf: {
                    config: {
                        itemName: "Resumo de IRRF",
                        fileName: "resumo_irrf"
                    },
                    params: [ {
                        field: this.DEFINITION_RCB.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    },{
                        field: this.DEFINITION_RCB.nrestrutlegal,
                        param: "P_ESTRUTLEGAL"
                    },{
                        field: this.DEFINITION_RCB.nrestrutgeren,
                        param: "P_ESTRUTGEREN"
                    },{
                        field: this.DEFINITION_RCB.nrvinculoMulti,
                        param: "P_VINCULO"
                    },{
                        row: "P_IDREGIMECAIXA",
                        param: "P_IDREGIMECAIXA",
                        value: "N"
                    },{
                        row: "P_OMITIRGEREN",
                        param: "P_OMITIRGEREN",
                        value: "N"
                    },{
                        row: "ZEBRADO",
                        param: "ZEBRADO",
                        value: "N"
                    },{
                        row: "P_IGNORAOCORR",
                        param: "P_IGNORAOCORR",
                        value: "N"
                    } ]
                },
                liquido: {
                    config: {
                        itemName: "Líquido Geral",
                        fileName: "liquido",
                    },
                    params: [ {
                        field: this.DEFINITION_RCB.competencia,
                        param: "P_DTMESCOMPETENC",
                        required: true
                    },{
                        field: this.DEFINITION_RCB.nrestrutlegal,
                        param: "P_NRESTRUTURA"
                    },{
                        field: this.DEFINITION_RCB.nrestrutgeren,
                        param: "P_NRESTRUTURAGEREN"
                    },{
                        row: "P_NRTPMOVIMENT",
                        param: "P_NRTPMOVIMENT",
                        value: "1"
                    },{
                         row: "P_NREVENTOM",
                         param: "P_NREVENTO",
                         value: "3030"
                    },{
                        row: "P_OMITIRVINC",
                        param: "P_OMITIRVINC",
                        value: "N"
                    },{
                        row: "P_OMITIRGEREN",
                        param: "P_OMITIRGEREN",
                        value: "N"
                    },{
                        row: "P_INCLUIRDEMITIDO",
                        param: "P_INCLUIRDEMITIDO",
                        value: "N"
                    },{
                        row: "ZEBRADO",
                        param: "ZEBRADO",
                        value: "N"
                    }]
                },
                darf: {
                    config: {
                        itemName: "DARF",
                        fileName: "darf"
                    },
                    params: [ 
                    {
                        field: this.DEFINITION_RCB.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    },
                    {
                        field: this.DEFINITION_RCB.nrestrutlegal,
                        param: "P_NRESTRUTURA"
                    },{
                        field: this.DEFINITION_RCB.nrestrutgeren,
                        param: "P_NRESTRUTGEREN"
                    },
                    {
                        field: this.DEFINITION_RCB.nrvinculo,
                        param: "P_NRVINCULOM"
                    },
                    {
                        row: "P_NRTPMOVIMENTO",
                        param: "P_NRTPMOVIMENTO",
                        value: "1"
                    },
                    {
                        field: this.DEFINITION_RCB.number1,
                        param: "P_MULTA",
                        label: "Multa",
                        required: true
                    },
                    {
                        field: this.DEFINITION_RCB.number2,
                        param: "P_JUROSENCARGOS",
                        label: "Juros e Encargos",
                        required: true
                    },
                    {
                        field: this.DEFINITION_RCB.data1,
                        label: "Data de Vencimento",
                        param: "P_DTVENCIMENTO",
                        required: true
                    },
                    {
                        field: this.DEFINITION_RCB.data2,
                        label: "Período de Apuração",
                        param: "P_PERIODOAPURACAO",
                        required: true
                    },
                    {
                        row: "P_MOSTRARVINC",
                        param: "P_MOSTRARVINC",
                        value: "N"
                    },
                    {
                        row: "P_AGRUPARMATRIZ",
                        param: "P_AGRUPARMATRIZ",
                        value: "N"
                    },
                    {
                        row: "P_IDREGIMECAIXA",
                        param: "P_IDREGIMECAIXA",
                        value: "N"
                    }]
                },
                gps: {
                    config: {
                        itemName: "GPS",
                        fileName: "gps",
                    },
                    params: [ 
                    {
                        field: this.DEFINITION_RCB.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    },
                    {
                        field: this.DEFINITION_RCB.tpestrut,
                        param: "P_NRTIPOESTRUTURA",
                    },{
                        field: this.DEFINITION_RCB.nrestrutgeren,
                        param: "P_NRESTRUTGEREN"
                    },
                    {
                        field: this.DEFINITION_RCB.nrestrutlegal,
                        param: "P_NRESTRUTURA"
                    },	
                    {
                        row: "P_MOVIMENTO",
                        param: "P_MOVIMENTO",
                        value: "1"
                    }
                    ]
                },
                aviso_previo_ferias: {
                    config: {
                        itemName: "Aviso Prévio de Férias",
                        fileName: "aviso_previo_ferias",
                    },
                    params: [ {
                        field: this.DEFINITION_RCB.competencia,
                        param: "P_DTMESCOMPETENC",
                        required: true
                    },{
                        field: this.DEFINITION_RCB.nrestrutlegal,
                        param: "P_NRESTRUTURA"
                    },{
                        field: this.DEFINITION_RCB.nrestrutgeren,
                        param: "P_NRESTRUTGEREN"
                    },{
                        field: this.DEFINITION_RCB.nrvinculo,
                        param: "P_NRVINCULOM"
                    },{
                        field: this.DEFINITION_RCB.dtinicio,
                        label: "Data Inicial de Gozo de Férias",
                        param: "P_DATAINICIAL"
                    },{
                        field: this.DEFINITION_RCB.dtfim,
                        label: "Data Final de Gozo de Férias",
                        param: "P_DATAFINAL"
                    }]
                },
                recibo_ferias: {
                    config: {
                        itemName: "Recibo de Férias",
                        fileName: "recibo_ferias",
                    },
                    params: [ {
                        field: this.DEFINITION_RCB.competencia,
                        param: "P_DTMESCOMPETENC",
                        required: true
                    },{
                        field: this.DEFINITION_RCB.nrestrutlegal,
                        param: "P_NRESTRUTURA"
                    },{
                        field: this.DEFINITION_RCB.nrestrutgeren,
                        param: "P_NRESTRUTGEREN"
                    },{
                        field: this.DEFINITION_RCB.nrvinculo,
                        param: "P_NRVINCULO"
                    },{
                        row: "P_2VIAS",
                        param: "P_2VIAS",
                        value: "N"
                    },{
                        row: "P_SOMENTEATIVOS",
                        param: "P_SOMENTEATIVOS",
                        value: "S"
                    }]
                },
                medias_ferias: {
                    config: {
                        itemName: "Médias para Cálculo de Férias",
                        fileName: "medias_ferias",
                    },
                    params: [ {
                        field: this.DEFINITION_RCB.competencia,
                        param: "P_DTMESCOMPETENC",
                        required: true
                    },{
                        field: this.DEFINITION_RCB.nrestrutlegal,
                        param: "P_ESTRUTLEGAL"
                    },{
                        field: this.DEFINITION_RCB.nrestrutgeren,
                        param: "P_ESTRUTGEREN"
                    },{
                        field: this.DEFINITION_RCB.nrvinculo,
                        param: "P_NRVINCULO"
                    },{
                        row: "P_NRTIPOMOVIMENT",
                        param: "P_NRTIPOMOVIMENT",
                        value: "1"
                    },{
                        field: this.DEFINITION_RCB.dtinicio,
                        label: "Data Inicial de Gozo de Férias",
                        param: "P_DTINIGOZO",
                        required: true
						
                    },{
                        field: this.DEFINITION_RCB.dtfim,
                        label: "Data Final de Gozo de Férias",
                        param: "P_DTFIMGOZO",
						required: true
                    },{
                        row: "P_MOSTRARSIMUL",
                        param: "P_MOSTRARSIMUL",
                        value: "N"
                    },{
                        row: "P_OMITIRGERENC",
                        param: "P_OMITIRGERENC",
                        value: "N"
                    },{
                        row: "ZEBRADO",
                        param: "ZEBRADO",
                        value: "N"
                    }]
                },
                medias_rescisao_aviso_prev: {
                    config: {
                        itemName: "Médias para Aviso Prévio na Rescisão",
                        fileName: "medias_rescisao_aviso_prev",
                    },
                    params: [ {
                        field: this.DEFINITION_RCB.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    }, {
                        field: this.DEFINITION_RCB.nrvinculo,
                        param: "P_VINCULO"
                    }, {
                        field: this.DEFINITION_RCB.nrestrutlegal,
                        param: "P_ESTRUTLEGAL"
                    }, {
                        field: this.DEFINITION_RCB.nrestrutgeren,
                        param: "P_ESTRUTGEREN"
                    }]
                },
                medias_rescisao_13: {
                    config: {
                        itemName: "Médias para 13 Salário na Rescisão",
                        fileName: "medias_rescisao_13",
                    },
                    params: [ {
                        field: this.DEFINITION_RCB.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    }, {
                        field: this.DEFINITION_RCB.nrvinculo,
                        param: "P_VINCULO"
                    }, {
                        field: this.DEFINITION_RCB.nrestrutgeren,
                        param: "P_ESTRUTGEREN"
                    }, {
                        field: this.DEFINITION_RCB.nrestrutlegal,
                        param: "P_ESTRUTLEGAL"
                    } ]
                },
                medias_rescisao_ferias: {
                    config: {
                        itemName: "Médias para Férias na Rescisão",
                        fileName: "medias_rescisao_ferias",
                    },
                    params: [ {
                        field: this.DEFINITION_RCB.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    }, {
                        field: this.DEFINITION_RCB.nrvinculo,
                        param: "P_VINCULO"
                    }, {
                        field: this.DEFINITION_RCB.nrestrutgeren,
                        param: "P_ESTRUTGEREN"
                    }, {
                        field: this.DEFINITION_RCB.nrestrutlegal,
                        param: "P_ESTRUTLEGAL"
                    } ]
                },
                demonstrativo_pagamento_via_unica: {
                    config: {
                        itemName: "Recibo de Pagamento de Salário (Laser, via única)",
                        fileName: "demonstrativo_pagamento_via_unica",
                    },
                    params: [ {
                        field: this.DEFINITION_RCB.competencia,
                        param: "P_COMPETENCIA"
                    }, {
                        field: this.DEFINITION_RCB.nrestrutlegal,
                        param: "P_NRESTRUTLEGAL"
                    },{
                        field: this.DEFINITION_RCB.nrestrutgeren,
                        param: "P_NRESTRUTGEREN"
                    },{
                        field: this.DEFINITION_RCB.tipomovimento,
                        param: "P_NRTIPOMOVIMENT"
                    },  {
                        field: this.DEFINITION_RCB.nrvinculo,
                        param: "P_NRVINCULO"
                    },{
                        row: "P_IGNORAOCORR",
                        param: "P_IGNORAOCORR",
                        value: "N"
                    }]
                },
                demonstrativo_pagamento_rpa_laser: {
                    config: {
                        itemName: "Recibo de Pagamento a Autônomo - RPA",
                        fileName: "demonstrativo_pagamento_rpa_laser",
                    },
                    params: [ {
                        field: this.DEFINITION_RCB.competencia,
                        param: "P_COMPETENCIA"
                    }, {
                        field: this.DEFINITION_RCB.nrestrutlegal,
                        param: "P_NRESTRUTLEGAL"
                    },{
                        field: this.DEFINITION_RCB.nrestrutgeren,
                        param: "P_NRESTRUTGEREN"
                    },{
                        field: this.DEFINITION_RCB.tipomovimento,
                        param: "P_NRTIPOMOVIMENT"
                    },  {
                        field: this.DEFINITION_RCB.nrvinculo,
                        param: "P_NRVINCULO"
                    },{
                        row: "P_IGNORAOCORR",
                        param: "P_IGNORAOCORR",
                        value: "N"
                    }]
                },
                trct_qh: {
                    config: {
                        itemName: "Termo de Rescisão de Contrato de Trabalho (com Quitação/Homologação)",
                        fileName: "trct_qh"
                    },
                    params: [ {
                        field: this.DEFINITION_RCB.competencia,
                        param: "P_DTMESCOMPETENC",
                        required: true
                    }, {
                        field: this.DEFINITION_RCB.nrestrutlegal,
                        param: "P_NRESTRUTURA"
                    }, {
                        field: this.DEFINITION_RCB.nrvinculo,
                        param: "P_NRVINCULO",
                        required: true
                    } ]
                },
                seguro_desemprego: {
                    config: {
                        itemName: "Seguro Desemprego (formulário contínuo)",
                        fileName: "seguro_desemprego",
                        order: 120
                    },
                    params: [ {
                        field: this.DEFINITION_RCB.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    }, {
                        field: this.DEFINITION_RCB.nrvinculoResc,
                        param: "P_NRVINCULO"
                    }, {
                        field: this.DEFINITION_RCB.dtinicio,
                        param: "P_DATAINICIAL",
                        label: "Data inicial da rescisão"
                    }, {
                        field: this.DEFINITION_RCB.dtfim,
                        param: "P_DATAFINAL",
                        label: "Data final da rescisão"
                    }, {
                        field: this.DEFINITION_RCB.nrestrutlegal,
                        param: "P_NRESTRUTURALEGAL"
                    }, {
                        field: this.DEFINITION_RCB.nrestrutgeren,
                        param: "P_NRESTRUTURAGEREN"
                    }, {
                        row: "P_NRTIPOMOVIMENT",
                        param: "P_TIPOMOVIMENTO",
                        value: "1"
                    } ]
                },
                seguro_desemprego_laser: {
                    config: {
                        itemName: "Seguro Desemprego (laser modelo 1)",
                        fileName: "seguro_desemprego_laser",
                        order: 130
                    },
                    params: [ {
                        field: this.DEFINITION_RCB.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    }, {
                        field: this.DEFINITION_RCB.nrvinculoResc,
                        param: "P_NRVINCULO"
                    }, {
                        field: this.DEFINITION_RCB.dtinicio,
                        param: "P_DATAINICIAL",
                        label: "Data inicial da rescisão"
                    }, {
                        field: this.DEFINITION_RCB.dtfim,
                        param: "P_DATAFINAL",
                        label: "Data final da rescisão"
                    }, {
                        field: this.DEFINITION_RCB.nrestrutlegal,
                        param: "P_NRESTRUTURALEGAL"
                    }, {
                        field: this.DEFINITION_RCB.nrestrutgeren,
                        param: "P_NRESTRUTURAGEREN"
                    }, {
                        row: "P_NRTIPOMOVIMENT",
                        param: "P_TIPOMOVIMENTO",
                        value: "1"
                    } ]
                },
                seguro_desemprego_laser_2: {
                    config: {
                        itemName: "Seguro Desemprego (laser modelo 2)",
                        fileName: "seguro_desemprego_laser_2",
                        order: 140
                    },
                    params: [ {
                        field: this.DEFINITION_RCB.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    }, {
                        field: this.DEFINITION_RCB.nrvinculoResc,
                        param: "P_NRVINCULO"
                    }, {
                        field: this.DEFINITION_RCB.dtinicio,
                        param: "P_DATAINICIAL",
                        label: "Data inicial da rescisão"
                    }, {
                        field: this.DEFINITION_RCB.dtfim,
                        param: "P_DATAFINAL",
                        label: "Data final da rescisão"
                    }, {
                        field: this.DEFINITION_RCB.nrestrutlegal,
                        param: "P_NRESTRUTURALEGAL"
                    }, {
                        field: this.DEFINITION_RCB.nrestrutgeren,
                        param: "P_NRESTRUTURAGEREN"
                    }, {
                        row: "P_NRTIPOMOVIMENT",
                        param: "P_TIPOMOVIMENTO",
                        value: "1"
                    } ]
                },
                requisicao_seguro_desemprego: {
                    config: {
                        itemName: "Requisição de Seguro Desemprego",
                        fileName: "requisicao_seguro_desemprego",
                        notShow: false, //Campo opcional. Estão aqui para exemplo. TODO implementar estas alterações.
                        format: "pdf", //Campo opcional. Estão aqui para exemplo. TODO implementar estas alterações.
                        download: { //Campo opcional.
                            fileName: "requisicao_seguro_desemprego", //Requerido
                            format: "txt", //Requerido
                            extension: 'SD', //Campo opcional. Usa esta extensão no arquivo gerado. Se não informada usará a extensão do 'format'.
                            strFind: "*", //Campo opcional. String que será substituída pela strinf 'strReplace'
                            strReplace: " " ////Campo opcional.
                        },
                        order: 145
                    },
                    params: [ {
                        field: this.DEFINITION_RCB.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    }, {
                        field: this.DEFINITION_RCB.nrvinculoResc,
                        param: "P_NRVINCULO"
                    }, {
                        field: this.DEFINITION_RCB.dtinicio,
                        param: "P_DTINICIAL",
                        label: "Data inicial da rescisão"
                    }, {
                        field: this.DEFINITION_RCB.dtfim,
                        param: "P_DTFINAL",
                        label: "Data final da rescisão"
                    }, {
                        field: this.DEFINITION_RCB.nrestrutlegal,
                        param: "P_ESTRUTEMPRESA",
                        required: true
                    }, {
                        field: this.DEFINITION_RCB.nrestrutgeren,
                        param: "P_NRESTRUTURAGEREN"
                    } ]
                },
                aviso_previo_empregado: {
                    config: {
                        itemName: "Aviso Prévio do Empregado",
                        fileName: "aviso_previo_empregado",
                    },
                    params: [ {
                        field: this.DEFINITION_RCB.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    },{
                        field: this.DEFINITION_RCB.nrvinculo,
                        param: "P_NRVINCULOM",
                        required: true
                    }]
                },
                aviso_previo_empregador_indenizado: {
                    config: {
                        itemName: "Aviso Prévio do Empregador",
                        fileName: "aviso_previo_empregador",
                    },
                    params: [ {
                        field: this.DEFINITION_RCB.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    }, {
                        field: this.DEFINITION_RCB.nrvinculo,
                        param: "P_NRVINCULOM",
                    }, {
                        field: this.DEFINITION_RCB.dtdocumento,
                        param: "P_DTAVISO",
                        label: "Data do aviso prévio"
                    }, {
                        row: "P_TIPOAVISO",
                        param: "P_TIPOAVISO",
                        value: "S"
                    } ]
                },
                aviso_previo_empregador_trabalhado: {
                    config: {
                        itemName: "Aviso Prévio do Empregador",
                        fileName: "aviso_previo_empregador",
                    },
                    params: [ {
                        field: this.DEFINITION_RCB.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    }, {
                        field: this.DEFINITION_RCB.nrvinculo,
                        param: "P_NRVINCULOM",
                    }, {
                        field: this.DEFINITION_RCB.dtdocumento,
                        param: "P_DTAVISO",
                        label: "Data do aviso prévio"
                    }, {
                        row: "P_TIPOAVISO",
                        param: "P_TIPOAVISO",
                        value: "N"
                    } ]
                },
                extrato_esocial:{
                    config: {
                        itemName: "Extrato do eSocial",
                        fileName: "extrato_esocial"
                    },
                    params: [ {
                        field: this.DEFINITION_RCB.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    }, {
                        field: this.DEFINITION_RCB.nrestrutlegal,
                        param: "P_NRESTRUTURAM"
                    } ]
                },
                carta_referencia: {
                    config: {
                        itemName: "Carta de Referência",
                        fileName: "carta_referencia",
                        order: 195
                    },
                    params: [{
                        field: this.DEFINITION_RCB.competencia,
                        param: "P_COMPETENCIA",
                        required: true
                    },{
                        field: this.DEFINITION_RCB.nrvinculo,
                        param: "P_VINCULO",
                        required: true
                    }]
                }
            }
        }
    }; //FIM Definições dos relatórios - objeto REPORTS
}

Configuration(function(ContextRegister) {
    ContextRegister.register('RelatoriosHcmConfig', RelatoriosHcmConfig);
});

// FILE: assets/js/repositories/ContaContabilRepository.js
var ContaContabilRepository = function(restEngine) {

     this.verificaContaNivelAnterior = function(filter) {
          return restEngine.post('product#/verificaContaNivelAnterior', {
               "requestType": "FilterData",
               "filter": filter
          });
     };

     this.retornaMaiorConta = function(row) {
          return restEngine.post('product#/retornaMaiorConta', {
               "requestType": "Row",
               "row": row
          });
     };

};


Configuration(function(ContextRegister) {
     ContextRegister.register('ContaContabilRepository', ContaContabilRepository);
});


// FILE: assets/js/repositories/HcmRepository.js
/**
 * Created by leonardocarvalho on 28/03/2016.
 */
Configuration(function(ContextRegister, RepositoryFactory, Query, ScreenService) {

    var userImage = './assets/images/user.jpg';
    var HcmRepository = RepositoryFactory.factory('product#/hcmFactory', 'LOCAL', 1, 30000);

    HcmRepository.hcmFactory = function(cdoperador) {
        return this.download(Query.build().where('cdoperador').equals(cdoperador));
    };

    HcmRepository.setUserDataInfo = function(userName, userInfo) {
        ScreenService.buildUserData(userName, userInfo, function() {
            ScreenService.openWindow('product#dashboard');
        }, userImage);
    };

    HcmRepository.setUserHeaderInfo = function(headerInfo) {
        ScreenService.setHeaderInfo(headerInfo);
    };

    HcmRepository.buildUserDataAndHeaderInfo = function(data) {
        var userInfo = [
            "Mês Competência: " + data[0].dtmescompetenc,
            "Organização: " + data[0].nrorgtrab + ' - ' + data[0].nmorganizacaotrab,
            "Ambiente Salarial: " + data[0].idambientesal,
            "Modalidade Salarial: " + data[0].nmtpmodalidsal,
            "Modalidade Cálculo: " + data[0].nmtpmodalidcal,
            "Ocorrência: " + data[0].nrocorrecal
        ];

        var headerInfo = "Competência: " + data[0].dtmescompetenc + " | " +
                         "Organização: " + data[0].nrorgtrab + ' - ' + data[0].nmorganizacaotrab + " | " +
                         "Ambiente Salarial: " + data[0].idambientesal + " | " +
                         "Modalidade Salarial: " + data[0].nmtpmodalidsal + " | " +
                         "Modalidade Cálculo: " + data[0].nmtpmodalidcal + " | " +
                         "Ocorrência: " + data[0].nrocorrecal;

        this.setUserDataInfo(data[0].nmoperador, userInfo);
        this.setUserHeaderInfo(headerInfo);
    };

    ContextRegister.register('HcmRepository', HcmRepository);
});

// FILE: assets/js/services/CalculoBeneficioService.js
/**
 * Created by felipesantos on 11/07/2016.
 */
function CalculoBeneficioService (ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, Messages) {
    var flagAbrirLancamentoBeneficio;

    this.calcular = function(widget, tpcalc, ABUtilController) {
        flagAbrirLancamentoBeneficio = false;
        restEngine.post('/calcularBeneficio', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
            then(function (data) {

                if (data.messages) 
                    ScreenService.showMessage(data.messages[0].message, data.messages[0].type);
                
                else {
                    if (data.notifications && data.notifications[0].type === "success") {
                        ScreenService.showMessage(Messages.CALCULO_SUCCESS, 'SUCCESS');
                        ScreenService.closePopup();

                        if(tpcalc === 'DIARIO') flagAbrirLancamentoBeneficio = true;

                    }else {
                        ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR('ERROR'), 'ERROR');
                    }
                }
                
                if(data && data.dataset && data.dataset.memoriaCalculo) ABUtilController.downloadArquivo(data.dataset.memoriaCalculo[0]);
                    
                if(data.dataset && data.dataset.calculoBeneficio && data.dataset.calculoBeneficio.length > 0){
                    var popUp = templateManager.container.getWidget('mensagens_calc_beneficio');
                    popUp.dataSource.data = data.dataset.calculoBeneficio;
                    ABUtilController.masterDetailOpenPopup(popUp);
                }else if(flagAbrirLancamentoBeneficio){
                    ScreenService.openWindow('product#hcm02016_vab_lancamentoBeneficio');
                }
            }).
            catch(function(e) {
                var error;
                if(!e.data || e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;

                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
    };
    
    this.abrirTelaLancamentoBeneficio = function(){
        if(flagAbrirLancamentoBeneficio) ScreenService.openWindow('product#hcm02016_vab_lancamentoBeneficio');
    };

    this.retroceder = function(widget, ABUtilController) {
        restEngine.post('/retrocederBeneficio', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
            then(function (data) {

                if(data.dataset && data.dataset.retrocessoCalculo && data.dataset.retrocessoCalculo.length > 0){
                    var popUp = templateManager.container.getWidget('mensagens_calc_beneficio');
                    popUp.dataSource.data = data.dataset.retrocessoCalculo;
                    ABUtilController.masterDetailOpenPopup(popUp);
                }                        
                
                if (data.messages) 
                    ScreenService.showMessage(data.messages[0].message, data.messages[0].type);
                
                else {
                    if (data.notifications && data.notifications[0].type === "success") {
                        ScreenService.showMessage(Messages.RETROCESSO_SUCCESS, 'SUCCESS');
                        ScreenService.closePopup();
                    }else {
                        ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR('ERROR'), 'ERROR');
                    }
                }    
            }).
            catch(function(e) {
                var error;
                if(!e.data || e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;

                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
    };

}

Configuration(function(ContextRegister) {
    ContextRegister.register('CalculoBeneficioService', CalculoBeneficioService);
});

// FILE: assets/js/services/CalculoValeTransporteService.js
/**
 * Created by felipesantos on 11/07/2016.
 */
function CalculoValeTransporteService (ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, Messages) {

    this.calcular = function(widget, ABUtilController) {
        restEngine.post('/calcularValeTransporte', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
            then(function (data) {
                if (data.messages) {
                    ScreenService.showMessage(data.messages[0].message, data.messages[0].type);
                } else if( data.dataset && data.dataset.calculoValeTransporte && data.dataset.calculoValeTransporte.length > 0 ){
                    if(data && data.dataset && data.dataset.memoriaCalculo) ABUtilController.downloadArquivo(data.dataset.memoriaCalculo[0]);
                    var popUp = templateManager.container.getWidget('mensagens_calc_valetransporte');
                    popUp.dataSource.data = data.dataset.calculoValeTransporte;
                    ABUtilController.masterDetailOpenPopup(popUp);
                    ScreenService.showMessage('Cálculo finalizado com alertas', 'WARNING');
                } else {
                    if(data && data.dataset && data.dataset.memoriaCalculo) ABUtilController.downloadArquivo(data.dataset.memoriaCalculo[0]);
                    
                    ScreenService.showMessage(Messages.CALCULO_SUCCESS, 'SUCCESS');
                    ScreenService.openWindow('product#hcm02011_vab_lancamentoValeTransporte');
                }
            }).
            catch(function(e) {
                var error;
                if(e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;

                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
    };

    this.retroceder = function(widget) {
        restEngine.post('/retrocederValeTransporte', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
            then(function (data) {
                if (data.messages) {
                    ScreenService.showMessage(data.messages[0].message, data.messages[0].type);
                }
                else {
                    ScreenService.showMessage(Messages.RETROCESSO_SUCCESS, 'SUCCESS');
                }
            }).
            catch(function(e) {
                var error;
                if(e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;

                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
    };

}

Configuration(function(ContextRegister) {
    ContextRegister.register('CalculoValeTransporteService', CalculoValeTransporteService);
});

// FILE: assets/js/services/CandidatosService.js
/**
 * Created by leonardocarvalho on 02/03/2016.
 */
function CandidatosService (ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine) {



}

Configuration(function(ContextRegister) {
    ContextRegister.register('CandidatosService', CandidatosService);
});

// FILE: assets/js/services/ContaContabilService.js
var ContaContabilService = function(ContaContabilRepository) {

	this.validaDataContaContabil = function(row, nomeData) {
		var dataFinal = row[nomeData];
		var dataAtual = moment();
		if (dataFinal) {
			var data = moment(dataFinal, 'DD/MM/YYYY');
			if (dataAtual.isAfter(data))
				return false;
			else
				return true;
		} else {
			return true;
		}
	};

	this.retornaMaiorConta = function(row) {
		return ContaContabilRepository.retornaMaiorConta(row);
	};

	this.verificaContaNivelAnterior = function(row) {
		var fiter = [{
			"name": "CDCONTCTBL",
			"operator": "=",
			"value": row.CDCONTANTE
		}];
		return ContaContabilRepository.verificaContaNivelAnterior(fiter);
	};

	this.validaPreenchimentonivel = function(cdcontctbl, mascara) {
		var arrayNivel = [];
		var tamanho = cdcontctbl.length;

		mascara.forEach(function(nivel) {
			arrayNivel.push(nivel.caracteres);
		});
		if (arrayNivel.indexOf(String(tamanho)) == -1)
			return false;
		else
			return true;

	};

	this.retornaNivelConta = function(cdcontctbl, mascara) {
		var cdnvcontctbl = '';
		var tamanho = cdcontctbl.length;
		mascara.forEach(function(nivel) {
			if (nivel.caracteres === String(tamanho))
				cdnvcontctbl = nivel.nivel;
		});
		return cdnvcontctbl;
	};

	this.retornaContaPai = function(cdcontctbl, nivel, mascara) {
		var cdcontante = null;
		var caracteresNivelAnterior = '';
		if (nivel > 1) {
			mascara.forEach(function(nivelAtual) {
				if (parseFloat(nivelAtual.nivel) === parseFloat(nivel) - 1)
					caracteresNivelAnterior = nivelAtual.caracteres;
			});
			cdcontante = cdcontctbl.substr(0, caracteresNivelAnterior);
			return cdcontante;
		} else
			return cdcontante;
	};

	this.verificaValores = function(row, mascara) {
		if (row.IDCONTCCUS === 'R')
			row.CDCONTCTBLANALI = '';

		if (row.CDCONTCTBLANALI)
			row.CDCONTCTBLANALI = row.CDCONTCTBLANALI.replace(/[^0-9]/g, '');

		if (row.IDTIPOCOME === ' ')
			row.IDTIPOCOME = null;


		if (parseFloat(row.CDNVCONTCTBL) === mascara.length)
			row.IDTIPOCONT = 'A';
		else
			row.IDTIPOCONT = 'S';

		row.CDCONTCTBL = row.CDCONTCTBL.replace(/[^0-9]/g, '');

	};

	this.validaIntervaloContas = function(contaInicial, contaFinal) {
		if (parseFloat(contaInicial.replace(/[^0-9]/g, '')) > parseFloat(contaFinal.replace(/[^0-9]/g, '')))
			return false;
		else
			return true;
	};

};

Configuration(function(ContextRegister) {
	ContextRegister.register('ContaContabilService', ContaContabilService);
});


// FILE: assets/js/services/ESocialService.js
/* jshint esversion: 6 */
function ESocialService(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, Messages, $window) {

    var self = this;
    
    var FILTROS = null;
    
    // Operações do eSocial'
    this.IDTRANSENVIO = 'ENVIAR'; //Enviar Evento
    this.IDTRANSCONSU = 'CONSULTAR'; //Consultar Status do evento
    this.IDTRANSREENV = 'REENVIAR'; //Reenviar Evento
    this.IDTRANSEXCLU = 'EXCLUSAO'; //Excluir Evento
    this.IDTRANSRETIF = 'RETIFICACAO'; //Retificar Evento
    
    this.nomesErrosInclusaoEventos = ["HCM09000_ESO_ENVIOS_NOT_FOUND_ERROR", "HCM09000_ESO_UNIQUE_ENVIO_ERROR"];
    this.eventosPeriodicosPendentes = [];
    this.namePopUp = "eventosNaoPeriodicosPendentes";
    
    this.setFields = function(actionName) {
        var widgetEnvios = templateManager.container.getWidget("envioCadastros");
        var FORM_FIELDS = [];
        var EDIT_FIELDS = [];
        var REQU_FIELDS = [];
        var DADO_FIELDS = [];
        
        switch (actionName) {
            case 'new':
                FORM_FIELDS = ['NRENVIO','DSVERSAO','NRTPAMBIENTE','NREVENTO_LIST','DSEVENTO','GERADEMONSTENVIO'];
                EDIT_FIELDS = ['NREVENTO_LIST'];
                REQU_FIELDS = ['NREVENTO_LIST'];
                DADO_FIELDS = [];
                break;
            case 'editar':
                FORM_FIELDS = ['NRENVIO','DSVERSAO','NRTPAMBIENTE','NMEVENTO','DSEVENTO','NRCHAVE','NRTABELA','DTMESCOMPETENC','IDOPERACAO','IDSTATUS','DTENVIO','IDEVENTO','DTRESPOSTA','NRRECIBO','DTPROCESSAMENTO','NRRECIBO2','CDERRO','DSOBSERVACAO', 'CDMATRICULAESOCIAL'];
                EDIT_FIELDS = ['NRRECIBO'];
                REQU_FIELDS = ['NRRECIBO'];
                DADO_FIELDS = ['NRCPFPESSOA', 'DSCDCHAVE', 'DSCHAVE'];
                break;
            default:
                FORM_FIELDS = ['NRENVIO','DSVERSAO','NRTPAMBIENTE','NMEVENTO','NRCHAVE','NRTABELA','IDOPERACAO','IDSTATUS', 'NRRECIBO','NRRECIBO2'];
                EDIT_FIELDS = ['NRENVIO','NMEVENTO','NRCHAVE','NRTABELA','IDOPERACAO','IDSTATUS','NRRECIBO','NRRECIBO2','CHAVEACTION'];
                REQU_FIELDS = [];
                DADO_FIELDS = ['NRCPFPESSOA', 'DSCDCHAVE', 'DSCHAVE'];
                break; 
        }
        
        widgetEnvios.fields.forEach(function(field){
            field.showOnForm = (FORM_FIELDS.indexOf(field.name) >= 0);
            field.readOnly = (EDIT_FIELDS.indexOf(field.name) == -1);
            field.validations = (REQU_FIELDS.indexOf(field.name) >= 0) ? {"required": true} : {};
        
            if(field.name == 'NRCPFPESSOA' || field.name == 'DSCDCHAVE' || field.name == 'DSCHAVE'){                    
                if((widgetEnvios.currentRow.IDGRUPO == 'P' || widgetEnvios.currentRow.IDGRUPO == 'N') && actionName != 'new'){
                    field.isVisible = true;
                }
            }
            
            if(field.name == 'CDMATRICULAESOCIAL' &&  widgetEnvios.currentRow.IDGRUPO == 'N' && actionName != 'new'){
                field.isVisible = true;
            }
            
            if (widgetEnvios.currentRow.IDGRUPO == 'P' && widgetEnvios.currentRow.NMEVENTO == 'S-1299') {
                if(field.name == 'IDFECHASMOVIMENT'){
                    field.isVisible = true;
                    field.showOnForm = true;
                    field.readOnly = false;
                    field.validations = {"required": true};
                }else if(field.name == 'IDOPERACAO' || field.name == 'IDSTATUS' || field.name == 'DTMESCOMPETENC'){
                    field.class = '3';
                }else if(field.name == 'NRRECIBO'){
                    field.validations = (widgetEnvios.currentRow.IDSTATUS == 'P' ? {} : {"required": true});
                }else if(field.name == 'NRTIPOMOVIMENT'){
                    
                    field.label = 'Indicativo Apuração';
                    field.dataSourceFilter[2].value = [1,4];
                    field.reload();
                }
            } else {
                if(field.name == 'IDFECHASMOVIMENT'){
                    field.isVisible = false;
                    field.showOnForm = false;
                    field.readOnly = true;
                    field.validations = {};
                }else if(field.name == 'IDOPERACAO' || field.name == 'IDSTATUS' || field.name == 'DTMESCOMPETENC'){
                    field.class = '4';
                    
                }else if(field.name == 'NRTIPOMOVIMENT'){
                    field.label = 'Tipo Movimento';
                    field.dataSourceFilter[2].value = [1,2,4,10,19,22];
                    field.reload();
                }
            }
        });
    };
    
    this.setEnvioCadastros = function(widget, ABUtilController, idGrupo) {
        restEngine.post('/setEnvioCadastros', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
            then(function (data) {
                var existeMensagemTradada;
                if (!Util.isUndefined(data.notifications) && data.notifications[0].type === "success") {
                    ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                    if (widget.currentRow.__is_new) {
                        if(data.messages){
                            existeMensagemTradada = this.validaSeMensagemExiste(data.messages[0].message);
                            if (existeMensagemTradada) {
                                data.messages[0].message = this.substituiNomesMensagens(existeMensagemTradada, data.messages[0].message);
                            }
                            ScreenService.alertNotification(Util.isUndefined(Messages[data.messages[0].message]) ? data.messages[0].message : Messages[data.messages[0].message], 10000);
                        }
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    } else {
                        ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                            
                        widget.backupRow = null;
                        widget.view();
                    }
                    self.unsetFiltroNovoEnvio();
                    self.setFields('');
                } else if (!Util.isUndefined(data.messages)) {
                    existeMensagemTradada = this.validaSeMensagemExiste(data.messages[0].message);
                    if (existeMensagemTradada) {
                        data.messages[0].message = this.substituiNomesMensagens(existeMensagemTradada, data.messages[0].message);
                    }
                    ScreenService.showMessage(Util.isUndefined(Messages[data.messages[0].message]) ? data.messages[0].message : Messages[data.messages[0].message], data.messages[0].type);
                } else {
                    ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                }
            }.bind(this)).
            catch(function(e) {
                var error;
                if(Util.isUndefined(e.data) && Util.isUndefined(e.data.error) && Util.isUndefined(e.message))
                    error = e;
                else if(!Util.isUndefined(e.message))
                    error = e.message;
                else
                    error = e.data.error;
                ScreenService.showMessage(Util.isUndefined(Messages[error]) ? error : Messages[error], 'ERROR');
            });
    };

    this.deleteEnvioCadastros = function(widget, ABUtilController) {
        var dataSet = [];
        var idOnlyOne = true;
        if (widget.dataSource.getCheckedRows().length > 0) {
            dataSet = widget.dataSource.getCheckedRows();
            idOnlyOne = false;
        } else {
            dataSet = [widget.currentRow];
        }
        restEngine.post('/deleteEnvioCadastros', {'requestType':'DataSet','dataset':dataSet}).
            then(function(data){
                if(data.notifications[0].type === "success"){
                    ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                    ABUtilController.blockCheckbox(widget.id, false);
                    if (idOnlyOne) {
                        ABUtilController.masterDetailVoltarList(widget);
                    }
                    widget.reload();
                } else {
                    ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                }
            }).
            catch(function(e) {
                var error;
                if(e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
    };

    // Função responsável pela transmissão de eventos para o eSocial
    // @param boolean validacaoPendencias: Se refere à opção de fazer a validação de possíveis eventos não periódicos pendentes de envio associados
    // aos vínculos dos eventos que estão sendo enviados. Essa validação, se marcada como true, só é realizada no backend para os eventos periódicos
    // S-1200 e S-1210. O dataSet 'pendenciasDeEnvioPeriodicos' também só é retornado caso existam pendências para os mesmos eventos.
    this.transmissao = function(widget, ABUtilController, idTransmissao, arrEventos, realizaVerificacao = true, realizaConsulta = false) {
        
        var nameWidget = widget.name;
        
        // Insere nos eventos do lote a propriedade que definirá se deverão ser realizadas a validação de pendências e consulta do retorno do evento
        arrEventos.forEach(function (evento) {
            evento.REALIZAVERIFICACAO = realizaVerificacao;
            evento.REALIZACONSULTA = realizaConsulta;
        });
        
        restEngine.post('/setTransmissaoESocial/' + idTransmissao, {'requestType': 'DataSet', 'dataset': arrEventos /*[arrEventos, {'REALIZACONSULTA': realizaConsulta}]*/}).
            then(function (data) {
                
                switch (nameWidget) {
                    
                    case self.namePopUp:    
                        // tratativa alternativa considerando o envio de não periódicos pendentes ao enviar S-1200 ou S-1210
                        var popUpPendencias = templateManager.container.getWidget(self.namePopUp);
                        var widgetEnvios = templateManager.container.getWidget('envioCadastros');
                        // var botaoTransmitir = templateManager.container.getWidget('eventosNaoPeriodicosPendentes');
                        
                        if (!Util.isUndefined(data.dataset) && !Util.isUndefined(data.dataset.setTransmissaoESocial) && data.dataset.setTransmissaoESocial.length >= 1) {
                            // mesagens são adequadas para aparecer em forma de aviso ao invés de utilizar a widget de mensagens
                            var mensagensGeradas = data.dataset.setTransmissaoESocial;
                            var mensagemTransmissao = '<b>Eventos pendentes não enviados! </b><br /><br />'; 
                            mensagemTransmissao += mensagensGeradas.map(function(mensagem) {
                                return '[EVENTO: ' + mensagem.NMEVENTO +  ' | CHAVE: ' + mensagem.NRCHAVE +  ']<br />' + mensagem.MSG; 
                            }).join('<br /><br />');
                            
                            ScreenService.showMessage(mensagemTransmissao);
                        } else if (!Util.isUndefined(data.messages)) {
                            // mostra mensagem retornada pelo processo
                            
                            var message = data.messages[0];
                            ScreenService.showMessage(Util.isUndefined(Messages[message.message]) ? message.message : Messages[message.message], message.type);
                            ABUtilController.masterDetailClosePopup(popUpPendencias);
                            widgetEnvios.reload();
                        } else {
                            ScreenService.showMessage(Messages.PROCESSO_ERROR);
                        }
                        break;
                    default:
                        // tratativa padrão do retorno do envio 
                        if (!Util.isUndefined(data.dataset)) {
                            var popUpPend = templateManager.container.getWidget("eventosNaoPeriodicosPendentes");
                            // se houverem pendencias no envio, essas tem preferencia sobre possíveis mensagens
                            if (!Util.isUndefined(data.dataset.pendenciasDeEnvioPeriodicos)) {
                                popUpPend.dataSource.data = data.dataset.pendenciasDeEnvioPeriodicos;
                                
                                // guarda informações necessárias na widget do popUp para posteriormente enviar o periódico, 
                                // após o operador avaliar as pendências encontradas
                                popUpPend.envioPeriodico = {
                                    'idTransmissao': idTransmissao,
                                    'arrEventos': arrEventos,
                                    'widget': widget
                                };
                                ABUtilController.masterDetailOpenPopup(popUpPend);
                                
                            } else if (!Util.isUndefined(data.dataset.setTransmissaoESocial) && data.dataset.setTransmissaoESocial.length >= 1) {
                                var popUp = templateManager.container.getWidget("mensagens");
                                popUp.getField('NRCHAVE').isVisible = true;
                                popUp.dataSource.data = data.dataset.setTransmissaoESocial;
                                ABUtilController.masterDetailOpenPopup(popUp);
                                popUp.getField('NMEVENTO').isVisible = true;
                            } 
                            
                        } else if (!Util.isUndefined(data.messages)) {
                            var definedMessage = data.messages[0];
                            ScreenService.showMessage(Util.isUndefined(Messages[definedMessage.message]) ? definedMessage.message : Messages[definedMessage.message], definedMessage.type);
                            if (definedMessage.type == 'M') {
                                ScreenService.closePopup(true);
                                if (!widget.inListMode()) {
                                    ABUtilController.masterDetailVoltarList(widget);
                                }
                                widget.reload();
                            }
                            ABUtilController.blockCheckbox(widget.id, false);
                        } else {
                            ScreenService.showMessage(Messages.PROCESSO_ERROR);
                        }
                    }
            }.bind(this)).
            catch(function(e) {
                var error;
                if(Util.isUndefined(e.data) && Util.isUndefined(e.data.error) && Util.isUndefined(e.message))
                    error = e;
                else if(!Util.isUndefined(e.message))
                    error = e.message;
                else
                    error = e.data.error;
                ScreenService.showMessage(Util.isUndefined(Messages[error]) ? Messages.CATCH_EXCEPTION_ERROR(error) : Messages[error], 'ERROR');
            });
    };

    this.gerarCargaInicial = function(widget, ABUtilController) {
        restEngine.post('/gerarCargaInicial', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
            then(function (data) {
                if(!Util.isUndefined(data.notifications) && data.notifications[0].type === "success"){
                    templateManager.container.getWidget("envioCadastros").activate();
                    templateManager.container.getWidget("envioCadastros").reload();
                    ScreenService.showMessage(Messages.HCM09000_ESO_CARGAINICIAL_SUCCESS);
                    ScreenService.closePopup();
                } else if (!Util.isUndefined(data.messages)) {
                    ScreenService.showMessage(Util.isUndefined(Messages[data.messages[0].message]) ? data.messages[0].message : Messages[data.messages[0].message], data.messages[0].type);
                } else {
                    ScreenService.showMessage(Messages.PROCESSO_ERROR);
                }
            }).
            catch(function(e) {
                var error;
                if(Util.isUndefined(e.data) && Util.isUndefined(e.data.error) && Util.isUndefined(e.message))
                    error = e;
                else if(!Util.isUndefined(e.message))
                    error = e.message;
                else
                    error = e.data.error;
                ScreenService.showMessage(Util.isUndefined(Messages[error]) ? error : Messages[error], 'ERROR');
            });
    };

    this.excluirDadosEmpregador = function(widget, ABUtilController) {
        restEngine.post('/excluirDadosEmpregador', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
            then(function (data) {
                if(!Util.isUndefined(data.notifications) && data.notifications[0].type === "success"){
                    templateManager.container.getWidget("envioCadastros").activate();
                    templateManager.container.getWidget("envioCadastros").reload();
                    ScreenService.closePopup();
                }
                if (!Util.isUndefined(data.messages)) {
                    ScreenService.showMessage(Util.isUndefined(Messages[data.messages[0].message]) ? data.messages[0].message : Messages[data.messages[0].message], data.messages[0].type);
                    if (data.messages[0].type == 'W') {
                        templateManager.container.getWidget("envioCadastros").activate();
                        templateManager.container.getWidget("envioCadastros").reload();
                        ScreenService.closePopup();
                    }
                } else {
                    ScreenService.showMessage(Messages.PROCESSO_ERROR);
                }
            }).
            catch(function(e) {
                var error;
                if(Util.isUndefined(e.data) && Util.isUndefined(e.data.error) && Util.isUndefined(e.message))
                    error = e;
                else if(!Util.isUndefined(e.message))
                    error = e.message;
                else
                    error = e.data.error;
                ScreenService.showMessage(Util.isUndefined(Messages[error]) ? error : Messages[error], 'ERROR');
            });
    };

    this.envioAutomaticoEventos = function(widget, ABUtilController, realizaVerificacao = true) {
        
        // var nameWidget = widget.name;
        widget.currentRow.REALIZAVERIFICACAO = realizaVerificacao;
        restEngine.post('/envioAutomaticoEventos', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
            then(function (data) {
                // tratativa padrão para a visualização do retorno da rotina de envioAutomático
                if (!Util.isUndefined(data.dataset)) {
                    if (data.notifications[0].type === "success") {
                        ScreenService.successNotification(Messages.HCM09000_ESO_TRANSMISSAO_SUCCESS);
                    } else {
                        ScreenService.alertNotification(Messages.HCM09000_ESO_ENVIOAUTO_WARNING);
                    }
                        
                    // se houverem pendencias no envio, essas tem preferencia sobre possíveis mensagens                    
                    if (!Util.isUndefined(data.dataset.pendenciasDeEnvioPeriodicos)) {
                        var popUpPend = templateManager.container.getWidget("eventosNaoPeriodicosPendentes");
                        popUpPend.dataSource.data = data.dataset.pendenciasDeEnvioPeriodicos;
                        ABUtilController.masterDetailOpenPopup(popUpPend);
                        popUpPend.envioPeriodico = {
                            'widget': widget
                        };
                        ABUtilController.masterDetailOpenPopup(popUpPend);
                    } else if (data.dataset.setTransmissaoESocial.length >= 1) {
                        var popUp = templateManager.container.getWidget("mensagens");
                        popUp.getField('NMEVENTO').isVisible = true;
                        popUp.getField('NRCHAVE').isVisible = true;
                        popUp.dataSource.data = data.dataset.setTransmissaoESocial;
                        ABUtilController.masterDetailOpenPopup(popUp);
                    }
                    if (!Util.isUndefined(data.messages)){
                        ScreenService.showMessage(Util.isUndefined(Messages[data.messages[0].message]) ? data.messages[0].message : Messages[data.messages[0].message], data.messages[0].type);
                    } 
                    
                } else if(!Util.isUndefined(data.notifications)){
                    if (data.notifications[0].type === "success") {
                        ABUtilController.masterDetailClosePopup(widget);
                        templateManager.container.getWidget("envioCadastros").activate();
                        templateManager.container.getWidget("envioCadastros").reload();
                        ScreenService.showMessage(Messages.HCM09000_ESO_TRANSMISSAO_SUCCESS);
                    } else {
                        ABUtilController.masterDetailClosePopup(widget);
                        templateManager.container.getWidget("envioCadastros").activate();
                        templateManager.container.getWidget("envioCadastros").reload();
                        ScreenService.showMessage(Messages.HCM09000_ESO_ENVIOAUTO_WARNING);
                    }
                } else if (!Util.isUndefined(data.messages)) {
                    var message = data.messages[0];
                    ScreenService.showMessage(Util.isUndefined(Messages[message.message]) ? message.message : Messages[message.message], message.type);
                } else {
                    ScreenService.showMessage(Messages.PROCESSO_ERROR);
                }
            }).
            catch(function(e) {
                var error;
                if(Util.isUndefined(e.data) && Util.isUndefined(e.data.error) && Util.isUndefined(e.message))
                    error = e;
                else if(!Util.isUndefined(e.message))
                    error = e.message;
                else
                    error = e.data.error;
                ScreenService.showMessage(Util.isUndefined(Messages[error]) ? error : Messages[error], 'ERROR');
            });
    };

    this.consultaAutomaticaEventos = function(widget, ABUtilController) {
        restEngine.post('/consultaAutomaticaEventos', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
            then(function (data) {
                if(!Util.isUndefined(data.notifications)){
                    if (data.notifications[0].type === "success") {
                        ABUtilController.masterDetailClosePopup(widget);
                        templateManager.container.getWidget("envioCadastros").activate();
                        templateManager.container.getWidget("envioCadastros").reload();
                        ScreenService.showMessage(Messages.HCM09000_ESO_CONSULTA_SUCCESS);
                    } else {
                        ABUtilController.masterDetailClosePopup(widget);
                        templateManager.container.getWidget("envioCadastros").activate();
                        templateManager.container.getWidget("envioCadastros").reload();
                        ScreenService.showMessage(Messages.HCM09000_ESO_ENVIOAUTO_WARNING);
                    }
                } else if (!Util.isUndefined(data.messages)) {
                    ScreenService.showMessage(Util.isUndefined(Messages[data.messages[0].message]) ? data.messages[0].message : Messages[data.messages[0].message], data.messages[0].type);
                } else {
                    ScreenService.showMessage(Messages.PROCESSO_ERROR);
                }
            }).
            catch(function(e) {
                var error;
                if(Util.isUndefined(e.data) && Util.isUndefined(e.data.error) && Util.isUndefined(e.message))
                    error = e;
                else if(!Util.isUndefined(e.message))
                    error = e.message;
                else
                    error = e.data.error;
                ScreenService.showMessage(Util.isUndefined(Messages[error]) ? error : Messages[error], 'ERROR');
            });
    };

    this.fechamentoPeriodico = function(widget, ABUtilController) {
        restEngine.post('/fechamentoPeriodico', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
            then(function (data) {
                if (!Util.isUndefined(data.dataset) && data.dataset.fechamentoPeriodico.length >= 1) {
                    var popUp = templateManager.container.getWidget("mensagens");
                    popUp.getField('NMEVENTO').isVisible = false;
                    popUp.getField('NRCHAVE').isVisible = false;
                    popUp.dataSource.data = data.dataset.fechamentoPeriodico;
                    ABUtilController.masterDetailOpenPopup(popUp);
                } else if (!Util.isUndefined(data.notifications)){
                    if (data.notifications[0].type === "success") {
                        ScreenService.closePopup(true);
                        templateManager.container.getWidget("envioCadastros").reload();
                        var mensagem = '';
                        if (!Util.isUndefined(data.messages)) {
                            mensagem = Util.isUndefined(Messages[data.messages[0].message]) ? data.messages[0].message : Messages[data.messages[0].message];
                        }
                        ScreenService.showMessage(Messages.SAVE_ROW_SUCCESS + (mensagem ? '<br />' + mensagem : ''), data.messages[0].type);
                    } else {
                        ScreenService.closePopup(true);
                        templateManager.container.getWidget("envioCadastros").reload();
                        ScreenService.showMessage(Messages.HCM09000_ESO_FECHAMENTO_WARNING);
                    }
                } else if (!Util.isUndefined(data.messages)) {
                    ScreenService.showMessage(Util.isUndefined(Messages[data.messages[0].message]) ? data.messages[0].message : Messages[data.messages[0].message], data.messages[0].type);
                } else {
                    ScreenService.showMessage(Messages.PROCESSO_ERROR);
                }
            }).
            catch(function(e) {
                var error;
                if(Util.isUndefined(e.data) && Util.isUndefined(e.data.error) && Util.isUndefined(e.message))
                    error = e;
                else if(!Util.isUndefined(e.message))
                    error = e.message;
                else
                    error = e.data.error;
                ScreenService.showMessage(Util.isUndefined(Messages[error]) ? error : Messages[error], 'ERROR');
            });
    };

    this.reaberturaPeriodico = function(widget, ABUtilController) {
        restEngine.post('/reaberturaPeriodico', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
            then(function (data) {
                if (!Util.isUndefined(data.dataset) && data.dataset.reaberturaPeriodico.length >= 1) {
                    var popUp = templateManager.container.getWidget("mensagens");
                    popUp.getField('NMEVENTO').isVisible = false;
                    popUp.getField('NRCHAVE').isVisible = false;
                    popUp.dataSource.data = data.dataset.reaberturaPeriodico;
                    ABUtilController.masterDetailOpenPopup(popUp);
                } else if (!Util.isUndefined(data.notifications)){
                    if (data.notifications[0].type === "success") {
                        ScreenService.closePopup(true);
                        templateManager.container.getWidget("envioCadastros").reload();
                        ScreenService.showMessage(Messages.SAVE_ROW_SUCCESS);
                    } else {
                        ScreenService.closePopup(true);
                        templateManager.container.getWidget("envioCadastros").reload();
                        ScreenService.showMessage(Messages.HCM09000_ESO_FECHAMENTO_WARNING);
                    }
                } else if (!Util.isUndefined(data.messages)) {
                    ScreenService.showMessage(Util.isUndefined(Messages[data.messages[0].message]) ? data.messages[0].message : Messages[data.messages[0].message], data.messages[0].type);
                } else {
                    ScreenService.showMessage(Messages.PROCESSO_ERROR);
                }
            }).
            catch(function(e) {
                var error;
                if(Util.isUndefined(e.data) && Util.isUndefined(e.data.error) && Util.isUndefined(e.message))
                    error = e;
                else if(!Util.isUndefined(e.message))
                    error = e.message;
                else
                    error = e.data.error;
                ScreenService.showMessage(Util.isUndefined(Messages[error]) ? error : Messages[error], 'ERROR');
            });
    };
    
    this.unsetFiltroNovoEnvio = function() {
        var widgetEnvios = templateManager.container.getWidget("envioCadastros");
        widgetEnvios.fields.forEach(function(field){
            if (!Util.isUndefined(field.fieldGroup) && field.fieldGroup == 'FILTRO' && !Util.isUndefined(self.FILTROS[field.name])) {
                field.isVisible = false;
            }
            // if(field.name == 'NREVENTO'){
            //     field.isVisible = false;
            //     field.showOnForm = false;
            // }
        });
    };
    
    this.setEnvioAtivo = function(widget, ABUtilController){
        restEngine.post('/ativaEvento', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
            then(function (data) {
                if(data.notifications[0].type === "success"){
                    ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                    ABUtilController.masterDetailVoltarList(widget);
                    ScreenService.closePopup();
                    ABUtilController.blockCheckbox(widget.id, false);
                    widget.reload();
                } else {
                    ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                }
            });
    };
    
    this.getArquivoXML = function(eventos) {
        //Função que recebe dados que identificam os arquivos gerados pelo sistema HCM para eventos do eSocial para permitir o download dos mesmos
        
        restEngine.post('/getArquivoXML', {'requestType': 'DataSet', 'dataset': [eventos]}).
            then(function (data) {
                var arquivos = data.dataset.arquivos;
                var erros = '';
                for (var arquivo in arquivos){
                    if(arquivos[arquivo].ERRO){
                        erros += arquivos[arquivo].ERRO;
                    } else {
                        $window.open($window.serviceUrl + "/abrirArquivo?requestType=DataSet&dataset[0][CMARQUIVO]=" + arquivos[arquivo].NMARQUIVO);
                    }
                }
                if(erros){
                  ScreenService.showMessage(erros, 'ERROR');  
                } 
            }).
            catch(function(e) {
                var error;
                if(Util.isUndefined(e.data) && Util.isUndefined(e.data.error) && Util.isUndefined(e.message))
                    error = e;
                else if(!Util.isUndefined(e.message))
                    error = e.message;
                else
                    error = e.data.error;
                ScreenService.showMessage(Util.isUndefined(Messages[error]) ? error : Messages[error], 'ERROR');
            });
    };
    
    this.validaSeMensagemExiste = function (mensagem) {
        var mensagemEncontrada = [];
        this.nomesErrosInclusaoEventos.forEach(function(mensagemAtual){
            if (mensagem.indexOf(mensagemAtual) !== -1) {
                mensagemEncontrada.push(mensagemAtual);
            }
        });
        return mensagemEncontrada.length > 0 ? mensagemEncontrada : false;
    };
    
    this.substituiNomesMensagens = function (nomesEncontrados, mensagem) {
        nomesEncontrados.forEach(function(nome){
            mensagem = mensagem.replace(new RegExp(nome, 'g'), Messages[nome]);
        }.bind(this));
        return mensagem;
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('ESocialService', ESocialService);
});

// FILE: assets/js/services/PerfilAcessoService.js
function PerfilAcessoService(restEngine) {

    var self = this;

    self.sync = function () {
        return restEngine.post("/zhu_acl_element_rules/sync", undefined, undefined, undefined, undefined, undefined, 90000);
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('PerfilAcessoService', PerfilAcessoService);
});

// FILE: assets/js/services/ProcessosServices.js
/**
 * Created by leonardocarvalho on 29/02/2016.
 */
function ProcessosServices(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine) {

    this.adicionarUpdateProcesso = function(dataProcesso) {

        dataProcesso.changed = true;
        return localStorageEngine.setDataSource('/adicionarUpdateProcesso', dataProcesso, function () {
            return localStorageEngine.saveInServer('/adicionarUpdateProcesso').then(function(data) {
                if (!Util.isUndefinedOrNull(data.dataset.save)) {
                    if (data.dataset.save[0] == 'save')
                        ScreenService.successNotification("Processo inserido com sucesso", 10000);
                    else
                        ScreenService.successNotification("Processo atualizado com sucesso", 10000);

                    var widgetProcessos = templateManager.container.getWidget('processos');
                    widgetProcessos.reload().then(function() {
                        if(dataProcesso.update === false){
                            ScreenService.closeSwipe();
                        }
                        //ScreenService.closePopup(true);
                        widgetProcessos.activate();
                    });
                } else {
                    ScreenService.showMessage(data);
                }
            });
        })/*.catch(function(e) {
            ScreenService.showMessage('Ocorreu um erro inesperado, contate o administrador informando o trecho abaixo: <br><br>' + e.data.error + '<br><br>', 'ERROR');
        })*/;

    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('ProcessosServices', ProcessosServices);
});

// FILE: assets/js/services/RelatoriosHcmService.js
/* jshint esversion: 6 */
function RelatoriosHcmService (ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, Messages, RelatoriosHcmConfig) {
/**
 * Created by Rafael Pickbrenner on 25/10/2016.
 * Funcionalidades para as telas dos relatórios do HCM.
 * Funções de manipulação de show/hide, required/not required e validtae dos fields da tela de relatórios.
 * As configurações constam no /hcm/mobile/assets/js/utilities/RelatoriosHcmConfig.js
 * A rotina de importação da remessão é tratada no gerarRelatorio()
 */
    
    var REPORTS = RelatoriosHcmConfig.REPORTS;
    this.REPORTS_SELECTED = {};
    var LISTNAME = RelatoriosHcmConfig.LISTNAME;
    var DEFINITION = RelatoriosHcmConfig.DEFINITION;
    var DEFINITIONRCB = RelatoriosHcmConfig.DEFINITIONRCB;
    
    /*Exibi mensagem de tela não registra no objeto reports ou requeri ao utilizador que abara a tela a partir do menu*/
    this.msgTelaNaoRegistrada = function(nmTela) {
        var msg;
        if(nmTela == null){ //Caso a tela seja acessada diretamente do browser, sem passar por um menu.
            msg = "Por favor, acesse a tela de relatórios a partir de um menu.";
        } else {
            msg = "A tela " + nmTela + " não está registrada no objeto REPORTS.";
        }
        return msg;
    };
    
    /*Cria e ajusta o data source do field NMRELATORIO de acordo com o container e as configurações do relatório no objeto REPORTS*/
    this.setDataSourceAndLabel = function(owner, nrOrg, nrOrgPadrao, nmTela) {
        //Verifica se a tela está registrada
        if(!REPORTS.hasOwnProperty(nmTela)){
            owner.container.label = ""; //Label para o container caso a tela não esteja registrada
            return this.msgTelaNaoRegistrada(nmTela);
        }
        
        //Label do container (tela)
        owner.container.label = REPORTS[nmTela].label;
        
        //Monta o data source com os labels dos relatórios e os valores internos, da org padrão e da org de trabalho
        var data = [];
        var nmRelatOrg = []; //variável criada para verificar relatórios diferentes dos de org padrão e evitar a duplicação
        for(var i in REPORTS[nmTela][nrOrg]){
            nmRelatOrg.push(i);
            data.push( {"name": REPORTS[nmTela][nrOrg][i].config.itemName, "value": i, "order": REPORTS[nmTela][nrOrg][i].config.order } );
        }
        for(i in REPORTS[nmTela][nrOrgPadrao]){
            if(!nmRelatOrg.includes(i)) //não insere da orgPadrão caso exista relatório modificado para cliente
                data.push( {"name": REPORTS[nmTela][nrOrgPadrao][i].config.itemName, "value": i, "order": REPORTS[nmTela][nrOrgPadrao][i].config.order } );
        }
        
        //Verifica se existe relatórios na org padrão e de trabalho para a tela especificada
        if(data.length === 0) {
            return "A tela " + nmTela + " não possui relatórios.";
        }
        
        //Ordenando o array/objeto
        data.sort(function(a, b) {
            a = a.order; //Este é o 'order' do objeto 'config'
            b = b.order;
            return a - b;}
        );
        
        //Ajusta o datasource do campo de lista dos relatórios
        owner.getField(LISTNAME).dataSource.data = data;
        
        //Limpa a selação do campo de relatório e ordena a ocultar os campos desnecessários
        owner.getField(LISTNAME).clearValue();
        this.setExibicaoCampos(owner.container.widgets[0], this.nrOrg, this.nrOrgPadrao, this.nmTela, "");
        
        return true;
    };
    
    /*Ajusta a visibilidade, requerido ou não requerido e o label (se necessário) de acordo com o relatório selecionado*/
    this.setExibicaoCampos = function(widget, nrOrg, nrOrgPadrao, nmTela, nmReport) {
        //Restaura todos os campos para invisíveis
        for(var i in widget.fields)
        {
            widget.fields[i].isVisible   = false;
            widget.fields[i].validations = {}; //Campo ajustado para não required
        }
        widget.getField(LISTNAME).isVisible = true; //O campo de lista de relatórios deve ficar visível
        
        //Restaura os labels originais dos campos e o 'required' para não
        // for(i in DEFINITION)
        // {
        //     widget.getField(DEFINITION[i].name).label       = DEFINITION[i].label;
        //     widget.getField(DEFINITION[i].name).validations = {}; //Campo ajustado para não required
        // }

        //Verifica se há algum relatório selecionado
        if(nmReport === "" || nmReport === null)
        {
            return true;
        }
        
        //Verifica se a tela está registrada
        if(!REPORTS.hasOwnProperty(nmTela))
        {
            return this.msgTelaNaoRegistrada(nmTela);
        }
        
        //Monta um array com os relatórios selecionados
        this.REPORTS_SELECTED = {}; //Reseta o objeto de relatórios
        for(i in nmReport)
        {
            var aux = this.getNrorgReport(nmTela, nrOrg, nrOrgPadrao, nmReport[i]); //Retorna o nrorg do relatório (padrão ou org do cliente)
            if(aux == -1)
            {
                return "O relatório não está disponível.";
            }
            this.REPORTS_SELECTED[nmReport[i]] = REPORTS[nmTela][aux][nmReport[i]];  //Armazena os relatórios selecionados
        }
        
        //Percorre os relatórios selecionados para percorrer os fields dos mesmos e monta o array de configurações
        // var fieldName;
        // var rowName;
        var FIELDS_CONFIG = {}; //Configurações MESCLADAS de todos os fields de TODOS os relatórios selecionados
        var PARAMS;
        var labelAux;
        for(var key in this.REPORTS_SELECTED)
        {
            PARAMS = this.REPORTS_SELECTED[key].params; //Todos os fields do report em questão

            for(i in PARAMS) //Percorre todos os fields do relatório
            {
                if(PARAMS[i].hasOwnProperty('field')) //Verifica se há field no relatório selecionado
                {
                    //Verifica se o FIELD já existe (se já está setado) em FIELDS_CONFIG...
                    if(FIELDS_CONFIG.hasOwnProperty(PARAMS[i].field.name))
                    { //O FIELD do campo já está setado em FIELDS_CONFIG...
                        
                        //Adquiri o label personalizado ou o padrão, nesta ordem de prioridade.
                        labelAux = PARAMS[i].hasOwnProperty('label') ? PARAMS[i].label : PARAMS[i].field.label;
                        //Procura na LABEL do FIELD se há um valor igual
                        if(FIELDS_CONFIG[PARAMS[i].field.name].label.search(labelAux) < 0 )
                        {
                            FIELDS_CONFIG[PARAMS[i].field.name].label += " \\ " + labelAux;
                        }
                    } else { //Primeira vez que este FIELD é setado
                        
                        //Verifica se existe configuração de Label ou se deve usar o label padrão
                        if(PARAMS[i].hasOwnProperty('label'))
                        { //Label personalizado
                            FIELDS_CONFIG[PARAMS[i].field.name] = { 'label': PARAMS[i].label };
                        } else { //Label padrão
                            FIELDS_CONFIG[PARAMS[i].field.name] = { 'label': PARAMS[i].field.label };
                        }
                    }
                
                    //Ajusta o required. Basta que um relatório tenha o campo required que este campo será required para os demais relatórios
                    if(PARAMS[i].hasOwnProperty('required'))
                    {
                        if(PARAMS[i].required)
                        {
                            FIELDS_CONFIG[PARAMS[i].field.name].required = true;
                        }
                    } else {
                        if(!FIELDS_CONFIG[PARAMS[i].field.name].hasOwnProperty('required')) //apenas seta como false se não existir valor pre-selecionado
                            FIELDS_CONFIG[PARAMS[i].field.name].required = false;
                    }
                    
                    //Ajusta o dataList caso este exista
                    FIELDS_CONFIG[PARAMS[i].field.name].dataList         = PARAMS[i].hasOwnProperty('dataList')         ? PARAMS[i].dataList         : null;
                    
                    //Valor padrão. Verifica se existi um valor para o campo
                    FIELDS_CONFIG[PARAMS[i].field.name].valueField       = PARAMS[i].hasOwnProperty('valueField')       ? PARAMS[i].valueField       : null;
                    
                    //Valor padrão. Verifica se existi um valor para a row (geralemnte trabalha em conjunto com o campo acima)
                    FIELDS_CONFIG[PARAMS[i].field.name].descriptionField = PARAMS[i].hasOwnProperty('descriptionField') ? PARAMS[i].descriptionField : null;
                    
                    //Nome da row do campo
                    FIELDS_CONFIG[PARAMS[i].field.name].row              = PARAMS[i].field.row;
                }
            }
        }
        
        if(nmReport.length == 1)
        {
            var objConfig;
            if(REPORTS[nmTela].hasOwnProperty(nrOrg))
            {
                if(REPORTS[nmTela][nrOrg].hasOwnProperty(nmReport[0]))
                {
                    objConfig = REPORTS[nmTela][nrOrg][nmReport[0]].config; //Adquiri os configurações do relatório em questão na org do cliente
                    
                    // verifica visibilidade da action de enviar e-mail
                    widget.getAction("sendEmail").isVisible = false;
                    if(objConfig.hasOwnProperty('sendEmail'))
                    {
                        if (objConfig.sendEmail)
                            widget.getAction("sendEmail").isVisible = true;
                    }
                }
            } else {
                objConfig = REPORTS[nmTela][nrOrgPadrao][nmReport[0]].config; //Adquiri os configurações do relatório em questão na org padrão
                
                // verifica visibilidade da action de enviar e-mail (BIS)
                widget.getAction("sendEmail").isVisible = false;
                if(objConfig.hasOwnProperty('sendEmail'))
                {
                    if (objConfig.sendEmail)
                        widget.getAction("sendEmail").isVisible = true;
                }
            }
        }   
        
        //Percorre a lista de FIELD usados pelos relatórios selecionados para ajustar os campos usados por ele na tela.
        for(i in FIELDS_CONFIG)
        {
            //Visbility
            widget.getField(i).isVisible = true; //Todos os campos que o relatório precisa serão visíveis
            if(i == "DTMESCOMPETENCIA")
                widget.getField("DTMESCOMPETENCIAFIM").isVisible = true;
            
            //Required
            widget.getField(i).validations = FIELDS_CONFIG[i].required ? {"required": true} : {} ;
            
            //Label
            widget.getField(i).label = FIELDS_CONFIG[i].label;
            
            //Associa um dataSource personalidado. NEM TODOS OS FIELDS POSSUEM ESSA PROPRIEDADE!
            if(FIELDS_CONFIG[i].dataList != null)
            {
                widget.getField(i).dataSource.data = FIELDS_CONFIG[i].dataList;
            }else if (i.substring(0,8) == 'NMOPCOES'){
                widget.getField(i).dataSource.data =  [
                            {
                                "value": "S",
                                "name": "Sim"
                            },
                            {
                                "value": "N",
                                "name": "Não"
                            }
                        ];
            } 
            
            //Valor padrão. Verifica se existi um valor para o campo
            if(FIELDS_CONFIG[i].valueField != null)
            {
                widget.currentRow[FIELDS_CONFIG[i].row] = FIELDS_CONFIG[i].valueField;
            }
            
            //Valor padrão. Verifica se existi um valor para a row
            if(FIELDS_CONFIG[i].descriptionField != null)
            {
                widget.currentRow[i] = FIELDS_CONFIG[i].descriptionField;
            }
        }

        return true; //Indica que a solicitação foi atendida
    };
    
    //Retorna a organização do relatório (cliente ou padrão). Nomes iguais de relatórios a org do cliente tem prioridade.
    this.getNrorgReport = function(nmTela, nrOrg, nrOrgPadrao, nmReport) {
        if(REPORTS[nmTela].hasOwnProperty(nrOrg))   //Verifica se existe relatorio na org do cliente (prioridade)
        {
            if(REPORTS[nmTela][nrOrg].hasOwnProperty(nmReport))
            {
                return nrOrg;
            }
        }
        if(REPORTS[nmTela].hasOwnProperty(nrOrgPadrao))   //Verifica se existe relatorio na org do cliente (prioridade)
        {
            if(REPORTS[nmTela][nrOrgPadrao].hasOwnProperty(nmReport))
            {
                return nrOrgPadrao;
            }
        }
        return -1; //Se chegou aqui sugnifica que o relatório requerido não consta no array
    };
    
    this.setExibicaoCampos_RCB = function(widget, nrOrg, nrOrgPadrao, nmTela, nmReport) {
        //Restaura todos os campos para invisíveis
        for(var i in widget.fields)
        {
            widget.fields[i].isVisible = false;
        }
        widget.getField(LISTNAME).isVisible = true; //O campo de lista de relatórios deve ficar visível
        
        //Restaura os labels originais dos campos e o 'required' para não
        for(i in DEFINITIONRCB)
        {
            widget.getField(DEFINITIONRCB[i].name).label       = DEFINITIONRCB[i].label;
            widget.getField(DEFINITIONRCB[i].name).validations = {}; //Campo ajustado para não required
        }

        //Verifica se há algum relatório selecionado
        if(nmReport === "" || nmReport === null)
        {
            return true;
        }
        
        //Verifica se a tela está registrada
        if(!REPORTS.hasOwnProperty(nmTela))
        {
            return this.msgTelaNaoRegistrada(nmTela);
        }
        
        //Verifica se existe relatórios específicos para esta organização e ajusta o nrOrg para padrão ou org do cliente
        if(REPORTS[nmTela].hasOwnProperty(nrOrgPadrao))
        {
            if(REPORTS[nmTela][nrOrgPadrao].hasOwnProperty(nmReport) && (!REPORTS[nmTela][nrOrg] || !REPORTS[nmTela][nrOrg].hasOwnProperty(nmReport)))
            {
                nrOrg = nrOrgPadrao;
            }
        }
        
        //Verifica se o relatório não existe na organização padrão e na tela especificada
        if(!REPORTS[nmTela][nrOrg].hasOwnProperty(nmReport))
        {
            return "O relatório não está disponível.";
        }
        
        //Percorre o objeto em busca do relatório na organização de trabalho
        var objParams = REPORTS[nmTela][nrOrg][nmReport].params; //Adquiri os parâmetros do relatório em questão
        var objConfig = REPORTS[nmTela][nrOrg][nmReport].config; //Adquiri os configurações do relatório em questão
        var fieldName;
        var rowName;

        // verifica visibilidade da action de enviar e-mail
        widget.getAction("sendEmail").isVisible = false;
        if(objConfig.hasOwnProperty('sendEmail'))
        {
            if (objConfig.sendEmail)
                widget.getAction("sendEmail").isVisible = true;
        }

        for(var key in objParams) //Loop para adquirir todos os parâmetros do relatório e ajustá-los na tela
        {            
            //Verifica se existe definições para o field/row em questão
            if(objParams[key].hasOwnProperty('field'))
            {
                fieldName = objParams[key].field.name;
                rowName   = objParams[key].field.row;
                widget.getField(fieldName).isVisible = true; //Todos os campos que o relatório precisa serão visíveis
            } else {
                fieldName = null; //Indica que não existe field
            }
            
            //Verifica se a propriedade 'required' existe. Caso não exista esta propriedade será criada com valor 'false' (não required).
            if(!objParams[key].hasOwnProperty('required'))
            {
                objParams[key].required = false; //Propriedade de required não existe, campo ajustado para não required
            }
            
            //Somente marca required/ não required se o field existir na tela (testa pelo fieldName)
            if(objParams[key].required && fieldName !== null)
            {
                widget.getField(fieldName).validations = {"required": objParams[key].required}; //Propriedade de required ajustada, campo ajustado para o mesmo valor
            }
            
            //Verifica se existe a propriedade de label e se a mesma está ajustada
            if(objParams[key].hasOwnProperty('label') && fieldName !== null)
            {
                widget.getField(fieldName).label = objParams[key].label;
            }
            
            //Para os campos de opções: Monta o data source com os labels/valores das opções
            if(objParams[key].hasOwnProperty('dataList'))
            {
                widget.getField(fieldName).dataSource.data = objParams[key].dataList;
            }
            
            //Valor padrão. Verifica se existi um valor para o campo
            if(objParams[key].hasOwnProperty('valueField'))
            {
                widget.currentRow[rowName] = objParams[key].valueField;
            }
            
            //Valor padrão. Verifica se existi um valor para a row
            if(objParams[key].hasOwnProperty('descriptionField'))
            {
                widget.currentRow[fieldName] = objParams[key].descriptionField;
            }
        }
        return true; //Indica que a solicitação foi atendida
    };
    
    /*Gera o relatório em questão*/
    this.gerarRelatorio = function (widget, nrOrg, nrOrgPadrao, nmTela, nmReport, abUtil, sendEmail) {
        
        //Verifica se existe relatório a ser gerado
        if(nmReport === null || nmReport === ""){
            return "Por favor selecione um relatório.";
        }
        
        if(widget.currentRow.DTMESCOMPETENCIAFIM != undefined && widget.currentRow.DTMESCOMPETENCIAFIM != null && widget.currentRow.DTMESCOMPETENCIAFIM != ""){
            if(moment(widget.currentRow.DTMESCOMPETENCIA,'DD/MM/YYYY').isAfter(moment(widget.currentRow.DTMESCOMPETENCIAFIM,'DD/MM/YYYY')))
                return "Data final menor que a inicial";
        } else {
            widget.currentRow.DTMESCOMPETENCIAFIM = widget.currentRow.DTMESCOMPETENCIA;
        }
        
        //Verifica se os campos requeridos estão preenchidos
        if(!widget.isValid()){
            return true;
        }
        
        //Verifica se a tela está registrada
        if(!REPORTS.hasOwnProperty(nmTela)){
            return this.msgTelaNaoRegistrada(nmTela);
        }
        var dtCompetenc = widget.currentRow.DTMESCOMPETENCIA;
        
        //Monta a row com o reportMapping percorrendo os objetos de campos do relatório em questão
        var row = {};
        var map = {};
        var rowName;
        var rowValue;
        var objParams;
        var objConfig;
        var req = {}; //Recebe a row como elemento de um array para ser processada no backend
        var i = -1; //Contador de relatórios para a verificação / id de múltiplos relatórios (idLote, ver após o for() abaixo)
        
        
        for(var report in this.REPORTS_SELECTED){
        var j = -1;
        req[report] = {};
            do{
                i++;j++;
                
                //Adquiri os parâmetros e configurações do relatório em questão
                objParams = this.REPORTS_SELECTED[report].params;
                objConfig = this.REPORTS_SELECTED[report].config;
                row = {}; //Reset para o próximo relatório
                map = {};
                for(var key in objParams)
                {
                    //Adquiri o nome da row
                    rowName = null;
                    if(objParams[key].hasOwnProperty('field')) //Verifica se existem definições para os campos
                    {
                        rowName = objParams[key].field.row;
                    }
                    if(objParams[key].hasOwnProperty('row')) //Verifica se existe row ajustada manualmente (row 'personalizada')
                    {
                        rowName = objParams[key].row;
                    }
                    
                    //Adquiri o valor da row
                    rowValue = null;
                    if(widget.currentRow.hasOwnProperty(rowName)) //Adquiri o valor da row caso ela exista
                    {
                        if(objParams[key].hasOwnProperty('field'))
                        {
                            if(objParams[key].field.hasOwnProperty('multi'))
                            {
                                if(objParams[key].field.multi) //Verifica se o campo é um multi-select (o valor é um array)
                                {
                                    if(widget.currentRow[rowName] == "" || widget.currentRow[rowName] == null) //Se não houver dados este ajusta para um array vazio, prevenindo erros abaixo.
                                    {
                                        widget.currentRow[rowName] = [];
                                    }
                                    rowValue = widget.currentRow[rowName].join(','); //Campo multi (array), valores separados por ','
                                } else {
                                    rowValue = widget.currentRow[rowName]; //Campo de valor simples, sem tratativa
                                }
                            } else {
                                rowValue = widget.currentRow[rowName]; //Campo de valor simples, sem tratativa
                            }
                        } else {
                            rowValue = widget.currentRow[rowName]; //Campo de valor simples, sem tratativa
                        }
                    }
                    if(objParams[key].hasOwnProperty('value')) //Verifica se existe um value ajustado manualmente
                    {
                        rowValue = objParams[key].value;
                    }
                    //Monta a row e o map para cada parâmetro
                    if(rowName !== null && rowName !== undefined) //Verifica se a row deve ser criada
                    {
                        row[rowName] = rowValue;             //Row para o parâmetro do relatório
                        map[rowName] = objParams[key].param; //Parâmetro do relatório
                    }
                }
                
                //Verifica se o formato da emissão foi modificado
                if(objConfig.hasOwnProperty('format'))
                {
                    row.format = objConfig.format; //Formato (ex.: txt, xls, xlsx, ect.)
                    map.format = "__format";
                }
                
                //Para 'setar' o reportMapping do backend
                row.mapping = {
                    [objConfig.fileName]: { //Nome interno do relatório. Pode variar em função de relatórios específicos para outras orgs
                        strategy: 'BIRT',
                        parameterMapping: map
                    }
                };
                
                //Configurações sobre download do relatório
                if(objConfig.hasOwnProperty('download'))
                {
                    row.download = objConfig.download;
                }
                
                //Monta o array para a a requisição de emissão/download/zip do(s) relatório(s)
                req[report][j] = row;
                req[report][j].fileName = this.REPORTS_SELECTED[report].config.fileName;
                widget.currentRow.DTMESCOMPETENCIA = moment(widget.currentRow.DTMESCOMPETENCIA,'DD/MM/YYYY').add(1,'months').calendar();
            } while(moment(widget.currentRow.DTMESCOMPETENCIAFIM,'DD/MM/YYYY').diff(moment(widget.currentRow.DTMESCOMPETENCIA,'DD/MM/YYYY'), 'days') >= 0);
            widget.currentRow.DTMESCOMPETENCIA = dtCompetenc;
        }
        
        //Verifica se a emissão foi de mais de um relatório (para manter compatibilidade com a emissão do RCB que não emitira um array de 'row')
        req.isLote = i > 0;
        
        //Envia por e-mail
        if (sendEmail) {
            // enviar relatório por e-mail
            this.sendReportEmail(widget, row);
        } else {
            //Abre o relatório e/ou faz o download do mesmo
            abUtil.openReport('/geraRelatoriosHcm', objConfig.fileName, req, 'DataSet');
        }
        
        return true; //Indica que a solicitação foi atendida
    };
    
    /*Gera o relatório em questão*/
    this.gerarRelatorio_RCB = function (widget, nrOrg, nrOrgPadrao, nmTela, nmReport, abUtil){
        /*Verifica se existe relatório a ser gerado*/
        if(nmReport === null || nmReport === ""){
            return "Por favor selecione um relatório.";
        }
        
        
        //Verifica se a tela está registrada
        if(!REPORTS.hasOwnProperty(nmTela)){
            return this.msgTelaNaoRegistrada(nmTela);
        }
        //Verifica se existe relatórios específicos para esta organização e ajusta o nrOrg para padrão ou org do cliente
        if(REPORTS[nmTela].hasOwnProperty(nrOrgPadrao))
        {
            if(REPORTS[nmTela][nrOrgPadrao].hasOwnProperty(nmReport) && (!REPORTS[nmTela][nrOrg] || !REPORTS[nmTela][nrOrg].hasOwnProperty(nmReport)))
            {
                nrOrg = nrOrgPadrao;
            }
        }
        //Verifica se o relatório não existe na organização padrão e na tela especificada
        if(!REPORTS[nmTela][nrOrg].hasOwnProperty(nmReport)) {
            return "O relatório não está disponível.";
        }
        
        //Monta a row com o reportMapping percorrendo os objetos de campos do relatório em questão
        var row = {};
        var map = {};
        var rowName;
        var rowValue;
        
        var objParams = REPORTS[nmTela][nrOrg][nmReport].params; //Adquiri os parâmetros do relatório em questão
        for(var key in objParams)
        {
            //Adquiri o nome da row
            rowName = null;
            if(objParams[key].hasOwnProperty('field')) //Verifica se existem definições para os campos
            {
                rowName = objParams[key].field.row;
            }
            if(objParams[key].hasOwnProperty('row')) //Verifica se existe row ajustada manualmente (row 'personalizada')
            {
                rowName = objParams[key].row;
            }
            //Adquiri o valor da row
            rowValue = null;
            if(widget.currentRow.hasOwnProperty(rowName)) //Adquiri o valor da row caso ela exista
            {
                if(objParams[key].hasOwnProperty('field'))
                {
                    if(objParams[key].field.hasOwnProperty('multi'))
                    {
                        if(objParams[key].field.multi) //Verifica se o campo é um multi-select (o valor é um array)
                        {
                            if(widget.currentRow[rowName] == "" || widget.currentRow[rowName] == null) //Se não houver dados este ajusta para um array vazio, prevenindo erros abaixo.
                            {
                                widget.currentRow[rowName] = [];
                            }
                            rowValue = widget.currentRow[rowName].join(','); //Campo multi (array), valores separados por ','
                        } else {
                            rowValue = widget.currentRow[rowName]; //Campo de valor simples, sem tratativa
                        }
                    } else {
                        rowValue = widget.currentRow[rowName]; //Campo de valor simples, sem tratativa
                    }
                } else {
                    rowValue = widget.currentRow[rowName]; //Campo de valor simples, sem tratativa
                }
            }
            if(objParams[key].hasOwnProperty('value')) //Verifica se existe um value ajustado manualmente
            {
                rowValue = objParams[key].value;
            }
            //Monta a row e o map para cada parâmetro
            if(rowName !== null && rowName !== undefined) //Verifica se a row deve ser criada
            {
                row[rowName] = rowValue;             //Row para o parâmetro do relatório
                map[rowName] = objParams[key].param; //Parâmetro do relatório
            }
        }
        
        //Verifica se o formato da emissão foi modificado
        if(REPORTS[nmTela][nrOrg][nmReport].config.hasOwnProperty('format')){
            row.format = REPORTS[nmTela][nrOrg][nmReport].config.format; //Formato (ex.: txt, xls, xlsx, ect.)
            map.format = "__format";
        }
        
        //Para 'setar' o reportMapping do backend
        var reportFileName = REPORTS[nmTela][nrOrg][nmReport].config.fileName; //Adquiri as configurações do relatório em questão
        row.mapping = {
            [reportFileName]: { //Nome interno do relatório. Pode variar em função de relatórios específicos para outras orgs
                strategy: 'BIRT',
                parameterMapping: map
            }
        };
        
        //Configurações sobre download do relatório
        if(REPORTS[nmTela][nrOrg][nmReport].config.hasOwnProperty('download')){
            row.download = REPORTS[nmTela][nrOrg][nmReport].config.download;
        }
        
        
        //Abre o relatório e/ou faz o download do mesmo
        abUtil.openReport('/geraRelatoriosHcm', reportFileName, row, 'DataSet');
        
        return true; //Indica que a solicitação foi atendida
    };

    this.sendReportEmail = function(widgetRelatorio, dataset) {
        var widgetMensagem = templateManager.container.getWidget("sendReportEmail");

        if (widgetMensagem.isValid()) {
            var row = Object.assign({}, dataset, {"MENSAGEM": widgetMensagem.currentRow}, {"FORMULARIO": widgetRelatorio.currentRow});
            restEngine.post('/sendReportEmail', 
                {
                    "requestType": "Row",
                    "row": row
                }
            ).then(function(response) {
                if (Util.isUndefined(response.messages)) {
                    ScreenService.showMessage(Messages.DEMONSTRATIVO_SEND_SUCCESS);                
                } else {
                    ScreenService.showMessage(response.messages[0].message);
                }

                ScreenService.closePopup(true);
                widgetRelatorio.activate();
            }).catch(function(e) {
                var error;
                if(e.data.error === undefined)
                    error = e;
                else 
                    error = e.data.error;
                
                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error));
            });
        }
    };

} //FIM do RelatoriosHcmService

Configuration(function(ContextRegister) {
    ContextRegister.register('RelatoriosHcmService', RelatoriosHcmService);
});

// FILE: assets/js/services/SolicitacaoService.js
function SolicitacaoService(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine) {

    var fieldsDados = {
        /*Solicitação de férias*/
        "1": [
            "NRESTRUTLEGAL",
            "NRESTRUTGERENVINC",
            "NRVINCULOM",
            "NMVINCULOM",
            "DTINIGOZOFERIAS",
            "QTDEDIASFERIAS",
            "DTFIMGOZOFERIAS",
            "DTRETORNOFERIAS",
            "DSOBSSOLICITACAO"
        ],
        /*Solicitação de movimentação*/
        "2": [
            "NRESTRUTLEGAL",
            "NRESTRUTGERENVINC",
            "NRVINCULOM",
            "NMVINCULOM",
            "NMTIPOTRANSFER",
            "NMTPMOVTRANSFH",
            "NMMOTIVOTRANSF",
            "NMESTRUTURAH",
            "DTINIMOVIMENT",
            "DTFIMMOVIMENT",
            "DSOBSSOLICITACAO"
        ],
        /*Solicitação de alteração salarial*/
        "3": [
            "NRESTRUTLEGAL",
            "NRESTRUTGERENVINC",
            "NRVINCULOM",
            "NMVINCULOM",
            "DTALTESALARIO",
            "NMTIPOALTERA",
            "NMTPMODALIDSAL_SAL",
            "DSTIPOSALARIO",
            "DSOBSSOLICITACAO",
            "NOVOVALORSALARIO",
            "NMOCUPACAOH_SAL"
        ],
        /*Solicitação de treinamento*/
        "4": [
            "NRESTRUTLEGAL",
            "NRESTRUTGERENVINC",
            "NRVINCULOM",
            "NMVINCULOM",
            "DSOBSSOLICITACAO",
            "NMCURSO",
            "NMPERFACESAPROV",
            "NMMETODOTRE",
            "NMPERFACESEXEC",
            "NMTREINAMENTO",
            "IDTREINAMENTOINT",
            "DTINIPLANEJADOTRE",
            "DTFIMPLANEJADOTRE"
        ],
        /*Solicitação de desligamento*/
        "5": [
            "NRESTRUTLEGAL",
            "NRESTRUTGERENVINC",
            "NRVINCULOM",
            "NMVINCULOM",
            "DSTPAVIPRE",
            "NMTPDEMISSAO",
            "NMMOTIVORESC",
            "DTAVISOPREVIO",
            "DTRESCISAOVINC",
            "DSOBSSOLICITACAO"
        ],
        /*Solicitação de seleção de pessoal*/
        "6": [
            "NRESTRUTLEGAL",
            "NRESTRUTGERENVINC",
            "NRVINCULOM",
            "NMVINCULOM",
            "NMTEMPLATE",
            "NMTIPOPROCESSO",
            "NMPARCNEGOCIORESP",
            "DSMOTIVO",
            "NMMUNICIPIO",
            "LOCALIDADE",
            "DSDESCRICAO",
            "DTSOLICITA",
            "DTLIMSOLICITA",
            "NMOCUPACAODESEJADA",
            "NMESTRUTGEREN",
            "NRVAGAS",
            "IDPUBLICAVAGA",
            "NMPROCESSO",
            "DSOBSSOLICITACAO"
        ],
        /*Solicitação de alteração de dados*/
        "7": [
            "NRESTRUTLEGAL",
            "NRESTRUTGERENVINC",
            "NRVINCULOM",
            "NMVINCULOM",
            "NRCERTCASAPES",
            "NMGRAUINSTR",
            "DTCASAPESSOA",
            "NRCARTHABPES",
            "DTHABCARTPES",
            "DSCATEGHABCART",
            "DTVALHABCARTPES",
            "DSPESSOA",
            "DSOBSSOLICITACAO"
        ],
        /*Solicitação de alteração de endereco*/
        "8": [
            "NRESTRUTLEGAL",
            "NRESTRUTGERENVINC",
            "NRVINCULOM",
            "NMVINCULOM",
            "NRCEPENDERECO",
            "NMTIPOENDERECO",
            "NMPAIS",
            "BUSCAR",
            "DSCOMPLEENDERECO",
            "DSREFERENCIAENDE",
            "SGESTADO",
            "NMMUNICIPIO",
            "NMBAIRROENDERECO",
            "DSLOGRADOURO",
            "DSENDERECO",
            "NRIMOVELENDERECO",
            "DSOBSSOLICITACAO"
        ],
        /*Solicitação de alteração de ocupação*/
        "9": [
            "NRESTRUTLEGAL",
            "NRESTRUTGERENVINC",
            "NRVINCULOM",
            "NMVINCULOM",
            "NMTIPOOCUPACAO",
            "NMOCUPACAOH_OCU",
            "DTINIOCUPACAO",
            "NMMOTIVOOCUPA",
            "NMTPMODALIDSAL",
            "DSOBSSOLICITACAO"
        ],
        /*Solicitação de vale transporte*/
        "10": [
            "NRESTRUTLEGAL",
            "NRESTRUTGERENVINC",
            "NRVINCULOM",
            "NMVINCULOM",
            "DSLINHATRANSP",
            "DSTIPOLINHAVINC",
            "DSSENTIDOLINHA",
            "QTLINHATARIFA",
            "DTINILINHAVINC",
            "DSOBSSOLICITACAO",
            "DTFIMLINHAVINC"
        ],
        /*Solicitação Inclusão de dependente*/
        "11": [
            "NRESTRUTLEGAL",
            "NRESTRUTGERENVINC",
            "NRVINCULOM",
            "NMVINCULOM",
            "NMTIPORELACIONA",
            "NMPESSOADEP",
            "DTNASCIFUNDPARC",
            "IDSEXOPESSOA",
            "NRCPFDEP",
            "DSOBSSOLICITACAO"
        ],
        /*Solicitação de Alteração de Situação Funcional*/
        "12": [
            "NRESTRUTLEGAL",
            "NRESTRUTGERENVINC",
            "NRVINCULOM",
            "NMVINCULOM",
            "NMSITUFUNCH",
            "DTINISITUFUNC",
            "NRQTDIASITUFUNC",
            "DTFIMSITUFUNC",
            "NMMOTIVOAFASTA",
            "NMPROXSITUFUNC",
            "CDTABECDI",
            "NMDIAGNOST",
            "DSOBSSOLICITACAO"
        ],
        /*Solicitação de Plano de Saúde/Odontológico*/
        "13": [
            "NRESTRUTLEGAL",
            "NRESTRUTGERENVINC",
            "NRVINCULOM",
            "NMVINCULOM",
            "DSBENEFICIO",
            "DTINSCBENEFICIARIO",
            "NMPESSOA",
            "IDTPBENEFICIARIO",
            "DSOBSSOLICITACAO"
        ],
        /*Solicitação de Escala de trabalho*/
        "14": [
            "NRESTRUTLEGAL",
            "NRESTRUTGERENVINC",
            "NRVINCULOM",
            "NMVINCULOM",
            "NMESCALATRABH",
            "DSTURNO",
            "DTINIESCALA",
            "NRMOTIVOESCALA",
            "DSOBSSOLICITACAO"
        ],
        /*Solicitação de Alteração de Conta Corrente*/
        "15": [
            "NRESTRUTLEGAL",
            "NRESTRUTGERENVINC",
            "NRVINCULOM",
            "NMVINCULOM",
            "NMBANCO",
            "DSTPCONTCORR",
            "NMAGENCIA",
            "CDCONTCORR",
            "DSOBSSOLICITACAO"
        ],
        /*Solicitação de alteração de forma de comunicação*/
        "16": [
            "NRESTRUTLEGAL",
            "NRESTRUTGERENVINC",
            "NRVINCULOM",
            "NMVINCULOM",
            "NMFORMACOMU",
            "CDPREFIXCOMUPARC",
            "CDCOMUNICAPARC",
            "DSOBSSOLICITACAO"
        ],
        /*Solicitação de efetivacao de admissao*/
        "17": [
            "DSOBSSOLICITACAO"
        ]
        
    };
    var fieldsDefault = [
        "NRORG",
        "NRSOLICITACAO",
        "NRESTRUTLEGAL",
        "NRESTRUTGERENVINC",
        "NRVINCULOM",
        "NMVINCULOM",
        "NMTIPOSOLICITACAO",
        "DTSOLICITACAO",
        "DSOBSSOLICITACAO",
        "IDAPROVACAOPRI",
        "DTAPROVACAOPRI",
        "NMOPERADORPRI",
        "DSOBSAPROVAPRI",
        "IDAPROVACAOSEC",
        "DTAPROVACAOSEC",
        "NMOPERADORSEC",
        "DSOBSAPROVASEC",
        "DTINCLUSAO",
        "CDOPERINCLUSAO",
        "NRORGINCLUSAO",
        "DTULTATU",
        "CDOPERULTATU",
        "NRORGULTATU"
    ];


    this.setInsertSolicitacaoView = function(widget) {
        widget.getField('NRSOLICITACAO').showOnForm = false;
        widget.getField('NMTIPOSOLICITACAO').class = 12;
        widget.getField('NMTIPOSOLICITACAO').showOnForm = true;
        widget.getField('DTSOLICITACAO').showOnForm = false;
        widget.getField('IDAPROVACAOPRI').showOnForm = false;
        widget.getField('DTAPROVACAOPRI').showOnForm = false;
        widget.getField('NMOPERADORPRI').showOnForm = false;
        widget.getField('IDAPROVACAOSEC').showOnForm = false;
        widget.getField('DTAPROVACAOSEC').showOnForm = false;
        widget.getField('NMOPERADORSEC').showOnForm = false;
        widget.getField('DSOBSSOLICITACAO').showOnForm = false;
        widget.getField('DSOBSAPROVAPRI').showOnForm = false;
        widget.getField('DSOBSAPROVASEC').showOnForm = false;
        widget.getField('DTINCLUSAO').showOnForm = false;
        widget.getField('DTULTATU').showOnForm = false;
        widget.getField('NRORGINCLUSAO').showOnForm = false;
        widget.getField('CDOPERINCLUSAO').showOnForm = false;
        widget.getField('NRORGULTATU').showOnForm = false;
        widget.getField('CDOPERULTATU').showOnForm = false;
    };

    this.setShowSolicitacaoView = function(widget) {
        widget.getField('NRSOLICITACAO').showOnForm = true;
        widget.getField('NMTIPOSOLICITACAO').class = 8;
        widget.getField('NMTIPOSOLICITACAO').showOnForm = true;
        widget.getField('DTSOLICITACAO').showOnForm = true;
        widget.getField('IDAPROVACAOPRI').showOnForm = true;
        widget.getField('DTAPROVACAOPRI').showOnForm = true;
        widget.getField('NMOPERADORPRI').showOnForm = true;
        widget.getField('IDAPROVACAOSEC').showOnForm = true;
        widget.getField('DTAPROVACAOSEC').showOnForm = true;
        widget.getField('NMOPERADORSEC').showOnForm = true;
        widget.getField('DSOBSSOLICITACAO').showOnForm = true;
        widget.getField('DSOBSAPROVAPRI').showOnForm = true;
        widget.getField('DSOBSAPROVASEC').showOnForm = true;
        widget.getField('DTINCLUSAO').showOnForm = true;
        widget.getField('DTULTATU').showOnForm = true;
        widget.getField('NRORGINCLUSAO').showOnForm = true;
        widget.getField('CDOPERINCLUSAO').showOnForm = true;
        widget.getField('NRORGULTATU').showOnForm = true;
        widget.getField('CDOPERULTATU').showOnForm = true;
    };

    this.showWidgetDados = function(TipoSolicitacao) {
        var widgetDados = templateManager.container.getWidget("solicitacao");
        var nrTipoSolicitacao = '';
        var nmTipoSolicitacao = '';
        
        if(TipoSolicitacao) {
            if(TipoSolicitacao.NRTIPOSOLICITACAO == '' || TipoSolicitacao.NRTIPOSOLICITACAO == null || TipoSolicitacao.NRTIPOSOLICITACAO == undefined) {
                nrTipoSolicitacao = null;
                nmTipoSolicitacao = null;
            } else {
                nrTipoSolicitacao = TipoSolicitacao.NRTIPOSOLICITACAO; 
                nmTipoSolicitacao = TipoSolicitacao.NMTIPOSOLICITACAO;
            }
        } else {
            nrTipoSolicitacao = null;
            nmTipoSolicitacao = null;
        }
        
        if(nrTipoSolicitacao) {
        //Mostra ou esconde os FieldGroups a partir do nrTipoSolicitacao
        widgetDados.fieldGroups.forEach(function(fieldGroup) {
            if (fieldGroup.nrTipoSolicitacao == nrTipoSolicitacao || fieldGroup.nrTipoSolicitacao >= 99) {
                fieldGroup.isVisible = true;
            } else {
                fieldGroup.isVisible = false;
            }
        });
        //Mostra ou esconde os Fields a partir do nrTipoSolicitacao
        widgetDados.fields.forEach(function(field) {
            if (fieldsDados[nrTipoSolicitacao].indexOf(field.name) == -1 && fieldsDefault.indexOf(field.name) == -1 ) {
                field.isVisible = false;
            } else {
                field.isVisible = true;
            }
        });
        } else this.hideWidgetDados();

        widgetDados.currentRow = {};
        widgetDados.getField('NMTIPOSOLICITACAO').isVisible = true;
        widgetDados.isVisible = true;
        widgetDados.activate();
        widgetDados.edit();
        widgetDados.currentRow.NRTIPOSOLICITACAO = nrTipoSolicitacao;
        widgetDados.currentRow.NMTIPOSOLICITACAO = nmTipoSolicitacao;
        widgetDados.currentRow.__is_new = true;
    };
    
    this.hideWidgetDados = function() {
        var widgetDados = templateManager.container.getWidget("solicitacao");
        widgetDados.fieldGroups.forEach(function(fieldGroup) {
            if(fieldGroup.nrTipoSolicitacao<100) {
                fieldGroup.isVisible = false;
            } else {
                fieldGroup.isVisible = true;
            }
        });
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('SolicitacaoService', SolicitacaoService);
});

// FILE: assets/js/controllers/ABUtilController.js
/* jshint esversion: 6 */
function ABUtilController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, Messages, $window, ZhPreferences, ZhFilterPreferences, Query, DecodeValueFieldService) {

    var DASHBOARD_NAME = 'dashboard';
    var self = this;
    this.voltarWidget = false;

    this.setLocalStorageHCM = function(data) {
        this.setMidiaServerUrl();

        setLocalVar('CDOPERADOR', data[0].cdoperador);
        setLocalVar('NMOPERADOR', data[0].nmoperador);
        setLocalVar("HCM_CDOPERADOR", data[0].cdoperador);
        setLocalVar("HCM_NMOPERADOR", data[0].nmoperador);
        setLocalVar("HCM_DSEMAILOPER", data[0].dsemailoper);
        
        setLocalVar('NRORG', data[0].nrorg);
        setLocalVar('NRORGTRAB', data[0].nrorgtrab);
        setLocalVar('NRORGPADRAO', data[0].nrorgpadrao);
        setLocalVar("HCM_NRORG_OPER", data[0].nrorgoper);
        setLocalVar("HCM_NRORG_TRAB", data[0].nrorgtrab);
        setLocalVar("HCM_NRORG_PADRAO", data[0].nrorgpadrao);
        
        setLocalVar("HCM_DTCOMPETENCIA", data[0].dtmescompetenc);
        setLocalVar("HCM_DTCOMPETENCIA_DIACORRENTE", data[0].dtmescompetencdiacorrente);
        setLocalVar("HCM_DATA_ATUAL", data[0].dataatual);
        setLocalVar("HCM_DATA_ULTIMO_DIACORRENTE", data[0].dtultimodiames);
        setLocalVar("HCM_DTCOMPETENCIA_OPER", data[0].dtmescompetenc);
        setLocalVar("HCM_FIM_DTCOMPETENCIA_OPER", data[0].dtultimodiacompetencia);
        
        setLocalVar("NROCORRECAL", data[0].nrocorrecal);
        setLocalVar("IDAMBIENTESAL", data[0].idambientesal);
        setLocalVar("NMTPMODALIDSAL", data[0].nmtpmodalidsal);
        setLocalVar("NMTPMODALIDCAL", data[0].nmtpmodalidcal);

        setLocalVar("HCM_NRTIPOESTRUTLEGAL", data[0].nrtipoestrutlegal);
        setLocalVar("HCM_NRTIPOESTRUTGEREN", data[0].nrtipoestrutgeren);
        setLocalVar("HCM_NRTIPOESTRUTOMADOR", data[0].nrtipoestrutomador);
        
        setLocalVar("CDPICTCCTB", data[0].cdpictcctb);
        setLocalVar("HCM_IDREALIZACONTAB", data[0].idrealizacontab);
        setLocalVar("HCM_IDREALIZADESPESA", data[0].idrealizadespesa);
        setLocalVar("IDADE_MIN_CPF_DEP", data[0].idademincpfdep);
        setLocalVar("HCM_SALARIO_MINIMO", data[0].salariominimo);
        
        setLocalVar('CDFILIAL', data[0].cdfilialselecionada);
        setLocalVar('NMFILIAL', data[0].nmfilialselecionada);
    };
    
    this.getBaseUrlFileServer = function() {
        return getLocalVar('MIDIA_SERVER_URL');
    };

    this.setMidiaServerUrl = function() {
        restEngine.post('/getBaseUrlFileServer', {
            requestType: "Row",
            row: [],
        })
        .then(function(response) {
            setLocalVar('MIDIA_SERVER_URL', response.dataset.baseUrlFileServer[0]);
        });
    };

    
    this.getParamsUrl = function() {
        var url = window.location.hash.split('?')[1];
        var params = url.split('&');
        var data = {};
        params.forEach(function(param) {
            var variavelValor = param.split('=');
            var variavel = variavelValor[0];
            var valor = variavelValor[1];
            data[variavel] = valor;
        });
        return data;
    };

    this.generateLink = function(link, params) {
        link += "?";
        for (var property in params) {
            if (link.split('?')[1] !== "") {
                link += "&";
            }
            link += property + "=" + params[property];
        }
        return link;
    };

    this.changeTemplateToEdit = function(args) {
        var widget = args.owner.widget;
        widget.template = 'widget/form.html';
        widget.edit();
    };

    this.changeTemplateToView = function(args) {
        var widget = args.owner.widget;
        widget.template = 'widget/form-view.html';
        widget.list();
    };

    this.closeContainer = function(containerName, openContainerName, closeAll) {
        /*
        	- containerName: name do container a ser fechado
        	- openContainerName: nome do novo container a ser aberto
        	- closeAll: boolean para fechar todos os containers
        	
        	Fecha todas as telas se closeAll = true, e abre uma nova tela passada como parâmetro ou abre
        	'dashboard' por padrão.
        	Para fechar uma tela específica, basta informar somente o nome do container e se quiser abrir uma
        	nova tela, informar também openContainerName
        */
        if (closeAll) {
            ScreenService.clearHistoryItems();
            if (!Util.isNull(openContainerName))
                ScreenService.openWindow('product#' + openContainerName);
            else
                ScreenService.openWindow('product#' + DASHBOARD_NAME);
        } else {
            if (!Util.isNull(containerName))
                templateManager.historyItems.splice(templateManager.historyItems.indexOf(containerName), 1);
            if (!Util.isNull(openContainerName))
                ScreenService.openWindow('product#' + openContainerName);
        }
    };
    
    this.closeContainers = function(excepts) {
        /*
            Fecha todos os containers (telas) exceto os containers listados em 'excepts' (um array)
        */
        Object.keys(templateManager.containers).forEach(function(container, index){
            if(excepts.indexOf(container) == -1) {
                templateManager.historyItems.forEach((item, index) => {
                    if(item == container) {
                        templateManager.historyItems.splice(index, 1);
                    }
                });
                delete templateManager.containers[container];
            }
        });
    };

    this.dataSourceError = function(args) {
        if (!Util.isUndefined(args.data))
            ScreenService.showMessage('Ocorreu o seguinte erro: <br><br>' + args.data.error + '<br><br>Contate o administrador.', 'ERROR');
    };

    this.checkWidget = function(args) {
        var widget;
        if (!Util.isUndefined(args.owner.widget)) {
            widget = args.owner.widget;
        } else if (!Util.isUndefined(args.owner)) {
            if (!Util.isUndefined(args.owner.field)) {
                widget = args.owner.field.widget;
            } else {
                widget = args.owner;
            }
        }
        return widget;
    };
    
    //Widget de cadasttro de agência
    this.activateParent = function(widget) {
        if(!Util.isEmptyOrBlank(widget.parent)) {
             widget.parent.parent.currentWidget = widget.parent.parent;
             widget.parent.parent.activate();
        }
    };

    this.gerarRelatorio = function(reportName) {
        var widget = templateManager.container.getActiveWidget();
        var row = {};
        var gerar = false;

        switch (reportName) {
            case 'curriculo_candidato':
                row.NRORG = getLocalVar('HCM_NRORG_PADRAO');
                row.NMOPERADOR = getLocalVar('HCM_NMOPERADOR');
                row.NRPARCNEGOCIO = getLocalVar('BTL_NRPARCNEGOCIOCAND');
                row.COMPETENCIA = getLocalVar('HCM_DTCOMPETENCIA_DIACORRENTE');
                if (widget.getField('CAMINHOFOTO')) {
                    row.PATH_FOTO = '/var/www/anexos/pebbian/recrutamentoSelecao/files/';
                } else {
                    row.PATH_FOTO = '';
                }
                gerar = true;

                break;

            case 'avaliacao_psicologica':
                row.P_NRORG = getLocalVar('HCM_NRORG_TRAB');
                row.P_NRORG_PADRAO = getLocalVar('HCM_NRORG_PADRAO');
                row.P_COMPETENCIA = widget.currentRow.DTMESCOMPETENC;
                row.P_NRPARCNEGOCIOCAND = widget.currentRow.NRPARCNEGOCIO;
                gerar = true;

                break;
            default:
                ScreenService.showMessage('Relatório não identificado', 'ALERT');
                gerar = false;
                break;
        }

        if (gerar)
            this.openReport('/geraBirtReport', reportName, row);
    };

    this.openReport = function(route, reportName, params, requestType) {

        var routeObject = {};
        if (Util.isUndefinedOrNull(requestType)) {
            requestType = 'Row';
            routeObject = {
                "requestType": requestType,
                "row": params
            };
        } else {
            routeObject = {
                "requestType": requestType,
                "dataset": [params]
            };
        }

        params.__report_name = reportName;
        return restEngine.post('product#' + route, routeObject, null, null, null, null, 3000000).then(function(response) {
            if (response && response.messages) {
                var report = response.messages;
                for(var i in report){
                    window.open(report[i].message);
                }
            }
            if (response && response.dataset && response.dataset.arquivo) {
                self.downloadArquivo(response.dataset.arquivo.NMARQUIVO);
            }
        }).catch(function(response) {
            if (response.data && response.data.error) {
                ScreenService.showMessage(ScreenService.i18n(response.data.error), 'E');
            }
        });
    };

    self.voltarDashboard = function() {
        ScreenService.openWindow('product#dashboard');
    };

    self.masterDetailNewRow = function(widget) {
        self.mudarVisibilidadeWidgets(widget.widgets, false);
        widget.newRow();
    };

    self.masterDetailVoltarList = function(widget) {
        widget.list();
        ScreenService.closeSwipe();
        widget.activate();
    };

    self.masterDetailEdit = function() {
        var widget = templateManager.container.getActiveWidget();
        self.mudarVisibilidadeWidgets(widget.widgets, false);
        widget.backupRow = Util.clone(widget.currentRow);
        widget.edit();
    };

    self.masterDetailCancelaEdicao = function(widget) {
        self.mudarVisibilidadeWidgets(widget.widgets, true);
        if (widget.currentRow.__is_new) {
            var indexOfCurrentRow = widget.dataSource.data.indexOf(widget.currentRow);
            if (indexOfCurrentRow !== -1) {
                widget.dataSource.data.pop();
            }
            widget.list();
            ScreenService.closeSwipe();
            widget.activate();
        } else {
            Util.extend(widget.currentRow, widget.backupRow);
            widget.view();
        }
    };

    self.mudarVisibilidadeWidgets = function(widgets, isVisible) {
        widgets.forEach(function(widget) {
            widget.isVisible = isVisible;
        });
    };

    self.masterDetailSave = function(widget) {
        self.mudarVisibilidadeWidgets(widget.widgets, true);
        if (widget.isValid()) {
            widget.currentRow.changed = true;

            return widget.saveRow().then(function() {
                widget.currentRow.changed = false;
                widget.currentRow.__is_new = false;
                widget.view();
                widget.reload();
            }).catch(function(e) {
                ScreenService.showMessage('Ocorreu um erro inesperado, contate o administrador informando o trecho abaixo: <br><br>' + e.data.error + '<br><br>', 'ERROR');
            });
        } else {
            return ZHPromise.reject();
        }
    };

    self.validaCPF = function(CPF) {
        if (CPF === undefined || CPF === null) {
            return false;
        }
        CPF = CPF.toString().replace(/[\D]+/g, '');
        if (CPF.length != 11) {
            return false;
        }
        if (CPF == "00000000000" ||
            CPF == "11111111111" ||
            CPF == "22222222222" ||
            CPF == "33333333333" ||
            CPF == "44444444444" ||
            CPF == "55555555555" ||
            CPF == "66666666666" ||
            CPF == "77777777777" ||
            CPF == "88888888888" ||
            CPF == "99999999999")
            return false;
        var soma = 0;
        var resto;
        for (var i = 1; i <= 9; i++) {
            soma = soma + parseInt(CPF.substring(i - 1, i)) * (11 - i);
        }
        resto = (soma * 10) % 11;
        if ((resto == 10) || (resto == 11)) {
            resto = 0;
        }
        if (resto != parseInt(CPF.substring(9, 10))) {
            return false;
        }
        soma = 0;
        for (i = 1; i <= 10; i++) {
            soma = soma + parseInt(CPF.substring(i - 1, i)) * (12 - i);
        }
        resto = (soma * 10) % 11;
        if ((resto == 10) || (resto == 11)) {
            resto = 0;
        }
        if (resto != parseInt(CPF.substring(10, 11))) {
            return false;
        }
        return true;
    };

    self.validaPIS = function(PIS) {

        var ftap = "3298765432";
        var total = 0;
        var i;
        var resto = 0;
        var numPIS = 0;
        var strResto = "";
        numPIS = PIS;

        numPIS = numPIS.toString().replace(/[\.-]/g, '');

        if (numPIS === "" || numPIS === null) {
            return false;
        }
        for (i = 0; i <= 9; i++) {
            var resultado = (numPIS.slice(i, i + 1)) * (ftap.slice(i, i + 1));
            total = total + resultado;
        }
        resto = (total % 11);
        if (resto !== 0) {
            resto = 11 - resto;
        }
        if (resto === 10 || resto === 11) {
            strResto = resto + "";
            resto = strResto.slice(1, 2);
        }
        if (resto != (numPIS.slice(10, 11))) {
            return false;
        }
        return true;
    };

    self.newRow = function(args) {
        var widget = args.owner.widget;
        self.mudarVisibilidadeWidgets(widget.widgets, false);
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
    };

    self.masterDetailVoltarParent = function(widget) {
        ScreenService.closeSwipe().then(function() {
             widget.parent.parent.list();
             widget.parent.parent.activate();
        });
    };

    self.masterDetailClosePopup = function(popup) {
        popup.currentRow = {};
        ScreenService.closePopup(true);
        popup.deactivate();
        popup.parent.parent.currentWidget = popup.parentWidget;
        popup.parent.parent.activate();
    };

    self.masterDetailOpenPopup = function(popup) {
        if(popup.parent){
            popup.parentWidget = popup.parent.parent;
        }
        ScreenService.openPopup(popup);
    };

    self.changeVisibilityOrgTrab = function(nrOrgRegistro, widget, actions, fields) {

        var visible = true;
        var nrOrgTrab = getLocalVar("HCM_NRORG_TRAB");

        if (nrOrgRegistro == nrOrgTrab) {
            visible = true;
        } else {
            visible = false;
        }

        if (!Util.isUndefinedOrNull(actions)) {
            actions.forEach(function(action) {
                if (widget.getAction(action)) {
                    widget.getAction(action).isVisible = visible;
                }
            });
        }

        if (!Util.isUndefinedOrNull(fields)) {
            fields.forEach(function(field) {
                if (widget.getField(field)) {
                    widget.getField(field).isVisible = visible;
                }
            });
        }
    };

    self.setCamposAuditoria = function(widget) {
        var operinclusao = false;
        var operultatu = false;

        widget.getField('CDOPERINCLUSAO').dataSource.data.forEach(function(data) {
            if (data.cdoperador == widget.currentRow.CDOPERINCLUSAO) {
                operinclusao = true;
            }
        });
        if (operinclusao === false) {
            if (widget.currentRow.CDOPERINCLUSAO == getLocalVar('HCM_CDOPERADOR')) {
                widget.getField('CDOPERINCLUSAO').dataSource.data.push({
                    "cdoperador": getLocalVar('HCM_CDOPERADOR'),
                    "nmoperador": getLocalVar('HCM_NMOPERADOR')
                });
            } else {
                widget.getField('CDOPERINCLUSAO').dataSource.data.push({
                    "cdoperador": widget.currentRow.CDOPERINCLUSAO,
                    "nmoperador": widget.currentRow.CDOPERINCLUSAO
                });
            }
        }

        widget.getField('CDOPERULTATU').dataSource.data.forEach(function(data) {
            if (data.cdoperador == widget.currentRow.CDOPERULTATU) {
                operultatu = true;
            }
        });
        if (operultatu === false) {
            if (widget.currentRow.CDOPERULTATU == getLocalVar('HCM_CDOPERADOR')) {
                widget.getField('CDOPERULTATU').dataSource.data.push({
                    "cdoperador": getLocalVar('HCM_CDOPERADOR'),
                    "nmoperador": getLocalVar('HCM_NMOPERADOR')
                });
            } else {
                widget.getField('CDOPERULTATU').dataSource.data.push({
                    "cdoperador": widget.currentRow.CDOPERULTATU,
                    "nmoperador": widget.currentRow.CDOPERULTATU
                });
            }
        }
    };

    this.getConditionNrorgTrabPadrao = function(widget) {
        var condition = [];
        condition.push(getLocalVar('HCM_NRORG_PADRAO'));
        condition.push(getLocalVar('HCM_NRORG_TRAB').toString());

        var filter = widget.dataSourceFilter.filter(function(filter) {
            return (filter.name === "NRORG" && filter.operator === "IN");
        });
        if (filter.length === 0) {
            widget.dataSourceFilter.push({
                "name": "NRORG",
                "operator": "IN",
                "value": condition
            });
        }
        widget.reload();
    };

    self.prepareSaveMasterHistory = function(widget) {
        var paramsNewCode = widget.paramsNewCode;
        var saveHistoryTable = widget.saveHistoryTable;
        var columnsToSave = widget.__columns_to_return;
        var historyField = saveHistoryTable.__table_competenc.toUpperCase();

        if (paramsNewCode && paramsNewCode.__is_new_code) {
            widget.currentRow.__new_code_pk = paramsNewCode.__new_code_pk;
            widget.currentRow.__table_pk = paramsNewCode.__table_pk;
            widget.currentRow.__new_code_length = paramsNewCode.__new_code_length || 5;
        }
        if (!Util.isUndefined(paramsNewCode.__use_org_padrao) && paramsNewCode.__use_org_padrao) {
            widget.currentRow.__nrorgpadrao = getLocalVar('HCM_NRORG_PADRAO');
        }

        if (paramsNewCode) {
            widget.currentRow.saveHistoryTable = saveHistoryTable;
        }

        if (columnsToSave) {
            widget.currentRow.__columns_to_return = columnsToSave;
        }

        if (!widget.backupRow) {
            widget.currentRow.__is_new = true;
        } else {
            widget.currentRow.__is_new = false;
            widget.currentRow[historyField] = getLocalVar('HCM_DTCOMPETENCIA_OPER');
        }

        return widget;
    };

    self.saveMasterDetailMasterHistory = function(widget) {

        var preparedWidget = this.prepareSaveMasterHistory(widget);
        var masterTable = preparedWidget.paramsNewCode.__new_code_pk;

        restEngine.post('product#/saveCrud', {
            'requestType': 'DataSet',
            'dataset': [preparedWidget.currentRow]
        }).
        then(function(data) {
            if(data.dataset.verificaVigenciaEnvio){
                var mensagem = 'Registro possui o(s) evento(s) '+widget.currentRow.NMEVENTO+'  já transmitido para o eSocial com a data de vigência atual. Ao alterar a vigência o mesmo ficará incompatível com o sistema único. Deseja prosseguir com a alteração?';
                ScreenService.showCustomDialog(mensagem, 'CONFIRMATION', null, [{
                    label: ScreenService.i18n("Sim"),
                    code: function(e, deferred) {
                        preparedWidget.currentRow.IDVERIFICAVIGENCIAESO = 'N';
                        this.saveMasterDetailMasterHistory(widget);
                        deferred.resolve(e);
                    }.bind(this)
                  },{
                    label: ScreenService.i18n("Não"),
                    code: function(e, deferred) {
                    preparedWidget.currentRow = preparedWidget.backupRow;
                        preparedWidget.view();
                        deferred.reject(e);
                    }
                }]);
            }else if (data.dataset.columnsToReturn) {
                ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                if (preparedWidget.currentRow.__is_new) {
                    self.mudarVisibilidadeWidgets(preparedWidget.widgets, true);
                    self.masterDetailVoltarList(preparedWidget);
                    preparedWidget.reload();
                } else {
                    self.mudarVisibilidadeWidgets(preparedWidget.widgets, true);
                    var tableHistoryPk = preparedWidget.saveHistoryTable.__table_history_pk.toUpperCase();
                    if (preparedWidget.currentRow[tableHistoryPk]) {
                        for (var i = 0; i < data.dataset.columnsToReturn.length; i++) {
                            if (!Util.isUndefined(data.dataset.columnsToReturn[i][tableHistoryPk])) {
                                preparedWidget.currentRow[tableHistoryPk] = data.dataset.columnsToReturn[i][tableHistoryPk];
                            }
                        }
                    }
                    preparedWidget.backupRow = null;
                    preparedWidget.view();
                }
            } else {
                ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
            }
        }.bind(this)).
        catch(function(e) {
            var error;
            if (e.data.error === undefined)
                error = e;
            else
                error = e.data.error;

            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
        });
    };

    this.validaDtIniMenorIgualDtFin = function(dtIni, dtFin) {
        var today = new Date();
        return !(moment(dtIni, 'DD/MM/YYYY').unix() > moment(dtFin, 'DD/MM/YYYY').unix() || moment(dtFin, 'DD/MM/YYYY').unix() < moment(dtIni, 'DD/MM/YYYY').unix());
    };

    this.validaDataIgualPosteriorDtAtual = function(data) {
        var today = getLocalVar('HCM_DATA_ATUAL');
        return !(moment(today, 'DD/MM/YYYY').unix() > moment(data, 'DD/MM/YYYY').unix() || moment(data, 'DD/MM/YYYY').unix() < moment(today, 'DD/MM/YYYY').unix());
    };

    this.setIdTpFormCalculo = function(valueId, valueCalc, valueTipoMoviment, nameTipoMoviment) {
        setLocalVar('HCM_FPA_FORMCALCULO', {
            'IDTPFORMCALCULO': valueId,
            'NRTIPOCALCULO': valueCalc,
            'NRTIPOMOVIMENT': valueTipoMoviment,
            'NMTIPOMOVIMENT': nameTipoMoviment
        });
    };

    this.clearLocalStorage = function(exceptions) {
        //localStorage.clear();
        var storage = localStorage;
        var keys = [];
        exceptions = [].concat(exceptions); //prevent undefined

        //get storage keys
        $.each(localStorage, function(key, val) {
            keys.push(key);
        });

        //loop through keys
        for (i = 0; i < keys.length; i++) {
            var key = keys[i];
            var deleteItem = true;
            //check if key excluded
            for (j = 0; j < exceptions.length; j++) {
                var exception = exceptions[j];
                if (key == exception) deleteItem = false;
            }
            //delete key
            if (deleteItem) {
                localStorage.removeItem(key);
            }
        }
    };

    this.downloadArquivo = function(nmArquivo) {
        $window.open($window.serviceUrl + "/abrirArquivo?requestType=DataSet&dataset[0][CMARQUIVO]=" + nmArquivo);
    };
    
    this.openLink = function(link) {
        $window.open(link);  
    };

    this.validaCritSelecao = function(currentRow) {
        var r = true;
        switch (currentRow.DSORDEM) {
            case 'ALFABETICA':
                if (currentRow.DSINICIO.localeCompare(currentRow.DSFIM) > 0){
                    r = false;
                    ScreenService.showMessage("O nome inicial deve ser anterior ao nome final");
                }
                break;
            case 'DATA_ADMISSAO':
                r = this.validaDtIniMenorIgualDtFin(currentRow.DSINICIO, currentRow.DSFIM);
                if(!r)
                    ScreenService.showMessage("A data inicial deve ser anterior a data final");
                break;
            case 'ESTRUT_ALFABETICA_TPVINC':
                if(currentRow.DSINICIO == '' && currentRow.DSFIM == '' && currentRow.DSINICIO2 == '' && currentRow.DSFIM2 == '' && currentRow.DSINICIO3 == '' ){
                    ScreenService.showMessage('Você deve preencher pelo menos um dos campos', 'ALERT');
                    r = false;
                }  
                break;
                
            default:
        }
        return r;
    };
    
    this.retornaFiltro = function(dataSourceFilter, nomeDoFiltro) {
        var index = false;
        dataSourceFilter.forEach(function(filter, i){
           if(filter.name === nomeDoFiltro){
                index =  i; 
            }
        });
        return index;
    };
    
    this.retornaWidget = function(widget, nomeWidget) {
         var i = false;
        widget.widgets.forEach(function(wid, index){
           if(wid.name === nomeWidget){
                i = index; 
            }
        });
        
        return i;
    };
    
    this.reloadWidgetOnEnter = function(nameWidget){
        var widget = templateManager.container.getWidget(nameWidget);
        widget.reload();
    };
    
    this.convertStringFormatBRtoEUA = function(str){
        str = str.substr(0, 10); 
        str = str.split('/');
        str = str[2]+'/'+str[1]+'/'+str[0];
        return str;      
    };
    
    /* 
    *  Função que permite os campos select multiple serem "lazyLoad" = true;
    *  É necessário que o "dataSource" tenha a propriedade "data": [].
    */
    this.setValuesSelectMultiple = function(args, namesField){
        var widget = this.checkWidget(args);
        var currentRow = widget.currentRow;
        namesField.forEach(function(nameField){
            var widField = widget.getField(nameField);
            this.setValueDataSource(currentRow, widField); 
        }.bind(this));
          
    };
    
    this.setValueDataSource = function(currentRow, field){
        var data = [];
        var arrayId =  Array.isArray(currentRow[field.outData[field.valueField]])? currentRow[field.outData[field.valueField]] : [currentRow[field.outData[field.valueField]]] ;
        var arrayName = Array.isArray(currentRow[field.outData[field.descriptionField]])? currentRow[field.outData[field.descriptionField]] : [currentRow[field.outData[field.descriptionField]]];
        if(arrayId && arrayId[0]){
            arrayId.forEach(function(id, index){
                var object = {};
                object[field.valueField] = arrayId[index];
                object[field.descriptionField] = arrayName[index];
                data.push(object);
            });
            field.dataSource.data = data;
        }
    };
    
    this.validaData = function(args, nomeCampo){
        var widget = this.checkWidget(args);
        var data = widget.currentRow[nomeCampo];
        if(data){
            var valida = moment(data, "DD MM YYYY").isValid();
            if(!valida){
                widget.currentRow[nomeCampo] = '';
                ScreenService.showMessage('Data inválida!');
            }
        }
    };
    this.validateFormatHora = function (args, campo, onlyMinute){
        var widget = this.checkWidget(args);
        var hora = widget.currentRow[campo];    
        if(!onlyMinute && (hora.split(":")[0]>=24 || hora.split(":")[1]>=60 ) ){
            ScreenService.showMessage("Formato de Hora inválido!");
            widget.currentRow[campo] = "";
        }else if(onlyMinute && hora.split(":")[1]>=60){
            ScreenService.showMessage("Formato de Minutos inválido!");
            widget.currentRow[campo] = "";
        }
    };    
    
    this.arrayUnique = function(array){
        var arrayNovo = [];
        array.forEach(function(item, index){
            if ( array.indexOf( array[ index ] ) === index ) {
                arrayNovo.push(array[ index ] );
            }
        });
        return arrayNovo;
    };
    
    this.deactivateWidgetSelectMultiple = function(args) {
        args.owner.field.selectWidget.deactivate();
    };    
    
    this.alteraTemplateData = function(args, campos, editing, widgetNome = false){
        var widget = this.checkWidget(args);
        if(widgetNome){
            widget = widget.container.getWidget(widgetNome).__filterPopup;
        }
        campos.forEach(function(campo){
            if(editing === true){
                widget.getField(campo).template = 'field/text-edit.html';
                widget.getField(campo).mask = {
                    "type": "date",
                    "params":{
                        "inputFormat": "DD/MM/YYYY HH:mm:ss",
                        "format": "DD/MM/YYYY"
                    }
                };
            }else {
                widget.getField(campo).template = 'field/calendar.html';
                widget.getField(campo).mask = {};   
            }
        });
    };
    
    this.LoadDataAutoComplete = function(field, changeRest){
        if(field.initializeField){
            field.initializeField();
        }
        if(changeRest == true && field.dataSource.rest === true){
            field.reload().then(function(data){
                field.dataSource.rest = false;
            });
            
        }else if(changeRest == false && field.dataSource.data.length == 0) {
            field.reload();   
        }
    };
    
    this.reactivateRefreshButton = function() {
        var widget = templateManager.container.getActiveWidget();
        setTimeout(()=>{
            var reloadElm = $('#popup > span > section > section > section > section > div > div:nth-child(2) > div > div.control-menu > ul > li.float-action.refresh-action.ng-scope > span.action-icon.zh-icon.zh-icon-refresh.zh-icon-no-border.zh-icon-color-white');
            if(!!reloadElm.length) {
                reloadElm.on('click', function() {
                    widget.selectField.rest = true; 
                    if(widget.selectField.initializeField){
                        widget.selectField.initializeField();
                    }
                    //widget.selectField.reload().then(function(callBack){
                        widget.dataSource.rest = false;
                    //});
                });
            }
        }, 100);
    };
    
    this.deactivateRefreshButton = function(){
        var reloadElm = $('#popup > span > section > section > section > section > div > div:nth-child(2) > div > div.control-menu > ul > li.float-action.refresh-action.ng-scope > span.action-icon.zh-icon.zh-icon-refresh.zh-icon-no-border.zh-icon-color-white');
        if(!!reloadElm.length) {
            reloadElm.on('click', function(){});
        }
    };
    
    this.reloadWidgetAutoComplete = function(widget){
        var field = widget.selectField;
        if(field.initializeField){
            field.initializeField();
        }
        field.dataSource.rest = true;
        field.dataSource.reload().then(function(callBack){
            field.dataSource.rest = false;
        });
    };
    
    this.setFilterInit = function (widget) {
        widget.omAppliedFilter = true;
    };
    
    this.applyDefaultFilterOnEnter = function(widget, isApplyFilter, rowToBeSet = null ){
        var time = 1800;
        return setTimeout(function() {
            self.applyDefaultFilter(widget, isApplyFilter, rowToBeSet);
        }, time);
    };
    
     this.applyDefaultFilter = function(widget, isApplyFilter, rowToBeSet){
        if (widget.inListMode()) {
            if (widget.omAppliedFilter) {
                widget.reload();
            } else if (widget.currentRowDefaultFilter) {
                self.startFilter(widget, widget.currentRowDefaultFilter, isApplyFilter, rowToBeSet);
            } else {
                self.startFilter(widget, widget.currentRow, isApplyFilter, rowToBeSet);
            }
        }
    };

    this.startFilter = function(widget, currentRow, isApplyOriginalFilter, rowToBeSet){
        ZhPreferences.getDefaultWidgetPreferences(widget.id).then(function(result) {
            if (result && result.DEFAULT_FILTER) {
                ZhPreferences.getPreferences('filter', Query.build().where('WIDGET_ID').equals(widget.id)).then(function(filters) {
                    var defaultFilter = filters.filter(function(filter) {
                        return filter.ID == result.DEFAULT_FILTER;
                    })[0];
                    var filter = {
                        ID: defaultFilter.LABEL_TO_PREFERENCE || 'EDITED',
                        FILTER_ROW: JSON.parse(defaultFilter.FILTER_ROW)
                    };
                    ZhFilterPreferences.applyFilter(widget, filter).then(function() {
                        widget.appliedFilter = widget.appliedFilter || filter;
                        widget.appliedFilter.ID = result.DEFAULT_FILTER;
                        if(defaultFilter.LABEL_TO_PREFERENCE) {
                            widget._filterInfo[0].value = defaultFilter.LABEL_TO_PREFERENCE;
                        }
                    });
                });
            } else if(isApplyOriginalFilter) {
                ZhFilterPreferences.applyOriginalFilter(widget);
            } else {
                ZhFilterPreferences.openFilterWidget(widget, rowToBeSet);
            }
        });
    };
    
    this.loadFieldAutoComplete = function(field){
        if(field.dataSource.rest == false){
            if(field.initializeField){
                field.initializeField();
            }
            field.dataSource.rest = true;
            field.reload().then(function(data){
                field.dataSource.rest = false;
            });
        }
    };

    this.validaDtInicioDtFinal_dateInterval = function(args, fieldName){
        widget = args.owner.field.widget;

        if(
            widget.currentRow.DTINIAPURVALE != '' && widget.currentRow.DTINIAPURVALE != undefined &&
            widget.currentRow.DTFINAPURVALE != '' && widget.currentRow.DTFINAPURVALE != undefined  &&
            widget.currentRow.DTINIAPURVALE.start >= widget.currentRow.DTFINAPURVALE.end 
              
         ){
             widget.currentRow[fieldName] = "";
             ScreenService.showMessage(Messages.HCM02012_VAB_RELATCUSTOMVALETRANSPORTE_INTEVALO_DATA_ERRO);
         }
    };
    
    
    // bloqueia o checkBox da widget quando o swipe de visualizar esta aberto
    this.blockCheckbox = function(id, idBlock){
        var idClass = '#grid-'+id+' .grid-checkbox-column';
        if(idBlock){
            $(idClass).css('pointer-events', 'none');
        }else{
            $(idClass).css('pointer-events', 'auto');    
        }
    };
    
    this.setSysdateFilter = function(field){
          field.filterProperties.defaultValue = getLocalVar('HCM_DATA_ATUAL') ? getLocalVar('HCM_DATA_ATUAL') : '' ;
    };
    
    /* Adiciona e remove filtro do dataSource Filter
     * var remove -> informa se deseja remover o filtro (true) ou somente o valor dele (false)
    */
    this.alteraDataSourceFilterCampo = function(args, nomeCampo, nomeFiltro, valorFiltro, remove = null){
        var widget = this.checkWidget(args);
        if(valorFiltro){
            var filtro = widget.getField(nomeCampo).dataSourceFilter[this.retornaFiltro(widget.getField(nomeCampo).dataSourceFilter, nomeFiltro)];
            if(filtro){
                filtro.value = valorFiltro;
            }else{
                widget.getField(nomeCampo).dataSourceFilter.push(
                    {
                        "name": nomeFiltro,
                        "operator": Array.isArray(valorFiltro) ? "IN" : "=", 
                        "value": valorFiltro
                    }    
                );
            }
        }else{
            widget.dataSourceFilter.forEach(function(filtro, index){
                if(filtro.name === nomeFiltro){
                    if(remove){
                        widget.dataSourceFilter.splice(index, 1);
                    }else{
                        filtro.value = "";
                    }
                }
            });
        }
    };
    
    this.retornaObjetoDateComString = function(data){
        var dataSplit = data.split('/');
        if(dataSplit.length == 3){
            var dataFormatoEUA = dataSplit[1] + '/' + dataSplit[0] + '/' + dataSplit[2];  
            var dataDate = new Date(dataFormatoEUA);
            return dataDate;
        }
    };
    
    this.truncateObjetoDate = function(date){
        try {
            date.setHours(0);
            date.setMinutes(0);
            date.setSeconds(0);
            date.setMilliseconds(0);
        } catch(err){
            return false;
        }
    };
    
    this.dataEhAnteriorACompetenciaAtual = function(data){
        var dtMesCompetencia = self.retornaObjetoDateComString(getLocalVar('HCM_DTCOMPETENCIA'));
        return data.getTime() < dtMesCompetencia.getTime();
    };
    
    this.validaDataSeAnteriorACompetenciaAtual = function(args, nomeCampo, aviso){
        var widget = this.checkWidget(args);
        var data = widget.currentRow[nomeCampo];
        if(data){
            if(self.dataEhAnteriorACompetenciaAtual(self.retornaObjetoDateComString(data)))
                ScreenService.showMessage(aviso);
        }
    };
    
    this.mesDataEhAnteriorAoMesAtual = function(data){
        var dataAtual = new Date();
        if(data.getMonth() < dataAtual.getMonth() || data.getYear() < dataAtual.getYear()){
            return true;
        } else {
            return false;
        }
    };
    
    this.validaDataSeMesAnteriorAoMesAtual = function(args, nomeCampo, aviso){
       var widget = this.checkWidget(args);
        var data = widget.currentRow[nomeCampo];
        if(data){
            if(self.mesDataEhAnteriorAoMesAtual(self.retornaObjetoDateComString(data)))
                ScreenService.showMessage(aviso);
        }
    };
    
    this.setMensagemDescricaoField = function(widget, campos){ 
        //função que recebe a widget e um objeto com o nome dos campos e as respectivas mensagens a serem mostradas
        //a mensagem aparece no campo no espaço da mensagem "Campo obrigatório"
        /*formato campo a ser recebido (parametro campos):
                {
                    "NOME": "MSG"
                }
        */
        Object.keys(campos).forEach(function(nameField){
            widget.currentRow.$error = widget.currentRow.$error || {}; 
                widget.currentRow.$error[nameField] = [
                    {
                        'valid': false,
                        'message': campos[nameField]
                    }
                ];
        });
    };
    
	this.atualizaValorStringLocalStorage = function(nomeVariavel, valor){
		localStorage.setItem(nomeVariavel, '"' + valor + '"');
	};
	
    this.limparDataSourceTabsFilhaMoveRow = function(args){
        var widget = this.checkWidget(args);
        widget.widgets.forEach(function(tab){
            if(tab.dataSource)tab.dataSource.data = [];
        });
    };
    
    //função que fecha widgets passadas como parâmetro caso estejam em modo view ou se as filhas dessas widgets estejam ativas
    //objetivo: Ao alterar a currentRow da WidgetPrincipal, as widgets filhas que estejam abertas sejam fechadas para evitar a inconsistência de dados
    //'widgets': array de nomes das widgets filhas da principal em questão a serem analisadas
    //'widgetReload': é passada caso a widget, em que se encontra o evento que chama a função, necessita de reload (geralmente é necessário quando o evento não está na widget raiz
    //mas em uma de suas widgets filhas))
    //Evento widget principal => 'WidgetOnMoveRow'
    this.closeWidgetsFilhasSecundarias = function(widgets, widgetReload, reload = true){
        const widgetAtiva = templateManager.container.getActiveWidget();
        
        for(var widget in widgets){
            var widgetCorrente = templateManager.container.getWidget(widgets[widget]);
            var widgetsFilhas  = widgetCorrente.widgets ? widgetCorrente.widgets : [];
            var widgetFilha    = widgetsFilhas.find(function(widgetFilha){
                return widgetFilha.name == this.name;
            }, widgetAtiva);
            if((widgetAtiva.name == widgets[widget] && widgetAtiva.inViewMode()) || (!!widgetFilha)){
                widgetCorrente.list();
                if(reload){
                    widgetCorrente.reload();
                }
                ScreenService.closeSwipe(1);
                if(widgetReload){
                    ScreenService.closeSwipe();
                }
                
            }
        }
        
    };
    
    this.retornaIdade = function(dtNascimento){
        var hoje = new Date();  
        var data = dtNascimento.split('/');
        dtNascimento = data[1] + '/' + data[0] + '/' + data[2];
        var nascimento = new Date(dtNascimento);  
        return hoje.getFullYear() - nascimento.getFullYear();  
    };
    
    this.retornaPeriodo = function(dataInicio, dataFim){
        var dataIni = dataInicio.split('/');
        dataInicio = dataIni[1] + '/' + dataIni[0] + '/' + dataIni[2];
        dataInicio = new Date(dataInicio);
        var dataFi = dataFim.split('/');
        dataFim = dataFi[1] + '/' + dataFi[0] + '/' + dataFi[2];
        dataFim = new Date(dataFim);
        
        var dIY = dataInicio.getFullYear();
    	var dIM = dataInicio.getMonth();
    	
    	var dFY = dataFim.getFullYear();
    	var dFM = dataFim.getMonth();

    	return (dFM+(12*dFY)) - (dIM+(12*dIY));
        
    };
    
    this.setFieldRequired = function(field) {
        if (field) {
            field.validations = {required:true};
        }
    };
    
    this.setFieldsRequired = function(fields) {
        if (!this.isIterable(fields)) {
            return false;
        }
        
        for (const field of fields) {
            this.setFieldRequired(field);
        }
    };
    
    this.setFieldNotRequired = function(field) {
        if (field) {
            field.validations = {};
        }
    };
    
    this.setFieldsNotRequired = function(fields) {
        if (!this.isIterable(fields)) {
            return false;
        }
        
        for (const field of fields) {
            this.setFieldNotRequired(field);
        }
    };
    
    this.isIterable = function(obj) {
      // checks for null and undefined
      if (obj == null) {
        return false;
      }
      return typeof obj[Symbol.iterator] === 'function';
    };
    
    this.arrayDiference = function(arr1, arr2) {
        const difference = arr1.filter(x => !arr2.includes(x));
        return difference;
    };
    
    this.removeStringQuote = function (stringVar) {
        if (stringVar) {
            return stringVar.replace(/"/g, '');
        }
        return "";
    };
    
    this.syncRowFieldValue = function(args, fieldNameToSync, alterValueFunction = null) {
        const fieldName = args.owner.field.name;
        const valueToSync = alterValueFunction ? alterValueFunction(args.row[fieldName]) : args.row[fieldName];
        args.row[fieldNameToSync] = valueToSync;
    };
    
    this.widgetHasSelectedRows = function(args) {
        const widget = self.checkWidget(args);
        return Array.isArray(widget.getCheckedRows()) && widget.getCheckedRows().length > 0;
    };
    
    /**
     *  Responsável por alterar as propriedades 'read-only' de todos os campos de uma determinada widget
     */
    this.setReadOnlyAllWidgetFields = function(widget, readOnlyValue) {
        if (!widget || !widget.fields || (Array.isArray(widget.fields) && widget.fields.length < 1)) {
            return;
        }
        
        for (const field of widget.fields) {
            if (field) {
                field.readOnly = readOnlyValue;
            }
        }
    };
    
    /**
     *  Responsável por alterar as propriedades 'read-only' de todos os campos de uma determinada widget para false
     */
    this.clearReadOnlyAllWidgetFields = function(widget) {
        return this.setReadOnlyAllWidgetFields(widget, false);
    };
    
    /**
     * Blocks keypress in a field to key codes and numbers
     * - args : args of a FieldOnKeyPress
     * - keyCodesAllow : array of key codes allowed
     * - keyCodesBlock : array of key codes not allowed
     * - number : true to allow numbers or false to not allow
     */
    this.digitaOcorrencias = function(args) {
        var regex = /^[0-9,\b]+$/;
        if (!regex.test(args.e.key)) {
            args.e.preventDefault();
        }
    };
    
    /**
     *  Rotina que permite o cadastro local de informações em grid
     * 
     *  @param  args
     *  @param  widgetGridName
     *  @param  widgetRowName
     * 
     */
    /* jshint ignore:start */
    this.localWidgetAddItem = function(args, widgetGridName, widgetRowName, callBackValidations = function() { return false }) {
        const widget = templateManager.container.getWidget(widgetGridName);
        const widgetRow = templateManager.container.getWidget(widgetRowName);
        if (!widget || !widgetRow || !widgetRow.currentRow) {
            return false;
        }
        
        if (!widgetRow.isValid() || !callBackValidations(widgetRow.currentRow, widgetRow)) {
            widgetRow.activate();
            return false;
        }
        
        const newId = widget.dataSource.data.length > 0 ? Math.max(...widget.dataSource.data.map((item) => item.id || 0)) + 1 : 0;
        
        widget.dataSource.data.push({ ...widgetRow.currentRow, id: newId });
        widget.redraw();
    };
    /* jshint ignore:end */
    
    /**
     *  Rotina que permite a exclusão de registros cadastrados localmente em grid
     * 
     *  @param  args
     *  @param  widgetGridName
     * 
     */
    this.localWidgetRemoveItemInlineAction = function(args, widgetGridName) {
        const widget = templateManager.container.getWidget(widgetGridName);
        if (!widget) {
            return false;
        }
        
        const rowIndexToRemove = widget.dataSource.data.findIndex((item) => item.id == args.row.id);
        
        widget.dataSource.data.splice(rowIndexToRemove, 1);
        widget.redraw();
    };
    
    /**
     *  Função que retorna se a Widget em questão é um grid.
     * 
     *  @param  widget [Widget]
     * 
     */
    this.isWidgetGrid = function(widget) {
        const gridTemplates = ['widget/master_detail/grid.html', 'widget/grid.html'];
        return widget && widget.template ? gridTemplates.includes(widget.template) : false;
    };
    
    /**
     *  Função que retorna se a Widget em questão é um grid.
     * 
     *  @param  widget [Widget]
     * 
     */
    this.isWidgetTabbed = function(widget) {
        const gridTemplates = ['widget/tabbedWidget.html'];
        return widget && widget.template ? gridTemplates.includes(widget.template) : false;
    };
    
    /**
     *  Função que retorna se o Field em questão é um multiple.
     * 
     *  @param  widget [Widget]
     * 
     */
    this.isFieldMutiple = function(field) {
        const fieldTemplates = ['field/select-multiple.html'];
        return field && field.template ? fieldTemplates.includes(field.template) : false;
    };
     
    /**
     *  Rotina que compara datas.
     *  + Caso a primeira data seja maior que a segunda, 1 é retornada. Se for menor, -1. Igual, 0.
     * 
     *  @param  stringDate1
     *  @param  stringDate2
     * 
     *  @return int
     * 
     */
    this.compareDates = function(stringDate1, stringDate2) {
        if (!stringDate1 || !stringDate2) {
            return false;
        }
        
        const date1 = this.retornaObjetoDateComString(stringDate1);
        const date2 = this.retornaObjetoDateComString(stringDate2);
         
        return date1 > date2 ? 1 : (date1 < date2 ? -1 : 0);
    };
    
    /**
     *  Rotina que compara dois campos de data informados. Os campos são buscados na Widget passada como parâmetro
     * 
     *  @param  widget          [Widget]
     *  @param  dateFieldName1
     *  @param  dateFieldName2
     *  @param  showMessage     = true
     * 
     */
    this.checkFieldDatesGraterEqualThan = function(widget, dateFieldName1, dateFieldName2, showMessage = true) {
        const field1 = widget.getField(dateFieldName1);
        const field2 = widget.getField(dateFieldName2);
        
        if (!field1 || !field2) {
            return false;
        }
        
        if (this.compareDates(field1.value(), field2.value()) == -1) {
            if (showMessage) {
                ScreenService.showMessage(`O campo "${field1.label}" não pode ser menor que "${field2.label}"`);
            }
            return false;
        }
        
        return true;
    };
    
    /**
     *  Rotina que compara se um determinado campo é menor que zero. Os campos são buscados na Widget passada como parâmetro
     * 
     *  @param  widget          [Widget]
     *  @param  dateFieldName
     *  @param  showMessage     = true
     * 
     */
    this.checkFieldGreaterThanZero = function(widget, dateFieldName, showMessage = true) {
        const field = widget.getField(dateFieldName);
        
        if (!field) {
            return false;
        }
        
        const fieldValue = field.value() || 0;
        const isFieldValueLessThanZero = fieldValue <= 0;
        
        if (isFieldValueLessThanZero && showMessage) {
            ScreenService.showMessage(`O campo "${field.label}" deve ser maior que 0`);
        }
        
        return !isFieldValueLessThanZero;
    };
    
    /**
     *  Rotina responsável por controlar a propriedade 'readOnly' de campos informados, por meio do valor do valor do campo principal.
     * Essa rotina foi pensada para ser associada a eventos "FieldOnChange". A função saberá qual é o principal a partir do parametro 'args'
     * 
     *  @param  args                    [args]
     *  @param  secondaryFieldNames     = []
     *  @param  exactMainFieldValue     = null
     *  @param  mainFieldName           = null
     *  @param  fieldsRequired          = false
     * 
     */
    this.makeFieldReadOnlyIfNotFilled = function(args, secondaryFieldNames = [], exactMainFieldValue = null, mainFieldName = null, fieldsRequired = false) {
        const widget = args.owner.owner.getParent();
        const mainField = args.owner.field;
        
        const mainFieldValue = mainFieldName ? widget.currentRow[mainFieldName] : mainField.value();
        const readOnlySecondaryFields = exactMainFieldValue ? mainFieldValue != exactMainFieldValue : !mainFieldValue;
        
        for (const fieldName of secondaryFieldNames) {
            if (readOnlySecondaryFields) {
                widget.currentRow[fieldName] = null;
            }
            
            const field = widget.getField(fieldName);
            if (!field) {
                continue;
            }
            
            field.readOnly = readOnlySecondaryFields;
            
            // Change fields required properties only if forced
            if (fieldsRequired) {
                field.validations = readOnlySecondaryFields ? {} : { required: true };
            }
        }
        
        widget.sync();
    };
    
    /**
     *  Rotina desenvolvida com o propósito de checar se, dentro de um conjunto de campos, pelo menos um está preenchido
     * 
     *  @param  widget      [Widget]
     *  @param  fieldNames  = []
     *  @param  showMessage = true
     * 
     *  @return isValid
     */
    this.checkAtLeastOneRequired = function(widget, fieldNames = [], showMessage = true) {
        if (!widget || !widget.currentRow) {
            return false;
        }
        
        const fieldsNotFilled = [];
        let atLeastOneIsFilled = false;
        
        for (const fieldName of fieldNames) {
            const field = widget.getField(fieldName);
            if (!field) {
                continue;
            }
            
            const fieldValue = widget.currentRow[fieldName];
            const fieldIsFilled = fieldValue && !(Array.isArray(fieldValue) && fieldValue.length == 0);
            fieldsNotFilled.push(field.label);
                
            atLeastOneIsFilled = atLeastOneIsFilled || fieldIsFilled;
        }
        
        if (!atLeastOneIsFilled && showMessage) {
            ScreenService.showMessage('Atenção! Pelo menos um dos campos ' + fieldsNotFilled.map((item) => "'" + item + "'").join(', ') + ' deve ser preenchido');
        }
        
        return atLeastOneIsFilled;
    };
    
    /**
     *  Rotina que monta o dialog padrão (sim ou não) para confirmação de informações
     * 
     *  @param  message
     *  @param  callBackOnYes
     *  @param  callBackOnNo
     * 
     */
    this.defaultConfirmationDialog = function(message, callBackOnYes = function() {}, callBackOnNo = function() {}) {
        ScreenService.showCustomDialog(message, 'CONFIRMATION', null, [{
            label: ScreenService.i18n("Sim"),
            code: function(e, deferred) {
    		    callBackOnYes();
                deferred.resolve(e);
            }.bind(this)
          },{
            label: ScreenService.i18n("Não"),
            code: function(e, deferred) {
                callBackOnNo();
                deferred.reject(e);
            }
        }]);  
    };
    
    /**
     *  Rotina que faz um grid simples ser editavel
     * 
     * 
     */
    this.simpleGridEdit = function () {
        const activeWidget = templateManager.container.getActiveWidget();
        activeWidget.edit();
        activeWidget.__backupDataSourceData = Util.clone(activeWidget.dataSource.data);
    };
    
    /**
     *  Rotina que faz um grid convencional (widget/grid.html) retornar ao estado de list
     * 
     * 
     */
    this.simpleGridEditBack = function () {
        const activeWidget = templateManager.container.getActiveWidget();
        activeWidget.dataSource.data = Util.clone(activeWidget.__backupDataSourceData);
        
        activeWidget.currentRow = Util.clone(activeWidget.backupRow);
        
        self.masterDetailVoltarList(activeWidget);
    };
    
    /**
     *  Rotina que salva o valor alterado em modo 'edit' em um grid covencional, retornando para modo list
     * 
     * 
     */
    this.simpleGridEditSave = function (callback = function() { return true; }) {
        const activeWidget = templateManager.container.getActiveWidget();
        if (!activeWidget.isValid()) {
            return;
        }
        
        if (!callback()) {
            return;
        }
        
        self.masterDetailVoltarList(activeWidget);
    };
    
    /**
     *  Rotina capaz de retornar um objeto ({}) a partir de um Iterator
     * 
     *  @param  Iterator iterator
     * 
     *  @return {}
     * 
     */
    this.iteratorToObject = function(iterator) {
        const newObject = {};
        
        for (const prop of iterator) {
            if (Array.isArray(prop) && prop.length == 2) {
                newObject[prop[0]] = prop[1];
            }
        }
        
        return newObject;
    };
    
    /**
     *  Rotina capaz de tranformar registros organizados em forma de dataSourceFilter em um objeto (row)
     * 
     *  @param dataSourceFilter
     * 
     *  @return {}
     * 
     */
    this.dataSourceFilterToRow = function(dataSourceFilter) {
        const rowFromDataSourceFilter = {};
        for (const item of dataSourceFilter) {
            rowFromDataSourceFilter[item.name] = item.value;
        }
        
        return rowFromDataSourceFilter;
    };
    
    /**
     *  Rotina criada com o proposito de forcar a redefinicao de campos de uma Widget para seus valores padrao
     * 
     *  @param  args    [args]
     * 
     */
    this.widgetSetDefaultRowOnEnter = function(args) {
        const widget = self.checkWidget(args);
        
        for (const field of widget.fields) {
            field.applyDefaultValue();
        }
    };
    
    /**
     *  Rotina capaz de realizar a operacao operacao semelhante a 'eval' porem restringindo o escopo
     * 
     *  @param  scope
     *  @param  script
     * 
     */
     /* jshint ignore:start */
    this.scopeEval = function(scope, script) {
        return Function('"use strict";return (' + script + ')').bind(scope)();
    }
    /* jshint ignore:end */
    
    /**
     *  Rotina que permite que uma nova tela do sistema seja aberta em outra aba. Eh possivel informar parametros para a nova tela.
     * 
     *  @param  containerName
     *  @param  paramsSendNewTab = {}
     * 
     */
    /* jshint ignore:start */
    this.openNewTab = async function(containerName, paramsSendNewTab = {}) {
        const URL = await this.getURL(containerName);
        
        for (const param in paramsSendNewTab) {
            if (paramsSendNewTab[param]) {
                URL.searchParams.set(param, paramsSendNewTab[param]);
            }
        }
        
        window.open(URL, '_blank');
    };
    /* jshint ignore:end */
    
    /**
     *  Rotina que retorna um objeto URL com a url do container informado. Essa operacao eh importante para a abertura de novas abas do sistema
     * 
     *  @param  containerName
     * 
     */
    /* jshint ignore:start */
    this.getURL = async function (containerName) {
        const productMobileBaseUrl = await this.getProductMobileBaseUrl();
        return new URL(productMobileBaseUrl + containerName);
    };
    /* jshint ignore:end */
    
    /**
     *  Rotina que retorna um objeto URL com a url corrente do sistema. Essa operacao eh importante para a obtencao de parametros informados a tela
     * 
     */
    this.getCurrentURL = function () {
        return new URL(window.location.href);
    };
    
    /**
     *  Rotina que obtem os parametros informados na url em forma de objeto
     * 
     *  @param  URL URL
     * 
     *  @return {}
     * 
     */
    /* jshint ignore:start */
    this.getURLParams = async function(URL = {}) {
        let URLFinal = URL;
        if (Util.isEmptyObject(URLFinal)) {
            URLFinal = await this.getCurrentURL();
        }
        
        return self.iteratorToObject(URLFinal.searchParams.entries());
    };
    /* jshint ignore:end */
    
    /**
     *  Rotina que possibilita a analise dos parametros informados a uma tela e a aplicacao destes ao filtro da tela. Por padrao, invoca a rotina this.getDataSourceDataUrlItemsDefaultCallback,
     * responsavel por montar os parametros ao dataSource da Widget da nova tela, e this.applyDataSourceItemsDefaultCallback, responsavel por aplica-los ao dataSourceFilter da Widget.
     * Eh possivel sobrescrever esses comportamentos informando callbacks como argumento.
     * 
     *  Evento Zeedhi: 'WidgetOnEnter'
     * 
     *  @parm   args                            [args]
     *  @parm   getDataSourceUrlItemsCallback   () => []
     *  @param  alterFilterRowCallback          () => undefined
     *  @param  applyDataSourceItemsCallback    () => undefined
     * 
     */
    /* jshint ignore:start */
    this.applyUrlParamsOnEnter = async function(args, beforeApplyDataSourceFilterCallback = function() {}, applyDataSourceItemsCallback = this.applyDataSourceItemsDefaultCallback, alterFilterRowCallback = this.alterFilterRowDefaultCallback, getDataSourceUrlItemsCallback = this.getDataSourceDataUrlItemsDefaultCallback) {
        
        // Monta objeto com os parametros informados na URL
        const allParams = await self.getURLParams();
        
        // Widget informada no filtro
        const paramWidget = allParams.widget && templateManager.container.getWidget(allParams.widget) ?
            templateManager.container.getWidget(allParams.widget) : templateManager.container.getActiveWidget();
        delete allParams.widget;
        
        // Widget acionada no evento WidgetOnEnter
        const currentWidget = args.owner;
        
        // Aciona a rotina que manipulara a interface de acordo com os parametros
        const dataSourceNewItems = getDataSourceUrlItemsCallback(allParams, currentWidget, paramWidget);
        
        alterFilterRowCallback(paramWidget, allParams, dataSourceNewItems);
        
        // Rotina que aplicara os filtros informados na url
        applyDataSourceItemsCallback(dataSourceNewItems, paramWidget, beforeApplyDataSourceFilterCallback);
    };
    /* jshint ignore:end */
    
    /**
     *  Monta o dataSourceFilter a partir de parametros obtidos da url. Eh a rotina padrao executada em this.applyUrlParamsOnEnter
     * 
     *  @param  args        [args]
     *  @param  urlParams   {}
     * 
     */
    /* jshint ignore:start */
    this.getDataSourceDataUrlItemsDefaultCallback = function (urlParams, currentWidget, paramWidget) {
        const dataSourceFilterUrlParams = [];
        
        /* Tratativas especificas para templates de Widget */
        
        if (self.isWidgetTabbed(currentWidget)) {
            currentWidget.openTab(paramWidget.name);
        }
        
        if (Util.isEmptyObject(urlParams)) {
            return dataSourceFilterUrlParams;
        }
        
        /* Monta dataSourceFilter da Widget com as informacoes da URL */
        
        for (const filterName in urlParams) {
            
            // Otem o campo a partir do nome informado na url. O campo tambem eh buscando dentro de 'filterProperties'
            const field = paramWidget.getField(filterName) || paramWidget.fields.find((item) => item.filterProperties && item.filterProperties.name == filterName);
            
            let filterNameFinal = filterName;
            let filterValueFinal = urlParams[filterNameFinal];
            
            // Altera propriedades caso exista um Field com o nome do parameto
            if (field) {
                filterValueFinal = self.isFieldMutiple(field) ? filterValueFinal.split(',') : filterValueFinal;
                filterNameFinal = field.filterProperties && field.filterProperties.name ? field.filterProperties.name : filterName;
                
                // Caso campo seja descricao o filtro nao devera ser aplicado
                if (field.descriptionField && field.descriptionField == filterNameFinal) {
                    continue;
                }
            }
            
            dataSourceFilterUrlParams.push(
                {
                    name: filterNameFinal,
                    operator: Array.isArray(filterValueFinal) ? "IN" : "=",
                    value: filterValueFinal,
                }
            );
        }
        
        return dataSourceFilterUrlParams;
        
    };
    /* jshint ignore:end */
    
    /**
     *  Rotina padrao para a aplicacao de novos itens a um dataSourceFilter
     * 
     *  @param  dataSourceNewItems
     *  @param  widget              [Widget]
     * 
     */
    this.applyDataSourceItemsDefaultCallback = function(dataSourceNewItems, widget, beforeApplyDataSourceFilterCallback = function() {}) {
        /* Altera informacoes do dataSourceFilter */
        
        if (!Array.isArray(dataSourceNewItems) || dataSourceNewItems.length == 0) {
            return;
        }
        
        for (const item of dataSourceNewItems) {
            const existingFilter = widget.dataSourceFilter.find((existingDataSourceFilterItem) => existingDataSourceFilterItem.name == item.name);
            if (existingFilter) {
                existingFilter.value = item.value;
                continue;
            }
            
            widget.dataSourceFilter.push(item);
        }
        
        const defaultTimeout = 3000;
        
        if (Util.isFunction(beforeApplyDataSourceFilterCallback)) {
            beforeApplyDataSourceFilterCallback(widget);
        }
        
        /* Trataiva para garantir que o filtro seja aplicado e o popUp de filtro seja fechado */
        
        setTimeout(() => {
            widget.reload().then(function(callBack){
                setTimeout(() => {
                    ScreenService.closePopup();
                }, defaultTimeout);
            });
        }, defaultTimeout);
    };
    
    /**
     *  Rotina que altera a row do filtro para a utilizacao de valores informados na url. Rotina padrao dentro das acoes em this.applyUrlParamsOnEnter
     * 
     *  @param  widget              [Widget]
     *  @param  allParams           {}
     *  @param  dataSourceNewItems  []
     * 
     */
    this.alterFilterRowDefaultCallback = function(widget, allParams, dataSourceNewItems) {
        if (!widget.appliedFilter) {
            widget.appliedFilter = {FILTER_ROW: {}};
        }
        
        for (const item of dataSourceNewItems) {
            widget.appliedFilter.FILTER_ROW[item.name] = item.value;
        }
        
        for (const itemName in allParams) {
            widget.appliedFilter.FILTER_ROW[itemName] = allParams[itemName];
        }
    };  
    
    /**
     *  Rotina responnsavel por verificar se foram aplicados parametros via url para o atual estado do sistema
     * 
     */
    /* jshint ignore:start */
    this.urlParamsApplied = async function() {
        const urlParams = await self.getURLParams();
        return !Util.isEmptyObject(urlParams);
    };
    /* jshint ignore:end */
    
    /**
     *  Rotina que busca a url do produto, a url que faz referencia as rotas das telas
     * 
     */
    /* jshint ignore:start */
    this.getProductMobileBaseUrl = async function () {
        const modules = await this.requestModulesMetadata();
        return window.location.origin + "/" + modules.product.baseUrl + "/#/product#";
    };
    /* jshint ignore:end */
    
    /**
     *  Rotina que busca os parametros informados no arquivo 'json/modules.json'. Rotina copiada de LibUtilities
     * 
     */
    this.requestModulesMetadata = function () {
        var modulesPackage = window.modulesPackage || "modules";
        return restEngine.requestMetaData(modulesPackage + "#json/modules.json").then(function (response) {
            return response.data;
        });
    };
    
    this.deleteCircularProperties = function (object) {
        object.__leftActions = null;
        object.__rightActions = null;
        return object;
    };
    
    this.isFileExtensionValid = function (fileName, validFileExtensions = []) {
        const fileExtension = fileName.split('.').pop() || '';
        return validFileExtensions.includes(fileExtension.toLowerCase());
    };
    
    this.limitFilePathFieldToOneItem = function (widget, fieldName) {
        return this.limitFilePathField(widget, fieldName, 1);
    };
    
    this.limitFilePathField = function (widget, fieldName, size) {
        if (this.limitFilePathFieldItemsSize(widget, fieldName, size)) {
            ScreenService.showMessage(`Só é possível selecionar ${size} arquivo(s).`, 'WARNING');
            setTimeout(() => {
                widget.currentRow.DSPATH.pop();
            }, 500);
        }
    };
    
    this.limitFilePathFieldItemsSize = function (widget, fieldName, size) {
        const filePathField = widget.currentRow[fieldName] || [];
        return Array.isArray(filePathField) && filePathField.length >= size;
    };
    
    this.unavailableService = function () {
        ScreenService.showMessage(Messages.SERVICE_UNAVAILABLE, 'WARNING');
    };
    
    this.reloadAndUpdateWidgetCurrentRowAfterSave = function (widget, rowKeyName) {
        widget.reload().then(function () {
            widget.currentRow = widget.dataSource.data.find((item) => item[rowKeyName] === widget.currentRow[rowKeyName]);
            widget.view();
        });
    };
    
    this.applyConditionToWidgetAction = function (widget, actionsName, condition) {
        const processedCondition = '@templateManager.container.getActiveWidget().currentRow.' + condition.replace('row.', '') + '@';
        const isConditionValid = ZhUtil.evaluate(processedCondition);
        
        for (const actionName of actionsName) {
            const action = widget.getAction(actionName) || {};
            action.isVisible = isConditionValid;
        }
    };
    
    this.showResponseMessages = function (responseMessages) {
        const messages = responseMessages.map((item) => item.message);
        const messageBody =
            messages ? messages.reduce((accMessage, currentMessage) => accMessage + Messages.TEXT_BREAK + currentMessage) : '';

        if (messageBody) {
            const fullMessage = Messages.SHOW_WANINGS_TITLE + messageBody;
            ScreenService.showMessage(fullMessage);
        }        
    };
    
    this.updateGridCheckboxVisibility = function (widget) {
        let gridCheckboxBlocked = true;
        if (widget.inListMode()) {
            gridCheckboxBlocked = false;
        }
        
        self.blockCheckbox(widget.id, gridCheckboxBlocked);
    };
    
}


Configuration(function(ContextRegister) {
    ContextRegister.register('ABUtilController', ABUtilController);
});


// FILE: assets/js/controllers/AFormataHoraDecimal.js
/**
 * Created by leonardocarvalho on 17/08/2015.
 */

function AFormataHoraDecimal(ScreenService, templateManager, localStorageEngine) {

    /**
     * CONVERSÃO DE VALOR HORA DECIMAL E HORA-MINUTO PARA STRING NO FORMATO HH:MM:SS
     * No Birt usar estas no script 'initialize' do 'Report Design'.
     * 30/01/2015 Rafael Pickbrenner
     * Exemplos:
     * hms(6.2)    = "06:12:00"   -   hms_hm(6.2)    = "06:20:00"
     * hms(7.3333) = "07:20:00"   -   hms_hm(7.3333) = "07:33:20"
     * hms(8.95)   = "08:57:00"   -   hms_hm(8.95)   = "09:35:00"
     */
    /**
     * Converte um valor (positivo ou negativo) em hora decimal para exibição em hh:mm (string)
     */
    this.formataHoraDecimal = function(x) {
        if (x === null || x === 0)		//Verifica se houve entrada de valor
            return "00:00"; //Nenhum valor entrou, retorna null
        if (x === '-')
            return "-";

        f = "";				//Flag de sinal de negativo

        x = x.replace(',', '.');
        x = parseFloat(x);

        if (x < 0) {			//Verifica se o valor é negativo
            x *= -1;		//Passa o valor para positivo
            f = "-";		//Ajusta o flag de sinal para negativo
        }

        h = Math.floor(x);	//Parte inteira das horas
        m2 = (x - h) * 60;	//Minutos fracionados
        m = Math.round(m2);	//Parte inteira dos minutos
        //s = Math.round((m2 - m) * 60);	//Segundos inteiros (arredondamento)
        //Caso os segundos e/ou minutos superem 60 estes são atualizados
        /*if (s >= 60) {
            m++;
            s -= 60;
        }*/
        if (m >= 60) {
            h++;
            m -= 60;
        }
        //Mantendo sempre no mínimo 2 casas
        if (h < 10)    h = "0" + h.toString();
        else        h = h.toString();
        h = f + h;			//Adiciona o sinal (se necessário)
        if (m < 10)    m = "0" + m.toString();
        else        m = m.toString();
        //if(s < 10)	s = "0" + s.toString();
        //else		s = s.toString();
        return h + ":" + m/* + ":" + s*/;
    };

    this.getHoraFloatDeString = function(hora)
    {
        hora = hora.replace(":", "");

        minutos = hora.substr(-2);
        horas = hora.substr(0, 2);
        horasFloat = parseFloat(horas);

        sinal = 1;
        if(horasFloat < 0) {
            sinal = -1;
        }

        horasFloat = sinal * (Math.abs(horasFloat) + (parseFloat(minutos)/60));

        return horasFloat;
    };

    this.getHoraStringDeFloat = function(hora, comSeparador){
        if(Util.isNull(comSeparador)){
            comSeparador = false;
        }
        separador = "";
        if(comSeparador) {
            separador = ":";
        }

        horafloat = parseFloat(hora);

        sinal = 1;
        if(horafloat < 0) {
            sinal = -1;
        }

        horafloat = Math.abs(horafloat);

        minutos = Math.round((horafloat-Math.floor(horafloat))*60);
        if(minutos >= 60){
            /* Essa situação acontece quando a parte decimal da hora é muito perto de 1.
               Exemplo: 7.99999 retornava 07:60 quando deveria retornar 08:00 */
            minutos = this.padLeft(2, (minutos-60), "0");
            somahora = 1;
        } else {
            minutos = this.padLeft(2, (minutos), "0");
            somahora = 0;
        }

        horas = Math.floor(horafloat)+somahora;
        horas = this.padLeft(2, horas, "0");

        horastring = horas.concat(separador.concat(minutos));
        if(sinal < 0) {
            horastring = '-'.horastring;
        }

        return horastring;
    };

    this.padLeft = function(width, string, padding) { 
      return (width > string.toString().length) ?  this.padLeft(width, padding + string, padding) : string.toString();
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('AFormataHoraDecimal', AFormataHoraDecimal);
});

// FILE: assets/js/controllers/AcaoController.js
function AcaoController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, General, Messages, HcmConsts) {

    var self = this;
    var mensagem = '';
    
    this.adicionarRow = function(args) {
        var widget = args.owner.widget;
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
    };

    this.filtrarWidgets = function(args) {
        var widget = args.owner;
        templateManager.container.getWidget("Tramitacao").dataSourceFilter[0].value = widget.currentRow.NRACAO;
        templateManager.container.getWidget("Historico").dataSourceFilter[0].value = widget.currentRow.NRACAO;
        templateManager.container.getWidget("Etapas").dataSourceFilter[0].value = widget.currentRow.NRACAO;
        templateManager.container.getWidget("Observacao").dataSourceFilter[0].value = widget.currentRow.NRACAO;
    };

    this.habilitaClausula = function(widget) {
        if(!Util.isEmptyOrBlank(widget.currentRow.CDNORMA)){
            widget.getField("NMCLAUSULA").dataSourceFilter[0].value = widget.currentRow.CDNORMA;
            widget.getField("NMCLAUSULA").readOnly = false;
        }  else {
            widget.getField("NMCLAUSULA").readOnly = true;
            widget.currentRow.NMCLAUSULA = "";
            widget.currentRow.CDCLAUSULA = "";
        }
    };
    this.widgetsvisiblefalse = function(args) {
        var widget = templateManager.container.getWidget("Acao");
        this.habilitaClausula(widget);
        templateManager.container.getWidget("Tramitacao").showAsTab = false;
        templateManager.container.getWidget("Historico").showAsTab = false;
        templateManager.container.getWidget("Etapas").showAsTab = false;
        templateManager.container.getWidget("Observacao").showAsTab = false;
    };

    this.widgetsvisibletrue = function(args) {
        templateManager.container.getWidget("Tramitacao").showAsTab = true;
        templateManager.container.getWidget("Historico").showAsTab = true;
        templateManager.container.getWidget("Etapas").showAsTab = true;
        templateManager.container.getWidget("Observacao").showAsTab = true;
    };
    
    this.setOperadorVisto = function(){
        var widget = templateManager.container.getActiveWidget();
        if(widget.currentRow.CBVISTO == 'S'){
            widget.currentRow.CDOPEVISTOAC = getLocalVar('HCM_CDOPERADOR');
            widget.currentRow.NMOPEVISTOAC = getLocalVar('HCM_NMOPERADOR');
        }else{
            widget.currentRow.CDOPEVISTOAC = ''; 
            widget.currentRow.NMOPEVISTOAC = ''; 
        }
    };

    this.setAcao = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
            if (!widget.backupRow) {
                widget.currentRow.__is_new = true;
                widget.currentRow.salvaH = true;
            } else {
                widget.currentRow.__is_new = false;
                if(widget.backupRow.DTPREVENCEAC.substr(0,10) != widget.currentRow.DTPREVENCEAC.substr(0,10))
                    widget.currentRow.salvaH = true;
                else
                    widget.currentRow.salvaH = false;
            }
            restEngine.post('product#/setAcao', {
                'requestType': 'DataSet',
                'dataset': [widget.currentRow]
            }).
            then(function(data) {
                if (data.notifications[0].type === "success") {
                    ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                    if (widget.currentRow.__is_new) {
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    } else {
                        ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                        widget.backupRow = null;
                        widget.view();
                    }
                } else {
                    ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                }
            }).
            catch(function(e) {
                var error;
                if (e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
        }
    };

    this.deleteAcao = function(args) { 
        ScreenService.confirmMessage(Messages.DELETE_ROW, 'CONFIRMATION', function(){
        var widget = args.owner.widget;
        widget.currentRow.__is_new = false;
        restEngine.post('product#/deleteAcao', {
            'requestType': 'DataSet',
            'dataset': [widget.currentRow]
        }).
        then(function(data) {
            if (data.notifications[0].type === "success") {
                ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                ABUtilController.masterDetailVoltarList(widget);
                widget.reload();
            } else {
                ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
            }
        }).
        catch(function(e) {
            var error;
            if (e.data.error === undefined)
                error = e;
            else
                error = e.data.error;
            ScreenService.showMessage(error, 'ERROR');
        });
    });};
    
    
    this.setLogprevacao = function(args) {
        var widget = args.owner.widget;
        widget.currentRow.NRACAO = templateManager.container.getWidget('Acao').currentRow.NRACAO;
        if (widget.isValid()) {
            if (!widget.backupRow) {
                widget.currentRow.__is_new = true;
            } else {
                widget.currentRow.__is_new = false;
            }
            restEngine.post('product#/setLogprevacao', {
                'requestType': 'DataSet',
                'dataset': [widget.currentRow]
            }).
            then(function(data) {
                if (data.notifications[0].type === "success") {
                    ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                    if (widget.currentRow.__is_new) {
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    } else {
                        ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                        widget.backupRow = null;
                        widget.view();
                    }
                } else {
                    ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                }
            }).
            catch(function(e) {
                var error;
                if (e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
        }
    };

    this.deleteLogprevacao = function(args) { 
        ScreenService.confirmMessage(Messages.DELETE_ROW, 'CONFIRMATION', function(){
            
        var widget = args.owner.widget;
        widget.currentRow.__is_new = false;
        restEngine.post('product#/deleteLogprevacao', {
            'requestType': 'DataSet',
            'dataset': [widget.currentRow]
        }).
        then(function(data) {
            if (data.notifications[0].type === "success") {
                ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                ABUtilController.masterDetailVoltarList(widget);
                widget.reload();
            } else {
                ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
            }
        }).
        catch(function(e) {
            var error;
            if (e.data.error === undefined)
                error = e;
            else
                error = e.data.error;
            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
        });
    
        });};
    
    this.setTramitacao = function(args) {
        var widget = args.owner.widget;
        widget.currentRow.NRACAO = templateManager.container.getWidget('Acao').currentRow.NRACAO;
        if (widget.isValid()) {
            if (!widget.backupRow) {
                widget.currentRow.__is_new = true;
            } else {
                widget.currentRow.__is_new = false;
            }
            restEngine.post('product#/setTramitacao', {
                'requestType': 'DataSet',
                'dataset': [widget.currentRow]
            }).
            then(function(data) {
                if (data.notifications[0].type === "success") {
                    ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                    if (widget.currentRow.__is_new) {
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    } else {
                        ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                        widget.backupRow = null;
                        widget.view();
                    }
                } else {
                    ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                }
            }).
            catch(function(e) {
                var error;
                if (e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
        }
    };

    this.deleteTramitacao = function(args) { 
        ScreenService.confirmMessage(Messages.DELETE_ROW, 'CONFIRMATION', function(){
            
        var widget = args.owner.widget;
        widget.currentRow.__is_new = false;
        restEngine.post('product#/deleteTramitacao', {
            'requestType': 'DataSet',
            'dataset': [widget.currentRow]
        }).
        then(function(data) {
            if (data.notifications[0].type === "success") {
                ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                ABUtilController.masterDetailVoltarList(widget);
                widget.reload();
            } else {
                ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
            }
        }).
        catch(function(e) {
            var error;
            if (e.data.error === undefined)
                error = e;
            else
                error = e.data.error;
            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
        });
    
        });};
        
    this.setEtapaAcao = function(args) {
        var widget = args.owner.widget;
        widget.currentRow.NRACAO = templateManager.container.getWidget('Acao').currentRow.NRACAO;
        if (widget.isValid()) {
            if(ABUtilController.validaDtIniMenorIgualDtFin(widget.currentRow.DTINICETAP , widget.currentRow.DTCONCETAP)){
            
            if (!widget.backupRow) {
                widget.currentRow.__is_new = true;
            } else {
                widget.currentRow.__is_new = false;
            }
            restEngine.post('product#/setEtapaAcao', {
                'requestType': 'DataSet',
                'dataset': [widget.currentRow]
            }).
            then(function(data) {
                if (data.notifications[0].type === "success") {
                    ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                    if (widget.currentRow.__is_new) {
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    } else {
                        ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                        widget.backupRow = null;
                        widget.view();
                    }
                } else {
                    ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                }
            }).
            catch(function(e) {
                var error;
                if (e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
        
            }else{
                ScreenService.showMessage(Messages.DTINI_POST_DTFIM_ERROR);
            }
        }
    };

    this.deleteEtapaAcao = function(args) { 
        ScreenService.confirmMessage(Messages.DELETE_ROW, 'CONFIRMATION', function(){
            
        var widget = args.owner.widget;
        widget.currentRow.__is_new = false;
        restEngine.post('product#/deleteEtapaAcao', {
            'requestType': 'DataSet',
            'dataset': [widget.currentRow]
        }).
        then(function(data) {
            if (data.notifications[0].type === "success") {
                ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                ABUtilController.masterDetailVoltarList(widget);
                widget.reload();
            } else {
                ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
            }
        }).
        catch(function(e) {
            var error;
            if (e.data.error === undefined)
                error = e;
            else
                error = e.data.error;
            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
        });
    
        });};   
        
    this.setObsAcao = function(args) {
        var widget = args.owner.widget;
        widget.currentRow.NRACAO = templateManager.container.getWidget('Acao').currentRow.NRACAO;
        if (widget.isValid()) {
            
            
            if (!widget.backupRow) {
                widget.currentRow.__is_new = true;
            } else {
                widget.currentRow.__is_new = false;
            }
            restEngine.post('product#/setObsAcao', {
                'requestType': 'DataSet',
                'dataset': [widget.currentRow]
            }).
            then(function(data) {
                if (data.notifications[0].type === "success") {
                    ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                    if (widget.currentRow.__is_new) {
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    } else {
                        ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                        widget.backupRow = null;
                        widget.view();
                    }
                } else {
                    ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                }
            }).
            catch(function(e) {
                var error;
                if (e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
        
        }
    };

    this.deleteObsAcao = function(args) { 
        ScreenService.confirmMessage(Messages.DELETE_ROW, 'CONFIRMATION', function(){
            
        var widget = args.owner.widget;
        widget.currentRow.__is_new = false;
        restEngine.post('product#/deleteObsAcao', {
            'requestType': 'DataSet',
            'dataset': [widget.currentRow]
        }).
        then(function(data) {
            if (data.notifications[0].type === "success") {
                ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                ABUtilController.masterDetailVoltarList(widget);
                widget.reload();
            } else {
                ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
            }
        }).
        catch(function(e) {
            var error;
            if (e.data.error === undefined)
                error = e;
            else
                error = e.data.error;
            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
        });
    
        });};   
    
}

Configuration(function(ContextRegister) {
    ContextRegister.register('AcaoController', AcaoController);
});


// FILE: assets/js/controllers/AdmissaoController.js
/* jshint esversion: 6 */

function AdmissaoController (ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine,Messages, $window, ABUtilController, HcmConsts) {

    var templateWidget;
    var telaRetorno;
    var pessoaCadastrada;
    var mensagem = '';
    var vinculosRescindidos;
    var solicitacao;
    var nrtipoestrutura = '';
    var nmtipoestrutura = '';
    var tpEstrutAntigo;
    this.verificaEnvioEsocialDescentralizado = true;
    var self = this;
    var cpfPesquisado = false;
    var cpfAnterior = '';
    var dadosAdmissao = [];
    var validaIniciaContinuaAdmissao = false;
    var validaContratoVerdeAmarelo = false;
    this.lastArgs = {};
    this.eSocialController = {};
    this.ignorarVerificacaoQuadroVagas = false;
    
    this.getValidaIniciaContinuaAdmissao = function() {
        return validaIniciaContinuaAdmissao;
    };
    
    this.setValidaIniciaContinuaAdmissao = function(value) {
        validaIniciaContinuaAdmissao = value;
    };
    
    this.getPessoaCadastrada = function() {
        return pessoaCadastrada;
    };
    
    this.setPessoaCadastrada = function(value) {
        pessoaCadastrada = value;
    };
    
    this.getDadosAdmissao = function() {
        return dadosAdmissao;
    };
    
    this.setDadosAdmissao = function(nrcpfpessoa, nrpessoa, nmoperador, dtnascpessoa, idmultvinc) {
        dadosAdmissao.NRCPFPESSOA = nrcpfpessoa;
        dadosAdmissao.NRPESSOA = nrpessoa;
        dadosAdmissao.NMPESSOA = nmoperador;
        dadosAdmissao.DTNASCPESSOA = dtnascpessoa;
        dadosAdmissao.IDMULTVINC = idmultvinc;
    };

    this.setMotivoAdmissao = function (args) {
        var widget = ABUtilController.checkWidget(args);
        if (widget.currentRow.NRMOTIVOADMISSAO) {
            widget.getField('NMVINCULOMSUBST').readOnly = false;
        } else {
            widget.currentRow.NRVINCULOMSUBST = '';
            widget.currentRow.NMVINCULOMSUBST = '';
            widget.getField('NMVINCULOMSUBST').readOnly = true;
        }
    };

    this.filtraTurno = function(args){
        var widget = ABUtilController.checkWidget(args);
        var escalaTrabalho = widget.currentRow.NRESCALATRABM;
        if(escalaTrabalho) {
            widget.getField('DSTURNO').dataSourceFilter[ABUtilController.retornaFiltro(widget.getField('DSTURNO').dataSourceFilter, 'NRESCALATRABM')].value = escalaTrabalho;
            widget.getField('DSTURNO').readOnly = false;
            return true;
        }else{
            widget.currentRow.DSTURNO = '';
            widget.currentRow.NRTURNO = '';
            widget.getField('DSTURNO').readOnly = true;
            return false;
            
        }  
    };
    
    this.selecionaTurno = function(args){
        var widget = ABUtilController.checkWidget(args);
        var filtro = widget.getField('DSTURNO').dataSourceFilter[ABUtilController.retornaFiltro(widget.getField('DSTURNO').dataSourceFilter, 'P_NRESCALATRABM')];
        
        if(filtro){    
            widget.getField('DSTURNO').reload().then(function(){
                var dados = widget.getField('DSTURNO').dataSource.data;
                if(dados.length === 1){
                    widget.currentRow.DSTURNO = dados[0].DSTURNO;
                    widget.currentRow.NRTURNO = dados[0].NRTURNO;
                }
            }.bind(this));
        }
    };
    
    // this.openAdmissao = function(args){
    //     var widget = ABUtilController.checkWidget(args);
        
    //     if(args.row.NRTIPOSOLICITACAO)
    //         solicitacao = args.row;
    //     else
    //         solicitacao = false;
        
    //     ScreenService.showCustomDialog('A pessoa já foi cadastrada para realizar a admissão?', 'CONFIRMATION', null, [
    //         {
    //             label: ScreenService.i18n("Sim"),
    //             code: function (e, deferred) {
    //                 pessoaCadastrada = true;
    //                 ScreenService.openWindow('product#hcm01055_fpa_admissao');
    //                 deferred.resolve(e);
    //             }.bind(this)
    //         },
    //         {
    //             label: ScreenService.i18n("Não"),
    //             code: function (e, deferred) {
    //                 pessoaCadastrada = false;
    //                 ScreenService.openWindow('product#hcm01055_fpa_admissao');
    //                 deferred.reject(e);
    //             }
    //         }
    //     ]);
    // };
    
    this.setNomeVinculo = function(args){
        if(args.row.NMPESSOA) {
            templateManager.container.getWidget("vinculo").currentRow.NMVINCULOM = args.row.NMPESSOA;
        }
    };
    
    this.cpfOnChange = function(){
        var widget = templateManager.container.getWidget('cpfPessoaTabbed');
        
        if(widget.currentRow.NRCPFPESSOA && cpfAnterior != widget.currentRow.NRCPFPESSOA){
            cpfPesquisado = false;
            cpfAnterior = widget.currentRow.NRCPFPESSOA;
        }
    };
    
    this.buscarPessoaCPF = function(){
        var widgetPessoa = templateManager.container.getActiveWidget();

        if(!Util.isEmptyOrBlank(widgetPessoa.parent.currentRow.NRCPFPESSOA)){
            restEngine.post('product#/buscarPessoaCPF', {'requestType': 'DataSet', 'dataset': [widgetPessoa.parent.currentRow]}).
                then(function (data) {
                    cpfPesquisado = true;
                    if(data.dataset && data.dataset.buscarPessoaCPF){
                        widgetPessoa.dataSource.data = data.dataset.buscarPessoaCPF;
                    }
                    if (data.messages) {
                        ScreenService.showMessage(data.messages[0].message, data.messages[0].type);
                    }
                }).
                catch(function(e) {
                    var error;
                    if(e.data.error === undefined){
                        error = e;
                    }    
                    else{
                        error = e.data.error;
                        ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    }    
                });
        }
    };
    
    // ------ FORMA ANTERIOR DA ADMISSÃO ------//
    
    // this.onEnterAdmissao = function(args){
    //     var widget = ABUtilController.checkWidget(args);
    //     if(pessoaCadastrada){
    //         templateManager.container.getWidget("Pessoa").showAsTab = false;
    //         templateManager.container.getWidget("enderecoParc").showAsTab = false;
    //         templateManager.container.getWidget("formaComunicacaoParc").showAsTab = false;
    //         templateManager.container.getWidget("contaCorrenteParc").showAsTab = false;
            
    //         templateManager.container.getWidget("vinculo").getField("NMPESSOA").validations = {
    //             "required":{}
    //         };
    //         templateManager.container.getWidget("vinculo").getField("NMPESSOA").readOnly = false;
            
    //     }else{
    //         templateManager.container.getWidget("Pessoa").showAsTab = true;
    //         templateManager.container.getWidget("enderecoParc").showAsTab = true;
    //         templateManager.container.getWidget("formaComunicacaoParc").showAsTab = true;
    //         templateManager.container.getWidget("contaCorrenteParc").showAsTab = true;
    //         templateManager.container.getWidget("vinculo").getField("NMPESSOA").validations = {};
            
    //         templateManager.container.getWidget("vinculo").getField("NMPESSOA").readOnly = true;
    //     }
    //     this.newRowWidgets();
    //     widget.widgets[0].deactivate();
    //     widget.widgets[0].activate();
    // };
    
    /* jshint ignore:start */
    this.iniciaContinuaAdmissao = async function(pessoaCadastradaAdmissao){
        var widgetCPF = templateManager.container.getWidget('cpfPessoaTabbed');
        if(widgetCPF.isValid()){
            if(((widgetCPF.widgets[0].dataSource.data.length > 0 && widgetCPF.widgets[0].getCheckedRows().length == 1) || widgetCPF.widgets[0].dataSource.data.length == 0) && cpfPesquisado){
                pessoaCadastrada = pessoaCadastradaAdmissao;
                validaIniciaContinuaAdmissao = true;
                dadosAdmissao.NRCPFPESSOA = widgetCPF.currentRow.NRCPFPESSOA; 
                if(widgetCPF.widgets[0].getCheckedRows().length == 1){
                    dadosAdmissao.IDMULTVINC = widgetCPF.widgets[0].dataSource.data.length > 1 || widgetCPF.widgets[0].getCheckedRows()[0].VINCULOATIVO == 'S' ? 'PRIMARIO' : 'UNICO';
                    dadosAdmissao.NMPESSOA = widgetCPF.widgets[0].getCheckedRows()[0].NMPESSOA; 
                    dadosAdmissao.NRPESSOA = widgetCPF.widgets[0].getCheckedRows()[0].NRPESSOA;
                    dadosAdmissao.NRPISPASEPPES = widgetCPF.widgets[0].getCheckedRows()[0].NRPISPASEPPES;
                    dadosAdmissao.NRCTPSPESSOA = widgetCPF.widgets[0].getCheckedRows()[0].NRCTPSPESSOA;
                    dadosAdmissao.NRSERIECTPSPES = widgetCPF.widgets[0].getCheckedRows()[0].NRSERIECTPSPES;
                    dadosAdmissao.DTCTPSPESSOA = widgetCPF.widgets[0].getCheckedRows()[0].DTCTPSPESSOA;
                    dadosAdmissao.NMUFCTPSPES = widgetCPF.widgets[0].getCheckedRows()[0].NMUFCTPSPES;
                    dadosAdmissao.NMUFRGPESSOA = widgetCPF.widgets[0].getCheckedRows()[0].NMUFRGPESSOA;
                    dadosAdmissao.NRPARCNEGOCIO = widgetCPF.widgets[0].getCheckedRows()[0].NRPARCNEGOCIO;
                    dadosAdmissao.DTNASCPESSOA = widgetCPF.widgets[0].getCheckedRows()[0].DTNASCPESSOA;
                    dadosAdmissao.NRCPFPESSOA = widgetCPF.widgets[0].getCheckedRows()[0].NRCPFPESSOA;
                    dadosAdmissao.NMESTACIVIL = widgetCPF.widgets[0].getCheckedRows()[0].NMESTACIVIL;
                    dadosAdmissao.NRGRAUINSTR = widgetCPF.widgets[0].getCheckedRows()[0].NRGRAUINSTR;
                    dadosAdmissao.CDPAIS = widgetCPF.widgets[0].getCheckedRows()[0].CDPAIS;
                    dadosAdmissao.NRRGPESSOA = widgetCPF.widgets[0].getCheckedRows()[0].NRRGPESSOA;
                    dadosAdmissao.CDEXRGPESSOA = widgetCPF.widgets[0].getCheckedRows()[0].CDEXRGPESSOA;
                    dadosAdmissao.DTEXRGPESSOA = widgetCPF.widgets[0].getCheckedRows()[0].DTEXRGPESSOA;
                    dadosAdmissao.SGUFRGPESSOA = widgetCPF.widgets[0].getCheckedRows()[0].SGUFRGPESSOA;
                    dadosAdmissao.NRNACIONALID = widgetCPF.widgets[0].getCheckedRows()[0].NRNACIONALID;
                    dadosAdmissao.DTADMISSAOPRE = widgetCPF.widgets[0].getCheckedRows()[0].DTADMISSAOPRE;
                    dadosAdmissao.CDRECIBOADMPRE = widgetCPF.widgets[0].getCheckedRows()[0].CDRECIBOADMPRE;
                    await restEngine.post('product#/procuraPorDependentes', {'requestType':'DataSet','dataset':[widgetCPF.widgets[0].getCheckedRows()[0]]}).then(function(data){
                        if(data.dataset && data.dataset.procuraPorDependentes){
                            if (!Util.isEmptyOrBlank(data.dataset.procuraPorDependentes)) {
                                dadosAdmissao.DEPENDENTES = data.dataset.procuraPorDependentes;
                            }
                        }
                        if(data.messages){
                            ScreenService.showMessage(data.messages[0].message);
                        }
                    }.bind(self)).catch(function(e) {
                        var error;
                        if(e.data.error === undefined)
                            error = e;
                        else 
                            error = e.data.error;
                            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    });
                }
                ScreenService.closePopup();
                ScreenService.openWindow('product#hcm01055_fpa_admissao');
            }else if(!cpfPesquisado){
                ScreenService.showMessage('Pesquise o CPF antes de iniciar a admissão!');
            }else if(widgetCPF.widgets[0].dataSource.data.length > 0 && widgetCPF.widgets[0].getCheckedRows().length > 1){
                ScreenService.showMessage('Selecione somente uma pessoa!');
            }else if(widgetCPF.widgets[0].dataSource.data.length > 0 && widgetCPF.widgets[0].getCheckedRows().length == 0){
                ScreenService.showMessage('O CPF já foi inserido, favor selecionar a pessoa que deseja admitir!');
            }
        }else{
            ScreenService.showMessage('informe um CPF');
        }
    };
    
    this.openAdmissaoPreliminarSimplificada = function(){
        var widgetCPF = templateManager.container.getWidget('cpfPessoaTabbed');
        if(widgetCPF.isValid()){
            if(((widgetCPF.widgets[0].dataSource.data.length > 0 && widgetCPF.widgets[0].getCheckedRows().length == 1) || widgetCPF.widgets[0].dataSource.data.length == 0) && cpfPesquisado){
                validaIniciaContinuaAdmissao = true;
                dadosAdmissao.NRCPFPESSOA = widgetCPF.currentRow.NRCPFPESSOA; 
                if(widgetCPF.widgets[0].getCheckedRows().length == 1){
                    pessoaCadastrada = true;
                    dadosAdmissao.NRCPFPESSOA = widgetCPF.widgets[0].getCheckedRows()[0].NRCPFPESSOA;
                    dadosAdmissao.NRPESSOA = widgetCPF.widgets[0].getCheckedRows()[0].NRPESSOA;
                    dadosAdmissao.NMPESSOA = widgetCPF.widgets[0].getCheckedRows()[0].NMPESSOA; 
                    dadosAdmissao.DTNASCPESSOA = widgetCPF.widgets[0].getCheckedRows()[0].DTNASCPESSOA;
                    dadosAdmissao.IDMULTVINC = widgetCPF.widgets[0].dataSource.data.length > 1 || widgetCPF.widgets[0].getCheckedRows()[0].VINCULOATIVO == 'S' ? 'PRIMARIO' : 'UNICO';
                }
                ScreenService.closePopup();
                ScreenService.openWindow('product#hcm09015_eso_admissaoPreliminarSimplificada');
            }else if(!cpfPesquisado){
                ScreenService.showMessage('Pesquise o CPF antes de iniciar a admissão!');
            }else if(widgetCPF.widgets[0].dataSource.data.length > 0 && widgetCPF.widgets[0].getCheckedRows().length > 1){
                ScreenService.showMessage('Selecione somente uma pessoa!');
            }else if(widgetCPF.widgets[0].dataSource.data.length > 0 && widgetCPF.widgets[0].getCheckedRows().length == 0){
                ScreenService.showMessage('O CPF já foi inserido, favor selecionar a pessoa que deseja admitir!');
            }
        }else{
            ScreenService.showMessage('informe um CPF');
        }
    };
    /* jshint ignore:end */
    
    this.onEnterAdmissao = function(args){
        if(validaIniciaContinuaAdmissao){
            this.newRowWidgets();  
            
            if(pessoaCadastrada){
                templateManager.container.getWidget("Pessoa").showAsTab = false;
                templateManager.container.getWidget("enderecoParc").showAsTab = false;
                templateManager.container.getWidget("formaComunicacaoParc").showAsTab = false;
                templateManager.container.getWidget("contaCorrenteParc").showAsTab = false;
                templateManager.container.getWidget("cadastroDependentesCandidato").validaDependente = false;
        
                templateManager.container.getWidget("vinculo").getField("NMPESSOA").validations.required = true;
                templateManager.container.getWidget("vinculo").getField("NMPESSOA").readOnly = false;
                templateManager.container.getWidget("vinculo").currentRow.NMPESSOA = dadosAdmissao.NMPESSOA;
                templateManager.container.getWidget("vinculo").currentRow.NRPESSOA = dadosAdmissao.NRPESSOA;
                templateManager.container.getWidget("vinculo").currentRow.NMVINCULOM = dadosAdmissao.NMPESSOA;
                templateManager.container.getWidget("vinculo").currentRow.NRPISPASEPPES = dadosAdmissao.NRPISPASEPPES;
                templateManager.container.getWidget("vinculo").currentRow.NRCTPSPESSOA = dadosAdmissao.NRCTPSPESSOA;
                templateManager.container.getWidget("vinculo").currentRow.NRSERIECTPSPES = dadosAdmissao.NRSERIECTPSPES;
                templateManager.container.getWidget("vinculo").currentRow.DTCTPSPESSOA = dadosAdmissao.DTCTPSPESSOA;
                templateManager.container.getWidget("vinculo").currentRow.NMUFCTPSPES = dadosAdmissao.NMUFCTPSPES;
                templateManager.container.getWidget("vinculo").currentRow.NMUFRGPESSOA = dadosAdmissao.NMUFRGPESSOA;
                templateManager.container.getWidget("vinculo").currentRow.NRPARCNEGOCIO = dadosAdmissao.NRPARCNEGOCIO;
                templateManager.container.getWidget("vinculo").currentRow.DTNASCPESSOA = dadosAdmissao.DTNASCPESSOA;
                templateManager.container.getWidget("vinculo").currentRow.NRCPFPESSOA = dadosAdmissao.NRCPFPESSOA;
                templateManager.container.getWidget("vinculo").currentRow.NMESTACIVIL = dadosAdmissao.NMESTACIVIL;
                templateManager.container.getWidget("vinculo").currentRow.NRGRAUINSTR = dadosAdmissao.NRGRAUINSTR;
                templateManager.container.getWidget("vinculo").currentRow.CDPAIS = dadosAdmissao.CDPAIS;
                templateManager.container.getWidget("vinculo").currentRow.NRRGPESSOA = dadosAdmissao.NRRGPESSOA;
                templateManager.container.getWidget("vinculo").currentRow.CDEXRGPESSOA = dadosAdmissao.CDEXRGPESSOA;
                templateManager.container.getWidget("vinculo").currentRow.DTEXRGPESSOA = dadosAdmissao.DTEXRGPESSOA;
                templateManager.container.getWidget("vinculo").currentRow.SGUFRGPESSOA = dadosAdmissao.SGUFRGPESSOA;
                templateManager.container.getWidget("vinculo").currentRow.NRNACIONALID = dadosAdmissao.NRNACIONALID;
                templateManager.container.getWidget("vinculo").currentRow.DTADMISSAOPRE = dadosAdmissao.DTADMISSAOPRE;
                templateManager.container.getWidget("vinculo").currentRow.CDRECIBOADMPRE = dadosAdmissao.CDRECIBOADMPRE;
                templateManager.container.getWidget("vinculo").currentRow.IDMULTVINC = dadosAdmissao.IDMULTVINC;
                templateManager.container.getWidget("vinculo").activate();
                
                var wdgtDependente = templateManager.container.getWidget("cadastroDependentesCandidato");
                if(!Util.isEmptyOrBlank(dadosAdmissao.DEPENDENTES) && Util.isEmptyOrBlank(wdgtDependente.dataSource.data)) {
                    var dep;
                    dadosAdmissao.DEPENDENTES.forEach(function(dependente) {
                        dep = {
                            NRPESSOA: dependente.NRPESSOA,
                            NMPESSOA: dependente.NMPESSOA,
                            DTNASCIFUNDPARC: dependente.DTNASCIFUNDPARC,
                            IDSEXOPESSOA: dependente.IDSEXOPESSOA,
                            CDESTACIVIL: dependente.CDESTACIVIL,
                            NRNACIONALIDADE: dependente.NRNACIONALID,
                            CDPAIS: dependente.CDPAIS,
                            SGESTADO: dependente.SGESTADO,
                            CDMUNICIPIO: dependente.CDMUNICIPIO,
                            NMTIPORELACIONA: dependente.NMTIPORELACIONA,
                            NRTIPORELACIONA: dependente.NRTIPORELACIONA,
                            NRCPFPESSOA: dependente.NRCPFPESSOA,
                            DTFIMRELACIONAMENTO: dependente.DTFIMRELACIONAMENTO,
                            NRPARCNEGOCIO: dependente.NRPARCNEGOCIO
                        };
                        wdgtDependente.dataSource.data.push(dep);
                    });
                    ScreenService.showMessage("Foram preenchidos os dependentes do vínculo de acordo com a pessoa cadastrada! Favor preencher o tipo de dependência!", "ALERT");
                    dadosAdmissao.DEPENDENTES = [];
                }
            }else{
                templateManager.container.getWidget("Pessoa").showAsTab = true;
                templateManager.container.getWidget("Pessoa").currentRow.NRCPFPESSOA = dadosAdmissao.NRCPFPESSOA;
                templateManager.container.getWidget("enderecoParc").showAsTab = true;
                templateManager.container.getWidget("formaComunicacaoParc").showAsTab = true;
                templateManager.container.getWidget("contaCorrenteParc").showAsTab = true;
                templateManager.container.getWidget("cadastroDependentesCandidato").validaDependente = true;
                templateManager.container.getWidget("vinculo").getField("NMPESSOA").validations = {};
                templateManager.container.getWidget("vinculo").getField("NMPESSOA").readOnly = true;
                templateManager.container.getWidget("Pessoa").activate();
            }
        }
    };
    
    this.onEnterPessoa = function(args){
        var widget = ABUtilController.checkWidget(args);
        var widgetMain = templateManager.container.getWidget('processoAdmissaoTabbed');
        if(pessoaCadastrada){
            widgetMain.currentWidget = templateManager.container.getWidget('vinculo');
            widgetMain.activate();
            templateManager.container.getWidget('vinculo').activate();
            templateManager.updateTemplate();
        }
    };
        
    this.onEnterContaCorrent = function (){
        var widget = templateManager.container.getWidget('contaCorrenteParc');
        if(Util.isEmptyOrBlank(widget.currentRow.CDBANCO)){
            widget.getField('NMBANCO').validations = {};
            widget.getField('NMAGENCIA').validations = {};
            widget.getField('DSTPCONTCORR').validations = {};
            widget.getField('CDCONTCORR').validations = {};
        }
    };

    this.onChangeTipoVinculoPessoa = function(args){
        var widget = ABUtilController.checkWidget(args);
        var widgetVinc = templateManager.container.getWidget("vinculo");
        if(widget.currentRow.NMTIPOVINCULOH){    
            widgetVinc.currentRow.NRTIPOVINCULOM = widget.currentRow.NRTIPOVINCULOM;
            widgetVinc.currentRow.NMTIPOVINCULOH = widget.currentRow.NMTIPOVINCULOH;
            widgetVinc.getField('NMTIPOVINCULOH').readOnly = true;
        }
        if(widget.currentRow.NRTIPOVINCULOM === HcmConsts.tipoVinculo.CLT){
            widget.getField('NRPISPASEPPES').validations = {"required": true};
            widget.getField('NRCTPSPESSOA').validations = {"required": true};
            widget.getField('NRSERIECTPSPES').validations = {"required": true};
            widget.getField('DTCTPSPESSOA').validations = {"required": true};
            widget.getField('NMUFCTPSPES').validations = {"required": true};
            widget.getField('DTINSCPISPASEP').validations = {"required": true};
            widget.fieldGroups[3].opened = true;
        }else{
            widget.getField('NRPISPASEPPES').validations = {};
            widget.getField('NRCTPSPESSOA').validations = {};
            widget.getField('NRSERIECTPSPES').validations = {};
            widget.getField('DTCTPSPESSOA').validations = {};
            widget.getField('NMUFCTPSPES').validations = {};
            widget.getField('DTINSCPISPASEP').validations = {};
        }
    };
    
    this.onChangeBanco = function(args){
        var widget = ABUtilController.checkWidget(args);
        if(widget.currentRow.NMBANCO){
            widget.getField('NMBANCO').validations = {"required": true};
            widget.getField('NMAGENCIA').validations = {"required": true};
            widget.getField('DSTPCONTCORR').validations = {"required": true};
            widget.getField('CDCONTCORR').validations = {"required": true};
        }else{
            widget.getField('NMBANCO').validations = {};
            widget.getField('NMAGENCIA').validations = {};
            widget.getField('DSTPCONTCORR').validations = {};
            widget.getField('CDCONTCORR').validations = {};
        }    
    };
    
    this.cancelarAdmissao = function(){
        ScreenService.showCustomDialog('Deseja realmente cancelar a admissão do candidato ?', 'CONFIRMATION', null, [{
            label: ScreenService.i18n("Sim"),
            code: function(e, deferred) {
                this.limpaWidgets();
                //ScreenService.openWindow('product#hcm00052_gpe_vinculo');
                var historicoWidgets = templateManager.historyItems;
                var origemAdmissaoMenu = false;
                historicoWidgets.forEach(function(widget){
                    if(widget == 'product#hcm01083_fpa_admissaoMenu'){
                        origemAdmissaoMenu = true;
                    }
                });
                if(origemAdmissaoMenu){
                    ScreenService.closePopup();
        		    ScreenService.openWindow('product#dashboard');
                }else{
                    ScreenService.goBack();
                }
                deferred.resolve(e);
            }.bind(this)
          },{
            label: ScreenService.i18n("Não"),
            code: function(e, deferred) {
                deferred.reject(e);
            }
        }]);
    };

    this.confirmarSaveAdmissao = function(args, ESocialController){
        ScreenService.confirmMessage('Deseja realmente finalizar a admissão?', 'CONFIRMATION', 
            function(){
                this.salvarDadosPessoaisAdmissao(args, ESocialController, true);
            }.bind(this)
        );
    };

    this.removeDependente = function () {
        var widget = templateManager.container.getActiveWidget();  
        for(var i = 0; i<widget.dataSource.data.length; i++){
            if(widget.currentRow.NRBENEFICIOM === widget.dataSource.data[i].NRBENEFICIOM){
                if(widget.dataSource.data.length == 1){
                    widget.dataSource.data = [];
                } else {
                    widget.dataSource.data.splice(i, 1);
                }
                ABUtilController.masterDetailVoltarList(widget);
                widget.reload();
            }
        }
    };
    
    this.removeFoto = function(){
        var widget = templateManager.container.getActiveWidget();  
        
        if(widget.currentRow.DSPATH){
            widget.currentRow = {};
        }    
    };
    
    this.onChangeOperador = function(){
        var widgetPessoa = templateManager.container.getWidget('Pessoa');
        if(widgetPessoa.currentRow.INSERE_OPERADOR === 'S'){
            widgetPessoa.getField('EMAIL').validations = {"required": true};
        }else{
            widgetPessoa.getField('EMAIL').validations = {};
        } 
    };

    this.salvarDadosPessoaisAdmissao = function(args, ESocialController, verificaEnvioEsocialDescentralizado = true){
        var argsRow = args.row;
        var widgetVinculo = templateManager.container.getWidget('vinculo');
        var widgetPessoa = templateManager.container.getWidget('Pessoa');
        var widgetFormaComu = templateManager.container.getWidget('formaComunicacaoParc');
        var widgetFoto = templateManager.container.getWidget('WidgetUploadFoto');
        var widgetsValids = self.validaWidgets();
        var current;

        this.lastArgs = args;
        this.eSocialController = ESocialController;

        if(!solicitacao){
            solicitacao = {};
        }
        if(!widgetsValids){
            if(verificaEnvioEsocialDescentralizado){
                if(widgetVinculo.currentRow.NRTIPOVINCULOM == 1){
                    ESocialController.envioEsocialDescentralizado(widgetVinculo.currentRow, 'S-2200', null, null, self.salvarDadosPessoaisAdmissao, args); 
                }else{
                    ESocialController.envioEsocialDescentralizado(widgetVinculo.currentRow, 'S-2300', null, null, self.salvarDadosPessoaisAdmissao, args);
                }
            }else{
                if(widgetPessoa.showAsTab){
                    if(widgetPessoa.currentRow.NRPISPASEPPES){widgetPessoa.currentRow.NRPISPASEPPES = widgetPessoa.currentRow.NRPISPASEPPES.toString().replace(/[\D]+/g, '');}
                    if(widgetPessoa.currentRow.NRCPFPESSOA){widgetPessoa.currentRow.NRCPFPESSOA = widgetPessoa.currentRow.NRCPFPESSOA.toString().replace(/[\D]+/g, '');}
                    current = widgetFormaComu.currentRow;
                    widgetFormaComu.currentRow = self.constructRowCadFormaComu(widgetFormaComu);
                }
                var rows = self.criaRow();
                
                rows.push({ignorarVerificacaoQuadroVagas: self.ignorarVerificacaoQuadroVagas});

                widgetFormaComu.currentRow = current;
                restEngine.post('product#/admissaoVinculo', {'requestType':'DataSet','dataset':[rows,widgetFoto.currentRow,solicitacao]}
                    ).then(function(data){
                        if(data.dataset && data.dataset.retornoEsocial && data.dataset.retornoEsocial.length > 0){
                            var mensagem = '';
                            data.dataset.retornoEsocial.forEach(function(retorno){
                                mensagem += retorno.MSG + '<br>';
                            });
                            ScreenService.showMessage(mensagem);
                        }

                        if (data.dataset && data.dataset.verificacaoQuadroVagas) {
                            let mensagemVerificacao = data.dataset.verificacaoQuadroVagas.mensagemVerificacao;
                            let tipoValidacao = data.dataset.verificacaoQuadroVagas.tipoValidacao;

                            if (tipoValidacao === 'A') {
                                ScreenService.confirmMessage(mensagemVerificacao, 'CONFIRMATION', 
                                    function(){
                                        self.ignorarVerificacaoQuadroVagas = true;
                                        self.salvarDadosPessoaisAdmissao(self.lastArgs, self.eSocialController, true);
                                    }
                                );

                                return;
                            }

                            if (tipoValidacao === 'I') {
                                ScreenService.showMessage(mensagemVerificacao);

                                return;
                            }
                        }
                        
                        self.ignorarVerificacaoQuadroVagas = false;

                        if(data.messages){
                            ScreenService.showMessage(data.messages[0].message);
                        }else{
                            if(data.notifications && data.notifications[0].type === "success"){
                                ScreenService.successNotification('Admissão realizada com sucesso.',10000);
                                templateManager.historyItems.pop();
                                self.limpaWidgets();
                                ScreenService.openWindow('product#hcm00052_gpe_vinculo');
                            }else{
                                ScreenService.showMessage("Erro ao concluir admissão","error");
                            }
                        }
                    }.bind(self)
                    ).catch(function(e) {
                        self.ignorarVerificacaoQuadroVagas = false;
                        var error;
                        if(e.data.error === undefined)
                            error = e;
                        else 
                            error = e.data.error;
                            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    }.bind(self));
            }
        }else{
            ScreenService.showMessage("Para prosseguir, preencha corretamente os campos da aba de " + widgetsValids); 
        }
    };
    
    this.criaRow = function(){
        var widgets = templateManager.container.getWidget('processoAdmissaoTabbed').widgets;
        var rows = [];
        for(var k in widgets){
            if(widgets[k].showAsTab){
                
                var name = widgets[k].name;
                var obj = {};
                
                if(widgets[k].currentRow){
                    if(widgets[k].name === "cadastroDependentesCandidato"){
                        widgets[k].currentRow = widgets[k].dataSource.data;
                    }
                    if(widgets[k].name === "beneficioTitular"){
                        widgets[k].currentRow = widgets[k].dataSource.data;
                    }
                    if(widgets[k].name === "cadastroValeTransporte"){
                        widgets[k].currentRow = widgets[k].dataSource.data;
                    }
                    if(name !== "WidgetUploadFoto"){
                        obj[name] = widgets[k].currentRow;
                        rows.push(obj);
                    }
                }  
                
            }    
        }
        return rows;
    };
    
    this.newRowWidgets = function(){
        var widget = templateManager.container.getWidget('processoAdmissaoTabbed').widgets;
        for(var k in widget){
            if(widget[k].showAsTab){
                if(widget[k].name !== "WidgetUploadFoto" && widget[k].name !== "cadastroDependentesCandidato" && widget[k].name !== "beneficioTitular" && widget[k].name !== "cadastroValeTransporte"){
                    widget[k].newRow();
                }    
            }    
        }
    };
    
    this.validaWidgets = function(){
        var widgets = templateManager.container.getWidget('processoAdmissaoTabbed').widgets;
        var widgetDependente = templateManager.container.getWidget('cadastroDependentesCandidato');
        
        if((widgetDependente.validaDependente == true || Util.isEmptyOrBlank(widgetDependente.validaDependente)) && widgetDependente.dataSource.data.length === 0){    
            return widgetDependente.label;
        }
        
        for(var k in widgets ){
            if(widgets[k].showAsTab){
                if(widgets[k].name !== 'WidgetUploadFoto' && widgets[k].name !== 'cadastroDependentesCandidato' && widgets[k].name !== "beneficioTitular" && widgets[k].name !== "cadastroValeTransporte"){ 
                    switch (widgets[k].name) {
                        case 'vinculo':
                            if(widgets[k].isValid()){
                                if(!widgets[k].currentRow.NMABREV){
                                    return widgets[k].label;
                               }
                            } 
                            break;  
                        case 'enderecoParc':
                            if(widgets[k].isValid()){
                                if(!widgets[k].currentRow.NMBAIRROENDERECO){
                                    return widgets[k].label;
                                }
                            }   
                            break;   
                    }
                    if(!widgets[k].isValid()){
                        return widgets[k].label;
                    }
                }    
            }    
        }
        return false;
    };
    
    this.limpaWidgets = function(){
        var widgets = templateManager.container.getWidget('processoAdmissaoTabbed').widgets;
        for(var k in widgets ){
            widgets[k].currentRow = {};
            widgets[k].onEnterOnceCalled = false;
            if(widgets[k].name === 'cadastroDependentesCandidato'){
                widgets[k].dataSource.data = [];
            }
            if(widgets[k].name === "cadastroValeTransporte"){
                widgets[k].dataSource.data = [];
            }
            if(widgets[k].name === "beneficioTitular"){
                widgets[k].dataSource.data = [];
            }
        }
    };
    
    this.constructRowCadFormaComu = function(widget){
        var rowCad = [];
        var currentRow = widget.currentRow;
        if(currentRow.TELPRINCIPAL){
            rowCad.push({
                'CDCOMUNICAPARC':currentRow.TELPRINCIPAL,
                'CDPREFIXCOMUPARC':currentRow.PREFTELPRINCIPAL,
                'CDFORMACOMU': HcmConsts.FormaComu.TELPRINCIPAL,
                'NRPARCNEGOCIO': currentRow.NRPARCNEGOCIO
            });
        }
        if(currentRow.TELRESIDEN){
            rowCad.push({
                'CDCOMUNICAPARC':currentRow.TELRESIDEN,
                'CDPREFIXCOMUPARC':currentRow.PREFTELRESIDEN,
                'CDFORMACOMU': HcmConsts.FormaComu.TELRESIDEN,
                'NRPARCNEGOCIO': currentRow.NRPARCNEGOCIO
            });
        }
        if(currentRow.TELCOMERC){
            rowCad.push({
                'CDCOMUNICAPARC':currentRow.TELCOMERC,
                'CDPREFIXCOMUPARC':currentRow.PREFTELCOMERC,
                'CDFORMACOMU': HcmConsts.FormaComu.TELCOMERC,
                'NRPARCNEGOCIO': currentRow.NRPARCNEGOCIO
            });
        }
        if(currentRow.CELPARTIC){
            rowCad.push({
                'CDCOMUNICAPARC':currentRow.CELPARTIC,
                'CDPREFIXCOMUPARC':currentRow.PREFCELPARTIC,
                'CDFORMACOMU': HcmConsts.FormaComu.CELPARTIC,
                'NRPARCNEGOCIO': currentRow.NRPARCNEGOCIO
            });
        }
        if(currentRow.CELCOMERC){
            rowCad.push({
                'CDCOMUNICAPARC':currentRow.CELCOMERC,
                'CDPREFIXCOMUPARC':currentRow.PREFCELCOMERC,
                'CDFORMACOMU': HcmConsts.FormaComu.CELCOMERC,
                'NRPARCNEGOCIO': currentRow.NRPARCNEGOCIO
            });
        }
        if(currentRow.FAX){
            rowCad.push({
                'CDCOMUNICAPARC':currentRow.FAX,
                'CDPREFIXCOMUPARC':currentRow.PREFFAX,
                'CDFORMACOMU': HcmConsts.FormaComu.FAX,
                'NRPARCNEGOCIO': currentRow.NRPARCNEGOCIO
            });
        }
        if(currentRow.EMAIL){
            rowCad.push({
                'CDCOMUNICAPARC':currentRow.EMAIL,
                'CDPREFIXCOMUPARC': null,
                'CDFORMACOMU': HcmConsts.FormaComu.EMAIL,
                'NRPARCNEGOCIO': currentRow.NRPARCNEGOCIO
            });
        }
        return rowCad;
    }; 
    
    this.setDadosDefaultMovimentacao = function(){
        var data = new Date();
        var dataAtual = data.toLocaleString();
        dataAtual = dataAtual.split(" ");
        var widget = templateManager.container.getActiveWidget();
        var widgetVinculo = templateManager.container.getWidget('vinculo');
        // widget.getField('CDMATRICULAESOCIAL').readOnly = true;
        if (widgetVinculo.currentRow.NRTPADMISSAO == 1) {
            widget.currentRow.NMTPMOVTRANSFH = widget.currentRow.NMTPMOVTRANSFH? widget.currentRow.NMTPMOVTRANSFH : 'Admissão no primeiro emprego';
            widget.currentRow.NRTPMOVTRANSF = widget.currentRow.NRTPMOVTRANSF? widget.currentRow.NRTPMOVTRANSF : 1;
        } else {
            widget.currentRow.NMTPMOVTRANSFH = widget.currentRow.NMTPMOVTRANSFH? widget.currentRow.NMTPMOVTRANSFH : 'Admissão com emprego anterior';
            widget.currentRow.NRTPMOVTRANSF = widget.currentRow.NRTPMOVTRANSF? widget.currentRow.NRTPMOVTRANSF : 2;
        }
        widget.currentRow.DTINIMOVIMENT = widget.currentRow.DTINIMOVIMENT? widget.currentRow.DTINIMOVIMENT : dataAtual[0];
        widget.currentRow.NMTIPOTRANSFER_LEGAL = widget.currentRow.NMTIPOTRANSFER_LEGAL? widget.currentRow.NMTIPOTRANSFER_LEGAL : 'Movimentação Legal';
        widget.currentRow.NRTIPOTRANSFER_LEGAL = widget.currentRow.NRTIPOTRANSFER_LEGAL? widget.currentRow.NRTIPOTRANSFER_LEGAL : 1;
        widget.currentRow.NMTIPOTRANSFER_GEREN = widget.currentRow.NMTIPOTRANSFER_GEREN? widget.currentRow.NMTIPOTRANSFER_GEREN : 'Movimentação Gerencial';
        widget.currentRow.NRTIPOTRANSFER_GEREN = widget.currentRow.NRTIPOTRANSFER_GEREN? widget.currentRow.NRTIPOTRANSFER_GEREN : 2;
        widget.currentRow.NMTIPOTRANSFER_SINDICAL = widget.currentRow.NMTIPOTRANSFER_SINDICAL? widget.currentRow.NMTIPOTRANSFER_SINDICAL : 'Movimentação Legal';
        widget.currentRow.NRTIPOTRANSFER_SINDICAL = widget.currentRow.NRTIPOTRANSFER_SINDICAL? widget.currentRow.NRTIPOTRANSFER_SINDICAL : 1;
        
        //Caso a pessoa informada tenha um recibo de processamento do evento de admissão preliminar do esocial (S-2190), preenche a estrutura legal com a estrutura que enviou o evento
        if (!Util.isEmptyOrBlank(widgetVinculo.currentRow.CDRECIBOADMPRE)) {
            var filtro = [
                    {
                        "name": "P_NRORG",
                        "operator": "=",
                        "value": getLocalVar('HCM_NRORG_TRAB')
                    },
                    {
                        "name": "P_NRORG_PADRAO",
                        "operator": "=",
                        "value": getLocalVar('HCM_NRORG_PADRAO')
                    },
                    {
                        "name": "P_DTMESCOMPETENC",
                        "operator": "=",
                        "value": getLocalVar('HCM_DTCOMPETENCIA_OPER')
                    },
                    {
                        "name": "P_NRESTRUTURAM",
                        "operator": "=",
                        "value": ""
                    },
                    {
                        "name": "NRTPAMBIENTE",
                        "operator": "=",
                        "value": "1"
                    },
                    {
                        "name": "IDATIVO",
                        "operator": "=",
                        "value": "S"
                    },
                    {
                        "name": "NMEVENTO",
                        "operator": "=",
                        "value": "S-2190"
                    },
                    {
                        "name": "NRCHAVE",
                        "operator": "=",
                        "value": widgetVinculo.currentRow.NRPESSOA
                    },
                    {
                        "name": "NRENVIOEXCL",
                        "operator": "IS_NOT_NULL",
                        "value": ""
                    }
            ];
            restEngine.post("product#/getEnviosCadastros", {requestType: "FilterData", filter: filtro}).
                then(function (data) {
                    if(data.dataset.getEnviosCadastros){
                        var envios = data.dataset.getEnviosCadastros;
                        for(var k in envios){
                            if(envios[k].NRESTRUTURAM){
                                widget.currentRow.NRESTRUTLEGAL = envios[k].NRESTRUTURAM;
                                widget.currentRow.NMRAZSOCESTRUT_LEGAL = envios[k].NMESTRUTURAM;
                            }
                        }
                    }
                }).catch(function(e) {
                    var error;
                    if(e.data.error === undefined)
                        error = e;
                    else 
                        error = e.data.error;
                        ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
        }
    };
    
    this.setDadosDefaultPessoa = function(){
        var data = new Date();
        var dataAtual = data.toLocaleString();
        dataAtual = dataAtual.split(" ");
        var widget = templateManager.container.getActiveWidget();
        widget.currentRow.IDPESNATURALIZA = widget.currentRow.IDPESNATURALIZA? widget.currentRow.IDPESNATURALIZA : 'N';
        widget.currentRow.IDPOSVISTOPERM = widget.currentRow.IDPOSVISTOPERM? widget.currentRow.IDPOSVISTOPERM : 'N';
        widget.currentRow.IDISENTITUELEI = widget.currentRow.IDISENTITUELEI? widget.currentRow.IDISENTITUELEI : 'N';
        widget.currentRow.INSERE_OPERADOR = widget.currentRow.INSERE_OPERADOR? widget.currentRow.INSERE_OPERADOR : 'N';
        widget.currentRow.DSNACIONALIDADE = widget.currentRow.DSNACIONALIDADE? widget.currentRow.DSNACIONALIDADE : 'Brasileira';
        widget.currentRow.NRNACIONALID = widget.currentRow.NRNACIONALID? widget.currentRow.NRNACIONALID : 1;
        
        var widgetEndereco = templateManager.container.getWidget("enderecoParc");
        widgetEndereco.currentRow.CDTIPOENDERECO = 'PRINCIPAL';
        widgetEndereco.currentRow.NMTIPOENDERECO = 'Principal';
    };
    
     this.setDadosDefaultVinculo = function(){
        var data = new Date();
        var dataAtual = data.toLocaleString();
        dataAtual = dataAtual.split(" ");
        var widget = templateManager.container.getActiveWidget();
        var widgetPessoa = templateManager.container.getWidget('Pessoa');
        widget.currentRow.IDSEGDESEMPVINC = widget.currentRow.IDSEGDESEMPVINC? widget.currentRow.IDSEGDESEMPVINC : 'N';
        widget.currentRow.IDMULTVINC = widget.currentRow.IDMULTVINC? widget.currentRow.IDMULTVINC : 'UNICO';
        widget.currentRow.IDCONTRIBUISIND = widget.currentRow.IDCONTRIBUISIND? widget.currentRow.IDCONTRIBUISIND : 'SEMPRE';
        widget.currentRow.IDREMUNERACAO = widget.currentRow.IDREMUNERACAO? widget.currentRow.IDREMUNERACAO : 'SAL1';
        widget.currentRow.IDTPPAGAMENTO = widget.currentRow.IDTPPAGAMENTO? widget.currentRow.IDTPPAGAMENTO : 'MENSAL';
        widget.currentRow.DTADMISSAOVINC = widget.currentRow.DTADMISSAOVINC? widget.currentRow.DTADMISSAOVINC : '';
        widget.currentRow.DTPRIMADMISSAO = widget.currentRow.DTPRIMADMISSAO? widget.currentRow.DTPRIMADMISSAO : '';
        widget.currentRow.DTEXAMEMEDICO = widget.currentRow.DTEXAMEMEDICO? widget.currentRow.DTEXAMEMEDICO : '';
        widget.currentRow.DTOPCAOFGTS = widget.currentRow.DTOPCAOFGTS? widget.currentRow.DTOPCAOFGTS : '';
        widget.currentRow.DTENTREGAEPI = widget.currentRow.DTENTREGAEPI? widget.currentRow.DTENTREGAEPI : '';
        widget.currentRow.DTBASEFERIAS = widget.currentRow.DTBASEFERIAS? widget.currentRow.DTBASEFERIAS : '';
        if(widgetPessoa.showAsTab){
            widget.getField('NMPESSOA').readOnly = true;
        }else{
            widget.getField('NMPESSOA').readOnly = false;
            widget.getField('NMTIPOVINCULOH').readOnly = false;
        }
    };
    
    this.onChangeNmPessoa = function(){
        var widgetPessoa = templateManager.container.getWidget('Pessoa');
        var rowVinc = templateManager.container.getWidget('vinculo').currentRow;
        var widgetParametros = templateManager.container.getWidget('parametros');
        var widgetMovimentacao = templateManager.container.getWidget('movimentacaoCandidato');
        
        if(widgetPessoa.showAsTab){
            rowVinc.NMPESSOA = widgetPessoa.currentRow.NMPESSOA;
            rowVinc.NMVINCULOM = widgetPessoa.currentRow.NMPESSOA;
        }else{
            if(rowVinc.NRVINCULOM && rowVinc.IDMULTVINC === 'UNICO' && (rowVinc.DTRESCISAOVINC ==null || rowVinc.DTRESCISAOVINC.substring(0, 10) > getLocalVar('HCM_DTCOMPETENCIA_OPER'))) {
                ScreenService.showMessage("Já existe outro vínculo cadastrado para a pessoa. O campo 'Múltiplos Vínculos' não pode ser 'UNICO'");
                rowVinc.NMPESSOA = "";
                return false;
            }
            if(!this.onChangeTipoVinculo()){
                rowVinc.NMPESSOA = "";
                return false;
            }
            rowVinc.NMVINCULOM = rowVinc.NMPESSOA;
            this.verificaVinculoRescindido(rowVinc.NRPESSOA);
            if(!Util.isEmptyOrBlank(rowVinc.DTADMISSAOPRE)){
                rowVinc.DTADMISSAOVINC = rowVinc.DTADMISSAOPRE;
                rowVinc.DTPRIMADMISSAO = rowVinc.DTADMISSAOPRE;
                rowVinc.DTEXAMEMEDICO = rowVinc.DTADMISSAOPRE;
                rowVinc.DTOPCAOFGTS = rowVinc.DTADMISSAOPRE;
                rowVinc.DTENTREGAEPI = rowVinc.DTADMISSAOPRE;
                rowVinc.DTBASEFERIAS = rowVinc.DTADMISSAOPRE;
                widgetParametros.currentRow.DTINIOCUPACAO = rowVinc.DTADMISSAOPRE;
                widgetParametros.currentRow.DTINIESCALA = rowVinc.DTADMISSAOPRE;
                widgetParametros.currentRow.DTINISITUFUNC = rowVinc.DTADMISSAOPRE;
                widgetParametros.currentRow.DTALTESALARIO = rowVinc.DTADMISSAOPRE;
                widgetMovimentacao.currentRow.DTINIMOVIMENT = rowVinc.DTADMISSAOPRE;
            }
        }    
        if(rowVinc.NMPESSOA){
            if (!rowVinc.DTNASCPESSOA){
                ScreenService.showMessage("Pessoa sem Data de Nascimento cadastrada!");
                return false;
            }
            if (!rowVinc.NRCPFPESSOA){
                ScreenService.showMessage("Pessoa sem CPF cadastrado!");
                return false;
            }
            if (!rowVinc.NMESTACIVIL){
                ScreenService.showMessage("Pessoa sem Estado Civil cadastrado!");
                return false;
            }
            if (!rowVinc.NRGRAUINSTR){
                ScreenService.showMessage("Pessoa sem Grau de Instrução cadastrada!");
                return false;
            }
            if (!rowVinc.CDPAIS){
                ScreenService.showMessage("Pessoa sem País cadastrado!");
                return false;
            }
            if (!rowVinc.NRRGPESSOA){
                ScreenService.showMessage("Pessoa sem RG cadastrado!");
                return false;
            }
            if (!rowVinc.CDEXRGPESSOA){
                ScreenService.showMessage("Pessoa sem Orgão do RG cadastrado!");
                return false;
            }
            if (!rowVinc.DTEXRGPESSOA){
                ScreenService.showMessage("Pessoa sem data de Expedição do RG cadastrada!");
                return false;
            }
            if (!rowVinc.SGUFRGPESSOA){
                ScreenService.showMessage("Pessoa sem UF do RG cadastrado!");
                return false;
            }
            if (!rowVinc.NRNACIONALID){
                ScreenService.showMessage("Pessoa sem nacionalidade cadastrada!");
                return false;
            }
            if(rowVinc.NRPARCNEGOCIO){
                var filtro = [
                    
                    {
                        "name": "NRPARCNEGOCIO",
                        "operator": "=",
                        "value": rowVinc.NRPARCNEGOCIO
                    },
                    {
                        "name": "P_NRORG",
                        "operator": "=",
                        "value": getLocalVar('HCM_NRORG_TRAB')
                    },
                    {
                        "name": "P_NRORGPADRAO",
                        "operator": "=",
                        "value": getLocalVar('HCM_NRORG_PADRAO')
                    }
                
                ];                        
                restEngine.post("product#/getEnderecoParc", {
                    requestType: "FilterData",
                        filter: filtro}).
                then(function (data) {
                    if(!data.dataset.enderecoparc_get[0]){
                        ScreenService.showMessage("Pessoa sem Endereço cadastrado!");
                        rowVinc.NMPESSOA = "";
                        rowVinc.NMVINCULOM = "";
                        return false;
                    }    
                }).catch(function(e) {
                    var error;
                    if(e.data.error === undefined)
                        error = e;
                    else 
                        error = e.data.error;
                        ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
                
            }
        }
    };
    
    this.verificaVinculoRescindido = function(nrpessoa){
        var widgetRescisao = templateManager.container.getWidget('popUpRescisao');
        var filtro = [
                {
                    "name": "P_DTMESCOMPETENC",
                    "operator": "=",
                    "value": getLocalVar('HCM_DTCOMPETENCIA_OPER')
                },
                {
                    "name": "P_NRORG",
                    "operator": "=",
                    "value": getLocalVar('HCM_NRORG_TRAB')
                },
                {
                    "name": "P_NRORG_PADRAO",
                    "operator": "=",
                    "value": getLocalVar('HCM_NRORG_PADRAO')
                },
                {
                    "name": "NRPESSOA",
                    "operator": "=",
                    "value": nrpessoa
                },
                {
                    "name": "P_RESCISAO",
                    "operator": "=",
                    "value": "%R%"
                }
            ];  
            
        restEngine.post("product#/getVinculos", {
                requestType: "FilterData",
                    filter: filtro}).
            then(function (data) {
                if(data.dataset.gpe_vinculom_get){
                    var vinculos = data.dataset.gpe_vinculom_get;
                    for(var k in vinculos){
                        if(vinculos[k].IDVERIFICARESCISAO){
                            vinculosRescindidos = vinculos[k];
                            ScreenService.openPopup(widgetRescisao);
                        }
                    }
                }
            }).catch(function(e) {
                var error;
                if(e.data.error === undefined)
                    error = e;
                else 
                    error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
        
    };
    
    this.widgetRescisaoOnEnter = function(args){
        var widget = ABUtilController.checkWidget(args);
        widget.currentRow.DSTPAVIPRE = vinculosRescindidos.DSTPAVIPRE;
        widget.currentRow.NMTPDEMISSAO = vinculosRescindidos.NMTPDEMISSAO;
        widget.currentRow.NMMOTIVORESC = vinculosRescindidos.NMMOTIVORESC;
        widget.currentRow.DSOBSRESCISAO = vinculosRescindidos.DSOBSRESCISAO;
        widget.currentRow.DSOBSERVACAORESCISAO = vinculosRescindidos.DSOBSERVACAORESCISAO;
        widget.currentRow.DTRESCISAOVINC = vinculosRescindidos.DTRESCISAOVINC;
    };
    
    this.onChangeTipoVinculo = function(){
        
        var widgetVinculo = templateManager.container.getWidget('vinculo');
        var rowVinc = widgetVinculo.currentRow;
        var messenger = '';
        var messengerAux = '';
        if(rowVinc.NRTIPOVINCULOM === HcmConsts.tipoVinculo.CLT && rowVinc.NMPESSOA){
            if(!rowVinc.NRPISPASEPPES){
                messengerAux += 'PIS';
            }
            messenger += this.verificaMensagem(messengerAux);
            messengerAux = '';
            if(!rowVinc.NRCTPSPESSOA){
                messengerAux += 'Nr. CTPS';
            }
            messenger += this.verificaMensagem(messengerAux);
            messengerAux = '';
            if(!rowVinc.NRSERIECTPSPES){
                messengerAux += 'Série CTPS';
            }
            messenger += this.verificaMensagem(messengerAux);
            messengerAux = '';
            if(!rowVinc.DTCTPSPESSOA){
                messengerAux += 'Dt. CTPS';
            }
            messenger += this.verificaMensagem(messengerAux);
            messengerAux = '';
            if(!rowVinc.NMUFCTPSPES){
                messengerAux += 'UF da CTPS';
            }
            messenger += this.verificaMensagem(messengerAux);
            messengerAux = '';
            if(!rowVinc.NMUFRGPESSOA){
                messenger += 'UF';
            }
            if(messenger){
                ScreenService.showMessage("Pessoa possui inconsistências para cadastro CLT: " + messenger);
                rowVinc.NMTIPOVINCULOH = "";
                rowVinc.NRTIPOVINCULOM = "";
                return false;
            }
        }
        
        if(rowVinc.NRTIPOVINCULOM && rowVinc.NRTIPOVINCULOM == HcmConsts.tipoVinculo.AUTONOMO){
            widgetVinculo.getField('NMTPADMISSAO').validations = {};
        } else {
            widgetVinculo.getField('NMTPADMISSAO').validations = { "required": true};
        }
        
        return true;
    };

    this.verificaMensagem = function(messenger){
        if(messenger){
            messenger = messenger + ", ";
        }    
        return messenger;
    };
    
    this.onChangeTpRelacionamento = function(){
        
        var widgetPessoa = templateManager.container.getWidget('Pessoa');
        var widgetDependentes = templateManager.container.getWidget('cadastroDependentesCandidato');
        var tipoRelaciona = widgetDependentes.currentRow.NRTIPORELACIONA;
        if(widgetPessoa.showAsTab){
            if(tipoRelaciona === HcmConsts.RelacionaParc.PAI){
                if(widgetPessoa.currentRow.NMPAI){
                    widgetDependentes.currentRow.NMPESSOA = widgetPessoa.currentRow.NMPAI;
                    widgetDependentes.getField('NMPESSOA').readOnly = true;
                }
            }
            else if(tipoRelaciona === HcmConsts.RelacionaParc.MAE){
                if(widgetPessoa.currentRow.NMMAE){
                    widgetDependentes.currentRow.NMPESSOA = widgetPessoa.currentRow.NMMAE;
                    widgetDependentes.getField('NMPESSOA').readOnly = true;
                }
            }
        }
    };
    
    this.saveDependentes = function (widget) {
        var widgetPessoa = templateManager.container.getWidget('Pessoa');
        if(widget.isValid()) {
            widget.currentRow.DTNASCPESSOA = widget.currentRow.DTNASCIFUNDPARC;
            if (ABUtilController.validaDataIgualPosteriorDtAtual(widget.currentRow.DTNASCPESSOA) && widget.currentRow.DTNASCPESSOA) {
                    ScreenService.showMessage(Messages.DT_NASC_ERROR);
                    return false;
                }
            if(widgetPessoa.showAsTab){
                // if(!this.validaRelacionaParc(widget,widgetPessoa)){
                //     ScreenService.showMessage(mensagem);
                //     return false;
                // }
                widget.getField('NMPESSOA').readOnly = false;
            }    
            widget.currentRow.changed = true;
            return widget.saveRow().then(function(){
                widget.currentRow.changed = false;
                widget.currentRow.__is_new = false;
                widget.view();
                widget.reload();
            }).catch(function(e) {
                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(e), 'ERROR');
            });
        }
    };
    
    this.onEnterDependentes = function(args){
        var widget = ABUtilController.checkWidget(args);
        var widgetPessoa = templateManager.container.getWidget('Pessoa').currentRow;
        if(widget.dataSource.data.length === 0){    
            if(widgetPessoa.NMPAI){
                widget.dataSource.data.push(
                    {
                        'NMPESSOA': widgetPessoa.NMPAI,
                        'NRTIPORELACIONA':HcmConsts.RelacionaParc.PAI,
                        'NMTIPORELACIONA': 'Pai',
                        'IDSEXOPESSOA': 'M'
                    }
                );
            }
            if(widgetPessoa.NMMAE){
                widget.dataSource.data.push(
                    {
                        'NMPESSOA': widgetPessoa.NMMAE,
                        'NRTIPORELACIONA':HcmConsts.RelacionaParc.MAE,
                        'NMTIPORELACIONA': 'Mãe',
                        'IDSEXOPESSOA': 'F'
                    }
                );
            }
        }    
    };
    
    this.includeOrModifyParents = function(){
        var dependentesWidget = templateManager.container.getWidget('cadastroDependentesCandidato');
        var widgetPessoa = templateManager.container.getActiveWidget();
        var maeExiste = false;
        var paiExiste = false;
        
        dependentesWidget.dataSource.data.forEach(function(dependente, index) {
            if(dependente.NRTIPORELACIONA == HcmConsts.RelacionaParc.MAE) {
                dependente.NMPESSOA = widgetPessoa.currentRow.NMMAE;
                maeExiste = true;
            } else if(dependente.NRTIPORELACIONA == HcmConsts.RelacionaParc.PAI) {
                dependente.NMPESSOA = widgetPessoa.currentRow.NMPAI;
                paiExiste = true;
            }
        });
        
        if(!maeExiste && widgetPessoa.currentRow.NMMAE) {
            dependentesWidget.dataSource.data.push(
                {
                    'NMPESSOA': widgetPessoa.currentRow.NMMAE,
                    'NRTIPORELACIONA': HcmConsts.RelacionaParc.MAE,
                    'NMTIPORELACIONA': 'Mãe',
                    'IDSEXOPESSOA': 'F'
                }
            );
        }
        
        if(!paiExiste && widgetPessoa.currentRow.NMPAI) {
            dependentesWidget.dataSource.data.push(
                {
                    'NMPESSOA': widgetPessoa.currentRow.NMPAI,
                    'NRTIPORELACIONA': HcmConsts.RelacionaParc.PAI,
                    'NMTIPORELACIONA': 'Pai',
                    'IDSEXOPESSOA': 'M'
                }
            );
        }
    };
    
    this.validaCPFPessoa = function(){
        var widget = templateManager.container.getWidget('cpfPessoaTabbed');
        if(!ABUtilController.validaCPF(widget.currentRow.NRCPFPESSOA)){
            widget.currentRow.NRCPFPESSOA = "";
            ScreenService.showMessage(Messages.CPF_ERROR);
            return false;
        } 
    };  
    
    this.onChangeCpf = function(nameWidget){
        var widget = templateManager.container.getWidget(nameWidget);
        if(widget.currentRow.NRCPFPESSOA){
            if(!ABUtilController.validaCPF(widget.currentRow.NRCPFPESSOA)){
                widget.currentRow.NRCPFPESSOA = "";
                ScreenService.showMessage(Messages.CPF_ERROR);
                return false;
            }
            var cpf = widget.currentRow.NRCPFPESSOA.toString().replace(/[\D]+/g, '');
            var filtro = [
                {
                    "name": "P_DTMESCOMPETENC",
                    "operator": "=",
                    "value": getLocalVar('HCM_DTCOMPETENCIA_OPER')
                },
                {
                    "name": "P_NRORG",
                    "operator": "=",
                    "value": getLocalVar('HCM_NRORG_TRAB')
                },
                {
                    "name": "P_NRORG_PADRAO",
                    "operator": "=",
                    "value": getLocalVar('HCM_NRORG_PADRAO')
                },
                {
                    "name": "NRCPFPESSOA",
                    "operator": "=",
                    "value": cpf
                },
                {
                    "name": "EXISTE_VINCULOS",
                    "operator": "=",
                    "value": "N"
                }
            ];                        
            restEngine.post("product#/getPessoa", {
                requestType: "FilterData",
                    filter: filtro}).
            then(function (data) {
                var name;
                if(data.dataset.getPessoa[0]){
                    for(var k in data.dataset.getPessoa){
                        if(data.dataset.getPessoa[k].NMPESSOA !== name){
                            name = data.dataset.getPessoa[k].NMPESSOA;
                        }
                    }
                    widget.currentRow.NRCPFPESSOA = "";
                    ScreenService.showMessage(Messages.CPF_EXISTS + name);
                }    
            }).catch(function(e) {
                var error;
                if(e.data.error === undefined)
                    error = e;
                else 
                    error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
        }
    };
    
    this.onChangePis = function(){
        var widgetPessoa = templateManager.container.getWidget('Pessoa');
        if(widgetPessoa.currentRow.NRPISPASEPPES){
            if(!ABUtilController.validaPIS(widgetPessoa.currentRow.NRPISPASEPPES)){
                widgetPessoa.currentRow.NRPISPASEPPES = "";
                ScreenService.showMessage(Messages.PIS_PASEP_ERROR);
                return false;
            } 
        }
    };
    
    this.validaRelacionaParc = function(widget,widgetPrincipal){
	    
	    var dtNascPessoa = widgetPrincipal.currentRow.DTNASCPESSOA;
	    var dtNascParceiro = widget.currentRow.DTNASCPESSOA;
	    var tipoRelaciona = widget.currentRow.NRTIPORELACIONA;
	    if(!dtNascPessoa){
	        mensagem = Messages.HCM00000_GER_PESSOA_DTNASC_PESSOA_ERROR;
	        return false;
	    }
	    if(!dtNascParceiro){
	        mensagem = Messages.HCM00000_GER_PESSOA_DTNASC_PESSOARELAC_ERROR;
	        return false;
	    }
	    if(tipoRelaciona === HcmConsts.RelacionaParc.FILHO){
	        if(!ABUtilController.validaDtIniMenorIgualDtFin(dtNascPessoa,dtNascParceiro)){
	            mensagem = Messages.HCM00000_GER_PESSOA_DTNASC_MAIOR_ERROR;
	            return false;
	        }
	    }
	    if(tipoRelaciona === HcmConsts.RelacionaParc.PAI || tipoRelaciona === HcmConsts.RelacionaParc.MAE || tipoRelaciona === HcmConsts.RelacionaParc.AVO){
	        if(!ABUtilController.validaDtIniMenorIgualDtFin(dtNascParceiro,dtNascPessoa)){
	            mensagem = Messages.HCM00000_GER_PESSOA_DTNASC_MAIOR_ERROR;
	            return false;
	        }
	    }
	    return true;
	};
    
    this.setDadosDefaultParametros = function(){
        var data = new Date();
        var dataAtual = data.toLocaleString();
        dataAtual = dataAtual.split(" ");
        var widget = templateManager.container.getActiveWidget();
        widget.currentRow.NMTIPOOCUPACAO = widget.currentRow.NMTIPOOCUPACAO? widget.currentRow.NMTIPOOCUPACAO : 'Cargo Efetivo';
        widget.currentRow.NRTIPOOCUPACAO = widget.currentRow.NRTIPOOCUPACAO? widget.currentRow.NRTIPOOCUPACAO : 1;
        widget.currentRow.DTINIOCUPACAO = widget.currentRow.DTINIOCUPACAO? widget.currentRow.DTINIOCUPACAO : dataAtual[0];
        widget.currentRow.DTINIESCALA = widget.currentRow.DTINIESCALA? widget.currentRow.DTINIESCALA : dataAtual[0];
        widget.currentRow.NMTPMODALIDSAL = widget.currentRow.NMTPMODALIDSAL? widget.currentRow.NMTPMODALIDSAL : "Efetivo";
        widget.currentRow.NRTPMODALIDSAL = widget.currentRow.NRTPMODALIDSAL? widget.currentRow.NRTPMODALIDSAL : 1;
        widget.currentRow.NMSITUFUNCH = widget.currentRow.NMSITUFUNCH? widget.currentRow.NMSITUFUNCH : "Atividade Normal";
        widget.currentRow.NRSITUFUNCM = widget.currentRow.NRSITUFUNCM? widget.currentRow.NRSITUFUNCM : 1;
        widget.currentRow.DTINISITUFUNC = widget.currentRow.DTINISITUFUNC? widget.currentRow.DTINISITUFUNC : dataAtual[0];
        widget.currentRow.NMTIPOALTERA = widget.currentRow.NMTIPOALTERA? widget.currentRow.NMTIPOALTERA : "Salário Admissão";
        widget.currentRow.NRTIPOALTERA = widget.currentRow.NRTIPOALTERA? widget.currentRow.NRTIPOALTERA : 1;
        widget.currentRow.DTALTESALARIO = widget.currentRow.DTALTESALARIO? widget.currentRow.DTALTESALARIO : dataAtual[0];
        widget.currentRow.CDTIPOSALARIO = widget.currentRow.CDTIPOSALARIO? widget.currentRow.CDTIPOSALARIO : "MENSAL";
        widget.currentRow.DSTIPOSALARIO = widget.currentRow.DSTIPOSALARIO? widget.currentRow.DSTIPOSALARIO : "MENSAL";
        widget.currentRow.NROCORRENCIA = widget.currentRow.NROCORRENCIA? widget.currentRow.NROCORRENCIA : 1;
    };

    this.setDataAdmissao = function() {
        var widget = templateManager.container.getActiveWidget();
        var widgetParametros = templateManager.container.getWidget('parametros');
        var widgetMovimentacao = templateManager.container.getWidget('movimentacaoCandidato');
        
        var data = new Date();
        var dataAtual = data.toLocaleString();
        dataAtual = dataAtual.split(" ");
        
        if (!!widget.currentRow.DTADMISSAOVINC && moment(widget.currentRow.DTADMISSAOVINC, 'DD/MM/YYYY') <= moment(dataAtual[0], 'DD/MM/YYYY')) {
            if(moment(widget.currentRow.DTADMISSAOVINC, 'DD/MM/YYYY') < moment(getLocalVar('HCM_DTCOMPETENCIA_OPER'), 'DD/MM/YYYY')){
                ScreenService.showMessage("Data de Admissão fora do período de competência!");
            } else {
                ScreenService.showMessage(Messages.AVISO_ESO_PENSALIDADE_ADMISSAO_DATA_RETROATIVA);
            }
        }
        
        widget.currentRow.DTPRIMADMISSAO = widget.currentRow.DTADMISSAOVINC;
        widget.currentRow.DTEXAMEMEDICO = widget.currentRow.DTADMISSAOVINC;
        widget.currentRow.DTOPCAOFGTS = widget.currentRow.DTADMISSAOVINC;
        widget.currentRow.DTENTREGAEPI = widget.currentRow.DTADMISSAOVINC;
        widget.currentRow.DTBASEFERIAS = widget.currentRow.DTADMISSAOVINC;
        widgetParametros.currentRow.DTINIOCUPACAO = widget.currentRow.DTADMISSAOVINC;
        widgetParametros.currentRow.DTINIESCALA   = widget.currentRow.DTADMISSAOVINC;
        widgetParametros.currentRow.DTINISITUFUNC = widget.currentRow.DTADMISSAOVINC;
        widgetParametros.currentRow.DTALTESALARIO = widget.currentRow.DTADMISSAOVINC;
        widgetMovimentacao.currentRow.DTINIMOVIMENT = widget.currentRow.DTADMISSAOVINC;
    };
    
    this.PaisOnChange_liberarEstado = function(args) {
        var widget = ABUtilController.checkWidget(args);
        if(widget.currentRow.NMPAIS)
            widget.getField('SGESTADO').readOnly = false;
        else{
            widget.getField('SGESTADO').readOnly = true;
            widget.currentRow.SGESTADO = "";
            widget.getField('NMMUNICIPIO').readOnly = true;
            widget.currentRow.NMMUNICIPIO = "";
        }
    };

    this.EstadoOnChange_liberarMunicipio = function(args) {
        var widget = ABUtilController.checkWidget(args);
        if(widget.currentRow.SGESTADO)
            widget.getField('NMMUNICIPIO').readOnly = false;
        else{
            widget.getField('NMMUNICIPIO').readOnly = true;
            widget.currentRow.NMMUNICIPIO = "";
        }
    };
    
    this.visibilidadeFieldRgPorFieldPais = function(args){
        var widget = ABUtilController.checkWidget(args);    
        if(parseInt(widget.currentRow.CDPAIS) == 55){
            widget.getField('NRRGPESSOA').validations = {required: true};
            widget.getField('CDEXRGPESSOA').validations = {required: true};
            widget.getField('DTEXRGPESSOA').validations = {required: true};
            widget.getField('NMUFRGPESSOA').validations = {required: true};
            widget.getField('DSCLASSESTRANG').validations = {};
        }else{
            widget.getField('NRRGPESSOA').validations = {};
            widget.getField('CDEXRGPESSOA').validations = {};
            widget.getField('DTEXRGPESSOA').validations = {};
            widget.getField('NMUFRGPESSOA').validations = {};
            widget.getField('DSCLASSESTRANG').validations = {required: true};
        }
    };

    this.setDefaultValueFieldTipoRegimePrev = function(args){
        var widget = ABUtilController.checkWidget(args);    
        widget.getField('DSTPREGIMEPREV').reload().then(function(){
            widget.getField('DSTPREGIMEPREV').dataSource.data.forEach(function(data){
                if(data.NRTPREGIMEPREV == 1){
                    widget.currentRow.NRTPREGIMEPREV = data.NRTPREGIMEPREV;
                    widget.currentRow.DSTPREGIMEPREV = data.DSTPREGIMEPREV;
                }
            });
        });
    };
    
    this.mostrarMensagemIdadeMenor14 = function(){
        var widCadDep = templateManager.container.getWidget('Pessoa');
        var idadeDep = moment(moment().format('DD/MM/YYYY'), 'DD/MM/YYYY').diff(moment(widCadDep.currentRow.DTNASCPESSOA, 'DD/MM/YYYY'), 'year');
        if(idadeDep < 14) ScreenService.showMessage(Messages.HCM01055_FPA_ADMISSAO_IDADE_MENOR_14);
    };
    
    this.geraMatriculaEsocial = function(widget){
        restEngine.post('product#/geraMatriculaESocial', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
            then(function (data) {
                if(data.dataset){
                    widget.currentRow.CDMATRICULAESOCIAL = data.dataset.geraMatriculaESocial.NOVO;
                }
            }).
            catch(function(e) {
                var error;
                if(e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
        
    };
    
    this.validaMatriculaESocialAdmissao = function(){
        var widget = templateManager.container.getWidget('movimentacaoCandidato');
        if(widget.currentRow.IDUTILIZAMATRIC && widget.currentRow.IDUTILIZAMATRIC == 'S'){
            // widget.getField('CDMATRICULAESOCIAL').readOnly = false
            this.geraMatriculaEsocial(widget);
        }else{
            // widget.getField('CDMATRICULAESOCIAL').readOnly = true;
            widget.currentRow.CDMATRICULAESOCIAL = '';
        }
    };
    
    this.validaRequerimentoCpfDependete = function() {
        var widCadDep = templateManager.container.getWidget('cadastroDependentesCandidato');
        var flag = false;
        var idadeDep = moment(moment().format('DD/MM/YYYY'), 'DD/MM/YYYY').diff(moment(widCadDep.currentRow.DTNASCIFUNDPARC, 'DD/MM/YYYY'), 'year');
        var idadeMinCPF = 0;
        if(getLocalVar("IDADE_MIN_CPF_DEP"))
        idadeMinCPF = getLocalVar("IDADE_MIN_CPF_DEP");
        
        if(widCadDep.currentRow.NRTIPODEPENDE && idadeDep >= idadeMinCPF){
            
            if(Array.isArray(widCadDep.currentRow.NRTIPODEPENDE) ){
                widCadDep.currentRow.NRTIPODEPENDE.forEach(function(obj){
                    if(obj == 2) //obj == 2, 2 é imposto de renda
                        flag = true;
                });
            }else if( widCadDep.currentRow.NRTIPODEPENDE == 2 )
                flag = true;

        }
        
        if(flag)
            widCadDep.getField('NRCPFPESSOA').validations = {required: true};
        else
            widCadDep.getField('NRCPFPESSOA').validations = {};
    };

    this.resetaPropriedadesFieldsOnAdd_cadBeneficiario = function(){
        var widgetMain = templateManager.container.getWidget('cadastroDependentesCandidato');
        widgetMain.getField('NRCPFPESSOA').validations = {};
    };
    
    this.validaDtNascDependete = function() {
        var widCadDep = templateManager.container.getWidget('cadastroDependentesCandidato');
        var flag = false;
        
        if(Array.isArray(widCadDep.currentRow.NRTIPODEPENDE) ){
            widCadDep.currentRow.NRTIPODEPENDE.forEach(function(obj){
                if(obj == 2) //obj == 2, 2 é imposto de renda
                    flag = true;
            });
        }else if( widCadDep.currentRow.NRTIPODEPENDE == 2 )
            flag = true;
            
        if(flag)
            widCadDep.getField('DTNASCIFUNDPARC').validations = {required: true};
        else
            widCadDep.getField('DTNASCIFUNDPARC').validations = {};
        
        
    };
    
    this.saveBeneficio = function (widget) {
        if(widget.isValid()) {
            var flag =0;
            widget.dataSource.data.forEach(function(bene){
                if(widget.currentRow.NRBENEFICIOM == bene.NRBENEFICIOM)                    
                    flag++;
            });
            if(flag>1){
                ScreenService.showMessage("Benefício já cadastrado!", 'ERROR');
                return;
            }
            widget.currentRow.changed = true;
            return widget.saveRow().then(function(){
                widget.currentRow.changed = false;
                widget.currentRow.__is_new = false;
                widget.view();
                 widget.reload();
            }).catch(function(e) {
                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(e), 'ERROR');
            });
        }
    };
    
    this.setBeneficioPorSindicato = function (args) {
        var widgetMovi = ABUtilController.checkWidget(args);
        var widgetBene = templateManager.container.getWidget('beneficioTitular');
        var widgetVinc = templateManager.container.getWidget('vinculo');
        
        if(!!widgetMovi.currentRow.NRESTRUTSIND && widgetMovi.currentRow.NRESTRUTSIND!= "") {
            var filtro = [
                {
                    "name": "NRORG",
                    "operator": "=",
                    "value": getLocalVar('HCM_NRORG_TRAB')
                },
                {
                    "name": "NRORG_PADRAO",
                    "operator": "=",
                    "value": getLocalVar('HCM_NRORG_PADRAO')
                },
                {
                    "name": "DTMESCOMPETENC",
                    "operator": "=",
                    "value":  getLocalVar('HCM_DTCOMPETENCIA_OPER')
                },
                {
                    "name": "NRESTRUTSIND",
                    "operator": "=",
                    "value": widgetMovi.currentRow.NRESTRUTSIND
                }
            ];
        
            restEngine.post("product#/getBeneficio", {requestType: "FilterData", filter: filtro}).
                then(function (data) {
                    if(!!data.dataset.getBeneficio.length){
                        var beneficios = data.dataset.getBeneficio;
                        beneficios.forEach(function(obj){
                            if(widgetBene.dataSource.data.findIndex(bene => bene.NRBENEFICIOM == obj.NRBENEFICIOM) == -1){
                                widgetBene.dataSource.data.push({
                                   NRBENEFICIOM: obj.NRBENEFICIOM,
                                   DSBENEFICIO: obj.DSBENEFICIO,
                                   DTINSCBENEFICIARIO:  !!widgetVinc.currentRow.DTADMISSAOVINC ? widgetVinc.currentRow.DTADMISSAOVINC : getLocalVar('HCM_DATA_ATUAL'),
                                   QTBENEFICIO: 1,
                                   IDTPBENEFICIARIO: "T",
                                   IDATIVO: "S",
                                   NRORG: getLocalVar('HCM_NRORG_TRAB'),
                                   NREVENTOMENSADEP: obj.NREVENTOMENSADEP
                                });
                            }
                        });
                    } else {
                        widgetBene.dataSource.data = [];
                    }
                });
            } else {
                widgetBene.dataSource.data = [];
            }
        
    };
    
    this.adicionaVale = function() {
        var widget = templateManager.container.getActiveWidget();
        if(widget.isValid()) {
            
            if (!ABUtilController.validaDtIniMenorIgualDtFin(widget.currentRow.DTINILINHAVINC, widget.currentRow.DTFIMLINHAVINC)) {
                ScreenService.showMessage(Messages.DTINI_POST_DTFIM_ERROR);
                return false;
            }
            
            var cont = 0;
            for(var i = 0; i < widget.dataSource.data.length; i++) {
                cont++;
            }
            
            widget.currentRow.NRORG = getLocalVar('HCM_NRORG_TRAB');
            widget.currentRow.changed = true;
            widget.currentRow.NRLINHAVINC = cont;
            return widget.saveRow().then(function(){
                widget.currentRow.changed = false;
                widget.currentRow.__is_new = false;
                widget.view();
                widget.reload();
            }).catch(function(e) {
                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(e), 'ERROR');
            });
        }
    };
    
    this.removeVale = function() {
        var widget = templateManager.container.getActiveWidget();  
        for(var i = 0; i<widget.dataSource.data.length; i++) {
            if(widget.currentRow.NRLINHAVINC === widget.dataSource.data[i].NRLINHAVINC){
                if(widget.dataSource.data.length == 1){
                    widget.dataSource.data = [];
                } else {
                    widget.dataSource.data.splice(i, 1);
                }
                ABUtilController.masterDetailVoltarList(widget);
                widget.reload();
            }
        }
    };
    
    this.validarCampoEstrutAdicional = function(args){
        var widget = args.owner.field.widget;
        widget.currentRow.NMRAZSOCESTRUT_ADICIONAL = null;
        widget.currentRow.NRESTRUTURAM_ADICIONAL = null;

        if(widget.currentRow.NMTIPOTRANSFER_ADICIONAL && widget.currentRow.NMTIPOESTRUTURA){
            widget.getField('NMRAZSOCESTRUT_ADICIONAL').readOnly = false;    
            widget.getField('NMRAZSOCESTRUT_ADICIONAL').dataSourceFilter.forEach(function(filter, index){
                if(filter.name == "NRTIPOESTRUTURA") filter.value = widget.currentRow.NRTIPOESTRUTURA;
            });   
        }else{
            widget.getField('NMRAZSOCESTRUT_ADICIONAL').readOnly = true;    
        } 
    };
    
    this.verificaContratoVerdeAmarelo = function(){
        var widgetVinculo = templateManager.container.getWidget('vinculo');
        var widgetPessoa = templateManager.container.getWidget('Pessoa');
        var widgetParametros = templateManager.container.getWidget('parametros');
        var dados = [];
        
        if(widgetVinculo.currentRow.NRVINCULOEMPREG && (widgetVinculo.currentRow.NRVINCULOEMPREG == 107 || widgetVinculo.currentRow.NRVINCULOEMPREG == 108)){
            validaContratoVerdeAmarelo = true;
            widgetVinculo.getField('IDPAGPROPFER13').readOnly = false;
            if(pessoaCadastrada == true){
                dados.DTNASCPESSOA = !Util.isEmptyOrBlank(widgetVinculo.currentRow.DTNASCPESSOA) ? widgetVinculo.currentRow.DTNASCPESSOA : null;
                dados.NRTPADMISSAO = !Util.isEmptyOrBlank(widgetVinculo.currentRow.NRTPADMISSAO) ? widgetVinculo.currentRow.NRTPADMISSAO : null;
                dados.DTFIMCONTRDETERMIN = !Util.isEmptyOrBlank(widgetVinculo.currentRow.DTFIMCONTRDETERMIN) ? widgetVinculo.currentRow.DTFIMCONTRDETERMIN : null;
                dados.DTADMISSAOVINC = !Util.isEmptyOrBlank(widgetVinculo.currentRow.DTADMISSAOVINC) ? widgetVinculo.currentRow.DTADMISSAOVINC : null;
                dados.VRSALARIO = !Util.isEmptyOrBlank(widgetParametros.currentRow.VRSALARIO) ? widgetParametros.currentRow.VRSALARIO : null;
                this.realizaValidacoesContratoVerdeAmarelo(dados);
            }else{
                dados.DTNASCPESSOA = !Util.isEmptyOrBlank(widgetPessoa.currentRow.DTNASCPESSOA) ? widgetPessoa.currentRow.DTNASCPESSOA : null;
                dados.NRTPADMISSAO = !Util.isEmptyOrBlank(widgetVinculo.currentRow.NRTPADMISSAO) ? widgetVinculo.currentRow.NRTPADMISSAO : null;
                dados.DTFIMCONTRDETERMIN = !Util.isEmptyOrBlank(widgetVinculo.currentRow.DTFIMCONTRDETERMIN) ? widgetVinculo.currentRow.DTFIMCONTRDETERMIN : null;
                dados.DTADMISSAOVINC = !Util.isEmptyOrBlank(widgetVinculo.currentRow.DTADMISSAOVINC) ? widgetVinculo.currentRow.DTADMISSAOVINC : null;
                dados.VRSALARIO = !Util.isEmptyOrBlank(widgetParametros.currentRow.VRSALARIO) ? widgetParametros.currentRow.VRSALARIO : null;
                this.realizaValidacoesContratoVerdeAmarelo(dados);
            }
        }else{
            validaContratoVerdeAmarelo = false;
            widgetVinculo.getField('IDPAGPROPFER13').readOnly = true;
            widgetVinculo.currentRow.IDPAGPROPFER13 = '';
        }
        
        
    };
    
    this.verificaContratoVerdeAmareloCampos = function(campos, nomeWidget){
        if(validaContratoVerdeAmarelo){                    
            var currentRow = templateManager.container.getWidget(nomeWidget) ? templateManager.container.getWidget(nomeWidget).currentRow : null;
            var dados = [];
            dados.DTNASCPESSOA = null;
            dados.NRTPADMISSAO = null;
            dados.DTFIMCONTRDETERMIN = null;
            dados.DTADMISSAOVINC = null;
            dados.VRSALARIO = null;

            if(!Util.isEmptyOrBlank(currentRow) ){
                campos.forEach(function(campo){
                    dados[campo] = !Util.isEmptyOrBlank(currentRow[campo]) ? currentRow[campo] : null;
                });
            }
            
            this.realizaValidacoesContratoVerdeAmarelo(dados);
        }
    };
    
    this.realizaValidacoesContratoVerdeAmarelo = function(currentRow){
        var mensagem = '';
        if(!Util.isEmptyOrBlank(currentRow.DTNASCPESSOA)){
            var idade = ABUtilController.retornaIdade(currentRow.DTNASCPESSOA);
            if(idade > 29 || idade < 18){
                mensagem += Messages.HCMOOOOO_GER_ADMISSAO_CONTRATOVERAMAR_DATANASC + '<br>';
            }
        }
        if(!Util.isEmptyOrBlank(currentRow.NRTPADMISSAO) && currentRow.NRTPADMISSAO != 1){
            mensagem += Messages.HCMOOOOO_GER_ADMISSAO_CONTRATOVERAMAR_TPADMISSAO + '<br>';
        }
        if(!Util.isEmptyOrBlank(currentRow.DTFIMCONTRDETERMIN) && !Util.isEmptyOrBlank(currentRow.DTADMISSAOVINC)){
           var periodo = ABUtilController.retornaPeriodo(currentRow.DTADMISSAOVINC.substr(0,10)+' 00:00:00', currentRow.DTFIMCONTRDETERMIN.substr(0,10)+' 00:00:00');
           if(periodo > 24){
               mensagem += Messages.HCMOOOOO_GER_ADMISSAO_CONTRATOVERAMAR_PRAZO + '<br>';
           }
        }
        if(!Util.isEmptyOrBlank(currentRow.VRSALARIO)){
            var salariominimo = getLocalVar('HCM_SALARIO_MINIMO');
            var salario = currentRow.VRSALARIO.replace('.','').replace(',', '.');
            if(parseFloat(salario) > parseFloat(1.5*salariominimo)){
                mensagem += Messages.HCMOOOOO_GER_ADMISSAO_CONTRATOVERAMAR_SALARIO;
            }
        }
        
        if(!Util.isEmptyOrBlank(mensagem)){
            ScreenService.showMessage('Contrato Verde e Amarelo:<br>' + mensagem);
        }
    };
    
    this.atualizaDadosRelacionados = function(nomeWidget){
        var widgetVinculo = templateManager.container.getWidget('vinculo');
        var widgetParametros = templateManager.container.getWidget('parametros');
        
        if (nomeWidget == widgetVinculo.name){
            widgetParametros.currentRow.NRTPMODALIDSAL = widgetVinculo.currentRow.NRTPMODALIDSAL;
            widgetParametros.currentRow.NMTPMODALIDSAL = widgetVinculo.currentRow.NMTPMODALIDSAL;
        }
        
        if (nomeWidget == widgetParametros.name){
            widgetVinculo.currentRow.NRTPMODALIDSAL = widgetParametros.currentRow.NRTPMODALIDSAL;
            widgetVinculo.currentRow.NMTPMODALIDSAL = widgetParametros.currentRow.NMTPMODALIDSAL;
        }
    };
    
    this.getFieldValue = function(nmWidget, nmField) {
        var widget = templateManager.container.getWidget(nmWidget); //widget do campo desejado
        if(widget.currentRow.hasOwnProperty(nmField)) {             //Verifica se o campo na 'currentRow' já existe
            return widget.currentRow[nmField];                      //Retorna o valor do campo na 'currentRow'
        }
        return "";                                                  //Retorna vazio para quando o campo ainda não existir
    };
    
    this.setReadOnlyFromValue = function(nmWidget, nmThisField, nmFieldAlvo) {
        var widget = templateManager.container.getWidget(nmWidget); //widget do campo desejado
        var aux = widget.currentRow.hasOwnProperty(nmThisField) ? widget.currentRow[nmThisField] : "";  //Adiquiri o valor do campo
        if(aux != "") {
            widget.getField(nmFieldAlvo).readOnly = false;                                              //Se 'este' campo estiver preenchido o campo alvo será habilitado
            widget.getField(nmFieldAlvo).reload();                                                      //Recarrega para este aplicar o filtro
        } else
            widget.getField(nmFieldAlvo).readOnly = true;                                               //Se 'este' campo não estiver preenchido o campo alvo será inabilitado
    };
    
    this.getHorasSemanais = function() {
        var widget = templateManager.container.getWidget('parametros');
        var admissaoController = this;
        
        restEngine.post('product#/getHorasSemanais', {'requestType': 'DataSet', 'dataset': [widget.currentRow]})
        .then(function (data) {
            widget.currentRow.QTHRSEMESCTRABH = data.dataset.quantidadeHoras[0];
            admissaoController.getSalarioHora();
        })
        .catch(function(e) {
            var error;
            if(e.data.error === undefined){
                error = e;
            }    
            else{
                error = e.data.error;
                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            }    
        });
    };
    
    this.getSalarioHora = function() {
        var row = templateManager.container.getWidget('parametros').currentRow;
        var jornadaSemanal = row.QTHRSEMESCTRABH;
    
        if (row.DSTIPOSALARIO === "HORA") {
            row.VRSALARIOHR = row.VRSALARIO.replace(/[.]/g, '').replace(/[,]/, '.') / (jornadaSemanal * 5);
        }
    };

}

Configuration(function(ContextRegister) {
    ContextRegister.register('AdmissaoController', AdmissaoController);
});

// FILE: assets/js/controllers/AdmissaoPreliminarSimplificadaController.js
/* jshint esversion: 6 */

function AdmissaoPreliminarSimplificadaController (ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine,Messages, $window, ABUtilController, HcmConsts, AdmissaoController) {
    
    this.onEnterAdmissao = function(){
        var widgetAdmissao = templateManager.container.getWidget("admissaoPreliminarSimplificada");
        var validaIniciaContinuaAdmissao = AdmissaoController.getValidaIniciaContinuaAdmissao();
        var pessoaCadastrada = AdmissaoController.getPessoaCadastrada();
        var dadosAdmissao = AdmissaoController.getDadosAdmissao();
        
        widgetAdmissao.setCurrentRow({});
        
        if(validaIniciaContinuaAdmissao){
            if(pessoaCadastrada){
                widgetAdmissao.currentRow.NRCPFPESSOA = dadosAdmissao.NRCPFPESSOA;
                widgetAdmissao.currentRow.NRPESSOA = dadosAdmissao.NRPESSOA;
                widgetAdmissao.currentRow.NMPESSOA = dadosAdmissao.NMPESSOA;
                widgetAdmissao.currentRow.DTNASCPESSOA = dadosAdmissao.DTNASCPESSOA;
                widgetAdmissao.currentRow.IDMULTVINC = dadosAdmissao.IDMULTVINC;
                widgetAdmissao.getField('NRCPFPESSOA').readOnly = true;
                widgetAdmissao.getField('NMPESSOA').readOnly = true;
                widgetAdmissao.getField('DTNASCPESSOA').readOnly = true;
                widgetAdmissao.activate();
            }else{
                widgetAdmissao.currentRow.NRCPFPESSOA = dadosAdmissao.NRCPFPESSOA;
                widgetAdmissao.currentRow.IDMULTVINC = 'UNICO';
                widgetAdmissao.currentRow.NRVINCULOEMPREG = 1;
                widgetAdmissao.getField('NRCPFPESSOA').readOnly = true;
                widgetAdmissao.activate();
            }
        }
    };
    
    this.getDefaultVinculoEmpregaticio = function() {
        var filtro = [
            {
                "name": "NRVINCULOEMPREG",
                "operator": "=",
                "value": 1
            }
        ];
        
        restEngine.post(
            'product#/getVinculoEmpregaticio', {
                "requestType": "FilterData",
                "filter": filtro
            }
        )
        .then( (data) => {
            templateManager.container.getWidget("admissaoPreliminarSimplificada").currentRow.NRVINCULOEMPREG = data.dataset.gpe_vinculoempreg_get[0].NRVINCULOEMPREG;
            templateManager.container.getWidget("admissaoPreliminarSimplificada").currentRow.NMABREV = data.dataset.gpe_vinculoempreg_get[0].NMABREV;
        })
        .catch( (error) => {
            ScreenService.showMessage(error.data.error, 'ERROR');
        });
     };
    
    this.setDataAdmissao = function() {
        var widget = templateManager.container.getActiveWidget();
        
        var data = new Date();
        var dataAtual = data.toLocaleString();
        dataAtual = dataAtual.split(" ");
        
        if (!!widget.currentRow.DTADMISSAOVINC && moment(widget.currentRow.DTADMISSAOVINC, 'DD/MM/YYYY') <= moment(dataAtual[0], 'DD/MM/YYYY')) {
            if(moment(widget.currentRow.DTADMISSAOVINC, 'DD/MM/YYYY') < moment(getLocalVar('HCM_DTCOMPETENCIA_OPER'), 'DD/MM/YYYY')){
                ScreenService.showMessage("Data de Admissão fora do período de competência!");
            } else {
                ScreenService.showMessage(Messages.AVISO_ESO_PENSALIDADE_ADMISSAO_DATA_RETROATIVA);
            }
        }
        
        this.atualizaPeriodo(widget);
    };
    
    this.atualizaPeriodo = function(widget) {
        var dtadmissao = widget.getField('DTADMISSAOVINC').value();
        var dtfimcontrato = widget.getField('DTFIMCONTRDETERMIN').value();
        if (!ABUtilController.validaDtIniMenorIgualDtFin(dtadmissao, dtfimcontrato)) {
            ScreenService.alertNotification(Messages.DTINI_POST_DTFIM_ERROR, 10000);
        }
    };
    
    this.cancelarAdmissao = function(){
        ScreenService.showCustomDialog('Deseja realmente cancelar a admissão ?', 'CONFIRMATION', null, [{
            label: ScreenService.i18n("Sim"),
            code: function(e, deferred) {
                var historicoWidgets = templateManager.historyItems;
                var origemAdmissaoMenu = false;
                historicoWidgets.forEach(function(widget){
                    if(widget == 'product#hcm01083_fpa_admissaoMenu'){
                        origemAdmissaoMenu = true;
                    }
                });
                if(origemAdmissaoMenu){
                    ScreenService.closePopup();
        		    ScreenService.openWindow('product#dashboard');
                }else{
                    ScreenService.goBack();
                }
                deferred.resolve(e);
            }.bind(this)
          },{
            label: ScreenService.i18n("Não"),
            code: function(e, deferred) {
                deferred.reject(e);
            }
        }]);
    };
    
    this.confirmarSaveAdmissao = function(){
        ScreenService.confirmMessage('Deseja realmente finalizar a admissão?', 'CONFIRMATION', 
            function(){
                
                var widgetAdmissao = templateManager.container.getWidget("admissaoPreliminarSimplificada");
                var admissaoPreliminarSimplificadaController = this;
                
                if(widgetAdmissao.isValid()){
                    
                    if (widgetAdmissao.currentRow.NRCPFPESSOA) {
                        widgetAdmissao.currentRow.NRCPFPESSOA = widgetAdmissao.currentRow.NRCPFPESSOA.toString().replace(/[\D]+/g, '');
                    }
                    
                    restEngine.post('product#/admissaoPreliminarSimplificada', {'requestType':'DataSet','dataset':[widgetAdmissao.currentRow]})
                    .then(function(data){                        
                        if (data.notifications[0].type == 'success') {
                                
                            var concluiAdmissao = function() {
                                ScreenService.showMessage('Admissão realizada com sucesso. Favor aprovar posteriormente na tela Aprovação de Admissão.');
                                templateManager.historyItems.pop();
                                ScreenService.openWindow('product#hcm00052_gpe_vinculo'); 
                            }.bind(this);
                            
                            ScreenService.confirmMessage('Deseja transmitir esse evento para o eSocial?', 'CONFIRMATION', function () {
                                admissaoPreliminarSimplificadaController.setEvento();
                            })
                            .then(concluiAdmissao, concluiAdmissao);
                                
                        } else if (data.messages) {
                            ScreenService.showMessage(data.messages[0].message);
                        } else {
                            ScreenService.showMessage('Erro ao realizar admissão. Tente novamente.');
                        }
                    })
                    .catch(function(e) {
                        var error;
                        if(e.data.error === undefined)
                            error = e;
                        else 
                            error = e.data.error;
                            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');   
                    });
                } else {
                    ScreenService.showMessage("Para prosseguir, preencha corretamente os campos"); 
                }
            }.bind(this)
        );
    };
    
    this.setEvento = function() {
        var widgetAdmissao = templateManager.container.getWidget('admissaoPreliminarSimplificada');
        var row = { 
            CDCNPJEMPREGADOR: widgetAdmissao.currentRow.CDCNPJESTRUT,
            DSEVENTO: "S-2190 - Registro Preliminar de Trabalhador",
            DSVERSAO: "S-1.0",
            IDGRUPO: "N",
            NMEVENTO: "S-2190",
            NRESTRUTURAM: widgetAdmissao.currentRow.NRESTRUTLEGAL,
            NREVENTO: "198",
            NRTPAMBIENTE: "2",
            changed: true,
            __is_new: true
        };
            
        restEngine.post('/setEsonaoperiodico', {'requestType': 'DataSet', 'dataset': [row]})
        .then()
        .catch(function(e) {
            ScreenService.showMessage(e.data.error, 'ERROR');
        });
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('AdmissaoPreliminarSimplificadaController', AdmissaoPreliminarSimplificadaController);
});

// FILE: assets/js/controllers/AdvertenciaSituacaoFrequenciaController.js
function AdvertenciaSituacaoFrequenciaController (ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, $window, ABUtilController, Messages) {

    this.deleteAssociacaoSituacaoFrequencia = function(args) {
        var widget = ABUtilController.checkWidget(args);
        var data = {}; 
        ScreenService.confirmMessage(Messages.DELETE_ROW, 'CONFIRMATION', 
            function(){
                widget.dataSource.remove(widget.currentRow).then(function (data){
                    if(data.dataset.ptoAdvertSituFreq_setAdvertenciaSituacaoFrequencia.type === "success"){
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                        ScreenService.showMessage(Messages.REMOVE_ROW_SUCCESS); 
                    } else {
                        ScreenService.showMessage(Messages.REMOVE_ROW_ERROR); 
                    }
                }.bind(this));
            }.bind(this)
        );
    };

    this.salvarAssociacaoSituacaoFrequencia = function(argsrRow){
        var widget = templateManager.container.getWidget("advertenciaSituacaoFrequencia");
        if(widget.isValid())  {
            
            if (!widget.backupRow) {
                widget.currentRow.__is_new = true;
            } else {
                widget.currentRow.__is_new = false;
            }
            if(Util.isObject(widget.currentRow.DSCORHEXADECIMAL)){
                widget.currentRow.DSCORHEXADECIMAL = widget.currentRow.DSCORHEXADECIMAL.toHexString();
            }
            widget.currentRow.CDOPERADOR_LOG = getLocalVar("HCM_CDOPERADOR");
            widget.currentRow.NRORGTRAB = getLocalVar("HCM_NRORG_TRAB");
            widget.currentRow.NRORGPADRAO = getLocalVar("HCM_NRORG_PADRAO");
            widget.currentRow.DTATUAL = getLocalVar("HCM_DATA_ATUAL");
            return widget.saveRow().then(function (data){
                if (data.notifications[0].type === "success") {
                    ScreenService.showMessage(Messages.SAVE_ROW_SUCCESS);
                    if(widget.currentRow.__is_new){
                        ScreenService.closeSwipe();
                        widget.reload();
                    }else{
                        ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                        widget.backupRow = null;
                        widget.view();
                    }
                } else {
                    ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                }
            }.bind(this)).catch(function(e) {
                var error;
                if(e.data.error === undefined)
                    error = e;
                else 
                    error = e.data.error;
                
                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error));
            });
        }
    };

    this.setColor = function(row, element, widget){
        widget = templateManager.container.getWidget(widget);
        var field = widget.getField("DSCORHEXADECIMAL");
        if(widget.mode != "edit"){
            element.children('p').remove();
            element.children('span').remove();
            element.children('div').remove();
            var class1 = "colorfield", class2 = "";
            if(widget.mode == "view"){
                class1 += " colorfield-in-form";
                class2 = "zh-field-value";
            }
            else {
                class1 += " colorfield-in-grid";
            }
            element.append('<div class='+class2+'> <div class='+class1+' style = background-color:'+ row.DSCORHEXADECIMAL +';"> </div> </div>');
        }
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('AdvertenciaSituacaoFrequenciaController', AdvertenciaSituacaoFrequenciaController);
});

// FILE: assets/js/controllers/AgendaController.js
/**
 * Created by lara on 15/06/2016.
 */
function AgendaController (ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, $window, ABUtilController,Messages) {

    this.backFilterDate = function(argsRow) {
        date = argsRow.DATE;
        date = moment(date, 'DD/MM/YYYY').add(-1, 'days');
		this.setDateFilter(date);
    };

    this.deleteAgenda = function(args) {
    ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
        var widget = args.owner.widget;
        var data = {};
        widget.dataSource.checkedRows = widget.currentRow;
        widget.removeCheckedRows();
        widget.reload();
        ABUtilController.masterDetailVoltarList(widget);
        ScreenService.showMessage("Agenda excluída com sucesso");
        }, null);
    };

    this.deleteEvento = function(args) {
    ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
        var widget = args.owner.widget;
        var data = {};
        widget.dataSource.checkedRows = widget.currentRow;
        widget.removeCheckedRows();
        widget.reload();
        ABUtilController.masterDetailVoltarList(widget);
        ScreenService.showMessage("Evento excluído com sucesso");
        }, null);
    };

    this.enviarMensagem = function(){
        var widgetMensagens = templateManager.container.getWidget("mensagens");
        var widgetEventosDia = templateManager.container.getWidget("eventosDia");
        if(widgetEventosDia.currentRow.NRPARCNEGOCIORELA === null || widgetEventosDia.currentRow.NRPARCNEGOCIORELA === undefined || widgetEventosDia.currentRow.NRPARCNEGOCIORELA === ''){
            ScreenService.showMessage("Não há pessoa relacionada no evento");
        } else {
            if(widgetMensagens.isValid()){
                save = Object.assign({},{"COMUNICADO": widgetEventosDia.currentRow}, {"MENSAGEM":  widgetMensagens.currentRow});
                restEngine.post("product#/enviarMensagem",
                    {'requestType':'DataSet','dataset':[save]}
                ).then(
                    function(data){
                        if(data.dataset.enviarMensagem[0] === undefined) {
                            ScreenService.showMessage('Erro ao enviar a mensagem');
                            ABUtilController.masterDetailClosePopup(widgetMensagens);
                        } else {
                            ScreenService.showMessage('Mensagem enviada com sucesso');
                            ABUtilController.masterDetailClosePopup(widgetMensagens);
                        }
                        widgetMensagens.currentRow = {};
                    }
                ).catch(function(e) {
                    var error;
                    if(e.data.error === undefined)
                        error = e;
                    else 
                        error = e.data.error;
                    
                    ScreenService.showMessage('Ocorreu um erro inesperado, contate o administrador informando o trecho abaixo: <br><br>' + error + '<br><br>', 'ERROR');
                });
            }
        }
    };

    this.filterDateSelected = function(argsRowDate) {
        var container = templateManager.container;
        var widget = container.getWidget('STRIPE');
        var popUp = container.getWidget('calendario');

        date = argsRowDate;
        date = moment(date).format("DD/MM/YYYY");
        this.setDateFilter(moment(date, "DD/MM/YYYY"));

        ABUtilController.masterDetailClosePopup(popUp);
    };

    this.nextFilterDate = function(argsRow) {
        date = argsRow.DATE;
        date = moment(date, 'DD/MM/YYYY').add(1, 'days');
        this.setDateFilter(date);
    };

    this.onEnterMensagem = function(){
        var widgetMensagens = templateManager.container.getWidget("mensagens");
        widgetMensagens.getField("DSMENSAGEM").placeholder = "Mnemônicos aceitos:" +
                                                            '\n\n' +
                                                            "[NOME_CANDIDATO] = Nome do relacionado" +
                                                            '\n' +
                                                            "[NOME_EVENTO] = Nome do Evento" +
                                                            '\n' +
                                                            "[LOCAL_EVENTO] = Local do Evento"+
                                                            '\n' +
                                                            "[DATA_EVENTO] = Data do Evento"+
                                                            '\n' +
                                                            "[RESPONSAVEL_EVENTO] = Responsável pelo Evento"+
                                                            '\n' +
                                                            "[DESCRICAO_EVENTO] = Descrição do Evento";
    };

    this.openAdicionarAgenda = function() {
        var widget = templateManager.container.getWidget('agenda');
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
    };

    this.openAdicionarEvento = function() {
        var widget = templateManager.container.getWidget('eventosDia');
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
    };

    this.openFilterDate = function() {
        var container = templateManager.container;
        var widget = container.getWidget('calendario');
        ABUtilController.masterDetailOpenPopup(widget);
    };

    this.openPopUpDados = function(){
        var widget = templateManager.container.getWidget('dadosCalendario');
        widget.isVisible = true;
        ABUtilController.masterDetailOpenPopup(widget);
    };

    this.salvarAgenda = function(argsRow){
        var widgetAgenda = templateManager.container.getWidget("agenda");
        if(widgetAgenda.isValid())  {
            widgetAgenda.currentRow.CDOPERLOG = getLocalVar("HCM_CDOPERADOR");
            widgetAgenda.currentRow.NRORGOPERLOG = getLocalVar("HCM_NRORG_TRAB");
            widgetAgenda.currentRow.DTATUAL = getLocalVar("HCM_DATA_ATUAL");
            dataInicio = null;
            dataFim = null;
            if(!widgetAgenda.currentRow.DTINICIOAGENDA && widgetAgenda.currentRow.DTFIMAGENDA){
                ScreenService.showMessage('Favor colocar uma data inicial');
            } else {
                if(widgetAgenda.currentRow.DTINICIOAGENDA){
                    split = widgetAgenda.currentRow.DTINICIOAGENDA.split('/');
                    dataInicio = Date.parse(split[1] + "/" +split[0]+"/"+split[2]);
                    if(widgetAgenda.currentRow.DTFIMAGENDA){
                        split = widgetAgenda.currentRow.DTFIMAGENDA.split('/');
                        dataFim = Date.parse(split[1] + "/" +split[0]+"/"+split[2]);
                        if(dataInicio !== "" && dataFim !== ""){
                            if(dataInicio > dataFim){
                                ScreenService.showMessage('Favor colocar uma data inicial menor ou igual que a data final');
                            } else {
                                return widgetAgenda.saveRow().then(function(){
                                    if (widgetAgenda.currentRow.__is_new) {
                                        ABUtilController.masterDetailVoltarList(widgetAgenda);
                                        widgetAgenda.reload();
                                    } else {
                                        ABUtilController.mudarVisibilidadeWidgets(widgetAgenda.widgets, true);
                                        widgetAgenda.backupRow = null;
                                        widgetAgenda.view();
                                    }
                                }).catch(function(e) {
                                    var error;
                                    if(e.data.error === undefined)
                                        error = e;
                                    else 
                                        error = e.data.error;
                                    
                                    ScreenService.showMessage('Ocorreu um erro inesperado, contate o administrador informando o trecho abaixo: <br><br>' + error + '<br><br>', 'ERROR');
                                });
                            }
                        }
                    } else {
                        return widgetAgenda.saveRow().then(function(){
                            widgetAgenda.currentRow.changed = false;
                            widgetAgenda.currentRow.__is_new = false;
                            ABUtilController.masterDetailVoltarList(widgetAgenda);
                            widgetAgenda.reload();
                        }).catch(function(e) {
                            var error;
                            if(e.data.error === undefined)
                                error = e;
                            else 
                                error = e.data.error;
                            
                            ScreenService.showMessage('Ocorreu um erro inesperado, contate o administrador informando o trecho abaixo: <br><br>' + error + '<br><br>', 'ERROR');
                        });
                    }
                } else {
                    return widgetAgenda.saveRow().then(function(){
                        widgetAgenda.currentRow.changed = false;
                        widgetAgenda.currentRow.__is_new = false;
                        ABUtilController.masterDetailVoltarList(widgetAgenda);
                        widgetAgenda.reload();
                    }).catch(function(e) {
                        var error;
                        if(e.data.error === undefined)
                            error = e;
                        else 
                            error = e.data.error;
                        
                        ScreenService.showMessage('Ocorreu um erro inesperado, contate o administrador informando o trecho abaixo: <br><br>' + error + '<br><br>', 'ERROR');
                    });
                }
            }
        }
    };

    this.salvarEvento = function(argsRow){
        var widgetEventos = templateManager.container.getWidget("eventosDia");
        if(widgetEventos.currentRow.NMEVENTO === '.'){
            ScreenService.showMessage("Nome do evento inválido");
        } else {
            if(widgetEventos.isValid())  {
                restEngine.post('product#/saveEventoDia', {'requestType': 'DataSet', 'dataset': [widgetEventos.currentRow]}).
                then(function(){
                    if (widgetEventos.currentRow.__is_new) {
                        ABUtilController.masterDetailVoltarList(widgetEventos);
                        widgetEventos.reload();
                    } else {
                        ABUtilController.mudarVisibilidadeWidgets(widgetEventos.widgets, true);
                        widgetEventos.backupRow = null;
                        widgetEventos.view();
                    }
                }).catch(function(e) {
                    var error;
                    if(e.data.error === undefined)
                        error = e;
                    else 
                        error = e.data.error;
                    
                    ScreenService.showMessage('Ocorreu um erro inesperado, contate o administrador informando o trecho abaixo: <br><br>' + error + '<br><br>', 'ERROR');
                });
            }
        }
    };

    this.setDateFilter = function(date){
        var container = templateManager.container;
        var widget = container.getWidget('STRIPE');

        if (date === undefined)
            date = moment().add(0, 'days');

        numberWeek = date.weekday();
        weekday = moment().isoWeekday([numberWeek]).format('dddd');

        widget.currentRow.DATE = date.format("DD/MM/YYYY");
        widget.currentRow.WEEK_DAY = weekday;
        setLocalVar("BTL_DTAGENDAEVENTO", widget.currentRow.DATE);
        widget = container.getWidget('eventosDia');
        widget.reload();
    };

    this.setDefaultValues = function(){
        var widgetEventos = templateManager.container.getWidget("eventosDia");
        var widgetStripe = templateManager.container.getWidget("STRIPE");
        widgetEventos.currentRow.DTEVENTO = widgetStripe.currentRow.DATE;
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('AgendaController', AgendaController);
});

// FILE: assets/js/controllers/AgenteCausadorController.js
function AgenteCausadorController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, General,Messages) {

    this.adicionarRow = function(args) {
        var widget = args.owner.widget;
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
    };

	this.setAgenteCausador = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
                if (!widget.backupRow) {
                    widget.currentRow.__is_new = true;
                } else {
                    widget.currentRow.__is_new = false;
                }
                restEngine.post('product#/setAgenteCausador', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                    then(function (data) {
                        if (data.notifications[0].type === "success") {
                            ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                            if (widget.currentRow.__is_new) {
                                ABUtilController.masterDetailVoltarList(widget);
                                widget.reload();
                            } else {
                                ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                                widget.backupRow = null;
                                widget.view();
                            }
                        }else if(data.notifications[0].message === 'DUPLICATE_PRIMARY_KEY_ERROR'){
                            ScreenService.showMessage(Messages.DUPLICATE_PRIMARY_KEY_ERROR);
                        }else {
                            ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                        }
                    }).
                    catch(function(e) {
                        var error;
                        if(e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;
                            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    });
            }
    };
    
    this.deleteAgenteCausador = function(args) {
        var widget = args.owner.widget;
        widget.currentRow.__is_new = false;
        restEngine.post('product#/deleteAgenteCausador', {'requestType':'DataSet','dataset':[widget.currentRow]}).
            then(function(data){
                if(data.notifications[0].type === "success"){
                    ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                    ABUtilController.masterDetailVoltarList(widget);
                    widget.reload();
                } else {
                    ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                }
            }).
            catch(function(e) {
                var error;
                if(e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('AgenteCausadorController', AgenteCausadorController);
});

// FILE: assets/js/controllers/AgenteNocivoController.js
function AgenteNocivoController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, General,Messages) {

    this.adicionarRow = function(args) {
        var widget = args.owner.widget;
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
    };
    
    this.setAgenteNocivo = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
                if (!widget.backupRow) {
                    widget.currentRow.__is_new = true;
                } else {
                    widget.currentRow.__is_new = false;
                }
                restEngine.post('product#/setAgenteNocivo', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                    then(function (data) {
                        if (data.notifications[0].type === "success") {
                            ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                            if (widget.currentRow.__is_new) {
                                ABUtilController.masterDetailVoltarList(widget);
                                widget.reload();
                            } else {
                                ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                                widget.backupRow = null;
                                widget.view();
                            }
                        } else {
                            ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                        }
                    }).
                    catch(function(e) {
                        var error;
                        if(e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;
                            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    });
            }
    };
    
    this.deleteAgenteNocivo = function(args) {
    ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
        var widget = args.owner.widget;
        widget.currentRow.__is_new = false;
        restEngine.post('product#/deleteAgenteNocivo', {'requestType':'DataSet','dataset':[widget.currentRow]}).
            then(function(data){
                if(data.notifications[0].type === "success"){
                    ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                    ABUtilController.masterDetailVoltarList(widget);
                    widget.reload();
                } else {
                    ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                }
            }).
            catch(function(e) {
                var error;
                if(e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
        }, null);
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('AgenteNocivoController', AgenteNocivoController);
});

// FILE: assets/js/controllers/AlteEscalaController.js
/**
 * Created by felipesantos on 31/10/2016.
 */
 /* jshint esversion: 6 */
function AlteEscalaController (ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, $window, ABUtilController, Messages) {
    
    this.camposData = ['DTINIESCALA', 'DTFIMESCALA'];
    var self = this;

    this.openPopUpGeraEscala = function(args) {
        var widgetPopup = templateManager.container.getWidget('geraEscala');
        widgetPopup.currentRow = {};
        ABUtilController.masterDetailOpenPopup(widgetPopup);
    };
    
    this.setMinDateDataFim = function(args){
        var widget = ABUtilController.checkWidget(args);
        widget.getField('DTFIMESCALA').minDate = widget.currentRow.DTINIESCALA;
        widget.currentRow.DTFIMESCALA = null;
    };
    
    this.limpaTurno = function(args){
        var widgetAlteEscala = ABUtilController.checkWidget(args);
        widgetAlteEscala.currentRow.DSTURNO = "";
        widgetAlteEscala.currentRow.NRTURNO = null;
    };

    this.habilitaDesabilitaTurno = function(args){
        var widgetAlteEscala = templateManager.container.getActiveWidget(args);
        var fieldEscala = widgetAlteEscala.getField('NMESCALATRABH');
        var fieldTurno = widgetAlteEscala.getField('DSTURNO');
        
        if (fieldEscala.value() !== "" && fieldEscala.value() != undefined) {
            fieldTurno.dataSourceFilter = [
                {
                    "name": "P_NRORG",
                    "operator": "=",
                    "value": "@getLocalVar('HCM_NRORG_TRAB') ? getLocalVar('HCM_NRORG_TRAB') : '' @"
                },
                {
                    "name": "P_NRESCALATRABM",
                    "operator": "=",
                    "value": widgetAlteEscala.currentRow.NRESCALATRABM
                },
                {
                    "name": "P_IDATIVO",
                    "operator": "=",
                    "value": "S"
                }
            ];
            fieldTurno.readOnly = false;
            fieldTurno.reload();
        } else {
            fieldTurno.dataSourceFilter = [
                {
                    "name": "P_NRORG",
                    "operator": "=",
                    "value": "@getLocalVar('HCM_NRORG_TRAB') ? getLocalVar('HCM_NRORG_TRAB') : '' @"
                },
                {
                    "name": "P_IDATIVO",
                    "operator": "=",
                    "value": "S"
                }
            ];
            fieldTurno.readOnly = true;
            fieldTurno.reload();
        }
    };

    this.validaDtInicialCompetencia = function(dtIniEscala) {
        var dtCompetencia = getLocalVar('HCM_DTCOMPETENCIA_OPER');
        if(dtIniEscala.substring(3) === dtCompetencia.substring(3)){
            return true;
        } else {
            ScreenService.showMessage("Data inicial deve estar no mês da competencia", 'ERROR');
            return false;
        }
    };

    this.salvarAlteEscala = function(args, ESocialController, verificaEnvioEsocialDescentralizado = true) {
        var widget = templateManager.container.getActiveWidget();
        var tipovinculo = '';
        if(!Util.isEmptyOrBlank(widget.currentRow.NRTIPOVINCULOM)){
            tipovinculo = widget.currentRow.NRTIPOVINCULOM;
        }else{
            tipovinculo = templateManager.container.getWidget('vinculo') ? templateManager.container.getWidget('vinculo').currentRow.NRTIPOVINCULOM : null;
        }
        if (widget.isValid()) {
            if(verificaEnvioEsocialDescentralizado){
                if(tipovinculo == 1){
                    ESocialController.envioEsocialDescentralizado(widget.currentRow, 'S-2206', widget.currentRow.NRVINCULOM, widget.currentRow.NRVINCULOM, self.salvarAlteEscala, args);
                }else{
                    ESocialController.envioEsocialDescentralizado(widget.currentRow, 'S-2306', widget.currentRow.NRVINCULOM, widget.currentRow.NRVINCULOM, self.salvarAlteEscala, args);
                }
            }else{
                widget.currentRow.DTINIESCALA = widget.currentRow.DTINIESCALA.substring(0,10);
                if (widget.currentRow.DTFIMESCALA !== null)
                   widget.currentRow.DTFIMESCALA = widget.currentRow.DTFIMESCALA.substring(0,10);
                    if(ABUtilController.validaDtIniMenorIgualDtFin(widget.currentRow.DTINIESCALA,widget.currentRow.DTFIMESCALA)) {
                        if (!widget.backupRow) {
                            widget.currentRow.__is_new = true;
                        } else {
                            widget.currentRow.__is_new = false;
                        }
                        restEngine.post('product#/setAlteescala', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                            then(function (data) {
                                if (!Util.isUndefined(data.notifications) && data.notifications[0].type === "success") {
                                    ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                                    if(data.dataset && data.dataset.retornoEsocial && data.dataset.retornoEsocial.length > 0){
                                        var mensagem = 'S-2206/S-2306: ';
                                        data.dataset.retornoEsocial.forEach(function(retorno){
                                            mensagem += retorno.MSG + '<br>';
                                        });
                                        ScreenService.showMessage(mensagem);
                                    }
                                    if (widget.currentRow.__is_new) {
                                        ABUtilController.masterDetailVoltarList(widget);
                                        widget.reload();
                                    } else {
                                        ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                                        widget.backupRow = null;
                                        widget.view();
                                    }
                                } else if (!Util.isUndefined(data.messages)) {
                                    ScreenService.showMessage(data.messages[0].message, data.messages[0].type);
                                } else {
                                    ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                                }
                            }).
                            catch(function (e) {
                                var error;
                                if (e.data.error === undefined)
                                    error = e;
                                else
                                    error = e.data.error;
                                    
                                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                            });
                }else{
                    ScreenService.showMessage(Messages.DTINI_POST_DTFIM_ERROR);
                }
            }
        }
    };

    this.deleteAlteEscala = function(args) {
        ScreenService.confirmMessage(Messages.DELETE_ROW, 'CONFIRMATION', function(){
            var widget = templateManager.container.getActiveWidget();
            if (widget.isValid()) {
                widget.currentRow.__is_new = false;
                restEngine.post('product#/deleteAlteescala', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                    then(function (data) {
                        if (data.notifications[0].type === "success") {
                            ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                            ABUtilController.masterDetailVoltarList(widget);
                            widget.reload();
                        } else {
                            ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                        }
                        
                        ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    }).
                    catch(function(e) {
                        var error;
                        if(e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;
    
                        ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    });
            }
        });
    };
    
    this.geraEscala = function(args) {
        var widget = ABUtilController.checkWidget(args);
        var widgetMain = templateManager.container.getWidget('alteEscalaTrabalho');
        var nrestrutlegal = widget.getField('LIST_NRESTRUTLEGAL').dataSource.getCheckedRows().length;
        var nrestrutgeren = widget.getField('LIST_NRESTRUTGEREN').dataSource.getCheckedRows().length;
        var nrvinculo = widget.getField('NRVINCULOM_LIST').dataSource.getCheckedRows().length;
        var nrtipovinculo = widget.getField('NMTIPOVINCULOH').dataSource.getCheckedRows().length;
        if (widget.isValid()) {
            if (nrtipovinculo !== 0 && nrvinculo == 0){
                ScreenService.showMessage('Favor informar os vínculos para as escalas a serem contemplados na rotina.', 'WARNING');
            } else if(nrestrutlegal == 0 && nrestrutgeren == 0 && nrvinculo == 0){
                ScreenService.showMessage('Favor informar um filtro para as escalas a serem contemplados na rotina.', 'WARNING');
            } else {
            ScreenService.confirmMessage('Deseja realmente gerar a Escala?', 'CONFIRMATION', 
                function(){
                    if(ABUtilController.validaDtIniMenorIgualDtFin(widget.currentRow.DTINIESCALA,widget.currentRow.DTFIMESCALA)) {
                        if (this.validaDtInicialCompetencia(widget.currentRow.DTINIESCALA)) {
                            widget.currentRow.__is_new = true;
                            restEngine.post("product#/geraEscala",{'requestType':'DataSet','dataset':[ZhUtil.clearRow(widget.currentRow)]})
                                .then(function(data) {
                                    if(data.messages[0].type === "M"){
                                        ScreenService.showMessage(data.messages[0].message, data.messages[0].type);
                                        ScreenService.closePopup();
                                        widget.reload();
                                    }else if(data.messages[0].type === "W"){
                                        ScreenService.showMessage(data.messages[0].message, data.messages[0].type);
                                        ScreenService.closePopup();
                                        widget.reload();
                                    }
                                    if (data.dataset && data.dataset.geraEscala) {
                                        var popUp = templateManager.container.getWidget("mensagens");
                                        popUp.dataSource.data = data.dataset.geraEscala;
                                        ABUtilController.masterDetailOpenPopup(popUp);
                                    }
                                    widgetMain.reload();
                                }.bind(this)).catch(function(e) {
                                    var error;
                                    if(e.data.error === undefined)
                                        error = e;
                                    else 
                                        error = e.data.error;
                                    
                                    ScreenService.showMessage('Ocorreu um erro inesperado, contate o administrador informando o trecho abaixo: <br><br>' + error + '<br><br>', 'ERROR');
                                });
                           }
                        }
                    }.bind(this)
                );
            }
        }
    };
    
    this.escalaExclusiva = function (args){
        var widget = ABUtilController.checkWidget(args);
        if (widget.currentRow.ESCALAEXLUSIVA == "Y") 
            widget.getField('DTFIMESCALA').validations = {"required": true};
        else
            widget.getField('DTFIMESCALA').validations = {};
    };
    
    this.setFiltroVinculo = function(args) {
        var widget = ABUtilController.checkWidget(args);
        var index = ABUtilController.retornaFiltro(widget.getField('NRVINCULOM_LIST').dataSourceFilter, "NRTIPOVINCULOM");
        if(widget.currentRow.NMTIPOVINCULOH) {
            if(index === false){
                widget.getField('NRVINCULOM_LIST').dataSourceFilter.push(
                    {
                        "name": "NRTIPOVINCULOM",
                        "operator": "=", 
                        "value": widget.currentRow.NRTIPOVINCULOM
                    });
            } else {
                widget.getField('NRVINCULOM_LIST').dataSourceFilter[index] = {
                                                "name": "NRTIPOVINCULOM",
                                                "operator": "=", 
                                                "value": widget.currentRow.NRTIPOVINCULOM
                                            };
            }
        } else {
            widget.getField('NRVINCULOM_LIST').dataSourceFilter.splice(index, 1);
        }
        widget.getField('NRVINCULOM_LIST').reload();
    };

    /**
     * Verifica se há históricos posteriores ao vínculo editado, se houver este indaga ao operador se quer atualiza-los também
     */
    this.verificaHistoricoPosterior = function($nrvinculom, $dtmescompetenc, eSocialMessage) {
        var info = [$nrvinculom, $dtmescompetenc];
        var msg;
        
        /*Função: Atualiza os históricos posteriores do vínculo*/
        var atualizaHistoricos = function(historicos, dados) {
            var infos = [historicos, dados];
            restEngine.post('product#/setVinculoHistoricoPosterior', {'requestType': 'DataSet', 'dataset': [infos]})
                .then(function(response) {
                    if(response.messages) {
                        if(response.messages[0].message.length > 0) {
                            msg = 'Competência(s) alteradas:<br>' + response.messages[0].message.join(",<br>");
                            ScreenService.showMessage(msg, response.messages[0].type);
                        } else {
                            ScreenService.showMessage("Nenhuma competência foi alterada.");
                        }
                    }
                }).catch(function(e) {
                    var error;
                    if(e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
        };
        
        /*Função: Verifica se há históricos para atualizar e lança mensagem na tela*/
        var verificaHistoricos = function(response) {
            if(response.dataset.historicos.length > 0) {
                ScreenService.showCustomDialog(
                    'Vínculo possui históricos posteriores à esta competência. Deseja atualizar esses históricos?',
                    'CONFIRMATION',
                    null,
                    [
                        {
                            label: ScreenService.i18n("Sim"),
                            code: function (e, deferred) {
                                atualizaHistoricos(response.dataset.historicos, info);
                                deferred.reject(e);
                            }.bind(this)
                        },
                        {
                            label: ScreenService.i18n("Não"),
                            code: function (e, deferred) {
                                deferred.resolve(e);
                            }.bind(this)
                        }
                    ]);
            }
        };
        
        /*Requisição ao backend para consultar possíveis históricos*/
        var consultaHistoricos = function() {
            restEngine.post('product#/getVinculoHistoricoPosterior', {'requestType': 'DataSet', 'dataset': [info]})
                    .then(verificaHistoricos);
        };
        
        /*Exibe as mensagens do eSocial (se houver) e aciona a rotina de verificação de existência de históricos posteriores*/
        if(eSocialMessage != null)
            ScreenService.showMessage(eSocialMessage).then(consultaHistoricos);
        else
            consultaHistoricos();
            
    };
    
}

Configuration(function(ContextRegister) {
    ContextRegister.register('AlteEscalaController', AlteEscalaController);
});

// FILE: assets/js/controllers/AlteEstabilidadeController.js
/**
 * Created by felipesantos on 02/12/2016.
 */
function AlteEstabilidadeController (ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, ABUtilController, Messages) {
    
    this.camposData = ['DTINIESTABVINC', 'DTFIMESTABVINC'];

    this.salvarAlteEstabilidade = function(args) {
        var widget = templateManager.container.getActiveWidget();
        if (widget.isValid()) {
            if(ABUtilController.validaDtIniMenorIgualDtFin(widget.currentRow.DTINIESTABVINC,widget.currentRow.DTFIMESTABVINC)) {
                if (!widget.backupRow) {
                    widget.currentRow.__is_new = true;
                } else {
                    widget.currentRow.__is_new = false;
                }
                restEngine.post('product#/setAltestabvinc', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                    then(function (data) {
                        if (!Util.isUndefined(data.notifications) && data.notifications[0].type === "success") {
                            ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                            if (data.notifications.length > 1) {
                                data.notifications.shift();
                                data.notifications.forEach(function (notification) {
                                    ScreenService.notificationMessage(notification.message, 10000);
                                });
                            }
                            if (!Util.isUndefined(data.messages)) {
                                ScreenService.showMessage(data.messages[0].message, data.messages[0].type);
                            }
                            if (widget.currentRow.__is_new) {
                                ABUtilController.masterDetailVoltarList(widget);
                                widget.reload();
                            } else {
                                ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                                widget.backupRow = null;
                                widget.view();
                            }
                        } else if (!Util.isUndefined(data.messages)) {
                            ScreenService.showMessage(data.messages[0].message, data.messages[0].type);
                        } else {
                            ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                        }
                    }).
                    catch(function (e) {
                        var error;
                        if (e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;

                        ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    });
            }else{
                ScreenService.showMessage(Messages.DTINI_POST_DTFIM_ERROR);
            }
        }
    };

    this.deleteAlteEstabilidade = function(args) {
        var widget = templateManager.container.getActiveWidget();
        if (widget.isValid()) {
            widget.currentRow.__is_new = false;
            
            ScreenService.confirmMessage(Messages.DELETE_ROW, 'CONFIRMATION', function(){
            
                restEngine.post('product#/deleteAltestabvinc', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                    then(function (data) {
                        if (data.notifications[0].type === "success") {
                            ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                            ABUtilController.masterDetailVoltarList(widget);
                            widget.reload();
                        } else {
                            ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                        }
                    }).
                    catch(function(e) {
                        var error;
                        if(e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;
    
                        ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    });
                
            }.bind(this));
        }
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('AlteEstabilidadeController', AlteEstabilidadeController);
});

// FILE: assets/js/controllers/AlteOcupacaoController.js
/**
 * Created by felipesantos on 08/11/2016.
 */
 /* jshint esversion: 6 */
function AlteOcupacaoController (ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, ABUtilController, Messages) {
    
    this.camposData = ['DTINIOCUPACAO', 'DTFIMOCUPACAO'];
    var self = this;
    
    this.setMinDateDataFim = function(args){
        var widget = ABUtilController.checkWidget(args);
        widget.getField('DTFIMOCUPACAO').minDate = widget.currentRow.DTINIOCUPACAO;
        widget.currentRow.DTFIMOCUPACAO = null;
    };

    // this.setDataSourceFilters = function(args){
    //     var widgetAlteOcupacao = ABUtilController.checkWidget(args);
    //     ABUtilController.getConditionNrorgTrabPadrao(widgetAlteOcupacao.getField('NMMOTIVOOCUPA'));
    //     ABUtilController.getConditionNrorgTrabPadrao(widgetAlteOcupacao.getField('NMTPMODALIDSAL'));
    // };

    this.validaDtInicialCompetencia = function(dtIniOcupacao) {
        var dtCompetencia = getLocalVar('HCM_DTCOMPETENCIA_OPER');
        if(dtIniOcupacao.substring(3) === dtCompetencia.substring(3)){
            return true;
        } else {
            ScreenService.alertNotification(Messages.DATAINI_MES_COMPETENC_ERROR, 10000);
            return false;
        }
    };
    
    this.ajustaFiltroNmvinculo = function(){
        var widget = templateManager.container.getActiveWidget();
        if (widget.currentRow.P_RESCISAO == 'R') {
                widget.getField('NMVINCULOM').dataSource.name = '/getVinculosRescindidosGeral';
                widget.getField('NMVINCULOM').dataSourceFilter = [];
            }else if (widget.currentRow.P_RESCISAO == 'T') {
                widget.getField('NMVINCULOM').dataSource.name = '/getVinculoAtivosRescindidos';
                widget.getField('NMVINCULOM').dataSourceFilter = [];
            }else {
                widget.getField('NMVINCULOM').dataSource.name = '/getVinculosAtivosCompetencia';
                widget.getField('NMVINCULOM').dataSourceFilter = [];
            }
        widget.getField('NMVINCULOM').reload();
       
    };
    
    this.ajustaFiltroNmvinculoAdicionar = function(){
        var widget = templateManager.container.getActiveWidget();
        widget.getField('NMVINCULOM').dataSource.name = '/getVinculosAtivosCompetencia';
        widget.getField('NMVINCULOM').dataSourceFilter = [];
        widget.getField('NMVINCULOM').reload();
    };
    
    this.salvarAlteOcupacao = function(args, ESocialController, verificaEnvioEsocialDescentralizado = true) {
        var widget = templateManager.container.getActiveWidget();
        var tipovinculo = '';
        var mensagem = null;
        if(!Util.isEmptyOrBlank(widget.currentRow.NRTIPOVINCULOM)){
            tipovinculo = widget.currentRow.NRTIPOVINCULOM;
        }else{
            tipovinculo = templateManager.container.getWidget('vinculo') ? templateManager.container.getWidget('vinculo').currentRow.NRTIPOVINCULOM : null;
        }
        if (widget.isValid()) {
            if(verificaEnvioEsocialDescentralizado){
                if(tipovinculo == 1){
                    ESocialController.envioEsocialDescentralizado(widget.currentRow, 'S-2206', widget.currentRow.NRVINCULOM, widget.currentRow.NRVINCULOM, self.salvarAlteOcupacao, args);
                }else{
                    ESocialController.envioEsocialDescentralizado(widget.currentRow, 'S-2306', widget.currentRow.NRVINCULOM, widget.currentRow.NRVINCULOM, self.salvarAlteOcupacao, args);
                } 
            }else{
                if(ABUtilController.validaDtIniMenorIgualDtFin(widget.currentRow.DTINIOCUPACAO,widget.currentRow.DTFIMOCUPACAO)) {
                    if (!widget.backupRow) {
                        widget.currentRow.__is_new = true;
                    } else {
                        widget.currentRow.__is_new = false;
                    }
                    restEngine.post('product#/setAlteocupacao', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                        then(function (data) {
                            if (!Util.isUndefined(data.notifications) && data.notifications[0].type === "success") {
                                ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                                if(data.dataset && data.dataset.retornoEsocial && data.dataset.retornoEsocial.length > 0){
                                    /*var*/ mensagem = 'S-2206/S-2306: ';
                                    data.dataset.retornoEsocial.forEach(function(retorno){
                                        mensagem += retorno.MSG + '<br>';
                                    });
                                    //ScreenService.showMessage(mensagem);
                                }
                                if (widget.currentRow.__is_new) {
                                    ABUtilController.masterDetailVoltarList(widget);
                                    widget.reload();
                                } else {
                                    ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                                    widget.backupRow = null;
                                    widget.view();
                                }
                            } else if (!Util.isUndefined(data.messages)) {
                                ScreenService.showMessage(data.messages[0].message, data.messages[0].type);
                            } else {
                                ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                            }
                            self.verificaHistoricoPosterior(widget.currentRow.NRVINCULOM, getLocalVar('HCM_DTCOMPETENCIA_OPER'), mensagem);
                        }).
                        catch(function (e) {
                            var error;
                            if (e.data.error === undefined)
                                error = e;
                            else
                                error = e.data.error;
    
                            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                        });
                }else{
                    ScreenService.showMessage(Messages.DTINI_POST_DTFIM_ERROR);
                }
            }
        }
    };

    this.deleteAlteOcupacao = function(args) {
        var widget = templateManager.container.getActiveWidget();
        ScreenService.confirmMessage(Messages.DELETE_ROW, 'CONFIRMATION', function(){
            if (widget.isValid()) {
                widget.currentRow.__is_new = false;
                restEngine.post('product#/deleteAlteocupacao', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                    then(function (data) {
                        if (data.notifications[0].type === "success") {
                            ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                            ABUtilController.masterDetailVoltarList(widget);
                            widget.reload();
                            self.verificaHistoricoPosterior(widget.currentRow.NRVINCULOM, getLocalVar('HCM_DTCOMPETENCIA_OPER'));
                        } else {
                            ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                        }
                    }).
                    catch(function(e) {
                        var error;
                        if(e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;
    
                        ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    });
            }
        }.bind(this));
    };
    
    this.descAtividadesOnChange = function(){
        var widget = templateManager.container.getActiveWidget();
        if(widget.currentRow.DSATIVIDADESCARGO == null || widget.currentRow.DSATIVIDADESCARGO == ""){
            widget.getField('DSATIVIDADESCARGO').setValue(widget.currentRow.DSSUMARIA);
        }
    };
    
    this.openWidgetFilha = function(args){
        var widget = ABUtilController.checkWidget(args);
        ScreenService.confirmMessage("Deseja ser redirecionado para tela de Ocupação?", null, function () {
            var url = new URL(window.location.href.split('hcm00046_gpe_alteOcupacao')[0] + 'hcm00042_gpe_ocupacao');
            url.searchParams.set('value', widget.currentRow.NROCUPACAOM);
            window.open(url, '_blank');
        }, null);
    };
    
    /**
     * Verifica se há históricos posteriores ao vínculo editado, se houver este indaga ao operador se quer atualiza-los também
     */
    this.verificaHistoricoPosterior = function($nrvinculom, $dtmescompetenc, eSocialMessage) {
        var info = [$nrvinculom, $dtmescompetenc];
        var msg;
        
        /*Função: Atualiza os históricos posteriores do vínculo*/
        var atualizaHistoricos = function(historicos, dados) {
            var infos = [historicos, dados];
            restEngine.post('product#/setVinculoHistoricoPosterior', {'requestType': 'DataSet', 'dataset': [infos]})
                .then(function(response) {
                    if(response.messages) {
                        if(response.messages[0].message.length > 0) {
                            msg = 'Competência(s) alteradas:<br>' + response.messages[0].message.join(",<br>");
                            ScreenService.showMessage(msg, response.messages[0].type);
                        } else {
                            ScreenService.showMessage("Nenhuma competência foi alterada.");
                        }
                    }
                }).catch(function(e) {
                    var error;
                    if(e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
        };
        
        /*Função: Verifica se há históricos para atualizar e lança mensagem na tela*/
        var verificaHistoricos = function(response) {
            if(response.dataset.historicos.length > 0) {
                ScreenService.showCustomDialog(
                    'Vínculo possui históricos posteriores à esta competência. Deseja atualizar esses históricos?',
                    'CONFIRMATION',
                    null,
                    [
                        {
                            label: ScreenService.i18n("Sim"),
                            code: function (e, deferred) {
                                atualizaHistoricos(response.dataset.historicos, info);
                                deferred.reject(e);
                            }.bind(this)
                        },
                        {
                            label: ScreenService.i18n("Não"),
                            code: function (e, deferred) {
                                deferred.resolve(e);
                            }.bind(this)
                        }
                    ]);
            }
        };
        
        /*Requisição ao backend para consultar possíveis históricos*/
        var consultaHistoricos = function() {
            restEngine.post('product#/getVinculoHistoricoPosterior', {'requestType': 'DataSet', 'dataset': [info]})
                    .then(verificaHistoricos);
        };
        
        /*Exibe as mensagens do eSocial (se houver) e aciona a rotina de verificação de existência de históricos posteriores*/
        if(eSocialMessage != null)
            ScreenService.showMessage(eSocialMessage).then(consultaHistoricos);
        else
            consultaHistoricos();
            
    };
}


Configuration(function(ContextRegister) {
    ContextRegister.register('AlteOcupacaoController', AlteOcupacaoController);
});

// FILE: assets/js/controllers/AlteSalarioController.js
/**
 * Created by felipesantos on 10/11/2016.
 */
 /* jshint esversion: 6 */
function AlteSalarioController (ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, ABUtilController, Messages, General, $window) {
    
    this.camposData = ['DTALTESALARIO', 'DTBASEDISSIDIO'];
    var self = this;
    
    this.openPopupImportacoes = function(widget, action) {
        this.NMIMPORTACAO = action;
        var widgetPopupImportacao = templateManager.container.getWidget('popupImportacao');
        widgetPopupImportacao.currentRow.DSPATH = [];
        ScreenService.openPopup(widgetPopupImportacao);
    };
    
    this.geraPlanilhaTemplate = function() {
    restEngine.post('product#/baixarPlanilhaSalarial', {
        'requestType': 'DataSet',
        'dataset': []
        }).then(function(data) {
            ScreenService.closePopup();
            if(data.dataset && data.dataset.arquivo){
                $window.open($window.serviceUrl + "/abrirArquivo?requestType=DataSet&dataset[0][CMARQUIVO]=" + data.dataset.arquivo.NMARQUIVO);
            }
        }).catch(function(e) {
            var error;
            if (e.data.error === undefined)
                error = e;
            else
                error = e.data.error;
            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
        });
            
    };
    
     this.importarPlanilhaSalarial = function() {
        var widgetPop = templateManager.container.getActiveWidget();
        var widgetPai = templateManager.container.getWidget('alteSalario');
        if(widgetPop.isValid()){
            if(this.validaArquivo(widgetPop.currentRow.DSPATH[0].name)) {
                restEngine.post('product#/importarPlanilhaSalarial', {'requestType': 'DataSet', 'dataset': [widgetPop.currentRow]}).
                then(function(data) {
                    if (data.messages) {
                        ScreenService.closePopup(true);
                        ScreenService.showMessage(data.messages[0].message, data.messages[0].type);
                        if (data.dataset && data.dataset.msg) {
                            openPopupMensagens(data.dataset.msg);
                        } else {
                            widgetPai.activate();
                        }
                        widgetPai.reload();
                    } else
                        ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                }).
                catch(function(e) {   
                    var error;
                    if (e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    
                });
            }
        }
    };
    
    this.validaArquivo = function(filePath) {
        var extension = filePath.split('.').pop().toUpperCase();
        if (extension !== 'XLS' && extension !== 'XLSX') {
            ScreenService.showMessage('Formato de arquivo inválido');
            return false;
        } else {
            return true;
        }
    };
    
    var openPopupMensagens = function(msg) {
        var widgetMensagens = templateManager.container.getWidget('mensagensImportaSalarial');
        widgetMensagens.dataSource.data = msg;
        ScreenService.openPopup(widgetMensagens);
    };

    this.popupImportacaoPlanilhaVoltar = function() {
        ScreenService.closePopup();
        templateManager.container.getWidget('alteSalario').activate();
    };
    
    this.validaDtAlteracaoCompetencia = function(dtAlteSalario) {
        var dtCompetencia = getLocalVar('HCM_DTCOMPETENCIA_OPER');
        if(dtAlteSalario.substring(3) === dtCompetencia.substring(3)){
            return true;
        } else {
            ScreenService.alertNotification('Data de alteração deve estar no mês de competência!', 10000);
            return false;
        }
    };
    
    this.defaultValues = function(args){
        var widget = ABUtilController.checkWidget(args);
        widget.currentRow.DTALTESALARIO = getLocalVar('HCM_DTCOMPETENCIA_OPER'); 
        widget.currentRow.NROCORRENCIA = 1;
        widget.currentRow.DSOBSERVACAO = '';
    };
    
    this.defaultModalidade = function(args){
        var widget = ABUtilController.checkWidget(args);
        widget.currentRow.NRTPMODALIDSAL = 1;
        widget.currentRow.NMTPMODALIDSAL = 'Efetivo';
        // widget.getField('NMTPMODALIDSAL').reload().then(function(response){
            // var data = response.dataset.fpa_tpmodalidsal.filter(function(r){return r.NRTPMODALIDSAL === 1;});
            // widget.currentRow.NRTPMODALIDSAL = 1;
            // widget.currentRow.NMTPMODALIDSAL = data[0].NMTPMODALIDSAL;
        // });
    };
    
    this.valorMenorSalarioMinimo = function(){
        var widget = templateManager.container.getActiveWidget();
        
        if(!Util.isEmptyOrBlank(widget.currentRow.VRSALARIO)){    
            var salariominimo = getLocalVar('HCM_SALARIO_MINIMO');
            var salario = widget.currentRow.VRSALARIO.replace('.','').replace(',', '.');
            if(parseFloat(salario) < parseFloat(1.5*salariominimo)){
                ScreenService.showMessage('O valor de salário informado é menor que o valor do Salário Mínimo');
            }
        }
    };

    this.salvarAlteSalario = function(args, ESocialController, verificaEnvioEsocialDescentralizado = true) {
        var widget = templateManager.container.getActiveWidget();
        var tipovinculo = '';
        if(!Util.isEmptyOrBlank(widget.currentRow.NRTIPOVINCULOM)){
            tipovinculo = widget.currentRow.NRTIPOVINCULOM;
        }else{
            tipovinculo = templateManager.container.getWidget('vinculo') ? templateManager.container.getWidget('vinculo').currentRow.NRTIPOVINCULOM : null;
        }
        
        if (widget.isValid()) {
            if(verificaEnvioEsocialDescentralizado){
                if(tipovinculo == 1){
                    ESocialController.envioEsocialDescentralizado(widget.currentRow, 'S-2206', widget.currentRow.NRVINCULOM, widget.currentRow.NRVINCULOM, self.salvarAlteSalario, args);
                }else{
                    ESocialController.envioEsocialDescentralizado(widget.currentRow, 'S-2306', widget.currentRow.NRVINCULOM, widget.currentRow.NRVINCULOM, self.salvarAlteSalario, args);
                }
            }else{
                if (self.validaDtAlteracaoCompetencia(widget.currentRow.DTALTESALARIO)) {
                    if (!widget.backupRow) {
                        widget.currentRow.__is_new = true;
                    } else {
                        widget.currentRow.__is_new = false;
                    }
                    widget.currentRow.VRSALARIO = General.valueToFloat(widget.currentRow.VRSALARIO);
                    widget.currentRow.VRSALARIOHR = General.valueToFloat(widget.currentRow.VRSALARIOHR);
                    widget.currentRow.VRDIFERENCAREAL = General.valueToFloat(widget.currentRow.VRDIFERENCAREAL);
                    widget.currentRow.VRPERCALTERA = General.valueToFloat(widget.currentRow.VRPERCALTERA);
                    widget.currentRow.VRPERCREAL = General.valueToFloat(widget.currentRow.VRPERCREAL);
                    restEngine.post('product#/setAltesalario', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                        then(function (data) {
                            if (!Util.isUndefined(data.notifications) && data.notifications[0].type === "success") {
                                ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                                if(data.dataset && data.dataset.retornoEsocial && data.dataset.retornoEsocial.length > 0){
                                    var mensagem = 'S-2206/S-2306: ';
                                    data.dataset.retornoEsocial.forEach(function(retorno){
                                        mensagem += retorno.MSG + '<br>';
                                    });
                                    ScreenService.showMessage(mensagem);
                                }
                                if (!Util.isUndefined(data.messages)) {
                                    ScreenService.showMessage(data.messages[0].message,data.messages[0].type);
                                }
                                if (widget.currentRow.__is_new) {
                                    ABUtilController.masterDetailVoltarList(widget);
                                    widget.reload();
                                } else {
                                    ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                                    widget.backupRow = null;
                                    widget.view();
                                }
                            } else if (!Util.isUndefined(data.messages)) {
                                ScreenService.showMessage(data.messages[0].message, data.messages[0].type);
                            } else {
                                ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                                
                            }
                        }).
                        catch(function (e) {
                            var error;
                            if (e.data.error === undefined)
                                error = e;
                            else
                                error = e.data.error;
    
                            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                        });
                }
            }
        }
    };

    this.deleteAlteSalario = function(args) {
        var widget = templateManager.container.getActiveWidget();
        widget.currentRow.__is_new = false;

        ScreenService.confirmMessage(Messages.DELETE_ROW, 'CONFIRMATION', function(){

            restEngine.post('product#/deleteAltesalario', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                then(function (data) {
                    if (data.notifications[0].type === "success") {
                        ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    } else {
                        ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                    }
                }).
                catch(function(e) {
                    var error;
                    if(e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;

                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });

        }.bind(this));
    };
    
    this.reajustarSalarios = function(args){
        var widget = ABUtilController.checkWidget(args);
        var rows = [];
        if (widget.isValid()) {
            ScreenService.confirmMessage("Deseja Reajustar o salário dos vínculos selecionados?", 'CONFIRMATION', function(){
            widget.parent.parent.dataSource.checkedRows.forEach(function(row){
                var currentRow = Object.assign({}, widget.currentRow);
                currentRow.NRVINCULOM = row.NRVINCULOM;
                currentRow.VRSALARIO = row.VRSUGERIDO;
                currentRow.NRORG = row.NRORG;
                currentRow.VRDIFERENCAREAL = '';
                currentRow.VRPERCALTERA = '';
                currentRow.VRPERCREAL = '';
                
                currentRow.__is_new = true;
                rows.push(currentRow);
            });
            
            
            restEngine.post('product#/setAltesalario', {'requestType': 'DataSet', 'dataset': rows}).
                then(function (data) {
                    if (!Util.isUndefined(data.notifications) && data.notifications[0].type === "success") {
                        ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                        if (!Util.isUndefined(data.messages)) {
                            ScreenService.showMessage(data.messages[0].message,data.messages[0].type);
                        }
                        ABUtilController.masterDetailClosePopup(widget);
                        templateManager.container.getWidget("salarioDivergente").reload();
                    } else if (!Util.isUndefined(data.messages)) {
                        ScreenService.showMessage(data.messages[0].message, data.messages[0].type);
                    } else {
                        ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                        
                    }
                }).
                catch(function (e) {
                    var error;
                    if (e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;

                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
            }.bind(this));
        }
    };
  
    this.salarioHoraVinculo = function() {
        var widget = templateManager.container.getWidget('alteSalario');
        var getSalarioHora = () => {
            return this.getSalarioHora();
        };
        
        if (widget.currentRow.NRVINCULOM !== "") {
            var getQthrsemesctrabh = function() {
                var widget = templateManager.container.getWidget('alteSalario');
                
                restEngine.post('product#/getHorasSemanais', {'requestType': 'DataSet', 'dataset': [widget.currentRow]})
                .then(function (data) {
                    if (data.dataset) {
                        widget.currentRow.QTHRSEMESCTRABH = data.dataset.quantidadeHoras[0];
                    }
                    getSalarioHora();
                })
                .catch(function(e) {
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(e.data.error), 'ERROR');
               });
            };
        
            restEngine.post('product#/getNrEscalaVinculo', {'requestType': 'DataSet', 'dataset': [widget.currentRow]})
            .then(function (data) {
                if (data.dataset) {
                    widget.currentRow.NRESCALATRABM = data.dataset.escalaVinculo[0];
                    getQthrsemesctrabh();
                }
            })
            .catch(function(e) {
                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(e.data.error), 'ERROR');
            });
        }
    };
    
    this.getSalarioHora = function() {
        var row = templateManager.container.getWidget('alteSalario').currentRow;
        var jornadaSemanal = row.QTHRSEMESCTRABH;
      
        if (row.DSTIPOSALARIO === "HORA") {
            row.VRSALARIOHR = row.VRSALARIO.replace(/[.]/g, '').replace(/[,]/, '.') / (jornadaSemanal * 5);
        }
    };
  
    this.getHorasSemanaisVinculo = function() {
        var widget = templateManager.container.getWidget('alteSalario');
      
        for (var i in widget.dataSource.data ) {
            if (widget.dataSource.data[i].NRVINCULOM === widget.currentRow.NRVINCULOM) {
                widget.currentRow.QTHRSEMESCTRABH = widget.dataSource.data[i].QTHRSEMESCTRABH;
            }
        }
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('AlteSalarioController', AlteSalarioController);
});

// FILE: assets/js/controllers/AlteSituacaoFuncionalController.js
/**
 * Created by felipesantos on 10/11/2016.
 */
 /* jshint esversion: 6 */
function AlteSituacaoFuncionalController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, ABUtilController, Messages, HcmConsts) {

    var self = this;
    
    this.camposData = ['DTINISITUFUNC', 'DTFIMSITUFUNC', 'DTESTABSITUFUNC', 'DTVERIFSITUFUNC', 'DTPREVIRETOSITU', 'DTPRORRSITUFUNC'];

    this.objActions = {
        'exclusao_automatica': {
            'name': 'exclusao_automatica',
            'label': 'Exclusão Automática',
            'route': '/exclusaoAutoAlteSitufunc',
            'confirm': 'Deseja excluir a situação funcional para todos os vínculos filtrados?'
        },
        'cadastro_automatico': {
            'name': 'cadastro_automatico',
            'label': 'Cadastro Automático',
            'route': '/cadastroAutoAlteSitufunc',
            'confirm': 'Deseja cadastrar a situação funcional para todos os vínculos filtrados?'
        }
    };

    this.selectedAction = '';
    
    this.obrigaMotivo = function (args){
        var widget = ABUtilController.checkWidget(args);
        if(widget.currentRow.NRSITUFUNCM && widget.currentRow.NRSITUFUNCM === 13){
            widget.getField('NMMOTIVOAFASTA').validations = {};
            widget.getField('NMMOTIVOAFASTA').readOnly = true;
        }else{
            if (widget.currentRow.IDAFASTSITUFUNC && (widget.currentRow.IDAFASTSITUFUNC == 'S' || 
                widget.currentRow.NRSITUFUNCM == 12 || widget.currentRow.NRSITUFUNCM == 15 ||
                widget.currentRow.NRSITUFUNCM == 16 || widget.currentRow.NRSITUFUNCM == 100012)) {
                widget.getField('NMMOTIVOAFASTA').validations = {"required":{}};
                widget.getField('NMMOTIVOAFASTA').readOnly = false;
            } else {
                widget.getField('NMMOTIVOAFASTA').validations = {};
                widget.getField('NMMOTIVOAFASTA').readOnly = false;
            }
        }
        
        
        
    };
    
    this.obrigaQuantDias = function(args){
        var widget = templateManager.container.getActiveWidget();
        if(widget.currentRow.NRMOTIVOAFASTA && (widget.currentRow.NRMOTIVOAFASTA == 01 || widget.currentRow.NRMOTIVOAFASTA == 03 || widget.currentRow.NRMOTIVOAFASTA == 35)){
            
            widget.getField('NRQTDIASITUFUNC').validations = {'required': true};    
        }else{
            widget.getField('NRQTDIASITUFUNC').validations = {};
        }
    };
    
    this.validaMotivo = function (args){
        var widget = ABUtilController.checkWidget(args);
        /*Código eSocial do motivo de afastamento*/
        if(widget.name == 'popupCadExclAuto') {
            switch (widget.currentRow.CDESOCIAL) {
                case '01':
                    widget.getField('DSOBSALTSITFUNC').validations = {};
                    break;
                case '03':
                    widget.getField('DSOBSALTSITFUNC').validations = {};
                    break;
                case '21':
                    widget.getField('DSOBSALTSITFUNC').validations = {'required': {}};
                    break;
                default:
                    widget.getField('DSOBSALTSITFUNC').validations = {};
            }
        } else {
            switch (widget.currentRow.CDESOCIAL) {
                case '01':
                    widget.getField('NMDIAGNOST').validations = {};
                    widget.getField('NMPESSOA').validations = {};
                    widget.getField('DSOBSALTSITFUNC').validations = {};
                    break;
                case '03':
                    widget.getField('NMDIAGNOST').validations = {};
                    widget.getField('NMPESSOA').validations = {};
                    widget.getField('DSOBSALTSITFUNC').validations = {};
                    break;
                case '21':
                    widget.getField('NMDIAGNOST').validations = {};
                    widget.getField('NMPESSOA').validations = {};
                    widget.getField('DSOBSALTSITFUNC').validations = {'required': {}};
                    break;
                default:
                    widget.getField('NRQTDIASITUFUNC').validations = {};
                    widget.getField('NMDIAGNOST').validations = {};
                    widget.getField('NMPESSOA').validations = {};
                    widget.getField('DSOBSALTSITFUNC').validations = {};
            }
        }
    };
    
    this.verificaQtDiasAtestado = function(args){
        var widget = templateManager.container.getActiveWidget();
        if(!Util.isEmptyOrBlank(widget.currentRow.NRSITUFUNCM) && !Util.isEmptyOrBlank(widget.currentRow.QTDIASATESTADOEMPR)){
            if(Util.isEmptyOrBlank(widget.currentRow.QTDIASATESTADO)){
                widget.currentRow.QTDIASATESTADOEMPR = '';
                ScreenService.showMessage('Verifique se o  campo "Qt. Dias Atestado" dessa situação funcional está preenchido');
            }else if(widget.currentRow.QTDIASATESTADOEMPR > widget.currentRow.QTDIASATESTADO){
                widget.currentRow.QTDIASATESTADOEMPR = '';
                ScreenService.showMessage('A quatidade de dias de atestado da empresa não pode ultrapassar a quantidade de dias de atestado da situação funcional ('+widget.currentRow.QTDIASATESTADO+')');
            }
        }
    };
    
    this.atualizaPeriodoSituFunc = function(args) {
        var widget = ABUtilController.checkWidget(args);
        var dtinisitufunc = widget.getField('DTINISITUFUNC').value();
        var nrqtdiassitufunc = widget.getField('NRQTDIASITUFUNC').value();
        var dtfimsitufunc = widget.getField('DTFIMSITUFUNC').value();

        if (!ABUtilController.validaDtIniMenorIgualDtFin(dtinisitufunc, dtfimsitufunc)) {
            ScreenService.alertNotification(Messages.DTINI_POST_DTFIM_ERROR, 10000);
        } else {
            if (!Util.isEmptyOrBlank(dtinisitufunc) && !isNaN(nrqtdiassitufunc) && nrqtdiassitufunc > 0) {
                nrqtdiassitufunc--;
                var dtfim = moment(dtinisitufunc, 'DD/MM/YYYY').add(nrqtdiassitufunc, 'day').format('DD/MM/YYYY');
                widget.getField('DTFIMSITUFUNC').setValue(dtfim);
            } else if (!Util.isEmptyOrBlank(dtinisitufunc) && !Util.isEmptyOrBlank(dtfimsitufunc)) {
                nrqtdiassitufunc = moment(dtfimsitufunc, 'DD/MM/YYYY').diff(moment(dtinisitufunc, 'DD/MM/YYYY'), 'day') + 1;
                widget.getField('NRQTDIASITUFUNC').setValue(nrqtdiassitufunc);
            } else if (Util.isEmptyOrBlank(dtinisitufunc)){
                widget.currentRow.NRQTDIASITUFUNC = "";
                widget.currentRow.DTFIMSITUFUNC = "";
            }    
        }
    };

    this.atualizaQtdDiasSituFunc = function(args) {
        var widget = ABUtilController.checkWidget(args);
        var dtinisitufunc = widget.getField('DTINISITUFUNC').value();
        var dtfimsitufunc = widget.getField('DTFIMSITUFUNC').value();

        if (!ABUtilController.validaDtIniMenorIgualDtFin(dtinisitufunc, dtfimsitufunc)) {
            ScreenService.alertNotification(Messages.DTINI_POST_DTFIM_ERROR, 10000);
        } else {
            if (!Util.isEmptyOrBlank(dtinisitufunc) && !Util.isEmptyOrBlank(dtfimsitufunc)) {
                var nrqtdiassitufunc = moment(dtfimsitufunc, 'DD/MM/YYYY').diff(moment(dtinisitufunc, 'DD/MM/YYYY'), 'day') + 1;
                widget.getField('NRQTDIASITUFUNC').setValue(nrqtdiassitufunc);
            }
        }
    };

    this.validaDtAlteracaoCompetencia = function(dtInisitufunc) {
        var dtCompetencia = getLocalVar('HCM_DTCOMPETENCIA_OPER');
        if (dtInisitufunc.substring(3) === dtCompetencia.substring(3)) {
            return true;
        } else {
            ScreenService.alertNotification(Messages.DATAINI_MES_COMPETENC_ERROR, 10000);
            return false;
        }
    };


    this.salvarAlteSituFuncional = function(args, dtFimGozoFerias = null, saldo = null, nrgozoferias = null, nrferias = null) {
        var widget = templateManager.container.getActiveWidget();
        var mensagem = null;
        if (widget.isValid()) {
            widget.currentRow.DTINISITUFUNC = widget.currentRow.DTINISITUFUNC.substring(0, 10);
            if (!Util.isUndefined(dtFimGozoFerias) && dtFimGozoFerias !== null) {
                widget.currentRow.DTFIMGOZO = dtFimGozoFerias;
            }
            if (!Util.isUndefined(saldo) && saldo !== null) {
                widget.currentRow.SALDO = saldo;
            }
            if (!Util.isUndefined(nrgozoferias) && saldo !== null) {
                widget.currentRow.NRGOZOFERIAS = nrgozoferias;
            }
            if (!Util.isUndefined(nrferias) && saldo !== null) {
                widget.currentRow.NRFERIAS = nrferias;
            }
            if (ABUtilController.validaDtIniMenorIgualDtFin(widget.currentRow.DTINISITUFUNC, widget.currentRow.DTFIMSITUFUNC)) {
                if (!widget.backupRow) {
                    widget.currentRow.__is_new = true;
                } else {
                    widget.currentRow.__is_new = false;
                }
                
                var valida = true;
                if(widget.currentRow.__is_new == false){
                    if (widget.currentRow.NRVINCULOM != widget.backupRow.NRVINCULOM)  valida = false ;
                    if ( (widget.currentRow.DTINISITUFUNC  || "").substring(10, 0) != (widget.backupRow.DTINISITUFUNC  || "").substring(10, 0))  valida = false ;
                    if (widget.currentRow.NRQTDIASITUFUNC != widget.backupRow.NRQTDIASITUFUNC)  valida = false ;
                    if ( (widget.currentRow.DTFIMSITUFUNC  || "").substring(10, 0) != (widget.backupRow.DTFIMSITUFUNC  || "").substring(10, 0))  valida = false ;
                    if (widget.currentRow.NMMOTIVOAFASTA != widget.backupRow.NMMOTIVOAFASTA)  valida = false ;
                    if (widget.currentRow.NMPROXSITUFUNC != widget.backupRow.NMPROXSITUFUNC)  valida = false ;
                    if (widget.currentRow.NMDIAGNOST != widget.backupRow.NMDIAGNOST)  valida = false ;
                    if (widget.currentRow.NMPESSOA != widget.backupRow.NMPESSOA)  valida = false ;
                }
                
                widget.currentRow.VALIDA = valida;
                
            restEngine.post('product#/setAltesitufunc', {
                'requestType': 'DataSet',
                'dataset': [widget.currentRow]
            }).
            then(function(data) {
                if (!Util.isUndefined(data.notifications) && data.notifications[0].type === "success") {
                    if(data.dataset && data.dataset.retornoEsocial && data.dataset.retornoEsocial.length > 0){
                        /*var*/ mensagem = 'S-2230: ';
                        data.dataset.retornoEsocial.forEach(function(retorno){
                            mensagem += retorno.MSG + '<br>';
                        });
                        //ScreenService.showMessage(mensagem);
                    }
                    ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                    if (data.notifications.length > 1) {
                        data.notifications.shift();
                        data.notifications.forEach(function(notification) {
                            ScreenService.notificationMessage(notification.message, 10000);
                        });
                    }
                    if (!Util.isUndefined(data.messages)) {
                        ScreenService.showMessage(data.messages[0].message, data.messages[0].type);
                    }
                    if (widget.currentRow.__is_new) {
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    } else {
                        ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                        widget.backupRow = null;
                        widget.view();
                    }
                    self.verificaHistoricoPosterior(widget.currentRow.NRVINCULOM, getLocalVar('HCM_DTCOMPETENCIA_OPER'), mensagem);
                } else if (!Util.isUndefined(data.messages)) {
                    ScreenService.showMessage(data.messages[0].message, data.messages[0].type);
                } else {
                    ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                }
            }).
            catch(function(e) {
                var error;
                if (e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;

                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
                
                
            } else {
                ScreenService.showMessage(Messages.DTINI_POST_DTFIM_ERROR);
            }
        }
    };

    this.deleteAlteSituFuncional = function(args) {
        var widget = templateManager.container.getActiveWidget();
        widget.currentRow.__is_new = false;

        ScreenService.confirmMessage(Messages.DELETE_ROW, 'CONFIRMATION', function(){
        
            restEngine.post('product#/deleteAltesitufunc', {
                'requestType': 'DataSet',
                'dataset': [widget.currentRow]
            }).
            then(function(data) {
                if (data.notifications && data.notifications[0].type === "success") {
                    ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                    ABUtilController.masterDetailVoltarList(widget);
                    widget.reload();
                } else if (!Util.isUndefined(data.messages)) {
                    ScreenService.showMessage(data.messages[0].message, data.messages[0].type);
                } else {
                    ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                }
                
                self.verificaHistoricoPosterior(widget.currentRow.NRVINCULOM, getLocalVar('HCM_DTCOMPETENCIA_OPER'));
            }).
            catch(function(e) {
                var error;
                if (e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;

                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });

        }.bind(this));
    };

    this.openPopupCadExclAuto = function(action) {
        var widgetPopup = templateManager.container.getWidget('popupCadExclAuto');
        this.selectedAction = action.name;
        widgetPopup.label = this.objActions[action.name].label;
        if(action.name == 'cadastro_automatico') {
            widgetPopup.getField('NMMOTIVOAFASTA').isVisible = true;
        } else if(action.name == 'exclusao_automatica') {
            widgetPopup.getField('NMMOTIVOAFASTA').isVisible = false;
        }
        ABUtilController.masterDetailOpenPopup(widgetPopup);
    };

    this.confirmaCadExclAuto = function(widget) {
        if (widget.isValid()) {
            if (this.validaDtAlteracaoCompetencia(widget.currentRow.DTINISITUFUNC) && widget.currentRow.NRSITUFUNCM != HcmConsts.GpeSitufunc.SITUACAO_FUNCIONAL_ATESTADO) {
                ScreenService.showCustomDialog(this.objActions[this.selectedAction].confirm, 'CONFIRMATION', null, [{
                    label: ScreenService.i18n("Sim"),
                    code: function(e, deferred) {
                        this.executaCadExclAuto(widget);
                        deferred.resolve(e);
                        
                    }.bind(this)
                }, {
                    label: ScreenService.i18n("Não"),
                    code: function(e, deferred) {
                        deferred.reject(e);
                    }
                }]);
            }
        }
    };

    this.executaCadExclAuto = function(widget) {
        var action = this.selectedAction;
        restEngine.post(this.objActions[this.selectedAction].route, {
            'requestType': 'DataSet',
            'dataset': [widget.currentRow]
        }).
        then(function(data) {
            if (data.messages) {
                var textMessage = '';
                data.messages.forEach(function(objMsg) {
                    textMessage += '-' + objMsg.message + '<br>';
                });
                ScreenService.showMessage(textMessage);
            }

            if (data.notifications[0].type === "error") {
                if (action === 'exclusao_automatica') {
                    ScreenService.alertNotification(Messages.EXCLUSAO_AUTOMATICA_ERRO, 10000);
                } else if (action === 'cadastro_automatico') {
                    ScreenService.alertNotification(Messages.CADASTRO_AUTOMATICO_ERRO, 10000);
                }
            } else if ( data.notifications[0].type === "WARNING" ) {
                if (action === 'cadastro_automatico') {
                    // ScreenService.showMessage(data.notifications[0].message, 'ERROR');
                    var popUp = templateManager.container.getWidget('mensagens');
                    popUp.dataSource.data = data.dataset.msg;
                    ABUtilController.masterDetailOpenPopup(popUp);
                }
                
            } else {
                if (action === 'exclusao_automatica') {
                    ScreenService.successNotification(Messages.EXCLUSAO_AUTOMATICA_SUCCESS, 10000);
                } else if (action === 'cadastro_automatico') {
                    ScreenService.successNotification(Messages.CADASTRO_AUTOMATICO_SUCCESS, 10000);
                }
                ABUtilController.masterDetailClosePopup(widget);
                templateManager.container.getWidget('alteSitufunc').activate();
                templateManager.container.getWidget('alteSitufunc').reload();
            }
        }).
        catch(function(e) {
            var error;
            if (e.data.error === undefined)
                error = e;
            else
                error = e.data.error;

            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
        });
    };
    
    this.validaAtestadoFerias = function(args, ESocialController, verificaEnvioEsocialDescentralizado = false) {
        var widget = templateManager.container.getActiveWidget();
        //5 - Afastamento Licença Gestante 12 - atestado médico 15 - Afastamento doença 16 - Afastamento acidente 100012 - Atestado odontológico
        if (widget.currentRow.NRSITUFUNCM == 5 || widget.currentRow.NRSITUFUNCM == 12 || widget.currentRow.NRSITUFUNCM == 15 ||
            widget.currentRow.NRSITUFUNCM == 16 || widget.currentRow.NRSITUFUNCM == 100012 || widget.currentRow.IDAFASTSITUFUNC == 'S') {
                if(verificaEnvioEsocialDescentralizado){
                    ESocialController.envioEsocialDescentralizado(widget.currentRow, 'S-2230', widget.currentRow.NRALTESITUFUNC, widget.currentRow.NRVINCULOM, this.validaAtestadoFerias, args);
                }else{
                    var saldo;
                    var filtro = [
                        {
                            "name": "P_NRORG",
                            "operator": "=",
                            "value": getLocalVar('HCM_NRORG_TRAB')
                        },
                        {
                            "name": "NRVINCULOM",
                            "operator": "=",
                            "value": widget.currentRow.NRVINCULOM
                        },
                        {
                            "name": "P_NRORG_PADRAO",
                            "operator": "=",
                            "value": getLocalVar('HCM_NRORG_PADRAO')
                        }
                    ];
                restEngine.post("product#/getGozoFerias", {
                        requestType: "FilterData",
                            filter: filtro}).
                then(function (data) {
                    var flag = false;
                    var dateIniGozo;
                    var dateFimGozo;
                    var nrferias;
                    var nrgozoferias;
                    
                    if(data.dataset.getGozoFerias.length){
                        var position = data.dataset.getGozoFerias.length;
                        var iniAtest = new Date(ABUtilController.convertStringFormatBRtoEUA(widget.currentRow.DTINISITUFUNC));
                        var fimAtest = null;
                        
                        if(widget.currentRow.DTFIMSITUFUNC) 
                            fimAtest = new Date(ABUtilController.convertStringFormatBRtoEUA(widget.currentRow.DTFIMSITUFUNC));
                        else if(widget.currentRow.NRQTDIASITUFUNC){
                            fimAtest = moment(widget.currentRow.DTINISITUFUNC, 'DD/MM/YYYY').add(parseInt(widget.currentRow.NRQTDIASITUFUNC), 'day').format('DD/MM/YYYY');
                            fimAtest = new Date(ABUtilController.convertStringFormatBRtoEUA(fimAtest));
                        }    
                        
                        for(;position > 0; position--){
                            var stringIniGozo = new Date(ABUtilController.convertStringFormatBRtoEUA(data.dataset.getGozoFerias[position-1].DTINIGOZOFERIAS));
                            var stringFimGozo = new Date(ABUtilController.convertStringFormatBRtoEUA(data.dataset.getGozoFerias[position-1].DTFIMGOZOFERIAS));
                            
                            if(
                                ( fimAtest && iniAtest.getTime() <= stringFimGozo.getTime() && fimAtest.getTime() >= stringIniGozo.getTime() ) ||
                                ( !fimAtest && stringIniGozo.getTime() <= iniAtest.getTime() && iniAtest.getTime() <= stringFimGozo.getTime() )
                             ) {
                                flag = true;
                                
                                
                                // pega os dados necessários para a montagem da mensagem e para a mudança do período de gozo caso a situação funcional seja = 5
                                if (widget.currentRow.NRSITUFUNCM == 5 && ((iniAtest.getTime() >= stringIniGozo.getTime() && iniAtest.getTime() <= stringFimGozo.getTime()))) {
                                    dateIniGozo = data.dataset.getGozoFerias[position-1].DTINIGOZOFERIAS;
                                    dateFimGozo = data.dataset.getGozoFerias[position-1].DTFIMGOZOFERIAS;
                                    nrferias = data.dataset.getGozoFerias[position-1].NRFERIAS;
                                    nrgozoferias = data.dataset.getGozoFerias[position-1].NRGOZOFERIAS;
                                    saldo = moment(dateFimGozo, 'DD/MM/YYYY').diff(moment(widget.currentRow.DTINISITUFUNC, 'DD/MM/YYYY'), 'day') + 1;
                                }
                            }
                        }
                        
                    }
                    if(flag) {
                        var msg; var diaFimGozoFerias; 
                        if (widget.currentRow.NRSITUFUNCM == 5 && saldo) {
                            diaFimGozoFerias = moment(widget.currentRow.DTINISITUFUNC, "DD-MM-YYYY").subtract(1, 'day').format('DD/MM/YYYY');
                            msg = "Foi localizado férias no período entre " + dateIniGozo.substring(0, 10) + " e " + dateFimGozo.substring(0, 10) + ". Deseja remanejar a data final de gozo de férias para o dia " + diaFimGozoFerias + " e adicionar " + saldo + " dias de saldo?";
                            ScreenService.confirmMessage(msg, 'CONFIRMATION', function(){
                                self.salvarAlteSituFuncional(widget, diaFimGozoFerias, saldo, nrgozoferias, nrferias);
                            }.bind(this));
                        } else if(widget.currentRow.NRSITUFUNCM == 5){
                            ScreenService.confirmMessage("Período de gozo de férias encontrado dentro do período do afastamento cadastrado. Deseja continuar?", 'CONFIRMATION', function(){
                                self.salvarAlteSituFuncional(widget);
                            }.bind(this));
                        } else if(widget.currentRow.NRSITUFUNCM == 12) {
                            ScreenService.confirmMessage("Atestado cadastrado dentro de um período de gozo de férias. Deseja continuar?", 'CONFIRMATION', function(){
                                self.salvarAlteSituFuncional(widget);
                            }.bind(this));
                        } else {
                            ScreenService.showMessage("O vínculo possui período de gozo de férias coincidente ao lançamento desta situação funcional de afastamento. Favor verificar.", 'ALERT');
                        }
                    } else {
                        self.salvarAlteSituFuncional(widget);
                    }
                    
                });
            }
        } else {
            self.salvarAlteSituFuncional(widget);
        }
        
    };
    
    /**
     * Verifica se há históricos posteriores ao vínculo editado, se houver este indaga ao operador se quer atualiza-los também
     */
    this.verificaHistoricoPosterior = function($nrvinculom, $dtmescompetenc, eSocialMessage) {
        var info = [$nrvinculom, $dtmescompetenc];
        var msg;
        
        /*Função: Atualiza os históricos posteriores do vínculo*/
        var atualizaHistoricos = function(historicos, dados) {
            var infos = [historicos, dados];
            restEngine.post('product#/setVinculoHistoricoPosterior', {'requestType': 'DataSet', 'dataset': [infos]})
                .then(function(response) {
                    if(response.messages) {
                        if(response.messages[0].message.length > 0) {
                            msg = 'Competência(s) alteradas:<br>' + response.messages[0].message.join(",<br>");
                            ScreenService.showMessage(msg, response.messages[0].type);
                        } else {
                            ScreenService.showMessage("Nenhuma competência foi alterada.");
                        }
                    }
                }).catch(function(e) {
                    var error;
                    if(e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
        };
        
        /*Função: Verifica se há históricos para atualizar e lança mensagem na tela*/
        var verificaHistoricos = function(response) {
            if(response.dataset.historicos.length > 0) {
                ScreenService.showCustomDialog(
                    'Vínculo possui históricos posteriores à esta competência. Deseja atualizar esses históricos?',
                    'CONFIRMATION',
                    null,
                    [
                        {
                            label: ScreenService.i18n("Sim"),
                            code: function (e, deferred) {
                                atualizaHistoricos(response.dataset.historicos, info);
                                deferred.reject(e);
                            }.bind(this)
                        },
                        {
                            label: ScreenService.i18n("Não"),
                            code: function (e, deferred) {
                                deferred.resolve(e);
                            }.bind(this)
                        }
                    ]);
            }
        };
        
        /*Requisição ao backend para consultar possíveis históricos*/
        var consultaHistoricos = function() {
            restEngine.post('product#/getVinculoHistoricoPosterior', {'requestType': 'DataSet', 'dataset': [info]})
                    .then(verificaHistoricos);
        };
        
        /*Exibe as mensagens do eSocial (se houver) e aciona a rotina de verificação de existência de históricos posteriores*/
        if(eSocialMessage != null)
            ScreenService.showMessage(eSocialMessage).then(consultaHistoricos);
        else
            consultaHistoricos();
            
    };
    
    /* jshint ignore:start */
    this.verificaLiquidoDef = function(/*args*/){
        var widget = templateManager.container.getWidget('vinculo');
        var widgetFilha = templateManager.container.getWidget('situafunc');
        var row = {};
        row = {... widget.currentRow, ...widgetFilha.currentRow};
        if (widget.isValid()) {
            restEngine.post('product#/verificaLiquidoDef', {'requestType': 'DataSet', 'dataset': [row]}).
            then(function (data) {
                if (data.messages && data.messages[0].type === 'E') {
                    //ScreenService.showMessage("Operação Bloqueada! O vínculo já possui líquido definitivo para o movimento mensal na respectiva competência", 'ERROR');
                    //ScreenService.goBack();
                    return false;
                } else {
                    return true;
                }
            }.bind(this)).
            catch(function(e) {
                var error;
                if(e.data.error === undefined)
                    error = e;
                else{
                    error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                }
            });
        }
        
    };
    
    this.verificaLiquidoDefCadAuto = function(args){
        var widget = templateManager.container.getWidget('alteSitufunc');
        var widgetPopUp = templateManager.container.getWidget('popupCadExclAuto');
        var row = {};
        row = {... widget.currentRow, ...widgetPopUp.currentRow};
        if (widgetPopUp.isValid()) {
            restEngine.post('product#/verificaLiquidoDef', {'requestType': 'DataSet', 'dataset': [row]}).
            then(function (data) {
                if (data.messages && data.messages[0].type === 'E') {
                    ScreenService.showMessage("Operação Bloqueada! O vínculo já possui líquido definitivo para o movimento mensal na respectiva competência", 'ERROR');
                    ScreenService.goBack();
                } else {
                    this.confirmaCadExclAuto(args.owner.widget);
                }
            }.bind(this)).
            catch(function(e) {
                var error;
                if(e.data.error === undefined)
                    error = e;
                else{
                    error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                }
            });
        }
        
    };
    
    //verifica se a situação funcional é Acidente de trabalho ou Lincença de Gestante, caso seja a Data para Estabilidade se torna obrigatorio 
    this.validaDataEstablidade = function(args){
        var widget = ABUtilController.checkWidget(args);
        if (widget.currentRow.NRSITUFUNCM == 5) {
            widget.getField('DTESTABSITUFUNC').validations = {"required":{}};
        } else {
             widget.getField('DTESTABSITUFUNC').validations = {};
        }
    };
    
    /* jshint ignore:end */ 
    
}

Configuration(function(ContextRegister) {
    ContextRegister.register('AlteSituacaoFuncionalController', AlteSituacaoFuncionalController);
});


// FILE: assets/js/controllers/AnaliseApuracaoController.js
function AnaliseApuracaoController (ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, ABUtilController, Messages, HcmConsts) {
    
    this.nrparcexecaval = null;
    this.nrparcavaliado = null;
    
    this.openSwipe = function(args){
        var widget = ABUtilController.checkWidget(args);
        var tabbed = templateManager.container.getWidget('tabbedParticipantes');
        this.nrparcexecaval = widget.currentRow.NRPARCEXECAVAL;
        this.nrparcavaliado = widget.currentRow.NRPARCAVALIADO;

        ScreenService.openSwipe(tabbed);
    };
    
}

Configuration(function(ContextRegister) {
    ContextRegister.register('AnaliseApuracaoController', AnaliseApuracaoController);
});

// FILE: assets/js/controllers/AprovacaoAdmissaoController.js
/* jshint esversion: 6 */
function AprovacaoAdmissaoController (ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine,Messages, $window, ABUtilController,HcmConsts) {

    this.camposData = ['DTADMISSAOVINC', 'DTPRIMADMISSAO', 'DTEXAMEMEDICO', 'DTOPCAOFGTS', 'DTENTREGAEPI', 'DTAPOSENTAFGTS', 'DTFIMCONTRDETERMIN', 'DTBASEFERIAS', 'DTEXRGPESSOA', 'DTNASCPESSOA', 'DTCTPSPESSOA', 'DTINSCPISPASEP', 'DTCHEGADAPAIS', 'DTNATURALIZAPES'];
    
    this.pais = '';
    var validaContratoVerdeAmarelo = false;
    
    this.cancelaAdmissao = function(args){
        ScreenService.confirmMessage('Deseja realmente cancelar essa(s) admissão(ões)?', 'CONFIRMATION', function(){    
            var widget = ABUtilController.checkWidget(args);
            restEngine.post('product#/cancelaAdmissao', {'requestType': 'DataSet', 'dataset': widget.getCheckedRows()}).
                then(function (data) {
                    if (data.messages) {
                        ScreenService.showMessage(data.messages[0].message, data.messages[0].type);
                    } else {
                        ScreenService.successNotification(Messages.HCM00000_GER_VINCULO_CANCELAADMISSAO_SUCESS, 10000);
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    }
                }).
                catch(function(e) {
                    var error;
                    if(e.data.error === undefined){
                        error = e;
                    }    
                    else{
                        error = e.data.error;
                        ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    }    
                });
        }.bind(this));
    };
    
    this.aprovaAdmissao = function(args, ESocialController, verificaEnvioEsocialDescentralizado = true){
        var widget = ABUtilController.checkWidget(args);
        var isValid = true;
        var vincInvalid = [];

        widget.getCheckedRows().forEach(function(row){
            widget.currentRow = row;
            if (!widget.isValid()) {
                isValid = false;

                var fields = [];
                for (var key in widget.currentRow.$error) {
                    if (widget.currentRow.$error[key].length > 0){
                        fields.push(widget.getField(key).label);
                    }
                }

                vincInvalid.push(widget.currentRow.NRVINCULOM + '-' + widget.currentRow.NMVINCULOM + '[' + fields.join() + ']');
            }
        });
        
        if(isValid){
            if(verificaEnvioEsocialDescentralizado){
                ScreenService.confirmMessage('Deseja realmente aprovar essa(s) admissão(ões)?', 'CONFIRMATION',
                    function() {
                        ESocialController.envioEsocialDescentralizado(widget.getCheckedRows()[0], 'S-2200', widget.getCheckedRows()[0].NRVINCULOM, widget.getCheckedRows()[0].NRVINCULOM, this.aprovaAdmissao, args);
                    }.bind(this));
            }else{
                restEngine.post('product#/aprovaAdmissao', {'requestType': 'DataSet', 'dataset': [widget.getCheckedRows()]}).
                    then(function (data) {
                        if(data.dataset && data.dataset.retornoEsocial2200 && !Util.isEmptyOrBlank(data.dataset.retornoEsocial2200)){
                            var mensagem = 'S-2200/S-2300: <br>';
                            data.dataset.retornoEsocial2200.forEach(function(retorno, index){
                                mensagem += 'vínculo ' + retorno.VINCULO + ': ' + retorno.RETORNO.MSG + '<br>';
                            });
                            ScreenService.showMessage(mensagem);
                        }
                        if (data.messages) {
                            ScreenService.showMessage(data.messages[0].message, data.messages[0].type);
                        } else {
                            ScreenService.successNotification(Messages.HCM00000_GER_VINCULO_APROVAADMISSAO_SUCESS, 10000);
                            ABUtilController.masterDetailVoltarList(widget);
                            widget.reload();
                        }
                    }).
                    catch(function(e) {
                        var error;
                        if(e.data.error === undefined){
                            error = e;
                        }    
                        else{
                            error = e.data.error;
                            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                        }    
                    });
            }
        } else {
            ScreenService.showMessage('Favor preencher todos os campos obrigatórios: <br>' + vincInvalid.join(" \n <br> "));
            return;
        }
    };
    
    this.onChangeTipoVinculo = function(args){
        var widget = ABUtilController.checkWidget(args);
        if(widget.currentRow.NRTIPOVINCULOM){
            switch (widget.currentRow.NRTIPOVINCULOM) {
                case HcmConsts.tipoVinculo.CLT:
                    widget.getField('NRPISPASEPPES').validations = {"required": true};
                    widget.getField('NRCTPSPESSOA').validations = {"required": true};
                    widget.getField('NRSERIECTPSPES').validations = {"required": true};
                    widget.getField('DTCTPSPESSOA').validations = {"required": true};
                    widget.getField('NMUFCTPSPES').validations = {"required": true};
                    widget.getField('DTINSCPISPASEP').validations = {"required": true};
                    widget.currentRow.IDREMUNERACAO = "";
                    widget.getField('IDREMUNERACAO').readOnly = false;
                break;
                case HcmConsts.tipoVinculo.ESTAGIARIO:
                    widget.getField('NRPISPASEPPES').validations = {};
                    widget.getField('NRCTPSPESSOA').validations = {};
                    widget.getField('NRSERIECTPSPES').validations = {};
                    widget.getField('DTCTPSPESSOA').validations = {};
                    widget.getField('NMUFCTPSPES').validations = {};
                    widget.getField('DTINSCPISPASEP').validations = {};
                    widget.currentRow.IDREMUNERACAO = "ESTAGIO";
                    widget.getField('IDREMUNERACAO').readOnly = true;
                break;
                case HcmConsts.tipoVinculo.SOCIO:
                    widget.getField('NRPISPASEPPES').validations = {};
                    widget.getField('NRCTPSPESSOA').validations = {};
                    widget.getField('NRSERIECTPSPES').validations = {};
                    widget.getField('DTCTPSPESSOA').validations = {};
                    widget.getField('NMUFCTPSPES').validations = {};
                    widget.getField('DTINSCPISPASEP').validations = {};
                    widget.currentRow.IDREMUNERACAO = "SOCIO";
                    widget.getField('IDREMUNERACAO').readOnly = true;
                break;
                default:
                    widget.getField('NRPISPASEPPES').validations = {};
                    widget.getField('NRCTPSPESSOA').validations = {};
                    widget.getField('NRSERIECTPSPES').validations = {};
                    widget.getField('DTCTPSPESSOA').validations = {};
                    widget.getField('NMUFCTPSPES').validations = {};
                    widget.getField('DTINSCPISPASEP').validations = {};
                    widget.currentRow.IDREMUNERACAO = "";
                    widget.getField('IDREMUNERACAO').readOnly = false;
            }
        }
    };
    
    this.setAlteracoesAprova = function(args){
        var widget = ABUtilController.checkWidget(args);
        if(widget.isValid()){
            restEngine.post('product#/setAlteracoesAprova', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                then(function (data) {
                    if (data.messages) {
                        ScreenService.showMessage(data.messages[0].message, data.messages[0].type);
                    } else {
                        ScreenService.successNotification('Alterações salvas', 10000);
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    }
                }).
                catch(function(e) {
                    var error;
                    if(e.data.error === undefined){
                        error = e;
                    }    
                    else{
                        error = e.data.error;
                        ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    }    
                });
        }    
    };
    
    this.paisOnchange = function(args) {
        var widget = args.owner.field.widget;
        var estado;
        if (!Util.isUndefined(widget.getField('SGESTADONATURALI'))) {
            estado = widget.getField('SGESTADONATURALI');
        } else {
            estado = widget.getField('NMESTADONATURALI');
        }
        if (widget.currentRow.NMPAISNATURALI.length > 0) {
            estado.readOnly = false;
        }
        else {
            estado.readOnly = true;
            estado.validations = {};
        }
    };
    
    this.filtrarEstadoMunicipioPorPais = function(args){
        var widget = args.owner.field.widget;
        var estado;

        if (!Util.isUndefined(widget.getField('SGESTADONATURALI'))) {
            estado = widget.getField('SGESTADONATURALI');
        } else {
            estado = widget.getField('NMESTADONATURALI');
        }
        var municipio = widget.getField('NMMUNICIPIONATURALI');

        estado.dataSourceFilter[ABUtilController.retornaFiltro(estado.dataSourceFilter, 'CDPAIS')].value = widget.currentRow.CDPAISNATURALI;
        municipio.dataSourceFilter[ABUtilController.retornaFiltro(estado.dataSourceFilter, 'CDPAIS')].value = widget.currentRow.CDPAISNATURALI;
        municipio.dataSourceFilter[ABUtilController.retornaFiltro(municipio.dataSourceFilter, 'SGESTADO')].value = widget.currentRow.SGESTADONATURALI;
        estado.dataSourceFilter[ABUtilController.retornaFiltro(estado.dataSourceFilter, 'CDPAIS')].operator = "=";
        municipio.dataSourceFilter[ABUtilController.retornaFiltro(estado.dataSourceFilter, 'CDPAIS')].operator = "=";
        municipio.dataSourceFilter[ABUtilController.retornaFiltro(municipio.dataSourceFilter, 'SGESTADO')].operator = "=";
        estado.readOnly = false;
        municipio.readOnly = false;
        if(!widget.currentRow.NMPAISNATURALI){
            estado.dataSourceFilter[ABUtilController.retornaFiltro(estado.dataSourceFilter, 'CDPAIS')].value = 0;
            estado.dataSourceFilter[ABUtilController.retornaFiltro(estado.dataSourceFilter, 'CDPAIS')].operator = ">";
            estado.readOnly = true;
        }
        if(!widget.currentRow.SGESTADONATURALI){
            widget.currentRow.SGESTADONATURALI = "";
            widget.currentRow.NMMUNICIPIONATURALI = "";
            municipio.dataSourceFilter[ABUtilController.retornaFiltro(estado.dataSourceFilter, 'CDPAIS')].value = 0;
            municipio.dataSourceFilter[ABUtilController.retornaFiltro(municipio.dataSourceFilter, 'SGESTADO')].value = 0;
            municipio.dataSourceFilter[ABUtilController.retornaFiltro(estado.dataSourceFilter, 'CDPAIS')].operator = ">";
            municipio.dataSourceFilter[ABUtilController.retornaFiltro(municipio.dataSourceFilter, 'SGESTADO')].operator = ">";
            municipio.readOnly = true;
        }
        if(widget.currentRow.NMPAISNATURALI !== this.pais){
            widget.currentRow.SGESTADONATURALI = "";
            widget.currentRow.NMESTADONATURALI = "";
            widget.currentRow.NMMUNICIPIONATURALI = "";
        }
        this.pais = widget.currentRow.NMPAISNATURALI;
    };
    
    this.EstadoOnChange_liberarMunicipio = function(args) {
        var widget = ABUtilController.checkWidget(args);
        if(widget.currentRow.SGESTADONATURALI){
            widget.getField('NMMUNICIPIONATURALI').readOnly = false;
        }else{
            widget.getField('NMMUNICIPIONATURALI').readOnly = true;
            widget.currentRow.NMMUNICIPIONATURALI = "";
        }
    };
    
     this.habilitaIdpagpropfer13 = function(){
        var widget = templateManager.container.getActiveWidget();
        if(widget.currentRow.NRVINCULOEMPREG == 107 || widget.currentRow.NRVINCULOEMPREG == 108){
            validaContratoVerdeAmarelo = true;
            widget.getField('IDPAGPROPFER13').readOnly = false;
        }else{
            validaContratoVerdeAmarelo = false;
            widget.getField('IDPAGPROPFER13').readOnly = true;
            widget.currentRow.IDPAGPROPFER13 = '';
        }
    };
    
    this.verificaContratoVerdeAmarelo = function(){
        var widgetAprova = templateManager.container.getWidget('aprovacaoAdmissao');
        // var widgetPessoa = templateManager.container.getWidget('Pessoa');
        // var widgetParametros = templateManager.container.getWidget('parametros');
        var dados = [];
        
        if(widgetAprova.currentRow.NRVINCULOEMPREG && (widgetAprova.currentRow.NRVINCULOEMPREG == 107 || widgetAprova.currentRow.NRVINCULOEMPREG == 108)){
            validaContratoVerdeAmarelo = true;
            widgetAprova.getField('IDPAGPROPFER13').readOnly = false;
            
            dados.DTNASCPESSOA = !Util.isEmptyOrBlank(widgetAprova.currentRow.DTNASCPESSOA) ? widgetAprova.currentRow.DTNASCPESSOA : null;
            dados.NRTPADMISSAO = !Util.isEmptyOrBlank(widgetAprova.currentRow.NRTPADMISSAO) ? widgetAprova.currentRow.NRTPADMISSAO : null;
            dados.DTFIMCONTRDETERMIN = !Util.isEmptyOrBlank(widgetAprova.currentRow.DTFIMCONTRDETERMIN) ? widgetAprova.currentRow.DTFIMCONTRDETERMIN : null;
            dados.DTADMISSAOVINC = !Util.isEmptyOrBlank(widgetAprova.currentRow.DTADMISSAOVINC) ? widgetAprova.currentRow.DTADMISSAOVINC : null;
            dados.VRSALARIO = !Util.isEmptyOrBlank(widgetAprova.currentRow.VRSALARIO) ? widgetAprova.currentRow.VRSALARIO : null;
            this.realizaValidacoesContratoVerdeAmarelo(dados);
        }else{
            validaContratoVerdeAmarelo = false;
            widgetAprova.getField('IDPAGPROPFER13').readOnly = true;
            widgetAprova.currentRow.IDPAGPROPFER13 = '';
        }
        
        
    };
    
    this.verificaContratoVerdeAmareloCampos = function(campos, nomeWidget){
        if(validaContratoVerdeAmarelo){                    
            var currentRow = templateManager.container.getWidget(nomeWidget) ? templateManager.container.getWidget(nomeWidget).currentRow : null;
            var dados = [];
            dados.DTNASCPESSOA = null;
            dados.NRTPADMISSAO = null;
            dados.DTFIMCONTRDETERMIN = null;
            dados.DTADMISSAOVINC = null;
            dados.VRSALARIO = null;

            if(!Util.isEmptyOrBlank(currentRow) ){
                campos.forEach(function(campo){
                    dados[campo] = !Util.isEmptyOrBlank(currentRow[campo]) ? currentRow[campo] : null;
                });
            }
            
            this.realizaValidacoesContratoVerdeAmarelo(dados);
        }
    };
    
    this.realizaValidacoesContratoVerdeAmarelo = function(currentRow){
        var mensagem = '';
        if(!Util.isEmptyOrBlank(currentRow.DTNASCPESSOA)){
            var idade = ABUtilController.retornaIdade(currentRow.DTNASCPESSOA);
            if(idade > 29 || idade < 18){
                mensagem += Messages.HCMOOOOO_GER_ADMISSAO_CONTRATOVERAMAR_DATANASC + '<br>';
            }
        }
        if(!Util.isEmptyOrBlank(currentRow.NRTPADMISSAO) && currentRow.NRTPADMISSAO != 1){
            mensagem += Messages.HCMOOOOO_GER_ADMISSAO_CONTRATOVERAMAR_TPADMISSAO + '<br>';
        }
        if(!Util.isEmptyOrBlank(currentRow.DTFIMCONTRDETERMIN) && !Util.isEmptyOrBlank(currentRow.DTADMISSAOVINC)){
           var periodo = ABUtilController.retornaPeriodo(currentRow.DTADMISSAOVINC.substr(0,10)+' 00:00:00', currentRow.DTFIMCONTRDETERMIN.substr(0,10)+' 00:00:00');
           if(periodo > 24){
               mensagem += Messages.HCMOOOOO_GER_ADMISSAO_CONTRATOVERAMAR_PRAZO + '<br>';
           }
        }
        if(!Util.isEmptyOrBlank(currentRow.VRSALARIO)){
            var salariominimo = getLocalVar('HCM_SALARIO_MINIMO');
            var salario = currentRow.VRSALARIO.replace('.','').replace(',', '.');
            if(parseFloat(salario) > parseFloat(1.5*salariominimo)){
                mensagem += Messages.HCMOOOOO_GER_ADMISSAO_CONTRATOVERAMAR_SALARIO;
            }
        }
        
        if(!Util.isEmptyOrBlank(mensagem)){
            ScreenService.showMessage('Contrato Verde e Amarelo:<br>' + mensagem);
        }
    };
    
    //Admissão simplificada (pessoa)
    this.openPopupAdmissaoSimplificada = function(){
        var widgetPopup = templateManager.container.getWidget('admissaoSimplificada');
        ABUtilController.masterDetailOpenPopup(widgetPopup);
    };
     
    this.aprovaAdmissaoPessoa = function(args){
        var widget = ABUtilController.checkWidget(args);
        
        restEngine.post('product#/aprovaAdmissaoPessoa', {'requestType': 'DataSet', 'dataset': [widget.getCheckedRows()]}).
            then(function (data) {
                data.messages.forEach(function(msg){
                    if(msg.type == 'E')
                        ScreenService.alertNotification(Messages.HCM0000_GER_PESSOA_APROVAADMISSAO_ERRO + msg.message, 10000);
                    else
                        ScreenService.successNotification(Messages.HCM0000_GER_PESSOA_APROVAADMISSAO + msg.message, 10000);
                });
                ABUtilController.masterDetailVoltarList(widget);
                widget.reload();
            }).
            catch(function(e) {
                var error;
                if(e.data.error === undefined){
                    error = e;
                }    
                else{
                    error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                }    
            });
        
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('AprovacaoAdmissaoController', AprovacaoAdmissaoController);
});

// FILE: assets/js/controllers/AprovacaoCalculoController.js
/* jshint esversion: 6 */
function AprovacaoCalculoController (ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine,Messages, $window, ABUtilController,HcmConsts) {

    this.aprovaCalculo = function(args, ESocialController, verificaEnvioEsocialDescentralizado = true){
        var widget = templateManager.container.getWidget('aprovacaoCalculo'); 
        if(verificaEnvioEsocialDescentralizado){
            ESocialController.envioEsocialDescentralizado(widget.getCheckedRows()[0], 'S-2299/S-2230', widget.getCheckedRows()[0].NRVINCULOM, widget.getCheckedRows()[0].NRVINCULOM, this.aprovaCalculo, args);
        }else{
            restEngine.post('product#/aprovaCalculo', {'requestType': 'DataSet', 'dataset': [widget.getCheckedRows()]}).
                    then(function (data) {
                        if (data.dataset.aprovaCalculo) {
                            ScreenService.successNotification(Messages.HCM01000_FPA_CALCULO_APROVACALCULO_SUCESS);
                            widget.reload();   
                        }
                        var mensagem = '';
                        if(data.dataset && data.dataset.retornoEsocial2230 && !Util.isEmptyOrBlank(data.dataset.retornoEsocial2230)){
                            mensagem += 'S-2230: <br>';
                            data.dataset.retornoEsocial2230.forEach(function(retorno, index){
                                mensagem += 'vínculo ' + retorno.VINCULO + ': ' + retorno.RETORNO.MSG + '<br>';
                            });
                        }
                        if(data.dataset && data.dataset.retornoEsocial2299 && !Util.isEmptyOrBlank(data.dataset.retornoEsocial2299)){
                            mensagem += 'S-2299/S-2399: <br>';
                            data.dataset.retornoEsocial2299.forEach(function(retorno, index){
                                mensagem += 'vínculo ' + retorno.VINCULO + ': ' + retorno.RETORNO.MSG + '<br>';
                            });
                        }
                        if(!Util.isEmptyOrBlank(mensagem)){
                            ScreenService.showMessage(mensagem);
                        }
                    }).
                    catch(function(e) {
                        var error;
                        if(e.data.error === undefined){
                            error = e;
                        }    
                        else{
                            error = e.data.error;
                            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                        }    
                    });
        }
    };

}

Configuration(function(ContextRegister) {
    ContextRegister.register('AprovacaoCalculoController', AprovacaoCalculoController);
});

// FILE: assets/js/controllers/ApuracaoAvaliacaoController.js
function ApuracaoAvaliacaoController (ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, ABUtilController, Messages, HcmConsts) {

    this.setCamposBaseadoNaAvaliacao = function(args){
        var widget = args.owner.owner.widget;
        //row do Select
        var currentRow = args.row;
        //seta os valores da widget principal com os pegados no select
        widget.NMTIPOAVALIACAO = currentRow.NMTIPOAVALIACAO;
        widget.NMPADRAVALIACAO = currentRow.NMPADRAVALIACAO;
        widget.VRAPROVACAOAVAL = currentRow.VRAPROVACAOAVAL;
        widget.NMCRITERIORESUL = currentRow.NMCRITERIORESUL;
        widget.DTINIREALIZAVAL = currentRow.DTINIREALIZAVAL;
        widget.DTREFEAVALIACAO = currentRow.DTREFEAVALIACAO;
        widget.NRORG = currentRow.NRORG;
        
        if(widget.NMTIPOAVALIACAO === ""){
            widget.currentRow.IDOPCAO = 'A';
            widget.fields[8].isVisible = false;
        }
        
        widget.reload();
    };
    
    this.confirmarInicioApuracao = function(args){
        var widget = args.owner.widget;  
        var row = {}; 
        row = angular.copy(widget.currentRow);
        var qtPart;
        try{
            if(!widget.currentRow.NRAVALIACAO)
                throw "Preencha a Avaliação";
            var avaliados = widget.getField('AVALIADO').dataSource.getCheckedRows();
            var opcao = widget.currentRow.IDOPCAO;
            if(opcao === 'L'){
                if(!avaliados || avaliados.length === 0 ){
                    throw "Selecione pelo menos um participante";
                }else{
                    row.AVALIADO = avaliados;
                    qtPart = avaliados.length;
                }
            }else{
                row.AVALIADO = avaliados;
                qtPart = "todos";
            }    
            ScreenService.confirmMessage("Deseja iniciar a apuração da avaliação:"+widget.currentRow.NRAVALIACAO+" - "+widget.currentRow.NMAVALIACAO+" de "+qtPart+" avaliador(es)","question", 
            //yes
                function(success){
                    restEngine.post('product#/iniciarApuracao',{'requestType': 'Row','row': [row]}).
                        then(function(data){
                            if (data.notifications[data.notifications.length - 1].type === "success") {
                                ScreenService.showMessage(Messages.HCM03000_AVL_APURACAO_SUCESSO, 'S');
                                    
                                    data.notifications.forEach(function(notifAlert){
                                        if(notifAlert.type === "alert")
                                            ScreenService.alertNotification(notifAlert.message, 100000);
                                        if(notifAlert.type === "success")
                                        ScreenService.successNotification(notifAlert.message, 100000);
                                    });
                            } else {
                                ScreenService.showMessage(Messages.HCM03000_AVL_APURACAO_FALHA);
                                data.notifications.forEach(function(notifAlert){
                                    if(notifAlert.type === "alert")
                                        ScreenService.alertNotification(notifAlert.message, 100000);
                                    if(notifAlert.type === "success")
                                    ScreenService.successNotification(notifAlert.message, 100000);
                                });
                            }
                        }).
                        catch(function(e) {
                            var error;
                            if(e.data.error === undefined)
                                error = e;
                            else
                                error = e.data.error;
                                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                        });
                    ScreenService.closePopup(); 
                    
                }.bind(this),
            //no
                function(error){
                    ScreenService.closePopup();    
                });
        }catch(e){
            ScreenService.showMessage(e);
        }
    };
    
    this.confirmarRetrocessoApuracao = function(args){
        var widget = args.owner.widget;  
        var row = {}; 
        row = angular.copy(widget.currentRow);
        var qtPart;
        try{
            if(!widget.currentRow.NRAVALIACAO)
                throw "Preencha a Avaliação";
            var avaliados = widget.getField('AVALIADO').dataSource.getCheckedRows();
            var opcao = widget.currentRow.IDOPCAO;
            if(opcao === 'L'){
                if(!avaliados || avaliados.length === 0 ){
                    throw "Selecione pelo menos um participante";
                }else{
                    row.AVALIADO = avaliados;
                    qtPart = avaliados.length;
                }
            }else{
                row.AVALIADO = avaliados;
                qtPart = "todos";
            }   
            ScreenService.confirmMessage("Deseja iniciar o retrocesso da avaliação:"+widget.currentRow.NRAVALIACAO+" - "+widget.currentRow.NMAVALIACAO+" de "+qtPart+" avaliador(es)","question", 
            //yes
                function(success){
                    restEngine.post('product#/iniciarRetrocesso',{'requestType': 'Row','row': [row]}).
                        then(function(data){
                            if (data.notifications[data.notifications.length - 1].type === "success") {
                                ScreenService.showMessage(Messages.HCM03000_AVL_RETROCESSO_SUCESSO);
                                data.notifications.forEach(function(notifAlert){
                                    if(notifAlert.type === "alert")
                                        ScreenService.alertNotification(notifAlert.message, 100000);
                                    if(notifAlert.type === "success")
                                    ScreenService.successNotification(notifAlert.message, 100000);
                                });
                            }else {
                                ScreenService.showMessage(Messages.HCM03000_AVL_RETROCESSO_FALHA);
                                data.notifications.forEach(function(notifAlert){
                                    if(notifAlert.type === "alert")
                                        ScreenService.alertNotification(notifAlert.message, 100000);
                                    if(notifAlert.type === "success")
                                    ScreenService.successNotification(notifAlert.message, 100000);
                                });
                            }
                        }).
                        catch(function(e) {
                            var error;
                            if(e.data.error === undefined)
                                error = e;
                            else
                                error = e.data.error;
                                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                        });
                    ScreenService.closePopup(); 
                    
                }.bind(this),
            //no
                function(error){
                    ScreenService.closePopup();    
                });
        }catch(e){
            ScreenService.showMessage(e);
        }
    };
    
    this.habilitaLista = function(args){
        var widget = args.owner.owner.widget;
        try{
            if(widget.currentRow.IDOPCAO === 'L'){
                if(!widget.currentRow.NRAVALIACAO){
                    widget.currentRow.IDOPCAO = 'A';
                    throw "Preencha a Avaliação";
                }else
                    widget.getField('AVALIADO').isVisible = true;
            }
            if(widget.currentRow.IDOPCAO === 'A')
                widget.getField('AVALIADO').isVisible = false;
        }catch(e){
            ScreenService.showMessage(e);
        }   
    };
    
    this.participantesOnEnter = function(args) {
        var calculo = templateManager.container.getWidget('calculoAvaliacao');
        var avaliacao = calculo.currentRow.NRAVALIACAO;

        calculo.getField('AVALIADO').dataSourceFilter[ABUtilController.retornaFiltro(calculo.getField('AVALIADO').dataSourceFilter, 'P_NRAVALIACAO')].value = avaliacao;
        calculo.getField('AVALIADO').reload();
    };

}

Configuration(function(ContextRegister) {
    ContextRegister.register('ApuracaoAvaliacaoController', ApuracaoAvaliacaoController);
});

// FILE: assets/js/controllers/ApuracaoFrequenciaController.js
function ApuracaoFrequenciaController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, Messages) {
    this.DSINICIO = ['NMESTRUTLEGAL', 'NMINIVINCULOM', 'DTINIADMISSAO', 'CDINIMATRICULA', 'NRVINCULOM'];
    this.DSFIM = ['NMESTRUTGEREN', 'NMFIMVINCULOM', 'DTFIMADMISSAO' , 'CDFIMMATRICULA'];
    var widgetDataConst;

    this.deleteApuracao = function(args) {
        var widget = ABUtilController.checkWidget(args);
        var data = {}; 
        ScreenService.confirmMessage(Messages.DELETE_ROW, 'CONFIRMATION', 
            function(){
                widget.dataSource.remove(widget.currentRow).then(function (data){
                    if(data.dataset.gpeApuraFrequencia_setApuracaoFrequencia.type === "success"){
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                        ScreenService.showMessage(Messages.REMOVE_ROW_SUCCESS); 
                    } else {
                        ScreenService.showMessage(Messages.REMOVE_ROW_ERROR); 
                    }
                }.bind(this));
            }.bind(this)
        );
    };
    
    this.getWigetData = function(args){
        var widgetData = templateManager.container.getActiveWidget();
        var widgetPrincipal = templateManager.container.getWidget("apuracaoFrequencia");
        widgetData.minDate = widgetPrincipal.currentRow.DTINICIAL;
        widgetData.maxDate = widgetPrincipal.currentRow.DTFINAL;
        widgetDataConst = widgetData;
    };
    
    this.setMaxAndMinDate = function(args){
        var widgetPrincipal = templateManager.container.getWidget("apuracaoFrequencia");
        widgetDataConst.minDate = widgetPrincipal.currentRow.DTINICIALAPURACAO;
        widgetDataConst.maxDate = widgetPrincipal.currentRow.DTFINALAPURACAO;  
    };
    
    this.edit = function(args){
        var widget = ABUtilController.checkWidget(args);
        ABUtilController.masterDetailEdit(widget);
        widget.getField("DTFINAL").readOnly   = false;
        widget.getField("DSPERIODOAPURACAO").readOnly = false;
        widget.getField("DSTIPOPERIODOAPURACAO").readOnly = false;
        widget.getField("DSPERIODOAPURACAO").dataSourceFilter.forEach(function(dados){
            if(dados.name === 'NRTIPOPERIODOAPURACAO'){
                dados.value = widget.currentRow.NRTIPOPERIODOAPURACAO;
            }
        });

        widget.getField("DSTIPOPERIODOAPURACAO").dataSourceFilter.forEach(function(dados){
            if(dados.name === 'NRTIPOVINCULOM'){
                dados.value = widget.currentRow.NRTIPOVINCULOM;
            }
        });
    };

    this.efetivarApuracao = function(args){
        var widget = ABUtilController.checkWidget(args);
        ScreenService.confirmMessage('Deseja realmente efetivar apuração?', 'CONFIRMATION', 
            function(){
                var saveData = Object.assign({}, widget.currentRow, {
                        "NRORGTRAB": getLocalVar("HCM_NRORG_TRAB")
                    }, {
                        "DTCOMPETENCIA": getLocalVar("HCM_DTCOMPETENCIA_OPER")
                    }, {
                        "NRORGPADRAO": getLocalVar("HCM_NRORG_PADRAO")
                    });
                restEngine.post("product#/efetivarApuracao",
                        {'requestType':'DataSet','dataset':[saveData]}
                    ).then(function(data) {
                            if (Util.isEmptyOrBlank(data.messages[0].variables)) {
                                data.messages.forEach(function(mensagem){
                                    ScreenService.showMessage('Avisos efetivação apuração: <br>' + mensagem.message, 'WARNING');
                                    ScreenService.closePopup();
                                });
                            } else {
                                data.messages.forEach(function(mensagem){
                                    ScreenService.showMessage('Apuração efetivada com sucesso: <br>' + mensagem.message, 'SUCCESS');
                                    ScreenService.closePopup();
                                });    
                                
                            }
                        }
                    ).catch(function(e) {
                        var error;
                        if(e.data.error === undefined)
                            error = e;
                        else 
                            error = e.data.error;
                        
                        ScreenService.showMessage('Ocorreu um erro inesperado, contate o administrador informando o trecho abaixo: <br><br>' + error + '<br><br>', 'ERROR');
                    });
            }.bind(this));
    };

    this.enableData = function(args){
        var widget = ABUtilController.checkWidget(args);
        if(!Util.isEmptyOrBlank(widget.currentRow.DSPERIODOAPURACAO)){
            widget.getField("DTFINAL").readOnly   = false;
            widget.currentRow.DTINICIALAPURACAO = widget.currentRow.DTINICIAL.split(" ")[0];
            widget.currentRow.DTFINALAPURACAO = widget.currentRow.DTFINAL.split(" ")[0];
        } else {
            widget.getField("DTINICIAL").readOnly = true;
            widget.getField("DTFINAL").readOnly   = true;
        }
    };

    this.enablePeriodoApuracao = function(args){
        var widget = ABUtilController.checkWidget(args);
        if(!Util.isEmptyOrBlank(widget.currentRow.DSTIPOPERIODOAPURACAO)){
            widget.getField("DSPERIODOAPURACAO").readOnly = false;
            widget.getField("DSPERIODOAPURACAO").dataSourceFilter.forEach(function(dados){
                if(dados.name === 'NRTIPOPERIODOAPURACAO'){
                    dados.value = widget.currentRow.NRTIPOPERIODOAPURACAO;
                }
            });
        } else {
            widget.getField("DSPERIODOAPURACAO").readOnly = true;
            widget.getField("DSPERIODOAPURACAO").dataSourceFilter.forEach(function(dados){
                if(dados.name === 'NRTIPOPERIODOAPURACAO'){
                    dados.value = widget.currentRow.NRTIPOPERIODOAPURACAO;
                }
            });
        }
    };

    this.enableTipoPeriodoApuracao = function(args, CriterioSelecaoController){
        var widget = ABUtilController.checkWidget(args);

        widget.currentRow.DTINICIAL = null;
        widget.currentRow.DTFINAL   = null;
        widget.currentRow.DSPERIODOAPURACAO = null;
        widget.currentRow.DSTIPOPERIODOAPURACAO = null;
        widget.currentRow.DSORDEM = null;
        if(widget.currentRow.DSORDEM){
            CriterioSelecaoController.setVisibilidadeCampos(widget);
        }
        
        widget.getField("DTINICIAL").readOnly = true;
        widget.getField("DTFINAL").readOnly   = true;
        widget.getField("DSPERIODOAPURACAO").readOnly = true;
        widget.getField("DSPERIODOAPURACAO").dataSourceFilter.forEach(function(dados){
            if(dados.name === 'NRTIPOPERIODOAPURACAO'){
                dados.value = widget.currentRow.NRTIPOPERIODOAPURACAO;
            }
        });

        widget.getField("NMINIVINCULOM").dataSourceFilter.forEach(function(dados){
            if(dados.name === 'NRTIPOVINCULOM'){
                dados.value = widget.currentRow.NRTIPOVINCULOM;
            }
        });

        widget.getField("NMFIMVINCULOM").dataSourceFilter.forEach(function(dados){
            if(dados.name === 'NRTIPOVINCULOM'){
                dados.value = widget.currentRow.NRTIPOVINCULOM;
            }
        });

        if(!Util.isEmptyOrBlank(widget.currentRow.NMTIPOVINCULOH)){
            widget.getField("DSTIPOPERIODOAPURACAO").readOnly = false;
            widget.getField("DSTIPOPERIODOAPURACAO").dataSourceFilter.forEach(function(dados){
                if(dados.name === 'NRTIPOVINCULOM'){
                    dados.value = widget.currentRow.NRTIPOVINCULOM;
                }
            });
        } else {
            widget.getField("DSTIPOPERIODOAPURACAO").readOnly = true;
            widget.getField("DSTIPOPERIODOAPURACAO").dataSourceFilter.forEach(function(dados){
                if(dados.name === 'NRTIPOVINCULOM'){
                    dados.value = widget.currentRow.NRTIPOVINCULOM;
                }
            });
        }
    };

    this.moveRow = function(args, CriterioSelecaoController){
        var widget = ABUtilController.checkWidget(args);
        CriterioSelecaoController.setVisibilidadeCampos(widget);
    };

    this.newRow = function(args){
        ABUtilController.newRow(args);
        this.enableTipoPeriodoApuracao(args);
        this.enablePeriodoApuracao(args);
        this.enableData(args);
    };

    this.retrocederApuracao = function(args){
        var widget = ABUtilController.checkWidget(args);
        ScreenService.confirmMessage('Deseja realmente retroceder a apuração?', 'CONFIRMATION', 
            function(){
                var saveData = Object.assign({}, widget.currentRow, {
                        "NRORGTRAB": getLocalVar("HCM_NRORG_TRAB")
                    }, {
                        "DTCOMPETENCIA": getLocalVar("HCM_DTCOMPETENCIA_OPER")
                    }, {
                        "NRORGPADRAO": getLocalVar("HCM_NRORG_PADRAO")
                    });
                restEngine.post("product#/retrocederApuracao",
                        {'requestType':'DataSet','dataset':[saveData]}
                    ).then(function(data) {
                            if (Util.isEmptyOrBlank(data)) {
                                ScreenService.showMessage('Apuração retrocedida com sucesso!', 'SUCCESS');
                                ScreenService.closePopup();
                            } else {
                                if (data.messages && Array.isArray(data.messages)) {
                                    data.messages.forEach(function(mensagem){
                                        ScreenService.showMessage('Avisos retrocesso apuração: <br>' + mensagem.message);
                                        ScreenService.closePopup();
                                    });
                                } else {
                                    ScreenService.showMessage('Erro ao retroceder a apuração', 'ERROR');
                                }
                            }
                        }
                    ).catch(function(e) {
                        var error;
                        if(e.data.error === undefined)
                            error = e;
                        else 
                            error = e.data.error;
                        
                        ScreenService.showMessage('Ocorreu um erro inesperado, contate o administrador informando o trecho abaixo: <br><br>' + error + '<br><br>', 'ERROR');
                    });
            }.bind(this));
    };

    this.salvarApuracao = function(args){
        var widget = ABUtilController.checkWidget(args);
        if(widget.isValid())  {
            
            if (!widget.backupRow) {
                widget.currentRow.__is_new = true;
            } else {
                widget.currentRow.__is_new = false;
            }
            widget.currentRow.CDOPERADOR_LOG = getLocalVar("HCM_CDOPERADOR");
            widget.currentRow.NRORGTRAB = getLocalVar("HCM_NRORG_TRAB");
            widget.currentRow.NRORGPADRAO = getLocalVar("HCM_NRORG_PADRAO");
            return widget.saveRow().then(function (data){
                if (data.notifications[0].type === "success") {
                    if (widget.currentRow.__is_new) {
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    } else {
                        ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                        widget.backupRow = null;
                        widget.view();
                    }
                } else {
                    ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                }
            }.bind(this)).catch(function(e) {
                var error;
                if(e.data.error === undefined)
                    error = e;
                else 
                    error = e.data.error;
                
                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error));
            });
        }
    };

    this.setDsInicioFim = function(args){
        var widget = ABUtilController.checkWidget(args);
        this.DSINICIO.forEach(function(campo) {
            if(args.owner.field.name == campo && args.owner.field.name != 'NMESTRUTLEGAL'){
                widget.currentRow.DSINICIO = args.owner.field.value();
            }else if(args.owner.field.name == 'NMESTRUTLEGAL'){
                widget.currentRow.DSINICIO = widget.currentRow.NRESTRUTLEGAL;
            }
        });

        this.DSFIM.forEach(function(campo) {
            if(args.owner.field.name == campo){
                widget.currentRow.DSFIM = args.owner.field.value();
            }
            
            if(args.owner.field.name == 'NMESTRUTGEREN'){
                widget.currentRow.DSFIM = widget.currentRow.NRESTRUTGEREN;
            }
        });
    };

    this.simularApuracao = function(args){
       var widget = ABUtilController.checkWidget(args);
        ScreenService.confirmMessage('Deseja realmente simular apuração?', 'CONFIRMATION', 
            function(){
                var saveData = Object.assign({}, widget.currentRow, {
                        "NRORGTRAB": getLocalVar("HCM_NRORG_TRAB")
                    }, {
                        "DTCOMPETENCIA": getLocalVar("HCM_DTCOMPETENCIA_OPER")
                    }, {
                        "NRORGPADRAO": getLocalVar("HCM_NRORG_PADRAO")
                    });
                restEngine.post("product#/simularApuracao",
                        {'requestType':'DataSet','dataset':[saveData]}
                    ).then(function(data) {
                            if (!Util.isEmptyOrBlank(data)) {
                                if(!Util.isEmptyOrBlank(data.messages)){
                                    ScreenService.showMessage('Avisos simulação apuração: <br>' + data.messages[0].message);
                                    ScreenService.closePopup();
                                }
                                if(!Util.isEmptyOrBlank(data.dataset)){
                                    ScreenService.showMessage('Apuração simulada com sucesso. A simulação é limitada aos 5 primeiros vínculos encontrados.', 'SUCCESS');
                                    ScreenService.openWindow('product#hcm07023_pto_simulacao').then (function(){
                                            if(!Util.isEmptyOrBlank(data.messages))
                                                ScreenService.showMessage('A simulação é limitada aos 5 primeiros vínculos encontrados. ' + data.messages[0].message);
                                            var widgetSimulacao = templateManager.containers['product#hcm07023_pto_simulacao'].getWidget('simulacao');
                                            widgetSimulacao.dataSource.data = "";
                                            ABUtilController.applyDefaultFilterOnEnter(widgetSimulacao);
                                            widgetSimulacao.getField("NMVINCULOM").dataSourceFilter.forEach(function(filter){
                                                if(filter.name === 'DSORDEM'){
                                                    filter.value = data.dataset.gpeApuraFrequencia_setApuracaoFrequencia.DSORDEM;
                                                }

                                                if(filter.name === 'DSINICIO'){
                                                    filter.value = data.dataset.gpeApuraFrequencia_setApuracaoFrequencia.DSINICIO;
                                                }

                                                if(filter.name === 'DSFIM'){
                                                    filter.value = data.dataset.gpeApuraFrequencia_setApuracaoFrequencia.DSFIM;
                                                }

                                                if(filter.name === 'NRTIPOVINCULOM'){
                                                    filter.value = data.dataset.gpeApuraFrequencia_setApuracaoFrequencia.NRTIPOVINCULOM;
                                                }
                                                
                                                if(filter.name === 'NRPERIODOAPURACAO'){
                                                    filter.value = data.dataset.gpeApuraFrequencia_setApuracaoFrequencia.NRPERIODOAPURACAO;
                                                }
                                                
                                                if(filter.name === 'NRVINCULOM'){
                                                    filter.value = data.dataset.gpeApuraFrequencia_setApuracaoFrequencia.NRVINCULOM;
                                                }
                                                
                                            });

                                            widgetSimulacao.dataSourceFilter.forEach(function(filter){
                                                if(filter.name === 'DTINICIAL'){
                                                    filter.value = data.dataset.gpeApuraFrequencia_setApuracaoFrequencia.DTINICIAL;
                                                }

                                                if(filter.name === 'DTFINAL'){
                                                    filter.value = data.dataset.gpeApuraFrequencia_setApuracaoFrequencia.DTFINAL;
                                                }
                                                
                                                
                                                
                                            });
                                        widgetSimulacao.activate();
                                        });
                                    }
                            } else {
                                ScreenService.showMessage('Erro ao simular apuração');
                            }
                        }
                    ).catch(function(e) {
                        var error;
                        if(e.data.error === undefined)
                            error = e;
                        else 
                            error = e.data.error;
                        
                        ScreenService.showMessage('Ocorreu um erro inesperado, contate o administrador informando o trecho abaixo: <br><br>' + error + '<br><br>', 'ERROR');
                    });
            }.bind(this));
    };

}

Configuration(function(ContextRegister) {
    ContextRegister.register('ApuracaoFrequenciaController', ApuracaoFrequenciaController);
});


// FILE: assets/js/controllers/AquisicaoProdutoRuralController.js
function AquisicaoProdutoRuralController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, General,Messages) {
    
    this.adicionarRow = function(args) {
        var widget = args.owner.widget;
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
    };
    
    this.openPopupImportacoes = function(widget, action) {
        this.NMIMPORTACAO = action;
        var widgetPopupImportacao = templateManager.container.getWidget('popupImportacao');
        widgetPopupImportacao.currentRow.DSPATH = [];
        ScreenService.openPopup(widgetPopupImportacao);
    };
    
    this.validaArquivo = function(filePath) {
        var extension = filePath.split('.').pop().toUpperCase();
        if (extension !== 'XLS' && extension !== 'XLSX') {
            ScreenService.showMessage('Formato de arquivo inválido');
            return false;
        } else {
            return true;
        }
    };
    
    this.importarPlanilhaAquisicaoProdutoRural = function() {
        var widgetPop = templateManager.container.getActiveWidget();
        var widgetPai = templateManager.container.getWidget('AquisicaoDeProdutoRural');
        if( widgetPop.isValid() ){
            if( this.validaArquivo(widgetPop.currentRow.DSPATH[0].name) ){
                restEngine.post('product#/importarPlanilhaAquisicaoProdutoRural', {'requestType': 'DataSet', 'dataset': [widgetPop.currentRow]})
                .then(function(data) {
                    if( data.messages ){
                        ScreenService.closePopup(true);
                        ScreenService.showMessage(data.messages[0].message, data.messages[0].type);
                        if( data.dataset && data.dataset.msg ){
                            openPopupMensagensImportacao(data.dataset.msg);
                        } else {
                            widgetPai.activate();
                        }
                        widgetPai.reload();
                    } else {
                        ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                    }
                }).
                catch(function(e) {   
                    var error;
                    if( e.data.error === undefined ){
                        error = e;
                    } else {
                        error = e.data.error;
                        ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    }
                });
            }
        }
    };
    
    var openPopupMensagensImportacao = function(msg) {
        var widgetMensagens = templateManager.container.getWidget('mensagensImportacao');
        widgetMensagens.dataSource.data = msg;
        ScreenService.openPopup(widgetMensagens);
    };
    
    this.setAquisicaoProdutoRural = function(args) {
        var widget = args.owner.widget;
        
        if( widget.currentRow.VRRATDESCPR === undefined || widget.currentRow.VRRATDESCPR === null ){
            widget.currentRow.VRRATDESCPR = 0;
        }
        if( widget.currentRow.VRSENARDESC === undefined || widget.currentRow.VRSENARDESC === null ){
            widget.currentRow.VRSENARDESC = 0;
        }
        if( widget.currentRow.IDATIVO === undefined || widget.currentRow.IDATIVO === null ){
            widget.currentRow.IDATIVO = 'S';
        }
        
        var ajustaMascaraNumero = function(float){
            if( float.indexOf(".") ){
                var num = float.replace(".", "");
                float = num.replace(",", ".");
                return float;
            } else {
                return float.replace(',', '.');
            }
        };
        
        if( widget.currentRow.VRBRUTOAQUIS ){
            widget.currentRow.VRBRUTOAQUIS = ajustaMascaraNumero(widget.currentRow.VRBRUTOAQUIS);
        }
        if( widget.currentRow.VRCPDESCPR ){
            widget.currentRow.VRCPDESCPR = ajustaMascaraNumero(widget.currentRow.VRCPDESCPR);
        }
        
        if( widget.isValid() ){
            if( !widget.backupRow ){
                widget.currentRow.__is_new = true;
            } else {
                widget.currentRow.__is_new = false;
            }
            restEngine.post('product#/setAquisicaoProdutoRural', {'requestType': 'DataSet', 'dataset': [widget.currentRow]})
            .then(function(data) {
                if( data.notifications[0].type === "success" ){
                    ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                    if( widget.currentRow.__is_new ){
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    } else {
                        ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                        widget.backupRow = null;
                        widget.view();
                    }
                } else {
                    ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                }
            })
            .catch(function(e) {
                var error;
                if( e.data.error === undefined ){
                 error = e;
                } else {
                    error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                }
            });
        }
    };
    
    this.deleteAquisicaoProdutoRural = function(args) {
    ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
        var widget = args.owner.widget;
        widget.currentRow.__is_new = false;
        restEngine.post('product#/deleteAquisicaoProdutoRural', {'requestType':'DataSet','dataset':[widget.currentRow]})
        .then(function(data) {
                if( data.notifications[0].type === "success" ){
                    ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                    ABUtilController.masterDetailVoltarList(widget);
                    widget.reload();
                } else {
                    ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                }
            })
            .catch(function(e) {
                var error;
                if( e.data.error === undefined ){
                    error = e;
                } else { 
                    error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');   
                }
            });
        }, null);
    };
    
    this.verificaCampoInscricaoFornecedor = function(args) {
        var widget = ABUtilController.checkWidget(args);

        if( widget.currentRow.NRINSCPROD.match(/[a-z]/i) ){
            widget.currentRow.NRINSCPROD = undefined;
            widget.getField('NRINSCPROD').help = 'Esse campo só aceita valores numéricos!';
        } else if( widget.currentRow.NRINSCPROD.match(/[.|-|/]/g) ){
            widget.currentRow.NRINSCPROD = widget.currentRow.NRINSCPROD.replace(/[.|-|/]/g, '');
        }
    };

    
}

Configuration(function(ContextRegister) {
    ContextRegister.register('AquisicaoProdutoRuralController', AquisicaoProdutoRuralController);
});

// FILE: assets/js/controllers/AssociacaoContabilController.js
function AssociacaoContabilController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, General, Messages, $window) {

    var self = this;
    
    this.NMIMPORTACAO = null;

    this.adicionarRow = function(args) {
        var widget = args.owner.widget;
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
    };
    
	this.setAssociacaoContabil = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
            if (this.validaPeriodo(widget.currentRow.DTINIVIGENCIA, widget.currentRow.DTFIMVIGENCIA)) {
                if (!widget.backupRow) {
                    widget.currentRow.__is_new = true;
                } else {
                    widget.currentRow.__is_new = false;
                }
                restEngine.post('product#/setAssociacaoContabil', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                    then(function (data) {
                        if (data.notifications[0].type === "success") {
                            ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                            if (widget.currentRow.__is_new) {
                                ABUtilController.masterDetailVoltarList(widget);
                                widget.reload();
                            } else {
                                ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                                widget.backupRow = null;
                                widget.view();
                            }
                        }else if(data.notifications[0].message === 'HCM01037_FPA_REGISTRO_EXISTENTE')
                            ScreenService.showMessage(Messages.HCM01037_FPA_REGISTRO_EXISTENTE, 'ERROR');
                        else 
                            ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                    }).
                    catch(function(e) {
                        var error;
                        if(e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;
                            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    });
                    } else {
                        ScreenService.showMessage(Messages.HCM01037_FPA_DATA_INICIAL_MAIOR_QUE_FINAL);
                        return false;
                    }
            }  
    }; 
    
    this.deleteAssociacaoContabil = function(args) {
    ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
        var widget = args.owner.widget;
        widget.currentRow.__is_new = false;
        restEngine.post('product#/deleteAssociacaoContabil', {'requestType':'DataSet','dataset':[widget.currentRow]}).
            then(function(data){
                if(data.notifications[0].type === "success"){
                    ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                    ABUtilController.masterDetailVoltarList(widget);
                    widget.reload();
                } else {
                    ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                }
            }).
            catch(function(e) {
                var error;
                if(e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
        }, null);
    };
    
    this.deleteAssociacaoContabilChecked = function(args) {
    ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
        var dataSet = [];
        
        var widget = args.owner.widget;
        dataSet = widget.dataSource.getCheckedRows();
        widget.currentRow.__is_new = false;
        restEngine.post('product#/deleteAssociacaoContabilChecked', {'requestType':'DataSet','dataset':dataSet}).
            then(function(data){
                if(data.notifications[0].type === "success"){
                    ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                    ABUtilController.masterDetailVoltarList(widget);
                    widget.reload();
                } else {
                    ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                }
            }).
            catch(function(e) {
                var error;
                if(e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
        }, null);
    };
    
    this.openPopupCadAutomatico = function(args) {
        var widgetFilter = templateManager.container.getWidget('cadAssocCtbl');
        widgetFilter.applyDefaultValue();
        ScreenService.openPopup(widgetFilter);
    };   
    
    this.cadAutoAssocCtbl = function(args, nameWidgetPrincipal) {
        var widget = args.owner.widget;
        var widgetPrincipal = templateManager.container.getWidget(nameWidgetPrincipal);
        widget.currentRow.NRPARCNEGOCIO = widgetPrincipal.currentRow.NRPARCNEGOCIO;
        if (widget.isValid()) {
            restEngine.post('product#/cadAutoAssocCtbl', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                then(function (data) {
                    if(data.notifications[0].type === "success"){
                        ScreenService.showMessage(Messages.CADASTRO_AUTOMATICO_SUCCESS, 'SUCCESS');
                        ScreenService.closePopup();
                        templateManager.container.getWidget('associacaoContabil').activate();
                        templateManager.container.getWidget('associacaoContabil').reload();
                    }else if(data.notifications[0].message === 'HCM01037_FPA_REGISTROS_EXISTENTES')
                        ScreenService.showMessage(Messages.HCM01037_FPA_REGISTROS_EXISTENTES, 'ERROR');
                    else if(data.notifications[0].message === 'HCM01037_FPA_TODOS_EVENTOS_SELECIONADO')
                        ScreenService.showMessage(Messages.HCM01037_FPA_TODOS_EVENTOS_SELECIONADO, 'ERROR');
                    else
                        ScreenService.showMessage(Messages.SAVE_ROW_ERROR); 
                }).
                catch(function(e) {
                    var error;
                    if(e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;

                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
        }
    };
    
    this.validaPeriodo = function(dtIni, dtFin) {
        if (moment(dtIni, 'DD/MM/YYYY').unix() > moment(dtFin, 'DD/MM/YYYY').unix()) {
            return false;
        }
        else {
            return true;
        }
    };
    
    this.openPopupImportacao = function(widget, action) {
        this.NMIMPORTACAO = action;
        var widgetPopupImportacao = templateManager.container.getWidget('popupImportacaoPlanilha');
        widgetPopupImportacao.currentRow.IDOPCAOIMPORT = 'A';
        widgetPopupImportacao.currentRow.DSPATH = [];
        ScreenService.openPopup(widgetPopupImportacao);
    };
    
    this.baixarPlanilhaTemplate = function(action) {
        var widget = templateManager.container.getActiveWidget();
        ScreenService.confirmMessage("Deseja fazer o download da Planilha Template?", null, function () {
            widget.currentRow.NMIMPORTACAO = action;
            restEngine.post('product#/baixarPlanilhaTemplate', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                then(function(data) {
                    ScreenService.closePopup();
                    if(data.dataset && data.dataset.arquivo){
                        $window.open($window.serviceUrl + "/abrirArquivo?requestType=DataSet&dataset[0][CMARQUIVO]=" + data.dataset.arquivo.NMARQUIVO);
                        ABUtilController.masterDetailClosePopup(templateManager.container.getWidget("mensagens_loteLancEventos"));
                        templateManager.container.getWidget("loteLancEvento").reload();
                    }
                    if(data.dataset && data.dataset.erros){
                        var popUp = templateManager.container.getWidget("mensagensContabil");
                        popUp.dataSource.data = data.dataset.erros;
                        ABUtilController.masterDetailOpenPopup(popUp);
                    } else{
                        if (data.messages && data.messages[0].message) {
                            ScreenService.successNotification(Messages.IMPORTACAO_SUCCESS, 10000);
                            ABUtilController.masterDetailClosePopup(templateManager.container.getWidget("mensagensContabil"));
                            templateManager.container.getWidget("loteLancEvento").reload();
                        } else {
                            ScreenService.showMessage(Messages.EXPORTACAO_ERROR);
                        }
                    }
                    
                }).catch(function(e) {
                    var error;
                    if (e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;
                    
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
            },null);
        
    };

    this.importarPlanilhaContabil = function(action) {
        var widget = templateManager.container.getActiveWidget();
        if(widget.isValid()){
            var widgetPai = templateManager.container.getWidget('associacaoContabil');
            if (this.validaArquivo(widget.currentRow.DSPATH[0].name)) {
                restEngine.post('product#/importarPlanilha', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                then(function(data) {
                    if (data.messages) {
                        ScreenService.closePopup(true);
                        ScreenService.showMessage(data.messages[0].message, data.messages[0].type);
                        if (data.dataset && data.dataset.msg) {
                            openPopupMensagens(data.dataset.msg);
                        } else {
                            widgetPai.activate();
                        }
                        widgetPai.reload();
                    } else
                        ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                }).
                catch(function(e) {   
                    var error;
                    if (e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    
                });
            }
        }
    };

    this.validaArquivo = function(filePath) {
        var extension = filePath.split('.').pop().toUpperCase();
        if (extension !== 'XLS' && extension !== 'XLSX') {
            ScreenService.showMessage('Formato de arquivo inválido');
            return false;
        } else {
            return true;
        }
    };
    
    var openPopupMensagens = function(msg) {
        var widgetMensagens = templateManager.container.getWidget('mensagensContabil');
        widgetMensagens.dataSource.data = msg;
        ScreenService.openPopup(widgetMensagens);
    };
    
    this.voltarPai = function() {
        var widgetPai = templateManager.container.getWidget('associacaoContabil');
        widgetPai.activate();
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('AssociacaoContabilController', AssociacaoContabilController);
});

// FILE: assets/js/controllers/AssociacaoEventoController.js
function AssociacaoEventoController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, General,Messages) {

    this.adicionarRow = function(args) {
        var widget = args.owner.widget;
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
    };

	this.setAssociacaoEvento = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
                if (!widget.backupRow) {
                    widget.currentRow.__is_new = true;
                } else {
                    widget.currentRow.__is_new = false;
                }
                restEngine.post('product#/setAssociacaoEvento', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                    then(function (data) {
                        if (data.notifications[0].type === "success") {
                            ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                            if (widget.currentRow.__is_new) {
                                ABUtilController.masterDetailVoltarList(widget);
                                widget.reload();
                            } else {
                                ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                                widget.backupRow = null;
                                widget.view();
                            }
                        } else {
                            ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                        }
                    }).
                    catch(function(e) {
                        var error;
                        if(e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;
                            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    });
            }
    };
    
    this.deleteAssociacaoEvento = function(args) {
    ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
        var widget = args.owner.widget;
        widget.currentRow.__is_new = false;
        restEngine.post('product#/deleteAssociacaoEvento', {'requestType':'DataSet','dataset':[widget.currentRow]}).
            then(function(data){
                if(data.notifications[0].type === "success"){
                    ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                    ABUtilController.masterDetailVoltarList(widget);
                    widget.reload();
                } else {
                    ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                }
            }).
            catch(function(e) {
                var error;
                if(e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
        }, null);
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('AssociacaoEventoController', AssociacaoEventoController);
});

// FILE: assets/js/controllers/AssociacaoFinanceiraController.js
function AssociacaoFinanceiraController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, General, Messages) {

    var self = this;

    this.adicionarRow = function(args) {
        var widget = args.owner.widget;
        widget.currentRow = {}; 
        widget.backupRow = undefined;
        widget.newRow();
    };
 
    this.salvarAssociacaoFinanceira = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
            if (ABUtilController.validaDtIniMenorIgualDtFin(widget.currentRow.DTINIVIGENCIA, widget.currentRow.DTFIMVIGENCIA)) {
                if (!widget.backupRow) {
                    widget.currentRow.__is_new = true;
                } else {
                    widget.currentRow.__is_new = false;
                }
                restEngine.post('product#/salvarAssociacaoFinanceira', {
                    'requestType': 'DataSet',
                    'dataset': [widget.currentRow]
                }).
                then(function(data) {
                    if (data.notifications[0].type === "success") {
                        ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                        if (widget.currentRow.__is_new) {
                            ABUtilController.masterDetailVoltarList(widget);
                            widget.reload();
                        } else {
                            widget.backupRow = null;
                            widget.view();
                        }
                    } else {
                        ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                    }
                }).
                catch(function(e) {
                    var error;
                    if (e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
            } else {
                ScreenService.showMessage(Messages.DTINI_POST_DTFIM_ERROR);
                return false;
            }
        }
    };

    this.deleteAssociacaoFinanceira = function(args) {
    ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
        var widget = args.owner.widget;
        ScreenService.confirmMessage(Messages.DELETE_ROW, 'CONFIRMATION',
            function() {
                if (widget.isValid()) {
                    widget.currentRow.__is_new = false;
                    restEngine.post('product#/deleteAssociacaoFinanceira', {
                        'requestType': 'DataSet',
                        'dataset': [widget.currentRow]
                    }).
                    then(function(data) {
                        if (data.messages) {
                            ScreenService.showMessage(Messages.REMOVE_ROW_ERROR + '. ' + data.messages[0].message, data.messages[0].type);
                        } else {
                            ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                            ABUtilController.masterDetailVoltarList(widget);
                            widget.reload();
                        }
                    }).
                    catch(function(e) {
                        var error;
                        if (e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;
                        ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                        });
                    }
                }
            );
        }, null);
    };


}

Configuration(function(ContextRegister) {
    ContextRegister.register('AssociacaoFinanceiraController', AssociacaoFinanceiraController);
});


// FILE: assets/js/controllers/AssociacaoSituacaoFrequenciaController.js
function AssociacaoSituacaoFrequenciaController (ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, $window, ABUtilController, Messages) {
    
    this.assumirPadroes = function(args) {
        var widget = ABUtilController.checkWidget(args);
        var data = {}; 
        ScreenService.confirmMessage('Deseja reamente assumir todos os dados para o padrão?', 'CONFIRMATION', 
            function(){
                dados = Object.assign({}, {"NRORG": getLocalVar("HCM_NRORG_TRAB")});
                restEngine.post("product#/assumirPadroes",
                    {
                        requestType: "DataSet",
                        dataset: [dados]
                    }
                ).then(function (data) {
                    widget.reload();
                    if (!data.dataset.assumirPadroes) {
                        ScreenService.showMessage("Erro ao assumir padrões");
                    } else {
                        ScreenService.showMessage("Padrões assumidos com sucesso");
                        widget.getAction('assumirPadroes').isVisible = false;
                    } 
                }.bind(this)
                ).catch(function(e) {
                    var error;
                    if(e.data.error === undefined)
                        error = e;
                    else  
                        error = e.data.error;
                    ScreenService.showMessage('Ocorreu um erro inesperado, contate o administrador informando o trecho abaixo: <br><br>' + error + '<br><br>', 'ERROR');
                });
            }
               
        );
    };

    this.deleteAssociacaoSituacaoFrequencia = function(args) {
        var widget = ABUtilController.checkWidget(args);
        var data = {}; 
        ScreenService.confirmMessage(Messages.DELETE_ROW, 'CONFIRMATION', 
            function(){
                widget.dataSource.remove(widget.currentRow).then(function (data){
                    if(data.dataset.ptoTipoProgOcorrencia_setAssocSituacaoFrequencia.type === "success"){
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                        this.enableAssumirPadroes(args);
                        ScreenService.showMessage(Messages.REMOVE_ROW_SUCCESS); 
                    } else {
                        ScreenService.showMessage(Messages.REMOVE_ROW_ERROR); 
                    }
                }.bind(this));
            }.bind(this)
        );
    };

    this.enableAssumirPadroes = function(args){
        var widget = ABUtilController.checkWidget(args);
        widget.dataSource.data.forEach(function(dados){
            if(dados.NRORG !== parseInt(getLocalVar("HCM_NRORG_PADRAO"))) {
                widget.getAction('assumirPadroes').isVisible = true;
            }
        });
    };

    this.enableExcluir = function(args){
        var widget = ABUtilController.checkWidget(args);
        if(widget.currentRow.NRORG !== parseInt(getLocalVar("HCM_NRORG_PADRAO"))){
            widget.getAction('excluir').isVisible = true;
        } else {
            widget.getAction('excluir').isVisible = false;
        }
    };

    this.salvarAssociacaoSituacaoFrequencia = function(args){
        var argsRow = args.row;
        var widget = templateManager.container.getWidget("associacaoSituacaoFrequencia");
        if(widget.isValid())  {
            
            // if (widget.currentRow.NRORG === parseInt(getLocalVar("HCM_NRORG_PADRAO"))) {
            //     widget.currentRow.__is_new = true;
            // } else {
            //     widget.currentRow.__is_new = false;
            // }
            
            widget.currentRow.CDOPERADOR_LOG = getLocalVar("HCM_CDOPERADOR");
            widget.currentRow.NRORGTRAB = getLocalVar("HCM_NRORG_TRAB");
            widget.currentRow.NRORGPADRAO = getLocalVar("HCM_NRORG_PADRAO");
            widget.currentRow.DTATUAL = getLocalVar("HCM_DATA_ATUAL");
            return widget.saveRow().then(function (data){
                if (data.notifications[0].type === "success") {
                    ScreenService.showMessage(Messages.SAVE_ROW_SUCCESS);
                    ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                    widget.backupRow = null;
                    widget.view();
                    ScreenService.closeSwipe();
                    widget.getAction('excluir').isVisible = true;
                    widget.reload();
                } else {
                    ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                }
            }.bind(this)).catch(function(e) {
                var error;
                if(e.data.error === undefined)
                    error = e;
                else 
                    error = e.data.error;
                
                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error));
            });
        }
    };
    
    this.setDefaultRow = function() {
        var widget = templateManager.container.getWidget('associacaoSituacaoFrequencia');
        widget.currentRow.__is_new = true;
        widget.currentRow.CDOPERINCLUSAO    = getLocalVar('HCM_CDOPERADOR');
        widget.currentRow.CDOPERULTATU      = getLocalVar('HCM_CDOPERADOR');
        widget.currentRow.DTINCLUSAO        = getLocalVar('HCM_DATA_ATUAL');
        widget.currentRow.DTULTATU          = getLocalVar('HCM_DATA_ATUAL');
        widget.currentRow.NRORG             = getLocalVar('HCM_NRORG_TRAB');
        widget.currentRow.NRORGINCLUSAO     = getLocalVar('HCM_NRORG_TRAB');
        widget.currentRow.NRORGULTATU       = getLocalVar('HCM_NRORG_TRAB');
    };

}

Configuration(function(ContextRegister) {
    ContextRegister.register('AssociacaoSituacaoFrequenciaController', AssociacaoSituacaoFrequenciaController);
});

// FILE: assets/js/controllers/AtivPlanAcaoController.js
function AtivPlanAcaoController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, General,Messages) {
    
    var self = this;
    
    this.adicionarRow = function(args) {
        var widget = args.owner.widget;
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
        templateManager.container.getWidget('ativplanacao').reload();

    };

    
	this.setAtivPlanAcao = function(args) {
        var widget = args.owner.widget;
        var self = this;
        if (widget.isValid()) {
            if (ABUtilController.validaDtIniMenorIgualDtFin(widget.currentRow.DTINIVIGENCIA, widget.currentRow.DTFIMVIGENCIA)) {
                if (!widget.backupRow) {
                    widget.currentRow.__is_new = true;
                } else {
                    widget.currentRow.__is_new = false;
                }
                restEngine.post('product#/setAtivPlanAcao', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                    then(function (data) {
                        if (data.notifications[0].type === "success") {
                            ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                            if (widget.currentRow.__is_new) {
                                ABUtilController.masterDetailVoltarList(widget);
                                ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                                widget.reload();
                            } else {
                                ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                                widget.backupRow = null;
                                widget.view();
                            }
                        } else {
                            ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                        }
                    }).
                    catch(function(e) {
                        var error;
                        if(e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;
                            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    });
            }else{
                ScreenService.showMessage(Messages.DTINI_POST_DTFIM_ERROR);
                return false;
            }        
        }
        templateManager.container.getWidget('ativplanacao').reload();
    };
    
    this.deleteAtivPlanAcao = function(args) {
        var widget = templateManager.container.getActiveWidget();
        if (widget.isValid()) {
            widget.currentRow.__is_new = false;
            ScreenService.confirmMessage(Messages.DELETE_ROW, 'CONFIRMATION', function(){ 
            restEngine.post('product#/deleteAtivPlanAcao', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                then(function (data) {
                    if (data.messages) {
                        ScreenService.showMessage(Messages.REMOVE_ROW_ERROR + '. ' + data.messages[0].message, data.messages[0].type);
                    } else {
                        ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    }
                }).
                catch(function(e) {
                    var error;
                    if(e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;

                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
            });
        }
    templateManager.container.getWidget('ativplanacao').reload();
    };
    

}

Configuration(function(ContextRegister) {
    ContextRegister.register('AtivPlanAcaoController', AtivPlanAcaoController);
});

// FILE: assets/js/controllers/AuditoriaApuracaoController.js
function AuditoriaApuracaoController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, Messages) {

    this.cancelEdit = function(args){
        var widget = ABUtilController.checkWidget(args);
        widget.currentRow.DSINICIO = widget.currentRow.BKPDSINICIO;
        widget.currentRow.DSFIM = widget.currentRow.BKPDSFIM;
        widget.currentRow.BKPDSINICIO = null;
        widget.currentRow.BKPDSFIM = null;
        widget.getField("DSTIPOPERIODOAPURACAO").dataSourceFilter.forEach(function(dados){
            if(dados.name === 'NRTIPOVINCULOM'){
                dados.value = "";
            }
        });
        ABUtilController.masterDetailCancelaEdicao(widget);
    };

    this.deleteAuditoria = function(args) {
        var widget = ABUtilController.checkWidget(args);
        var data = {}; 
        ScreenService.confirmMessage(Messages.DELETE_ROW, 'CONFIRMATION', 
            function(){
                widget.dataSource.remove(widget.currentRow).then(function (data){
                    if(data.dataset.ptoAuditoraApuracao_setAuditoriaApuracao.type === "success"){
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                        ScreenService.showMessage(Messages.REMOVE_ROW_SUCCESS); 
                    } else {
                        ScreenService.showMessage(Messages.REMOVE_ROW_ERROR); 
                    }
                }.bind(this));
            }.bind(this)
        );
    };
    
    this.edit = function(args){
        var widget = ABUtilController.checkWidget(args);
        ABUtilController.masterDetailEdit(widget);
        widget.getField("DSPERIODOAPURACAO").readOnly = false;
        widget.getField("DSTIPOPERIODOAPURACAO").readOnly = false;
        widget.getField("NMVINCULOM").readOnly = false;
        widget.getField("DSTIPOPERIODOAPURACAO").reload().then(function(){
            widget.getField("DSTIPOPERIODOAPURACAO").dataSource.data.forEach(function(obj){
                if(obj.DSTIPOPERIODOAPURACAO == widget.currentRow.DSTIPOPERIODOAPURACAO){
                    widget.currentRow.NRTIPOPERIODOAPURACAO = obj.NRTIPOPERIODOAPURACAO;
                    widget.currentRow.NRTIPOVINCULOM = obj.NRTIPOVINCULOM;
                }
            });
            widget.getField("DSPERIODOAPURACAO").dataSourceFilter.forEach(function(dados){
                if(dados.name === 'NRTIPOPERIODOAPURACAO'){
                    dados.value = widget.currentRow.NRTIPOPERIODOAPURACAO;
                }
            });
            widget.getField("DSTIPOPERIODOAPURACAO").dataSourceFilter.forEach(function(dados){
                if(dados.name === 'NRTIPOVINCULOM'){
                    dados.value = widget.currentRow.NRTIPOVINCULOM;
                }
            });
        });
    
    };

    this.tipoPeriodoApuracaoOnChange = function(args){
        var widget = ABUtilController.checkWidget(args);
        widget.currentRow.DSPERIODOAPURACAO = '';
        widget.currentRow.NMVINCULOM = '';
        if(!Util.isEmptyOrBlank(widget.currentRow.DSTIPOPERIODOAPURACAO)){
            widget.getField("NMVINCULOM").readOnly = false;
            widget.getField("NMVINCULOM").dataSourceFilter.forEach(function(dados){
                if(dados.name === 'NRTIPOVINCULOM'){
                    dados.value = widget.currentRow.NRTIPOVINCULOM;
                    widget.getField("NMVINCULOM").reload();
                }
            });
        } else {
            widget.getField("NMVINCULOM").readOnly = true;
            widget.getField("NMVINCULOM").dataSourceFilter.forEach(function(dados){
                if(dados.name === 'NRTIPOVINCULOM'){
                    dados.value = widget.currentRow.NRTIPOVINCULOM;
                }
            });
        }        
        
        if(!Util.isEmptyOrBlank(widget.currentRow.DSTIPOPERIODOAPURACAO)){
            widget.getField("DSPERIODOAPURACAO").readOnly = false;
            widget.getField("DSPERIODOAPURACAO").dataSourceFilter.forEach(function(dados){
                if(dados.name === 'NRTIPOPERIODOAPURACAO'){
                    dados.value = widget.currentRow.NRTIPOPERIODOAPURACAO;
                }
            });
        } else {
            widget.getField("DSPERIODOAPURACAO").readOnly = true;
            widget.getField("DSPERIODOAPURACAO").dataSourceFilter.forEach(function(dados){
                if(dados.name === 'NRTIPOPERIODOAPURACAO'){
                    dados.value = widget.currentRow.NRTIPOPERIODOAPURACAO;
                }
            });
        }        

    };

    this.newRow = function(args){
        ABUtilController.newRow(args);
        // this.enableTipoPeriodoApuracao(args);
    };

    this.salvarAuditoria = function(args){
        var widget = ABUtilController.checkWidget(args);
        if(widget.isValid())  {
            
            if (!widget.backupRow) {
                widget.currentRow.__is_new = true;
            } else {
                widget.currentRow.__is_new = false;
            }
            widget.currentRow.CDOPERADOR_LOG = getLocalVar("HCM_CDOPERADOR");
            widget.currentRow.NRORGTRAB = getLocalVar("HCM_NRORG_TRAB");
            widget.currentRow.NRORGPADRAO = getLocalVar("HCM_NRORG_PADRAO");
            widget.currentRow.DTATUAL = getLocalVar("HCM_DATA_ATUAL");
            return widget.saveRow().then(function (data){
                if (data.notifications[0].type === "success") {
                    if (widget.currentRow.__is_new) {
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    } else {
                        ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                        widget.backupRow = null;
                        widget.view();
                    }
                } else {
                    ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                }
            }.bind(this)).catch(function(e) {
                var error;
                if(e.data.error === undefined)
                    error = e;
                else 
                    error = e.data.error;
                
                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error));
            });
        }
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('AuditoriaApuracaoController', AuditoriaApuracaoController);
});


// FILE: assets/js/controllers/AvaliacaoController.js
function AvaliacaoController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, General, Messages, HcmConsts) {
    var self = this;
    /*this.objActions = {
        'cadastro_automatico': {
            'name': 'cadastro_automatico',
            'label': 'Cadastro Automático',
            'fields': ["NRORG", "NRPARTICIPAVAL", "NRAVALIACAO", "NMAVALIADOR", "NMAVALIADO", "NRTIPORELACIONA", "IDSITUACAOAVAL", "VRRESULTAVALIA", "CDTIPORESU", "DTCONCLUSAOAVAL", "IDATIVO"],
            'nullable': ["VRRESULTAVALIA", "CDTIPORESU", "DTCONCLUSAOAVAL"]
        },
        'nova_questao': {
            'name': 'nova_questao',
            'label': 'Nova Questão',
            'fields': ["NRQUESTAO", "NRNIVELPADQUEST", "TXQUESTAO", "IDTIPOQUESTAO", "DTREVISAQUESTAO", "IDQUESTAOOBRIGA", "IDOPCAORESPOSTA", "IDATIVO"],
            'nullable': ["DTREVISAQUESTAO"]

        }
    };*/
    this.openPopup = function(widget, action) {
        var c_participante = templateManager.container.getWidget('cadastro_automatico');
        var c_questao = templateManager.container.getWidget('nova_questao');
        var i_relac = templateManager.container.getWidget('importa_relacionamento');
        if (action == 'cadastro_automatico') {
            ScreenService.openPopup(c_participante);
            c_participante.currentRow.IDATIVO = 'S';
            //c_participante.currentRow.DSATIVO = "Sim";
            c_participante.currentRow.IDSITUACAOAVAL = "PENDENTE";
            //c_participante.currentRow.DSSITUACAOAVAL = "Pendente";
        }
        else
        if (action == 'nova_questao') {
            ScreenService.openPopup(c_questao);

        }
        else
        if (action == 'importa_relacionamento') {
            ScreenService.openPopup(i_relac);

        }
    };

    this.importarRelacionamento = function(widget) {
        if (widget.isValid()) {
            restEngine.post('product#/importaRelacionamento', {
                'requestType': 'DataSet',
                'dataset': [widget.currentRow]
            }).
            then(function(data) {
                if (data.notifications) {
                    if (data.notifications[0].type == 'error') {
                        ScreenService.errorNotification(data.notifications[0].message, 10000);
                    }
                    else {
                        ScreenService.successNotification(data.notifications[0].message, 10000);
                    }
                    
                }
                else {
                    ScreenService.alertNotification("Nenhum registro valido encontrado", 10000);

                }
                widget.currentRow = {};
                ScreenService.closePopup(true);
                templateManager.container.getWidget('participantes').activate();
                templateManager.container.getWidget('participantes').reload();
            }).
            catch(function(e) {
                var error;
                if (e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
        }
    };

    this.closePopup = function(popup) {
        popup.currentRow = {};
        ScreenService.closePopup(true);
        popup.deactivate();
        popup.parent.parent.currentWidget.activate();
    };

    this.closePopupOpenWidget = function(popup, nomeWidget) {
        ScreenService.closePopup(true);
        templateManager.container.getWidget(nomeWidget).activate();
    };

    this.questoesUpdateFields = function(args) {
        var questoes = templateManager.container.getWidget('questoes');
        switch (questoes.currentRow.IDSORTQUESTAVAL) {
            case 'SEM_SORTEIO':
                questoes.getField('NMNIVELQUESTAO').readOnly = true;
                questoes.getField('TXQUESTAO').readOnly = false;
                questoes.getField('TXQUESTAO').validations.required = true;
                questoes.reload();
                break;
            case 'ABERTA':
                questoes.getField('NMNIVELQUESTAO').readOnly = false;
                questoes.getField('TXQUESTAO').readOnly = true;
                questoes.getField('TXQUESTAO').validations = {};
                questoes.reload();
                break;
            case 'FECHADA':
                questoes.getField('NMNIVELQUESTAO').readOnly = false;
                questoes.getField('TXQUESTAO').readOnly = true;
                questoes.getField('TXQUESTAO').validations = {};
                questoes.reload();
                break;
            default:
                questoes.getField('NMNIVELQUESTAO').readOnly = true;
                questoes.getField('TXQUESTAO').readOnly = false;
                questoes.getField('TXQUESTAO').validations.required = true;
                questoes.reload();
                break;
            
        }
    };


    this.cadastroAutomaticoParticipantes = function(widget) {
        widget.currentRow.NRAVALIACAO = templateManager.container.getWidget('avaliacao').currentRow.NRAVALIACAO;
    
        if (widget.isValid()) {
            if (!widget.backupRow) {
                    widget.currentRow.__is_new = true;
                }
                else {
                    widget.currentRow.__is_new = false;
                }
            restEngine.post('product#/cadastroAutomaticoParticipantes', {
                'requestType': 'DataSet',
                'dataset': [widget.currentRow]
            }).
            then(function(data) {
                ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 1000);
                ScreenService.closePopup(true);
                widget.currentRow = {};
                templateManager.container.getWidget('participantes').reload();
                templateManager.container.getWidget('participantes').activate();
            }).
            catch(function(e) {
                var error;
                if (e.data.error === undefined) error = e;
                else error = e.data.error;
                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
        }
        templateManager.container.getWidget('participantes').activate();
        templateManager.container.getWidget('participantes').reload();

    };

    this.importarModelo = function(widget) {
        ScreenService.confirmMessage(Messages.HCM03000_AVL_IMPORTACAO, null, function() {
            restEngine.post('product#/importarPadraAval', {
                'requestType': 'DataSet',
                'dataset': [widget.currentRow]
            }).
            then(function(data) {
                if (data.messages) {
                    ScreenService.showMessage(data.messages[0].message, data.messages[0].type);
                }
                else {
                    ScreenService.successNotification(Messages.HCM03000_AVL_IMPORTACAO_SUCESSO, 10000);
                    widget.reload();
                }
                ScreenService.closePopup(true);
            }).
            catch(function(e) {
                var error;
                if (e.data.error === undefined) error = e;
                else error = e.data.error;
                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });

        }, null);
    };
    
    this.liberarAvaliacao = function(widget) {
        ScreenService.confirmMessage(Messages.HCMO3000_AVL_LIBERACAO, null, function() {
            if(widget.isValid()){
                restEngine.post('product#/liberarAvaliacao', {
                    'requestType': 'DataSet',
                    'dataset': [widget.currentRow]
                }).
                then(function(data) {
                    if (data.messages) {
                        ScreenService.showMessage(data.messages[0].message, data.messages[0].type);
                        ScreenService.closePopup(true);
                        templateManager.container.getWidget('participantes').reload();
                        templateManager.container.getWidget('participantes').activate();
                    }
                    else {
                        ScreenService.successNotification(Messages.HCM03000_AVL_IMPORTACAO_SUCESSO, 10000);
                        ScreenService.closePopup(true);
                        templateManager.container.getWidget('participantes').reload();
                        templateManager.container.getWidget('participantes').activate();
                    }
                }).
                catch(function(e) {
                    var error;
                    if (e.data.error === undefined) error = e;
                    else error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
            }
        }, null);
    };


   this.avaliacaoAfterMoveRow = function(args) {
        args.owner.widgets.forEach(function(index) {
            if (index.dataSourceFilter[ABUtilController.retornaFiltro(index.dataSourceFilter, "NRAVALIACAO")]) {
                    index.dataSourceFilter[ABUtilController.retornaFiltro(index.dataSourceFilter, "NRAVALIACAO")].value = args.owner.currentRow.NRAVALIACAO;
            }else if(index.dataSourceFilter[ABUtilController.retornaFiltro(index.dataSourceFilter, "P_NRAVALIACAO")]){
                index.dataSourceFilter[ABUtilController.retornaFiltro(index.dataSourceFilter, "P_NRAVALIACAO")].value = args.owner.currentRow.NRAVALIACAO;
            }
        });
    };
    
    this.avaliacaoOnEnter = function(args){
        
        var widQuest = args.owner.widgets[ABUtilController.retornaWidget(args.owner, 'questoes')];
        widQuest.getField('NMTEMAANALISE').dataSourceFilter[ABUtilController.retornaFiltro(widQuest.getField('NMTEMAANALISE').dataSourceFilter, 'NRTIPOAVALIACAO')].value = args.owner.currentRow.NRTIPOAVALIACAO;
        
    };

    this.adicionarRow = function(args) {
        var widget = args.owner.widget;
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
    };

    this.adicionarParticipante = function(args) {
        var widget = args.owner.widget;
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
        widget.getField('NMAVALIADOR').reload();
        widget.getField('NMAVALIADO').reload();
    };

    this.setQuestao = function(widget) {
        if (widget.isValid()) {
            restEngine.post('product#/novaQuestao', {
                'requestType': 'DataSet',
                'dataset': [widget.currentRow]
            }).
            then(function(data) {
                //var dt = data.substr(data.indexOf("{"), data.lastIndexOf("}"));
                var questoes = templateManager.container.getWidget('questoes');
                questoes.currentRow.NRQUESTAO = data.dataset.cod[0];
                questoes.currentRow.TXQUESTAO = data.dataset.cod[1];
                questoes.fields[7].reload();
                ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 1000);
            }).
            catch(function(e) {
                var error;
                if (e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
        }
        widget.currentRow = {};
        ScreenService.closePopup(true);
        widget.deactivate();
        templateManager.container.getWidget('questoes').activate();
    };

    this.avaliacaoWidgetsOnEnter = function(args) {
        args.owner.reload();
        args.owner.fields.forEach(function(index) {
            if (index.dataSourceFilter) {
                if (index.dataSourceFilter[ABUtilController.retornaFiltro(index.dataSourceFilter, "NRAVALIACAO")]) {        
                    index.dataSourceFilter[ABUtilController.retornaFiltro(index.dataSourceFilter, "NRAVALIACAO")].value = templateManager.container.getWidget('avaliacao').currentRow.NRAVALIACAO;
                    index.reload();
                }else if(index.dataSourceFilter[ABUtilController.retornaFiltro(index.dataSourceFilter, "P_NRAVALIACAO")]){
                    index.dataSourceFilter[ABUtilController.retornaFiltro(index.dataSourceFilter, "P_NRAVALIACAO")].value = templateManager.container.getWidget('avaliacao').currentRow.NRAVALIACAO;
                    index.reload();
                }
            }
        });
        args.owner.reload();
    };
    this.combinacaoAfterMoveRow = function(args) {
        var combinacao = templateManager.container.getWidget('combquestoes');
        if (combinacao.currentRow.NRAVALIACAO === null) {
            combinacao.actions[2].isVisible = false;
            combinacao.actions[3].isVisible = false;
        }
        else {
            combinacao.actions[2].isVisible = true;
            combinacao.actions[3].isVisible = true;
        }
    };

    this.cadastroAutomaticoOnEnter = function(args) {
        var cadastro_automatico = templateManager.container.getWidget('cadastro_automatico');
        var i;
        for (i = 0; i <= 4; i++) {
            cadastro_automatico.fields[i].reload();
            cadastro_automatico.fields[i].readOnly = false;
        }
    };

    this.TipoAvalOnChange = function(widget) {
        var avaliacao = templateManager.container.getWidget('avaliacao');
        
        widget.getField('NMPADRAVALIACAO').dataSourceFilter = [
                        {
                            "name": "P_NRORG",
                            "operator": "=",
                            "value": "@getLocalVar('HCM_NRORG_TRAB') ? getLocalVar('HCM_NRORG_TRAB') : '' @"
                        },
                        {
                            "name": "P_NRORG_PADRAO",
                            "operator": "=",
                            "value": "@getLocalVar('HCM_NRORG_PADRAO') ? getLocalVar('HCM_NRORG_PADRAO') : '' @"
                        },
                        {
                            "name": "NRTIPOAVALIACAO",
                            "operator": "=",
                            "value": avaliacao.currentRow.NRTIPOAVALIACAO
                        }
        ];
        if(avaliacao.currentRow.NMTIPOAVALIACAO != ''){
        widget.getField('NMPADRAVALIACAO').readOnly = false;
        avaliacao.currentRow.NMPADRAVALIACAO = "";
        avaliacao.currentRow.NRPADRAVALIACAO = "";
        widget.getField('NMPADRAVALIACAO').reload();
        widget.getField('NMNIVELAVALIA').reload();
        }else{
            widget.getField('NMPADRAVALIACAO').readOnly = true;
        }
    };
    this.importaRelacionamentoOnEnter = function(args) {
        var widget = templateManager.container.getWidget('importa_relacionamento');
        widget.newRow();
        widget.currentRow.IDORDEM = 'ALFABETICA';
        widget.currentRow.DSORDEM = 'Alfabética';
        this.ordemChangeFields('NMVINCULOM_INI', 'NMVINCULOM_FIN');
        widget.getField('NMPRINCIPALPARC').isVisible = false;
        widget.getField('NMPRINCIPALPARC').validations = {};
        widget.reload();
        widget.currentRow.NRAVALIACAO = templateManager.container.getWidget('avaliacao').currentRow.NRAVALIACAO;

    };
    this.relacFieldOnChange = function(args) {
        var widget = templateManager.container.getWidget('importa_relacionamento');
        if (widget.currentRow.NRTIPORELACIONA === HcmConsts.RelacionaParc.PARCEIRO) {
            widget.getField('NMPRINCIPALPARC').isVisible = true;
            widget.getField('NMPRINCIPALPARC').validations = {
                "required": {}
            };

        }
        else {
            widget.getField('NMPRINCIPALPARC').isVisible = false;
            widget.getField('NMPRINCIPALPARC').validations = {};
        }
    };

    this.ordemFieldOnChange = function(args) {
        switch (args.owner.owner.value()) {
            case 'ALFABETICA':
                this.ordemChangeFields('NMVINCULOM_INI', 'NMVINCULOM_FIN');
                break;
            case 'MATRICULA':
                this.ordemChangeFields('VRMATRICULA_INI', 'VRMATRICULA_FIN');
                break;
            case 'DATA_ADMISSAO':
                this.ordemChangeFields('DTADMISS_INI', 'DTADMISS_FIN');
                break;
            case 'ESTRUTURA':
                this.ordemChangeFields('NM_ESTRUTURA_LEG', 'NM_ESTRUTURA_GER');
                break;
            default:
                this.ordemChangeFields('NMVINCULOM_INI', 'NMVINCULOM_FIN');
        }
    };

    this.ordemChangeFields = function(campo1, campo2) {
        var widget = templateManager.container.getWidget('importa_relacionamento');
        var campos = ['NMVINCULOM_INI', 'NMVINCULOM_FIN', 'VRMATRICULA_INI', 'VRMATRICULA_FIN', 'DTADMISS_INI', 'DTADMISS_FIN', 'NM_ESTRUTURA_LEG', 'NM_ESTRUTURA_GER'];
        campos.forEach(function(campo) {
            if (campo == campo1 || campo == campo2) {
                widget.getField(campo).isVisible = true;
                widget.getField(campo).validations = {
                    "required": {}
                };
            }
            else {
                widget.getField(campo).isVisible = false;
                widget.getField(campo).validations = {};
            }
        });
    };

    this.setAvaliacaoGeral = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
            if(widget.currentRow.QTMAXPARTICAVAL >= widget.currentRow.QTMINPARTICAVAL || widget.currentRow.QTMAXPARTICAVAL == null)
            {
                if(ABUtilController.validaDtIniMenorIgualDtFin(widget.currentRow.DTINIINSCRIAVAL , widget.currentRow.DTFIMINSCRIAVAL) && ABUtilController.validaDtIniMenorIgualDtFin(widget.currentRow.DTINIREALIZAVAL , widget.currentRow.DTFIMREALIZAVAL))
                {
                    
            {
                if (!widget.backupRow) {
                    widget.currentRow.__is_new = true;
                }
                else {
                    widget.currentRow.__is_new = false;
                }
                restEngine.post('product#/setAvaliacaoGeral', {
                    'requestType': 'DataSet',
                    'dataset': [widget.currentRow]
                }).
                then(function(data) {
                    if (data.notifications[0].type === "success") {
                        ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                        ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                        if (widget.currentRow.__is_new) {
                            ABUtilController.masterDetailVoltarList(widget);
                            widget.reload();
                        }
                        else {
                            widget.backupRow = null;
                            widget.view();
                        }
                    }
                    else {
                        ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                    }
                }).
                catch(function(e) {
                    var error;
                    if (e.data.error === undefined) error = e;
                    else error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
            }

        
                }
                else
                    ScreenService.showMessage(Messages.DTINI_POST_DTFIM_ERROR);
            }
            else
                ScreenService.showMessage("A Quantidade maxima de participantes não pode ser menor que a minima");
        }
    };

    this.setQuestAvaliacao = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
            if (!widget.backupRow) {
                widget.currentRow.__is_new = true;
            }
            else {
                widget.currentRow.__is_new = false;
            }
            widget.currentRow.NRAVALIACAO = templateManager.container.getWidget('avaliacao').currentRow.NRAVALIACAO;
            restEngine.post('product#/setQuestAvaliacao', {
                'requestType': 'DataSet',
                'dataset': [widget.currentRow]
            }).
            then(function(data) {
                if (data.messages) {
                    ScreenService.showMessage(data.messages[0].message, data.messages[0].type);
                }
                if (data.notifications[0].type == "success") {
                    ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                    if (widget.currentRow.__is_new) {
                        ABUtilController.masterDetailVoltarList(widget);
                        templateManager.container.getWidget('questoes').reload();
                    }
                    else {
                        ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                        widget.backupRow = null;
                        widget.view();
                    }
                }
                else {
                    ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                }
            }).
            catch(function(e) {
                var error;
                if (e.data.error === undefined) error = e;
                else error = e.data.error;
                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
        }
    };

    this.setParticipante = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
            if (!widget.backupRow) {
                widget.currentRow.__is_new = true;
            }
            else {
                widget.currentRow.__is_new = false;
            }
            widget.currentRow.NRAVALIACAO = templateManager.container.getWidget('avaliacao').currentRow.NRAVALIACAO;
            restEngine.post('product#/setParticipante', {
                'requestType': 'DataSet',
                'dataset': [widget.currentRow]
            }).
            then(function(data) {
                if (data.messages) {
                    ScreenService.showMessage(data.messages[0].message, data.messages[0].type);
                }
                if (data.notifications[0].type == "success") {
                    ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                    if (widget.currentRow.__is_new) {
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    }
                    else {
                        ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                        widget.backupRow = null;
                        widget.view();
                    }
                }
                else {
                    ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                }
            }).
            catch(function(e) {
                var error;
                if (e.data.error === undefined) error = e;
                else error = e.data.error;
                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
        }
    };

    this.setCombAval = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
            if (!widget.backupRow) {
                widget.currentRow.__is_new = true;
            }
            else {
                widget.currentRow.__is_new = false;
            }
            widget.currentRow.NRAVALIACAO = templateManager.container.getWidget('avaliacao').currentRow.NRAVALIACAO;
            restEngine.post('product#/setCombAval', {
                'requestType': 'DataSet',
                'dataset': [widget.currentRow]
            }).
            then(function(data) {
                if (data.notifications[0].type === "success") {
                    ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                    if (widget.currentRow.__is_new) {
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    }
                    else {
                        ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                        widget.backupRow = null;
                        widget.view();
                    }
                }
                else {
                    ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                }
            }).
            catch(function(e) {
                var error;
                if (e.data.error === undefined) error = e;
                else error = e.data.error;
                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });

        }
    };

    this.setAgrupAval = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {

            if (!widget.backupRow) {
                widget.currentRow.__is_new = true;
            }
            else {
                widget.currentRow.__is_new = false;
            }
            widget.currentRow.NRAVALIACAO = templateManager.container.getWidget('avaliacao').currentRow.NRAVALIACAO;
            restEngine.post('product#/setAgrupAval', {
                'requestType': 'DataSet',
                'dataset': [widget.currentRow]
            }).
            then(function(data) {
                if (data.notifications[0].type === "success") {
                    ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                    if (widget.currentRow.__is_new) {
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    }
                    else {
                        ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                        widget.backupRow = null;
                        widget.view();
                    }
                }
                else {
                    ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                }
            }).
            catch(function(e) {
                var error;
                if (e.data.error === undefined) error = e;
                else error = e.data.error;
                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });

        }
        templateManager.container.getWidget('avaliacao').reload();
    };

    this.setTipoRelacAval = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
            if (!widget.backupRow) {
                widget.currentRow.__is_new = true;
            }
            else {
                widget.currentRow.__is_new = false;
            }
            widget.currentRow.NRAVALIACAO = templateManager.container.getWidget('avaliacao').currentRow.NRAVALIACAO;
            restEngine.post('product#/setTipoRelacAval', {
                'requestType': 'DataSet',
                'dataset': [widget.currentRow]
            }).
            then(function(data) {
                if (data.messages) {
                    ScreenService.showMessage(data.messages[0].message, data.messages[0].type);
                }
                else {
                    if (data.notifications[0].type === "success") {
                        ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                        if (widget.currentRow.__is_new) {
                            ABUtilController.masterDetailVoltarList(widget);
                            widget.reload();
                        }
                        else {
                            ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                            widget.backupRow = null;
                            widget.view();
                        }
                    }
                    else {
                        ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                    }

                }
            }).
            catch(function(e) {
                var error;
                if (e.data.error === undefined) error = e;
                else error = e.data.error;
                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });

        }
        templateManager.container.getWidget('avaliacao').reload();
    };

    this.deleteParticipante = function(args) {
        ScreenService.confirmMessage(Messages.DELETE_ROW, null, function() {
            var widget = templateManager.container.getActiveWidget();
            if (widget.isValid()) {
                widget.currentRow.__is_new = false;
                restEngine.post('product#/deleteParticipante', {
                    'requestType': 'DataSet',
                    'dataset': [widget.currentRow]
                }).
                then(function(data) {
                    if (data.messages) {
                        ScreenService.showMessage(data.messages[0].message, data.messages[0].type);
                    }
                    else {
                        ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    }
                }).
                catch(function(e) {
                    var error;
                    if (e.data.error === undefined) error = e;
                    else error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
            }
        }, null);
    };

    this.deleteAvaliacaoGeral = function(args) {
        ScreenService.confirmMessage(Messages.DELETE_ROW, null, function() {
            var widget = templateManager.container.getActiveWidget();
            widget.currentRow.__is_new = false;
            restEngine.post('product#/deleteAvaliacaoGeral', {
                'requestType': 'DataSet',
                'dataset': [widget.currentRow]
            }).
            then(function(data) {
                if (data.messages) {
                    ScreenService.showMessage(data.messages[0].message, data.messages[0].type);
                }
                else {
                    ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                    ABUtilController.masterDetailVoltarList(widget);
                    widget.reload();
                }
            }).
            catch(function(e) {
                var error;
                if (e.data.error === undefined) error = e;
                else error = e.data.error;
                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });

        }, null);
    };


    this.deleteQuestAvaliacao = function(args) {
        ScreenService.confirmMessage(Messages.DELETE_ROW, null, function() {
            var widget = templateManager.container.getActiveWidget();
            if (widget.isValid()) {
                widget.currentRow.__is_new = false;
                restEngine.post('product#/deleteQuestAvaliacao', {
                    'requestType': 'DataSet',
                    'dataset': [widget.currentRow]
                }).
                then(function(data) {
                    if (data.messages) {
                        ScreenService.showMessage(Messages.REMOVE_ROW_ERROR + '. ' + data.messages[0].message, data.messages[0].type);
                    }
                    else {
                        ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    }
                }).
                catch(function(e) {
                    var error;
                    if (e.data.error === undefined) error = e;
                    else error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
            }
        }, null);
    };

    this.deleteRespostaAval = function(args) {
        ScreenService.confirmMessage(Messages.DELETE_ROW, null, function() {
            var widget = templateManager.container.getActiveWidget();
            if (widget.isValid()) {
                widget.currentRow.__is_new = false;
                restEngine.post('product#/deleteRespostaAval', {
                    'requestType': 'DataSet',
                    'dataset': [widget.currentRow]
                }).
                then(function(data) {
                    if (data.messages) {
                        ScreenService.showMessage(Messages.REMOVE_ROW_ERROR + '. ' + data.messages[0].message, data.messages[0].type);
                    }
                    else {
                        ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    }
                }).
                catch(function(e) {
                    var error;
                    if (e.data.error === undefined) error = e;
                    else error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
            }
        }, null);
    };

    this.deleteCombAval = function(args) {
        ScreenService.confirmMessage(Messages.DELETE_ROW, null, function() {
            var widget = templateManager.container.getActiveWidget();
            if (widget.isValid()) {
                widget.currentRow.__is_new = false;
                restEngine.post('product#/deleteCombAval', {
                    'requestType': 'DataSet',
                    'dataset': [widget.currentRow]
                }).
                then(function(data) {
                    if (data.messages) {
                        ScreenService.showMessage(Messages.REMOVE_ROW_ERROR + '. ' + data.messages[0].message, data.messages[0].type);
                    }
                    else {
                        ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    }
                }).
                catch(function(e) {
                    var error;
                    if (e.data.error === undefined) error = e;
                    else error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
            }
        }, null);
    };

    this.deleteAgrupamento = function(args) {
        ScreenService.confirmMessage(Messages.DELETE_ROW, null, function() {
            var widget = templateManager.container.getActiveWidget();
            if (widget.isValid()) {
                widget.currentRow.__is_new = false;
                restEngine.post('product#/deleteAgrupAval', {
                    'requestType': 'DataSet',
                    'dataset': [widget.currentRow]
                }).
                then(function(data) {
                    if (data.messages) {
                        ScreenService.showMessage(Messages.REMOVE_ROW_ERROR + '. ' + data.messages[0].message, data.messages[0].type);
                    }
                    else {
                        ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    }
                }).
                catch(function(e) {
                    var error;
                    if (e.data.error === undefined) error = e;
                    else error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
            }
        }, null);
    };

    this.deleteTipoRelacAval = function(args) {
        ScreenService.confirmMessage(Messages.DELETE_ROW, null, function() {
            var widget = templateManager.container.getActiveWidget();
            if (widget.isValid()) {
                widget.currentRow.__is_new = false;
                restEngine.post('product#/deleteTipoRelacAval', {
                    'requestType': 'DataSet',
                    'dataset': [widget.currentRow]
                }).
                then(function(data) {
                    if (data.messages) {
                        ScreenService.showMessage(Messages.REMOVE_ROW_ERROR + '. ' + data.messages[0].message, data.messages[0].type);
                    }
                    else {
                        ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    }
                }).
                catch(function(e) {
                    var error;
                    if (e.data.error === undefined) error = e;
                    else error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
            }
        }, null);
    };

}
Configuration(function(ContextRegister) {
    ContextRegister.register('AvaliacaoController', AvaliacaoController);
});


// FILE: assets/js/controllers/BancoAgenciaController.js
function BancoAgenciaController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, General,Messages) {
    
    var self = this;
    
    this.limpaCamposCep = function(widget){
        widget.CDPAIS = "";
        widget.NMPAIS = ""; 
        widget.SGESTADO = ""; 
        widget.NMESTADO = ""; 
        widget.CDMUNICIPIO = ""; 
        widget.NMMUNICIPIO = ""; 
        widget.CDBAIRRO = ""; 
        widget.DSBAIRAGEN = ""; 
        widget.DSENDEAGEN = "";
    };
    
    this.buscarCep = function(args) {
        var messageError = "Um erro foi identificado! Favor verificar seu CEP ou sua conexão com a Internet";
        var widget = args.owner.field.widget.currentRow;
        if(widget.NRCEPAGEN){
            var cep = widget.NRCEPAGEN;
            cep = cep.replace(/[\.-]/g, '');
            if (cep.length === 8) { 
                restEngine.post('product#/lib_findAddress',
                {'requestType':'Row','row':{'CEP': cep, 'NRORG': getLocalVar('HCM_NRORG_TRAB')}},
                function(array) {
                    if(array && array.dataset){
                        var data = array.dataset.ENDERECO;
                        if(data) {
                            if(data.CDPAIS) {
                                widget.CDPAIS = data.CDPAIS;
                                widget.NMPAIS = data.NMPAIS;
                                widget.SGESTADO = data.SGESTADO;
                                widget.NMESTADO = data.NMESTADO;
                                if((data.CDMUNICIPIO)) {
                                    widget.CDMUNICIPIO = data.CDMUNICIPIO;
                                    widget.NMMUNICIPIO = data.NMMUNICIPIO;
                                    if((data.NMBAIRRO)) {
                                        widget.CDBAIRRO = data.CDBAIRRO;
                                        widget.DSBAIRAGEN = data.NMBAIRRO.toUpperCase();
                                        widget.DSENDEAGEN = data.DSENDERECO.toUpperCase();
                                    }
                                }
                            }
                        }
                    }else{
                        ScreenService.showMessage(messageError);
                        if(widget.NRCEPAGEN) widget.NRCEPAGEN = "";
                    }
                }, undefined, 
                function(error) {
                    ScreenService.showMessage(messageError);
                    self.limpaCamposCep(widget);
                });
            } 
            else {
                ScreenService.showMessage(messageError);
                this.limpaCamposCep(widget);
            } 
        }else {
            ScreenService.showMessage('Favor digitar um CEP');
            this.limpaCamposCep(widget);
        }  
    };
    
    this.adicionarRow = function(args) {
        var widget = args.owner.widget;
        widget.currentRow = {};
        widget.backupRow = undefined;
        if(widget.name == 'agencia'){
            widget.getField('CDAGENCIA').readOnly = false;
        }
        widget.newRow();
    };
    
    this.bloqueiaCdagencia = function(){
        var widget = templateManager.container.getActiveWidget();
        widget.getField('CDAGENCIA').readOnly = true;
    };
    
    this.filtrarWidgetPorBancoAgencia = function(args){
        var widget = args.owner;
        templateManager.container.getWidget("agencia").dataSourceFilter[0].value = widget.currentRow.CDBANCO;
    };
    
    this.filtrarEstadoMunicipioPorPais = function(args){
        var widget = ABUtilController.checkWidget(args);
        widget.getField('SGESTADO').dataSourceFilter[0].value = widget.currentRow.CDPAIS;
        widget.getField('NMMUNICIPIO').dataSourceFilter[0].value = widget.currentRow.CDPAIS;
        widget.getField('NMMUNICIPIO').dataSourceFilter[1].value = widget.currentRow.SGESTADO;
        if(!widget.currentRow.NMPAIS){
            widget.currentRow.SGESTADO = "";
            widget.currentRow.NMMUNICIPIO = "";
        }
        if(!widget.currentRow.SGESTADO){
            widget.currentRow.NMMUNICIPIO = "";
        }
    };
    
    this.widgetsvisiblefalse = function(args) {
        var widget = args.owner.widget;
        widget.widgets[0].showAsTab = false;
    };

    this.widgetsvisibletrue = function(args) {
        var widget = args.owner.widget;
        widget.widgets[0].showAsTab = true;
    };
    
	this.setBanco = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
            if (ABUtilController.validaDtIniMenorIgualDtFin(widget.currentRow.DTINIVIGENCIA, widget.currentRow.DTFIMVIGENCIA)) {
                if (!widget.backupRow) {
                    widget.currentRow.__is_new = true;
                } else {
                    widget.currentRow.__is_new = false;
                }
                restEngine.post('product#/setBanco', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                    then(function (data) {
                        if (data.messages) {
                            ScreenService.showMessage(data.messages[0].message, data.messages[0].type);
                            if (widget.currentRow.__is_new) {
                                ABUtilController.masterDetailVoltarList(widget);
                                self.widgetsvisibletrue(args);
                                widget.reload();
                            } else {
                                ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                                widget.backupRow = null;
                                widget.view();
                            }
                        } else {
                            ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                        }
                    }).
                    catch(function(e) {
                        var error;
                        if(e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;
                            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    });
            }else{
                ScreenService.showMessage(Messages.DTINI_POST_DTFIM_ERROR);
                return false;
            }        
        }
    };
    
    this.deleteBanco = function(args) {
    ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
        var widget = templateManager.container.getActiveWidget();
        if (widget.isValid()) {
            widget.currentRow.__is_new = false;
            restEngine.post('product#/deleteBanco', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                then(function (data) {
                    if (data.messages) {
                        ScreenService.showMessage(Messages.REMOVE_ROW_ERROR + '. ' + data.messages[0].message, data.messages[0].type);
                    } else {
                        ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    }
                }).
                catch(function(e) {
                    var error;
                    if(e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;

                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
            }
        }, null);
    };
    
	this.setAgencia = function(args) {
        var widget = args.owner.widget;
        var widgetMain = templateManager.container.getWidget("banco");
        if (widget.isValid()) {
                if (!widget.backupRow) {
                    widget.currentRow.__is_new = true;
                } else {
                    widget.currentRow.__is_new = false;
                }
                widget.currentRow.CDBANCO = widgetMain.currentRow.CDBANCO;
                restEngine.post('product#/setAgencia', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                    then(function (data) {
                        if(data.messages){
                            ScreenService.showMessage(data.messages[0].message);
                            ABUtilController.masterDetailVoltarList(widget);
                            widget.reload();
                        }else{
                            if (data.notifications[0].type === "success") {
                                ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                                if (widget.currentRow.__is_new) {
                                    ABUtilController.masterDetailVoltarList(widget);
                                    self.widgetsvisibletrue(args);
                                    widget.reload();
                                } else {
                                    ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                                    widget.backupRow = null;
                                    widget.view();
                                }
                            } else {
                                ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                            }
                        }    
                    }).
                    catch(function(e) {
                        var error;
                        if(e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;
                            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    });
        }
    };
    
    this.deleteAgencia = function(args) {
        var widget = args.owner.widget;
        widget.currentRow.__is_new = false;
        ScreenService.confirmMessage(Messages.DELETE_ROW, 'CONFIRMATION', function(){
            restEngine.post('product#/deleteAgencia', {'requestType':'DataSet','dataset':[widget.currentRow]}).
                then(function(data){
                    if(data.notifications[0].type === "success"){
                        ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    } else {
                        ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                    }
                }).
                catch(function(e) {
                    var error;
                    if(e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;
                        ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
        }.bind(this));
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('BancoAgenciaController', BancoAgenciaController);
});

// FILE: assets/js/controllers/BancoHorasAdmissaoController.js
function BancoHorasAdmissaoController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, ABUtilController, AFormataHoraDecimal, Messages) {
    
    this.newRow = function(){
        var widget = templateManager.container.getActiveWidget();
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
    };
    
    this.saveBancoHorasAdmissao = function(){
        var widget = templateManager.container.getActiveWidget();
        if(widget.isValid()){
            if (!widget.backupRow) {
                widget.currentRow.__is_new = true;
            }else {
                widget.currentRow.__is_new = false;
            }
            restEngine.post('product#/setBancoHorasAdmissao', {
                'requestType': 'DataSet',
                'dataset': [widget.currentRow]
            }).
            then(function(data) {
                if (data.notifications[0].type === "success") {
                    ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 1000);
                    if(widget.currentRow.__is_new){
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    } else {
                        widget.reload();
                        widget.view();
                    }
                }
                else {
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                }
            }).catch(function(e) {
                var error;
                if (e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });    
        }
    };
    
    this.deleteBancoHorasAdmissao = function(){
        var widget =  templateManager.container.getActiveWidget();
        ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
            widget.currentRow.__is_new = false;
            restEngine.post('product#/deleteBancoHorasAdmissao', {
                    'requestType': 'DataSet',
                    'dataset': [widget.currentRow]
                }).
                then(function(data) {
                    if (data.notifications[0].type === "success") {
                        ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 1000);
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    }
                    else {
                        ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                    }
                }).catch(function(e) {
                    var error;
                    if (e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;
                        ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                }); 
        }, null);
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('BancoHorasAdmissaoController', BancoHorasAdmissaoController);
});

// FILE: assets/js/controllers/BancoQuestoesController.js
function BancoQuestoesController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, General,Messages) {

    this.adicionarRow = function(args) {
        var widget = args.owner.widget;
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
    };


	this.setQuestao = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
                if (!widget.backupRow) {
                    widget.currentRow.__is_new = true;
                } else {
                    widget.currentRow.__is_new = false;
                }
                restEngine.post('product#/setQuestao', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                    then(function (data) {
                        if (data.notifications[0].type === "success") {
                            ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                            if (widget.currentRow.__is_new) {
                                ABUtilController.masterDetailVoltarList(widget);
                                ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                                widget.reload();
                            } else {
                                ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                                widget.backupRow = null;
                                widget.view();
                            }
                        } else {
                            ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                        }
                    }).
                    catch(function(e) {
                        var error;
                        if(e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;
                            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    });
            }
    };
    
    this.deleteQuestao = function(args) {
        var widget = args.owner.widget;
        widget.currentRow.__is_new = false;
        ScreenService.confirmMessage(Messages.DELETE_ROW, 'CONFIRMATION', function(){
            restEngine.post('product#/deleteQuestao', {'requestType':'DataSet','dataset':[widget.currentRow]}).
            then(function(data){
                if(data.notifications[0].type === "success"){
                    ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                    ABUtilController.masterDetailVoltarList(widget);
                    widget.reload();
                } else {
                    ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                }
            }).
            catch(function(e) {
                var error;
                if(e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
        });
    };
    
    this.setResposta = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
                if (!widget.backupRow) {
                    widget.currentRow.__is_new = true;
                } else {
                    widget.currentRow.__is_new = false;
                }
                restEngine.post('product#/setResposta', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                    then(function (data) {
                        if (data.notifications[0].type === "success") {
                            ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                            if (widget.currentRow.__is_new) {
                                ABUtilController.masterDetailVoltarList(widget);
                                widget.reload();
                            } else {
                                ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                                widget.backupRow = null;
                                widget.view();
                            }
                        } else {
                            ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                        }
                    }).
                    catch(function(e) {
                        var error;
                        if(e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;
                            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    });
            }
    };
    
    this.deleteResposta = function(args) {
        var widget = args.owner.widget;
        widget.currentRow.__is_new = false;
        ScreenService.confirmMessage(Messages.DELETE_ROW, 'CONFIRMATION', function(){
            restEngine.post('product#/deleteResposta', {'requestType':'DataSet','dataset':[widget.currentRow]}).
                then(function(data){
                    if(data.notifications[0].type === "success"){
                        ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    } else {
                        ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                    }
                }).catch(function(e) {
                    var error;
                    if(e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;
                        ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
        });
    };
    
    this.setAvaliacao = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
                if (!widget.backupRow) {
                    widget.currentRow.__is_new = true;
                } else {
                    widget.currentRow.__is_new = false;
                }
                restEngine.post('product#/setAvaliacao', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                    then(function (data) {
                        if (data.notifications[0].type === "success") {
                            ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                            if (widget.currentRow.__is_new) {
                                ABUtilController.masterDetailVoltarList(widget);
                                widget.reload();
                            } else {
                                ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                                widget.backupRow = null;
                                widget.view();
                            }
                        } else {
                            ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                        }
                    }).
                    catch(function(e) {
                        var error;
                        if(e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;
                            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    });
            }
    };
    
    this.deleteAvaliacao = function(args) {
        var widget = args.owner.widget;
        widget.currentRow.__is_new = false;
        ScreenService.confirmMessage(Messages.DELETE_ROW, 'CONFIRMATION', function(){    
            restEngine.post('product#/deleteAvaliacao', {'requestType':'DataSet','dataset':[widget.currentRow]}).
                then(function(data){
                    if(data.notifications[0].type === "success"){
                        ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    } else {
                        ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                    }
                }).
                catch(function(e) {
                    var error;
                    if(e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;
                        ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
        });
    };
    
   	this.setNiveis = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
                if (!widget.backupRow) {
                    widget.currentRow.__is_new = true;
                } else {
                    widget.currentRow.__is_new = false;
                }
                restEngine.post('product#/setNiveis', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                    then(function (data) {
                        if (data.notifications[0].type === "success") {
                            ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                            if (widget.currentRow.__is_new) {
                                ABUtilController.masterDetailVoltarList(widget);
                                widget.reload();
                            } else {
                                ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                                widget.backupRow = null;
                                widget.view();
                            }
                        } else {
                            ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                        }
                    }).
                    catch(function(e) {
                        var error;
                        if(e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;
                            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    });
            }
    };
    
    this.deleteNiveis = function(args) {
        var widget = args.owner.widget;
        widget.currentRow.__is_new = false;
        ScreenService.confirmMessage(Messages.DELETE_ROW, 'CONFIRMATION', function(){    
            restEngine.post('product#/deleteNiveis', {'requestType':'DataSet','dataset':[widget.currentRow]}).
                then(function(data){
                    if(data.notifications[0].type === "success"){
                        ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    } else {
                        ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                    }
                }).
                catch(function(e) {
                    var error;
                    if(e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;
                        ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
        });
    };
    
    this.habilitaSelectAval = function(args){
        
        var widget = templateManager.container.getActiveWidget();
        
        if(!Util.isEmptyOrBlank(widget.getField('NMNIVELQUESTAO').value())){
            widget.getField('NMNIVELAVALIA').readOnly = false;
            widget.getField('NMNIVELAVALIA').validations = {"required": true};
        }else{
            widget.getField('NMNIVELAVALIA').validations = {};
            widget.getField('NMNIVELAVALIA').readOnly = true;
        }
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('BancoQuestoesController', BancoQuestoesController);
});

// FILE: assets/js/controllers/BancohorasController.js
function BancoHorasController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, ABUtilController, AFormataHoraDecimal, Messages) {

    this.widgetsVisibleFalse = function(args){
        var widget = args.owner.widget;
        widget.widgets[0].showAsTab = false;
    };
    
    this.widgetsVisibleTrue = function(args){
        var widget = args.owner.widget;
        widget.widgets[0].showAsTab = true;
    };

    this.openAdicionar = function(args){
        var widget = args.owner.widget;
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
    };

    this.setBancoHorasPeriodo = function(args) {
        var codigobancohoras = templateManager.container.getWidget("banco_horas").currentRow.NRBANCOHORAS;
        var widget = args.owner.widget;
        if (widget.isValid()) {
            if (this.validaPeriodo(widget.currentRow.DTINICIOPERIODOBHORAS, widget.currentRow.DTFIMPERIODOBHORAS)) {
                if (this.validaData(widget.currentRow.DTINICIOPERIODOBHORAS, widget.currentRow.DTFIMPERIODOBHORAS)) {
                    var codbancohoras = templateManager.container.getWidget("banco_horas").currentRow.NRBANCOHORAS;
                    widget.currentRow.NRBANCOHORAS = codbancohoras;
                    var tipo;
                    if (!widget.backupRow) {
                        widget.currentRow.__is_new = true;
                        tipo = true;
                    }
                    else {
                        widget.currentRow.__is_new = false;
                        tipo = false;
                    }
                    var saveData = Object.assign({}, widget.currentRow, {
                        "NRORG": getLocalVar("HCM_NRORG_TRAB")
                    }, {
                        "CDOPERADOR_LOG": getLocalVar("HCM_CDOPERADOR")
                    });
                    restEngine.post('product#/setBancoHorasPeriodo', {
                        'requestType': 'DataSet',
                        'dataset': [saveData]
                    }).
                    then(function(data) {
                        if (data.notifications[0].type === "success") {
                            ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 1000);
                            if(tipo){
                                ABUtilController.masterDetailVoltarList(widget);
                                widget.reload();
                            } else {
                                widget.reload();
                                widget.view();
                                widget.activate();
                            }
                        }
                        else {
                            ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                        }
                    }).catch(function(e) {
                        var error;
                        if (e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    });
                }
                else {
                    ScreenService.showMessage('As Datas de Início e de Fim do Período devem estar compreendidas entre o Início e o Fim do Banco de Horas.');
                    return false;
                }
            }
            else {
                ScreenService.showMessage('O campo "Data Fim" deve ser igual ou posterior à "Data Início"');
                return false;
            }
        }
    };
    
    this.setBancoHoras = function(args) {
        var widgetPeriodo = templateManager.container.getWidget("PTO_BANCOHORASPERIODO");
        var widget = args.owner.widget;
        if (widget.isValid()) {
            if (this.validaPeriodo(widget.currentRow.DTINICIOBANCOHORAS, widget.currentRow.DTFIMBANCOHORAS)) {
                if (!widget.backupRow) {
                    widget.currentRow.__is_new = true;
                    tipo = true;
                }
                else {
                    widget.currentRow.__is_new = false;
                    tipo = false;
                }
                var saveData = Object.assign({}, widget.currentRow, {
                    "NRORG": getLocalVar("HCM_NRORG_TRAB")
                }, {
                    "CDOPERADOR_LOG": getLocalVar("HCM_CDOPERADOR")
                });
                restEngine.post('product#/setBancoHoras', {
                    'requestType': 'DataSet',
                    'dataset': [saveData]
                }).
                then(function(data) {
                    if (data.notifications[0].type === "success") {
                        ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 1000);
                        if(tipo){
                            ABUtilController.masterDetailVoltarList(widget);
                            widget.widgets[0].isVisible = true;
                            widget.widgets[0].showAsTab = true;
                            widget.reload();
                        } else {
                            widget.reload();
                            widget.view();
                            widget.widgets[0].isVisible = true;
                            widget.widgets[0].showAsTab = true;
                        }
                    }
                    else {
                        ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                    }
                }).catch(function(e) {
                    var error;
                    if (e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;

                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
            }
            else {
                ScreenService.showMessage('O campo "Fim Vigência" deve ser igual ou posterior ao campo "Início Vigência".');
                return false;
            }
        }
    };

    this.setFilterBancoHoras = function(argsRow){
        var widgetPeriodo = templateManager.container.getWidget("PTO_BANCOHORASPERIODO");
        widgetPeriodo.dataSourceFilter[0].value = argsRow.NRBANCOHORAS;
    };

    this.validaPeriodo = function(dtIni, dtFin) {
        if (moment(dtIni, 'DD/MM/YYYY').unix() > moment(dtFin, 'DD/MM/YYYY').unix() || moment(dtFin, 'DD/MM/YYYY').unix() < moment(dtIni, 'DD/MM/YYYY').unix()) {

            return false;
        }
        else {
            return true;
        }
    };
    
    this.validaData = function(dtIni, dtFin) {
        var widget = templateManager.container.getWidget("banco_horas");
        var dtbancoini = widget.currentRow.DTINICIOBANCOHORAS;
        var dtbancofim = widget.currentRow.DTFIMBANCOHORAS;
        if (moment(dtIni, 'DD/MM/YYYY').unix() < moment(dtbancoini, 'DD/MM/YYYY').unix() || moment(dtFin, 'DD/MM/YYYY').unix() > moment(dtbancofim, 'DD/MM/YYYY').unix()) {
            return false;
        }
        else {
            return true;
        }
    };

    this.removerBancohorasPeriodo = function(args) {
        ScreenService.confirmMessage(Messages.DELETE_ROW, 'CONFIRMATION', 
            function() {
                var widget = args.owner.widget;
                widget.currentRow.__is_new = false;
                var removeData = Object.assign({}, widget.currentRow, {
                    "NRORG": getLocalVar("HCM_NRORG_TRAB")
                }, {
                    "CDOPERADOR_LOG": getLocalVar("HCM_CDOPERADOR")
                });
                restEngine.post('product#/removeBancoHorasPeriodo', {
                    'requestType': 'DataSet',
                    'dataset': [removeData]
                }).
                then(function(data) {
                    if (data.notifications[0].type === "success") {
                        ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 1000);
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    }
                    else {
                        ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                    }
                }).catch(function(e) {
                    var error;
                    if (e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;
                        ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
            }
        );
    };

    this.removerBancohoras = function(args) {
        ScreenService.confirmMessage(Messages.DELETE_ROW, 'CONFIRMATION', 
            function() {
                var widget = args.owner.widget;
                widget.currentRow.__is_new = false;
                var removeData = Object.assign({}, widget.currentRow, {
                    "NRORG": getLocalVar("HCM_NRORG_TRAB")
                }, {
                    "CDOPERADOR_LOG": getLocalVar("HCM_CDOPERADOR")
                });
                restEngine.post('product#/removeBancoHoras', {
                    'requestType': 'DataSet',
                    'dataset': [removeData]
                }).
                then(function(data) {
                    if (data.notifications[0].type === "success") {
                        ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 1000);
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    }
                    else {
                        ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                    }
                }).catch(function(e) {
                    var error;
                    if (e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;
                        ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
            }
        );
    };

}

Configuration(function(ContextRegister) {
    ContextRegister.register('BancoHorasController', BancoHorasController);
});

// FILE: assets/js/controllers/BeneficioController.js
function BeneficioController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, General, Messages, $window) {
    
    /* Controller utilizado também na tela hcm00118_gpe_parametrizacaoSindicado */
    
    var estrutSindInformada;
    var estrutLegalInformada;
    var estrutGerenInformada;
    var vincInformado;
    var widgetPaiDoPopUpCadExc;
     this.objActions = {
        'exclusao_automatica': {
            'name':'exclusao_automatica',
            'label': 'Exclusão Automática',
            'fields': [
                "NRESTRUTSIND",
                "NRESTRUTLEGAL",
                "NMESTRUTGEREN", 
                "NRVINCULOM_LIST",
                "IDTPBENEFICIARIO",
                "NRPESSOA_LIST"
            ],
            'nullable': [
                "NRVINCULOM_LIST",
                "NRPESSOA_LIST",
                "NRESTRUTSIND",
                "NRESTRUTLEGAL",
                "NMESTRUTGEREN",
                "NREVENTOM_LIST"
            ]
        },
        'cadastro_automatico': {
            'name':'cadastro_automatico',
            'label': 'Cadastro Automático',
            'fields': [
                "NRESTRUTSIND",
                "NRESTRUTLEGAL",
                "NMESTRUTGEREN",
                "NRVINCULOM_LIST",
                "NREVENTOM_LIST",
                "IDTPBENEFICIARIO", 
                "NRPESSOA_LIST",
                "QTBENEFICIO",
                "IDVALORDIFEBENEF",
                "DSREFERENCIA",
                "VRBENEFICIO"
            ],
            'nullable': [
                "NRESTRUTSIND",
                "NRESTRUTLEGAL",
                "NMESTRUTGEREN",
                "NRVINCULOM_LIST",
                "NREVENTOM_LIST",
                "NRPESSOA_LIST",
                "IDVALORDIFEBENEF",
                "DSREFERENCIA",
                "VRBENEFICIO"
            ]
        }
        
    };

    this.selectedAction = '';
    
    this.reloadVinculo = function(args){
        var widget = args.owner.field.widget;
        widget.getField('NMVINCULOM').reload();
    };
    
    this.popupImportacaoPlanilha = function() {
        var widgetPopupImportacao = templateManager.container.getWidget('popupImportacaoPlanilha');
        widgetPopupImportacao.currentRow.IDOPCAOIMPORT = 'A';
        widgetPopupImportacao.currentRow.DSPATH = [];
        ScreenService.openPopup(widgetPopupImportacao);
    };
    
    this.importarPlanilhaBeneficio = function() {
        var widgetPop = templateManager.container.getActiveWidget();
        var widgetPai = templateManager.container.getWidget('beneficiario');
        if(widgetPop.isValid()){
            if(validaArquivo(widgetPop.currentRow.DSPATH[0].name)) {
                restEngine.post('product#/importarPlanilhaBeneficio', {'requestType': 'DataSet', 'dataset': [widgetPop.currentRow]}).
                then(function(data) {
                    if (data.messages) {
                        ScreenService.closePopup(true);
                        ScreenService.showMessage(data.messages[0].message, data.messages[0].type);
                        if (data.dataset && data.dataset.msg) {
                            openPopupMensagens(data.dataset.msg);
                        } else {
                            widgetPai.activate();
                        }
                        widgetPai.reload();
                    } else
                        ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                }).
                catch(function(e) {   
                    var error;
                    if (e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    
                });
            }
        }
    };
    
    var validaArquivo = function(filePath) {
        var extension = filePath.split('.').pop().toUpperCase();
        if (extension !== 'XLS' && extension !== 'XLSX') {
            ScreenService.showMessage('Formato de arquivo inválido');
            return false;
        } else {
            return true;
        }
    };
    
    var openPopupMensagens = function(msg) {
        var widgetMensagens = templateManager.container.getWidget('messagesImportacaoBeneficio');
        widgetMensagens.dataSource.data = msg;
        ScreenService.openPopup(widgetMensagens);
    };
    
     this.popupImportacaoPlanilhaBeneficiario = function() {
        ScreenService.closePopup();
        templateManager.container.getWidget('beneficiario').activate();
    };

    this.limpaCamposPopup = function(args) {
        var widgetFilter = templateManager.container.getWidget('filterBeneficiarios');
        widgetFilter.fields.forEach(function(field) {
            field.setValue('');
        });
        widgetFilter.getField('NRVINCULOM_LIST').readOnly = false;
        widgetFilter.getField('NRPESSOA_LIST').readOnly = true;
        widgetFilter.getField('NRPESSOA_LIST').validations = {};
        widgetFilter.getField('DSREFERENCIA').readOnly = true;
        widgetFilter.getField('DSREFERENCIA').validations = {};
        widgetFilter.getField('VRBENEFICIO').readOnly = true;
        widgetFilter.getField('VRBENEFICIO').validations = {};
    };
    

    this.openPopupBeneficiarios = function(action, widgetName) {
        var widgetFilter = templateManager.container.getWidget('filterBeneficiarios');
        var widgetMain = templateManager.container.getWidget('Beneficio');
        this.selectedAction = action;
        widgetFilter.label = this.objActions[action].label;
        var actionObj = this.objActions[action];
        widgetFilter.fields.forEach(function(field) {
            if (actionObj.fields.indexOf(field.name) >= 0) {
                widgetFilter.getField(field.name).isVisible = true;
                if (actionObj.nullable.indexOf(field.name) >= 0) {
                    widgetFilter.getField(field.name).validations = {};
                } else {
                    widgetFilter.getField(field.name).validations = {"required": true};
                }
            } else {
                widgetFilter.getField(field.name).isVisible = false;
            }
        });
        
        if(widgetMain.currentRow.TPPERIODOBENEF === 'MENSAL'){
            widgetFilter.currentRow.QTBENEFICIO = 1;
            widgetFilter.getField('QTBENEFICIO').readOnly = true;
            widgetFilter.getField('IDVALORDIFEBENEF').readOnly = true;
            widgetFilter.getField('NRVINCULOM_LIST').class = "6";
            widgetFilter.getField('IDTPBENEFICIARIO').showOnForm = true;
            widgetFilter.currentRow.IDTPBENEFICIARIO = "";
            widgetFilter.getField('NRPESSOA_LIST').showOnForm = true;
        }else{
            widgetFilter.getField('QTBENEFICIO').readOnly = false;
            widgetFilter.getField('IDVALORDIFEBENEF').readOnly = false;
            widgetFilter.getField('NRVINCULOM_LIST').class = "12";
            widgetFilter.getField('IDTPBENEFICIARIO').showOnForm = false;
            widgetFilter.currentRow.IDTPBENEFICIARIO = "T";
            widgetFilter.getField('NRPESSOA_LIST').showOnForm = false;
        }    

        
        widgetFilter.getField('NREVENTOM_LIST').validations = {};
        widgetFilter.getField('IDVALORDIFEBENEF').validations = {};
        
        if(action === 'exclusao_automatica'){
            widgetFilter.getField('NREVENTOM_LIST').fieldGroup = "FILTRO";
            widgetFilter.getField('NREVENTOM_LIST').isVisible = true;
            widgetFilter.getField('NRVINCULOM_LIST').class = "6";
            widgetFilter.fieldGroups[1].isVisible = false;
        }else{
            widgetFilter.getField('NREVENTOM_LIST').fieldGroup = "CAD_BENEFICIARIO";
            widgetFilter.getField('NREVENTOM_LIST').isVisible = true;
            widgetFilter.fieldGroups[1].isVisible = true;
        }
        
        
        widgetPaiDoPopUpCadExc = widgetName;
        
        widgetFilter.redraw();
        
        ABUtilController.masterDetailOpenPopup(widgetFilter);
    };
    
    this.voltarAoPaiDoPopupCadExcAutomatica = function(popup){
        var widgetPai = templateManager.container.getWidget(widgetPaiDoPopUpCadExc);
        popup.currentRow = {};
        ScreenService.closePopup(true);
        popup.deactivate();
        widgetPai.activate();        
    };
    
    this.validaReadOnlyFieldPessoaOnActionAdd = function(widgetName){
        var widget = templateManager.container.getWidget(widgetName);
        widget.getField('NMPESSOA').readOnly = true;
    };

    this.validaReadOnlyFieldPessoaOnActionEdit = function(widgetName){
        var widget = templateManager.container.getWidget(widgetName);
        var widgetMain = templateManager.container.getWidget('Beneficio');
        
        if(widgetMain.currentRow.TPPERIODOBENEF === 'DIARIO')
            widget.getField('NMPESSOA').readOnly = true;
        else if(widgetMain.currentRow.TPPERIODOBENEF === 'MENSAL')
            widget.getField('NMPESSOA').readOnly = false;
    };
    
    this.setarRequerimentoEventoCadAutomatico = function(widgetBeneficio){
        if(widgetBeneficio.currentRow.TPPERIODOBENEF === 'MENSAL'){
            this.objActions.cadastro_automatico.nullable.push("NREVENTOM_LIST");
            this.objActions.cadastro_automatico.nullable.push("IDVALORDIFEBENEF");
        }else {
            var index = this.objActions.cadastro_automatico.nullable.indexOf("NREVENTOM_LIST");
            if(index > -1)
                this.objActions.cadastro_automatico.nullable.splice(index, 1);

            index = this.objActions.cadastro_automatico.nullable.indexOf("IDVALORDIFEBENEF");
            if(index > -1)
                this.objActions.cadastro_automatico.nullable.splice(index, 1);
        }    
    };
    
    this.validaCamposAfterMoveRow = function(widget){
        if(widget.currentRow.CONSVINCRESMESANT == 'S') widget.getField('NRDIARESCISAO').validations = {required: true};
        else widget.getField('NRDIARESCISAO').validations = {};
    };
    
    this.validaRequerimentoFieldsEventsCadAuto = function(widgetCadAuto){
        var widgetMain = templateManager.container.getWidget('Beneficio');
        var tpperiodobenef = widgetMain.currentRow.TPPERIODOBENEF;

        if(widgetCadAuto.currentRow.NREVENTOM_LIST.length > 0){
            widgetCadAuto.getField('IDVALORDIFEBENEF').readOnly = false;
            widgetCadAuto.getField('IDVALORDIFEBENEF').validations.required = true;
        }else{
            widgetCadAuto.getField('IDVALORDIFEBENEF').readOnly = true;
            widgetCadAuto.getField('IDVALORDIFEBENEF').validations = {};
            widgetCadAuto.currentRow.IDVALORDIFEBENEF = "";
    
            widgetCadAuto.getField('DSREFERENCIA').readOnly = true;
            widgetCadAuto.getField('DSREFERENCIA').validations = {};
            widgetCadAuto.currentRow.DSREFERENCIA = "";
    
            widgetCadAuto.getField('VRBENEFICIO').readOnly = true;
            widgetCadAuto.getField('VRBENEFICIO').validations = {};
            widgetCadAuto.currentRow.VRBENEFICIO = "";
        }

    };
    
    this.validaRequiredFieldsCadExcAutomaticoOnEnter = function(widget){
        widget.getField('NRVINCULOM_LIST').readOnly = false;
        widget.getField('IDVALORDIFEBENEF').readOnly = true;
    };
    
    this.beneficiarioAutomatico = function(widget) {
        var widgetmain = templateManager.container.getWidget("Beneficio");
        var arraypessoas = [];
        var nrpessoas = [];
        var NRESTRUTGEREN = widget.currentRow.NRESTRUTGEREN;
        var nreventom_list = widget.currentRow.NREVENTOM_LIST;
        
        widget.currentRow.NRBENEFICIOM = widgetmain.currentRow.NRBENEFICIOM;
        widget.currentRow.NRESTRUTURAM = widgetmain.currentRow.NRESTRUTURAM;
        widget.currentRow.NRTABELAFOLHAPRI = widgetmain.currentRow.NRTABELAFOLHAPRI;
        widget.currentRow.NRTABELAFOLHASEC = widgetmain.currentRow.NRTABELAFOLHASEC;
        widget.currentRow.TPPERIODOBENEF = widgetmain.currentRow.TPPERIODOBENEF;
        widget.currentRow.__is_new = false;
        if(widget.currentRow.VRBENEFICIO){
                widget.currentRow.VRBENEFICIO = General.valueToFloat(widget.currentRow.VRBENEFICIO); 
        }
        if (widget.isValid()) {
            var action = this.selectedAction;
            widget.currentRow.action = this.selectedAction;
            if (widget.getField('NRVINCULOM_LIST').dataSource.getCheckedRows().length === 0) {
                widget.getField('NRVINCULOM_LIST').setValue('A');
            }
            if (widget.getField('NRPESSOA_LIST').dataSource.getCheckedRows().length === 0) {
                widget.getField('NRPESSOA_LIST').setValue('A');
            }
            if (!NRESTRUTGEREN) {
                widget.currentRow.NRESTRUTGEREN = 'A';
            }
            if(action === 'cadastro_automatico' || 'exclusao_automatica'){
                arraypessoas = this.arrayVinculoDependentes(widget,nrpessoas,arraypessoas);
            }
            widget.currentRow.NRPESSOASVINC = arraypessoas;
            restEngine.post('/cadastroAutomaticoBeneficiario', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                then(function (data) {
                    if (data.messages) {
                        ScreenService.showMessage(data.messages[0].message, data.messages[0].type);
                        ABUtilController.masterDetailClosePopup(widget);
                        templateManager.container.getWidget('beneficiario').reload();
                    }
                    else {
                        if(action === 'exclusao_automatica'){
                            ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                        }else if(action === 'cadastro_automatico'){
                            ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 1000);
                        }
                        ABUtilController.masterDetailClosePopup(widget);
                        if(nreventom_list.length > 0){
                            templateManager.container.getWidget('beneficiarioPorEvento').reload();
                            templateManager.container.getWidget('beneficiarioPorEvento').activate();
                        }else{
                            templateManager.container.getWidget('beneficiario').reload();
                            templateManager.container.getWidget('beneficiario').activate();
                        }
                    }
                }.bind(this)).
                catch(function(e) {
                    var error;
                    if(e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
        }
    };

    this.saveMasterDetailMasterHistory = function(widget) {
        var preparedWidget = ABUtilController.prepareSaveMasterHistory(widget);
        var masterTable = preparedWidget.paramsNewCode.__new_code_pk;
        restEngine.post('/setBeneficio', {'requestType': 'DataSet', 'dataset': [preparedWidget.currentRow]}).
            then(function (data) {
                if(data.messages){
                    ScreenService.showMessage(data.messages[0].message);
                }else{    
                    if (data.dataset.columnsToReturn) {
                        ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                        if (preparedWidget.currentRow.__is_new) {
                            ABUtilController.masterDetailVoltarList(preparedWidget);
                            preparedWidget.reload();    
                        } else {
                            preparedWidget.backupRow = null;
                            preparedWidget.view();
                            preparedWidget.currentRow.NRBENEFICIOH = Number(data.dataset.columnsToReturn[0].NRBENEFICIOH);
                        }
                    } else {
                        ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                    }
                }    
            }).
            catch(function(e) {
                var error;
                if(e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
    };
    
    this.arrayVinculoDependentes = function(widget,nrpessoas,arraypessoas){
        
        if(widget.getField('NRVINCULOM_LIST') && widget.currentRow.NRPESSOA_LIST === 'A'){
            nrpessoas = widget.getField('NRVINCULOM_LIST').dataSource.getCheckedRows();
            for(var row in nrpessoas){
                arraypessoas.push({
                    'NRVINCULOM':nrpessoas[row].NRVINCULOM,
                    'NRPESSOA':nrpessoas[row].NRPESSOA,
                    'NMVINCULOM':nrpessoas[row].NMVINCULOM
                });
            }
        }
        if(widget.getField('NRVINCULOM_LIST') && widget.getField('NRPESSOA_LIST')){
            var pessoas = widget.getField('NRPESSOA_LIST').dataSource.getCheckedRows();
            nrpessoas = widget.getField('NRVINCULOM_LIST').dataSource.getCheckedRows();
            var tipopessoa;

            for(var k in pessoas){
                    var nrpessoaprinc = pessoas[k].NRPESSOAPRINC;
                    var nmpessoa = pessoas[k].NMPESSOA;
                    var nrpessoa = pessoas[k].NRPESSOA;
                for (var y in nrpessoas){
                    var nrPessoaVinculom = nrpessoas[y].NRPESSOA;
                    if(nrpessoaprinc === nrPessoaVinculom){
                        if(nrpessoa === nrPessoaVinculom){
                            tipopessoa = 'T';
                        }else{
                            tipopessoa = 'D';
                        }
                        arraypessoas.push({
                        'NRVINCULOM': nrpessoas[y].NRVINCULOM,
                        'NRPESSOA': nrpessoa,
                        'TIPOPESSOA': tipopessoa,
                        'DTNASCIMENTO': pessoas[k].DTNASCIMENTO,
                        'NOMEPESSOA': nmpessoa
                        });
                    }
                }
            }
        }
        return arraypessoas;
    };
    
    this.OnChangeEstrutSind = function(args){
        var widget = args.owner.field.widget;
        if(!widget.currentRow.NRESTRUTSIND || widget.currentRow.NRESTRUTSIND.length == 0){
            widget.currentRow.NMESTRUTSIND = "";
            widget.currentRow.NRVINCULOM_LIST = "";
            widget.currentRow.NRPESSOA_LIST = "";
        }
        if(widget.currentRow.NRESTRUTSIND !== estrutSindInformada){
            widget.currentRow.NRVINCULOM_LIST = "";
            widget.currentRow.NRPESSOA_LIST = "";
            estrutSindInformada = widget.currentRow.NRESTRUTSIND;
        }
    };
    
    this.OnChangeEstrutLegal = function(args){
        var widget = args.owner.field.widget;
        if(!widget.currentRow.NRESTRUTLEGAL || widget.currentRow.NRESTRUTLEGAL.length == 0){
            widget.currentRow.NMESTRUTLEGAL = "";
            widget.currentRow.NRVINCULOM_LIST = "";
            widget.currentRow.NRPESSOA_LIST = "";
        }
        if(widget.currentRow.NRESTRUTLEGAL !== estrutLegalInformada){
            widget.currentRow.NRVINCULOM_LIST = "";
            widget.currentRow.NRPESSOA_LIST = "";
            estrutLegalInformada = widget.currentRow.NRESTRUTLEGAL;
        }
    };
    
    this.OnChangeEstrutGerencial = function(args){
        var widget = args.owner.field.widget;
        if(!widget.currentRow.NMESTRUTGEREN || widget.currentRow.NMESTRUTGEREN.length == 0){
            widget.currentRow.NRESTRUTGEREN = "";        
            widget.currentRow.NRVINCULOM_LIST = "";
            widget.currentRow.NRPESSOA_LIST = "";
        }
        if(widget.currentRow.NMESTRUTGEREN !== estrutGerenInformada){
            widget.currentRow.NRVINCULOM_LIST = "";
            widget.currentRow.NRPESSOA_LIST = "";
            estrutGerenInformada = widget.currentRow.NMESTRUTGEREN;
        }
    };
    
    this.filtrarVinculoPorEstruturas = function(args){
        var widget = args.owner.field.widget;

        widget.getField('NRVINCULOM_LIST').dataSourceFilter = [];
        
        if(!Util.isEmptyOrBlank(widget.currentRow.NRESTRUTSIND) && widget.currentRow.NRESTRUTSIND !== 'A'){
            widget.getField('NRVINCULOM_LIST').dataSourceFilter.
            push(
                {
                    name: "NRESTRUTSIND",
                    operator: "IN",
                    value: widget.currentRow.NRESTRUTSIND
                }    
            );
        }

        if(widget.currentRow.NRESTRUTLEGAL && widget.currentRow.NRESTRUTLEGAL !== 'A'){
            widget.getField('NRVINCULOM_LIST').dataSourceFilter.
            push(
                {
                    name: "NRESTRUTLEGAL",
                    operator: "IN",
                    value: widget.currentRow.NRESTRUTLEGAL
                }    
            );
        }

        if(widget.currentRow.NMESTRUTGEREN && widget.currentRow.NMESTRUTGEREN !== 'A'){
            widget.getField('NRVINCULOM_LIST').dataSourceFilter.
            push(
                {
                    name: "NRESTRUTGEREN",
                    operator: "IN",
                    value: widget.currentRow.NRESTRUTGEREN
                }    
            );
        }
    };
    
    this.filterVincHabilitaCampo = function(args){
        var widget = args.owner.field.widget;
        var NRVINCULOM = widget.currentRow.NRVINCULOM_LIST;
        var IDTPBENEFICIARIO = widget.currentRow.IDTPBENEFICIARIO;
        var action = this.selectedAction;
        if(NRVINCULOM.length > 0 && IDTPBENEFICIARIO === "L"){
            widget.getField('NRPESSOA_LIST').readOnly = false;
            widget.getField('NRPESSOA_LIST').validations = {required:true};
        }else{
            widget.getField('NRPESSOA_LIST').readOnly = true;
            widget.currentRow.NRPESSOA_LIST = "";
            widget.getField('NRPESSOA_LIST').validations = {};
        }
    };
    
    this.setarFiltroPessoaVinculomOnChange = function(args){
        var widget = args.owner.field.widget;
        var arraypessoas = [];
        
        if(widget.getField('NRVINCULOM_LIST')){
            var nrpessoas = widget.getField('NRVINCULOM_LIST').dataSource.getCheckedRows();
            nrpessoas.forEach(function(obj){
                arraypessoas.push(obj.NRPESSOA);
            });
        }    
        
        widget.getField('NRPESSOA_LIST').dataSourceFilter = [{
            "name": "NRPESSOA",
            "operator": "IN",
            "value": arraypessoas
        }];
        
        widget.getField('NRPESSOA_LIST').reload();
    };
    
    this.filterTpBeneficiario = function(args){
        var widgetmain = templateManager.container.getWidget("Beneficio");
        var widget = args.owner.field.widget;
        var NRVINCULOM = widget.currentRow.NRVINCULOM_LIST;
        var IDTPBENEFICIARIO = widget.currentRow.IDTPBENEFICIARIO;
        var action = this.selectedAction;
        if(NRVINCULOM){
            if(NRVINCULOM.length > 0 && IDTPBENEFICIARIO === "L"){
                widget.getField('NRPESSOA_LIST').readOnly = false;
                widget.getField('NRPESSOA_LIST').validations = {required:true};
            }else{
                widget.getField('NRPESSOA_LIST').readOnly = true;
                widget.currentRow.NRPESSOA_LIST = "";
                widget.getField('NRPESSOA_LIST').validations = {};
            }
        }    
        if(action === 'cadastro_automatico'){
            if(widget.currentRow.IDVALORDIFEBENEF === 'TABELA'){
                if( (!widgetmain.currentRow.NRTABELAFOLHAPRI) && (!widgetmain.currentRow.NRTABELAFOLHASEC) ){
                    widget.currentRow.IDTPBENEFICIARIO = "";
                    widget.currentRow.IDVALORDIFEBENEF = "";
                    ScreenService.showMessage(Messages.HCM02000_VAB_BENEFICIO_TABELA_PRI_SEC_INF);
                }else{
                    if(IDTPBENEFICIARIO === 'T' || IDTPBENEFICIARIO === 'A' || IDTPBENEFICIARIO === 'L'){
                        if(!widgetmain.currentRow.NRTABELAFOLHAPRI){
                            widget.currentRow.IDTPBENEFICIARIO = "";
                            widget.currentRow.IDVALORDIFEBENEF = "";
                            ScreenService.showMessage(Messages.HCM02000_VAB_BENEFICIO_TABELA_PRI_INF);    
                        }
                    }else if(IDTPBENEFICIARIO === 'D' || IDTPBENEFICIARIO === 'A' || IDTPBENEFICIARIO === 'L'){
                        if(!widgetmain.currentRow.NRTABELAFOLHASEC){
                            widget.currentRow.IDTPBENEFICIARIO = "";
                            widget.currentRow.IDVALORDIFEBENEF = "";
                            ScreenService.showMessage(Messages.HCM02000_VAB_BENEFICIO_TABELA_SEC_INF);
                        }
                    }
                }
            }
        }
    };
    
    this.filterTipoValor = function(args){
        var widgetmain = templateManager.container.getWidget("Beneficio");
        var widget = args.owner.field.widget;
        var IDTPBENEFICIARIO = widget.currentRow.IDTPBENEFICIARIO;
        var IDVALORDIFEBENEF = widget.currentRow.IDVALORDIFEBENEF;
        if(IDVALORDIFEBENEF === 'VALOR'){
            widget.getField('VRBENEFICIO').readOnly = false;
            widget.getField('VRBENEFICIO').validations = {required:true};
            widget.getField('DSREFERENCIA').readOnly = true;
            widget.getField('DSREFERENCIA').validations = {};
            widget.currentRow.DSREFERENCIA = "";
            /*if(!widget.currentRow.DSOBSBENEFICIARIO){
                widget.currentRow.DSOBSBENEFICIARIO = Messages.HCM02000_VAB_OBS_VALOR_BENEFICIARIO;
            }*/
        }else if(IDVALORDIFEBENEF === 'REFERENCIA'){
            widget.getField('DSREFERENCIA').readOnly = false;
            widget.getField('DSREFERENCIA').validations = {required:true};
            widget.getField('VRBENEFICIO').readOnly = true;
            widget.getField('VRBENEFICIO').validations = {};
            widget.currentRow.VRBENEFICIO = "";
            /*if(!widget.currentRow.DSOBSBENEFICIARIO){
                widget.currentRow.DSOBSBENEFICIARIO = Messages.HCM02000_VAB_OBS_VALOR_BENEFICIARIO;
            }*/
        }else if(IDVALORDIFEBENEF === 'TABELA'){
            widget.getField('DSREFERENCIA').readOnly = true;
            widget.getField('VRBENEFICIO').readOnly = true;
            widget.getField('VRBENEFICIO').validations = {};
            widget.getField('DSREFERENCIA').validations = {};
            widget.currentRow.DSREFERENCIA = "";
            widget.currentRow.VRBENEFICIO = "";
            if( (!widgetmain.currentRow.NRTABELAFOLHAPRI) && (!widgetmain.currentRow.NRTABELAFOLHASEC)){
                widget.currentRow.IDTPBENEFICIARIO = "";
                widget.currentRow.IDVALORDIFEBENEF = "";
                ScreenService.showMessage(Messages.HCM02000_VAB_BENEFICIO_TABELA_PRI_SEC_INF);
            }else{
                if( (IDTPBENEFICIARIO === 'T') || (IDTPBENEFICIARIO === 'A') || (IDTPBENEFICIARIO === 'L') ){
                    if(!widgetmain.currentRow.NRTABELAFOLHAPRI){
                        widget.currentRow.IDTPBENEFICIARIO = "";
                        widget.currentRow.IDVALORDIFEBENEF = "";
                        ScreenService.showMessage(Messages.HCM02000_VAB_BENEFICIO_TABELA_PRI_INF);    
                    }
                } 
                if( (IDTPBENEFICIARIO === 'D') || (IDTPBENEFICIARIO === 'A') || (IDTPBENEFICIARIO === 'L') ){
                    if(!widgetmain.currentRow.NRTABELAFOLHASEC){
                        widget.currentRow.IDTPBENEFICIARIO = "";
                        widget.currentRow.IDVALORDIFEBENEF = "";
                        ScreenService.showMessage(Messages.HCM02000_VAB_BENEFICIO_TABELA_SEC_INF);
                    }
                }                
            }
            if(widget.currentRow.DSOBSBENEFICIARIO){
                widget.currentRow.DSOBSBENEFICIARIO = "";
            }
        }else{
            widget.getField('DSREFERENCIA').readOnly = true;
            widget.getField('VRBENEFICIO').readOnly = true;
            widget.getField('VRBENEFICIO').validations = {};
            widget.getField('DSREFERENCIA').validations = {};
        }
    };

    this.filtrarBeneficiario = function(args) {
        var widget = args.owner;
        var widgetBeneficiarioPorEvento = templateManager.container.getWidget("beneficiarioPorEvento");
        var widgetBeneficiario = templateManager.container.getWidget("beneficiario");
        var codigo = widget.currentRow.NRBENEFICIOM;
        widgetBeneficiarioPorEvento.dataSourceFilter = [{
            "name": "NRBENEFICIOM",
            "operator": "=",
            "value": codigo
        }];
        widgetBeneficiario.dataSourceFilter = [{
            "name": "NRBENEFICIOM",
            "operator": "=",
            "value": codigo
        }];

        if(!widget.currentRow.NMESTRUTURAH){
            widget.getField('NMESTRUTURAH').readOnly = false;
        }
        if(!widget.currentRow.TPPERIODOBENEF){
            widget.getField('TPPERIODOBENEF').readOnly = false;
        }    
    };

    this.setTipoBeneficio = function(args){
        var widget = args.owner.field.widget;
        var nmVinculo = widget.currentRow.NMVINCULOM;
        var nrPessoaVinculo = widget.currentRow.NRPESSOAVINC;
        var widgetmain = templateManager.container.getWidget("Beneficio");
        var nmPessoa = widget.currentRow.NMPESSOA;
        var nrPessoa = widget.currentRow.NRPESSOA;
        var IdValorDifeBenef = widget.currentRow.IDVALORDIFEBENEF;
        
        if(nrPessoa){
            if(nrPessoa === nrPessoaVinculo){
                if(!widgetmain.currentRow.NRTABELAFOLHAPRI){
                    if(IdValorDifeBenef === 'TABELA'){
                        widget.currentRow.IDTPBENEFICIARIO = "";
                        widget.currentRow.NMPESSOA = "";
                        widget.currentRow.IDTPBENEFICIARIO = "";
                        ScreenService.showMessage(Messages.HCM02000_VAB_BENEFICIO_TABELA_PRI_INF);
                    /*}else if(IdValorDifeBenef === 'REFERENCIA' || IdValorDifeBenef === 'VALOR') {*/
                    }else{
                        widget.currentRow.IDTPBENEFICIARIO = "T";
                    }
                }else {
                    widget.currentRow.IDTPBENEFICIARIO = "T";
                }
            }else if(nrPessoa !== nrPessoaVinculo){
                if(!widgetmain.currentRow.NRTABELAFOLHASEC){
                    if(IdValorDifeBenef === 'TABELA'){
                        widget.currentRow.IDTPBENEFICIARIO = "";
                        widget.currentRow.NMPESSOA = "";
                        widget.currentRow.IDTPBENEFICIARIO = "";
                        ScreenService.showMessage(Messages.HCM02000_VAB_BENEFICIO_TABELA_SEC_INF);
                    /*}else if(IdValorDifeBenef === 'REFERENCIA' || IdValorDifeBenef === 'VALOR') {*/
                    }else{
                        widget.currentRow.IDTPBENEFICIARIO = "D";
                    }
                }else{
                    widget.currentRow.IDTPBENEFICIARIO = "D";
                }
            }
        }else{
            widget.currentRow.IDTPBENEFICIARIO = "";
        }    
    };
    
    this.mudarVibilidadeWidgets = function(args, valorLogico) {
        var widget = templateManager.container.getWidget("Beneficio");
        var widgetBeneficiarioPorEvento = templateManager.container.getWidget("beneficiarioPorEvento");
        var widgetBeneficiario = templateManager.container.getWidget("beneficiario");
        
        if (!Util.isUndefined(widgetBeneficiarioPorEvento)) {
            widgetBeneficiarioPorEvento.showAsTab = valorLogico;
            widgetBeneficiarioPorEvento.isVisible = valorLogico;
        }
        
        if (!Util.isUndefined(widgetBeneficiario)) {
            widgetBeneficiario.showAsTab = valorLogico;
            widgetBeneficiario.isVisible = valorLogico;
        }
    };

    this.widgetsVisibleTrue = function(args) {
        var widget = args.owner.widget;
        var widgetBeneficiarioPorEvento = templateManager.container.getWidget("beneficiarioPorEvento");
        
        if (!Util.isUndefined(widgetBeneficiarioPorEvento)) {
            widgetBeneficiarioPorEvento.showAsTab = true;
            widgetBeneficiarioPorEvento.isVisible = true;
        }
    };
     
    this.visibleWidgetBeneficiarioSintetico = function(widget){

        if(widget.currentRow.TPPERIODOBENEF === 'DIARIO' || !widget.currentRow.TPPERIODOBENEF)
        {
            widget.widgets[1].showAsTab = false;
            widget.widgets[1].isVisible = false;
        }else{
            widget.widgets[1].showAsTab = true;
            widget.widgets[1].isVisible = true;
        }
    };

    this.adicionarRow = function(args) {
        var widget = args.owner.widget;
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
    };
    
    this.setPercSubisidio = function(args) {
        var widget = args.owner.field.widget;
    
        if(widget.getField('VRPERCSUBSIDIO')){
            if(widget.currentRow.SUBSIDIO100 == 'S'){
                widget.getField('VRPERCSUBSIDIO').readOnly = true;
                widget.currentRow.VRPERCSUBSIDIO = 100;
            }else{
                widget.getField('VRPERCSUBSIDIO').readOnly = false;
                widget.currentRow.VRPERCSUBSIDIO = 0;
            } 
        }
    };
    
    this.filtraPessoa = function(args) {
        var widget = args.owner.field.widget;
        var nrpessoafilter;
        var nrpessoas = [];
        var arraypessoas = [];
        if(widget.getField('NRVINCULOM_LIST')){
            nrpessoas = widget.getField('NRVINCULOM_LIST').dataSource.getCheckedRows();
            for(var row in nrpessoas){
                arraypessoas.push(nrpessoas[row].NRPESSOA);
            }
        }    
        if(nrpessoas.length > 0){
            nrpessoafilter = arraypessoas;
        }else{
            nrpessoafilter = widget.currentRow.NRPESSOAVINC;
        }
        widget.getField('NMPESSOA').dataSourceFilter = [{
            "name": "NRPESSOA",
            "operator": "=",
            "value": nrpessoafilter
        }];
        if(nrpessoafilter){
            widget.getField('NMPESSOA').reload();
        }
    };

    this.addFilterPessoaOnActionEdit = function(widget){
        widget.getField('NMPESSOA').dataSourceFilter = [{
            "name": "NRPESSOA",
            "operator": "=",
            "value": widget.currentRow.NRPESSOAVINC
        }];
    };

    this.VincHabilitaCampos = function(args) {
        var widget = args.owner.field.widget;
        var widgetmain = templateManager.container.getWidget("Beneficio");
        
        var NMVINCULOM = widget.currentRow.NMVINCULOM;
        var NMEVENTOH = widget.currentRow.NMEVENTOH;
        var TPPERIODOBENEF = widgetmain.currentRow.TPPERIODOBENEF;
        
        
        if(TPPERIODOBENEF === 'MENSAL'){
        
            if (!NMVINCULOM || NMVINCULOM === ""){ 
                widget.currentRow.NMPESSOA = "";
                widget.getField('NMPESSOA').readOnly = true;
                widget.currentRow.IDTPBENEFICIARIO = "";
                widget.currentRow.NRPESSOA = "";
                widget.currentRow.NMPESSOA = "";
            }else    
                widget.getField('NMPESSOA').readOnly = false;

        }else if(TPPERIODOBENEF === 'DIARIO'){

            widget.getField('NMPESSOA').readOnly = true;
            
            if (!NMVINCULOM || NMVINCULOM === "") {
                widget.currentRow.NRPESSOA = "";
                widget.currentRow.NMPESSOA = "";
                widget.currentRow.IDTPBENEFICIARIO = "";
            }else {
                widget.currentRow.NMPESSOA = widget.currentRow.NMVINCULOM;
                widget.currentRow.NRPESSOA = widget.currentRow.NRPESSOAVINC;
                widget.currentRow.IDTPBENEFICIARIO = "T";
            }
                        
        }   
    };
    
    this.validaFieldVinculoBeneficiarioSintetico = function(widget){
        widget.currentRow.NMPESSOA = "";
        if(widget.currentRow.NMVINCULOM)
            widget.getField('NMPESSOA').readOnly = false;
        else
            widget.getField('NMPESSOA').readOnly = true;
    };
    
    
    this.validaWidgetAfterMoveRow = function(args){
        var widget = args.owner; 
        var actionEdit = widget.getAction('editar');
        var widgetmain = templateManager.container.getWidget("Beneficio");
        var nmPessoa = widget.currentRow.NMPESSOA;
        var nmEventoh = widget.currentRow.NMEVENTOH;
        var nmVinculo = widget.currentRow.NMVINCULOM;
        var tpBeneficio = widgetmain.currentRow.TPPERIODOBENEF;
        var tpvalor = widget.currentRow.IDVALORDIFEBENEF;
        
        if(widget.getField('IDVALORDIFEBENEF')){
            
            if(tpvalor === 'VALOR'){
                widget.getField('VRBENEFICIO').readOnly = false;
                widget.getField('DSREFERENCIA').readOnly = true;
                
                widget.currentRow.DSREFERENCIA = "";
            }
            else if(tpvalor === 'REFERENCIA'){
                widget.getField('VRBENEFICIO').readOnly = true;
                widget.getField('DSREFERENCIA').readOnly = false;
                
                widget.currentRow.VRBENEFICIO = "";
            }
            else if(tpvalor === 'TABELA'){
                widget.getField('VRBENEFICIO').readOnly = true;
                widget.getField('DSREFERENCIA').readOnly = true;
                
                widget.currentRow.VRBENEFICIO = "";
                widget.currentRow.DSREFERENCIA = "";
            }

        }
        
        if(!widget.currentRow.P_RESCISAO){
            widget.currentRow.P_RESCISAO = "A";
        }
        
        
        if(widget.getField('VRPERCSUBSIDIO') && widget.currentRow.SUBSIDIO100 == 'S') {
            widget.getField('VRPERCSUBSIDIO').readOnly = true;
        }else if(widget.getField('VRPERCSUBSIDIO'))
            widget.getField('VRPERCSUBSIDIO').readOnly = false;
        
    };
    
    this.salvarBeneficiarioPorEvento = function(args) {
        var widget = args.owner.widget;
        var widgetmain = templateManager.container.getWidget("Beneficio");
        var tipo;
        if (widget.isValid()) {

            /*if(verificaDtCancelamentoPorIdativoOnSave(widget))
                return;*/

            if (!widget.backupRow) {
                widget.currentRow.__is_new = true;
                tipo = true;
            }
            else {
                widget.currentRow.__is_new = false;
                tipo = false;
            }

            widget.currentRow.NRBENEFICIOM = widgetmain.currentRow.NRBENEFICIOM;
            widget.currentRow.NRESTRUTURAM = widgetmain.currentRow.NRESTRUTURAM;
            widget.currentRow.NRTABELAFOLHAPRI = widgetmain.currentRow.NRTABELAFOLHAPRI;
            widget.currentRow.NRTABELAFOLHASEC = widgetmain.currentRow.NRTABELAFOLHASEC;
            widget.currentRow.TPPERIODOBENEF = widgetmain.currentRow.TPPERIODOBENEF;
            
            
            if(widget.currentRow.VRBENEFICIO){
                widget.currentRow.VRBENEFICIO = General.valueToFloat(widget.currentRow.VRBENEFICIO); 
            }

            var saveData = Object.assign({}, widget.currentRow, {
                "NRORG": getLocalVar("HCM_NRORG_TRAB")
            }, {
                "DTMESCOMPETENC": getLocalVar("HCM_DTCOMPETENCIA_OPER")
            });

            if(widget.currentRow.SUBSIDIO100 == 'S'){
            
                if(widget.currentRow.IDTPBENEFICIARIO == 'T' && !widgetmain.currentRow.NMEVETITULAREMP){
                    ScreenService.showMessage(Messages.HCM02014_VAB_BENEFICIO_SUBSIDIADO100_TITULAR, 'ALERT');
                    return;
                }else if(widget.currentRow.IDTPBENEFICIARIO == 'D' && !widgetmain.currentRow.NMEVEDEPEMPRESA){
                    ScreenService.showMessage(Messages.HCM02014_VAB_BENEFICIO_SUBSIDIADO100_DEPENDENTE, 'ALERT');
                    return;
                }
            }

            restEngine.post('/setBeneficiarioPorEvento', {
                'requestType': 'DataSet',
                'dataset': [saveData]
            }).
            then(function(data) {
                // É verificado se data é do tipo String. Caso seja, é convertido para
                // tipo objeto.
                if(typeof(data) == 'string'){
                    var position=0; do{position++;}while(data.charAt(position) !== '{');
                    data = data.substring(position, data.length);
                    data = JSON.parse(data);
                }
                
                if ( (data.notifications != undefined) && (data.notifications[0].type === "success") ) {
                    ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 1000);
                    ABUtilController.masterDetailVoltarList(widget);
                    widget.reload();
                }else if(data.messages[0].message == Messages.HCM02014_VAB_BENEFICIARIO_EXISTENTE)
                    ScreenService.showMessage(Messages.HCM02014_VAB_BENEFICIARIO_EXISTENTE, 'ALERT');
                else if(data.messages[0].message == Messages.HCM02014_VAB_DTNASCIMENTO_NAO_INFORMADA)
                    ScreenService.showMessage(Messages.HCM02014_VAB_DTNASCIMENTO_NAO_INFORMADA, 'ALERT');
                else if(data.messages.length > 0)
                    ScreenService.showMessage(data.messages[0].message);
                else 
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                
            }).catch(function(e) {
                var error;
                if (e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
        }
    };

    this.salvarBeneficiario = function(args) {
        var widget = args.owner.widget;
        var widgetmain = templateManager.container.getWidget("Beneficio");
        var tipo;
        if (widget.isValid()) {

            /*if(verificaDtCancelamentoPorIdativoOnSave(widget))
                return;*/
            

            if (!widget.backupRow) {
                widget.currentRow.__is_new = true;
                tipo = true;
            }
            else {
                widget.currentRow.__is_new = false;
                tipo = false;
            }
            
            widget.currentRow.NRBENEFICIOM = widgetmain.currentRow.NRBENEFICIOM;
            
            var saveData = Object.assign({}, widget.currentRow, {
                "NRORG": getLocalVar("HCM_NRORG_TRAB")
            }, {
                "DTMESCOMPETENC": getLocalVar("HCM_DTCOMPETENCIA_OPER")
            });
            
            if(widget.currentRow.SUBSIDIO100 == 'S'){
            
                if(widget.currentRow.IDTPBENEFICIARIO == 'T' && !widgetmain.currentRow.NMEVETITULAREMP){
                    ScreenService.showMessage(Messages.HCM02014_VAB_BENEFICIO_SUBSIDIADO100_TITULAR, 'ALERT');
                    return;
                }else if(widget.currentRow.IDTPBENEFICIARIO == 'D' && !widgetmain.currentRow.NMEVEDEPEMPRESA){
                    ScreenService.showMessage(Messages.HCM02014_VAB_BENEFICIO_SUBSIDIADO100_DEPENDENTE, 'ALERT');
                    return;
                }
            }
            
            
            restEngine.post('/setBeneficiario', {
                'requestType': 'DataSet',
                'dataset': [saveData]
            }).
            then(function(data) {
                // É verificado se data é do tipo String. Caso seja, é convertido para
                // tipo objeto.
                if(typeof(data) == 'string'){
                    var position=0; do{position++;}while(data.charAt(position) !== '{');
                    data = data.substring(position, data.length);
                    data = JSON.parse(data);
                }
                
                if ( (data.notifications != undefined) && (data.notifications[0].type === "success") ) { 
                    ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 1000);
                    ABUtilController.masterDetailVoltarList(widget);
                    widget.reload();                
                }else if(data.messages[0].message == Messages.HCM02014_VAB_BENEFICIARIO_EXISTENTE)
                    ScreenService.showMessage(Messages.HCM02014_VAB_BENEFICIARIO_EXISTENTE, 'ERROR');
                else if(data.messages.length > 0)
                    ScreenService.showMessage(data.messages[0].message);
                else 
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                
            }).catch(function(e) {
                var error;
                if (e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
        }
    };
    
    this.salvarBeneficiarioVinculo = function(args) {
        var widget = args.owner.widget;
        var tipo;
        if (widget.isValid()) {

            if (!widget.backupRow) {
                widget.currentRow.__is_new = true;
                tipo = true;
            }
            else {
                widget.currentRow.__is_new = false;
                tipo = false;
            }
            
            
            var saveData = Object.assign({}, widget.currentRow, {
                "NRORG": getLocalVar("HCM_NRORG_TRAB")
            }, {
                "DTMESCOMPETENC": getLocalVar("HCM_DTCOMPETENCIA_OPER")
            });
            
            if(widget.currentRow.SUBSIDIO100 == 'S'){
            
                if(widget.currentRow.IDTPBENEFICIARIO == 'T'){
                    ScreenService.showMessage(Messages.HCM02014_VAB_BENEFICIO_SUBSIDIADO100_TITULAR, 'ALERT');
                    return;
                }else if(widget.currentRow.IDTPBENEFICIARIO == 'D'){
                    ScreenService.showMessage(Messages.HCM02014_VAB_BENEFICIO_SUBSIDIADO100_DEPENDENTE, 'ALERT');
                    return;
                }
            }
            
            
            restEngine.post('/setBeneficiario', {
                'requestType': 'DataSet',
                'dataset': [saveData]
            }).
            then(function(data) {
                // É verificado se data é do tipo String. Caso seja, é convertido para
                // tipo objeto.
                if(typeof(data) == 'string'){
                    var position=0; do{position++;}while(data.charAt(position) !== '{');
                    data = data.substring(position, data.length);
                    data = JSON.parse(data);
                }
                
                if ( (data.notifications != undefined) && (data.notifications[0].type === "success") ) { 
                    ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 1000);
                    ABUtilController.masterDetailVoltarList(widget);
                    widget.reload();                
                }else if(data.messages[0].message == Messages.HCM02014_VAB_BENEFICIARIO_EXISTENTE)
                    ScreenService.showMessage(Messages.HCM02014_VAB_BENEFICIARIO_EXISTENTE, 'ERROR');
                else if(data.messages.length > 0)
                    ScreenService.showMessage(data.messages[0].message);
                // else 
                //     ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                
            }).catch(function(e) {
                var error;
                if (e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
        }
    };

    this.salvarBeneficio = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
            if (this.validaPeriodo(widget.currentRow.DTINICIOVIGENCIA, widget.currentRow.DTFINALVIGENCIA)) {
                if(widget.currentRow.__is_new === true)
                    widget.currentRow.DTMESCOMPETENC = getLocalVar("HCM_DTCOMPETENCIA_OPER");
                
                if(!widget.currentRow.NMTABELAFOLHAPRI)
                    widget.currentRow.NRTABELAFOLHAPRI = null;
                
                if(!widget.currentRow.NMTABELAFOLHASEC)
                    widget.currentRow.NRTABELAFOLHASEC = null;
                
                var possibilidade = calcMensalidadePorFaixaEtaria(widget);

                if(possibilidade == 1){
                    ScreenService.showMessage(Messages.HCM02014_VAB_BENEFICIO_FAIXA_TIT_NULL_VLR_MENS_TIT_NULL);    
                    return false;
                }
                else if(possibilidade == 2){
                    ScreenService.showMessage(Messages.HCM02014_VAB_BENEFICIO_FAIXA_DEP_NULL_VLR_MENS_DEP_NULL);    
                    return false;
                }
                
                validaCamposMonetarios(widget.currentRow);
                this.saveMasterDetailMasterHistory(widget);
            }else {
                ScreenService.showMessage(Messages.HCM02014_VAB_BENEFICIO_FIM_VIGENCIA_MENOR_INICIO_VIGENCIA);
                return false;
            }
        }
    };
    
    var calcMensalidadePorFaixaEtaria = function(widget){
        var retorno = 0;
        
        if( widget.currentRow.TPPERIODOBENEF === 'MENSAL' ){
            if( !widget.currentRow.NRTABELAFOLHAPRI && !widget.currentRow.VRLINEARBENEFICIO )
                retorno = 1;
            else if( !widget.currentRow.NRTABELAFOLHASEC && !widget.currentRow.VRLINEARBENEFICIODEP )
                retorno = 2;
        }
        
        return retorno;

    };
    
    var validaCamposMonetarios = function(currentRow){
        currentRow.VRLINEARBENEFICIO = General.valueToFloat(currentRow.VRLINEARBENEFICIO);
        currentRow.VRLINEARBENEFICIODEP = General.valueToFloat(currentRow.VRLINEARBENEFICIODEP);
        currentRow.VRPISOTITULARMENS = General.valueToFloat(currentRow.VRPISOTITULARMENS);
        currentRow.VRTETOTITULARMENS = General.valueToFloat(currentRow.VRTETOTITULARMENS);
        currentRow.VRPARTICIPATITULAR = General.valueToFloat(currentRow.VRPARTICIPATITULAR);
        currentRow.VRTITULARSIND = General.valueToFloat(currentRow.VRTITULARSIND);
        currentRow.VRPARTICIPADEPE = General.valueToFloat(currentRow.VRPARTICIPADEPE);
        currentRow.VRDEPSIND = General.valueToFloat(currentRow.VRDEPSIND);
        currentRow.VRPISOTITULAR = General.valueToFloat(currentRow.VRPISOTITULAR);
        currentRow.VRTETOTITULAR = General.valueToFloat(currentRow.VRTETOTITULAR);
        currentRow.VRPISOTITULARSIND = General.valueToFloat(currentRow.VRPISOTITULARSIND);
        currentRow.VRTETOTITULARSIND = General.valueToFloat(currentRow.VRTETOTITULARSIND);
        currentRow.VRPISODEP = General.valueToFloat(currentRow.VRPISODEP);
        currentRow.VRTETODEP = General.valueToFloat(currentRow.VRTETODEP);
        currentRow.VRPISODEPSIND = General.valueToFloat(currentRow.VRPISODEPSIND);
        currentRow.VRTETODEPSIND = General.valueToFloat(currentRow.VRTETODEPSIND);
        currentRow.PERCOPARTICIPADEPE = General.valueToFloat(currentRow.PERCOPARTICIPADEPE);
        currentRow.PERCOPARTICIPATITU = General.valueToFloat(currentRow.PERCOPARTICIPATITU);
        currentRow.VREVENTOTAXA = General.valueToFloat(currentRow.VREVENTOTAXA);
        
    };

    this.removerBeneficio = function(args) {
        var widget = args.owner.widget;
        ScreenService.confirmMessage(Messages.DELETE_ROW, 'CONFIRMATION', function(){   
            widget.currentRow.__is_new = false;
            restEngine.post('/removerBeneficio', {
                'requestType': 'DataSet',
                'dataset': [widget.currentRow]
            }).
            then(function(data) {
                // É verificado se data é do tipo String. Caso seja, é convertido para
                // tipo objeto.
                if(typeof(data) == 'string'){
                    var position=0; do{position++;}while(data.charAt(position) !== '{');
                    data = data.substring(position, data.length);
                    data = JSON.parse(data);
                }            
                if ( (data.notifications != undefined) &&  (data.notifications[0].type === "success") ) {
                    ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                    ABUtilController.masterDetailVoltarList(widget);
                    widget.reload();
                }
                else if(data && data.messages && data.messages.length>0){
                    ScreenService.showMessage(data.messages[0].message);
                }else
                    ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
            }).
            catch(function(e) {
                var error;
                if (e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
        });
    };

    this.removerBeneficiario = function(args) {
        var widget = args.owner.widget;
        var widgetmain = templateManager.container.getWidget("Beneficio");
        ScreenService.confirmMessage(Messages.DELETE_ROW, 'CONFIRMATION', function(){   
            widget.currentRow.__is_new = false;
            widget.currentRow.NRESTRUTURAM = widgetmain.currentRow.NRESTRUTURAM;
            restEngine.post('/removerBeneficiario', {
                'requestType': 'DataSet',
                'dataset': [widget.currentRow]
            }).
            then(function(data) {
                // É verificado se data é do tipo String. Caso seja, é convertido para
                // tipo objeto.
                if(typeof(data) == 'string'){
                    var position=0; do{position++;}while(data.charAt(position) !== '{');
                    data = data.substring(position, data.length);
                    data = JSON.parse(data);
                }             
                if ((data.notifications != undefined) && (data.notifications[0].type === "success") ) {
                    ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                    ABUtilController.masterDetailVoltarList(widget);
                    widget.reload();
                }
                else {
                    ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                }
            }).
            catch(function(e) {
                var error;
                if (e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
        });
    };

    this.removerBeneficioVinculo = function(args) {
        var widget = args.owner.widget;
        ScreenService.confirmMessage(Messages.DELETE_ROW, 'CONFIRMATION', function(){   
            widget.currentRow.__is_new = false;
            restEngine.post('/removerBeneficiario', {
                'requestType': 'DataSet',
                'dataset': [widget.currentRow]
            }).
            then(function(data) {
                // É verificado se data é do tipo String. Caso seja, é convertido para
                // tipo objeto.
                if(typeof(data) == 'string'){
                    var position=0; do{position++;}while(data.charAt(position) !== '{');
                    data = data.substring(position, data.length);
                    data = JSON.parse(data);
                }             
                if ((data.notifications != undefined) && (data.notifications[0].type === "success") ) {
                    ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                    ABUtilController.masterDetailVoltarList(widget);
                    widget.reload();
                }
                else {
                    ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                }
            }).
            catch(function(e) {
                var error;
                if (e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
        });
    };
    
    this.validaPeriodo = function(dtIni, dtFin) {
        if (moment(dtIni, 'DD/MM/YYYY').unix() > moment(dtFin, 'DD/MM/YYYY').unix()) {
            return false;
        }
        else {
            return true;
        }
    }; 
    
    this.relogafield = function(args){
        var field = args.owner.field;
        field.reload();
    };
    
    
    this.fieldConsideraVincRescindidoOnChange = function(field){
        var widget = field.widget;
        if(widget.currentRow[field.name] == 'S') widget.getField('NRDIARESCISAO').validations = {required: true};
        else widget.getField('NRDIARESCISAO').validations = {};
    };
    
    this.montaDataSourceDias = function(widget){
        var fieldVencBoleto = widget.getField("NRDIAVENCBOLETO");
        var fieldDiaRescisao = widget.getField("NRDIARESCISAO");
        if(fieldVencBoleto.dataSource.data.length == 0){
            for(var i=1; i<=31; i++){
                fieldVencBoleto.dataSource.data.push({"NRDIAVENCBOLETO": i.toString(), "NMDIAVENCBOLETO": i.toString()});
                fieldDiaRescisao.dataSource.data.push({"NRDIARESCISAO": i.toString(), "NMDIARESCISAO": i.toString()});
            }    
        }
    };

    this.montaDataSourceMesAniversario  = function(widget){
        var fieldVencBoleto = widget.getField("NRMESANIVERSARIO");
        if(fieldVencBoleto.dataSource.data.length == 0){
            for(var i=1; i<=12; i++)
                fieldVencBoleto.dataSource.data.push({"NRMESANIVERSARIO": i.toString(), "NMMESANIVERSARIO": i.toString()});
        }
    };

    this.fieldsEventoVinculoOnEdit = function(widget, tipo){
        switch(tipo){
            case 'titular':
                var fieldTpPartTit = widget.getField('NRTIPOPARTICIPATITULAR');
                widget.getField('NRTABFAIXASALTIT').setValue("");
                widget.getField('VRPARTICIPATITULAR').setValue("");
                widget.getField('VRTITULARSIND').setValue("");
                if(fieldTpPartTit.value() === 'FAIXA_SAL'){
                    widget.getField('NRTABFAIXASALTIT').readOnly = false;
                    widget.getField('NRTABFAIXASALTIT').validations.required = true;
                    widget.getField('VRPARTICIPATITULAR').readOnly = true;
                    widget.getField('VRPARTICIPATITULAR').validations = {};
                    widget.getField('VRTITULARSIND').readOnly = true;
                }else{
                    widget.getField('NRTABFAIXASALTIT').readOnly = true;
                    widget.getField('NRTABFAIXASALTIT').validations = {};
                    widget.getField('VRPARTICIPATITULAR').readOnly = false;
                    widget.getField('VRPARTICIPATITULAR').validations.required = true;
                    widget.getField('VRTITULARSIND').readOnly = false;
                }
                break;
    
            case 'dependente':
                var fieldTpPartDep = widget.getField('NRTIPOPARTICIPADEP');
                widget.getField('NRTABFAIXASALDEP').setValue("");
                widget.getField('VRPARTICIPADEPE').setValue("");
                widget.getField('VRDEPSIND').setValue("");
                if(fieldTpPartDep.value() === 'FAIXA_SAL'){
                    widget.getField('NRTABFAIXASALDEP').readOnly = false;
                    widget.getField('NRTABFAIXASALDEP').validations.required = true;
                    widget.getField('VRPARTICIPADEPE').readOnly = true;
                    widget.getField('VRPARTICIPADEPE').validations = {};
                    widget.getField('VRDEPSIND').readOnly = true;
                }else{
                    widget.getField('NRTABFAIXASALDEP').readOnly = true;
                    widget.getField('NRTABFAIXASALDEP').validations = {};
                    widget.getField('VRPARTICIPADEPE').readOnly = false;
                    widget.getField('VRPARTICIPADEPE').validations.required = true;
                    widget.getField('VRDEPSIND').readOnly = false;
                }
                break;
        }
    };
    
    this.fieldsEventoVinculoOnActionEdit = function(widget){
        var fieldTpPartTit = widget.currentRow.NRTIPOPARTICIPATITULAR;
        var fieldTpPartDep = widget.currentRow.NRTIPOPARTICIPADEP;
        
        if(fieldTpPartTit){
            if(fieldTpPartTit === 'FAIXA_SAL'){
                widget.getField('NRTABFAIXASALTIT').readOnly = false;
                widget.getField('NRTABFAIXASALTIT').validations.required = true;
                widget.getField('VRPARTICIPATITULAR').readOnly = true;
                widget.getField('VRPARTICIPATITULAR').validations = {};
                widget.getField('VRTITULARSIND').readOnly = true;
            }else{
                widget.getField('NRTABFAIXASALTIT').readOnly = true;
                widget.getField('NRTABFAIXASALTIT').validations = {};
                widget.getField('VRPARTICIPATITULAR').readOnly = false;
                widget.getField('VRPARTICIPATITULAR').validations.required = true;
                widget.getField('VRTITULARSIND').readOnly = false;
            }
        }
        
        if(fieldTpPartDep){
            if(fieldTpPartDep === 'FAIXA_SAL'){
                widget.getField('NRTABFAIXASALDEP').readOnly = false;
                widget.getField('NRTABFAIXASALDEP').validations.required = true;
                widget.getField('VRPARTICIPADEPE').readOnly = true;
                widget.getField('VRPARTICIPADEPE').validations = {};
                widget.getField('VRDEPSIND').readOnly = true;
            }else{
                widget.getField('NRTABFAIXASALDEP').readOnly = true;
                widget.getField('NRTABFAIXASALDEP').validations = {};
                widget.getField('VRPARTICIPADEPE').readOnly = false;
                widget.getField('VRPARTICIPADEPE').validations.required = true;
                widget.getField('VRDEPSIND').readOnly = false;
            }        
        }
    };

    this.selectNativeToString = function(widget){
        var currentRow = widget.currentRow;
        if(currentRow.NRMESANIVERSARIO)
            currentRow.NRMESANIVERSARIO = currentRow.NRMESANIVERSARIO.toString();
        if(currentRow.NRDIAVENCBOLETO)
            currentRow.NRDIAVENCBOLETO = currentRow.NRDIAVENCBOLETO.toString();
        if(currentRow.NRDIARESCISAO)
            currentRow.NRDIARESCISAO = currentRow.NRDIARESCISAO.toString();
    };
    
    this.setReadOnlyFieldsEventoVinculoOnCancel = function(widget){
        widget.getField('NRTABFAIXASALDEP').readOnly = true;
        widget.getField('NRTABFAIXASALDEP').validations = {};
        widget.getField('VRPARTICIPADEPE').readOnly = true;
        widget.getField('VRPARTICIPADEPE').validations = {};
        widget.getField('VRDEPSIND').readOnly = true;
        widget.getField('NRTABFAIXASALTIT').readOnly = true;
        widget.getField('NRTABFAIXASALTIT').validations = {};
        widget.getField('VRPARTICIPATITULAR').readOnly = true;
        widget.getField('VRPARTICIPATITULAR').validations = {};
        widget.getField('VRTITULARSIND').readOnly = true;
    };
    
    this.validaEventoAndVlrMensalidadeOnEdit = function(widget, tipo){
        switch(tipo){
            case 'titular':
                if(widget.currentRow.NMEVENTOMENSA == ""){
                    widget.currentRow.NREVENTOMENSA = "";
                    widget.currentRow.VRLINEARBENEFICIO = "";
                }    
                break;
            
            case 'dependente':
                if(widget.currentRow.NMEVENTOMENSADEP == ""){
                   widget.currentRow.NREVENTOMENSADEP = "";
                   widget.currentRow.VRLINEARBENEFICIODEP = "";
                }   
                break;
        }
    };
    
    this.readOnlyQtdeBeneficioWidgetOnEnter = function(nomeWidget){
        var widget = templateManager.container.getWidget(nomeWidget);
        var widgetmain = templateManager.container.getWidget("Beneficio");
        if(widgetmain.currentRow.TPPERIODOBENEF === 'MENSAL')
            widget.getField('QTBENEFICIO').readOnly = true;
        else
            widget.getField('QTBENEFICIO').readOnly = false;
    };
    
    this.validaVisibilidadeFieldsTpBeneficiarioAndPessoa = function(nomeWidget){
        var widget;
        var widgetmain = templateManager.container.getWidget("Beneficio");
        
        if(widgetmain.currentRow.TPPERIODOBENEF === 'DIARIO'){
    
            if(nomeWidget === 'beneficiario'){
                widget = templateManager.container.getWidget(nomeWidget);
                widget.getField('NMPESSOA').validations = {};
                widget.getField('NMPESSOA').showOnForm = false;
                widget.getField('IDTPBENEFICIARIO').validations = {};
                widget.getField('IDTPBENEFICIARIO').showOnForm = false;
                widget.getField('IDTPBENEFICIARIO').filterProperties.showOnForm = false;
                widget.getField('IDTPBENEFICIARIO').filterProperties.sreadOnlyhowfalseOnForm = false;
                widget.getField('NMVINCULOM').class = "10";
            }else if(nomeWidget === 'beneficiarioPorEvento'){
                widget = templateManager.container.getWidget(nomeWidget);
                widget.getField('NMPESSOA').validations = {};
                widget.getField('NMPESSOA').showOnForm = false;
                widget.getField('IDTPBENEFICIARIO').validations = {};
                widget.getField('IDTPBENEFICIARIO').showOnForm = false;
                widget.getField('IDTPBENEFICIARIO').filterProperties.showOnForm = false;
                widget.getField('IDTPBENEFICIARIO').filterProperties.sreadOnlyhowfalseOnForm = false;
                widget.getField('NMEVENTOH').class = "4";
                
            }
    
        }else if(widgetmain.currentRow.TPPERIODOBENEF === 'MENSAL'){

            if(nomeWidget === 'beneficiario'){
                widget = templateManager.container.getWidget(nomeWidget);
                widget.getField('NMPESSOA').validations = {"required": true};
                widget.getField('NMPESSOA').showOnForm = true;
                widget.getField('IDTPBENEFICIARIO').validations = {"required": true};
                widget.getField('IDTPBENEFICIARIO').showOnForm = true;
                widget.getField('IDTPBENEFICIARIO').filterProperties.showOnForm = true;
                widget.getField('IDTPBENEFICIARIO').filterProperties.sreadOnlyhowfalseOnForm = true;
                widget.getField('NMVINCULOM').class = "4";
            }else if(nomeWidget === 'beneficiarioPorEvento'){
                widget = templateManager.container.getWidget(nomeWidget);
                widget.getField('NMPESSOA').validations = {"required": true};
                widget.getField('NMPESSOA').showOnForm = true;
                widget.getField('IDTPBENEFICIARIO').validations = {"required": true};
                widget.getField('IDTPBENEFICIARIO').showOnForm = true;
                widget.getField('IDTPBENEFICIARIO').filterProperties.showOnForm = true;
                widget.getField('IDTPBENEFICIARIO').filterProperties.sreadOnlyhowfalseOnForm = true;
                widget.getField('NMEVENTOH').class = "6";
                
            }
            
        }
    };
    
    this.setarVisibilidadeCamposParticipacaoOnEdit = function(tipo){
        var widget = templateManager.container.getWidget('Beneficio');
        switch(tipo){
            case 'titular':
                if(widget.currentRow.NMEVETITULARVINC){
                    widget.getField('NRTIPOPARTICIPATITULAR').validations.required = true;
                    widget.getField('NRTIPOPARTICIPATITULAR').readOnly = false;

                    widget.getField('VRPISOTITULAR').readOnly = false;
                    widget.currentRow.VRPISOTITULAR = "";    
                    widget.getField('VRTETOTITULAR').readOnly = false;
                    widget.currentRow.VRTETOTITULAR = "";    

                    widget.getField('VRPISOTITULARSIND').readOnly = false;
                    widget.currentRow.VRPISOTITULARSIND = "";    
                    widget.getField('VRTETOTITULARSIND').readOnly = false;
                    widget.currentRow.VRTETOTITULARSIND = "";    

                }else{
                    widget.getField('NRTIPOPARTICIPATITULAR').validations = {};
                    widget.getField('NRTIPOPARTICIPATITULAR').readOnly = true;
                    widget.currentRow.NRTIPOPARTICIPATITULAR = "";
                    
                    widget.getField('NRTABFAIXASALTIT').validations = {};
                    widget.getField('NRTABFAIXASALTIT').readOnly = true;
                    widget.currentRow.NMTABFAIXASALTIT = "";
                    widget.currentRow.NRTABFAIXASALTIT = "";
                    
                    widget.getField('VRPARTICIPATITULAR').validations = {};
                    widget.getField('VRPARTICIPATITULAR').readOnly = true;    
                    widget.currentRow.VRPARTICIPATITULAR = "";

                    widget.getField('VRTITULARSIND').readOnly = true;    
                    widget.currentRow.VRTITULARSIND = "";
                    
                    widget.getField('VRPISOTITULAR').readOnly = true;
                    widget.currentRow.VRPISOTITULAR = "";    
                    widget.getField('VRTETOTITULAR').readOnly = true;
                    widget.currentRow.VRTETOTITULAR = "";    

                    widget.getField('VRPISOTITULARSIND').readOnly = false;
                    widget.currentRow.VRPISOTITULARSIND = "";    
                    widget.getField('VRTETOTITULARSIND').readOnly = false;
                    widget.currentRow.VRTETOTITULARSIND = "";    
                }
                break;
                
            case 'dependente':
                if(widget.currentRow.NMEVEDEPEVINC){
                    widget.getField('NRTIPOPARTICIPADEP').validations.required = true;
                    widget.getField('NRTIPOPARTICIPADEP').readOnly = false;

                    widget.getField('VRPISODEP').readOnly = false;
                    widget.currentRow.VRPISODEP = "";    
                    widget.getField('VRTETODEP').readOnly = false;
                    widget.currentRow.VRTETODEP = "";    

                    widget.getField('VRPISODEPSIND').readOnly = false;
                    widget.currentRow.VRPISODEPSIND = "";    
                    widget.getField('VRTETODEPSIND').readOnly = false;
                    widget.currentRow.VRTETODEPSIND = "";    
                }else{
                    widget.getField('NRTIPOPARTICIPADEP').validations = {};
                    widget.getField('NRTIPOPARTICIPADEP').readOnly = true;                    
                    widget.currentRow.NRTIPOPARTICIPADEP = "";
                    
                    widget.getField('NRTABFAIXASALDEP').validations = {};
                    widget.getField('NRTABFAIXASALDEP').readOnly = true;
                    widget.currentRow.NMTABFAIXASALDEP = "";
                    widget.currentRow.NRTABFAIXASALDEP = "";
                    
                    widget.getField('VRPARTICIPADEPE').validations = {};
                    widget.getField('VRPARTICIPADEPE').readOnly = true;    
                    widget.currentRow.VRPARTICIPADEPE = "";                    

                    widget.getField('VRDEPSIND').readOnly = true;    
                    widget.currentRow.VRDEPSIND = "";                    

                    widget.getField('VRPISODEP').readOnly = true;
                    widget.currentRow.VRPISODEP = "";  
                    widget.getField('VRTETODEP').readOnly = true;
                    widget.currentRow.VRTETODEP = "";    

                    widget.getField('VRPISODEPSIND').readOnly = false;
                    widget.currentRow.VRPISODEPSIND = "";    
                    widget.getField('VRTETODEPSIND').readOnly = false;
                    widget.currentRow.VRTETODEPSIND = "";    
                }
                break;
        }
    };
    
    this.setarVisibilidadeCamposParticipacaoOnActionEdit = function(widget){
        
        if(widget.currentRow.NMEVETITULARVINC){
            widget.getField('NRTIPOPARTICIPATITULAR').validations.required = true;
            widget.getField('NRTIPOPARTICIPATITULAR').readOnly = false;
            
            widget.getField('VRPISOTITULAR').readOnly = false;
            widget.getField('VRTETOTITULAR').readOnly = false;

            widget.getField('VRPISOTITULARSIND').readOnly = false;
            widget.getField('VRTETOTITULARSIND').readOnly = false;

            if(widget.currentRow.NMTABFAIXASALTIT){
                widget.getField('NRTABFAIXASALTIT').validations.required = true;
                widget.getField('NRTABFAIXASALTIT').readOnly = false;    
                widget.getField('VRPARTICIPATITULAR').validations = {};
                widget.getField('VRPARTICIPATITULAR').readOnly = true;
                widget.getField('VRTITULARSIND').readOnly = true;
            }else{
                widget.getField('NRTABFAIXASALTIT').validations = {};
                widget.getField('NRTABFAIXASALTIT').readOnly = true;    
                widget.getField('VRPARTICIPATITULAR').validations.required = true;
                widget.getField('VRPARTICIPATITULAR').readOnly = false;    
                widget.getField('VRTITULARSIND').readOnly = false;    
            }
            
        }else{
            widget.getField('NRTIPOPARTICIPATITULAR').validations = {};
            widget.getField('NRTIPOPARTICIPATITULAR').readOnly = true;

            widget.getField('NRTABFAIXASALTIT').validations = {};
            widget.getField('NRTABFAIXASALTIT').readOnly = true;

            widget.getField('VRPARTICIPATITULAR').validations = {};
            widget.getField('VRPARTICIPATITULAR').readOnly = true;    

            widget.getField('VRTITULARSIND').readOnly = true;    

            widget.getField('VRPISOTITULAR').readOnly = true;
            widget.getField('VRTETOTITULAR').readOnly = true;

            widget.getField('VRPISOTITULARSIND').readOnly = true;
            widget.getField('VRTETOTITULARSIND').readOnly = true;
        }
        
        if(widget.currentRow.NMEVEDEPEVINC){
            widget.getField('NRTIPOPARTICIPADEP').validations.required = true;
            widget.getField('NRTIPOPARTICIPADEP').readOnly = false;

            widget.getField('VRPISODEP').readOnly = false;
            widget.getField('VRTETODEP').readOnly = false;

            widget.getField('VRPISODEPSIND').readOnly = false;
            widget.getField('VRTETODEPSIND').readOnly = false;

            if(widget.currentRow.NMTABFAIXASALDEP){
                widget.getField('NRTABFAIXASALDEP').validations.required = true;
                widget.getField('NRTABFAIXASALDEP').readOnly = false;    
                widget.getField('VRPARTICIPADEPE').validations = {};
                widget.getField('VRPARTICIPADEPE').readOnly = true;
                widget.getField('VRDEPSIND').readOnly = true;
            }else{
                widget.getField('NRTABFAIXASALDEP').validations = {};
                widget.getField('NRTABFAIXASALDEP').readOnly = true;    
                widget.getField('VRPARTICIPADEPE').validations.required = true;
                widget.getField('VRPARTICIPADEPE').readOnly = false;    
                widget.getField('VRDEPSIND').readOnly = false;    
            }            

        }else{
            widget.getField('NRTIPOPARTICIPADEP').validations = {};
            widget.getField('NRTIPOPARTICIPADEP').readOnly = true;
            
            widget.getField('NRTABFAIXASALDEP').validations = {};
            widget.getField('NRTABFAIXASALDEP').readOnly = true;
            
            widget.getField('VRPARTICIPADEPE').validations = {};
            widget.getField('VRPARTICIPADEPE').readOnly = true;    

            widget.getField('VRDEPSIND').readOnly = true;    
            
            widget.getField('VRPISODEP').readOnly = true;
            widget.getField('VRTETODEP').readOnly = true;

            widget.getField('VRPISODEPSIND').readOnly = true;
            widget.getField('VRTETODEPSIND').readOnly = true;
        }
        
    };
    
    this.setarVisibilidadeCamposParticipacaoOnActionAdd = function(widget){
        // ----- Fields Participação Titular
        widget.getField('NRTIPOPARTICIPATITULAR').validations = {};
        widget.getField('NRTIPOPARTICIPATITULAR').readOnly = true;

        widget.getField('NRTABFAIXASALTIT').validations = {};
        widget.getField('NRTABFAIXASALTIT').readOnly = true;

        widget.getField('VRPARTICIPATITULAR').validations = {};
        widget.getField('VRPARTICIPATITULAR').readOnly = true;  

        widget.getField('VRTITULARSIND').readOnly = true;  
        
        widget.getField('VRPISOTITULAR').readOnly = true;
        widget.getField('VRTETOTITULAR').readOnly = true;

        widget.getField('VRPISOTITULARSIND').readOnly = true;
        widget.getField('VRTETOTITULARSIND').readOnly = true;

        // ----- Fields Participação Dependente
        widget.getField('NRTIPOPARTICIPADEP').validations = {};
        widget.getField('NRTIPOPARTICIPADEP').readOnly = true;
        
        widget.getField('NRTABFAIXASALDEP').validations = {};
        widget.getField('NRTABFAIXASALDEP').readOnly = true;
        
        widget.getField('VRPARTICIPADEPE').validations = {};
        widget.getField('VRPARTICIPADEPE').readOnly = true;  

        widget.getField('VRDEPSIND').readOnly = true;  

        widget.getField('VRPISODEP').readOnly = true;
        widget.getField('VRTETODEP').readOnly = true;

        widget.getField('VRPISODEPSIND').readOnly = true;
        widget.getField('VRTETODEPSIND').readOnly = true;
    };
    
    this.fieldTetoOnChange = function(widgetBeneficio, tipo, associado){
        var piso, teto, campoPiso, campoTeto;
        switch(tipo){
            case 'titular':
                campoPiso = 'VRPISOTITULAR';
                campoTeto = 'VRTETOTITULAR';
                if(associado){
                    campoPiso = 'VRPISOTITULARSIND';
                    campoTeto = 'VRTETOTITULARSIND';
                }

                piso = widgetBeneficio.currentRow[campoPiso];
                teto = widgetBeneficio.currentRow[campoTeto];
                if ( piso && General.valueToFloat(piso) > General.valueToFloat(teto) ) 
                    widgetBeneficio.currentRow[campoTeto] = "";
                break;
                
            case 'dependente':
                campoPiso = 'VRPISODEP';
                campoTeto = 'VRTETODEP';
                if(associado){
                    campoPiso = 'VRPISODEPSIND';
                    campoTeto = 'VRTETODEPSIND';
                }
                

                piso = widgetBeneficio.currentRow[campoPiso];
                teto = widgetBeneficio.currentRow[campoTeto];
                if( piso && General.valueToFloat(piso) > General.valueToFloat(teto) )
                    widgetBeneficio.currentRow[campoTeto] = "";    
                break;
        }
        
    };
    
    this.fieldPisoOnChange = function(widgetBeneficio, tipo, associado){
        var piso, teto, campoPiso, campoTeto;
        switch(tipo){
            case 'titular':
                campoPiso = 'VRPISOTITULAR';
                campoTeto = 'VRTETOTITULAR';
                if(associado){
                    campoPiso = 'VRPISOTITULARSIND';
                    campoTeto = 'VRTETOTITULARSIND';
                }
                
                piso = widgetBeneficio.currentRow[campoPiso];
                teto = widgetBeneficio.currentRow[campoTeto];
                if (teto && General.valueToFloat(piso) > General.valueToFloat(teto) ) 
                    widgetBeneficio.currentRow[campoTeto] = "";
                break;
                
            case 'dependente':
                campoPiso = 'VRPISODEP';
                campoTeto = 'VRTETODEP';
                if(associado){
                    campoPiso = 'VRPISODEPSIND';
                    campoTeto = 'VRTETODEPSIND';
                }
                
                piso = widgetBeneficio.currentRow[campoPiso];
                teto = widgetBeneficio.currentRow[campoTeto];
                if( teto && General.valueToFloat(piso) > General.valueToFloat(teto) )
                    widgetBeneficio.currentRow[campoTeto] = "";    
                break;  
        }        
    };
    
    this.validaQtdeBeneficioWidgetCadExcAutomatico = function(){
        var widgetCad = templateManager.container.getWidget('filterBeneficiarios');
        var widgetMain = templateManager.container.getWidget('Beneficio');
        
        if(widgetMain.currentRow.TPPERIODOBENEF == 'MENSAL'){
            widgetCad.currentRow.QTBENEFICIO = 1;
            widgetCad.getField('QTBENEFICIO').readOnly = true;
        }else{
            widgetCad.currentRow.QTBENEFICIO = "";
            widgetCad.getField('QTBENEFICIO').readOnly = false;
        }
    };
    
    this.validaMinimizadores = function(fieldConsid, fieldQtdd){
        var widgetBeneficio = templateManager.container.getWidget('Beneficio');
        
        if(widgetBeneficio.getField(fieldConsid).value() == 'N'){
            widgetBeneficio.getField(fieldQtdd).setValue(0);
            widgetBeneficio.getField(fieldQtdd).readOnly = true;
        }else{
            widgetBeneficio.getField(fieldQtdd).readOnly = false;
        }
    };
    
    this.validaMinizadoresOnActionEdit = function(widget){
        if(widget.currentRow.IDCONSFALTABENEF === 'N') widget.getField('QTMESESFALTABENEF').readOnly = true;

        if(widget.currentRow.IDCONSATESTBENEF === 'N') widget.getField('QTMESESATESTBENEF').readOnly = true;

        if(widget.currentRow.IDCONSAFASTBENEF === 'N') widget.getField('QTMESESAFASTBENEF').readOnly = true;

        if(widget.currentRow.IDCONSFERIASBENEF === 'N') widget.getField('QTMESESFERIASBENEF').readOnly = true;

        if(widget.currentRow.IDCONSFERIADOBENEF === 'N') widget.getField('QTMESESFERIADOBENEF').readOnly = true;
    
        if(widget.currentRow.IDCONSDSRBENEF === 'N') widget.getField('QTMESESDSRBENEF').readOnly = true;
    };
    
    this.validarIgualdadeMesesFeriadosDSR = function(nameField){
        
        var widgetBeneficio = templateManager.container.getWidget('Beneficio');
        
        if(nameField === 'IDCONSFERIADOBENEF' && widgetBeneficio.currentRow.IDCONSFERIADOBENEF == 'S')
            widgetBeneficio.currentRow.QTMESESFERIADOBENEF = widgetBeneficio.currentRow.QTMESESDSRBENEF;

        else if(nameField === 'QTMESESFERIADOBENEF' && widgetBeneficio.currentRow.IDCONSDSRBENEF == 'S')
            widgetBeneficio.currentRow.QTMESESDSRBENEF = widgetBeneficio.currentRow.QTMESESFERIADOBENEF;

        else if(nameField === 'IDCONSDSRBENEF' && widgetBeneficio.currentRow.IDCONSDSRBENEF == 'S')
            widgetBeneficio.currentRow.QTMESESDSRBENEF = widgetBeneficio.currentRow.QTMESESFERIADOBENEF;

        else if(nameField === 'QTMESESDSRBENEF' && widgetBeneficio.currentRow.IDCONSFERIADOBENEF == 'S')
            widgetBeneficio.currentRow.QTMESESFERIADOBENEF = widgetBeneficio.currentRow.QTMESESDSRBENEF;

    };
    

    this.validaDtCancelamentoBeneficiarioPorIdativo = function(args){
        var widgetBeneficiario = args.owner.field.widget;
        
        widgetBeneficiario.currentRow.DTCANCBENEFICIARIO = "";

        if(widgetBeneficiario.currentRow.IDATIVO === 'N'){
            widgetBeneficiario.getField('DTCANCBENEFICIARIO').validations = {required:true};
        }else{
            widgetBeneficiario.getField('DTCANCBENEFICIARIO').validations = {};
        }

    };
    
    var verificaDtCancelamentoPorIdativoOnSave = function(widgetBeneficiario){
        var retorno = false;
        
        // ------ Manipulacao DtCompetencia para formato americano
        var dtCompetencia = getLocalVar('HCM_DTCOMPETENCIA_OPER');
        dtCompetencia = dtCompetencia.substr(0, 10); 
        dtCompetencia = dtCompetencia.split('/');
        dtCompetencia = dtCompetencia[2]+'/'+dtCompetencia[1]+'/'+dtCompetencia[0];

        // ------ Manipulacao DtCancelamento para formato americano
        var dtCancelamento = widgetBeneficiario.currentRow.DTCANCBENEFICIARIO;
    
        if(dtCancelamento){
            dtCancelamento = dtCancelamento.substr(0, 10); 
            dtCancelamento = dtCancelamento.split('/');
            dtCancelamento = dtCancelamento[2]+'/'+dtCancelamento[1]+'/'+dtCancelamento[0];
        }

        if(    widgetBeneficiario.currentRow.IDATIVO === 'N' && ( !dtCancelamento || dtCancelamento >= dtCompetencia) ){
            ScreenService.showMessage(Messages.HCM02014_VAB_BENEFICIO_DTINSCRICAO_POR_IDATIVO, 'ALERT');
            retorno = true;
        }    
        
        return retorno;
    };
    
    this.validaReadOnlyFieldDtCancelamentoOnActionEdit = function(widgetName){
        var widgetBeneficiario = templateManager.container.getWidget(widgetName);
        
        if(widgetBeneficiario.currentRow.IDATIVO === 'N')
            widgetBeneficiario.getField('DTCANCBENEFICIARIO').validations = {required:true};
        else
            widgetBeneficiario.getField('DTCANCBENEFICIARIO').validations = {};
    
    };

    this.validaReadOnlyFieldDtCancelamentoOnActionAdd = function(widgetName){
        var widgetBeneficiario = templateManager.container.getWidget(widgetName);
        widgetBeneficiario.getField('DTCANCBENEFICIARIO').validations = {};
    };

    this.tipoHierarquiaOnChange = function(args){
        var widget = args.owner.field.widget;

        widget.getField('NMESTRUTSUPERIOR').dataSourceFilter.forEach(function(filter, index){
            if(filter.name == 'NRTIPOESTRUTURA') widget.getField('NMESTRUTSUPERIOR').dataSourceFilter.splice(index, 1);
        });

        if(widget.currentRow.NRTIPOHIERARQORG){
            widget.getField('NMESTRUTSUPERIOR').dataSourceFilter.push(
                {
                    name: "NRTIPOESTRUTURA",
                    operator: "=",
                    value: widget.currentRow.NRTIPOESTRUTSUP ? widget.currentRow.NRTIPOESTRUTSUP : widget.currentRow.NRTIPOESTRUTREL
                }
            );
        }
        
        widget.getField('NMESTRUTSUPERIOR').reload();
        
    };
    
    this.setDataSourceFilter = function(arsg){
        var widget = args.owner.field.widget;
        
        if(widget.currentRow.NRTIPOHIERARQORG){
            widget.getField('NMESTRUTSUPERIOR').dataSourceFilter.push(
                {
                    name: "NRTIPOESTRUTURA",
                    operator: "=",
                    value: widget.currentRow.NRTIPOESTRUTSUP
                }
            );
        }
        
    };
    
    this.habilitaIdgeradescafast = function(){
        var widgetBeneficio = templateManager.container.getWidget('Beneficio');
        
        if(widgetBeneficio.getField('IDGERABENEFAFAST').value() == 'S'){
            widgetBeneficio.getField('IDGERADESCAFAST').readOnly = false;
        }else{
            widgetBeneficio.getField('IDGERADESCAFAST').readOnly = true;
            if(widgetBeneficio.editing){
                widgetBeneficio.getField('IDGERADESCAFAST').setValue('N');
            }
        }
    };
    
    this.setPeriodicidadeMes = function(){
        var widgetBeneficio = templateManager.container.getWidget('Beneficio');
        
        widgetBeneficio.getField('PERIODICIDADEMES').setValue(
            widgetBeneficio.getField('PERIODICIDADEMES01').value()+
            widgetBeneficio.getField('PERIODICIDADEMES02').value()+
            widgetBeneficio.getField('PERIODICIDADEMES03').value()+
            widgetBeneficio.getField('PERIODICIDADEMES04').value()+
            widgetBeneficio.getField('PERIODICIDADEMES05').value()+
            widgetBeneficio.getField('PERIODICIDADEMES06').value()+
            widgetBeneficio.getField('PERIODICIDADEMES07').value()+
            widgetBeneficio.getField('PERIODICIDADEMES08').value()+
            widgetBeneficio.getField('PERIODICIDADEMES09').value()+
            widgetBeneficio.getField('PERIODICIDADEMES10').value()+
            widgetBeneficio.getField('PERIODICIDADEMES11').value()+
            widgetBeneficio.getField('PERIODICIDADEMES12').value()
        );
    };
    
     this.exportarTemplateBeneficio = function(widget) {
        restEngine.post('/exportarTemplateBeneficio', {
            'requestType': 'DataSet',
            'dataset': []
        }).then(function(data) {
            ScreenService.closePopup();
            if(data.dataset && data.dataset.arquivo){
                $window.open($window.serviceUrl + "/abrirArquivo?requestType=DataSet&dataset[0][CMARQUIVO]=" + data.dataset.arquivo.NMARQUIVO);
            }
        }).catch(function(e) {
            var error;
            if (e.data.error === undefined)
                error = e;
            else
                error = e.data.error;
            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
        });
    };

}

Configuration(function(ContextRegister) {
    ContextRegister.register('BeneficioController', BeneficioController);
});

// FILE: assets/js/controllers/BeneficioVinculoController.js
function BeneficioVinculoController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, General, Messages) {
    
    this.setNrvinculoDatasourcefilter = function(args){
        var widget = args.owner;
        var widBeneficioTitular = widget.widgets[ABUtilController.retornaWidget(widget, 'beneficioTitular')];
        var widRelac = widget.widgets[ABUtilController.retornaWidget(widget, 'beneficioRelacionamento')];
        var widBeneficioRelac = widRelac.widgets[ABUtilController.retornaWidget(widRelac, 'beneficioRelacionados')];
        
        widBeneficioTitular.dataSourceFilter[ABUtilController.retornaFiltro(widBeneficioTitular.dataSourceFilter, 'P_NRVINCULOM')].value = widget.currentRow.NRVINCULOM;
        widRelac.dataSourceFilter[ABUtilController.retornaFiltro(widRelac.dataSourceFilter, 'P_NRVINCULOM')].value = widget.currentRow.NRVINCULOM;
        widBeneficioRelac.dataSourceFilter[ABUtilController.retornaFiltro(widBeneficioRelac.dataSourceFilter, 'P_NRVINCULOM')].value = widget.currentRow.NRVINCULOM;
    };
    
    this.setNrpessoaDatasourcefilter = function(args){
        var widget = args.owner;
        var widBeneficioRelac = widget.widgets[ABUtilController.retornaWidget(widget, 'beneficioRelacionados')];
        
        widBeneficioRelac.dataSourceFilter[ABUtilController.retornaFiltro(widBeneficioRelac.dataSourceFilter, 'P_NRPESSOA_DEP')].value = widget.currentRow.NRPESSOA;
    };
    
    this.insereBeneficioVinculo = function(args){
        var widBeneficio = args.owner.widget;
        var widVinculo = widBeneficio.parent.parent;
        var currentRow = widBeneficio.currentRow;
        currentRow.NRVINCULOM = widVinculo.currentRow.NRVINCULOM;
        currentRow.NRPESSOA = widVinculo.currentRow.NRPESSOA;
        currentRow.SUBSIDIO100 = null;
        if(widBeneficio.isValid()){
            ScreenService.confirmMessage('Deseja realmente acrescentar esse benefício?', 'CONFIRMATION', 
                function(){
                    restEngine.post('product#/setBeneficiario', {'requestType':'DataSet','dataset':[currentRow]}).
                        then(function(data){
                            if ( (data.notifications != undefined) && (data.notifications[0].type === "success") ) { 
                                ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 1000);
                                ABUtilController.masterDetailVoltarList(widBeneficio);
                                widBeneficio.reload();                
                            }else if(data.messages[0].message == Messages.HCM02014_VAB_BENEFICIARIO_EXISTENTE)
                                ScreenService.showMessage(Messages.HCM02014_VAB_BENEFICIARIO_EXISTENTE, 'ERROR');
                            else if(data.messages.length > 0)
                                ScreenService.showMessage(data.messages[0].message);
                            else 
                                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                            
                        }).
                        catch(function(e) {
                            var error;
                            if(e.data.error === undefined)
                                error = e;
                            else
                                error = e.data.error;
                                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                        });
                        
                        
                });
        }
    };
    
    this.deleteBeneficiarioVinculo = function(args){
        var widBeneficio = args.owner.widget;
        var widVinculo = widBeneficio.parent;
        var currentRow = widBeneficio.currentRow;
        currentRow.NRVINCULOM = widVinculo.currentRow.NRVINCULOM;
        currentRow.NRPESSOA = widVinculo.currentRow.NRPESSOA;
        currentRow.__is_new = false;
        
        ScreenService.confirmMessage('Deseja realmente remover esse benefício?', 'CONFIRMATION', 
            function(){
                restEngine.post('product#/removerBeneficiario', {'requestType':'DataSet','dataset':[currentRow]}).
                    then(function(data){
                        if ((data.notifications != undefined) && (data.notifications[0].type === "success") ) {
                            ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                            ABUtilController.masterDetailVoltarList(widBeneficio);
                            widBeneficio.reload();
                        }
                        else {
                            ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                        }
                    }).
                    catch(function(e) {
                        var error;
                        if(e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;
                            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    });
                        
            });
    };

}

Configuration(function(ContextRegister) {
    ContextRegister.register('BeneficioVinculoController', BeneficioVinculoController);
});

// FILE: assets/js/controllers/BloqueioEventoVinculoController.js
function BloqueioEventoVinculoController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, $window, ABUtilController, Messages) {

    this.adicionarRow = function() {
        var widget = templateManager.container.getActiveWidget();
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
    };
    
    this.setBloqueioEvento = function () {
        var widget = templateManager.container.getActiveWidget();
        if (widget.isValid()) {
            if (!widget.backupRow) {
                widget.currentRow.__is_new = true;
            } else {
                widget.currentRow.__is_new = false;
            }
            restEngine.post('product#/setBloqueioEvento', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                then(function (data) {
                    if (data.notifications[0].type === "success") {
                        ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                        if (widget.currentRow.__is_new) {
                            ABUtilController.masterDetailVoltarList(widget);
                            widget.reload();
                        } else {
                            ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                            widget.backupRow = null;
                            widget.view();
                        }
                    }else if(data.notifications[0].message === 'HCM01037_FPA_REGISTRO_EXISTENTE')
                        ScreenService.showMessage(Messages.HCM01037_FPA_REGISTRO_EXISTENTE, 'ERROR');
                    else 
                        ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                }).
                catch(function(e) {
                    var error;
                    if(e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;
                        
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
                
            }  
    };
    
    this.deleteBloqueioEvento = function() {
        ScreenService.confirmMessage(Messages.DELETE_ROW, 'CONFIRMATION', function(){
            var widget = templateManager.container.getActiveWidget();
            if (widget.isValid()) {
                widget.currentRow.__is_new = false;
                restEngine.post('product#/deleteBloqueioEvento', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                    then(function (data) {
                        if (data.notifications[0].type === "success") {
                            ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                            ABUtilController.masterDetailVoltarList(widget);
                            widget.reload();
                        } else {
                            ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                        }
                    }).
                    catch(function(e) {
                        var error;
                        if(e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;
                            
                        ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    });
            }
        });
    };
    
}

Configuration(function(ContextRegister) {
    ContextRegister.register('BloqueioEventoVinculoController', BloqueioEventoVinculoController);
});

// FILE: assets/js/controllers/CCTController.js
function CCTController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, General, Messages) {
    
    /* Controller utilizado também na tela hcm00118_gpe_parametrizacaoSindicado */
    
    var self = this;
    
    this.mudarVisibilidadeWidgets = function(widgets, value) {
        widgets.forEach(function(widget) {
            widget.isVisible = value;
        });
    };

    this.CCTAfterMoveRow = function(widget) {
        widget.widgets[0].dataSourceFilter[0].value = widget.currentRow.NRCADASTROCCT;
        widget.widgets[1].dataSourceFilter.forEach(function(filter){
            if(filter.name == "NRCADASTROCCT") filter.value = widget.currentRow.NRCADASTROCCT;
        });
    };

    this.montaDataSourceDias = function(widget){
        var fieldQtdeDiasMinMes = widget.getField("QTDIASMINMES");
        if(fieldQtdeDiasMinMes.dataSource.data.length == 0){
            for(var i=1; i<=31; i++){
                fieldQtdeDiasMinMes.dataSource.data.push({"QTDIASMINMES": i.toString(), "NMQTDIASMINMES": i.toString()});
            }    
        }
    };


    this.adicionarRow = function(args) {
        var widget = args.owner.widget;
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
    };

    this.setCCT = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
            if (ABUtilController.validaDtIniMenorIgualDtFin(widget.currentRow.DTINIVIGENCIACCT, widget.currentRow.DTFINVIGENCIACCT)) {
                if (!widget.backupRow) {
                    widget.currentRow.__is_new = true;
                } else {
                    widget.currentRow.__is_new = false;
                }
                widget.currentRow.DTANOBASECCT = "01" + widget.currentRow.DTANOBASECCT.slice(2);
                restEngine.post('product#/setCCT', {
                    'requestType': 'DataSet',
                    'dataset': [widget.currentRow]
                }).
                then(function(data) {
                    if (data.notifications[0].type === "success") {
                        ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                        if (widget.currentRow.__is_new) {
                            ABUtilController.masterDetailVoltarList(widget);
                            widget.reload();
                        } else {
                            widget.backupRow = null;
                            widget.view();
                        }
                        self.mudarVisibilidadeWidgets(widget.widgets, true);
                    } else {
                        ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                    }
                }).
                catch(function(e) {
                    var error;
                    if (e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;

                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });

            } else {
                ScreenService.showMessage(Messages.DTINI_POST_DTFIM_ERROR);
                return false;
            }
        }
    };

    this.deleteCCT = function(args) {
        var widget = args.owner.widget;
        ScreenService.confirmMessage(Messages.DELETE_ROW, 'CONFIRMATION',
            function() {
                restEngine.post('product#/deleteCCT', {
                    'requestType': 'DataSet',
                    'dataset': [widget.currentRow]
                }).
                then(function(data) {
                    if (data.notifications[0].type === "success") {
                        ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    } else {
                        ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                    }
                }).
                catch(function(e) {
                    var error;
                    if (e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;

                    ScreenService.showMessage(error, 'ERROR');
                });
            }
        );
    };

    this.setItemCCT = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
            if (ABUtilController.validaDtIniMenorIgualDtFin(widget.currentRow.DTINIVIGENCIACCT, widget.currentRow.DTFINVIGENCIACCT)) {
                if (!widget.backupRow) {
                    widget.currentRow.__is_new = true;
                } else {
                    widget.currentRow.__is_new = false;
                }
                widget.currentRow.NRCADASTROCCT = templateManager.container.getWidget('CCT').currentRow.NRCADASTROCCT;
                restEngine.post('product#/setItemCCT', {
                    'requestType': 'DataSet',
                    'dataset': [widget.currentRow]
                }).
                then(function(data) {
                    if (data.notifications[0].type === "success") {
                        ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                        if (widget.currentRow.__is_new) {
                            ABUtilController.masterDetailVoltarList(widget);
                            widget.reload();
                        } else {
                            ABUtilController.masterDetailVoltarList(widget);
                            widget.reload();
                        }
                    } else {
                        ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                    }
                }).
                catch(function(e) {
                    var error;
                    if (e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;

                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });

            } else {
                ScreenService.showMessage(Messages.DTINI_POST_DTFIM_ERROR);
                return false;
            }
        }
    };

    this.deleteItemCCT = function(args) {
        var widget = args.owner.widget;
        ScreenService.confirmMessage(Messages.DELETE_ROW, 'CONFIRMATION',
            function() {
                restEngine.post('product#/deleteItemCCT', {
                    'requestType': 'DataSet',
                    'dataset': [widget.currentRow]
                }).
                then(function(data) {
                    if (data.notifications[0].type === "success") {
                        ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    } else {
                        ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                    }
                }).
                catch(function(e) {
                    var error;
                    if (e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
            }
        );
    };

    this.openPopupRecadastro = function(args) {
        var widget = templateManager.container.getWidget('recadastro');
        ScreenService.openPopup(widget);
        widget.currentRow.NRORG = args.owner.widget.currentRow.NRORG;
        widget.currentRow.NRCADASTROCCT = args.owner.widget.currentRow.NRCADASTROCCT;
        widget.currentRow.IDATIVO = args.owner.widget.currentRow.IDATIVO;
        widget.currentRow.NMESTRUTURAM = args.owner.widget.currentRow.NMESTRUTURAM;
        widget.currentRow.DTANOBASECCT = args.owner.widget.currentRow.DTANOBASECCT;
        widget.currentRow.DTINIVIGENCIACCT = args.owner.widget.currentRow.DTINIVIGENCIACCT;
        widget.currentRow.DTFINVIGENCIACCT = args.owner.widget.currentRow.DTFINVIGENCIACCT;

    };

    this.salvarRecadastro = function(args) {
        var widget = args.owner.widget;
        var wid = templateManager.container.getWidget("CCT");
        if (widget.isValid()) {
            if (ABUtilController.validaDtIniMenorIgualDtFin(widget.currentRow.DTINIVIGENCIACCT, widget.currentRow.DTFINVIGENCIACCT)) {
                if (ABUtilController.validaDtIniMenorIgualDtFin(wid.currentRow.DTANOBASECCT, widget.currentRow.DTANOBASECCT)) {
                    if (!widget.backupRow) {
                        widget.currentRow.__is_new = true;
                    } else {
                        widget.currentRow.__is_new = false;
                    }
                    widget.currentRow.NRORG = wid.currentRow.NRORG;
                    widget.currentRow.NRCADASTROCCT = wid.currentRow.NRCADASTROCCT;
                    widget.currentRow.IDATIVO = wid.currentRow.IDATIVO;
                    widget.currentRow.NRESTRUTURAM = wid.currentRow.NRESTRUTURAM;
                    restEngine.post('product#/recadastroCCT', {
                        'requestType': 'DataSet',
                        'dataset': [widget.currentRow]
                    }).
                    then(function(data) {
                        ScreenService.showMessage(data.messages[0].message, data.messages[0].type);
                        ScreenService.closePopup();
                        ScreenService.closeSwipe();
                        wid.reload();
                    }).
                    catch(function(e) {
                        var error;
                        if (e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;

                        ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    });
                } else {
                    ScreenService.showMessage("A nova data base deve ser posterior a atual.");
                    return false;
                }
            } else {
                ScreenService.showMessage(Messages.DTINI_POST_DTFIM_ERROR);
                return false;
            }
        }
    };
    

    
    
    this.reloadFields = function(args){
        var widget = ABUtilController.checkWidget(args);
        
        args.owner.getField('NROCUPACAOM').reload();
        args.owner.getField('NRESCALATRABM').reload();
        args.owner.getField('NRSITUFUNCM').reload();
        args.owner.getField('NRTPDEMISSAO').reload();
        args.owner.getField('NREVENTOM').reload();
        
        
    };
    
    this.alteraIdAtivo = function(args){
        var widget = ABUtilController.checkWidget(args);
        
        if(widget.currentRow.DTFINVIGENCIACCT <= getLocalVar('HCM_DATA_ATUAL')) {
            widget.currentRow.IDATIVO = 'N';
            widget.currentRow.DSATIVO = 'Não';
        } else {
            widget.currentRow.IDATIVO = 'S';
            widget.currentRow.DSATIVO = 'Sim';
        }
        
        
    };
    
    
    /**
     * Funções relativas à aba de Benefício
     */

    this.fieldsEventoVinculoOnEdit = function(widget, tipo){
        switch(tipo){
            case 'titular':
                var fieldTpPartTit = widget.getField('NRTIPOPARTICIPATITULAR');
                widget.getField('NRTABFAIXASALTIT').setValue("");
                widget.getField('VRTITULARSIND').setValue("");
                widget.getField('VRPARTICIPATITULAR').setValue("");
                
                if(fieldTpPartTit.value() === 'FAIXA_SAL'){
                    widget.getField('NRTABFAIXASALTIT').readOnly = false;
                    widget.getField('NRTABFAIXASALTIT').validations.required = true;
                    widget.getField('VRTITULARSIND').readOnly = true;
                    widget.getField('VRTITULARSIND').validations = {};
                    widget.getField('VRPARTICIPATITULAR').readOnly = true;
                    widget.getField('VRPARTICIPATITULAR').validations = {};
                }else if(fieldTpPartTit.value() == '' || !fieldTpPartTit.value()){
                    widget.getField('NRTABFAIXASALTIT').readOnly = true;
                    widget.getField('NRTABFAIXASALTIT').validations = {};
                    widget.getField('VRTITULARSIND').readOnly = true;
                    widget.getField('VRTITULARSIND').validations = {};
                    widget.getField('VRPARTICIPATITULAR').readOnly = true;
                    widget.getField('VRPARTICIPATITULAR').validations = {};
                }else{
                    widget.getField('NRTABFAIXASALTIT').readOnly = true;
                    widget.getField('NRTABFAIXASALTIT').validations = {};
                    widget.getField('VRTITULARSIND').readOnly = false;
                    widget.getField('VRTITULARSIND').validations.required = true;
                    widget.getField('VRPARTICIPATITULAR').readOnly = false;
                    widget.getField('VRPARTICIPATITULAR').validations.required = true;
                }
                break;
    
            case 'dependente':
                var fieldTpPartDep = widget.getField('NRTIPOPARTICIPADEP');
                widget.getField('NRTABFAIXASALDEP').setValue("");
                widget.getField('VRDEPSIND').setValue("");
                widget.getField('VRPARTICIPADEPE').setValue("");
                if(fieldTpPartDep.value() === 'FAIXA_SAL'){
                    widget.getField('NRTABFAIXASALDEP').readOnly = false;
                    widget.getField('NRTABFAIXASALDEP').validations.required = true;
                    widget.getField('VRDEPSIND').readOnly = true;
                    widget.getField('VRDEPSIND').validations = {};
                    widget.getField('VRPARTICIPADEPE').readOnly = true;
                    widget.getField('VRPARTICIPADEPE').validations = {};
                }else if(fieldTpPartDep.value() == '' || !fieldTpPartDep.value()){
                    widget.getField('NRTABFAIXASALDEP').readOnly = true;
                    widget.getField('NRTABFAIXASALDEP').validations = {};
                    widget.getField('VRDEPSIND').readOnly = true;
                    widget.getField('VRDEPSIND').validations = {};
                    widget.getField('VRPARTICIPADEPE').readOnly = true;
                    widget.getField('VRPARTICIPADEPE').validations = {};
                }else{
                    widget.getField('NRTABFAIXASALDEP').readOnly = true;
                    widget.getField('NRTABFAIXASALDEP').validations = {};
                    widget.getField('VRDEPSIND').readOnly = false;
                    widget.getField('VRDEPSIND').validations.required = true;
                    widget.getField('VRPARTICIPADEPE').readOnly = false;
                    widget.getField('VRPARTICIPADEPE').validations.required = true;
                }
                break;
        }
    };

    this.setarVisibilidadeCamposParticipacaoOnEdit = function(tipo){
        var widget = templateManager.container.getWidget('BeneficioCCT');
        switch(tipo){
            case 'titular':

                if(widget.currentRow.NMEVETITULARVINC){
                    widget.getField('NRTIPOPARTICIPATITULAR').validations.required = true;
                    widget.getField('NRTIPOPARTICIPATITULAR').readOnly = false;

                    widget.getField('VRPISOTITULARSIND').readOnly = false;
                    widget.currentRow.VRPISOTITULARSIND = "";    
                    widget.getField('VRTETOTITULARSIND').readOnly = false;
                    widget.currentRow.VRTETOTITULARSIND = "";    

                    widget.getField('VRPISOTITULAR').readOnly = false;
                    widget.currentRow.VRPISOTITULAR = "";    
                    widget.getField('VRTETOTITULAR').readOnly = false;
                    widget.currentRow.VRTETOTITULAR = "";    

                }else{
                    widget.getField('NRTIPOPARTICIPATITULAR').validations = {};
                    widget.getField('NRTIPOPARTICIPATITULAR').readOnly = true;
                    widget.currentRow.NRTIPOPARTICIPATITULAR = "";
                    
                    widget.getField('NRTABFAIXASALTIT').validations = {};
                    widget.getField('NRTABFAIXASALTIT').readOnly = true;
                    widget.currentRow.NMTABFAIXASALTIT = "";
                    widget.currentRow.NRTABFAIXASALTIT = "";
                    
                    widget.currentRow.VRPARTICIPATITULAR = "";

                    widget.getField('VRTITULARSIND').readOnly = true;    
                    widget.currentRow.VRTITULARSIND = "";

                    widget.getField('VRPARTICIPATITULAR').readOnly = true;    
                    widget.currentRow.VRPARTICIPATITULAR = "";
                    
                    widget.getField('VRPISOTITULARSIND').readOnly = false;
                    widget.currentRow.VRPISOTITULARSIND = "";    
                    widget.getField('VRTETOTITULARSIND').readOnly = false;
                    widget.currentRow.VRTETOTITULARSIND = "";    

                    widget.getField('VRPISOTITULAR').readOnly = false;
                    widget.currentRow.VRPISOTITULAR = "";    
                    widget.getField('VRTETOTITULAR').readOnly = false;
                    widget.currentRow.VRTETOTITULAR = "";    
                }
                break;
                
            case 'dependente':
                if(widget.currentRow.NMEVEDEPEVINC){
                    widget.getField('NRTIPOPARTICIPADEP').validations.required = true;
                    widget.getField('NRTIPOPARTICIPADEP').readOnly = false;

                    widget.getField('VRPISODEPSIND').readOnly = false;
                    widget.currentRow.VRPISODEPSIND = "";    
                    widget.getField('VRTETODEPSIND').readOnly = false;
                    widget.currentRow.VRTETODEPSIND = "";    

                    widget.getField('VRPISODEP').readOnly = false;
                    widget.currentRow.VRPISODEP = "";    
                    widget.getField('VRTETODEP').readOnly = false;
                    widget.currentRow.VRTETODEP = "";    
                }else{
                    widget.getField('NRTIPOPARTICIPADEP').validations = {};
                    widget.getField('NRTIPOPARTICIPADEP').readOnly = true;                    
                    widget.currentRow.NRTIPOPARTICIPADEP = "";
                    
                    widget.getField('NRTABFAIXASALDEP').validations = {};
                    widget.getField('NRTABFAIXASALDEP').readOnly = true;
                    widget.currentRow.NMTABFAIXASALDEP = "";
                    widget.currentRow.NRTABFAIXASALDEP = "";
                    
                    widget.currentRow.VRPARTICIPADEPE = "";                    

                    widget.getField('VRDEPSIND').readOnly = true;    
                    widget.currentRow.VRDEPSIND = "";                    

                    widget.getField('VRPARTICIPADEPE').readOnly = true;    
                    widget.currentRow.VRPARTICIPADEPE = "";                    

                    widget.getField('VRPISODEPSIND').readOnly = false;
                    widget.currentRow.VRPISODEPSIND = "";    
                    widget.getField('VRTETODEPSIND').readOnly = false;
                    widget.currentRow.VRTETODEPSIND = "";    

                    widget.getField('VRPISODEP').readOnly = false;
                    widget.currentRow.VRPISODEP = "";    
                    widget.getField('VRTETODEP').readOnly = false;
                    widget.currentRow.VRTETODEP = "";    
                }
                break;
        }
    };
    
    this.setarVisibilidadeCamposEventoIntegral = function(tipo){
        var widget = templateManager.container.getWidget('BeneficioCCT');
        switch(tipo){
            case 'titular':
                if(widget.currentRow.NMEVENTOMENSA){
                    widget.getField('VRLINEARBENEFICIO').validations.required = true;
                    widget.getField('VRLINEARBENEFICIO').readOnly = false;

                    widget.getField('QTMAXHSREDUZIDA').readOnly = false;
                }else{
                    widget.getField('VRLINEARBENEFICIO').validations = {};
                    widget.getField('VRLINEARBENEFICIO').readOnly = true;

                    widget.getField('QTMAXHSREDUZIDA').readOnly = true;
                    widget.getField('VRHSREDUZIDA').readOnly = true;

                    widget.currentRow.QTMAXHSREDUZIDA = "";
                    widget.currentRow.VRHSREDUZIDA = "";
                }
                break;
                
            case 'dependente':
                if(widget.currentRow.NMEVENTOMENSADEP){
                    widget.getField('VRLINEARBENEFICIODEP').validations.required = true;
                    widget.getField('VRLINEARBENEFICIODEP').readOnly = false;
                }else{
                    widget.getField('VRLINEARBENEFICIODEP').validations = {};
                    widget.getField('VRLINEARBENEFICIODEP').readOnly = true;                    
                    widget.currentRow.VRLINEARBENEFICIODEP = "";
                }
                break;
        }
    };
    
    this.setarVisibilidadeCamposSituFunc = function(id){
        var widget = templateManager.container.getWidget("BeneficioCCT");
        
        var campoSitu = null;
        var campoRetrocSitu = null;
    
        if(id == 1){
            campoSitu = 'DSAFASTAMENTO1';
            campoRetrocSitu = 'QTMESMAXAFAST';
        }else{
            campoSitu = 'DSAFASTAMENTO2';
            campoRetrocSitu = 'QTMESMAXAFAST2';
        }
        
        if(widget.currentRow[campoSitu] && widget.currentRow[campoSitu].length > 0){
            widget.getField(campoRetrocSitu).validations = {required: true};
            widget.getField(campoRetrocSitu).readOnly = false;
        }else{
            widget.getField(campoRetrocSitu).validations = {};
            widget.getField(campoRetrocSitu).readOnly = true;
            widget.currentRow[campoRetrocSitu] = "";
        }
    };
    
    this.setarVisibilidadeCamposEventIntegOnActionEdit = function(widget){
        if(widget.currentRow.NMEVENTOMENSA){
            widget.getField('VRLINEARBENEFICIO').validations.required = true;
            widget.getField('VRLINEARBENEFICIO').readOnly = false;

            widget.getField('QTMAXHSREDUZIDA').readOnly = false;
        }else{
            widget.getField('VRLINEARBENEFICIO').validations = {};
            widget.getField('VRLINEARBENEFICIO').readOnly = true;

            widget.getField('QTMAXHSREDUZIDA').readOnly = true;
            widget.getField('VRHSREDUZIDA').readOnly = true;
        }   

        if(widget.currentRow.NMEVENTOMENSADEP){
            widget.getField('VRLINEARBENEFICIODEP').validations.required = true;
            widget.getField('VRLINEARBENEFICIODEP').readOnly = false;
        }else{
            widget.getField('VRLINEARBENEFICIODEP').validations = {};
            widget.getField('VRLINEARBENEFICIODEP').readOnly = true;
        }   
    }; 

    this.setarVisibilidadeCamposSituFuncOnActionEdit = function(widget){
        if(widget.currentRow.DSAFASTAMENTO1 && widget.currentRow.DSAFASTAMENTO1.length > 0){
            widget.getField('QTMESMAXAFAST').validations.required = true;
            widget.getField('QTMESMAXAFAST').readOnly = false;

        }else{
            widget.getField('QTMESMAXAFAST').validations = {};
            widget.getField('QTMESMAXAFAST').readOnly = true;
        }   

        if(widget.currentRow.DSAFASTAMENTO2 && widget.currentRow.DSAFASTAMENTO2.length > 0){
            widget.getField('QTMESMAXAFAST2').validations.required = true;
            widget.getField('QTMESMAXAFAST2').readOnly = false;
        }else{
            widget.getField('QTMESMAXAFAST2').validations = {};
            widget.getField('QTMESMAXAFAST2').readOnly = true;
        }   
    }; 
    
    this.setCamposOnActionADD = function(widget){
        // Campos eventos integral
        widget.getField('VRLINEARBENEFICIO').validations = {};
        widget.getField('VRLINEARBENEFICIO').readOnly = true;
        widget.getField('VRLINEARBENEFICIODEP').validations = {};
        widget.getField('VRLINEARBENEFICIODEP').readOnly = true;
        widget.getField('QTMAXHSREDUZIDA').readOnly = true;
        widget.getField('VRHSREDUZIDA').readOnly = true;
        
        // Campos eventos do vínculo
        widget.getField('NRTABFAIXASALTIT').readOnly = true;
        widget.getField('NRTABFAIXASALTIT').validations = {};
        widget.getField('VRTITULARSIND').readOnly = true;
        widget.getField('VRTITULARSIND').validations = {};
        widget.getField('VRPARTICIPATITULAR').readOnly = true;
        widget.getField('VRPARTICIPATITULAR').validations = {};

        widget.getField('NRTABFAIXASALDEP').readOnly = true;
        widget.getField('NRTABFAIXASALDEP').validations = {};
        widget.getField('VRDEPSIND').readOnly = true;
        widget.getField('VRDEPSIND').validations = {};
        widget.getField('VRPARTICIPADEPE').readOnly = true;
        widget.getField('VRPARTICIPADEPE').validations = {};

        widget.getField('NRTIPOPARTICIPATITULAR').validations = {};
        widget.getField('NRTIPOPARTICIPADEP').validations = {};
        
        // Campos Situação funcional
        widget.getField('QTMESMAXAFAST').validations = {};
        widget.getField('QTMESMAXAFAST').readOnly = true;
        widget.getField('QTMESMAXAFAST2').validations = {};
        widget.getField('QTMESMAXAFAST2').readOnly = true;
    };

    this.fieldPisoOnChange = function(widgetBeneficio, tipo, sind){
        var piso, teto, campoPiso, campoTeto;
        switch(tipo){
            case 'titular':
                if(sind){
                    campoPiso = 'VRPISOTITULARSIND';
                    campoTeto = 'VRTETOTITULARSIND';
                }else{
                    campoPiso = 'VRPISOTITULAR';
                    campoTeto = 'VRTETOTITULAR';
                }

                piso = widgetBeneficio.currentRow[campoPiso];
                teto = widgetBeneficio.currentRow[campoTeto];
                if (teto && General.valueToFloat(piso) > General.valueToFloat(teto) ) 
                    widgetBeneficio.currentRow[campoTeto] = "";
                break;
                
            case 'dependente':
                if(sind){
                    campoPiso = 'VRPISODEPSIND';
                    campoTeto = 'VRTETODEPSIND';
                }else{
                    campoPiso = 'VRPISODEP';
                    campoTeto = 'VRTETODEP';
                }

                piso = widgetBeneficio.currentRow[campoPiso];
                teto = widgetBeneficio.currentRow[campoTeto];
                if( teto && General.valueToFloat(piso) > General.valueToFloat(teto) )
                    widgetBeneficio.currentRow[campoTeto] = "";    
                break;

            case 'integral':
                campoPiso = 'VRPISOTITULARMENS';
                campoTeto = 'VRTETOTITULARMENS';

                piso = widgetBeneficio.currentRow[campoPiso];
                teto = widgetBeneficio.currentRow[campoTeto];
                if( teto && General.valueToFloat(piso) > General.valueToFloat(teto) )
                    widgetBeneficio.currentRow[campoTeto] = "";    
                break;
        }        
    };

    this.fieldTetoOnChange = function(widgetBeneficio, tipo, sind){
        var piso, teto, campoPiso, campoTeto;
        
        switch(tipo){
            case 'titular':
                if(sind){
                    campoPiso = 'VRPISOTITULARSIND';
                    campoTeto = 'VRTETOTITULARSIND';
                }else{
                    campoPiso = 'VRPISOTITULAR';
                    campoTeto = 'VRTETOTITULAR';
                }

                piso = widgetBeneficio.currentRow[campoPiso];
                teto = widgetBeneficio.currentRow[campoTeto];
                if (teto && General.valueToFloat(piso) > General.valueToFloat(teto) ) 
                    widgetBeneficio.currentRow[campoTeto] = "";
                break;
                
            case 'dependente':
                if(sind){
                    campoPiso = 'VRPISODEPSIND';
                    campoTeto = 'VRTETODEPSIND';
                }else{
                    campoPiso = 'VRPISODEP';
                    campoTeto = 'VRTETODEP';
                }

                piso = widgetBeneficio.currentRow[campoPiso];
                teto = widgetBeneficio.currentRow[campoTeto];
                if( teto && General.valueToFloat(piso) > General.valueToFloat(teto) )
                    widgetBeneficio.currentRow[campoTeto] = "";    
                break;

            case 'integral':
                campoPiso = 'VRPISOTITULARMENS';
                campoTeto = 'VRTETOTITULARMENS';

                piso = widgetBeneficio.currentRow[campoPiso];
                teto = widgetBeneficio.currentRow[campoTeto];
                if( teto && General.valueToFloat(piso) > General.valueToFloat(teto) )
                    widgetBeneficio.currentRow[campoTeto] = "";    
                break;
        }        
    };

    this.setarVisibilidadeCamposParticipacaoOnActionAdd = function(widget){
        // ----- Fields Participação Titular
        widget.getField('NRTIPOPARTICIPATITULAR').validations = {};
        widget.getField('NRTIPOPARTICIPATITULAR').readOnly = true;

        widget.getField('NRTABFAIXASALTIT').validations = {};
        widget.getField('NRTABFAIXASALTIT').readOnly = true;

        widget.getField('VRTITULARSIND').validations = {};
        widget.getField('VRTITULARSIND').readOnly = true;  

        widget.getField('VRPARTICIPATITULAR').validations = {};
        widget.getField('VRPARTICIPATITULAR').readOnly = true;  
        
        widget.getField('VRPISOTITULARSIND').readOnly = true;
        widget.getField('VRTETOTITULARSIND').readOnly = true;

        widget.getField('VRPISOTITULAR').readOnly = true;
        widget.getField('VRTETOTITULAR').readOnly = true;

        // ----- Fields Participação Dependente
        widget.getField('NRTIPOPARTICIPADEP').validations = {};
        widget.getField('NRTIPOPARTICIPADEP').readOnly = true;
        
        widget.getField('NRTABFAIXASALDEP').validations = {};
        widget.getField('NRTABFAIXASALDEP').readOnly = true;
        
        widget.getField('VRDEPSIND').validations = {};
        widget.getField('VRDEPSIND').readOnly = true;  

        widget.getField('VRPARTICIPADEPE').validations = {};
        widget.getField('VRPARTICIPADEPE').readOnly = true;  

        widget.getField('VRPISODEPSIND').readOnly = true;
        widget.getField('VRTETODEPSIND').readOnly = true;

        widget.getField('VRPISODEP').readOnly = true;
        widget.getField('VRTETODEP').readOnly = true;
    };

    this.fieldsEventoVinculoOnActionEdit = function(widget){
        var fieldTpPartTit = widget.currentRow.NRTIPOPARTICIPATITULAR;
        var fieldTpPartDep = widget.currentRow.NRTIPOPARTICIPADEP;

        if(fieldTpPartTit){
            if(fieldTpPartTit === 'FAIXA_SAL'){
                widget.getField('NRTABFAIXASALTIT').readOnly = false;
                widget.getField('NRTABFAIXASALTIT').validations.required = true;
                widget.getField('VRTITULARSIND').validations = {};
                widget.getField('VRTITULARSIND').readOnly = true;
                widget.getField('VRPARTICIPATITULAR').validations = {};
                widget.getField('VRPARTICIPATITULAR').readOnly = true;
            }else{
                widget.getField('NRTABFAIXASALTIT').readOnly = true;
                widget.getField('NRTABFAIXASALTIT').validations = {};
                widget.getField('VRTITULARSIND').validations.required = true;
                widget.getField('VRTITULARSIND').readOnly = false;
                widget.getField('VRPARTICIPATITULAR').validations.required = true;
                widget.getField('VRPARTICIPATITULAR').readOnly = false;
            }
        }

        if(fieldTpPartDep){
            if(fieldTpPartDep === 'FAIXA_SAL'){
                widget.getField('NRTABFAIXASALDEP').readOnly = false;
                widget.getField('NRTABFAIXASALDEP').validations.required = true;
                widget.getField('VRDEPSIND').validations = {};
                widget.getField('VRDEPSIND').readOnly = true;
                widget.getField('VRPARTICIPADEPE').validations = {};
                widget.getField('VRPARTICIPADEPE').readOnly = true;
            }else{
                widget.getField('NRTABFAIXASALDEP').readOnly = true;
                widget.getField('NRTABFAIXASALDEP').validations = {};
                widget.getField('VRDEPSIND').validations.required = true;
                widget.getField('VRDEPSIND').readOnly = false;
                widget.getField('VRPARTICIPADEPE').validations.required = true;
                widget.getField('VRPARTICIPADEPE').readOnly = false;
            }        
        }
    };
    
    
    this.setarVisibilidadeCamposParticipacaoOnActionEdit = function(widget){
        

        if(widget.currentRow.NMEVENTOMENSADEP){
            widget.getField('NRTIPOPARTICIPATITULAR').validations.required = true;
            widget.getField('NRTIPOPARTICIPATITULAR').readOnly = false;
        }else{
            widget.getField('NRTIPOPARTICIPATITULAR').validations = {};
            widget.getField('NRTIPOPARTICIPATITULAR').readOnly = true;
        }   

        if(widget.currentRow.NMEVETITULARVINC){
            widget.getField('NRTIPOPARTICIPATITULAR').validations.required = true;
            widget.getField('NRTIPOPARTICIPATITULAR').readOnly = false;
            
            widget.getField('VRPISOTITULARSIND').readOnly = false;
            widget.getField('VRTETOTITULARSIND').readOnly = false;

            widget.getField('VRPISOTITULAR').readOnly = false;
            widget.getField('VRTETOTITULAR').readOnly = false;

            if(widget.currentRow.NMTABFAIXASALTIT){
                widget.getField('NRTABFAIXASALTIT').validations.required = true;
                widget.getField('NRTABFAIXASALTIT').readOnly = false;    
                widget.getField('VRTITULARSIND').validations = {};
                widget.getField('VRTITULARSIND').readOnly = true;
                widget.getField('VRPARTICIPATITULAR').validations = {};
                widget.getField('VRPARTICIPATITULAR').readOnly = true;
            }else{
                widget.getField('NRTABFAIXASALTIT').validations = {};
                widget.getField('NRTABFAIXASALTIT').readOnly = true;    
                widget.getField('VRTITULARSIND').validations.required = true;
                widget.getField('VRTITULARSIND').readOnly = false;    
                widget.getField('VRPARTICIPATITULAR').validations.required = true;
                widget.getField('VRPARTICIPATITULAR').readOnly = false;    
            }
            
        }else{
            widget.getField('NRTIPOPARTICIPATITULAR').validations = {};
            widget.getField('NRTIPOPARTICIPATITULAR').readOnly = true;

            widget.getField('NRTABFAIXASALTIT').validations = {};
            widget.getField('NRTABFAIXASALTIT').readOnly = true;

            widget.getField('VRTITULARSIND').validations = {};
            widget.getField('VRTITULARSIND').readOnly = true;    

            widget.getField('VRPARTICIPATITULAR').validations = {};
            widget.getField('VRPARTICIPATITULAR').readOnly = true;    

            widget.getField('VRPISOTITULARSIND').readOnly = true;
            widget.getField('VRTETOTITULARSIND').readOnly = true;

            widget.getField('VRPISOTITULAR').readOnly = true;
            widget.getField('VRTETOTITULAR').readOnly = true;
        }
        
        if(widget.currentRow.NMEVEDEPEVINC){
            widget.getField('NRTIPOPARTICIPADEP').validations.required = true;
            widget.getField('NRTIPOPARTICIPADEP').readOnly = false;

            widget.getField('VRPISODEPSIND').readOnly = false;
            widget.getField('VRTETODEPSIND').readOnly = false;

            widget.getField('VRPISODEP').readOnly = false;
            widget.getField('VRTETODEP').readOnly = false;

            if(widget.currentRow.NMTABFAIXASALDEP){
                widget.getField('NRTABFAIXASALDEP').validations.required = true;
                widget.getField('NRTABFAIXASALDEP').readOnly = false;    
                widget.getField('VRDEPSIND').validations = {};
                widget.getField('VRDEPSIND').readOnly = true;
                widget.getField('VRPARTICIPADEPE').validations = {};
                widget.getField('VRPARTICIPADEPE').readOnly = true;
            }else{
                widget.getField('NRTABFAIXASALDEP').validations = {};
                widget.getField('NRTABFAIXASALDEP').readOnly = true;    
                widget.getField('VRDEPSIND').validations.required = true;
                widget.getField('VRDEPSIND').readOnly = false;    
                widget.getField('VRPARTICIPADEPE').validations.required = true;
                widget.getField('VRPARTICIPADEPE').readOnly = false;    
            }            

        }else{
            widget.getField('NRTIPOPARTICIPADEP').validations = {};
            widget.getField('NRTIPOPARTICIPADEP').readOnly = true;
            
            widget.getField('NRTABFAIXASALDEP').validations = {};
            widget.getField('NRTABFAIXASALDEP').readOnly = true;

            widget.getField('VRDEPSIND').validations = {};
            widget.getField('VRDEPSIND').readOnly = true;    

            widget.getField('VRPARTICIPADEPE').validations = {};
            widget.getField('VRPARTICIPADEPE').readOnly = true;    
            
            widget.getField('VRPISODEP').readOnly = true;
            widget.getField('VRTETODEP').readOnly = true;
        }
        
    };

    this.setBeneficioCCT = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid() && this.validaValorAcrescimo()) {
            if (!widget.backupRow) {
                widget.currentRow.__is_new = true;
            } else {
                widget.currentRow.__is_new = false;
            }
            widget.currentRow.NRCADASTROCCT = templateManager.container.getWidget('CCT').currentRow.NRCADASTROCCT;
            validaCamposMonetarios(widget.currentRow);
            restEngine.post('product#/setBeneficioCCT', {
                'requestType': 'DataSet',
                'dataset': [widget.currentRow]
            }).
            then(function(data) {
                if (data.notifications[0].type === "success") {
                    ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                    if (widget.currentRow.__is_new) {
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    } else {
                        //ABUtilController.masterDetailVoltarList(widget);
                        widget.backupRow = null;
                        widget.view();
                        //widget.reload();
                    }
                } else {
                    ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                }
            }).
            catch(function(e) {
                var error;
                if (e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;

                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
        }
    };

    var validaCamposMonetarios = function(currentRow){
        currentRow.VRTITULARSIND = General.valueToFloat(currentRow.VRTITULARSIND);
        currentRow.VRDEPSIND = General.valueToFloat(currentRow.VRDEPSIND);
        currentRow.VRPISOTITULARSIND = General.valueToFloat(currentRow.VRPISOTITULARSIND);
        currentRow.VRTETOTITULARSIND = General.valueToFloat(currentRow.VRTETOTITULARSIND);
        currentRow.VRPISODEPSIND = General.valueToFloat(currentRow.VRPISODEPSIND);
        currentRow.VRTETODEPSIND = General.valueToFloat(currentRow.VRTETODEPSIND);
        currentRow.VRTETOTITULARMENS = General.valueToFloat(currentRow.VRTETOTITULARMENS);
        currentRow.VRPISOTITULARMENS = General.valueToFloat(currentRow.VRPISOTITULARMENS);
        currentRow.VRLINEARBENEFICIO = General.valueToFloat(currentRow.VRLINEARBENEFICIO);
        currentRow.VRLINEARBENEFICIODEP = General.valueToFloat(currentRow.VRLINEARBENEFICIODEP);
        currentRow.VRPARTICIPATITULAR = General.valueToFloat(currentRow.VRPARTICIPATITULAR);
        currentRow.VRPISOTITULAR = General.valueToFloat(currentRow.VRPISOTITULAR);
        currentRow.VRTETOTITULAR = General.valueToFloat(currentRow.VRTETOTITULAR);
        currentRow.VRPARTICIPADEPE = General.valueToFloat(currentRow.VRPARTICIPADEPE);
        currentRow.VRPISODEP = General.valueToFloat(currentRow.VRPISODEP);
        currentRow.VRTETODEP = General.valueToFloat(currentRow.VRTETODEP);
        currentRow.VRHSREDUZIDA = General.valueToFloat(currentRow.VRHSREDUZIDA);
        currentRow.VRFIXACRESDESC = General.valueToFloat(currentRow.VRFIXACRESDESC);
        currentRow.VRPERACRESCDESC = General.valueToFloat(currentRow.VRPERACRESCDESC);
    };
    
    this.deleteBeneficioCCT = function(args) {
        var widget = args.owner.widget;
        ScreenService.confirmMessage(Messages.DELETE_ROW, 'CONFIRMATION',
            function() {
                restEngine.post('product#/deleteBeneficioCCT', {
                    'requestType': 'DataSet',
                    'dataset': [widget.currentRow]
                }).
                then(function(data) {
                    if (data.notifications[0].type === "success") {
                        ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    } else {
                        ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                    }
                }).
                catch(function(e) {
                    var error;
                    if (e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
            }
        );
    };
    
    this.habilitaDesabilitaVlrHrReduzida = function(widget){
        if(widget.currentRow.QTMAXHSREDUZIDA){
            widget.getField('VRHSREDUZIDA').readOnly = false;
        }else{
            widget.getField('VRHSREDUZIDA').readOnly = true;
            widget.currentRow.VRHSREDUZIDA = "";
        }
    };

    /*
    this.tratarTpBeneficio = function(args){
        var widget = args.owner;
        var jahExiste = false;
        var tpBeneCadastrados = [];
        
        widget.dataSource.data.forEach(function(data){
            tpBeneCadastrados.push(data.NRTPBENEFICIO);    
        });
        
        if(tpBeneCadastrados.length > 0){
            widget.getField('DSTPBENEFICIO').dataSourceFilter.forEach(function(filter){
                if(filter.name == 'NRTPBENEFICIO') {
                    jahExiste = true;
                    filter.value = tpBeneCadastrados;             
                }
            });
            
            if(!jahExiste){
                widget.getField('DSTPBENEFICIO').dataSourceFilter.push(
                    {
                        name: "NRTPBENEFICIO",
                        operator: "NOT IN",
                        value: tpBeneCadastrados
                    }
                );
            }
        }else{

            widget.getField('DSTPBENEFICIO').dataSourceFilter.forEach(function(filter){
                if(filter.name == 'NRTPBENEFICIO') jahExiste = true;
            });

            if(jahExiste) widget.getField('DSTPBENEFICIO').dataSourceFilter.pop();
        }
        
        
        
    };
    */
    
    this.habilitaValorAcrescimo = function(){
        var widgetBeneficio = templateManager.container.getWidget('BeneficioCCT');
        
        if(!Util.isUndefinedOrNull(widgetBeneficio.getField('DSINCIDEVENTO').value()) && widgetBeneficio.getField('DSINCIDEVENTO').value().length > 0){
            widgetBeneficio.getField('VRFIXACRESDESC').readOnly = false;
            widgetBeneficio.getField('VRPERACRESCDESC').readOnly = false;
        }else{
            widgetBeneficio.getField('VRFIXACRESDESC').readOnly = true;
            widgetBeneficio.getField('VRPERACRESCDESC').readOnly = true;
        }
    };
    
    this.validaValorAcrescimo = function(){
        var widgetBeneficio = templateManager.container.getWidget('BeneficioCCT');
        
        if(!Util.isUndefinedOrNull(widgetBeneficio.getField('DSINCIDEVENTO').value()) && widgetBeneficio.getField('DSINCIDEVENTO').value().length > 0 && 
           !Util.isUndefinedOrNull(widgetBeneficio.getField('VRFIXACRESDESC').value()) && widgetBeneficio.getField('VRFIXACRESDESC').value() != "" && 
           !Util.isUndefinedOrNull(widgetBeneficio.getField('VRPERACRESCDESC').value()) && widgetBeneficio.getField('VRPERACRESCDESC').value() != ""
        ){
            ScreenService.showMessage("Somente um dos campos referente ao acréscimo por não ter considerado o multiplicador devido a existência de eventos pode ser informado.", "WARNING");
            return false;
        }else{
            return true;
        }
    };
    
}

Configuration(function(ContextRegister) {
    ContextRegister.register('CCTController', CCTController);
});


// FILE: assets/js/controllers/CNABController.js
function CNABController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, General, Messages) {

    var self = this;

    this.mudarVisibilidadeWidgets = function(widgets, value) {
        widgets.forEach(function(widget) {
            widget.isVisible = value;
        });
    };

    this.CNABAfterMoveRow = function(widget) {
        widget.widgets[0].dataSourceFilter[0].value = widget.currentRow.NRCADASTROCNAB;
    };

    this.habilitaGeracao = function(args) {
        
        var widget = ABUtilController.checkWidget(args);
        if (args.row.CDBANCO == "001" || args.row.CDBANCO == "033"){
            widget.getField("IDAGRUPARQUIVO").readOnly = false;
        }
        else{
            widget.getField("IDAGRUPARQUIVO").readOnly = true;
        }
            
        if (args.row.CDBANCO == "237"){
            widget.getField("IDLAYOUT").readOnly = false;
            widget.getField("IDLAYOUT").validations = {"required": true};
        }
        else{
            widget.getField("IDLAYOUT").readOnly = true;
            widget.getField("IDLAYOUT").validations = {};
            widget.currentRow.IDLAYOUT = "";
        }        
            
        widget.reload();
    };
    
    

    this.adicionarRow = function(args) {
        var widget = args.owner.widget;
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
    };
    
    this.setCodconvenio = function(){
        var widget = templateManager.container.getWidget('CNAB');
        if(Util.isEmptyOrBlank(widget.currentRow.CODCONVENIO) && !Util.isEmptyOrBlank(widget.currentRow.CODCONVENIOESTR)){
            widget.currentRow.CODCONVENIO = widget.currentRow.CODCONVENIOESTR;
        }
    };

    this.setCNAB = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
             if (widget.currentRow.DSORDEM == 'LISTA_VINCULO' && widget.currentRow.NRVINCULOM_LIST && widget.currentRow.NRVINCULOM_LIST.length > 200) {
                ScreenService.showMessage("Favor selecionar um máximo de 200 vínculos na lista ou usar outro filtro como por exemplo por estrutura legal.");
                return;
            }
            if (widget.currentRow.DSORDEM == 'LISTA_NRESTRUTSIND' && widget.currentRow.LIST_NRESTRUTSIND && widget.currentRow.LIST_NRESTRUTSIND.length > 200) {
                ScreenService.showMessage("Favor selecionar um máximo de 200 estruturas na Lista sindical .");
                return;
            }
            if (widget.currentRow.DSORDEM == 'LISTA_ESTRUTURA' && widget.currentRow.LIST_NRESTRUTLEGAL && widget.currentRow.LIST_NRESTRUTLEGAL.length > 200) {
                ScreenService.showMessage("Favor selecionar um máximo de 200 estruturas na Lista de Estrutura Legal.");
                return;
            }  
            if (widget.currentRow.DSORDEM == 'LISTA_ESTRUTURA' && widget.currentRow.LIST_NRESTRUTGEREN && widget.currentRow.LIST_NRESTRUTGEREN.length > 200) {
                ScreenService.showMessage("Favor selecionar um máximo de 200 estruturas na Lista de Estrutura Gerencial.");
                return;
            }
            if (ABUtilController.validaCritSelecao(widget.currentRow)) {

            if (!widget.backupRow) {
                widget.currentRow.__is_new = true;
            } else {
                widget.currentRow.__is_new = false;
            }
            restEngine.post('product#/setArquivoCNAB', {
                'requestType': 'DataSet',
                'dataset': [widget.currentRow]
            }).
            then(function(data) {
                if (data.notifications[0].type === "success") {
                    ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                    if (widget.currentRow.__is_new) {
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    } else {
                        widget.backupRow = null;
                        widget.view();
                    }
                    self.mudarVisibilidadeWidgets(widget.widgets, true);
                } else {
                    ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                }
            }).
            catch(function(e) {
                var error;
                if (e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;

                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });

        
            
            }
        }
    };

    this.deleteCNAB = function(args) {
        var widget = args.owner.widget;
        ScreenService.confirmMessage(Messages.DELETE_ROW, 'CONFIRMATION',
            function() {
                restEngine.post('product#/deleteArquivoCNAB', {
                    'requestType': 'DataSet',
                    'dataset': [widget.currentRow]
                }).
                then(function(data) {
                    if (data.notifications[0].type === "success") {
                        ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    } else {
                        ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                    }
                }).
                catch(function(e) {
                    var error;
                    if (e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;

                    ScreenService.showMessage(error, 'ERROR');
                });
            }
        );
    };

    this.geraCNAB = function(args) {
        var widget = ABUtilController.checkWidget(args);
        ScreenService.confirmMessage('Deseja realmente gerar o CNAB ?', 'CONFIRMATION', 
            function(){
                widget.currentRow.TP_PROCESSAMENTO = 'COMPETENCIA_MENSAL';
                restEngine.post("product#/geraCNAB", {'requestType':'DataSet','dataset':[widget.currentRow]})
                    .then(function(data) {
                            if(data.dataset && data.dataset.arquivo){
                                ABUtilController.downloadArquivo(data.dataset.arquivo.NMARQUIVO);
                            }
                            if(data.messages){
                                if(data.messages[0].message.substring(0,4) == "http"){
                                    window.open(data.messages[0].message);
                                    if(data.messages[1]){
                                        ScreenService.showMessage(data.messages[1].message, data.messages[1].type);
                                        ScreenService.closePopup();    
                                    }
                                } else {
                                    ScreenService.showMessage(data.messages[0].message, data.messages[0].type);
                                    ScreenService.closePopup();
                                }
                            }
                            if(data.dataset && data.dataset.msgCalculo && data.dataset.msgCalculo.length > 0){
                                var popUp = templateManager.container.getWidget("mensagens");
                                popUp.dataSource.data = data.dataset.msgCalculo;
                                ABUtilController.masterDetailOpenPopup(popUp);
                            }
                        }.bind(this)).catch(
                            function(e) {
                                var error;
                                if(e.data.error === undefined)
                                    error = e;
                                else 
                                    error = e.data.error;
                                ScreenService.showMessage( error, 'ERROR');
                            }.bind(this)
                        );    
            }.bind(this)
        );
    };
    
    this.retrocede = function(args) {
        var widget = ABUtilController.checkWidget(args);
        ScreenService.confirmMessage('Deseja realmente retroceder o CNAB ?', 'CONFIRMATION', 
            function(){
                widget.currentRow.TP_PROCESSAMENTO = 'RETROCESSO';
                restEngine.post("product#/geraCNAB",
                        {'requestType':'DataSet','dataset':[widget.currentRow]},
                    function(data) {
                        if(data.messages){
                            ScreenService.successNotification(data.messages[0].message);
                            ScreenService.closePopup();
                        }
                        if(data.dataset && data.dataset.msgCalculo && data.dataset.msgCalculo.length > 0){
                            var popUp = templateManager.container.getWidget("mensagens");
                            popUp.dataSource.data = data.dataset.msgCalculo;
                            ABUtilController.masterDetailOpenPopup(popUp);
                        }
                    }.bind(this),undefined,
                    function(e) {
                        var error;
                        if(e.data.error === undefined)
                            error = e;
                        else 
                            error = e.data.error;
                        ScreenService.showMessage('Ocorreu um erro inesperado, contate o administrador informando o trecho abaixo: <br><br>' + error + '<br><br>', 'ERROR');
                    }
                );
            }.bind(this)
        );
    };

}

Configuration(function(ContextRegister) {
    ContextRegister.register('CNABController', CNABController);
});


// FILE: assets/js/controllers/CadastroCboController.js
/* jshint esversion: 6 */
function CadastroCboController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, General, Messages) {

    this.adicionarRow = (args) => {
        let widget = args.owner.widget;
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
    };

    this.setCadastroCbo = (args) => {
        let widget = args.owner.widget;

        if (widget.isValid()) {
            widget.currentRow.__is_new = !widget.backupRow;

            restEngine.post('product#/setCadastroCbo', {
                'requestType': 'DataSet',
                'dataset': [widget.currentRow
                ]
            }).then((data) => {
                if (data.messages && data.messages[0].type === "E" && data.notifications[0].type === "error") {
                    ScreenService.showMessage(Messages.HCM010011_FPA_EXISTE_CADASTRO_CBO);
                    return;
                }

                if (data.notifications[0].type === "success") {
                    ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                }

                if (widget.currentRow.__is_new) {
                    ABUtilController.masterDetailVoltarList(widget);
                    widget.reload();
                    return;
                }

                if (!widget.currentRow.__is_new) {
                    ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                    widget.backupRow = null;
                    widget.view();
                    return;
                }

                ScreenService.showMessage(Messages.SAVE_ROW_ERROR);

            }).catch((error) => {
                let msgError = error.data.error ? error.data.error : error;

                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(msgError), 'ERROR');
            });
        }

    };

    this.deleteCadastroCboController = (args) => {
        ScreenService.confirmMessage(Messages.DELETE_ROW, null, () => {
            let widget = args.owner.widget;

            widget.currentRow.__is_new = false;

            restEngine.post('product#/deleteCadastroCboController', {
                'requestType': 'DataSet',
                'dataset': [widget.currentRow]
            }).then((data) => {
                if (data.notifications[0].type === "success") {
                    ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                    ABUtilController.masterDetailVoltarList(widget);
                    widget.reload();
                    return;
                }

                ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
            }).catch((error) => {
                let msgError = error.data.error ? error.data.error : error;

                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(msgError), 'ERROR');
            });
        }, null);
    };
}

Configuration(function (ContextRegister) {
    ContextRegister.register('CadastroCboController', CadastroCboController);
});

// FILE: assets/js/controllers/CalculoBeneficioController.js
function CalculoBeneficioController(ScreenService, templateManager, restEngine, ABUtilController, Messages, CalculoBeneficioService) {

    this.ALFABETICA_CAMPOS = ['NMINIVINCULOM', 'NMFIMVINCULOM'];
    this.ESTRUTURA_CAMPOS = ['NMESTRUTLEGAL', 'NMESTRUTGEREN'];
    this.LISTA_ESTRUTURA_CAMPOS = ['LIST_NRESTRUTLEGAL', 'LIST_NRESTRUTGEREN'];	 
    this.LISTA_ESTRUTRA_SIND = ['LIST_NRESTRUTLEGAL', 'LIST_NRESTRUTSIND'];	 
    this.LISTA_VINCULO_CAMPOS = ['NRVINCULOM_LIST'];
    this.DATA_ADMISSAO_CAMPOS = ['DTINIADMISSAO', 'DTFIMADMISSAO'];
    this.MATRICULA_CAMPOS = ['CDINIMATRICULA', 'CDFIMMATRICULA'];
    this.LISTA_BENEFICIO_CAMPOS = ['LIST_NRBENEFICIOM'];

    this.CALCULAR = 'calcular';
    this.RETROCEDER = 'retroceder';
    
    this.ORDEM_CAMPOS = [	 
       'NMINIVINCULOM', 'NMFIMVINCULOM',	 
       'NMESTRUTLEGAL', 'NMESTRUTGEREN',	 
       'LIST_NRESTRUTLEGAL', 'LIST_NRESTRUTGEREN',	 
       'LIST_NRESTRUTLEGAL', 'LIST_NRESTRUTGEREN',	 
       'NRVINCULOM_LIST',	 
       'DTINIADMISSAO', 'DTFIMADMISSAO',	 
       'CDINIMATRICULA', 'CDFIMMATRICULA'	 
   ];
    
    this.habilitaCamposOrdem = function(widget, arrayCampos) {
        this.ALFABETICA_CAMPOS.concat(this.ESTRUTURA_CAMPOS, this.LISTA_ESTRUTURA_CAMPOS, this.LISTA_ESTRUTRA_SIND, this.LISTA_VINCULO_CAMPOS, this.DATA_ADMISSAO_CAMPOS, this.LISTA_BENEFICIO_CAMPOS,
        this.MATRICULA_CAMPOS).forEach(function(campo) {
            if (arrayCampos.indexOf(campo) >= 0) {
                widget.getField(campo).isVisible = true;
                if(campo == 'LIST_NRESTRUTGEREN'){
                    widget.getField(campo).validations = {};	 
                }
                else {
                    widget.getField(campo).validations = {"required": true};
                }
            } else {
                widget.getField(campo).isVisible = false;
                widget.getField(campo).validations = {};
            }
        });
    };
    
    this.fieldOrdemOnChange = function(widget){	 
        widget.currentRow.DSINICIOCALCBENEF = null;	 
        widget.currentRow.DSFIMCALCBENEF = null;	 
        widget.currentRow.NMINIVINCULOM = null;	 
        widget.currentRow.NMFIMVINCULOM = null;	 
        widget.currentRow.CDINIMATRICULA = null;	 
        widget.currentRow.CDFIMMATRICULA = null;	 
        widget.currentRow.DTINIADMISSAO = null;	 
        widget.currentRow.DTFIMADMISSAO = null;	 
        widget.currentRow.NMESTRUTLEGAL = null;	 
        widget.currentRow.NMESTRUTGEREN = null;	 
        widget.currentRow.LIST_NRESTRUTLEGAL = null;	 
        widget.currentRow.LIST_NRESTRUTGEREN = null;	 
        widget.currentRow.LIST_NRESTRUTLEGAL = null;	 
        widget.currentRow.LIST_NRESTRUTGEREN = null;	 
        widget.currentRow.NRVINCULOM_LIST = null;	 
    };
    
    this.limpaOutrosCampos = function(widget, arrayCampos) {
        this.ALFABETICA_CAMPOS.concat(this.ESTRUTURA_CAMPOS, this.DATA_ADMISSAO_CAMPOS, this.MATRICULA_CAMPOS).forEach(function(campo) {
            if (arrayCampos.indexOf(campo) < 0) {
                widget.getField(campo).setValue('');
            }
        });
    };
    this.validaFiltroBeneficio = function () {
        var widget = templateManager.container.getWidget('formCalcBeneficios');
        var resultado = false;
        if(!widget.getField('NRVINCULOM_LIST') && !widget.getField('LIST_NRESTRUTLEGAL') && !widget.getField('LIST_NRESTRUTGEREN') && !widget.getField('LIST_NRESTRUTSIND')){
            ScreenService.showMessage("É necessário preencher o campo 'Vínculo', 'Estrutura Legal', 'Estrutura Gerencial' ou 'Estrutura Sindical' para realizar o filtro.");

        } else {
            if ((widget.currentRow.NRVINCULOM_LIST && widget.currentRow.NRVINCULOM_LIST.length > 400)) {
                ScreenService.showMessage("Favor selecionar um máximo de 400 vínculos na lista ou usar outro filtro como por exemplo por estrutura legal.");
                resultado =  true;
            }
            if ((widget.currentRow.LIST_NRESTRUTLEGAL && widget.currentRow.LIST_NRESTRUTLEGAL.length > 400) || (widget.currentRow.LIST_NRESTRUTGEREN && widget.currentRow.LIST_NRESTRUTGEREN .length > 400) || (widget.currentRow.LIST_NRESTRUTGEREN  && widget.currentRow.LIST_NRESTRUTGEREN.length > 400)) {
                ScreenService.showMessage("Favor selecionar um máximo de 400 estruturas na lista.");
                resultado = true;
            }
        } 
        return resultado;
    };


    this.salvar = function(args) {
        var widget = templateManager.container.getActiveWidget();
        var filtroBeneficio = this.validaFiltroBeneficio();
        if (widget.isValid()) {
            var validaData = true;
            var validaOrdem = true;
            
            if(widget.currentRow.TPPERIODOBENEF == 'DIARIO')
                validaData = ABUtilController.validaDtIniMenorIgualDtFin(widget.currentRow.DTINICALCBENEF, widget.currentRow.DTFIMCALCBENEF);

            switch (widget.currentRow.DSORDEMCALCBENEF) {
                case 'ALFABETICA':
                    if (widget.currentRow.NMINIVINCULOM.localeCompare(widget.currentRow.NMFIMVINCULOM) > 0) {
                        validaOrdem = false;
                        ScreenService.showMessage("O nome inicial deve ser anterior ao nome final");
                    }
                    break;
                case 'DATA_ADMISSAO':
                    validaOrdem = ABUtilController.validaDtIniMenorIgualDtFin(widget.currentRow.DTINIADMISSAO, widget.currentRow.DTFIMADMISSAO);
                    if (!validaOrdem)
                        ScreenService.showMessage("A data inicial deve ser anterior a data final");
                    break;
                default:
            }
            if (!validaData) {
                ScreenService.showMessage("A data inicial deve ser anterior a data final");
            } else if (validaOrdem) {
                if(filtroBeneficio == true){
                    return;
                }
                if (!widget.backupRow) {
                    widget.currentRow.__is_new = true;
                } else {
                    widget.currentRow.__is_new = false;
                }
                restEngine.post('product#/setFormcalcbenef', {
                    'requestType': 'DataSet',
                    'dataset': [widget.currentRow]
                }).
                then(function(data) {
                    if (data.notifications[0].type === "success") {
                        ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                        if (widget.currentRow.__is_new) {
                            ABUtilController.masterDetailVoltarList(widget);
                            widget.reload();
                        } else {
                            ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                            widget.backupRow = null;
                            widget.view();
                        }
                    } else {
                        ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                    }
                }).
                catch(function(e) {
                    var error;
                    if (e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;

                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
            }
        }
    };

    this.remover = function(args) {
        ScreenService.confirmMessage(Messages.DELETE_ROW, 'CONFIRMATION',
            function() {

                var widget = templateManager.container.getActiveWidget();
                if (widget.isValid()) {
                    widget.currentRow.__is_new = false;
                    restEngine.post('product#/deleteFormcalcbenef', {
                        'requestType': 'DataSet',
                        'dataset': [widget.currentRow]
                    }).
                    then(function(data) {
                        if (data.notifications[0].type === "success") {
                            ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                            ABUtilController.masterDetailVoltarList(widget);
                            widget.reload();
                        } else {
                            ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                        }
                    }).
                    catch(function(e) {
                        var error;
                        if (e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;

                        ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    });
                }
            });

    };

    this.setVisibilidadeCampos = function(widget) {
        var ordem = widget.currentRow.DSORDEMCALCBENEF;

        switch (ordem) {
            case 'ALFABETICA':
                this.habilitaCamposOrdem(widget, this.ALFABETICA_CAMPOS);
                break;
            case 'MATRICULA':
                this.habilitaCamposOrdem(widget, this.MATRICULA_CAMPOS);
                break;
            case 'DATA_ADMISSAO':
                this.habilitaCamposOrdem(widget, this.DATA_ADMISSAO_CAMPOS);
                break;
            case 'ESTRUTURA':
                this.habilitaCamposOrdem(widget, this.ESTRUTURA_CAMPOS);
                widget.getField('NMESTRUTGEREN').validations = {};
                break;
            case 'LISTA_ESTRUTURA':	 
                this.habilitaCamposOrdem(widget, this.LISTA_ESTRUTURA_CAMPOS);	 
                widget.getField('NMESTRUTGEREN').validations = {};	 
                break;	 
            case 'LISTA_NRESTRUTSIND':	 
                this.habilitaCamposOrdem(widget, this.LISTA_ESTRUTRA_SIND);	 
                widget.getField('NMESTRUTGEREN').validations = {};	 
                break;	 
            case 'LISTA_VINCULO':	 
                this.habilitaCamposOrdem(widget, this.LISTA_VINCULO_CAMPOS);	 
                widget.getField('NMESTRUTGEREN').validations = {};	 
                break;	 
            case 'LISTA_BENEFICIO':	 
                this.habilitaCamposOrdem(widget, this.LISTA_BENEFICIO_CAMPOS);	 
                widget.getField('NMESTRUTGEREN').validations = {};	 
                break;	 
            default:
                this.habilitaCamposOrdem(widget, []);
                break;
        }
    };

    this.setValorCamposBeforeSave = function(widget) {
        var ordem = widget.currentRow.DSORDEMCALCBENEF;

        switch (ordem) {
            case 'ALFABETICA':
                //widget.getField('DSINICIOCALCBENEF').setValue(widget.currentRow.NRINIVINCULOM);
                //widget.getField('DSFIMCALCBENEF').setValue(widget.currentRow.NRFIMVINCULOM);
                this.limpaOutrosCampos(widget, this.ALFABETICA_CAMPOS);
                break;
            case 'MATRICULA':
                widget.getField('DSINICIOCALCBENEF').setValue(widget.currentRow.CDINIMATRICULA);
                widget.getField('DSFIMCALCBENEF').setValue(widget.currentRow.CDFIMMATRICULA);
                this.limpaOutrosCampos(widget, this.MATRICULA_CAMPOS);
                break;
            case 'DATA_ADMISSAO':
                widget.getField('DSINICIOCALCBENEF').setValue(widget.currentRow.DTINIADMISSAO);
                widget.getField('DSFIMCALCBENEF').setValue(widget.currentRow.DTFIMADMISSAO);
                this.limpaOutrosCampos(widget, this.DATA_ADMISSAO_CAMPOS);
                break;
            case 'ESTRUTURA':
                //widget.getField('DSINICIOCALCBENEF').setValue(widget.currentRow.NRESTRUTLEGAL);
                widget.getField('DSFIMCALCBENEF').setValue(widget.currentRow.NMESTRUTGEREN ? widget.currentRow.DSFIMCALCBENEF : '');
                this.limpaOutrosCampos(widget, this.ESTRUTURA_CAMPOS);
                break;
        }
    };

    this.setDescricaoSelecionada = function(widget) {
        var ordem = widget.currentRow.DSORDEMCALCBENEF;

        switch (ordem) {
            case 'ALFABETICA':
                //widget.getField('NRINIVINCULOM').setValue(widget.currentRow.DSINICIOCALCBENEF);
                //widget.getField('NRFIMVINCULOM').setValue(widget.currentRow.DSFIMCALCBENEF);
                break;
            case 'MATRICULA':
                widget.getField('CDINIMATRICULA').setValue(widget.currentRow.DSINICIOCALCBENEF);
                widget.getField('CDFIMMATRICULA').setValue(widget.currentRow.DSFIMCALCBENEF);
                break;
            case 'DATA_ADMISSAO':
                widget.getField('DTINIADMISSAO').setValue(widget.currentRow.DSINICIOCALCBENEF);
                widget.getField('DTFIMADMISSAO').setValue(widget.currentRow.DSFIMCALCBENEF);
                break;
            case 'ESTRUTURA':
                //widget.getField('NRESTRUTLEGAL').setValue(widget.currentRow.DSINICIOCALCBENEF);
                //widget.getField('NRESTRUTGEREN').setValue(widget.currentRow.DSFIMCALCBENEF);
                break;
        }
    };

    this.processarBeneficio = function(widget, action) {
        if (action === this.CALCULAR) {
            var tpperiodobenef = widget.currentRow.TPPERIODOBENEF;

            if (tpperiodobenef === 'DIARIO') {
                var dtmescompetencia = getLocalVar('HCM_DTCOMPETENCIA_OPER');
                var dtiniperiodo = widget.currentRow.DTINICALCBENEF;

                if (dtmescompetencia.substr(3, 7) === dtiniperiodo.substr(3, 7)) {
                    CalculoBeneficioService.calcular(widget, 'DIARIO', ABUtilController);
                } else {
                    ScreenService.showMessage(Messages.HCM02000_VAB_PER_CALC_COMP_ERROR, 'ERROR');
                }
            } else
                CalculoBeneficioService.calcular(widget, 'MENSAL', ABUtilController);

        }

        if (action === this.RETROCEDER) {
            CalculoBeneficioService.retroceder(widget, ABUtilController);
        }
    };

    this.visibilidadeDatasInicioFim = function(widget) {
        if (widget.currentRow.TPPERIODOBENEF === "MENSAL") {
            widget.getField("DTINICALCBENEF").isVisible = false;
            widget.currentRow.DTINICALCBENEF = "";
            widget.getField("DTFIMCALCBENEF").isVisible = false;
            widget.currentRow.DTFIMCALCBENEF = "";
        } else {
            widget.getField("DTINICALCBENEF").isVisible = true;
            widget.getField("DTFIMCALCBENEF").isVisible = true;
        }
    };

}

Configuration(function(ContextRegister) {
    ContextRegister.register('CalculoBeneficioController', CalculoBeneficioController);
});


// FILE: assets/js/controllers/CalculoFolhaCompController.js
function CalculoFolhaCompController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, $window, ABUtilController, Messages) {

    var tipo_calculo = 13;
    
    /*this.deleteCalculo = function(args) {
        var widget = ABUtilController.checkWidget(args);
        ScreenService.confirmMessage(Messages.DELETE_ROW, 'CONFIRMATION',
            function() {
                widget.dataSource.checkedRows = widget.currentRow;
                widget.removeCheckedRows();
                ABUtilController.masterDetailVoltarList(widget);
                ScreenService.showMessage(Messages.REMOVE_ROW_SUCCESS);
            }.bind(this)
        );
    };*/
    
    this.deleteCalculo = function(args) {
        var widget = templateManager.container.getActiveWidget();
        ScreenService.confirmMessage(Messages.DELETE_ROW, 'CONFIRMATION', function(){
            if (widget.isValid()) {
                widget.currentRow.__is_new = false;
                restEngine.post('product#/deleteFormCalculoComp', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                    then(function (data) {
                        if (data.notifications[0].type === "success") {
                            ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                            ABUtilController.masterDetailVoltarList(widget);
                            widget.reload();
                        } else {
                            ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                        }
                    }).
                    catch(function(e) {
                        var error;
                        if(e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;
    
                        ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    });
            }
        }.bind(this));
    };
    
    this.gravacaoApolo = function(args) {
        var widget = ABUtilController.checkWidget(args);
        ScreenService.confirmMessage('Deseja realmente gravar definitivamente o cálculo?', 'CONFIRMATION',
            function() {
                widget.currentRow.TP_PROCESSAMENTO = 'CALCULO_APOLO_GRAVAR';
                widget.currentRow.TP_CALCULO = tipo_calculo;
                restEngine.post("product#/calculoApolo", {
                    'requestType': 'DataSet',
                    'dataset': [widget.currentRow]
                }).then(function(data) {
                    if (data.messages) {
                        ScreenService.showMessage(data.messages[0].message);
                        ScreenService.closePopup();
                    }
                }).catch(function(e) {
                    var error;
                    if (e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;

                    ScreenService.showMessage('Ocorreu um erro inesperado, contate o administrador informando o trecho abaixo: <br><br>' + error + '<br><br>', 'ERROR');
                });
            }.bind(this));
    };
    
    this.gravacaoParcialApolo = function(args) {
        var widget = ABUtilController.checkWidget(args);
        ScreenService.confirmMessage('Deseja realmente gravar parcial o cálculo?', 'CONFIRMATION',
            function() {
                widget.currentRow.TP_PROCESSAMENTO = 'CALCULO_APOLO_GRAVAR_PARCIAL';
                widget.currentRow.TP_CALCULO = tipo_calculo;
                restEngine.post("product#/calculoApolo", {
                    'requestType': 'DataSet',
                    'dataset': [widget.currentRow]
                }).then(function(data) {
                    if (data.messages) {
                        ScreenService.showMessage(data.messages[0].message);
                        ScreenService.closePopup();
                    }
                }).catch(function(e) {
                    var error;
                    if (e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;

                    ScreenService.showMessage('Ocorreu um erro inesperado, contate o administrador informando o trecho abaixo: <br><br>' + error + '<br><br>', 'ERROR');
                });
            }.bind(this));
    };
    
    this.gravacaoDefinitivaCalculo = function(args) {
        var widget = ABUtilController.checkWidget(args);
        ScreenService.confirmMessage('Deseja realmente gravar definitivamente o cálculo?', 'CONFIRMATION',
            function() {
                widget.currentRow.TP_PROCESSAMENTO = 'CALCULO';
                widget.currentRow.TP_CALCULO = tipo_calculo;
                restEngine.post("product#/calculo", {
                    'requestType': 'DataSet',
                    'dataset': [widget.currentRow]
                }).then(function(data) {
                    if (data.messages) {
                        ScreenService.successNotification(data.messages[0].message);
                        ScreenService.closePopup();
                    }
                    if (data.dataset && data.dataset.memoriaCalculo && data.dataset.memoriaCalculo.length > 0) {
                        data.dataset.memoriaCalculo.forEach(function(nmArquivo){
                           ABUtilController.downloadArquivo(nmArquivo.ARQUIVOMEMORIA);
                        });
                    }
                    if (data.dataset && data.dataset.msgCalculo && data.dataset.msgCalculo.length > 0) {
                        var popUp = templateManager.container.getWidget("mensagens");
                        popUp.dataSource.data = data.dataset.msgCalculo;
                        ABUtilController.masterDetailOpenPopup(popUp);
                    }
                    if (widget.currentRow.FORM_RECIBO) {
                        var widgetCalc = templateManager.container.getWidget(widget.currentRow.FORM_RECIBO);
                        widgetCalc.reload();
                        ScreenService.closePopup();
                    }
                }).catch(function(e) {
                    var error;
                    if (e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;

                    ScreenService.showMessage('Ocorreu um erro inesperado, contate o administrador informando o trecho abaixo: <br><br>' + error + '<br><br>', 'ERROR');
                });
            }.bind(this));
    };

    this.gravacaoParcialCalculo = function(args) {
        var widget = ABUtilController.checkWidget(args);
        ScreenService.confirmMessage('Deseja realmente gravar parcialmente o cálculo?', 'CONFIRMATION',
            function() {
                widget.currentRow.TP_PROCESSAMENTO = 'PARCIAL';
                widget.currentRow.TP_CALCULO = tipo_calculo;
                restEngine.post("product#/calculo", {
                    'requestType': 'DataSet',
                    'dataset': [widget.currentRow]
                }).then(function(data) {
                    if (data.messages) {
                        ScreenService.successNotification(data.messages[0].message);
                        ScreenService.closePopup();
                    }
                    if (data.dataset && data.dataset.memoriaCalculo && data.dataset.memoriaCalculo.length > 0) {
                        data.dataset.memoriaCalculo.forEach(function(nmArquivo){
                           ABUtilController.downloadArquivo(nmArquivo.ARQUIVOMEMORIA);
                        });
                    }
                    if (widget.currentRow.FORM_RECIBO) {
                        var widgetCalc = templateManager.container.getWidget(widget.currentRow.FORM_RECIBO);
                        widgetCalc.reload();
                        ScreenService.closePopup();
                    }
                    if (data.dataset && data.dataset.msgCalculo && data.dataset.msgCalculo.length > 0) {
                        var popUp = templateManager.container.getWidget("mensagens");
                        popUp.dataSource.data = data.dataset.msgCalculo;
                        ABUtilController.masterDetailOpenPopup(popUp);
                    }
                }).catch(function(e) {
                    var error;
                    if (e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;

                    ScreenService.showMessage('Ocorreu um erro inesperado, contate o administrador informando o trecho abaixo: <br><br>' + error + '<br><br>', 'ERROR');
                });
            }.bind(this));
    };

    this.retrocessoCalculo = function(args) {
        var widget = ABUtilController.checkWidget(args);
        ScreenService.confirmMessage('Deseja realmente retroceder o cálculo?', 'CONFIRMATION',
            function() {
                widget.currentRow.TP_PROCESSAMENTO = 'RETROCESSO';
                widget.currentRow.TP_CALCULO = tipo_calculo;
                restEngine.post("product#/calculo", {
                    'requestType': 'DataSet',
                    'dataset': [widget.currentRow]
                }).then(function(data) {
                    if (data.messages) {
                        ScreenService.successNotification(data.messages[0].message);
                        ScreenService.closePopup();
                    }
                    if (data.dataset && data.dataset.msgCalculo && data.dataset.msgCalculo.length > 0) {
                        var popUp = templateManager.container.getWidget("mensagens");
                        popUp.dataSource.data = data.dataset.msgCalculo;
                        ABUtilController.masterDetailOpenPopup(popUp);
                    }
                    if (widget.currentRow.FORM_RECIBO) {
                        var widgetCalc = templateManager.container.getWidget(widget.currentRow.FORM_RECIBO);
                        widgetCalc.reload();
                        ScreenService.closePopup();
                    }
                }).catch(function(e) {
                    var error;
                    if (e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;

                    ScreenService.showMessage('Ocorreu um erro inesperado, contate o administrador informando o trecho abaixo: <br><br>' + error + '<br><br>', 'ERROR');
                });
            }.bind(this));

    };

    this.simularCalculo = function(args) {
        var widget = ABUtilController.checkWidget(args);
        ScreenService.confirmMessage('Deseja realmente simular o cálculo?', 'CONFIRMATION',
            function() {
                widget.currentRow.TP_PROCESSAMENTO = 'SIMULACAO';
                widget.currentRow.TP_CALCULO = tipo_calculo;
                restEngine.post("product#/calculo", {
                        'requestType': 'DataSet',
                        'dataset': [widget.currentRow]
                    },
                    function(data) {
                        if (data.messages) {
                            ScreenService.successNotification(data.messages[0].message);
                            ScreenService.closePopup();
                        }
                        if (data.dataset && data.dataset.simulacao) {
                            var widgetSimu = this.preparaDemonstrativo(data.dataset.simulacao);
                            ABUtilController.masterDetailOpenPopup(widgetSimu);
                        }
                        if (data.dataset && data.dataset.memoriaCalculo && data.dataset.memoriaCalculo.length > 0) {
                            data.dataset.memoriaCalculo.forEach(function(nmArquivo){
                               ABUtilController.downloadArquivo(nmArquivo.ARQUIVOMEMORIA);
                            });
                        }
                        if (data.dataset && data.dataset.msgCalculo && data.dataset.msgCalculo.length > 0) {
                            var popUp = templateManager.container.getWidget("mensagens");
                            popUp.dataSource.data = data.dataset.msgCalculo;
                            ABUtilController.masterDetailOpenPopup(popUp);
                        }
                        if (widget.currentRow.FORM_RECIBO) {
                            var widgetCalc = templateManager.container.getWidget(widget.currentRow.FORM_RECIBO);
                            widgetCalc.reload();
                            ScreenService.closePopup();
                        }
                    }.bind(this), undefined,
                    function(e) {
                        var error;
                        if (e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;

                        ScreenService.showMessage('Ocorreu um erro inesperado, contate o administrador informando o trecho abaixo: <br><br>' + error + '<br><br>', 'ERROR');
                    }
                );
            }.bind(this));
    };

    this.preparaDemonstrativo = function(vinculos) {

        var widgetSimulacao = templateManager.container.getWidget("simulacao");
        widgetSimulacao.dataSource.data = [];
        vinculos.forEach(function(nrcalculofolha) {
            nrcalculofolha.SIMULACAO.forEach(function(itensCalcFolha) {
                widgetSimulacao.dataSource.data = widgetSimulacao.dataSource.data.concat(itensCalcFolha);
            });
        });
        return widgetSimulacao;
    };

    this.salvarCalculo = function(args) {
        var widget = ABUtilController.checkWidget(args);

        if (widget.isValid()) {
            if (ABUtilController.validaCritSelecao(widget.currentRow)) {
                widget.currentRow.CDOPERADOR_LOG = getLocalVar("HCM_CDOPERADOR");
                widget.currentRow.NRORGTRAB = getLocalVar("HCM_NRORG_TRAB");
                widget.currentRow.NRORGPADRAO = getLocalVar("HCM_NRORG_PADRAO");
                widget.currentRow.DTATUAL = getLocalVar("HCM_DATA_ATUAL");
                widget.dataSourceFilter.forEach(function(filter) {
                    if (filter.name == 'P_IDTPFORMCALCULO') {
                        widget.currentRow.IDTPFORMCALCULO = filter.value;
                    }
                });
                if (!widget.backupRow) {
                    widget.currentRow.__is_new = true;
                } else {
                    widget.currentRow.__is_new = false;
                }

                return restEngine.post("product#/setFormCalculoComp", {
                        'requestType': 'DataSet',
                        'dataset': [widget.currentRow]
                    }).then(function(data) {
                    if (widget.currentRow.__is_new) {
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    } else {
                        ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                        widget.backupRow = null;
                        widget.view();
                    }
                }).catch(function(e) {
                    var error;
                    if (e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;

                    ScreenService.showMessage('Ocorreu um erro inesperado, contate o administrador informando o trecho abaixo: <br><br>' + error + '<br><br>', 'ERROR');
                });
            }
        }
    };
    
}

Configuration(function(ContextRegister) {
    ContextRegister.register('CalculoFolhaCompController', CalculoFolhaCompController);
});


// FILE: assets/js/controllers/CalculoFolhaCompRescisaoController.js
function CalculoFolhaCompRescisaoController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, $window, ABUtilController, Messages) {

    var tipo_calculo = 13;
    
    /*this.deleteCalculo = function(args) {
        var widget = ABUtilController.checkWidget(args);
        ScreenService.confirmMessage(Messages.DELETE_ROW, 'CONFIRMATION',
            function() {
                widget.dataSource.checkedRows = widget.currentRow;
                widget.removeCheckedRows();
                ABUtilController.masterDetailVoltarList(widget);
                ScreenService.showMessage(Messages.REMOVE_ROW_SUCCESS);
            }.bind(this)
        );
    };*/
    
    this.deleteCalculo = function(args) {
        var widget = templateManager.container.getActiveWidget();
        ScreenService.confirmMessage(Messages.DELETE_ROW, 'CONFIRMATION', function(){
            if (widget.isValid()) {
                widget.currentRow.__is_new = false;
                restEngine.post('product#/deleteFormCalculoComp', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                    then(function (data) {
                        if (data.notifications[0].type === "success") {
                            ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                            ABUtilController.masterDetailVoltarList(widget);
                            widget.reload();
                        } else {
                            ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                        }
                    }).
                    catch(function(e) {
                        var error;
                        if(e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;
    
                        ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    });
            }
        }.bind(this));
    };
    
    this.gravacaoApolo = function(args) {
        var widget = ABUtilController.checkWidget(args);
        ScreenService.confirmMessage('Deseja realmente gravar definitivamente o cálculo?', 'CONFIRMATION',
            function() {
                widget.currentRow.TP_PROCESSAMENTO = 'CALCULO_APOLO_GRAVAR';
                widget.currentRow.TP_CALCULO = tipo_calculo;
                restEngine.post("product#/calculoApolo", {
                    'requestType': 'DataSet',
                    'dataset': [widget.currentRow]
                }).then(function(data) {
                    if (data.messages) {
                        ScreenService.showMessage(data.messages[0].message);
                        ScreenService.closePopup();
                    }
                }).catch(function(e) {
                    var error;
                    if (e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;

                    ScreenService.showMessage('Ocorreu um erro inesperado, contate o administrador informando o trecho abaixo: <br><br>' + error + '<br><br>', 'ERROR');
                });
            }.bind(this));
    };
    
    this.gravacaoParcialApolo = function(args) {
        var widget = ABUtilController.checkWidget(args);
        ScreenService.confirmMessage('Deseja realmente gravar parcial o cálculo?', 'CONFIRMATION',
            function() {
                widget.currentRow.TP_PROCESSAMENTO = 'CALCULO_APOLO_GRAVAR_PARCIAL';
                widget.currentRow.TP_CALCULO = tipo_calculo;
                restEngine.post("product#/calculoApolo", {
                    'requestType': 'DataSet',
                    'dataset': [widget.currentRow]
                }).then(function(data) {
                    if (data.messages) {
                        ScreenService.showMessage(data.messages[0].message);
                        ScreenService.closePopup();
                    }
                }).catch(function(e) {
                    var error;
                    if (e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;

                    ScreenService.showMessage('Ocorreu um erro inesperado, contate o administrador informando o trecho abaixo: <br><br>' + error + '<br><br>', 'ERROR');
                });
            }.bind(this));
    };
    
    this.gravacaoDefinitivaCalculo = function(args) {
        var widget = ABUtilController.checkWidget(args);
        ScreenService.confirmMessage('Deseja realmente gravar definitivamente o cálculo?', 'CONFIRMATION',
            function() {
                widget.currentRow.TP_PROCESSAMENTO = 'CALCULO';
                widget.currentRow.TP_CALCULO = tipo_calculo;
                restEngine.post("product#/calculo", {
                    'requestType': 'DataSet',
                    'dataset': [widget.currentRow]
                }).then(function(data) {
                    if (data.messages) {
                        ScreenService.successNotification(data.messages[0].message);
                        ScreenService.closePopup();
                    }
                    if (data.dataset && data.dataset.memoriaCalculo && data.dataset.memoriaCalculo.length > 0) {
                        data.dataset.memoriaCalculo.forEach(function(nmArquivo){
                           ABUtilController.downloadArquivo(nmArquivo.ARQUIVOMEMORIA);
                        });
                    }
                    if (data.dataset && data.dataset.msgCalculo && data.dataset.msgCalculo.length > 0) {
                        var popUp = templateManager.container.getWidget("mensagens");
                        popUp.dataSource.data = data.dataset.msgCalculo;
                        ABUtilController.masterDetailOpenPopup(popUp);
                    }
                    if (widget.currentRow.FORM_RECIBO) {
                        var widgetCalc = templateManager.container.getWidget(widget.currentRow.FORM_RECIBO);
                        widgetCalc.reload();
                        ScreenService.closePopup();
                    }
                }).catch(function(e) {
                    var error;
                    if (e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;

                    ScreenService.showMessage('Ocorreu um erro inesperado, contate o administrador informando o trecho abaixo: <br><br>' + error + '<br><br>', 'ERROR');
                });
            }.bind(this));
    };

    this.gravacaoParcialCalculo = function(args) {
        var widget = ABUtilController.checkWidget(args);
        ScreenService.confirmMessage('Deseja realmente gravar parcialmente o cálculo?', 'CONFIRMATION',
            function() {
                widget.currentRow.TP_PROCESSAMENTO = 'PARCIAL';
                widget.currentRow.TP_CALCULO = tipo_calculo;
                restEngine.post("product#/calculo", {
                    'requestType': 'DataSet',
                    'dataset': [widget.currentRow]
                }).then(function(data) {
                    if (data.messages) {
                        ScreenService.successNotification(data.messages[0].message);
                        ScreenService.closePopup();
                    }
                    if (data.dataset && data.dataset.memoriaCalculo && data.dataset.memoriaCalculo.length > 0) {
                        data.dataset.memoriaCalculo.forEach(function(nmArquivo){
                           ABUtilController.downloadArquivo(nmArquivo.ARQUIVOMEMORIA);
                        });
                    }
                    if (widget.currentRow.FORM_RECIBO) {
                        var widgetCalc = templateManager.container.getWidget(widget.currentRow.FORM_RECIBO);
                        widgetCalc.reload();
                        ScreenService.closePopup();
                    }
                    if (data.dataset && data.dataset.msgCalculo && data.dataset.msgCalculo.length > 0) {
                        var popUp = templateManager.container.getWidget("mensagens");
                        popUp.dataSource.data = data.dataset.msgCalculo;
                        ABUtilController.masterDetailOpenPopup(popUp);
                    }
                }).catch(function(e) {
                    var error;
                    if (e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;

                    ScreenService.showMessage('Ocorreu um erro inesperado, contate o administrador informando o trecho abaixo: <br><br>' + error + '<br><br>', 'ERROR');
                });
            }.bind(this));
    };

    this.retrocessoCalculo = function(args) {
        var widget = ABUtilController.checkWidget(args);
        ScreenService.confirmMessage('Deseja realmente retroceder o cálculo?', 'CONFIRMATION',
            function() {
                widget.currentRow.TP_PROCESSAMENTO = 'RETROCESSO';
                widget.currentRow.TP_CALCULO = tipo_calculo;
                restEngine.post("product#/calculo", {
                    'requestType': 'DataSet',
                    'dataset': [widget.currentRow]
                }).then(function(data) {
                    if (data.messages) {
                        ScreenService.successNotification(data.messages[0].message);
                        ScreenService.closePopup();
                    }
                    if (data.dataset && data.dataset.msgCalculo && data.dataset.msgCalculo.length > 0) {
                        var popUp = templateManager.container.getWidget("mensagens");
                        popUp.dataSource.data = data.dataset.msgCalculo;
                        ABUtilController.masterDetailOpenPopup(popUp);
                    }
                    if (widget.currentRow.FORM_RECIBO) {
                        var widgetCalc = templateManager.container.getWidget(widget.currentRow.FORM_RECIBO);
                        widgetCalc.reload();
                        ScreenService.closePopup();
                    }
                }).catch(function(e) {
                    var error;
                    if (e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;

                    ScreenService.showMessage('Ocorreu um erro inesperado, contate o administrador informando o trecho abaixo: <br><br>' + error + '<br><br>', 'ERROR');
                });
            }.bind(this));

    };

    this.simularCalculo = function(args) {
        var widget = ABUtilController.checkWidget(args);
        ScreenService.confirmMessage('Deseja realmente simular o cálculo?', 'CONFIRMATION',
            function() {
                widget.currentRow.TP_PROCESSAMENTO = 'SIMULACAO';
                widget.currentRow.TP_CALCULO = tipo_calculo;
                restEngine.post("product#/calculo", {
                        'requestType': 'DataSet',
                        'dataset': [widget.currentRow]
                    },
                    function(data) {
                        if (data.messages) {
                            ScreenService.successNotification(data.messages[0].message);
                            ScreenService.closePopup();
                        }
                        if (data.dataset && data.dataset.simulacao) {
                            var widgetSimu = this.preparaDemonstrativo(data.dataset.simulacao);
                            ABUtilController.masterDetailOpenPopup(widgetSimu);
                        }
                        if (data.dataset && data.dataset.memoriaCalculo && data.dataset.memoriaCalculo.length > 0) {
                            data.dataset.memoriaCalculo.forEach(function(nmArquivo){
                               ABUtilController.downloadArquivo(nmArquivo.ARQUIVOMEMORIA);
                            });
                        }
                        if (data.dataset && data.dataset.msgCalculo && data.dataset.msgCalculo.length > 0) {
                            var popUp = templateManager.container.getWidget("mensagens");
                            popUp.dataSource.data = data.dataset.msgCalculo;
                            ABUtilController.masterDetailOpenPopup(popUp);
                        }
                        if (widget.currentRow.FORM_RECIBO) {
                            var widgetCalc = templateManager.container.getWidget(widget.currentRow.FORM_RECIBO);
                            widgetCalc.reload();
                            ScreenService.closePopup();
                        }
                    }.bind(this), undefined,
                    function(e) {
                        var error;
                        if (e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;

                        ScreenService.showMessage('Ocorreu um erro inesperado, contate o administrador informando o trecho abaixo: <br><br>' + error + '<br><br>', 'ERROR');
                    }
                );
            }.bind(this));
    };

    this.preparaDemonstrativo = function(vinculos) {

        var widgetSimulacao = templateManager.container.getWidget("simulacao");
        widgetSimulacao.dataSource.data = [];
        vinculos.forEach(function(nrcalculofolha) {
            nrcalculofolha.SIMULACAO.forEach(function(itensCalcFolha) {
                widgetSimulacao.dataSource.data = widgetSimulacao.dataSource.data.concat(itensCalcFolha);
            });
        });
        return widgetSimulacao;
    };

    this.salvarCalculo = function(args) {
        var widget = ABUtilController.checkWidget(args);

        if (widget.isValid()) {
            if (ABUtilController.validaCritSelecao(widget.currentRow)) {
                widget.currentRow.CDOPERADOR_LOG = getLocalVar("HCM_CDOPERADOR");
                widget.currentRow.NRORGTRAB = getLocalVar("HCM_NRORG_TRAB");
                widget.currentRow.NRORGPADRAO = getLocalVar("HCM_NRORG_PADRAO");
                widget.currentRow.DTATUAL = getLocalVar("HCM_DATA_ATUAL");
                widget.dataSourceFilter.forEach(function(filter) {
                    if (filter.name == 'P_IDTPFORMCALCULO') {
                        widget.currentRow.IDTPFORMCALCULO = filter.value;
                    }
                });
                if (!widget.backupRow) {
                    widget.currentRow.__is_new = true;
                } else {
                    widget.currentRow.__is_new = false;
                }

                return restEngine.post("product#/setFormCalculoComp", {
                        'requestType': 'DataSet',
                        'dataset': [widget.currentRow]
                    }).then(function(data) {
                    if (widget.currentRow.__is_new) {
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    } else {
                        ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                        widget.backupRow = null;
                        widget.view();
                    }
                }).catch(function(e) {
                    var error;
                    if (e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;

                    ScreenService.showMessage('Ocorreu um erro inesperado, contate o administrador informando o trecho abaixo: <br><br>' + error + '<br><br>', 'ERROR');
                });
            }
        }
    };
    
    //caso o campo "Data Base" esteja preenchido o campo "Sallario Dissidio precisa ser obrigatorio"
    this.validaSalarioDissidio = function(){
        var widgetParam = templateManager.container.getWidget("calculoFolhaCompRescisao");
        var campo1 = widgetParam.getField('NRSALADISSIDIO');
        if (widgetParam.currentRow.DTBASE) {
            campo1.validations = { required: {} };
        } else {
            campo1.validations = {};
        }
    };

}

Configuration(function(ContextRegister) {
    ContextRegister.register('CalculoFolhaCompRescisaoController', CalculoFolhaCompRescisaoController);
});


// FILE: assets/js/controllers/CalculoFolhaController.js
function CalculoFolhaController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, $window, ABUtilController, Messages) {
    var tipo_calculo;

    this.ACTION_FECHAMENTO = ['fechamento'];
    this.ACTION_PADRAO = ['simulacao', 'gravacaoDefinitiva', 'gravacaoParcial', 'retrocesso'];
    this.NR_CALCULO_MENSAL = 1;
    this.NR_CALCULO_ADIANTAMENTO = 5;
    this.NR_CALCULO_ADIANTAMENTO_13SAL = 4;
    this.NR_CALCULO_13SAL = 3;
    this.NR_CALCULO_PROVISAO_CONTABIL = 8;
    this.NR_CALCULO_FECHAMENTO = 9;
    this.NR_CALCULO_PLR = 11;

    this.setVisibilityActions = function(widget, fechamento) {

        if (fechamento) {
            this.ACTION_FECHAMENTO.forEach(function(campo) {
                widget.getAction(campo).isVisible = true;
            });
            this.ACTION_PADRAO.forEach(function(campo) {
                widget.getAction(campo).isVisible = false;
            });
        } else {
            this.ACTION_FECHAMENTO.forEach(function(campo) {
                widget.getAction(campo).isVisible = false;
            });
            this.ACTION_PADRAO.forEach(function(campo) {
                widget.getAction(campo).isVisible = true;
            });
        }
    };
    
    this.validaFiltroListas = function () {
        var widget = templateManager.container.getWidget('calculoFolha');
        var resultado = false;
        if(!widget.getField('NRVINCULOM_LIST') && !widget.getField('LIST_NRESTRUTLEGAL') && !widget.getField('LIST_NRESTRUTGEREN') && !widget.getField('LIST_NRESTRUTSIND')){
            ScreenService.showMessage("É necessário preencher o campo 'Vínculo', 'Estrutura Legal', 'Estrutura Gerencial' ou 'Estrutura Sindical' para realizar o filtro.");

        } else {
            if ((widget.currentRow.NRVINCULOM_LIST && widget.currentRow.NRVINCULOM_LIST.length > 400)) {
                ScreenService.showMessage("Favor selecionar um máximo de 400 vínculos na lista ou usar outro filtro como por exemplo por estrutura legal.");
                resultado =  true;
            }
            if ((widget.currentRow.LIST_NRESTRUTLEGAL && widget.currentRow.LIST_NRESTRUTLEGAL.length > 400) || (widget.currentRow.LIST_NRESTRUTGEREN && widget.currentRow.LIST_NRESTRUTGEREN .length > 400) || (widget.currentRow.LIST_NRESTRUTGEREN  && widget.currentRow.LIST_NRESTRUTGEREN.length > 400)) {
                ScreenService.showMessage("Favor selecionar um máximo de 400 estruturas na lista.");
                resultado = true;
            }
        } 
        return resultado;
    };


    this.setVisibilityFields = function(widget) {
        var param = getLocalVar("HCM_FPA_PARAMFORMCALC").IDTPFORMCALCULO;
        var container = templateManager.containers['product#hcm01047_fpa_calculoFolha'];
        widget.getField('IDPROPSAL').isVisible = false;
        widget.getField('IDPAGAADIC').isVisible = false;
        widget.getField('IDDESCSALDOADI').isVisible = false;
        widget.getField('IDCONSALREDUCAO').isVisible = false;
        widget.getField('IDCONSOLIDAINSS').isVisible = false;
        widget.getField('IDCONSVINCRESC').isVisible = false;
        
        if (param == this.NR_CALCULO_MENSAL) {
            tipo_calculo = this.NR_CALCULO_MENSAL;
            
            container.label = 'Cálculo de Folha Mensal';
            widget.label = 'Cálculo de Folha Mensal';
            widget.getField('IDPROPSAL').isVisible = true;
            widget.getField('IDPAGAADIC').isVisible = true;
            widget.getField('IDCONSOLIDAINSS').isVisible = true;
            
            this.setVisibilityActions(widget, false);
            widget.dataSourceFilter.forEach(function(filter) {
                if (filter.name == 'P_IDTPFORMCALCULO') {
                    filter.value = 'FOLHAMENSAL';
                }
            });
        } else if (param == this.NR_CALCULO_13SAL) {
            tipo_calculo = this.NR_CALCULO_13SAL;

            container.label = 'Cálculo de 13° Salário - Complemento';
            widget.label = 'Cálculo de 13° Salário - Complemento';
            widget.getField('IDCONSALREDUCAO').isVisible = true;
            widget.getField('IDCONSVINCRESC').isVisible = true;
            this.setVisibilityActions(widget, false);
            widget.dataSourceFilter.forEach(function(filter) {
                if (filter.name == 'P_IDTPFORMCALCULO') {
                    filter.value = '13SALARIO';
                }
            });
        } else if (param == this.NR_CALCULO_ADIANTAMENTO_13SAL) {
            tipo_calculo = this.NR_CALCULO_ADIANTAMENTO_13SAL;

            container.label = 'Cálculo de 13° Salário - Adiantamento';
            widget.label = 'Cálculo de 13° Salário - Adiantamento';
            widget.getField('IDCONSALREDUCAO').isVisible = true;
            widget.getField('IDCONSVINCRESC').isVisible = true;
            this.setVisibilityActions(widget, false);
            widget.dataSourceFilter.forEach(function(filter) {
                if (filter.name == 'P_IDTPFORMCALCULO') {
                    filter.value = '13SALARIO';
                }
            });
        } else if (param == this.NR_CALCULO_ADIANTAMENTO) {
            tipo_calculo = this.NR_CALCULO_ADIANTAMENTO;
            widget.getField('IDDESCSALDOADI').isVisible = true;
            widget.getField('IDCONSVINCRESC').isVisible = true;
            container.label = 'Cálculo de Adiantamento';
            widget.label = 'Cálculo de Adiantamento';
            this.setVisibilityActions(widget, false);
            widget.dataSourceFilter.forEach(function(filter) {
                if (filter.name == 'P_IDTPFORMCALCULO') {
                    filter.value = 'ADIANTAMENTO';
                }
            });
        } else if (param == this.NR_CALCULO_PROVISAO_CONTABIL) {
            tipo_calculo = this.NR_CALCULO_PROVISAO_CONTABIL;
            widget.getField('IDPROPSAL').isVisible = true;
            container.label = 'Provisão Mensal';
            widget.label = 'Provisão Mensal';
            this.setVisibilityActions(widget, false);
            widget.dataSourceFilter.forEach(function(filter) {
                if (filter.name == 'P_IDTPFORMCALCULO') {
                    filter.value = 'PROVISAO';
                }
            });
            widget.actions.forEach(function(action){
                if(action.name == 'retrocesso') {
                    action.isVisible = false;
                }
                if(action.name == 'gravacaoParcial') {
                    action.isVisible = false;
                }
                if(action.name == 'gravarParcialLote') {
                    action.isVisible = false;
                }
                if(action.name == 'recalculoPatronal') {
                    action.isVisible = false;
                }
                if(action.name == 'gravarLote') {
                    action.isVisible = false;
                }
                if(action.name == 'gravacaoDefinitiva') {
                    action.isVisible = false;
                }
                if(action.name == 'simulacao') {
                    action.isVisible = false;
                }
                if(action.name == 'gravacaoNovaProvisao') {
                    action.isVisible = true;
                }
                if(action.name == 'gravarLoteNovaProvisao') {
                    action.isVisible = true;
                }
                if(action.name == 'gravarLoteNovaProvisaoNP') {
                    action.isVisible = true;
                }
            });
            
        } else if (param == this.NR_CALCULO_FECHAMENTO) {
            tipo_calculo = this.NR_CALCULO_FECHAMENTO;

            container.label = 'Fechamento Mensal';
            widget.label = 'Fechamento Mensal';
            this.setVisibilityActions(widget, true);
            widget.dataSourceFilter.forEach(function(filter) {
                if (filter.name == 'P_IDTPFORMCALCULO') {
                    filter.value = 'FECHAMENTO';
                }
            });
        } else if (param == this.NR_CALCULO_PLR) {
            tipo_calculo = this.NR_CALCULO_PLR;

            container.label = 'Cálculo de PLR';
            widget.label = 'Cálculo de PLR';
            this.setVisibilityActions(widget, false);
            widget.dataSourceFilter.forEach(function(filter) {
                if (filter.name == 'P_IDTPFORMCALCULO') {
                    filter.value = 'CALC_PLR';
                }
            });
        }
    };

    this.menuOnClick = function(args, param) {
        if (Util.isEmptyOrBlank(getLocalVar('HCM_FPA_PARAMFORMCALC'))) {
            setLocalVar('HCM_FPA_PARAMFORMCALC', {
                'IDTPFORMCALCULO': param
            });
        } else {
            var localVar = getLocalVar('HCM_FPA_PARAMFORMCALC');
            for (var tipoNome in localVar) {
                if (tipoNome == 'IDTPFORMCALCULO') {
                    localVar[tipoNome] = param;
                }
            }
            setLocalVar('HCM_FPA_PARAMFORMCALC', localVar);
        }

        if (!Util.isEmptyOrBlank(templateManager.containers['product#hcm01047_fpa_calculoFolha'])) {
            var widget = templateManager.containers['product#hcm01047_fpa_calculoFolha'].getWidget('calculoFolha');
            ScreenService.closeSwipe(widget);
            this.setVisibilityFields(widget);
            widget.reload();
        }
    };

    this.deleteCalculo = function(args) {
        var widget = ABUtilController.checkWidget(args);
        ScreenService.confirmMessage(Messages.DELETE_ROW, 'CONFIRMATION',
            function() {
                widget.dataSource.checkedRows = widget.currentRow;
                widget.removeCheckedRows();
                ABUtilController.masterDetailVoltarList(widget);
                ScreenService.showMessage(Messages.REMOVE_ROW_SUCCESS);
            }.bind(this)
        );
    };
    
    this.gravacaoApolo = function(args) {
        var widget = ABUtilController.checkWidget(args);
        ScreenService.confirmMessage('Deseja realmente gravar definitivamente o cálculo?', 'CONFIRMATION',
            function() {
                widget.currentRow.TP_PROCESSAMENTO = 'CALCULO_APOLO_GRAVAR';
                widget.currentRow.TP_CALCULO = tipo_calculo;
                restEngine.post("product#/calculoApolo", {
                    'requestType': 'DataSet',
                    'dataset': [widget.currentRow]
                }).then(function(data) {
                    if (data.messages) {
                        ScreenService.showMessage(data.messages[0].message);
                        ScreenService.closePopup();
                    }
                }).catch(function(e) {
                    var error;
                    if (e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;

                    ScreenService.showMessage('Ocorreu um erro inesperado, contate o administrador informando o trecho abaixo: <br><br>' + error + '<br><br>', 'ERROR');
                });
            }.bind(this));
    };
    
    this.gravacaoParcialApolo = function(args) {
        var widget = ABUtilController.checkWidget(args);
        ScreenService.confirmMessage('Deseja realmente gravar parcial o cálculo?', 'CONFIRMATION',
            function() {
                widget.currentRow.TP_PROCESSAMENTO = 'CALCULO_APOLO_GRAVAR_PARCIAL';
                widget.currentRow.TP_CALCULO = tipo_calculo;
                restEngine.post("product#/calculoApolo", {
                    'requestType': 'DataSet',
                    'dataset': [widget.currentRow]
                }).then(function(data) {
                    if (data.messages) {
                        ScreenService.showMessage(data.messages[0].message);
                        ScreenService.closePopup();
                    }
                }).catch(function(e) {
                    var error;
                    if (e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;

                    ScreenService.showMessage('Ocorreu um erro inesperado, contate o administrador informando o trecho abaixo: <br><br>' + error + '<br><br>', 'ERROR');
                });
            }.bind(this));
    };
    
    this.gravacaoDefinitivaCalculo = function(args) {
        var widget = ABUtilController.checkWidget(args);
        ScreenService.confirmMessage('Deseja realmente gravar definitivamente o cálculo?', 'CONFIRMATION',
            function() {
                widget.currentRow.TP_PROCESSAMENTO = 'CALCULO';
                widget.currentRow.TP_CALCULO = tipo_calculo;
                restEngine.post("product#/calculo", {
                    'requestType': 'DataSet',
                    'dataset': [widget.currentRow]
                }).then(function(data) {
                    if (widget.currentRow.FORM_RECIBO) {
                        var widgetCalc = templateManager.container.getWidget(widget.currentRow.FORM_RECIBO);
                        widgetCalc.reload();
                        ScreenService.closePopup();
                    }
                    if (data.messages) {
                        ScreenService.successNotification(data.messages[0].message);
                        ScreenService.closePopup();
                    }
                    if (data.dataset && data.dataset.memoriaCalculo && data.dataset.memoriaCalculo.length > 0) {
                        data.dataset.memoriaCalculo.forEach(function(nmArquivo){
                           ABUtilController.downloadArquivo(nmArquivo.ARQUIVOMEMORIA);
                        });
                    }
                    if (data.dataset && data.dataset.msgCalculo && data.dataset.msgCalculo.length > 0) {
                        var popUp = templateManager.container.getWidget("mensagens");
                        popUp.dataSource.data = data.dataset.msgCalculo;
                        ABUtilController.masterDetailOpenPopup(popUp);
                    }
                }).catch(function(e) {
                    var error;
                    if (e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;

                    ScreenService.showMessage('Ocorreu um erro inesperado, contate o administrador informando o trecho abaixo: <br><br>' + error + '<br><br>', 'ERROR');
                });
            }.bind(this));
    };
    
    this.gravacaoNovaProvisao = function(args) {
        var widget = ABUtilController.checkWidget(args);
        ScreenService.confirmMessage('Deseja realmente gravar a provisão ?', 'CONFIRMATION',
            function() {
                widget.currentRow.TP_PROCESSAMENTO = 'CALCULO';
                widget.currentRow.TP_CALCULO = 14;
                restEngine.post("product#/calculo", {
                    'requestType': 'DataSet',
                    'dataset': [widget.currentRow]
                }).then(function(data) {
                    if (widget.currentRow.FORM_RECIBO) {
                        var widgetCalc = templateManager.container.getWidget(widget.currentRow.FORM_RECIBO);
                        widgetCalc.reload();
                        ScreenService.closePopup();
                    }
                    if (data.messages) {
                        ScreenService.successNotification(data.messages[0].message);
                        ScreenService.closePopup();
                    }
                    if (data.dataset && data.dataset.memoriaCalculo && data.dataset.memoriaCalculo.length > 0) {
                        data.dataset.memoriaCalculo.forEach(function(nmArquivo){
                           ABUtilController.downloadArquivo(nmArquivo.ARQUIVOMEMORIA);
                        });
                    }
                    if (data.dataset && data.dataset.msgCalculo && data.dataset.msgCalculo.length > 0) {
                        var popUp = templateManager.container.getWidget("mensagens");
                        popUp.dataSource.data = data.dataset.msgCalculo;
                        ABUtilController.masterDetailOpenPopup(popUp);
                    }
                }).catch(function(e) {
                    var error;
                    if (e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;

                    ScreenService.showMessage('Ocorreu um erro inesperado, contate o administrador informando o trecho abaixo: <br><br>' + error + '<br><br>', 'ERROR');
                });
            }.bind(this));
    };
    
    this.gravacaoApoloNovaProvisao = function(args) {
        var widget = ABUtilController.checkWidget(args);
        ScreenService.confirmMessage('Deseja realmente gravar definitivamente o cálculo?', 'CONFIRMATION',
            function() {
                widget.currentRow.TP_PROCESSAMENTO = 'CALCULO_APOLO_GRAVAR';
                widget.currentRow.TP_CALCULO = 14;
                restEngine.post("product#/calculoApolo", {
                    'requestType': 'DataSet',
                    'dataset': [widget.currentRow]
                }).then(function(data) {
                    if (data.messages) {
                        ScreenService.showMessage(data.messages[0].message);
                        ScreenService.closePopup();
                    }
                }).catch(function(e) {
                    var error;
                    if (e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;

                    ScreenService.showMessage('Ocorreu um erro inesperado, contate o administrador informando o trecho abaixo: <br><br>' + error + '<br><br>', 'ERROR');
                });
            }.bind(this));
    };
    
    this.gravacaoApoloNovaProvisaoNP = function(args) {
        var widget = ABUtilController.checkWidget(args);
        ScreenService.confirmMessage('Deseja realmente gravar definitivamente o cálculo?', 'CONFIRMATION',
            function() {
                widget.currentRow.TP_PROCESSAMENTO = 'CALCULO_APOLO_GRAVAR_NP';
                widget.currentRow.TP_CALCULO = 14;
                restEngine.post("product#/calculoApolo", {
                    'requestType': 'DataSet',
                    'dataset': [widget.currentRow]
                }).then(function(data) {
                    if (data.messages) {
                        ScreenService.showMessage(data.messages[0].message);
                        ScreenService.closePopup();
                    }
                }).catch(function(e) {
                    var error;
                    if (e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;

                    ScreenService.showMessage('Ocorreu um erro inesperado, contate o administrador informando o trecho abaixo: <br><br>' + error + '<br><br>', 'ERROR');
                });
            }.bind(this));
    };

    this.gravacaoParcialCalculo = function(args) {
        var widget = ABUtilController.checkWidget(args);
        ScreenService.confirmMessage('Deseja realmente gravar parcialmente o cálculo?', 'CONFIRMATION',
            function() {
                widget.currentRow.TP_PROCESSAMENTO = 'PARCIAL';
                widget.currentRow.TP_CALCULO = tipo_calculo;
                restEngine.post("product#/calculo", {
                    'requestType': 'DataSet',
                    'dataset': [widget.currentRow]
                }).then(function(data) {
                    if (widget.currentRow.FORM_RECIBO) {
                        var widgetCalc = templateManager.container.getWidget(widget.currentRow.FORM_RECIBO);
                        widgetCalc.reload();
                        ScreenService.closePopup();
                    }
                    if (data.messages) {
                        ScreenService.successNotification(data.messages[0].message);
                        ScreenService.closePopup();
                    }
                    if (data.dataset && data.dataset.memoriaCalculo && data.dataset.memoriaCalculo.length > 0) {
                        data.dataset.memoriaCalculo.forEach(function(nmArquivo){
                           ABUtilController.downloadArquivo(nmArquivo.ARQUIVOMEMORIA);
                        });
                    }
                    if (data.dataset && data.dataset.msgCalculo && data.dataset.msgCalculo.length > 0) {
                        var popUp = templateManager.container.getWidget("mensagens");
                        popUp.dataSource.data = data.dataset.msgCalculo;
                        ABUtilController.masterDetailOpenPopup(popUp);
                    }
                }).catch(function(e) {
                    var error;
                    if (e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;

                    ScreenService.showMessage('Ocorreu um erro inesperado, contate o administrador informando o trecho abaixo: <br><br>' + error + '<br><br>', 'ERROR');
                });
            }.bind(this));
    };
    
    this.recalculoPatronal = function(args) {
        var widget = ABUtilController.checkWidget(args);
        ScreenService.confirmMessage('Deseja realmente recalcular os eventos patronais?', 'CONFIRMATION',
            function() {
                widget.currentRow.TP_PROCESSAMENTO = 'RECALCPATRONAL';
                widget.currentRow.TP_CALCULO = tipo_calculo;
                restEngine.post("product#/calculo", {
                    'requestType': 'DataSet',
                    'dataset': [widget.currentRow]
                }).then(function(data) {
                    if (widget.currentRow.FORM_RECIBO) {
                        var widgetCalc = templateManager.container.getWidget(widget.currentRow.FORM_RECIBO);
                        widgetCalc.reload();
                        ScreenService.closePopup();
                    }
                    if (data.messages) {
                        ScreenService.successNotification(data.messages[0].message);
                        ScreenService.closePopup();
                    }
                    if (data.dataset && data.dataset.memoriaCalculo && data.dataset.memoriaCalculo.length > 0) {
                        data.dataset.memoriaCalculo.forEach(function(nmArquivo){
                           ABUtilController.downloadArquivo(nmArquivo.ARQUIVOMEMORIA);
                        });
                    }
                    if (data.dataset && data.dataset.msgCalculo && data.dataset.msgCalculo.length > 0) {
                        var popUp = templateManager.container.getWidget("mensagens");
                        popUp.dataSource.data = data.dataset.msgCalculo;
                        ABUtilController.masterDetailOpenPopup(popUp);
                    }
                }).catch(function(e) {
                    var error;
                    if (e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;

                    ScreenService.showMessage('Ocorreu um erro inesperado, contate o administrador informando o trecho abaixo: <br><br>' + error + '<br><br>', 'ERROR');
                });
            }.bind(this));
    };
    
    this.retrocesso = function(args) {
        var widget = ABUtilController.checkWidget(args);
        var self = this;
        ScreenService.confirmMessage('Deseja realmente retroceder o cálculo?', 'CONFIRMATION', function() {
            self.retrocessoCalculo(widget, false);
        });
    };
    
    this.retrocessoCalculo = function(widget, confirmacao) {
        var self = this;
        widget.currentRow.TP_PROCESSAMENTO = 'RETROCESSO';
        widget.currentRow.TP_CALCULO = tipo_calculo;
        widget.currentRow.RETROCESSO_CONFIRMADO = confirmacao;
        restEngine.post("product#/calculo", {
            'requestType': 'DataSet',
            'dataset': [widget.currentRow]
        }).then(function(data) {
            if (widget.currentRow.FORM_RECIBO) {
                var widgetCalc = templateManager.container.getWidget(widget.currentRow.FORM_RECIBO);
                widgetCalc.reload();
                ScreenService.closePopup();
            }
            if (data.messages) {
                if (data.messages[0].type == 'W') {
                    ScreenService.confirmMessage(data.messages[0].message, 'CONFIRMATION', function() {
                        self.retrocessoCalculo(widget, true);
                    });
                } else {
                    ScreenService.successNotification(data.messages[0].message);
                }
                ScreenService.closePopup();
            }
            if (data.dataset && data.dataset.msgCalculo && data.dataset.msgCalculo.length > 0) {
                var popUp = templateManager.container.getWidget("mensagens");
                popUp.dataSource.data = data.dataset.msgCalculo;
                ABUtilController.masterDetailOpenPopup(popUp);
            }
        }).catch(function(e) {
            var error;
            if (e.data.error === undefined)
                error = e;
            else
                error = e.data.error;

            ScreenService.showMessage('Ocorreu um erro inesperado, contate o administrador informando o trecho abaixo: <br><br>' + error + '<br><br>', 'ERROR');
        });
            
    };

    this.simularCalculo = function(args) {
        var widget = ABUtilController.checkWidget(args);
        ScreenService.confirmMessage('Deseja realmente simular o cálculo?', 'CONFIRMATION',
            function() {
                widget.currentRow.TP_PROCESSAMENTO = 'SIMULACAO';
                widget.currentRow.TP_CALCULO = tipo_calculo;
                restEngine.post("product#/calculo", {
                        'requestType': 'DataSet',
                        'dataset': [widget.currentRow]
                    },
                    function(data) {
                        if (widget.currentRow.FORM_RECIBO) {
                            var widgetCalc = templateManager.container.getWidget(widget.currentRow.FORM_RECIBO);
                            widgetCalc.reload();
                            ScreenService.closePopup();
                        }
                        if (data.messages) {
                            ScreenService.successNotification(data.messages[0].message);
                            ScreenService.closePopup();
                        }
                        if (data.dataset && data.dataset.simulacao) {
                            var widgetSimu = this.preparaDemonstrativo(data.dataset.simulacao);
                            ABUtilController.masterDetailOpenPopup(widgetSimu);
                        }
                        if (data.dataset && data.dataset.memoriaCalculo && data.dataset.memoriaCalculo.length > 0) {
                            data.dataset.memoriaCalculo.forEach(function(nmArquivo){
                               ABUtilController.downloadArquivo(nmArquivo.ARQUIVOMEMORIA);
                            });
                        }
                        if (data.dataset && data.dataset.msgCalculo && data.dataset.msgCalculo.length > 0) {
                            var popUp = templateManager.container.getWidget("mensagens");
                            popUp.dataSource.data = data.dataset.msgCalculo;
                            ABUtilController.masterDetailOpenPopup(popUp);
                        }
                        if (data.error) {
                            ScreenService.showMessage(data.error, 'ERROR');
                        }
                    }.bind(this), undefined,
                    function(e) {
                        var error;
                        if (e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;

                        ScreenService.showMessage('Ocorreu um erro inesperado, contate o administrador informando o trecho abaixo: <br><br>' + error + '<br><br>', 'ERROR');
                    }
                );
            }.bind(this));
    };

    this.preparaDemonstrativo = function(vinculos) {

        var widgetSimulacao = templateManager.container.getWidget("simulacao");
        widgetSimulacao.dataSource.data = [];
        vinculos.forEach(function(nrcalculofolha) {
            nrcalculofolha.SIMULACAO.forEach(function(itensCalcFolha) {
                widgetSimulacao.dataSource.data = widgetSimulacao.dataSource.data.concat(itensCalcFolha);
            });
        });
        return widgetSimulacao;
    };

    this.fechamento = function(args) {
        var widget = ABUtilController.checkWidget(args);
        ScreenService.confirmMessage('Deseja realmente realizar o fechamento ?', 'CONFIRMATION',
            function() {
                widget.currentRow.TP_PROCESSAMENTO = 'CALCULO';
                widget.currentRow.TP_CALCULO = tipo_calculo;
                restEngine.post("product#/calculo", {
                    'requestType': 'DataSet',
                    'dataset': [widget.currentRow]
                }).then(function(data) {
                    if (data.messages) {
                        ScreenService.successNotification(data.messages[0].message);
                        ScreenService.closePopup();
                    }
                    if (data.dataset && data.dataset && data.dataset.msgCalculo && data.dataset.msgCalculo.length > 0) {
                        var popUp = templateManager.container.getWidget("mensagens");
                        popUp.dataSource.data = data.dataset.msgCalculo;
                        ABUtilController.masterDetailOpenPopup(popUp);
                    }
                }).catch(function(e) {
                    var error;
                    if (e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;

                    ScreenService.showMessage('Ocorreu um erro inesperado, contate o administrador informando o trecho abaixo: <br><br>' + error + '<br><br>', 'ERROR');
                });
            }.bind(this));
    };

    this.salvarCalculo = function(args) {
        var widget = ABUtilController.checkWidget(args);
        var validaFiltro = this.validaFiltroListas();

        if (widget.isValid()) {
            if (ABUtilController.validaCritSelecao(widget.currentRow)) {
                widget.currentRow.CDOPERADOR_LOG = getLocalVar("HCM_CDOPERADOR");
                widget.currentRow.NRORGTRAB = getLocalVar("HCM_NRORG_TRAB");
                widget.currentRow.NRORGPADRAO = getLocalVar("HCM_NRORG_PADRAO");
                widget.currentRow.DTATUAL = getLocalVar("HCM_DATA_ATUAL");
                widget.dataSourceFilter.forEach(function(filter) {
                    if (filter.name == 'P_IDTPFORMCALCULO') {
                        widget.currentRow.IDTPFORMCALCULO = filter.value;
                    }
                });
                if(validaFiltro == true){
                    return;
                }
                if (!widget.backupRow) {
                    widget.currentRow.__is_new = true;
                } else {
                    widget.currentRow.__is_new = false;
                }

                return widget.saveRow().then(function() {
                    if (widget.currentRow.__is_new) {
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    } else {
                        ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                        widget.backupRow = null;
                        widget.view();
                    }
                }).catch(function(e) {
                    var error;
                    if (e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;

                    ScreenService.showMessage('Ocorreu um erro inesperado, contate o administrador informando o trecho abaixo: <br><br>' + error + '<br><br>', 'ERROR');
                });
            }
        }
    };

}

Configuration(function(ContextRegister) {
    ContextRegister.register('CalculoFolhaController', CalculoFolhaController);
});


// FILE: assets/js/controllers/CalculoRegraController.js
function CalculoRegraController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, General,Messages) {

    this.adicionarRow = function(args) {
        var widget = args.owner.widget;
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
    };

	this.setCalcRegra = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
                if (!widget.backupRow) {
                    widget.currentRow.__is_new = true;
                } else {
                    widget.currentRow.__is_new = false;
                }
                restEngine.post('product#/setCalcRegra', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                    then(function (data) {
                        if (data.notifications[0].type === "success") {
                            ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                            if (widget.currentRow.__is_new) {
                                ABUtilController.masterDetailVoltarList(widget);
                                widget.reload();
                            } else {
                                ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                                widget.backupRow = null;
                                widget.view();
                            }
                        } else {
                            ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                        }
                    }).
                    catch(function(e) {
                        var error;
                        if(e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;
                            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    });
            }
    };
    
    this.deleteCalcRegra = function(args) {
    ScreenService.confirmMessage(Messages.DELETE_ROW, 'CONFIRMATION', function () {
        var widget = args.owner.widget;
        widget.currentRow.__is_new = false;
        restEngine.post('product#/deleteCalcRegra', {'requestType':'DataSet','dataset':[widget.currentRow]}).
            then(function(data){
                if(data.notifications[0].type === "success"){
                    ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                    ABUtilController.masterDetailVoltarList(widget);
                    widget.reload();
                } else {
                    ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                }
            }).
            catch(function(e) {
                var error;
                if(e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
        });
    };
    
    this.preencheNome = function(args) {
        var widget = templateManager.container.getActiveWidget();
        var regra = widget.getField('NMREGRAH').value();
        if(widget.currentRow.NMTPCALCREGRA === ""){
            widget.getField('NMTPCALCREGRA').setValue(regra);

        }
        widget.reload();
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('CalculoRegraController', CalculoRegraController);
});

// FILE: assets/js/controllers/CalculoValeTransporteController.js
function CalculoValeTransporteController(ScreenService, templateManager, restEngine, ABUtilController, Messages, CalculoValeTransporteService) {

    this.ORDEM_CAMPOS = [
        'NMINIVINCULOM', 'NMFIMVINCULOM',
        'NMESTRUTLEGAL', 'NMESTRUTGEREN',
        'DTINIADMISSAO', 'DTFIMADMISSAO',
        'CDINIMATRICULA', 'CDFIMMATRICULA',
        'LIST_NRESTRUTLEGAL', 'LIST_NRESTRUTGEREN',	 
        'LIST_NRESTRUTLEGAL', 'LIST_NRESTRUTGEREN',	 
        'NRVINCULOM_LIST'
    ];

    this.ALFABETICA_CAMPOS = ['NMINIVINCULOM', 'NMFIMVINCULOM'];
    this.ESTRUTURA_CAMPOS = ['NMESTRUTLEGAL', 'NMESTRUTGEREN'];
    this.DATA_ADMISSAO_CAMPOS = ['DTINIADMISSAO', 'DTFIMADMISSAO'];
    this.LISTA_ESTRUTURA_CAMPOS = ['LIST_NRESTRUTLEGAL', 'LIST_NRESTRUTGEREN'];	 
    this.LISTA_ESTRUTRA_SIND = ['NMESTRUTLEGAL', 'LIST_NRESTRUTSIND'];	 
    this.LISTA_VINCULO_CAMPOS = ['NRVINCULOM_LIST'];
    this.MATRICULA_CAMPOS = ['CDINIMATRICULA', 'CDFIMMATRICULA'];

    this.CALCULAR = 'calcular';
    this.RETROCEDER = 'retroceder';

    this.habilitaCamposOrdem = function(widget, arrayCampos) {
        this.ALFABETICA_CAMPOS.concat(this.ESTRUTURA_CAMPOS,this.LISTA_ESTRUTURA_CAMPOS,this.LISTA_ESTRUTRA_SIND,this.LISTA_VINCULO_CAMPOS,this.DATA_ADMISSAO_CAMPOS,this.MATRICULA_CAMPOS).forEach(function(campo) {
            //this.ORDEM_CAMPOS.forEach(function(campo) {
            if(arrayCampos.indexOf(campo) >= 0) {
                widget.getField(campo).isVisible = true;
                if(campo == 'LIST_NRESTRUTGEREN')	 
                    widget.getField(campo).validations = {};	 
                else 	 
                    widget.getField(campo).validations = {"required": true};
            } else {
                widget.getField(campo).isVisible = false;
                widget.getField(campo).validations = {};
            }
        });
    };

	this.salvar = function(args) {
        var widget = templateManager.container.getActiveWidget();
        
        if (widget.isValid()) {
            if (ABUtilController.validaDtIniMenorIgualDtFin(widget.currentRow.DTINICIOVALE, widget.currentRow.DTFINALVALE)) {
                
            if (!widget.backupRow) {
                widget.currentRow.__is_new = true;
            } else {
                widget.currentRow.__is_new = false;
            }
            restEngine.post('product#/setFormvales', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                then(function (data) {
                    if (data.notifications[0].type === "success") {
                        ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                        if (widget.currentRow.__is_new) {
                            ABUtilController.masterDetailVoltarList(widget);
                            widget.reload();
                        } else {
                            ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                            widget.backupRow = null;
                            widget.view();
                        }
                    } else {
                        ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                    }
                }).
                catch(function(e) {
                    var error;
                    if(e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;

                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
        
            }else{
                ScreenService.showMessage("A data inicial deve ser anterior a data final");
            }
        }
        
    };

    this.remover = function(args) {
        var widget = templateManager.container.getActiveWidget();
        ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
            widget.currentRow.__is_new = false;
            restEngine.post('product#/deleteFormvales', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                then(function (data) {
                    if (data.notifications[0].type === "success") {
                        ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    } else {
                        ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                    }
                }).
                catch(function(e) {
                    var error;
                    if(e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;

                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
        }, null);
    };

    this.fieldOrdemOnChange = function(widget){
        widget.currentRow.DSINICIOVALE = null;
        widget.currentRow.DSFIMVALE = null;
        widget.currentRow.NMINIVINCULOM = null;
        widget.currentRow.NMFIMVINCULOM = null;
        widget.currentRow.CDINIMATRICULA = null;
        widget.currentRow.CDFIMMATRICULA = null;
        widget.currentRow.DTINIADMISSAO = null;
        widget.currentRow.DTFIMADMISSAO = null;
        widget.currentRow.NMESTRUTLEGAL = null;
        widget.currentRow.NMESTRUTGEREN = null;
        widget.currentRow.LIST_NRESTRUTLEGAL = null;	 
        widget.currentRow.LIST_NRESTRUTGEREN = null;	 
        widget.currentRow.LIST_NRESTRUTLEGAL = null;	 
        widget.currentRow.LIST_NRESTRUTGEREN = null;	 
        widget.currentRow.NRVINCULOM_LIST = null;
    };
    
    this.setVisibilidadeCampos = function(widget) {
        var ordem = widget.currentRow.DSORDEMVALE;
        switch(ordem) {
            case 'ALFABETICA':
                this.habilitaCamposOrdem(widget, this.ALFABETICA_CAMPOS);
                break;
            case 'MATRICULA':
                this.habilitaCamposOrdem(widget, this.MATRICULA_CAMPOS);
                break;
            case 'DATA_ADMISSAO':
                this.habilitaCamposOrdem(widget, this.DATA_ADMISSAO_CAMPOS);
                break;
            case 'ESTRUTURA':
                this.habilitaCamposOrdem(widget, this.ESTRUTURA_CAMPOS);
                widget.getField('NMESTRUTGEREN').validations = {};
                break;
            case 'LISTA_ESTRUTURA':	 
                this.habilitaCamposOrdem(widget, this.LISTA_ESTRUTURA_CAMPOS);	 
                widget.getField('NMESTRUTGEREN').validations = {};	 
                break;	 
            case 'LISTA_NRESTRUTSIND':	 
                this.habilitaCamposOrdem(widget, this.LISTA_ESTRUTRA_SIND);	 
                widget.getField('NMESTRUTGEREN').validations = {};	 
                break;	 
            case 'LISTA_VINCULO':	 
                this.habilitaCamposOrdem(widget, this.LISTA_VINCULO_CAMPOS);	 
                widget.getField('NMESTRUTGEREN').validations = {};	 
                break;
            default :
                this.habilitaCamposOrdem(widget, []);
                break;
        }
    };

    this.setValorCamposBeforeSave = function(widget) {
        var ordem = widget.currentRow.DSORDEMVALE;

        switch(ordem) {
            case 'ALFABETICA':
                //widget.getField('DSINICIOVALE').setValue(widget.currentRow.NRINIVINCULOM);
                //widget.getField('DSFIMVALE').setValue(widget.currentRow.NRFIMVINCULOM);
                break;
            case 'MATRICULA':
                widget.getField('DSINICIOVALE').setValue(widget.currentRow.CDINIMATRICULA);
                widget.getField('DSFIMVALE').setValue(widget.currentRow.CDFIMMATRICULA);
                break;
            case 'DATA_ADMISSAO':
                widget.getField('DSINICIOVALE').setValue(widget.currentRow.DTINIADMISSAO);
                widget.getField('DSFIMVALE').setValue(widget.currentRow.DTFIMADMISSAO);
                break;
            case 'ESTRUTURA':
                //widget.getField('DSINICIOVALE').setValue(widget.currentRow.NRESTRUTLEGAL);
                widget.getField('DSFIMVALE').setValue(widget.currentRow.NMESTRUTGEREN ? widget.currentRow.DSFIMVALE : '');
                break;
        }
    };

    this.setDescricaoSelecionada = function(widget) {
        var ordem = widget.currentRow.DSORDEMVALE;

        switch(ordem) {
            case 'ALFABETICA':
                //widget.getField('NRINIVINCULOM').setValue(widget.currentRow.DSINICIOVALE);
                //widget.getField('NRFIMVINCULOM').setValue(widget.currentRow.DSFIMVALE);
                break;
            case 'MATRICULA':
                widget.getField('CDINIMATRICULA').setValue(widget.currentRow.DSINICIOVALE);
                widget.getField('CDFIMMATRICULA').setValue(widget.currentRow.DSFIMVALE);
                break;
            case 'DATA_ADMISSAO':
                widget.getField('DTINIADMISSAO').setValue(widget.currentRow.DSINICIOVALE);
                widget.getField('DTFIMADMISSAO').setValue(widget.currentRow.DSFIMVALE);
                break;
            case 'ESTRUTURA':
                //widget.getField('NRESTRUTLEGAL').setValue(widget.currentRow.DSINICIOVALE);
                //widget.getField('NRESTRUTGEREN').setValue(widget.currentRow.DSFIMVALE);
                break;
        }
    };
    
    this.reloadFieldsSelectMultiple = function(widget){	 
        if(widget.currentRow.DSORDEMVALE == 'ALFABETICA' && widget.getField('NMINIVINCULOM').dataSource.data.length == 0)widget.getField('NMINIVINCULOM').reload();	 
        if(widget.currentRow.DSORDEMVALE == 'ALFABETICA' && widget.getField('NMFIMVINCULOM').dataSource.data.length == 0)widget.getField('NMFIMVINCULOM').reload();	 
        if(widget.currentRow.DSORDEMVALE == 'ESTRUTURA' && widget.getField('NMESTRUTLEGAL').dataSource.data.length == 0)widget.getField('NMESTRUTLEGAL').reload();	 
        if(widget.currentRow.DSORDEMVALE == 'ESTRUTURA' && widget.getField('NMESTRUTGEREN').dataSource.data.length == 0)widget.getField('NMESTRUTGEREN').reload();	 
        if(widget.currentRow.DSORDEMVALE == 'LISTA_ESTRUTURA' && widget.getField('NMESTRUTLEGAL').dataSource.data.length == 0)widget.getField('NMESTRUTLEGAL').reload();	 
        if(widget.currentRow.DSORDEMVALE == 'LISTA_ESTRUTURA' && widget.getField('LIST_NRESTRUTGEREN').dataSource.data.length == 0)widget.getField('LIST_NRESTRUTGEREN').reload();	 
        if(widget.currentRow.DSORDEMVALE == 'LISTA_NRESTRUTSIND' && widget.getField('LIST_NRESTRUTSIND').dataSource.data.length == 0)widget.getField('LIST_NRESTRUTSIND').reload();	 
        if(widget.currentRow.DSORDEMVALE == 'LISTA_NRESTRUTSIND' && widget.getField('LIST_NRESTRUTSIND').dataSource.data.length == 0)widget.getField('LIST_NRESTRUTSIND').reload();	 
        if(widget.currentRow.DSORDEMVALE == 'LISTA_VINCULO' && widget.getField('NRVINCULOM_LIST').dataSource.data.length == 0)widget.getField('NRVINCULOM_LIST').reload();	 
    };
    
    this.processarValeTransporte = function(widget, action) {
        if (action === this.CALCULAR) {

            var dtmescompetencia = getLocalVar('HCM_DTCOMPETENCIA');
            var dtiniperiodo = widget.currentRow.DTINICIOVALE;

            if (dtmescompetencia.substr(3, 7) === dtiniperiodo.substr(3, 7)) {
                CalculoValeTransporteService.calcular(widget, ABUtilController);
            } else {
                ScreenService.showMessage(Messages.HCM02000_VAB_PER_CALC_COMP_ERROR, 'ERROR');
            }
        }

        if (action === this.RETROCEDER) {
            CalculoValeTransporteService.retroceder(widget);
        }
    };

}

Configuration(function(ContextRegister) {
    ContextRegister.register('CalculoValeTransporteController', CalculoValeTransporteController);
});

// FILE: assets/js/controllers/CalendarioController.js
function CalendarioController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, General,Messages) {
    
    var self = this;
    
    this.openPopup = function(popupName) {
        var widgetPopup = templateManager.container.getWidget(popupName);
        ScreenService.openPopup(widgetPopup);
    };
    
    this.closePopup = function(widgetName) {
        ScreenService.closePopup();
        templateManager.container.getWidget(widgetName).activate();
    };
    
    this.adicionarRow = function(args) {
        var widget = args.owner.widget;
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
    };
    
    this.filtrarWidgetPorCalendario = function(args){
        var widget = args.owner;
        templateManager.container.getWidget("feriado").dataSourceFilter[0].value = widget.currentRow.NRCALENDARIO;
    };
    
    this.widgetsvisiblefalse = function(args) {
        var widget = args.owner.widget;
        widget.widgets[0].showAsTab = false;
    };

    this.widgetsvisibletrue = function(args) {
        var widget = args.owner.widget;
        widget.widgets[0].showAsTab = true;
    };
    
	this.setCalendario = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
            if (ABUtilController.validaDtIniMenorIgualDtFin(widget.currentRow.DTINIVIGENCIA, widget.currentRow.DTFIMVIGENCIA)) {
                if (!widget.backupRow) {
                    widget.currentRow.__is_new = true;
                } else {
                    widget.currentRow.__is_new = false;
                }
                restEngine.post('product#/setCalendario', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                    then(function (data) {
                        if (data.notifications[0].type === "success") {
                            ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                            if (widget.currentRow.__is_new) {
                                ABUtilController.masterDetailVoltarList(widget);
                                self.widgetsvisibletrue(args);
                                widget.reload();
                            } else {
                                ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                                widget.backupRow = null;
                                widget.view();
                            }
                        } else {
                            ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                        }
                    }).
                    catch(function(e) {
                        var error;
                        if(e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;
                            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    });
            }else{
                ScreenService.showMessage(Messages.DTINI_POST_DTFIM_ERROR);
                return false;
            }        
        }
    };
    
    this.deleteCalendario = function(args) {
        ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
        var widget = templateManager.container.getActiveWidget();
        if (widget.isValid()) {
            widget.currentRow.__is_new = false;
            restEngine.post('product#/deleteCalendario', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                then(function (data) {
                    if (data.messages) {
                        ScreenService.showMessage(Messages.REMOVE_ROW_ERROR + '. ' + data.messages[0].message, data.messages[0].type);
                    } else {
                        ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    }
                }).
                catch(function(e) {
                    var error;
                    if(e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;

                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
        }
      }, null);
    };
    
	this.setFeriado = function(args) {
        var widget = args.owner.widget;
        var widgetMain = templateManager.container.getWidget("calendario");
        if (widget.isValid()) {
                if (!widget.backupRow) {
                    widget.currentRow.__is_new = true;
                } else {
                    widget.currentRow.__is_new = false;
                }
                widget.currentRow.NRCALENDARIO = widgetMain.currentRow.NRCALENDARIO;
                restEngine.post('product#/setFeriado', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                    then(function (data) {
                        if(data.messages){
                            ScreenService.showMessage(data.messages[0].message);
                        }else{
                            if (data.notifications[0].type === "success") {
                                ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                                if (widget.currentRow.__is_new) {
                                    ABUtilController.masterDetailVoltarList(widget);
                                    widget.reload();
                                } else {
                                    ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                                    widget.backupRow = null;
                                    widget.view();
                                }
                            } else {
                                ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                            }
                        }    
                    }).
                    catch(function(e) {
                        var error;
                        if(e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;
                            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    });
        }
    };
    
    this.deleteFeriado = function(args) {
        ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
            var widget = args.owner.widget;
            widget.currentRow.__is_new = false;
            restEngine.post('product#/deleteFeriado', {'requestType':'DataSet','dataset':[widget.currentRow]}).
                then(function(data){
                    if(data.notifications[0].type === "success"){
                        ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    } else {
                        ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                    }
                }).
                catch(function(e) {
                    var error;
                    if(e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;
                        ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error));
                });
        }, null);
    };
    
    /*Operações de sincronização e replicação do calendário*/
    
    this.syncCalendarioFeriado = function(args){
        restEngine.post('product#/syncCalendarioFeriado', {
            'requestType': 'DataSet',
            'dataset': [args.owner.widget.currentRow]
            }).then(function(data) {
                if(data.messages){
                    ScreenService.showMessage(data.messages[0].message, '');
                }
            }).catch(function(e) {
                var error;
                if (e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
    };
    
    this.replicaCalendario = function(){
        var widgetMain = templateManager.container.getWidget("calendario");
        var widgtPopup = templateManager.container.getActiveWidget();
        
        widgtPopup.currentRow.NRORG        = widgetMain.currentRow.NRORG;
        widgtPopup.currentRow.NRCALENDARIO = widgetMain.currentRow.NRCALENDARIO;
        widgtPopup.currentRow.DSCALENDARIO = widgetMain.currentRow.DSCALENDARIO;
        
        restEngine.post('product#/replicaCalendario', {
            'requestType': 'DataSet',
            'dataset': [widgtPopup.currentRow]
            }).then(function(data) {
                if(data.messages){
                    ScreenService.showMessage(data.messages[0].message);
                }
            }).catch(function(e) {
                var error;
                if (e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
        });
        
    };
    
    this.openReplicaCalendario = function(popupName) {
        var widgetPopup = templateManager.container.getWidget(popupName);
        var anoAtual = getLocalVar('HCM_DTCOMPETENCIA');
        
        anoAtual = parseInt(anoAtual.substr(6, 4), 10);
        
        widgetPopup.getField('anoAtual'   ).value(anoAtual    );
        widgetPopup.getField('anoAnterior').value(anoAtual - 1);
        
        ScreenService.openPopup(widgetPopup);
    };

}

Configuration(function(ContextRegister) {
    ContextRegister.register('CalendarioController', CalendarioController);
});

// FILE: assets/js/controllers/CanalComunicaController.js
function CanalComunicaController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, General,Messages) {

    this.adicionarRow = function(args) {
        var widget = args.owner.widget;
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
    };
    
	this.setCanalComunica = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
                if (!widget.backupRow) {
                    widget.currentRow.__is_new = true;
                } else {
                    widget.currentRow.__is_new = false;
                }
                restEngine.post('product#/setCanalComunica', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                    then(function (data) {
                        if (data.notifications[0].type === "success") {
                            ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                            if (widget.currentRow.__is_new) {
                                ABUtilController.masterDetailVoltarList(widget);
                                widget.reload();
                            } else {
                                ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                                widget.backupRow = null;
                                widget.view();
                            }
                        } else {
                            ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                        }
                    }).
                    catch(function(e) {
                        var error;
                        if(e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;
                            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    });
            }
    };
    
    this.deleteCanalComunica = function(args) {
    ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
        var widget = args.owner.widget;
        widget.currentRow.__is_new = false;
        restEngine.post('product#/deleteCanalComunica', {'requestType':'DataSet','dataset':[widget.currentRow]}).
            then(function(data){
                if(data.notifications[0].type === "success"){
                    ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                    ABUtilController.masterDetailVoltarList(widget);
                    widget.reload();
                } else {
                    ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                }
            }).
            catch(function(e) {
                var error;
                if(e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
        },null);
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('CanalComunicaController', CanalComunicaController);
});

// FILE: assets/js/controllers/CandidatosController.js
/**
 * Created by leonardocarvalho on 02/03/2016.
 */
function CandidatosController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, $window, ABUtilController, Messages, HcmConsts) {

    var templateWidget;
    var telaRetorno;

    this.abrirArquivo = function(argsRow) {
        var path = ABUtilController.getBaseUrlFileServer() + argsRow.DSPATH;
        $window.open($window.serviceUrl + "/abrirArquivo?requestType=DataSet&dataset[0][CMARQUIVO]=" + path);
    };

    this.admitirCandidato = function() {
        ScreenService.confirmMessage('Deseja realmente admitir o candidato ?', 'CONFIRMATION',
            function() {
                this.verificaVinculo();
            }.bind(this)
        );
    };

    this.newUploadDocument = function(widget) {
        widget.parentWidget = widget.parent.parent;
        ScreenService.openSwipe(widget);
        widget.currentRow = {};
        widget.isVisible = true;
        widget.newRow();

    };

    this.verificaSalario = function(args) {
        var widget = args.row;
        if (widget.VRPRETENSAOSALARIO === "0") {
            ScreenService.showMessage("Valor inválido para a pretensão salarial");
            widget.VRPRETENSAOSALARIO = '';
        }
    };

    this.onChangeTpRelac = function(args) {
        var widget = ABUtilController.checkWidget(args);
        var currentRow = widget.currentRow;
        if (currentRow.NRTIPORELACIONA === 1) {
            currentRow.IDSEXOPESSOA = 'F';
        } else if (currentRow.NRTIPORELACIONA === 2) {
            currentRow.IDSEXOPESSOA = 'M';
        }
    };

    this.onEnterWidgetFoto = function(args) {
        var widget = ABUtilController.checkWidget(args);
        widget.currentRow = widget.dataSource.data[0];
    };

    this.backFormPessoais = function() {
        var widget = templateManager.container.getActiveWidget();
        widget.template = templateWidget;
        templateManager.updateTemplate();
        ABUtilController.masterDetailCancelaEdicao(widget);
    };

    this.setFieldReferencia = function(widgetDocumentos) {
        var dsreferencia = widgetDocumentos.currentRow.NMANEXO.split('_');
        widgetDocumentos.currentRow.DSREFERENCIA = dsreferencia[0];

        templateManager.container.getWidget('novoArquivo').isVisible = false;
    };

    this.closePopupMensagens = function(args) {
        var widgetMensagens = args.owner.widget;
        widgetMensagens.currentRow = {};
        ABUtilController.masterDetailClosePopup(widgetMensagens);
    };

    this.openPopupMensagem = function(args) {
        var widget = templateManager.container.getWidget('mensagens');
        widget.isVisible = true;
        ABUtilController.masterDetailOpenPopup(widget);
    };

    this.onEnter = function() {
        var widgetMensagens = templateManager.container.getWidget("mensagens");
        widgetMensagens.getField("DSMENSAGEM").placeholder = "Mnemônicos aceitos:" +
            '\n\n' +
            "[NOME_CANDIDATO] = Nome do candidado";
    };

    this.editComentarios = function(args) {
        var widget = ABUtilController.checkWidget(args);
        if (widget.currentRow.NRPROCESSO && widget.currentRow.NRTEMPLATE) {
            this.setNrTemplate(args);
            this.setIdTipoComentario(args);
        } else {
            widget.getField("NMFASE").readOnly = true;
        }
        ABUtilController.masterDetailEdit(args.owner.widget);
    };
    
        this.setIdTipoComentario = function(args){
            var widget = ABUtilController.checkWidget(args);

            if(!Util.isEmptyOrBlank(widget.backupRow)){
                if(widget.backupRow.IDTIPOCOMENTARIO == 'LAUDO'){
                    widget.currentRow.DELETEPARECERFINAL = true;
                } else {
                    widget.currentRow.DELETEPARECERFINAL = false;
                }
            }

            if(widget.currentRow.NRORDEM == widget.currentRow.MAXNRORDEM && !Util.isEmptyOrBlank(widget.currentRow.NRORDEM)){
                if (widget.currentRow.IDTIPOCOMENTARIO == 'LAUDO'){
                    widget.getField("IDPARECERFINAL").isVisible = true;
                    widget.getField("DSENTPSICOLOGICA").isVisible = true;
                    widget.getField("IDTIPOCOMENTARIO").readOnly = false;
                    widget.getField("DSRESULTESTES").isVisible = true;
                    widget.getField("DSRESULTESTES").validations = {"required": {}};
                    widget.getField("DSENTPSICOLOGICA").validations = {"required": {}};
                } else {
                    if(widget.dataSource.data[0]){
                        if(Util.toBoolean(widget.dataSource.data[0].EXISTSLAUDO)){
                            widget.getField("IDTIPOCOMENTARIO").readOnly = true;
                        } else {
                            widget.getField("IDTIPOCOMENTARIO").readOnly = false;
                        }
                    } else {
                        widget.getField("IDTIPOCOMENTARIO").readOnly = true;
                    }

                    widget.getField("IDPARECERFINAL").isVisible = false;
                    widget.getField("DSENTPSICOLOGICA").isVisible = false;
                    widget.getField("DSRESULTESTES").isVisible = false;
                    widget.getField("DSRESULTESTES").validations = {};
                    widget.getField("DSENTPSICOLOGICA").validations = {};
                }
            } else {
                widget.getField("IDTIPOCOMENTARIO").readOnly = true;
                widget.currentRow.IDTIPOCOMENTARIO = 'COMENTARIO';
                widget.getField("IDPARECERFINAL").isVisible = false;
                widget.getField("DSENTPSICOLOGICA").isVisible = false;
                widget.getField("DSRESULTESTES").isVisible = false;
                widget.getField("DSRESULTESTES").validations = {};
                widget.getField("DSENTPSICOLOGICA").validations = {};
            }
        };

        this.moveRowComentarios = function(args){
            var widget = ABUtilController.checkWidget(args);
            if (widget.currentRow.IDTIPOCOMENTARIO == 'LAUDO'){
                widget.getField("IDPARECERFINAL").isVisible = true;
                widget.getField("DSENTPSICOLOGICA").isVisible = true;
                widget.getField("DSRESULTESTES").isVisible = true;
                widget.getField("IDTIPOCOMENTARIO").readOnly = false;
                widget.getField("DSRESULTESTES").validations = {"required": {}};
                widget.getField("DSENTPSICOLOGICA").validations = {"required": {}};

            } else {
                widget.getField("IDPARECERFINAL").isVisible = false;
                widget.getField("DSENTPSICOLOGICA").isVisible = false;
                widget.getField("DSRESULTESTES").isVisible = false;
                widget.getField("IDTIPOCOMENTARIO").readOnly = true;
                widget.getField("DSRESULTESTES").validations = {};
                widget.getField("DSENTPSICOLOGICA").validations = {};
            }
        };

        this.changeProcessos = function(args){
            var widget = ABUtilController.checkWidget(args);
            widget.currentRow.NMFASE = null;
            widget.currentRow.NRFASE = null;
            this.setIdTipoComentario(args);
        };

    this.enviarMensagem = function(args) {
        var widgetMensagens = args.owner.widget;
        var widgetCandidatos = templateManager.container.getWidget("candidatos");
        if (widgetMensagens.isValid()) {
            save = Object.assign({}, {
                "CANDIDATO": widgetCandidatos.dataSource.checkedRows
            }, {
                "MENSAGEM": widgetMensagens.currentRow
            });
            restEngine.post("product#/enviarMensagem", {
                'requestType': 'DataSet',
                'dataset': [save]
            }).then(
                function(data) {
                    if (data.dataset.enviarMensagem[0] === undefined) {
                        ScreenService.showMessage('Erro ao enviar a mensagem');
                        ABUtilController.masterDetailClosePopup(widgetMensagens);
                    } else {
                        ScreenService.showMessage('Mensagem enviada com sucesso');
                        ABUtilController.masterDetailClosePopup(widgetMensagens);
                        widgetCandidatos.unSelectAll();
                    }
                    widgetMensagens.currentRow = {};
                }
            ).catch(function(e) {
                var error;
                if (Util.isUndefined(e.data))
                    error = e;
                else
                    error = e.data.error;

                ScreenService.showMessage('Ocorreu um erro inesperado, contate o administrador informando o trecho abaixo: <br><br>' + error + '<br><br>', 'ERROR');
            });
        }
    };

    this.setCampoTitulo = function(args) {
        var currentRow = args.row;
        currentRow.DSTITULOMENSAGEM = currentRow.DSASSUNTOMENSAGEM;
    };

    this.cancelarAdmissao = function() {
        var widget = templateManager.container.getWidget('dadosPessoaisCandidato');
        var widget1 = templateManager.container.getWidget('dadosComplementaresCandidato');
        var widget2 = templateManager.container.getWidget('formacaoCandidato');
        var widget3 = templateManager.container.getWidget('contaBancariaCandidato');
        var widget4 = templateManager.container.getWidget('cadastroDependentesCandidato');
        var widget5 = templateManager.container.getWidget('parametros');
        var widget6 = templateManager.container.getWidget('movimentacaoCandidato');

        ScreenService.showCustomDialog('Deseja realmente cancelar a admissão do candidato ?', 'CONFIRMATION', null, [{
            label: ScreenService.i18n("Sim"),
            code: function(e, deferred) {
                widget2.dataSource.data = Array();
                widget4.dataSource.data = Array();
                widget5.getField('DSTURNO').readOnly = true;
                templateManager.containers['product#hcm04002_btl_processo_admissao'].widgets[0].widgets[0].currentRow = [];
                templateManager.containers['product#hcm04002_btl_processo_admissao'].widgets[0].widgets[1].currentRow = [];
                templateManager.containers['product#hcm04002_btl_processo_admissao'].widgets[0].widgets[3].currentRow = [];
                templateManager.containers['product#hcm04002_btl_processo_admissao'].widgets[0].widgets[5].currentRow = [];
                templateManager.containers['product#hcm04002_btl_processo_admissao'].widgets[0].widgets[6].currentRow = [];
                widget.onEnterOnceCalled = false;
                widget1.onEnterOnceCalled = false;
                widget2.onEnterOnceCalled = false;
                widget3.onEnterOnceCalled = false;
                widget4.onEnterOnceCalled = false;
                widget5.onEnterOnceCalled = false;
                widget6.onEnterOnceCalled = false;
                //ScreenService.openWindow('product#' + this.telaRetorno);
                ScreenService.goBack();
                deferred.resolve(e);
            }.bind(this)
        }, {
            label: ScreenService.i18n("Não"),
            code: function(e, deferred) {
                deferred.reject(e);
            }
        }]);
    };

    this.confirmarSaveAdmissao = function(argsRow, args) {
        ScreenService.confirmMessage('Deseja realmente finalizar a admissão?', 'CONFIRMATION',
            function() {
                this.salvarDadosPessoaisAdmissao(argsRow, args);
            }.bind(this)
        );
    };

    this.editFormPessoais = function() {
        var widget = templateManager.container.getActiveWidget();
        templateWidget = widget.template;
        widget.template = widget.templateToForm;
        templateManager.updateTemplate();
        ABUtilController.masterDetailEdit();
    };

    this.filtrarAgencia = function() {
        var widget = templateManager.container.getActiveWidget();
        var agenciaDataSourceFilter = widget.getField('CDAGENCIA').dataSourceFilter;
        if (Util.isEmptyOrBlank(widget.currentRow.CDBANCO)) {
            agenciaDataSourceFilter.forEach(function(filtro) {
                if (filtro.name === 'CDBANCO') {
                    filtro.value = '';
                }
            });
            widget.getField('CDAGENCIA').readOnly = true;
        } else {
            agenciaDataSourceFilter.forEach(function(filtro) {
                if (filtro.name === 'CDBANCO') {
                    filtro.value = widget.currentRow.CDBANCO;
                }
            });
            widget.getField('CDAGENCIA').readOnly = false;
        }

    };

    this.filtrarCidade = function() {
        var widget = templateManager.container.getActiveWidget();
        var cidadeDataSourceFilter = widget.getField('NMMUNICIPIO').dataSourceFilter;
        if (Util.isEmptyOrBlank(widget.currentRow.SGESTADO)) {
            cidadeDataSourceFilter.forEach(function(filtro) {
                if (filtro.name === 'SGESTADO') {
                    filtro.value = '';
                }
            });
            widget.getField('NMMUNICIPIO').readOnly = true;
            widget.currentRow.CDMUNICIPIO = null;
            widget.currentRow.NMMUNICIPIO = '';
        } else {
            cidadeDataSourceFilter.forEach(function(filtro) {
                if (filtro.name === 'SGESTADO') {
                    filtro.value = widget.currentRow.SGESTADO;
                }
            });
            widget.getField('NMMUNICIPIO').readOnly = false;
        }
    };

    this.filtrarEstado = function() {
        var widget = templateManager.container.getActiveWidget();
        var estadoDataSourceFilter = widget.getField('SGESTADO').dataSourceFilter;
        if (Util.isEmptyOrBlank(widget.currentRow.CDPAIS)) {
            estadoDataSourceFilter.forEach(function(filtro) {
                if (filtro.name === 'CDPAIS') {
                    filtro.value = '';
                }
            });
            widget.getField('SGESTADO').readOnly = true;
            widget.currentRow.SGESTADO = null;
            widget.currentRow.NMESTADO = '';
        } else {
            estadoDataSourceFilter.forEach(function(filtro) {
                if (filtro.name === 'CDPAIS') {
                    filtro.value = widget.currentRow.CDPAIS;
                }
            });
            widget.getField('SGESTADO').readOnly = false;
            widget.currentRow.SGESTADO = null;
            widget.currentRow.NMESTADO = '';
        }
        this.filtrarCidade();
    };

    this.filtrarDocumentos = function() {
        var dados = [];
        var widgetDocumentos = templateManager.container.getWidget("anexarArquivo");
        var widgetCandidatos = templateManager.container.getWidget("candidatos");
        for (var i = 0; i < widgetDocumentos.dataSource.data.length; i++) {
            var array = widgetDocumentos.dataSource.data[i].NMANEXO.split("_");
            array = array[array.length - 1].split(".");
            for (var y = 0; y < array.length; y++) {
                if (array[y] === widgetCandidatos.currentRow.NRPESSOA.toString()) {
                    dados[dados.length] = widgetDocumentos.dataSource.data[i];
                }
            }
        }
        if (dados !== null) {
            widgetDocumentos.dataSource.data = dados;
        } else {
            widgetDocumentos.dataSource.data = [];
        }
    };

    this.filtrarFoto = function(args) {
        var dados = [];
        var widgetFoto = templateManager.container.getWidget("anexarfoto");
        var widgetCandidatos = templateManager.container.getWidget("candidatos");
        for (var i = 0; i < widgetFoto.dataSource.data.length; i++) {
            var array = widgetFoto.dataSource.data[i].NMANEXO.split(".");
            if ((widgetCandidatos.currentRow.NRPESSOA !== undefined) && array[0] === widgetCandidatos.currentRow.NRPESSOA.toString()) {
                dados[dados.length] = widgetFoto.dataSource.data[i];
            }
        }
        if (dados !== null) {
            widgetFoto.dataSource.data = dados;
        } else {
            widgetFoto.dataSource.data = [];
        }
        this.onEnterFoto(args);
        templateManager.updateTemplate();
        args.owner.moveToFirst();
    };

    this.filtrarTurno = function() {
        var widget = templateManager.container.getActiveWidget();
        var turnoDataSourceFilter = widget.getField('DSTURNO').dataSourceFilter;
        var turno = widget.currentRow.NRESCALATRABM;
        if (turno == widget.currentRow.NRTURNO) {
            widget.currentRow.NRTURNO = null;
            widget.currentRow.NRTURNO = "";
        }
        turnoDataSourceFilter[0].value = turno;
        widget.currentRow.DSTURNO = null;
        widget.currentRow.NRTURNO = null;
        widget.getField('DSTURNO').readOnly = false;
    };

    this.habilitarCampoAreaOutros = function(field) {
        if (field.value() == "Outra") {
            field.widget.getField('DES_AREAFORMACAO_NRORG').readOnly = false;
        } else {
            field.widget.getField('DES_AREAFORMACAO_NRORG').readOnly = true;

        }
    };

    this.tipoVinculoOnChange = function(args) {
        var dadosComplementares = templateManager.container.getWidget("dadosComplementaresCandidato");
        var parametros = templateManager.container.getWidget("parametros");

        parametros.currentRow.NRTIPOVINCULOM = dadosComplementares.currentRow.NRTIPOVINCULOM;
        parametros.currentRow.NMTIPOVINCULOH = dadosComplementares.currentRow.NMTIPOVINCULOH;

        if (dadosComplementares.currentRow.NRTIPOVINCULOM == 1) {
            dadosComplementares.getField("NRCTPSPESSOA").validations = {
                required: true
            };
            dadosComplementares.getField("NRSERIECTPSPES").validations = {
                required: true
            };
            dadosComplementares.getField("DTCTPSPESSOA").validations = {
                required: true
            };
            dadosComplementares.getField("SGUFCTPSPES").validations = {
                required: true
            };
            dadosComplementares.getField("NRPISPASEPPES").validations = {
                required: true
            };
            dadosComplementares.getField("DTINSCPISPASEP").validations = {
                required: true
            };
        } else {
            dadosComplementares.getField("NRCTPSPESSOA").validations = {};
            dadosComplementares.getField("NRSERIECTPSPES").validations = {};
            dadosComplementares.getField("DTCTPSPESSOA").validations = {};
            dadosComplementares.getField("SGUFCTPSPES").validations = {};
            dadosComplementares.getField("NRPISPASEPPES").validations = {};
            dadosComplementares.getField("DTINSCPISPASEP").validations = {};
        }
    };


    this.habilitarCampoOcupacaoOutros = function(field) {
        if (field.value() == "Outros...") {
            field.widget.getField('DSOCUPACAO').readOnly = false;
        } else {
            field.widget.getField('DSOCUPACAO').readOnly = true;

        }
    };

    this.habilitarCampoCursoOutros = function(field) {
        if (field.value() == "Outro") {
            field.widget.getField('DSCURSO').readOnly = false;
        } else {
            field.widget.getField('DSCURSO').readOnly = true;
        }
    };

    this.openComentarios = function(args) {
        var widgetComentarios = templateManager.container.getWidget("comentarios_candidato");

        var nrparcnegocio = getLocalVar("BTL_NRPARCNEGOCIOCAND");

        var comentarioDataSourceFilter = widgetComentarios.dataSourceFilter;
        comentarioDataSourceFilter[1].value = nrparcnegocio;
        widgetComentarios.reload();
    };

    this.puxarCamposDadosComplementares = function() {
        var nrparcnegocio = getLocalVar("BTL_NRPARCNEGOCIOCAND");
        var nrorg = getLocalVar("HCM_NRORG_PADRAO");
        restEngine.post("product#/dadosComplementares", {
            requestType: "FilterData",
            filter: [{
                operator: "=",
                name: "NRPARCNEGOCIO",
                value: nrparcnegocio
            }, {
                operator: "=",
                name: "NRORG",
                value: nrorg
            }]
        }).
        then(function(data) {
            var widget = templateManager.container.getWidget('dadosComplementaresCandidato');
            widget.currentRow = data.dataset.dadosComplementares.length == 0 ? widget.currentRow : data.dataset.dadosComplementares[0];
            widget.currentRow.NMPESSOA = templateManager.container.getWidget("dadosPessoaisCandidato").currentRow.NMOPERADOR;
        }).catch(function(e) {
            var error;
            if (e.data.error === undefined)
                error = e;
            else
                error = e.data.error;

            ScreenService.showMessage('Ocorreu um erro inesperado, contate o administrador informando o trecho abaixo: <br><br>' + error + '<br><br>', 'ERROR');
        });
    };

    this.puxarDadosContaBancaria = function() {
        var nrparcnegocio = getLocalVar("BTL_NRPARCNEGOCIOCAND");
        var nrorg = getLocalVar("HCM_NRORG_PADRAO");
        restEngine.post("product#/contaBancaria", {
            requestType: "FilterData",
            filter: [{
                operator: "=",
                name: "NRPARCNEGOCIO",
                value: nrparcnegocio
            }, {
                operator: "=",
                name: "NRORG",
                value: nrorg
            }]
        }).
        then(function(data) {
            var widget = templateManager.container.getActiveWidget();
            if (data.dataset.contaBancaria[0]) {
                widget.currentRow = data.dataset.contaBancaria[0];
            }
        }).catch(function(e) {
            var error;
            if (e.data.error === undefined)
                error = e;
            else
                error = e.data.error;

            ScreenService.showMessage('Ocorreu um erro inesperado, contate o administrador informando o trecho abaixo: <br><br>' + error + '<br><br>', 'ERROR');
        });
    };

    this.puxarCamposDadosPessoais = function() {
        var nrparcnegocio = getLocalVar("BTL_NRPARCNEGOCIOCAND");
        var nrorg = getLocalVar("HCM_NRORG_PADRAO");
        restEngine.post("product#/dadosPessoaisCandidato", {
            requestType: "FilterData",
            filter: [{
                operator: "=",
                name: "NRPARCNEGOCIO",
                value: nrparcnegocio
            }, {
                operator: "=",
                name: "NRORG",
                value: nrorg
            }]
        }).
        then(function(data) {
            var widget = templateManager.container.getActiveWidget();
            if (data.dataset.dadosPessoaisCandidato[0]) {
                widget.currentRow = data.dataset.dadosPessoaisCandidato[0];
                var nmoperador = widget.currentRow.NMOPERADOR;
                widget.currentRow.NMOPERADOR = nmoperador.toUpperCase();
            }
        }).catch(function(e) {
            var error;
            if (e.data.error === undefined)
                error = e;
            else
                error = e.data.error;

            ScreenService.showMessage('Ocorreu um erro inesperado, contate o administrador informando o trecho abaixo: <br><br>' + error + '<br><br>', 'ERROR');
        });
    };
    
    this.puxarCamposFormacao = function() {
        var nrparcnegocio = getLocalVar("BTL_NRPARCNEGOCIOCAND");
        var nrorg = getLocalVar("HCM_NRORG_PADRAO");
        var dtcompetencia = getLocalVar("HCM_DTCOMPETENCIA_OPER");
        restEngine.post("product#/getFormacaoParc", {
            requestType: "FilterData",
            filter: [{
    			name: "NRPARCNEGOCIO",
    			operator: "=",
    			value: nrparcnegocio
    		},
    		{
    			name: "P_NRORG",
    			operator: "=",
    			value: nrorg
    		},
    		{
    			name: "P_NRORG_PADRAO",
    			operator: "=",
    			value: nrorg
    		},
    		{
    			name: "P_DTMESCOMPETENC",
    			operator: "=",
    			value: dtcompetencia
    		}]
        }).
        then(function(data) {
            var widget = templateManager.container.getActiveWidget();
            if (data.dataset.gpe_formacaoparc_get) {
                widget.dataSource.data = data.dataset.gpe_formacaoparc_get;
            }
        }).catch(function(e) {
            var error;
            if (e.data.error === undefined)
                error = e;
            else
                error = e.data.error;

            ScreenService.showMessage('Ocorreu um erro inesperado, contate o administrador informando o trecho abaixo: <br><br>' + error + '<br><br>', 'ERROR');
        });
    };


    this.removeDependente = function() {
        ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
            var widget = templateManager.container.getActiveWidget();
            for (var i = 0; i < widget.dataSource.data.length; i++) {
                if (widget.currentRow.NMPESSOA == widget.dataSource.data[i].NMPESSOA) {
                    if (widget.dataSource.data.length == 1) {
                        widget.dataSource.data = [];
                    } else {
                        widget.dataSource.data.splice(i, 1);
                    }
                    ABUtilController.masterDetailVoltarList(widget);
                    widget.reload();
                }
            }
        }, null);
    };
    
    this.removeFormacao = function() {
        ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
            var widget = templateManager.container.getActiveWidget();
            for (var i = 0; i < widget.dataSource.data.length; i++) {
                if (widget.currentRow.NRFORMACAO == widget.dataSource.data[i].NRFORMACAO) {
                    if (widget.dataSource.data.length == 1) {
                        widget.dataSource.data = [];
                    } else {
                        widget.dataSource.data.splice(i, 1);
                    }
                    ABUtilController.masterDetailVoltarList(widget);
                    widget.reload();
                }
            }
        }, null);
    };

    this.retirarRequired = function() {
        var widgetDependentes = templateManager.container.getWidget("cadastroDependentesCandidato");
        widgetDependentes.getField("NRTIPODEPENDE").validations = {};
    };

    this.salvarComentarios = function() {
        var widgetComentarios = templateManager.container.getWidget("comentarios_candidato");

        if (widgetComentarios.isValid()) {
            widgetComentarios.currentRow.NRPARCNEGOCIOCAND = getLocalVar("BTL_NRPARCNEGOCIOCAND");
            widgetComentarios.currentRow.NRORG = getLocalVar("HCM_NRORG_TRAB");
            widgetComentarios.currentRow.CDOPERRESPONSAVEL = getLocalVar("HCM_CDOPERADOR");
            widgetComentarios.currentRow.NRPROCESSO = widgetComentarios.currentRow.NRPROCESSO;

            if (!widgetComentarios.backupRow) {
                widgetComentarios.currentRow.__is_new = true;
            } else {
                widgetComentarios.currentRow.__is_new = false;
            }
            return widgetComentarios.saveRow().then(function() {
                if (widgetComentarios.currentRow.__is_new) {
                    ABUtilController.masterDetailVoltarList(widgetComentarios);
                    widgetComentarios.reload();
                } else {
                    ABUtilController.mudarVisibilidadeWidgets(widgetComentarios.widgets, true);
                    widgetComentarios.backupRow = null;
                    widgetComentarios.view();
                }
            }).catch(function(e) {
                var error;
                if (e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;

                ScreenService.showMessage('Ocorreu um erro inesperado, contate o administrador informando o trecho abaixo: <br><br>' + error + '<br><br>', 'ERROR');
            });
        }
    };

    this.salvarDadosPessoais = function(argsRow) {
        var widget = templateManager.container.getActiveWidget();
        var confirmacao = this.saveUploadFile(argsRow, 'N');
        if (widget.isValid()) {
            widget.currentRow.NRPARCNEGOCIO = getLocalVar("BTL_NRPARCNEGOCIOCAND");
            widget.currentRow.NRORG = getLocalVar("HCM_NRORG_PADRAO");
            widget.currentRow.CDOPERADOR = getLocalVar("HCM_CDOPERADOR");
            widget.currentRow.changed = true;
            widget.currentRow.__is_new = false;
            widget.currentRow.DTNASCPESSOA = widget.currentRow.DTNASCPESSOA.substr(6, 4) + '/' + widget.currentRow.DTNASCPESSOA.substr(3, 2) + '/' + widget.currentRow.DTNASCPESSOA.substr(0, 2);
            return widget.saveRow().then(function() {
                widget.currentRow.changed = false;
                widget.currentRow.__is_new = false;
                widget.template = templateWidget;
                templateManager.updateTemplate();
                widget.view();
                widget.reload();
            }).catch(function(e) {
                var error;
                if (e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;

                ScreenService.showMessage('Ocorreu um erro inesperado, contate o administrador informando o trecho abaixo: <br><br>' + error + '<br><br>', 'ERROR');
            });
        }
    };

    this.setNmPessoa = function(args) {
        var widget = ABUtilController.checkWidget(args);
        var widgetDadosAdicionais = templateManager.container.getWidget("dadosComplementaresCandidato");
        this.convertToUpperCase(widget, 'dadosPessoaisCandidato');
        widgetDadosAdicionais.currentRow.NMPESSOA = widget.currentRow.NMOPERADOR;
    };

    this.convertToUpperCase = function(widget, tab) {
        switch (tab) {
            case 'dadosPessoaisCandidato':
                var nmoperador = widget.currentRow.NMOPERADOR;
                nmoperador = convert(nmoperador);
                widget.currentRow.NMOPERADOR = nmoperador;
                break;
            case 'cadastroDeRelacionamentos':
                var nmpessoa = widget.currentRow.NMPESSOA;
                nmpessoa = convert(nmpessoa);
                widget.currentRow.NMPESSOA = nmpessoa;
                break;
        }
    };

    var convert = function(name) {
        if ((typeof(name) !== 'undefined') && (name.length > 0)) {
            name = name.toUpperCase();
        } else {
            name = '';
        }
        return name;
    };

    this.salvarDadosPessoaisAdmissao = function(argsRow, args) {
        var widget = templateManager.container.getWidget('dadosPessoaisCandidato');
        var widget1 = templateManager.container.getWidget('dadosComplementaresCandidato');
        var widget2 = templateManager.container.getWidget('formacaoCandidato');
        var widget3 = templateManager.container.getWidget('contaBancariaCandidato');
        var widget4 = templateManager.container.getWidget('cadastroDependentesCandidato');
        var widget5 = templateManager.container.getWidget('parametros');
        var widget6 = templateManager.container.getWidget('movimentacaoCandidato');

        var cdoperador = getLocalVar("HCM_CDOPERADOR");
        var nrorgoperador = getLocalVar("HCM_NRORG_TRAB");
        var saveData = Object.assign({}, {
                "DEPENDENTES": templateManager.containers['product#hcm04002_btl_processo_admissao'].widgets[0].widgets[4].dataSource.data
            },{
                "FORMACAO": templateManager.containers['product#hcm04002_btl_processo_admissao'].widgets[0].widgets[2].dataSource.data
            },
            templateManager.containers['product#hcm04002_btl_processo_admissao'].widgets[0].widgets[0].currentRow,
            templateManager.containers['product#hcm04002_btl_processo_admissao'].widgets[0].widgets[1].currentRow,
            templateManager.containers['product#hcm04002_btl_processo_admissao'].widgets[0].widgets[3].currentRow,
            templateManager.containers['product#hcm04002_btl_processo_admissao'].widgets[0].widgets[5].currentRow,
            templateManager.containers['product#hcm04002_btl_processo_admissao'].widgets[0].widgets[6].currentRow, {
                "CDOPERADOR_LOG": cdoperador
            }, {
                "NRORG": nrorgoperador
            }, {
                "NRPROCESSO": getLocalVar("HCM_NRPROCESSO")
            });
        if (this.verificaCampo(args)) {
            restEngine.post('product#/finalizarProcesso', {
                'requestType': 'DataSet',
                'dataset': [saveData]
            }).then(function(data) {
                widget.onEnterOnceCalled = false;
                widget1.onEnterOnceCalled = false;
                widget2.onEnterOnceCalled = false;
                widget3.onEnterOnceCalled = false;
                widget4.onEnterOnceCalled = false;
                widget5.onEnterOnceCalled = false;
                widget6.onEnterOnceCalled = false;

                widget2.dataSource.data = [];
                widget4.dataSource.data = [];
                templateManager.containers['product#hcm04002_btl_processo_admissao'].widgets[0].widgets[0].currentRow = [];
                templateManager.containers['product#hcm04002_btl_processo_admissao'].widgets[0].widgets[1].currentRow = [];
                templateManager.containers['product#hcm04002_btl_processo_admissao'].widgets[0].widgets[3].currentRow = [];
                templateManager.containers['product#hcm04002_btl_processo_admissao'].widgets[0].widgets[5].currentRow = [];
                templateManager.containers['product#hcm04002_btl_processo_admissao'].widgets[0].widgets[6].currentRow = [];
                ScreenService.showMessage('Admissão realizada com sucesso.');
                ScreenService.openWindow('product#' + this.telaRetorno);
            }.bind(this)).catch(function(e) {
                var error;
                if (e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;

                ScreenService.showMessage('Ocorreu um erro inesperado, contate o administrador informando o trecho abaixo: <br><br>' + error + '<br><br>', 'ERROR');
            });
        }
    };

    this.setCaminhoCurriculo = function(argsRow) {
        var widget = templateManager.container.getActiveWidget();
        restEngine.post("product#/procurarCurriculo", {
            requestType: "DataSet",
            dataset: [argsRow]

        }).then(function(data) {
            if (data) {
                if (data.dataset.procurarCurriculo[0][2].ANEXARCURRICULO)
                    widget.currentRow.CAMINHOCURRICULO = data.dataset.procurarCurriculo[0][2].CAMINHO;
                if (data.dataset.procurarCurriculo[0][1].ANEXARFOTO)
                    widget.currentRow.CAMINHOFOTO = data.dataset.procurarCurriculo[0][1].CAMINHO;

                templateManager.container.getWidget("anexarfoto").reload();
            }
        }).catch(function(e) {
            var error;
            if (e.data.error === undefined)
                error = e;
            else
                error = e.data.error;

            ScreenService.showMessage('Ocorreu um erro inesperado, contate o administrador informando o trecho abaixo: <br><br>' + error + '<br><br>', 'ERROR');
        });
    };

    this.setDadosDefaultMovimentacao = function(args) {
        dataAtual = moment().format('DD/MM/YYYY');
        var currentRow = ABUtilController.checkWidget(args).currentRow;
        currentRow.NMTPMOVTRANSFH = currentRow.NMTPMOVTRANSFH ? currentRow.NMTPMOVTRANSFH : 'Admissão com emprego anterior';
        currentRow.NRTPMOVTRANSFM = currentRow.NRTPMOVTRANSFM ? currentRow.NRTPMOVTRANSFM : 2;
        currentRow.NRTPMOVTRANSF = currentRow.NRTPMOVTRANSF ? currentRow.NRTPMOVTRANSF : 2;
        currentRow.DTINIMOVIMENT = currentRow.DTINIMOVIMENT ? currentRow.DTINIMOVIMENT : dataAtual;
        currentRow.NMTIPOTRANSFER_LEGAL = currentRow.NMTIPOTRANSFER_LEGAL ? currentRow.NMTIPOTRANSFER_LEGAL : 'Movimentação Legal';
        currentRow.NRTIPOTRANSFER_LEGAL = currentRow.NRTIPOTRANSFER_LEGAL ? currentRow.NRTIPOTRANSFER_LEGAL : 1;
        currentRow.NMTIPOTRANSFER_GEREN = currentRow.NMTIPOTRANSFER_GEREN ? currentRow.NMTIPOTRANSFER_GEREN : 'Movimentação Gerencial';
        currentRow.NRTIPOTRANSFER_GEREN = currentRow.NRTIPOTRANSFER_GEREN ? currentRow.NRTIPOTRANSFER_GEREN : 2;
        currentRow.NMTIPOTRANSFER_SINDICAL = currentRow.NMTIPOTRANSFER_SINDICAL ? currentRow.NMTIPOTRANSFER_SINDICAL : 'Movimentação Legal';
        currentRow.NRTIPOTRANSFER_SINDICAL = currentRow.NRTIPOTRANSFER_SINDICAL ? currentRow.NRTIPOTRANSFER_SINDICAL : 1;

    };

    this.setDadosDefaultParamentros = function(args) {
        dataAtual = moment().format('DD/MM/YYYY');
        var currentRow = ABUtilController.checkWidget(args).currentRow;
        currentRow.NMTIPOOCUPACAO = currentRow.NMTIPOOCUPACAO ? currentRow.NMTIPOOCUPACAO : 'Cargo Efetivo';
        currentRow.NRTIPOOCUPACAO = currentRow.NRTIPOOCUPACAO ? currentRow.NRTIPOOCUPACAO : 1;
        currentRow.DTADMISSAOVINC = currentRow.DTADMISSAOVINC ? currentRow.DTADMISSAOVINC : dataAtual;
        currentRow.DTBASEFERIAS = currentRow.DTBASEFERIAS ? currentRow.DTBASEFERIAS : dataAtual;
        currentRow.DTINIOCUPACAO = currentRow.DTINIOCUPACAO ? currentRow.DTINIOCUPACAO : dataAtual;
        currentRow.DTINIESCALA = currentRow.DTINIESCALA ? currentRow.DTINIESCALA : dataAtual;
        currentRow.NMTPMODALIDSAL = currentRow.NMTPMODALIDSAL ? currentRow.NMTPMODALIDSAL : "Efetivo";
        currentRow.NRTPMODALIDSAL = currentRow.NRTPMODALIDSAL ? currentRow.NRTPMODALIDSAL : 1;
        currentRow.NMSITUFUNCH = currentRow.NMSITUFUNCH ? currentRow.NMSITUFUNCH : "Atividade Normal";
        currentRow.NRSITUFUNCM = currentRow.NRSITUFUNCM ? currentRow.NRSITUFUNCM : 1;
        currentRow.DTINISITUFUNC = currentRow.DTINISITUFUNC ? currentRow.DTINISITUFUNC : dataAtual;
        currentRow.NMTIPOALTERA = currentRow.NMTIPOALTERA ? currentRow.NMTIPOALTERA : "Salário Admissão";
        currentRow.NRTIPOALTERA = currentRow.NRTIPOALTERA ? currentRow.NRTIPOALTERA : 1;
        currentRow.DTALTESALARIO = currentRow.DTALTESALARIO ? currentRow.DTALTESALARIO : dataAtual;
        currentRow.CDTIPOSALARIO = currentRow.CDTIPOSALARIO ? currentRow.CDTIPOSALARIO : "MENSAL";
        currentRow.DSTIPOSALARIO = currentRow.DSTIPOSALARIO ? currentRow.DSTIPOSALARIO : "MENSAL";
        currentRow.NMVINCULOEMPREG = currentRow.NMVINCULOEMPREG ? currentRow.NMVINCULOEMPREG : 'Contrato de Trabalho CLT por prazo indeterminado';
        currentRow.NRVINCULOEMPREG = currentRow.NRVINCULOEMPREG ? currentRow.NRVINCULOEMPREG : 1;
    };

    this.setDataAdmissao = function() {
        var widget = templateManager.container.getActiveWidget();
        widget.currentRow.DTINIOCUPACAO = widget.currentRow.DTADMISSAOVINC;
        widget.currentRow.DTINIESCALA = widget.currentRow.DTADMISSAOVINC;
        widget.currentRow.DTINISITUFUNC = widget.currentRow.DTADMISSAOVINC;
        widget.currentRow.DTALTESALARIO = widget.currentRow.DTADMISSAOVINC;
        widget.currentRow.DTBASEFERIAS = widget.currentRow.DTADMISSAOVINC;


        var widgetMovimentacao = templateManager.container.getWidget('movimentacaoCandidato');
        widgetMovimentacao.currentRow.DTINIMOVIMENT = widget.currentRow.DTADMISSAOVINC;
    };

    this.setNrparcnegociocand = function(argsRow) {
        setLocalVar('BTL_NRPARCNEGOCIOCAND', argsRow.NRPARCNEGOCIO);
    };

    this.setNrTemplate = function(args) {
        var widget = ABUtilController.checkWidget(args);
        widget.getField("NMFASE").dataSourceFilter[1].value = widget.currentRow.NRTEMPLATE;
        widget.getField("NMFASE").readOnly = false;
    };

    this.setTelaRetorno = function(widget, ProcessoSeletivoController) {
        this.telaRetorno = widget.container.name;
        if (widget.name === "candidatos") {
            this.admitirCandidato();
        } else {
            ProcessoSeletivoController.admitirCandidato();
        }
    };

    this.verificaCampo = function(args) {

        if (!templateManager.containers['product#hcm04002_btl_processo_admissao'].widgets[0].widgets[0].isValid()) {
            args.e.preventDefault();
            ScreenService.showMessage('Para prosseguir, preencha corretamente os campos da aba Dados Pessoais');
            return false;
        }
        if (templateManager.containers['product#hcm04002_btl_processo_admissao'].widgets[0].widgets[1].isValid()) {
            if (templateManager.containers['product#hcm04002_btl_processo_admissao'].widgets[0].widgets[1].currentRow.NMRACAPESSOA === undefined) {
                args.e.preventDefault();
                ScreenService.showMessage('Para prosseguir, preencha corretamente os campos da aba Dados Complementares');
                return false;
            }
        } else {
            args.e.preventDefault();
            ScreenService.showMessage('Para prosseguir, preencha corretamente os campos da aba Dados Complementares');
            return false;
        }

        if (templateManager.containers['product#hcm04002_btl_processo_admissao'].widgets[0].widgets[1].currentRow.NRTIPOVINCULOM == 1) {
            if (!ABUtilController.validaPIS(templateManager.containers['product#hcm04002_btl_processo_admissao'].widgets[0].widgets[1].currentRow.NRPISPASEPPES)) {
                ScreenService.showMessage('Para prosseguir, insira um número de PIS/PASEP valido na aba Dados Complementares');
                return false;
            }
        }

        if (templateManager.containers['product#hcm04002_btl_processo_admissao'].widgets[0].widgets[3].isValid()) {
            if (templateManager.containers['product#hcm04002_btl_processo_admissao'].widgets[0].widgets[3].currentRow.CDBANCO === undefined) {
                args.e.preventDefault();
                ScreenService.showMessage('Para prosseguir, preencha corretamente os campos da aba Conta Bancária');
                return false;
            }
        } else {
            args.e.preventDefault();
            ScreenService.showMessage('Para prosseguir, preencha corretamente os campos da aba Conta Bancária');
            return false;
        }

        if (templateManager.containers['product#hcm04002_btl_processo_admissao'].widgets[0].widgets[5].isValid()) {
            if (templateManager.containers['product#hcm04002_btl_processo_admissao'].widgets[0].widgets[5].currentRow.VRSALARIO === undefined) {
                args.e.preventDefault();
                ScreenService.showMessage('Para prosseguir, preencha corretamente os campos da aba Parâmetros');
                return false;
            }
        } else {
            args.e.preventDefault();
            ScreenService.showMessage('Para prosseguir, preencha corretamente os campos da aba Parâmetros');
            return false;
        }

        if (templateManager.containers['product#hcm04002_btl_processo_admissao'].widgets[0].widgets[6].isValid()) {
            if (templateManager.containers['product#hcm04002_btl_processo_admissao'].widgets[0].widgets[6].currentRow.NMTIPOTRANSFER_LEGAL === undefined) {
                args.e.preventDefault();
                ScreenService.showMessage('Para prosseguir, preencha corretamente os campos da aba Movimentação');
                return false;
            }
        } else {
            args.e.preventDefault();
            ScreenService.showMessage('Para prosseguir, preencha corretamente os campos da aba Movimentação');
            return false;
        }

        return true;
    };

    this.verificaVinculo = function() {
        var wdg = templateManager.container.getActiveWidget();
        var cpf = wdg.currentRow.NRCPFPESSOA;
        var nrorg = getLocalVar("HCM_NRORG_TRAB");
        restEngine.post("product#/verificaVinculo", {
                requestType: "FilterData",
                filter: [{
                    operator: "=",
                    name: "NRCPFPESSOA",
                    value: cpf
                }, {
                    operator: "=",
                    name: "NRORG",
                    value: nrorg
                }]
            },
            function(data) {
                if (data.dataset.verificaVinculo[0] !== undefined) {
                    ScreenService.showMessage('Candidato já admitido');
                } else {
                    ScreenService.openWindow('product#hcm04002_btl_processo_admissao');
                }
            });
    };

    this.onEnterFoto = function(args) {
        var widget = ABUtilController.checkWidget(args);
        if (!args.owner.dataSource.data[0]) {
            args.owner.dataSource.data[0] = [];
        }

        if (!args.owner.dataSource.data[0].DSPATH) {
            args.owner.dataSource.data[0].DSPATH = "tkOrg2058222b239fc57/GPE_ANEXOS/583d7e7ea584c.jpg";
            widget.currentRow = args.owner.dataSource.data[0];
        }
        args.owner.moveToFirst();
        templateManager.updateTemplate();
    };

    this.openPopupAdicionarProcessoCandidato = function() {
        var widget = templateManager.container.getWidget('processosCadastrados');
        ABUtilController.masterDetailOpenPopup(widget);
    };

    this.adicionarProcessoCandidato = function(args) {
        var widgetParticipantes = templateManager.container.getWidget('processosParticipantes');
        var widgetCandidatos = templateManager.container.getWidget('candidatos');
        var argsRow = [];
        var widget;
        var auxRow;
        if (widgetCandidatos.dataSource.checkedRows && widgetCandidatos.mode === "list") {
            for (var i = 0; i < widgetCandidatos.dataSource.checkedRows.length; i++) {
                auxRow = {};
                Util.extend(auxRow, args.row);
                auxRow.NRPARCNEGOCIO = widgetCandidatos.dataSource.checkedRows[i].NRPARCNEGOCIO;
                argsRow[i] = auxRow;
                widget = widgetCandidatos;
            }
        } else {
            args.row.NRPARCNEGOCIO = getLocalVar("BTL_NRPARCNEGOCIOCAND");
            argsRow.push(args.row);
            widget = widgetParticipantes;
        }

        if (args.owner.widget.isValid()) {
            restEngine.post("product#/adicionarCandidatoProcesso", {
                requestType: "DataSet",
                dataset: [argsRow]
            }).then(function(data) {
                if (!Util.isUndefined(data.dataset.save)) {
                    ScreenService.successNotification("Processo Adicionado com Sucesso", 10000);
                    widget.activate();
                    widget.reload().then(function() {
                        if (widget === widgetCandidatos) {
                            widget.unSelectAll();
                            widget.updateCheckingState();
                        }
                        ABUtilController.masterDetailClosePopup(templateManager.container.getWidget('processosCadastrados'));
                    });
                }
            }).catch(function(e) {
                var error;
                if (e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;

                ScreenService.showMessage('Ocorreu um erro inesperado, contate o administrador informando o trecho abaixo: <br><br>' + error + '<br><br>', 'ERROR');
            });
        }
    };

    this.closeSwipe = function(widget) {
        ScreenService.closeSwipe();
        widget.deactivate();
        widget.parentWidget.currentWidget = widget.parentWidget;
        widget.parentWidget.activate();
    };

    this.saveUploadFile = function(argsRow, idfoto) {
        var widgetCandidatos = templateManager.container.getWidget("candidatos");
        var widgetAnexarArquivo = templateManager.container.getWidget("anexarArquivo");
        var widgetNovoArquivo = templateManager.container.getWidget("novoArquivo");
        var caracteresInvalidos = ["*", "%", "@", "#", "$", "¨", "&", "'"];
        var verificaNomeArquivo = !caracteresInvalidos.find(function(value) {
            return argsRow.DSPATH[0].name.indexOf(value) !== -1;
        });
        if (verificaNomeArquivo) {
            if (widgetNovoArquivo.isValid()) {
                argsRow.IDFOTO = idfoto;
                argsRow.DSPATH[0].type = argsRow.DSPATH[0].name.split(".")[argsRow.DSPATH[0].name.split(".").length-1];
                saveData = Object.assign({}, argsRow, {
                    "NRPESSOA": widgetCandidatos.currentRow.NRPESSOA
                }, {
                    "NRPARCNEGOCIO": widgetCandidatos.currentRow.NRPARCNEGOCIO
                }, {
                    "NRORG": widgetCandidatos.currentRow.NRORG
                }, {
                    "CDOPERADOR_LOG": getLocalVar("HCM_CDOPERADOR")
                });
                return restEngine.post("product#/saveUploadFile", {
                    requestType: "DataSet",
                    dataset: [saveData]
                }).then(function(data) {
                    if (!Util.isUndefined(data.dataset.saveUploadFile) && data.dataset.saveUploadFile[0]) {
                        ScreenService.showMessage("Arquivo carregado com sucesso");
                    } else {
                        ScreenService.showMessage("Não foi possível realizar o upload do arquivo");
                    }
                    widgetAnexarArquivo.reload().then(function() {
                        ABUtilController.masterDetailVoltarList(widgetAnexarArquivo);
                        widgetAnexarArquivo.widgets[0].deactivate();
                        widgetAnexarArquivo.currentWidget = widgetAnexarArquivo;
                    });
                }.bind(this)).catch(function(e) {
                    var error;
                    if (e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;
                    ScreenService.showMessage('Ocorreu um erro inesperado, contate o administrador informando o trecho abaixo: <br><br>' + error + '<br><br>', 'ERROR');
                });
            }
        } else {
            ScreenService.showMessage('Nome inválido para o arquivo');
        }
    };

    this.apagarArquivos = function(argsRow) {
        ScreenService.confirmMessage('Deseja realmente exluir o arquivo ?', 'CONFIRMATION',
            function() {
                var widgetCandidatos = templateManager.container.getWidget("candidatos");
                var widgetAnexarArquivo = templateManager.container.getWidget("anexarArquivo");
                var widgetNovoArquivo = templateManager.container.getWidget("novoArquivo");
                saveData = Object.assign({}, argsRow, {
                    "NRPESSOA": widgetCandidatos.currentRow.NRPESSOA
                }, {
                    "NRPARCNEGOCIO": widgetCandidatos.currentRow.NRPARCNEGOCIO
                }, {
                    "NRORG": widgetCandidatos.currentRow.NRORG
                }, {
                    "CDOPERADOR_LOG": getLocalVar("HCM_CDOPERADOR")
                });
                restEngine.post("product#/apagarArquivos", {
                    requestType: "DataSet",
                    dataset: [saveData]
                }).then(function(data) {
                    if (data) {
                        ScreenService.showMessage('Arquivo deletado com sucesso', 'SUCCESS');
                        widgetAnexarArquivo.reload();
                    } else {
                        ScreenService.showMessage('Falha ao apagar o arquivo', 'ALERT');
                        widgetAnexarArquivo.reload();
                    }
                    ScreenService.closeSwipe();
                }).catch(function(e) {
                    var error;
                    if (e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;
                    ScreenService.showMessage('Ocorreu um erro inesperado, contate o administrador informando o trecho abaixo: <br><br>' + error + '<br><br>', 'ERROR');
                });
            }
        );
    };

    this.setaSexo = function(widget) {
        var tipoRelacionamento = widget.currentRow.NMTIPORELACIONA;
        switch (tipoRelacionamento) {
            // Se o tipo de relacionamento adere ao caso abaixo, significa que 
            // o sexo do relacionado é feminino
            case 'Mae':
                widget.currentRow.IDSEXOPESSOA = 'F';
                break;
                // Se o tipo de relacionamento adere aos casos abaixo, significa que 
                // o sexo dos relacionados é masculino
            case 'Avo':
                widget.currentRow.IDSEXOPESSOA = 'M';
                break;
            case 'Pai':
                widget.currentRow.IDSEXOPESSOA = 'M';
                break;
            default:
                widget.currentRow.IDSEXOPESSOA = '';
        }
    };
    
    this.obrigaDtNascimentoDependente = function() {
        var widCadDep = templateManager.container.getWidget('cadastroDependentesCandidato');
        var isDep = false;
        
        if (Array.isArray(widCadDep.currentRow.NRTIPODEPENDE)) {
            widCadDep.currentRow.NRTIPODEPENDE.forEach(function(obj) {
                if (obj == 1 || obj == 2) //1 é salario familia, 2 é imposto de renda, 
                    isDep = true;
            });
        } else if ( widCadDep.currentRow.NRTIPODEPENDE == 1 || widCadDep.currentRow.NRTIPODEPENDE == 2 ) {
            isDep = true;
        }
        
        widCadDep.getField('DTNASCPESSOA').validations = ( isDep ? {required: true} : {} );
    };
    
    this.validaRequerimentoCpfDependete = function() {
        var widCadDep = templateManager.container.getWidget('cadastroDependentesCandidato');
        var flag = false;
        var idadeDep = moment(moment().format('DD/MM/YYYY'), 'DD/MM/YYYY').diff(moment(widCadDep.currentRow.DTNASCPESSOA, 'DD/MM/YYYY'), 'year');
        var idadeMinCPF = 0;
        if(getLocalVar("IDADE_MIN_CPF_DEP"))
        idadeMinCPF = getLocalVar("IDADE_MIN_CPF_DEP");
        
        if(widCadDep.currentRow.NRTIPODEPENDE && idadeDep >= idadeMinCPF){
            
            if(Array.isArray(widCadDep.currentRow.NRTIPODEPENDE) ){
                widCadDep.currentRow.NRTIPODEPENDE.forEach(function(obj){
                    if(obj == 2) //obj == 2, 2 é imposto de renda
                        flag = true;
                });
            }else if( widCadDep.currentRow.NRTIPODEPENDE == 2 )
                flag = true;
        }
        if(flag)
            widCadDep.getField('NRCPFPESSOA').validations = {required: true};
        else
            widCadDep.getField('NRCPFPESSOA').validations = {};
     };
                
    this.saveDependentes = function (widget) {
        if (ABUtilController.validaDataIgualPosteriorDtAtual(widget.currentRow.DTNASCPESSOA)) {
            ScreenService.showMessage(Messages.DT_NASC_ERROR);
            return false;
        }
        ABUtilController.masterDetailSave(widget);
    };
    
}

Configuration(function(ContextRegister) {
    ContextRegister.register('CandidatosController', CandidatosController);
});


// FILE: assets/js/controllers/CategDocumentoController.js
function CategDocumentoController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, General,Messages) {

    this.adicionarRow = function(args) {
        var widget = args.owner.widget;
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
    };
    
	this.setCategDocumento = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
                if (!widget.backupRow) {
                    widget.currentRow.__is_new = true;
                } else {
                    widget.currentRow.__is_new = false;
                }
                restEngine.post('product#/setCategDocumento', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                    then(function (data) {
                        if (data.notifications[0].type === "success") {
                            ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                            if (widget.currentRow.__is_new) {
                                ABUtilController.masterDetailVoltarList(widget);
                                widget.reload();
                            } else {
                                ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                                widget.backupRow = null;
                                widget.view();
                            }
                        } else {
                            ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                        }
                    }).
                    catch(function(e) {
                        var error;
                        if(e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;
                            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    });
            }
    };
    
    this.deleteCategDocumento = function(args) {
    ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
        var widget = args.owner.widget;
        widget.currentRow.__is_new = false;
        restEngine.post('product#/deleteCategDocumento', {'requestType':'DataSet','dataset':[widget.currentRow]}).
            then(function(data){
                if(data.notifications[0].type === "success"){
                    ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                    ABUtilController.masterDetailVoltarList(widget);
                    widget.reload();
                } else {
                    ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                }
            }).
            catch(function(e) {
                var error;
                if(e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
        },null);
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('CategDocumentoController', CategDocumentoController);
});

// FILE: assets/js/controllers/CategPlanAcaoController.js
function CategPlanAcaoController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, General,Messages) {
    
    var self = this;
    
    this.adicionarRow = function(args) {
        var widget = args.owner.widget;
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
        templateManager.container.getWidget('categplanacao').reload();

    };


	this.setCategPlanAcao = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
            if (ABUtilController.validaDtIniMenorIgualDtFin(widget.currentRow.DTINIVIGENCIA, widget.currentRow.DTFIMVIGENCIA)) {
                if (!widget.backupRow) {
                    widget.currentRow.__is_new = true;
                } else {
                    widget.currentRow.__is_new = false;
                }
                restEngine.post('product#/setCategPlanAcao', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                    then(function (data) {
                        if (data.notifications[0].type === "success") {
                            ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                            if (widget.currentRow.__is_new) {
                                ABUtilController.masterDetailVoltarList(widget);
                                ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                                widget.reload();
                            } else {
                                ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                                widget.backupRow = null;
                                widget.view();
                            }
                        } else {
                            ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                        }
                    }).
                    catch(function(e) {
                        var error;
                        if(e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;
                            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    });
            }else{
                ScreenService.showMessage(Messages.DTINI_POST_DTFIM_ERROR);
                return false;
            }        
        }
        templateManager.container.getWidget('categplanacao').reload();
    };
    
    this.deleteCategPlanAcao = function(args) {
        var widget = templateManager.container.getActiveWidget();
        if (widget.isValid()) {
            widget.currentRow.__is_new = false;
            ScreenService.confirmMessage(Messages.DELETE_ROW, 'CONFIRMATION', function(){
            restEngine.post('product#/deleteCategPlanAcao', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                then(function (data) {
                    if (data.messages) {
                        ScreenService.showMessage(Messages.REMOVE_ROW_ERROR + '. ' + data.messages[0].message, data.messages[0].type);
                    } else {
                        ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    }
                }).
                catch(function(e) {
                    var error;
                    if(e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;

                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
            });            
        }
    templateManager.container.getWidget('categplanacao').reload();
    };
    

}

Configuration(function(ContextRegister) {
    ContextRegister.register('CategPlanAcaoController', CategPlanAcaoController);
});

// FILE: assets/js/controllers/CategoriaMilitarController.js
function CategoriaMilitarController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, General,Messages) {

    this.adicionarRow = function(args) {
        var widget = args.owner.widget;
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
    };

	this.setCategoriaMilitar = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
                if (!widget.backupRow) {
                    widget.currentRow.__is_new = true;
                } else {
                    widget.currentRow.__is_new = false;
                }
                restEngine.post('product#/setCategoriaMilitar', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                    then(function (data) {
                        if (data.notifications[0].type === "success") {
                            ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                            if (widget.currentRow.__is_new) {
                                ABUtilController.masterDetailVoltarList(widget);
                                widget.reload();
                            } else {
                                ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                                widget.backupRow = null;
                                widget.view();
                            }
                        } else {
                            ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                        }
                    }).
                    catch(function(e) {
                        var error;
                        if(e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;
                            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    });
            }
    };
    
    this.deleteCategoriaMilitar = function(args) {
    ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
        var widget = args.owner.widget;
        widget.currentRow.__is_new = false;
        restEngine.post('product#/deleteCategoriaMilitar', {'requestType':'DataSet','dataset':[widget.currentRow]}).
            then(function(data){
                if(data.notifications[0].type === "success"){
                    ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                    ABUtilController.masterDetailVoltarList(widget);
                    widget.reload();
                } else {
                    ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                }
            }).
            catch(function(e) {
                var error;
                if(e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
        }, null);
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('CategoriaMilitarController', CategoriaMilitarController);
});

// FILE: assets/js/controllers/CategoriaTrabalhadorController.js
function CategoriaTrabalhadorController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, General,Messages) {

    this.adicionarRow = function(args) {
        var widget = args.owner.widget;
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
    };

	this.setCategoriaTrabalhador = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
                if (!widget.backupRow) {
                    widget.currentRow.__is_new = true;
                } else {
                    widget.currentRow.__is_new = false;
                }
                restEngine.post('product#/setCategoriaTrabalhador', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                    then(function (data) {
                        if (data.notifications[0].type === "success") {
                            ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                            if (widget.currentRow.__is_new) {
                                ABUtilController.masterDetailVoltarList(widget);
                                widget.reload();
                            } else {
                                ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                                widget.backupRow = null;
                                widget.view();
                            }
                        } else {
                            ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                        }
                    }).
                    catch(function(e) {
                        var error;
                        if(e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;
                            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    });
            }
    };
    
    this.deleteCategoriaTrabalhador = function(args) {
        var widget = args.owner.widget;
        widget.currentRow.__is_new = false;
        restEngine.post('product#/deleteCategoriaTrabalhador', {'requestType':'DataSet','dataset':[widget.currentRow]}).
            then(function(data){
                if(data.notifications[0].type === "success"){
                    ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                    ABUtilController.masterDetailVoltarList(widget);
                    widget.reload();
                } else {
                    ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                }
            }).
            catch(function(e) {
                var error;
                if(e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('CategoriaTrabalhadorController', CategoriaTrabalhadorController);
});

// FILE: assets/js/controllers/CategoriadetransporteController.js
function CategoriadetransporteController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, Messages) {

    this.salvarCategoriadetransporte = function(args) {
        var widget = templateManager.container.getActiveWidget();
        if (widget.isValid()) {
            if (!widget.backupRow) {
                widget.currentRow.__is_new = true;
            } else {
                widget.currentRow.__is_new = false;
            }
            restEngine.post('product#/setCategoriatransporte', {
                'requestType': 'DataSet',
                'dataset': [widget.currentRow]
            }).
            then(function(data) {
                if (data.notifications[0].type === "success") {
                    ScreenService.successNotification('Categoria de transporte salva com sucesso', 10000);
                    if (widget.currentRow.__is_new) {
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    } else {
                        ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                        widget.backupRow = null;
                        widget.view();
                    }
                } else {
                    ScreenService.showMessage('Erro ao salvar a categoria de transporte');
                }
            }).
            catch(function(e) {
                var error;
                if (e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;

                ScreenService.showMessage('Ocorreu um erro inesperado, contate o administrador informando o trecho abaixo: <br><br>' + error + '<br><br>', 'ERROR');
            });
        }
    };

    this.removerCategoriadetransporte = function(args) {
        ScreenService.confirmMessage(Messages.DELETE_ROW, 'CONFIRMATION',
            function() {


                var widget = templateManager.container.getActiveWidget();
                widget.currentRow.__is_new = false;
                restEngine.post('product#/deleteCategoriatransporte', {
                    'requestType': 'DataSet',
                    'dataset': [widget.currentRow]
                }).
                then(function(data) {
                    if (data.notifications[0].type === "success") {
                        ScreenService.successNotification('Categoria de transporte excluída com sucesso', 10000);
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    } else {
                        ScreenService.showMessage('Erro ao excluir a categoria de transporte');
                    }
                }).
                catch(function(e) {
                    var error;
                    if (e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;

                    ScreenService.showMessage('Ocorreu um erro inesperado, contate o administrador informando o trecho abaixo: <br><br>' + error + '<br><br>', 'ERROR');
                });

            });
    };

}

Configuration(function(ContextRegister) {
    ContextRegister.register('CategoriadetransporteController', CategoriadetransporteController);
});


// FILE: assets/js/controllers/CausaOcorrenciaController.js
function CausaOcorrenciaController(ScreenService, templateManager, restEngine, ABUtilController, Messages) {

	this.salvar = function(args) {
        var widget = templateManager.container.getActiveWidget();
        if (widget.isValid()) {
            if (!widget.backupRow) {
                widget.currentRow.__is_new = true;
            } else {
                widget.currentRow.__is_new = false;
            }
            restEngine.post('product#/setCausa', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                then(function (data) {
                    if (data.notifications[0].type === "success") {
                        ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                        if (widget.currentRow.__is_new) {
                            ABUtilController.masterDetailVoltarList(widget);
                            widget.reload();
                        } else {
                            ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                            widget.backupRow = null;
                            widget.view();
                        }
                    } else {
                        ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                    }
                }).
                catch(function(e) {
                    var error;
                    if(e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;

                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
        }
    };

    this.remover = function(args) {
    ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
        var widget = templateManager.container.getActiveWidget();
        if (widget.isValid()) {
            widget.currentRow.__is_new = false;
            restEngine.post('product#/deleteCausa', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                then(function (data) {
                    if (data.notifications[0].type === "success") {
                        ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    } else {
                        ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                    }
                }).
                catch(function(e) {
                    var error;
                    if(e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;

                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
            }
         }, null);
    };

}

Configuration(function(ContextRegister) {
    ContextRegister.register('CausaOcorrenciaController', CausaOcorrenciaController);
});

// FILE: assets/js/controllers/CidController.js
function CidController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, General,Messages) {
    
    this.validaFiltro = function(args){
        var widgetFiltro = templateManager.container.getActiveWidget();
        if(!widgetFiltro.currentRow.CDCID && !widgetFiltro.currentRow.DSCID){
            args.e.preventDefault();
            ScreenService.showMessage("Preencha com um CID ou uma Descrição para filtrar!");
        }
    };
    
    
    // this.validaRequiredFieldsFilterOnFocus = function(field){
    //     var widgetMain = templateManager.container.getWidget('CIDTREE');

    //     if( field === 'CDCID' && !widgetMain.__filterPopup.currentRow.DSCID){
    //         widgetMain.__filterPopup.getField(field).validations.required = true;
    //         widgetMain.__filterPopup.getField('DSCID').validations = {};
    //     }
    //     else if( field === 'DSCID' && !widgetMain.__filterPopup.currentRow.CDCID ){
    //         widgetMain.__filterPopup.getField(field).validations.required = true;
    //         widgetMain.__filterPopup.getField('CDCID').validations = {};
    //     }    
    // };

    // this.validaRequiredFieldsFilterOnBlur = function(){
    //     var widgetMain = templateManager.container.getWidget('CIDTREE');
        
    //     if( !widgetMain.__filterPopup.currentRow.CDCID && !widgetMain.__filterPopup.currentRow.DSCID ){
    //         widgetMain.__filterPopup.getField('CDCID').validations.required = true;
    //         widgetMain.__filterPopup.getField('DSCID').validations.required = true;
    //     }
    //     else if(!widgetMain.__filterPopup.currentRow.CDCID){
    //         widgetMain.__filterPopup.getField('CDCID').validations = {};
    //         widgetMain.__filterPopup.getField('DSCID').validations.required = true;
    //     }
    //     else if(!widgetMain.__filterPopup.currentRow.DSCID){
    //         widgetMain.__filterPopup.getField('CDCID').validations.required = true;
    //         widgetMain.__filterPopup.getField('DSCID').validations = {};
    //     }
    // };

}

Configuration(function(ContextRegister) {
    ContextRegister.register('CidController', CidController);
});

// FILE: assets/js/controllers/ClassificacaoController.js
function ClassificacaoController(ScreenService, templateManager, restEngine, ABUtilController, Messages) {

	this.salvar = function(args) {
        var widget = templateManager.container.getActiveWidget();
        if (widget.isValid()) {
            if (!widget.backupRow) {
                widget.currentRow.__is_new = true;
            } else {
                widget.currentRow.__is_new = false;
            }
            restEngine.post('product#/setClassificacao', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                then(function (data) {
                    if (data.notifications[0].type === "success") {
                        ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                        if (widget.currentRow.__is_new) {
                            ABUtilController.masterDetailVoltarList(widget);
                            widget.reload();
                        } else {
                            ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                            widget.backupRow = null;
                            widget.view();
                        }
                    } else {
                        ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                    }
                }).
                catch(function(e) {
                    var error;
                    if(e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;

                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
        }
    };

    this.remover = function(args) {
    ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
        var widget = templateManager.container.getActiveWidget();
        if (widget.isValid()) {
            widget.currentRow.__is_new = false;
            restEngine.post('product#/deleteClassificacao', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                then(function (data) {
                    if (data.notifications[0].type === "success") {
                        ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    } else {
                        ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                    }
                }).
                catch(function(e) {
                    var error;
                    if(e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;

                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
            }
        }, null);
    };

}

Configuration(function(ContextRegister) {
    ContextRegister.register('ClassificacaoController', ClassificacaoController);
});

// FILE: assets/js/controllers/ClassificacaoTributariaController.js
function ClassificacaoTributariaController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, General,Messages) {

    this.adicionarRow = function(args) {
        var widget = args.owner.widget;
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
    };

	this.setClassificacaoTributaria = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
                if (!widget.backupRow) {
                    widget.currentRow.__is_new = true;
                } else {
                    widget.currentRow.__is_new = false;
                }
                restEngine.post('product#/setClassificacaoTributaria', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                    then(function (data) {
                        if (data.notifications[0].type === "success") {
                            ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                            if (widget.currentRow.__is_new) {
                                ABUtilController.masterDetailVoltarList(widget);
                                widget.reload();
                            } else {
                                ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                                widget.backupRow = null;
                                widget.view();
                            }
                        } else {
                            ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                        }
                    }).
                    catch(function(e) {
                        var error;
                        if(e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;
                            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    });
            }
    };
    
    this.deleteClassificacaoTributaria = function(args) {
        var widget = args.owner.widget;
        widget.currentRow.__is_new = false;
        restEngine.post('product#/deleteClassificacaoTributaria', {'requestType':'DataSet','dataset':[widget.currentRow]}).
            then(function(data){
                if(data.notifications[0].type === "success"){
                    ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                    ABUtilController.masterDetailVoltarList(widget);
                    widget.reload();
                } else {
                    ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                }
            }).
            catch(function(e) {
                var error;
                if(e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('ClassificacaoTributariaController', ClassificacaoTributariaController);
});

// FILE: assets/js/controllers/CnaeXCidController.js

function CnaeXCidController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, General,Messages) {

    this.adicionarRow = function(args) {
        var widget = args.owner.widget;
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
    };
    
	this.setCNAExCID = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
                if (!widget.backupRow) {
                    widget.currentRow.__is_new = true;
                } else {
                    widget.currentRow.__is_new = false;
                }
                restEngine.post('product#/setCNAExCID', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                    then(function (data) {
                        if (data.notifications[0].type === "success") {
                            ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                            if (widget.currentRow.__is_new) {
                                ABUtilController.masterDetailVoltarList(widget);
                                widget.reload();
                            } else {
                                ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                                widget.backupRow = null;
                                widget.view();
                            }
                        } else {
                            ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                        }
                    }).
                    catch(function(e) {
                        var error;
                        if(e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;
                            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    });
            }
    };
    
    this.deleteCNAExCID = function(args) {
        ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
            var widget = args.owner.widget;
            widget.currentRow.__is_new = false;
            restEngine.post('product#/deleteCNAExCID', {'requestType':'DataSet','dataset':[widget.currentRow]}).
                then(function(data){
                    if(data.notifications[0].type === "success"){
                        ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    } else {
                        ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                    }
                }).
                catch(function(e) {
                    var error;
                    if(e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;
                        ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
        },null);
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('CnaeXCidController', CnaeXCidController);
});

// FILE: assets/js/controllers/ColetorController.js
function ColetorController (ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, $window, ABUtilController, Messages) {

    this.deleteColetor = function(args) {
        var widget = ABUtilController.checkWidget(args);
        var data = {}; 
        ScreenService.confirmMessage(Messages.DELETE_ROW, 'CONFIRMATION', 
            function(){
                widget.dataSource.remove(widget.currentRow).then(function (data){
                    if(data.dataset.gpeColetor_setColetor.type === "success"){
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                        ScreenService.showMessage(Messages.REMOVE_ROW_SUCCESS); 
                    } else {
                        ScreenService.showMessage(Messages.REMOVE_ROW_ERROR); 
                    }
                }.bind(this));
            }.bind(this)
        );
    };

    this.salvarColetor = function(argsrRow){
        var widget = templateManager.container.getWidget("coletores");
        if(widget.isValid())  {
            
            if (!widget.backupRow) {
                widget.currentRow.__is_new = true;
            } else {
                widget.currentRow.__is_new = false;
            }
            widget.currentRow.CDOPERADOR_LOG = getLocalVar("HCM_CDOPERADOR");
            widget.currentRow.NRORGTRAB = getLocalVar("HCM_NRORG_TRAB");
            widget.currentRow.NRORGPADRAO = getLocalVar("HCM_NRORG_PADRAO");
            widget.currentRow.DTATUAL = getLocalVar("HCM_DATA_ATUAL");
            return widget.saveRow().then(function (data){
                if (data.notifications[0].type === "success") {
                    if (widget.currentRow.__is_new) {
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    } else {
                        ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                        widget.backupRow = null;
                        widget.view();
                    }
                } else {
                    ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                }
            }.bind(this)).catch(function(e) {
                var error;
                if(e.data.error === undefined)
                    error = e;
                else 
                    error = e.data.error;
                
                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error));
            });
        }
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('ColetorController', ColetorController);
});

// FILE: assets/js/controllers/ComiteController.js
function ComiteController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, General, Messages) {

    var self = this;
    this.objActions = {
        'cadastro_automatico': {
            'name': 'cadastro_automatico',
            'label': 'Cadastro Automático',
            'fields': [
                "NRPARCNEGOCIO_LIST",
                "DTINIPARTICIPA",
                "DTFIMPARTICIPA"
            ],
            'nullable': [
                "DTINIPARTICIPA",
                "DTFIMPARTICIPA"
            ]
        }
    };
    this.selectedAction = '';

    this.openPopupCadastroAutomatico = function(widget, action) {
        var widgetFilter = templateManager.container.getWidget('filterParticipantes');
        this.selectedAction = action;
        widgetFilter.label = this.objActions[action].label;
        var actionObj = this.objActions[action];
        widgetFilter.fields.forEach(function(field) {
            if (actionObj.fields.indexOf(field.name) >= 0) {
                widgetFilter.getField(field.name).isVisible = true;
                if (actionObj.nullable.indexOf(field.name) >= 0) {
                    widgetFilter.getField(field.name).validations = {};
                } else {
                    widgetFilter.getField(field.name).validations = {
                        "required": true
                    };
                }
            } else {
                widgetFilter.getField(field.name).isVisible = false;
            }
        });
        ABUtilController.masterDetailOpenPopup(widgetFilter);
    };

    this.cadastroAutomatico = function(widget) {
        var widgetmain = templateManager.container.getWidget("comite");
        if (widget.isValid()) {
            if (this.validaPeriodo(widget.currentRow.DTINIPARTICIPA, widget.currentRow.DTFIMPARTICIPA)) {
                var action = this.selectedAction;
                widget.currentRow.action = this.selectedAction;
                widget.currentRow.NRCOMITE = widgetmain.currentRow.NRCOMITE;
                restEngine.post('product#/cadastroAutomaticoParticipanteComite', {
                    'requestType': 'DataSet',
                    'dataset': [widget.currentRow]
                }).
                then(function(data) {
                    ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 1000);
                    ABUtilController.masterDetailClosePopup(widget);
                    templateManager.container.getWidget('participantescomite').activate();
                    templateManager.container.getWidget('participantescomite').reload();
                }).
                catch(function(e) {
                    var error;
                    if (e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
            } else {
                ScreenService.showMessage(Messages.DTINI_POST_DTFIM_ERROR);
                return false;
            }
        }
    };

    this.adicionarRow = function(args) {
        var widget = args.owner.widget;
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
    };

    this.filtrarWidgetsPorComite = function(args) {
        var widget = args.owner;
        templateManager.container.getWidget("reuniao").dataSourceFilter[2].value = widget.currentRow.NRCOMITE;
        templateManager.container.getWidget("participantescomite").dataSourceFilter[2].value = widget.currentRow.NRCOMITE;
    };

    this.widgetsvisiblefalse = function(args) {
        var widget = args.owner.widget;
        widget.widgets[0].showAsTab = false;
        if (widget.widgets.length > 1) {
            widget.widgets[1].showAsTab = false;
        }
    };

    this.widgetsvisibletrue = function(args) {
        var widget = args.owner.widget;
        widget.widgets[0].showAsTab = true;
        if (widget.widgets.length > 1) {
            widget.widgets[1].showAsTab = true;
        }
    };

    this.validaPeriodo = function(dtIni, dtFin) {
        if (moment(dtIni, 'DD/MM/YYYY').unix() > moment(dtFin, 'DD/MM/YYYY').unix() || moment(dtFin, 'DD/MM/YYYY').unix() < moment(dtIni, 'DD/MM/YYYY').unix()) {
            return false;
        } else {
            return true;
        }
    };

    this.setComite = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
            if (this.validaPeriodo(widget.currentRow.DTINICOMITE, widget.currentRow.DTFIMCOMITE)) {
                if (!widget.backupRow) {
                    widget.currentRow.__is_new = true;
                } else {
                    widget.currentRow.__is_new = false;
                }
                restEngine.post('product#/setComite', {
                    'requestType': 'DataSet',
                    'dataset': [widget.currentRow]
                }).
                then(function(data) {
                    if (data.notifications[0].type === "success") {
                        ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                        if (widget.currentRow.__is_new) {
                            ABUtilController.masterDetailVoltarList(widget);
                            self.widgetsvisibletrue(args);
                            widget.reload();
                        } else {
                            ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                            widget.backupRow = null;
                            widget.view();
                        }
                    } else {
                        ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                    }
                }).
                catch(function(e) {
                    var error;
                    if (e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
            } else {
                ScreenService.showMessage(Messages.DTINI_POST_DTFIM_ERROR);
                return false;
            }
        }
    };

    this.deleteComite = function(args) {
        ScreenService.confirmMessage(Messages.DELETE_ROW, 'CONFIRMATION',
            function() {
                var widget = templateManager.container.getActiveWidget();
                if (widget.isValid()) {
                    widget.currentRow.__is_new = false;
                    restEngine.post('product#/deleteComite', {
                        'requestType': 'DataSet',
                        'dataset': [widget.currentRow]
                    }).
                    then(function(data) {
                        if (data.messages) {
                            ScreenService.showMessage(Messages.REMOVE_ROW_ERROR + '. ' + data.messages[0].message, data.messages[0].type);
                        } else {
                            ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                            ABUtilController.masterDetailVoltarList(widget);
                            widget.reload();
                        }
                    }).
                    catch(function(e) {
                        var error;
                        if (e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;

                        ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    });
                }
            });
    };

    this.setComiteParticipa = function(args) {
        var widget = args.owner.widget;
        var widgetMain = templateManager.container.getWidget("comite");
        if (widget.isValid()) {
            if (this.validaPeriodo(widget.currentRow.DTINIPARTICIPA, widget.currentRow.DTFIMPARTICIPA)) {
                if (!widget.backupRow) {
                    widget.currentRow.__is_new = true;
                } else {
                    widget.currentRow.__is_new = false;
                }
                widget.currentRow.NRCOMITE = widgetMain.currentRow.NRCOMITE;
                restEngine.post('product#/setComiteParticipa', {
                    'requestType': 'DataSet',
                    'dataset': [widget.currentRow]
                }).
                then(function(data) {
                    if (data.messages) {
                        ScreenService.showMessage('Esse Participante já está cadastrado');
                    } else {
                        if (data.notifications[0].type === "success") {
                            ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                            if (widget.currentRow.__is_new) {
                                ABUtilController.masterDetailVoltarList(widget);
                                widget.reload();
                            } else {
                                ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                                widget.backupRow = null;
                                widget.view();
                            }
                        } else {
                            ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                        }
                    }
                }).
                catch(function(e) {
                    var error;
                    if (e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
            } else {
                ScreenService.showMessage(Messages.DTINI_POST_DTFIM_ERROR);
                return false;
            }
        }
    };

    this.deleteComiteParticipa = function(args) {
        var widget = args.owner.widget;
        widget.currentRow.__is_new = false;
        restEngine.post('product#/deleteComiteParticipa', {
            'requestType': 'DataSet',
            'dataset': [widget.currentRow]
        }).
        then(function(data) {
            if (data.notifications[0].type === "success") {
                ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                ABUtilController.masterDetailVoltarList(widget);
                widget.reload();
            } else {
                ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
            }
        }).
        catch(function(e) {
            var error;
            if (e.data.error === undefined)
                error = e;
            else
                error = e.data.error;
            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
        });
    };


}

Configuration(function(ContextRegister) {
    ContextRegister.register('ComiteController', ComiteController);
});


// FILE: assets/js/controllers/ComunicadoController.js
function ComunicadoController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, General,Messages) {

    this.adicionarRow = function(args) {
        var widget = args.owner.widget;
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
    };
    
	this.setComuniocado = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
            if (ABUtilController.validaDtIniMenorIgualDtFin(widget.currentRow.DTINIVIGENCIA, widget.currentRow.DTFIMVIGENCIA)) {
                if (!widget.backupRow) {
                    widget.currentRow.__is_new = true;
                } else {
                    widget.currentRow.__is_new = false;
                }
                restEngine.post('product#/setComunicado', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                    then(function (data) {
                        if (data.notifications[0].type === "success") {
                            ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                            if (widget.currentRow.__is_new) {
                                ABUtilController.masterDetailVoltarList(widget);
                                widget.reload();
                            } else {
                                ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                                widget.backupRow = null;
                                widget.view();
                            }
                        } else {
                            ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                        }
                    }).
                    catch(function(e) {
                        var error;
                        if(e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;
                            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    });
            } else {
                ScreenService.showMessage(Messages.DTINI_POST_DTFIM_ERROR);
                return false;
            }   
        }
    };
    
    this.deleteComunicado = function(args) {
    ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
        var widget = args.owner.widget;
        widget.currentRow.__is_new = false;
        restEngine.post('product#/deleteComunicado', {'requestType':'DataSet','dataset':[widget.currentRow]}).
            then(function(data){
                if(data.notifications[0].type === "success"){
                    ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                    ABUtilController.masterDetailVoltarList(widget);
                    widget.reload();
                } else {
                    ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                }
            }).
            catch(function(e) {
                var error;
                if(e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
        }, null);
    };
    
        this.enviarComunicado = function(){
        ScreenService.confirmMessage("Enviar Comunicado por E-Mail?", null, function () {
            var widget = templateManager.container.getWidget("comunicado");
            restEngine.post("product#/enviarComunicado",
                {'requestType':'DataSet','dataset':[widget.currentRow]}
            ).then(
                function(data){
                    if(data.dataset.enviarComunicado[0] == undefined) {
                        ScreenService.showMessage('Erro ao enviar o email');
                    } else {
                        ScreenService.showMessage('Email enviado com sucesso');
                    }
                }
            ).catch(function(e) {
                var error;
                if(e.data.error === undefined)
                    error = e;
                else 
                    error = e.data.error;
                
                ScreenService.showMessage('Ocorreu um erro inesperado, contate o administrador informando o trecho abaixo: <br><br>' + error + '<br><br>', 'ERROR');
            });
        }, null);
    };
    
    this.ajustaFiltro = function(args) {
        var widget = templateManager.container.getWidget('comunicado');
        widget.dataSourceFilter.forEach(function (filtro, index, object){
            if(filtro.name == "NRESTRUTSIND"){
                filtro.value = filtro.value.forEach(function (estrut){
                        widget.dataSourceFilter.push({
                        "name": "NRESTRUTSIND",
                        "operator": "LIKE_I",
                        "value": "%"+estrut+"%"
                    });
                    
                });
                
                object.splice(index, 1);
            }
            
            if(filtro.name == "NRESTRUTLEGAL"){
                filtro.value = filtro.value.forEach(function (estrut){
                        widget.dataSourceFilter.push({
                        "name": "NRESTRUTLEGAL",
                        "operator": "LIKE_I",
                        "value": "%"+estrut+"%"
                    });
                    
                });
                object.splice(index, 1);
            }
            
            if(filtro.name == "NRESTRUTGEREN"){
                filtro.value = filtro.value.forEach(function (estrut){
                        widget.dataSourceFilter.push({
                        "name": "NRESTRUTGEREN",
                        "operator": "LIKE_I",
                        "value": "%"+estrut+"%"
                    });
                    
                });
                object.splice(index, 1);
            }
            
            if(filtro.name == "NRVINCULOM"){
                filtro.value = filtro.value.forEach(function (vinc){
                        widget.dataSourceFilter.push({
                        "name": "NRVINCULOM",
                        "operator": "LIKE_I",
                        "value": "%"+vinc+"%"
                    });
                    
                });
                object.splice(index, 1);
            }
        });
        
    };
    
    this.resetFilter = function(args){
        var widget = templateManager.container.getWidget('comunicado');
        widget.dataSourceFilter = [];
        widget.dataSourceFilter.push(
            {
                "name": "P_NRORG",
                "operator": "=",
                "value": "@getLocalVar('HCM_NRORG_TRAB') ? getLocalVar('HCM_NRORG_TRAB') : '' @"
            }
        );
        widget.dataSourceFilter.push(
            {
                "name": "P_NRORG_PADRAO",
                "operator": "=",
                "value": "@getLocalVar('HCM_NRORG_PADRAO') ? getLocalVar('HCM_NRORG_PADRAO') : '' @"
            }
        );
        
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('ComunicadoController', ComunicadoController);
});

// FILE: assets/js/controllers/CondicaoFisicaController.js
function CondicaoFisicaController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, General,Messages) {

    this.adicionarRow = function(args) {
        var widget = args.owner.widget;
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
    };

	this.setCondicaoFisica = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
                if (!widget.backupRow) {
                    widget.currentRow.__is_new = true;
                } else {
                    widget.currentRow.__is_new = false;
                }
                restEngine.post('product#/setCondicaoFisica', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                    then(function (data) {
                        if (data.notifications[0].type === "success") {
                            ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                            if (widget.currentRow.__is_new) {
                                ABUtilController.masterDetailVoltarList(widget);
                                widget.reload();
                            } else {
                                ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                                widget.backupRow = null;
                                widget.view();
                            }
                        } else {
                            ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                        }
                    }).
                    catch(function(e) {
                        var error;
                        if(e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;
                            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    });
            }
    };
    
    this.deleteCondicaoFisica = function(args) {
    ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
        var widget = args.owner.widget;
        widget.currentRow.__is_new = false;
        restEngine.post('product#/deleteCondicaoFisica', {'requestType':'DataSet','dataset':[widget.currentRow]}).
            then(function(data){
                if(data.notifications[0].type === "success"){
                    ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                    ABUtilController.masterDetailVoltarList(widget);
                    widget.reload();
                } else {
                    ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                }
            }).
            catch(function(e) {
                var error;
                if(e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
        }, null);
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('CondicaoFisicaController', CondicaoFisicaController);
});

// FILE: assets/js/controllers/ConfigCursoController.js
function ConfigCursoController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, General, Messages) {

    var self = this;

    this.adicionarRow = function(args) {
        var widget = args.owner.widget;
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
    };

    this.setConfigCurso = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
            if (!widget.backupRow) {
                widget.currentRow.__is_new = true;
            }
            else {
                widget.currentRow.__is_new = false;
            }
            restEngine.post('product#/setConfigCurso', {
                'requestType': 'DataSet',
                'dataset': [widget.currentRow]
            }).
            then(function(data) {
                if (data.notifications[0].type === "success") {
                    ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                    templateManager.container.getWidget('configCurso').reload();
                    if (widget.currentRow.__is_new) {
                        ABUtilController.masterDetailVoltarList(widget);
                        self.widgetsvisibletrue(args);
                    }
                    else {
                        ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                        widget.backupRow = null;
                        widget.view();
                    }
                }
                else {
                    ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                }
            }).
            catch(function(e) {
                var error;
                if (e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });


        }
    };

    this.deleteConfigCurso = function(args) {
    ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
        var widget = templateManager.container.getActiveWidget();
        if (widget.isValid()) {
            widget.currentRow.__is_new = false;
            restEngine.post('product#/deleteConfigCurso', {
                'requestType': 'DataSet',
                'dataset': [widget.currentRow]
            }).
            then(function(data) {
                if (data.messages) {
                    ScreenService.showMessage(Messages.REMOVE_ROW_ERROR + '. ' + data.messages[0].message, data.messages[0].type);
                }
                else {
                    ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                    ABUtilController.masterDetailVoltarList(widget);
                    templateManager.container.getWidget('configCurso').reload();
                }
            }).
            catch(function(e) {
                var error;
                if (e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;

                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
            }
        }, null);
    };


}

Configuration(function(ContextRegister) {
    ContextRegister.register('ConfigCursoController', ConfigCursoController);
});


// FILE: assets/js/controllers/ConselhoRegionalController.js
function ConselhoRegionalController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, General,Messages) {

    this.adicionarRow = function(args) {
        var widget = args.owner.widget;
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
    };

	this.setConselhoRegional = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
                if (!widget.backupRow) {
                    widget.currentRow.__is_new = true;
                } else {
                    widget.currentRow.__is_new = false;
                }
                restEngine.post('product#/setConselhoRegional', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                    then(function (data) {
                        if (data.notifications[0].type === "success") {
                            ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                            if (widget.currentRow.__is_new) {
                                ABUtilController.masterDetailVoltarList(widget);
                                widget.reload();
                            } else {
                                ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                                widget.backupRow = null;
                                widget.view();
                            }
                        } else {
                            ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                        }
                    }).
                    catch(function(e) {
                        var error;
                        if(e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;
                            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    });
            }
    };
    
    this.deleteConselhoRegional = function(args) {
    ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
        var widget = args.owner.widget;
        widget.currentRow.__is_new = false;
        restEngine.post('product#/deleteConselhoRegional', {'requestType':'DataSet','dataset':[widget.currentRow]}).
            then(function(data){
                if(data.notifications[0].type === "success"){
                    ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                    ABUtilController.masterDetailVoltarList(widget);
                    widget.reload();
                } else {
                    ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                }
            }).
            catch(function(e) {
                var error;
                if(e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
        }, null);
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('ConselhoRegionalController', ConselhoRegionalController);
});

// FILE: assets/js/controllers/ConsultaQualificaController.js
function ConsultaQualificaController(ScreenService, templateManager, restEngine, ABUtilController, Messages, General, RepositoryFactory) {

    
    this.openPopupImportacao = function() {
        var widgetPopupImportacao = templateManager.container.getWidget('popupImportacao');
        widgetPopupImportacao.currentRow.DSPATH = [];
        ScreenService.openPopup(widgetPopupImportacao);
    };


    this.importar = function(args) {
        var widget = args.owner.widget;
        var widgetPai = templateManager.container.getWidget('esocial_cqc');
        this.limparData();
        if (widget.isValid()) {
            widget.currentRow.DSPATH[0].name = this.validaArquivo(widget.currentRow.DSPATH[0].name);
            if (!!widget.currentRow.DSPATH[0].name) {
                restEngine.post('product#/importarCQC', {
                    'requestType': 'DataSet',
                    'dataset': [widget.currentRow]
                }).
                then(function(data) {
                    if (data.messages) {
                        ScreenService.showMessage(data.messages[0].message, data.messages[0].type);
                    } else if (data.notifications[0].type === "success") {
                        var esocial_cqcRepository = RepositoryFactory.factory('product#/getEsocialCQC', 'LOCAL', 1, 30000);
                        esocial_cqcRepository.save(data.dataset.getEsocialCQC).
                        then(function(){
                            ScreenService.successNotification(Messages.IMPORTACAO_SUCCESS, 10000);
                            ScreenService.closePopup(true);
                            widgetPai.reload();
                            widgetPai.activate();
                        });
                    } else {
                        ScreenService.showMessage(Messages.IMPORTACAO_ERROR);
                    }
                    
                }).
                catch(function(e) {
                    var error;
                    if (e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;

                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
            }
        }
    };
    
    this.validaArquivo = function(filePath) {
        var arrayPath = filePath.split('.');
        var extension = arrayPath.pop().toUpperCase();
        
        if (extension !== 'TXT') {
            if (extension == 'PROCESSADO' || extension == 'REJEITADO'){
                filePath = arrayPath.join(".");
                return filePath;
            }
            ScreenService.showMessage('Formato de arquivo inválido');
            return false;
        } else {
            return filePath;
        }
    };
    
    this.limparData = function(){
        var esocial_cqcRepository = RepositoryFactory.factory('product#/getEsocialCQC', 'LOCAL', 1, 30000);
        esocial_cqcRepository.clearAll();
    };
    
}

Configuration(function(ContextRegister) {
    ContextRegister.register('ConsultaQualificaController', ConsultaQualificaController);
});


// FILE: assets/js/controllers/ContaContabilController.js
var ContaContabilController = function(ScreenService, ABUtilController, templateManager, General, restEngine, ContaContabilService, Messages) {

	self = this;

	var MSG_MASCARA = 'Máscara de Conta Contábil não Cadastrada.';
	var MSG_MASCARA_NAO_EXISTE = 'Valor informado para máscara de Conta Contábil não é válida com o padrão. Favor informar apenas os dígitos \'9\' ou \'.\'';
	var MSG_EXLUIR = 'Exclusão não permitida. Existem contas contábeis relacionadas.';
	var MSG_PRENCHIMENTONIVEL = 'Conta Contábil informada com preenchimento de nível inválido.';
	var MSG_NIVELANTERIOR = 'Nível anterior da conta contábil não cadastrado.';
	var MSG_INTERVALOCONTA = 'Conta Contábil Final deve ser maior ou igual a Conta Contábil Inicial.';
	var MSG_SUCESSOCADASTRO = 'Operação realizada com sucesso.';
	var IDENTIFICADOR = {
		"A": "Ativo",
		"P": "Passivo",
		"R": "Receita",
		"D": "Despesa",
		"C": "Custo",
		"N": "Não tem"
	};

	this.contaContabilAfterMoveRow = function(args) {
		args.owner.view();
		ScreenService.openSwipe(args.owner);
		var widgetContaCorrelatas = templateManager.container.getWidget('widgetSubContas');
		args.owner.reload([], false).then(
			function(success) {
				if (!args.owner.currentRow.IDTIPOCOME) {
					args.owner.currentRow.IDTIPOCOME = ' ';
				}
				controlaWidgetContasCorrelatas(args.owner);
			}
		);
		widgetContaCorrelatas.reload();
		args.owner.getField('CDCONTCTBL').mask.params.mask = "9?.9.9.99.9999";
	};

	this.cancelar = function(widget) {
		// var formContaContabil = templateManager.container.getWidget('formContaContabil');
		var ContaContabil = templateManager.container.getWidget('ContaContabil');
		General.widgetCancelForm(widget);
		if (widget.currentRow.__is_new) {
			ScreenService.closeSwipe();
			ContaContabil.activate();
		}
		controlaWidgetContasCorrelatas(ContaContabil);
	};

	this.voltar = function(widget) {
		var ContaContabil = templateManager.container.getWidget('ContaContabil');
		ScreenService.goBack();
		ContaContabil.activate();
	};

	this.addContaContabil = function(widget) {
		General.justInteger('#CDCONTREDU');
		widget.newRow();
		ABUtilController.mudarVisibilidadeWidgets(widget.widgets, false);
		widget.currentRow = {
			"__is_new": true,
			"IDCONTCCUS": "O",
			'IDTIPOCOME': " ",
			"IDPADRREL": "N",
			"IDNATUCONT": "00",
			'CDRATEIO': '',
			'IDTIPOPESS': null,
			"CDINDPLACON": null,
			'CDCTBLINTE': null,
			'CDCONTPLANREFE': null,
			'CDCONTCTBLANALI': null,
			'CDCONTREFEAUX': null,
			'CDCONTREFEPRE': null
		};
		widget.descriptionOrder = '';
		this.controlaCamposNivelConta(widget);
		this.isVisibleCamposContasReferenciais(false);
	};

	this.verificarDelecaoContaContabil = function(widget) {
    	
		if(!getLocalVar('CDPICTCCTB')){
			this.openPopupMascara();
			return;
		}	

    	ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {

			var nivelMascara = General.getLevelByMask('CDPICTCCTB', 1);
			if (parseFloat(widget.currentRow.CDNVCONTCTBL) === nivelMascara.length) {
				deletarContaContabil(widget);
			} else {
				restEngine.post('product#/verificaExclusao', {
					"requestType": "DataSet",
					"dataset": [widget.currentRow]
				}).then(
					function(success) {
						var dataSet = success.dataset.verificaExclusao;
						if (dataSet.length === 0) {
							deletarContaContabil(widget);
						} else {
							ScreenService.showMessage(MSG_EXLUIR);
						}
					}.bind(this),
					function(callback) {
						if (callback.data) {
							ScreenService.showMessage(callback.data.error);
							}
						}
					);
				}
    	}, null);
    	
	};

	this.verificaDataField = function(field, msg) {
		field.reload().then(
			function(success) {
				if (field.dataSource.data.length === 0) {
					ScreenService.showMessage(msg);
				}
			}
		);
	};

	this.controlaCampoContaVertical = function(field) {
		var widget = field.widget;
		var campoContaVertical = widget.getField('CDCONTCTBLANALI');
		if (field.value() === 'R')
			campoContaVertical.readOnly = true;
		else
			campoContaVertical.readOnly = false;
	};

	this.controlaCamposNivelConta = function(widget) {

		if(!getLocalVar('CDPICTCCTB')){
			this.openPopupMascara();
			return;
		}	

		var campos = ['IDCONTCCUS', 'IDTIPOCOME', 'IDPADRREL', 'CDCONTPLANREFE', 'CDCONTREFEPRE', 'CDCONTREFEAUX', 'CDCONTREFEIMUISEN'];
		var nivelMascara = General.getLevelByMask('CDPICTCCTB', 1);
		var readOnly = true;
		var contaVertical = widget.getField('CDCONTCTBLANALI');

		if (parseFloat(widget.currentRow.CDNVCONTCTBL) === nivelMascara.length)
			readOnly = false;
		campos.forEach(function(campo) {
			widget.getField(campo).readOnly = readOnly;
		});


		if (widget.currentRow.CDNVCONTCTBL) {
			if (parseFloat(widget.currentRow.CDNVCONTCTBL) > 1 && widget.currentRow.IDCONTCCUS !== 'R')
				contaVertical.readOnly = false;
			else
				contaVertical.readOnly = true;
		} else {
			contaVertical.readOnly = true;
		}

	};

	var controlaWidgetContasCorrelatas = function(widget) {

		if(!getLocalVar('CDPICTCCTB')){
			this.openPopupMascara();
			return;
		}	

		var widgetContaCorrelatas = templateManager.container.getWidget('widgetSubContas');
		var nivelMascara = General.getLevelByMask('CDPICTCCTB', 1);
		if (parseFloat(widget.currentRow.CDNVCONTCTBL) === nivelMascara.length)
			widgetContaCorrelatas.enabled = true;
		else
			widgetContaCorrelatas.enabled = false;
	};

	this.validaDataContaContabil = function(field, campoData) {
		if (field.value()) {
			var widget = field.widget;
			var resul = ContaContabilService.validaDataContaContabil(widget.currentRow, campoData);
			if (!resul) {
				ScreenService.confirmMessage(ScreenService.i18n('Conta referencial com data de validade expirada. Deseja usá-la assim mesmo?'), 'question',
					function(success) {},
					function(error) {
						field.value('');
					}
				);

			}
		}
	};

	var deletarContaContabil = function(widget) {
		restEngine.post('product#/deleteContaContabil', {
			'requestType': 'DataSet',
			'dataset': [widget.currentRow]
		}).then(
			function() {
				ABUtilController.masterDetailVoltarList(widget);
				widget.reload();
			},
			function(error) {
				if (error.data && error.data.error.indexOf('ORA-02292') !== -1) {
					ScreenService.showMessage('Exclusão não permitida! O registro possui registros filhos.');
				} else {
					ScreenService.showMessage(error.data.error);
				}

			}
		);
		
	};

	this.salvarContaContabil = function(widget) {

		if(!getLocalVar('CDPICTCCTB')){
			this.openPopupMascara();
			return;
		}	

		var nivelMascara = General.getLevelByMask('CDPICTCCTB', 1);
		var ContaContabil = templateManager.container.getWidget('ContaContabil');
		// var formContaContabil = templateManager.container.getWidget('formContaContabil');
		var tipoConta = widget.currentRow.IDTIPOCOME;
		ContaContabilService.verificaValores(widget.currentRow, nivelMascara);
		restEngine.post('product#/salvarContaContabil', {
			"requestType": "DataSet",
			'dataset': [widget.currentRow]
		}).then(
			function(success) {
				controlaWidgetContasCorrelatas(ContaContabil);
				if (widget.currentRow.__is_new) {
					ABUtilController.masterDetailVoltarList(widget);
					widget.reload();
					this.isVisibleCamposContasReferenciais(true);
				} else {
					if (!widget.currentRow.IDTIPOCOME) {
						widget.currentRow.IDTIPOCOME = ' ';
					}
					widget.activate();
					widget.view();
				}
			}.bind(this),
			function(callback) {
				widget.getField('CDCONTCTBL').element.focus();
				widget.currentRow.IDTIPOCOME = tipoConta;
				if (callback.data) {
					ScreenService.showMessage(callback.data.error);
				}
			}
		);
	};

	this.salvarSubContas = function(widget) {
		var widgetPai = templateManager.container.getWidget('ContaContabil');
		if (widget.isValid()) {
			if (widget.currentRow.__is_new) {
				widget.currentRow.CDCONTCTBL = widgetPai.currentRow.CDCONTCTBL;
			}
			widget.currentRow.CDCONTACORRE = widget.currentRow.CDCONTACORRE.replace(/[^0-9]/g, '');
			restEngine.post('product#/salvarSubContas', {
				"requestType": "DataSet",
				"dataset": [widget.currentRow]
			}).then(
				function(success) {
					widget.activate();
					if (widget.currentRow.__is_new) {
						widget.list(true);
						ScreenService.goBack();
						widget.reload();
					} else {
						widget.computeDescriptionOrder();
						widget.view();
					}
				}.bind(this),
				function(callback) {
					if (callback.data) {
						ScreenService.showMessage(callback.data.error);
					}
				}
			);
		}
	};

	this.deletarSubContas = function(widget) {
		ScreenService.confirmMessage(ScreenService.i18n('Deletar Registro?'), 'question', function(success) {
			restEngine.post('product#/deletarSubContas', {
				"requestType": "DataSet",
				"dataset": [widget.currentRow]
			}).then(
				function(success) {
					ScreenService.closeSwipe().then(function() {
						widget.activate();
					});
					widget.reload();
					ScreenService.showMessage('Deletado com sucesso.');
				},
				function(error) {
					if (error.data && error.data.error.indexOf('ORA-02292') !== -1) {
						ScreenService.showMessage('Exclusão não permitida! O registro possui registros filhos.');
					} else {
						ScreenService.showMessage(error.data.error);
					}
				}
			);
		});
	};

	this.validacoesSalvarContaContabil = function(widget) {
	
		if(!getLocalVar('CDPICTCCTB')){
			this.openPopupMascara();
			return;
		}	

		if (widget.isValid()) {
	
			var cdcontctbl = widget.getField('CDCONTCTBL').value().replace(/[^0-9]/g, '');
			var nivelMascara = General.getLevelByMask('CDPICTCCTB', 1);
			if (ContaContabilService.validaPreenchimentonivel(cdcontctbl, nivelMascara)) {
				widget.currentRow.CDNVCONTCTBL = ContaContabilService.retornaNivelConta(cdcontctbl, nivelMascara);
				widget.currentRow.CDCONTANTE = ContaContabilService.retornaContaPai(cdcontctbl, widget.currentRow.CDNVCONTCTBL, nivelMascara);
				this.salvarContaContabil(widget);
			} else {
				ScreenService.showMessage(MSG_PRENCHIMENTONIVEL);
			}
		}
	};

	this.propriedadesContaContabil = function(field) {

		if(!getLocalVar('CDPICTCCTB')){
			this.openPopupMascara();
			return;
		}	

		var widget = field.widget;

		if (field.value()) {
			var cdcontctbl = field.value();
			var nivelMascara = General.getLevelByMask('CDPICTCCTB', 1);
			cdcontctbl = cdcontctbl.replace(/[^0-9]/g, '');
			var resultadoNivel = ContaContabilService.validaPreenchimentonivel(cdcontctbl, nivelMascara);

			if (resultadoNivel) {
				widget.currentRow.CDNVCONTCTBL = ContaContabilService.retornaNivelConta(cdcontctbl, nivelMascara);
				widget.currentRow.CDCONTANTE = ContaContabilService.retornaContaPai(cdcontctbl, widget.currentRow.CDNVCONTCTBL, nivelMascara);
				if (parseFloat(widget.currentRow.CDNVCONTCTBL) > 1) {
					this.controlaCamposNivelConta(widget);
					widget.currentRow.CDCONTREDU = widget.currentRow.CDCONTCTBL.replace(/[^0-9]/g, '');
				} else {
					this.controlaCamposNivelConta(widget);
					widget.currentRow.CDCONTREDU = widget.currentRow.CDCONTCTBL;
				}

			} else {
				ScreenService.showMessage(MSG_PRENCHIMENTONIVEL);
				widget.currentRow.CDCONTANTE = null;
				widget.currentRow.CDNVCONTCTBL = null;
				this.controlaCamposNivelConta(widget);
			}
		} else {
			widget.currentRow.CDCONTANTE = null;
			widget.currentRow.CDNVCONTCTBL = null;
		}
	};

	this.validacoesCadastramentoAutomatico = function(widget) {
		if (widget.isValid()) {
			switch (widget.currentRow.TIPOCADASTRO) {
				case '1':
					if (ContaContabilService.validaIntervaloContas(widget.currentRow.P_CONTAINICIAL, widget.currentRow.P_CONTAFINAL)) {
						ScreenService.confirmMessage(ScreenService.i18n("Confirma o cadastramento automático do Indentificador Padrão '" + IDENTIFICADOR[widget.currentRow.P_IDPADRREL] + "' para as Contas Contábeis informadas ?"), 'question',
							function(success) {
								widget.currentRow.P_CONTAINICIAL = widget.currentRow.P_CONTAINICIAL.replace(/[^0-9]/g, '');
								widget.currentRow.P_CONTAFINAL = widget.currentRow.P_CONTAFINAL.replace(/[^0-9]/g, '');
								salvarCadastramentoAutomatico(widget);
							}
						);
					} else {
						ScreenService.showMessage(MSG_INTERVALOCONTA);
					}
					break;
				case '2':
					if (ContaContabilService.validaIntervaloContas(widget.currentRow.P_CONTAINICIAL, widget.currentRow.P_CONTAFINAL)) {
						ScreenService.confirmMessage(ScreenService.i18n("Deseja cadastrar a conta base informada para ser utilizada na Análise Vertical para o intervalo de contas informado ?"), 'question',
							function(success) {
								widget.currentRow.P_CONTAINICIAL = widget.currentRow.P_CONTAINICIAL.replace(/[^0-9]/g, '');
								widget.currentRow.P_CONTAFINAL = widget.currentRow.P_CONTAFINAL.replace(/[^0-9]/g, '');
								salvarCadastramentoAutomatico(widget);
							}
						);
					} else {
						ScreenService.showMessage(MSG_INTERVALOCONTA);
					}
					break;
				case '3':
					ScreenService.confirmMessage(ScreenService.i18n("Confirma a alteração de todas as contas contábeis parametrizadas com esta conta referencial " + widget.currentRow.P_CONTANTIGA + ", para está conta referencial " + widget.currentRow.P_CONTNOVA + " ?"), 'question',
						function(success) {
							salvarCadastramentoAutomatico(widget);
						}
					);
					break;
			}
		}
	};

	var salvarCadastramentoAutomatico = function(widget) {
		var ContaContabil = templateManager.container.getWidget('ContaContabil');
		if (widget.isValid()) {
			restEngine.post('product#/salvarCadastramentoAutomatico', {
				"requestType": "DataSet",
				"dataset": [widget.currentRow]
			}).then(
				function(success) {
					ScreenService.closePopup();
					ContaContabil.activate();
					ContaContabil.reload();
					ScreenService.showMessage(MSG_SUCESSOCADASTRO);

				}.bind(this),
				function(callback) {
					if (callback.data) {
						ScreenService.showMessage(callback.data.error);
					}
				}
			);
		}
	};

	this.controlaCamposCadastramentoAutomatico = function(widget) {
		var camposTipo1 = ['P_CONTAINICIAL', 'P_CONTAFINAL', 'P_IDPADRREL'];
		var camposTipo2 = ['P_CONTAINICIAL', 'P_CONTAFINAL', 'P_CONTABASE'];
		var camposTipo3 = ['P_CONTANTIGA', 'P_CONTNOVA', 'TIPOCONTA'];
		var campoAntigo = widget.getField('P_CONTANTIGA');
		var campoNovo = widget.getField('P_CONTNOVA');

		switch (widget.getField('TIPOCADASTRO').value()) {
			case '1':
				this.statusField(camposTipo2, widget, false);
				this.statusField(camposTipo3, widget, false);
				this.statusField(camposTipo1, widget, true);
				break;
			case '2':
				this.statusField(camposTipo1, widget, false);
				this.statusField(camposTipo3, widget, false);
				this.statusField(camposTipo2, widget, true);
				break;
			case '3':
				widget.currentRow.TIPOCONTA = 'ECD';
				campoAntigo.dataSource.name = 'ger#/crud/contrefe';
				campoNovo.dataSource.name = 'ger#/crud/contrefe';
				this.statusField(camposTipo1, widget, false);
				this.statusField(camposTipo2, widget, false);
				this.statusField(camposTipo3, widget, true);
				break;
		}
	};

	this.statusField = function(nomesFileds, widget, visibilidade) {
		nomesFileds.forEach(function(nome) {
			widget.getField(nome).isVisible = visibilidade;
			if (visibilidade)
				widget.getField(nome).validations.required = true;
			else
				delete(widget.getField(nome).validations.require);

		});

	};

	this.controlaTipoContaReferencial = function(field) {
		var widget = field.widget;
		var campoAntigo = widget.getField('P_CONTANTIGA');
		var campoNovo = widget.getField('P_CONTNOVA');
		if (field.value() === 'ECD') {
			campoAntigo.dataSource.name = 'ger#/crud/contrefe';
			campoNovo.dataSource.name = 'ger#/crud/contrefe';
		} else if (field.value() === 'AUX') {
			campoAntigo.dataSource.name = 'ctb#/crud/contrefeaux_contacontabil';
			campoNovo.dataSource.name = 'ctb#/crud/contrefeaux_contacontabil';
		}
		campoAntigo.value('');
		campoNovo.value('');
	};

	this.openPopupMascara = function(){
		var widgetMascara = templateManager.container.getWidget('popupMascara');
		ScreenService.openPopup(widgetMascara);
	};
	
	this.salvaMascara = function(widget){
		var mascara = widget.currentRow.CDPICTCCTB;
		
		if(widget.isValid()){
			if(this.validaSeMascaraInformadaExiste(mascara)){
				restEngine.post('product#/salvaMascara', {
					"requestType": "DataSet",
					"dataset": [widget.currentRow]
				}).then(function(data) {
					var novaMascara = data.dataset.MASCARA.CDPICTCCTB;
				    ScreenService.closePopup();
				    templateManager.container.getWidget('ContaContabil').activate();
				    this.setMascara(novaMascara);
				}.bind(this));
			} else {
				ScreenService.showMessage(MSG_MASCARA_NAO_EXISTE);
			}
		}
	};
	
	this.getMascara = function(){
		var widgetContaContabil = templateManager.container.getWidget('ContaContabil');
		var fieldMascara = widgetContaContabil.getField('CDCONTCTBL');
		restEngine.post('product#/getMascara', {
			"requestType": "FilterData"
		}).then(function(data) {
				if(data && data.dataset){
					var mask = data.dataset.MASCARA.CDPICTCCTB;
					if(mask){
						fieldMascara.mask.params.mask = mask;
					} else {
						fieldMascara.mask.params.mask = "9?.9.9.99.9999";
					}
				}
			}.bind(this)
		);
	};
	
	this.setMascara = function(mascara){
		var widgetContaContabil = templateManager.container.getWidget('ContaContabil');
		var fieldMascara = widgetContaContabil.getField('CDCONTCTBL');
	    ABUtilController.atualizaValorStringLocalStorage('CDPICTCCTB', mascara); 
		fieldMascara.mask.params.mask = mascara;
		widgetContaContabil.redraw();
	};
	
	this.isVisibleCamposContasReferenciais = function(op){
		var widget = templateManager.container.getWidget('ContaContabil');
		var campos = ['CDCONTPLANREFE', 'CDCONTREFEPRE', 'CDCONTREFEAUX', 'CDCONTREFEIMUISEN', 'IDNATUCONT'];
		
		campos.forEach(function(campo) {
		    widget.getField(campo).isVisible = op;
		});
		
		widget.reload();
	};
	
	this.validaSeMascaraInformadaExiste = function(mascara){
		mascara = mascara.split('');
		var flagMascaraExiste = true;
		mascara.forEach(function(mascara){
			if(mascara != '.' && mascara != '9'){
				flagMascaraExiste = false;
			}
		}.bind(this.validaSeMascaraInformadaExiste));
		return flagMascaraExiste;
	};
};

Configuration(function(ContextRegister) {
	ContextRegister.register('ContaContabilController', ContaContabilController);
});


// FILE: assets/js/controllers/ContabilizacaoMensalController.js
function ContabilizacaoMensal(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, $window, ABUtilController, Messages) {

    this.openPopup = function(dataSet) {
        var widgetDemonstrativo = templateManager.container.getWidget('demostrativoContabil');

        if (dataSet.contabil) {
            widgetDemonstrativo.dataSource.data = dataSet.contabil;
            widgetDemonstrativo.getField('ESTRUTURA').isVisible = false;
            widgetDemonstrativo.getField('CONTA').isVisible = true;
            widgetDemonstrativo.getField('TIPO').isVisible = true;
            widgetDemonstrativo.getField('DESPESA').isVisible = false;
            widgetDemonstrativo.getField('HISTORICO').isVisible = true;
            widgetDemonstrativo.dataSource.data.push({
                'ESTRUTURASUP': null,
                'CONTA': null,
                'TIPO': null,
                'HISTORICO': null,
                'VALOR': null
            });
            widgetDemonstrativo.dataSource.data.push({
                'ESTRUTURASUP': 'Total - Conta de Crédito',
                'CONTA': null,
                'TIPO': null,
                'HISTORICO': null,
                'VALOR': dataSet.credito
            }, {
                'ESTRUTURASUP': 'Total - Conta de Débito',
                'CONTA': null,
                'TIPO': null,
                'HISTORICO': null,
                'VALOR': dataSet.debito
            });
        } else if (dataSet.despesas) {
            widgetDemonstrativo.dataSource.data = dataSet.despesas;
            widgetDemonstrativo.getField('ESTRUTURA').isVisible = true;
            widgetDemonstrativo.getField('CONTA').isVisible = false;
            widgetDemonstrativo.getField('TIPO').isVisible = false;
            widgetDemonstrativo.getField('DESPESA').isVisible = true;
            widgetDemonstrativo.getField('HISTORICO').isVisible = false;
            widgetDemonstrativo.dataSource.data.push({
                'ESTRUTURASUP': null,
                'CONTA': null,
                'TIPO': null,
                'HISTORICO': null,
                'VALOR': null
            });
            widgetDemonstrativo.dataSource.data.push({
                'ESTRUTURASUP': 'Total - Despesas',
                'CONTA': null,
                'TIPO': null,
                'HISTORICO': null,
                'VALOR': dataSet.totaldes
            });
        }
        ScreenService.openPopup(widgetDemonstrativo);
    };

    this.deleteFormContabil = function(args) {
        var widget = args.owner.widget;
        if(widget.isValid()){
            ScreenService.confirmMessage('Deseja realmente excluir essa contabilização mensal?', 'CONFIRMATION',
                function() {
                widget.currentRow.__is_new = false;
                restEngine.post('product#/deleteFormContabil', {
                    'requestType': 'DataSet',
                    'dataset': [widget.currentRow]
                }).
                then(function(data) {
                    if (data.notifications[0].type === "success") {
                        ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    } else {
                        ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                    }
                }).
                catch(function(e) {
                    var error;
                    if (e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
            });
        }
    };
    
    this.gravacaoApolo = function(args) {
        var widget = ABUtilController.checkWidget(args);
        ScreenService.confirmMessage('Deseja realmente gravar a contabilização?', 'CONFIRMATION',
            function() {
                widget.currentRow.TP_PROCESSAMENTO = 'CALCULO_APOLO_GRAVAR';
                widget.currentRow.TP_CALCULO = 12;
                restEngine.post("product#/calculoApolo", {
                    'requestType': 'DataSet',
                    'dataset': [widget.currentRow]
                }).then(function(data) {
                    if (data.messages) {
                        ScreenService.showMessage(data.messages[0].message);
                        ScreenService.closePopup();
                    }
                }).catch(function(e) {
                    var error;
                    if (e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;

                    ScreenService.showMessage('Ocorreu um erro inesperado, contate o administrador informando o trecho abaixo: <br><br>' + error + '<br><br>', 'ERROR');
                });
            }.bind(this));
    };
    
    this.gravacaoDefinitivaCalculo = function(args) {
        var widget = ABUtilController.checkWidget(args);
        ScreenService.confirmMessage('Deseja realmente gravar?', 'CONFIRMATION',
            function() {
                widget.currentRow.TP_PROCESSAMENTO = 'CALCULO';
                restEngine.post("product#/calculoContabilizacao", {
                        'requestType': 'DataSet',
                        'dataset': [widget.currentRow]
                    },
                    function(data) {
                        if (data.dataset) {
                            if (data.dataset.contabilizacao.msg) {
                                ScreenService.showMessage(data.dataset.contabilizacao.msg);
                                ScreenService.closePopup();
                            } else if (data.dataset.contabilizacao.contabil || data.dataset.contabilizacao.despesas) {
                                ScreenService.closePopup();
                                this.openPopup(data.dataset.contabilizacao);
                                ScreenService.showMessage('Gravado com sucesso');
                            } else {
                                ScreenService.showMessage('Não foram encontrados dados para a contabilização');
                                ScreenService.closePopup();
                            }
                        } else {
                            if(data.messages){
                                data.messages.forEach(function(mensagem) {
                                    ScreenService.showMessage('Erro ao gravar definitivamente contabilização: <br>' + mensagem.message);
                                });
                            } else if(data.error){
                                ScreenService.showMessage('Erro ao gravar definitivamente contabilização: <br>' + data.error);
                            } else {
                                ScreenService.showMessage('Não foi possível gravar definitivamente contabilização');
                            }
                        }
                    }.bind(this), undefined,
                    function(e) {
                        var error;
                        if (e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;

                        ScreenService.showMessage('Ocorreu um erro inesperado, contate o administrador informando o trecho abaixo: <br><br>' + error + '<br><br>', 'ERROR');
                    }
                );
            }.bind(this));
    };
    
    this.gravacaoDefinitivaCalculoLite = function(args) {
        var widget = ABUtilController.checkWidget(args);
        if (widget.currentRow.IDFORMACONTAB == 'C') {
            ScreenService.confirmMessage('Deseja realmente gravar?', 'CONFIRMATION',
                function() {
                    widget.currentRow.TP_PROCESSAMENTO = 'CALCULO';
                    restEngine.post("product#/calculoContabilizacaoLite", {
                            'requestType': 'DataSet',
                            'dataset': [widget.currentRow]
                        },
                        function(data) {
                            if (data.dataset) {
                                if (data.dataset.contabilizacao.msg) {
                                    ScreenService.showMessage(data.dataset.contabilizacao.msg);
                                    ScreenService.closePopup();
                                } else if (data.dataset.contabilizacao.contabil || data.dataset.contabilizacao.despesas) {
                                    ScreenService.showMessage('Gravado com sucesso');
                                    ScreenService.closePopup();
                                } else {
                                    ScreenService.showMessage('Não foram encontrados dados para a contabilização');
                                    ScreenService.closePopup();
                                }
                            } else {
                                if(data.messages){
                                    data.messages.forEach(function(mensagem) {
                                        ScreenService.showMessage('Erro ao gravar definitivamente contabilização: <br>' + mensagem.message);
                                    });
                                } else if(data.error){
                                    ScreenService.showMessage('Erro ao gravar definitivamente contabilização: <br>' + data.error);
                                } else {
                                    ScreenService.showMessage('Não foi possível gravar definitivamente contabilização');
                                }
                            }
                        }.bind(this), undefined,
                        function(e) {
                            var error;
                            if (e.data.error === undefined)
                                error = e;
                            else
                                error = e.data.error;
    
                            ScreenService.showMessage('Ocorreu um erro inesperado, contate o administrador informando o trecho abaixo: <br><br>' + error + '<br><br>', 'ERROR');
                        }
                    );
                }.bind(this));
        } else {
            ScreenService.showMessage("A opção 'Gravação Definitiva (Otimizada)' só pode ser acionada para forma de contabilização 'Gera Contabilização'", 'ERROR');
        }
    };

    this.retrocessoCalculo = function(args) {
        var widget = ABUtilController.checkWidget(args);
        ScreenService.confirmMessage('Deseja realmente retroceder?', 'CONFIRMATION',
            function() {
                widget.currentRow.TP_PROCESSAMENTO = 'RETROCESSO';
                restEngine.post("product#/calculoContabilizacao", {
                    'requestType': 'DataSet',
                    'dataset': [widget.currentRow]
                }).then(function(data) {
                    if (data) {
                        ScreenService.showMessage('Retrocedido com sucesso');
                        ScreenService.closePopup();
                    }
                }).catch(function(e) {
                    var error;
                    if (e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;

                    ScreenService.showMessage('Ocorreu um erro inesperado, contate o administrador informando o trecho abaixo: <br><br>' + error + '<br><br>', 'ERROR');
                });
            }.bind(this));
    };

    this.simularCalculo = function(args) {
        var widget = ABUtilController.checkWidget(args);
        ScreenService.confirmMessage('Deseja realmente simular?', 'CONFIRMATION',
            function() {
                widget.currentRow.TP_PROCESSAMENTO = 'SIMULACAO';
                restEngine.post("product#/calculoContabilizacao", {
                        'requestType': 'DataSet',
                        'dataset': [widget.currentRow]
                    },
                    function(data) {
                        if (data.dataset) {
                            if (data.dataset.contabilizacao.msg) {
                                ScreenService.showMessage(data.dataset.contabilizacao.msg);
                                ScreenService.closePopup();
                            } else if (data.dataset.contabilizacao.contabil || data.dataset.contabilizacao.despesas) {
                                ScreenService.closePopup();
                                this.openPopup(data.dataset.contabilizacao);
                            } else {
                                ScreenService.showMessage('Não foram encontrados dados para a contabilização');
                                ScreenService.closePopup();
                            }
                        } else if (data.error) {
                            ScreenService.showMessage(data.error);
                        } else {
                            data.messages.forEach(function(mensagem) {
                                ScreenService.showMessage('Erro ao simular cálculo: <br>:' + mensagem.message);
                            });
                        }
                    }.bind(this), undefined,
                    function(e) {
                        var error;
                        if (e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;

                        ScreenService.showMessage('Ocorreu um erro inesperado, contate o administrador informando o trecho abaixo: <br><br>' + error + '<br><br>', 'ERROR');
                    }
                );
            }.bind(this));
    };

    this.setFormContabil = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
            if (ABUtilController.validaCritSelecao(widget.currentRow)) {
                
                if (widget.currentRow.DSORDEM == 'LISTA_VINCULO' && widget.currentRow.NRVINCULOM_LIST && widget.currentRow.NRVINCULOM_LIST.length > 200) {
                    ScreenService.showMessage("Favor selecionar um máximo de 200 vínculos na lista ou usar outro filtro como por exemplo por estrutura legal.");
                    return;
                }

                if (!widget.backupRow) {
                    widget.currentRow.__is_new = true;
                } else {
                    widget.currentRow.__is_new = false;
                }
                restEngine.post('product#/setFormContabil', {
                    'requestType': 'DataSet',
                    'dataset': [widget.currentRow]
                }).
                then(function(data) {
                    if (data.notifications[0].type === "success") {
                        ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                        if (widget.currentRow.__is_new) {
                            ABUtilController.masterDetailVoltarList(widget);
                            widget.reload();
                        } else {
                            ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                            widget.backupRow = null;
                            widget.view();
                        }
                    } else {
                        ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                    }
                }).
                catch(function(e) {
                    var error;
                    if (e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });

            }
        }
    };

}

Configuration(function(ContextRegister) {
    ContextRegister.register('ContabilizacaoMensal', ContabilizacaoMensal);
});


// FILE: assets/js/controllers/ControleAptidaoController.js
function ControleAptidaoController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, General,Messages) {

    this.adicionarRow = function(args) {
        var widget = args.owner.widget;
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
    };
    
	this.setControleapt = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
                if (!widget.backupRow) {
                    widget.currentRow.__is_new = true;
                } else {
                    widget.currentRow.__is_new = false;
                }
                restEngine.post('product#/setControleapt', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                    then(function (data) {
                        if (data.notifications[0].type === "success") {
                            ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                            if (widget.currentRow.__is_new) {
                                ABUtilController.masterDetailVoltarList(widget);
                                widget.reload();
                            } else {
                                ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                                widget.backupRow = null;
                                widget.view();
                            }
                        } else {
                            ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                        }
                    }).
                    catch(function(e) {
                        var error;
                        if(e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;
                            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    });
            }
    };
    
    this.deleteControleapt = function(args) {
    ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
        var widget = args.owner.widget;
        widget.currentRow.__is_new = false;
        restEngine.post('product#/deleteControleapt', {'requestType':'DataSet','dataset':[widget.currentRow]}).
            then(function(data){
                if(data.notifications[0].type === "success"){
                    ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                    ABUtilController.masterDetailVoltarList(widget);
                    widget.reload();
                } else {
                    ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                }
            }).
            catch(function(e) {
                var error;
                if(e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
        },null);
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('ControleAptidaoController', ControleAptidaoController);
});

// FILE: assets/js/controllers/CriterioResultadoController.js
function CriterioResultadoController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, General,Messages) {
    
    var self = this;
    var idFiltrarWidgetMain;
    var nmFiltrarWidgetMain;
    var nomeVerifica;
    
    
    this.adicionarRow = function(args) {
        var widget = args.owner.widget;
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
    };
    this.openFilterOnOpen = function(){
        templateManager.container.openPopup('FilterPrincipal');
    };

    this.idFaixaFieldOnChangeAndAfterMoveRow = function(args){
        var ID = templateManager.container.getActiveWidget('faixaCritResult').currentRow.IDFAIXACRIRESUL;
        if(ID == 'ENTRE'){
            templateManager.container.getWidget("faixaCritResult").getField("VRINIFAIXARESUL").label = 'Valor inicial';
            templateManager.container.getWidget("faixaCritResult").getField("VRFINFAIXARESUL").readOnly = false;
        }else{
            templateManager.container.getWidget("faixaCritResult").getField("VRINIFAIXARESUL").label = 'Valor';
            templateManager.container.getWidget("faixaCritResult").getField("VRFINFAIXARESUL").readOnly = true;
            templateManager.container.getActiveWidget('faixaCritResult').currentRow.VRFINFAIXARESUL = 0;
        }
        templateManager.container.getActiveWidget('faixaCritResult').reload();
    };

    
    this.filtrarWidgetMain = function(widget){
        if(idFiltrarWidgetMain){
            widget.dataSourceFilter[2] = 
                {
                    "name": "NRCRITERIORESUL",
                    "operator": "=",
                    "value": idFiltrarWidgetMain
                };  
        }else{
            widget.dataSourceFilter[2] = 
            {
                "name": "NRCRITERIORESUL",
                "operator": ">",
                "value": 0
            };  
        }
        if(nmFiltrarWidgetMain !== nomeVerifica){
            widget.reload();
            ScreenService.closeSwipe();
            nomeVerifica = nmFiltrarWidgetMain; 
        }
        if(nmFiltrarWidgetMain !== 'Críterio de Resultado'){
            widget.actions[0].isVisible = false;
            templateManager.containers['product#hcm03003_avl_criterioResultado'].label = 'Críterio de Resultado - '+ nmFiltrarWidgetMain;
        }else{
            widget.actions[0].isVisible = true;
            templateManager.containers['product#hcm03003_avl_criterioResultado'].label = 'Críterio de Resultado';
        }
        
    };
    
    this.parametrofiltrarWidgetMain = function(id, nm){
        idFiltrarWidgetMain = id;
        nmFiltrarWidgetMain = nm;
        if(templateManager.containers['product#hcm01003_fpa_tabelaReferencia']){
            var widget = templateManager.containers['product#hcm01003_fpa_tabelaReferencia'].getWidget('tabelafolha');
            this.filtrarWidgetMain(widget);
        }    
    };
    
    this.adicionarRowFaixaCritResult = function(args) {
        var widget = args.owner.widget;
        var widgetMain = templateManager.container.getWidget("criterioResultado");
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
        widget.currentRow.NRCRITERIORESUL = widgetMain.currentRow.NRCRITERIORESUL;
    };
    
    this.faixaAfterMoveRow = function(widget){
        if(widget.currentRow.IDFAIXACRIRESUL == 'ENTRE'){
            widget.getField("VRINIFAIXARESUL").label = 'Valor inicial';
            widget.getField("VRFINFAIXARESUL").readOnly = false;
        }else{
            widget.getField("VRINIFAIXARESUL").label = 'Valor';
            widget.getField("VRFINFAIXARESUL").readOnly = true;
            widget.currentRow.VRFINFAIXARESUL = 0;
        }
        widget.reload();
    };
    
    this.filtrarWidgetPorCriterioResultado = function(args){
        var widget = args.owner;
        templateManager.container.getWidget("faixaCritResult").dataSourceFilter[0].value = widget.currentRow.NRCRITERIORESUL;
        templateManager.container.getWidget("faixaCritResult").dataSourceFilter[1].value = widget.currentRow.NRORG;
        templateManager.container.getWidget("faixaCritResult").reload();
    };
    
    this.widgetsvisiblefalse = function(args) {
        var widget = args.owner.widget;
        widget.widgets[0].showAsTab = false;
    };

    this.widgetsvisibletrue = function(args) {
        var widget = args.owner.widget;
        widget.widgets[0].showAsTab = true;
    };
    
	this.setCriterioResultado = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
                if (!widget.backupRow) {
                    widget.currentRow.__is_new = true;
                } else {
                    widget.currentRow.__is_new = false;
                }
                restEngine.post('product#/setCriterioResultado', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                    then(function (data) {
                        if (data.notifications[0].type === "success") {
                            ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                            if (widget.currentRow.__is_new) {
                                ABUtilController.masterDetailVoltarList(widget);
                                self.widgetsvisibletrue(args);
                                widget.reload();
                            } else {
                                ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                                widget.backupRow = null;
                                widget.view();
                            }
                        } else {
                            ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                        }
                    }).
                    catch(function(e) {
                        var error;
                        if(e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;
                            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    });
            
        }
    };
    
    this.deleteCriterioResultado = function(args) {
        var widget = args.owner.widget;
        
        widget.currentRow.__is_new = false;
        widget.currentRow.FAIXAS = null;
        
        ScreenService.confirmMessage(Messages.DELETE_ROW, 'CONFIRMATION', function(){
        restEngine.post('product#/deleteCriterioResultado', {'requestType': 'DataSet', 'dataset': [widget.currentRow]})
            .then(function (data) {
                if(data.notifications && data.notifications[0].type === "success"){
                    ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                    ABUtilController.masterDetailVoltarList(widget);
                    widget.reload();
                }else if(data.messages && data.messages[0].type === "W"){
                    ScreenService.confirmMessage(data.messages[0].message, 'CONFIRMATION', function(){
                        widget.currentRow.FAIXAS = data.dataset.faixas;
                            restEngine.post('product#/deleteCriterioResultado', {'requestType': 'DataSet', 'dataset': [widget.currentRow]})
                                .then(function(data) {
                                    if(data.notifications && data.notifications[0].type === "success"){
                                        ScreenService.successNotification(data.notifications[0].message, 10000);
                                        ABUtilController.masterDetailVoltarList(widget);
                                        widget.reload();    
                                    }
                                    
                                }.bind(this))
                                
                                .catch(function(e) {
                                    if(e.data.errorCode == 5){
                                        ScreenService.showMessage(e.data.error, 'ERROR');
                                    } else {
                                        var error;
                                        if(e.data.error === undefined)
                                            error = e;
                                        else
                                            error = e.data.error;
                                        ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                                    }
                                });
                    });
                } else {
                    ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                }
            })
            .catch(function(e) {
                if(e.data.errorCode == 5){
                    ScreenService.showMessage(e.data.error, 'ERROR');
                } else {
                    var error;
                    if(e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                }
            });
        }.bind(this));   
    };
    
	this.setFaixaCritResult = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
            if((widget.currentRow.VRFINFAIXARESUL >= widget.currentRow.VRINIFAIXARESUL) || widget.currentRow.IDFAIXACRIRESUL != 'ENTRE'){
            
            
                if (!widget.backupRow) {
                    widget.currentRow.__is_new = true;
                } else {
                    widget.currentRow.__is_new = false;
                }
                restEngine.post('product#/setFaixaCritResult', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                    then(function (data) {
                        if (data.notifications[0].type === "success") {
                            ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                            if (widget.currentRow.__is_new) {
                                ABUtilController.masterDetailVoltarList(widget);
                                widget.reload();
                            } else {
                                ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                                widget.backupRow = null;
                                widget.view();
                            }
                        } else {
                            ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                        }
                    }).
                    catch(function(e) {
                        var error;
                        if(e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;
                            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    });
        
            }
            else{
                ScreenService.showMessage("O valor inicial deve ser menor ou igual ao valor final");
            }
        }
    };
    
    this.deleteFaixaCritResult = function(args) {
        ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
            var widget = args.owner.widget;
            widget.currentRow.__is_new = false;
            restEngine.post('product#/deleteFaixaCritResult', {'requestType':'DataSet','dataset':[widget.currentRow]}).
                then(function(data){
                    if(data.notifications[0].type === "success"){
                        ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    } else {
                        ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                    }
                }).
                catch(function(e) {
                    var error;
                    if(e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;
                        ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
        }, null);
    };
}


Configuration(function(ContextRegister) {
    ContextRegister.register('CriterioResultadoController', CriterioResultadoController);
});

// FILE: assets/js/controllers/CriterioSelecaoController.js
/* jshint esversion: 6 */
function CriterioSelecaoController(ScreenService, templateManager, restEngine, ABUtilController, Messages, CalculoValeTransporteService) {
    /*global Util*/
    this.ALFABETICA_CAMPOS = ['NMINIVINCULOM', 'NMFIMVINCULOM'];
    this.ESTRUTURA_CAMPOS = ['NMESTRUTLEGAL', 'NMESTRUTGEREN'];
    this.DATA_ADMISSAO_CAMPOS = ['DTINIADMISSAO', 'DTFIMADMISSAO'];
    this.DATA_RESCISAO_CAMPOS = ['DTINIRESCISAO', 'DTFIMRESCISAO', 'NMESTRUTLEGAL', 'NMESTRUTGEREN'];
    this.MATRICULA_CAMPOS = ['CDINIMATRICULA', 'CDFIMMATRICULA'];
    this.LISTA_VINCULO_CAMPOS = ['NRVINCULOM_LIST'];
    this.LISTA_ESTRUTURA_CAMPOS = ['LIST_NRESTRUTLEGAL', 'LIST_NRESTRUTGEREN'];
    this.ESTRUT_SINDICAL_CAMPOS = ['LIST_NRESTRUTLEGAL', 'LIST_NRESTRUTSIND'];
    this.ESTRUT_ALFABETICA_TPVINC_CAMPOS = ['LIST_NRESTRUTLEGAL', 'LIST_NRESTRUTGEREN', 'NMVINCULOM_INI', 'NMVINCULOM_FIM', 'NRTIPOVINCULO'];    
    this.TIPO_HIERARQUIA_CAMPOS = ['NMTPHIERARQORG', 'LIST_NRESTRUTURAMSUP', 'LIST_NRESTRUTURAMREL'];
    this.LISTA_OCUPACAO_CAMPOS =['LIST_NROCUPACAOM'];
    this.LISTA_BANCOS_CAMPOS = ['LIST_CDBANCO'];
    this.LISTA_BENEFICIO_CAMPOS = ['LIST_NRBENEFICIOM'];
    
    this.NMVINCULOM = 'NMVINCULOM';
    this.CDMATRICULA = 'CDMATRICULA';
    this.DTADMISSAOVINC = 'DTADMISSAOVINC';
    this.DTRESCISAOVINC = 'DTRESCISAOVINC';
    this.NRESTRUTLEGAL = 'NRESTRUTLEGAL';
    this.LISTA_VINCULO = 'LISTA_VINCULO';
    this.LISTA_ESTRUTURA = 'LISTA_ESTRUTURA';
    this.LISTA_SINDICAL = 'LISTA_NRESTRUTSIND';
    this.ESTRUT_ALFABETICA_TPVINC = 'ESTRUT_ALFABETICA_TPVINC';
    this.TIPO_HIERARQUIA = 'TIPO_HIERARQUIA';
    this.LISTA_OCUPACAO = 'LISTA_OCUPACAO';
    this.LISTA_BANCOS = 'LISTA_BANCOS';
    this.LISTA_BENEFICIO = 'LISTA_BENEFICIO';
    
    this.DSINICIO = ['NMESTRUTLEGAL', 'NMINIVINCULOM', 'DTINIADMISSAO', 'CDINIMATRICULA', 'NRVINCULOM', 'LIST_NRESTRUTLEGAL', 'NRVINCULOM_LIST', 'NMTPHIERARQORG', 'LIST_NROCUPACAOM', 'LIST_CDBANCO', 'LIST_NRBENEFICIOM'];
    this.DSFIM = ['NMESTRUTGEREN', 'NMFIMVINCULOM', 'DTFIMADMISSAO', 'CDFIMMATRICULA', 'LIST_NRESTRUTGEREN', 'LIST_NRESTRUTSIND'];
    this.DSINICIO2 = ['NMVINCULOM_INI', 'LIST_NRESTRUTURAMSUP'];
    this.DSFIM2 = ['NMVINCULOM_FIM', 'LIST_NRESTRUTURAMREL'];
    this.DSINICIO3 = ['NRTIPOVINCULO'];
    this.DSFIM3 = [];
    this.DTINICIAL = ['DTINIRESCISAO'];
    this.DTFINAL = ['DTFIMRESCISAO'];
    
    // variaveis globais auxiliares
    this.tpHierarquiaAntigo = null;
    

    this.habilitaCamposOrdem = function(widget, arrayCampos) {
        this.ALFABETICA_CAMPOS.concat(this.ESTRUTURA_CAMPOS, this.DATA_ADMISSAO_CAMPOS, this.DATA_RESCISAO_CAMPOS, this.MATRICULA_CAMPOS, this.LISTA_VINCULO_CAMPOS, this.LISTA_ESTRUTURA_CAMPOS, this.ESTRUT_SINDICAL_CAMPOS, this.ESTRUT_ALFABETICA_TPVINC_CAMPOS, this.TIPO_HIERARQUIA_CAMPOS, this.LISTA_OCUPACAO_CAMPOS, this.LISTA_BANCOS_CAMPOS).forEach(function(campo) {
            if (!Util.isEmptyOrBlank(widget.getField(campo))) {
                if (arrayCampos.indexOf(campo) >= 0) {
                    widget.getField(campo).isVisible = true;
                    if (campo.indexOf('GEREN') < 0 && campo != 'LIST_NRESTRUTURAMSUP' && campo != 'LIST_NRESTRUTURAMREL') {
                        widget.getField(campo).validations = {"required": true};
                    }
                } else {
                    widget.getField(campo).isVisible = false;
                    widget.getField(campo).validations = {};
                }
            }
        });
    };
    
    this.cleanCampos = function(args){
       var widget = args.owner.owner.widget; 
       if( widget.getField('LIST_NRESTRUTLEGAL')!= null){
            delete widget.currentRow.LIST_NRESTRUTLEGAL;
            widget.reload();
       }
    };
    
    this.validaFimvinculo = function(args){
        var widget = args.owner.owner.widget;
        if(widget.currentRow.NMVINCULOM_INI){
            widget.getField('NMVINCULOM_FIM').validations = {"required": true};
        }else{
           widget.getField('NMVINCULOM_FIM').validations = {}; 
        }  
    };
    
    this.alteraEstruturasHierarquiaGrid = function(){
        var widget = templateManager.container.getActiveWidget();
        var estruturaSup = widget.getField('LIST_NRESTRUTURAMSUP');
        var estruturaRel = widget.getField('LIST_NRESTRUTURAMREL');
        
        if(widget.currentRow.DSORDEM == 'TIPO_HIERARQUIA' && widget.currentRow.NMTPHIERARQORG){
            
            if(this.tpHierarquiaAntigo != widget.currentRow.NRTIPOHIERARQORG){
                widget.currentRow.NMESTRUTURAMSUP = "";
                widget.currentRow.LIST_NRESTRUTURAMSUP = "";
                widget.currentRow.NMESTRUTURAMREL = "";
                widget.currentRow.LIST_NRESTRUTURAMREL = "";
            }
            
            this.tpHierarquiaAntigo = widget.currentRow.NRTIPOHIERARQORG;
    
            estruturaRel.readOnly = false;
            estruturaSup.readOnly = false;            
            
    
            estruturaRel.dataSourceFilter.forEach(function(obj){
                if(obj.name == 'NRTIPOESTRUTURA' ) obj.value = widget.currentRow.NRTIPOESTRUTREL;
            });
    
            if(widget.currentRow.NRTIPOESTRUTREL == widget.currentRow.NRTIPOESTRUTSUP || !widget.currentRow.NRTIPOESTRUTSUP){
                estruturaSup.validations = {};
                estruturaSup.dataSourceFilter.forEach(function(obj){
                    if(obj.name == 'NRTIPOESTRUTURA' ) obj.value = widget.currentRow.NRTIPOESTRUTREL;
                });
            }else{
                estruturaSup.validations = {required:true};
                estruturaSup.dataSourceFilter.forEach(function(obj){
                    if(obj.name == 'NRTIPOESTRUTURA' ) obj.value = widget.currentRow.NRTIPOESTRUTSUP;
                });
            }
            estruturaSup.reload();
            estruturaRel.reload();
        }
        else{
            widget.currentRow.NRTIPOHIERARQORG = "";
            widget.currentRow.NMTPHIERARQORG = "";
            widget.currentRow.LIST_NRESTRUTURAMSUP = "";
            widget.currentRow.NMESTRUTURAMSUP = "";
            widget.currentRow.LIST_NRESTRUTURAMREL = "";
            widget.currentRow.NMESTRUTURAMREL = "";
            estruturaSup.validations = {};
            estruturaSup.readOnly = true;
            estruturaRel.validations = {};
            estruturaRel.readOnly = true;
        }
        
        
    };
    
    this.setVisibilidadeCampos = function(widget) {
        var ordem = widget.currentRow.DSORDEM;
        
        if(widget.container.name === 'hcm01070_fpa_DIRF') {
            if(!widget.currentRow.DSINICIO && !widget.currentRow.BKPDSINICIO) {
                widget.currentRow.DSINICIO = widget.currentRow.NOMEINICIAL;
                widget.currentRow.DSFIM = widget.currentRow.NOMEFINAL;
                widget.currentRow.NOMEINICIAL = null;
                widget.currentRow.NOMEFINAL = null;
            }
        } else if (!widget.currentRow.DSINICIO && widget.currentRow.NOMEINICIAL) {
            widget.currentRow.DSINICIO = widget.currentRow.NOMEINICIAL;
            widget.currentRow.DSFIM = widget.currentRow.NOMEFINAL;
        }
        
        
        if (ordem === 'LISTA_NRESTRUTSIND') {
            widget.getField('NMESTRUTLEGAL').class = "12";
        } else {
            widget.getField('NMESTRUTLEGAL').class = "6";
        }
    
        switch (ordem) {
            case 'ALFABETICA':
                this.habilitaCamposOrdem(widget, this.ALFABETICA_CAMPOS);
                widget.currentRow.DSCRITERIO = this.NMVINCULOM;
                widget.currentRow.NMINIVINCULOM = widget.currentRow.DSINICIO;
                widget.currentRow.NMFIMVINCULOM = widget.currentRow.DSFIM;
                break;
            case 'MATRICULA':
                this.habilitaCamposOrdem(widget, this.MATRICULA_CAMPOS);
                widget.currentRow.DSCRITERIO = this.CDMATRICULA;
                widget.currentRow.CDINIMATRICULA = widget.currentRow.DSINICIO;
                widget.currentRow.CDFIMMATRICULA = widget.currentRow.DSFIM;
                break;
            case 'DATA_ADMISSAO':
                this.habilitaCamposOrdem(widget, this.DATA_ADMISSAO_CAMPOS);
                widget.currentRow.DSCRITERIO = this.DTADMISSAOVINC;
                widget.currentRow.DTINIADMISSAO = widget.currentRow.DSINICIO;
                widget.currentRow.DTFIMADMISSAO = widget.currentRow.DSFIM;
                break;
            case 'DATA_RESCISAO':
                this.habilitaCamposOrdem(widget, this.DATA_RESCISAO_CAMPOS);
                widget.currentRow.DSCRITERIO = this.DTRESCISAOVINC;
                widget.currentRow.DTINIRESCISAO = widget.currentRow.DTINICIAL;
                widget.currentRow.DTFIMRESCISAO = widget.currentRow.DTFINAL;
                widget.currentRow.NMESTRUTLEGAL = widget.currentRow.DSINICIO;
                widget.currentRow.NMESTRUTGEREN = widget.currentRow.DSFIM;
                break;
            case 'ESTRUTURA':
                this.habilitaCamposOrdem(widget, this.ESTRUTURA_CAMPOS);
                widget.currentRow.DSCRITERIO = this.NRESTRUTLEGAL;
                if(widget.name != 'hcm01059_fpa_contabilizacaoMensal'){
                    widget.currentRow.NMESTRUTLEGAL = widget.currentRow.DSINICIO;
                    widget.currentRow.NMESTRUTGEREN = widget.currentRow.DSFIM;
                }
                break;
            case 'LISTA_VINCULO':
                this.habilitaCamposOrdem(widget, this.LISTA_VINCULO_CAMPOS);
                widget.currentRow.DSCRITERIO = this.LISTA_VINCULO;
                if(widget.currentRow.NRVINCULOM_LIST && !widget.currentRow.DSINICIO)
                    widget.currentRow.NRVINCULOM_LIST = null;
                break;
            case 'LISTA_ESTRUTURA':
                this.habilitaCamposOrdem(widget, this.LISTA_ESTRUTURA_CAMPOS);
                widget.currentRow.DSCRITERIO = this.LISTA_ESTRUTURA;
                if(Array.isArray(widget.currentRow.DSINICIO)){
                    widget.currentRow.LIST_NRESTRUTLEGAL = widget.currentRow.DSINICIO;
                }
                if(Array.isArray(widget.currentRow.DSFIM)){
                    widget.currentRow.LIST_NRESTRUTGEREN = widget.currentRow.DSFIM;
                }
                this.clearCamposOnEditOrdem(this.LISTA_ESTRUTURA_CAMPOS);
                break;
            case 'LISTA_NRESTRUTSIND':
                this.habilitaCamposOrdem(widget, this.ESTRUT_SINDICAL_CAMPOS);
                widget.currentRow.DSCRITERIO = this.LISTA_SINDICAL;
                if(Array.isArray(widget.currentRow.DSINICIO)){
                    widget.currentRow.LIST_NRESTRUTLEGAL = widget.currentRow.DSINICIO;
                }
                if(Array.isArray(widget.currentRow.DSFIM)){
                    widget.currentRow.LIST_NRESTRUTSIND = widget.currentRow.DSFIM;
                }
                this.clearCamposOnEditOrdem(this.ESTRUT_SINDICAL_CAMPOS);
                break;
            case 'ESTRUT_ALFABETICA_TPVINC':
                this.habilitaCamposOrdem(widget, this.ESTRUT_ALFABETICA_TPVINC_CAMPOS);
                widget.currentRow.DSCRITERIO = this.ESTRUT_ALFABETICA_TPVINC;
                widget.currentRow.LIST_NRESTRUTLEGAL = widget.currentRow.DSINICIO;
                widget.currentRow.LIST_NRESTRUTGEREN = widget.currentRow.DSFIM;
                widget.currentRow.NMVINCULOM_INI = widget.currentRow.DSINICIO2 ? widget.currentRow.DSINICIO2 : null; 
                widget.currentRow.NMVINCULOM_FIM = widget.currentRow.DSFIM2 ? widget.currentRow.DSFIM2 : null; 
                widget.currentRow.NRTIPOVINCULO = widget.currentRow.DSINICIO3 ? widget.currentRow.DSINICIO3 : null; 
                break;
            case 'TIPO_HIERARQUIA':
                this.habilitaCamposOrdem(widget, this.TIPO_HIERARQUIA_CAMPOS);
                widget.currentRow.DSCRITERIO = this.TIPO_HIERARQUIA;
                this.alteraEstruturasHierarquiaGrid();
                break;
            case 'LISTA_OCUPACAO':
                this.habilitaCamposOrdem(widget, this.LISTA_OCUPACAO_CAMPOS);
                widget.currentRow.DSCRITERIO = this.LISTA_OCUPACAO;
                widget.currentRow.LIST_NROCUPACAOM = widget.currentRow.DSINICIO;
                break;
            case 'LISTA_BANCOS':
                this.habilitaCamposOrdem(widget, this.LISTA_BANCOS_CAMPOS);
                widget.currentRow.DSCRITERIO = this.LISTA_BANCOS;
                widget.currentRow.LIST_CDBANCO = widget.currentRow.DSINICIO;
                break;
            case 'LISTA_BENEFICIO':
                this.habilitaCamposOrdem(widget, this.LISTA_BENEFICIO_CAMPOS);
                widget.currentRow.DSCRITERIO = this.LISTA_BENEFICIO;
                widget.currentRow.LIST_NRBENEFICIOM = widget.currentRow.DSINICIO;
                break;
            default:
                this.habilitaCamposOrdem(widget, []);
                widget.currentRow.DSCRITERIO = '';
                break;
        }
    };
    
    this.ordenaCampos = function(args){
        var widget = ABUtilController.checkWidget(args);
        var ordem = widget.currentRow.DSORDEM;
        if (ordem === this.ESTRUT_ALFABETICA_TPVINC){
            widget.orderFieldsBySequenceInForm = true;
            widget.getField('DSORDEM').sequenceInForm = 0;
            widget.getField('LIST_NRESTRUTLEGAL').sequenceInForm = 0;
            widget.getField('LIST_NRESTRUTGEREN').sequenceInForm = 1;
            widget.getField('LIST_NRESTRUTSIND').sequenceInForm = 2;
            widget.getField('LIST_NRESTRUTSIND').validations = {};
            widget.getField('NMVINCULOM_INI').sequenceInForm = 3;
            widget.getField('NMVINCULOM_INI').validations = {};
            widget.getField('NMVINCULOM_FIM').sequenceInForm = 4;
            widget.getField('NMVINCULOM_FIM').validations = {};
            widget.getField('NRTIPOVINCULO').sequenceInForm = 5;
            widget.getField('NRTIPOVINCULO').validations = {};
        }else if(widget.name == 'hcm01047_fpa_calculoFolha'){
            widget.orderFieldsBySequenceInForm = false;
        }
    };

    this.changeDsOrdem = function(args, clearDataInicialFinal=true) {
        var widget = ABUtilController.checkWidget(args);
        widget.currentRow.BKPDSINICIO = widget.currentRow.DSINICIO;
        widget.currentRow.BKPDSFIM = widget.currentRow.DSFIM;
        widget.currentRow.DSINICIO = null;
        widget.currentRow.DSFIM = null;
        if(widget.currentRow.DSINICIO2){
            widget.currentRow.BKPDSINICIO2 = widget.currentRow.DSINICIO2;    
            widget.currentRow.DSINICIO2 = null;
        }
        if(widget.currentRow.DSFIM2){
            widget.currentRow.BKPDSFIM2 = widget.currentRow.DSFIM2;    
            widget.currentRow.DSFIM2 = null;
        }
        if(widget.currentRow.DTINICIAL && clearDataInicialFinal){
            widget.currentRow.BKPDTINICIAL = widget.currentRow.DTINICIAL;
            widget.currentRow.DTINICIAL = null;
        }
        if(widget.currentRow.DTFINAL && clearDataInicialFinal){
            widget.currentRow.BKPDTFINAL = widget.currentRow.DTFINAL;
            widget.currentRow.DTFINAL = null;
        }
        this.ordenaCampos(args);
        this.setVisibilidadeCampos(widget);
    };

    this.setDsInicioFim = function(args) {
        var widget = ABUtilController.checkWidget(args);
        var dtadmissaoini = widget.getField('DTINIADMISSAO').value();
        var dtadmissaofim = widget.getField('DTFIMADMISSAO').value();
        var dtrescisaoini = Util.isUndefined(widget.getField('DTINIRESCISAO')) ? false : widget.getField('DTINIRESCISAO').value();
        var dtrescisaofim = Util.isUndefined(widget.getField('DTFIMRESCISAO')) ? false : widget.getField('DTFIMRESCISAO').value();
        
        if(args.owner.field.name == 'NMINIVINCULOM'){
            this.setNmFimVinculo(widget);
        }
        if(widget.currentRow.DSORDEM == this.ESTRUT_ALFABETICA_TPVINC){
            this.setDsInicioFimEstrutAlfa(args);
        }else if(widget.currentRow.DSORDEM == this.TIPO_HIERARQUIA){
            this.setDsInicioFimTipoHierarquia();
        }else{
            if ((!ABUtilController.validaDtIniMenorIgualDtFin(dtadmissaoini, dtadmissaofim) && widget.currentRow.DSORDEM == "DATA_ADMISSAO") ||
                (dtrescisaoini && dtrescisaofim && !ABUtilController.validaDtIniMenorIgualDtFin(dtrescisaoini, dtrescisaofim) && widget.currentRow.DSORDEM == "DATA_RESCISAO")){
                ScreenService.alertNotification(Messages.DTINI_POST_DTFIM_ERROR, 10000);
            } else {
                this.DSINICIO.forEach(function(campo) {
                    if (args.owner.field.name == campo) {
                        this.ESTRUTURA_CAMPOS.forEach(function(estrutura) {
                            if (estrutura == campo) {
                                campo = campo.replace('M', 'R');
                            }
                        });
                        widget.currentRow.DSINICIO = widget.currentRow[campo];
                    }
                }.bind(this));
                    
                this.DSFIM.forEach(function(campo) {
                    if (args.owner.field.name == campo) {
                        this.ESTRUTURA_CAMPOS.forEach(function(estrutura) {
                            if (estrutura == campo) {
                                campo = campo.replace('M', 'R');
                            }
                        });
                        widget.currentRow.DSFIM = widget.currentRow[campo];
                    }
                }.bind(this));
                
                if(!Util.isUndefined(widget.currentRow.DTINICIAL)){
                    this.DTINICIAL.forEach(function(campo) {
                        if (args.owner.field.name == campo) {
                            widget.currentRow.DTINICIAL = widget.currentRow[campo];
                        }
                    }.bind(this));
                }
                
                if(!Util.isUndefined(widget.currentRow.DTFINAL)){
                    this.DTFINAL.forEach(function(campo) {
                        if (args.owner.field.name == campo) {
                            widget.currentRow.DTFINAL = widget.currentRow[campo];
                        }
                    }.bind(this));
                }
            }
        }
      
    };
    
    this.setDsInicioFimEstrutAlfa = function(args){
        var widget = ABUtilController.checkWidget(args);
        var aux;
        var variaveis = [this.DSINICIO, this.DSFIM, this.DSINICIO2, this.DSFIM2, this.DSINICIO3, this.DSFIM3];
        var dscampo = ['DSINICIO', 'DSFIM', 'DSINICIO2', 'DSFIM2', 'DSINICIO3'];
        
        if(widget.currentRow.DSORDEM == this.ESTRUT_ALFABETICA_TPVINC){
            variaveis.forEach(function(variavel){
                variavel.forEach(function(campo) {
                    if (args.owner.field.name == campo) {
                        this.ESTRUT_ALFABETICA_TPVINC_CAMPOS.forEach(function(estrut_campo, index) {
                            if (estrut_campo == campo && (estrut_campo == 'NMVINCULOM_INI' || estrut_campo == 'NMVINCULOM_FIM')) {
                                aux = index;
                            }else if(estrut_campo == campo){
                                campo = campo.replace('M', 'R');
                                aux = index;
                            }
                        });
                        widget.currentRow[dscampo[aux]] = widget.currentRow[campo];
                    }
                }.bind(this)); 
            }.bind(this));
        }
        
        
    };
    
    this.setDsInicioFimTipoHierarquia = function(){
        var widget = templateManager.container.getActiveWidget();
        
        widget.currentRow.DSINICIO = Util.isEmptyOrBlank(widget.currentRow.NRTIPOHIERARQORG) ? null : widget.currentRow.NRTIPOHIERARQORG ;
        widget.currentRow.DSINICIO2 = Util.isEmptyOrBlank(widget.currentRow.LIST_NRESTRUTURAMSUP) ? null : widget.currentRow.LIST_NRESTRUTURAMSUP;
        widget.currentRow.DSFIM2 = Util.isEmptyOrBlank(widget.currentRow.LIST_NRESTRUTURAMREL) ? null : widget.currentRow.LIST_NRESTRUTURAMREL;
        
    };
    
    this.cancelEdit = function(args){
        var widget = templateManager.container.getActiveWidget();
        widget.currentRow.DSINICIO = widget.currentRow.BKPDSINICIO;
        widget.currentRow.DSFIM = widget.currentRow.BKPDSFIM;
        widget.currentRow.BKPDSINICIO = null;
        widget.currentRow.BKPDSFIM = null;
        if(widget.currentRow.DSINICIO2){
            widget.currentRow.DSINICIO2 = widget.currentRow.BKPDSINICIO2;    
            widget.currentRow.BKPDSINICIO2 = null;
        }
        if(widget.currentRow.DSFIM2){
            widget.currentRow.DSFIM2 = widget.currentRow.BKPDSFIM2;    
            widget.currentRow.BKPDSFIM2 = null;
        }
        if(widget.currentRow.DTINICIAL){
            widget.currentRow.DTINICIAL = widget.currentRow.BKPDTINICIAL;
            widget.currentRow.BKPDTINICIAL = null;
        }
        if(widget.currentRow.DTFINAL){
            widget.currentRow.DTFINAL = widget.currentRow.BKPDTFINAL;
            widget.currentRow.BKPDTFINAL = null;
        }
        ABUtilController.masterDetailCancelaEdicao(widget);
        if(widget.currentRow.DSORDEM){
            this.setVisibilidadeCampos(widget);
        }
    };

    
    this.setNmFimVinculo = function(widget){
        if(widget.currentRow.NMINIVINCULOM && !widget.currentRow.NMFIMVINCULOM){
            widget.currentRow.NMFIMVINCULOM = widget.currentRow.NMINIVINCULOM;
            widget.currentRow.DSFIM = widget.currentRow.NMINIVINCULOM;
            widget.activate();
        }
    };
    
    this.clearCamposOnEditOrdem = function (fieldNames) {
        const widget = templateManager.container.getActiveWidget();
        const widgetIsNotInEditMode = !widget.inEditMode();
        if (widgetIsNotInEditMode) {
            return;
        }
        
        for (const fieldName of fieldNames) {
            widget.currentRow[fieldName] = null;
        }
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('CriterioSelecaoController', CriterioSelecaoController);
});

// FILE: assets/js/controllers/CursoController.js
function CursoController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, General, Messages) {

    var self = this;

    this.adicionarRow = function(args) {
        var widget = args.owner.widget;
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
    };
    this.adicionarRowCont = function(args) {
        var widget = args.owner.widget;
        widget.newRow();
        templateManager.container.getWidget('conteudoCurso');
        widget.currentRow.NRCURSO = templateManager.container.getWidget("curso").currentRow.NRCURSO;
        widget.getField('NMCONTEUDOCURSOSUP').readOnly = false;
    };
    this.conteudoSupOnEdit = function(args){
        var widget = args.owner.widget;
        widget.getField('NMCONTEUDOCURSOSUP').readOnly = true;
    };

    this.conteudoAfterMoveRow = function(widget) {
        widget.view();
        ScreenService.openSwipe(widget);
        //widget.getField('NMCONTEUDOCURSOSUP').reload();
    };

    this.setCurso = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
            if (!widget.backupRow) {
                widget.currentRow.__is_new = true;
            }
            else {
                widget.currentRow.__is_new = false;
            }
            restEngine.post('product#/setCurso_Tre', {
                'requestType': 'DataSet',
                'dataset': [widget.currentRow]
            }).
            then(function(data) {
                if (data.notifications[0].type === "success") {
                    ABUtilController.mudarVisibilidadeWidgets(widget.widgets,true);
                    ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                    widget.widgets[0].showAsTab = true;
                    widget.reload();
                    if (widget.currentRow.__is_new) {
                        ABUtilController.masterDetailVoltarList(widget);
                    }
                    else {
                        widget.backupRow = null;
                        widget.view();
                    }
                }
                else {
                    ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                }
            }).
            catch(function(e) {
                var error;
                if (e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
        }
    };

    this.deleteCurso = function(args) {
        ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
            var widget = templateManager.container.getActiveWidget();
            if (widget.isValid()) {
                widget.currentRow.__is_new = false;
                restEngine.post('product#/deleteCurso_Tre', {
                    'requestType': 'DataSet',
                    'dataset': [widget.currentRow]
                }).
                then(function(data) {
                    if (data.messages) {
                        ScreenService.showMessage(Messages.REMOVE_ROW_ERROR + '. ' + data.messages[0].message, data.messages[0].type);
                    }
                    else {
                        ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                        ABUtilController.masterDetailVoltarList(widget);
                        templateManager.container.getWidget('curso').reload();
                    }
                }).
                catch(function(e) {
                    var error;
                    if (e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;
    
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
            }
        }, null);
    };

    this.setConteudoCurso = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
            if(!!widget.currentRow.NRCONTEUDOCURSO && widget.currentRow.NRCONTEUDOCURSO == widget.currentRow.NRCONTEUDOCURSOSUP)
                ScreenService.showMessage('O conteudo não pode ser seu próprio superior');
            else {
                if (!widget.backupRow) {
                widget.currentRow.__is_new = true;
                }
                else {
                    widget.currentRow.__is_new = false;
                }
                restEngine.post('product#/setConteudoCurso_Tre', {
                    'requestType': 'DataSet',
                    'dataset': [widget.currentRow]
                }).
                then(function(data) {
                    if (data.notifications[0].type === "success") {
                        ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                        templateManager.container.getWidget('conteudoCurso').reload();
                        if (widget.currentRow.__is_new) {
                            ABUtilController.masterDetailVoltarList(widget);
                        }
                        else {
                            ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                            widget.backupRow = null;
                            widget.view();
                        }
                    }
                    else {
                        ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                    }
                }).
                catch(function(e) {
                    var error;
                    if (e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
            
            }    
        }
    };

    this.deleteConteudoCurso = function(args) {
        ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
            var widget = templateManager.container.getActiveWidget();
            if (widget.isValid()) {
                widget.currentRow.__is_new = false;
                restEngine.post('product#/deleteConteudoCurso_Tre', {
                    'requestType': 'DataSet',
                    'dataset': [widget.currentRow]
                }).
                then(function(data) {
                    if (data.messages) {
                        ScreenService.showMessage(Messages.REMOVE_ROW_ERROR + '. ' + data.messages[0].message, data.messages[0].type);
                    }
                    else {
                        ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                        ABUtilController.masterDetailVoltarList(widget);
                        templateManager.container.getWidget('conteudoCurso').reload();
                    }
                }).
                catch(function(e) {
                    var error;
                    if (e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;
    
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
            }
        }, null);
    };

    this.cursoAfterMoveRow = function(widget) {
        var conteudo = templateManager.container.getWidget("conteudoCurso");
        if (widget.currentRow.NRORG != getLocalVar("HCM_NRORG_TRAB")) {
            widget.getAction('editar').isVisible = false;
            widget.getAction('excluir').isVisible = false;
            conteudo.getAction("new").isVisible = false;
        }
        else {
            widget.getAction('editar').isVisible = true;
            widget.getAction('excluir').isVisible = true;
            conteudo.getAction("new").isVisible = true;
        }
        conteudo.dataSourceFilter[2].value = widget.currentRow.NRCURSO;
        conteudo.getField('NMCONTEUDOCURSOSUP').dataSourceFilter[2].value = widget.currentRow.NRCURSO;
    };
    
}

Configuration(function(ContextRegister) {
    ContextRegister.register('CursoController', CursoController);
});

// FILE: assets/js/controllers/CursoExternoController.js
function CursoExternoController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, General, Messages) {

    this.adicionarRow = function(args) {
        var widget = args.owner.widget;
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
    };

    this.setCurso = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
            if (!widget.backupRow) {
                widget.currentRow.__is_new = true;
            } else {
                widget.currentRow.__is_new = false;
            }
            restEngine.post('/setCurso', {
                'requestType': 'DataSet',
                'dataset': [widget.currentRow]
            }).
            then(function(data) {
                if (data.notifications[0].type === "success") {
                    ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                    if (widget.currentRow.__is_new) {
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    } else {
                        ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                        widget.backupRow = null;
                        widget.view();
                    }
                } else {
                    ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                }
            }).
            catch(function(e) {
                var error;
                if (e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
        }
    };

    this.deleteCurso = function(args) {
    ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
        var widget = args.owner.widget;
        widget.currentRow.__is_new = false;
        restEngine.post('/deleteCurso', {
            'requestType': 'DataSet',
            'dataset': [widget.currentRow]
        }).
        then(function(data) {
            if (data.notifications[0].type === "success") {
                ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                ABUtilController.masterDetailVoltarList(widget);
                widget.reload();
            } else {
                ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
            }
        }).
        catch(function(e) {
            var error;
            if (e.data.error === undefined)
                error = e;
            else
                error = e.data.error;
            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
        }, null);
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('CursoExternoController', CursoExternoController);
});


// FILE: assets/js/controllers/CustomizavelTreController.js
/**
 * Created by felipesantos on 10/11/2016.
 */
function CustomizavelTreController (ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, ABUtilController, Messages, General) {

    this.alterarVisibilidadeFieldsConteudoCurso = function(args, nmWidget){
        var widget = templateManager.container.getWidget(nmWidget);
        var filterRow = args.e.preference.FILTER_ROW;
        
        if(filterRow.currentRow.IDEXIBIRCONTEUDOCURSO == 'S'){
            widget.getField('NMCONTEUDOCURSO').isVisible = true;
            widget.getField('QTHORCONTEUDOCURSO').isVisible = true;
            widget.getField('DSOBSCONTEUDOCURSO').isVisible = true;
        }
        else if(filterRow.currentRow.IDEXIBIRCONTEUDOCURSO == 'N'){
            widget.getField('NMCONTEUDOCURSO').isVisible = false;
            widget.getField('QTHORCONTEUDOCURSO').isVisible = false;
            widget.getField('DSOBSCONTEUDOCURSO').isVisible = false;
        }
    };
        
}

Configuration(function(ContextRegister) {
    ContextRegister.register('CustomizavelTreController', CustomizavelTreController);
});

// FILE: assets/js/controllers/DIRFController.js
function DIRFController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, General, Messages, $window) {

    var self = this;

    this.mudarVisibilidadeWidgets = function(widgets, value) {
        widgets.forEach(function(widget) {
            widget.isVisible = value;
        }); 
    };

    this.adicionarRow = function(args) {
        var widget = args.owner.widget;
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
    };

    this.geraDIRF = function(args) {
        ScreenService.confirmMessage("Deseja realmente gerar a Dirf?", 'CONFIRMATION',
            function() {
                var widget = templateManager.container.getWidget('DIRF');
                restEngine.post('product#/geraDIRF', {
                    'requestType': 'DataSet',
                    'dataset': [widget.currentRow]
                }).
                then(function(data) {
                    if (data.dataset) {
                        if (data.dataset.mensagens) {
                            if (data.dataset.mensagens.length > 0) {
                                var popUp = templateManager.container.getWidget("mensagens");
                                popUp.dataSource.data = data.dataset.mensagens;
                                ABUtilController.masterDetailOpenPopup(popUp);
                            }
                        }
                        if(data.dataset.report){
                            window.open(data.dataset.report[0].NMREPORT);
                            window.open(data.dataset.report[1].NMREPORT);
                        }
                        if (data.dataset.arquivo)
                            $window.open($window.serviceUrl + "/abrirArquivo?requestType=DataSet&dataset[0][CMARQUIVO]=" + data.dataset.arquivo[0].NMARQUIVO);
                    }
                    if (data.notifications) {
                        if (data.notifications[0].type == 'success')
                            ScreenService.successNotification(data.notifications[0].message);
                        if (data.notifications[0].type == 'alert')
                            ScreenService.successNotification(data.notifications[0].message);
                    }
                    if (data.messages)
                        ScreenService.showMessage(data.messages[0].message);
                }).
                catch(function(e) {
                    var error;
                    if (e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;

                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
            }
        );

    };

    this.geraDirfOtimizada = function(args) {
        ScreenService.confirmMessage("Deseja realmente gerar a Dirf (2021/2022)?", 'CONFIRMATION',
            function() {
                var widget = templateManager.container.getWidget('DIRF');
                restEngine.post('product#/geraDirfOtimizada', {
                    'requestType': 'DataSet',
                    'dataset': [widget.currentRow]
                }).
                then(function(data) {
                    if (data.dataset) {
                        if (data.dataset.mensagens) {
                            if (data.dataset.mensagens.length > 0) {
                                var popUp = templateManager.container.getWidget("mensagens");
                                popUp.dataSource.data = data.dataset.mensagens;
                                ABUtilController.masterDetailOpenPopup(popUp);
                            }
                        }
                        if(data.dataset.report){
                            window.open(data.dataset.report[0].NMREPORT);
                            window.open(data.dataset.report[1].NMREPORT);
                        }
                        if (data.dataset.arquivo)
                            $window.open($window.serviceUrl + "/abrirArquivo?requestType=DataSet&dataset[0][CMARQUIVO]=" + data.dataset.arquivo[0].NMARQUIVO);
                    }
                    if (data.notifications) {
                        if (data.notifications[0].type == 'success')
                            ScreenService.successNotification(data.notifications[0].message);
                        if (data.notifications[0].type == 'alert')
                            ScreenService.successNotification(data.notifications[0].message);
                    }
                    if (data.messages)
                        ScreenService.showMessage(data.messages[0].message);
                }).
                catch(function(e) {
                    var error;
                    if (e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;

                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
            }
        );

    };

    this.retrocede = function(args) {
        ScreenService.confirmMessage("Deseja realmente retroceder a Dirf?", 'CONFIRMATION',
            function() {
                var widget = templateManager.container.getWidget('DIRF');
                restEngine.post('product#/retrocedeDIRF', {
                    'requestType': 'DataSet',
                    'dataset': [widget.currentRow]
                }).
                then(function(data) {
                    if (data.dataset) {
                        if (data.dataset.mensagens) {
                            if (data.dataset.mensagens.length > 0) {
                                var popUp = templateManager.container.getWidget("mensagens");
                                popUp.dataSource.data = data.dataset.mensagens;
                                ABUtilController.masterDetailOpenPopup(popUp);
                            }
                        }
                    }
                    if (data.messages)
                        ScreenService.showMessage(data.messages[0].message);
                }).
                catch(function(e) {
                    var error;
                    if (e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;

                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
            }
        );
    };

    this.setDIRF = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
            
            widget.currentRow.VRREFERENCIA = General.valueToFloat(widget.currentRow.VRREFERENCIA);
            
            if( widget.getField('VRREFERENCIA').value() == '' ){
                widget.getField('VRREFERENCIA').defaultValue = 0;
                widget.getField('VRREFERENCIA').applyDefaultValue();
            }
            if (!widget.backupRow) {
                widget.currentRow.__is_new = true;
            } else {
                widget.currentRow.__is_new = false;
            }
            restEngine.post('product#/setDIRF', {
                'requestType': 'DataSet',
                'dataset': [widget.currentRow]
            }).
            then(function(data) {
                if (data.notifications[0].type === "success") {
                    ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                    if (widget.currentRow.__is_new) {
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    } else {
                        widget.backupRow = null;
                        widget.view();
                    }
                    self.mudarVisibilidadeWidgets(widget.widgets, true);
                } else {
                    ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                }
            }).
            catch(function(e) {
                var error;
                if (e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;

                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });

        }
    };

    this.deleteDIRF = function(args) {
        var widget = args.owner.widget;
        ScreenService.confirmMessage(Messages.DELETE_ROW, 'CONFIRMATION',
            function() {
                restEngine.post('product#/deleteDIRF', {
                    'requestType': 'DataSet',
                    'dataset': [widget.currentRow]
                }).
                then(function(data) {
                    if (data.notifications[0].type === "success") {
                        ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    } else {
                        ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                    }
                }).
                catch(function(e) {
                    var error;
                    if (e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;

                    ScreenService.showMessage(error, 'ERROR');
                });
            }
        );
    };
    
    this.changeIdVinculos = function(){
        var widget = templateManager.container.getWidget("DIRF");
        if (widget.getField('IDTDVINCULOS').value() == "T") {
			widget.getField('IDRETVINCULOS').readOnly = true;
			widget.getField('IDRENDVINCULOS').readOnly = true;
			widget.getField('IDPROVINCULOS').readOnly = true;
			widget.getField('VRREFERENCIA').readOnly = true;
			widget.getField('VRREFERENCIA').clearValue();
		}else{
		    widget.getField('IDRETVINCULOS').readOnly = false;
			widget.getField('IDRENDVINCULOS').readOnly = false;
			widget.getField('IDPROVINCULOS').readOnly = false;
			widget.getField('VRREFERENCIA').readOnly = false;
			if( widget.currentRow.VRREFERENCIA == '' ){
			    widget.getField('VRREFERENCIA').applyDefaultValue();
			}
		}
		templateManager.updateTemplate();
	};
	
	this.applyRefDefaultValue = function(args) {
        var widget = args.owner.widget;
        restEngine.post('product#/findValorReferencia', {
            'requestType': 'DataSet',
            'dataset': [widget.currentRow]
        }).
        then(function(data) {
            if(data.dataset.referencia[0]  && widget.getField('IDTDVINCULOS').value() != "T"){
                widget.getField('VRREFERENCIA').defaultValue = data.dataset.referencia[0];
                widget.getField('VRREFERENCIA').applyDefaultValue();
            }
        }).
        catch(function(e) {
            var error;
            if (e.data.error === undefined)
                error = e;
            else
                error = e.data.error;

            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
        });

    };

}

Configuration(function(ContextRegister) {
    ContextRegister.register('DIRFController', DIRFController);
});


// FILE: assets/js/controllers/DashboardController.js
/**
 * Created by lara on 15/06/2016.
 */
function DashboardController (ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, $window) {

    this.itemClick = function(widget) {
        if (widget) {
            var event;
            if(widget.onDashboardClick) {
                event = widget.onDashboardClick();
            }
            if ((!event || !event.isDefaultPrevented()) && widget.windowName) {
                ScreenService.openWindow('product#'+widget.windowName);
            }
        }
    };
    
    this.changeColorLastChartBar = function(name){
        $(document).ready(function() {
            var element = angular.element(name);
            element.find("g.bars").last().find("rect").attr("fill","#5eb43c");
            element.find("g.bars").last().find("text").attr("fill","#5eb43c");

            // adiciona classe css para minipulação do grid
            $('.dashboard-table-container').addClass('hcm-overflow-grid');
            $('#masonry-item-14 th').addClass('hcm-padding-grid');
        });        
    };

    this.getTotalCurriculos = function(args){
        var containerDashboard = templateManager.containers['product#dashboard'];
        if (!Util.isUndefined(containerDashboard)) {
            var widgetTotalCurriculo   = containerDashboard.getWidget('curriculoTotalProcesso');
            var nrorg = getLocalVar("HCM_NRORG_TRAB");
            var dtcompetencia = getLocalVar("HCM_DTCOMPETENCIA_OPER");
            restEngine.post("product#/getTotalCurriculos", {
                requestType: "FilterData",
                    filter: [{operator: "=", name : "NRORG", value : nrorg}, {operator: "=", name : "DTINICIOMES", value : dtcompetencia}]}).
            then(function (data) {
                widgetTotalCurriculo.highlight = data.dataset.desParticipaProcesso_getTotalCurriculos[0].NRTOTALCURRICULO;
            }).catch(function(e) {
                var error;
                if(e.data.error === undefined)
                    error = e;
                else 
                    error = e.data.error;
                
                ScreenService.showMessage('Ocorreu um erro inesperado, contate o administrador informando o trecho abaixo: <br><br>' + error + '<br><br>', 'ERROR');
            });
            containerDashboard.getWidget("processoEmpresa").reload();
            containerDashboard.getWidget("admissoesTipoPeriodo").reload();
        }
    };

    this.getProcessosMes = function(args){
        var containerDashboard = templateManager.containers['product#dashboard'];
        if (!Util.isUndefined(containerDashboard)) {
            var widgetProcessosMes   = containerDashboard.getWidget('processosMes');
            var nrorg = getLocalVar("HCM_NRORG_TRAB");
            var dtinicio = getLocalVar("HCM_DTCOMPETENCIA_OPER");
            var dtfim = getLocalVar("HCM_FIM_DTCOMPETENCIA_OPER");
            restEngine.post("product#/getProcessosMes", {
                requestType: "FilterData",
                    filter: [{operator: "=", name : "NRORG", value : nrorg}, {operator: "=", name : "DTINICIOMES", value : dtinicio}, {operator: "=", name : "DTFIMMES", value : dtfim}]}).
            then(function (data) {
                widgetProcessosMes.highlight = data.dataset.desParticipaProcesso_getProcessosMes[0].NRPROCESSOSABERTOSMES;
            }).catch(function(e) {
                var error;
                if(e.data.error === undefined)
                    error = e;
                else 
                    error = e.data.error;
                
                ScreenService.showMessage('Ocorreu um erro inesperado, contate o administrador informando o trecho abaixo: <br><br>' + error + '<br><br>', 'ERROR');
            });
        }
    };

    this.getProcessosCancelados = function(args){
        var containerDashboard = templateManager.containers['product#dashboard'];
        if (!Util.isUndefined(containerDashboard)) {
            var widgetProcessosCancelados   = containerDashboard.getWidget('processosCancelados');
            var nrorg = getLocalVar("HCM_NRORG_TRAB");
            var idstatus = 7;
            var dtinicio = getLocalVar("HCM_DTCOMPETENCIA_OPER");
            var dtfim = getLocalVar("HCM_FIM_DTCOMPETENCIA_OPER");
            restEngine.post("product#/getProcessosCancelados", {
                requestType: "FilterData",
                    filter: [{operator: "=", name : "NRORG", value : nrorg}, {operator: "=", name : "IDSTATUS", value : idstatus}, {operator: "=", name : "DTINICIOMES", value : dtinicio}, {operator: "=", name : "DTFIMMES", value : dtfim}]}).
            then(function (data) {
                widgetProcessosCancelados.highlight = data.dataset.desParticipaProcesso_getProcessosCancelados[0].NRPROCESSOSCANCELADOS;
            }).catch(function(e) {
                var error;
                if(e.data.error === undefined)
                    error = e;
                else 
                    error = e.data.error;
                
                ScreenService.showMessage('Ocorreu um erro inesperado, contate o administrador informando o trecho abaixo: <br><br>' + error + '<br><br>', 'ERROR');
            });
        }
    };

    this.getProcessosSuspensos = function(args){
        var containerDashboard = templateManager.containers['product#dashboard'];
        if (!Util.isUndefined(containerDashboard)) {
            var widgetProcessosCancelados   = containerDashboard.getWidget('processosSuspensos');
            var nrorg = getLocalVar("HCM_NRORG_TRAB");
            var idstatus = 9;
            var dtinicio = getLocalVar("HCM_DTCOMPETENCIA_OPER");
            restEngine.post("product#/getProcessosSuspensos", {
                requestType: "FilterData",
                    filter: [{operator: "=", name : "NRORG", value : nrorg}, {operator: "=", name : "IDSTATUS", value : idstatus}, {operator: "=", name : "DTINICIOMES", value : dtinicio}]}).
            then(function (data) {
                widgetProcessosCancelados.highlight = data.dataset.desParticipaProcesso_getProcessosSuspensos[0].NRPROCESSOSSUSPENSOS;
            }).catch(function(e) {
                var error;
                if(e.data.error === undefined)
                    error = e;
                else 
                    error = e.data.error;
                
                ScreenService.showMessage('Ocorreu um erro inesperado, contate o administrador informando o trecho abaixo: <br><br>' + error + '<br><br>', 'ERROR');
            });
        }
    };

    this.getAdmissoesPeriodo = function(args){
        var containerDashboard = templateManager.containers['product#dashboard'];
        if (!Util.isUndefined(containerDashboard)) {
            var widgetAdmissoesPeriodo   = containerDashboard.getWidget('admissoesPeriodo');
            var nrorg = getLocalVar("HCM_NRORG_TRAB");
            var dtinicio = getLocalVar("HCM_DTCOMPETENCIA_OPER");
            var dtfim = getLocalVar("HCM_FIM_DTCOMPETENCIA_OPER");
            restEngine.post("product#/getAdmissoesPeriodo", {
                requestType: "FilterData",
                    filter: [{operator: "=", name : "P_NRORG", value : nrorg}, {operator: "=", name : "DTINICIOMES", value : dtinicio}, {operator: "=", name : "DTFIMMES", value : dtfim}, {operator: "=", name : "P_NRORG_PADRAO", value : getLocalVar("HCM_NRORG_PADRAO")}] }).
            then(function (data) {
                widgetAdmissoesPeriodo.highlight = data.dataset.desParticipaProcesso_getAdmissoesPeriodo.length;
            }).catch(function(e) {
                var error;
                if(e.data.error === undefined)
                    error = e;
                else 
                    error = e.data.error;
                
                ScreenService.showMessage('Ocorreu um erro inesperado, contate o administrador informando o trecho abaixo: <br><br>' + error + '<br><br>', 'ERROR');
            });
        }
    };

    this.getTotalProcessos = function(args){
        var containerDashboard = templateManager.containers['product#dashboard'];
        if (!Util.isUndefined(containerDashboard)) {
            var widgetTotalProcesso   = containerDashboard.getWidget('totalProcessos');
            var nrorg = getLocalVar("HCM_NRORG_TRAB");
            var dtinicio = getLocalVar("HCM_DTCOMPETENCIA_OPER");
            restEngine.post("product#/getTotalProcessos", {
                requestType: "FilterData",
                    filter: [{operator: "=", name : "NRORG", value : nrorg}, {operator: "=", name : "DTINICIOMES", value : dtinicio}]}).
            then(function (data) {
                widgetTotalProcesso.highlight = data.dataset.desParticipaProcesso_getTotalProcessos[0].NRPROCESSOSABERTOS;
            }).catch(function(e) {
                var error;
                if(e.data.error === undefined)
                    error = e;
                else 
                    error = e.data.error;
                
                ScreenService.showMessage('Ocorreu um erro inesperado, contate o administrador informando o trecho abaixo: <br><br>' + error + '<br><br>', 'ERROR');
            });
        }
    };

    this.openProcessosCancelados = function(args){
        sessionStorage.setItem("filtroProcessosDashboard", "CANCELADO");
        ScreenService.openWindow('product#hcm04000_btl_processos');
    };

    this.openProcessosMes = function(args){
        sessionStorage.setItem("filtroProcessosDashboard", "MES");
        ScreenService.openWindow('product#hcm04000_btl_processos');
    };

    this.openProcessosSuspenso = function(args){
        sessionStorage.setItem("filtroProcessosDashboard", "SUSPENSO");
        ScreenService.openWindow('product#hcm04000_btl_processos');
    };

    this.openTotalProcessos = function(args){
        sessionStorage.setItem("filtroProcessosDashboard", "TODOS");
        ScreenService.openWindow('product#hcm04000_btl_processos');
    };

    this.reloadCharts = function() {
        var containerDashboard = templateManager.containers['product#dashboard'];
        if (!Util.isUndefined(containerDashboard)) {
            var widgetTurnover     = containerDashboard.getWidget('turnOver');
            var widgetRetencao     = containerDashboard.getWidget('indiceRetencao');
            var widgetConhecimento = containerDashboard.getWidget('perdaConhecimento');
            var widgetFluxoMetas   = containerDashboard.getWidget('fluxoVagasMeta');
            var widgetAlertasSistema   = containerDashboard.getWidget('alertasSistema');
            var widgetAprovadoReprovado   = containerDashboard.getWidget('aprovadoReprovado');
            var widgetResponsaveisProcesso   = containerDashboard.getWidget('responsaveisProcesso');

            widgetTurnover.reload();
            widgetRetencao.reload();
            widgetConhecimento.reload();
            widgetFluxoMetas.reload();
            widgetAlertasSistema.reload();
            widgetAprovadoReprovado.reload();
            widgetResponsaveisProcesso.reload();
        }
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('DashboardController', DashboardController);
});

// FILE: assets/js/controllers/DemissaoxDireitoController.js
function DemissaoxDireitoController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, General,Messages) {

    this.adicionarRow = function(args) {
        var widget = args.owner.widget;
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
    };

	this.setDemissaoxDireito = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
                if (!widget.backupRow) {
                    widget.currentRow.__is_new = true;
                } else {
                    widget.currentRow.__is_new = false;
                }
                restEngine.post('product#/setDemissaoxDireito', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                    then(function (data) {
                        if (data.notifications[0].type === "success") {
                            ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                            if (widget.currentRow.__is_new) {
                                ABUtilController.masterDetailVoltarList(widget);
                                widget.reload();
                            } else {
                                ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                                widget.backupRow = null;
                                widget.view();
                            }
                        } else {
                            ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                        }
                    }).
                    catch(function(e) {
                        var error;
                        if(e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;
                            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    });
            }
    };
    
    this.deleteDemissaoxDireito = function(args) {
    ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
        var widget = args.owner.widget;
        widget.currentRow.__is_new = false;
        restEngine.post('product#/deleteDemissaoxDireito', {'requestType':'DataSet','dataset':[widget.currentRow]}).
            then(function(data){
                if(data.notifications[0].type === "success"){
                    ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                    ABUtilController.masterDetailVoltarList(widget);
                    widget.reload();
                } else {
                    ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                }
            }).
            catch(function(e) {
                var error;
                if(e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
       }, null);
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('DemissaoxDireitoController', DemissaoxDireitoController);
});

// FILE: assets/js/controllers/DemonsEletronicoController.js
function DemonsEletronicoController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, General, Messages, $window) {

    var self = this;

    this.adicionarRow = function(args) {
        var widget = args.owner.widget;
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
    };
    this.gerarHorelite = function(args) {
        if(args.owner.name == 'COMPETENCIA_MENSAL')
        {
        ScreenService.confirmMessage("Deseja realmente gerar a Holerite?", 'CONFIRMATION',
        
            function() {
                var widget = templateManager.container.getWidget('demonstrativo');
                widget.currentRow.TPPROCESSAMENTO = args.owner.name;
                restEngine.post('product#/gerarHorelite', {
                    'requestType': 'DataSet',
                    'dataset': [widget.currentRow]
                }).
                then(function(data) {
                    if (data.dataset) {
                        if (data.dataset.msgCalculo) {
                            if (data.dataset.msgCalculo.length > 0) {
                                var popUp = templateManager.container.getWidget("mensagens");
                                popUp.dataSource.data = data.dataset.msgCalculo;
                                ABUtilController.masterDetailOpenPopup(popUp);
                            }
                        }
                        if (data.dataset.arquivo)
                            $window.open($window.serviceUrl + "/abrirArquivo?requestType=DataSet&dataset[0][CMARQUIVO]=" + data.dataset.arquivo[0].NMARQUIVO);
                    }
                    if (data.notifications) {
                        if (data.notifications[0].type == 'success')
                            ScreenService.successNotification(data.notifications[0].message);
                        if (data.notifications[0].type == 'alert')
                            ScreenService.successNotification(data.notifications[0].message);
                    }
                    if (data.messages)
                        ScreenService.showMessage(data.messages[0].message);
                }).
                catch(function(e) {
                    var error;
                    if (e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;

                    ScreenService.showMessage(error, 'ERROR');
                });
            
                
            }
        );
            
        } else {
                var widget = templateManager.container.getWidget('demonstrativo');
                widget.currentRow.TPPROCESSAMENTO = args.owner.name;
                restEngine.post('product#/gerarHorelite', {
                    'requestType': 'DataSet',
                    'dataset': [widget.currentRow]
                }).
                then(function(data) {
                    if (data.messages)
                        ScreenService.showMessage(data.messages[0].message);
                }).
                catch(function(e) {
                    var error;
                    if (e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;

                    ScreenService.showMessage(error, 'ERROR');
                });
        }

    };
    
    this.setDemonstrativo = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
            if (widget.currentRow.DSORDEM == 'LISTA_VINCULO' && widget.currentRow.NRVINCULOM_LIST && widget.currentRow.NRVINCULOM_LIST.length > 200) {
                ScreenService.showMessage("Favor selecionar um máximo de 200 vínculos na lista ou usar outro filtro como por exemplo por estrutura legal.");
                return;
            }
            if (!widget.backupRow) {
                widget.currentRow.__is_new = true;
            } else {
                widget.currentRow.__is_new = false;
            }
            restEngine.post('product#/setDemonstrativoEletronico', {
                'requestType': 'DataSet',
                'dataset': [widget.currentRow]
            }).
            then(function(data) {
                if (data.notifications[0].type === "success") {
                    ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                    if (widget.currentRow.__is_new) {
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    } else {
                        widget.backupRow = null;
                        widget.view();
                    }
                } else {
                    ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                }
            }).
            catch(function(e) {
                var error;
                if (e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;

                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });

        }
    };

    this.deleteDemonstrativo = function(args) {
        var widget = args.owner.widget;
        ScreenService.confirmMessage(Messages.DELETE_ROW, 'CONFIRMATION',
            function() {
                restEngine.post('product#/deleteDemonstrativoEletronico', {
                    'requestType': 'DataSet',
                    'dataset': [widget.currentRow]
                }).
                then(function(data) {
                    if (data.notifications[0].type === "success") {
                        ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    } else {
                        ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                    }
                }).
                catch(function(e) {
                    var error;
                    if (e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;

                    ScreenService.showMessage(error, 'ERROR');
                });
            }
        );
    };

}

Configuration(function(ContextRegister) {
    ContextRegister.register('DemonsEletronicoController', DemonsEletronicoController);
});


// FILE: assets/js/controllers/DependenteVincController.js
/**
 * Created by felipesantos on 02/12/2016.
 */
 /* jshint esversion: 6 */
function DependenteVincController (ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, ABUtilController, Messages, $window) {

    this.camposData = ['DTINIDEPENDE', 'DTFINDEPENDE', 'DTVERCONTROLE', 'DTINIDEPENDEXC', 'DTFINDEPENDEXC'];
    var self = this;
        
    this.setFiltroPessoaVinc = function(args, fieldPessoa) {
        var widget = ABUtilController.checkWidget(args);
        if (!Util.isUndefined(widget.currentRow.NRPESSOAVINC) && widget.currentRow.NRPESSOAVINC !== '') {
            widget.getField(fieldPessoa).dataSourceFilter = [
                { "name": "NRPESSOA", "operator": "=", "value": widget.currentRow.NRPESSOAVINC },
                { "name": "IDPESSOAPRINC", "operator": "=", "value": "N" }
            ];
        } else {
            widget.getField(fieldPessoa).dataSourceFilter = [
                { "name": "NRPESSOA", "operator": "=", "value": "" },
                { "name": "IDPESSOAPRINC", "operator": "=", "value": "N" }
            ];
        }
        widget.getField(fieldPessoa).reload();
    };

    this.setIdadeDependente = function(args) {
        var widget = ABUtilController.checkWidget(args);
        if (!Util.isUndefined(widget.currentRow.DTNASCIMENTO)) {
            if (widget.currentRow.DTNASCIMENTO !== '') {
                var dtnascimento = moment(widget.currentRow.DTNASCIMENTO, 'DD/MM/YYYY');
                var dtatual = moment();
                var idade = dtatual.diff(dtnascimento, 'year');
                widget.currentRow.NRANOSDEPVINC = idade;
            }
        }
        
        // Atualiza o campo de data ('DTNASCIMENTO')
        widget.redraw();
    };
    
    this.obrigaCamposDependentes = function(){
        var widget = templateManager.container.getActiveWidget();
        if(widget.currentRow.NRTIPORELACIONA == 3 || widget.currentRow.NRTIPORELACIONA == 5){
            widget.getField('DTNASCIFUNDPARC').validations = {required: true};
            widget.getField('NRCPFPESSOA').validations = {required: true};
        }else{
            widget.getField('DTNASCIFUNDPARC').validations = {};
            widget.getField('NRCPFPESSOA').validations = {};
        }
    };

    this.habilitaDependente = function(args, fieldPessoa) {
        var widget;
        
        if( typeof(args) == 'object')
            widget = ABUtilController.checkWidget(args);
        else if ( typeof(args) == 'string')
            widget = templateManager.container.getWidget(args);
            
        var nmvinculom = widget.getField('NMVINCULOM').value();
        widget.getField(fieldPessoa).readOnly = nmvinculom === '' ? true : false;
        if (widget.getField(fieldPessoa).readOnly) 
            this.resetDependente(args);
    };
    
    this.resetDependente = function(args) {
        var widget = ABUtilController.checkWidget(args);
        widget.currentRow.NMPESSOA = '';
        widget.currentRow.NRPESSOA = '';
        widget.currentRow.DTNASCIMENTO = '';
        widget.currentRow.NRANOSDEPVINC = '';
        widget.currentRow.NRCPFPESSOA = '';
    };

    this.habilitaExcecao = function(args) {
        var widget = ABUtilController.checkWidget(args);
        var idexcecao = widget.getField('IDEXCDEPENDE').value();
        widget.getField('NMEXCEDEPENDE').readOnly = idexcecao === 'S' ? false : true;
        widget.getField('DTINIDEPENDEXC').readOnly = idexcecao === 'S' ? false : true;
        widget.getField('DTFINDEPENDEXC').readOnly = idexcecao === 'S' ? false : true;
    };

    this.salvarDependenteVinc = function(args, ESocialController, verificaEnvioEsocialDescentralizado = true) {
        
        if(self.validaDependenteIR()){
            var widget = templateManager.container.getActiveWidget();
            
            var tipovinculo = '';
            if(!Util.isEmptyOrBlank(widget.currentRow.NRTIPOVINCULOM)){
                tipovinculo = widget.currentRow.NRTIPOVINCULOM;
            }else{
                tipovinculo = templateManager.container.getWidget('vinculo') ? templateManager.container.getWidget('vinculo').currentRow.NRTIPOVINCULOM : null;
            }
            
            if (widget.isValid()) {
                if(verificaEnvioEsocialDescentralizado){
                if(tipovinculo == 1){
                    ESocialController.envioEsocialDescentralizado(widget.currentRow, 'S-2206', widget.currentRow.NRVINCULOM, widget.currentRow.NRVINCULOM, self.salvarDependenteVinc, args);
                }else{
                    ESocialController.envioEsocialDescentralizado(widget.currentRow, 'S-2306', widget.currentRow.NRVINCULOM, widget.currentRow.NRVINCULOM, self.salvarDependenteVinc, args);
                }  
                }else{
                    if(ABUtilController.validaDtIniMenorIgualDtFin(widget.currentRow.DTINIDEPENDE,widget.currentRow.DTFINDEPENDE) &&
                    ABUtilController.validaDtIniMenorIgualDtFin(widget.currentRow.DTINIDEPENDEXC,widget.currentRow.DTFINDEPENDEXC)) {
                        if (!widget.backupRow) {
                            widget.currentRow.__is_new = true;
                        } else {
                            widget.currentRow.__is_new = false;
                        }
                        restEngine.post('product#/setDepvinculo', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                            then(function (data) {
                                if (!Util.isUndefined(data.notifications) && data.notifications[0].type === "success") {
                                    ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                                        if(data.dataset && data.dataset.retornoEsocial && data.dataset.retornoEsocial.length > 0){
                                        var mensagem = 'S-2206/S-2306: ';
                                        data.dataset.retornoEsocial.forEach(function(retorno){
                                            mensagem += retorno.MSG + '<br>';
                                        });
                                        ScreenService.showMessage(mensagem);
                                    }
                                    if (data.notifications.length > 1) {
                                        data.notifications.shift();
                                        data.notifications.forEach(function (notification) {
                                            ScreenService.notificationMessage(notification.message, 10000);
                                        });
                                    }
                                    if (!Util.isUndefined(data.messages)) {
                                        ScreenService.showMessage(data.messages[0].message, data.messages[0].type);
                                    }
                                    if (widget.currentRow.__is_new) {
                                        ABUtilController.masterDetailVoltarList(widget);
                                        widget.reload();
                                    } else {
                                        ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                                        widget.backupRow = null;
                                        widget.view();
                                    }
                                } else if (!Util.isUndefined(data.messages)) {
                                    ScreenService.showMessage(data.messages[0].message, data.messages[0].type);
                                } else {
                                    ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                                }
                            }).
                            catch(function (e) {
                                var error;
                                if (e.data.error === undefined)
                                    error = e;
                                else
                                    error = e.data.error;
        
                                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                            });
                    }else{
                        ScreenService.showMessage(Messages.DTINI_POST_DTFIM_ERROR);
                    }
                }
            }
        }
    };
    
    var isObrigatorioCpf = function(widget) {
        var isObrigatorio = false;
        var idadeDep = widget.currentRow.NRANOSDEPVINC;
        var idadeMinCPF = 0;
        if(getLocalVar("IDADE_MIN_CPF_DEP"))
        idadeMinCPF = getLocalVar("IDADE_MIN_CPF_DEP");

        if(widget.currentRow.NRTIPODEPENDE && idadeDep >= idadeMinCPF){

            if( Array.isArray(widget.currentRow.NRTIPODEPENDE) ){
                widget.currentRow.NRTIPODEPENDE.forEach(function(obj){
                    if(obj == 2) //obj == 2, 2 é imposto de renda
                        isObrigatorio = true;
                });
            }else if( widget.currentRow.NRTIPODEPENDE == 2 )
                isObrigatorio = true;

        }
        
        return isObrigatorio;
        
    };    

    this.deleteDependenteVinc = function(args) {
        var widget = templateManager.container.getActiveWidget();
        if (widget.isValid()) {
            widget.currentRow.__is_new = false;
            
            ScreenService.confirmMessage(Messages.DELETE_ROW, 'CONFIRMATION', function(){
                
                restEngine.post('product#/deleteDepvinculo', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                    then(function (data) {
                        if (data.notifications[0].type === "success") {
                            ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                            ABUtilController.masterDetailVoltarList(widget);
                            widget.reload();
                        } else {
                            ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                        }
                    }).
                    catch(function(e) {
                        var error;
                        if(e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;
    
                        ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    });
                    
            }.bind(this));
        }
    };

    this.openPopupCadAuto = function(action, widget) {
        if (action == 'cadAutoDependente') {
            ABUtilController.masterDetailOpenPopup(templateManager.container.getWidget('popupCadAutoDepend'));
        }
        if (action == 'cadPessoaDepend') {
            ABUtilController.masterDetailOpenPopup(templateManager.container.getWidget('popupPessoaDepend'));
        }
    };

    this.cadPessoaDepend = function(args) {
        var widget = ABUtilController.checkWidget(args);
        if (widget.isValid()) {
             if (widget.currentRow.NRCPFPESSOA) {
                    if (!ABUtilController.validaCPF(widget.currentRow.NRCPFPESSOA)) {
                        ScreenService.showMessage(Messages.CPF_ERROR);
                        return false;
                    }
                }
            widget.currentRow.__is_new = true;
            restEngine.post("product#/cadPessoaDepend", {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                then(function (data) {
                    if (data.messages) {
                        var textMessage = '';
                        data.messages.forEach(function (objMsg) {
                            textMessage += '-' + objMsg.message + '<br>';
                        });
                        ScreenService.showMessage(textMessage);
                    }

                    if (data.notifications[0].type === "error") {
                        ScreenService.alertNotification(Messages.CADASTRO_AUTOMATICO_ERRO, 10000);
                    } else {
                        ScreenService.successNotification(Messages.CADASTRO_AUTOMATICO_SUCCESS, 10000);
                        ABUtilController.masterDetailClosePopup(widget);
                        templateManager.container.getWidget('dependenteVinc').activate();
                        templateManager.container.getWidget('dependenteVinc').reload();
                    }
                }).
                catch(function (e) {
                    var error;
                    if (e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;

                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
        }
    };

    this.cadAutoDependentes = function(args) {
        var widget = ABUtilController.checkWidget(args);
        if (widget.isValid()) {
            widget.currentRow.__is_new = true;
            restEngine.post("product#/cadAutoDependentes", {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                then(function (data) {
                    if (data.messages) {
                        var textMessage = '';
                        data.messages.forEach(function (objMsg) {
                            textMessage += '-' + objMsg.message + '<br>';
                        });
                        ScreenService.showMessage(textMessage);
                    }

                    if (data.notifications[0].type === "error") {
                        ScreenService.alertNotification(Messages.CADASTRO_AUTOMATICO_ERRO, 10000);
                    } else {
                        ScreenService.successNotification(Messages.CADASTRO_AUTOMATICO_SUCCESS, 10000);
                        ABUtilController.masterDetailClosePopup(widget);
                        templateManager.container.getWidget('dependenteVinc').activate();
                        templateManager.container.getWidget('dependenteVinc').reload();
                    }
                }).
                catch(function (e) {
                    var error;
                    if (e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;

                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
        }
    };
    
    this.validaDependenteIR = function() {
        var widget = templateManager.container.getActiveWidget();
        if(widget.currentRow.NMTIPODEPENDE === "Imposto de Renda"){
            if(isObrigatorioCpf(widget) && !widget.currentRow.NRCPFPESSOA || Util.isNull(widget.currentRow.NRANOSDEPVINC)) {
                ScreenService.showMessage(Messages.HCM01046_ERRO_CPF_IDADE_VINCULO, 'ERROR');
                return false;
            }
        } 
        return true;
    };
    
    /*Importação e exportação de planilha de dependentes - xls*/
    
    this.geraPlanilhaTemplete = function() {
        restEngine.post('product#/baixarPlanilhaTemplateDependente', {
            'requestType': 'DataSet',
            'dataset': []
        }).then(function(data) {
            ScreenService.closePopup();
            if(data.dataset && data.dataset.arquivo){
                $window.open($window.serviceUrl + "/abrirArquivo?requestType=DataSet&dataset[0][CMARQUIVO]=" + data.dataset.arquivo.NMARQUIVO);
            }
        }).catch(function(e) {
            var error;
            if (e.data.error === undefined)
                error = e;
            else
                error = e.data.error;
            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
        });
            
    };
    
    this.openPopupImportacao = function() {
        var widgetPopupImportacao = templateManager.container.getWidget('popupImportacaoPlanilha');
        ScreenService.openPopup(widgetPopupImportacao);
    };
    
    this.popupImportacaoPlanilhaVoltar = function() {
        ScreenService.closePopup();
        templateManager.container.getWidget('dependenteVinc').activate();
    };
    
    this.importarPlanilhaDependente = function() {
        var widgetPop = templateManager.container.getActiveWidget();
        var widgetPai = templateManager.container.getWidget('dependenteVinc');
        if(widgetPop.isValid()){
            if(this.validaArquivo(widgetPop.currentRow.DSPATH[0].name)) {
                restEngine.post('product#/importarPlanilhaDependente', {'requestType': 'DataSet', 'dataset': [widgetPop.currentRow]}).
                then(function(data) {
                    if (data.messages) {
                        ScreenService.closePopup(true);
                        ScreenService.showMessage(data.messages[0].message, data.messages[0].type);
                        if (data.dataset && data.dataset.msg) {
                            openPopupMensagens(data.dataset.msg);
                        } else {
                            widgetPai.activate();
                        }
                        widgetPai.reload();
                    } else
                        ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                }).
                catch(function(e) {   
                    var error;
                    if (e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    
                });
            }
        }
    };
    
    this.validaArquivo = function(filePath) {
        var extension = filePath.split('.').pop().toUpperCase();
        if (extension !== 'XLS' && extension !== 'XLSX') {
            ScreenService.showMessage('Formato de arquivo inválido');
            return false;
        } else {
            return true;
        }
    };
    
    var openPopupMensagens = function(msg) {
        var widgetMensagens = templateManager.container.getWidget('messagesImportacaoDependente');
        widgetMensagens.dataSource.data = msg;
        ScreenService.openPopup(widgetMensagens);
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('DependenteVincController', DependenteVincController);
});

// FILE: assets/js/controllers/DespesasAdministrativasController.js
 function DespesasAdministrativasController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, Messages) {

     this.salvarDespesasAdministrativas = function(args) {
         var widget = templateManager.container.getActiveWidget();
         if (widget.isValid()) {
             if (!widget.backupRow) {
                 widget.currentRow.__is_new = true;
             } else {
                 widget.currentRow.__is_new = false;
             }
             widget.currentRow.DTULTATUDADM = widget.currentRow.DTULTATU;
             restEngine.post('product#/setDespesasAdministrativas', {
                 'requestType': 'DataSet',
                 'dataset': [widget.currentRow]
             }).
             then(function(data) {
                 if (data.notifications[0].type === "success") {
                     ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                     if (widget.currentRow.__is_new) {
                         ABUtilController.masterDetailVoltarList(widget);
                         widget.reload();
                     } else {
                         ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                         widget.backupRow = null;
                         widget.view();
                     }
                 } else if (data.notifications[0].message === 'HCM01062_FPA_DUPLICATE_PRIMARY_KEY_ERROR') {
                     ScreenService.showMessage(Messages.HCM01062_FPA_DUPLICATE_PRIMARY_KEY_ERROR, 'ERROR');
                 } else
                     ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
             }).
             catch(function(e) {
                 var error;
                 if (e.data.error === undefined)
                     error = e;
                 else
                     error = e.data.error;

                 ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
             });
         }
     };

     this.removerDespesasAdministrativas = function(args) {
         ScreenService.confirmMessage(Messages.DELETE_ROW, 'CONFIRMATION',
             function() {

                 var widget = templateManager.container.getActiveWidget();
                 widget.currentRow.__is_new = false;
                 restEngine.post('product#/deleteDespesasAdministrativas', {
                     'requestType': 'DataSet',
                     'dataset': [widget.currentRow]
                 }).
                 then(function(data) {
                     if (data.notifications[0].type === "success") {
                         ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                         ABUtilController.masterDetailVoltarList(widget);
                         widget.reload();
                     } else if (data.notifications[0].message === 'HCM01062_FPA_DESPESA_EXISTENTE_EM_EVENTCTBL') {
                         ScreenService.showMessage(Messages.HCM01062_FPA_DESPESA_EXISTENTE_EM_EVENTCTBL, 'ERROR');
                     } else
                         ScreenService.showMessage(Messages.REMOVE_ROW_ERROR, 'ERROR');
                 }).
                 catch(function(e) {
                     var error;
                     if (e.data.error === undefined)
                         error = e;
                     else
                         error = e.data.error;

                     ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                 });

             });
     };

     this.desabilitaCodigo = function(widget) {
         widget.getField('CDDESPADMFAT').readOnly = true;
     };

     this.habilitaCodigo = function(widget) {
         widget.getField('CDDESPADMFAT').readOnly = false;
     };
 }

 Configuration(function(ContextRegister) {
     ContextRegister.register('DespesasAdministrativasController', DespesasAdministrativasController);
 });
 

// FILE: assets/js/controllers/DocumentoModeloController.js
function DocumentoModeloController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, $window, ABUtilController, General,Messages) {
    
  this.newUploadDocument = function(widget) {
      widget.parentWidget = widget.parent.parent;
      ScreenService.openSwipe(widget);
      widget.currentRow = {};
      widget.isVisible = true;
      widget.newRow();

  };
  
  this.closeSwipe = function(widget) {
      ScreenService.closeSwipe();
      widget.deactivate();
      widget.parentWidget.currentWidget = widget.parentWidget;
      widget.parentWidget.activate();
  };
  
  this.filtrarWidgetPorEstrutura = function(args){
      var widget = args.owner;
      templateManager.container.getWidget("documentacao").dataSourceFilter[0].value = widget.currentRow.NRPARCNEGOCIO;
  };
  
  this.uploadFile = function(argsRow, idfoto, mensagens){
      var widget = templateManager.container.getWidget("documentoModelo");
      var widgetAnexarArquivo = templateManager.container.getWidget("documentacao");
      argsRow.IDFOTO = idfoto;
      saveData = Object.assign({}, argsRow, {
          "NRPARCNEGOCIO": widget.currentRow.NRPARCNEGOCIO
      }, {
          "NRORG": widget.currentRow.NRORG
      }, {
          "CDOPERADOR_LOG": getLocalVar("HCM_CDOPERADOR")
      });
      return restEngine.post("product#/saveUploadFile", {
          requestType: "DataSet",
          dataset: [saveData]
      }).then(function(data) {
          if (!Util.isUndefined(data.dataset.saveUploadFile) && data.dataset.saveUploadFile[0]) {
              ScreenService.showMessage(mensagens[0]);
          } else {
              ScreenService.showMessage(mensagens[1]);
          }
          widgetAnexarArquivo.reload().then(function() {
              ABUtilController.masterDetailVoltarList(widgetAnexarArquivo);
              widgetAnexarArquivo.widgets[0].deactivate();
              widgetAnexarArquivo.currentWidget = widgetAnexarArquivo;
          });
      }.bind(this)).catch(function(e) {
          var error;
          if( e.data.error === undefined ){
              error = e;
          } else {
              error = e.data.error;
          }
          ScreenService.showMessage('Ocorreu um erro inesperado, contate o administrador informando o trecho abaixo: <br><br>' + error + '<br><br>', 'ERROR');
      });
  };
  
  this.saveFile = function(argsRow, idfoto) {
      var widgetNovoArquivo = templateManager.container.getWidget("novoArquivo");
      var mensagens = ["Arquivo carregado com sucesso", "Não foi possível realizar o upload do arquivo"];
      var caracteresInvalidos = ["*", "%", "@", "#", "$", "¨", "&", "'"];
      var verificaNomeArquivo = !caracteresInvalidos.find(function(value) {
          return argsRow.DSPATH[0].name.indexOf(value) !== -1;
      });
      if( verificaNomeArquivo && widgetNovoArquivo.isValid() ){
          this.uploadFile(argsRow, idfoto, mensagens);
      } else {
          ScreenService.showMessage('Nome inválido para o arquivo');
      }
  };
  
  this.editFile = function(argsRow, idfoto) {
      var widgetAnexarArquivo = templateManager.container.getWidget("documentacao");
      var mensagens = ["Edição concluída com sucesso", "Não foi possível realizar a edição do arquivo"];
      if( typeof(argsRow.DSPATH) == "string" ){
          argsRow.DSPATH = [];
      }
      if( widgetAnexarArquivo.isValid() ){
          this.uploadFile(argsRow, idfoto, mensagens);
      } else {
          ScreenService.showMessage('Nome inválido para o arquivo');
      }
  };
  
  this.apagarArquivos = function(argsRow) {
      ScreenService.confirmMessage('Deseja realmente exluir o arquivo ?', 'CONFIRMATION',
          function() {
              var widget = templateManager.container.getWidget("documentoModelo");
              var widgetAnexarArquivo = templateManager.container.getWidget("documentacao");
              saveData = Object.assign({}, argsRow,  {
                  "NRPARCNEGOCIO": widget.currentRow.NRPARCNEGOCIO
              }, {
                  "NRORG": widget.currentRow.NRORG
              }, {
                  "CDOPERADOR_LOG": getLocalVar("HCM_CDOPERADOR")
              });
              restEngine.post("product#/apagarArquivos", {
                  requestType: "DataSet",
                  dataset: [saveData]
              }).then(function(data) {
                  if( data ){
                      ScreenService.showMessage('Arquivo deletado com sucesso', 'SUCCESS');
                      widgetAnexarArquivo.reload();
                  } else {
                      ScreenService.showMessage('Falha ao apagar o arquivo', 'ALERT');
                      widgetAnexarArquivo.reload();
                  }
                  ScreenService.closeSwipe();
              }).catch(function(e) {
                  var error;
                  if( e.data.error === undefined ){
                      error = e;
                  } else {
                      error = e.data.error;
                  }
                  ScreenService.showMessage('Ocorreu um erro inesperado, contate o administrador informando o trecho abaixo: <br><br>' + error + '<br><br>', 'ERROR');
              });
          }
      );
  };
  
  this.abrirArquivo = function(argsRow) {
      var path = ABUtilController.getBaseUrlFileServer() + argsRow.DSPATH;
      
      $window.open($window.serviceUrl + "/abrirArquivo?requestType=DataSet&dataset[0][CMARQUIVO]=" + path);
  };
}

Configuration(function(ContextRegister) {
  ContextRegister.register('DocumentoModeloController', DocumentoModeloController);
});

// FILE: assets/js/controllers/DocumentoParceiroController.js
/**
 * Created by leonardocarvalho on 02/03/2016.
 */
function DocumentoParceiroController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, $window, ABUtilController, Messages, HcmConsts) {
    
    this.saveUploadFile = function(argsRow, idfoto) {
        var widgetDocParc = templateManager.container.getWidget("documentacaoParceiro");
        var widgetAnexarArquivo = templateManager.container.getWidget("anexarArquivo");
        var widgetNovoArquivo = templateManager.container.getWidget("novoArquivo");
        var caracteresInvalidos = ["*", "%", "@", "#", "$", "¨", "&", "'"];
        var verificaNomeArquivo = !caracteresInvalidos.find(function(value) {
            return argsRow.DSPATH[0].name.indexOf(value) !== -1;
        });
        if (verificaNomeArquivo) {
            if (widgetNovoArquivo.isValid()) {
                argsRow.IDFOTO = idfoto;
                saveData = Object.assign({}, argsRow, {
                    "NRPARCNEGOCIO": widgetDocParc.currentRow.NRPARCNEGOCIO
                }, {
                    "NRORG": widgetDocParc.currentRow.NRORG
                }, {
                    "CDOPERADOR_LOG": getLocalVar("HCM_CDOPERADOR")
                });
                return restEngine.post("product#/saveUploadFile", {
                    requestType: "DataSet",
                    dataset: [saveData]
                }).then(function(data) {
                    if (!Util.isUndefined(data.dataset.saveUploadFile) && data.dataset.saveUploadFile[0]) {
                        ScreenService.showMessage("Arquivo carregado com sucesso");
                    } else {
                        ScreenService.showMessage("Não foi possível realizar o upload do arquivo");
                    }
                    widgetAnexarArquivo.reload().then(function() {
                        ABUtilController.masterDetailVoltarList(widgetAnexarArquivo);
                        widgetAnexarArquivo.widgets[0].deactivate();
                        widgetAnexarArquivo.currentWidget = widgetAnexarArquivo;
                    });
                }.bind(this)).catch(function(e) {
                    var error;
                    if (e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;
                    ScreenService.showMessage('Ocorreu um erro inesperado, contate o administrador informando o trecho abaixo: <br><br>' + error + '<br><br>', 'ERROR');
                });
            }
        } else {
            ScreenService.showMessage('Nome inválido para o arquivo');
        }
    };
    
   this.apagarArquivos = function(argsRow) {
        ScreenService.confirmMessage('Deseja realmente exluir o arquivo ?', 'CONFIRMATION',
            function() {
                var widgetDocParc = templateManager.container.getWidget("documentacaoParceiro");
                var widgetAnexarArquivo = templateManager.container.getWidget("anexarArquivo");
                var widgetNovoArquivo = templateManager.container.getWidget("novoArquivo");
                saveData = Object.assign({}, argsRow,  {
                    "NRPARCNEGOCIO": widgetDocParc.currentRow.NRPARCNEGOCIO
                }, {
                    "NRORG": widgetDocParc.currentRow.NRORG
                }, {
                    "CDOPERADOR_LOG": getLocalVar("HCM_CDOPERADOR")
                });
                restEngine.post("product#/apagarArquivos", {
                    requestType: "DataSet",
                    dataset: [saveData]
                }).then(function(data) {
                    if (data) {
                        ScreenService.showMessage('Arquivo deletado com sucesso', 'SUCCESS');
                        widgetAnexarArquivo.reload();
                    } else {
                        ScreenService.showMessage('Falha ao apagar o arquivo', 'ALERT');
                        widgetAnexarArquivo.reload();
                    }
                    ScreenService.closeSwipe();
                }).catch(function(e) {
                    var error;
                    if (e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;
                    ScreenService.showMessage('Ocorreu um erro inesperado, contate o administrador informando o trecho abaixo: <br><br>' + error + '<br><br>', 'ERROR');
                });
            }
        );
    };
    
    this.aprovaStatusFile = function(argsRow) {
        
        ScreenService.confirmMessage(Messages.AVISO_GER_APPROVAL_CONFIRMATION, 'CONFIRMATION',
            function () {
                var row = {
                    NRANEXO: argsRow.NRANEXO,
                };
                
                restEngine.post("product#/aprovaStatusFile", {
                    requestType: "Row",
                    row: row,
                }).then(function(data) {
                    if (!data || !data.dataset.alteraStatusFile.success) {
                        ScreenService.showMessage('Não foi possível gerenciar o documento.', 'ALERT');
                        return;
                    }
                    
                    // Atualiza campo na widget de documentos
                    var widgetDocumentos = templateManager.container.getWidget('anexarArquivo');
                    widgetDocumentos.currentRow.IDDOCAPROVADO = 'S';
                    widgetDocumentos.redraw();
                    
                    ScreenService.showMessage('O status do documento foi alterado com sucesso.', 'SUCCESS');
                    ScreenService.closePopup();
                    
                }).catch(function(e) {
                    var error;
                    if (e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;
                    ScreenService.showMessage('Ocorreu um erro inesperado, contate o administrador informando o trecho abaixo: <br><br>' + error + '<br><br>', 'ERROR');
                });
                 
            }
        );
    };
    
}

Configuration(function(ContextRegister) {
    ContextRegister.register('DocumentoParceiroController', DocumentoParceiroController);
});


// FILE: assets/js/controllers/ESocialBXController.js
/* jshint esversion: 6 */
function ESocialBXController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, General, Messages, $window) {
    /*global Util*/
    
    var self = this;

    this.STATUS_PENDENTE = 'P';
    this.STATUS_PENDPROCE = 'M';
    this.STATUS_CONCLUIDO = 'C';

    this.afterMoveEstrutura = function() {
        var widget = templateManager.container.getWidget('estruturas');
        var widgetEventos = templateManager.container.getWidget('eventos');
        var idParametrizado = (widget.currentRow.DSVERSAO != null && widget.currentRow.NRTPAMBIENTE != null && widget.currentRow.NRPARCNEGOCIO != null);
        
        // Enable or disable widget eventos and action parametroEsocial
        widgetEventos.isVisible = idParametrizado;
        widget.actions.forEach(function(action){
            if (action.name == 'parametroEsocial') {
                action.isVisible = !idParametrizado;
            }
        }.bind(this));

        //Seta dados para widget Eventos
        if (widgetEventos.isVisible) {
            widgetEventos.getField('NRESTRUTURAM').defaultValue = widget.currentRow.NRESTRUTURAM;
            widgetEventos.getField('NRTPAMBIENTE').defaultValue = widget.currentRow.NRTPAMBIENTE;
            widgetEventos.getField('DSEVENTO').dataSourceFilter.forEach(function(filter){
                if (filter.name == 'DSVERSAO') {
                    filter.value = widget.currentRow.DSVERSAO;
                }
            });
            widgetEventos.dataSourceFilter.forEach(function(filter){
                if (filter.name == 'NRESTRUTURAM') {
                    filter.value = widget.currentRow.NRESTRUTURAM;
                }
                if (filter.name == 'NRTPAMBIENTE') {
                    filter.value = widget.currentRow.NRTPAMBIENTE;
                }
            });
        }
    };
    
    this.openParametroESocial = function() {
        ScreenService.openWindow('product#hcm09004_eso_parametro');
    };

    this.adicionarRow = function(args) {
        var widget = args.owner.widget;
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
    };
    
    this.afterMoveEvento = function() {
        this.changeTipoEvento();
        this.setActionsEvento();
        this.setWidgetsEvento();
    };
    
    this.changeTipoEvento = function() {
        var widget = templateManager.container.getWidget('eventos');
        
        if(!Util.isUndefined(widget.currentRow.IDTIPO)){
            switch(widget.currentRow.IDTIPO){
                case 'E':
                    widget.getField('DSEVENTO').dataSourceFilter[ABUtilController.retornaFiltro(widget.getField('DSEVENTO').dataSourceFilter, 'IDATIVO')].value = ["S","N"];
                    widget.getField('DSEVENTO').dataSourceFilter[ABUtilController.retornaFiltro(widget.getField('DSEVENTO').dataSourceFilter, 'IDATIVO')].operator = "IN";
                    widget.getField('DSEVENTO').dataSourceFilter[ABUtilController.retornaFiltro(widget.getField('DSEVENTO').dataSourceFilter, 'IDGRUPO')].value = ["I","T","N","P"];
                    widget.getField('DSEVENTO').dataSourceFilter[ABUtilController.retornaFiltro(widget.getField('DSEVENTO').dataSourceFilter, 'NMEVENTO')].operator = "IN";
                    /*https://pt.stackoverflow.com/questions/387097/esocialbx-erro-402-solicita%C3%A7%C3%A3o-inv%C3%A1lida*/
                    widget.getField('DSEVENTO').dataSourceFilter[ABUtilController.retornaFiltro(widget.getField('DSEVENTO').dataSourceFilter, 'NMEVENTO')].value = ["S-1250","S-1260","S-1270","S-1280","S-1295","S-1298","S-1299","S-1300","S-5011","S-5012","S-5013"];
                    widget.getField('DSEVENTO').validations = { "required": true };
                    widget.getField('CDPERIODOAPURACAO').validations = { "required": true };
                    widget.getField('NRCPFTRABALHADOR').validations = {};
                    widget.getField('DTINIPERIODO').validations = {};
                    widget.getField('DTFIMPERIODO').validations = {};
                    break;
                case 'T':
                    widget.getField('DSEVENTO').dataSourceFilter[ABUtilController.retornaFiltro(widget.getField('DSEVENTO').dataSourceFilter, 'IDATIVO')].value = "S";
                    widget.getField('DSEVENTO').dataSourceFilter[ABUtilController.retornaFiltro(widget.getField('DSEVENTO').dataSourceFilter, 'IDATIVO')].operator = "=";
                    widget.getField('DSEVENTO').dataSourceFilter[ABUtilController.retornaFiltro(widget.getField('DSEVENTO').dataSourceFilter, 'IDGRUPO')].value = ["I","T"];
                    widget.getField('DSEVENTO').dataSourceFilter[ABUtilController.retornaFiltro(widget.getField('DSEVENTO').dataSourceFilter, 'NMEVENTO')].operator = "IS_NOT_NULL";
                    widget.getField('DSEVENTO').dataSourceFilter[ABUtilController.retornaFiltro(widget.getField('DSEVENTO').dataSourceFilter, 'NMEVENTO')].value = "";
                    widget.getField('DSEVENTO').validations = { "required": true };
                    widget.getField('CDPERIODOAPURACAO').validations = {};
                    widget.getField('NRCPFTRABALHADOR').validations = {};
                    widget.getField('DTINIPERIODO').validations = {};
                    widget.getField('DTFIMPERIODO').validations = {};
                    break;
                case 'F':
                    widget.getField('DSEVENTO').dataSourceFilter[ABUtilController.retornaFiltro(widget.getField('DSEVENTO').dataSourceFilter, 'IDATIVO')].value = "S";
                    widget.getField('DSEVENTO').dataSourceFilter[ABUtilController.retornaFiltro(widget.getField('DSEVENTO').dataSourceFilter, 'IDATIVO')].operator = "=";
                    widget.getField('DSEVENTO').dataSourceFilter[ABUtilController.retornaFiltro(widget.getField('DSEVENTO').dataSourceFilter, 'IDGRUPO')].value = ["N","P"];
                    widget.getField('DSEVENTO').dataSourceFilter[ABUtilController.retornaFiltro(widget.getField('DSEVENTO').dataSourceFilter, 'NMEVENTO')].operator = "IS_NOT_NULL";
                    widget.getField('DSEVENTO').dataSourceFilter[ABUtilController.retornaFiltro(widget.getField('DSEVENTO').dataSourceFilter, 'NMEVENTO')].value = "";
                    widget.getField('DSEVENTO').validations = {};
                    widget.getField('CDPERIODOAPURACAO').validations = {};
                    widget.getField('NRCPFTRABALHADOR').validations = { "required": true };
                    widget.getField('DTINIPERIODO').validations = { "required": true };
                    widget.getField('DTFIMPERIODO').validations = { "required": true };
                    break;
                default:
                    widget.getField('DSEVENTO').dataSourceFilter[ABUtilController.retornaFiltro(widget.getField('DSEVENTO').dataSourceFilter, 'IDATIVO')].value = "S";
                    widget.getField('DSEVENTO').dataSourceFilter[ABUtilController.retornaFiltro(widget.getField('DSEVENTO').dataSourceFilter, 'IDATIVO')].operator = "=";
                    widget.getField('DSEVENTO').dataSourceFilter[ABUtilController.retornaFiltro(widget.getField('DSEVENTO').dataSourceFilter, 'IDGRUPO')].value = [];
                    widget.getField('DSEVENTO').dataSourceFilter[ABUtilController.retornaFiltro(widget.getField('DSEVENTO').dataSourceFilter, 'NMEVENTO')].operator = "IS_NOT_NULL";
                    widget.getField('DSEVENTO').dataSourceFilter[ABUtilController.retornaFiltro(widget.getField('DSEVENTO').dataSourceFilter, 'NMEVENTO')].value = "";
                    widget.getField('DSEVENTO').validations = {};
                    widget.getField('CDPERIODOAPURACAO').validations = {};
                    widget.getField('NRCPFTRABALHADOR').validations = {};
                    widget.getField('DTINIPERIODO').validations = {};
                    widget.getField('DTFIMPERIODO').validations = {};
            }
            widget.getField('DSEVENTO').reload();
        }
    };
    
    this.setActionsEvento = function() {
        var widget = templateManager.container.getWidget('eventos');
        
        if(!Util.isUndefined(widget.currentRow.IDSTATUS)){
            switch(widget.currentRow.IDSTATUS){
                case 'P':
                    widget.getAction('editar').isVisible = true;
                    widget.getAction('excluir').isVisible = true;
                    widget.getAction('consultarIdentificadoresEventos').isVisible = true;
                    break;
                case 'M':
                    widget.getAction('editar').isVisible = false;
                    widget.getAction('excluir').isVisible = false;
                    widget.getAction('consultarIdentificadoresEventos').isVisible = false;
                    break;
                case 'C':
                    widget.getAction('editar').isVisible = false;
                    widget.getAction('excluir').isVisible = false;
                    widget.getAction('consultarIdentificadoresEventos').isVisible = false;
                    break;
                default:
                    widget.getAction('editar').isVisible = true;
                    widget.getAction('excluir').isVisible = true;
                    widget.getAction('consultarIdentificadoresEventos').isVisible = true;
            }
        }
    };
    
    this.setWidgetsEvento = function() {
        var widgetEstrutura = templateManager.container.getWidget('estruturas');
        var widgetEvento = templateManager.container.getWidget('eventos');
        var widgetRetorno = templateManager.container.getWidget('dadosRetorno');
        var widgetRegistro = templateManager.container.getWidget('registros');
        
        //Seta visibilidade para widgets filhas
        if(!Util.isUndefinedOrNull(widgetEvento.currentRow.DSDIRXMLRETENV)){
            widgetRetorno.isVisible = true;
        }else{
            widgetRetorno.isVisible = false;
        }
        
        if(widgetEvento.currentRow.IDSTATUS == 'P'){
            widgetRegistro.isVisible = false;
        }else{
            widgetRegistro.isVisible = true;
        }
        
        //Seta filtros para widgets filhas
        widgetRetorno.dataSourceFilter.forEach(function(filter){
            if (filter.name == 'NRESTRUTURAM') {
                filter.value = widgetEvento.currentRow.NRESTRUTURAM;
            }
            if (filter.name == 'NRTPAMBIENTE') {
                filter.value = widgetEvento.currentRow.NRTPAMBIENTE;
            }
            if (filter.name == 'NRBXESOCIAL') {
                filter.value = widgetEvento.currentRow.NRBXESOCIAL;
            }
        });
    
        widgetRegistro.dataSourceFilter.forEach(function(filter){
            if (filter.name == 'NRBXESOCIAL') {
                filter.value = widgetEvento.currentRow.NRBXESOCIAL;
            }
        });

        //Seta dados para widgets filhas
        if (widgetRegistro.isVisible) {
            widgetRegistro.getField('NRBXESOCIAL').defaultValue = widgetEvento.currentRow.NRBXESOCIAL;
            widgetRegistro.getField('DSEVENTO').dataSourceFilter.forEach(function(filter){
                if (filter.name == 'DSVERSAO') {
                    filter.value = widgetEstrutura.currentRow.DSVERSAO;
                }
            });
        }
    };
    
	this.setEsoBxEsocial = function() {
        var widget = templateManager.container.getWidget('eventos');
        if (widget.isValid()) {
            if (!widget.backupRow) {
                widget.currentRow.__is_new = true;
            } else {
                widget.currentRow.__is_new = false;
            }
            restEngine.post('product#/setEsoBxEsocial', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                then(function (data) {
                    if (data.notifications[0].type === "success") {
                        ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                        if (widget.currentRow.__is_new) {
                            ABUtilController.masterDetailVoltarList(widget);
                            widget.reload();
                        } else {
                            ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                            widget.backupRow = null;
                            widget.view();
                        }
                    } else {
                        ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                    }
                }).
                catch(function(e) {
                    var error;
                    if(e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;
                        ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
            }
    };
    
    this.deleteEsoBxEsocial = function() {
        ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
            var widget = templateManager.container.getWidget('eventos');
            widget.currentRow.__is_new = false;
            restEngine.post('product#/deleteEsoBxEsocial', {'requestType':'DataSet','dataset':[widget.currentRow]}).
                then(function(data){
                    if(data.notifications[0].type === "success"){
                        ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    } else {
                        ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                    }
                }).
                catch(function(e) {
                    var error;
                    if(e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;
                        ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
        }, null);
    };

    this.openCadastroAutomaticoBxEsocial = function() {
        var widgetFilter = templateManager.container.getWidget('cadastroAutomaticoBxEsocial');
        var widgetEstrutura = templateManager.container.getWidget('estruturas');

        widgetFilter.currentRow.NRESTRUTURAM = widgetEstrutura.currentRow.NRESTRUTURAM;
        widgetFilter.currentRow.DSVERSAO = widgetEstrutura.currentRow.DSVERSAO;
        widgetFilter.currentRow.NRTPAMBIENTE = widgetEstrutura.currentRow.NRTPAMBIENTE;
        widgetFilter.getField('NREVENTOLIST').dataSourceFilter.forEach(function(filter){
            if (filter.name == 'DSVERSAO') {
                filter.value = widgetEstrutura.currentRow.DSVERSAO;
            }
        });

        ABUtilController.masterDetailOpenPopup(widgetFilter);
    };

    this.cadastroAutomaticoBxEsocial = function() {
        var widgetFilter = templateManager.container.getWidget('cadastroAutomaticoBxEsocial');
        var widgetEventos = templateManager.container.getWidget('eventos');
        
        if (widgetFilter.isValid()) {
            ScreenService.confirmMessage('Deseja realizar o cadastro automático de eventos?', 'CONFIRMATION',
                function(){
                    restEngine.post('/cadastroAutomaticoBxEsocial', {'requestType': 'Row', 'row': widgetFilter.currentRow}).
                        then(function (data) {
                            // tratativa padrão para a visualização do retorno da rotina de envioAutomático
                            if (!Util.isUndefined(data.dataset)) {
                                if (data.dataset.cadastroAutomaticoBxEsocial.result === true) {
                                    ScreenService.successNotification(Messages.CADASTRO_AUTOMATICO_SUCCESS);
                                    ABUtilController.masterDetailClosePopup(widgetFilter);
                                    widgetEventos.reload();
                                } else {
                                    ScreenService.alertNotification(Messages.CADASTRO_AUTOMATICO_ERRO);
                                }
                                    
                                if (!Util.isUndefined(data.dataset.cadastroAutomaticoBxEsocial.msg) && data.dataset.cadastroAutomaticoBxEsocial.msg.length > 0) {
                                    var popUpMsg = templateManager.container.getWidget("mensagens");
                                    popUpMsg.dataSource.data = data.dataset.cadastroAutomaticoBxEsocial.msg;
                                    ABUtilController.masterDetailOpenPopup(popUpMsg);
                                }
                            }
                        }).
                        catch(function(e) {
                            var error;
                            if(Util.isUndefined(e.data) && Util.isUndefined(e.data.error) && Util.isUndefined(e.message))
                                error = e;
                            else if(!Util.isUndefined(e.message))
                                error = e.message;
                            else
                                error = e.data.error;
                            ScreenService.showMessage(Util.isUndefined(Messages[error]) ? error : Messages[error], 'ERROR');
                        });
                },
                function(){
                    //nothing to do
                }
            );
        }
    };
    
    this.gerarTemplatePlanilhaCPF = function() {
        var widget = templateManager.container.getActiveWidget();
        ScreenService.confirmMessage("Deseja fazer o download da planilha template?", null, function () {
            restEngine.post('product#/gerarTemplatePlanilhaCPF', {'requestType': 'Row', 'row': widget.currentRow}).
                then(function(data) {
                    ScreenService.closePopup();
                    if(data.dataset && data.dataset.arquivo){
                        $window.open($window.serviceUrl + "/abrirArquivo?requestType=DataSet&dataset[0][CMARQUIVO]=" + data.dataset.arquivo.NMARQUIVO);
                        ABUtilController.masterDetailClosePopup(templateManager.container.getWidget("mensagens"));
                        ScreenService.successNotification(Messages.EXPORTACAO_SUCCESS, 10000);                        
                    }else if(data.dataset && data.dataset.erros){
                        var popUp = templateManager.container.getWidget("mensagens");
                        popUp.dataSource.data = data.dataset.erros;
                        ABUtilController.masterDetailOpenPopup(popUp);
                    }else{
                        ScreenService.showMessage(Messages.EXPORTACAO_ERROR);
                    }
                    
                }).catch(function(e) {
                    var error;
                    if (e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;
                    
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
            },null);
    };
    
    this.openImportacaoPlanilhaCPFBxEsocial = function(){
        var widgetFilter = templateManager.container.getWidget('importacaoPlanilhaCPFBxEsocial');
        var widgetEstrutura = templateManager.container.getWidget('estruturas');
        
        widgetFilter.currentRow.NRESTRUTURAM = widgetEstrutura.currentRow.NRESTRUTURAM;
        widgetFilter.currentRow.DSVERSAO = widgetEstrutura.currentRow.DSVERSAO;
        widgetFilter.currentRow.NRTPAMBIENTE = widgetEstrutura.currentRow.NRTPAMBIENTE;
        
        ABUtilController.masterDetailOpenPopup(widgetFilter);
    };
    
    this.validaArquivo = function(filePath) {
        var extension = filePath.split('.').pop().toUpperCase();
        if (extension !== 'XLS' && extension !== 'XLSX') {
            ScreenService.showMessage('Formato de arquivo inválido');
            return false;
        } else {
            return true;
        }
    };
    
    this.importarPlanilhaCPFBxEsocial = function(){
        var widget = templateManager.container.getWidget('importacaoPlanilhaCPFBxEsocial');
        var widgetEventos = templateManager.container.getWidget('eventos');
        
        if(widget.isValid()){
            if (this.validaArquivo(widget.currentRow.DSPATH[0].name)) {
                restEngine.post('product#/importarPlanilhaCPFBxEsocial', {'requestType': 'Row', 'row': widget.currentRow}).
                then(function(data) {
                    if (data.messages) {
                        ScreenService.closePopup(true);
                        ScreenService.showMessage(data.messages[0].message, data.messages[0].type);
                        if (data.dataset && data.dataset.msg) {
                            var widgetMensagens = templateManager.container.getWidget('mensagens');
                            widgetMensagens.dataSource.data = data.dataset.msg;
                            ScreenService.openPopup(widgetMensagens);
                        } else {
                            widgetEventos.activate();
                            widgetEventos.reload();
                        }
                    } else {
                        ScreenService.showMessage(Messages.PROCESSO_ERROR);
                    }
                }.bind(this)).
                catch(function(e) {  
                    var error;
                    if (e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error; 
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
            }
        }
    };
    
    this.consultarIdentificadoresEventos = function(){
        var widgetEventos = templateManager.container.getActiveWidget();
        
        if(widgetEventos.isValid()){
            restEngine.post('product#/consultarIdentificadoresEventos', {'requestType': 'Row', 'row': widgetEventos.currentRow}).
                then(function(data) {
                    if(data) {
                        if (data.dataset.consultarIdentificadoresEventos.result == true) {
                            ABUtilController.masterDetailVoltarList(widgetEventos);
                            widgetEventos.reload();
                        }
                        if (data.messages) {
                            ScreenService.showMessage(Util.isUndefined(Messages[data.messages[0].message]) ? data.messages[0].message : Messages[data.messages[0].message], data.messages[0].type);
                            
                            if (data.dataset.msg) {
                                var widgetMensagens = templateManager.container.getWidget('mensagens');
                                widgetMensagens.dataSource.data = data.dataset.msg;
                                ScreenService.openPopup(widgetMensagens);
                            }
                        } else {
                            ScreenService.showMessage(Messages.PROCESSO_ERROR);
                        }
                    } else {
                        ScreenService.showMessage(Messages.PROCESSO_ERROR);
                    }
                }.bind(this)).
                catch(function(e) {  
                    var error;
                    if (e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error; 
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
        }
    };
    
    this.onEnterWidgetDadosRetorno = function(){
        var widget = templateManager.container.getWidget('dadosRetorno');
        widget.reload();
    };
    
    this.onEnterWidgetDadosRegistro = function(){
        var widget = templateManager.container.getWidget('registros');
        widget.reload();
    };
    
	this.setEsoEventoBxEsocial = function() {
        var widget = templateManager.container.getWidget('registros');
        if (widget.isValid()) {
            if (Util.isUndefinedOrNull(widget.currentRow.IDEVENTO) && Util.isUndefinedOrNull(widget.currentRow.NRRECIBO)) {
                ScreenService.errorNotification('Deve ser informado pelo menos o ID Evento ou o Recibo de Processamento', 10000);
                return;
            }
            if (!widget.backupRow) {
                widget.currentRow.__is_new = true;
            } else {
                widget.currentRow.__is_new = false;
            }
            restEngine.post('product#/setEsoEventoBxEsocial', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                then(function (data) {
                    if (data.notifications[0].type === "success") {
                        ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                        if (widget.currentRow.__is_new) {
                            ABUtilController.masterDetailVoltarList(widget);
                            widget.reload();
                        } else {
                            ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                            widget.backupRow = null;
                            widget.view();
                        }
                    } else if (data.notifications[0].type === "error") {
                        ScreenService.errorNotification(data.notifications[0].message, 10000);
                    } else {
                        ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                    }
                }).
                catch(function(e) {
                    var error;
                    if(e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;
                        ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
            }
    };
    
    this.deleteEsoEventoBxEsocial = function() {
        ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
            var widget = templateManager.container.getWidget('registros');
            widget.currentRow.__is_new = false;
            restEngine.post('product#/deleteEsoEventoBxEsocial', {'requestType':'DataSet','dataset':[widget.currentRow]}).
                then(function(data){
                    if(data.notifications[0].type === "success"){
                        ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    } else {
                        ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                    }
                }).
                catch(function(e) {
                    var error;
                    if(e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;
                        ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
        }, null);
    };
    
    this.onCheckUncheckRegistro = function() {
        var widget = templateManager.container.getWidget('registros');
        
        widget.getAction('downloadEventosPorNrRecibo').isVisible = (widget.getCheckedRows().length > 0);
        widget.getAction('downloadEventosPorId').isVisible = (widget.getCheckedRows().length > 0);
    };
    
    this.downloadEventoPorId = function(){
        var widgetEvento = templateManager.container.getWidget('eventos');
        var widgetRegistros = templateManager.container.getWidget('registros');
        
        var row = {
            'NRESTRUTURAM': widgetEvento.currentRow.NRESTRUTURAM,
            'NRTPAMBIENTE': widgetEvento.currentRow.NRTPAMBIENTE,
            'NRBXESOCIAL': widgetEvento.currentRow.NRBXESOCIAL,
            'ESOEVENTOBXESOCIAL': [widgetRegistros.currentRow]
        };
        
        restEngine.post('product#/downloadEventosPorId', {'requestType': 'Row', 'row': row}).
            then(function(data) {
                if(data) {
                    if (data.dataset.downloadEventosPorId.result == true) {
                        ABUtilController.masterDetailVoltarList(widgetRegistros);
                        widgetRegistros.reload();
                    }
                    if (data.messages) {
                        ScreenService.showMessage(Util.isUndefined(Messages[data.messages[0].message]) ? data.messages[0].message : Messages[data.messages[0].message], data.messages[0].type);
                        
                        if (data.dataset.msg) {
                            var widgetMensagens = templateManager.container.getWidget('mensagens');
                            widgetMensagens.dataSource.data = data.dataset.msg;
                            ScreenService.openPopup(widgetMensagens);
                        }
                    } else {
                        ScreenService.showMessage(Messages.PROCESSO_ERROR);
                    }
                } else {
                    ScreenService.showMessage(Messages.PROCESSO_ERROR);
                }
            }.bind(this)).
            catch(function(e) {  
                var error;
                if (e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error; 
                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
    };
    
    this.downloadEventoPorNrRecibo = function(){
        var widgetEvento = templateManager.container.getWidget('eventos');
        var widgetRegistros = templateManager.container.getWidget('registros');
        
        var row = {
            'NRESTRUTURAM': widgetEvento.currentRow.NRESTRUTURAM,
            'NRTPAMBIENTE': widgetEvento.currentRow.NRTPAMBIENTE,
            'NRBXESOCIAL': widgetEvento.currentRow.NRBXESOCIAL,
            'ESOEVENTOBXESOCIAL': [widgetRegistros.currentRow]
        };
        
        restEngine.post('product#/downloadEventosPorNrRecibo', {'requestType': 'Row', 'row': row}).
            then(function(data) {
                if(data) {
                    if (data.dataset.downloadEventosPorNrRecibo.result == true) {
                        ABUtilController.masterDetailVoltarList(widgetRegistros);
                        widgetRegistros.reload();
                    }
                    if (data.messages) {
                        ScreenService.showMessage(Util.isUndefined(Messages[data.messages[0].message]) ? data.messages[0].message : Messages[data.messages[0].message], data.messages[0].type);
                        
                        if (data.dataset.msg) {
                            var widgetMensagens = templateManager.container.getWidget('mensagens');
                            widgetMensagens.dataSource.data = data.dataset.msg;
                            ScreenService.openPopup(widgetMensagens);
                        }
                    } else {
                        ScreenService.showMessage(Messages.PROCESSO_ERROR);
                    }
                } else {
                    ScreenService.showMessage(Messages.PROCESSO_ERROR);
                }
            }.bind(this)).
            catch(function(e) {  
                var error;
                if (e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error; 
                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
    };
    
    this.downloadEventosPorId = function(){
        var widgetEvento = templateManager.container.getWidget('eventos');
        var widgetRegistros = templateManager.container.getWidget('registros');
        
        if (widgetRegistros.getCheckedRows().length > 0) {
            var row = {
                'NRESTRUTURAM': widgetEvento.currentRow.NRESTRUTURAM,
                'NRTPAMBIENTE': widgetEvento.currentRow.NRTPAMBIENTE,
                'NRBXESOCIAL': widgetEvento.currentRow.NRBXESOCIAL,
                'ESOEVENTOBXESOCIAL': widgetRegistros.getCheckedRows()
            };
            
            restEngine.post('product#/downloadEventosPorId', {'requestType': 'Row', 'row': row}).
                then(function(data) {
                    if(data) {
                        if (data.dataset.downloadEventosPorId.result == true) {
                            ABUtilController.masterDetailVoltarList(widgetRegistros);
                            widgetRegistros.reload();
                        }
                        if (data.messages) {
                            ScreenService.showMessage(Util.isUndefined(Messages[data.messages[0].message]) ? data.messages[0].message : Messages[data.messages[0].message], data.messages[0].type);
                            
                            if (data.dataset.msg) {
                                var widgetMensagens = templateManager.container.getWidget('mensagens');
                                widgetMensagens.dataSource.data = data.dataset.msg;
                                ScreenService.openPopup(widgetMensagens);
                            }
                        } else {
                            ScreenService.showMessage(Messages.PROCESSO_ERROR);
                        }
                    } else {
                        ScreenService.showMessage(Messages.PROCESSO_ERROR);
                    }
                }.bind(this)).
                catch(function(e) {  
                    var error;
                    if (e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error; 
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
        }
    };
    
    this.downloadEventosPorNrRecibo = function(){
        var widgetEvento = templateManager.container.getWidget('eventos');
        var widgetRegistros = templateManager.container.getWidget('registros');
        
        if (widgetRegistros.getCheckedRows().length > 0) {
            var row = {
                'NRESTRUTURAM': widgetEvento.currentRow.NRESTRUTURAM,
                'NRTPAMBIENTE': widgetEvento.currentRow.NRTPAMBIENTE,
                'NRBXESOCIAL': widgetEvento.currentRow.NRBXESOCIAL,
                'ESOEVENTOBXESOCIAL': widgetRegistros.getCheckedRows()
            };
            
            restEngine.post('product#/downloadEventosPorNrRecibo', {'requestType': 'Row', 'row': row}).
                then(function(data) {
                    if(data) {
                        if (data.dataset.downloadEventosPorNrRecibo.result == true) {
                            ABUtilController.masterDetailVoltarList(widgetRegistros);
                            widgetRegistros.reload();
                        }
                        if (data.messages) {
                            ScreenService.showMessage(Util.isUndefined(Messages[data.messages[0].message]) ? data.messages[0].message : Messages[data.messages[0].message], data.messages[0].type);
                            
                            if (data.dataset.msg) {
                                var widgetMensagens = templateManager.container.getWidget('mensagens');
                                widgetMensagens.dataSource.data = data.dataset.msg;
                                ScreenService.openPopup(widgetMensagens);
                            }
                        } else {
                            ScreenService.showMessage(Messages.PROCESSO_ERROR);
                        }
                    } else {
                        ScreenService.showMessage(Messages.PROCESSO_ERROR);
                    }
                }.bind(this)).
                catch(function(e) {  
                    var error;
                    if (e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error; 
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
        }
    };
    
}

Configuration(function(ContextRegister) {
    ContextRegister.register('ESocialBXController', ESocialBXController);
}); 

// FILE: assets/js/controllers/ESocialController.js
/* jshint esversion: 6 */
function ESocialController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, General, Messages, ESocialService, LibUtilities) {

    var self = this;

    this.STATUS_PENDENTE = 'P';
    this.STATUS_ERROENVIO = 'E';
    this.STATUS_PENDPROCE = 'M';
    this.STATUS_ERROPROCE = 'R';
    this.STATUS_CONCLUIDO = 'C';
    this.STATUS_CONCADVER = 'A';
    this.idGrupo = null;
    this.idGrupoCadastro = null;
    this.lblContainer = null;
    
    // Variáveis para o redirecionamento de tela
    this.filtrarFilhasESocial = false;
    this.CODIGO = null;
    this.TABELA = null;
    this.paramFiltro = null;
    this.paramFiltroTabela = null;
    this.idItemCalculo = null;
    this.widgetItemCalculo = null;
    this.nmWidgetRedirecionada = null;
    this.nomeWidget = null;
    this.dsversao = null;
    this.alteraCampos = null;
    this.campoAtivoFiltroNaoEstaMarcado = false; //variavel criada para validar se o campo 'Ativo' do filtro foi setado ou não (true: não está marcado; false: está marcado)
    this.nrestruturam = null; //Variável criada para recarregar os dados de envios quando a estrutura for alterada
    
    //Campos de filtro por evento que utiliza o campo
    this.FILTROS = {
        "NREVENTOM" : ["S-1010"],
        "NRTIPOMOVIMENT" : ["S-1010", "S-1200"],
        "NRESTRUTTOMAD" : ["S-1020"],
        "NROCUPACAOM" : ["S-1030","S-1040"],
        "NRHORDIAM" : ["S-1050"],
        "NRESTRUTGEREN" : ["S-1060"],
        "NRVINCULOMCOMPL" : ["S-1200","S-1210"],
        "NRVINCULOMRESC" : ["S-2299","S-2399"],
        "NRVINCULOM" : ["S-2200","S-2205","S-2206","S-2230","S-2250","S-2260","S-2298","S-2300","S-2306"],
        "NRPESSOAPRE" : ["S-2190"]
    };
    
    this.setIdGrupoOnmenuClick = function(idGrupo, args){
        this.idGrupo = idGrupo;
        this.lblContainer = args.owner.label;
        this.alteraCampos = true;
        switch (idGrupo) {
            case 'T':
                this.idGrupoCadastro = ["I", "T"];
                break;
            case 'P':
                this.idGrupoCadastro = ["P"];
                break;
            case 'N':
                this.idGrupoCadastro = ["N"];
                break; 
        }
        
        if (!Util.isUndefined(templateManager.containers['product#hcm09001_eso_envioCadastros'])) {
            var container = templateManager.containers['product#hcm09001_eso_envioCadastros'];
            var widgetEstrutura = container.getWidget('estruturas');
            var widgetEnvios = container.getWidget('envioCadastros');
            // Altera o label do container conforme o menu acionado
            container.label = this.lblContainer;
            
            // Caso a widget ativa seja as widgets filhas de envios, volta para a widget de envios em modo list
            if (container.getActiveWidget().name != 'estruturas' || container.getActiveWidget().inViewMode()) {
                ScreenService.closeSwipe(0).then(function() {
                    widgetEstrutura.activate();
                    widgetEstrutura.dataSourceFilter[ABUtilController.retornaFiltro(widgetEstrutura.dataSourceFilter, 'P_IDGRUPO')].value = this.idGrupoCadastro;
                    widgetEstrutura.list();
                    widgetEstrutura.reload();
                    
                }.bind(this));
            }else{
                widgetEstrutura.dataSourceFilter[ABUtilController.retornaFiltro(widgetEstrutura.dataSourceFilter, 'P_IDGRUPO')].value = this.idGrupoCadastro;
                widgetEstrutura.reload();
            }
            
            ESocialService.FILTROS = self.FILTROS;
            // this.controlaCampos(widgetEnvios);
            //container.getWidget('envioCadastros').getField('NREVENTO').reload();
            
        }
    };
    
    this.redrawFields = function(){
        var widget = templateManager.container.getWidget('envioCadastros');  
        if(this.alteraCampos && this.controlaCampos()){
            widget.redraw();
            this.alteraCampos = false;
        }
    };
    
    this.controlaCampos = function(){
        var widget = templateManager.container.getWidget('envioCadastros');
        widget.fields.forEach(function(field){
            if(field.name == 'NRCPFPESSOA'){
               field.isVisible = this.idGrupoCadastro[0] == 'I' ? false : true; 
            }else if(field.name == 'DSCDCHAVE'){
                field.isVisible = this.idGrupoCadastro[0] == 'I' ? false : true; 
                if(this.idGrupoCadastro[0] == 'N'){
                    field.label = 'Nr. Vínculo';
                }else if(this.idGrupoCadastro[0] == 'P'){
                    field.label = 'Nr. Pessoa';
                }else{
                    field.label = '';            
                }
            }else if(field.name == 'DSCHAVE'){
               field.isVisible = this.idGrupoCadastro[0] == 'I' ? false : true; 
               field.label = this.idGrupoCadastro[0] == 'I' ? '' : 'Nome';
            }else if(field.name == 'CDMATRICULAESOCIAL'){
               field.isVisible = this.idGrupoCadastro[0] == 'N' ? true : false;
            }else if(field.name == 'NRCHAVE'){
                field.class = this.idGrupoCadastro[0] == 'N' ? '3' : '5';
            }else if(field.name == 'NRTABELA'){
                field.class = this.idGrupoCadastro[0] == 'N' ? '4' : '6';
            }
        }.bind(this));
        return true;
    };
    
    this.onActivateEstruturas = function() {
        // Altera o label do container conforme o menu acionado
        
        if(!Util.isEmptyOrBlank(templateManager.loadingContainerJson)){
            var widget = templateManager.loadingContainerJson.widgets[0];
            widget.container.label = this.lblContainer;
            
            if(this.lblContainer){
                var widgetAtiva = widget.container.getActiveWidget();
                // Caso a widget de envios esteja ativa recarrega os envios conforme o grupo do menu acionado
                // if (widgetAtiva.name == 'envioCadastros' && widgetAtiva.active) {
                //     widgetAtiva.reload();
                // }
                
                // Recarrega os eventos conforme o menu acionado
            
            }else{
                ScreenService.openWindow('product#dashboard');
            }        
        }
    };

    this.afterMoveEstrutura = function(args) {
        var widget = templateManager.container.getWidget('estruturas');
        var widgetEnvios = templateManager.container.getWidget('envioCadastros');
        var idParametrizado = (widget.currentRow.DSVERSAO != null && widget.currentRow.NRTPAMBIENTE != null && widget.currentRow.NRPARCNEGOCIO != null);
        
        // Enable or disable widget envioCadastros and actions cargainicial and parametroEsocial
        widgetEnvios.isVisible = idParametrizado;
        widget.actions.forEach(function(action){
            if (action.name == 'cargainicial') {
                action.isVisible = (idParametrizado && (this.idGrupo == 'T' || this.idGrupo == 'N'));
            }else if (action.name == 'exclusaoEmpregador') {
                action.isVisible = (idParametrizado && (this.idGrupo == 'T') && (widget.currentRow.NRTPAMBIENTE == 2) && widget.currentRow.IDMATRIZ == 'S');
            }else if (action.name == 'parametroEsocial') {
                action.isVisible = !idParametrizado;
            }
        }.bind(this));
        
        // Fecha os swipes abertos
        // if(widgetEnvios.active && widgetEnvios.inViewMode()){
        //     ScreenService.closeSwipe(0);
        // }

        //Seta dados para widget Envios
        if (widgetEnvios.isVisible) {
            widgetEnvios.dataSourceFilter.forEach(function(filter){
                if (filter.name == 'P_NRESTRUTURAM') {
                    filter.value = widget.currentRow.NRESTRUTURAM;
                }
                if (filter.name == 'NRTPAMBIENTE') {
                    filter.value = widget.currentRow.NRTPAMBIENTE;
                }
            });
            
            widgetEnvios.fields.forEach(function(field){
                var filtro;
                if(field.name == 'NRESTRUTURAM'){
                    field.defaultValue = widget.currentRow.NRESTRUTURAM;
                }else if(field.name == 'IDMATRIZ'){
                    field.defaultValue = widget.currentRow.IDMATRIZ;
                }else if(field.name == 'NRTPAMBIENTE'){
                    field.defaultValue = widget.currentRow.NRTPAMBIENTE;
                // }else if(field.name == 'NREVENTO'){
                //     filtro = field.dataSourceFilter[ABUtilController.retornaFiltro(field.dataSourceFilter, 'DSVERSAO')];
                //     if(filtro)
                //         filtro.value = widget.currentRow.DSVERSAO;
                }else if(field.name == 'NRVINCULOM'){
                    filtro = field.dataSourceFilter[ABUtilController.retornaFiltro(field.dataSourceFilter, 'NRESTRUTLEGAL')];
                    if(filtro)
                        filtro.value = widget.currentRow.NRESTRUTURAM;
                }else if(field.name == 'NRVINCULOMCOMPL'){
                    filtro = field.dataSourceFilter[ABUtilController.retornaFiltro(field.dataSourceFilter, 'NRESTRUTMATRIZ')];
                    if(filtro)
                        filtro.value = widget.currentRow.NRESTRUTURAM;
                }else if(field.name == 'NRVINCULOMRESC'){
                    filtro = field.dataSourceFilter[ABUtilController.retornaFiltro(field.dataSourceFilter, 'NRESTRUTLEGAL')];
                    if(filtro)
                        filtro.value = widget.currentRow.NRESTRUTURAM;
                }
                // else if(field.name == 'DTMESCOMPETENC' && field.label == 'Histórico'){
                //     field.filterProperties.defaultValue = {
                //         start: getLocalVar('HCM_DTCOMPETENCIA_OPER') ? getLocalVar('HCM_DTCOMPETENCIA_OPER') : '',
                //         end: getLocalVar('HCM_FIM_DTCOMPETENCIA_OPER') ? getLocalVar('HCM_FIM_DTCOMPETENCIA_OPER') : ''
                //     };
                // }
            });
        }
        widgetEnvios.reload();
        this.nrestruturam = widget.currentRow.NRESTRUTURAM;
        // Versão
        this.getVersao(args);
    };

    // this.getEnviosCadastros = function(args) {
    //     var widgetEnvios = templateManager.container.getWidget('envioCadastros');
    //     var dados = widgetEnvios.dataSource.data;
    //     var registro = !Util.isEmptyOrBlank(dados) ? dados[0] : null;
    
    //     if (Util.isEmptyOrBlank(registro) || registro.NRESTRUTURAM != this.nrestruturam) {
    //         // widgetEnvios.reload();
    //     }
    // };

    this.setActionEnvioAutomatico = function(args) {
        var widgetEstruturas = templateManager.container.getWidget('estruturas');
        var widgetEnvios = templateManager.container.getWidget('envioCadastros');
        var idGrupo = this.idGrupo;
        if(!this.campoAtivoFiltroNaoEstaMarcado){
            widgetEnvios.actions.forEach(function(action){
                if (action.name == 'envioAutomatico') {
                    action.isVisible = (widgetEnvios.dataSource.data.length > 0);
                } else if (action.name == 'consultaAutomatica') {
                    action.isVisible = (widgetEnvios.dataSource.data.length > 0);
                } else if (action.name == 'fechamentoPeriodico' || action.name == 'fechamentoPeriodicoSemMovimento') {
                    action.isVisible = (idGrupo == 'P' && (widgetEstruturas.currentRow.IDFECHAMENTO == 'N' || widgetEstruturas.currentRow.IDREABERTURA == 'S'));
                } else if (action.name == 'reaberturaPeriodico') {
                    action.isVisible = (idGrupo == 'P' && widgetEstruturas.currentRow.IDFECHAMENTO == 'S' &&  widgetEstruturas.currentRow.IDREABERTURA == 'N');
                } else if (action.name == 'fechamentoPeriodicoAnual') {
                    action.isVisible = (idGrupo == 'P' && (widgetEstruturas.currentRow.IDFECHAMENTO13 == 'N' || widgetEstruturas.currentRow.IDREABERTURA13 == 'S'));
                } else if (action.name == 'fechamentoPeriodicoAnualSemMovimento') {
                    action.isVisible = (idGrupo == 'P' && (widgetEstruturas.currentRow.IDFECHAMENTO13 == 'N' || widgetEstruturas.currentRow.IDREABERTURA13 == 'S'));
                } else if (action.name == 'reaberturaPeriodicoAnual') {
                    action.isVisible = (idGrupo == 'P' && widgetEstruturas.currentRow.IDFECHAMENTO13 == 'S' &&  widgetEstruturas.currentRow.IDREABERTURA13 == 'N');
                }
            });
            //insere o valor true na propriedade 'isVisible' das actions 'emissaoExtrato' e 'new', que sempre estão presentes na tela e que podem ter sido anteriormente ocultadas
            widgetEnvios.getAction('emissaoExtrato').isVisible = true;
            widgetEnvios.getAction('new').isVisible = true;
        } else {
            //Campo 'Ativo' do filtro não foi marcado
            this.setActionsModoFiltroAtivoNaoMarcado(false);
        }
    };

    this.adicionarRow = function(args) {
        var widget = args.owner.widget;
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
        this.setVersao(true);
        widget.currentRow.DSVERSAO = this.dsversao;
        widget.currentRow.GERADEMONSTENVIO = 'N';
    };
    
    this.setFields = function(actionName) {
        ESocialService.setFields(actionName);
    };
    
    this.changeOutData = function(widget){
        var field = widget.getField('NREVENTO_LIST');
        var keys = field.value();
        var rows = field.selectWidget.getCheckedRows();
        field.widget.currentRow.NMEVENTO = [];
        field.widget.currentRow.DSEVENTO = [];
        field.widget.currentRow.IDGRUPO = [];
        
        rows.forEach(function(row) {
    		keys.forEach(function(key) {
    			if (row.NREVENTO == key) {
                    field.widget.currentRow.NMEVENTO.push(row.NMEVENTO);
                    field.widget.currentRow.DSEVENTO.push(row.DSEVENTO);
                    field.widget.currentRow.IDGRUPO.push(row.IDGRUPO);
    			}
    		});
    	});
    };
    
    this.verificaEventosSemFiltro = function(arrayEventos, idgrupo){
        var period = ["S-1250", "S-1202", "S-1207", "S-1260", "S-1270", "S-1280", "S-1295", "S-1300"];
        var naoper = ["S-2210", "S-2220", "S-2221"];
        var eventosSemFiltro = idgrupo == 'P' ? period : naoper;
        var retorno = false;
        
        arrayEventos.forEach(function(evento){
            var verifica = eventosSemFiltro.indexOf(evento);
            if(verifica != -1){
                retorno =  true;
            }
        }); 
        
        return retorno;
    };
    
    this.verificaEventosSelectMultiple = function(){
        var widget = templateManager.container.getWidget('envioCadastros');
        this.changeOutData(widget);
        setTimeout(()=>{
            var nrEvento = widget.currentRow.NREVENTO_LIST;
            var nmEvento = widget.currentRow.NMEVENTO;
            if(nrEvento.length != 0){
                if(this.idGrupoCadastro[0] == "I"){
                    if(nrEvento.length == 1 || (nrEvento.length == 2 && (nmEvento.indexOf('S-1030') != -1 && nmEvento.indexOf('S-1040') != -1))){
                        this.setFiltroNovoEnvio(nmEvento[0], widget);
                    }else{
                        this.setFiltroNovoEnvio(0, widget);
                    }
                }else{
                    if(nrEvento.length == 1 && nmEvento[0] == 'S-1200'){
                        this.setFiltroNovoEnvio(nmEvento[0], widget, true);
                        widget.getField('NRVINCULOMCOMPL').class = '6';
                        widget.getField('NRTIPOMOVIMENT').label = 'Indicativo Apuração';
                        widget.getField('NRTIPOMOVIMENT').dataSourceFilter[ABUtilController.retornaFiltro(widget.getField('NRTIPOMOVIMENT').dataSourceFilter, 'NRTIPOMOVIMENT')].value = [1,4];
                        widget.getField('NRTIPOMOVIMENT').reload();
                    }else if(nrEvento.length == 1 && nmEvento[0] == 'S-1210'){
                        this.setFiltroNovoEnvio(nmEvento[0], widget, true);
                        widget.getField('NRVINCULOMCOMPL').class = '12';
                    }else if((nrEvento.length == 2 && (nmEvento.indexOf('S-1200') != -1  && nmEvento.indexOf('S-1210') != -1))){
                        this.setFiltroNovoEnvio(nmEvento[0], widget, true);
                        widget.getField('NRTIPOMOVIMENT').isVisible = false;
                        widget.currentRow.NRTIPOMOVIMENT = '';
                        widget.getField('NRVINCULOMCOMPL').class = '12';
                    }else if(this.verificaEventosSemFiltro(nmEvento, this.idGrupoCadastro[0]) != true){
                        this.setFiltroNovoEnvio(nmEvento[0], widget);
                        widget.getField('NRTIPOMOVIMENT').label = 'Tipo Movimentação';
                        widget.getField('NRTIPOMOVIMENT').dataSourceFilter[ABUtilController.retornaFiltro(widget.getField('NRTIPOMOVIMENT').dataSourceFilter, 'NRTIPOMOVIMENT')].value = [1,2,4,10,19];
                        widget.getField('NRTIPOMOVIMENT').reload();
                    }else{
                        widget.getField('NRTIPOMOVIMENT').label = 'Tipo Movimentação';
                        this.setFiltroNovoEnvio(0, widget);
                        widget.getField('NRTIPOMOVIMENT').dataSourceFilter[ABUtilController.retornaFiltro(widget.getField('NRTIPOMOVIMENT').dataSourceFilter, 'NRTIPOMOVIMENT')].value = [1,2,4,10,19];
                        widget.getField('NRTIPOMOVIMENT').reload();
                    }
                }
            }else{
                this.setFiltroNovoEnvio(0, widget);   
            }
            
        }, 25);
    };

    this.setFiltroNovoEnvio = function(nmEvento, widget, $geradesmostrativo = false) {
        if(nmEvento != 0){    
            if (widget.currentRow.__is_new) {
                widget.fields.forEach(function(field){
                    if (!Util.isUndefined(field.fieldGroup) && field.fieldGroup == 'FILTRO') {
                        field.isVisible = self.FILTROS[field.name].indexOf(nmEvento) >= 0;
                        field.showOnForm = self.FILTROS[field.name].indexOf(nmEvento) >= 0;
                        field.readOnly = self.FILTROS[field.name].indexOf(nmEvento) < 0;
                        if (field.name == 'NMVINCULOM' && self.FILTROS[field.name].indexOf(nmEvento) >= 0) {
                            field.dataSourceFilter.forEach(function(filter){
                                if (filter.name == 'NRESTRUTLEGAL') {
                                    filter.value = widget.currentRow.NRESTRUTURAM;
                                }
                                if (filter.name == 'NRTIPOVINCULOM') {
                                    filter.value = (nmEvento == 'S-2200' ? [1] : (nmEvento == 'S-2300' ? [2,3,10] : [1,2,3,10]));
                                }
                            });
                            field.reload();
                        }
                    }
                    
                    if(field.name == 'GERADEMONSTENVIO'){ 
                        if($geradesmostrativo){
                            field.readOnly = false;
                            field.checked = false;
                        }else{
                            field.readOnly = true;
                            field.checked = false;
                        }
                    }
                });
            }
        }else{
            widget.fields.forEach(function(field){
                if(field.fieldGroup == 'FILTRO' && field.isVisible == true){
                    field.isVisible = false;
                }
                if(field.name == 'GERADEMONSTENVIO'){ 
                    field.readOnly = true;
                    field.checked = false;
                }
            });
        }
    };

    this.unsetFiltroNovoEnvio = function() {
        var widgetEnvios = templateManager.container.getWidget("envioCadastros");
        widgetEnvios.fields.forEach(function(field){
            if (!Util.isUndefined(field.fieldGroup) && field.fieldGroup == 'FILTRO' && !Util.isUndefined(self.FILTROS[field.name])) {
                field.isVisible = false;
            }
            if(field.name == 'GERADEMONSTENVIO'){
                field.readOnly = true;
                field.checked = false;
            }
            if(field.name == 'NREVENTO_LIST'){
                field.isVisible = false;
                field.showOnForm = false;
            }
        });
        
    };
    
    this.getVersao = function(args){
        var widget = ABUtilController.checkWidget(args);
        this.dsversao = Array.isArray(widget.currentRow.DSVERSAO) ? widget.currentRow.DSVERSAO[0] : widget.currentRow.DSVERSAO;
    };

    this.setVersao = function(visibilidade = false) {
        var widget =  templateManager.containers['product#hcm09001_eso_envioCadastros'].getWidget('envioCadastros');
        var field = widget.getField('NREVENTO_LIST'); 
        // Enable NREVENTO field and set VERSAO in its dataSourceFilter
        field.readOnly = false;
        if(visibilidade){
            field.isVisible = true;
        }
        var filterVs = field.dataSourceFilter[ABUtilController.retornaFiltro(field.dataSourceFilter, 'DSVERSAO')];
        filterVs.value = this.dsversao;
        field.reload();
    };

    this.enableActions = function(args) {
        var widget = ABUtilController.checkWidget(args);
        if(widget.currentRow.__is_new != true && !this.campoAtivoFiltroNaoEstaMarcado){
            widget.actions.forEach(function(action){
                if (action.name == 'excluir') {
                    action.isVisible = (
                        action.widget.currentRow.IDSTATUS == self.STATUS_PENDENTE || 
                        action.widget.currentRow.IDSTATUS == self.STATUS_ERROENVIO || 
                        action.widget.currentRow.IDSTATUS == self.STATUS_ERROPROCE || 
                        Util.isNull(action.widget.currentRow.IDSTATUS)
                    );
                }
            });
        }
    };

    this.enableFields = function(args) {
        var widget = ABUtilController.checkWidget(args);
        
        if(widget.currentRow.__is_new != true){
            this.TABELA = null;
            this.nomeWidget = this.getWidgetEvento(widget);
            
            widget.getField('NRENVIOEXCL').isVisible = !Util.isNull(widget.currentRow.NRENVIOEXCL);
            widget.getField('NREVENTO_LIST').isVisible = false;
            if(!!this.nomeWidget) {
                widget.getField('CHAVEACTION').isVisible = true;
                widget.getField('NRCHAVE').class = this.idGrupoCadastro[0] == 'N' ? '3' : '5';
            } else {
                widget.getField('CHAVEACTION').isVisible = false;
                widget.getField('NRCHAVE').class = this.idGrupoCadastro[0] == 'N' ? '4' : '5';
            }
            
        }
        
        //validação para que o campo IDFECHASMOVIMENT fique visivel no view para eventos S-1299
        this.validaVisualizacaoIdfechasmoviment();
    };
    
    this.validaVisualizacaoIdfechasmoviment = function(){
        var widget = templateManager.container.getWidget('envioCadastros');
        
        var fieldidfechasmoviment = widget.getField('IDFECHASMOVIMENT');
        var fieldidoperacao = widget.getField('IDOPERACAO');
        var fieldidstatus = widget.getField('IDSTATUS');
        var fielddthistorico = widget.getField('DTMESCOMPETENC');
        var fieldnrrecibo = widget.getField('NRRECIBO');
        
        if (widget.currentRow.IDGRUPO == 'P' && widget.currentRow.NMEVENTO == 'S-1299') {
            fieldidfechasmoviment.isVisible = true;
            fieldidfechasmoviment.showOnForm = true;
            fieldidfechasmoviment.readOnly = false;
            fieldidfechasmoviment.validations = {"required": true};
            
            fieldidstatus.class = '3';
            fieldidoperacao.class = '3';
            fielddthistorico.class = '3';
            
            if(widget.currentRow.IDSTATUS == 'P' || widget.currentRow.IDSTATUS == 'E'){
                fieldnrrecibo.validations = {};
            }else{
                fieldnrrecibo.validations = {"required": true};
            }
        } else {
            fieldidfechasmoviment.isVisible = false;
            fieldidfechasmoviment.showOnForm = false;
            fieldidfechasmoviment.readOnly = true;
            fieldidfechasmoviment.validations = {};
            
            fieldidoperacao.class = '4';
            fieldidstatus.class = '4';
            fielddthistorico.class = '4';      
            
            if(!widget.currentRow.IDSTATUS || widget.currentRow.IDSTATUS == 'P' || widget.currentRow.IDSTATUS == 'E'){
                fieldnrrecibo.validations = {};
            }else{
                fieldnrrecibo.validations = {"required": true};
            }
        }
    };
    
    this.setFiltroProtocolo = function(args) {
        var widget = ABUtilController.checkWidget(args);
        widget.getField('NRRECIBO').dataSourceFilter.forEach(function(filter){
            if (filter.name == 'NRENVIO') {
                filter.value = widget.currentRow.NRENVIO;
            }
        });
        widget.getField('NRRECIBO').reload();
    };

    this.setTipoTransmissao = function(args) {
        
        var widget = ABUtilController.checkWidget(args);
        var idxActEditar = null;
        var idxActTransmitir = null;
        var idxActConsultar = null;
        var idxActReenviar = null;
        var idxActExclusao = null;
        var idxActRetificar = null;
        var idxActDownload = null;
        
        var arrEventosNExclui = ['S-1298','S-1299','S-3000'];
        var arrEventosNRetifica = ['S-1295','S-1298','S-1299','S-3000'];
        
        widget.actions.forEach(function(action, index){
            if (action.name == 'editar') {
                idxActEditar = index;
            }else if (action.name == 'transmitir') {
                idxActTransmitir = index;
            }else if (action.name == 'consultar') {
                idxActConsultar = index;
            }else if (action.name == 'reenvio') {
                idxActReenviar = index;
            }else if (action.name == 'exclusao') {
                idxActExclusao = index;
            }else if (action.name == 'retificar') {
                idxActRetificar = index;
            }else if (action.name == 'downloadXML') {
                idxActDownload = index;
            }
        });
        
        if(!this.campoAtivoFiltroNaoEstaMarcado){
    
            switch(widget.currentRow.IDSTATUS) {
                case this.STATUS_PENDENTE:
                    widget.actions[idxActEditar].isVisible = (widget.currentRow.NMEVENTO == 'S-1299');
                    widget.actions[idxActTransmitir].isVisible = true;
                    widget.actions[idxActConsultar].isVisible = false;
                    widget.actions[idxActReenviar].isVisible = false;
                    widget.actions[idxActExclusao].isVisible = false;
                    widget.actions[idxActRetificar].isVisible = false;
                    widget.actions[idxActDownload].isVisible = false;
                    break;
                case this.STATUS_ERROENVIO:
                    widget.actions[idxActEditar].isVisible = (widget.currentRow.NMEVENTO == 'S-1299');
                    widget.actions[idxActTransmitir].isVisible = false;
                    widget.actions[idxActConsultar].isVisible = false;
                    widget.actions[idxActReenviar].isVisible = true;
                    widget.actions[idxActExclusao].isVisible = false;
                    widget.actions[idxActRetificar].isVisible = false;
                    widget.actions[idxActDownload].isVisible = widget.currentRow.DSDIRXMLENV ? true : false;
                    break;
                case this.STATUS_PENDPROCE:
                    widget.actions[idxActEditar].isVisible = false;
                    widget.actions[idxActTransmitir].isVisible = false;
                    widget.actions[idxActConsultar].isVisible = true;
                    widget.actions[idxActReenviar].isVisible = (widget.currentRow.CDERRO == '301' || widget.currentRow.CDERRO == '69');
                    widget.actions[idxActExclusao].isVisible = false;
                    widget.actions[idxActRetificar].isVisible = false;
                    widget.actions[idxActDownload].isVisible = widget.currentRow.DSDIRXMLENV ? true : false;
                    break;
                case this.STATUS_ERROPROCE:
                    widget.actions[idxActEditar].isVisible = true;
                    widget.actions[idxActTransmitir].isVisible = false;
                    widget.actions[idxActConsultar].isVisible = true;
                    widget.actions[idxActReenviar].isVisible = true;
                    widget.actions[idxActExclusao].isVisible = false;
                    widget.actions[idxActRetificar].isVisible = false;
                    widget.actions[idxActDownload].isVisible = widget.currentRow.DSDIRXMLENV ? true : false;
                    break;
                case this.STATUS_CONCLUIDO:
                case this.STATUS_CONCADVER:
                    widget.actions[idxActEditar].isVisible = false;
                    widget.actions[idxActTransmitir].isVisible = false;
                    widget.actions[idxActConsultar].isVisible = false;
                    widget.actions[idxActReenviar].isVisible = false;
                    widget.actions[idxActExclusao].isVisible = (Util.isNull(widget.currentRow.NRENVIOEXCL) && 
                                                                ((this.idGrupo != 'T' && widget.currentRow.NMEVENTO != 'S-3000') || (this.idGrupo == 'T' && widget.currentRow.IDOPERACAO != 'E')) &&
                                                                (arrEventosNExclui.indexOf(widget.currentRow.NMEVENTO) == -1));
                    widget.actions[idxActRetificar].isVisible = (Util.isNull(widget.currentRow.NRENVIOEXCL) && 
                                                                 (this.idGrupo == 'P' || this.idGrupo == 'N') && 
                                                                 (widget.currentRow.IDOPERACAO != 'R' || (widget.currentRow.IDOPERACAO == 'R' && (widget.currentRow.IDSTATUS == this.STATUS_CONCLUIDO || widget.currentRow.IDSTATUS == this.STATUS_CONCADVER))) && 
                                                                 (arrEventosNRetifica.indexOf(widget.currentRow.NMEVENTO) == -1));
                    widget.actions[idxActDownload].isVisible = widget.currentRow.DSDIRXMLENV ? true : false;
                    break;
                default:
                    widget.actions[idxActEditar].isVisible = false;
                    widget.actions[idxActTransmitir].isVisible = false;
                    widget.actions[idxActConsultar].isVisible = false;
                    widget.actions[idxActReenviar].isVisible = false;
                    widget.actions[idxActExclusao].isVisible = false;
                    widget.actions[idxActRetificar].isVisible = false;
                    widget.actions[idxActDownload].isVisible = false;
                    break;
            
                
            }
            
            //Insere manualmente o valor false na propriedade 'isVisible' das actions 'new' e 'emissaoExtrato' que podem ter sido ocultadas anteriormente e
            //que não voltam a ser true durante as validações das demais actions
            widget.getAction('new').isVisible = true;
            widget.getAction('emissaoExtrato').isVisible = true;
        
        } else {
            
            //Entrando nessa condição, significa que o campo 'Ativo' do filtro foi desmarcado, logo devem ser 'escondidas' todas as actions exceto a 'editar' e a action 'ativaEvento' que
            //é ativada na função 'setModoFiltroAtivo'
            widget.actions[idxActEditar].isVisible = true;
            widget.actions[idxActTransmitir].isVisible = false;
            widget.actions[idxActConsultar].isVisible = false;
            widget.actions[idxActReenviar].isVisible = false;
            widget.actions[idxActExclusao].isVisible = false;
            widget.actions[idxActRetificar].isVisible = false;
            
            widget.getAction('new').isVisible = false;
            widget.getAction('excluirLote').isVisible = false;
            widget.getAction('excluir').isVisible = false;
        }
    };
    
    this.enableWidgetXml = function(args) {
        var widget = ABUtilController.checkWidget(args);
        var idxTabDadosEnv = null;
        var idxTabRespEnv = null;
        var idxTabRespPro = null;
        var idxTabRespTot = null;
        
        widget.widgets.forEach(function(widget, index){
            if (widget.name == 'envioCadastros_DadosEnv') {
                idxTabDadosEnv = index;
            }
            if (widget.name == 'envioCadastros_RetEnvio') {
                idxTabRespEnv = index;
            }
            if (widget.name == 'envioCadastros_RetProces') {
                idxTabRespPro = index;
            }
            if (widget.name == 'envioCadastros_RetTotal') {
                idxTabRespTot = index;
            }
        });
        
        widget.widgets[idxTabDadosEnv].isVisible = !Util.isUndefinedOrNull(widget.currentRow.DSDIRXMLENV);
        widget.widgets[idxTabRespEnv].isVisible = !Util.isUndefinedOrNull(widget.currentRow.DSDIRXMLRETENV);
        widget.widgets[idxTabRespPro].isVisible = !Util.isUndefinedOrNull(widget.currentRow.DSDIRXMLRETPRO);
        widget.widgets[idxTabRespTot].isVisible = !Util.isUndefinedOrNull(widget.currentRow.DSDIRXMLRETTOT);
    };

    this.setEnvioCadastros = function(args) {
        var ehEventoPeriodico = this.idGrupo == 'P' ? true : false;
        var widget = args.owner.widget;
        if (widget.isValid()) {
            if (!widget.backupRow) {
                widget.currentRow.__is_new = true;
            } else {
                widget.currentRow.__is_new = false;
            }
            widget.currentRow.NRESTRUTEMPREGADOR = widget.parent.parent.currentRow.NRESTRUTEMPREGADOR;
            widget.currentRow.CDCNPJEMPREGADOR = widget.parent.parent.currentRow.CDCNPJEMPREGADOR;
            ESocialService.FILTROS = self.FILTROS;
            
            if(this.seDataAtualMaiorDataEnvioESocial() && ehEventoPeriodico){
                //Apenas após clicar em 'Ok' que o processo é realizado
                //Esquema de aviso construída devido à sobreposição de avisos do framework
                ScreenService.showCustomDialog(Messages.AVISO_ESO_PENSALIDADE_PROCESSO_INCLUSAO, 'CONFIRMATION', null, [
                    {
                        label: ScreenService.i18n("Ok"),
                        code: function (e, deferred) { 
                            ESocialService.setEnvioCadastros(widget, ABUtilController, this.idGrupo);
                            deferred.resolve(e);
                        }.bind(this)
                    }
                ]);
            } else {
                //Caso o aviso não seja mostrado, o processo é realizado normalmente
                ESocialService.setEnvioCadastros(widget, ABUtilController);
            }
            
        }
    };

    this.deleteEnvioCadastros = function(args) {
        var widget = args.owner.widget;
        var erroExcl = false;
        if (widget.dataSource.getCheckedRows().length > 0) {
            widget.dataSource.getCheckedRows().forEach(function(row) {
                row.__is_new = false;
                if (!self.isEnviosRowDeletable(row)) {
                    erroExcl = true;
                }
            });
        } else {
            widget.currentRow.__is_new = false;
            if (!this.isEnviosRowDeletable(widget.currentRow)) {
                erroExcl = true;
            }
        }
        if (erroExcl) {
            ScreenService.showMessage(Messages.HCM09000_ESO_EXCLUSAO_ERROR, 'ERROR');
        } else {
            ScreenService.confirmMessage('Deseja realmente excluir o(s) registro(s)?', 'CONFIRMATION',
                function(){
                    ESocialService.deleteEnvioCadastros(widget, ABUtilController);
                }.bind(this),
                function(){
                    //nothing to do
                }
            );
        }
    };

    this.setActionTransmissaoLote = function(args) {
        var widget = ABUtilController.checkWidget(args);
        var widgetEstruturas = templateManager.container.getWidget('estruturas');
        var idGrupo = this.idGrupo;
        var idActVisible = false;
        var idCheckDesligamento = false;
        if(widgetEstruturas && !this.campoAtivoFiltroNaoEstaMarcado){
            if (widget.getCheckedRows().length > 0) {
                idActVisible = true;
                
                //Verifica se foram marcados somente os eventos de desligamento S-2299, S-2399
                var idDesligamento = false;
                var idOutros = false;
                widget.getCheckedRows().forEach(function(row){
                    if (row.NMEVENTO == 'S-2299' || row.NMEVENTO == 'S-2399') {
                        idDesligamento = true;
                    } else {
                        idOutros = true;
                    }
                });
                idCheckDesligamento = (idDesligamento && !idOutros);
            }
            widget.actions.forEach(function(action){
                if (action.name == 'envioAutomatico') {
                    action.isVisible = !idActVisible;
                } else if (action.name == 'consultaAutomatica') {
                    action.isVisible = !idActVisible;
                } else if (action.name == 'excluirLote') {
                    action.isVisible = idActVisible;
                } else if (action.name == 'transmitirLote') {
                    action.isVisible = idActVisible;
                } else if (action.name == 'retificarLote') {
                    action.isVisible = idActVisible && (idGrupo == 'P' || idCheckDesligamento);
                } else if (action.name == 'fechamentoPeriodico' || action.name == 'fechamentoPeriodicoSemMovimento') {
                    action.isVisible = !idActVisible && (idGrupo == 'P' && (widgetEstruturas.currentRow.IDFECHAMENTO == 'N' || widgetEstruturas.currentRow.IDREABERTURA == 'S'));
                } else if (action.name == 'reaberturaPeriodico') {
                    action.isVisible = !idActVisible && (idGrupo == 'P' && widgetEstruturas.currentRow.IDFECHAMENTO == 'S' &&  widgetEstruturas.currentRow.IDREABERTURA == 'N');
                } else if (action.name == 'fechamentoPeriodicoAnual') {
                    action.isVisible = !idActVisible && (idGrupo == 'P' && (widgetEstruturas.currentRow.IDFECHAMENTO13 == 'N' || widgetEstruturas.currentRow.IDREABERTURA13 == 'S'));
                } else if (action.name == 'fechamentoPeriodicoAnualSemMovimento') {
                    action.isVisible = !idActVisible && (idGrupo == 'P' && (widgetEstruturas.currentRow.IDFECHAMENTO13 == 'N' || widgetEstruturas.currentRow.IDREABERTURA13 == 'S'));
                } else if (action.name == 'reaberturaPeriodicoAnual') {
                    action.isVisible = !idActVisible && (idGrupo == 'P' && widgetEstruturas.currentRow.IDFECHAMENTO13 == 'S' &&  widgetEstruturas.currentRow.IDREABERTURA13 == 'N');
                } else if (action.name == 'downloadVariosXML') {
                    action.isVisible = idActVisible;
                }else if (action.name == 'inclusaoManualAdmissao'){
                    action.isVisible = !idActVisible && idGrupo == 'N';
                }
            });
            
            // this.controlaCampos(widget);
            // widget.redraw();
            
            //insere o valor true na propriedade 'isVisible' das actions 'emissaoExtrato' e 'new', que sempre estão presentes na tela e que podem ter sido anteriormente ocultadas
            widget.getAction('emissaoExtrato').isVisible = true;
            widget.getAction('new').isVisible = true;
        } else if(this.campoAtivoFiltroNaoEstaMarcado){
            //Campo 'Ativo' do filtro não foi marcado
            this.setActionsModoFiltroAtivoNaoMarcado(false);
        }
        
    };

    this.transmitirLoteEvento = function(args, realizaVerificacao = true, realizaConsulta = false, realizaValidacaoEventoPendente = true) {
        // Função que realiza a transmissão de um ou mais eventos simultâneamente na forma de lotes
        // @param boolean tratativaDeVisualizacaoPopUp: Indica que a visualização das mensagens deve ser construída em um popUp. Modificação realizada
        // tendo como objetivo mostrar corretamente as mensagens do processo no popUp de envios periódicos pendentes para o envio de S-1200 ou S-1210
         
        var widget;
        if (args instanceof Widget) {
            widget = args;
        } else {
            widget = args.owner.widget;
        }
        
        var ehEventoPeriodico = this.idGrupo == 'P' ? true : false;
        if (widget.getCheckedRows().length > 50) {
            ScreenService.showMessage(Messages.HCM09000_ESO_LOTE_QTDE_ERROR);
        } else {
            var lotePendente = true;
            if (realizaValidacaoEventoPendente) {
                widget.getCheckedRows().forEach(function (row) {
                    if (row.IDSTATUS != 'P') {
                        lotePendente = false;
                    }
                });
            }
            if (lotePendente) {
                ScreenService.confirmMessage('Deseja realmente enviar um lote com os eventos selecionados para o ambiente de ' + (widget.currentRow.NRTPAMBIENTE == '1' ? 'Produção' : 'Produção Restrita') + ' ?', 'CONFIRMATION',
                    function(){
                        if(this.seDataAtualMaiorDataEnvioESocial() && ehEventoPeriodico){
                            //Apenas após clicar em 'Ok' que o processo é realizado
                            //Esquema de aviso construída devido à sobreposição de avisos do framework
                            ScreenService.showCustomDialog(Messages.AVISO_ESO_PENSALIDADE_PROCESSO_TRANSMISSAO, 'CONFIRMATION', null, [
                                {
                                    label: ScreenService.i18n("Ok"),
                                    code: function (e, deferred) { 
                                        ESocialService.transmissao(widget, ABUtilController, ESocialService.IDTRANSENVIO, widget.getCheckedRows(), realizaVerificacao, realizaConsulta);
                                        deferred.resolve(e);
                                    }.bind(this)
                                }
                            ]);
                        } else {
                            //Caso o aviso não seja mostrado, o processo é realizado normalmente
                            ESocialService.transmissao(widget, ABUtilController, ESocialService.IDTRANSENVIO, widget.getCheckedRows(), realizaVerificacao, realizaConsulta);
                        }
                        
                    }.bind(this),
                    function(){
                        //nothing to do
                    }
                );
            } else {
                ScreenService.showMessage(Messages.HCM09000_ESO_LOTE_STATUS_ERROR);
            }
        }
    };

    this.retificarLoteEvento = function(args) {
        var widget = args.owner.widget;
        if (widget.getCheckedRows().length > 50) {
            ScreenService.showMessage(Messages.HCM09000_ESO_LOTE_QTDE_ERROR);
        } else {
            var nmEventoAnt = null;
            var loteConcluido = true;
            widget.getCheckedRows().forEach(function (row) {
                if ((row.IDSTATUS != 'C' && row.IDSTATUS != 'A') || row.NRENVIOEXCL != null) {
                    loteConcluido = false;
                }
                if (nmEventoAnt != null && nmEventoAnt != row.NMEVENTO) {
                    loteConcluido = false;
                }
                nmEventoAnt = row.NMEVENTO;
            });
            if (loteConcluido) {
                ScreenService.confirmMessage('Deseja realmente retificar um lote com os eventos selecionados para o ambiente de ' + (widget.currentRow.NRTPAMBIENTE == 1 ? 'Produção' : 'Produção Restrita') + ' ?', 'CONFIRMATION',
                    function(){
                        ESocialService.transmissao(widget, ABUtilController, ESocialService.IDTRANSRETIF, widget.getCheckedRows());
                    }.bind(this),
                    function(){
                        //nothing to do
                    }
                );
            } else {
                ScreenService.showMessage(Messages.HCM09000_ESO_RETIFICA_LOTE_STATUS_ERROR);
            }
        }
    };

    this.transmitirEvento = function(args, realizaVerificacao = true, realizaConsulta = false) {
        
        var widget;
        if (args instanceof Widget) {
            widget = args;
        } else {
            widget = args.owner.widget;
        }
        
        var ehEventoPeriodico = this.idGrupo == 'P' ? true : false;
        if (widget.isValid()) {
            ScreenService.confirmMessage('Deseja realmente enviar o evento para o ambiente de ' + (widget.currentRow.NRTPAMBIENTE == 1 ? 'Produção' : 'Produção Restrita') + ' ?', 'CONFIRMATION',
                function(){
                    if(this.seDataAtualMaiorDataEnvioESocial() && ehEventoPeriodico){
                        //Apenas após clicar em 'Ok' que o processo é realizado
                        //Esquema de aviso construída devido à sobreposição de avisos do framework
                        ScreenService.showCustomDialog(Messages.AVISO_ESO_PENSALIDADE_PROCESSO_TRANSMISSAO, 'CONFIRMATION', null, [
                            {
                                label: ScreenService.i18n("Ok"),
                                code: function (e, deferred) { 
                                    ESocialService.transmissao(widget, ABUtilController, ESocialService.IDTRANSENVIO, [widget.currentRow], realizaVerificacao, realizaConsulta);
                                    deferred.resolve(e);
                                }.bind(this)
                            }
                        ]);
                    } else {
                        //Caso o aviso não seja mostrado, o processo é realizado normalmente
                        ESocialService.transmissao(widget, ABUtilController, ESocialService.IDTRANSENVIO, [widget.currentRow], realizaVerificacao, realizaConsulta);
                    }
                }.bind(this),
                function(){
                    //nothing to do
                }
            );
        }
    };

    this.consultarEvento = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
            ESocialService.transmissao(widget, ABUtilController, ESocialService.IDTRANSCONSU, [widget.currentRow]);
        }
    };

    this.reenviarEvento = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
            ScreenService.confirmMessage('Deseja realmente reenviar o evento para o ambiente de ' + (widget.currentRow.NRTPAMBIENTE == 1 ? 'Produção' : 'Produção Restrita') + ' ?', 'CONFIRMATION',
                function(){
                    ESocialService.transmissao(widget, ABUtilController, ESocialService.IDTRANSREENV, [widget.currentRow]);
                }.bind(this),
                function(){
                    //nothing to do
                }
            );
        }
    };

    this.exluirEvento = function(args) {
        var widget = args.owner.widget;
        var message = '';
        if (widget.isValid()) {
            if (this.idGrupo == 'T') {
                message = 'Será incluído um envio de exclusão para o mesmo evento e chave selecionados e realizada exclusão da base de ' + (widget.currentRow.NRTPAMBIENTE == 1 ? 'Produção' : 'Produção Restrita') + ' do eSocial. Deseja continuar?';
            } else {
                message = 'Será incluído um envio S-3000 relacionado e realizada exclusão do evento da base de ' + (widget.currentRow.NRTPAMBIENTE == 1 ? 'Produção' : 'Produção Restrita') + ' do eSocial. Deseja continuar?';
            }
            ScreenService.confirmMessage(message, 'CONFIRMATION',
                function(){
                    ESocialService.transmissao(widget, ABUtilController, ESocialService.IDTRANSEXCLU, [widget.currentRow]);
                }.bind(this),
                function(){
                    //nothing to do
                }
            );
        }
    };

    this.retificarEvento = function(args) {
        var widget = args.owner.widget;
        var message = '';
        if (widget.isValid()) {
            message = 'Será incluído um envio de retificação para o mesmo evento e chave selecionados e realizado sua transmissão automatica. Deseja continuar?';
            ScreenService.confirmMessage(message, 'CONFIRMATION',
                function(){
                    ESocialService.transmissao(widget, ABUtilController, ESocialService.IDTRANSRETIF, [widget.currentRow]);
                }.bind(this),
                function(){
                    //nothing to do
                }
            );
        }
    };

    this.openParametroESocial = function(args) {
        var widget = ABUtilController.checkWidget(args);
        var nrestruturam = widget.currentRow.NRESTRUTURAM;
        ScreenService.openWindow('product#hcm09004_eso_parametro');
    };

    this.gerarCargaInicial = function(args) {
        var widget = ABUtilController.checkWidget(args);
        var message = '';
        if (widget.currentRow.DSVERSAO == null || widget.currentRow.NRTPAMBIENTE == null|| widget.currentRow.NRPARCNEGOCIO == null) {
            ScreenService.showMessage('Parametros do eSocial não informados para a estrutura');
        } else {
            if (this.idGrupo == 'T') {
                message = 'Será realizada a inserção de itens para os eventos iniciais e de tabela, como estruturas, eventos, ocupações e horários, necessários para a carga inicial do e-Social. Deseja continuar?';
            }
            else if (this.idGrupo == 'N') {
                message = 'Será realizada a inserção de itens referentes aos vínculos para a carga inicial dos eventos não periódicos do e-Social. Deseja continuar?';
            }
            else {
                return;
            }
            ScreenService.confirmMessage(message, 'CONFIRMATION',
                function(){
                    widget.currentRow.IDGRUPO = this.idGrupo;
                    ESocialService.gerarCargaInicial(widget, ABUtilController);
                }.bind(this),
                function(){
                    //nothing to do
                }
            );
        }
    };
    
    this.excluirDadosEmpregador = function(args) {
        var widget = ABUtilController.checkWidget(args);
        if (widget.currentRow.DSVERSAO == null || widget.currentRow.NRTPAMBIENTE == null|| widget.currentRow.NRPARCNEGOCIO == null) {
            ScreenService.showMessage('Parametros do eSocial não informados para a estrutura');
        } else {
            ScreenService.confirmMessage('Será realizada a exclusão de todos envios do empregador na base de dados do e-Social, inclusive o evento S-1000. Deseja continuar?', 'CONFIRMATION',
                function(){
                    ESocialService.excluirDadosEmpregador(widget, ABUtilController);
                }.bind(this),
                function(){
                    //nothing to do
                }
            );
        }
    };

    this.openEnvioAutomatico = function(widget) {
        var widgetFilter = templateManager.container.getWidget('envioAutomatico');
        var widgetEstrutura = templateManager.container.getWidget('estruturas');

        widgetFilter.currentRow.NRESTRUTURAM = widgetEstrutura.currentRow.NRESTRUTURAM;
        widgetFilter.currentRow.DSVERSAO = widgetEstrutura.currentRow.DSVERSAO;
        widgetFilter.currentRow.NRTPAMBIENTE = widgetEstrutura.currentRow.NRTPAMBIENTE;
        widgetFilter.currentRow.IDSTATUS = [this.STATUS_PENDENTE, this.STATUS_ERROENVIO, this.STATUS_ERROPROCE];
        widgetFilter.getField('NMEVENTO').dataSourceFilter.forEach(function(filter){
            if (filter.name == 'DSVERSAO') {
                filter.value = widgetEstrutura.currentRow.DSVERSAO;
            }
        });

        ABUtilController.masterDetailOpenPopup(widgetFilter);
    };

    // realizaVerificacao = true, realizaConsulta = false, realizaValidacaoEventoPendente = true
    this.envioAutomatico = function(widgetFilter, realizaVerificacao = true) {
        if (widgetFilter.isValid()) {
            var ehEventoPeriodico = this.idGrupo == 'P' ? true : false;
            var nmEvento = widgetFilter.currentRow.NMEVENTO;
            ScreenService.confirmMessage('Será realizada a transmissão automática em lotes de todos itens pendentes para o evento ' + nmEvento + '. Deseja continuar?', 'CONFIRMATION',
                function(){
                    if(this.seDataAtualMaiorDataEnvioESocial() && ehEventoPeriodico){
                        //Apenas após clicar em 'Ok' que o processo é realizado
                        //Esquema de aviso construída devido à sobreposição de avisos do framework
                        ScreenService.showCustomDialog(Messages.AVISO_ESO_PENSALIDADE_PROCESSO_INCLUSAO, 'CONFIRMATION', null, [
                            {
                                label: ScreenService.i18n("Ok"),
                                code: function (e, deferred) { 
                                    ESocialService.envioAutomaticoEventos(widgetFilter, ABUtilController, realizaVerificacao);
                                    deferred.resolve(e);
                                }.bind(this)
                            }
                        ]);
                    } else {
                        //Caso o aviso não seja mostrado, o processo é realizado normalmente
                        ESocialService.envioAutomaticoEventos(widgetFilter, ABUtilController, realizaVerificacao);
                    }
                    
                }.bind(this),
                function(){
                    //nothing to do
                }
            );
        }
    };

    this.openConsultaAutomatica = function(widget) {
        var widgetFilter = templateManager.container.getWidget('consultaAutomatica');
        var widgetEstrutura = templateManager.container.getWidget('estruturas');

        widgetFilter.currentRow.NRESTRUTURAM = widgetEstrutura.currentRow.NRESTRUTURAM;
        widgetFilter.currentRow.DSVERSAO = widgetEstrutura.currentRow.DSVERSAO;
        widgetFilter.currentRow.NRTPAMBIENTE = widgetEstrutura.currentRow.NRTPAMBIENTE;
        widgetFilter.currentRow.IDSTATUS = [this.STATUS_PENDPROCE, this.STATUS_ERROPROCE];
        widgetFilter.getField('NMEVENTO').dataSourceFilter.forEach(function(filter){
            if (filter.name == 'DSVERSAO') {
                filter.value = widgetEstrutura.currentRow.DSVERSAO;
            }
        });

        ABUtilController.masterDetailOpenPopup(widgetFilter);
    };
    
    this.selectEventoAutomaticos = function(){
        var widget = templateManager.container.getActiveWidget();
        if(widget.currentRow.NMEVENTO == 'S-1200'){
            widget.getField('NRTIPOMOVIMENT').isVisible = true;
        }else{
            widget.getField('NRTIPOMOVIMENT').isVisible = false;
        }
    };

    this.consultaAutomatica = function(widgetFilter) {
        if (widgetFilter.isValid()) {
            var nmEvento = widgetFilter.currentRow.NMEVENTO;
            ScreenService.confirmMessage('Será realizada a consulta automática de todos itens pendentes processamento para o evento ' + nmEvento + '. Deseja continuar?', 'CONFIRMATION',
                function(){
                    ESocialService.consultaAutomaticaEventos(widgetFilter, ABUtilController);
                }.bind(this),
                function(){
                    //nothing to do
                }
            );
        }
    };
    
    this.fechamentoPeriodico = function(args, semMovimento, anual) {
        var widget = ABUtilController.checkWidget(args);
        var ehEventoPeriodico = this.idGrupo == 'P' ? true : false;
        var widgetEstrutura = templateManager.container.getWidget('estruturas');
        widgetEstrutura.currentRow.SMOVIMENTO = semMovimento ? 'S' : 'N';
        widgetEstrutura.currentRow.NRTABELA = anual ? 4 : 1;
        if (widgetEstrutura.currentRow.DSVERSAO == null || widgetEstrutura.currentRow.NRTPAMBIENTE == null|| widgetEstrutura.currentRow.NRPARCNEGOCIO == null) {
            ScreenService.showMessage('Parametros do eSocial não informados para a estrutura');
        } else {
            ScreenService.confirmMessage('Será realizado o fechamento dos eventos periódicos para o empregador. Deseja continuar?', 'CONFIRMATION',
                function(){
                    if(this.seDataAtualMaiorDataEnvioESocial() && ehEventoPeriodico){
                        //Apenas após clicar em 'Ok' que o processo é realizado
                        //Esquema de aviso construída devido à sobreposição de avisos do framework
                        ScreenService.showCustomDialog(Messages.AVISO_ESO_PENSALIDADE_FECHAMENTO_MENSAL, 'CONFIRMATION', null, [
                            {
                                label: ScreenService.i18n("Ok"),
                                code: function (e, deferred) { 
                                    ESocialService.fechamentoPeriodico(widgetEstrutura, ABUtilController);
                                    deferred.resolve(e);
                                }.bind(this)
                            }
                        ]);
                    } else {
                        //Caso o aviso não seja mostrado, o processo é realizado normalmente
                        ESocialService.fechamentoPeriodico(widgetEstrutura, ABUtilController);
                    }
                    
                }.bind(this),
                function(){
                    //nothing to do
                }
            );
        }
    };
    
    this.reaberturaPeriodico = function(args, idAnual) {
        var widget = ABUtilController.checkWidget(args);
        var widgetEstrutura = templateManager.container.getWidget('estruturas');
        if (widgetEstrutura.currentRow.DSVERSAO == null || widgetEstrutura.currentRow.NRTPAMBIENTE == null|| widgetEstrutura.currentRow.NRPARCNEGOCIO == null) {
            ScreenService.showMessage('Parametros do eSocial não informados para a estrutura');
        } else {
            widgetEstrutura.currentRow.NRTABELA = (idAnual ? 4 : 1);
            ScreenService.confirmMessage('Será realizado a reabertura dos eventos periódicos para o empregador. Deseja continuar?', 'CONFIRMATION',
                function(){
                    ESocialService.reaberturaPeriodico(widgetEstrutura, ABUtilController);
                }.bind(this),
                function(){
                    //nothing to do
                }
            );
        }
    };

    this.setGetXmlFilter = function(widget) {
        var idXmlFile;
        var idEvento = templateManager.container.getWidget("envioCadastros").currentRow.IDEVENTO;
        var dsDirXmlEnv = templateManager.container.getWidget("envioCadastros").currentRow.DSDIRXMLENV;
        var dsDirXmlRetEnv = templateManager.container.getWidget("envioCadastros").currentRow.DSDIRXMLRETENV;
        var dsDirXmlRetPro = templateManager.container.getWidget("envioCadastros").currentRow.DSDIRXMLRETPRO;
        var dsDirXmlRetTot = templateManager.container.getWidget("envioCadastros").currentRow.DSDIRXMLRETTOT;
        var nrTpAmbiente = templateManager.container.getWidget("estruturas").currentRow.NRTPAMBIENTE;
        var idGrupo = this.idGrupo;
        var cdCnpjEstrut = templateManager.container.getWidget("estruturas").currentRow.CDCNPJESTRUT;
        widget.dataSourceFilter.forEach(function(filter){
            if (filter.name == 'P_XMLFILE') {
                idXmlFile = filter.value;
            }
            if (filter.name == 'P_IDEVENTO') {
                filter.value = idEvento;
            }
            if (filter.name == 'P_DSDIRXML') {
                filter.value = (idXmlFile == 'envio' ? dsDirXmlEnv : (idXmlFile == 'retorno' ? dsDirXmlRetEnv : (idXmlFile == 'consulta' ? dsDirXmlRetPro : (idXmlFile == 'total' ? dsDirXmlRetTot : ''))));
            }
            if (filter.name == 'P_NRTPAMBIENTE') {
                filter.value = nrTpAmbiente;
            }
            if (filter.name == 'P_IDGRUPO') {
                filter.value = idGrupo;
            }
            if (filter.name == 'P_CDCNPJESTRUT') {
                filter.value = cdCnpjEstrut;
            }
        });
        widget.reload();
    };
    
    // função inativada devido a mudança na action de redirecionamento - 19/04/2019
    // this.filtrarFilhasPorESocial = function(args){
    //     var widget = ABUtilController.checkWidget(args);
    //     if(this.filtrarFilhasESocial){
    //         widget.dataSourceFilter.push(
    //             {
    //                 "name": this.paramFiltro,
    //                 "operator": "=",
    //                 "value": this.CODIGO
    //             }
    //         );
    //         if(!!this.TABELA){ //verifica se existe mais um parãmetro a ser filtrado
    //             if(widget.dataSourceFilter[ABUtilController.retornaFiltro(widget.dataSourceFilter, this.paramFiltroTabela)]){
    //                 widget.dataSourceFilter[ABUtilController.retornaFiltro(widget.dataSourceFilter, this.paramFiltroTabela)].value = this.TABELA;
    //             }else{
    //                 widget.dataSourceFilter.push(
    //                     {
    //                         "name": this.paramFiltroTabela,
    //                         "operator": "=",
    //                         "value": this.TABELA
    //                     }
    //                 );
    //             }
    //             if(widget.dataSourceFilter[ABUtilController.retornaFiltro(widget.dataSourceFilter, 'P_RESCISAO')]){
    //                 widget.dataSourceFilter[ABUtilController.retornaFiltro(widget.dataSourceFilter, 'P_RESCISAO')].value = 'N'; 
    //             }
    //             widget.reload().then(function(callBack){
    //                 ScreenService.closePopup(true);
    //                 this.TABELA = null; // reinicia variável
    //             });
    //         } else{
    //             widget.reload().then(function(callBack){ //filtra caso não haja parãmetro adicional
    //                 ScreenService.closePopup();
    //             });
    //         }
            
    //         if(widget.dataSourceFilter[widget.dataSourceFilter.length-1].name == this.paramFiltro) // limpa filtro para valores default
    //             widget.dataSourceFilter.pop();
    //     }
    //     setTimeout(()=>{            
    //         this.filtrarFilhasESocial = false;
    //     }, 100);
    // };
    
    this.openWidgetFilha = function(args){
        var widget = ABUtilController.checkWidget(args);
        ScreenService.confirmMessage("Deseja ser redirecionado para tela de "+this.nmWidgetRedirecionada+"?", null, function () {
            // self.CODIGO = widget.currentRow.NRCHAVE;
            // self.filtrarFilhasESocial = true;
            var url = new URL(window.location.href.split('hcm09001_eso_envioCadastros')[0] + self.nomeWidget);
            url.searchParams.set('value', widget.currentRow.NRCHAVE);
            if(self.nomeWidget == 'hcm01001_fpa_itemDeCalculo'){
                url.searchParams.set('idItemCalculo', self.idItemCalculo);
                url.searchParams.set('widgetItemCalculo', self.widgetItemCalculo);
            }
            window.open(url, '_blank');
        }, null);
    };
    
    this.widgetFilterOnEnterOnceEsocial = function(nomeWidget, fieldFilter){
        // if(!this.filtrarFilhasESocial){
        //     ABUtilController.applyDefaultFilterOnEnter(templateManager.container.getWidget(nomeWidget));
        // }
        var widget = templateManager.container.getActiveWidget();
        var url = new URL (window.location.href);
        var valueFiltro = url.searchParams.get('value');
               
        if(valueFiltro){
            if(nomeWidget == 'ferias'){
                var widgetFerias = templateManager.container.getWidget(nomeWidget);
                var filtro = [
                            {
                                "name": "P_NRORG",
                                "operator": "=",
                                "value": getLocalVar('HCM_NRORG_TRAB')
                            },
                            {
                                "name": "NRGOZOFERIAS",
                                "operator": "=",
                                "value": valueFiltro
                            },
                            {
                                "name": "P_NRORG_PADRAO",
                                "operator": "=",
                                "value": getLocalVar('HCM_NRORG_PADRAO')
                            }
                    ];
                restEngine.post("product#/getGozoFerias", {
                        requestType: "FilterData",
                            filter: filtro}).
                    then(function (data) {
                        if(!!data.dataset.getGozoFerias.length){
                            widgetFerias.dataSourceFilter.push(
                                {
                                    "name": "NRFERIAS",
                                    "operator": "=",
                                    "value": data.dataset.getGozoFerias[0].NRFERIAS
                                }
                            );
                            
                            widgetFerias.reload().then(function(callBack){
                                ScreenService.closePopup();
                            });
                            if(widget.dataSourceFilter[widget.dataSourceFilter.length-1].name == "NRFERIAS") // limpa filtro para valores default
                                widget.dataSourceFilter.pop();
                        } else{
                            ScreenService.showMessage("Nenhum gozo foi encontrado!");
                        }
                    });
            }else{ 
                widget.dataSourceFilter.push({"name":fieldFilter,
                                              "operator": "=",
                                              "value":valueFiltro});   
                widget.reload().then(function(callBack){
                    ScreenService.closePopup();
                });
            }
        }else{
            ABUtilController.applyDefaultFilterOnEnter(templateManager.container.getWidget(nomeWidget));
        }
    };
    
    this.getWidgetEvento = function(widget){
        var evento = widget.currentRow.NMEVENTO;
        switch(evento) {
            case "S-1000":
            case "S-1005":
            case "S-1020":
            case "S-1060":
                this.paramFiltro = "NRESTRUTURAM";
                this.nmWidgetRedirecionada = "Estrutura";
                return "hcm00044_gpe_estrutura";
            case "S-1010":
                this.nmWidgetRedirecionada = "Evento";
                this.paramFiltro = "NREVENTOM";
                return "hcm01036_fpa_evento";
            case "S-1030":
            case "S-1040":
                this.nmWidgetRedirecionada = "Ocupação";
                this.paramFiltro = "NROCUPACAOM";
                return "hcm00042_gpe_ocupacao";
            case "S-1050":
                this.nmWidgetRedirecionada = "Horário";
                this.paramFiltro = "NRHORDIAM";
                return "hcm07007_pto_horario";
            case "S-1070":
                this.nmWidgetRedirecionada = "Processos Administrativos/Judiciais";
                this.paramFiltro = "NRPROCESSADMJUD";
                return "hcm00102_gpe_procAdminJud";
            case "S-2200":
            case "S-2206":
            case "S-2250":
            case "S-2260":
            case "S-2298":
            case "S-2299":
            case "S-2300":
            case "S-2306":
            case "S-2399":
                this.nmWidgetRedirecionada = "Vínculo";
                this.paramFiltro = "NRVINCULOM";
                return "hcm00052_gpe_vinculo";
            case "S-2205":
                this.nmWidgetRedirecionada = "Pessoa";
                this.paramFiltro = "NRVINCULOM";
                return "hcm00048_gpe_pessoa";
            case "S-1300":
                this.nmWidgetRedirecionada = "Pessoa";
                this.paramFiltro = "NRVINCULOM";
                return "hcm00048_gpe_pessoa";
            case "S-1200":
            case "S-1210":
                this.paramFiltroTabela = 'P_NRTIPOMOVIMENT';
                this.TABELA = widget.currentRow.NRTABELA;
                this.paramFiltro = "NRPESSOA";
                this.setParamWidgetItemCalculo(this.TABELA);
                return "hcm01001_fpa_itemDeCalculo";
            case "S-1298":
                this.nmWidgetRedirecionada = "Lançamentos de Itens por Estrutura";
                this.paramFiltroTabela = 'NREVENTOM';
                this.TABELA = '3036';
                this.paramFiltro = "NRESTRUTURAM";
                return "hcm01077_fpa_LancamentoEstrutura";
            case "S-1299":
                this.nmWidgetRedirecionada = "Lançamentos de Itens por Estrutura";
                this.paramFiltroTabela = 'NREVENTOM';
                this.TABELA = '3035';
                this.paramFiltro = "NRESTRUTURAM";
                return "hcm01077_fpa_LancamentoEstrutura";
            case "S-2230":
                if(widget.currentRow.NRTABELA == 2){
                    this.nmWidgetRedirecionada = "Férias";
                    this.paramFiltro = "NRGOZOFERIAS";
                    return "hcm01044_fpa_gozoFerias";
                }
                else {
                    this.nmWidgetRedirecionada = "Alteração da Situação Funcional";
                    this.paramFiltro = "NRALTESITUFUNC";
                    return "hcm00049_gpe_alteSituacaoFuncional";
                }
        }
        return null;
    };
    
    this.setParamWidgetItemCalculo = function(TIPOMOVIMENT) {
        this.idItemCalculo = TIPOMOVIMENT;
        switch(TIPOMOVIMENT){
            case 1:
                this.nmWidgetRedirecionada = "Lançamentos de Folha Mensal";
                this.widgetItemCalculo = 'Lançamentos de Folha Mensal';break;
            case 2:
                this.nmWidgetRedirecionada = "Lançamento de Férias";
                this.widgetItemCalculo = 'Lançamento de Férias';break;
            case 4:
                this.nmWidgetRedirecionada = "Lançamento do 13° Salário";
                this.widgetItemCalculo = 'Lançamento do 13° Salário';break;
            case 10:
                this.nmWidgetRedirecionada = "Lançamentos de Adiantamento";
                this.widgetItemCalculo = 'Lançamentos de Adiantamento';break;
            case 17:
                this.nmWidgetRedirecionada = "Itens do Movimento de Vale Transporte";
                this.widgetItemCalculo = 'Itens do Movimento de Vale Transporte';break;
            case 19:
                this.nmWidgetRedirecionada = "Lançamentos de PLR";
                this.widgetItemCalculo = 'Lançamentos de PLR';break;
            case 21:
                this.nmWidgetRedirecionada = "Itens do Movimento de Benefício";
                this.widgetItemCalculo = 'Itens do Movimento de Benefício';break;
        }
        
    };
    
    this.validacaoPrazoESocial = function(args){
        var widget = ABUtilController.checkWidget(args);
        var dataInicio = widget.currentRow.DTINISITUFUNC;
        var codigoAfastamento = widget.currentRow.CDESOCIAL;
        var nrDiasAfastamento = widget.currentRow.NRQTDIASITUFUNC;
        var dataAtual = new Date();
        ABUtilController.truncateObjetoDate(dataAtual);
      
        if(codigoAfastamento && dataInicio && nrDiasAfastamento) {
            var dataEnvioESocial = null;
            if ((codigoAfastamento == '01' || codigoAfastamento == '03') && nrDiasAfastamento > 15){
                dataEnvioESocial = ABUtilController.retornaObjetoDateComString(dataInicio).addDays(16);
                if(dataAtual.getTime() > dataEnvioESocial.getTime()){
                    ScreenService.showMessage(Messages.AVISO_ESO_PENSALIDADE_AFASTAMENTO_FORA_PRAZO);
                }
            } else {
                var dataInicioDate = ABUtilController.retornaObjetoDateComString(dataInicio);
                dataEnvioESocial = this.retornaDataEnvioMesSubsequenteESocial(dataInicioDate);
                if(dataAtual.getTime() > dataEnvioESocial.getTime()){
                    ScreenService.showMessage(Messages.AVISO_ESO_PENSALIDADE_AFASTAMENTO_FORA_PRAZO);
                }
            }
        }
    };
    
    this.validaDataEnvioESocial = function(args, campoData, aviso){
        var widget = ABUtilController.checkWidget(args);
        var data = widget.currentRow[campoData];
        var dataAtual = new Date();
        ABUtilController.truncateObjetoDate(dataAtual);
      
        if(data) {
            var dataDateObject = ABUtilController.retornaObjetoDateComString(data);
            var dataEnvioESocial = this.retornaDataEnvioMesSubsequenteESocial(dataDateObject);
            if(dataAtual.getTime() > dataEnvioESocial.getTime()){
                ScreenService.showMessage(aviso);
            }
        }
    };  
    
    this.retornaDataEnvioMesSubsequenteESocial = function(dataAtual){
        try {
            var anoEnvioEscocial = dataAtual.getFullYear();
            var mesEnvioESocial = dataAtual.getMonth() + 1;
            if(mesEnvioESocial + 1 > 12){
                anoEnvioEscocial++;
                mesEnvioESocial = 1;
            } else {
                mesEnvioESocial++;
            }
            mesEnvioESocial = mesEnvioESocial < 10 ? '0' + mesEnvioESocial : mesEnvioESocial;
            var dataEnvioESocial =  '15/' + mesEnvioESocial + '/' +  anoEnvioEscocial;
            var dataEnvioESocialDate = ABUtilController.retornaObjetoDateComString(dataEnvioESocial);
            return dataEnvioESocialDate;
        } catch(err){
            return false;
        }
    };
    
    this.mostraMensagemAvisoFiltroAtivo = function(args){
        var checkboxFiltroAtivo = args.row.IDATIVO;
        
        if(checkboxFiltroAtivo == 'N'){
            ScreenService.showMessage("Atenção! Ao desmarcar esta opção, serão exibidos registros que, outrora, foram excluídos por algum operador.");
            //está desativado o filtro, o operador poderá somente fazer somente a edição dos registros da página de Envio (nenhuma outra ação ficará disponível) e
            //dentre as alterações possíveis, o operador poderá novamente ajustar o registro para “Ativo”.
            
            //essas modificações são feitas a partir da função 'setModoFiltroAtivo' que altera o valor da flag 'campoAtivoFiltroNaoEstaMarcado'
        } 
    };
    
    this.ativaEvento = function(args){
        //Funão que invoca a rota pra alterar o IDATIVO do envio como 'S'
        var widget = ABUtilController.checkWidget(args);
        ESocialService.setEnvioAtivo(widget, ABUtilController);
    };
     
    this.setModoFiltroAtivo = function(args){ 
        //função que tem como objetivo marcar a flag 'campoAtivoFiltroNaoEstaMarcado' e mostrar a action 'ativaEvento' quando o filtro da tela for setado com o checkbox 'Ativo' do do filtro marcado
        var widget = ABUtilController.checkWidget(args);
        var opcao = false;
        if(widget.dataSourceFilter[ABUtilController.retornaFiltro(widget.dataSourceFilter, 'IDATIVO')].value == '%N%' || widget.dataSourceFilter[ABUtilController.retornaFiltro(widget.dataSourceFilter, 'IDATIVO')].value == 'N'){
            opcao = true;
        } 
        this.campoAtivoFiltroNaoEstaMarcado = opcao; 
        widget.getAction('ativaEvento').isVisible = opcao;
    };
    
    this.setActionsModoFiltroAtivoNaoMarcado = function(bool){
        var widget = templateManager.container.getWidget('envioCadastros');
        widget.getAction('envioAutomatico').isVisible = bool;
        widget.getAction('consultaAutomatica').isVisible = bool;
        widget.getAction('fechamentoPeriodico').isVisible = bool;
        widget.getAction('fechamentoPeriodicoSemMovimento').isVisible = bool;
        widget.getAction('fechamentoPeriodicoAnual').isVisible = bool;
        widget.getAction('fechamentoPeriodicoAnualSemMovimento').isVisible = bool;
        widget.getAction('emissaoExtrato').isVisible = bool;
        widget.getAction('reaberturaPeriodico').isVisible = bool;
        widget.getAction('reaberturaPeriodicoAnual').isVisible = bool;
        widget.getAction('transmitirLote').isVisible = bool;  
        widget.getAction('inclusaoManualAdmissao').isVisible = bool;  
        
    };
    
    this.seDataAtualMaiorDataEnvioESocial = function(){
        //Função que compara a data atual com a data de envio do registro ao eSocial, tendo como base a data de competência utilizada pelo operador
        //Retorna true se a data atual passar da data de envio ao eSocial e false caso a data atual esteja dentro do prazo estabelecido
        var dataCompetencia = ABUtilController.retornaObjetoDateComString(getLocalVar('HCM_DTCOMPETENCIA_OPER'));
        var dataEnvioESocial = this.retornaDataEnvioMesSubsequenteESocial(dataCompetencia);
        var dataAtual = new Date();
        ABUtilController.truncateObjetoDate(dataAtual);
        
        return dataAtual.getTime() > dataEnvioESocial.getTime();
    };
    
    this.downloadXML = function(){
        //Função que tem como objetivo tornar possível o download de um arquivo XML criado pelo sistema HCM e enviado ao eSocial
        
        //widgets:
        var widgetEstruturas = templateManager.container.getWidget("estruturas");
        var widgetEnvioCadastros = templateManager.container.getWidget("envioCadastros");
        //var widgetDados = templateManager.container.getWidget("envioCadastros_DadosEnv");
        var widgetDados = templateManager.container.getActiveWidget();
        
        //variaveis necessárias para identificar o objeto e conseguir o respectivo arquivo XML:
        var nrCpfPessoa = widgetEnvioCadastros.currentRow.NRCPFPESSOA;
        var nmEvento = widgetEnvioCadastros.currentRow.NMEVENTO;
        var nrChaveEvento = widgetEnvioCadastros.currentRow.NRCHAVE;
        
        //informações necessárias para a identificação do arquivo xml
        var idXmlFile = ABUtilController.retornaFiltro(widgetDados.dataSourceFilter, 'P_XMLFILE') == false ? 'envio' : widgetDados.dataSourceFilter[ABUtilController.retornaFiltro(widgetDados.dataSourceFilter, 'P_XMLFILE')].value;
        var idEvento = widgetEnvioCadastros.currentRow.IDEVENTO;
        var dsDirXmlEnv = widgetEnvioCadastros.currentRow.DSDIRXMLENV;
        var dsDirXmlRetEnv = widgetEnvioCadastros.currentRow.DSDIRXMLRETENV;
        var dsDirXmlRetPro = widgetEnvioCadastros.currentRow.DSDIRXMLRETPRO;
        var dsDirXmlRetTot = widgetEnvioCadastros.currentRow.DSDIRXMLRETTOT;
        var nrTpAmbiente = widgetEstruturas.currentRow.NRTPAMBIENTE;
        var idGrupo = this.idGrupo;
        var cdCnpjEstrut = widgetEstruturas.currentRow.CDCNPJESTRUT;
        var nrorg = getLocalVar('HCM_NRORG_TRAB');
        
        var dsDirXml = (idXmlFile == 'envio' ? dsDirXmlEnv : (idXmlFile == 'retorno' ? dsDirXmlRetEnv : (idXmlFile == 'consulta' ? dsDirXmlRetPro : (idXmlFile == 'total' ? dsDirXmlRetTot : 'envio'))));
        var dsDirXmlFilesPath = 
                (nrTpAmbiente == 1 ? 'Producao' : 'ProducaoRestrita') + "/" +
                (idGrupo == 'P' ? 'Periodicos' : (idGrupo == 'N' ? 'NaoPeriodicos' : 'Cadastros')) + "/" +
                cdCnpjEstrut + "/" +
                (idXmlFile == 'envio' ? 'Envio' : (idXmlFile == 'retorno' ? 'RetornoEnvio' : (idXmlFile == 'consulta' ? 'RetornoProcessamento' : (idXmlFile == 'total' ? 'Totalizador' : 'Envio')))) + "/" +
                dsDirXml;
                
        var evento = [{
            'NRORG': nrorg,
            'IDXMLFILE': idXmlFile,
            'IDEVENTO': idEvento,
            'DSDIRXML': dsDirXml,
            'DSDIRXMLFILESPATH': dsDirXmlFilesPath,
            'NRCPFPESSOA': nrCpfPessoa,
            'NMEVENTO': nmEvento,
            'NRCHAVE': nrChaveEvento
        }];
                
        ESocialService.getArquivoXML(evento);
    };
    
    this.downloadVariosXML = function(){
        //Função que tem como objetivo tornar possível o download de vários arquivo XML criado pelo sistema HCM e enviado ao eSocial
        //Realiza processo similar à da função 'downloadXML' porém estuturada para permiitir o download de vários arquivos simultâneamente
        
        var widgetEnvioCadastros = templateManager.container.getWidget('envioCadastros');
        var widgetEstruturas = templateManager.container.getWidget("estruturas");
        var widgetDados = templateManager.container.getWidget("envioCadastros_DadosEnv");
        
        var idXmlFile = widgetDados.dataSourceFilter[ABUtilController.retornaFiltro(widgetDados.dataSourceFilter, 'P_XMLFILE')].value;
        var nrTpAmbiente = widgetEstruturas.currentRow.NRTPAMBIENTE;
        var idGrupo = this.idGrupo;
        var cdCnpjEstrut = widgetEstruturas.currentRow.CDCNPJESTRUT;
        var nrorg = getLocalVar('HCM_NRORG_TRAB');
        
        var idEvento;
        var dsDirXmlEnv;
        var dsDirXmlRetEnv;
        var dsDirXmlRetPro;
        var dsDirXmlRetTot;
        var dsDirXml;
        var dsDirXmlFilesPath;
        
        var nrCpfPessoa;
        var nmEvento;
        var nrChaveEvento;
        
        var eventos = [];
        
        for(var row in widgetEnvioCadastros.getCheckedRows()){
            idEvento = widgetEnvioCadastros.getCheckedRows()[row].IDEVENTO;
            dsDirXmlEnv = widgetEnvioCadastros.getCheckedRows()[row].DSDIRXMLENV;
            dsDirXmlRetEnv = widgetEnvioCadastros.getCheckedRows()[row].DSDIRXMLRETENV;
            dsDirXmlRetPro = widgetEnvioCadastros.getCheckedRows()[row].DSDIRXMLRETPRO;
            dsDirXmlRetTot = widgetEnvioCadastros.getCheckedRows()[row].DSDIRXMLRETTOT;
            
            dsDirXml = (idXmlFile == 'envio' ? dsDirXmlEnv : (idXmlFile == 'retorno' ? dsDirXmlRetEnv : (idXmlFile == 'consulta' ? dsDirXmlRetPro : (idXmlFile == 'total' ? dsDirXmlRetTot : ''))));
            dsDirXmlFilesPath = 
                (nrTpAmbiente == 1 ? 'Producao' : 'ProducaoRestrita') + "/" +
                (idGrupo == 'P' ? 'Periodicos' : (idGrupo == 'N' ? 'NaoPeriodicos' : 'Cadastros')) + "/" +
                cdCnpjEstrut + "/" +
                (idXmlFile == 'envio' ? 'Envio' : (idXmlFile == 'retorno' ? 'RetornoEnvio' : (idXmlFile == 'consulta' ? 'RetornoProcessamento' : (idXmlFile == 'total' ? 'Totalizador' : '')))) + "/" +
                dsDirXml;
                
            nrCpfPessoa = widgetEnvioCadastros.getCheckedRows()[row].NRCPFPESSOA;
            nmEvento = widgetEnvioCadastros.getCheckedRows()[row].NMEVENTO;
            nrChaveEvento = widgetEnvioCadastros.getCheckedRows()[row].NRCHAVE;
            
            eventos[row] = {
                'NRORG': nrorg,
                'IDXMLFILE': idXmlFile,
                'IDEVENTO': idEvento,
                'DSDIRXML': dsDirXml,
                'DSDIRXMLFILESPATH': dsDirXmlFilesPath,
                'NRCPFPESSOA': nrCpfPessoa,
                'NMEVENTO': nmEvento,
                'NRCHAVE': nrChaveEvento
            };
        }
        
        ESocialService.getArquivoXML(eventos);
    };
    
    this.blockCheckbox = function (widget, idBlock){
        if(widget.inViewMode())
            ABUtilController.blockCheckbox(widget.id, idBlock);
    };
    
    this.reloadWidgetEnvioCadastros = function () {
        templateManager.container.getWidget('envioCadastros').reload();
    };
    
    // Função que tem como objetivo realizar a rotina de transmissão dos eventos independente das pendências que esses possuam
    this.ignorarPendenciasETransmitirLoteEvento = function () {
        
        var widget = templateManager.container.getWidget('eventosNaoPeriodicosPendentes');
        
        // as informações sobre o envio do periódico estão na própria widget do popUp
        var widgetEnvioCadastros = widget.envioPeriodico.widget;
        var widgetEnvios = templateManager.container.getWidget('envioCadastros');
        ScreenService.closePopup(true);
        widgetEnvios.activate();
        
        switch (widgetEnvioCadastros.name) {
            case "envioAutomatico":
                this.envioAutomatico(widgetEnvioCadastros, false);
                break;
            case "envioCadastros":
                // verifica se está sendo transmitido um lote ou um evento individual dos periódicos
                if(widgetEnvioCadastros.getCheckedRows().length > 0){
                    this.transmitirLoteEvento(widgetEnvioCadastros, false);
                } else {
                    this.transmitirEvento(widgetEnvioCadastros, false);
                }
                break;
        }
    };
    
    this.transmitirPendencias = function (args) {
        var widget = args.owner.widget;
        var existemEventosSelecionados = widget.getCheckedRows().length > 0;
        
        // verifica se há eventos pendentes selecionados
        if (existemEventosSelecionados) {
            // há eventos, realiza a transmissão das pendencias
            this.transmitirLoteEvento(args, false, true, false);
        } else {
            // não há, realiza a transmissao do evento periódico
            this.ignorarPendenciasETransmitirLoteEvento();
        }
    };
    
    // Função que altera a label da action de transmissão do popUp 'eventosNaoPeriodicosPendentes' caso algum evento seja selecionado
    // ou deselecionado
    this.mudaLabelBotaoTransmitir = function (widget) {
        if (Util.isUndefined(widget)) {
            widget = templateManager.container.getWidget('eventosNaoPeriodicosPendentes');
        }
        var widgetEstruturas = templateManager.container.getWidget('estruturas');
        var existemEventosSelecionados = widget.getCheckedRows().length > 0;
        var botaoTransmitir = widget.getAction('transmissaoPendencias');
        if (existemEventosSelecionados) {
            botaoTransmitir.label = 'Transmitir Pendências';
            botaoTransmitir.isVisible = true;
        } else {
            botaoTransmitir.label = 'Ignorar Pendências';
            if (widgetEstruturas.currentRow.IDBLOQEVENTPERIO == 'N') {
                botaoTransmitir.isVisible = true;
            } else {
                botaoTransmitir.isVisible = false;
            }
        }
    };
    
    this.envioEsocialDescentralizado = function(currentRow, nmevento, nrchave, nrvinculom, salvar, args){
        var widget = ABUtilController.checkWidget(args);
        ScreenService.showCustomDialog('Deseja prosseguir com o envio da informação para o eSocial?', 'CONFIRMATION', null, [
            {
                label: ScreenService.i18n("Não"),
                code: function (e, deferred) {
                    currentRow.IDENVIAESOCIAL = 'N';
                    salvar(args, self, false);
                    deferred.reject(e);
                }
            },
            {
                label: ScreenService.i18n("Sim"),
                code: function (e, deferred) {
                    currentRow.IDENVIAESOCIAL = 'S';
                    currentRow.NRCHAVE = nrchave;
                    currentRow.NRVINCULOM = nrvinculom;
                    
                    if(widget.name == 'vinculo'){
                        var popUp = widget.widgets[ABUtilController.retornaWidget(widget, 'popupEnvioESocialDescentra')];
                        popUp.newRow();
                        
                        if(currentRow.NRTIPOVINCULOM == "1" || currentRow.NRTIPOVINCULOM == 1){
                            popUp.getField('EVENTO2206').isVisible = true;
                            popUp.getField('EVENTO2306').isVisible = false;
                        }else{
                            popUp.getField('EVENTO2206').isVisible = false;
                            popUp.getField('EVENTO2306').isVisible = true;
                        }
                        
                        if(!Util.isEmptyOrBlank(currentRow.DTAVISOPREVIO) && currentRow.DTAVISOPREVIO != widget.backupRow.DTAVISOPREVIO){
                            popUp.getField('EVENTO2250').isVisible = true;
                        }else{
                            popUp.getField('EVENTO2250').isVisible = false;
                        }
                        
                        if(!Util.isEmptyOrBlank(currentRow.IDTPREINTEGRACAO) && currentRow.IDTPREINTEGRACAO != widget.backupRow.IDTPREINTEGRACAO){
                            popUp.getField('EVENTO2298').isVisible = true;
                        }else{
                            popUp.getField('EVENTO2298').isVisible = false;
                        }
                        
                        ABUtilController.masterDetailOpenPopup(popUp);
                    }else{
                        currentRow.NMEVENTO = nmevento;
                        salvar(args, self, false);
                    }
                    deferred.resolve(e);
                }.bind(this)
            }
        ]);
    };
    
    
    this.inclusaoManualAdmissao = function(){
        var widget = templateManager.container.getActiveWidget() ;
        if(widget.isValid()){
            widget.currentRow.__is_new = true;
            restEngine.post('product#/setEnvio2200ManualAdmissao', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
            then(function (data) {
                if (data.messages[0].type === "success") {
                    ScreenService.showMessage(data.messages[0].message, data.messages[0].type);
                    ScreenService.closePopup(true);
                    widget.deactivate();
                    widget.parent.currentWidget = widget.parentWidget;
                    widget.parent.activate();
                    widget.parent.reload();
                } else {
                    ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                }
            }).
            catch(function(e) {
                var error;
                if(Util.isUndefined(e.data) && Util.isUndefined(e.data.error) && Util.isUndefined(e.message))
                    error = e;
                else if(!Util.isUndefined(e.message))
                    error = e.message;
                else
                    error = e.data.error;
                ScreenService.showMessage(Util.isUndefined(Messages[error]) ? error : Messages[error], 'ERROR');}
            );
            
        }
    };
    
    this.openPopupInclusaoManualAdmissao = function(){
        var widget = templateManager.container.getActiveWidget() ;
        var popup = templateManager.container.getWidget('inclusaoManualAdmissao') ;
        
        ABUtilController.masterDetailOpenPopup(popup);
        popup.parent = widget;
        popup.newRow();
        popup.getField('NRVINCULOM').dataSourceFilter[ABUtilController.retornaFiltro(popup.getField('NRVINCULOM').dataSourceFilter, 'P_NRESTRUTURAM')].value = this.nrestruturam;
        popup.currentRow.NRESTRUTURAM = this.nrestruturam;
        popup.currentRow.DSVERSAO = this.dsversao;
        
        
    };
    
    this.closePopupInclusaoManualAdmissao = function(){
        var popup = templateManager.container.getWidget('inclusaoManualAdmissao');
        // popup.currentRow = {};
        ScreenService.closePopup(true);
        popup.deactivate();
        popup.parent.currentWidget = popup.parentWidget;
        popup.parent.activate();
        popup.parent.reload();
    };

    this.isEnviosRowDeletable = function(row) {
        return (row.IDSTATUS == self.STATUS_PENDENTE || row.IDSTATUS == self.STATUS_ERROENVIO || row.IDSTATUS == self.STATUS_ERROPROCE || Util.isEmptyOrBlank(row.NRRECIBO));
    };
    
    this.verificaEventos = function() {
        var widget = templateManager.container.getWidget('envioCadastros');
        widget.getAction('excluirEnvio').isVisible = (widget.currentRow.NMEVENTO == "S-2300" || widget.currentRow.NMEVENTO == "S-2200" || widget.currentRow.NMEVENTO == "S-1250") &&
                                                     !(widget.currentRow.IDSTATUS == self.STATUS_PENDENTE || widget.currentRow.IDSTATUS == self.STATUS_ERROENVIO || widget.currentRow.IDSTATUS == self.STATUS_ERROPROCE) &&
                                                     (widget.currentRow.NRRECIBO == null);
    };
    
    this.deleteEventos = function(args) {
    ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
        var widget = args.owner.widget;
        widget.currentRow.__is_new = false;
        restEngine.post('product#/deleteEventos', {'requestType':'DataSet','dataset':[widget.currentRow]}).
            then(function(data){
                if(data.notifications[0].type === "success"){
                    ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                    ABUtilController.masterDetailVoltarList(widget);
                    widget.reload();
                } else {
                    ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                }
            }).
            catch(function(e) {
                var error;
                if(e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
        }, null);
    };

}

Configuration(function(ContextRegister) {
    ContextRegister.register('ESocialController', ESocialController);
}); 

// FILE: assets/js/controllers/EmissaoDocController.js
/**
 * Created by Rafael Pickbrenner on 09/04/2021.
 * Funcionalidades para a tela de Emissão de Documentos (Contratos/Termos), hcm10010_ger_emissaodoc.
 * 
 */

 function EmissaoDocController(ScreenService, templateManager, restEngine, ABUtilController, Messages, $window){

  /*Ajustes iniciais da tela*/
  this.widgetOnEnter = function() {
      var widget = templateManager.container.getActiveWidget();
      
      //Preenche da data de competência com a competência atual
      widget.getField("DTMESCOMPETENCIA").value(getLocalVar('HCM_DTCOMPETENCIA_OPER'));
  };
  
  /*Gera o documento selecionado em NMDOCUMENTO*/
  this.gerarDocumento = function() {
      var widget   = templateManager.container.getActiveWidget();
      widget.currentRow.urlMidiaServer = ABUtilController.getBaseUrlFileServer();
      var dataPost = { 'requestType': 'DataSet', 'dataset': [widget.currentRow] };
      
      var successFunction = function(data) {
          if(data.dataset && data.dataset.arquivo){
              if(Array.isArray(data.dataset.arquivo.NMARQUIVO)){
                  data.dataset.arquivo.NMARQUIVO.forEach(function(element){
                      $window.open($window.serviceUrl + "/abrirArquivo?requestType=DataSet&dataset[0][CMARQUIVO]=" + element);
                  });
              } else {
                  $window.open($window.serviceUrl + "/abrirArquivo?requestType=DataSet&dataset[0][CMARQUIVO]=" + data.dataset.arquivo.NMARQUIVO);
              }
          }
      };
      
      var errorFunction = function(e) {
          var error;
          if(Util.isUndefined(e.data) && Util.isUndefined(e.data.error) && Util.isUndefined(e.message))
              error = e;
          else if(!Util.isUndefined(e.message))
              error = e.message;
          else
              error = e.data.error;
          ScreenService.showMessage(Util.isUndefined(Messages[error]) ? error : Messages[error], 'ERROR');
      };
      
      /*Valida se o Documento foi selecionado*/
      if(widget.isValid()) {
          restEngine.post('product#/emitirDocPadrao', dataPost).then(successFunction).catch(errorFunction);
      } else {
          ScreenService.showMessage(Messages.HCM10010_GER_EMISSAODOC_NOTVALID, 'ALERT');
      }
  };
   
} //Fim function EmissaoDocController()

Configuration(function(ContextRegister) {
  ContextRegister.register('EmissaoDocController', EmissaoDocController);
});

// FILE: assets/js/controllers/EntrevistaDesligamentoController.js
function EntrevistaDesligamentoController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, Messages, CriterioSelecaoController) {
    this.salvarVinculo = function(args){
        var widget = ABUtilController.checkWidget(args);
        if(widget.isValid())  {
            widget.currentRow.__is_new = false;
            widget.currentRow.CDOPERADOR_LOG = getLocalVar("HCM_CDOPERADOR");
            widget.currentRow.NRORGTRAB = getLocalVar("HCM_NRORG_TRAB");
            widget.currentRow.NRORGPADRAO = getLocalVar("HCM_NRORG_PADRAO");
            widget.currentRow.DTATUAL = getLocalVar("HCM_DATA_ATUAL");
            return widget.saveRow().then(function (data){
                if (data.notifications[0].type === "success") {
                    ScreenService.showMessage(Messages.SAVE_ROW_SUCCESS);
                    ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                    widget.backupRow = null;
                    widget.view();
                } else {
                    ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                }
            }.bind(this)).catch(function(e) {
                var error;
                if(e.data.error === undefined)
                    error = e;
                else 
                    error = e.data.error;
                
                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error));
            });
        }
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('EntrevistaDesligamentoController', EntrevistaDesligamentoController);
});

// FILE: assets/js/controllers/EpiController.js
function EpiController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, General, Messages) {

    this.adicionarRow = function(args) {
        var widget = args.owner.widget;
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
    };
    
    this.baixarPlanilhaEpi = function() {
        restEngine.post(
            'product#/baixarPlanilhaEpi', {
                'requestType': 'DataSet',
                'dataset': [] 
            }
        )
        .then(function(data) {
            ScreenService.closePopup();
            if(data.dataset && data.dataset.arquivo){
                window.open(window.serviceUrl + "/abrirArquivo?requestType=DataSet&dataset[0][CMARQUIVO]=" + data.dataset.arquivo.NMARQUIVO);
            }
        })
        .catch(function(e) {
            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(e.data.error), 'ERROR');
        });
    };
    
    this.importarPlanilhaEpi = function() {
        var widgetPop       = templateManager.container.getActiveWidget();
        var widgetPrincipal = templateManager.container.getWidget('epi');
        if(widgetPop.isValid()){
            restEngine.post('product#/importarPlanilhaEpi', {'requestType': 'DataSet', 'dataset': [widgetPop.currentRow]}).
            then(function(data) {
                if (data.messages) {
                    ScreenService.closePopup(true);
                    ScreenService.showMessage(data.messages[0].message, data.messages[0].type);
                    if (data.dataset && data.dataset.msg) {
                        openPopupMensagensImportacao(data.dataset.msg, 'messagesImportacaoPlanilha');
                    }else{
                        widgetPrincipal.activate();
                        widgetPrincipal.reload();
                    }
                } else {
                    ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                }
            }).
            catch(function(e) {
                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(e.data.error), 'ERROR');
            });
        }
    };
    
    var openPopupMensagensImportacao = function(msg) {
        var widgetMensagens = templateManager.container.getWidget('messagesImportacaoPlanilha');
        widgetMensagens.dataSource.data = msg;
        ScreenService.openPopup(widgetMensagens);
    };
    
    this.popupImportacaoPlanilhaVoltar = function() {
        ScreenService.closePopup();
        var widgetPopup = templateManager.container.getWidget('epi');
        widgetPopup.currentRow.DSPATH = [];
        widgetPopup.activate();
    };
    
    this.afterLoadDataSource = function(){
        var widget = templateManager.container.getActiveWidget();
        if(!Util.isEmptyOrBlank(widget.currentRow.DSARQIMGEPI)){
            widget.currentRow.DADOSFOTOS = widget.currentRow.DSARQIMGEPI;
            widget.currentRow.DSARQIMGEPI = widget.currentRow.DSARQIMGEPI.DSPATH;
        }
    };

    this.setEpi = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
            if (!widget.backupRow) {
                widget.currentRow.__is_new = true;
            } else {
                widget.currentRow.__is_new = false;
            }
            widget.currentRow.DSPATH = !Util.isEmptyOrBlank(widget.currentRow.DSARQIMGEPI) ? widget.currentRow.DSARQIMGEPI : null;
            restEngine.post('product#/setEpi', {
                'requestType': 'DataSet',
                'dataset': [widget.currentRow]
            }).
            then(function(data) {
                if (data.notifications[0].type === "success") {
                    ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                    if (widget.currentRow.__is_new) {
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    } else {
                        ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                        widget.backupRow = null;
                        widget.view();
                    }
                } else {
                    ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                }
            }).
            catch(function(e) {
                var error;
                if (e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
        }
    };

    this.deleteEpi = function(args) {
        ScreenService.confirmMessage(Messages.DELETE_ROW, 'CONFIRMATION',
            function() {
                var widget = args.owner.widget;
                widget.currentRow.__is_new = false;
                restEngine.post('product#/deleteEpi', {
                    'requestType': 'DataSet',
                    'dataset': [widget.currentRow]
                }).
                then(function(data) {
                    if (data.notifications) {
                        if (data.notifications[0].type === "success") {
                            ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                            ABUtilController.masterDetailVoltarList(widget);
                            widget.reload();
                        } else {
                            ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                        }
                    } else {
                        ScreenService.showMessage(data.messages[0].message);
                    }
                }).
                catch(function(e) {
                    var error;
                    if (e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
            });
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('EpiController', EpiController);
});


// FILE: assets/js/controllers/EscalaTrabalhoController.js
/**
 * Created by lara on 06/09/2016.
 */
 
/* jshint esversion: 6 */
function EscalaTrabalhoController (ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, $window, ABUtilController, Messages) {
    
    var self = this;
    
    this.addEscala = function(args){
        ABUtilController.newRow(args);
        var widget = ABUtilController.checkWidget(args);
        widget.currentRow.DTMESCOMPETENC = getLocalVar("HCM_DTCOMPETENCIA_OPER");
        widget.widgets[0].isVisible = false;
        widget.widgets[1].isVisible = false;
    };

    this.cancelEditParametrizacao = function(args){
        var widget = ABUtilController.checkWidget(args);
        widget.templateToForm = widget.template;
        widget.template = widget.templateView;
        templateManager.container.getWidget("escalaTrabalho").showAsTab = true;
        templateManager.container.getWidget("escalaTrabalhoTurno").showAsTab = true;
        if(widget.currentRow.__is_new) {
            var indexOfCurrentRow = widget.dataSource.data.indexOf(widget.currentRow);
            if(indexOfCurrentRow !== -1) {
                widget.dataSource.data.pop();
            }
            widget.list();
            widget.activate();
        }
        else {
            Util.extend(widget.currentRow, widget.backupRow);
            widget.list();
            widget.activate();
        }
    };

    this.deleteEscalaTrabalho = function(args) {
    ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
        var widget = args.owner.widget;
        var data = {}; 
                widget.dataSource.remove(widget.currentRow).then(function (data){
                    if (data.messages) {
                        ScreenService.showMessage(Messages.REMOVE_ROW_ERROR + '. ' + data.messages[0].message, data.messages[0].type);
                    } else {
                        ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    }
                });
        }, null);
    };

    this.deleteHorarioTurno = function(args) {
    ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
        var widget = args.owner.widget;
        var data = {}; 
                widget.dataSource.remove(widget.currentRow).then(function (data){
                    if(data.dataset.gpeHorarioTurno_setHorarioTurno.type === "success"){
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                        ScreenService.showMessage(Messages.REMOVE_ROW_SUCCESS); 
                    } else {
                        ScreenService.showMessage(Messages.REMOVE_ROW_ERROR); 
                    }
                });
            }, null);
    };

    this.deleteTurno = function(args) {
    ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
        var widget = args.owner.widget;
        var data = {}; 
                widget.dataSource.remove(widget.currentRow).then(function (data){
                    if(data.dataset.gpeTurno_setTurno.type === "success"){
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                        ScreenService.showMessage(Messages.REMOVE_ROW_SUCCESS); 
                    }else if(data.messages){
                        ScreenService.showMessage(data.messages[0].message, data.messages[0].type);
                    }else {
                        ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                    }
                }).
                catch(function(e) {
                var error;
                if (e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
                if(error.includes("encontrado registo filho")){
                    ScreenService.showMessage("Impossível excluir.<br>Existe registro filho.");
                }else
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
            }, null);
    };
    
    this.setLimiteHoras = function(){
        var widget = templateManager.container.getWidget('escalaTrabalhoParametrizacao');
        if (widget.currentRow) {
            if( widget.currentRow.QTHRMAXHRTRAB && widget.currentRow.QTHRMAXHRTRAB > "0") {
                widget.getField('DSSITFREQMAXHRTRAB').readOnly = false;
                widget.getField('DSSITFREQMAXHRTRAB').validations = {required: true};
            }else{
                widget.getField('DSSITFREQMAXHRTRAB').readOnly = true;
                widget.getField('DSSITFREQMAXHRTRAB').validations = {};
                widget.currentRow.DSSITFREQMAXHRTRAB = null;
                widget.currentRow.NRSITFREQMAXHRTRAB = null;
            }
        }
        widget.redraw();
    };

    this.editParametrizacao = function(args){
        var widget = ABUtilController.checkWidget(args);
        widget.templateView =  widget.template;
        widget.template = widget.templateToForm;
        templateManager.container.getWidget("escalaTrabalho").showAsTab = false;
        templateManager.container.getWidget("escalaTrabalhoTurno").showAsTab = false;
        widget.backupRow = Util.clone(widget.currentRow);
        widget.edit();
    };

    this.salvarEscalaTrabalho = function(args){
        var widget = args.owner.widget;
        var widgetActivate = templateManager.container.getActiveWidget();
        if(widget.isValid())  {
            if(widgetActivate.name === 'escalaTrabalhoParametrizacao'){
                widget.currentRow = widgetActivate.currentRow;
                widget.currentRow.__is_new = false;
            } else {
                if (!widget.backupRow) {
                    widget.currentRow.__is_new = true;
                } else {
                    widget.currentRow.__is_new = false;
                }
            }
            widget.currentRow.CDOPERADOR_LOG = getLocalVar("HCM_CDOPERADOR");
            widget.currentRow.NRORGTRAB = getLocalVar("HCM_NRORG_TRAB");
            widget.currentRow.DTATUAL = getLocalVar("HCM_DATA_ATUAL");
            if(widget.currentRow.QTHRLIMITESEPHEXTRA)widget.currentRow.QTHRLIMITESEPHEXTRA = this.formataHora(widget.currentRow.QTHRLIMITESEPHEXTRA);
            if(widget.currentRow.QTHRPROJETAINTERVALO)widget.currentRow.QTHRPROJETAINTERVALO = this.formataHora(widget.currentRow.QTHRPROJETAINTERVALO);
            if(widget.currentRow.HRFIMPERIODONOTURNO)widget.currentRow.HRFIMPERIODONOTURNO = this.formataHora(widget.currentRow.HRFIMPERIODONOTURNO);
            if(widget.currentRow.HRINIPERIODONOTURNO)widget.currentRow.HRINIPERIODONOTURNO = this.formataHora(widget.currentRow.HRINIPERIODONOTURNO);
            if(widget.currentRow.QTHRMAXHRTRAB)widget.currentRow.QTHRMAXHRTRAB = this.formataHora(widget.currentRow.QTHRMAXHRTRAB);
            
            
            var preparedWidget = ABUtilController.prepareSaveMasterHistory(widget);
            restEngine.post('product#/getEscalaTrab/save', {'requestType': 'DataSet', 'dataset': [preparedWidget.currentRow]})
                    .then(function (data){
                    if (data.dataset.columnsToReturn) {
                        ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                        if(widgetActivate.name === 'escalaTrabalhoParametrizacao'){
                            this.cancelEditParametrizacao(args);    
                                var tableHistoryPk_ = preparedWidget.saveHistoryTable.__table_history_pk.toUpperCase();
                                    if (preparedWidget.currentRow[tableHistoryPk_]) {
                                        for (var y=0; y < data.dataset.columnsToReturn.length; y++) {
                                            if (!Util.isUndefined(data.dataset.columnsToReturn[y][tableHistoryPk_])) {
                                                preparedWidget.currentRow[tableHistoryPk_] = data.dataset.columnsToReturn[y][tableHistoryPk_];
                                            }
                                        }
                                    }
                        } else {
                            if (preparedWidget.currentRow.__is_new) {
                                ABUtilController.masterDetailVoltarList(preparedWidget);
                                ABUtilController.mudarVisibilidadeWidgets(preparedWidget.widgets, true);
                                preparedWidget.reload();
                            } else {
                                ABUtilController.mudarVisibilidadeWidgets(preparedWidget.widgets, true);
                                var tableHistoryPk = preparedWidget.saveHistoryTable.__table_history_pk.toUpperCase();
                                    if (preparedWidget.currentRow[tableHistoryPk]) {
                                        for (var i=0; i < data.dataset.columnsToReturn.length; i++) {
                                            if (!Util.isUndefined(data.dataset.columnsToReturn[i][tableHistoryPk])) {
                                                preparedWidget.currentRow[tableHistoryPk] = data.dataset.columnsToReturn[i][tableHistoryPk];
                                            }
                                        }
                                    }
                                preparedWidget.backupRow = null;
                                preparedWidget.view();
                                
                            }
                        }
                    } else {
                        ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                    }
                    }.bind(this)).catch(function(e) {
                    var error;
                    if(e.data.error === undefined)
                        error = e;
                    else 
                        error = e.data.error;
                    
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error));
                });
        }
    };

    this.salvarHorariorCadAuto = function(argsRow){
        var widget = templateManager.container.getWidget("horarioTurno");
        if(widget.isValid())  {
            if (!widget.backupRow) {
                ScreenService.showCustomDialog('Deseja utilizar esse horário em mais de um dia?', 'CONFIRMATION', null, [
                    {
                        label: ScreenService.i18n("Sim"),
                        code: function () {
                            self.openPopupCadAutoHorarioDia();
                        }
                    },
                    {
                        label: ScreenService.i18n("Não"),
                        code: function () {
                            self.salvarHorarioTurno(argsRow);
                        }
                    }
                ]);
            } else {
                self.salvarHorarioTurno(argsRow);
            }
        }
    };
    
    this.salvarHorarioTurno = function(argsRow){
        var widget = templateManager.container.getWidget("horarioTurno");
        if(widget.isValid())  {
            if (!widget.backupRow) {
                widget.currentRow.__is_new = true;
            } else {
                widget.currentRow.__is_new = false;
            }
            widget.currentRow.CDOPERADOR_LOG = getLocalVar("HCM_CDOPERADOR");
            widget.dataSourceFilter.forEach(function(dados){
                if(dados.name === 'NRTURNO'){
                    widget.currentRow.NRTURNO  = dados.value;
                }
            });
            widget.currentRow.NRORGTRAB = getLocalVar("HCM_NRORG_TRAB");
            widget.currentRow.DTATUAL = getLocalVar("HCM_DATA_ATUAL");
            return widget.saveRow().then(function (data){
                if (data.notifications[0].type === "success") {
                    ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                    if (widget.currentRow.__is_new) {
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    } else {
                        ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                        widget.backupRow = null;
                        widget.view();
                    }
                } else {
                    ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                }
            }).catch(function(e) {
                var error;
                if(e.data.error === undefined)
                    error = e;
                else 
                    error = e.data.error;
                
                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error));
            });
        }
    };

    this.salvarHorarioDiaAuto = function(args){
        var widget = args.owner.widget;
        if (widget.isValid()) {
            widget.currentRow.__is_new = true;
            restEngine.post('/saveHorarioDiaAuto', {
                'requestType': 'DataSet',
                'dataset': [widget.currentRow]
            }).
            then(function(data) {
                if (data.notifications[0].type === "success") {
                    ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                    ScreenService.closePopup();
                    templateManager.container.getActiveWidget().reload();
                    widget.currentRow.DIASEMANA = "";
                    widget.currentRow.NMHORDIAH = "";
                }
                else {
                    ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                }
            }).
            catch(function(e) {
                var error;
                if (e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
        }
    };

    this.salvarTurno = function(argsRow){
        var widgetMain = templateManager.container.getWidget("escalaTrabalho");
        var widget = templateManager.container.getWidget("escalaTrabalhoTurno");
        
        widget.currentRow.NRESCALATRABM = widgetMain.currentRow.NRESCALATRABM;
        
        if(widget.isValid())  {
            if (!widget.backupRow) {
                widget.currentRow.__is_new = true;
            } else {
                widget.currentRow.__is_new = false;
            }
            widget.currentRow.CDOPERADOR_LOG = getLocalVar("HCM_CDOPERADOR");
            widget.dataSourceFilter.forEach(function(dados){
                if(dados.name === 'NRESCALATRABM'){
                    widget.currentRow.NRESCALATRABM  = dados.value;
                }
            });
            widget.widgets[0].isVisible = true;
            widget.currentRow.NRORGTRAB = getLocalVar("HCM_NRORG_TRAB");
            widget.currentRow.DTATUAL = getLocalVar("HCM_DATA_ATUAL");
            return widget.saveRow().then(function (data){
                if (data.notifications[0].type === "success") {
                    ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                    if (widget.currentRow.__is_new) {
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    } else {
                        ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                        widget.backupRow = null;
                        widget.view();
                    }
                } else {
                    ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                }
            }).catch(function(e) {
                var error;
                if(e.data.error === undefined)
                    error = e;
                else 
                    error = e.data.error;
                
                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error));
            });
        }
    };

    this.setValueDefault = function(args){
        var widget = ABUtilController.checkWidget(args);
        var widgetTurno = templateManager.container.getWidget("escalaTrabalhoTurno");
        restEngine.post("product#/getNextDiaMaxNrSeq", {
            requestType: "FilterData",
                filter: [{operator: "=", name: "NRORG", value: getLocalVar('HCM_NRORG_TRAB')}, {operator: "=", name : "DATABASE", value : widgetTurno.currentRow.DTDATABASE.substr(0,10)}, {operator: "=", name : "NRTURNO", value : widgetTurno.currentRow.NRTURNO}]}).
        then(function (data) {
            if(!Util.isUndefined(data.dataset.dual_getNextDiaMaxNrSeq[0])){
                widget.currentRow.NRSEQHORARIO = data.dataset.dual_getNextDiaMaxNrSeq[0].MAXNRSEQHORARIO;
                widget.currentRow.DIASEMANA = data.dataset.dual_getNextDiaMaxNrSeq[0].PROXDIA;
            } else {
                ScreenService.showMessage('Erro ao buscar os dados default');
                ABUtilController.masterDetailCancelaEdicao(widget);
            }
        }).catch(function(e) {
            var error;
            if(e.data.error === undefined)
                error = e;
            else 
                error = e.data.error;
            
            ScreenService.showMessage('Ocorreu um erro inesperado, contate o administrador informando o trecho abaixo: <br><br>' + error + '<br><br>', 'ERROR');
        });
    };

    this.setNrEscalaTrabM = function(args){
        var widgetEscala = ABUtilController.checkWidget(args);
        var widgetTurno  = templateManager.container.getWidget("escalaTrabalhoTurno");
        var widgetParametrizacao  = templateManager.container.getWidget("escalaTrabalhoParametrizacao");
        widgetTurno.dataSourceFilter.forEach(function(dados){
            if(dados.name === 'P_NRESCALATRABM'){
                dados.value = widgetEscala.currentRow.NRESCALATRABM;
            }

        });
        widgetParametrizacao.dataSourceFilter.forEach(function(dados){
            if(dados.name === 'NRESCALATRABM'){
                dados.value = widgetEscala.currentRow.NRESCALATRABM;
            }

        });
        widgetTurno.reload([],false);
        widgetParametrizacao.reload([],false);
    };

    this.setNrTurno = function(args){
        var widgetTurno = ABUtilController.checkWidget(args);
        var widgetHorarioTurno  = templateManager.container.getWidget("horarioTurno");
        widgetHorarioTurno.dataSourceFilter.forEach(function(dados){
            if(widgetTurno.currentRow.NRTURNO && dados.name === 'NRTURNO'){
                dados.value = widgetTurno.currentRow.NRTURNO;
                widgetHorarioTurno.currentRow.NRTURNO = widgetTurno.currentRow.NRTURNO;
            }else if(widgetTurno.currentRow.DTDATABASE && dados.name === 'DTDATABASE'){
                dados.value = widgetTurno.currentRow.DTDATABASE.substr(0,10);
            }
        });
        
    };

    this.setValues = function(args){
        var widget = ABUtilController.checkWidget(args);
        widget.currentRow = widget.dataSource.data[0];
        if (widget.currentRow) {
            widget.currentRow.QTHRLIMITESEPHEXTRA = widget.currentRow.QTHRLIMITESEPHEXTRA.substr(0,2)+":"+widget.currentRow.QTHRLIMITESEPHEXTRA.substr(2,2);
            widget.currentRow.HRINIPERIODONOTURNO = widget.currentRow.HRINIPERIODONOTURNO.substr(0,2)+":"+widget.currentRow.HRINIPERIODONOTURNO.substr(2,2);
            widget.currentRow.HRFIMPERIODONOTURNO = widget.currentRow.HRFIMPERIODONOTURNO.substr(0,2)+":"+widget.currentRow.HRFIMPERIODONOTURNO.substr(2,2);
            widget.currentRow.QTHRPROJETAINTERVALO = widget.currentRow.QTHRPROJETAINTERVALO.substr(0,2)+":"+widget.currentRow.QTHRPROJETAINTERVALO.substr(2,2);
            if (widget.currentRow.QTHRMAXHRTRAB) {
                widget.currentRow.QTHRMAXHRTRAB = widget.currentRow.QTHRMAXHRTRAB.substr(0,2)+":"+widget.currentRow.QTHRMAXHRTRAB.substr(2,2);
            }
        }
    };
    
    this.formataHora = function(hora){
        hora = hora.replace(':', "");
        return hora;
    };
    
    this.salvarNovoHorario = function(args){
        var widget = templateManager.container.getActiveWidget();
        widget.currentRow.HRINICOLETAMARCACAO = widget.currentRow.HRINICOLETAMARCACAO.replace(/[\:-]/g, '');
        if (widget.isValid()) {
            var preparedWidget = ABUtilController.prepareSaveMasterHistory(widget);
    
            restEngine.post('product#/saveCrud', {
                'requestType': 'DataSet',
                'dataset': [preparedWidget.currentRow]
            }).
            then(function(data) {
                if (data.dataset.columnsToReturn) {
                    ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                    ScreenService.closePopup();
                } else {
                    ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                }
            }).
            catch(function(e) {
                var error;
                if (e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
    
                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
        }
    };
    
    this.openPopupCadHorario = function(){
        var widget = templateManager.container.getWidget('popupCadAutoHorario');
        widget.currentRow.DTMESCOMPETENC = getLocalVar("HCM_DTCOMPETENCIA_OPER");
        widget.currentRow.NRHORDIAH = "";
    };
    
    this.openPopupCadAutoHorarioDia = function(){
        var widget = templateManager.container.getWidget('popupCadAutoHorarioDia');
        var widgetHorarioTurno  = templateManager.container.getWidget("horarioTurno");
        
        if(widgetHorarioTurno.currentRow.NRHORDIAM){
            widget.currentRow.NRHORDIAM = widgetHorarioTurno.currentRow.NRHORDIAM;
            widget.currentRow.NMHORDIAH = widgetHorarioTurno.currentRow.NMHORDIAH;
        }
        ABUtilController.masterDetailOpenPopup(widget);
    };
    
    this.changeDiaDaSemana = function(args){
        var widgetEscalaTrabalhoTurno  = templateManager.container.getWidget("escalaTrabalhoTurno");
        var widgetHorarioTurno  = templateManager.container.getWidget("horarioTurno");
        
        var nrDia = null;
        var semana = new Array(6);
        semana[0]='Domingo';
        semana[1]='Segunda-Feira';
        semana[2]='Terça-Feira';
        semana[3]='Quarta-Feira';
        semana[4]='Quinta-Feira';
        semana[5]='Sexta-Feira';
        semana[6]='Sábado';
        semana[7]='Dia Variável';
        
        var idDiaVariavel = widgetHorarioTurno.currentRow.IDDIAVARIAVEL;
        
        if (idDiaVariavel === 'S') {
            nrDia = 7;
        } else {
            var dia = widgetEscalaTrabalhoTurno.currentRow.DTDATABASE.substr(0,2);
            var mes = widgetEscalaTrabalhoTurno.currentRow.DTDATABASE.substr(3,2);
            var ano = widgetEscalaTrabalhoTurno.currentRow.DTDATABASE.substr(6,4);
            var dtDataBase = new Date(ano, mes-1, dia);
            dtDataBase = dtDataBase.addDays(widgetHorarioTurno.currentRow.NRSEQHORARIO-1);
            nrDia = dtDataBase.getDay();
        }
        
        widgetHorarioTurno.currentRow.DIASEMANA = semana[nrDia];
    };
    
    this.SetaDiaDaSemana = function(){
        var widgetEscalaTrabalhoTurno  = templateManager.container.getWidget("escalaTrabalhoTurno");
        var widget = templateManager.container.getWidget('popupCadAutoHorarioDia');
        
        var nrDia = null;
        var semana = new Array(13);
        semana[0]='Domingo';
        semana[1]='Segunda-Feira';
        semana[2]='Terça-Feira';
        semana[3]='Quarta-Feira';
        semana[4]='Quinta-Feira';
        semana[5]='Sexta-Feira';
        semana[6]='Sábado';
        semana[7]='Domingo';
        semana[8]='Segunda-Feira';
        semana[9]='Terça-Feira';
        semana[10]='Quarta-Feira';
        semana[11]='Quinta-Feira';
        semana[12]='Sexta-Feira';
        semana[13]='Sábado';
        
        
        var dia = widgetEscalaTrabalhoTurno.currentRow.DTDATABASE.substr(0,2);
        var mes = widgetEscalaTrabalhoTurno.currentRow.DTDATABASE.substr(3,2);
        var ano = widgetEscalaTrabalhoTurno.currentRow.DTDATABASE.substr(6,4);
        var dtDataBase = new Date(ano, mes-1, dia);
        
        for(var i = 1; i<=14; i++){
            nrDia = dtDataBase.getDay();
            widget.getField("DIASEMANA").dataSource.data.push({"name": semana[nrDia], "value": i});
            dtDataBase = dtDataBase.addDays(1);
        }
    };
    
    this.setTurnoWidgetFromEscalaTrabalhoTurno = function(nomeWidget) {
        var widgetEscalaTrabalhoTurno  = templateManager.container.getWidget("escalaTrabalhoTurno");
        var widget = templateManager.container.getWidget(nomeWidget);
        
        widget.currentRow.NRTURNO = widgetEscalaTrabalhoTurno.currentRow.NRTURNO;
    };

    this.verificarIntervaloPeriodoApur = function(args, mostrarMsg){
        var widget = ABUtilController.checkWidget(args);
        var dtFim = widget.currentRow.NRDIAINIAPUR;
        var dtIni = widget.currentRow.NRDIAFINAPUR;
        
        if(!dtIni || !dtFim){
            widget.currentRow.IDUTAPURADSR="N";
            widget.currentRow.IDUTAPURATEST="N";
            widget.currentRow.IDFALTASREFLEXO="N";
            if(mostrarMsg) ScreenService.showMessage(Messages.HCM07009_PTO_INTERVALO_SELECAO_AUSENTE);            
        }
    };
    
    this.verificaPeriodoInicialFinal = function(args) {
        var widget = ABUtilController.checkWidget(args);
        var dataInicial = widget.currentRow.NRDIAINIAPUR;
        var dataFinal = widget.currentRow.NRDIAFINAPUR;
        var mensagem = "Apenas valores de 1 à 31 são permitidos";
        
        if (dataInicial) {
            if (dataInicial < 1 || dataInicial > 31) {
                ScreenService.showMessage(mensagem);
                widget.currentRow.NRDIAINIAPUR = '';
            }
        }
        
        if (dataFinal) {
           if (dataFinal < 1 || dataFinal > 31) {
                ScreenService.showMessage(mensagem);
                widget.currentRow.NRDIAFINAPUR = '';
            }
        }
    };
    
    this.atualizaFimVigencia=function(args){
        var widget = ABUtilController.checkWidget(args);
        var dtFim = widget.currentRow.DTFIMVIGENCIA;
        var idAtivo = widget.currentRow.IDATIVO;
        
        if(dtFim==""){
            widget.currentRow.IDATIVO="S";
        } else {
            widget.currentRow.IDATIVO="N";
        }
    };

    this.atualizaFimVigenciaPorIdAtivo=function(args){
        var widget = ABUtilController.checkWidget(args);
        var dtFim = widget.currentRow.DTFIMVIGENCIA;
        var idAtivo = widget.currentRow.IDATIVO;
        
        if(idAtivo=="S"){
            widget.currentRow.DTFIMVIGENCIA="";
        } else if(idAtivo=="N"){
            var today = new Date();
            var dd = today.getDate();
            var mm = today.getMonth() + 1; //January is 0!
            var yyyy = today.getFullYear();
            if (dd < 10) {
            dd = '0' + dd;
            }
            if (mm < 10) {
            mm = '0' + mm;
            }
            today = dd + '/' + mm + '/' + yyyy;
            widget.currentRow.DTFIMVIGENCIA=today;
        }
    };
    
  
  this.states = {
    sequencia: 0
  };
  this.popupCadastroAutomaticoCiclos = new PopupCadastroAutomaticoCiclos(templateManager, ABUtilController, ScreenService, restEngine, Messages, this.states);
    
  this.openPopupCadastroAutomaticoCiclos = function() {
    this.popupCadastroAutomaticoCiclos.showPopup();
  };
  
  this.openFormModelo = function() {
    this.popupCadastroAutomaticoCiclos.showFormModelo();
  };
    
  this.setItemGridModelo = function() {
    this.popupCadastroAutomaticoCiclos.setItemGridModelo();
  };
    
  this.deleteHorarioGridCiclos = function() {
    this.popupCadastroAutomaticoCiclos.deleteItemGrid();
  };
    
  this.gerarCiclosPorQuantidade = function() {
    this.popupCadastroAutomaticoCiclos.gerarCiclosPorQuantidade();
  };
  
  this.gerarCiclosAutomaticamente = function() {
    this.popupCadastroAutomaticoCiclos.gerarCiclosAutomaticamente();
  };
    
  this.setaDiaDaSemanaCadCiclos = function(){
    this.popupCadastroAutomaticoCiclos.setSemanaDias();
  };
    
  this.salvarHorarioDiaAutoCiclo = function() {
    this.popupCadastroAutomaticoCiclos.cadastrar();
  };
  
  this.retrocederCiclosGrid = function() {
    this.popupCadastroAutomaticoCiclos.retrocederCiclosGrid();
    var widget = templateManager.container.getWidget('popupCadastroAutomaticoCiclos');
    widget.currentRow.QUANTIDADECICLOS = '';
    widget.currentRow.CICLOSAUTOMATICOS = 'N';
  };
  
  this.verificaCamposPopup = function() {
    var widget = templateManager.container.getWidget('popupCadastroAutomaticoCiclos');
    var gridModelo = templateManager.container.getWidget('GRID_MODELO');
    if (gridModelo.dataSource.data.length > 0) {
      widget.getField('QUANTIDADECICLOS').readOnly = false;
      widget.getField('CICLOSAUTOMATICOS').readOnly = false;
    } else {
      widget.getField('QUANTIDADECICLOS').readOnly = true;
      widget.currentRow.QUANTIDADECICLOS = '';
      widget.getField('CICLOSAUTOMATICOS').readOnly = true;
      widget.currentRow.CICLOSAUTOMATICOS = 'N';
    }
  };
  
  this.ajustaVisibilidade = function() {
    var widget = templateManager.container.getWidget('popupCadastroAutomaticoCiclos');
    
    if (widget.currentRow.QUANTIDADECICLOS > 0) {
      widget.getField('CICLOSAUTOMATICOS').readOnly = true;
    } else if (widget.currentRow.CICLOSAUTOMATICOS === 'S') {
      widget.getField('QUANTIDADECICLOS').readOnly = true;
    } else {
      widget.getField('CICLOSAUTOMATICOS').readOnly = false;
      widget.getField('QUANTIDADECICLOS').readOnly = false;
    }
  };
  
}

class PopupCadastroAutomaticoCiclos {
  
  constructor(templateManager, ABUtilController, ScreenService, restEngine, Messages, states) {
    this.templateManager = templateManager;
    this.ABUtilController = ABUtilController;
    this.ScreenService = ScreenService;
    this.restEngine = restEngine;
    this.Messages = Messages;
    this.gridModelo = () => {
      return this.templateManager.container.getWidget('GRID_MODELO');
    };
    this.formModelo = () => {
      return this.templateManager.container.getWidget('FORM_MODELO');
    };
    this.popup = () => {
      return this.templateManager.container.getWidget('popupCadastroAutomaticoCiclos');
    };
    this.states = states;
  }
  
  showPopup() {
    this.gridModelo().dataSource.data = [];
    this.ABUtilController.masterDetailOpenPopup(this.popup());
  }
  
  showFormModelo() {
    var nrUltimaOcorrencia = 0;
      
    if (this.gridModelo().dataSource.data.length > 0) {
      for (let i in this.gridModelo().dataSource.data) {
        nrUltimaOcorrencia = this.gridModelo().dataSource.data[i].OCORRENCIA;
      }
    }
    
    this.formModelo().currentRow.OCORRENCIA = nrUltimaOcorrencia + 1;
    this.formModelo().currentRow.DIASEMANA = [];
    this.formModelo().currentRow.NMHORDIAH = '';
    this.formModelo().currentRow.NRHORDIAM = '';
    this.formModelo().currentRow.NRSEQHORARIO = '';
    this.ScreenService.openPopup(this.formModelo());
  }
  
  setItemGridModelo() {
    if (this.formModelo().isValid()) {
      if (this.formModelo().currentRow.DIASEMANA_.length > 1) {
        for (let i in this.formModelo().currentRow.DIASEMANA_) {
          this.gridModelo().dataSource.data.push(this.getItemFormModelo(i));
        }
      } else {
        this.gridModelo().dataSource.data.push(this.getItemFormModelo(0));
      }
      this.ScreenService.closePopup();
      this.states.sequencia = this.gridModelo().dataSource.data.length;
    }
  }
  
  getItemFormModelo(posicaoArray) {
    return {
      DIASEMANA: this.formModelo().currentRow.DIASEMANA[posicaoArray],
      DIASEMANA_: this.formModelo().currentRow.DIASEMANA_[posicaoArray],
      IDDIAVARIAVEL: this.formModelo().currentRow.IDDIAVARIAVEL,
      NMHORDIAH: this.formModelo().currentRow.NMHORDIAH,
      NRHORDIAM: this.formModelo().currentRow.NRHORDIAM,
      NRSEQHORARIO: this.formModelo().currentRow.NRSEQHORARIO[posicaoArray],
      NRTURNO: this.formModelo().currentRow.NRTURNO,
      OCORRENCIA: this.formModelo().currentRow.OCORRENCIA++
    };
  }
  
  deleteItemGrid() {
    for (let c in this.gridModelo().getCheckedRows()) {
      for (let i in this.gridModelo().dataSource.data) {
        if (this.isTheItemToDelete(i, c)) {
           this.gridModelo().dataSource.data.splice(i,1);
        }
      }
    }
    this.gridModelo().updateCheckedRows();
    this.states.sequencia = this.gridModelo().dataSource.data.length;
  }
  
  isTheItemToDelete(posA, posB) {
    return (
      (this.gridModelo().dataSource.data[posA].DIASEMANA_ === this.gridModelo().getCheckedRows()[posB].DIASEMANA_) && 
      (this.gridModelo().dataSource.data[posA].OCORRENCIA === this.gridModelo().getCheckedRows()[posB].OCORRENCIA)
    );
  } 
    
  gerarCiclosPorQuantidade() {
    var ciclosPorQuantidade = new CiclosPorQuantidade(this.gridModelo(), this.popup().currentRow.QUANTIDADECICLOS);
    var ciclos = ciclosPorQuantidade.getCiclos();
    var obj = {};
    
    for (let i in ciclos) {
      obj = {
        DIASEMANA_: ciclos[i].DIASEMANA_,
        DIASEMANA: ciclos[i].DIASEMANA,
        NMHORDIAH: ciclos[i].NMHORDIAH,
        NRHORDIAM: ciclos[i].NRHORDIAM,
        NRSEQHORARIO: ciclos[i].NRSEQHORARIO,
        OCORRENCIA: ciclos[i].OCORRENCIA,
        NRTURNO: ciclos[i].NRTURNO
      };
      this.gridModelo().dataSource.data.push(obj);
    }
    
    this.gridModelo().redraw();
  }
  
  gerarCiclosAutomaticamente() {
    var checkboxCiclosAutomaticos = this.popup().currentRow.CICLOSAUTOMATICOS;
    
    if (checkboxCiclosAutomaticos === 'S') {
      var ciclosAutomaticos = new CiclosAutomaticos(this.gridModelo());
      var ciclos = ciclosAutomaticos.getCiclos();
      var obj = {};
      
      for (let i in ciclos) {
        obj = {
          DIASEMANA_: ciclos[i].DIASEMANA_,
          DIASEMANA: ciclos[i].DIASEMANA,
          NMHORDIAH: ciclos[i].NMHORDIAH,
          NRHORDIAM: ciclos[i].NRHORDIAM,
          NRSEQHORARIO: ciclos[i].NRSEQHORARIO,
          OCORRENCIA: ciclos[i].OCORRENCIA,
          NRTURNO: ciclos[i].NRTURNO
        };
        this.gridModelo().dataSource.data.push(obj);
      }
    }
  }
  
  retrocederCiclosGrid() {
    var count = 0;
    var ciclos = this.gridModelo().dataSource.data.length - this.states.sequencia;
    while (count++ < ciclos) {
      this.gridModelo().dataSource.data.pop();
    }
    
    this.gridModelo().redraw();
  }
    
  setSemanaDias() {
    var widgetEscalaTrabalhoTurno  = this.templateManager.container.getWidget("escalaTrabalhoTurno");
      
    var nrDia = null;
    var semana = new Array(13);
    semana[0]='Domingo';
    semana[1]='Segunda-Feira';
    semana[2]='Terça-Feira';
    semana[3]='Quarta-Feira';
    semana[4]='Quinta-Feira';
    semana[5]='Sexta-Feira';
    semana[6]='Sábado';
      
    var dia = widgetEscalaTrabalhoTurno.currentRow.DTDATABASE.substr(0,2);
    var mes = widgetEscalaTrabalhoTurno.currentRow.DTDATABASE.substr(3,2);
    var ano = widgetEscalaTrabalhoTurno.currentRow.DTDATABASE.substr(6,4);
    var dtDataBase = new Date(ano, mes-1, dia);
    
    for(let i = 1; i<=7; i++){
        nrDia = dtDataBase.getDay();
        this.formModelo().getField("DIASEMANA").dataSource.data.push({"name": semana[nrDia], "value": i});
        dtDataBase = dtDataBase.addDays(1);
    }
  }
  
  cadastrar() {
    var popup = this;
    var horario = this.templateManager.container.getWidget('horarioTurno');
    
    if (this.gridModelo().dataSource.data.length > 0) {
      this.restEngine.post(
        '/saveHorarioDiaAutoCiclo', {
        'requestType': 'DataSet',
        'dataset': [this.gridModelo().dataSource.data]
        }
      )
      .then(function(data) {
        if (data.notifications[0].type === "success") {
          popup.ScreenService.successNotification(popup.Messages.SAVE_ROW_SUCCESS, 10000);
          popup.ScreenService.closePopup();
          popup.ScreenService.closePopup();
          horario.activate();
          horario.reload();
        } else {
          popup.ScreenService.showMessage(popup.Messages.SAVE_ROW_ERROR);
        }
      })
      .catch(function(e) {
        var error = e.data.error;
        popup.ScreenService.showMessage(popup.Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
      });
    }
  }
  
}

class Ciclos {
  
  constructor(gridModelo, quantidadeCiclos){
    this.mapDias = [];
    this.sequenciaDias = [];
    this.ciclos = [];
    this.gridModelo = gridModelo;
    this.ultimoDiaSemana = 1;
    this.quantidadeCiclos = quantidadeCiclos;
    this.diasDaSemana = {'1': 'Sábado', '2': 'Domingo', '3': 'Segunda-Feira', '4': 'Terça-Feira', '5': 'Quarta-Feira', '6': 'Quinta-Feira', '7': 'Sexta-Feira'};
    this.nrSequencia = 0;
  }
  
  getCiclos() {
    this.buildMapAndSequencia();
    this.buildCiclos();
    
    return this.ciclos;
  }

  buildMapAndSequencia() {
    for (let i in this.gridModelo.dataSource.data) {
      this.sequenciaDias.push(this.getItemGridModelo(i));
      this.mapDias.push(this.gridModelo.dataSource.data[i].DIASEMANA);
    }
    this.ultimoDiaSemana = this.mapDias[this.mapDias.length -1];
    this.nrSequencia = this.ultimoDiaSemana;
  }
  
  getItemGridModelo(posicaoArray) {
    return {
      NMHORDIAH: this.gridModelo.dataSource.data[posicaoArray].NMHORDIAH,
      NRHORDIAM: this.gridModelo.dataSource.data[posicaoArray].NRHORDIAM,
      NRSEQHORARIO: this.gridModelo.dataSource.data[posicaoArray].NRSEQHORARIO,
      NRTURNO: this.gridModelo.dataSource.data[posicaoArray].NRTURNO,
      OCORRENCIA: this.gridModelo.dataSource.data[posicaoArray].OCORRENCIA
    };
  }

  getItemSequencia(posicaoArray) {
    return {
      DIASEMANA: this.ultimoDiaSemana,
      DIASEMANA_: this.diasDaSemana[this.ultimoDiaSemana],
      NMHORDIAH: this.sequenciaDias[posicaoArray].NMHORDIAH,
      NRHORDIAM: this.sequenciaDias[posicaoArray].NRHORDIAM,
      NRSEQHORARIO: ++this.nrSequencia,
      OCORRENCIA: ++this.sequenciaDias[this.sequenciaDias.length -1].OCORRENCIA,
      NRTURNO: this.sequenciaDias[posicaoArray].NRTURNO
    };
  }
  
}

class CiclosPorQuantidade extends Ciclos {
  
  buildCiclos() {
    var contador = 1;
    
    while (contador++ < this.quantidadeCiclos) {
      for (let i in this.sequenciaDias) {
        if (++this.ultimoDiaSemana > 7) {
          this.ultimoDiaSemana = 1;
        }
        this.ciclos.push(this.getItemSequencia(i));
      }
    }
  }
  
}

class CiclosAutomaticos extends Ciclos {
  
  buildCiclos() {
    var contador = 1;
    var quantidadeCiclos = (7 * this.sequenciaDias.length)/this.sequenciaDias.length;
    
    while (contador++ < quantidadeCiclos) {
      for (let i in this.sequenciaDias) {
       if (++this.ultimoDiaSemana > 7) {
         this.ultimoDiaSemana = 1;
        }
        this.ciclos.push(this.getItemSequencia(i));
      }
    }
  }
  
}

Configuration(function(ContextRegister) {
    ContextRegister.register('EscalaTrabalhoController', EscalaTrabalhoController);
});

// FILE: assets/js/controllers/EscalaVinculoController.js
function EscalaVinculoController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, General, Messages) {
    
    var self = this;
    var novo = false;
    var dataSelecionada;
    
    this.setFilterOcorrencia = function(args){
        var widget = args.owner;
        var widgetOcorrencia = widget.widgets[ABUtilController.retornaWidget(widget, 'ocorrenciaFrequencia')];
        var widgetCalendar = widget.widgets[ABUtilController.retornaWidget(widget, 'FilterDate')];
        
        widgetOcorrencia.dataSourceFilter[ABUtilController.retornaFiltro(widgetOcorrencia.dataSourceFilter, 'NRVINCULOM')].value = widget.currentRow.NRVINCULOM;
        widgetCalendar.dataSourceFilter[ABUtilController.retornaFiltro(widgetCalendar.dataSourceFilter, 'NRVINCULOM')].value = widget.currentRow.NRVINCULOM;
    };
    
     this.setDateLimitFilter = function() {
        var container      = templateManager.container;
        var widgetCalendar = container.getWidget('FilterDate');

        minDate = moment(getLocalVar("HCM_DTCOMPETENCIA_OPER"), 'DD/MM/YYYY').format('DD/MM/YYYY');

        widgetCalendar.minDate = minDate;

        templateManager.updateTemplate(widgetCalendar);
    };
    
    this.filterDateSelected = function(argsRowDate) {
        var container = templateManager.container;
        var widget = container.getWidget('ocorrenciaFrequencia');
        var widgetCalendar = container.getWidget('FilterDate');
        novo = true;
        dataSelecionada = argsRowDate;
        for(var k in widgetCalendar.dataSource.data){
            if(widgetCalendar.dataSource.data[k].DTPROGOCOR == argsRowDate) {
                novo = false;
            }
        }
        widget.activate();

        if(!novo){
            widget.dataSourceFilter.push({
                "name": "DTPROGOCOR",
                "operator": "LIKE_I",
                "value": "%"+argsRowDate+"%"
            });
            widget.reload().
            then(function(){
                widget.dataSourceFilter.pop();
            });
        }
        
    };
    
    this.selecionaVinculo = function(args){
        var container = templateManager.container;
        var widget = container.getWidget('ocorrenciaFrequencia');
        var widgetPai = widget.parent ? widget.parent.parent : null; 
        
        widget.currentRow.NRVINCULOM = widgetPai.currentRow.NRVINCULOM;
        widget.currentRow.NMVINCULOM = widgetPai.currentRow.NMVINCULOM;
    };
    
    this.criaOcorrencia = function(args){
        var container = templateManager.container;
        var widget = container.getWidget('ocorrenciaFrequencia');
        if(novo){
            ABUtilController.masterDetailNewRow(widget);
            self.selecionaVinculo(args);
            widget.currentRow.DTINICIOPROGOCOR = dataSelecionada;
            widget.currentRow.DTFIMPROGOCOR = dataSelecionada;
        }
        novo = false;
    };

}

Configuration(function(ContextRegister) {
    ContextRegister.register('EscalaVinculoController', EscalaVinculoController);
});

// FILE: assets/js/controllers/EscolaridadeController.js
function EscolaridadeController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, General,Messages) {

    this.adicionarRow = function(args) {
        var widget = args.owner.widget;
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
    };

	this.setEscolaridade = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
                if (!widget.backupRow) {
                    widget.currentRow.__is_new = true;
                } else {
                    widget.currentRow.__is_new = false;
                }
                restEngine.post('product#/setEscolaridade', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                    then(function (data) {
                        if (data.notifications[0].type === "success") {
                            ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                            if (widget.currentRow.__is_new) {
                                ABUtilController.masterDetailVoltarList(widget);
                                widget.reload();
                            } else {
                                ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                                widget.backupRow = null;
                                widget.view();
                            }
                        } else {
                            ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                        }
                    }).
                    catch(function(e) {
                        var error;
                        if(e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;
                            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    });
            }
    };
    
    this.deleteEscolaridade = function(args) {
    ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
        var widget = args.owner.widget;
        widget.currentRow.__is_new = false;
        restEngine.post('product#/deleteEscolaridade', {'requestType':'DataSet','dataset':[widget.currentRow]}).
            then(function(data){
                if(data.notifications[0].type === "success"){
                    ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                    ABUtilController.masterDetailVoltarList(widget);
                    widget.reload();
                } else {
                    ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                }
            }).
            catch(function(e) {
                var error;
                if(e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
        }, null);
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('EscolaridadeController', EscolaridadeController);
});

// FILE: assets/js/controllers/EsoEventoController.js
function EsoEventoController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, General,Messages) {

    this.adicionarRow = function(args) {
        var widget = args.owner.widget;
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
    };
    
	this.setEsoEvento = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
                if (!widget.backupRow) {
                    widget.currentRow.__is_new = true;
                } else {
                    widget.currentRow.__is_new = false;
                }
                restEngine.post('product#/setEsoEvento', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                    then(function (data) {
                        if (data.notifications[0].type === "success") {
                            ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                            if (widget.currentRow.__is_new) {
                                ABUtilController.masterDetailVoltarList(widget);
                                widget.reload();
                            } else {
                                ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                                widget.backupRow = null;
                                widget.view();
                            }
                        } else {
                            ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                        }
                    }).
                    catch(function(e) {
                        var error;
                        if(e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;
                            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    });
            }
    };
    
    this.deleteEsoEvento = function(args) {
    ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
        var widget = args.owner.widget;
        widget.currentRow.__is_new = false;
        restEngine.post('product#/deleteEsoEvento', {'requestType':'DataSet','dataset':[widget.currentRow]}).
            then(function(data){
                if(data.notifications[0].type === "success"){
                    ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                    ABUtilController.masterDetailVoltarList(widget);
                    widget.reload();
                } else {
                    ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                }
            }).
            catch(function(e) {
                var error;
                if(e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
        }, null);
        };
    }
    
    this.afterMoveRowEvento = function() {	 
        var widgetEvento = templateManager.container.getWidget('esoEvento');	 
        var widgetRegistro = templateManager.container.getWidget('esoRegistro');	 
        	 
        widgetRegistro.dataSourceFilter[0].value = widgetEvento.currentRow.NREVENTO;	 
    };	 
    	 
    this.setEsoRegistro = function(args) {	 
        var widget = args.owner.widget;	 
        if (widget.isValid()) {	 
                if (!widget.backupRow) {	 
                    widget.currentRow.__is_new = true;	 
                } else {	 
                    widget.currentRow.__is_new = false;	 
                }	 
                restEngine.post('product#/setEsoRegistro', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).	 
                    then(function (data) {	 
                        if (data.notifications[0].type === "success") {	 
                            ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);	 
                            if (widget.currentRow.__is_new) {	 
                                ABUtilController.masterDetailVoltarList(widget);	 
                                widget.reload();	 
                            } else {	 
                                ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);	 
                                widget.backupRow = null;	 
                                widget.view();	 
                            }	 
                        } else {	 
                            ScreenService.showMessage(Messages.SAVE_ROW_ERROR);	 
                        }	 
                    }).	 
                    catch(function(e) {	 
                        var error;	 
                        if(e.data.error === undefined)	 
                            error = e;	 
                        else	 
                            error = e.data.error;	 
                            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');	 
                    });	 
            }	 
    };	 
    	 
    this.deleteEsoRegistro = function(args) {	 
    ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {	 
        var widget = args.owner.widget;	 
        widget.currentRow.__is_new = false;	 
        restEngine.post('product#/deleteEsoRegistro', {'requestType':'DataSet','dataset':[widget.currentRow]}).	 
            then(function(data){	 
                if(data.notifications[0].type === "success"){	 
                    ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);	 
                    ABUtilController.masterDetailVoltarList(widget);	 
                    widget.reload();	 
                } else {	 
                    ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);	 
                }	 
            }).	 
            catch(function(e) {	 
                var error;	 
                if(e.data.error === undefined)	 
                    error = e;	 
                else	 
                    error = e.data.error;	 
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');	 
            });	 
        }, null);	 
    };	 
    	 
    this.importacaoXSD = function() {	 
        var widgetEvento = templateManager.container.getWidget("esoEvento");	 
        var widgetRegistro = templateManager.container.getWidget("esoRegistro");	 
        var widgetAnexo = templateManager.container.getWidget("importacaoXSD");	 
        var caracteresInvalidos = ["*", "%", "@", "#", "$", "¨", "&", "'"];	 
        var verificaNomeArquivo = true;	 
        var argsRow = widgetAnexo.currentRow;	 
	 
        if(widgetAnexo.isValid()){	 
            verificaNomeArquivo = !caracteresInvalidos.find(function(value) {	 
                return !Util.isUndefined(argsRow.DSPATH) ? argsRow.DSPATH[0].name.indexOf(value) !== -1 : false;	 
            });	 
            if(verificaNomeArquivo) {	 
                saveData = Object.assign({}, argsRow,	 
                    {"NRORG":           getLocalVar("HCM_NRORG_PADRAO")},	 
                    {"NREVENTO":        widgetEvento.currentRow.NREVENTO}	 
                );	 
                return restEngine.post("/setEsoImportacaoXSD",	 
                    {	 
                        requestType: "DataSet",	 
                        dataset: [saveData]	 
                    }	 
                ).then(function (data) {	 
                    if (!Util.isUndefined(data.messages)) {	 
                        var messages = "";	 
                        data.messages.forEach(function(objMsg){	 
                            messages += objMsg.message + "\n";	 
                        });	 
                        ScreenService.showMessage(messages);	 
                        ABUtilController.masterDetailClosePopup(widgetAnexo);	 
                        ABUtilController.masterDetailVoltarList(widgetRegistro);	 
                        widgetRegistro.reload();	 
                    } else {	 
                        ScreenService.showMessage("Não foi possível realizar o upload do arquivo");	 
                    }	 
                }.bind(this)	 
                ).catch(function(e) {	 
                    var error;	 
                    if(e.data.error === undefined)	 
                        error = e;	 
                    else	 
                        error = e.data.error;	 
                    ScreenService.showMessage('Ocorreu um erro inesperado, contate o administrador informando o trecho abaixo: <br><br>' + error + '<br><br>', 'ERROR');	 
                });	 
            } else {	 
                ScreenService.showMessage('Nome inválido para o arquivo');	 
            }	 
        }	 
    };

Configuration(function(ContextRegister) {
    ContextRegister.register('EsoEventoController', EsoEventoController);
});

// FILE: assets/js/controllers/EsoHistoricoEnvioController.js
function EsoHistoricoEnvioController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, General, Messages, ESocialService) {

    this.setVersaoEvento = function(field) {
        var versao = field.value();
        var widget = field.widget;
        var idx = null;

        widget.getField('NMEVENTO').dataSourceFilter.forEach(function(filter, index){
            if (filter.name == 'DSVERSAO') {
                idx = index;
            }
        });
        
        if (versao == null) {
            if (idx !== null) {
                widget.getField('NMEVENTO').dataSourceFilter.splice(idx);
            }
        } else {
            if (idx === null) {
                widget.getField('NMEVENTO').dataSourceFilter.push(
                    {
                        "name": "DSVERSAO",
                        "operator": "=",
                        "value": versao
                    }
                );
            } else {
                widget.getField('NMEVENTO').dataSourceFilter[idx].valeu = versao;
            }
        }
    };
    
    this.setGrupoEvento = function(field) {
        var grupo = field.value();
        var widget = field.widget;
        var idx = null;

        widget.getField('NMEVENTO').dataSourceFilter.forEach(function(filter, index){
            if (filter.name == 'IDGRUPO') {
                idx = index;
            }
        });
        
        if (grupo == null) {
            if (idx !== null) {
                widget.getField('NMEVENTO').dataSourceFilter.splice(idx);
            }
        } else {
            if (idx === null) {
                widget.getField('NMEVENTO').dataSourceFilter.push(
                    {
                        "name": "IDGRUPO",
                        "operator": "=",
                        "value": grupo
                    }
                );
            } else {
                widget.getField('NMEVENTO').dataSourceFilter[idx].valeu = grupo;
            }
        }
    };
    
}

Configuration(function(ContextRegister) {
    ContextRegister.register('EsoHistoricoEnvioController', EsoHistoricoEnvioController);
});

// FILE: assets/js/controllers/EsoInfComplementarController.js
function EsoInfComplementarController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, General, Messages) {

    this.adicionarRow = function() {
        var widget = templateManager.container.getWidget('infoComplementar');
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
    };
    
	this.setEsoInfComplementar = function() {
        var widget = templateManager.container.getWidget('infoComplementar');
        if (widget.isValid()) {
                if (!widget.backupRow) {
                    widget.currentRow.__is_new = true;
                } else {
                    widget.currentRow.__is_new = false;
                }
                restEngine.post('product#/setEsoInfComplementar', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                    then(function (data) {
                        if (data.notifications[0].type === "success") {
                            ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                            if (widget.currentRow.__is_new) {
                                ABUtilController.masterDetailVoltarList(widget);
                                widget.reload();
                            } else {
                                ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                                widget.backupRow = null;
                                widget.view();
                            }
                        } else {
                            ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                        }
                    }).
                    catch(function(e) {
                        var error;
                        if(e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;
                            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    });
            }
    };
    
    this.deleteEsoInfComplementar = function() {
        ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
            var widget = templateManager.container.getWidget('infoComplementar');
            widget.currentRow.__is_new = false;
            restEngine.post('product#/deleteEsoInfComplementar', {'requestType':'DataSet','dataset':[widget.currentRow]}).
                then(function(data){
                    if(data.notifications[0].type === "success"){
                        ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    } else {
                        ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                    }
                }).
                catch(function(e) {
                    var error;
                    if(e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;
                        ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
        }, null);
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('EsoInfComplementarController', EsoInfComplementarController);
});

// FILE: assets/js/controllers/EsoParametroController.js
function EsoParametroController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, General,Messages) {
    
    this.adicionarRow = function(args) {
        var widget = args.owner.widget;
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
        this.verificaMatriculaESocial('IDUTILIZAMATRIC');
    };
    
    this.verificaRespPeriodico = function(args){
        var widget = ABUtilController.checkWidget(args);
        if(!widget.currentRow.NMPARCRESPPERI){
            widget.currentRow.NRPARCRESPPERI = '';
            widget.currentRow.NRCPFPESSOA = '';
            widget.currentRow.TELEFONE = '';
            widget.currentRow.PREFIXOTEL = '';
            widget.currentRow.EMAIL = '';
            
        }
    };
    
    this.alteraValidacaoCamposEdicao = function(){
        var widget = templateManager.container.getWidget('esoParametro');
        if(widget.currentRow.IDUTILIZAMATRIC == 'S'){
            widget.getField('NRQTDEDIGMATRIC').validations = {"required": true};
        }else{
            widget.getField('NRQTDEDIGMATRIC').validations = {};
        }
    };
    
    this.verificaQtdeTotalmatricula = function(){
        var widget = templateManager.container.getWidget('esoParametro');
        var qtdeDigitos = widget.getField('NRQTDEDIGMATRIC').value();
        var prefixo = widget.getField('DSPREFIXOMATRIC').value() ? ""+widget.getField('DSPREFIXOMATRIC').value()+"" : 0;
        if((qtdeDigitos + prefixo.length) > 30){
            ScreenService.showMessage('A soma entre a quantidade de caracteres do prefixo e o nº de dígitos sequenciais informados para a matrícula não pode superar 30 caracteres!');
            return false;
        }else{
            return true;
        }  
    };
    
    this.verificaMatriculaESocial = function(fieldName){
        var widget = templateManager.container.getWidget('esoParametro');
        
        if(fieldName == 'NRQTDEDIGMATRIC'){
            this.verificaQtdeTotalmatricula();
        }else if(fieldName == 'DSPREFIXOMATRIC'){
            var prefixo = ""+widget.getField('DSPREFIXOMATRIC').value()+"";
            this.verificaQtdeTotalmatricula();
            if(prefixo == 'ESOCIAL'){
                ScreenService.showMessage('O prefixo não pode ser "ESOCIAL".');
            }
            
        }else if(fieldName == 'IDUTILIZAMATRIC'){
            if(widget.currentRow.IDUTILIZAMATRIC == 'S'){
                widget.getField('NRQTDEDIGMATRIC').validations = {"required": true};
                widget.getField('DSPREFIXOMATRIC').readOnly = false;
                widget.getField('NRQTDEDIGMATRIC').readOnly = false;
            }else{
                widget.getField('NRQTDEDIGMATRIC').validations = {};
                widget.getField('DSPREFIXOMATRIC').readOnly = true;
                widget.getField('NRQTDEDIGMATRIC').readOnly = true;
            }
        }
        
    };
    
	this.salvarParametro = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
            if(this.verificaQtdeTotalmatricula()){
                if (!widget.backupRow) {
                    widget.currentRow.__is_new = true;
                } else {
                    widget.currentRow.__is_new = false;
                }
                restEngine.post('product#/setEsoParametro', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                    then(function (data) {
                        if (data.notifications[0].type === "success") {
                            ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                            if (widget.currentRow.__is_new) {
                                ABUtilController.masterDetailVoltarList(widget);
                                widget.reload();
                            } else {
                                ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                                widget.backupRow = null;
                                widget.view();
                            }
                        } else {
                            ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                        }
                    }).
                    catch(function(e) {
                        var error;
                        if(e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;
                            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    });
                }
            }
        
    };

    this.deleteParametro = function(args) {
    ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
        var widget = args.owner.widget;
        widget.currentRow.__is_new = false;
        restEngine.post('product#/deleteEsoParametro', {'requestType':'DataSet','dataset':[widget.currentRow]}).
            then(function(data){
                if(data.notifications[0].type === "success"){
                    ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                    ABUtilController.masterDetailVoltarList(widget);
                    widget.reload();
                } else {
                    ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                }
            }).
            catch(function(e) {
                var error;
                if(e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
      }, null);
    };

	this.saveUploadFile = function(args) {
        var widgetAnexar        = ABUtilController.checkWidget(args);
        var widgetParametro     = templateManager.container.getWidget("esoParametro");
        var caracteresInvalidos = ["*", "%", "@", "#", "$", "¨", "&", "'"];
        var verificaNomeArquivo = true;
        var argsRow = widgetAnexar.currentRow;

        if(widgetAnexar.isValid()){
            verificaNomeArquivo = !caracteresInvalidos.find(function(value) {
                return !Util.isUndefined(argsRow.DSPATH) ? argsRow.DSPATH[0].name.indexOf(value) !== -1 : false;
            });
            if(verificaNomeArquivo) {
                saveData = Object.assign({}, argsRow,
                    {"NRORG":          getLocalVar("HCM_NRORG_PADRAO")},
                    {"NRPARAMETRO":  widgetParametro.currentRow.NRPARAMETRO},
                    {"NRPARCNEGOCIO":  widgetParametro.currentRow.NRPARCNEGOCIO},
                    {"NRANEXO":  widgetParametro.currentRow.NRANEXO},
                    {"CDOPERINCLUSAO": getLocalVar("CDOPERADOR")},
                    {"CDOPERADOR_LOG": getLocalVar("CDOPERADOR")},
                    {"DSREFERENCIA":   'Certificado eSocial'},
                    {"IDFOTO":         'N'});
                return restEngine.post("/setCertTransmissor",
                    {
                        requestType: "DataSet",
                        dataset: [saveData]
                    }
                ).then(function (data) {
                    if (!Util.isUndefined(data.dataset.setCertTransmissor) && data.dataset.setCertTransmissor[0]) {
                        ScreenService.showMessage("Arquivo carregado com sucesso");
                        ABUtilController.masterDetailClosePopup(widgetAnexar);
                        ABUtilController.masterDetailVoltarList(widgetParametro);
                        widgetParametro.reload();
                    } else {
                        ScreenService.showMessage("Não foi possível realizar o upload do arquivo");
                    }
                }.bind(this)
                ).catch(function(e) {
                    var error;
                    if(e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;
                    ScreenService.showMessage('Ocorreu um erro inesperado, contate o administrador informando o trecho abaixo: <br><br>' + error + '<br><br>', 'ERROR');
                });
            } else {
                ScreenService.showMessage('Nome inválido para o arquivo');
            }
        }
    };

}

Configuration(function(ContextRegister) {
    ContextRegister.register('EsoParametroController', EsoParametroController);
});

// FILE: assets/js/controllers/EsoSimplificadoController.js
/* jshint esversion: 6 */
function EsoSimplificadoController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, General, Messages, ESocialService, LibUtilities) {

    var self = this;

    this.STATUS_PENDENTE = 'P';
    this.STATUS_ERROENVIO = 'E';
    this.STATUS_PENDPROCE = 'M';
    this.STATUS_ERROPROCE = 'R';
    this.STATUS_CONCLUIDO = 'C';
    this.STATUS_CONCADVER = 'A';
    this.idGrupo = null;
    this.idGrupoCadastro = null;
    this.lblContainer = null;
    
    // Variáveis para o redirecionamento de tela
    this.filtrarFilhasESocial = false;
    this.CODIGO = null;
    this.TABELA = null;
    this.paramFiltro = null;
    this.paramFiltroTabela = null;
    this.idItemCalculo = null;
    this.widgetItemCalculo = null;
    this.nmWidgetRedirecionada = null;
    this.nomeWidget = null;
    this.dsversao = null;
    this.alteraCampos = null;
    this.campoAtivoFiltroNaoEstaMarcado = false; //variavel criada para validar se o campo 'Ativo' do filtro foi setado ou não (true: não está marcado; false: está marcado)
    this.nrestruturam = null; //Variável criada para recarregar os dados de envios quando a estrutura for alterada
    
    //Campos de filtro por evento que utiliza o campo
    this.FILTROS = {
        "NREVENTOM" : ["S-1010"],
        "NRTIPOMOVIMENT" : ["S-1010", "S-1200"],
        "NRESTRUTTOMAD" : ["S-1020"],
        "NROCUPACAOM" : ["S-1030","S-1040"],
        "NRHORDIAM" : ["S-1050"],
        "NRESTRUTGEREN" : ["S-1060"],
        "NRVINCULOMCOMPL" : ["S-1200","S-1210"],
        "NRVINCULOMRESC" : ["S-2299","S-2399"],
        "NRVINCULOM" : ["S-2200","S-2205","S-2206","S-2230","S-2250","S-2260","S-2298","S-2300","S-2306"],
        "NRPESSOAPRE" : ["S-2190"]
    };
    
    this.nomesErrosInclusaoEventos = ["HCM09000_ESO_ENVIOS_NOT_FOUND_ERROR", "HCM09000_ESO_UNIQUE_ENVIO_ERROR"];
    
    this.getWidgetEstruturas = function() {
        return templateManager.container.getWidget('estruturas');
    };
    
    this.getWidgetCadastros = function() {
        return templateManager.container.getWidget('cadastros');
    };
    
    this.getWidgetNaoPeriodicos = function() {
        return templateManager.container.getWidget('naoPeriodicos');
    };
    
    this.getWidgetSST = function() {
        return templateManager.container.getWidget('sst');
    };
    
    this.getWidgetPeriodo = function() {
        return templateManager.container.getWidget('tabbed_periodicos');
    };
    
    this.getWidgetPeriodicos = function() {
        return templateManager.container.getWidget('periodicos');
    };
    
    this.getWidgetNovoEventoCadastro = function() {
        return templateManager.container.getWidget('novoEventoCadastro');
    };
    
    this.getWidgetNovoEventoNaoPeriodico = function() {
        return templateManager.container.getWidget('novoEventoNaoPeriodico');
    };
    
    this.getWidgetNovoEventoSST = function() {
        return templateManager.container.getWidget('novoEventoSST');
    };
    
    this.getWidgetNovoEventoPeriodico = function() {
        return templateManager.container.getWidget('novoEventoPeriodico');
    };
    
    this.getWidgetEnvioAutomaticoCadastro = function() {
        return templateManager.container.getWidget('envioAutomaticoCadastro');
    };
    
    this.getWidgetEnvioAutomaticoNaoPeriodico = function() {
        return templateManager.container.getWidget('envioAutomaticoNaoPeriodico');
    };
    
    this.getWidgetEnvioAutomaticoSST = function() {
        return templateManager.container.getWidget('envioAutomaticoSST');
    };
    
    this.getWidgetEnvioAutomaticoPeriodico = function() {
        return templateManager.container.getWidget('envioAutomaticoPeriodico');
    };
    
    this.getWidgetConsultaAutomaticaCadastro = function() {
        return templateManager.container.getWidget('consultaAutomaticaCadastro');
    };
    
    this.getWidgetConsultaAutomaticaNaoPeriodico = function() {
        return templateManager.container.getWidget('consultaAutomaticaNaoPeriodico');
    };
    
    this.getWidgetConsultaAutomaticaSST = function() {
        return templateManager.container.getWidget('consultaAutomaticaSST');
    };
    
    this.getWidgetConsultaAutomaticaPeriodico = function() {
        return templateManager.container.getWidget('consultaAutomaticaPeriodico');
    };
    
    this.getWidgetDadosEnv = function() {
        return templateManager.container.getWidget('dadosEnv');
    };
    
    this.getWidgetRetEnvio = function() {
        return templateManager.container.getWidget('retEnvio');
    };
    
    this.getWidgetRetProces = function() {
        return templateManager.container.getWidget('retProces');
    };
    
    this.getWidgetRetTotal = function() {
        return templateManager.container.getWidget('retTotal');
    };
    
    this.getWidgetMensagens = function() {
        return templateManager.container.getWidget("mensagens");
    };
    
    this.getWidgetNaoPeriodicosPendentes = function() {
        return templateManager.container.getWidget('naoPeriodicosPendentes');
    };
    
    this.getEstruturaParametrizada = function() {
        var widgetEstruturas = this.getWidgetEstruturas();
        
        return (widgetEstruturas.currentRow.DSVERSAO != null && widgetEstruturas.currentRow.NRTPAMBIENTE != null && widgetEstruturas.currentRow.NRPARCNEGOCIO != null);
    };
    
    this.afterMoveEstrutura = function() {
        this.enableDisableActionsEstruturas();
        this.enableDisableWidgetsFilhasEstruturas();
        this.setFilterWidgetCadastros();
        this.setFilterWidgetNaoPeriodicos();
        this.setFilterWidgetPeriodicos();
    };
    
    this.enableDisableActionsEstruturas = function() {
        var widgetEstruturas = this.getWidgetEstruturas();
        
        widgetEstruturas.actions.forEach(function(action){
            if (/*action.name == 'cargainicial' ||*/ (action.name == 'exclusaoEmpregador' && widgetEstruturas.currentRow.NRTPAMBIENTE == 2) || action.name == 'parametroEsocial') {
                action.isVisible = this.getEstruturaParametrizada();
            }
        }.bind(this));
    };
    
    this.enableDisableWidgetsFilhasEstruturas = function() {
        var widgetNaoperiodicos = this.getWidgetNaoPeriodicos();
        var widgetSST = this.getWidgetSST();
        var widgetPeriodicos = this.getWidgetPeriodicos();
        
        widgetNaoperiodicos.isVisible = this.getEstruturaParametrizada();
        widgetSST.isVisible = this.getEstruturaParametrizada();
        widgetPeriodicos.isVisible = this.getEstruturaParametrizada();
    };
    
    this.setFilterWidgetCadastros = function() {
        var widgetEstruturas = this.getWidgetEstruturas();
        var widgetCadastros = this.getWidgetCadastros();
        
        if (widgetCadastros.isVisible) {
            widgetCadastros.dataSourceFilter.forEach(function(filter){
                if (filter.name == 'P_NRTPAMBIENTE') {
                    filter.value = widgetEstruturas.currentRow.NRTPAMBIENTE;
                }
                if (filter.name == 'P_NRESTRUTURAM') {
                    filter.value = widgetEstruturas.currentRow.NRESTRUTURAM;
                }
            });
        }
    };
    
    this.setFilterWidgetNaoPeriodicos = function() {
        var widgetEstruturas = this.getWidgetEstruturas();
        var widgetNaoperiodicos = this.getWidgetNaoPeriodicos();
        var widgetSST = this.getWidgetSST();
        
        if (widgetNaoperiodicos.isVisible) {
            widgetNaoperiodicos.dataSourceFilter.forEach(function(filter){
                if (filter.name == 'P_NRTPAMBIENTE') {
                    filter.value = widgetEstruturas.currentRow.NRTPAMBIENTE;
                }
                if (filter.name == 'P_NRESTRUTURAM') {
                    filter.value = widgetEstruturas.currentRow.NRESTRUTURAM;
                }
            });
        }
        
        if (widgetSST.isVisible) {
            widgetSST.dataSourceFilter.forEach(function(filter){
                if (filter.name == 'P_NRTPAMBIENTE') {
                    filter.value = widgetEstruturas.currentRow.NRTPAMBIENTE;
                }
                if (filter.name == 'P_NRESTRUTURAM') {
                    filter.value = widgetEstruturas.currentRow.NRESTRUTURAM;
                }
            });
        }
    };
    
    this.setFilterWidgetPeriodicos = function() {
        var widgetEstruturas = this.getWidgetEstruturas();
        var widgetPeriodo = this.getWidgetPeriodo();
        var widgetPeriodicos = this.getWidgetPeriodicos();
        
        if (widgetPeriodo.isVisible) {
            widgetPeriodo.dataSourceFilter.forEach(function(filter){
                if (filter.name == 'P_NRESTRUTURAM') {
                    filter.value = widgetEstruturas.currentRow.NRESTRUTURAM;
                }
            });
        }

        if (widgetPeriodicos.isVisible) {
            widgetPeriodicos.dataSourceFilter.forEach(function(filter){
                if (filter.name == 'P_NRTPAMBIENTE') {
                    filter.value = widgetEstruturas.currentRow.NRTPAMBIENTE;
                }
                if (filter.name == 'P_NRESTRUTURAM') {
                    filter.value = widgetEstruturas.currentRow.NRESTRUTURAM;
                }
            });
        }
    };
    
    this.afterMoveCadastro = function() {
        var widget = this.getWidgetCadastros();
        
        if (widget.currentRow.NMEVENTO == 'S-1010') {
            widget.getField('DSEVENTO').class = 9;
            widget.getField('DSTABELA').isVisible = true;
        } else {
            widget.getField('DSEVENTO').class = 12;
            widget.getField('DSTABELA').isVisible = false;
        }
        
        this.setActionsEvento(widget);
        this.enableWidgetXml(widget);
    };
    
    this.afterMoveNaoPeriodico = function() {
        var widget = this.getWidgetNaoPeriodicos();
        
        if (widget.currentRow.NMEVENTO == 'S-2230') {
            widget.getField('DSEVENTO').class = 9;
            widget.getField('DSTABELA').isVisible = true;
        } else {
            widget.getField('DSEVENTO').class = 12;
            widget.getField('DSTABELA').isVisible = false;
        }
        
        this.setActionsEvento(widget);
        this.enableWidgetXml(widget);
    };
    
    this.afterMoveSST = function() {
        var widget = this.getWidgetSST();
        this.setActionsEvento(widget);
        this.enableWidgetXml(widget);
    };
    
    this.afterMovePeriodico = function() {
        var widget = this.getWidgetPeriodicos();
        
        this.setActionsEvento(widget);
        this.enableWidgetXml(widget);
    };
    
    this.setActionsEvento = function(widget) {
        var idxActEditar = null;
        var idxActTransmitir = null;
        var idxActEnviar = null;
        var idxActConsultar = null;
        var idxActReenviar = null;
        var idxActExcluir = null;
        var idxActExclusao = null;
        var idxActRetificar = null;
        var idxActDownload = null;
        
        widget.actions.forEach(function(action, index){
            if (action.name == 'editar') {
                idxActEditar = index;
            }else if (action.name == 'transmitir') {
                idxActTransmitir = index;
            }else if (action.name == 'enviar') {
                idxActEnviar = index;
            }else if (action.name == 'consultar') {
                idxActConsultar = index;
            }else if (action.name == 'reenvio') {
                idxActReenviar = index;
            }else if (action.name == 'excluir') {
                idxActExcluir = index;
            }else if (action.name == 'exclusao') {
                idxActExclusao = index;
            }else if (action.name == 'retificar') {
                idxActRetificar = index;
            }else if (action.name == 'downloadXML') {
                idxActDownload = index;
            }
        });
        
        if(!this.campoAtivoFiltroNaoEstaMarcado){
    
            if (widget.currentRow.NMEVENTO == 'S-1298' || widget.currentRow.NMEVENTO == 'S-1299') {
                //widget.actions[idxActEditar].isVisible = false;
                widget.actions[idxActTransmitir].isVisible = false;
                widget.actions[idxActEnviar].isVisible = false;
                widget.actions[idxActConsultar].isVisible = false;
                widget.actions[idxActReenviar].isVisible = false;
                widget.actions[idxActExcluir].isVisible = false;
                widget.actions[idxActExclusao].isVisible = false;
                widget.actions[idxActRetificar].isVisible = false;
                //widget.actions[idxActDownload].isVisible = false;
            } else {
                switch(widget.currentRow.IDSTATUS) {
                    case this.STATUS_PENDENTE:
                        //widget.actions[idxActEditar].isVisible = false;
                        widget.actions[idxActTransmitir].isVisible = true;
                        widget.actions[idxActEnviar].isVisible = true;
                        widget.actions[idxActConsultar].isVisible = false;
                        widget.actions[idxActReenviar].isVisible = false;
                        widget.actions[idxActExcluir].isVisible = true;
                        widget.actions[idxActExclusao].isVisible = false;
                        widget.actions[idxActRetificar].isVisible = false;
                        //widget.actions[idxActDownload].isVisible = false;
                        break;
                    case this.STATUS_ERROENVIO:
                        //widget.actions[idxActEditar].isVisible = false;
                        widget.actions[idxActTransmitir].isVisible = false;
                        widget.actions[idxActEnviar].isVisible = false;
                        widget.actions[idxActConsultar].isVisible = false;
                        widget.actions[idxActReenviar].isVisible = true;
                        widget.actions[idxActExcluir].isVisible = true;
                        widget.actions[idxActExclusao].isVisible = false;
                        widget.actions[idxActRetificar].isVisible = false;
                        //widget.actions[idxActDownload].isVisible = widget.currentRow.DSDIRXMLENV ? true : false;
                        break;
                    case this.STATUS_PENDPROCE:
                        //widget.actions[idxActEditar].isVisible = false;
                        widget.actions[idxActTransmitir].isVisible = false;
                        widget.actions[idxActEnviar].isVisible = false;
                        widget.actions[idxActConsultar].isVisible = true;
                        widget.actions[idxActReenviar].isVisible = (widget.currentRow.CDERRO == '301' || widget.currentRow.CDERRO == '69');
                        widget.actions[idxActExcluir].isVisible = false;
                        widget.actions[idxActExclusao].isVisible = false;
                        widget.actions[idxActRetificar].isVisible = false;
                        //widget.actions[idxActDownload].isVisible = widget.currentRow.DSDIRXMLENV ? true : false;
                        break;
                    case this.STATUS_ERROPROCE:
                        //widget.actions[idxActEditar].isVisible = true;
                        widget.actions[idxActTransmitir].isVisible = false;
                        widget.actions[idxActEnviar].isVisible = false;
                        widget.actions[idxActConsultar].isVisible = true;
                        widget.actions[idxActReenviar].isVisible = true;
                        widget.actions[idxActExcluir].isVisible = true;
                        widget.actions[idxActExclusao].isVisible = false;
                        widget.actions[idxActRetificar].isVisible = false;
                        //widget.actions[idxActDownload].isVisible = widget.currentRow.DSDIRXMLENV ? true : false;
                        break;
                    case this.STATUS_CONCLUIDO:
                    case this.STATUS_CONCADVER:
                        //widget.actions[idxActEditar].isVisible = false;
                        widget.actions[idxActTransmitir].isVisible = false;
                        widget.actions[idxActEnviar].isVisible = false;
                        widget.actions[idxActConsultar].isVisible = false;
                        widget.actions[idxActReenviar].isVisible = false;
                        widget.actions[idxActExcluir].isVisible = false;
                        widget.actions[idxActExclusao].isVisible = ((widget.name == 'cadastros' && widget.currentRow.NMEVENTO != 'S-1000') || (Util.isNull(widget.currentRow.NRENVIOEXCL) && widget.currentRow.NMEVENTO != 'S-3000'));
                        widget.actions[idxActRetificar].isVisible = (Util.isNull(widget.currentRow.NRENVIOEXCL) && 
                                                                    (widget.currentRow.IDOPERACAO != 'R' || (widget.currentRow.IDOPERACAO == 'R' && (widget.currentRow.IDSTATUS == this.STATUS_CONCLUIDO || widget.currentRow.IDSTATUS == this.STATUS_CONCADVER))) && 
                                                                    (widget.currentRow.NMEVENTO != 'S-3000'));
                        //widget.actions[idxActDownload].isVisible = widget.currentRow.DSDIRXMLENV ? true : false;
                        break;
                    default:
                        //widget.actions[idxActEditar].isVisible = false;
                        widget.actions[idxActTransmitir].isVisible = false;
                        widget.actions[idxActEnviar].isVisible = false;
                        widget.actions[idxActConsultar].isVisible = false;
                        widget.actions[idxActReenviar].isVisible = false;
                        widget.actions[idxActExcluir].isVisible = true;
                        widget.actions[idxActExclusao].isVisible = false;
                        widget.actions[idxActRetificar].isVisible = false;
                        //widget.actions[idxActDownload].isVisible = false;
                        break;
                }
            }
        }
    };
    
    this.enableWidgetXml = function(widget) {
        var idxTabDadosEnv = null;
        var idxTabRespEnv = null;
        var idxTabRespPro = null;
        var idxTabRespTot = null;
        
        widget.widgets.forEach(function(widget, index){
            if (widget.name == 'dadosEnv') {
                idxTabDadosEnv = index;
            }
            if (widget.name == 'retEnvio') {
                idxTabRespEnv = index;
            }
            if (widget.name == 'retProces') {
                idxTabRespPro = index;
            }
            if (widget.name == 'retTotal') {
                idxTabRespTot = index;
            }
        });
        
        widget.widgets[idxTabDadosEnv].isVisible = !Util.isUndefinedOrNull(widget.currentRow.DSDIRXMLENV);
        widget.widgets[idxTabRespEnv].isVisible = !Util.isUndefinedOrNull(widget.currentRow.DSDIRXMLRETENV);
        widget.widgets[idxTabRespPro].isVisible = !Util.isUndefinedOrNull(widget.currentRow.DSDIRXMLRETPRO);
        if (idxTabRespTot != null) {
            widget.widgets[idxTabRespTot].isVisible = !Util.isUndefinedOrNull(widget.currentRow.DSDIRXMLRETTOT);
        }
    };

    this.onChangeNovoEventoCad = function() {
        var widgetFilter = this.getWidgetNovoEventoCadastro();

        if (widgetFilter.currentRow.NMEVENTO == 'S-1005') {
            widgetFilter.getField('NRESTRUTESTAB').isVisible = true;
            widgetFilter.getField('NRESTRUTTOMAD').isVisible = false;
            widgetFilter.getField('NREVENTOM').isVisible = false;
        } else if (widgetFilter.currentRow.NMEVENTO == 'S-1010') {
            widgetFilter.getField('NRESTRUTESTAB').isVisible = false;
            widgetFilter.getField('NRESTRUTTOMAD').isVisible = false;
            widgetFilter.getField('NREVENTOM').isVisible = true;
        } else if (widgetFilter.currentRow.NMEVENTO == 'S-1020') {
            widgetFilter.getField('NRESTRUTESTAB').isVisible = false;
            widgetFilter.getField('NRESTRUTTOMAD').isVisible = true;
            widgetFilter.getField('NREVENTOM').isVisible = false;
        } else {
            widgetFilter.getField('NRESTRUTESTAB').isVisible = false;
            widgetFilter.getField('NRESTRUTTOMAD').isVisible = false;
            widgetFilter.getField('NREVENTOM').isVisible = false;
        }
    };

    this.onChangeNovoEventoNaoPer = function() {
        var widgetFilter = this.getWidgetNovoEventoNaoPeriodico();

        if (widgetFilter.currentRow.NMEVENTO == 'S-2190') {
            widgetFilter.getField('NRPESSOAPRE').isVisible = true;
            widgetFilter.getField('NRVINCULOM').isVisible = false;
        } else {
            widgetFilter.getField('NRPESSOAPRE').isVisible = false;
            widgetFilter.getField('NRVINCULOM').isVisible = true;
        }
    };
    
    this.novoEventoCadastro = function() {
        var widgetEstruturas = this.getWidgetEstruturas();
        var widgetFilter = this.getWidgetNovoEventoCadastro();

        widgetFilter.getField('NMEVENTO').dataSourceFilter.forEach(function(filter, index){
            if (filter.name == 'DSVERSAO') {
                filter.value = widgetEstruturas.currentRow.DSVERSAO;
            }
        });
        widgetFilter.getField('NMEVENTO').reload();

        ABUtilController.masterDetailOpenPopup(widgetFilter);
    };
    
    this.setNovoEventoCadastro = function() {
        var widgetFilter = this.getWidgetNovoEventoCadastro();
        var widgetEnvios = this.getWidgetCadastros();
        
        this.setEvento(widgetFilter,widgetEnvios,'/setEsocadastro');
    };

    this.deleteEsocadastro = function(args) {
        this.deleteEvento(this.getWidgetCadastros(),'/deleteEsocadastro');
    };
    
    this.novoEventoNaoPeriodico = function() {
        var widgetEstruturas = this.getWidgetEstruturas();
        var widgetFilter = this.getWidgetNovoEventoNaoPeriodico();

        widgetFilter.getField('NMEVENTO').dataSourceFilter.forEach(function(filter, index){
            if (filter.name == 'DSVERSAO') {
                filter.value = widgetEstruturas.currentRow.DSVERSAO;
            }
        });
        widgetFilter.getField('NMEVENTO').reload();

        ABUtilController.masterDetailOpenPopup(widgetFilter);
    };
    
    this.setNovoEventoNaoPeriodico = function() {
        var widgetFilter = this.getWidgetNovoEventoNaoPeriodico();
        var widgetEnvios = this.getWidgetNaoPeriodicos();
        
        this.setEvento(widgetFilter,widgetEnvios,'/setEsonaoperiodico');
    };

    this.deleteEsonaoperiodico = function(args) {
        this.deleteEvento(this.getWidgetNaoPeriodicos(),'/deleteEsonaoperiodico');
    };
    
    this.novoEventoSST = function() {
        var widgetEstruturas = this.getWidgetEstruturas();
        var widgetFilter = this.getWidgetNovoEventoSST();

        widgetFilter.getField('NMEVENTO').dataSourceFilter.forEach(function(filter, index){
            if (filter.name == 'DSVERSAO') {
                filter.value = widgetEstruturas.currentRow.DSVERSAO;
            }
        });
        widgetFilter.getField('NMEVENTO').reload();

        ABUtilController.masterDetailOpenPopup(widgetFilter);
    };
    
    this.setNovoEventoSST = function() {
        var widgetFilter = this.getWidgetNovoEventoSST();
        var widgetEnvios = this.getWidgetSST();
        
        this.setEvento(widgetFilter,widgetEnvios,'/setEsonaoperiodico');
    };

    this.deleteEsoSST = function(args) {
        this.deleteEvento(this.getWidgetSST(),'/deleteEsonaoperiodico');
    };

    this.loadEsoPeriodico = function() {
        var widgetPeriodo = this.getWidgetPeriodo();
        var widgetPeriodico = this.getWidgetPeriodicos();

        if (widgetPeriodo.currentRow.IDPERIODO == 'F') {
            widgetPeriodo.getField('FECHAMENTO').readOnly = true;
            widgetPeriodo.getField('REABERTURA').readOnly = false;
        } else {
            widgetPeriodo.getField('FECHAMENTO').readOnly = false;
            widgetPeriodo.getField('REABERTURA').readOnly = true;
        }

        widgetPeriodico.dataSourceFilter.forEach(function(filter, index){
            if (filter.name == 'P_DTMESCOMPETENC') {
                filter.value = widgetPeriodo.currentRow.DTMESCOMPETENC;
            }
            if (filter.name == 'NRTABELA') {
                filter.value = widgetPeriodo.currentRow.NRTABELA;
            }
        });

        widgetPeriodico.reload();
    };

    this.afterLoadEsoPeriodico = function() {
        var widgetPeriodo = this.getWidgetPeriodo();
        var widgetPeriodico = this.getWidgetPeriodicos();

        widgetPeriodo.getField('PERIODO').setValue(widgetPeriodo.dataSource.data[0].PERIODO);
        widgetPeriodo.getField('IDPERIODO').setValue(widgetPeriodo.dataSource.data[0].IDPERIODO);
        widgetPeriodo.getField('NRTABELA').setValue(widgetPeriodo.dataSource.data[0].NRTABELA);

        if (widgetPeriodo.dataSource.data[0].IDPERIODO == 'F') {
            widgetPeriodo.getField('FECHAMENTO').readOnly = true;
            widgetPeriodo.getField('REABERTURA').readOnly = false;
        } else {
            widgetPeriodo.getField('FECHAMENTO').readOnly = false;
            widgetPeriodo.getField('REABERTURA').readOnly = true;
        }

        widgetPeriodico.dataSourceFilter.forEach(function(filter){
            if (filter.name == 'NRTABELA') {
                filter.value = widgetPeriodo.dataSource.data[0].NRTABELA;
            }
        });

        widgetPeriodico.reload();
    };
    
    this.novoEventoPeriodico = function() {
        var widgetEstruturas = this.getWidgetEstruturas();
        var widgetFilter = this.getWidgetNovoEventoPeriodico();

        widgetFilter.getField('NMEVENTO').dataSourceFilter.forEach(function(filter, index){
            if (filter.name == 'DSVERSAO') {
                filter.value = widgetEstruturas.currentRow.DSVERSAO;
            }
        });
        widgetFilter.getField('NMEVENTO').reload();

        ABUtilController.masterDetailOpenPopup(widgetFilter);
    };
    
    this.setNovoEventoPeriodico = function() {
        var widgetFilter = this.getWidgetNovoEventoPeriodico();
        var widgetEnvios = this.getWidgetPeriodicos();
        
        this.setEvento(widgetFilter,widgetEnvios,'/setEsoperiodico');
    };

    this.deleteEsoperiodico = function(args) {
        this.deleteEvento(this.getWidgetPeriodicos(),'/deleteEsoperiodico');
    };
    
    this.setEvento = function(widgetFilter, widgetEnvios, route) {
        if (widgetFilter.isValid()) {
            if (!widgetFilter.backupRow) {
                widgetFilter.currentRow.__is_new = true;
            } else {
                widgetFilter.currentRow.__is_new = false;
            }
            
            var widgetEstruturas = this.getWidgetEstruturas();
            
            widgetFilter.currentRow.NRESTRUTURAM = widgetEstruturas.currentRow.NRESTRUTURAM;
            widgetFilter.currentRow.CDCNPJEMPREGADOR = widgetEstruturas.currentRow.CDCNPJESTRUT;
            widgetFilter.currentRow.DSVERSAO = widgetEstruturas.currentRow.DSVERSAO;
            widgetFilter.currentRow.NRTPAMBIENTE = widgetEstruturas.currentRow.NRTPAMBIENTE;
            
            restEngine.post(route, {'requestType': 'DataSet', 'dataset': [widgetFilter.currentRow]}).
                then(function (data) {
                    var existeMensagemTradada;
                    if (!Util.isUndefined(data.notifications) && data.notifications[0].type === "success") {
                        ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                        if (widgetFilter.currentRow.__is_new) {
                            if(data.messages){
                                data.messages.forEach(function(msg){
                                    existeMensagemTradada = this.validaSeMensagemExiste(msg.message);
                                    if (existeMensagemTradada) {
                                        msg.message = this.substituiNomesMensagens(existeMensagemTradada, msg.message);
                                    }
                                    ScreenService.alertNotification(Util.isUndefined(Messages[msg.message]) ? msg.message : Messages[msg.message], 10000);
                                }.bind(this));
                            }
                            ScreenService.closePopup(true);
                            widgetEnvios.reload();
                        } else {
                            ScreenService.closePopup(true);
                                
                            widgetFilter.backupRow = null;
                            widgetFilter.view();
                        }
                    } else if (!Util.isUndefined(data.messages)) {
                        data.messages.forEach(function(msg){
                            existeMensagemTradada = this.validaSeMensagemExiste(msg.message);
                            if (existeMensagemTradada) {
                                msg.message = this.substituiNomesMensagens(existeMensagemTradada, msg.message);
                            }
                            ScreenService.alertNotification(Util.isUndefined(Messages[msg.message]) ? msg.message : Messages[msg.message], 10000);
                        }.bind(this));
                    } else {
                        ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                    }
                }.bind(this)).
                catch(function(e) {
                    var error;
                    if(Util.isUndefined(e.data) && Util.isUndefined(e.data.error) && Util.isUndefined(e.message))
                        error = e;
                    else if(!Util.isUndefined(e.message))
                        error = e.message;
                    else
                        error = e.data.error;
                    ScreenService.showMessage(Util.isUndefined(Messages[error]) ? error : Messages[error], 'ERROR');
                });
            
        }
    };

    this.isEnviosRowDeletable = function(row) {
        return (row.IDSTATUS == self.STATUS_PENDENTE || row.IDSTATUS == self.STATUS_ERROENVIO || row.IDSTATUS == self.STATUS_ERROPROCE || Util.isEmptyOrBlank(row.NRPROTOCOLO));
    };

    this.deleteEvento = function(widget, route) {
        var erroExcl = false;
        
        if (widget.dataSource.getCheckedRows().length > 0) {
            widget.dataSource.getCheckedRows().forEach(function(row) {
                row.__is_new = false;
                row.__rightActions = [];
                if (!self.isEnviosRowDeletable(row)) {
                    erroExcl = true;
                }
            });
        } else {
            widget.currentRow.__is_new = false;
            widget.currentRow.__rightActions = [];
            if (!self.isEnviosRowDeletable(widget.currentRow)) {
                erroExcl = true;
            }
        }
        
        if (erroExcl) {
            ScreenService.showMessage(Messages.HCM09000_ESO_EXCLUSAO_ERROR, 'ERROR');
        } else {
            ScreenService.confirmMessage('Deseja realmente excluir o(s) registro(s)?', 'CONFIRMATION',
                function(){
                    var dataSet = [];
                    var idOnlyOne = true;
                    
                    if (widget.dataSource.getCheckedRows().length > 0) {
                        dataSet = widget.dataSource.getCheckedRows();
                        idOnlyOne = false;
                    } else {
                        dataSet = [widget.currentRow];
                    }
                    
                    restEngine.post(route, {'requestType':'DataSet','dataset':dataSet}).
                        then(function(data){
                            if(data.notifications[0].type === "success"){
                                ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                                ABUtilController.blockCheckbox(widget.id, false);
                                if (idOnlyOne) {
                                    ABUtilController.masterDetailVoltarList(widget);
                                }
                                widget.reload();
                            } else {
                                ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                            }
                        }).
                        catch(function(e) {
                            var error;
                            if(e.data.error === undefined)
                                error = e;
                            else
                                error = e.data.error;
                            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                        });
                }.bind(this),
                function(){
                    //nothing to do
                }
            );
        }
    };
    
    this.exclusaoEmpregador = function() {
        var widget = this.getWidgetEstruturas();
        ScreenService.confirmMessage('Será realizada a exclusão de todos envios do empregador na base de dados do e-Social, inclusive o evento S-1000. Deseja continuar?', 'CONFIRMATION',
                function(){
                    restEngine.post('/exclusaoEmpregador', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                        then(function (data) {
                            if(!Util.isUndefined(data.notifications) && data.notifications[0].type === "success"){
                                this.getWidgetCadastros.activate();
                                this.getWidgetCadastros.reload();
                                ScreenService.closePopup();
                            }
                            if (!Util.isUndefined(data.messages)) {
                                ScreenService.showMessage(Util.isUndefined(Messages[data.messages[0].message]) ? data.messages[0].message : Messages[data.messages[0].message], data.messages[0].type);
                                if (data.messages[0].type == 'W') {
                                    this.getWidgetCadastros.activate();
                                    this.getWidgetCadastros.reload();
                                    ScreenService.closePopup();
                                }
                            } else {
                                ScreenService.showMessage(Messages.PROCESSO_ERROR);
                            }
                        }).
                        catch(function(e) {
                            var error;
                            if(Util.isUndefined(e.data) && Util.isUndefined(e.data.error) && Util.isUndefined(e.message))
                                error = e;
                            else if(!Util.isUndefined(e.message))
                                error = e.message;
                            else
                                error = e.data.error;
                            ScreenService.showMessage(Util.isUndefined(Messages[error]) ? error : Messages[error], 'ERROR');
                        });
                }.bind(this),
                function(){
                    //nothing to do
                }
        );
    };
    
    /*----- Transmissões -----*/
    this.validaTransmitirEventoCadastro = function() {
        var widget = this.getWidgetCadastros();
        this.validaTransmitirEvento(widget,'enviarEventoCadastro','consultarProtocoloCadastro');
    };
    
    this.validaTransmitirEventoNaoPeriodico = function() {
        var widget = this.getWidgetNaoPeriodicos();
        this.validaTransmitirEvento(widget,'enviarEventoNaoPeriodico','consultarProtocoloNaoPeriodico');
    };
    
    this.validaTransmitirEventoSST = function() {
        var widget = this.getWidgetSST();
        this.validaTransmitirEvento(widget,'enviarEventoNaoPeriodico','consultarProtocoloNaoPeriodico');
    };
    
    this.validaTransmitirEventoPeriodico = function() {
        var widget = this.getWidgetPeriodicos();
        this.validaTransmitirEvento(widget,'enviarEventoPeriodico','consultarProtocoloPeriodico');
    };
    
    this.validaTransmitirEvento = function(widget, actionEnviar, actionConsultar) {
        if (widget.currentRow.IDATIVO != 'N' && !widget.currentRow.NRENVIOEXCL) {
            switch (widget.currentRow.IDSTATUS) {
                case 'P':
                case 'E':
                case 'R':
                    this.validaEnviarEvento(widget, actionEnviar);
                    break;
                case 'M':
                    this.consultarProtocolo(widget, actionConsultar);
                    break;
                case 'C':
                case 'A':
                    ScreenService.showMessage('O evento já está concluído', 'ERROR');
                    break;
            }
        }
    };
    
    this.validaEnviarEventoCadastro = function() {
        var widget = this.getWidgetCadastros();
        this.validaEnviarEvento(widget, 'enviarEventoCadastro');
    };
    
    this.validaEnviarEventoNaoPeriodico = function() {
        var widget = this.getWidgetNaoPeriodicos();
        this.validaEnviarEvento(widget, 'enviarEventoNaoPeriodico');
    };
    
    this.validaEnviarEventoSST = function() {
        var widget = this.getWidgetSST();
        this.validaEnviarEvento(widget, 'enviarEventoNaoPeriodico');
    };
    
    this.validaEnviarEventoPeriodico = function() {
        var widget = this.getWidgetPeriodicos();
        this.validaEnviarEvento(widget, 'enviarEventoPeriodico');
    };
    
    this.validaEnviarEvento = function(widget, action) {
        ScreenService.confirmMessage('Deseja realmente enviar o evento para o ambiente de ' + (widget.currentRow.NRTPAMBIENTE == 1 ? 'Produção' : 'Produção Restrita') + ' ?', 'CONFIRMATION',
                function(){
                    widget.currentRow.__rightActions = [];
                    if(this.seDataAtualMaiorDataEnvioESocial()){
                        //Apenas após clicar em 'Ok' que o processo é realizado
                        //Esquema de aviso construída devido à sobreposição de avisos do framework
                        ScreenService.showCustomDialog(Messages.AVISO_ESO_PENSALIDADE_PROCESSO_TRANSMISSAO, 'CONFIRMATION', null, [
                            {
                                label: ScreenService.i18n("Ok"),
                                code: function (e, deferred) { 
                                    this.enviarEvento(action);
                                    deferred.resolve(e);
                                }.bind(this)
                            }
                        ]);
                    } else {
                        //Caso o aviso não seja mostrado, o processo é realizado normalmente
                        this.enviarEvento(action);
                    }
                }.bind(this),
                function(){
                    //nothing to do
                }
            );
    };
    
    this.validaEnviarEventoNaoPeriodicoPendente = function() {
        var widget = this.getWidgetNaoPeriodicosPendentes();
        ScreenService.confirmMessage('Deseja realmente enviar o evento para o ambiente de ' + (widget.currentRow.NRTPAMBIENTE == 1 ? 'Produção' : 'Produção Restrita') + ' ?', 'CONFIRMATION',
                function(){
                    widget.currentRow.__rightActions = [];
                    widget.currentRow.VERIFICAPENDENTES = false;
                    restEngine.post('/enviarEventoNaoPeriodico', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                        then(function (data) {
                            // tratativa padrão do retorno do envio 
                            if (!Util.isUndefined(data.dataset)) {
                                if (!Util.isUndefined(data.dataset.enviarEventoNaoPeriodico) && data.dataset.enviarEventoNaoPeriodico.length >= 1) {
                                    var popUp = this.getWidgetMensagens();
                                    popUp.widgetActive = widget;
                                    popUp.getField('NRCHAVE').isVisible = true;
                                    popUp.dataSource.data = data.dataset.enviarEventoNaoPeriodico;
                                    ABUtilController.masterDetailOpenPopup(popUp);
                                    popUp.getField('NMEVENTO').isVisible = true;
                                } 
                            } else if (!Util.isUndefined(data.messages)) {
                                var definedMessage = data.messages[0];
                                ScreenService.showMessage(Util.isUndefined(Messages[definedMessage.message]) ? definedMessage.message : Messages[definedMessage.message], definedMessage.type);
                                if (definedMessage.type == 'M') {
                                    var filtro = [
                                        {
                                            "name": "P_NRORG",
                                            "operator": "=",
                                            "value": getLocalVar('HCM_NRORG_TRAB')
                                        },
                                        {
                                            "name": "P_NRORG_PADRAO",
                                            "operator": "=",
                                            "value": getLocalVar('HCM_NRORG_PADRAO')
                                        },
                                        {
                                            "name": "P_DTMESCOMPETENC",
                                            "operator": "=",
                                            "value": getLocalVar('HCM_DTCOMPETENCIA_OPER')
                                        },
                                        {
                                            "name": "P_NRESTRUTURAM",
                                            "operator": "=",
                                            "value": widget.currentRow.NRESTRUTURAM
                                        },
                                        {
                                            "name": "P_NRTPAMBIENTE",
                                            "operator": "=",
                                            "value": widget.currentRow.NRTPAMBIENTE
                                        },
                                        {
                                            "name": "NRENVIO",
                                            "operator": "=",
                                            "value": widget.currentRow.NRENVIO
                                        }
                                    ];
                                    restEngine.post("product#/getEsonaoperiodico", {requestType: "FilterData", filter: filtro}).
                                        then(function (data) {
                                            if(!!data.dataset.getEsonaoperiodico.length){
                                                var eventos = data.dataset.getEsonaoperiodico;
                                                eventos.forEach(function(obj){
                                                    if(widget.dataSource.data.findIndex(envio => envio.NRENVIO == obj.NRENVIO) == -1){
                                                        widget.dataSource.data[widget.dataSource.data.findIndex(envio => envio.NRENVIO == obj.NRENVIO)].IDSTATUS = obj.IDSTATUS;
                                                    }
                                                });
                                            }
                                        });
                                }
                            } else {
                                ScreenService.showMessage(Messages.PROCESSO_ERROR);
                            }
                        }.bind(this)).
                        catch(function(e) {
                            var error;
                            if(Util.isUndefined(e.data) && Util.isUndefined(e.data.error) && Util.isUndefined(e.message))
                                error = e;
                            else if(!Util.isUndefined(e.message))
                                error = e.message;
                            else
                                error = e.data.error;
                            ScreenService.showMessage(Util.isUndefined(Messages[error]) ? Messages.CATCH_EXCEPTION_ERROR(error) : Messages[error], 'ERROR');
                        });
                }.bind(this),
                function(){
                    //nothing to do
                }
            );
    };
    
    this.ignorarNaoPeriodicosPendentes = function() {
        var widgetPendentes = this.getWidgetNaoPeriodicosPendentes();
        var widgetNaoPeriodicos = this.getWidgetNaoPeriodicos();
        
        ScreenService.closePopup(widgetPendentes);
        widgetPendentes.deactivate();
        widgetNaoPeriodicos.activate();
        widgetNaoPeriodicos.currentRow.VERIFICAPENDENTES = false;
        this.enviarEvento('enviarEventoNaoPeriodico');
    };
    
    this.enviarEvento = function(action) {
        var widget = templateManager.container.getActiveWidget();

        restEngine.post('/'+action, {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
            then(function (data) {
                // tratativa padrão do retorno do envio 
                if (!Util.isUndefined(data.dataset)) {
                    if (!Util.isUndefined(data.dataset.eventosPendentes) && data.dataset.eventosPendentes.length >= 1) {
                        var popUpPendentes = this.getWidgetNaoPeriodicosPendentes();
                        popUpPendentes.widgetActive = widget;
                        popUpPendentes.dataSource.data = data.dataset.eventosPendentes;
                        ABUtilController.masterDetailOpenPopup(popUpPendentes);
                    }
                    else if (!Util.isUndefined(data.dataset[action]) && data.dataset[action].length >= 1) {
                        var popUp = this.getWidgetMensagens();
                        popUp.widgetActive = widget;
                        popUp.getField('NRCHAVE').isVisible = true;
                        popUp.dataSource.data = data.dataset[action];
                        ABUtilController.masterDetailOpenPopup(popUp);
                        popUp.getField('NMEVENTO').isVisible = true;
                    } 
                } else if (!Util.isUndefined(data.messages)) {
                    var definedMessage = data.messages[0];
                    ScreenService.showMessage(Util.isUndefined(Messages[definedMessage.message]) ? definedMessage.message : Messages[definedMessage.message], definedMessage.type);
                    if (definedMessage.type == 'M') {
                        ScreenService.closePopup(true);
                        if (!widget.inListMode()) {
                            ABUtilController.masterDetailVoltarList(widget);
                        }
                        widget.reload();
                    }
                    ABUtilController.blockCheckbox(widget.id, false);
                } else {
                    ScreenService.showMessage(Messages.PROCESSO_ERROR);
                }
            }.bind(this)).
            catch(function(e) {
                var error;
                if(Util.isUndefined(e.data) && Util.isUndefined(e.data.error) && Util.isUndefined(e.message))
                    error = e;
                else if(!Util.isUndefined(e.message))
                    error = e.message;
                else
                    error = e.data.error;
                ScreenService.showMessage(Util.isUndefined(Messages[error]) ? Messages.CATCH_EXCEPTION_ERROR(error) : Messages[error], 'ERROR');
            });
    };
    
    this.consultarProtocoloCadastro = function() {
        var widget = this.getWidgetCadastros();
        this.consultarProtocolo(widget, 'consultarProtocoloCadastro');
    };
    
    this.consultarProtocoloNaoPeriodico = function() {
        var widget = this.getWidgetNaoPeriodicos();
        this.consultarProtocolo(widget, 'consultarProtocoloNaoPeriodico');
    };
    
    this.consultarProtocoloSST = function() {
        var widget = this.getWidgetSST();
        this.consultarProtocolo(widget, 'consultarProtocoloNaoPeriodico');
    };
    
    this.consultarProtocoloPeriodico = function() {
        var widget = this.getWidgetPeriodicos();
        this.consultarProtocolo(widget, 'consultarProtocoloPeriodico');
    };
    
    this.consultarProtocolo = function(widget, action) {
        
        widget.currentRow.__rightActions = [];
        
        restEngine.post('/'+action, {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
            then(function (data) {
                // tratativa padrão do retorno do envio 
                if (!Util.isUndefined(data.dataset)) {
                    if (!Util.isUndefined(data.dataset[action]) && data.dataset[action].length >= 1) {
                        var popUp = this.getWidgetMensagens();
                        popUp.widgetActive = widget;
                        popUp.getField('NRCHAVE').isVisible = true;
                        popUp.dataSource.data = data.dataset[action];
                        ABUtilController.masterDetailOpenPopup(popUp);
                        popUp.getField('NMEVENTO').isVisible = true;
                    } 
                } else if (!Util.isUndefined(data.messages)) {
                    var definedMessage = data.messages[0];
                    ScreenService.showMessage(Util.isUndefined(Messages[definedMessage.message]) ? definedMessage.message : Messages[definedMessage.message], definedMessage.type);
                    if (definedMessage.type == 'M') {
                        ScreenService.closePopup(true);
                        if (!widget.inListMode()) {
                            ABUtilController.masterDetailVoltarList(widget);
                        }
                        widget.reload();
                    }
                    ABUtilController.blockCheckbox(widget.id, false);
                } else {
                    ScreenService.showMessage(Messages.PROCESSO_ERROR);
                }
            }.bind(this)).
            catch(function(e) {
                var error;
                if(Util.isUndefined(e.data) && Util.isUndefined(e.data.error) && Util.isUndefined(e.message))
                    error = e;
                else if(!Util.isUndefined(e.message))
                    error = e.message;
                else
                    error = e.data.error;
                ScreenService.showMessage(Util.isUndefined(Messages[error]) ? Messages.CATCH_EXCEPTION_ERROR(error) : Messages[error], 'ERROR');
            });
    };
    
    this.retificarEventoCadastro = function() {
        var widget = this.getWidgetCadastros();
        this.retificarEvento(widget, 'retificarEventoCadastro');
    };
    
    this.retificarEventoNaoPeriodico = function() {
        var widget = this.getWidgetNaoPeriodicos();
        this.retificarEvento(widget, 'retificarEventoNaoPeriodico');
    };
    
    this.retificarEventoSST = function() {
        var widget = this.getWidgetSST();
        this.retificarEvento(widget, 'retificarEventoNaoPeriodico');
    };
    
    this.retificarEventoPeriodico = function() {
        var widget = this.getWidgetPeriodicos();
        this.retificarEvento(widget, 'retificarEventoPeriodico');
    };

    this.retificarEvento = function(widget, action) {
        var message = '';
        
        if (widget.isValid()) {
            message = 'Será incluído um envio de retificação para o mesmo evento e chave selecionados e realizado sua transmissão automatica. Deseja continuar?';
            ScreenService.confirmMessage(message, 'CONFIRMATION',
                function(){
                    widget.currentRow.__rightActions = [];
                    restEngine.post('/'+action, {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                        then(function (data) {
                            // tratativa padrão do retorno do envio 
                            if (!Util.isUndefined(data.dataset)) {
                                if (!Util.isUndefined(data.dataset[action]) && data.dataset[action].length >= 1) {
                                    var popUp = this.getWidgetMensagens();
                                    popUp.widgetActive = widget;
                                    popUp.getField('NRCHAVE').isVisible = true;
                                    popUp.dataSource.data = data.dataset[action];
                                    ABUtilController.masterDetailOpenPopup(popUp);
                                    popUp.getField('NMEVENTO').isVisible = true;
                                } 
                            } else if (!Util.isUndefined(data.messages)) {
                                var definedMessage = data.messages[0];
                                ScreenService.showMessage(Util.isUndefined(Messages[definedMessage.message]) ? definedMessage.message : Messages[definedMessage.message], definedMessage.type);
                                if (definedMessage.type == 'M') {
                                    ScreenService.closePopup(true);
                                    if (!widget.inListMode()) {
                                        ABUtilController.masterDetailVoltarList(widget);
                                    }
                                    widget.reload();
                                }
                                ABUtilController.blockCheckbox(widget.id, false);
                            } else {
                                ScreenService.showMessage(Messages.PROCESSO_ERROR);
                            }
                        }.bind(this)).
                        catch(function(e) {
                            var error;
                            if(Util.isUndefined(e.data) && Util.isUndefined(e.data.error) && Util.isUndefined(e.message))
                                error = e;
                            else if(!Util.isUndefined(e.message))
                                error = e.message;
                            else
                                error = e.data.error;
                            ScreenService.showMessage(Util.isUndefined(Messages[error]) ? Messages.CATCH_EXCEPTION_ERROR(error) : Messages[error], 'ERROR');
                        });
                }.bind(this),
                function(){
                    //nothing to do
                }
            );
        }
    };
    
    this.excluirEventoCadastro = function() {
        var widget = this.getWidgetCadastros();
        this.excluirEvento(widget, 'excluirEventoCadastro');
    };
    
    this.excluirEventoNaoPeriodico = function() {
        var widget = this.getWidgetNaoPeriodicos();
        this.excluirEvento(widget, 'excluirEventoNaoPeriodico');
    };
    
    this.excluirEventoSST = function() {
        var widget = this.getWidgetSST();
        this.excluirEvento(widget, 'excluirEventoNaoPeriodico');
    };
    
    this.excluirEventoPeriodico = function() {
        var widget = this.getWidgetPeriodicos();
        this.excluirEvento(widget, 'excluirEventoPeriodico');
    };

    this.excluirEvento = function(widget, action) {
        var message = '';
        
        if (widget.isValid()) {
            if (action == 'excluirEventoCadastro') {
                message = 'Será incluído outro evento de mesmo nome para exclusão do cadastro da base de ' + (widget.currentRow.NRTPAMBIENTE == 1 ? 'Produção' : 'Produção Restrita') + ' do eSocial. Deseja continuar?';
            } else {
                message = 'Será incluído um S-3000 relacionado e realizada exclusão do evento da base de ' + (widget.currentRow.NRTPAMBIENTE == 1 ? 'Produção' : 'Produção Restrita') + ' do eSocial. Deseja continuar?';
            }
            ScreenService.confirmMessage(message, 'CONFIRMATION',
                function(){
                    widget.currentRow.__rightActions = [];
                    restEngine.post('/'+action, {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                        then(function (data) {
                            // tratativa padrão do retorno do envio 
                            if (!Util.isUndefined(data.dataset)) {
                                if (!Util.isUndefined(data.dataset.action) && data.dataset.action.length >= 1) {
                                    var popUp = this.getWidgetMensagens();
                                    popUp.widgetActive = widget;
                                    popUp.getField('NRCHAVE').isVisible = true;
                                    popUp.dataSource.data = data.dataset.action;
                                    ABUtilController.masterDetailOpenPopup(popUp);
                                    popUp.getField('NMEVENTO').isVisible = true;
                                } 
                            } else if (!Util.isUndefined(data.messages)) {
                                var definedMessage = data.messages[0];
                                ScreenService.showMessage(Util.isUndefined(Messages[definedMessage.message]) ? definedMessage.message : Messages[definedMessage.message], definedMessage.type);
                                if (definedMessage.type == 'M') {
                                    ScreenService.closePopup(true);
                                    if (!widget.inListMode()) {
                                        ABUtilController.masterDetailVoltarList(widget);
                                    }
                                    widget.reload();
                                }
                                ABUtilController.blockCheckbox(widget.id, false);
                            } else {
                                ScreenService.showMessage(Messages.PROCESSO_ERROR);
                            }
                        }.bind(this)).
                        catch(function(e) {
                            var error;
                            if(Util.isUndefined(e.data) && Util.isUndefined(e.data.error) && Util.isUndefined(e.message))
                                error = e;
                            else if(!Util.isUndefined(e.message))
                                error = e.message;
                            else
                                error = e.data.error;
                            ScreenService.showMessage(Util.isUndefined(Messages[error]) ? Messages.CATCH_EXCEPTION_ERROR(error) : Messages[error], 'ERROR');
                        });
                }.bind(this),
                function(){
                    //nothing to do
                }
            );
        }
    };
    
    /*----- Transmissões Automáticas -----*/
    this.openEnvioAutomaticoCadastro = function() {
        this.openEnvioAutomatico(this.getWidgetEnvioAutomaticoCadastro());
    };
    
    this.openEnvioAutomaticoNaoPeriodico = function() {
        this.openEnvioAutomatico(this.getWidgetEnvioAutomaticoNaoPeriodico());
    };
    
    this.openEnvioAutomaticoSST = function() {
        this.openEnvioAutomatico(this.getWidgetEnvioAutomaticoSST());
    };
    
    this.openEnvioAutomaticoPeriodico = function() {
        this.openEnvioAutomatico(this.getWidgetEnvioAutomaticoPeriodico());
    };
    
    this.openEnvioAutomatico = function(widgetFilter) {
        var widgetEstrutura = templateManager.container.getWidget('estruturas');
        
        widgetFilter.currentRow.NRESTRUTURAM = widgetEstrutura.currentRow.NRESTRUTURAM;
        widgetFilter.currentRow.DSVERSAO = widgetEstrutura.currentRow.DSVERSAO;
        widgetFilter.currentRow.NRTPAMBIENTE = widgetEstrutura.currentRow.NRTPAMBIENTE;
        widgetFilter.currentRow.IDSTATUS = [this.STATUS_PENDENTE, this.STATUS_ERROENVIO, this.STATUS_ERROPROCE];
        widgetFilter.getField('NMEVENTO').dataSourceFilter.forEach(function(filter){
            if (filter.name == 'DSVERSAO') {
                filter.value = widgetEstrutura.currentRow.DSVERSAO;
            }
        });

        ABUtilController.masterDetailOpenPopup(widgetFilter);
    };

    this.validaEnvioAutomaticoCadastro = function() {
        var widget = this.getWidgetCadastros();
        var widgetFilter = this.getWidgetEnvioAutomaticoCadastro();
        this.envioAutomatico(widget, widgetFilter, 'envioAutomaticoCadastro');
    };

    this.validaEnvioAutomaticoNaoPeriodico = function() {
        var widget = this.getWidgetNaoPeriodicos();
        var widgetFilter = this.getWidgetEnvioAutomaticoNaoPeriodico();
        this.envioAutomatico(widget, widgetFilter, 'envioAutomaticoNaoPeriodico');
    };

    this.validaEnvioAutomaticoSST = function() {
        var widget = this.getWidgetSST();
        var widgetFilter = this.getWidgetEnvioAutomaticoSST();
        this.envioAutomatico(widget, widgetFilter, 'envioAutomaticoNaoPeriodico');
    };

    this.validaEnvioAutomaticoPeriodico = function() {
        var widget = this.getWidgetPeriodicos();
        var widgetFilter = this.getWidgetEnvioAutomaticoPeriodico();
        this.envioAutomatico(widget, widgetFilter, 'envioAutomaticoPeriodico', true);
    };

    this.validaEnvioAutomatico = function(widget, widgetFilter, action, ehEventoPeriodico=false) {
        if (widgetFilter.isValid()) {
            var nmEvento = widgetFilter.currentRow.NMEVENTO;
            ScreenService.confirmMessage('Será realizada a transmissão automática em lotes de todos itens pendentes para o evento ' + nmEvento + '. Deseja continuar?', 'CONFIRMATION',
                function(){
                    if(this.seDataAtualMaiorDataEnvioESocial() && ehEventoPeriodico){
                        //Apenas após clicar em 'Ok' que o processo é realizado
                        //Esquema de aviso construída devido à sobreposição de avisos do framework
                        ScreenService.showCustomDialog(Messages.AVISO_ESO_PENSALIDADE_PROCESSO_INCLUSAO, 'CONFIRMATION', null, [
                            {
                                label: ScreenService.i18n("Ok"),
                                code: function (e, deferred) { 
                                    this.envioAutomatico(widget, widgetFilter, action);
                                    deferred.resolve(e);
                                }.bind(this)
                            }
                        ]);
                    } else {
                        //Caso o aviso não seja mostrado, o processo é realizado normalmente
                        this.envioAutomatico(widget, widgetFilter, action);
                    }
                }.bind(this),
                function(){
                    //nothing to do
                }
            );
        }
    };
    
    this.envioAutomatico = function(widget, widgetFilter, action) {
        restEngine.post('/'+action, {'requestType': 'Row', 'row': widgetFilter.currentRow}).
            then(function (data) {
                // tratativa padrão do retorno do envio 
                if (!Util.isUndefined(data.dataset)) {
                    if (!Util.isUndefined(data.dataset[action]) && data.dataset[action].length >= 1) {
                        var popUp = this.getWidgetMensagens();
                        popUp.widgetActive = widget;
                        popUp.getField('NRCHAVE').isVisible = true;
                        popUp.dataSource.data = data.dataset[action];
                        ABUtilController.masterDetailOpenPopup(popUp);
                        popUp.getField('NMEVENTO').isVisible = true;
                    } 
                } else if (!Util.isUndefined(data.messages)) {
                    var definedMessage = data.messages[0];
                    ScreenService.showMessage(Util.isUndefined(Messages[definedMessage.message]) ? definedMessage.message : Messages[definedMessage.message], definedMessage.type);
                    if (definedMessage.type == 'M') {
                        ABUtilController.masterDetailClosePopup(widgetFilter);
                        widget.activate();
                        widget.reload();
                    }
                    ABUtilController.blockCheckbox(widget.id, false);
                }
            }.bind(this)).
            catch(function(e) {
                var error;
                if(Util.isUndefined(e.data) && Util.isUndefined(e.data.error) && Util.isUndefined(e.message))
                    error = e;
                else if(!Util.isUndefined(e.message))
                    error = e.message;
                else
                    error = e.data.error;
                ScreenService.showMessage(Util.isUndefined(Messages[error]) ? error : Messages[error], 'ERROR');
            });
    };
    
    this.openConsultaAutomaticaCadastro = function() {
        this.openConsultaAutomatica(this.getWidgetConsultaAutomaticaCadastro());
    };
    
    this.openConsultaAutomaticaNaoPeriodico = function() {
        this.openConsultaAutomatica(this.getWidgetConsultaAutomaticaNaoPeriodico());
    };
    
    this.openConsultaAutomaticaSST = function() {
        this.openConsultaAutomatica(this.getWidgetConsultaAutomaticaSST());
    };
    
    this.openConsultaAutomaticaPeriodico = function() {
        this.openConsultaAutomatica(this.getWidgetConsultaAutomaticaPeriodico());
    };
    
    this.openConsultaAutomatica = function(widgetFilter) {
        var widgetEstrutura = templateManager.container.getWidget('estruturas');

        widgetFilter.currentRow.NRESTRUTURAM = widgetEstrutura.currentRow.NRESTRUTURAM;
        widgetFilter.currentRow.DSVERSAO = widgetEstrutura.currentRow.DSVERSAO;
        widgetFilter.currentRow.NRTPAMBIENTE = widgetEstrutura.currentRow.NRTPAMBIENTE;
        widgetFilter.currentRow.IDSTATUS = [this.STATUS_PENDPROCE, this.STATUS_ERROPROCE];
        widgetFilter.getField('NMEVENTO').dataSourceFilter.forEach(function(filter){
            if (filter.name == 'DSVERSAO') {
                filter.value = widgetEstrutura.currentRow.DSVERSAO;
            }
        });

        ABUtilController.masterDetailOpenPopup(widgetFilter);
    };

    this.validaConsultaAutomaticaCadastro = function() {
        var widget = this.getWidgetCadastros();
        var widgetFilter = this.getWidgetConsultaAutomaticaCadastro();
        this.consultaAutomatica(widget, widgetFilter, 'consultaAutomaticaCadastro');
    };

    this.validaConsultaAutomaticaNaoPeriodico = function() {
        var widget = this.getWidgetNaoPeriodicos();
        var widgetFilter = this.getWidgetConsultaAutomaticaNaoPeriodico();
        this.consultaAutomatica(widget, widgetFilter, 'consultaAutomaticaNaoPeriodico');
    };

    this.validaConsultaAutomaticaSST = function() {
        var widget = this.getWidgetSST();
        var widgetFilter = this.getWidgetConsultaAutomaticaSST();
        this.consultaAutomatica(widget, widgetFilter, 'consultaAutomaticaNaoPeriodico');
    };

    this.validaConsultaAutomaticaPeriodico = function() {
        var widget = this.getWidgetPeriodicos();
        var widgetFilter = this.getWidgetConsultaAutomaticaPeriodico();
        this.consultaAutomatica(widget, widgetFilter, 'consultaAutomaticaPeriodico');
    };
    
    this.consultaAutomatica = function(widget, widgetFilter, action) {
        if (widgetFilter.isValid()) {
            var nmEvento = widgetFilter.currentRow.NMEVENTO;
            ScreenService.confirmMessage('Será realizada a consulta automática de todos itens pendentes processamento para o evento ' + nmEvento + '. Deseja continuar?', 'CONFIRMATION',
                function(){
                    restEngine.post('/'+action, {'requestType': 'Row', 'row': widgetFilter.currentRow}).
                        then(function (data) {
                            // tratativa padrão do retorno do envio 
                            if (!Util.isUndefined(data.dataset)) {
                                if (!Util.isUndefined(data.dataset[action]) && data.dataset[action].length >= 1) {
                                    var popUp = this.getWidgetMensagens();
                                    popUp.widgetActive = widget;
                                    popUp.getField('NRCHAVE').isVisible = true;
                                    popUp.dataSource.data = data.dataset[action];
                                    ABUtilController.masterDetailOpenPopup(popUp);
                                    popUp.getField('NMEVENTO').isVisible = true;
                                } 
                            } else if (!Util.isUndefined(data.messages)) {
                                var definedMessage = data.messages[0];
                                ScreenService.showMessage(Util.isUndefined(Messages[definedMessage.message]) ? definedMessage.message : Messages[definedMessage.message], definedMessage.type);
                                if (definedMessage.type == 'M') {
                                    ABUtilController.masterDetailClosePopup(widgetFilter);
                                    widget.activate();
                                    widget.reload();
                                }
                                ABUtilController.blockCheckbox(widget.id, false);
                            }
                        }.bind(this)).
                        catch(function(e) {
                            var error;
                            if(Util.isUndefined(e.data) && Util.isUndefined(e.data.error) && Util.isUndefined(e.message))
                                error = e;
                            else if(!Util.isUndefined(e.message))
                                error = e.message;
                            else
                                error = e.data.error;
                            ScreenService.showMessage(Util.isUndefined(Messages[error]) ? error : Messages[error], 'ERROR');
                        });
                }.bind(this),
                function(){
                    //nothing to do
                }
            );
        }
    };

    /*----- Fechamento / Reabertura -----*/
    this.fechamentoEsoSimplificado = function() {
        var widgetEstruturas = this.getWidgetEstruturas();
        var widgetPeriodo = this.getWidgetPeriodo();
        var widgetPeriodicos = this.getWidgetPeriodicos();

        var row = {
            'NRORG': widgetEstruturas.currentRow.NRORG,
            'NRESTRUTURAM': widgetEstruturas.currentRow.NRESTRUTURAM,
            'NRTPAMBIENTE': widgetEstruturas.currentRow.NRTPAMBIENTE,
            'NRTABELA': widgetPeriodo.currentRow.NRTABELA
        };

        restEngine.post('/fechamentoEsoSimplificado', {'requestType': 'Row', 'row': row}).
            then(function (data) {
                // tratativa padrão do retorno do envio 
                if (!Util.isUndefined(data.dataset)) {
                    if (!Util.isUndefined(data.dataset.fechamentoEsoSimplificado) && data.dataset.fechamentoEsoSimplificado.length >= 1) {
                        var popUp = this.getWidgetMensagens();
                        popUp.widgetActive = widgetPeriodo;
                        popUp.getField('NRCHAVE').isVisible = true;
                        popUp.dataSource.data = data.dataset.fechamentoEsoSimplificado;
                        ABUtilController.masterDetailOpenPopup(popUp);
                        popUp.getField('NMEVENTO').isVisible = true;
                    } 
                } else if (!Util.isUndefined(data.messages)) {
                    var definedMessage = data.messages[0];
                    ScreenService.showMessage(Util.isUndefined(Messages[definedMessage.message]) ? definedMessage.message : Messages[definedMessage.message], definedMessage.type);
                    if (definedMessage.type == 'M') {
                        ScreenService.closePopup(true);
                        if (!widgetPeriodicos.inListMode()) {
                            ABUtilController.masterDetailVoltarList(widget);
                        }
                        widgetPeriodo.reload();
                    }
                    ABUtilController.blockCheckbox(widgetPeriodicos.id, false);
                } else {
                    ScreenService.showMessage(Messages.PROCESSO_ERROR);
                }
            }.bind(this)).
            catch(function(e) {
                var error;
                if(Util.isUndefined(e.data) && Util.isUndefined(e.data.error) && Util.isUndefined(e.message))
                    error = e;
                else if(!Util.isUndefined(e.message))
                    error = e.message;
                else
                    error = e.data.error;
                ScreenService.showMessage(Util.isUndefined(Messages[error]) ? Messages.CATCH_EXCEPTION_ERROR(error) : Messages[error], 'ERROR');
            });
    };
    
    this.reaberturaEsoSimplificado = function() {
        var widgetEstruturas = this.getWidgetEstruturas();
        var widgetPeriodo = this.getWidgetPeriodo();
        var widgetPeriodicos = this.getWidgetPeriodicos();

        var row = {
            'NRORG': widgetEstruturas.currentRow.NRORG,
            'NRESTRUTURAM': widgetEstruturas.currentRow.NRESTRUTURAM,
            'NRTPAMBIENTE': widgetEstruturas.currentRow.NRTPAMBIENTE,
            'NRTABELA': widgetPeriodo.currentRow.NRTABELA
        };

        restEngine.post('/reaberturaEsoSimplificado', {'requestType': 'Row', 'row': row}).
            then(function (data) {
                // tratativa padrão do retorno do envio 
                if (!Util.isUndefined(data.dataset)) {
                    if (!Util.isUndefined(data.dataset.reaberturaEsoSimplificado) && data.dataset.reaberturaEsoSimplificado.length >= 1) {
                        var popUp = this.getWidgetMensagens();
                        popUp.widgetActive = widgetPeriodo;
                        popUp.getField('NRCHAVE').isVisible = true;
                        popUp.dataSource.data = data.dataset.reaberturaEsoSimplificado;
                        ABUtilController.masterDetailOpenPopup(popUp);
                        popUp.getField('NMEVENTO').isVisible = true;
                    } 
                } else if (!Util.isUndefined(data.messages)) {
                    var definedMessage = data.messages[0];
                    ScreenService.showMessage(Util.isUndefined(Messages[definedMessage.message]) ? definedMessage.message : Messages[definedMessage.message], definedMessage.type);
                    if (definedMessage.type == 'M') {
                        ScreenService.closePopup(true);
                        if (!widgetPeriodicos.inListMode()) {
                            ABUtilController.masterDetailVoltarList(widget);
                        }
                        widgetPeriodo.reload();
                    }
                    ABUtilController.blockCheckbox(widgetPeriodicos.id, false);
                } else {
                    ScreenService.showMessage(Messages.PROCESSO_ERROR);
                }
            }.bind(this)).
            catch(function(e) {
                var error;
                if(Util.isUndefined(e.data) && Util.isUndefined(e.data.error) && Util.isUndefined(e.message))
                    error = e;
                else if(!Util.isUndefined(e.message))
                    error = e.message;
                else
                    error = e.data.error;
                ScreenService.showMessage(Util.isUndefined(Messages[error]) ? Messages.CATCH_EXCEPTION_ERROR(error) : Messages[error], 'ERROR');
            });
    };
    
    this.getNaoPeriodicosPendentes = function() {
        var widget = this.getWidgetNaoPeriodicos();
        if (widget.isValid()) {
            var row = {
                'NRVINCULOMLIST': widget.currentRow.NRVINCULOM,
                'NMEVENTOLIST': widget.currentRow.NMEVENTO
            };
            restEngine.post('/getNaoPeriodicosPendentes', {'requestType': 'Row', 'row': row}).
                then(function (data) {
                    // tratativa padrão do retorno do envio 
                    if (!Util.isUndefined(data.dataset.naoPeriodicosPendentes)) {
                        var popUp = this.getWidgetNaoPeriodicosPendentes();
                        popUp.widgetActive = widget;
                        popUp.dataSource.data = data.dataset.naoPeriodicosPendentes;
                        ABUtilController.masterDetailOpenPopup(popUp);
                    } else if (!Util.isUndefined(data.messages)) {
                        var definedMessage = data.messages[0];
                        ScreenService.showMessage(Util.isUndefined(Messages[definedMessage.message]) ? definedMessage.message : Messages[definedMessage.message], definedMessage.type);
                    }
                }.bind(this)).
                catch(function(e) {
                    var error;
                    if(Util.isUndefined(e.data) && Util.isUndefined(e.data.error) && Util.isUndefined(e.message))
                        error = e;
                    else if(!Util.isUndefined(e.message))
                        error = e.message;
                    else
                        error = e.data.error;
                    ScreenService.showMessage(Util.isUndefined(Messages[error]) ? error : Messages[error], 'ERROR');
                });
        }
    };

    this.setGetXmlFilter = function() {
        var widgetEstruturas = this.getWidgetEstruturas();
        var widgetXml = templateManager.container.getActiveWidget();
        var widgetEnvio = widgetXml.getParent();
        
        var idXmlFile;
        var idEvento = widgetEnvio.currentRow.IDEVENTO;
        var dsDirXmlEnv = widgetEnvio.currentRow.DSDIRXMLENV;
        var dsDirXmlRetEnv = widgetEnvio.currentRow.DSDIRXMLRETENV;
        var dsDirXmlRetPro = widgetEnvio.currentRow.DSDIRXMLRETPRO;
        var dsDirXmlRetTot = widgetEnvio.currentRow.DSDIRXMLRETTOT;
        var nrTpAmbiente = widgetEstruturas.currentRow.NRTPAMBIENTE;
        var cdCnpjEstrut = widgetEstruturas.currentRow.CDCNPJESTRUT;
        var idGrupo = 'N';
        
        widgetXml.dataSourceFilter.forEach(function(filter){
            if (filter.name == 'P_XMLFILE') {
                idXmlFile = filter.value;
            }
            if (filter.name == 'P_IDEVENTO') {
                filter.value = idEvento;
            }
            if (filter.name == 'P_DSDIRXML') {
                filter.value = (idXmlFile == 'envio' ? dsDirXmlEnv : (idXmlFile == 'retorno' ? dsDirXmlRetEnv : (idXmlFile == 'consulta' ? dsDirXmlRetPro : (idXmlFile == 'total' ? dsDirXmlRetTot : ''))));
            }
            if (filter.name == 'P_NRTPAMBIENTE') {
                filter.value = nrTpAmbiente;
            }
            if (filter.name == 'P_IDGRUPO') {
                filter.value = idGrupo;
            }
            if (filter.name == 'P_CDCNPJESTRUT') {
                filter.value = cdCnpjEstrut;
            }
        });
        
        widgetXml.reload();
    };
    
    this.downloadXML = function(){
        //Função que tem como objetivo tornar possível o download de um arquivo XML criado pelo sistema HCM e enviado ao eSocial
        
        //widgets:
        var widgetEstruturas = templateManager.container.getWidget("estruturas");
        var widgetDados = templateManager.container.getActiveWidget();
        
        //variaveis necessárias para identificar o objeto e conseguir o respectivo arquivo XML:
        var nrCpfPessoa = widgetDados.getParent().currentRow.NRCPFPESSOA;
        var nmEvento = widgetDados.getParent().currentRow.NMEVENTO;
        var nrChaveEvento = widgetDados.getParent().currentRow.NRCHAVE;
        
        //informações necessárias para a identificação do arquivo xml
        var idXmlFile = ABUtilController.retornaFiltro(widgetDados.dataSourceFilter, 'P_XMLFILE') == false ? 'envio' : widgetDados.dataSourceFilter[ABUtilController.retornaFiltro(widgetDados.dataSourceFilter, 'P_XMLFILE')].value;
        var idEvento = widgetDados.getParent().currentRow.IDEVENTO;
        var dsDirXmlEnv = widgetDados.getParent().currentRow.DSDIRXMLENV;
        var dsDirXmlRetEnv = widgetDados.getParent().currentRow.DSDIRXMLRETENV;
        var dsDirXmlRetPro = widgetDados.getParent().currentRow.DSDIRXMLRETPRO;
        var dsDirXmlRetTot = widgetDados.getParent().currentRow.DSDIRXMLRETTOT;
        var nrTpAmbiente = widgetEstruturas.currentRow.NRTPAMBIENTE;
        var idGrupo = this.idGrupo;
        var cdCnpjEstrut = widgetEstruturas.currentRow.CDCNPJESTRUT;
        var nrorg = getLocalVar('HCM_NRORG_TRAB');
        
        var dsDirXml = (idXmlFile == 'envio' ? dsDirXmlEnv : (idXmlFile == 'retorno' ? dsDirXmlRetEnv : (idXmlFile == 'consulta' ? dsDirXmlRetPro : (idXmlFile == 'total' ? dsDirXmlRetTot : 'envio'))));
        var dsDirXmlFilesPath = 
                (nrTpAmbiente == 1 ? 'Producao' : 'ProducaoRestrita') + "/" +
                (idGrupo == 'P' ? 'Periodicos' : (idGrupo == 'N' ? 'NaoPeriodicos' : 'Cadastros')) + "/" +
                cdCnpjEstrut + "/" +
                (idXmlFile == 'envio' ? 'Envio' : (idXmlFile == 'retorno' ? 'RetornoEnvio' : (idXmlFile == 'consulta' ? 'RetornoProcessamento' : (idXmlFile == 'total' ? 'Totalizador' : 'Envio')))) + "/" +
                dsDirXml;
                
        var evento = [{
            'NRORG': nrorg,
            'IDXMLFILE': idXmlFile,
            'IDEVENTO': idEvento,
            'DSDIRXML': dsDirXml,
            'DSDIRXMLFILESPATH': dsDirXmlFilesPath,
            'NRCPFPESSOA': nrCpfPessoa,
            'NMEVENTO': nmEvento,
            'NRCHAVE': nrChaveEvento
        }];
                
        ESocialService.getArquivoXML(evento);
    };
    
    this.seDataAtualMaiorDataEnvioESocial = function(){
        //Função que compara a data atual com a data de envio do registro ao eSocial, tendo como base a data de competência utilizada pelo operador
        //Retorna true se a data atual passar da data de envio ao eSocial e false caso a data atual esteja dentro do prazo estabelecido
        var dataCompetencia = ABUtilController.retornaObjetoDateComString(getLocalVar('HCM_DTCOMPETENCIA_OPER'));
        var dataEnvioESocial = this.retornaDataEnvioMesSubsequenteESocial(dataCompetencia);
        var dataAtual = new Date();
        ABUtilController.truncateObjetoDate(dataAtual);
        
        return dataAtual.getTime() > dataEnvioESocial.getTime();
    };
    
    this.retornaDataEnvioMesSubsequenteESocial = function(dataAtual){
        try {
            var anoEnvioEscocial = dataAtual.getFullYear();
            var mesEnvioESocial = dataAtual.getMonth() + 1;
            if(mesEnvioESocial + 1 > 12){
                anoEnvioEscocial++;
                mesEnvioESocial = 1;
            } else {
                mesEnvioESocial++;
            }
            mesEnvioESocial = mesEnvioESocial < 10 ? '0' + mesEnvioESocial : mesEnvioESocial;
            var dataEnvioESocial =  '15/' + mesEnvioESocial + '/' +  anoEnvioEscocial;
            var dataEnvioESocialDate = ABUtilController.retornaObjetoDateComString(dataEnvioESocial);
            return dataEnvioESocialDate;
        } catch(err){
            return false;
        }
    };
    
    this.validaSeMensagemExiste = function (mensagem) {
        var mensagemEncontrada = [];
        this.nomesErrosInclusaoEventos.forEach(function(mensagemAtual){
            if (mensagem.indexOf(mensagemAtual) !== -1) {
                mensagemEncontrada.push(mensagemAtual);
            }
        });
        return mensagemEncontrada.length > 0 ? mensagemEncontrada : false;
    };
    
    this.substituiNomesMensagens = function (nomesEncontrados, mensagem) {
        nomesEncontrados.forEach(function(nome){
            mensagem = mensagem.replace(new RegExp(nome, 'g'), Messages[nome]);
        }.bind(this));
        return mensagem;
    };
    
    this.voltarMensagens = function() {
        var popUp = this.getWidgetMensagens();
        ScreenService.closePopup(true);
        popUp.deactivate();
        popUp.widgetActive.activate();
    };
        
      
    this.openPopupSimplificadoInclusaoManualAdmissao = function(){
        var widget = templateManager.container.getActiveWidget() ;
        var popup = templateManager.container.getWidget('inclusaoManualSimplificadoAdmissao') ;
        var widgetEstrutura = templateManager.container.getWidget('estruturas');
        
        ABUtilController.masterDetailOpenPopup(popup);
        popup.parent = widget;
        popup.newRow();
        popup.getField('NRVINCULOM').dataSourceFilter[ABUtilController.retornaFiltro(popup.getField('NRVINCULOM').dataSourceFilter, 'P_CDRAIZCNPJEMPREG')].value = widgetEstrutura.currentRow.CDCNPJESTRUT.substring(0,8);
        popup.currentRow.NRESTRUTURAM = widgetEstrutura.currentRow.NRESTRUTURAM;
        popup.currentRow.DSVERSAO = this.dsversao;
        
        
    };
    
    this.inclusaoManualSimplificadoAdmissao = function(){
        var widget = templateManager.container.getActiveWidget() ;
        var widgetNaoPeriodicos = templateManager.container.getWidget('naoPeriodicos');
        if(widget.isValid()){
            widget.currentRow.__is_new = true;
            restEngine.post('product#/setEnvio2200ManualSimplificadoAdmissao', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
            then(function (data) {
                if (data.messages[0].type === "success") {
                    ScreenService.showMessage(data.messages[0].message, data.messages[0].type);
                    ScreenService.closePopup(true);
                    widgetNaoPeriodicos.activate();
                    widgetNaoPeriodicos.reload();
                } else {
                    ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                }
            }).
            catch(function(e) {
                var error;
                if(Util.isUndefined(e.data) && Util.isUndefined(e.data.error) && Util.isUndefined(e.message))
                    error = e;
                else if(!Util.isUndefined(e.message))
                    error = e.message;
                else
                    error = e.data.error;
                ScreenService.showMessage(Util.isUndefined(Messages[error]) ? error : Messages[error], 'ERROR');}
            );
            
        }
    };
    
    this.closePopupInclusaSimplificadoManualAdmissao = function(){
        var popup = templateManager.container.getWidget('inclusaoManualAdmissao');
        // popup.currentRow = {};
        ScreenService.closePopup(true);
        popup.deactivate();
        popup.parent.currentWidget = popup.parentWidget;
        popup.parent.activate();
        popup.parent.reload();
    };
    
}

Configuration(function(ContextRegister) {
    ContextRegister.register('EsoSimplificadoController', EsoSimplificadoController);
}); 

// FILE: assets/js/controllers/EstadoCivilController.js
function EstadoCivilController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, General,Messages) {

    this.adicionarRow = function(args) {
        var widget = args.owner.widget;
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
    };

	this.setEstadoCivil = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
                if (!widget.backupRow) {
                    widget.currentRow.__is_new = true;
                } else {
                    widget.currentRow.__is_new = false;
                }
                restEngine.post('product#/setEstadoCivil', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                    then(function (data) {
                        if (data.notifications[0].type === "success") {
                            ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                            if (widget.currentRow.__is_new) {
                                ABUtilController.masterDetailVoltarList(widget);
                                widget.reload();
                            } else {
                                ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                                widget.backupRow = null;
                                widget.view();
                            }
                        } else {
                            ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                        }
                    }).
                    catch(function(e) {
                        var error;
                        if(e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;
                            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    });
            }
    };
    
    this.deleteEstadoCivil = function(args) {
    ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
        var widget = args.owner.widget;
        widget.currentRow.__is_new = false;
        restEngine.post('product#/deleteEstadoCivil', {'requestType':'DataSet','dataset':[widget.currentRow]}).
            then(function(data){
                if(data.notifications[0].type === "success"){
                    ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                    ABUtilController.masterDetailVoltarList(widget);
                    widget.reload();
                } else {
                    ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                }
            }).
            catch(function(e) {
                var error;
                if(e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
        }, null);
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('EstadoCivilController', EstadoCivilController);
});

// FILE: assets/js/controllers/EstruturaController.js
/* jshint esversion: 6 */
function EstruturaController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, General,Messages, HcmConsts) {
    
    /* Controller utilizado também na tela hcm00118_gpe_parametrizacaoSindicado */
    
    var self = this;
    
    this.tpHierarquiaAntigo = null;
    
    this.NRTIPOESTRUTGEREN      = localStorage.HCM_NRTIPOESTRUTGEREN;
    this.NRTIPOESTRUTLEGAL      = localStorage.HCM_NRTIPOESTRUTLEGAL;
    this.NRTIPOESTRUTOMADOR     = localStorage.HCM_NRTIPOESTRUTOMADOR;
    this.HCM_IDREALIZACONTAB    = ABUtilController.removeStringQuote(localStorage.HCM_IDREALIZACONTAB);

    this.validacoesObrigatoriedade = {
        [HcmConsts.TpEstrutura.CENTROCUSTO]: [],
        [HcmConsts.TpEstrutura.EMPRESA]: [
            'CDTIPOINSCRICAO',
            'CDCNPJESTRUT',
            'DSCALENDARIO',
            'IDTIPOEMPR',
        ],
        [HcmConsts.TpEstrutura.ESCOLA]: [],
        [HcmConsts.TpEstrutura.FILIAL]: [
            'CDTIPOINSCRICAO',
            'CDCNPJESTRUT',
        ],
        [HcmConsts.TpEstrutura.GRUPO]: [],
        [HcmConsts.TpEstrutura.PLANODESAUDE]: [
            'CDTIPOINSCRICAO',
            'CDCNPJESTRUT',    
        ],
        [HcmConsts.TpEstrutura.PROJETO]: [],
        [HcmConsts.TpEstrutura.REGIAO]: [],
        [HcmConsts.TpEstrutura.SECAO]: [],
        [HcmConsts.TpEstrutura.SINDICATO]: [
            'CDTIPOINSCRICAO',
            'CDCNPJESTRUT',
            'CDSINDICAL',
            'DTBASESINDICAL',
        ],
        [HcmConsts.TpEstrutura.TOMADORDESERVICOS]: [
            'CDTIPOINSCRICAO',
            'CDCNPJESTRUT',
            'IDTIPOEMPR',
            'DSFPAS',
            'DSCNAE',
            'CDTERCEIRO',
        ],
        DEFAULT_OBRIGATORIOS: [
            'NMESTRUTURAH',
            'NMRAZSOCESTRUT',
        ],
        CHANGEABLE_VALIDATIONS_FIELDS: [
            'CDTIPOINSCRICAO',
            'CDCNPJESTRUT',
            'DSCALENDARIO',
            'IDTIPOEMPR',
            'NMRAZSOCESTRUT',
            'CDSINDICAL',
            'DTBASESINDICAL',
            'NMESTRUTURAH',
            'DSFPAS',
            'DSCNAE',
            'CDTERCEIRO',
            'CDINTESTRUTEXPFIL',
            'CDINTESTRUTEXP',
            'CDEXPPDRATEIO',
            'NRTPEVENTOCTBL',
            'DSCLASSTRIBUT',
        ],
        ESTRUTURAS_PADRAO: {
            [this.NRTIPOESTRUTGEREN]: [],
            [this.NRTIPOESTRUTLEGAL]: [
                'CDTIPOINSCRICAO',
                'CDCNPJESTRUT',
                'DSCALENDARIO',
                'IDTIPOEMPR',
                'DSCLASSTRIBUT',
                'DSFPAS',
                'DSCNAE',
                'CDTERCEIRO',
            ],
            [this.NRTIPOESTRUTOMADOR]: [
                'CDTIPOINSCRICAO',
                'CDCNPJESTRUT',
                'IDTIPOEMPR',
                'DSFPAS',
                'DSCNAE',
                'CDTERCEIRO',
            ],
        },
        PARAMETROS_ORGANIZACAO: {
            HCM_IDREALIZACONTAB: {
                'S': [
                    'CDINTESTRUTEXPFIL',
                    'CDINTESTRUTEXP',
                    'NRTPEVENTOCTBL',
                ],
                'N': [],
                VALUE: this.HCM_IDREALIZACONTAB
            }
        },
    };
    
    this.adicionarRow = function(args) {
        var widget = args.owner.widget;
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
        this.validaTipoEstrutura(widget);
    };
    
    this.widgetsvisiblefalse = function(args) {
        var widget = args.owner.widget;
        widget.widgets[ABUtilController.retornaWidget(widget, 'enderecoParc')].showAsTab = false;
        widget.widgets[ABUtilController.retornaWidget(widget, 'formaComunicacaoParc')].showAsTab = false;
        if (ABUtilController.retornaWidget(widget, 'contaCorrenteParc')) {
            widget.widgets[ABUtilController.retornaWidget(widget, 'contaCorrenteParc')].showAsTab = false;
        }
        if (ABUtilController.retornaWidget(widget, 'WidgetUploadFoto')) {
            widget.widgets[ABUtilController.retornaWidget(widget, 'WidgetUploadFoto')].showAsTab = false;
        }
        if (ABUtilController.retornaWidget(widget, 'estruturasRelacionadas')) {
            widget.widgets[ABUtilController.retornaWidget(widget, 'estruturasRelacionadas')].showAsTab = false;
        }
        if (ABUtilController.retornaWidget(widget, 'estruturasSup')) {
            widget.widgets[ABUtilController.retornaWidget(widget, 'estruturasSup')].showAsTab = false;
        }
    };

    this.widgetsvisibletrue = function(args) {
        var widget = args.owner.widget;
        widget.widgets[ABUtilController.retornaWidget(widget, 'enderecoParc')].showAsTab = true;
        widget.widgets[ABUtilController.retornaWidget(widget, 'formaComunicacaoParc')].showAsTab = true;
        if (ABUtilController.retornaWidget(widget, 'contaCorrenteParc')) {
            widget.widgets[ABUtilController.retornaWidget(widget, 'contaCorrenteParc')].showAsTab = true;
        }
        if (ABUtilController.retornaWidget(widget, 'WidgetUploadFoto')) {
            widget.widgets[ABUtilController.retornaWidget(widget, 'WidgetUploadFoto')].showAsTab = true;
        }
        if (ABUtilController.retornaWidget(widget, 'estruturasRelacionadas')) {
            widget.widgets[ABUtilController.retornaWidget(widget, 'estruturasRelacionadas')].showAsTab = true;
        }
        if (ABUtilController.retornaWidget(widget, 'estruturasSup')) {
            widget.widgets[ABUtilController.retornaWidget(widget, 'estruturasSup')].showAsTab = true;
        }
        this.validaEntidadeEducacional(args);
    };
    
    this.setOpcaosimples = function(args){
        var widget = args.owner.owner.widget;
        if(widget.getField('NRTIPOTRIBUT').value() === 3){
            widget.getField('IDOPTSIMPLES').value('S');
        }else{
            widget.getField('IDOPTSIMPLES').value('N');
        }
    };
    
    this.validateInscription = function(widget){
        var currentRow = widget.currentRow;
        var resultValidate = this.inscricaoFormat(currentRow.CDCNPJESTRUT);
        if(resultValidate.value){
            currentRow.CDCNPJESTRUT = resultValidate.value;
        }
    };
    
    this.validaEntidadeEducacional = function(args){
        var widget = ABUtilController.checkWidget(args);
        if (ABUtilController.retornaWidget(widget, 'entidadeEducacional')) {
            var tipoEstrutura = getLocalVar('HCM_NRTIPOESTRUTLEGAL');
            var widgetEducacional = widget.widgets[ABUtilController.retornaWidget(widget, 'entidadeEducacional')];
            
            if(widget.currentRow.NRTIPOESTRUTURA === tipoEstrutura){
                widgetEducacional.isVisible = true;
                widgetEducacional.dataSourceFilter[ABUtilController.retornaFiltro(widgetEducacional.dataSourceFilter, 'NRESTRUTSUPERIOR')].value = widget.currentRow.NRESTRUTURAM;
            }else{
                widgetEducacional.isVisible = false;
            }
        }
    };
    
    this.validateCodigo = function(widget){
        var currentRow = widget.currentRow;
        if(getLocalVar('HCM_IDREALIZACONTAB') == 'S' || getLocalVar('HCM_IDREALIZADESPESA') == 'S'){
            widget.getField('CDINTESTRUTEXPFIL').validations = {required: true};
            widget.getField('CDINTESTRUTEXP').validations = {required: true};
        }else{
            widget.getField('CDINTESTRUTEXPFIL').validations = {};
            widget.getField('CDINTESTRUTEXP').validations = {};
        }
    };
    
    this.formatInscriptionAfterMoveRow = function(widget){
        var currentRow = widget.currentRow;
        var inscription = currentRow.CDCNPJESTRUT;
        if(inscription){
            switch (inscription.length) {
                case 11:
                    inscription = inscription.replace(/(\d{3})(\d{3})(\d{3})(\d{2})/, "$1.$2.$3-$4");
                break;
                
                case 14:
                    inscription = inscription.replace(/^(\d{2})(\d{3})(\d{3})(\d{4})(\d{2})/, "$1.$2.$3/$4-$5");
                break;
            }
            currentRow.CDCNPJESTRUT = inscription;
        }    
    };
    
    this.validaSelectNative =function(args){
        var widget = args.owner;
        if(widget.currentRow.NRTPOBRIGAPRENDIZ){
            widget.currentRow.NRTPOBRIGAPRENDIZ = widget.currentRow.NRTPOBRIGAPRENDIZ.toString();
        }
        if(widget.currentRow.NRTPOBRIGAPCD){
            widget.currentRow.NRTPOBRIGAPCD = widget.currentRow.NRTPOBRIGAPCD.toString();
        }
    };
    
    this.montaDataSourceFilterEstrutura = function(args){
        var widget = args.owner.owner.widget;
        var field = args.owner.owner;
        field.dataSourceFilter[ABUtilController.retornaFiltro(field.dataSourceFilter, 'NRHIERARQUIAORG')].value = [];
        widget.dataSource.data.forEach(function(elemento){
            if(elemento.NRHIERARQUIAORG != ''){
                field.dataSourceFilter[ABUtilController.retornaFiltro(field.dataSourceFilter, 'NRHIERARQUIAORG')].value.push(elemento.NRHIERARQUIAORG);    
            }
        });
        field.dataSourceFilter[ABUtilController.retornaFiltro(field.dataSourceFilter, 'NRESTRUTSUPERIOR')].value =  widget.parent.parent.currentRow.NRESTRUTURAM;
    };
    
    this.alterMaskInscricao = function(){
        var widget = templateManager.container.getWidget('estrutura');
        var fieldInscricao = widget.getField('CDCNPJESTRUT');
        
        if(!Util.isEmptyOrBlank(widget.currentRow.CDTIPOINSCRICAO) && !widget.inEditMode()){
            switch (widget.currentRow.CDTIPOINSCRICAO) {
                case 'CNPJ':
                    fieldInscricao.mask =   {
                                                "type": "fix",
                                                "params":   {
                                                                "mask" : "99.999.999/9999-99"
                                                            }
                                            };                                    
                    break;
                case 'CPF':
                    fieldInscricao.mask = {
                                                "type": "fix",
                                                "params":   {
                                                                "mask" : "999.999.999-99"
                                                            }
                                            };  
                    break;
                case 'LIVRE':
                    delete fieldInscricao.mask;
                    break;
                case 'CODIGO':
                    delete fieldInscricao.mask;
                    break;
                default:
                   delete fieldInscricao.mask;
            }
        }else{
            delete fieldInscricao.mask;
        }
        
        widget.redraw();
    };
    
    this.validaTipoEstrutura = function(widget){
        if(widget.name == 'zhFilterPreferencesSelectConditions' || widget.name.search('filter') >= 0 || widget.name.search("Filter") >= 0){
            return;
        }
        
        const tipoEstrutura = parseInt(widget.currentRow.NRTIPOESTRUTURA, 10);
        
        // São considerados para a validação, primeiramente os campos que serão obrigatórios para todos os tipos e depois os específicos para cada tipo.
        // Se o tipo de estrutura for um padrão, não pode pegar o específico, só o definido como padrão.
        const camposObrigatorios    = this.getCamposObrigatoriosEstrutura(tipoEstrutura);
        const camposManuseaveis     = this.getCamposValidacaoManuseavel();
        
        // Insere as validações selecionadas
        for (const campo of camposObrigatorios) {
            const widgetField = widget.getField(campo);
            ABUtilController.setFieldRequired(widgetField);
        }
        
        // Remove validação dos campos que não são obrigatórios
        const camposNaoObrigatorios = ABUtilController.arrayDiference(camposManuseaveis, camposObrigatorios);
        for (const campo of camposNaoObrigatorios) {
            const widgetField = widget.getField(campo);
            ABUtilController.setFieldNotRequired(widgetField);
        }
    };
    
    this.getCamposObrigatoriosEstrutura = function(nrTipoEstrutura) {
        let     camposObrigatoriosPadrao                = this.getCamposObrigatoriosPadrao();
        const   camposObrigatoriosEstruturaPadrao       = this.getCamposObrigatoriosEstruturasPadrao(nrTipoEstrutura);
        const   camposObrigatoriosParametrosOrganizacao = this.getCamposObrigatoriosParametrosOrganizacao();
        
        // Se existirem validações relacionadas com os parametros da organização, adiciona às validações a serem retornadas de acordo com os tipos de estrutura.
        if (camposObrigatoriosParametrosOrganizacao.length > 0) {
            camposObrigatoriosPadrao = [ ...camposObrigatoriosPadrao, ...camposObrigatoriosParametrosOrganizacao];
        }
        
        // Se a estrutura for padrão, retona apenas os campos obrigatórios dessa.
        if (camposObrigatoriosEstruturaPadrao.length > 0) {
            return ABUtilController.arrayUnique([ ...camposObrigatoriosPadrao, ...camposObrigatoriosEstruturaPadrao ]);
        }
        
        // Caso a estrutura não é padrão, retona os campos definidos para o tipo específico
        const camposObrigatoriosEstrutura = this.validacoesObrigatoriedade[nrTipoEstrutura] ? this.validacoesObrigatoriedade[nrTipoEstrutura] : [];
        return ABUtilController.arrayUnique([ ...camposObrigatoriosPadrao, ...camposObrigatoriosEstrutura ]);
    };
    
    this.getCamposObrigatoriosEstruturasPadrao = function(nrTipoEstrutura) {
        const camposObrigatoriosEstruturasPadrao = this.validacoesObrigatoriedade.ESTRUTURAS_PADRAO[nrTipoEstrutura] ? this.validacoesObrigatoriedade.ESTRUTURAS_PADRAO[nrTipoEstrutura] : [];
        return camposObrigatoriosEstruturasPadrao;
    };
    
    this.getCamposObrigatoriosParametrosOrganizacao = function() {
        const   camposParametrosOrganizacao         = this.validacoesObrigatoriedade.PARAMETROS_ORGANIZACAO ? this.validacoesObrigatoriedade.PARAMETROS_ORGANIZACAO : [];
        let     compactoCamposParametrosOrganizacao = [];
        
        for (const index in camposParametrosOrganizacao) {
            const campoParametrosOrganizacao = camposParametrosOrganizacao[index];
            
            const camposValidacao = campoParametrosOrganizacao[campoParametrosOrganizacao.VALUE] || [];
            compactoCamposParametrosOrganizacao = [ ...compactoCamposParametrosOrganizacao, ...camposValidacao ];
        }
        return compactoCamposParametrosOrganizacao;
    };
    
    this.getCamposValidacaoManuseavel = function() {
        const camposValidacaoManuseavel = this.validacoesObrigatoriedade.CHANGEABLE_VALIDATIONS_FIELDS ? this.validacoesObrigatoriedade.CHANGEABLE_VALIDATIONS_FIELDS : [];
        return camposValidacaoManuseavel;
    };
    
    this.getCamposObrigatoriosPadrao = function() {
        const camposObrigatoriosPadrao = this.validacoesObrigatoriedade.DEFAULT_OBRIGATORIOS ? this.validacoesObrigatoriedade.DEFAULT_OBRIGATORIOS : [];
        return camposObrigatoriosPadrao;
    };
    
    this.setEntidadeEducacional = function(args){
        var widget = args.owner.widget;
        var parentWidget = widget.parent.parent;
        ScreenService.confirmMessage('Deseja realmente adicionar essa entidade?', 'CONFIRMATION', 
        function(){
            if (widget.isValid()) {
                    widget.currentRow.NMESTRUTSUPERIOR = parentWidget.currentRow.NMESTRUTURAM;
                    widget.currentRow.NRESTRUTSUPERIOR = parentWidget.currentRow.NRESTRUTURAM;
                    widget.currentRow.NRTIPOESTRUTLEGAL = getLocalVar('HCM_NRTIPOESTRUTLEGAL');
                    restEngine.post('product#/setEntidadeEducacional', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                            then(function (data) {
                                if(data.notifications[0].type === 'success'){
                                    ScreenService.successNotification(data.notifications[0].message, 10000);
                                    ABUtilController.masterDetailVoltarList(widget);
                                    widget.reload();
                                }else{
                                    ScreenService.successNotification('Erro ao salvar a entidade', 10000);
                                }
                            }).
                            catch(function(e) {
                                var error;
                                if(e.data.error === undefined)
                                    error = e;
                                else
                                    error = e.data.error;
                    
                                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                            });
                }
            }.bind(this)
        );
    };
    
    this.deleteEntidadeEducacional = function(agrs){
        ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
        var widget = templateManager.container.getActiveWidget();
        if (widget.isValid()) {
            widget.currentRow.__is_new = false;
            restEngine.post('product#/deleteEntidadeEducacional', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                then(function (data) {
                    if (data.messages) {
                        ScreenService.showMessage(Messages.REMOVE_ROW_ERROR + '. ' + data.messages[0].message, data.messages[0].type);
                    } else {
                        ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    }
                }).
                catch(function(e) {
                    var error;
                    if(e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;

                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
            }
        }, null);  
    };
    
    this.setParcNegocioAndEstrutura = function(args, PopupCadastroController) {
        var widget = args.owner.widget;
        var retorno = null;
        if(widget.isValid()){
            if(ABUtilController.validaDtIniMenorIgualDtFin(widget.currentRow.DTINIVIGENCIA,widget.currentRow.DTFIMVIGENCIA)){
                var preparedWidget = ABUtilController.prepareSaveMasterHistory(widget);
    
                PopupCadastroController.getWidgetRetorno(args);
                
                if(!widget.currentRow.__is_new){
                    if(widget.currentRow.DTINIVIGENCIA != widget.backupRow.DTINIVIGENCIA){
                        preparedWidget.currentRow.IDVERIFICAVIGENCIAESO = 'S';
                        preparedWidget.currentRow.NMEVENTO = 'S-1005,S-1020';
                        preparedWidget.currentRow.NRCHAVE = preparedWidget.currentRow.NRESTRUTURAM;
                    }else{
                        preparedWidget.currentRow.IDVERIFICAVIGENCIAESO = 'N';
                    }
                    salvar(preparedWidget, args);
                }else if( parseInt(preparedWidget.currentRow.NRTIPOESTRUTURA) == parseInt(getLocalVar('HCM_NRTIPOESTRUTGEREN')) ){
                    ScreenService.confirmMessage('Deseja criar o Tomador de Serviço?', 'CONFIRMATION',
                        function() {
                            PopupCadastroController.openCadastro(args, 'tomadorServico', 'product#json/containers/hcm00113_ger_popupCadastro.json');
                        }.bind(this),
                        function(){
                            salvar(preparedWidget, args);
                        }.bind(this)
                    );
                }else if( parseInt(preparedWidget.currentRow.NRTIPOESTRUTURA) == parseInt(getLocalVar('HCM_NRTIPOESTRUTLEGAL')) ){
                    ScreenService.confirmMessage('Deseja relacionar uma ou mais estruturas gerenciais (centro de custos, departamentos...) para esta estrutura legal?', 'CONFIRMATION',
                        function() {
                            PopupCadastroController.openCadastro(args, 'estruturaGerencial1', 'product#json/containers/hcm00113_ger_popupCadastro.json');
                        }.bind(this),
                        function(){
                            salvar(preparedWidget, args);
                        }.bind(this)
                    );
                }else if( parseInt(preparedWidget.currentRow.NRTIPOESTRUTURA) == parseInt(getLocalVar('HCM_NRTIPOESTRUTOMADOR')) ){
                    ScreenService.confirmMessage('Deseja relacionar o Tomador de Serviço a uma ou mais estruturas gerenciais?', 'CONFIRMATION',
                        function() {
                            PopupCadastroController.openCadastro(args, 'estruturaGerencial2', 'product#json/containers/hcm00113_ger_popupCadastro.json');
                        }.bind(this),
                        function(){
                            salvar(preparedWidget, args);
                        }.bind(this)
                    );
                }else{    
                    salvar(preparedWidget, args);
                }
                    
                
            }else{
                ScreenService.showMessage(Messages.DTINI_POST_DTFIM_ERROR);
                return false;
            } 
        }
    };
    
    this.openWidgetRelac = function(widget){	 
        var tipoEstrut = parseInt(widget.currentRow.NRTIPOESTRUTURA); 	 
        var widgetRelac;	 
        self.setDataSourceFilterAbaEstrutRelSup();	 
        self.setDataSourceFilterFieldTpHierarquia();	 
        if(tipoEstrut == parseInt(getLocalVar('HCM_NRTIPOESTRUTLEGAL'))){	 
            self.setDefaultValueEstrutWidEstrutOnEnter('estruturasRelacionadas');	 
            widgetRelac = templateManager.container.getWidget('estruturasRelacionadas');	 
        } else if (tipoEstrut == parseInt(getLocalVar('HCM_NRTIPOESTRUTGEREN')) ){	 
            self.setDefaultValueEstrutWidEstrutOnEnter('estruturasSup');	 
            widgetRelac = templateManager.container.getWidget('estruturasSup');	 
        }	 
        widgetRelac.activate();	 
        widgetRelac.list();	 
        widgetRelac.reload();	 
    };
    
    var salvar = function(preparedWidget, args){
        restEngine.post('product#/setEstrutura', {'requestType': 'DataSet', 'dataset': [preparedWidget.currentRow]}).
            then(function (data) {
                if(data.dataset.verificaVigenciaEnvio){
                    ScreenService.showCustomDialog(data.dataset.verificaVigenciaEnvio.MENSAGEM, 'CONFIRMATION', null, [{
                        label: ScreenService.i18n("Sim"),
                        code: function(e, deferred) {
                            preparedWidget.currentRow.IDVERIFICAVIGENCIAESO = 'N';
                            salvar(preparedWidget, args);
                            deferred.resolve(e);
                        }.bind(this)
                      },{
                        label: ScreenService.i18n("Não"),
                        code: function(e, deferred) {
                        preparedWidget.currentRow = preparedWidget.backupRow;
                            preparedWidget.view();
                            deferred.reject(e);
                        }
                    }]);
                }else if (data.dataset.columnsToReturn) {
                    ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                    self.widgetsvisibletrue(args);
                    if (preparedWidget.currentRow.__is_new) {
                        ABUtilController.masterDetailVoltarList(preparedWidget);
                        ABUtilController.mudarVisibilidadeWidgets(preparedWidget.widgets, true);
                    } else {
                        ABUtilController.mudarVisibilidadeWidgets(preparedWidget.widgets, true);
                        var tableHistoryPk = preparedWidget.saveHistoryTable.__table_history_pk.toUpperCase();
                        if (preparedWidget.currentRow[tableHistoryPk]) {
                            for (var i=0; i < data.dataset.columnsToReturn.length; i++) {
                                if (!Util.isUndefined(data.dataset.columnsToReturn[i][tableHistoryPk])) {
                                    preparedWidget.currentRow[tableHistoryPk] = data.dataset.columnsToReturn[i][tableHistoryPk];
                                }
                            }
                        }
                        preparedWidget.backupRow = null;
                        preparedWidget.view();
                    }
                    preparedWidget.reload();
                    
                }else if( data.dataset.operacaoBloqueada ){
                    ScreenService.showMessage(data.dataset.operacaoBloqueada.MENSAGEM, 'ERROR');
                } else {
                    ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                }
            }.bind(this)).
            catch(function(e) {
                var error;
                if(e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
    
                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
    };
    
    this.verificaMovimentacaoeHierarquia = function(args){
        var widget = templateManager.container.getWidget('estrutura');
        if (widget.isValid()) {
            restEngine.post('product#/verificaMovimentacaoeHierarquia', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                then(function (data) {
                    if (data.messages && data.messages[0].type === 'E') {
                        ScreenService.showMessage("Operação bloqueada. Foram encontradas movimentações e/ou hierarquias utilizando esta estrutura.", 'ERROR');
                        widget.currentRow.NRTIPOESTRUTURA = widget.backupRow.NRTIPOESTRUTURA;
                        widget.currentRow.NMTIPOESTRUTURA = widget.backupRow.NMTIPOESTRUTURA;
                    } else {
                        return;
                    }
                }.bind(this)).
                catch(function(e) {
                    var error;
                    if(e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;

                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
            }
    };
    
    this.remover = function(args) {
        ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
        var widget = templateManager.container.getActiveWidget();
        if (widget.isValid()) {
            widget.currentRow.__is_new = false;
            restEngine.post('product#/deleteEstrutura', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                then(function (data) {
                    if (data.messages) {
                        ScreenService.showMessage(Messages.REMOVE_ROW_ERROR + '. ' + data.messages[0].message, data.messages[0].type);
                    } else {
                        ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    }
                }).
                catch(function(e) {
                    var error;
                    if(e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;

                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
            }
        }, null);
    };
    
    this.setEstruturaSup = function() {
        var widget = templateManager.container.getActiveWidget();
        widget.dataSourceFilter[2] = {"name": "NRESTRUTSUPERIOR", "operator": "=", "value": widget.parent.parent.currentRow.NRESTRUTURAM};
        widget.reload();
    };
    
    this.setDataSourceFilterAbaEstrutRelSup = function(){
        var widgetMain = templateManager.container.getWidget('estrutura');
        
        var abaEstrutRel = templateManager.container.getWidget('estruturasRelacionadas');
        abaEstrutRel.dataSourceFilter.forEach(function(filter){
            if(filter.name == 'NRESTRUTURAMSUP') filter.value = widgetMain.currentRow.NRESTRUTURAM;
        });

        var abaEstrutSup = templateManager.container.getWidget('estruturasSup');
        abaEstrutSup.dataSourceFilter.forEach(function(filter){
            if(filter.name == 'NRESTRUTURAMREL') filter.value = widgetMain.currentRow.NRESTRUTURAM;
        });
    };

    this.setDataSourceFilterFieldTpHierarquia = function(){
        var widgetMain = templateManager.container.getWidget('estrutura');
        var abaEstrutRel = templateManager.container.getWidget('estruturasRelacionadas');
        abaEstrutRel.getField('NMTIPOHIERARQORG').dataSourceFilter.forEach(function(filter){
            if(filter.name == 'NRTIPOESTRUTSUP') filter.value = widgetMain.currentRow.NRTIPOESTRUTURA;
        });        

        var abaEstrutSup = templateManager.container.getWidget('estruturasSup');
        abaEstrutSup.getField('NMTIPOHIERARQORG').dataSourceFilter.forEach(function(filter){
            if(filter.name == 'NRTIPOESTRUTREL') filter.value = widgetMain.currentRow.NRTIPOESTRUTURA;
        });        
    };
    
    this.setDefaultValueEstrutWidEstrutOnEnter = function(name){
        var widgetMain = templateManager.container.getWidget('estrutura');
        var abaEstrut = templateManager.container.getWidget(name);
        
        if( name == 'estruturasRelacionadas' ){
            abaEstrut.getField('NRESTRUTURAMSUP').setValue(widgetMain.currentRow.NRESTRUTURAM);
            abaEstrut.getField('NMESTRUTURAMSUP').setValue(widgetMain.currentRow.NMESTRUTURAM);
        }else if( name == 'estruturasSup' ){
            abaEstrut.getField('NRESTRUTURAMREL').setValue(widgetMain.currentRow.NRESTRUTURAM);
            abaEstrut.getField('NMESTRUTURAMREL').setValue(widgetMain.currentRow.NMESTRUTURAM);
        }    
    };
    
    this.habilitaEstruturasHierarquiaGrid = function(args, tab){
        var widget = args.owner.field.widget;

        if(widget.currentRow.NMTIPOHIERARQORG){
            
            if(this.tpHierarquiaAntigo != widget.currentRow.NRTIPOHIERARQORG){
                if(tab == 'estruturasRelacionadas'){
                    widget.currentRow.NMESTRUTURAMREL = "";
                    widget.currentRow.NRESTRUTURAMREL = "";
                }else if(tab == 'estruturasSup'){
                    widget.currentRow.NMESTRUTURAMSUP = "";
                    widget.currentRow.NRESTRUTURAMSUP = "";
                }
            }
            
            this.tpHierarquiaAntigo = widget.currentRow.NRTIPOHIERARQORG;
    
            if(tab == 'estruturasRelacionadas'){ 
                widget.getField('NMESTRUTURAMREL').readOnly = false;    
                widget.getField('NMESTRUTURAMREL').validations = {required:true};
                widget.getField('NMESTRUTURAMREL').dataSourceFilter.forEach(function(obj){
                    if(obj.name == 'NRTIPOESTRUTURA' ) obj.value = widget.currentRow.NRTIPOESTRUTREL;
                });
        
            }else if(tab == 'estruturasSup'){
                widget.getField('NMESTRUTURAMSUP').readOnly = false;            
                if(widget.currentRow.NRTIPOESTRUTREL == widget.currentRow.NRTIPOESTRUTSUP || !widget.currentRow.NRTIPOESTRUTSUP){
                    widget.getField('NMESTRUTURAMSUP').validations = {};
                    widget.getField('NMESTRUTURAMSUP').dataSourceFilter.forEach(function(obj){
                        if(obj.name == 'NRTIPOESTRUTURA' ) obj.value = widget.currentRow.NRTIPOESTRUTREL;
                    });
                }else{
                    widget.getField('NMESTRUTURAMSUP').validations = {required:true};
                    widget.getField('NMESTRUTURAMSUP').dataSourceFilter.forEach(function(obj){
                        if(obj.name == 'NRTIPOESTRUTURA' ) obj.value = widget.currentRow.NRTIPOESTRUTSUP;
                    });
                }
            } 

        }else if(tab == 'estruturasRelacionadas'){ 
            widget.currentRow.NRESTRUTURAMREL = "";
            widget.currentRow.NMESTRUTURAMREL = "";
         
            widget.getField('NMESTRUTURAMREL').validations = {};
            widget.getField('NMESTRUTURAMREL').readOnly = true;

        }else if(tab == 'estruturasSup'){
            widget.currentRow.NRESTRUTURAMSUP = "";
            widget.currentRow.NMESTRUTURAMSUP = "";
            
            widget.getField('NMESTRUTURAMSUP').validations = {};
            widget.getField('NMESTRUTURAMSUP').readOnly = true;
        } 
        
    };
    
    this.readOnlyFieldsEstruturas = function(widget, action, tab){
        if(action == 'editar'){
            if(tab == 'estruturasRelacionadas'){
                if(widget.currentRow.NMESTRUTURAMREL){
                    widget.getField('NMESTRUTURAMREL').readOnly = false;
                    widget.getField('NMESTRUTURAMREL').validations = {required:true};
                }else{
                    widget.getField('NMESTRUTURAMREL').readOnly = true;
                    widget.getField('NMESTRUTURAMREL').validations = {};
                }
            }else if(tab == 'estruturasSup'){
                if(widget.currentRow.NMESTRUTURAMSUP){
                    widget.getField('NMESTRUTURAMSUP').readOnly = false;
                    widget.getField('NMESTRUTURAMSUP').validations = {required:true};
                }else{
                    widget.getField('NMESTRUTURAMSUP').readOnly = true;
                    widget.getField('NMESTRUTURAMSUP').validations = {};
                }
            }    
        }else if(action == 'adicionar'){
            if(tab == 'estruturasRelacionadas') widget.getField('NMESTRUTURAMREL').readOnly = true;
            if(tab == 'estruturasSup') widget.getField('NMESTRUTURAMSUP').readOnly = true;
        }
    };
    
    this.openPopupImportXML = function(){
        var popup = templateManager.container.getWidget('popupImportacaoXML');
        ABUtilController.masterDetailOpenPopup(popup);
        popup.newRow();
    };

}

Configuration(function(ContextRegister) {
    ContextRegister.register('EstruturaController', EstruturaController);
});

// FILE: assets/js/controllers/EtniaController.js
function EtniaController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, General,Messages) {

    this.adicionarRow = function(args) {
        var widget = args.owner.widget;
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
    };

	this.setEtnia = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
                if (!widget.backupRow) {
                    widget.currentRow.__is_new = true;
                } else {
                    widget.currentRow.__is_new = false;
                }
                restEngine.post('product#/setEtnia', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                    then(function (data) {
                        if (data.notifications[0].type === "success") {
                            ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                            if (widget.currentRow.__is_new) {
                                ABUtilController.masterDetailVoltarList(widget);
                                widget.reload();
                            } else {
                                ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                                widget.backupRow = null;
                                widget.view();
                            }
                        } else {
                            ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                        }
                    }).
                    catch(function(e) {
                        var error;
                        if(e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;
                            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    });
            }
    };
    
    this.deleteEtnia = function(args) {
    ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
        var widget = args.owner.widget;
        widget.currentRow.__is_new = false;
        restEngine.post('product#/deleteEtnia', {'requestType':'DataSet','dataset':[widget.currentRow]}).
            then(function(data){
                if(data.notifications[0].type === "success"){
                    ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                    ABUtilController.masterDetailVoltarList(widget);
                    widget.reload();
                } else {
                    ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                }
            }).
            catch(function(e) {
                var error;
                if(e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
        }, null);
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('EtniaController', EtniaController);
});

// FILE: assets/js/controllers/EventoController.js
function EventoController(ScreenService, templateManager,localStorageEngine, ZhUtil, restEngine, ABUtilController, HcmRepository, Messages, General) {

    var self = this;
    
    this.NREVENTOM = null;
    this.NRREGRAM = null;
    this.modoListRegra = false;
    
    this.adicionarRow = function(args) {
        var widget = args.owner.widget;
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
    };
    
    this.setNreventomWidgetFilha = function(){
        var widget = templateManager.container.getWidget('Evento');
        if(widget.currentRow.NREVENTOM){
            this.NREVENTOM = widget.currentRow.NREVENTOM;  
        }else{
            this.NREVENTOM = null;
        }
    };
    
    this.verificaDigitoArredondamento = function() {
        var widget = templateManager.container.getWidget('Evento');
        if(widget.getField('NRDIGARREDONDA')){
            if( widget.currentRow.NRDIGARREDONDA.match(/[a-z]/i) ){
                widget.currentRow.NRDIGARREDONDA = undefined;
                widget.getField('NRDIGARREDONDA').help = 'Esse campo só aceita valores numéricos!';
            } else if( widget.currentRow.NRDIGARREDONDA.match(/[.|-|/]/g) ){
                widget.currentRow.NRDIGARREDONDA = widget.currentRow.NRDIGARREDONDA.replace(/[.|-|/]/g, '');
            }
        }
    };
    
    this.validaMoveRow = function(){
        var widget = templateManager.container.getActiveWidget();
        if(widget.name != 'Evento'){
            ScreenService.closeSwipe(1);
        }
    };
    
    this.setNrregramWidgetFilha = function(){
        var widget = templateManager.container.getWidget('regras_evento');
        if(widget.currentRow.NRREGRAM){
            this.NRREGRAM = widget.currentRow.NRREGRAM;  
        }else{
            this.NRREGRAM = null;
        }
    };
    
    this.validaIncidenciasEventos = function(campo){
        var widget = templateManager.container.getActiveWidget();
        
        if(campo == 'IDREFHORAEXTRA' && widget.currentRow.IDREFHORAEXTRA == 'S'){
            widget.currentRow.IDINCIDEDSRHORAEXT = 'S';
        }
        if(campo == 'IDREFADICIONOTURN' && widget.currentRow.IDREFADICIONOTURN == 'S'){
            widget.currentRow.IDINCIDEDSRADICNOT = 'S';
        }
        if(campo == 'IDPAGTOOBRIG' && widget.currentRow.IDPAGTOOBRIG == 'S'){
            widget.currentRow.NRPRIORESTORNO = 999;
        }
    };
    
    this.reloadWidgetFilhas = function(nomeWidgetPai){
        var widget =  templateManager.container.getActiveWidget();
        if(nomeWidgetPai === "regras_evento" || nomeWidgetPai === "incidencia_eventos" || nomeWidgetPai === "parametrizacaoESocial_evento"){
            var nrEventom = widget.dataSource.getFirstRow() ? widget.dataSource.getFirstRow().NREVENTOM : null;
            if(nrEventom != this.NREVENTOM || !nrEventom){
                widget.reload();
            }
        } else if(nomeWidgetPai == "ponto_regra_evento"){
            var nrRegram = widget.dataSource.getFirstRow() ? widget.dataSource.getFirstRow().NRREGRAM : null;
            if(nrRegram != this.NRREGRAM || !nrRegram){
                widget.reload();
            }
        } 
    };
    
    this.setListWidgetRegra = function(){
        var widgetAtiva = templateManager.container.getActiveWidget();
        if(this.modoListRegra && widgetAtiva.lastActiveWidget.name != 'ponto_regra_evento'){
            widgetAtiva.list();
        }
        this.modoListRegra = false;
    };
    
    this.setModoListWidgetRegra = function(){
        this.modoListRegra = true;    
    };
    
    //rotina que valida o preenchimento das widgets integração contábil de acordo com as variáveis HCM_IDREALIZACONTAB e HCM_IDREALIZADESPESA do localStorage
    this.validaCamposCtblEstaoInvalidos = function(args){
        var widget = templateManager.container.getWidget('Evento');
        var idTipoEvento = widget.currentRow.IDTIPOEVENTO;
        if((idTipoEvento == 'PROVENTO' || idTipoEvento == 'DESCONTO' || idTipoEvento == 'ENCARGO') && widget.currentRow.__is_new){
            var camposOperacional = ["NMCONTCTBLDEBOPER", "DSHISTPADRDEBOPER", "NMCONTCTBLCREOPER", "DSHISTPADRCREOPER"];
            var camposAdministrativa = ["NMCONTCTBLDEBADM", "DSHISTPADRDEBADM", "NMCONTCTBLCREADM", "DSHISTPADRCREADM"];
            
            var valicacaoIdRealizaContab = null;
            var valicacaoIdRealizaDespesa = null;
            
            var validacaoCamposOper = true;
            var validacaoCamposAdm = true;
            
            valicacaoIdRealizaContab = true;
            if(getLocalVar('HCM_IDREALIZACONTAB') == 'S'){
                        
                camposOperacional.forEach(function(name){
                   if( !widget.getField(name).value() ){
                       validacaoCamposOper = false;
                   }
                });
                
                camposAdministrativa.forEach(function(name){
                    if( !widget.getField(name).value() ){
                        validacaoCamposAdm = false;
                    }
                });
                
                valicacaoIdRealizaContab =  validacaoCamposOper || validacaoCamposAdm;
            }
            
            valicacaoIdRealizaDespesa = true;
            if(getLocalVar('HCM_IDREALIZADESPESA') == 'S'){
                if( ( ( (!!widget.getField('DSDESPADMFATADM').value() && !validacaoCamposAdm)  || (!!widget.getField('DSDESPADMFATOPER').value() && !validacaoCamposOper)) || 
                    (!widget.getField('DSDESPADMFATADM').value()  && !widget.getField('DSDESPADMFATOPER').value()))                                                        && 
                  !(((validacaoCamposAdm || validacaoCamposOper) && !(validacaoCamposAdm && validacaoCamposOper)) && (!!widget.getField('DSDESPADMFATADM').value() && !!widget.getField('DSDESPADMFATOPER').value()))
                ){
                        
                    valicacaoIdRealizaDespesa = false;    
                }
            }
    
            var mensagem = false;
            if(!valicacaoIdRealizaContab || !valicacaoIdRealizaDespesa){
                mensagem = 'Atenção! ';
                if(!valicacaoIdRealizaContab){
                    mensagem += 'O cadastro de pelo menos uma associação contábil é obrigatório';
                }
                
                if(!valicacaoIdRealizaDespesa){
                    if(mensagem == 'Atenção! ') {
                        mensagem += 'O cadastro de uma Despesa Administrativa junto à uma associação contábil é obrigatório';
                    } else {
                        mensagem += '. O cadastro de uma Despesa Administrativa junto a associação também é obrigatório';
                    }
                }
            }
            
            return mensagem;
        } else {
            return false;
        }
        
    };
    
    this.salvaAssociacao = function(preparedWidget,data){
        preparedWidget.currentRow.NREVENTOH = data.dataset.columnsToReturn[0].NREVENTOH;
        restEngine.post('product#/salvaAssocEvento', {'requestType': 'DataSet', 'dataset': [preparedWidget.currentRow]}).
            then(function (dataAssoc) {
                ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                self.mudaVisibilidadeFieldsIntegracao(false);
                var widget =  templateManager.container.getActiveWidget();
                ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                if (preparedWidget.currentRow.__is_new) {
                    ABUtilController.masterDetailVoltarList(preparedWidget);
                    preparedWidget.reload();
                } else {
                    ABUtilController.mudarVisibilidadeWidgets(preparedWidget.widgets, true);
                    var tableHistoryPk = preparedWidget.saveHistoryTable.__table_history_pk.toUpperCase();
                    if (preparedWidget.currentRow[tableHistoryPk]) {
                        for (var i = 0; i < data.dataset.columnsToReturn.length; i++) {
                            if (!Util.isUndefined(data.dataset.columnsToReturn[i][tableHistoryPk])) {
                                preparedWidget.currentRow[tableHistoryPk] = data.dataset.columnsToReturn[i][tableHistoryPk];
                            }
                        }
                    }
                    preparedWidget.backupRow = null;
                    preparedWidget.view();
                }
        }).
            catch(function(e) {
                var error;
                if(e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
            
    };
    
    this.prepareSaveMasterHistory = function(widget) {
        var paramsNewCode = widget.paramsNewCode;
        var saveHistoryTable = widget.saveHistoryTable;
        var columnsToSave = widget.__columns_to_return;
        var historyField = saveHistoryTable.__table_competenc.toUpperCase();

        if (paramsNewCode && paramsNewCode.__is_new_code) {
            widget.currentRow.__new_code_pk = paramsNewCode.__new_code_pk;
            widget.currentRow.__table_pk = paramsNewCode.__table_pk;
            widget.currentRow.__new_code_length = paramsNewCode.__new_code_length || 5;
        }
        if (!Util.isUndefined(paramsNewCode.__use_org_padrao) && paramsNewCode.__use_org_padrao) {
            widget.currentRow.__nrorgpadrao = getLocalVar('HCM_NRORG_PADRAO');
        }

        if (paramsNewCode) {
            widget.currentRow.saveHistoryTable = saveHistoryTable;
        }

        if (columnsToSave) {
            widget.currentRow.__columns_to_return = columnsToSave;
        }

        if (!widget.backupRow) {
            widget.currentRow.__is_new = true;
        } else {
            widget.currentRow.__is_new = false;
            widget.currentRow[historyField] = getLocalVar('HCM_DTCOMPETENCIA_OPER');
        }

        return widget;
    };

    
    this.saveMasterDetailMasterHistory = function(widget) {

        var preparedWidget = this.prepareSaveMasterHistory(widget);
        var masterTable = preparedWidget.paramsNewCode.__new_code_pk;

        restEngine.post('product#/saveCrud', {
            'requestType': 'DataSet',
            'dataset': [preparedWidget.currentRow]
        }).
        then(function(data) {
            if(data.dataset.verificaVigenciaEnvio){
                var mensagem = 'Registro possui o(s) evento(s) S-1010 já transmitido para o eSocial com a data de vigência atual. Ao alterar a vigência o mesmo ficará incompatível com o sistema único. Deseja prosseguir com a alteração?';
                ScreenService.showCustomDialog(mensagem, 'CONFIRMATION', null, [{
                    label: ScreenService.i18n("Sim"),
                    code: function(e, deferred) {
                        preparedWidget.currentRow.IDVERIFICAVIGENCIAESO = 'N';
                        this.saveMasterDetailMasterHistory(widget);
                        deferred.resolve(e);
                    }.bind(this)
                  },{
                    label: ScreenService.i18n("Não"),
                    code: function(e, deferred) {
                    preparedWidget.currentRow = preparedWidget.backupRow;
                        preparedWidget.view();
                        deferred.reject(e);
                    }
                }]);
            }else if (data.dataset.columnsToReturn) {
                if(self.possuiAssociacao(widget)){
                    self.salvaAssociacao(preparedWidget,data);
                } else {
                    ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                    self.mudaVisibilidadeFieldsIntegracao(false);
                    ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                    if (preparedWidget.currentRow.__is_new) {
                        ABUtilController.masterDetailVoltarList(preparedWidget);
                        preparedWidget.reload();
                    } else {
                        ABUtilController.mudarVisibilidadeWidgets(preparedWidget.widgets, true);
                        var tableHistoryPk = preparedWidget.saveHistoryTable.__table_history_pk.toUpperCase();
                        if (preparedWidget.currentRow[tableHistoryPk]) {
                            for (var i = 0; i < data.dataset.columnsToReturn.length; i++) {
                                if (!Util.isUndefined(data.dataset.columnsToReturn[i][tableHistoryPk])) {
                                    preparedWidget.currentRow[tableHistoryPk] = data.dataset.columnsToReturn[i][tableHistoryPk];
                                }
                            }
                        }
                        preparedWidget.backupRow = null;
                        preparedWidget.view();
                    }
                }
            } else {
                ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
            }
        }.bind(this)).
        catch(function(e) {
            var error;
            if (e.data.error === undefined)
                error = e;
            else
                error = e.data.error;

            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
        });
    };
    
    this.salvaEvento = function(args){
        var widget = args.owner.widget;
        widget.currentRow.VRPISOEVENTO = General.valueToFloat(widget.currentRow.VRPISOEVENTO);
        widget.currentRow.VRTETOEVENTO = General.valueToFloat(widget.currentRow.VRTETOEVENTO);  
        widget.currentRow.IDVERIFICAVIGENCIAESO = 'S';
        widget.currentRow.NMEVENTO = 'S-1010';
        widget.currentRow.NRCHAVE = widget.currentRow.NREVENTOM;
        if(ABUtilController.validaDtIniMenorIgualDtFin(widget.currentRow.DTINIVIGENCIA,widget.currentRow.DTFIMVIGENCIA)){
            this.saveMasterDetailMasterHistory(widget);
        }else{
            ScreenService.showMessage(Messages.DTINI_POST_DTFIM_ERROR);
            return false;
        }    
    };

    
    this.salvar = function(args) {
        var widget = args.owner.widget;
        var camposIntegCrblEstaoInvalidos = this.validaCamposCtblEstaoInvalidos();
        if (widget.isValid() && !camposIntegCrblEstaoInvalidos) {
            if(this.validaExclusaoIncidencias(args)){
                ScreenService.confirmMessage(this.validaExclusaoIncidencias(args), null, function () {
                    this.salvaEvento(args);
                }.bind(this), null);
            } else {
                this.salvaEvento(args);
            }
        } else if(camposIntegCrblEstaoInvalidos){
            ScreenService.showMessage(camposIntegCrblEstaoInvalidos, "E");
        }
    };
    
    this.remover = function(args) {
    ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
        var widget = args.owner.widget;
        if (widget.isValid()) {
            widget.currentRow.__is_new = false;
            restEngine.post('product#/deleteEvento', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                then(function (data) {
                    if (data.messages) {
                        ScreenService.showMessage(Messages.REMOVE_ROW_ERROR + '. ' + data.messages[0].message, data.messages[0].type);
                    } else {
                        ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    }
                }).
                catch(function(e) {
                    var error;
                    if(e.data.error === undefined)
                        error = e;
                     else
                        error = e.data.error;
                        
                    if(e.data.errorCode === 5){
                        ScreenService.showMessage(error, 'ERROR');
                    } else {
                        ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    }
                      
                });
            }
        },null);
    };
    this.validaPisoTeto = function(args){
        var currentRow = args.owner.field.widget.currentRow;
        
        var piso = General.valueToFloat(currentRow.VRPISOEVENTO);
        var teto = General.valueToFloat(currentRow.VRTETOEVENTO);  
        
        if(isNaN(piso)){
            piso = "0";
            currentRow.VRPISOEVENTO = piso;
        }
        if(isNaN(teto)){
            teto="9999999999";
            currentRow.VRTETOEVENTO = teto;
        }
        if(piso>teto){
            ScreenService.showMessage(Messages.PISO_MAIOR_QUE_TETO);
            piso = "0";
            currentRow.VRPISOEVENTO = piso;
            
        }
    };
    
    this.possuiAssociacao = function(widget){
        if(!widget.currentRow.CDCONTCTBLDEBOPER  && 
           !widget.currentRow.CDHISTPADRDEBOPER  &&
           !widget.currentRow.CDCONTCTBLCREOPER  && 
           !widget.currentRow.CDHISTPADRCREOPER  &&
           !widget.currentRow.CDDESPADMFATOPER   &&
           !widget.currentRow.CDCONTCTBLDEBADM   && 
           !widget.currentRow.CDHISTPADRDEBADM   &&
           !widget.currentRow.CDCONTCTBLCREADM   && 
           !widget.currentRow.CDHISTPADRCREADM   &&
           !widget.currentRow.CDDESPADMFATADM ){
            return false;
        }else{
            return true;
        }
    };
    
    this.widgetsvisiblefalse = function(args) {
        var widget = args.owner.widget;
        widget.widgets[0].showAsTab = false;  
    };
    
    this.openPopupCadastroAutomatico = function(args){
        var widgetFilter = templateManager.container.getWidget('cadRubricaEvento');
        widgetFilter.applyDefaultValue();
        ScreenService.openPopup(widgetFilter);
    };
    
    this.cadAutoEvento = function(args, nameWidgetPrincipal) {
        var widget = args.owner.widget;
        var widgetPrincipal = templateManager.container.getWidget(nameWidgetPrincipal);

        if (widget.isValid()) {
            widget.currentRow.VRPISOEVENTO = General.valueToFloat(widget.currentRow.VRPISOEVENTO);
            widget.currentRow.VRTETOEVENTO = General.valueToFloat(widget.currentRow.VRTETOEVENTO);  
            restEngine.post('product#/cadAutoEvento', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                then(function (data) {
                    if(data.notifications[0].type === "success"){
                        ScreenService.showMessage(Messages.CADASTRO_AUTOMATICO_SUCCESS, 'SUCCESS');
                        ScreenService.closePopup();
                        templateManager.container.getWidget(widgetPrincipal).activate();
                        templateManager.container.getWidget(widgetPrincipal).reload();
                    }else if(data.notifications[0].message === 'HCM01037_FPA_TODOS_EVENTOS_SELECIONADO')
                        ScreenService.showMessage(Messages.HCM01037_FPA_TODOS_EVENTOS_SELECIONADO, 'ERROR');
                    else
                        ScreenService.showMessage(Messages.SAVE_ROW_ERROR); 
                }).
                catch(function(e) {
                    var error;
                    if(e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;

                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
        }
    };

    this.widgetsvisibletrue = function(args) {
        var widget = args.owner.widget;
        widget.widgets[0].showAsTab = true;
    };
    
    this.filtrarIncidencia = function() {
        
        var evento = templateManager.container.getWidget("Evento").currentRow.NREVENTOM;
        var incidencia = templateManager.container.getWidget("incidencia_eventos");
        
        incidencia.dataSourceFilter[3] =
			{
				"name": "NREVENTOM",
				"operator": "=",
				"value": evento
			}
		;
    };
    
    this.masterDetailNewRow = function(widget) {
        ABUtilController.mudarVisibilidadeWidgets(widget.widgets, false);
        widget.newRow();
        widget.currentRow.NREVENTOM = widget.parent.parent.currentRow.NREVENTOM;
        widget.currentRow.NMEVENTOH = widget.parent.parent.currentRow.NMEVENTOH;
    };
    
    this.checaTiposAssociacaoContabil = function(field){
      var widget = templateManager.container.getWidget('Evento');
      if(widget.getField('NRTPEVENTOCTBLADM').value() == null && widget.getField('NRTPEVENTOCTBLOPER').value() == null){
        ScreenService.showMessage("O campo de Tipo de Associação Contábil não pode ser vazio em Integração Contábil Operacional e Integração Contábil Administrativa simultâneamente"); 
        if(field.name == 'NRTPEVENTOCTBLADM'){
            field.value(1);
        } else if(field.name == 'NRTPEVENTOCTBLOPER'){
            field.value(2);
        }
      }  
      
    };
    
    this.mudaVisibilidadeFieldsIntegracao = function(entrouModoAdicionar){
        //se entrouModoAdicionar = true significa que a função foi chamada ao clicar em adicionar, caso contrario a função é chamada ao sair
        //do form (salvar ou cancelar) pra setar todos os isVisible pra falso de novo pra não afetar a pesquisa, pois os campos não estão na query
        //de pesquisa
        
        var widget = templateManager.container.getWidget('Evento');
        var camposOperacional = ["CDCONTCTBLDEBOPER", "NMCONTCTBLDEBOPER", "CDHISTPADRDEBOPER", "DSHISTPADRDEBOPER", "CDCONTCTBLCREOPER", "NMCONTCTBLCREOPER",
                      "CDHISTPADRCREOPER", "DSHISTPADRCREOPER", "CDDESPADMFATOPER", "DSDESPADMFATOPER", "NRTPEVENTOCTBLOPER"];
        var camposAdministrativa = ["CDCONTCTBLDEBADM", "NMCONTCTBLDEBADM", "CDHISTPADRDEBADM", "DSHISTPADRDEBADM", "CDCONTCTBLCREADM", "NMCONTCTBLCREADM",
                      "CDHISTPADRCREADM", "DSHISTPADRCREADM", "CDDESPADMFATADM", "DSDESPADMFATADM", "NRTPEVENTOCTBLADM"];
        
        var visibilidade = entrouModoAdicionar ? widget.currentRow.__is_new : entrouModoAdicionar;
                
        camposOperacional.forEach(function(name){
            widget.getField(name).isVisible = visibilidade;
        });
        
        camposAdministrativa.forEach(function(name){
            widget.getField(name).isVisible = visibilidade;
        });
        
    };
    
    this.alteraValorBackupRow = function(widget, valor){
        widget = templateManager.container.getWidget('Evento');
        if(widget.backupRow){
            widget.backupRow = valor;
        }
    };
    
    this.validaExclusaoIncidencias = function(args){
        var widget = ABUtilController.checkWidget(args);
        if(!widget.currentRow.__is_new){
            var backupRow = widget.backupRow;
            var camposTipoIncidencia = ['NRINCIDCP', 'NRINCIDFGTS', 'NRINCIDIRRF', 'IDREPDECTERC', 'IDREPFERIAS', 'IDINCIDEPERIC', 'IDINCIDEINSALUB'];
            var mensagensIncidencias = [];
            
            camposTipoIncidencia.forEach(function(campoTipoIncidencia){
                if(backupRow && ((widget.currentRow[campoTipoIncidencia] == 'N' && backupRow[campoTipoIncidencia] != 'N') || (widget.currentRow[campoTipoIncidencia] == 1 && backupRow[campoTipoIncidencia] != 1))){
                    if(campoTipoIncidencia === 'NRINCIDCP'){
                        mensagensIncidencias.push(
                            '<br />INCIDE PARA O INSS NO CÁLCULO DA FOLHA',                   
                            '<br />INCIDE PARA O INSS NO CÁLCULO DA RESCISÃO'
                        );
                    } else if(campoTipoIncidencia === 'NRINCIDFGTS'){
                        mensagensIncidencias.push(
                            '<br />INCIDE PARA O FGTS NO CÁLCULO DA FOLHA',                   
                            '<br />INCIDE PARA O FGTS NO CÁLCULO DA RESCISÃO'
                        );
                    } else if(campoTipoIncidencia === 'NRINCIDIRRF'){
                        mensagensIncidencias.push(
                             '<br />INCIDE PARA O IRRF NO CÁLCULO DA FOLHA',                   
                             '<br />INCIDE PARA O IRRF NO CÁLCULO DA RESCISÃO'
                        );
                    } else if(campoTipoIncidencia === 'IDREPDECTERC'){
                        mensagensIncidencias.push(
                            '<br />INCIDE PARA O CÁLCULO DE 13º SALÁRIO'    
                        );
                    } else if(campoTipoIncidencia === 'IDREPFERIAS'){
                        mensagensIncidencias.push(
                            '<br />INCIDE PARA O CÁLCULO DE FÉRIAS'
                        );
                    }else if(campoTipoIncidencia === 'IDINCIDEPERIC'){
                        mensagensIncidencias.push(
                            '<br />- INCIDE PARA O ADICIONAL DE PERICULOSIDADE'
                        );
                    }else if(campoTipoIncidencia === 'IDINCIDEINSALUB'){
                        mensagensIncidencias.push(
                            '<br />INCIDE PARA O ADICIONAL DE INSALUBRIDADE'
                        );
                    }else if(campoTipoIncidencia === 'IDINCIDEPENSALIM'){
                        mensagensIncidencias.push(
                            '<br />INCIDE PARA PENSÃO JUDICIAL',
                            '<br />INCIDÊNCIA PENSÃO'
                        );
                    }else if(campoTipoIncidencia === 'IDINCIDEPENSALIMFE'){
                        mensagensIncidencias.push(
                            '<br />INCIDE PARA PENSÃO JUDICIAL',
                            '<br />INCIDÊNCIA PARA PENSÃO NAS FÉRIAS'
                        );
                    }else if(campoTipoIncidencia === 'IDINCIDEDSRHORAEXT'){
                        mensagensIncidencias.push(
                            '<br />INCIDE PARA O CALCULO DO REFLEXO DE HORA EXTRA PARA O RSR'
                        );
                    }else if(campoTipoIncidencia === 'IDINCIDEDSRADICNOT'){
                        mensagensIncidencias.push(
                            '<br />- INCIDE PARA O CALCULO DO REFLEXO DO ADICIONAL NOTURNO'
                        );
                    }else if(campoTipoIncidencia === 'IDINCIDECSIND'){
                        mensagensIncidencias.push(
                            '<br />INCIDE PARA A CONTRIBUIÇÃO SINDICAL'
                        );
                    }else if(campoTipoIncidencia === 'IDSALARIOFAMILIA'){
                        mensagensIncidencias.push(
                            '<br />INCIDE PARA O SALÁRIO FAMÍLIA'
                        );
                    }else if(campoTipoIncidencia === 'IDDEDUCAOINSS'){
                        mensagensIncidencias.push(
                            '<br />Outras deduções do INSS'
                        );
                    }
                }
            });
            if(mensagensIncidencias.length > 0){
                return "Alerta! Ao salvar o evento com esse valor, as seguintes incidências: " + mensagensIncidencias + "<br />cadastradas serão excluídas! Deseja continuar?";
            } else { 
                return false; 
            }
        }
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('EventoController', EventoController);
});

// FILE: assets/js/controllers/EventoDeParaController.js
function EventoDeParaController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, General, Messages, $window) {

    this.adicionarRow = function(args) {
        var widget = args.owner.widget;
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
    };

    this.setEventoDePara = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
            if (!widget.backupRow) {
                widget.currentRow.__is_new = true;
            }
            else {
                widget.currentRow.__is_new = false;
            }
            restEngine.post('/setEventoDePara', {
                'requestType': 'DataSet',
                'dataset': [widget.currentRow]
            }).
            then(function(data) {
                if (data.notifications[0].type === "success") {
                    ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                    if (widget.currentRow.__is_new) {
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    }
                    else {
                        widget.backupRow = null;
                        widget.view();
                    }
                }
                else {
                    ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                }
            }).
            catch(function(e) {
                var error;
                if (e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
        }
    };

    this.deleteEventoDePara = function(args) {
        ScreenService.confirmMessage('Deseja realmente excluir o arquivo ?', 'CONFIRMATION',
            function() {
                var widget = args.owner.widget;
                widget.currentRow.__is_new = false;
                restEngine.post('/deleteEventoDePara', {
                    'requestType': 'DataSet',
                    'dataset': [widget.currentRow]
                }).
                then(function(data) {
                    if (data.messages) {
                        ScreenService.showMessage(data.messages[0].message);
                    }
                    else {
                        if (data.notifications[0].type === "success") {
                            ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                            ABUtilController.masterDetailVoltarList(widget);
                            widget.reload();
                        }
                        else {
                            ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                        }
                    }
                }).
                catch(function(e) {
                    var error;
                    if (e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
            });
    };


}
Configuration(function(ContextRegister) {
    ContextRegister.register('EventoDeParaController', EventoDeParaController);
});


// FILE: assets/js/controllers/EventoEstruturaController.js
function EventoEstruturaController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, General,Messages) {
    
    /* Controller utilizado também na tela hcm00118_gpe_parametrizacaoSindicado */

    this.adicionarRow = function(args) {
        var widget = args.owner.widget;
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
    };
    
    this.validaFiltro = function(args){
        var widget = args.owner;
        if(args.e.preference.FILTER_ROW.IDTIPOMOVIMENTO === 0){
            widget.dataSourceFilter.push(
                {
                    "name": "IDTIPOMOVIMENTO",
                    "operator": "=",
                    "value":"0"
                }    
            );
        }else{
            widget.dataSourceFilter.forEach(function(filtro, index){
                if(filtro.name === 'IDTIPOMOVIMENTO' && filtro.value === '0'){
                    widget.dataSourceFilter.splice(index, 1);
                }
            });
        }
    };
    
	this.setEventoEstrutura = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
            if (ABUtilController.validaDtIniMenorIgualDtFin(widget.currentRow.DTINIVIGENCIA, widget.currentRow.DTFIMVIGENCIA)) {
                if (!widget.backupRow) {
                    widget.currentRow.__is_new = true;
                } else {
                    widget.currentRow.__is_new = false;
                }
                restEngine.post('product#/setEventoEstrutura', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                    then(function (data) {
                        if (data.messages){ 
                            ScreenService.showMessage(data.messages[0].message, data.messages[0].type);
                        }
                        if (data.notifications[0].type === "success") {
                            ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                            if (widget.currentRow.__is_new) {
                                ABUtilController.masterDetailVoltarList(widget);
                                widget.reload();
                            } else {
                                ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                                widget.backupRow = null;
                                widget.view();
                            }
                        } else {
                            ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                        }
                    }).
                    catch(function(e) {
                        var error;
                        if(e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;
                            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    });
                }   else {
                    ScreenService.showMessage(Messages.DTINI_POST_DTFIM_ERROR);
                    return false;
                }
            }
    };
    
    this.deleteEventoEstrutura = function(args) {
    ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
        var widget = args.owner.widget;
        widget.currentRow.__is_new = false;
        restEngine.post('product#/deleteEventoEstrutura', {'requestType':'DataSet','dataset':[widget.currentRow]}).
            then(function(data){
                if(data.notifications[0].type === "success"){
                    ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                    ABUtilController.masterDetailVoltarList(widget);
                    widget.reload();
                } else {
                    ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                }
            }).
            catch(function(e) {
                var error;
                if(e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
        }, null);
    };
    
    this.validaParcela = function(args){
        var widget = templateManager.container.getActiveWidget();
        if(widget.getField('IDREFGERAR').value() == "PARCELA" ){
            if(widget.currentRow.DTFIMVIGENCIA  == "" || widget.currentRow.DTFIMVIGENCIA  == null) 
            {
                ScreenService.showMessage("Para inserir um Tipo de Referência cujo valor seja igual a Parcela, favor selecionar uma data de Início e Fim de Vigência.");
                return;
            }else{
                this.setEventoEstrutura(args);
            }
        }else{
            this.setEventoEstrutura(args);
        }
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('EventoEstruturaController', EventoEstruturaController);
});

// FILE: assets/js/controllers/EventoUnidadeController.js
function EventoUnidadeController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, General,Messages, HcmConsts) {
    
    var self = this;
    
    this.adicionarRow = function(args) {
        var widget = args.owner.widget;
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
    };
    
    this.setEstruturaSupEvento = function(args) {
        var widget = args.owner;
        templateManager.container.getWidget("evento").dataSourceFilter[0].value = widget.currentRow.NRESTRUTURAM;
    };
    
    this.setEventoUnidade = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
            if (!widget.backupRow) {
                widget.currentRow.__is_new = true;
                widget.currentRow.NRESTRUTURAM = widget.dataSourceFilter[0].value;
            } else {
                widget.currentRow.__is_new = false;
            }
            restEngine.post('product#/setEventoUnidade', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                then(function (data) {
                    if (data.notifications[0].type === "success") {
                        ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                        if (widget.currentRow.__is_new) {
                            ABUtilController.masterDetailVoltarList(widget);
                            widget.reload();
                        } else {
                            ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                            widget.backupRow = null;
                            widget.view();
                        }
                    } else {
                        ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                    }
                }).
                catch(function(e) {
                    var error;
                    if(e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;
                        if(error == 'Este evento já foi inserido para esta unidade!') {
                            ScreenService.showMessage('Este evento já foi inserido para esta unidade!', 'ERROR');
                        } else {
                            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                        }
                });             
                
            }
    };
    
    this.deleteEventoUnidade = function(args) {
    ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
        var widget = args.owner.widget;
        widget.currentRow.__is_new = false;
        restEngine.post('product#/deleteEventoUnidade', {'requestType':'DataSet','dataset':[widget.currentRow]}).
            then(function(data){
                if(data.notifications[0].type === "success"){
                    ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                    ABUtilController.masterDetailVoltarList(widget);
                    widget.reload();
                } else {
                    ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                }
            }).
            catch(function(e) {
                var error;
                if(e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
        }, null);
    };
    
    this.openPopupCadAutomatico = function() {
        var widget = templateManager.container.getWidget('cadAutoEventoUnidade');
        widget.applyDefaultValue();
        ScreenService.openPopup(widget);
    };
    
    this.cadAutoEventoUnidade = function(args) {
        var widget = args.owner.widget;
        var rows = [];
        widget.currentRow.NRESTRUTGEREN_LIST.forEach(function(nrestrut){ 
            widget.currentRow.NREVENTOM_LIST.forEach(function(nrevento){ 
                rows.push({
                    'NRESTRUTURAM': nrestrut,
                    'NREVENTOM': nrevento
                });
            });
        });
        
        if (widget.isValid()) {
            restEngine.post('product#/cadAutoEventoUnidade', {'requestType': 'DataSet', 'dataset': [rows]}).
                then(function (data) {
                    ScreenService.showMessage(Messages.CADASTRO_AUTOMATICO_SUCCESS, 'SUCCESS');
                    ScreenService.closePopup();
                    templateManager.container.getWidget('estruturaEvento').activate();
                    templateManager.container.getWidget('estruturaEvento').reload();
                }).
                catch(function(e) {
                    var error;
                    if(e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;

                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
        }
    };
    

}

Configuration(function(ContextRegister) {
    ContextRegister.register('EventoUnidadeController', EventoUnidadeController);
});

// FILE: assets/js/controllers/ExameController.js
function ExameController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, General,Messages) {

    var self = this;

    this.adicionarRow = function(args) {
        var widget = args.owner.widget;
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
    };
    
    this.widgetsvisiblefalse = function(args) {
        var widget = args.owner.widget;
        widget.widgets[0].showAsTab = false;
        if(widget.widgets.length > 1){
            widget.widgets[1].showAsTab = false;
        }
    };

    this.widgetsvisibletrue = function(args) {
        var widget = args.owner.widget;
        widget.widgets[0].showAsTab = true;
        if(widget.widgets.length > 1){
            widget.widgets[1].showAsTab = false;
        }
    };
    
	this.setExame = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
                if (!widget.backupRow) {
                    widget.currentRow.__is_new = true;
                } else {
                    widget.currentRow.__is_new = false;
                }
                restEngine.post('product#/setExame', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                    then(function (data) {
                        if (data.notifications[0].type === "success") {
                            ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                            self.widgetsvisibletrue(args);
                            if (widget.currentRow.__is_new) {
                                ABUtilController.masterDetailVoltarList(widget);
                                widget.reload();
                            } else {
                                ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                                widget.backupRow = null;
                                widget.view();
                            }
                        } else {
                            ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                        }
                    }).
                    catch(function(e) {
                        var error;
                        if(e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;
                            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    });
            }
    };
    
    this.deleteExame = function(args) {
    ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
        
        var widget = args.owner.widget;
        widget.currentRow.__is_new = false;
        restEngine.post('product#/deleteExame', {'requestType':'DataSet','dataset':[widget.currentRow]}).
            then(function(data){
                if(data.messages){
                    ScreenService.showMessage(data.messages[0].message, data.messages[0].type);
                } else if(data.notifications[0].type === "success"){
                    ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                    ABUtilController.masterDetailVoltarList(widget);
                    widget.reload();
                } else {
                    ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                }
            }).
            catch(function(e) {
                var error;
                if(e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
        
        
    
        
    }, null);
    };

    this.setFiltroExame = function(widget) {
        var nrExame = widget.currentRow.NREXAME;
        templateManager.container.getWidget("itemExame").dataSourceFilter.forEach(function(filter) {
            if (filter.name === 'NREXAME') {
                filter.value = nrExame;
            }
        });
    };

    this.setItemExame = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
            if (!widget.backupRow) {
                widget.currentRow.__is_new = true;
                widget.currentRow.NREXAME = templateManager.container.getWidget("exame").currentRow.NREXAME;
            } else {
                widget.currentRow.__is_new = false;
            }
            restEngine.post('product#/setItemExame', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                then(function (data) {
                    if (data.notifications[0].type === "success") {
                        ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                        self.widgetsvisibletrue(args);
                        if (widget.currentRow.__is_new) {
                            ABUtilController.masterDetailVoltarList(widget);
                            widget.reload();
                        } else {
                            ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                            widget.backupRow = null;
                            widget.view();
                        }
                    } else {
                        ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                    }
                }).
                catch(function(e) {
                    var error;
                    if(e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
        }
    };

    this.deleteItemExame = function(args) {
        ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
        
        var widget = args.owner.widget;
        widget.currentRow.__is_new = false;
        restEngine.post('product#/deleteItemExame', {'requestType':'DataSet','dataset':[widget.currentRow]}).
            then(function(data){
                if(data.messages){
                    ScreenService.showMessage(data.messages[0].message, data.messages[0].type);
                } else if(data.notifications[0].type === "success"){
                    ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                    ABUtilController.masterDetailVoltarList(widget);
                    widget.reload();
                } else {
                    ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                }
            }).
            catch(function(e) {
                var error;
                if(e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
    
        }, null);
    };

    this.setFiltroItemExame = function(widget) {
        var nrItemExame = widget.currentRow.NRITEMEXAME;
        templateManager.container.getWidget("referenciaItemExame").dataSourceFilter.forEach(function(filter) {
            if (filter.name === 'NRITEMEXAME') {
                filter.value = nrItemExame;
            }
        });
    };

    this.setReferenciaItemExame = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
            if (!widget.backupRow) {
                widget.currentRow.__is_new = true;
                widget.currentRow.NRITEMEXAME = templateManager.container.getWidget("itemExame").currentRow.NRITEMEXAME;
            } else {
                widget.currentRow.__is_new = false;
            }
            restEngine.post('product#/setReferenciaItemExame', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                then(function (data) {
                    if (data.notifications[0].type === "success") {
                        ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                        self.widgetsvisibletrue(args);
                        if (widget.currentRow.__is_new) {
                            ABUtilController.masterDetailVoltarList(widget);
                            widget.reload();
                        } else {
                            widget.backupRow = null;
                            widget.view();
                        }
                        self.setFiltroReferenciaItemExame(widget);
                    } else {
                        ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                    }
                }).
                catch(function(e) {
                    var error;
                    if(e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
        }
    };

    this.deleteReferenciaItemExame = function(args) {
        ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
        
        var widget = args.owner.widget;
        widget.currentRow.__is_new = false;
        restEngine.post('product#/deleteReferenciaItemExame', {'requestType':'DataSet','dataset':[widget.currentRow]}).
            then(function(data){
                if(data.messages){
                    ScreenService.showMessage(data.messages[0].message, data.messages[0].type);
                } else if(data.notifications[0].type === "success"){
                    ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                    ABUtilController.masterDetailVoltarList(widget);
                    widget.reload();
                } else {
                    ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                }
            }).
            catch(function(e) {
                var error;
                if(e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
    
        }, null);
        
    };

    self.setFiltroReferenciaItemExame = function(widget) {
        var nrReferenciaItemExame = widget.currentRow.NRREFERENCIAITEMEXAME;
        if (widget.currentRow.IDREFFAIXACLASSIFICA === 'F') {
            templateManager.container.getWidget("faixaRefItemExame").dataSourceFilter.forEach(function (filter) {
                if (filter.name === 'NRREFERENCIAITEMEXAME') {
                    filter.value = nrReferenciaItemExame;
                }
            });
        }
        else if (widget.currentRow.IDREFFAIXACLASSIFICA === 'C') {
            templateManager.container.getWidget("classifRefItemExame").dataSourceFilter.forEach(function (filter) {
                if (filter.name === 'NRREFERENCIAITEMEXAME') {
                    filter.value = nrReferenciaItemExame;
                }
            });
        }
        self.habilitaReferenciaItemExameWidgets();
    };

    self.habilitaReferenciaItemExameWidgets = function() {
        var widget = templateManager.container.getWidget("referenciaItemExame");
        if (widget.currentRow.IDREFFAIXACLASSIFICA === 'F') {
            templateManager.container.getWidget("faixaRefItemExame").isVisible = true;
            templateManager.container.getWidget("classifRefItemExame").isVisible = false;
        }
        else if (widget.currentRow.IDREFFAIXACLASSIFICA === 'C') {
            templateManager.container.getWidget("faixaRefItemExame").isVisible = false;
            templateManager.container.getWidget("classifRefItemExame").isVisible = true;
        }
    };

    this.setFaixaRefItemExame = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
            if (!widget.backupRow) {
                widget.currentRow.__is_new = true;
                widget.currentRow.NRREFERENCIAITEMEXAME = templateManager.container.getWidget("referenciaItemExame").currentRow.NRREFERENCIAITEMEXAME;
            } else {
                widget.currentRow.__is_new = false;
            }
            restEngine.post('product#/setFaixaRefItemExame', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                then(function (data) {
                    if (data.notifications[0].type === "success") {
                        ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                        if (widget.currentRow.__is_new) {
                            ABUtilController.masterDetailVoltarList(widget);
                            widget.reload();
                        } else {
                            ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                            widget.backupRow = null;
                            widget.view();
                        }
                    } else {
                        ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                    }
                }).
                catch(function(e) {
                    var error;
                    if(e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
        }
    };

    this.deleteFaixaRefItemExame = function(args) {
        ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
        
        var widget = args.owner.widget;
        widget.currentRow.__is_new = false;
        restEngine.post('product#/deleteFaixaRefItemExame', {'requestType':'DataSet','dataset':[widget.currentRow]}).
            then(function(data){
                if(data.notifications[0].type === "success"){
                    ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                    ABUtilController.masterDetailVoltarList(widget);
                    widget.reload();
                } else {
                    ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                }
            }).
            catch(function(e) {
                var error;
                if(e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
    
        }, null);
    };

    this.setClassifRefItemExame = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
            if (!widget.backupRow) {
                widget.currentRow.__is_new = true;
                widget.currentRow.NRREFERENCIAITEMEXAME = templateManager.container.getWidget("referenciaItemExame").currentRow.NRREFERENCIAITEMEXAME;
            } else {
                widget.currentRow.__is_new = false;
            }
            restEngine.post('product#/setClassifRefItemExame', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                then(function (data) {
                    if (data.notifications[0].type === "success") {
                        ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                        if (widget.currentRow.__is_new) {
                            ABUtilController.masterDetailVoltarList(widget);
                            widget.reload();
                        } else {
                            ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                            widget.backupRow = null;
                            widget.view();
                        }
                    } else {
                        ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                    }
                }).
                catch(function(e) {
                    var error;
                    if(e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
        }
    };

    this.deleteClassifRefItemExame = function(args) {
        ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
        
        var widget = args.owner.widget;
        widget.currentRow.__is_new = false;
        restEngine.post('product#/deleteClassifRefItemExame', {'requestType':'DataSet','dataset':[widget.currentRow]}).
            then(function(data){
                if(data.notifications[0].type === "success"){
                    ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                    ABUtilController.masterDetailVoltarList(widget);
                    widget.reload();
                } else {
                    ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                }
            }).
            catch(function(e) {
                var error;
                if(e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
    
        }, null);
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('ExameController', ExameController);
});

// FILE: assets/js/controllers/ExcecaoDependenteController.js
function ExcecaoDependenteController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, General,Messages) {

    this.adicionarRow = function(args) {
        var widget = args.owner.widget;
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
    };

	this.setExcecaoDependente = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
                if (!widget.backupRow) {
                    widget.currentRow.__is_new = true;
                } else {
                    widget.currentRow.__is_new = false;
                }
                restEngine.post('product#/setExcecaoDependente', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                    then(function (data) {
                        if (data.notifications[0].type === "success") {
                            ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                            if (widget.currentRow.__is_new) {
                                ABUtilController.masterDetailVoltarList(widget);
                                widget.reload();
                            } else {
                                ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                                widget.backupRow = null;
                                widget.view();
                            }
                        } else {
                            ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                        }
                    }).
                    catch(function(e) {
                        var error;
                        if(e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;
                            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    });
            }
    };
    
    this.deleteExcecaoDependente = function(args) {
    ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
        var widget = args.owner.widget;
        widget.currentRow.__is_new = false;
        restEngine.post('product#/deleteExcecaoDependente', {'requestType':'DataSet','dataset':[widget.currentRow]}).
            then(function(data){
                if(data.notifications[0].type === "success"){
                    ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                    ABUtilController.masterDetailVoltarList(widget);
                    widget.reload();
                } else {
                    ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                }
            }).
            catch(function(e) {
                var error;
                if(e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
        }, null);
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('ExcecaoDependenteController', ExcecaoDependenteController);
});

// FILE: assets/js/controllers/FaixaOcupacaoController.js
function FaixaOcupacaoController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, General,Messages) {

    this.adicionarRow = function(args) {
        var widget = args.owner.widget;
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
    };

	this.setFaixaOcupacao = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
                if (!widget.backupRow) {
                    widget.currentRow.__is_new = true;
                } else {
                    widget.currentRow.__is_new = false;
                }
                restEngine.post('product#/setFaixaOcupacao', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                    then(function (data) {
                        if (data.notifications[0].type === "success") {
                            ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                            if (widget.currentRow.__is_new) {
                                ABUtilController.masterDetailVoltarList(widget);
                                widget.reload();
                            } else {
                                ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                                widget.backupRow = null;
                                widget.view();
                            }
                        } else {
                            ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                        }
                    }).
                    catch(function(e) {
                        var error;
                        if(e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;
                            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    });
            }
    };
    
    this.deleteFaixaOcupacao = function(args) {
         ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
         var widget = args.owner.widget;
        widget.currentRow.__is_new = false;
        restEngine.post('product#/deleteFaixaOcupacao', {'requestType':'DataSet','dataset':[widget.currentRow]}).
            then(function(data){
                if(data.notifications[0].type === "success"){
                    ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                    ABUtilController.masterDetailVoltarList(widget);
                    widget.reload();
                } else {
                    ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                }
            }).
            catch(function(e) {
                var error;
                if(e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
         }, null);
    };
    
    
    this.diferencaSalTotal = function(args) {
        var widget = args.owner.widget;
        var total = 0;
        widget.dataSource.checkedRows.forEach(function(row){
            total+= row.VRDIFERENCA;
        });
        ScreenService.showMessage("Impacto total de aumento dos vínculos selecionados: R$"+total.toFixed(2));
        /*var filtro = [
            {
                "name": "P_NRORG",
                "operator": "=",
                "value": getLocalVar('HCM_NRORG_TRAB')
            },
            {
                "name": "P_DTMESCOMPETENC",
                "operator": "=",
                "value": getLocalVar("HCM_DTCOMPETENCIA_OPER")
            }
        ];
        
        if (widget.currentRow.NRESTRUTLEGAL) {
            filtro.push({
                "name": "NRESTRUTLEGAL",
                "operator": "=",
                "value": widget.currentRow.NRESTRUTLEGAL
            });
        }
        
        if (widget.currentRow.NRESTRUTGEREN) {
            filtro.push({
                "name": "NRESTRUTGEREN",
                "operator": "=",
                "value": widget.currentRow.NRESTRUTGEREN
            });
        }
        
        if (widget.currentRow.NRESTRUTSIND) {
            filtro.push({
                "name": "NRESTRUTSIND",
                "operator": "=",
                "value": widget.currentRow.NRESTRUTSIND
            });
        }
        
        restEngine.post("product#/getDifesalarial", {
            requestType: "FilterData",
                filter: filtro}).
        then(function (data) {
            if(!!data.dataset.getDifesalarial.length){
                var total = 0;
                for( var dife in data.dataset.getDifesalarial) {
                    total += data.dataset.getDifesalarial[dife].VRDIFERENCA;
                }
                ScreenService.showMessage(data.dataset.getDifesalarial.length + " vínculos receberão aumento em um total de R$"+total.toFixed(2));
            } else{
                ScreenService.showMessage("Nenhuma Divergencia de Salário Encontrada!");
            }
        });
        */
            /*restEngine.post("product#/getGozoFerias", {
                    requestType: "FilterData",
                        filter: filtro}).
            then(function (data) {
                
            }*/
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('FaixaOcupacaoController', FaixaOcupacaoController);
});

// FILE: assets/js/controllers/FaltaFeriasController.js
function FaltaFeriasController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, General,Messages) {

    this.adicionarRow = function(args) {
        var widget = args.owner.widget;
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
    };

	this.setFaltaFerias = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
                if (!widget.backupRow) {
                    widget.currentRow.__is_new = true;
                } else {
                    widget.currentRow.__is_new = false;
                }
                restEngine.post('product#/setFaltaFerias', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                    then(function (data) {
                        if (data.notifications[0].type === "success") {
                            ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                            if (widget.currentRow.__is_new) {
                                ABUtilController.masterDetailVoltarList(widget);
                                widget.reload();
                            } else {
                                ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                                widget.backupRow = null;
                                widget.view();
                            }
                        } else {
                            ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                        }
                    }).
                    catch(function(e) {
                        var error;
                        if(e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;
                            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    });
            }
    };
    
    this.deleteFaltaFerias = function(args) {
    ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
        var widget = args.owner.widget;
        widget.currentRow.__is_new = false;
        restEngine.post('product#/deleteFaltaFerias', {'requestType':'DataSet','dataset':[widget.currentRow]}).
            then(function(data){
                if(data.notifications[0].type === "success"){
                    ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                    ABUtilController.masterDetailVoltarList(widget);
                    widget.reload();
                } else {
                    ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                }
            }).
            catch(function(e) {
                var error;
                if(e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
        }, null);
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('FaltaFeriasController', FaltaFeriasController);
});

// FILE: assets/js/controllers/FaseTramitacaoController.js
function FaseTramitacaoController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, General,Messages, Colors) {

    this.adicionarRow = function(args) {
        var widget = args.owner.widget;
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
    };
    
	this.setFaseTramitacao = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
                if (!widget.backupRow) {
                    widget.currentRow.__is_new = true;
                } else {
                    widget.currentRow.__is_new = false;
                }
                var currentRow = angular.copy(widget.currentRow);
                currentRow.NRCORFATRAMA = fromTinyColorToDecimal(currentRow.NRCORFATRAMA);
                restEngine.post('product#/setFaseTramitacao', {'requestType': 'DataSet', 'dataset': [currentRow]}).
                    then(function (data) {
                        if (data.notifications[0].type === "success") {
                            ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                            if (widget.currentRow.__is_new) {
                                ABUtilController.masterDetailVoltarList(widget);
                                widget.currentRow.NRCORFATRAMA = tinycolor( widget.currentRow.NRCORFATRAMA.toString(16) );
                                widget.reload();
                            } else {
                                ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                                widget.backupRow = null;
                                widget.currentRow.NRCORFATRAMA = tinycolor( widget.currentRow.NRCORFATRAMA.toString(16) );
                                widget.view();
                            }
                        } else {
                            ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                        }
                    }).
                    catch(function(e) {
                        var error;
                        if(e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;
                            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    });
            }
    };
    
    var fromTinyColorToDecimal = function(obj){
        var corHex = tinycolor(obj).toHexString();
        corHex = corHex.substr(1, corHex.length);
        var corDecimal = parseInt(corHex, 16);
        return corDecimal;
    };
    
    this.decimalToTinyColor = function(widgetPrincipal){
        widgetPrincipal.currentRow.NRCORFATRAMA = tinycolor( widgetPrincipal.currentRow.NRCORFATRAMA.toString(16) );
    };
    
    this.changeColor = function() {
		var widget = templateManager.container.getWidget('tramitacao');
		widget.dataSource.data.forEach(function(row){
            row.NRCORFATRAMA = '#'+row.NRCORFATRAMA.toString(16);
        });

	};
	
	this.setColor = function(row, element, widget){
        widget = templateManager.container.getActiveWidget(widget);
        var field = widget.getField("NRCORFATRAMA");
        if(widget.mode != "edit"){
            element.children('p').remove();
            element.children('span').remove();
            element.children('div').remove();
            var class1 = "colorfield", class2 = "zh-field-value";
            if(widget.mode == "view"){
                class1 += " colorfield-in-form";
            }
            else {
                class1 += " colorfield-in-grid";
            }
            element.append('<div class='+class2+' style="background-color:'+row.NRCORFATRAMA+'">  </div>');
        }
    };
    
    this.deleteFaseTramitacao = function(args) {
    ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
        var widget = args.owner.widget;
        widget.currentRow.__is_new = false;
        restEngine.post('product#/deleteFaseTramitacao', {'requestType':'DataSet','dataset':[widget.currentRow]}).
            then(function(data){
                if(data.notifications[0].type === "success"){
                    ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                    ABUtilController.masterDetailVoltarList(widget);
                    widget.reload();
                } else {
                    ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                }
            }).
            catch(function(e) {
                var error;
                if(e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
        }, null);
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('FaseTramitacaoController', FaseTramitacaoController);
});

// FILE: assets/js/controllers/FasesProcessosController.js
/**
 * Created by lara loures on 04/05/2016.
 */
function FasesProcessosController (ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, ABUtilController, AFormataHoraDecimal, Messages) {

    this.salvarDadosFases = function(){
        var widget = templateManager.container.getActiveWidget();
        if(!widget.backupRow){
            widget.currentRow.__is_new = true;        
        } else {
            widget.currentRow.__is_new = false;      
        }
        var saveData = Object.assign({}, widget.currentRow, {"NRORG": getLocalVar("HCM_NRORG_TRAB")}, {"CDOPERADOR_LOG": getLocalVar("HCM_CDOPERADOR")});
        restEngine.post('product#/saveFasesProcesso', {'requestType':'DataSet','dataset':[saveData]}).
            then(function(data){
                if(data.notifications[0].type === "success"){
                    ScreenService.successNotification('Fase salva com sucesso', 1000);
                    if(data.notifications[1].type === "success"){
                        ScreenService.successNotification('Parâmetros da fase salvos com sucesso', 1000);
                        if (widget.currentRow.__is_new) {
                            ABUtilController.masterDetailVoltarList(widget);
                            widget.reload();
                        } else {
                            ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                            widget.backupRow = null;
                            widget.view();
                        }
                    } else {
                        ScreenService.showMessage('Erro ao salvar os parâmetros da fase');
                    }
                } else {
                    ScreenService.showMessage('Erro ao salvar a fase');
                }
            }).catch(function(e) {
                var error;
                if(e.data.error === undefined)
                    error = e;
                else 
                    error = e.data.error;
                
                ScreenService.showMessage('Ocorreu um erro inesperado, contate o administrador informando o trecho abaixo: <br><br>' + error + '<br><br>', 'ERROR');
            });
    };

    this.removerDadosFases = function(){
        ScreenService.confirmMessage(Messages.DELETE_ROW, 'CONFIRMATION', 
            function() {
                var widget = templateManager.container.getActiveWidget();
                widget.currentRow.__is_new = false;
                var saveData = Object.assign({}, widget.currentRow, {"NRORG": getLocalVar("HCM_NRORG_OPER")}, {"CDOPERADOR_LOG": getLocalVar("HCM_CDOPERADOR")});
                restEngine.post('product#/removeFasesProcesso', {'requestType':'DataSet','dataset':[saveData]}).
                    then(function(data){
                        if(data.notifications[0].type === "success"){
                            ScreenService.successNotification('Template removido com sucesso', 1000);
                            ABUtilController.masterDetailVoltarList(widget);
                            widget.reload();
                        } else {
                            ScreenService.showMessage('Erro ao remover o template');
                        }
                    }).catch(function(e) {
                        var error;
                        if(e.data.error === undefined)
                            error = e;
                        else 
                            error = e.data.error;
                        
                        ScreenService.showMessage('Ocorreu um erro inesperado, contate o administrador informando o trecho abaixo: <br><br>' + error + '<br><br>', 'ERROR');
                    });
            }
        );
    };
    
}

Configuration(function(ContextRegister) {
    ContextRegister.register('FasesProcessosController', FasesProcessosController);
});

// FILE: assets/js/controllers/FatorRiscoEstruturaController.js
function FatorRiscoEstruturaController(ScreenService, templateManager, restEngine, ABUtilController, Messages, ZHPromise) {

	this.salvar = function(args) {
        var widget = templateManager.container.getActiveWidget();
        if (widget.isValid()) {
            if (!widget.backupRow) {
                widget.currentRow.__is_new = true;
            } else {
                widget.currentRow.__is_new = false;
            }
            restEngine.post('product#/setRelestrutrisco', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                then(function (data) {
                    if (data.notifications[0].type === "success") {
                        ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                        if (widget.currentRow.__is_new) {
                            ABUtilController.masterDetailVoltarList(widget);
                            widget.reload();
                        } else {
                            ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                            widget.backupRow = null;
                            widget.view();
                        }
                    } else {
                        ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                    }
                }).
                catch(function(e) {
                    var error;
                    if(e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;

                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
        }
    };

    this.remover = function(args) {
    ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
        var widget = templateManager.container.getActiveWidget();
        if (widget.isValid()) {
            widget.currentRow.__is_new = false;
            restEngine.post('product#/deleteRelestrutrisco', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                then(function (data) {
                    if (data.notifications[0].type === "success") {
                        ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    } else {
                        ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                    }
                }).
                catch(function(e) {
                    var error;
                    if(e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;

                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
            }
        }, null);
    };
    
    this.openPopupCadAutomatico = function(args) {
        var widgetFilter = templateManager.container.getWidget('cadAutFatorRisco');
        widgetFilter.applyDefaultValue();
        ScreenService.openPopup(widgetFilter);
    };   

    this.cadAutFatorRiscoPorEstrutura = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
            restEngine.post('product#/cadAutFatorRiscoPorEstrutura', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                then(function (data) {
                    if(data.notifications[0].type === "success"){
                        ScreenService.showMessage(Messages.CADASTRO_AUTOMATICO_SUCCESS, 'SUCCESS');
                        ScreenService.closePopup();
                        templateManager.container.getWidget('fatorRiscoEstrutura').activate();
                        templateManager.container.getWidget('fatorRiscoEstrutura').reload();
                    }else
                        ScreenService.showMessage(Messages.SAVE_ROW_ERROR); 
                }).
                catch(function(e) {
                    var error;
                    if(e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;

                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
        }
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('FatorRiscoEstruturaController', FatorRiscoEstruturaController);
});

// FILE: assets/js/controllers/FatorRiscoOcupacaoController.js
function FatorRiscoOcupacaoController(ScreenService, templateManager, restEngine, ABUtilController, Messages) {

    this.validaPeriodo = function(dtIni, dtFin) {
        if (moment(dtIni, 'DD/MM/YYYY').unix() > moment(dtFin, 'DD/MM/YYYY').unix() || moment(dtFin, 'DD/MM/YYYY').unix() < moment(dtIni, 'DD/MM/YYYY').unix()) {
            return false;
        }
        else {
            return true;
        }
    };

	this.salvar = function(args) {
        var widget = templateManager.container.getActiveWidget();
        if (widget.isValid()) {
            if (this.validaPeriodo(widget.currentRow.DTINIVIGENCIA, widget.currentRow.DTFIMVIGENCIA)) {
                if (!widget.backupRow) {
                    widget.currentRow.__is_new = true;
                } else {
                    widget.currentRow.__is_new = false;
                }
                restEngine.post('product#/setRelocuparisco', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                    then(function (data) {
                        if (data.notifications[0].type === "success") {
                            ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                            if (widget.currentRow.__is_new) {
                                ABUtilController.masterDetailVoltarList(widget);
                                widget.reload();
                            } else {
                                ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                                widget.backupRow = null;
                                widget.view();
                            }
                        } else {
                            ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                        }
                    }).
                    catch(function(e) {
                        var error;
                        if(e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;
    
                        ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    });
            }
            else {
                ScreenService.showMessage('A data final deve ser posterior à data inicial.');
                return false;
            }
        }
    };

    this.remover = function(args) {
    ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
        var widget = templateManager.container.getActiveWidget();
        if (widget.isValid()) {
            widget.currentRow.__is_new = false;
            restEngine.post('product#/deleteRelocuparisco', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                then(function (data) {
                    if (data.notifications[0].type === "success") {
                        ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    } else {
                        ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                    }
                }).
                catch(function(e) {
                    var error;
                    if(e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;

                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
            }
        }, null);    
    };

}

Configuration(function(ContextRegister) {
    ContextRegister.register('FatorRiscoOcupacaoController', FatorRiscoOcupacaoController);
});

// FILE: assets/js/controllers/FatorRiscoVinculoController.js
function FatorRiscoVinculoController(ScreenService, templateManager, restEngine, ABUtilController, Messages) {

    this.validaPeriodo = function(dtIni, dtFin) {
        if (moment(dtIni, 'DD/MM/YYYY').unix() > moment(dtFin, 'DD/MM/YYYY').unix() || moment(dtFin, 'DD/MM/YYYY').unix() < moment(dtIni, 'DD/MM/YYYY').unix()) {
            return false;
        }
        else {
            return true;
        }
    };

	this.salvar = function(args) {
        var widget = templateManager.container.getActiveWidget();
        if (widget.isValid()) {
            if (this.validaPeriodo(widget.currentRow.DTINIVIGENCIA, widget.currentRow.DTFIMVIGENCIA)) {
                if (!widget.backupRow) {
                    widget.currentRow.__is_new = true;
                } else {
                    widget.currentRow.__is_new = false;
                }
                restEngine.post('product#/setRelvincrisco', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                    then(function (data) {
                        if (data.notifications[0].type === "success") {
                            ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                            if (widget.currentRow.__is_new) {
                                ABUtilController.masterDetailVoltarList(widget);
                                widget.reload();
                            } else {
                                ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                                widget.backupRow = null;
                                widget.view();
                            }
                        } else {
                            ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                        }
                    }).
                    catch(function(e) {
                        var error;
                        if(e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;
    
                        ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    });
            }
            else {
                ScreenService.showMessage('A data final deve ser posterior à data inicial.');
                return false;
            }
        }
    };

    this.remover = function(args) {
    ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
        var widget = templateManager.container.getActiveWidget();
        if (widget.isValid()) {
            widget.currentRow.__is_new = false;
            restEngine.post('product#/deleteRelvincrisco', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                then(function (data) {
                    if (data.notifications[0].type === "success") {
                        ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    } else {
                        ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                    }
                }).
                catch(function(e) {
                    var error;
                    if(e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;

                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
            }
        }, null);
    };

}

Configuration(function(ContextRegister) {
    ContextRegister.register('FatorRiscoVinculoController', FatorRiscoVinculoController);
});

// FILE: assets/js/controllers/FatorriscoController.js
function FatorriscoController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, Messages) {

    this.NRFATORRISCO = null;

	this.salvar = function(args) {
        var widget = templateManager.container.getActiveWidget();
        if (widget.isValid()) {
            if (!widget.backupRow) {
                widget.currentRow.__is_new = true;
            } else {
                widget.currentRow.__is_new = false;
            }
            restEngine.post('product#/setFatorrisco', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                then(function (data) {
                    if (data.notifications[0].type === "success") {
                        ScreenService.successNotification('Registro salvo com sucesso', 10000);
                        if (widget.currentRow.__is_new) {
                            ABUtilController.masterDetailVoltarList(widget);
                            widget.reload();
                        } else {
                            widget.backupRow = null;
                            widget.view();
                        }
                        ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                    } else {
                        ScreenService.showMessage('Erro ao salvar o registro');
                    }
                }).
                catch(function(e) { 
                    var error;
                    if(e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;

                    ScreenService.showMessage('Ocorreu um erro inesperado, contate o administrador informando o trecho abaixo: <br><br>' + error + '<br><br>', 'ERROR');
                });
        }
    };

    this.remover = function(args) {
    ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
        var widget = templateManager.container.getActiveWidget();
        if (widget.isValid()) {
            widget.currentRow.__is_new = false;
            restEngine.post('product#/deleteFatorrisco', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                then(function (data) {
                    if (data.notifications[0].type === "success") {
                        ScreenService.successNotification('Registro excluído com sucesso', 10000);
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    } else {
                        ScreenService.showMessage('Erro ao excluir o registro');
                    }
                }).
                catch(function(e) {
                    var error;
                    if(e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;

                    ScreenService.showMessage('Ocorreu um erro inesperado, contate o administrador informando o trecho abaixo: <br><br>' + error + '<br><br>', 'ERROR');
                });
            }
        }, null);
    };
    
	this.salvarEpcXFatorRisco = function(args) {
        var widget = templateManager.container.getActiveWidget();
        var widgetMain = templateManager.container.getWidget('fatorRisco');
        widget.currentRow.NRFATORRISCO = widgetMain.currentRow.NRFATORRISCO;
        if (widget.isValid()) {
            if (!widget.backupRow) {
                widget.currentRow.__is_new = true;
            } else {
                widget.currentRow.__is_new = false;
            }
            restEngine.post('product#/setRiscoEpc', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                then(function (data) {
                    if (data.notifications[0].type === "success") {
                        ScreenService.successNotification('Registro salvo com sucesso', 10000);
                        if (widget.currentRow.__is_new) {
                            ABUtilController.masterDetailVoltarList(widget);
                            widget.reload();
                        } else {
                            ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                            widget.backupRow = null;
                            widget.view();
                        }
                    } else {
                        ScreenService.showMessage('Erro ao salvar o registro');
                    }
                }).
                catch(function(e) {
                    var error;
                    if(e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;

                    ScreenService.showMessage('Ocorreu um erro inesperado, contate o administrador informando o trecho abaixo: <br><br>' + error + '<br><br>', 'ERROR');
                });
        }
    };

    this.removerEpcXFatorRisco = function(args) {
        var widget = templateManager.container.getActiveWidget();
        if (widget.isValid()) {
            widget.currentRow.__is_new = false;
            restEngine.post('product#/deleteRiscoEpc', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                then(function (data) {
                    if (data.notifications[0].type === "success") {
                        ScreenService.successNotification('Registro excluído com sucesso', 10000);
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    } else {
                        ScreenService.showMessage('Erro ao excluir o registro');
                    }
                }).
                catch(function(e) {
                    var error;
                    if(e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;

                    ScreenService.showMessage('Ocorreu um erro inesperado, contate o administrador informando o trecho abaixo: <br><br>' + error + '<br><br>', 'ERROR');
                });
        }
    };    

	this.salvarEpiXFatorRisco = function(args) {
        var widget = templateManager.container.getActiveWidget();
        var widgetMain = templateManager.container.getWidget('fatorRisco');
        widget.currentRow.NRFATORRISCO = widgetMain.currentRow.NRFATORRISCO;
        if (widget.isValid()) {
            if (!widget.backupRow) {
                widget.currentRow.__is_new = true;
            } else {
                widget.currentRow.__is_new = false;
            }
            restEngine.post('product#/setRiscoEpi', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                then(function (data) {
                    if (data.notifications[0].type === "success") {
                        ScreenService.successNotification('Registro salvo com sucesso', 10000);
                        if (widget.currentRow.__is_new) {
                            ABUtilController.masterDetailVoltarList(widget);
                            widget.reload();
                        } else {
                            ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                            widget.backupRow = null;
                            widget.view();
                        }
                    } else {
                        ScreenService.showMessage('Erro ao salvar o registro');
                    }
                }).
                catch(function(e) {
                    var error;
                    if(e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;

                    ScreenService.showMessage('Ocorreu um erro inesperado, contate o administrador informando o trecho abaixo: <br><br>' + error + '<br><br>', 'ERROR');
                });
        }
    };

    this.removerEpiXFatorRisco = function(args) {
        var widget = templateManager.container.getActiveWidget();
        if (widget.isValid()) {
            widget.currentRow.__is_new = false;
            restEngine.post('product#/deleteRiscoEpi', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                then(function (data) {
                    if (data.notifications[0].type === "success") {
                        ScreenService.successNotification('Registro excluído com sucesso', 10000);
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    } else {
                        ScreenService.showMessage('Erro ao excluir o registro');
                    }
                }).
                catch(function(e) {
                    var error;
                    if(e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;

                    ScreenService.showMessage('Ocorreu um erro inesperado, contate o administrador informando o trecho abaixo: <br><br>' + error + '<br><br>', 'ERROR');
                });
        }
    };    
    
    this.setDataSourceFilterNRFATORRISCO = function(widgetMain){
        this.NRFATORRISCO = widgetMain.currentRow.NRFATORRISCO;
    };

}

Configuration(function(ContextRegister) {
    ContextRegister.register('FatorriscoController', FatorriscoController);
});

// FILE: assets/js/controllers/FechamentoMensalController.js
function FechamentoMensalController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, Messages, CriterioSelecaoController) {
    
    this.tipoRelatorio = null;
    
    this.cancelEdit = function(args){
        var widget = ABUtilController.checkWidget(args);
        widget.currentRow.DSINICIO = widget.currentRow.BKPDSINICIO;
        widget.currentRow.DSFIM = widget.currentRow.BKPDSFIM;
        widget.currentRow.BKPDSINICIO = null;
        widget.currentRow.BKPDSFIM = null;
        ABUtilController.masterDetailCancelaEdicao(widget);
        CriterioSelecaoController.setVisibilidadeCampos(widget);
    };

    this.changeDsOrdem = function(args) {
        var widget = ABUtilController.checkWidget(args);
        widget.currentRow.BKPDSINICIO = widget.currentRow.DSINICIO; 
        widget.currentRow.BKPDSFIM = widget.currentRow.DSFIM;
        widget.currentRow.DSINICIO = null;
        widget.currentRow.DSFIM = null;
        CriterioSelecaoController.setVisibilidadeCampos(widget);
    };

    this.deleteFechamento = function(args) {
        var widget = ABUtilController.checkWidget(args);
        var data = {}; 
        ScreenService.confirmMessage(Messages.DELETE_ROW, 'CONFIRMATION', 
            function(){
                widget.dataSource.remove(widget.currentRow).then(function (data){
                    if(data.dataset.fpaFormCalculo_setFechamentoMensal.type === "success"){
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                        ScreenService.showMessage(Messages.REMOVE_ROW_SUCCESS); 
                    } else {
                        ScreenService.showMessage(Messages.REMOVE_ROW_ERROR); 
                    }
                }.bind(this));
            }.bind(this)
        );
    };

    this.enviarDemonstrativo = function(args){
        var popUp = ABUtilController.checkWidget(args);
        var widget = templateManager.container.getWidget("demonstrativoEmail");

        if (popUp.isValid()) {
            widget.currentRow.TIPORELATORIO = this.tipoRelatorio;
            widget.currentRow.__report_name = 'demonstrativo_pagamento_via_unica';
            widget.currentRow.NRTIPOMOVIMENT = popUp.currentRow.NRTIPOMOVIMENT; //getLocalVar("HCM_FPA_FORMCALCULO").NRTIPOMOVIMENT;
            widget.currentRow.NMTIPOMOVIMENT = popUp.currentRow.NMTIPOMOVIMENT; //getLocalVar("HCM_FPA_FORMCALCULO").NMTIPOMOVIMENT;
            widget.currentRow.DSOBSERVACOES  = popUp.currentRow.DSOBSERVACOES;
            widget.currentRow.NRORGTRAB      = getLocalVar("HCM_NRORG_TRAB");
            widget.currentRow.COMPETENCIA    = getLocalVar("HCM_DTCOMPETENCIA_OPER");
            widget.currentRow.CDOPERADOR_LOG = getLocalVar("HCM_CDOPERADOR");

            delete popUp.currentRow.NRTIPOMOVIMENT;
            delete popUp.currentRow.NMTIPOMOVIMENT;
            delete popUp.currentRow.DSOBSERVACOES;

            var saveData = Object.assign({}, widget.currentRow, {"MENSAGEM": popUp.currentRow});
            restEngine.post('product#/enviarRelatorio', 
                {
                    "requestType": "Row",
                    "row": saveData
                }
            ).then(function(response) {
                if (!Util.isUndefined(response.notifications)) {
                    ScreenService.showMessage(Messages.DEMONSTRATIVO_SEND_SUCCESS);                
                    if(!Util.isUndefined(response.messages)) {
                        ScreenService.showMessage(response.messages[0].message,response.messages[0].type);
                    }
                    ABUtilController.masterDetailClosePopup(popUp);
                } else {
                    ScreenService.showMessage('Ocorreu um erro inesperado ao gerar o demonstrativo','ERROR');
                }
            }).catch(function(e) {
                var error;
                if(e.data.error === undefined)
                    error = e;
                else 
                    error = e.data.error;
                
                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error));
            });
        }
    };

    this.moveRow = function(args){
        var widget = ABUtilController.checkWidget(args);
        CriterioSelecaoController.setVisibilidadeCampos(widget);
    };

     this.onEnterMensagem = function(args){
        var widgetMensagens = ABUtilController.checkWidget(args);
        widgetMensagens.getField("DSMENSAGEM").placeholder = "Mnemônicos aceitos:" +
                                                            '\n\n' +
                                                            "[COMPETENCIA] = Competência do operador logado" +
                                                            '\n' +
                                                            "[COLABORADOR] = Nome da pessoa a receber o demonstrativo";
    };

    this.openPopupMensagem = function(args, relatorio){
        var widget = templateManager.container.getWidget('mensagens');
        
        this.tipoRelatorio = relatorio;
        
        if(relatorio == 'reciboFerias' || relatorio == 'informeRendimentos' || relatorio == 'pontoDemonstrativo'){
            widget.getField('RIEG').isVisible = false;
            widget.getField('IDOPERADORLOG').isVisible = false;
            widget.getField('NMTIPOMOVIMENT').isVisible = false;
        }else if(relatorio == 'holerite'){
            widget.getField('RIEG').isVisible = true;
            widget.getField('IDOPERADORLOG').isVisible = true;
            widget.getField('NMTIPOMOVIMENT').isVisible = true;
        }
        
        if(relatorio == 'holerite') widget.label = 'Demonstrativo de Pagamento via E-mail';
        if(relatorio == 'reciboFerias') widget.label = 'Recibo de Férias via E-mail';
        if(relatorio == 'informeRendimentos') widget.label = 'Informe de Rendimentos via E-mail';
        if(relatorio == 'pontoDemonstrativo') widget.label = 'Demonstrativo de Folha de Ponto via E-mail';
        
        widget.isVisible = true;
        
        ABUtilController.masterDetailOpenPopup(widget);
    };

    this.salvarFechamento = function(args){
        var widget = ABUtilController.checkWidget(args);
        if(widget.isValid())  {
            if (!widget.backupRow) {
                widget.currentRow.__is_new = true;
            } else {
                widget.currentRow.__is_new = false;
            }
            widget.currentRow.IDTPFORMCALCULO = getLocalVar('HCM_FPA_FORMCALCULO').IDTPFORMCALCULO;
            widget.currentRow.CDOPERADOR_LOG = getLocalVar("HCM_CDOPERADOR");
            widget.currentRow.NRORGTRAB = getLocalVar("HCM_NRORG_TRAB");
            widget.currentRow.NRORGPADRAO = getLocalVar("HCM_NRORG_PADRAO");
            widget.currentRow.DTATUAL = getLocalVar("HCM_DATA_ATUAL");
            return widget.saveRow().then(function (data){
                if (data.notifications[0].type === "success") {
                    if (widget.currentRow.__is_new) {
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    } else {
                        ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                        widget.backupRow = null;
                        widget.view();
                    }
                } else {
                    ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                }
            }.bind(this)).catch(function(e) {
                var error;
                if(e.data.error === undefined)
                    error = e;
                else 
                    error = e.data.error;
                
                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error));
            });
        }
    };

    this.setCampoTitulo = function(args){
        var widgetMensagens = ABUtilController.checkWidget(args);
        widgetMensagens.currentRow.DSTITULOMENSAGEM = widgetMensagens.currentRow.DSASSUNTOMENSAGEM;
    };

}

Configuration(function(ContextRegister) {
    ContextRegister.register('FechamentoMensalController', FechamentoMensalController);
});

// FILE: assets/js/controllers/FeriasColetivaController.js
function FeriasColetivaController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, General,Messages) {
    
    var self = this;
    
    this.adicionarRow = function(args) {
        var widget = args.owner.widget;
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
    };
    
    this.setIdColetiva = function(args){
        var widget = ABUtilController.checkWidget(args);
        var row = widget.currentRow;
        widget.currentRow.DSFERIASCOLET = 'COLET_'+row.DSORDEM+'_'+row.DTINIGOZOINI;
    };
    
    this.atualizaPeriodo = function(args) {
        var widget = ABUtilController.checkWidget(args);
        var dtini = widget.getField('DTINIGOZOINI').value();
        var nrqtdias = widget.getField('DIASFERIAS').value();
        var dtfim = widget.getField('DTINIGOZOFIM').value();

        if (!ABUtilController.validaDtIniMenorIgualDtFin(dtini, dtfim)) {
            ScreenService.alertNotification(Messages.DTINI_POST_DTFIM_ERROR, 10000);
        } else {
            if (!Util.isEmptyOrBlank(dtini) && !isNaN(nrqtdias) && nrqtdias > 0) {
                nrqtdias--;
                dtfim = moment(dtini, 'DD/MM/YYYY').add(nrqtdias, 'day').format('DD/MM/YYYY');
                widget.getField('DTINIGOZOFIM').setValue(dtfim);
                var dtretorno = moment(dtfim, 'DD/MM/YYYY').add(1, 'day').format('DD/MM/YYYY');
                widget.getField('DTRETORNOFERIAS').setValue(dtretorno);
            }
            else if (!Util.isEmptyOrBlank(dtini) && !Util.isEmptyOrBlank(dtfim)) {
                nrqtdias = moment(dtfim, 'DD/MM/YYYY').diff(moment(dtini, 'DD/MM/YYYY'), 'day') + 1;
                widget.getField('DIASFERIAS').setValue(nrqtdias);
            }
        }
    };

    this.atualizaQtdDias = function(args) {
        var widget = ABUtilController.checkWidget(args);
        var dtini = widget.getField('DTINIGOZOINI').value();
        var dtfim = widget.getField('DTINIGOZOFIM').value();

        if (!ABUtilController.validaDtIniMenorIgualDtFin(dtini, dtfim)) {
            ScreenService.alertNotification(Messages.DTINI_POST_DTFIM_ERROR, 10000);
        } else {
            if (!Util.isEmptyOrBlank(dtini) && !Util.isEmptyOrBlank(dtfim)) {
                var nrqtdias = moment(dtfim, 'DD/MM/YYYY').diff(moment(dtini, 'DD/MM/YYYY'), 'day') + 1;
                widget.getField('DIASFERIAS').setValue(nrqtdias);
                var dtretorno = moment(dtfim, 'DD/MM/YYYY').add(1, 'day').format('DD/MM/YYYY');
                widget.getField('DTRETORNOFERIAS').setValue(dtretorno);
            } else {
                widget.getField('DIASFERIAS').setValue("");
            }
        }
    };
    
	this.setFormFeriasColet = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
            if (ABUtilController.validaDtIniMenorIgualDtFin(widget.currentRow.DTINIGOZOINI, widget.currentRow.DTINIGOZOFIM)) {
                if (!widget.backupRow) {
                    widget.currentRow.__is_new = true;
                } else {
                    widget.currentRow.__is_new = false;
                }
                restEngine.post('product#/setFormFeriasColet', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                    then(function (data) {
                        if (data.notifications[0].type === "success") {
                            ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                            if (widget.currentRow.__is_new) {
                                ABUtilController.masterDetailVoltarList(widget);
                                widget.reload();
                            } else {
                                ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                                widget.backupRow = null;
                                widget.view();
                            }
                        } else {
                            ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                        }
                        
                    }).
                    catch(function(e) {
                        var error;
                        if(e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;
                            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    });
            }else{
                ScreenService.showMessage(Messages.DTINI_POST_DTFIM_ERROR);
                return false;
            }           
        }
    };
    
    this.deleteFormFeriasColet = function(args) {
         ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
        var widget = args.owner.widget;
        widget.currentRow.__is_new = false;
        restEngine.post('product#/deleteFormFeriasColet', {'requestType':'DataSet','dataset':[widget.currentRow]}).
            then(function(data){
                if(data.notifications[0].type === "success"){
                    ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                    ABUtilController.masterDetailVoltarList(widget);
                    widget.reload();
                } else {
                    ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                }
            }).
            catch(function(e) {
                var error;
                if(e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
         }, null);
    };
    
    this.preparaColetiva = function(args){
        var widget = ABUtilController.checkWidget(args);
        ScreenService.confirmMessage('Deseja realmente preparar as férias coletiva?', 'CONFIRMATION', 
            function(){
                restEngine.post("product#/preparaColetiva",
                        {'requestType':'DataSet','dataset':[widget.currentRow]}
                    ).then(function(data) {
                            if (Util.isEmptyOrBlank(data)) {
                                ScreenService.showMessage('Preparação realizada com sucesso');
                                ScreenService.closePopup();
                            }else if (data.dataset && data.dataset.msgCalculo && data.dataset.msgCalculo.length > 0) {
                                var popUp = templateManager.container.getWidget("mensagens");
                                popUp.dataSource.data = data.dataset.msgCalculo;
                                ABUtilController.masterDetailOpenPopup(popUp);
                            } 
                            else {
                                data.messages.forEach(function(mensagem){
                                    ScreenService.showMessage('Erro ao preparar a coletiva: <br>' + mensagem.message);
                                });
                            }
                            
                        }
                    ).catch(function(e) {
                        var error;
                        if(e.data.error === undefined)
                            error = e;
                        else 
                            error = e.data.error;
                        
                        ScreenService.showMessage('Ocorreu um erro inesperado, contate o administrador informando o trecho abaixo: <br><br>' + error + '<br><br>', 'ERROR');
                    });
            }.bind(this));
    };
    
    this.retrocedeColetiva = function(args){
        var widget = ABUtilController.checkWidget(args);
        ScreenService.confirmMessage('Deseja realmente retroceder as férias coletiva?', 'CONFIRMATION', 
            function(){
                this.enviaRetrocessoColetivo(widget, false);
            }.bind(this));
    };
    
    this.enviaRetrocessoColetivo = function(widget, confirmacaoLiquidoFerias){
        var thisController = this;
        widget.currentRow.CONFIRMACAOLIQUIDOFERIAS = confirmacaoLiquidoFerias; 
        restEngine.post("product#/retrocedeColetiva",
            {'requestType':'DataSet','dataset':[widget.currentRow]}
        ).then(function(data) {
                if (Util.isEmptyOrBlank(data)) {
                    ScreenService.showMessage('Retrocesso realizado com sucesso');
                    ScreenService.closePopup();
                } else {
                    data.messages.forEach(function(mensagem){
                        if(mensagem.type == 'W' && mensagem.message == Messages.HCM01000_FPA_CANCELAMENTO_FERIAS_EXISTEM_VINCULOS_COM_LIQUIDO_FERIAS){
                            var vinculos = data.dataset.vinculosLiquido[0];
                            ScreenService.confirmMessage(mensagem.message.replace("<vinculos>", vinculos), 'CONFIRMATION', function(){
                                thisController.enviaRetrocessoColetivo(widget, true);
                            });
                        } else {
                            ScreenService.showMessage('Erro ao retroceder a coletiva: <br>' + mensagem.message);
                        }
                    });
                }
            }
        ).catch(function(e) {
            var error;
            if(e.data.error === undefined)
                error = e;
            else 
                error = e.data.error;
            
            ScreenService.showMessage('Ocorreu um erro inesperado, contate o administrador informando o trecho abaixo: <br><br>' + error + '<br><br>', 'ERROR');
        });
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('FeriasColetivaController', FeriasColetivaController);
});

// FILE: assets/js/controllers/FeriasController.js
/* jshint esversion: 6 */
function FeriasController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, $window, ABUtilController, Messages) {
    
    this.nrVinculom = null;
    
    this.openPopup = function(msg) {
        var widgetGozo = templateManager.container.getWidget('mensagensGozo');
        widgetGozo.dataSource.data = msg;
        ScreenService.openPopup(widgetGozo);
    };

    this.adicionarRow = function(args) {
        var widget = ABUtilController.checkWidget(args);
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
    };
    
    this.setNrvinculom = function(args){
        var widget = ABUtilController.checkWidget(args);
        var row = widget.currentRow;
        this.nrVinculom = null;
        widget.getField('IDCONTROLFERIAS').readOnly = true;
        if (row.NMINIVINCULOM === row.NMFIMVINCULOM) {
            this.nrVinculom = row.NRVINCULOM;
            widget.getField('IDCONTROLFERIAS').readOnly = false;
        }
    };
    
    this.validaDtPagamento = function(widget) {
        var primDiaMes = getLocalVar("HCM_DTCOMPETENCIA");
        var ultDiaMes = moment(getLocalVar("HCM_DTCOMPETENCIA"),'DD/MM/YYYY').add(1, 'month').format('DD/MM/YYYY');
        var dtPagamento = widget.getField('DTPAGAMENTO').value();
        ultDiaMes  = moment(ultDiaMes,"DD/MM/YYYY").add(-1, 'day').format('DD/MM/YYYY');
        
        if(moment(primDiaMes,'DD/MM/YYYY').unix() > moment(dtPagamento,'DD/MM/YYYY').unix()||moment(ultDiaMes,'DD/MM/YYYY').unix() < moment(dtPagamento,'DD/MM/YYYY').unix()){
            ScreenService.showMessage('A Data de pagamento deve estar no mes da competencia');
            return false;
        }
        return true;
    };
    
    this.DtIniGozoOnChange = function(widget){
        var dtIniGozo = widget.currentRow.DTINIGOZOFERIAS;
        var dtFimGozo = widget.currentRow.DTFIMGOZOFERIAS;
        var nrQtdeDias = widget.currentRow.QTDIAGOZOFERIAS;
        var dtPagamento = widget.currentRow.DTPAGAMENTO;
        var dtAviso = widget.currentRow.DTAVISOFERIAS;

        if(!Util.isEmptyOrBlank(dtIniGozo)){
            
            if(!Util.isEmptyOrBlank(dtFimGozo)){
                if (!ABUtilController.validaDtIniMenorIgualDtFin(dtIniGozo, dtFimGozo)) {
                    ScreenService.showMessage("A data inicial deve ser anterior a data final");
                    widget.currentRow.DTINIGOZOFERIAS = "";
                    return;
                } 
            }
            if(!Util.isEmptyOrBlank(dtAviso)){
                
                if (!ABUtilController.validaDtIniMenorIgualDtFin(dtAviso, dtIniGozo)) {
                    ScreenService.showMessage("A data de aviso deve ser anterior a data inicial");
                    widget.currentRow.DTINIGOZOFERIAS = "";
                    return;
                } 
            }
            
            if(Util.isEmptyOrBlank(dtPagamento)){
                
                dtPagamento = moment(dtIniGozo,"DD/MM/YYYY").add(-2,'day').format('DD/MM/YYYY');
                switch(moment(dtPagamento,"DD/MM/YYYY").weekday()){
                    case 0:
                    case 6:
                    widget.currentRow.DTPAGAMENTO = moment(dtPagamento,"DD/MM/YYYY").add(-2,'day').format('DD/MM/YYYY');
                    break;
                    default:
                    widget.currentRow.DTPAGAMENTO = dtPagamento;
                    break;
                }
            }
            if( (Util.isEmptyOrBlank(dtFimGozo) || !Util.isEmptyOrBlank(dtFimGozo))  && !Util.isEmptyOrBlank(nrQtdeDias)){
                
                dtFimGozo = moment(dtIniGozo, 'DD/MM/YYYY').add(nrQtdeDias - 1, 'day').format('DD/MM/YYYY');
                widget.currentRow.DTFIMGOZOFERIAS = dtFimGozo;
            
            }
            if((Util.isEmptyOrBlank(dtAviso)) && !Util.isEmptyOrBlank(nrQtdeDias)){
                dtFimGozo = moment(dtIniGozo, 'DD/MM/YYYY').add(nrQtdeDias - 1, 'day').format('DD/MM/YYYY');
                widget.currentRow.DTFIMGOZOFERIAS = dtFimGozo;
                dtAviso = moment(dtIniGozo, 'DD/MM/YYYY').add(- 30, 'day').format('DD/MM/YYYY');
                widget.currentRow.DTAVISOFERIAS = dtAviso;
            }
            
        }
        
    };
    
    this.DtFimGozoOnChange = function(widget){
        var dtIniGozo = widget.currentRow.DTINIGOZOFERIAS;
        var dtFimGozo = widget.currentRow.DTFIMGOZOFERIAS;
        
        if(!Util.isEmptyOrBlank(dtIniGozo) && !Util.isEmptyOrBlank(dtFimGozo)){
            if (!ABUtilController.validaDtIniMenorIgualDtFin(dtIniGozo, dtFimGozo)) {
                ScreenService.showMessage("A data inicial deve ser anterior a data final");
                widget.currentRow.DTFIMGOZOFERIAS = "";
                return;
            } 
        }
    };

    this.DtAvisoFeriasOnChange = function(widget){
        var dtIniGozo = widget.currentRow.DTINIGOZOFERIAS;
        var dtFimGozo = widget.currentRow.DTFIMGOZOFERIAS;
        var dtAviso = widget.currentRow.DTAVISOFERIAS;
        var nrQtdeDias = widget.currentRow.QTDIAGOZOFERIAS;
        
        if(!Util.isEmptyOrBlank(dtIniGozo)){
            if (!ABUtilController.validaDtIniMenorIgualDtFin(dtAviso, dtIniGozo)) {
                ScreenService.showMessage("A data de aviso deve ser anterior a data inicial");
                widget.currentRow.DTAVISOFERIAS = "";
                return;
            } 
        }
        
        if(!Util.isEmptyOrBlank(dtAviso) && !Util.isEmptyOrBlank(nrQtdeDias) && Util.isEmptyOrBlank(dtIniGozo) && Util.isEmptyOrBlank(dtFimGozo)){
            dtIniGozo = moment(dtAviso, 'DD/MM/YYYY').add(30, 'day').format('DD/MM/YYYY');
            widget.currentRow.DTINIGOZOFERIAS = dtIniGozo;
            dtFimGozo = moment(dtIniGozo, 'DD/MM/YYYY').add(nrQtdeDias - 1, 'day').format('DD/MM/YYYY');
            widget.currentRow.DTFIMGOZOFERIAS = dtFimGozo;
        }
    };
    
    this.QtDiaGozoOnChange = function(widget){
        var dtIniGozo = widget.currentRow.DTINIGOZOFERIAS;
        var dtFimGozo = widget.currentRow.DTFIMGOZOFERIAS;
        var dtAviso = widget.currentRow.DTAVISOFERIAS;
        var nrQtdeDias = widget.currentRow.QTDIAGOZOFERIAS;
        var dtPagamento = widget.currentRow.DTPAGAMENTO;
        
        if(!Util.isEmptyOrBlank(nrQtdeDias)){
            if(!Util.isEmptyOrBlank(dtIniGozo) && (Util.isEmptyOrBlank(dtFimGozo) || !Util.isEmptyOrBlank(dtFimGozo))){
                dtFimGozo = moment(dtIniGozo, 'DD/MM/YYYY').add(nrQtdeDias - 1, 'day').format('DD/MM/YYYY');
                widget.currentRow.DTFIMGOZOFERIAS = dtFimGozo;
            }
            if(!Util.isEmptyOrBlank(dtAviso) && Util.isEmptyOrBlank(dtIniGozo) && Util.isEmptyOrBlank(dtFimGozo)){
                dtIniGozo = moment(dtAviso, 'DD/MM/YYYY').add(30, 'day').format('DD/MM/YYYY');
                widget.currentRow.DTINIGOZOFERIAS = dtIniGozo;
                dtFimGozo = moment(dtIniGozo, 'DD/MM/YYYY').add(nrQtdeDias - 1, 'day').format('DD/MM/YYYY');
                widget.currentRow.DTFIMGOZOFERIAS = dtFimGozo;
            }
            if(!Util.isEmptyOrBlank(dtAviso) && !Util.isEmptyOrBlank(dtIniGozo) && Util.isEmptyOrBlank(dtFimGozo)){
                dtFimGozo = moment(dtIniGozo, 'DD/MM/YYYY').add(nrQtdeDias - 1, 'day').format('DD/MM/YYYY');
                widget.currentRow.DTFIMGOZOFERIAS = dtFimGozo;
            }
            if(Util.isEmptyOrBlank(dtAviso) && !Util.isEmptyOrBlank(dtIniGozo) && Util.isEmptyOrBlank(dtFimGozo)){
                dtFimGozo = moment(dtIniGozo, 'DD/MM/YYYY').add(nrQtdeDias - 1, 'day').format('DD/MM/YYYY');
                widget.currentRow.DTFIMGOZOFERIAS = dtFimGozo;
                dtAviso = moment(dtIniGozo, 'DD/MM/YYYY').add(- 30, 'day').format('DD/MM/YYYY');
                widget.currentRow.DTAVISOFERIAS = dtAviso;    
            }
        }
    };

    this.setVisibilidadeCamposFerias = function(args) {
        var widget = ABUtilController.checkWidget(args);
        var ordem = widget.currentRow.DSORDEM;
        switch (ordem) {
            case 'ALFABETICA':
                widget.getField('IDCONTROLFERIAS').isVisible = true;
                widget.getField('QTDIASABONOFERI').isVisible = true;
                break;
            case 'MATRICULA':
                widget.getField('IDCONTROLFERIAS').isVisible = false;
                widget.getField('QTDIASABONOFERI').isVisible = false;
                break;
            case 'DATA_ADMISSAO':
                widget.getField('IDCONTROLFERIAS').isVisible = false;
                widget.getField('QTDIASABONOFERI').isVisible = false;
                break;
            case 'ESTRUTURA':
                widget.getField('IDCONTROLFERIAS').isVisible = false;
                widget.getField('QTDIASABONOFERI').isVisible = false;
                break;
            case 'LISTA_VINCULO':
                widget.getField('IDCONTROLFERIAS').isVisible = false;
                widget.getField('QTDIASABONOFERI').isVisible = false;
                break;
            case 'LISTA_ESTRUTURA':
                widget.getField('IDCONTROLFERIAS').isVisible = false;
                widget.getField('QTDIASABONOFERI').isVisible = false;
                break;
            default:
                widget.getField('IDCONTROLFERIAS').isVisible = false;
                widget.getField('QTDIASABONOFERI').isVisible = false;
                break;
        }
    };

    this.cadGozoFerias = function(args) {
        var widget = ABUtilController.checkWidget(args);
        if ((widget.currentRow.DTINIGOZOFERIAS && widget.currentRow.DTFIMGOZOFERIAS) ||
            (widget.currentRow.DTINIGOZOINI && widget.currentRow.DTINIGOZOFIM)) {
            var grupoMensagem; var tipoGrupoMensagem; var dtiniferias; var dtfimferias; 
            if(widget.currentRow.DTINIGOZOFERIAS && widget.currentRow.DTFIMGOZOFERIAS) {
                dtiniferias = widget.currentRow.DTINIGOZOFERIAS.substring(0,10);
                dtfimferias = widget.currentRow.DTFIMGOZOFERIAS.substring(0,10);
            } else if (widget.currentRow.DTINIGOZOINI && widget.currentRow.DTINIGOZOFIM){
                dtiniferias = widget.currentRow.DTINIGOZOINI.substring(0,10);
                dtfimferias = widget.currentRow.DTINIGOZOFIM.substring(0,10);
            }
            
            //diversificação das mensagens pra cada tipo de ordem
            if (widget.currentRow.DSORDEM == 'ALFABETICA') {
                tipoGrupoMensagem = ' para todos os vínculos entre ';
                grupoMensagem = widget.currentRow.NMINIVINCULOM + ' e ' + widget.currentRow.NMFIMVINCULOM;
            } else if (widget.currentRow.DSORDEM == 'MATRICULA') {
                tipoGrupoMensagem = ' para todos os vínculos com matrícula entre ';
                grupoMensagem = widget.currentRow.CDINIMATRICULA + ' e ' + widget.currentRow.CDFIMMATRICULA;
            } else if (widget.currentRow.DSORDEM == 'DATA_ADMISSAO') {
                tipoGrupoMensagem = ' para todos os vínculos com admitidos entre ';
                grupoMensagem = widget.currentRow.DTINIADMISSAO + ' e ' + widget.currentRow.DTFIMADMISSAO;
            } else if (widget.currentRow.DSORDEM == 'ESTRUTURA') {
                tipoGrupoMensagem = ' para todos os vínculos da empresa ';
                grupoMensagem = widget.currentRow.NMESTRUTLEGAL;
            } else if (widget.currentRow.DSORDEM == 'LISTA_ESTRUTURA') {
                tipoGrupoMensagem = ' para todos os vínculos das empresas selecionadas ';
                grupoMensagem = '';
            } else if (widget.currentRow.DSORDEM == 'LISTA_VINCULO') {
                tipoGrupoMensagem = ' para todos os vínculos selecionados ';
                grupoMensagem = '';
            }
            
            ScreenService.confirmMessage('Atenção: Serão incluídos o período de gozo ' + dtiniferias + ' à ' + dtfimferias + 
            tipoGrupoMensagem + grupoMensagem + '. Deseja prosseguir?', 'CONFIRMATION',
                function() {
                    widget.currentRow.TP_PROCESSAMENTO = 'CALCULO';
                    restEngine.post("product#/cadGozoFerias", {
                            'requestType': 'DataSet',
                            'dataset': [widget.currentRow]
                        },
                        function(data) {
                            if (data.dataset) {
                                if (data.dataset.msg && data.dataset.msg.length > 0) {
                                    this.openPopup(data.dataset.msg);
                                } else {
                                    ScreenService.showMessage('Não foram encontrados dados para o cadastro');
                                    ScreenService.closePopup();
                                }
                            } else {
                                data.messages.forEach(function(mensagem) {
                                    ScreenService.showMessage('Erro ao cadastrar gozo: <br>' + mensagem.message);
                                });
                            }
                        }.bind(this), undefined,
                        function(e) {
                            var error;
                            if (e.data.error === undefined)
                                error = e;
                            else
                                error = e.data.error;

                            ScreenService.showMessage('Ocorreu um erro inesperado, contate o administrador informando o trecho abaixo: <br><br>' + error + '<br><br>', 'ERROR');
                        }
                    );
                }.bind(this));
        } else {
            ScreenService.showMessage('Favor informar data de inicio e fim de gozo');
            return;
        }
    };

    this.retGozoFerias = function(args) {
        var widget = ABUtilController.checkWidget(args);
        if ((widget.currentRow.DTINIGOZOFERIAS && widget.currentRow.DTFIMGOZOFERIAS) ||
            (widget.currentRow.DTINIGOZOINI && widget.currentRow.DTINIGOZOFIM)) {
            var grupoMensagem; var tipoGrupoMensagem = ''; var dtiniferias; var dtfimferias;
            if(widget.currentRow.DTINIGOZOFERIAS && widget.currentRow.DTFIMGOZOFERIAS) {
                dtiniferias = widget.currentRow.DTINIGOZOFERIAS.substring(0,10);
                dtfimferias = widget.currentRow.DTFIMGOZOFERIAS.substring(0,10);
            } else if (widget.currentRow.DTINIGOZOINI && widget.currentRow.DTINIGOZOFIM){
                dtiniferias = widget.currentRow.DTINIGOZOINI.substring(0,10);
                dtfimferias = widget.currentRow.DTINIGOZOFIM.substring(0,10);
            }
            
            //diversificação das mensagens pra cada tipo de ordem
            if (widget.currentRow.DSORDEM == 'ALFABETICA') {
                tipoGrupoMensagem = ' para todos os vínculos entre ';
                grupoMensagem = widget.currentRow.NMINIVINCULOM + ' e ' + widget.currentRow.NMFIMVINCULOM;
            } else if (widget.currentRow.DSORDEM == 'MATRICULA') {
                tipoGrupoMensagem = ' para todos os vínculos com matrícula entre ';
                grupoMensagem = widget.currentRow.CDINIMATRICULA + ' e ' + widget.currentRow.CDFIMMATRICULA;
            } else if (widget.currentRow.DSORDEM == 'DATA_ADMISSAO') {
                tipoGrupoMensagem = ' para todos os vínculos com admitidos entre ';
                grupoMensagem = widget.currentRow.DTINIADMISSAO + ' e ' + widget.currentRow.DTFIMADMISSAO;
            } else if (widget.currentRow.DSORDEM == 'ESTRUTURA') {
                tipoGrupoMensagem = ' para todos os vínculos da empresa ';
                grupoMensagem = widget.currentRow.NMESTRUTLEGAL;
            } else if (widget.currentRow.DSORDEM == 'LISTA_ESTRUTURA') {
                tipoGrupoMensagem = ' para todos os vínculos das empresas selecionadas ';
            } else if (widget.currentRow.DSORDEM == 'LISTA_VINCULO') {
                tipoGrupoMensagem = ' para todos os vínculos selecionados ';
            }
            
            ScreenService.confirmMessage('Atenção: Serão retrocedidos todos os períodos de gozo que sejam exatamente iguais ao período ' + 
            dtiniferias + ' à ' + dtfimferias + tipoGrupoMensagem + grupoMensagem + '. Deseja prosseguir?', 'CONFIRMATION',
                function() {
                    widget.currentRow.TP_PROCESSAMENTO = 'RETROCESSO';
                    restEngine.post("product#/retGozoFerias", {
                            'requestType': 'DataSet',
                            'dataset': [widget.currentRow]
                        },
                        function(data) {
                            if (data.dataset) {
                                if (data.dataset.msg) {
                                    this.openPopup(data.dataset.msg);
                                } else {
                                    ScreenService.showMessage('Não foram encontrados dados para o retrocesso');
                                    ScreenService.closePopup();
                                }
                            } else {
                                data.messages.forEach(function(mensagem) {
                                    ScreenService.showMessage('Erro ao retroceder gozo: <br>' + mensagem.message);
                                });
                            }
                        }.bind(this), undefined,
                        function(e) {
                            var error;
                            if (e.data.error === undefined)
                                error = e;
                            else
                                error = e.data.error;

                            ScreenService.showMessage('Ocorreu um erro inesperado, contate o administrador informando o trecho abaixo: <br><br>' + error + '<br><br>', 'ERROR');
                        }
                    );
                }.bind(this));
        } else {
            ScreenService.showMessage('Favor informar data de inicio e fim de gozo');
            return;
        }
    };
    
        
    this.validaFiltroFerias = function () {
        var widget = templateManager.container.getWidget('calculoFerias');
        var resultado = false;
        if(!widget.getField('NRVINCULOM_LIST') && !widget.getField('LIST_NRESTRUTLEGAL') && !widget.getField('LIST_NRESTRUTGEREN') && !widget.getField('LIST_NRESTRUTSIND')){
            ScreenService.showMessage("É necessário preencher o campo 'Vínculo', 'Estrutura Legal', 'Estrutura Gerencial' ou 'Estrutura Sindical' para realizar o filtro.");

        } else {
            if ((widget.currentRow.NRVINCULOM_LIST && widget.currentRow.NRVINCULOM_LIST.length > 400)) {
                ScreenService.showMessage("Favor selecionar um máximo de 400 vínculos na lista ou usar outro filtro como por exemplo por estrutura legal.");
                resultado =  true;
            }
            if ((widget.currentRow.LIST_NRESTRUTLEGAL && widget.currentRow.LIST_NRESTRUTLEGAL.length > 400) || (widget.currentRow.LIST_NRESTRUTGEREN && widget.currentRow.LIST_NRESTRUTGEREN .length > 400) || (widget.currentRow.LIST_NRESTRUTGEREN  && widget.currentRow.LIST_NRESTRUTGEREN.length > 400)) {
                ScreenService.showMessage("Favor selecionar um máximo de 400 estruturas na lista.");
                resultado = true;
            }
        } 
        return resultado;
    };
    
    this.setFormFerias = function(args) {
        var widget = args.owner.widget;
        var filtroFerias = this.validaFiltroFerias();
        if (widget.isValid()) {
            if (ABUtilController.validaCritSelecao(widget.currentRow)) {
                if(filtroFerias == true){
                    return;
                }
                if (!widget.backupRow) {
                widget.currentRow.__is_new = true;
                } else {
                    widget.currentRow.__is_new = false;
                }
                widget.currentRow.DTINIGOZOINI = widget.currentRow.DTINIGOZOFERIAS;
                widget.currentRow.DTINIGOZOFIM = widget.currentRow.DTFIMGOZOFERIAS;
                restEngine.post('product#/setFormFerias', {
                    'requestType': 'DataSet',
                    'dataset': [widget.currentRow]
                }).
                then(function(data) {
                    if (data.notifications[0].type === "success") {
                        ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                        if (widget.currentRow.__is_new) {
                            ABUtilController.masterDetailVoltarList(widget);
                            widget.reload();
                        } else {
                            widget.backupRow = null;
                            widget.view();
                        }
                    } else {
                        ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                    }
                }).
                catch(function(e) {
                    var error;
                    if (e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
            }
        }
    };

    this.deleteFormFerias = function(args) {
        var widget = templateManager.container.getActiveWidget();
        ScreenService.confirmMessage(Messages.DELETE_ROW, 'CONFIRMATION', 
            function(){
                if (widget.isValid()) {
                    widget.currentRow.__is_new = false;
                    restEngine.post('product#/deleteFormFerias', {
                        'requestType': 'DataSet',
                        'dataset': [widget.currentRow]
                    }).
                    then(function(data) {
                        if (data.messages) {
                            ScreenService.showMessage(Messages.REMOVE_ROW_ERROR + '. ' + data.messages[0].message, data.messages[0].type);
                        } else {
                            ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                            ABUtilController.masterDetailVoltarList(widget);
                            widget.reload();
                        }
                    }).
                    catch(function(e) {
                        var error;
                        if (e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;
        
                        ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    });
                }
            }.bind(this)
        );
    };
    
    this.gravacaoApolo = function(args) {
        var widget = ABUtilController.checkWidget(args);
        ScreenService.confirmMessage('Deseja realmente gravar definitivamente o cálculo?', 'CONFIRMATION',
            function() {
                widget.currentRow.TP_PROCESSAMENTO = 'CALCULO_APOLO_GRAVAR';
                widget.currentRow.TP_CALCULO = 2;
                restEngine.post("product#/calculoApolo", {
                    'requestType': 'DataSet',
                    'dataset': [widget.currentRow]
                }).then(function(data) {
                    if (data.messages) {
                        ScreenService.showMessage(data.messages[0].message);
                        ScreenService.closePopup();
                    }
                }).catch(function(e) {
                    var error;
                    if (e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;

                    ScreenService.showMessage('Ocorreu um erro inesperado, contate o administrador informando o trecho abaixo: <br><br>' + error + '<br><br>', 'ERROR');
                });
            }.bind(this));
    };
    
    this.gravacaoParcialApolo = function(args) {
        var widget = ABUtilController.checkWidget(args);
        ScreenService.confirmMessage('Deseja realmente gravar parcial o cálculo?', 'CONFIRMATION',
            function() {
                widget.currentRow.TP_PROCESSAMENTO = 'CALCULO_APOLO_GRAVAR_PARCIAL';
                widget.currentRow.TP_CALCULO = 2;
                restEngine.post("product#/calculoApolo", {
                    'requestType': 'DataSet',
                    'dataset': [widget.currentRow]
                }).then(function(data) {
                    if (data.messages) {
                        ScreenService.showMessage(data.messages[0].message);
                        ScreenService.closePopup();
                    }
                }).catch(function(e) {
                    var error;
                    if (e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;

                    ScreenService.showMessage('Ocorreu um erro inesperado, contate o administrador informando o trecho abaixo: <br><br>' + error + '<br><br>', 'ERROR');
                });
            }.bind(this));
    };
    
    this.gravacaoDefinitiva = function(args, ESocialController, verificaEnvioEsocialDescentralizado = false, nmevento = 'S-2230') {
        var widget = ABUtilController.checkWidget(args);
        if(verificaEnvioEsocialDescentralizado){
            ScreenService.confirmMessage('Deseja realmente gravar definitivamente o cálculo?', 'CONFIRMATION',
            function() {
                ESocialController.envioEsocialDescentralizado(widget.currentRow, nmevento, null, null, this.gravacaoDefinitiva, args);
            }.bind(this));
        }else{
            widget.currentRow.TP_PROCESSAMENTO = 'CALCULO';
            widget.currentRow.TP_CALCULO = 2;
            restEngine.post("product#/calculo", {
                'requestType': 'DataSet',
                'dataset': [widget.currentRow]
            }).then(function(data) {
                if(data.dataset && data.dataset.retornoEsocial && data.dataset.retornoEsocial.length > 0){
                    var mensagem = nmevento+':<br>';
                    data.dataset.retornoEsocial.forEach(function(retorno){
                        mensagem += retorno.MSG + '<br>';
                    });
                    ScreenService.showMessage(mensagem);
                }
                if (widget.currentRow.FORM_RECIBO) {
                    var widgetCalc = templateManager.container.getWidget(widget.currentRow.FORM_RECIBO);
                    widgetCalc.reload();
                    ScreenService.closePopup();
                }
                if (data.messages) {
                    ScreenService.successNotification(data.messages[0].message);
                    ScreenService.closePopup();
                }
                if (data.dataset && data.dataset.memoriaCalculo && data.dataset.memoriaCalculo.length > 0) {
                    data.dataset.memoriaCalculo.forEach(function(nmArquivo){
                       ABUtilController.downloadArquivo(nmArquivo.ARQUIVOMEMORIA);
                    });
                }
                if (data.dataset && data.dataset.msgCalculo && data.dataset.msgCalculo.length > 0) {
                    var popUp = templateManager.container.getWidget("mensagens");
                    popUp.dataSource.data = data.dataset.msgCalculo;
                    ABUtilController.masterDetailOpenPopup(popUp);
                }
            }).catch(function(e) {
                var error;
                if (e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;

                ScreenService.showMessage('Ocorreu um erro inesperado, contate o administrador informando o trecho abaixo: <br><br>' + error + '<br><br>', 'ERROR');
            });
        }
    };

    this.gravacaoParcial = function(args) {
        var widget = ABUtilController.checkWidget(args);
        ScreenService.confirmMessage('Deseja realmente gravar parcialmente o cálculo?', 'CONFIRMATION',
            function() {
                widget.currentRow.TP_PROCESSAMENTO = 'PARCIAL';
                widget.currentRow.TP_CALCULO = 2;
                restEngine.post("product#/calculo", {
                    'requestType': 'DataSet',
                    'dataset': [widget.currentRow]
                }).then(function(data) {
                    if (widget.currentRow.FORM_RECIBO) {
                        var widgetCalc = templateManager.container.getWidget(widget.currentRow.FORM_RECIBO);
                        widgetCalc.reload();
                        ScreenService.closePopup();
                    }
                    if (data.messages) {
                        ScreenService.successNotification(data.messages[0].message);
                        ScreenService.closePopup();
                    }
                    if (data.dataset && data.dataset.memoriaCalculo && data.dataset.memoriaCalculo.length > 0) {
                        data.dataset.memoriaCalculo.forEach(function(nmArquivo){
                           ABUtilController.downloadArquivo(nmArquivo.ARQUIVOMEMORIA);
                        });
                    }
                    if (data.dataset && data.dataset.msgCalculo && data.dataset.msgCalculo.length > 0) {
                        var popUp = templateManager.container.getWidget("mensagens");
                        popUp.dataSource.data = data.dataset.msgCalculo;
                        ABUtilController.masterDetailOpenPopup(popUp);
                    }
                }).catch(function(e) {
                    var error;
                    if (e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;

                    ScreenService.showMessage('Ocorreu um erro inesperado, contate o administrador informando o trecho abaixo: <br><br>' + error + '<br><br>', 'ERROR');
                });
            }.bind(this));
    };

    this.retrocesso = function(args) {
        var widget = ABUtilController.checkWidget(args);
        var self = this;
        ScreenService.confirmMessage('Deseja realmente retroceder o cálculo?', 'CONFIRMATION', function() {
            self.enviaRetrocesso(widget, false);
        });
    };
    
    this.enviaRetrocesso = function(widget, confirmacao){
        var self = this;
        widget.currentRow.TP_PROCESSAMENTO = 'RETROCESSO';
        widget.currentRow.TP_CALCULO = 2;
        widget.currentRow.RETROCESSO_CONFIRMADO = confirmacao;
        restEngine.post("product#/calculo", {
            'requestType': 'DataSet',
            'dataset': [widget.currentRow]
        }).then(function(data) {
            if (widget.currentRow.FORM_RECIBO) {
                var widgetCalc = templateManager.container.getWidget(widget.currentRow.FORM_RECIBO);
                widgetCalc.reload();
                ScreenService.closePopup();
            }
            if (data.messages) {
                if (data.messages[0].type == 'W') {
                    ScreenService.confirmMessage(data.messages[0].message, 'CONFIRMATION', function() {
                        self.enviaRetrocesso(widget, true);
                    });
                } else {
                    ScreenService.successNotification(data.messages[0].message);
                }
                ScreenService.closePopup();
            }
            if (data.dataset && data.dataset.msgCalculo && data.dataset.msgCalculo.length > 0) {
                var popUp = templateManager.container.getWidget("mensagens");
                popUp.dataSource.data = data.dataset.msgCalculo;
                ABUtilController.masterDetailOpenPopup(popUp);
            }
        }.bind(this)).catch(function(e) {
            var error;
            if (e.data.error === undefined)
                error = e;
            else
                error = e.data.error;

            ScreenService.showMessage('Ocorreu um erro inesperado, contate o administrador informando o trecho abaixo: <br><br>' + error + '<br><br>', 'ERROR');
        });
    };

    this.cancelamentoDeFerias = function(args) {
        var widget = ABUtilController.checkWidget(args);
        ScreenService.confirmMessage('Deseja realmente cancelar o cálculo?', 'CONFIRMATION',
            function() {
                widget.currentRow.TP_PROCESSAMENTO = 'CANCELAMENTO';
                widget.currentRow.TP_CALCULO = 2;
                restEngine.post("product#/calculo", {
                    'requestType': 'DataSet',
                    'dataset': [widget.currentRow]
                }).then(function(data) {
                    if (widget.currentRow.FORM_RECIBO) {
                        var widgetCalc = templateManager.container.getWidget(widget.currentRow.FORM_RECIBO);
                        widgetCalc.reload();
                        ScreenService.closePopup();
                    }
                    if (data.messages) {
                        ScreenService.successNotification(data.messages[0].message);
                        ScreenService.closePopup();
                    }
                    if (data.dataset && data.dataset.msgCalculo && data.dataset.msgCalculo.length > 0) {
                        var popUp = templateManager.container.getWidget("mensagens");
                        popUp.dataSource.data = data.dataset.msgCalculo;
                        ABUtilController.masterDetailOpenPopup(popUp);
                    }
                }).catch(function(e) {
                    var error;
                    if (e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;

                    ScreenService.showMessage('Ocorreu um erro inesperado, contate o administrador informando o trecho abaixo: <br><br>' + error + '<br><br>', 'ERROR');
                });
            }.bind(this));
    };

    this.simular = function(args) {
        var widget = ABUtilController.checkWidget(args);
        ScreenService.confirmMessage('Deseja realmente simular o cálculo?', 'CONFIRMATION',
            function() {
                widget.currentRow.TP_PROCESSAMENTO = 'SIMULACAO';
                widget.currentRow.TP_CALCULO = 2;
                restEngine.post("product#/calculo", {
                        'requestType': 'DataSet',
                        'dataset': [widget.currentRow]
                    },
                    function(data) {
                        if (widget.currentRow.FORM_RECIBO) {
                            var widgetCalc = templateManager.container.getWidget(widget.currentRow.FORM_RECIBO);
                            widgetCalc.reload();
                            ScreenService.closePopup();
                        }
                        if(data.messages && data.messages[0].type == 'E'){
                            ScreenService.showMessage(data.messages[0].message);
                            ScreenService.closePopup();
                        }
                        if (data.messages) {
                            ScreenService.successNotification(data.messages[0].message);
                            ScreenService.closePopup();
                        }
                        if (data.dataset && data.dataset.memoriaCalculo && data.dataset.memoriaCalculo.length > 0) {
                            data.dataset.memoriaCalculo.forEach(function(nmArquivo){
                               ABUtilController.downloadArquivo(nmArquivo.ARQUIVOMEMORIA);
                            });
                        }
                        if (data.dataset && data.dataset.msgCalculo && data.dataset.msgCalculo.length > 0) {
                            var popUp = templateManager.container.getWidget("mensagens");
                            popUp.dataSource.data = data.dataset.msgCalculo;
                            ABUtilController.masterDetailOpenPopup(popUp);
                        }
                        if (data.dataset && data.dataset.simulacao) {
                            var widgetSimu = this.preparaDemonstrativo(data.dataset.simulacao);
                            ABUtilController.masterDetailOpenPopup(widgetSimu);
                        }
                    }.bind(this), undefined,
                    function(e) {
                        var error;
                        if (e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;

                        ScreenService.showMessage('Ocorreu um erro inesperado, contate o administrador informando o trecho abaixo: <br><br>' + error + '<br><br>', 'ERROR');
                    }
                );
            }.bind(this));
    };

    this.preparaDemonstrativo = function(vinculos) {

        var widgetSimulacao = templateManager.container.getWidget("simulacao");
        widgetSimulacao.dataSource.data = [];
        vinculos.forEach(function(nrcalculofolha) {
            nrcalculofolha.SIMULACAO.forEach(function(itensCalcFolha) {
                widgetSimulacao.dataSource.data = widgetSimulacao.dataSource.data.concat(itensCalcFolha);
            });
        });
        return widgetSimulacao;
    };
    
    this.aprovarFerias = function(args) {
        var widget = args.owner.widget;
        var total = 0;
        widget.dataSource.checkedRows.forEach(function(row){
            if(moment(row.DTINIPREVISAO,'DD/MM/YYYY').unix() > moment(row.DTLIMITE,'DD/MM/YYYY').unix()){
            ScreenService.showMessage('A Data de início de gozo não pode ser maior que a data limite.');
            return false;
        }
        });
        ScreenService.confirmMessage('Deseja realmente aprovar férias?', 'CONFIRMATION',
            function() {
                restEngine.post('product#/aprovaFerias', {
                    'requestType': 'DataSet',
                    'dataset': [widget.dataSource.checkedRows]
                }).
                then(function(data) {
                    if (data.notifications[0].type === "success") {
                        ScreenService.successNotification(data.notifications[0].message, 10000);
                        widget.reload();
                    } else {
                        ScreenService.showMessage(data.notifications[0].message);
                        widget.reload();
                    }
                }).
                catch(function(e) {
                    var error;
                    if (e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
            }.bind(this));
        
        
    };
    
    this.enviarEmailRecusa = function(args){
        var popUp = ABUtilController.checkWidget(args);
        var widget = templateManager.container.getWidget("ProgFerias");

        if (popUp.isValid()) {
            
            widget.dataSource.checkedRows.forEach(function(row){
                row.DSMENSAGEM = popUp.currentRow.DSMENSAGEM;
            });
            
            restEngine.post('product#/reprovaFerias', {
                    "requestType": "DataSet",
                    "dataset": [widget.dataSource.checkedRows]
                }
            ).then(function(response) {
                if (response.notifications[0].type === "success") {
                    ScreenService.showMessage("E-mail enviado com sucesso!");                
                    if(!Util.isUndefined(response.messages)) {
                        ScreenService.showMessage(response.messages[0].message,response.messages[0].type);
                    }
                    ABUtilController.masterDetailClosePopup(popUp);
                } else if(response.notifications[0].type === "alert"){
                    ScreenService.showMessage(response.notifications[0].message,'ERROR');
                }
                else {
                    ScreenService.showMessage('Ocorreu um erro inesperado ao gerar o demonstrativo','ERROR');
                }
            }).catch(function(e) {
                var error;
                if(e.data.error === undefined)
                    error = e;
                else 
                    error = e.data.error;
                
                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error));
            });
        }
    };
    
    this.openPopupEmailRecusa = function(args){
        var widget = templateManager.container.getWidget('emailRecusa');                              
        ABUtilController.masterDetailOpenPopup(widget);
    };

}

Configuration(function(ContextRegister) {
    ContextRegister.register('FeriasController', FeriasController);
});


// FILE: assets/js/controllers/FichaMedicaController.js
/* jshint esversion: 6 */
function FichaMedicaController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, General,Messages) {
    
    var self = this;
    
    this.adicionarRow = function(args) {
        var widget = args.owner.widget;
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
    };
    
    this.fichaMedicaWidget = function() {
        return templateManager.container.getWidget('fichamedica');
    };
    
    this.setNrocorrencia = function(){
        var widget            = templateManager.container.getWidget("ocorrencia");
        var widgetVitima      = templateManager.container.getWidget("vitima");
        var widgetFichaMedica = templateManager.container.getWidget("fichamedica");
        var nrOcorrencia      = widget.currentRow.NROCORRENCIA;
        var nrParcnegocio     = widgetVitima.currentRow.NRPARCNEGOCIO;
        widgetFichaMedica.currentRow.NROCORRENCIA   = nrOcorrencia;
        widgetFichaMedica.currentRow.NRPARCNEGOCIO  = nrParcnegocio;
        
    };
    
    this.setNrvinvulom = function(){
        var widgetVitima      = templateManager.container.getWidget("vitima");
        var widgetFichaMedica = templateManager.container.getWidget("fichamedica");
        for (var i = 0; i < widgetVitima.getField('NMPRINCIPALPARC').dataSource.data.length; i++) {
            if( widgetVitima.getField('NMPRINCIPALPARC').dataSource.data[i].NRPARCNEGOCIO == widgetVitima.currentRow.NRPARCNEGOCIO ) {
                widgetFichaMedica.currentRow.NRVINCULOM = widgetVitima.getField('NMPRINCIPALPARC').dataSource.data[i].NRVINCULOM;
                widgetFichaMedica.currentRow.NMVINCULOM = widgetVitima.getField('NMPRINCIPALPARC').dataSource.data[i].NMPRINCIPALPARC;
            }
        }
    };
    
    this.setParansPessoavinc = function(){
    var widgetVitima      = templateManager.container.getWidget("vitima");
        var widgetFichaMedica = templateManager.container.getWidget("fichamedica");
            
        widgetFichaMedica.dataSourceFilter[3].value = widgetVitima.currentRow.NRPESSOA;
        widgetFichaMedica.reload();
    };
    
    this.filtrarWidgetPorFichaMedica = function(args){
        var widget = args.owner;
        templateManager.container.getWidget("exames").dataSourceFilter[2].value = widget.currentRow.NRFICHAMEDICA;
        templateManager.container.getWidget("doenca").dataSourceFilter[2].value = widget.currentRow.NRFICHAMEDICA;
        
    };
    
    this.editFichaMedica = function(args){
        var widget = args.owner.widget;
        if(widget.currentRow.NMSITUFUNCH){
            widget.currentRow.NMSITUFUNCH = "";
            widget.currentRow.NRSITUFUNCM = "";
        }
        if(widget.currentRow.NMSITUFUNCHPROX){
            widget.currentRow.NMSITUFUNCHPROX = "";
            widget.currentRow.NRSITUFUNCMPROX = "";
        }
    };
    
    this.filtrarItemExame = function(args){
        var field = args.owner.field;
        field.dataSourceFilter[2].value = templateManager.container.getWidget("exames").currentRow.NREXAME;
    };
    
    this.afterMoveRowExame = function(args){
        var widget = args.owner;
        templateManager.container.getWidget("itemExame").dataSourceFilter[2].value = widget.currentRow.NREXAMEFICHAMED;
    };
    
    this.widgetsvisiblefalse = function(args) {
        var widget = args.owner.widget;
        widget.widgets[0].showAsTab = false;
        if(widget.widgets.length > 1){
            widget.widgets[1].showAsTab = false;
        }
    };
    
    this.calcularIMC = function(args){
        var widget = args.owner.field.widget;
        var IMC;
        var altura = widget.currentRow.VRALTURA;
        var peso = widget.currentRow.QTPESO;
        if(peso && altura){
            IMC = parseFloat(peso.replace(",", ".")) / Math.pow(parseFloat(altura.replace(",", ".")),2);
            widget.currentRow.VRIMC = IMC;
            if(IMC < 16) {
                widget.currentRow.GRAUOBESIDADE =  'Magreza grave';
            }else if(IMC >= 16 && IMC < 17) {
                widget.currentRow.GRAUOBESIDADE =  'Magreza moderada';
            }else if(IMC >= 17 && IMC < 18.5) {
                widget.currentRow.GRAUOBESIDADE =  'Magreza leve';
            }else if(IMC >= 18.5 && IMC < 25) {
                widget.currentRow.GRAUOBESIDADE =  'Saudável';
            }else if(IMC >= 25 && IMC < 30) {
                widget.currentRow.GRAUOBESIDADE =  'Sobrepeso';
            }else if(IMC >= 30 && IMC < 35) {
                widget.currentRow.GRAUOBESIDADE =  'Obesidade Grau I';
            }else if(IMC >= 35 && IMC < 40) {
                widget.currentRow.GRAUOBESIDADE =  'Obesidade Grau II (severa)';
            }else if(IMC >= 40) {
                widget.currentRow.GRAUOBESIDADE =  'Obesidade Grau III (mórbida)';
            }
        }else{
            widget.currentRow.VRIMC = "";
            widget.currentRow.GRAUOBESIDADE = "";
        }
    };

    this.widgetsvisibletrue = function(args) {
        var widget = args.owner.widget;
        widget.widgets[0].showAsTab = true;
        if(widget.widgets.length > 1){
            widget.widgets[1].showAsTab = true;
        }
    };
    
    this.validaPeriodo = function(dtIni, dtFin) {
        if (moment(dtIni, 'DD/MM/YYYY').unix() > moment(dtFin, 'DD/MM/YYYY').unix() || moment(dtFin, 'DD/MM/YYYY').unix() < moment(dtIni, 'DD/MM/YYYY').unix()) {

            return false;
        }
        else {
            return true;
        }
    };
    
	this.setFichaMedica = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
            if (this.validaPeriodo(widget.currentRow.DTHRINIAFASTAMENTO, widget.currentRow.DTHRFIMAFASTAMENTO)) {
                if (!widget.backupRow) {
                    widget.currentRow.__is_new = true;
                } else {
                    widget.currentRow.__is_new = false;
                }
                if(widget.currentRow.NRCAT){
                    widget.currentRow.IDEMISSAOCAT = "S";
                }else{
                    widget.currentRow.IDEMISSAOCAT = "N";
                }
                if(widget.currentRow.NRBENEFICIO){
                    widget.currentRow.IDBENEFICIO = "S";
                }else{
                    widget.currentRow.IDBENEFICIO = "N";
                }
                widget.currentRow.QTPESO = General.valueToFloat(widget.currentRow.QTPESO);
                widget.currentRow.VRALTURA = General.valueToFloat(widget.currentRow.VRALTURA);
                widget.currentRow.VRTEMPERATURA = General.valueToFloat(widget.currentRow.VRTEMPERATURA);
                restEngine.post('product#/setFichaMedica', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                    then(function (data) {
                        if (data.notifications[0].type === "success") {
                            ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                            if (widget.currentRow.__is_new) {
                                ABUtilController.masterDetailVoltarList(widget);
                                if(widget.getParent().name != "vitima"){
                                    self.widgetsvisibletrue(args);
                                }
                                widget.reload();
                            } else {
                                ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                                widget.backupRow = null;
                                widget.view();
                            }
                        } else {
                            ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                        }
                    }).
                    catch(function(e) {
                        var error;
                        if(e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;
                            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    });
            }else{
                ScreenService.showMessage('O campo "Data-Hora Inicio Afastamento" deve ser igual ou posterior à "Data-Hora Fim Afastamento"');
                return false;
            }           
        }
    };
    
    this.deleteFichaMedica = function(args) {
    ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
        var widget = templateManager.container.getActiveWidget();
        if (widget.isValid()) {
            widget.currentRow.__is_new = false;
            restEngine.post('product#/deleteFichaMedica', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                then(function (data) {
                    if (data.messages) {
                        ScreenService.showMessage(Messages.REMOVE_ROW_ERROR + '. ' + data.messages[0].message, data.messages[0].type);
                    } else {
                        ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    }
                }).
                catch(function(e) {
                    var error;
                    if(e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;

                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
            }
        }, null);
    };

    this.somenteNumerosCodigoProcedimento = function(cdproctuss){
        var retorno = true;
        var strNum = cdproctuss.replace(/[^0-9]/g,'');
        if(strNum.length != cdproctuss.length){
            ScreenService.showMessage(Messages.CODIGO_COM_LETRA, 'ALERT');
            retorno = false;  
        } 
        return retorno;
    };
    
	this.setExameFichaMed = function(args) {
        var widget = args.owner.widget;
        var widgetMain = templateManager.container.getWidget("fichamedica");
        if (widget.isValid() && this.somenteNumerosCodigoProcedimento(widget.currentRow.CDPROCTUSS)) {
            if (!widget.backupRow) {
                widget.currentRow.__is_new = true;
            } else {
                widget.currentRow.__is_new = false;
            }
            widget.currentRow.NRFICHAMEDICA = widgetMain.currentRow.NRFICHAMEDICA;
            restEngine.post('product#/setExameFichaMed', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                then(function (data) {
                    if (data.notifications[0].type === "success") {
                        ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                        if (widget.currentRow.__is_new) {
                            ABUtilController.masterDetailVoltarList(widget);
                            self.widgetsvisibletrue(args);
                            widget.reload();
                        } else {
                            ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                            widget.backupRow = null;
                            widget.view();
                        }
                    } else {
                        ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                    }
                }).
                catch(function(e) {
                    var error;
                    if(e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;
                        ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
        }
    };
    
    this.deleteExameFichaMed = function(args) {
        ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
        
        var widget = args.owner.widget;
        widget.currentRow.__is_new = false;
        restEngine.post('product#/deleteExameFichaMed', {'requestType':'DataSet','dataset':[widget.currentRow]}).
            then(function(data){
               if (data.messages) {
                    ScreenService.showMessage(Messages.REMOVE_ROW_ERROR + '. ' + data.messages[0].message, data.messages[0].type);
                } else {
                    ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                    ABUtilController.masterDetailVoltarList(widget);
                    widget.reload();
                }
            }).
            catch(function(e) {
                var error;
                if(e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
    
        }, null);
    };
    
    this.setItemExameFichaMed = function(args) {
        var widget = args.owner.widget;
        var widgetExame = templateManager.container.getWidget("exames");
        if (widget.isValid()) {
            if (!widget.backupRow) {
                widget.currentRow.__is_new = true;
            } else {
                widget.currentRow.__is_new = false;
            }
            widget.currentRow.NREXAMEFICHAMED = widgetExame.currentRow.NREXAMEFICHAMED;
            restEngine.post('product#/setItemExameFichaMed', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                then(function (data) {
                    if (data.notifications[0].type === "success") {
                        ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                        if (widget.currentRow.__is_new) {
                            ABUtilController.masterDetailVoltarList(widget);
                            widget.reload();
                        } else {
                            widget.backupRow = null;
                            widget.view();
                        }
                    } else {
                        ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                    }
                }).
                catch(function(e) {
                    var error;
                    if(e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;
                        ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
        }
    };
    
    this.deleteItemExameFichaMed = function(args) {
        ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
        
        var widget = templateManager.container.getActiveWidget();
        if (widget.isValid()) {
            widget.currentRow.__is_new = false;
            restEngine.post('product#/deleteItemExameFichaMed', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                then(function (data) {
                    if (data.messages) {
                        ScreenService.showMessage(Messages.REMOVE_ROW_ERROR + '. ' + data.messages[0].message, data.messages[0].type);
                    } else {
                        ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    }
                }).
                catch(function(e) {
                    var error;
                    if(e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;

                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
        }
    
        }, null);
    };
    
	this.setDoencaFichaMedica = function(args) {
        var widget = args.owner.widget;
        var widgetMain = templateManager.container.getWidget("fichamedica");
        if (widget.isValid()) {
            if (!widget.backupRow) {
                widget.currentRow.__is_new = true;
            } else {
                widget.currentRow.__is_new = false;
            }
            widget.currentRow.NRFICHAMEDICA = widgetMain.currentRow.NRFICHAMEDICA;
            restEngine.post('product#/setDoencaFichaMedica', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                then(function (data) {
                    if (data.notifications[0].type === "success") {
                        ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                        if (widget.currentRow.__is_new) {
                            ABUtilController.masterDetailVoltarList(widget);
                            widget.reload();
                        } else {
                            widget.backupRow = null;
                            widget.view();
                        }
                    } else {
                        ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                    }
                }).
                catch(function(e) {
                    var error;
                    if(e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;
                        ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
        }
    };
    
    this.deleteDoencaFichaMedica = function(args) {
        ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
        
        var widget = args.owner.widget;
        widget.currentRow.__is_new = false;
        restEngine.post('product#/deleteDoencaFichaMedica', {'requestType':'DataSet','dataset':[widget.currentRow]}).
            then(function(data){
               if (data.messages) {
                    ScreenService.showMessage(Messages.REMOVE_ROW_ERROR + '. ' + data.messages[0].message, data.messages[0].type);
                } else {
                    ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                    ABUtilController.masterDetailVoltarList(widget);
                    widget.reload();
                }
            }).
            catch(function(e) {
                var error;
                if(e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
    
        }, null);
    };
    
    this.openPopupCadAutomaticofichaMedica = function(args) {
        var widgetFilter = templateManager.container.getWidget('cadAutomaticoFichaMedica');
        widgetFilter.applyDefaultValue();
        ScreenService.openPopup(widgetFilter);
    };
    
    this.cadastroAutomaticoFichaMedica = function() {
       var widget = templateManager.container.getWidget('cadAutomaticoFichaMedica');
       var fichamedica = templateManager.container.getWidget('fichamedica');
        
        if(widget.currentRow.NRVINCULOM_LIST == '' && widget.currentRow.NRESTRUTGEREN_LIST == '' && widget.currentRow.NRESTRUTLEGAL_LIST == ''){
            ScreenService.showMessage("Para proseguir com o casdastro favor selecionar pelo menos um critério como lista de vínculos ou estruturas.");
            return;
        }
    
        if (widget.isValid()) {
            if (!widget.backupRow) {
                    widget.currentRow.__is_new = true;
                }
                else {
                    widget.currentRow.__is_new = false;
                }
            restEngine.post('product#/setCadastroAutomaticoFichaMedica', {
                'requestType': 'DataSet',
                'dataset': [widget.currentRow]
            }).
            then(function(data) {
                ScreenService.closePopup(true);
                ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 1000);
                ABUtilController.masterDetailVoltarList(fichamedica);
                templateManager.container.getWidget('fichamedica').reload();
            }).
            catch(function(e) {
                var error;
                if (e.data.error === undefined) error = e;
                else error = e.data.error;
                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
        }

    };
    
    /* jshint ignore:start */
    this.afterSuccessMedicoSaveCallback = async function(returnColumns) {
        const data = returnColumns[0];
        const medicoField = self.fichaMedicaWidget().getField('NMPESSOA');
        if (!medicoField || !medicoField.outData) {
            return;
        }
        
        await medicoField.reload();
        if (!medicoField.dataSource.data) {
            return;
        }
        
        const newMedicoData = medicoField.dataSource.data.find((row) => row.NRPESSOA == data.NRPESSOA);
        if (!newMedicoData) {
            return;
        }
        
        for (const outDataFrom in medicoField.outData) {
            const outDataTo = medicoField.outData[outDataFrom];
            self.fichaMedicaWidget().currentRow[outDataTo] = newMedicoData[outDataFrom];
        }
    };
    /* jshint ignore:end */
    
}

Configuration(function(ContextRegister) {
    ContextRegister.register('FichaMedicaController', FichaMedicaController);
});

// FILE: assets/js/controllers/FormaBeneficioController.js
function FormaBeneficioController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, General, Messages) {


    this.adicionarRow = function(args) {
        var widget = args.owner.widget;
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
    };

    this.salvarFormaBeneficio = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
            if (!widget.backupRow) {
                widget.currentRow.__is_new = true;
            } else {
                widget.currentRow.__is_new = false;
            }
            restEngine.post('product#/setFormaBeneficio', {
                'requestType': 'DataSet',
                'dataset': [widget.currentRow]
            }).
            then(function(data) {
                if (data.notifications[0].type === "success") {
                    ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                    if (widget.currentRow.__is_new) {
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    } else {
                        ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                        widget.backupRow = null;
                        widget.view();
                    }
                } else {
                    ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                }
            }).
            catch(function(e) {
                var error;
                if (e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
        }

    };

    this.removerFormaBeneficio = function(args) {
        ScreenService.confirmMessage(Messages.DELETE_ROW, 'CONFIRMATION',
            function() {

                var widget = args.owner.widget;
                widget.currentRow.__is_new = false;
                restEngine.post('product#/removerFormaBeneficio', {
                    'requestType': 'DataSet',
                    'dataset': [widget.currentRow]
                }).
                then(function(data) {
                    if (data.notifications[0].type === "success") {
                        ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    } else {
                        ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                    }
                }).
                catch(function(e) {
                    var error;
                    if (e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });

            });
    };

}

Configuration(function(ContextRegister) {
    ContextRegister.register('FormaBeneficioController', FormaBeneficioController);
});


// FILE: assets/js/controllers/FormadetransporteController.js
function FormadetransporteController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, Messages) {

    this.salvarFormadetransporte = function(args) {
        var widget = templateManager.container.getActiveWidget();
        if (widget.isValid()) {
            if (!widget.backupRow) {
                widget.currentRow.__is_new = true;
            } else {
                widget.currentRow.__is_new = false;
            }
            restEngine.post('product#/setFormatransporte', {
                'requestType': 'DataSet',
                'dataset': [widget.currentRow]
            }).
            then(function(data) {
                if (data.notifications[0].type === "success") {
                    ScreenService.successNotification('Forma de transporte salva com sucesso', 10000);
                    if (widget.currentRow.__is_new) {
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    } else {
                        ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                        widget.backupRow = null;
                        widget.view();
                    }
                } else {
                    ScreenService.showMessage('Erro ao salvar a forma de transporte');
                }
            }).
            catch(function(e) {
                var error;
                if (e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;

                ScreenService.showMessage('Ocorreu um erro inesperado, contate o administrador informando o trecho abaixo: <br><br>' + error + '<br><br>', 'ERROR');
            });
        }
    };

    this.removerFormadetransporte = function(args) {
        ScreenService.confirmMessage(Messages.DELETE_ROW, 'CONFIRMATION',
            function() {
                var widget = templateManager.container.getActiveWidget();
                widget.currentRow.__is_new = false;
                restEngine.post('product#/deleteFormatransporte', {
                    'requestType': 'DataSet',
                    'dataset': [widget.currentRow]
                }).
                then(function(data) {
                    if (data.notifications[0].type === "success") {
                        ScreenService.successNotification('Forma de transporte excluída com sucesso', 10000);
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    } else {
                        ScreenService.showMessage('Erro ao excluir a forma de transporte');
                    }
                }).
                catch(function(e) {
                    var error;
                    if (e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;

                    ScreenService.showMessage('Ocorreu um erro inesperado, contate o administrador informando o trecho abaixo: <br><br>' + error + '<br><br>', 'ERROR');
                });
            });
    };

}

Configuration(function(ContextRegister) {
    ContextRegister.register('FormadetransporteController', FormadetransporteController);
});


// FILE: assets/js/controllers/FormularioCagedController.js
function FormularioCagedController (ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, $window, ABUtilController, Messages) {
    
    this.downloadCaged = function(currentRow){
        $window.open($window.serviceUrl+"/downloadCaged?requestType=DataSet&dataset[0][NRFORMCAGED]=" + currentRow.NRFORMCAGED);
    };

    this.deleteFomulario = function(args){
        var widget = ABUtilController.checkWidget(args);
        ScreenService.confirmMessage(Messages.DELETE_ROW, 'CONFIRMATION', 
            function(){
                widget.dataSource.checkedRows = widget.currentRow;
                widget.removeCheckedRows();
                widget.reload();
                ABUtilController.masterDetailVoltarList(widget);
                ScreenService.showMessage(Messages.REMOVE_ROW_SUCCESS);
            }.bind(this)
        );
    };

    this.gerarCaged = function(args) {
        var widget = ABUtilController.checkWidget(args);
        if (widget.isValid()) {
            if (!widget.backupRow) {
                widget.currentRow.__is_new = true;
            } else {
                widget.currentRow.__is_new = false;
            }
            ScreenService.confirmMessage('Caso seja encontrado registros já gerados nessa competência, deseja continuar?', 'CONFIRMATION', 
                function(){
                    widget.currentRow.IDCONTINUA = 'S';
                    this.geraCagedRoute(widget);
                }.bind(this),
                function(){
                    widget.currentRow.IDCONTINUA = 'N';
                    this.geraCagedRoute(widget);
                }.bind(this)
            );
        }
    };

    this.geraCagedRoute = function(widget){
        restEngine.post('product#/gerarCAGED', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).then(function (data) {
                //Abre popup com mensagens do processamento
                if(data.dataset && data.dataset.gerarMagneticoCaged && data.dataset.gerarMagneticoCaged.length > 0){
                    var popUp = templateManager.container.getWidget("mensagens");
                    popUp.dataSource.data = data.dataset.gerarMagneticoCaged;
                    ABUtilController.masterDetailOpenPopup(popUp);
                }
                
                if(data.messages){
                    //Remove as mensagens referentes aos relatórios (magnetico/analitico)
                    var i;
                    for (i = data.messages.length-1; i >= 0; i--) {
                        if (data.messages[i].message.substring(0,4) == "http"){
                            window.open(data.messages[i].message);
                            data.messages.splice(i,1);
                        }
                    }
                    
                    if(data.messages.length > 0){
                        if (data.messages[0].type === "M") {
                            this.downloadCaged(widget.currentRow);
                            ScreenService.closePopup();
                            ScreenService.showMessage(data.messages[0].message, "M");
                        } else if(data.messages[0].type === "E") {
                            ScreenService.showMessage(data.messages[0].message, "E");
                        } else if(data.messages[0].type === "W") {
                            this.downloadCaged(widget.currentRow);
                            ScreenService.showMessage(data.messages[0].message, "W");
                        }
                    }
                }
            }.bind(this)).
            catch(function(e) {
                var error;
                if(e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
    };

    this.retorcederCaged = function(args){
        var widget = ABUtilController.checkWidget(args);
        ScreenService.confirmMessage('Deseja realmente retroceder o CAGED?', 'CONFIRMATION', 
            function(){
                restEngine.post('product#/retrocederCAGED', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).then(function (data) {
                    if(data.messages){
                        if (data.messages[0].type === "M") {
                            ScreenService.closePopup();
                            ScreenService.showMessage(data.messages[0].message, "M");
                        } else if(data.messages[0].type === "E") {
                            ScreenService.showMessage(data.messages[0].message, "E");
                        } else if(data.messages[0].type === "W") {
                            ScreenService.showMessage(data.messages[0].message, "W");
                        }
                    }
                }.bind(this)).
                catch(function(e) {
                    var error;
                    if(e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;
                        ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
            }.bind(this)
        );
    };

    this.salvarFomulario = function(args){
        var widget = ABUtilController.checkWidget(args);
        
        if(!Util.isEmptyOrBlank(widget.currentRow.DTINIADMISSAO) && widget.currentRow.DSORDEM == 'DATA_ADMISSAO') {
            if(!ABUtilController.validaDtIniMenorIgualDtFin(widget.currentRow.DTINIADMISSAO, widget.currentRow.DTFIMADMISSAO)) {
                ScreenService.showMessage(Messages.DTINI_POST_DTFIM_ERROR, 'ERROR');
                return;
            }
        }
        
        if(widget.isValid()) {
            if (!widget.backupRow) {
                widget.currentRow.__is_new = true;
            } else {
                widget.currentRow.__is_new = false;
            }

            return widget.saveRow().then(function(){
               if (widget.currentRow.__is_new) {
                    ABUtilController.masterDetailVoltarList(widget);
                    widget.reload();
                } else {
                    ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                    widget.backupRow = null;
                    widget.view();
                }
            }).catch(function(e) {
                var error;
                if(e.data.error === undefined)
                    error = e;
                else 
                    error = e.data.error;
                
                ScreenService.showMessage('Ocorreu um erro inesperado, contate o administrador informando o trecho abaixo: <br><br>' + error + '<br><br>', 'ERROR');
            });   
        }
    };

}

Configuration(function(ContextRegister) {
    ContextRegister.register('FormularioCagedController', FormularioCagedController);
});

// FILE: assets/js/controllers/FornecedorController.js
function FornecedorController(ScreenService, templateManager, restEngine, ABUtilController, Messages) {

    this.setIdtpijurforn = function(field, insc) {
        
        insc = field.widget.currentRow.NRINSJURFORN.replace(/\D/g,"");
        
        if (insc.length <= 5) {
            while (insc.length < 5) {
                insc = "0" + insc;
            }
            field.widget.currentRow.NRINSJURFORN = insc;
        }
        else if (insc.length <= 11) {
            while (insc.length < 11) {
                insc = "0" + insc;
            }
                //Coloca um ponto entre o terceiro e o quarto dígitos
                insc = insc.replace(/(\d{3})(\d)/,"$1.$2");
                //Coloca um ponto entre o terceiro e o quarto dígitos
                //de novo (para o segundo bloco de números)
                insc = insc.replace(/(\d{3})(\d)/,"$1.$2");
                //Coloca um hífen entre o terceiro e o quarto dígitos
                insc = insc.replace(/(\d{3})(\d{1,2})$/,"$1-$2");
            
            field.widget.currentRow.NRINSJURFORN = insc;
        }
        else if (insc.length <= 14) {
            while (insc.length < 14) {
                insc = "0" + insc;
            }
                //Coloca ponto entre o segundo e o terceiro dígitos
                insc = insc.replace(/^(\d{2})(\d)/,"$1.$2");
                //Coloca ponto entre o quinto e o sexto dígitos
                insc = insc.replace(/^(\d{2})\.(\d{3})(\d)/,"$1.$2.$3");
                //Coloca uma barra entre o oitavo e o nono dígitos
                insc = insc.replace(/\.(\d{3})(\d)/,".$1/$2");
                //Coloca um hífen depois do bloco de quatro dígitos
                insc = insc.replace(/(\d{4})(\d)/,"$1-$2");
                
            field.widget.currentRow.NRINSJURFORN = insc;
        }
        else if (insc.length <= 20) {
            while (insc.length < 20) {
                insc = "0" + insc;
            }
            field.widget.currentRow.NRINSJURFORN = insc;
        }
    };

	this.salvarFornecedor = function(args) {
        var widget = templateManager.container.getActiveWidget();
        if (widget.isValid()) {
            if (!widget.backupRow) {
                widget.currentRow.__is_new = true;
            } else {
                widget.currentRow.__is_new = false;
            }
            restEngine.post('product#/setFornecedor', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                then(function (data) {
                    if (data.messages[0].message === "success") {
                        ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                        if (widget.currentRow.__is_new) {
                            ABUtilController.masterDetailVoltarList(widget);
                            ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                            widget.reload();
                        } else {
                            ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                            widget.backupRow = null;
                            widget.view();
                        }
                    } else if (!Util.isUndefined(data.messages)) {
                        ScreenService.showMessage(data.messages[0].message, data.messages[0].type);
                    } else {
                        ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                    }
                }).
                catch(function(e) {
                    var error;
                    if(e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;

                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
        }
    };
    
    this.codigoEditavel = function (action) {
        var widget = templateManager.container.getActiveWidget();
        if (action == 'editar' || action == 'cancelar') {
            widget.getField('CDFORNECED').readOnly = true;
        } else if (action == 'add') {
            widget.getField('CDFORNECED').readOnly = false;
        } 
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('FornecedorController', FornecedorController);
});

// FILE: assets/js/controllers/FornecedorEpiController.js
function FornecedorEpiController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, General, Messages) {

    this.adicionarRow = function(args) {
        var widget = args.owner.widget;
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
    };
    
    this.defineNrParcNegocioFilterEpi = function(widget){
        var widgetEpi = widget.widgets[0];
        widgetEpi.dataSourceFilter.forEach(function(obj){
            if(obj.name == 'NRPARCNEGOCIO') obj.value = widget.currentRow.NRPARCNEGOCIO;
        });
    };

    this.setFornecedorEpi = function(args) {
        var widget = args.owner.widget;

        if(!ABUtilController.validaDtIniMenorIgualDtFin(widget.currentRow.DTINIVIGENCIA , widget.currentRow.DTFIMVIGENCIA))
           ScreenService.showMessage(Messages.DTINI_POST_DTFIM_ERROR); 
        
        else if (widget.isValid()) {
            widget.currentRow.NRPARCNEGOCIO =  widget.parent.parent.currentRow.NRPARCNEGOCIO;
            if (!widget.backupRow) {
                widget.currentRow.__is_new = true;
            } else {
                widget.currentRow.__is_new = false;
            }
            restEngine.post('product#/setFornecedorEpi', {
                'requestType': 'DataSet',
                'dataset': [widget.currentRow]
            }).
            then(function(data) {
                if (data.notifications[0].type === "success") {
                    ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                    if (widget.currentRow.__is_new) {
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    } else {
                        ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                        widget.backupRow = null;
                        widget.view();
                    }
                } else {
                    ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                }
            }).
            catch(function(e) {
                var error;
                if (e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
        }
    };

    this.deleteFornecedorEpi = function(args) {
        ScreenService.confirmMessage(Messages.DELETE_ROW, 'CONFIRMATION',
            function() {
                var widget = args.owner.widget;
                widget.currentRow.__is_new = false;
                restEngine.post('product#/deleteFornecedorEpi', {
                    'requestType': 'DataSet',
                    'dataset': [widget.currentRow]
                }).
                then(function(data) {
                    if (data.notifications) {
                        if (data.notifications[0].type === "success") {
                            ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                            ABUtilController.masterDetailVoltarList(widget);
                            widget.reload();
                        } else {
                            ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                        }
                    } else {
                        ScreenService.showMessage(data.messages[0].message);
                    }
                }).
                catch(function(e) {
                    var error;
                    if (e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
            });
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('FornecedorEpiController', FornecedorEpiController);
});


// FILE: assets/js/controllers/GRRFController.js
function GRRFController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, General, Messages) {
    /*global Util*/
    var self = this;

    this.mudarVisibilidadeWidgets = function(widgets, value) {
        widgets.forEach(function(widget) {
            widget.isVisible = value;
        });
    };

    this.adicionarRow = function(args) {
        var widget = args.owner.widget;
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
    };
    
    this.geraGRRF = function(args) {
        var widget = ABUtilController.checkWidget(args);
        ScreenService.confirmMessage('Deseja realmente gerar a GRRF ?', 'CONFIRMATION', 
            function(){
                widget.currentRow.TP_PROCESSAMENTO = 'COMPETENCIA_MENSAL';
                restEngine.post("product#/geraGrrf",
                        {'requestType':'DataSet','dataset':[widget.currentRow]},
                    function(data) {
                            if(data.dataset && data.dataset.arquivo){
                                ABUtilController.downloadArquivo(data.dataset.arquivo.NMARQUIVO);
                            }
                            if(data.messages){
                                if(data.messages[0].message.substring(0,4) == "http"){
                                    window.open(data.messages[0].message);
                                    if(data.messages[1]){
                                        ScreenService.successNotification(data.messages[1].message);
                                        ScreenService.closePopup();    
                                    }
                                } else {
                                    ScreenService.showMessage(data.messages[0].message, data.messages[0].type);
                                    ScreenService.closePopup();
                                }
                            }
                            if(data.dataset && data.dataset.msgCalculo && data.dataset.msgCalculo.length > 0){
                                var popUp = templateManager.container.getWidget("mensagens");
                                popUp.dataSource.data = data.dataset.msgCalculo;
                                ABUtilController.masterDetailOpenPopup(popUp);
                            }
                            if(data.error){
                                ScreenService.showMessage(data.error,'ERROR');
                            }
                        }.bind(this),undefined,
                    function(e) {
                        var error;
                        if(e.data.error === undefined)
                            error = e;
                        else 
                            error = e.data.error;
                        if(Util.isObject(error) && error.statusText)
                            error = error.statusText ? error.statusText : error;
                        ScreenService.showMessage('Ocorreu um erro inesperado, contate o administrador informando o trecho abaixo: <br><br>' + error + '<br><br>', 'ERROR');
                    }
                );
            }.bind(this)
        );
    };
    
    this.retrocede = function(args) {
        var widget = ABUtilController.checkWidget(args);
        ScreenService.confirmMessage('Deseja realmente retroceder a GRRF ?', 'CONFIRMATION', 
            function(){
                widget.currentRow.TP_PROCESSAMENTO = 'RETROCESSO';
                restEngine.post("product#/geraGrrf",
                        {'requestType':'DataSet','dataset':[widget.currentRow]},
                    function(data) {
                        if(data.messages){
                            ScreenService.successNotification(data.messages[0].message);
                            ScreenService.closePopup();
                        }
                        if(data.dataset && data.dataset.msgCalculo && data.dataset.msgCalculo.length > 0){
                            var popUp = templateManager.container.getWidget("mensagens");
                            popUp.dataSource.data = data.dataset.msgCalculo;
                            ABUtilController.masterDetailOpenPopup(popUp);
                        }
                        if(data.error){
                            ScreenService.showMessage(data.error,'ERROR');
                        }
                    }.bind(this),undefined,
                    function(e) {
                        var error;
                        if(e.data.error === undefined)
                            error = e;
                        else 
                            error = e.data.error;
                        if(Util.isObject(error) && error.statusText)
                            error = error.statusText ? error.statusText : error;
                        ScreenService.showMessage('Ocorreu um erro inesperado, contate o administrador informando o trecho abaixo: <br><br>' + error + '<br><br>', 'ERROR');
                    }
                );
            }.bind(this)
        );
    };

    this.setGRRF = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid() && this.validaQtdeCompetenciasInfoCompl()) {
            if (widget.currentRow.DSORDEM == 'LISTA_VINCULO' && widget.currentRow.NRVINCULOM_LIST && widget.currentRow.NRVINCULOM_LIST.length > 200) {
                ScreenService.showMessage("Favor selecionar um máximo de 200 vínculos na lista ou usar outro filtro como por exemplo por estrutura legal.");
                return;
            }
            if (widget.currentRow.DSORDEM == 'LISTA_NRESTRUTSIND' && widget.currentRow.LIST_NRESTRUTSIND && widget.currentRow.LIST_NRESTRUTSIND.length > 200) {
                ScreenService.showMessage("Favor selecionar um máximo de 200 estruturas na Lista sindical .");
                return;
            }
            if (widget.currentRow.DSORDEM == 'LISTA_ESTRUTURA' && widget.currentRow.LIST_NRESTRUTLEGAL && widget.currentRow.LIST_NRESTRUTLEGAL.length > 200) {
                ScreenService.showMessage("Favor selecionar um máximo de 200 estruturas na Lista de Estrutura Legal.");
                return;
            }  
            if (widget.currentRow.DSORDEM == 'LISTA_ESTRUTURA' && widget.currentRow.LIST_NRESTRUTGEREN && widget.currentRow.LIST_NRESTRUTGEREN.length > 200) {
                ScreenService.showMessage("Favor selecionar um máximo de 200 estruturas na Lista de Estrutura Gerencial.");
                return;
            }
            if (!widget.backupRow) {
                widget.currentRow.__is_new = true;
            } else {
                widget.currentRow.__is_new = false;
            }
            restEngine.post('product#/setGRRF', {
                'requestType': 'DataSet',
                'dataset': [widget.currentRow]
            }).
            then(function(data) {
                if (data.notifications[0].type === "success") {
                    ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                    if (widget.currentRow.__is_new) {
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    } else {
                        widget.backupRow = null;
                        widget.view();
                    }
                    self.mudarVisibilidadeWidgets(widget.widgets, true);
                } else {
                    ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                }
            }).
            catch(function(e) {
                var error;
                if (e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;

                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
        }
    };

    this.deleteGRRF = function(args) {
        var widget = args.owner.widget;
        ScreenService.confirmMessage(Messages.DELETE_ROW, 'CONFIRMATION',
            function() {
                restEngine.post('product#/deleteGRRF', {
                    'requestType': 'DataSet',
                    'dataset': [widget.currentRow]
                }).
                then(function(data) {
                    if (data.notifications[0].type === "success") {
                        ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    } else {
                        ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                    }
                }).
                catch(function(e) {
                    var error;
                    if (e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;

                    ScreenService.showMessage(error, 'ERROR');
                });
            }
        );
    };
    
    this.obrigaCompetenciasInfoCompl = function() {
        var widget = templateManager.container.getWidget("GRRF");
        if (widget.getField("IDINFOCOMPL43").value() == 'S' || widget.getField("IDINFOCOMPL44").value() == 'S' || widget.getField("IDINFOCOMPL45").value() == 'S') {
            widget.getField("DTMESCOMPETENCLIST").validations = { "required": true };
        } else {
            widget.getField("DTMESCOMPETENCLIST").validations = {};
        }
    };
    
    this.validaQtdeCompetenciasInfoCompl = function() {
        var widget = templateManager.container.getWidget("GRRF");
        if (!Util.isNull(widget.getField("DTMESCOMPETENCLIST").value()) && widget.getField("DTMESCOMPETENCLIST").value().length > 14) {
            ScreenService.errorNotification("Permitido informar um máximo de 14 competências", 10000);
            return false;
        }
        return true;
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('GRRFController', GRRFController);
});


// FILE: assets/js/controllers/GerarLoteEventosController.js
/* jshint esversion: 6 */
function GerarLoteEventosController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, Messages, CriterioSelecaoController) {
    this.DSINICIO = ['NMESTRUTLEGAL', 'NMINIVINCULOM', 'DTINIADMISSAO', 'CDINIMATRICULA'];
    this.DSFIM = ['NMESTRUTGEREN', 'NMFIMVINCULOM', 'DTFIMADMISSAO' , 'CDFIMMATRICULA'];
    
    const LOTE_FILTER = {
        SET_ON_REDIRECT: false,
        VALUE: null,
        DEFAULT_VALUE: '',
        LOTE_FILTER_NAME: 'NRLOTELANCEVENTO',
        ZEEDHI_CONTROLLER: {
            LOADED_ONCE: false,  
        },
    };

    this.cancelEdit = function(args){
        var widget = ABUtilController.checkWidget(args);
        widget.currentRow.DSINICIO = widget.currentRow.BKPDSINICIO;
        widget.currentRow.DSFIM = widget.currentRow.BKPDSFIM;
        widget.currentRow.BKPDSINICIO = null;
        widget.currentRow.BKPDSFIM = null;
        ABUtilController.masterDetailCancelaEdicao(widget);
        CriterioSelecaoController.setVisibilidadeCampos(widget);
    };

    this.changeDsOrdem = function(args) {
        var widget = ABUtilController.checkWidget(args);
        widget.currentRow.BKPDSINICIO = widget.currentRow.DSINICIO;
        widget.currentRow.BKPDSFIM = widget.currentRow.DSFIM;
        widget.currentRow.DSINICIO = null;
        widget.currentRow.DSFIM = null;
        CriterioSelecaoController.setVisibilidadeCampos(widget);
    };

    this.deleteLote = function(args) {
        var widget = ABUtilController.checkWidget(args);
        var data = {}; 
        ScreenService.confirmMessage(Messages.DELETE_ROW, 'CONFIRMATION', 
            function(){
                widget.dataSource.remove(widget.currentRow).then(function (data){
                    if(data.dataset.ptoFormGeracaoEvento_setGerarLoteEventos.type === "success"){
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                        ScreenService.showMessage(Messages.REMOVE_ROW_SUCCESS); 
                    } else {
                        ScreenService.showMessage(Messages.REMOVE_ROW_ERROR); 
                    }
                }.bind(this));
            }.bind(this)
        );
    };
    
    this.edit = function(args){
        var widget = ABUtilController.checkWidget(args);
        ABUtilController.masterDetailEdit(widget);
        widget.getField("DTINICIAL").readOnly = false;
        widget.getField("DTFINAL").readOnly   = false;
        widget.getField("DSPERIODOAPURACAO").readOnly = false;
        widget.getField("DSTIPOPERIODOAPURACAO").readOnly = false;
        widget.getField("DSPERIODOAPURACAO").dataSourceFilter.forEach(function(dados){
            if(dados.name === 'NRTIPOPERIODOAPURACAO'){
                dados.value = widget.currentRow.NRTIPOPERIODOAPURACAO;
            }
        });

        widget.getField("DSTIPOPERIODOAPURACAO").dataSourceFilter.forEach(function(dados){
            if(dados.name === 'NRTIPOVINCULOM'){
                dados.value = widget.currentRow.NRTIPOVINCULOM;
            }
        });
    };

    this.enableData = function(args){
        var widget = ABUtilController.checkWidget(args);
        if(!Util.isEmptyOrBlank(widget.currentRow.DSPERIODOAPURACAO)){
            widget.getField("DTINICIAL").readOnly = false;
            widget.getField("DTFINAL").readOnly   = false;
            widget.currentRow.DTINICIALAPURACAO = widget.currentRow.DTINICIAL.split(" ")[0];
            widget.currentRow.DTFINALAPURACAO = widget.currentRow.DTFINAL.split(" ")[0];
        } else {
            widget.getField("DTINICIAL").readOnly = true;
            widget.getField("DTFINAL").readOnly   = true;
        }
    };

    this.enablePeriodoApuracao = function(args){
        var widget = ABUtilController.checkWidget(args);
        if(!Util.isEmptyOrBlank(widget.currentRow.DSTIPOPERIODOAPURACAO)){
            widget.getField("DSPERIODOAPURACAO").readOnly = false;
            widget.getField("DSPERIODOAPURACAO").dataSourceFilter.forEach(function(dados){
                if(dados.name === 'NRTIPOPERIODOAPURACAO'){
                    dados.value = widget.currentRow.NRTIPOPERIODOAPURACAO;
                }
            });
        } else {
            widget.getField("DSPERIODOAPURACAO").readOnly = true;
            widget.getField("DSPERIODOAPURACAO").dataSourceFilter.forEach(function(dados){
                if(dados.name === 'NRTIPOPERIODOAPURACAO'){
                    dados.value = widget.currentRow.NRTIPOPERIODOAPURACAO;
                }
            });
        }
    };

    this.enableTipoPeriodoApuracao = function(args){
        var widget = ABUtilController.checkWidget(args);

        widget.currentRow.DTINICIAL = null;
        widget.currentRow.DTFINAL   = null;
        widget.currentRow.DSPERIODOAPURACAO = null;
        widget.currentRow.DSTIPOPERIODOAPURACAO = null;
        
        widget.getField("DTINICIAL").readOnly = true;
        widget.getField("DTFINAL").readOnly   = true;
        widget.getField("DSPERIODOAPURACAO").readOnly = true;
        widget.getField("DSPERIODOAPURACAO").dataSourceFilter.forEach(function(dados){
            if(dados.name === 'NRTIPOPERIODOAPURACAO'){
                dados.value = widget.currentRow.NRTIPOPERIODOAPURACAO;
            }
        });

        if(!Util.isEmptyOrBlank(widget.currentRow.NMTIPOVINCULOH)){
            widget.getField("DSTIPOPERIODOAPURACAO").readOnly = false;
            widget.getField("DSTIPOPERIODOAPURACAO").dataSourceFilter.forEach(function(dados){
                if(dados.name === 'NRTIPOVINCULOM'){
                    dados.value = widget.currentRow.NRTIPOVINCULOM;
                }
            });
        } else {
            widget.getField("DSTIPOPERIODOAPURACAO").readOnly = true;
            widget.getField("DSTIPOPERIODOAPURACAO").dataSourceFilter.forEach(function(dados){
                if(dados.name === 'NRTIPOVINCULOM'){
                    dados.value = widget.currentRow.NRTIPOVINCULOM;
                }
            });
        }
    };

    this.gerarLote = function(args){
        var widget = ABUtilController.checkWidget(args);
        ScreenService.confirmMessage('Deseja realmente gerar lote para o período de '+ widget.currentRow.DTINICIAL.split(" ")[0] +' à '+ widget.currentRow.DTFINAL.split(" ")[0] + ' ?', 'CONFIRMATION', 
            function(){
                var saveData = Object.assign({}, widget.currentRow, {
                        "NRORGTRAB": getLocalVar("HCM_NRORG_TRAB")
                    }, {
                        "DTCOMPETENCIA": getLocalVar("HCM_DTCOMPETENCIA_OPER")
                    }, {
                        "NRORGPADRAO": getLocalVar("HCM_NRORG_PADRAO")
                    });
                restEngine.post("product#/geraLote",
                        {'requestType':'DataSet','dataset':[saveData]}
                    ).then(function(data) {
                            if (data.dataset.nrlote) {
                                if(data.dataset.nrlote[0]) {
                                    ScreenService.showMessage('Lote gerado com sucesso');
                                    this.setLoteFilterOnRedirect(data.dataset.nrlote[0]);
                                    ScreenService.openWindow('product#hcm01020_fpa_loteLancEvento');
                                    if (data.dataset && data.dataset.msg) {
                                        openPopupMensagens(data.dataset.msg);
                                    }
                                } else {
                                    ScreenService.showMessage('Nenhum dado encontrado para os critérios selecionados');
                                }
                            } else {
                                ScreenService.showMessage('Erro ao gerar lote');
                            }
                        }.bind(this)
                    ).catch(function(e) {
                        var error;
                        if(e.data.error === undefined)
                            error = e;
                        else 
                            error = e.data.error;
                        
                        ScreenService.showMessage('Ocorreu um erro inesperado, contate o administrador informando o trecho abaixo: <br><br>' + error + '<br><br>', 'ERROR');
                    });
            }.bind(this));
    };

    this.moveRow = function(args){
        var widget = ABUtilController.checkWidget(args);
        CriterioSelecaoController.setVisibilidadeCampos(widget);
    };

    this.newRow = function(args){
        ABUtilController.newRow(args);
        this.enableTipoPeriodoApuracao(args);
        this.enablePeriodoApuracao(args);
        this.enableData(args);
    };

    this.salvarLote = function(argsRow){
        var widget = templateManager.container.getWidget("geracaoLoteEventosFolha");
        if(widget.isValid())  {
            
            if (!widget.backupRow) {
                widget.currentRow.__is_new = true;
            } else {
                widget.currentRow.__is_new = false;
            }
            widget.currentRow.CDOPERADOR_LOG = getLocalVar("HCM_CDOPERADOR");
            widget.currentRow.NRORGTRAB = getLocalVar("HCM_NRORG_TRAB");
            widget.currentRow.NRORGPADRAO = getLocalVar("HCM_NRORG_PADRAO");
            widget.currentRow.DTATUAL = getLocalVar("HCM_DATA_ATUAL");
            return widget.saveRow().then(function (data){
                if (data.notifications[0].type === "success") {
                    if (widget.currentRow.__is_new) {
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    } else {
                        ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                        widget.backupRow = null;
                        widget.view();
                    }
                } else {
                    ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                }
            }.bind(this)).catch(function(e) {
                var error;
                if(e.data.error === undefined)
                    error = e;
                else 
                    error = e.data.error;
                
                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error));
            });
        }
    };

    this.setDsInicioFim = function(args){
        var widget = ABUtilController.checkWidget(args);
        this.DSINICIO.forEach(function(campo) {
            if(args.owner.field.name == campo){
                widget.currentRow.DSINICIO = args.owner.field.value();
            }
        });

        this.DSFIM.forEach(function(campo) {
            if(args.owner.field.name == campo){
                widget.currentRow.DSFIM = args.owner.field.value();
            }
        });
    };

    this.validateDtFinal = function(args){
        var widget = ABUtilController.checkWidget(args);
        if(!Util.isEmptyOrBlank(widget.currentRow.DTFINALAPURACAO) && !Util.isEmptyOrBlank(widget.currentRow.DTFINAL)){
            if(!ABUtilController.validaDtIniMenorIgualDtFin(widget.currentRow.DTFINAL, widget.currentRow.DTFINALAPURACAO)){
                ScreenService.showMessage("O campo de 'Data Final' não pode ser maior que a data final do período");
                widget.currentRow.DTFINAL = widget.currentRow.DTFINALAPURACAO;
            } else if(!ABUtilController.validaDtIniMenorIgualDtFin(widget.currentRow.DTINICIAL, widget.currentRow.DTFINAL)){
                ScreenService.showMessage("O campo de 'Data Final' não pode ser menor que o campo 'Data Fim");
                widget.currentRow.DTFINAL = widget.currentRow.DTFINALAPURACAO;
            }
        }
    };

    this.validateDtInicial = function(args){
        var widget = ABUtilController.checkWidget(args);
        if(!Util.isEmptyOrBlank(widget.currentRow.DTINICIALAPURACAO) && !Util.isEmptyOrBlank(widget.currentRow.DTINICIAL)){
            if(!ABUtilController.validaDtIniMenorIgualDtFin(widget.currentRow.DTINICIALAPURACAO, widget.currentRow.DTINICIAL)){
                ScreenService.showMessage("O campo de 'Data Inicial' não pode ser menor que a data inicial do período");
                widget.currentRow.DTINICIAL = widget.currentRow.DTINICIALAPURACAO;
            } else if(!ABUtilController.validaDtIniMenorIgualDtFin(widget.currentRow.DTINICIAL, widget.currentRow.DTFINAL)){
                ScreenService.showMessage("O campo de 'Data Inicial' não pode ser maior que o campo 'Data Fim");
                widget.currentRow.DTINICIAL = widget.currentRow.DTINICIALAPURACAO;
            }
        }
    };
    
    var openPopupMensagens = function(msg) {
        var widgetMensagens = templateManager.container.getWidget('mensagensCalculo');
        widgetMensagens.dataSource.data = msg;
        ScreenService.openPopup(widgetMensagens);
   };
   
   this.setLoteFilterOnRedirect = function (nrLote) {
        LOTE_FILTER.VALUE = nrLote;
        LOTE_FILTER.SET_ON_REDIRECT = true;
   };
   
   this.unSetLoteFilterOnRedirect = function () {
        LOTE_FILTER.VALUE = null;
        LOTE_FILTER.SET_ON_REDIRECT = false;
   };
   
   this.addFiltersRedirect = function () {
        const widgetLoteLanc = templateManager.containers['product#hcm01020_fpa_loteLancEvento'].getWidget('loteLancEvento');
        if (LOTE_FILTER.SET_ON_REDIRECT) {
            const filterItem = widgetLoteLanc.dataSourceFilter.find((filter) => filter.name == LOTE_FILTER.LOTE_FILTER_NAME);
            filterItem.value = LOTE_FILTER.VALUE;
            widgetLoteLanc.reload().then(function(callBack){
                filterItem.value = LOTE_FILTER.DEFAULT_VALUE;
            });
            LOTE_FILTER.ZEEDHI_CONTROLLER.LOADED_ONCE = true;
            this.unSetLoteFilterOnRedirect();
            
        } else if (!LOTE_FILTER.ZEEDHI_CONTROLLER.LOADED_ONCE) {
            ABUtilController.applyDefaultFilterOnEnter(widgetLoteLanc);
            LOTE_FILTER.ZEEDHI_CONTROLLER.LOADED_ONCE = true;
        }
   };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('GerarLoteEventosController', GerarLoteEventosController);
});

// FILE: assets/js/controllers/GerenciamentoController.js
function GerenciamentoController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, Messages, CriterioSelecaoController) {
    
    var SITUACAO_CONCLUIDA = 'CONCLUIDA';
    var SITUACAO_PENDENTE  = 'PENDENTE';
  
    this.notificarPendentes = function(args){
        var popUp = ABUtilController.checkWidget(args);
        var widget = templateManager.container.getWidget("gerenciamentoAvaliacao");

        if (popUp.isValid()) {
            widget.currentRow.__report_name = 'notificacao_avaliacao_pendente';
            widget.currentRow.NRORGTRAB      = getLocalVar("HCM_NRORG_TRAB");
            widget.currentRow.COMPETENCIA    = getLocalVar("HCM_DTCOMPETENCIA_OPER");
            widget.currentRow.CDOPERADOR_LOG = getLocalVar("HCM_CDOPERADOR");
            widget.currentRow.NRAVALIACAO = widget.filterApplied[0].value;
            
            delete popUp.currentRow.DSOBSERVACOES;

            var saveData = Object.assign({}, widget.currentRow, {"MENSAGEM": popUp.currentRow});
             restEngine.post('product#/notificarPorEmail',{'requestType': 'Row','row': saveData})
             .then(function(data){
                var message = data.messages[(data.messages.length - 1)];
                if(!Util.isEmptyOrBlank(data.messages)){
                    if (message.type === "M") {
                        ScreenService.showMessage(Messages.HCM03000_AVL_PENDENTES_NOTIFICADOS);
                        ScreenService.successNotification(message.message, 100000);
                        ABUtilController.masterDetailClosePopup(popUp);
                        ABUtilController.masterDetailVoltarList(widget); 
                        widget.reload();
                    }
                } else {
                    ScreenService.showMessage(Messages.HCM03000_AVL_PENDENTES_FALHA);
                } 
                }).catch(function(e) {
                ABUtilController.masterDetailClosePopup(popUp);
                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(e));
            });
        }
    };
    
    this.reverterStatus = function(args){
        var widget = args.owner.widget;
        if(widget.isValid()){
            ScreenService.confirmMessage("Deseja reverter o status do(a):"+widget.currentRow.AVALIADOR+" ? ","question", 
            //yes
                function(success){
                    restEngine.post('product#/reverterStatus',{'requestType': 'DataSet','dataset': [widget.currentRow]}).
                        then(function(data){
                            if(!Util.isEmptyOrBlank(data.messages)){
                                if (data.messages[(data.messages.length - 1)].type === "M") {
                                    ScreenService.showMessage(Messages.HCM03000_AVL_REVERTER_SUCESSO);
                                }
                            } else {
                                ScreenService.showMessage(Messages.HCM03000_AVL_REVERTER_FALHA);
                            }
                            data.messages.forEach(function(notifAlert){
                                if(notifAlert.type === "W")
                                    ScreenService.alertNotification(notifAlert.message, 100000);
                                if(notifAlert.type === "M")
                                    ScreenService.successNotification(notifAlert.message, 100000);
                                if(notifAlert.type === "E")
                                    ScreenService.errorNotification(notifAlert.message, 100000);
                            });
                            ABUtilController.masterDetailVoltarList(widget); 
                            widget.reload();
                        }).
                        catch(function(e) {
                            var error;
                            if(e.data.error === undefined)
                                error = e;
                            else
                                error = e.data.error;
                                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                        });
                }.bind(this),
            //no
                function(error){
                    ABUtilController.masterDetailVoltarList(widget);
                });
        }
        widget.reload();
    };
    
    this.deleteRegistro = function(args) {
        var widget = args.owner.widget;
        ScreenService.confirmMessage(Messages.DELETE_ROW,"CONFIRMATION", 
        function(success){
            widget.currentRow.__is_new = false;
            restEngine.post('product#/deleteRegistroGerenciamento', {'requestType':'DataSet','dataset':[widget.currentRow]}).
                then(function(data){
                    if(data.messages[0].type === "M"){
                        ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    } else {
                        ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                    }
                }).
                catch(function(e) {
                    var error;
                    if(e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;
                        ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
        });
        
    };
    
    this.openPopupMensagem = function(args){
        var widget = templateManager.container.getWidget('mensagens');
        widget.isVisible = true;
        ABUtilController.masterDetailOpenPopup(widget);
        
    };
    
    this.setCampoTitulo = function(args){
        var widgetMensagens = ABUtilController.checkWidget(args);
        widgetMensagens.currentRow.DSTITULOMENSAGEM = widgetMensagens.currentRow.DSASSUNTOMENSAGEM;
    };
    
    this.onEnter = function(args){
        var widgetMensagens = templateManager.container.getWidget("mensagens");
        widgetMensagens.getField("DSMENSAGEM").placeholder = "Mnemônicos aceitos:" +
                                                            '\n\n' +
                                                            "[AVALIACAO] = Nome da Avaliação"+
                                                            '\n\n' +
                                                            "[AVALIADOR] = Nome do Avaliador"+
                                                            '\n\n' +
                                                            "[DATA_INICIO] = Data Inicial da Avaliação"+
                                                            '\n\n' +
                                                            "[DATA_FIM] = Data Limite da Avaliação";
    };
    
    // this.preparaAvaliadoEAvaliadorFiltro = function(args){
    //     var popUp = templateManager.container.getWidget("gerenciamentoAvaliacao").__filterPopup;
    //     var fieldAvaliacao = popUp.getField("NRAVALIACAO");  
    //     var fieldAvaliador = popUp.getField("AVALIADOR");
    //     var fieldAvaliado = popUp.getField("AVALIADO");
    //     if(popUp.isValid()){
    //         fieldAvaliado.dataSourceFilter.forEach(function(filter){
    //             if(filter.name === 'P_NRAVALIACAO')  {
    //                 filter.value = fieldAvaliacao.value();    
    //             }  
    //         });
    //         fieldAvaliado.readOnly = false;
            
    //         fieldAvaliador.dataSourceFilter.forEach(function(filter){
    //             if(filter.name === 'P_NRAVALIACAO')  {
    //                 filter.value = fieldAvaliacao.value();    
    //             }  
    //         });
    //         fieldAvaliador.readOnly = false;
    //     }else{
    //         fieldAvaliado.clearValue();
    //         fieldAvaliado.readOnly = true;
    //         fieldAvaliador.clearValue();
    //         fieldAvaliador.readOnly = true;
    //     }
        
    // };
    
    this.setVisisbilidadeActions = function(args){
        var widgetGerenciamento = templateManager.container.getWidget("gerenciamentoAvaliacao");
        var currentRow = args.row;
        if(currentRow.SITUACAO === SITUACAO_PENDENTE){
            widgetGerenciamento.actions.forEach(function(action){
                if(action.name === "reverter")
                    action.isVisible = false;
            });
        }else{
            widgetGerenciamento.actions.forEach(function(action){
                if(action.name === "reverter")
                    action.isVisible = true;
            });    
        }
    };
    
    
}

Configuration(function(ContextRegister) {
    ContextRegister.register('GerenciamentoController', GerenciamentoController);
});

// FILE: assets/js/controllers/GerenciarOcorrenciaFrenquenciaController.js
/* jshint esversion: 6 */

function GerenciarOcorrenciaFrenquenciaController (ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, $window, ABUtilController, Messages, HcmConsts) {
    const DSOBSERVACAORECUSA_DEFAULTVALUE = 'Sem Observações.';
    
    this.backList = function(args){
        var widget = ABUtilController.checkWidget(args);
        ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
        Util.extend(widget.currentRow, widget.backupRow);
        widget.list();
        ScreenService.closeSwipe();
        widget.activate();
    };

    this.changeModeWidget = function(args){
        var widget = ABUtilController.checkWidget(args);
        if(widget.mode === 'view'){
            ABUtilController.masterDetailEdit();
            widget.getField("DSOBSERVACAORECUSA").readOnly = true;
        }
    };

    this.enableDsObservacaoRecusa = function(args){
        var widget = ABUtilController.checkWidget(args);
        if(widget.currentRow.IDPROGOCORCONFIRMADA === 'N'){
            widget.getField("DSOBSERVACAORECUSA").readOnly = false;
        } else {
            widget.getField("DSOBSERVACAORECUSA").readOnly = true;
        }
    };
    
    this.salvarGerenciamento = function(argsrRow){
        var widget = templateManager.container.getWidget("gerenOcorFreq");
        if(widget.isValid())  {
            widget.currentRow.__is_new = false;
            widget.currentRow.CDOPERADOR_LOG = getLocalVar("HCM_CDOPERADOR");
            widget.currentRow.NRORGTRAB = getLocalVar("HCM_NRORG_TRAB");
            widget.currentRow.NRORGPADRAO = getLocalVar("HCM_NRORG_PADRAO");
            widget.currentRow.DTATUAL = getLocalVar("HCM_DATA_ATUAL");
            return widget.saveRow().then(function (data){
                if (data.notifications[0].type === "success") {
                    ABUtilController.masterDetailVoltarList(widget);
                    widget.reload();
                } else {
                    ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                }
            }.bind(this)).catch(function(e) {
                var error;
                if(e.data.error === undefined)
                    error = e;
                else 
                    error = e.data.error;
                
                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error));
            });
        }
    };
    
    /* jshint ignore:start */
    this.openGerenciarOcorrenciaPopUp = function(args) {
        const originalRow = { ...args.row };
        const gerenciarOcorrenciaWidget = templateManager.container.getWidget('gerenciarOcorrencia');

        gerenciarOcorrenciaWidget.getField('DSOBSERVACAORECUSA').isVisible = false;
        gerenciarOcorrenciaWidget.currentRow = originalRow;
        
        // Se está rejeitada, deixa visível o campo de recusa. Ver se isso faz sentido
        const currentIdProgOcor = originalRow.IDPROGOCORCONFIRMADA;
        if (currentIdProgOcor === HcmConsts.IdProgramacaoOcorrenciaConfirmada.Rejeitada) {
            gerenciarOcorrenciaWidget.getField('DSOBSERVACAORECUSA').isVisible = true;
        }

        // Se ocorrência de abonar saída existe campos de marcação de saída e entrada
        const currentNrTpProgOcorrencia = parseInt(originalRow.NRTIPOPROGOCORRENCIA, 10);
        if (currentNrTpProgOcorrencia === HcmConsts.TpProgOcorrencia.abonarSaida) {
            gerenciarOcorrenciaWidget.getField('DTHRMARCACAOPONTO_SAI').isVisible = true;
            gerenciarOcorrenciaWidget.getField('DTHRMARCACAOPONTO_ENT').isVisible = true;
        } else {
            gerenciarOcorrenciaWidget.getField('DTHRMARCACAOPONTO_SAI').isVisible = false;
            gerenciarOcorrenciaWidget.getField('DTHRMARCACAOPONTO_ENT').isVisible = false;
        }

        // Open Widget
        ScreenService.openPopup(gerenciarOcorrenciaWidget);
    };
    /* jshint ignore:start */
    
    this.ativaFieldDsobservacaorecusa = function(args){
        const widget            = templateManager.container.getWidget('gerenciarOcorrencia');
        const currentIdProgOcor = args.IDPROGOCORCONFIRMADA;

        if (currentIdProgOcor == HcmConsts.IdProgramacaoOcorrenciaConfirmada.Rejeitada) {
            widget.getField('DSOBSERVACAORECUSA').isVisible = true;
            this.setDefaultValueDsobservacaorecusa();
            
        } else {
            widget.getField('DSOBSERVACAORECUSA').isVisible = false;
        }
    };
    
    this.setDefaultValueDsobservacaorecusa = function() {
        const widget = templateManager.container.getWidget('gerenciarOcorrencia');
        
        const obsRecusaSemValor = !widget.getField('DSOBSERVACAORECUSA').value();
        if (obsRecusaSemValor) {
            widget.getField('DSOBSERVACAORECUSA').value(DSOBSERVACAORECUSA_DEFAULTVALUE);
        }
    };
    
    /* jshint ignore:start */
    this.salvaGerenciamentoOcorrencia = async function() {
        const widget            = templateManager.container.getWidget('gerenciarOcorrencia');
        const originalWidget    = templateManager.container.getWidget('gerenOcorFreq');
        const widgetRow         = widget.currentRow; 
        const popUpLayer        = 2;
        
        try {
            const response = await restEngine.post('product#/alteraStatusOcorrencia', { requestType: 'Row', row: widgetRow });
            const success = response.dataset.alteraStatusOcorrencia.success;
            
            if (success) {
                ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS);
                
                for (let i = 0; i<popUpLayer; i++) {
                    ScreenService.closePopup();
                }
                
                ScreenService.closeSwipe();
                originalWidget.reload();
                return;
            }
            
            ScreenService.errorNotification(Messages.SAVE_ROW_ERROR);
        } catch (error) {
            const message = error.data ? Messages.CATCH_EXCEPTION_ERROR(error.data.error) : Messages.SAVE_ROW_ERROR;
            ScreenService.showMessage(message);
        }
    };
    /* jshint ignore:end */
    
    /* jshint ignore:start */
    this.downloadArquivosOcorrencia = async function () {
        const widget = templateManager.container.getWidget('gerenOcorFreq');
        
        try {
            const response = await restEngine.post('product#/downloadArquivosOcorrencia', {
                'requestType': 'Row',
                'row': widget.currentRow
            });
            
            if (response.messages) {
                const message = response.messages[0].message;
                ScreenService.showMessage(message);
                return;
            }
            
            const fileName = response.dataset.downloadArquivosOcorrencia.FILENAME;
            if (fileName) {
                ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS);
                
                ScreenService.closePopup();
                ABUtilController.downloadArquivo(fileName);
                return;
            }
            
            ScreenService.errorNotification(Messages.SAVE_ROW_ERROR);
        } catch (error) {
            const message = error.data ? Messages.CATCH_EXCEPTION_ERROR(error.data.error) : Messages.SAVE_ROW_ERROR;
            ScreenService.showMessage(message);
        }
        
    };
    /* jshint ignore:end */
}

Configuration(function(ContextRegister) {
    ContextRegister.register('GerenciarOcorrenciaFrenquenciaController', GerenciarOcorrenciaFrenquenciaController);
});


// FILE: assets/js/controllers/GozoFeriasController.js
function GozoFeriasController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, General,Messages, ESocialController, $window) {
    
    var self = this;
    this.camposData_ferias = ['DTINIAQUISICAO', 'DTFIMAQUISICAO'];
    this.camposData_gozo = ['DTINIGOZOFERIAS', 'DTFIMGOZOFERIAS', 'DTRETORNOFERIAS'];
    
    this.adicionarRow = function(args) {
        var widget = args.owner.widget;
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
    };
    
    this.filtrarWidgetPorGozoFerias = function(args){
        var widget = args.owner;
        templateManager.container.getWidget("gozoFerias").dataSourceFilter[0].value = widget.currentRow.NRFERIAS;
    };
    
    this.widgetsvisiblefalse = function(args) {
        var widget = args.owner.widget;
        widget.widgets[0].showAsTab = false;
    };

    this.widgetsvisibletrue = function(args) {
        var widget = args.owner.widget;
        widget.widgets[0].showAsTab = true;
    };
    
    
    /*Planilhas - Geral*/
    this.openPopup = function(popupName) {
        var widgetPopup = templateManager.container.getWidget(popupName);
        widgetPopup.currentRow.DSPATH = [];
        ScreenService.openPopup(widgetPopup);
    };
    
    this.closePopup = function(widgetName) {
        ScreenService.closePopup();
        templateManager.container.getWidget(widgetName).activate();
    };
    
    this.validaArquivo = function(filePath) {
        var extension = filePath.split('.').pop().toUpperCase();
        if (extension !== 'XLS' && extension !== 'XLSX') {
            ScreenService.showMessage('Formato de arquivo inválido');
            return false;
        } else {
            return true;
        }
    };
    
    var openPopupMensagens = function(msg, nmPopupMsg) {
        var widgetMensagens = templateManager.container.getWidget(nmPopupMsg);
        widgetMensagens.dataSource.data = msg;
        ScreenService.openPopup(widgetMensagens);
    };
    
    /*Planilhas - Ferias*/
    this.geraPlanilhaTemplete = function() {
        restEngine.post('product#/baixarPlanilhaFerias', {
            'requestType': 'DataSet',
            'dataset': []
            }).then(function(data) {
                ScreenService.closePopup();
                if(data.dataset && data.dataset.arquivo){
                    $window.open($window.serviceUrl + "/abrirArquivo?requestType=DataSet&dataset[0][CMARQUIVO]=" + data.dataset.arquivo.NMARQUIVO);
                }
            }).catch(function(e) {
                var error;
                if (e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
    };
    
    this.importarPlanilhaFerias = function() {
        var widgetPop = templateManager.container.getActiveWidget();
        if(widgetPop.isValid()){
            if(this.validaArquivo(widgetPop.currentRow.DSPATH[0].name)) {
                restEngine.post('product#/importarPlanilhaFerias', {'requestType': 'DataSet', 'dataset': [widgetPop.currentRow]}).
                then(function(data) {
                    if (data.messages) {
                        ScreenService.closePopup(true);
                        ScreenService.showMessage(data.messages[0].message, data.messages[0].type);
                        if (data.dataset && data.dataset.msg) {
                            openPopupMensagens(data.dataset.msg, 'messagesImportacaoFerias');
                        } 
                    } else
                        ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                }).
                catch(function(e) {   
                    var error;
                    if (e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    
                });
            }
        }
    };
    
    this.atualizaPeriodo = function(args) {
        var widget = ABUtilController.checkWidget(args);
        var dtini = widget.getField('DTINIGOZOFERIAS').value();
        var nrqtdias = widget.getField('DIASFERIAS').value();
        var dtfim = widget.getField('DTFIMGOZOFERIAS').value();

        if (!ABUtilController.validaDtIniMenorIgualDtFin(dtini, dtfim)) {
            ScreenService.alertNotification(Messages.DTINI_POST_DTFIM_ERROR, 10000);
        } else {
            if (!Util.isEmptyOrBlank(dtini) && !isNaN(nrqtdias) && nrqtdias > 0) {
                nrqtdias--;
                dtfim = moment(dtini, 'DD/MM/YYYY').add(nrqtdias, 'day').format('DD/MM/YYYY');
                widget.getField('DTFIMGOZOFERIAS').setValue(dtfim);
                var dtretorno = moment(dtfim, 'DD/MM/YYYY').add(1, 'day').format('DD/MM/YYYY');
                widget.getField('DTRETORNOFERIAS').setValue(dtretorno);
            }
            else if (!Util.isEmptyOrBlank(dtini) && !Util.isEmptyOrBlank(dtfim)) {
                nrqtdias = moment(dtfim, 'DD/MM/YYYY').diff(moment(dtini, 'DD/MM/YYYY'), 'day') + 1;
                widget.getField('DIASFERIAS').setValue(nrqtdias);
            }
        }
        
    };

    this.atualizaQtdDias = function(args) {
        var widget = ABUtilController.checkWidget(args);
        var dtini = widget.getField('DTINIGOZOFERIAS').value();
        var dtfim = widget.getField('DTFIMGOZOFERIAS').value();

        if (!ABUtilController.validaDtIniMenorIgualDtFin(dtini, dtfim)) {
            ScreenService.alertNotification(Messages.DTINI_POST_DTFIM_ERROR, 10000);
        } else {
            if (!Util.isEmptyOrBlank(dtini) && !Util.isEmptyOrBlank(dtfim)) {
                var nrqtdias = moment(dtfim, 'DD/MM/YYYY').diff(moment(dtini, 'DD/MM/YYYY'), 'day') + 1;
                widget.getField('DIASFERIAS').setValue(nrqtdias);
                var dtretorno = moment(dtfim, 'DD/MM/YYYY').add(1, 'day').format('DD/MM/YYYY');
                widget.getField('DTRETORNOFERIAS').setValue(dtretorno);
            } else {
                widget.getField('DIASFERIAS').setValue("");
            }
        }
    };
    
	this.setFerias = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
            if (ABUtilController.validaDtIniMenorIgualDtFin(widget.currentRow.DTINIAQUISICAO, widget.currentRow.DTFIMAQUISICAO)) {
                if (!widget.backupRow) {
                    widget.currentRow.__is_new = true;
                } else {
                    widget.currentRow.__is_new = false;
                }
                restEngine.post('product#/setFerias', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                    then(function (data) {
                        if (data.notifications[0].type === "success") {
                            ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                            if (widget.currentRow.__is_new) {
                                ABUtilController.masterDetailVoltarList(widget);
                                self.widgetsvisibletrue(args);
                                widget.reload();
                            } else {
                                ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                                widget.backupRow = null;
                                widget.view();
                            }
                        } else {
                            ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                        }
                    }).
                    catch(function(e) {
                        var error;
                        if(e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;
                            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    });
            }else{
                ScreenService.showMessage(Messages.DTINI_POST_DTFIM_ERROR);
                return false;
            }        
        }
    };
    
    this.deleteFerias = function(args) {
        ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
        var widget = templateManager.container.getActiveWidget();
        if (widget.isValid()) {
            widget.currentRow.__is_new = false;
            restEngine.post('product#/deleteFerias', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                then(function (data) {
                    if (data.messages) {
                        ScreenService.showMessage(Messages.REMOVE_ROW_ERROR + '. ' + data.messages[0].message, data.messages[0].type);
                    } else {
                        ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    }
                }).
                catch(function(e) {
                    var error;
                    if(e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;

                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
        }
          }, null);
    };
        
    this.validaGozoFerias = function(widget,widgetMain){
        var row = widget.currentRow;
        var rowMain = widgetMain.currentRow;
        if(!Util.isNull(rowMain.QTDIASMINFERIAS) && parseInt(row.DIASFERIAS) < parseInt(rowMain.QTDIASMINFERIAS)){
            return "Total de dias de férias não deve ser menor que a quantidade mínima de "+rowMain.QTDIASMINFERIAS+" dias.";
        }
        if(!Util.isNull(rowMain.QTDIASMAXFERIAS) && parseInt(row.DIASFERIAS) > parseInt(rowMain.QTDIASMAXFERIAS)){
            return "Total de dias de férias não deve ser maior que a quantidade máxima de "+rowMain.QTDIASMAXFERIAS+" dias.";
        }
        if(!Util.isNull(rowMain.QTDIASMAXABONO) && parseInt(row.QTDIASABONOFERI) > parseInt(rowMain.QTDIASMAXABONO)){
            return "Total de dias de abono excede a quantidade máxima de "+rowMain.QTDIASMAXABONO+" dias.";
        }
        return null;
    };
    
	this.setGozoFerias = function(args, namewidgetMain) {
        var widget = args.owner.widget;

        var widgetMain;
        if(!namewidgetMain)
            widgetMain = templateManager.container.getWidget("ferias");
        else
            widgetMain = templateManager.container.getWidget("feriasPeriodo");
            
        if (widget.isValid()) {
            if (ABUtilController.validaDtIniMenorIgualDtFin(widget.currentRow.DTINIGOZOFERIAS, widget.currentRow.DTFIMGOZOFERIAS)) {
                if (!widget.backupRow) {
                    widget.currentRow.__is_new = true;
                } else {
                    widget.currentRow.__is_new = false;
                }
                var validaGozo = this.validaGozoFerias(widget,widgetMain);
                if(validaGozo){
                    ScreenService.showMessage(validaGozo);
                    return false;
                }
                widget.currentRow.NRFERIAS = widgetMain.currentRow.NRFERIAS;
                widget.currentRow.NRVINCULOM = widgetMain.currentRow.NRVINCULOM;
                restEngine.post('product#/setGozoFerias', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                    then(function (data) {
                        if(data.messages){
                            if(data.messages[0].type === 'E'){
                                ScreenService.showMessage(data.messages[0].message, data.messages[0].type);
                                return false;
                            } else if(data.messages[0].type === 'W') {
                                ScreenService.showMessage(data.messages[0].message, data.messages[0].type);
                                if(widget.currentRow.__is_new == true){
                                    ScreenService.closeSwipe();
                                    widget.reload();
                                }else{
                                    widget.view();
                                }
                            } else {
                                ScreenService.showMessage(data.messages[0].message, data.messages[0].type);
                            }    
                        } else if (data.notifications && data.notifications[0].type === "success") {
                            ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                            if (widget.currentRow.__is_new) {
                                ABUtilController.masterDetailVoltarList(widget);
                                widget.reload();
                            } else if (!Util.isUndefined(data.messages)) {
                                ScreenService.showMessage(data.messages[0].message, data.messages[0].type);
                            } else {
                                ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                                widget.backupRow = null;
                                widget.view();
                            }
                        } else {
                            ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                        }
                        
                    }).
                    catch(function(e) {
                        var error;
                        if(e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;
                            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    });
            }else{
                ScreenService.showMessage(Messages.DTINI_POST_DTFIM_ERROR);
                return false;
            }           
        }
    };
    
    
    this.deleteGozoFerias = function(args) {
        ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
        var widget = args.owner.widget;
        widget.currentRow.__is_new = false;
        restEngine.post('product#/deleteGozoFerias', {'requestType':'DataSet','dataset':[widget.currentRow]}).
            then(function(data){
                if(data.notifications && data.notifications[0].type === "success"){
                    ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                    ABUtilController.masterDetailVoltarList(widget);
                    widget.reload();
                } else if (!Util.isUndefined(data.messages)) {
                    ScreenService.showMessage(data.messages[0].message, data.messages[0].type);
                } else {
                    ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                }
            }).
            catch(function(e) {
                var error;
                if(e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
        }, null);
    };
    
    this.validaPrazoGozoESocial = function(args){
        var widget = ABUtilController.checkWidget(args);
        
        var dataInicioGozo = widget.currentRow.DTINIGOZOFERIAS;
        var dataAtual = new Date();
        ABUtilController.truncateObjetoDate(dataAtual);
        
        if(dataInicioGozo){
            var dataInicioGozoDate = ABUtilController.retornaObjetoDateComString(dataInicioGozo);
            var dataEnvioAntecedência = new Date();
            ABUtilController.truncateObjetoDate(dataEnvioAntecedência);
            dataEnvioAntecedência.setDate(dataAtual.getDate() + 30);
            //vê se o gozo está sendo transmitido antes do dia 07 do mês seguinte a data de inicio ou se a data de início do gozo não está sendo enviada com diferença de no mínimo 30 dias a frente da data atual
            if(dataEnvioAntecedência.getTime() >= dataInicioGozoDate.getTime()){
                ScreenService.showMessage(Messages.AVISO_ESO_PENSALIDADE_AFASTAMENTO_GOZO_FERIAS_FORA_PRAZO);
            }
        }
        
        
    };
    
}

Configuration(function(ContextRegister) {
    ContextRegister.register('GozoFeriasController', GozoFeriasController);
});

// FILE: assets/js/controllers/GrauAcaoController.js
function GrauAcaoController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, General,Messages) {

    this.adicionarRow = function(args) {
        var widget = args.owner.widget;
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
    };
    
	this.setGrauAcao = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
                if (!widget.backupRow) {
                    widget.currentRow.__is_new = true;
                } else {
                    widget.currentRow.__is_new = false;
                }
                restEngine.post('product#/setGrauAcao', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                    then(function (data) {
                        if (data.notifications[0].type === "success") {
                            ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                            if (widget.currentRow.__is_new) {
                                ABUtilController.masterDetailVoltarList(widget);
                                widget.reload();
                            } else {
                                ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                                widget.backupRow = null;
                                widget.view();
                            }
                        } else {
                            ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                        }
                    }).
                    catch(function(e) {
                        var error;
                        if(e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;
                            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    });
            }
    };
    
    this.deleteGrauAcao = function(args) {
    ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
        var widget = args.owner.widget;
        widget.currentRow.__is_new = false;
        restEngine.post('product#/deleteGrauAcao', {'requestType':'DataSet','dataset':[widget.currentRow]}).
            then(function(data){
                if(data.notifications[0].type === "success"){
                    ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                    ABUtilController.masterDetailVoltarList(widget);
                    widget.reload();
                } else {
                    ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                }
            }).
            catch(function(e) {
                var error;
                if(e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
        }, null);
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('GrauAcaoController', GrauAcaoController);
});

// FILE: assets/js/controllers/GrauInstrucaoController.js
function GrauInstrucaoController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, General,Messages) {

    this.adicionarRow = function(args) {
        var widget = args.owner.widget;
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
    };

	this.setGrauInstrucao = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
                if (!widget.backupRow) {
                    widget.currentRow.__is_new = true;
                } else {
                    widget.currentRow.__is_new = false;
                }
                restEngine.post('product#/setGrauInstrucao', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                    then(function (data) {
                        if (data.notifications[0].type === "success") {
                            ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                            if (widget.currentRow.__is_new) {
                                ABUtilController.masterDetailVoltarList(widget);
                                widget.reload();
                            } else {
                                ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                                widget.backupRow = null;
                                widget.view();
                            }
                        } else {
                            ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                        }
                    }).
                    catch(function(e) {
                        var error;
                        if(e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;
                            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    });
            }
    };
    
    this.deleteGrauInstrucao = function(args) {
    ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
        var widget = args.owner.widget;
        widget.currentRow.__is_new = false;
        restEngine.post('product#/deleteGrauInstrucao', {'requestType':'DataSet','dataset':[widget.currentRow]}).
            then(function(data){
                if(data.notifications[0].type === "success"){
                    ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                    ABUtilController.masterDetailVoltarList(widget);
                    widget.reload();
                } else {
                    ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                }
            }).
            catch(function(e) {
                var error;
                if(e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
        }, null);
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('GrauInstrucaoController', GrauInstrucaoController);
});

// FILE: assets/js/controllers/GravidadeOcorrenciaController.js
function GravidadeOcorrenciaController(ScreenService, templateManager, restEngine, ABUtilController, Messages) {

	this.salvar = function(args) {
        var widget = templateManager.container.getActiveWidget();
        if (widget.isValid()) {
            if (!widget.backupRow) {
                widget.currentRow.__is_new = true;
            } else {
                widget.currentRow.__is_new = false;
            }
            restEngine.post('product#/setGravidade', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                then(function (data) {
                    if (data.notifications[0].type === "success") {
                        ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                        if (widget.currentRow.__is_new) {
                            ABUtilController.masterDetailVoltarList(widget);
                            widget.reload();
                        } else {
                            ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                            widget.backupRow = null;
                            widget.view();
                        }
                    } else {
                        ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                    }
                }).
                catch(function(e) {
                    var error;
                    if(e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;

                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
        }
    };

    this.remover = function(args) {
    ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
        var widget = templateManager.container.getActiveWidget();
        if (widget.isValid()) {
            widget.currentRow.__is_new = false;
            restEngine.post('product#/deleteGravidade', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                then(function (data) {
                    if (data.notifications[0].type === "success") {
                        ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    } else {
                        ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                    }
                }).
                catch(function(e) {
                    var error;
                    if(e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;

                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
            }
        }, null);
    };

}

Configuration(function(ContextRegister) {
    ContextRegister.register('GravidadeOcorrenciaController', GravidadeOcorrenciaController);
});

// FILE: assets/js/controllers/GrupoIncidenciaController.js
/* jshint esversion: 6 */
function GrupoIncidenciaController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, General,Messages) {
    
    var self = this;

    this.adicionarRow = function(args) {
        var widget = args.owner.widget;
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
    };
    
    this.adicionarRowItem = function(args) {
        var widget = args.owner.widget;
        var widgetMain = templateManager.container.getWidget("grupoIncidencia");
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
        widget.currentRow.NRGRPINCIDE = widgetMain.currentRow.NRGRPINCIDE;
        widget.currentRow.NMGRPINCIDE = widgetMain.currentRow.NMGRPINCIDE;
        
    };
    
    this.openReplicarPopup = function(args) {
        var widgetFilter = templateManager.container.getWidget('repGrupoIncid');
        var widgetMain = templateManager.container.getWidget("grupoIncidencia");
        localStorageEngine.setLocalVar("HCM_NRGRPINCIDE_REP", widgetMain.currentRow.NRGRPINCIDE);
        widgetFilter.applyDefaultValue();
        ScreenService.openPopup(widgetFilter);
        widgetFilter.currentRow.NRGRPINCIDE = widgetMain.currentRow.NRGRPINCIDE;
    };
    
    this.filtrarWidgetPorGrupoIncidencia = function(args){
        var widget = args.owner;
        templateManager.container.getWidget("itensGrupo").dataSourceFilter[0].value = widget.currentRow.NRGRPINCIDE;
    };
    
    this.widgetsvisiblefalse = function(args) {
        var widget = args.owner.widget;
        widget.widgets[0].showAsTab = false;
    };

    this.widgetsvisibletrue = function(args) {
        var widget = args.owner.widget;
        widget.widgets[0].showAsTab = true;
    };
    
	this.setGrupoIncidencia = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
            if (ABUtilController.validaDtIniMenorIgualDtFin(widget.currentRow.DTINIVIGENCIA, widget.currentRow.DTFIMVIGENCIA)) {
                if (!widget.backupRow) {
                    widget.currentRow.__is_new = true;
                } else {
                    widget.currentRow.__is_new = false;
                }
                restEngine.post('product#/setGrupoIncidencia', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                    then(function (data) {
                        if (data.notifications[0].type === "success") {
                            ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                            if (widget.currentRow.__is_new) {
                                ABUtilController.masterDetailVoltarList(widget);
                                self.widgetsvisibletrue(args);
                                widget.reload();
                            } else {
                                ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                                widget.backupRow = null;
                                widget.view();
                            }
                        } else {
                            ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                        }
                    }).
                    catch(function(e) {
                        var error;
                        if(e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;
                            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    });
            }else{
                ScreenService.showMessage(Messages.DTINI_POST_DTFIM_ERROR);
                return false;
            }        
        }
    };
    
    this.replicaGrupoIncidencia = function(args) {
        var widget = args.owner.widget;
        var widgetMain = templateManager.container.getWidget("grupoIncidencia");
        if (widget.isValid()) {
            if (ABUtilController.validaDtIniMenorIgualDtFin(widget.currentRow.DTINIVIGENCIA, widget.currentRow.DTFIMVIGENCIA)) {
                restEngine.post('product#/replicaGrupoIncidencia', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                    then(function (data) {
                        if (data.notifications[0].type === "success") {
                            ScreenService.successNotification('Grupo de Incidência replicado!');
                            ScreenService.closePopup();
                            ABUtilController.masterDetailVoltarList(widgetMain);
                            widgetMain.reload();
                        } else {
                            ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                        }
                    }).
                    catch(function(e) {
                        var error;
                        if(e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;
                            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    });
            }else{
                ScreenService.showMessage(Messages.DTINI_POST_DTFIM_ERROR);
                return false;
            }        
        }
    };
    
    this.deleteGrupoIncidencia = function(args) {
    ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
        var widget = templateManager.container.getActiveWidget();
        if (widget.isValid()) {
            widget.currentRow.__is_new = false;
            restEngine.post('product#/deleteGrupoIncidencia', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                then(function (data) {
                    if (data.messages) {
                        ScreenService.showMessage(Messages.REMOVE_ROW_ERROR + '. ' + data.messages[0].message, data.messages[0].type);
                    } else {
                        ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    }
                }).
                catch(function(e) {
                    var error;
                    if(e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;

                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
            }
        }, null);
    };

    this.setItemGrupoIncidencia = (args) => {
        let widget = args.owner.widget;
        let widgetGrupoIncidencia = templateManager.container.getWidget("grupoIncidencia");

        if (widget.isValid()) {
            widget.currentRow.__is_new = !widget.backupRow;
            widget.currentRow.NRGRPINCIDE = widgetGrupoIncidencia.currentRow.NRGRPINCIDE;

            restEngine.post('product#/setItemGrupoIncidencia', {
                'requestType': 'DataSet',
                'dataset': [widget.currentRow]
            }).then((data) => {
                if (data.messages && data.messages[0].type === "E" && data.notifications[0].type === "error") {
                    ScreenService.showMessage(Messages.HCM01016_FPA_EXISTE_ITEM_GRUPO_INCIDENCIA);

                    return;
                }

                if (data.notifications[0].type === "success") {
                    ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                }

                if (widget.currentRow.__is_new) {
                    ABUtilController.masterDetailVoltarList(widget);
                    widget.reload();

                    return;
                }

                if (!widget.currentRow.__is_new) {
                    ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                    widget.backupRow = null;
                    widget.view();

                    return;
                }

                ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
            }).catch((error) => {
                let msgError = error.data.error ? error.data.error : error;

                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(msgError), 'ERROR');
            });
        }
    };
    
    this.deleteItemGrupoIncidencia = function(args) {
        var widget = args.owner.widget;
        widget.currentRow.__is_new = false;
        restEngine.post('product#/deleteItemGrupoIncidencia', {'requestType':'DataSet','dataset':[widget.currentRow]}).
            then(function(data){
                if(data.notifications[0].type === "success"){
                    ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                    ABUtilController.masterDetailVoltarList(widget);
                    widget.reload();
                } else {
                    ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                }
            }).
            catch(function(e) {
                var error;
                if(e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('GrupoIncidenciaController', GrupoIncidenciaController);
});

// FILE: assets/js/controllers/HCMLoginController.js
function HCMLoginController (ScreenService, templateManager, LibLoginController, Messages, eventAggregator) {

    var validateLoginResponse = function(response) {
        if(response && response.cdoperador) {
        	validateClientBrowseVersion(response.version);
        	eventAggregator.publish('authSuccess', response);
        }
    };

	this.loginWidgetOnEnter = function() {
        LibLoginController.authenticate(HCMLoginConfig.loginTitle, HCMLoginConfig.loginTheme, HCMLoginConfig.loginSplashFavicon,
            HCMLoginConfig.loginImage, HCMLoginConfig.loginProduct, HCMLoginConfig.loginProductId, HCMLoginConfig.loginVersionFile,
            HCMLoginConfig.loginTestDataBase)
            .then(validateLoginResponse)
            .catch(function(error) {
            	console.log(error);
            });
    };

    this.logout = function(){
        ScreenService.confirmMessage('Deseja realmente sair do sistema?', 'ALERT', logoutYes, logoutNo);
    };

    var logoutYes = function(){
        LibLoginController.logout(HCMLoginConfig.loginTitle, HCMLoginConfig.loginTheme, HCMLoginConfig.loginSplashFavicon,
            HCMLoginConfig.loginImage, HCMLoginConfig.loginProduct, HCMLoginConfig.loginProductId);
    };

    var logoutNo = function(){
        ScreenService.goBack();
    };

    var validateClientBrowseVersion = function(versionObj) {
        var versionClient = localStorage.getItem('VERSION');
        var versionServer = versionObj.version + '.' + versionObj.revision + '.' + versionObj.build;
        if(versionClient != versionServer) {
            localStorage.setItem('VERSION', versionServer);
            window.location.reload(true);
        }
    };
   
}

Configuration(function(ContextRegister) {
    ContextRegister.register('HCMLoginController', HCMLoginController);
});

// FILE: assets/js/controllers/HcmLogController.js
function HcmLogController(ScreenService, templateManager, localStorageEngine, restEngine, metaDataFactory) {

    this.execute = function(argsRow) {

        if (argsRow.DSQUERY === '') {
            ScreenService.showMessage('Favor informar a query desejada.', 'ALERT');
        } else {
            return restEngine.post("product#/executeQuery",
                {
                    requestType: "FilterData",
                    filter: [{operator: "=", name: "P_DSQUERY", value: argsRow.DSQUERY}]
                }
            ).then(function (data) {
                try {
                    if (!Util.isUndefined(data.messages)) {
                        ScreenService.showMessage(data.messages[0].message, 'ERROR');
                    } else {
                        var container = templateManager.container;
                        var widgetResult = container.getWidget('result');

                        widgetResult.fields = [];

                        if (data.dataset.result.length > 0) {
                            var resultColumns = data.dataset.result[0];
                            $.each(resultColumns, function (key, value) {
                                var obj = {
                                    "id": 0,
                                    "name": key,
                                    "label": key,
                                    "maxWidth": "",
                                    "sameLine": false,
                                    "isVisible": true,
                                    "showOnForm": true,
                                    "showOnList": true,
                                    "showOnView": true,
                                    "placeholder": null,
                                    "align": "center",
                                    "isReadOnly": true,
                                    "template": "field/text.html",
                                    "events": []
                                };

                                metaDataFactory.factoryField(obj, widgetResult);
                            });

                            widgetResult.dataSource.data = data.dataset.result;

                            templateManager.updateTemplate(widgetResult);

                            ScreenService.closePopup();
                            ScreenService.successNotification("Query executada com sucesso");
                        } else {
                            ScreenService.showMessage('Dados não encontrados na consulta.');
                        }
                    }
                } catch (e) {
                    ScreenService.showMessage(e, 'ERROR');
                }

            });
        }

    };

    this.openPopup = function() {

        var container = templateManager.container;
        var widget = container.getWidget('aplicar');

        ScreenService.openPopup(widget);
    };

}

Configuration(function(ContextRegister) {
    ContextRegister.register('HcmLogController', HcmLogController);
});

// FILE: assets/js/controllers/HcmManualController.js
/**
 * Created by rafael.pickbrenner on 01/09/2021.
 */

/**
 * Adiciona uma action na navbarr da aplicação para a chamada de manuais do sistema
 */

/* jshint esversion: 6 */
ZeedhiApp.run(function(templateManager, ZhuAccessButtonService) {
    templateManager.projectPromise.then(function(project){
        if(templateManager.project.aclEnable){
            var notification = {
                "label": "Manual",
                "name": "hcmManual",
                "icon": "information",
                "isVisible": false,
                "tooltip": "Manual e/ou vídeos de ajuda sobre o processo",
                "isAclNotification": true,
                "events": [
                    {
                        "name": "NotificationEvent",
                        "code": "HcmManualController.getManual();"
                    }
                ]
            };
            
            notification = Util.extend(new _Notification(), notification);
            templateManager.project.notifications = templateManager.project.notifications || [];
            templateManager.project.notifications.push(notification);
        }
    });
});

/**
 * Funções do HcmManualController
 */
function HcmManualController(ScreenService, templateManager, restEngine, Messages, $window, ABUtilController) {
    
    this.infoTela = {
        nmTela:   '',
        nmPagina: '',
        nmManual: ''
    };
    
    this.successFunction = function(data) {
        function download(url, filename) {
            fetch(url).then(function(t) {
                return t.blob().then((b)=>{
                    var a = document.createElement("a");
                    a.href = URL.createObjectURL(b);
                    a.setAttribute("download", filename);
                    a.click();
                    URL.revokeObjectURL(b);
                }
                );
            });
        }

        if (data.dataset.zip) {
            $window.open($window.serviceUrl + "/abrirArquivo?requestType=DataSet&dataset[0][CMARQUIVO]=" + data.dataset.zip[0]);
        }

        if(data.dataset && data.dataset.arquivo && Array.isArray(data.dataset.arquivo.NMARQUIVO)) {
            data.dataset.arquivo.NMARQUIVO.forEach(function(element){
                var path = ABUtilController.getBaseUrlFileServer() + element.dspath;

                download($window.serviceUrl + "/abrirArquivo?requestType=DataSet&dataset[0][CMARQUIVO]=" + path, element.nmanexo);
            });
        }
    };
    
    this.processError = function(e) {
        var error;
        if(Util.isUndefined(e.data) && Util.isUndefined(e.data.error) && Util.isUndefined(e.message))
            error = e;
        else if(!Util.isUndefined(e.message))
            error = e.message;
        else
            error = e.data.error;
        ScreenService.showMessage(Util.isUndefined(Messages[error]) ? error : Messages[error], 'ERROR');
    };
    
  
    this.getManual = function() {
        
        this.setInfoTela();
        
        var data = {
            requestType: "Row",
            row: this.infoTela,
        };
        
        restEngine.post("product#/getHcmManual", data).then(this.successFunction).catch(this.processError);
    };
  
    
    this.setInfoTela = function() {
        this.infoTela.nmTela   = templateManager.container.label;
        this.infoTela.nmPagina = templateManager.container.getActiveWidget().label;
        this.infoTela.nmManual = this.normalizeName(this.infoTela.nmTela + '-' + this.infoTela.nmPagina);
    };
  
  
    this.normalizeName = function(text) {
        return text.normalize("NFD").replace(/[\u0300-\u036f]/g, "").replace(/[\s/\?:*<>|"]/g, "").toLowerCase();
    };
    
}

Configuration(function(ContextRegister) {
    ContextRegister.register('HcmManualController', HcmManualController);
});


// FILE: assets/js/controllers/HierarquiaGridController.js
function HierarquiaGridController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, General,Messages) {
    
    var NMTIPOHIERARQORG;
    this.tpHierarquiaAntigo = null;
    
    this.CadAutomatico = function(args){
        var widget = args.owner.widget;
            if (!widget.backupRow) {
                widget.currentRow.__is_new = true;
            } else {
                widget.currentRow.__is_new = false;
            }
            restEngine.post('product#/setCadAutomaticoLegalGeren', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                then(function (data) {
                    if (data.messages[0].type === 'S') {
                        //ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                        ScreenService.showMessage(data.messages[0].message);
                        if (widget.currentRow.__is_new) {
                            ABUtilController.masterDetailVoltarList(widget);
                            widget.reload();
                        } else {
                            ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                            widget.backupRow = null;
                            widget.view();
                        }
                    } else {
                        ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                    }
                }).
                catch(function(e) {
                    var error;
                    if(e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;
                        ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
    };
    
    this.readOnlyFieldsEstruturas = function(widget, action){
        if(action == 'editar'){
            if(widget.currentRow.NMESTRUTURAMSUP){
                widget.getField('NMESTRUTURAMSUP').readOnly = false;
                widget.getField('NMESTRUTURAMSUP').validations = {required:true};
            }else{
                widget.getField('NMESTRUTURAMSUP').readOnly = true;
                widget.getField('NMESTRUTURAMSUP').validations = {};
            }

            if(widget.currentRow.NMESTRUTURAMREL){
                widget.getField('NMESTRUTURAMREL').readOnly = false;
                widget.getField('NMESTRUTURAMREL').validations = {required:true};
            }else{
                widget.getField('NMESTRUTURAMREL').readOnly = true;
                widget.getField('NMESTRUTURAMREL').validations = {};
            }
        }else if(action == 'adicionar'){
            widget.getField('NMESTRUTURAMREL').readOnly = true;
            widget.getField('NMESTRUTURAMSUP').readOnly = true;
        }
    };
    
    this.visibilidadeActionEdit = function(widget){
        if(!widget.currentRow.NRHIERARQUIAORG){ 
            widget.getAction('editar').isVisible = false;
            widget.getAction('excluir').isVisible = false;
        }else{
            widget.getAction('editar').isVisible = true;    
            widget.getAction('excluir').isVisible = true;    
        } 
    };
    
    
    this.setGlobalVar = function(widget){
        if(widget.currentRow && widget.currentRow.NRTIPOHIERARQORG) this.tpHierarquiaAntigo = widget.currentRow.NRTIPOHIERARQORG;
    };
    
    this.adicionarRow = function(args) {
        var widget = args.owner.widget;
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
        // this.habilitaEstruturas(widget, 'nao');
    };
    
    this.habilitaEstruturasHierarquiaTree = function(args, ehFiltro){
        var widget = args.owner.field.widget;
        
        if (ehFiltro) {
            ABUtilController.setFieldNotRequired(widget.getField('NMESTRUTURAMREL'));
            ABUtilController.setFieldNotRequired(widget.getField('NMESTRUTURAMREL'));
            
            widget.getField('NMESTRUTURAMREL').readOnly = false;
            widget.getField('NMESTRUTURAMSUP').readOnly = false;
            
            if(widget.currentRow.NMTIPOHIERARQORG && widget.currentRow.NRTIPOESTRUTREL == widget.currentRow.NRTIPOESTRUTSUP || !widget.currentRow.NRTIPOESTRUTSUP){
                widget.getField('NMESTRUTURAMSUP').readOnly = true;
            
            }
            
        } else {
            
            if(widget.currentRow.NMTIPOHIERARQORG){
    
                if(this.tpHierarquiaAntigo != widget.currentRow.NRTIPOHIERARQORG){
                    widget.currentRow.NMESTRUTURAMSUP = "";
                    widget.currentRow.NRESTRUTURAMSUP = "";
                    widget.currentRow.NMESTRUTURAMREL = "";
                    widget.currentRow.NRESTRUTURAMREL = "";
                }
                
                this.tpHierarquiaAntigo = widget.currentRow.NRTIPOHIERARQORG;
    
    
                widget.getField('NMESTRUTURAMREL').readOnly = false;
                widget.getField('NMESTRUTURAMSUP').readOnly = false;
                widget.getField('NMESTRUTURAMREL').validations = {required:true};
                
                widget.getField('NMESTRUTURAMREL').dataSourceFilter.forEach(function(obj){
                    if(obj.name == 'NRTIPOESTRUTURA' ) obj.value = widget.currentRow.NRTIPOESTRUTREL;
                });
        
                if(widget.currentRow.NRTIPOESTRUTREL == widget.currentRow.NRTIPOESTRUTSUP || !widget.currentRow.NRTIPOESTRUTSUP){
                    widget.getField('NMESTRUTURAMSUP').validations = {};
                    widget.getField('NMESTRUTURAMSUP').dataSourceFilter.forEach(function(obj){
                        if(obj.name == 'NRTIPOESTRUTURA' ) obj.value = widget.currentRow.NRTIPOESTRUTREL;
                    });
                }else{
                    widget.getField('NMESTRUTURAMSUP').validations =  {required:true};
                    widget.getField('NMESTRUTURAMSUP').dataSourceFilter.forEach(function(obj){
                        if(obj.name == 'NRTIPOESTRUTURA' ) obj.value = widget.currentRow.NRTIPOESTRUTSUP;
                    });
                }
            }else{
                widget.currentRow.NRESTRUTURAMSUP = "";
                widget.currentRow.NMESTRUTURAMSUP = "";
                widget.getField('NMESTRUTURAMSUP').readOnly = true;
                widget.currentRow.NRESTRUTURAMREL = "";
                widget.currentRow.NMESTRUTURAMREL = "";
                widget.getField('NMESTRUTURAMREL').validations = {};
            }    
        }
        
    };
    
    this.habilitaEstruturasHierarquiaGrid = function(args, ehFiltro){
        var widget = args.owner.field.widget;

        if(widget.currentRow.NMTIPOHIERARQORG){
            
            if(this.tpHierarquiaAntigo != widget.currentRow.NRTIPOHIERARQORG){
                widget.currentRow.NMESTRUTURAMSUP = "";
                widget.currentRow.NRESTRUTURAMSUP = "";
                widget.currentRow.NMESTRUTURAMREL = "";
                widget.currentRow.NRESTRUTURAMREL = "";
            }
            
            this.tpHierarquiaAntigo = widget.currentRow.NRTIPOHIERARQORG;
    
            widget.getField('NMESTRUTURAMREL').readOnly = false;
            widget.getField('NMESTRUTURAMSUP').readOnly = false;            
            
            if(!ehFiltro) widget.getField('NMESTRUTURAMREL').validations = {required:true};
    
            widget.getField('NMESTRUTURAMREL').dataSourceFilter.forEach(function(obj){
                if(obj.name == 'NRTIPOESTRUTURA' ) obj.value = widget.currentRow.NRTIPOESTRUTREL;
            });
    
            if(widget.currentRow.NRTIPOESTRUTREL == widget.currentRow.NRTIPOESTRUTSUP || !widget.currentRow.NRTIPOESTRUTSUP){
                widget.getField('NMESTRUTURAMSUP').validations = {};
                widget.getField('NMESTRUTURAMSUP').dataSourceFilter.forEach(function(obj){
                    if(obj.name == 'NRTIPOESTRUTURA' ) obj.value = widget.currentRow.NRTIPOESTRUTREL;
                });
            }else{
                if(!ehFiltro) widget.getField('NMESTRUTURAMSUP').validations = {required:true};
                widget.getField('NMESTRUTURAMSUP').dataSourceFilter.forEach(function(obj){
                    if(obj.name == 'NRTIPOESTRUTURA' ) obj.value = widget.currentRow.NRTIPOESTRUTSUP;
                });
            }
        }
        else{
            widget.currentRow.NRESTRUTURAMSUP = "";
            widget.currentRow.NMESTRUTURAMSUP = "";
            widget.currentRow.NRESTRUTURAMREL = "";
            widget.currentRow.NMESTRUTURAMREL = "";
         
            if(!ehFiltro){
                widget.getField('NMESTRUTURAMSUP').validations = {};
                widget.getField('NMESTRUTURAMSUP').readOnly = true;
                widget.getField('NMESTRUTURAMREL').validations = {};
                widget.getField('NMESTRUTURAMREL').readOnly = true;
            }else if(ehFiltro){
                widget.getField('NMESTRUTURAMSUP').dataSourceFilter.forEach(function(obj){
                    if(obj.name == 'NRTIPOESTRUTURA' ) obj.value = null;
                });
                widget.getField('NMESTRUTURAMREL').dataSourceFilter.forEach(function(obj){
                    if(obj.name == 'NRTIPOESTRUTURA' ) obj.value = widget.currentRow.NRTIPOESTRUTREL;
                });
            }
        }    
    };
    
    this.estrutRelacOnChange = function(args){
        var widget = args.owner.field.widget;
        if(widget.currentRow.NRTIPOESTRUTREL == widget.currentRow.NRTIPOESTRUTSUP || !widget.currentRow.NRTIPOESTRUTSUP){
            widget.currentRow.NMESTRUTURAMSUP = widget.currentRow.NMESTRUTURAMREL;
            widget.currentRow.NMTIPOESTRUTURASUP = widget.currentRow.NMTIPOESTRUTURAREL;
            widget.currentRow.NRESTRUTURAMSUP = widget.currentRow.NRESTRUTURAMREL;
        }
        
    };
    
	this.setHierarquiaGrid = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
                if (!widget.backupRow) {
                    widget.currentRow.__is_new = true;
                } else {
                    widget.currentRow.__is_new = false;
                }
                restEngine.post('product#/setHierarquiaGrid', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                    then(function (data) {
                        if (data.notifications[0].type === "success") {
                            ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                            if (widget.currentRow.__is_new) {
                                ABUtilController.masterDetailVoltarList(widget);
                                widget.reload();
                            } else {
                                ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                                widget.backupRow = null;
                                widget.view();
                            }
                        } else {
                            ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                        }
                    }).
                    catch(function(e) {
                        var error;
                        if(e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;
                            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    });
            }
    };
    
    this.deleteHierarquiaGrid = function(args) {
        var widget = args.owner.widget;
        ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
            widget.currentRow.__is_new = false;
            restEngine.post('product#/deleteHierarquiaGrid', {'requestType':'DataSet','dataset':[widget.currentRow]}).
                then(function(data){
                    if(data.notifications[0].type === "success"){
                        ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    } else {
                        ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                    }
                }).
                catch(function(e) {
                    var error;
                    if(e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;
                        ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
        }, null);
    };
    
    this.validaCadastroHierarquiaGrid = function(args){
        var widget = args.owner.widget;
        if(widget.isValid()){
            /*if(widget.currentRow.__is_new === true){
                restEngine.post('product#/validaCadastroHierarquiaGrid', {'requestType':'DataSet','dataset':[widget.currentRow]}).
                    then(function(data){
                        if(data.messages[0].type === 'E'){
                            ScreenService.showMessage(data.messages[0].message, 'ERROR');
                        }else{
                            this.setHierarquiaGrid(args);
                        }
                    }.bind(this)).
                    catch(function(e) {
                        var error;
                        if(e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;
                            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    });
            }else{*/
                this.setHierarquiaGrid(args);
            //}
        }
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('HierarquiaGridController', HierarquiaGridController);
});

// FILE: assets/js/controllers/HistoricoEpiController.js
function HistoricoEpiController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, General,Messages) {

    this.adicionarRow = function(args) {
        var widget = args.owner.widget;
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
    };
    
	this.setHistoricoEpi = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
                if (!widget.backupRow) {
                    widget.currentRow.__is_new = true;
                } else {
                    widget.currentRow.__is_new = false;
                }
                restEngine.post('product#/setHistoricoEpi', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                    then(function (data) {
                        if (data.notifications[0].type === "success") {
                            ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                            if (widget.currentRow.__is_new) {
                                ABUtilController.masterDetailVoltarList(widget);
                                widget.reload();
                            } else {
                                ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                                widget.backupRow = null;
                                widget.view();
                            }
                        } else {
                            ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                        }
                    }).
                    catch(function(e) {
                        var error;
                        if(e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;
                            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    });
        }
    };
    
    this.deleteHistoricoEpi = function(args) {
        var widget = args.owner.widget;
        widget.currentRow.__is_new = false;
        restEngine.post('product#/deleteHistoricoEpi', {'requestType':'DataSet','dataset':[widget.currentRow]}).
            then(function(data){
                if(data.notifications[0].type === "success"){
                    ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                    ABUtilController.masterDetailVoltarList(widget);
                    widget.reload();
                } else {
                    ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                }
            }).
            catch(function(e) {
                var error;
                if(e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('HistoricoEpiController', HistoricoEpiController);
});

// FILE: assets/js/controllers/HistoricoPadraoController.js
function HistoricoPadraoController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, General,Messages) {

    this.adicionarRow = function(args) {
        var widget = args.owner.widget;
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
    };

	this.setHistoricoPadrao = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
                if (!widget.backupRow) {
                    widget.currentRow.__is_new = true;
                } else {
                    widget.currentRow.__is_new = false;
                }
                restEngine.post('product#/setHistoricoPadrao', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                    then(function (data) {
                        if (data.notifications && data.notifications[0].type === "success") {
                            widget.getField('CDHISTPADR').readOnly = true;
                            ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                            if (widget.currentRow.__is_new) {
                                ABUtilController.masterDetailVoltarList(widget);
                                widget.reload();
                            } else {
                                ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                                widget.backupRow = null;
                                widget.view();
                            }
                        } else {
                            ScreenService.showMessage(data.messages[0].message, "ERROR");
                        }
                    }).
                    catch(function(e) {
                        var error;
                        if(e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;
                            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    });
            }
    };
    
    this.deleteHistoricoPadrao = function(args) {
    ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
        var widget = args.owner.widget;
        widget.currentRow.__is_new = false;
        restEngine.post('product#/deleteHistoricoPadrao', {'requestType':'DataSet','dataset':[widget.currentRow]}).
            then(function(data){
                if(data.notifications[0].type === "success"){
                    ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                    ABUtilController.masterDetailVoltarList(widget);
                    widget.reload();
                } else {
                    ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                }
            }).
            catch(function(e) {
                var error;
                if(e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
        }, null);
    };
    
    this.habilitaDesabilitaCodigo = function (condition) {
        var widget = templateManager.container.getActiveWidget();
        //true para habilitar o campo e false para desabilitar
        if (condition === true){
            widget.getField('CDHISTPADR').readOnly = false;
        } else {
            widget.getField('CDHISTPADR').readOnly = true;
        }
    };
    
    
}

Configuration(function(ContextRegister) {
    ContextRegister.register('HistoricoPadraoController', HistoricoPadraoController);
});

// FILE: assets/js/controllers/HomologRubricaController.js
function HomologRubricaController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, General,Messages) {

    this.adicionarRow = function(args) {
        var widget = args.owner.widget;
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
    };

	this.setHomologRubrica = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
                if (!widget.backupRow) {
                    widget.currentRow.__is_new = true;
                } else {
                    widget.currentRow.__is_new = false;
                }
                restEngine.post('product#/setHomologRubrica', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                    then(function (data) {
                        if (data.notifications[0].type === "success") {
                            ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                            if (widget.currentRow.__is_new) {
                                ABUtilController.masterDetailVoltarList(widget);
                                widget.reload();
                            } else {
                                ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                                widget.backupRow = null;
                                widget.view();
                            }
                        } else {
                            ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                        }
                    }).
                    catch(function(e) {
                        var error;
                        if(e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;
                            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    });
            }
    };
    
    this.deleteHomologRubrica = function(args) {
    ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
        var widget = args.owner.widget;
        widget.currentRow.__is_new = false;
        restEngine.post('product#/deleteHomologRubrica', {'requestType':'DataSet','dataset':[widget.currentRow]}).
            then(function(data){
                if(data.notifications[0].type === "success"){
                    ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                    ABUtilController.masterDetailVoltarList(widget);
                    widget.reload();
                } else {
                    ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                }
            }).
            catch(function(e) {
                var error;
                if(e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
        }, null);       
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('HomologRubricaController', HomologRubricaController);
});

// FILE: assets/js/controllers/HoraDiaController.js
function HoraDiaController(ScreenService, templateManager, restEngine, ABUtilController, Messages, General) {
    
    this.adicionarRow = function(args) {
        var widget = args.owner.widget;
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
    };
    
    this.salvar = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
            if(ABUtilController.validaDtIniMenorIgualDtFin(widget.currentRow.DTINIVIGENCIA,widget.currentRow.DTFIMVIGENCIA)){
                ABUtilController.saveMasterDetailMasterHistory(widget);
            }else{
                ScreenService.showMessage(Messages.DTINI_POST_DTFIM_ERROR);
                return false;
            }    
        }
    };

    this.remover = function(args) {
    ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
        var widget = args.owner.widget;
        if (widget.isValid()) {
            widget.currentRow.__is_new = false;
            restEngine.post('product#/deleteHoraDia', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                then(function (data) {
                    if (data.notifications[0].type === "success") {
                        ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    } else {
                        ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                    }
                }).
                catch(function(e) {
                    var error;
                    if(e.data.error === undefined){
                        error = e;
                    }    
                    else{
                        error = e.data.error;
                        ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    }    
                });
            }
        }, null);
    };

}

Configuration(function(ContextRegister) {
    ContextRegister.register('HoraDiaController', HoraDiaController);
});

// FILE: assets/js/controllers/HorarioController.js
/* jshint esversion: 6 */
/**
 * Created by lara loures on 24/08/2016.
 */
function HorarioController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, ABUtilController, AFormataHoraDecimal, Messages) {
    var DIA_ANTERIOR       = 'DA';
    var DIA_CORRENTE       = 'DC';
    var DIA_SEGUINTE       = 'DS';
    var FORCA_DIA_ANTERIOR = 'FA';
    var FORCA_DIA_CORRENTE = 'FC';
    var FORCA_DIA_SEGUINTE = 'FS';
    var DIA                = "D";
    var HORAS              = "H";
    var MINUTOS            = "m";
    var SEGUNDOS           = "S";
    var ANTES              = 1;
    var DEPOIS             = 2;
    var HRINVALIDA = false;
    
    const self = this;


    this.calculaSaida = function(currentRow, args){
        var widget = ABUtilController.checkWidget(args);
        currentRow.HRSAIDAINTERVALO = currentRow.HRSAIDA;
        currentRow.HRENTRADAINTERVALO = widget.currentRow.HRENTRADA;
        var hrSaidaIntervalo = AFormataHoraDecimal.getHoraFloatDeString(currentRow.HRSAIDAINTERVALO);
        var hrEntradaIntervalo = AFormataHoraDecimal.getHoraFloatDeString(currentRow.HRENTRADAINTERVALO);
        if(hrSaidaIntervalo>hrEntradaIntervalo){
            intervalo =  hrSaidaIntervalo - hrEntradaIntervalo;
        } else {
            intervalo =  hrEntradaIntervalo - hrSaidaIntervalo;
        }
        currentRow.HRPROJETARINTERVALO = AFormataHoraDecimal.getHoraStringDeFloat(intervalo, true);
    };
    
    this.calculaSaidaPrimIntervalo = function(rowInterv1, rowInterv2){
        rowInterv1.HRSAIDAINTERVALO = rowInterv1.HRSAIDA;
        rowInterv1.HRENTRADAINTERVALO = rowInterv2.HRENTRADA;
        var hrSaidaIntervalo = AFormataHoraDecimal.getHoraFloatDeString(rowInterv1.HRSAIDAINTERVALO);
        var hrEntradaIntervalo = AFormataHoraDecimal.getHoraFloatDeString(rowInterv1.HRENTRADAINTERVALO);
        if(hrSaidaIntervalo>hrEntradaIntervalo){
            intervalo =  hrSaidaIntervalo - hrEntradaIntervalo;
        } else {
            intervalo =  hrEntradaIntervalo - hrSaidaIntervalo;
        }
        rowInterv1.HRPROJETARINTERVALO = AFormataHoraDecimal.getHoraStringDeFloat(intervalo, true);
    };

    this.comparaDatas = function(data1, data2, tipoComparacao) {
        if(Util.isEmptyOrBlank(tipoComparacao)){
            tipoComparacao = ANTES;
        }
        if (tipoComparacao === ANTES) {
            return this.getIntervaloEmSegundos(data1, data2) > 0;
        } else if (tipoComparacao == DEPOIS) {
            return this.getIntervaloEmSegundos(data1, data2) < 0;
        } else {
            return this.getIntervaloEmSegundos(data1, data2) === 0;
        }
    };

    this.deleteHorario = function(args) {
        ScreenService.confirmMessage(Messages.DELETE_ROW, 'CONFIRMATION', function () {
            var widget = ABUtilController.checkWidget(args);
            var data = {};
            widget.dataSource.checkedRows = widget.currentRow;
            widget.removeCheckedRows();
            widget.reload();
            ABUtilController.masterDetailVoltarList(widget);
            ScreenService.showMessage(Messages.REMOVE_ROW_SUCCESS);
        }, null);
    };

    this.deleteIntervalo = function(args) {
        var widget = ABUtilController.checkWidget(args);
        var data = {};
        ScreenService.confirmMessage(Messages.DELETE_ROW, 'CONFIRMATION', 
            function() {
               if(widget.dataSource.data.length != '1'){ 
                    if(widget.currentRow.NRSEQINTERVHORARIO > 0 && Util.isEmptyOrBlank(widget.currentRow.HRPROJETARINTERVALO)){
                        var dados;
                        widget.dataSource.data.forEach(function(value){
                            if(value.NRSEQINTERVHORARIO === widget.currentRow.NRSEQINTERVHORARIO -1){
                                dados = value;
                            }
                        });
                        if (!Util.isUndefined(dados)) {
                            restEngine.post('product#/removeSaidaHorario', {'requestType': 'DataSet', 'dataset': [dados]}).
                            then(function (data){
                                widget.dataSource.checkedRows = widget.currentRow;
                                widget.removeCheckedRows();
                                widget.reload();
                                ABUtilController.masterDetailVoltarList(widget);
                            });
                        } else {
                            widget.dataSource.checkedRows = widget.currentRow;
                            widget.removeCheckedRows();
                            widget.reload();
                            ABUtilController.masterDetailVoltarList(widget);
                        }
                    } else if(widget.currentRow.NRSEQINTERVHORARIO > 0 && widget.currentRow.HRPROJETARINTERVALO){
                        restEngine.post('product#/removeSaidaHorario', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                        then(function (data){
                            widget.dataSource.checkedRows = widget.currentRow;
                            widget.removeCheckedRows();
                            widget.reload();
                            ABUtilController.masterDetailVoltarList(widget);
                        });
                    }
               } else {
                    widget.dataSource.checkedRows = widget.currentRow;
                    widget.removeCheckedRows();
                    widget.reload();
                    ABUtilController.masterDetailVoltarList(widget);
               }
            }
        );
    };

    this.getDataDeString = function(data, truncate) {
        if(Util.isEmptyOrBlank(truncate)){
            truncate = false;
        }
        data = moment(data, 'DD/MM/YYYY, h:mm:ss a');
        if (truncate) {
            data = this.truncateData(data);
        }

        return data._i;
    };

    this.getIntervaloEmSegundos = function(dataInicial, dataFinal) {
        dataInicial = moment(dataInicial, 'DD/MM/YYYY, h:mm:ss a');
        dataFinal = moment(dataFinal, 'DD/MM/YYYY, h:mm:ss a');
        intervalo = moment.duration(dataFinal.diff(dataInicial));

        intervaloDias     = parseInt(intervalo._data.days);
        intervaloHoras    = parseInt(intervalo._data.hours);
        intervaloMinutos  = parseInt(intervalo._data.minutes);
        intervaloSegundos = parseInt(intervalo._data.seconds);

        intervaloHoras    = intervaloHoras    + intervaloDias    * 24;
        intervaloMinutos  = intervaloMinutos  + intervaloHoras   * 60;
        return intervaloSegundos + intervaloMinutos * 60;
    };

    this.openAdicionarHorario = function(args) {
        var widget = args.owner.widget;
        widget.currentRow = {};
        widget.backupRow = undefined;
        if(widget.widgets.length > 0 && widget.widgets[0]) widget.widgets[0].isVisible = false;
        if(widget.widgets.length > 0 && widget.widgets[1]) widget.widgets[1].isVisible = false;
        widget.newRow();
        widget.currentRow.DTMESCOMPETENC = getLocalVar("HCM_DTCOMPETENCIA_OPER");
    };

    this.openAdicionarIntervalo = function(args) {
        var widget = args.owner.widget;
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
    };

    this.retornaDataDiaOcorrencia = function(horario, data, diaOcorrencia){
        horario = AFormataHoraDecimal.getHoraFloatDeString(horario);
        horario = AFormataHoraDecimal.getHoraStringDeFloat(horario, true);
        if(diaOcorrencia == DIA_SEGUINTE || diaOcorrencia == FORCA_DIA_SEGUINTE){
            data = moment('26/08/2016', 'DD/MM/YYYY')._d.addDays(1);
            data = moment(data, 'DD/MM/YYYY');
            data = data._i+' '+ horario;
            data = this.getDataDeString(data);
        }
        else if(diaOcorrencia == DIA_ANTERIOR || diaOcorrencia == FORCA_DIA_ANTERIOR) {
            data = moment('26/08/2016', 'DD/MM/YYYY')._d.addDays(-1);
            data = moment(data, 'DD/MM/YYYY');
            data = data._i+' ' + horario;
            data = this.getDataDeString(data);
        }
        else {
            data = moment(data, 'DD/MM/YYYY');
            data = data._i+' '+ horario;
            data = this.getDataDeString(data);
        }

        return data;
    };

    this.saveHorario = function(args){
        var widget = templateManager.container.getActiveWidget();
        widget.currentRow.HRINICOLETAMARCACAO = widget.currentRow.HRINICOLETAMARCACAO.replace(/[\:-]/g, '');
        widget.currentRow.IDVERIFICAVIGENCIAESO = 'S';
        widget.currentRow.NMEVENTO = 'S-1050';
        widget.currentRow.NRCHAVE = widget.currentRow.NRHORDIAM;
        if (widget.isValid()) {
            ABUtilController.saveMasterDetailMasterHistory(widget);
        }
    };

    this.saveIntervalo = function(args, validateIntervalos = true){
        var widget = ABUtilController.checkWidget(args);

        var widgetHorario = templateManager.container.getWidget("horario");
        try{
            if(widget.isValid()){
                //HORA ENTRADA
                this.validateHorasEntradaSaida(args, 'S', true);
                this.validateHoras(widget.currentRow.HRENTRADA, widget.currentRow.HRTOLERAANTEENTRADA, 'Entrada', 'Tolerância Anterior(Entrada)', 'S');
                this.validateHoras(widget.currentRow.HRENTRADA, widget.currentRow.HRTOLERAPOSTENTRADA, 'Entrada', 'Tolerância Posterior(Entrada)', 'S', true);
                
                //HORA TOLERANCIA ANTERIOR ENTRADA
                this.validateHoras(widget.currentRow.HRTOLERAANTEENTRADA, widget.currentRow.HRENTRADA, 'Tolerância Anterior(Entrada)', 'Entrada', 'S', true);
                this.validateHoras(widget.currentRow.HRTOLERAANTEENTRADA, widget.currentRow.HRTOLERAPOSTENTRADA, 'Tolerância Anterior(Entrada)', 'Tolerância Posterior(Entrada)', 'S', true);

                //HORA TOLERANCIA POSTERIOR ENTRADA
                this.validateHoras(widget.currentRow.HRTOLERAPOSTENTRADA, widget.currentRow.HRENTRADA, 'Tolerância Posterior(Entrada)', 'Entrada', 'S');
                this.validateHoras(widget.currentRow.HRTOLERAPOSTENTRADA, widget.currentRow.HRTOLERAANTEENTRADA, 'Tolerância Posterior(Entrada)', 'Tolerância Anterior(Entrada)', 'S');

                //HORA SAIDA
                this.validateHoras(widget.currentRow.HRSAIDA, widget.currentRow.HRTOLERAANTESAIDA, 'Saída', 'Tolerância Anterior(Saída)', 'S');
                this.validateHoras(widget.currentRow.HRSAIDA, widget.currentRow.HRTOLERAPOSTSAIDA, 'Saída', 'Tolerância Posterior(Saída)', 'S', true);

                //HORA TOLERANCIA ANTERIOR SAIDA
                this.validateHoras(widget.currentRow.HRTOLERAANTESAIDA, widget.currentRow.HRSAIDA, 'Tolerância Anterior(Saída)', 'Saída', 'S', true);
                this.validateHoras(widget.currentRow.HRTOLERAANTESAIDA, widget.currentRow.HRTOLERAPOSTSAIDA, 'Tolerância Anterior(Saída)', 'Tolerância Posterior(Saída)', 'S', true);

                //HORA TOLERANCIA POSTERIOR SAIDA
                this.validateHoras(widget.currentRow.HRTOLERAPOSTSAIDA, widget.currentRow.HRSAIDA, 'Tolerância Posterior(Saída)', 'Saída', 'S');
                this.validateHoras(widget.currentRow.HRTOLERAPOSTSAIDA, widget.currentRow.HRTOLERAANTESAIDA, 'Tolerância Posterior(Saída)', 'Tolerância Anterior(Saída)', 'S');

                //HORA INICIO E FIM NUCLEO
                // if(!Util.isEmptyOrBlank(widget.currentRow.HRINICIONUCLEO) && !Util.isEmptyOrBlank(widget.currentRow.HRFIMNUCLEO))
                //     this.validateNucleo(args);
                
                // Validações considerando horários já cadastradas. Caso sejam encontradas divergências entre os intervalos cadastrados e o a ser incluído, um aviso de confirmação é exibido
                const isIntervaloValid = validateIntervalos ? this.checkNewHorarioIntervalos(widget, validateIntervalos) : true;
                if (!isIntervaloValid) {
                    ScreenService.showCustomDialog('Atenção!<br><br>Foi encontrada uma divergência entre o horário a ser incluído e os demais cadastrados ou dentro do horário a ser incluído, com relação aos campos "Dia de Ocorrência".<br><br>Deseja prosseguir com a operação?', 'CONFIRMATION', null, [
                        {
                            label: ScreenService.i18n("Sim"),
                            code: () => {
                                // Chama a rotina novamente porém sem realizar a validação dos intervalos
                                self.saveIntervalo(args, false);
                            }
                        },
                        {
                            label: ScreenService.i18n("Não"),
                            code: () => {}
                        }
                    ]);
                    return;
                }

                if (!widget.backupRow) {
                    widget.currentRow.__is_new = true;
                    if(!Util.isEmptyOrBlank(widget.dataSource.data[0])){
                        widget.currentRow.MAXNRSEQINTERVHORARIO = widget.dataSource.data[0].MAXNRSEQINTERVHORARIO;
                        if(widget.currentRow.MAXNRSEQINTERVHORARIO > 1){
                            this.setSaida(args);
                        }
                    } else {
                        widget.currentRow.MAXNRSEQINTERVHORARIO = 1;
                    }
                } else {
                    widget.currentRow.__is_new = false;
                    if(widget.currentRow.MAXNRSEQINTERVHORARIO > 1){
                        this.setSaida(args);
                    }
                }
                var saveData = Object.assign({}, widget.currentRow, {"NRORGTRAB": getLocalVar("HCM_NRORG_TRAB")}, {"CDOPERADOR_LOG": getLocalVar("HCM_CDOPERADOR")}, {"DTATUAL": getLocalVar("HCM_DATA_ATUAL")}, {"NRHORDIAM": widgetHorario.currentRow.NRHORDIAM});
                restEngine.post('product#/setIntervaloHorario', {'requestType': 'DataSet', 'dataset': [saveData]}).
                    then(function (data) {
                        if (data.notifications[0].type === "success") {
                            ScreenService.showMessage(Messages.SAVE_ROW_SUCCESS);
                            if (widget.currentRow.__is_new) {
                                ABUtilController.masterDetailVoltarList(widget);
                                widget.reload();
                            } else {
                                ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                                widget.backupRow = null;
                                widget.view();
                            }
                        } else {
                            ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                        }
                    }
                ).
                catch(function(e) {
                    var error;
                    if(e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;

                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
            }
        } catch (e){
            ScreenService.showMessage(e);
        }   
    };

    this.saveSaida = function(args){
        var widget = ABUtilController.checkWidget(args);
        if(widget.isValid()){
            widget.currentRow.__is_new = false;
            var saveData = Object.assign({}, widget.currentRow, {"NRORGTRAB": getLocalVar("HCM_NRORG_TRAB")}, {"CDOPERADOR_LOG": getLocalVar("HCM_CDOPERADOR")}, {"DTATUAL": getLocalVar("HCM_DATA_ATUAL")});
            restEngine.post('product#/setSaidaHorario', {'requestType': 'DataSet', 'dataset': [saveData]}).
                then(function (data) {
                    if (data.notifications[0].type === "success") {
                        ScreenService.showMessage(Messages.SAVE_ROW_SUCCESS);
                        ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                        widget.backupRow = null;
                        widget.view();
                    } else {
                        ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                    }
                }
            ).
            catch(function(e) {
                var error;
                if(e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;

                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
        }
    };

    this.setMinDate = function(args){
        var widget = ABUtilController.checkWidget(args);
        widget.getField('DTFIMVIGENCIA').minDate = widget.currentRow.DTINIVIGENCIA;
        widget.currentRow.DTFIMVIGENCIA = null;
    };

    this.setNrhordiam = function(args) {
        var widget;
        if (Util.isUndefined(args.owner.widget)) {
            widget = args.owner;
        } else {
            widget = args.owner.widget;
        }
        if(widget.widgets.length > 0 && widget.widgets[0]) widget.widgets[0].dataSourceFilter[1].value = widget.currentRow.NRHORDIAM;
        if(widget.widgets.length > 0 && widget.widgets[1]) widget.widgets[1].dataSourceFilter[1].value = widget.currentRow.NRHORDIAM;
    };

    this.setSaida = function(args){
        var widget = ABUtilController.checkWidget(args);
        var saidaIntervalo;
        var saveData;
        var dados;
        var dados2;
        if(widget.currentRow.__is_new) {
            widget.dataSource.data.forEach(function(value){
                if(value.NRSEQINTERVHORARIO ===  widget.currentRow.NRSEQINTERVHORARIO -1){
                    dados = value;
                }
            });
            if (!Util.isUndefined(dados)) {
                dados.__is_new = false;
                this.calculaSaida(dados, args);
                saveData = Object.assign({}, dados, {"NRORGTRAB": getLocalVar("HCM_NRORG_TRAB")}, {"CDOPERADOR_LOG": getLocalVar("HCM_CDOPERADOR")}, {"DTATUAL": getLocalVar("HCM_DATA_ATUAL")});
                restEngine.post('product#/setSaidaHorario', {'requestType': 'DataSet', 'dataset': [saveData]});
            }
        } else {
            if (widget.currentRow.NRSEQINTERVHORARIO === 1 && widget.currentRow.MAXNRSEQINTERVHORARIO > 1) {
                /*Se estiver editando o primeiro intervalo do horario*/
                if(widget.dataSource.data.length > 1){    
                    widget.dataSource.data.forEach(function(value){
                        if(value.NRSEQINTERVHORARIO === 1){
                            dados = value;
                        }
                        if(value.NRSEQINTERVHORARIO === widget.currentRow.NRSEQINTERVHORARIO + 1) {
                            dados2 = value;
                        }
                    });
                    this.calculaSaidaPrimIntervalo(dados, dados2);
                    saveData = Object.assign({}, dados, {"NRORGTRAB": getLocalVar("HCM_NRORG_TRAB")}, {"CDOPERADOR_LOG": getLocalVar("HCM_CDOPERADOR")}, {"DTATUAL": getLocalVar("HCM_DATA_ATUAL")});
                    restEngine.post('product#/setSaidaHorario', {'requestType': 'DataSet', 'dataset': [saveData]});
                }
            } else {
                widget.dataSource.data.forEach(function(value){
                    if(widget.currentRow.NRSEQINTERVHORARIO > 1){
                        if(value.NRSEQINTERVHORARIO === widget.currentRow.NRSEQINTERVHORARIO -1){
                            dados = value;
                        }
                    }
                });
                if (!Util.isUndefined(dados)) {
                    if(!dados.NRSEQINTERVHORARIO)
                        dados = widget.dataSource.data[1];
                    dados.__is_new = false;
                    this.calculaSaida(dados, args);
                    saveData = Object.assign({}, dados, {"NRORGTRAB": getLocalVar("HCM_NRORG_TRAB")}, {"CDOPERADOR_LOG": getLocalVar("HCM_CDOPERADOR")}, {"DTATUAL": getLocalVar("HCM_DATA_ATUAL")});
                    restEngine.post('product#/setSaidaHorario', {'requestType': 'DataSet', 'dataset': [saveData]});
                }
            }
        }
    };

    this.setTime = function(args){
        var widget = ABUtilController.checkWidget(args);
        if(!Util.isEmptyOrBlank(widget.currentRow.HRENTRADA) && !Util.isEmptyOrBlank(widget.currentRow.HRSAIDA)){
            widget.getField("HRINICIONUCLEO").readOnly = false;
            widget.getField("HRFIMNUCLEO").readOnly = false;
            widget.getField("HRINICIONUCLEO")['datetime-minDate'] = getLocalVar("HCM_DATA_ATUAL") + ' ' + args.row.HRENTRADA; 
            widget.getField("HRINICIONUCLEO")['datetime-maxDate'] = getLocalVar("HCM_DATA_ATUAL") + ' ' + args.row.HRSAIDA;
            widget.getField("HRFIMNUCLEO")['datetime-minDate']    = getLocalVar("HCM_DATA_ATUAL") + ' ' + args.row.HRENTRADA;
            widget.getField("HRFIMNUCLEO")['datetime-maxDate']    = getLocalVar("HCM_DATA_ATUAL") + ' ' + args.row.HRSAIDA;
            templateManager.updateTemplate(widget);
        }
    };

    this.truncateData = function(data) {
        strData = data.format('DD/MM/YYYY');
        strData += " 00:00:00";
        return moment(strData, 'DD/MM/YYYY, h:mm:ss a');
    };

    this.validateHoras = function(campo, campo2, label, label2, save, antes, message){
        if(Util.isEmptyOrBlank(antes)){
            antes = false;
        }
        if(Util.isEmptyOrBlank(save)){
            save = 'N';
        }
        try {
            if(!Util.isEmptyOrBlank(campo) && !Util.isEmptyOrBlank(campo2)){
                valor = AFormataHoraDecimal.getHoraFloatDeString(campo);
                valor2 = AFormataHoraDecimal.getHoraFloatDeString(campo2);
                if((!Util.isEmptyOrBlank(valor) && valor !== '') && (!Util.isEmptyOrBlank(valor2) && valor2 !== '')){
                    if(antes && (valor > valor2) && save == 'N'){
                        HRINVALIDA = true;
                        throw 'O campo '+ label +' deve ser anterior ao campo '+ label2;
                    }
                    else if(antes && (valor > valor2) && save === 'S'){
                        HRINVALIDA = true;
                        throw 'O campo '+ label +' deve ser anterior ao campo '+ label2;
                    }
                    else if((antes === false) && (valor < valor2) && save === 'N'){
                        HRINVALIDA = true;
                        throw 'O campo '+ label +' deve ser posterior ao campo '+ label2;
                    }
                    else if((antes === false) && (valor < valor2) && save === 'S'){
                        HRINVALIDA = true;
                        throw 'O campo '+ label +' deve ser posterior ao campo '+ label2;
                    }
                }
            }
        } catch(e){
            if(!Util.isEmptyOrBlank(message) && message){
                ScreenService.alertNotification(e, 10000);
            } else {
                throw e;
            }
        }
    };
    
    this.preparaEntradaSaida = function(args){
        var widget = args.owner;
        widget.dataSourceFilter.forEach(function(filtro){
            if(filtro.name === 'HRENTRADA' || filtro.name === 'HRENTRADAINTERVALO' /*|| filtro.name === 'PRIENTRADA' || filtro.name === 'SEGENTRADA'*/){
                filtro.value = AFormataHoraDecimal.getHoraStringDeFloat(filtro.value.substr(1, 5)); 
            }
            if(filtro.name === 'HRSAIDA' || filtro.name === 'HRSAIDAINTERVALO' /*|| filtro.name === 'PRISAIDA' || filtro.name === 'SEGSAIDA'*/){
                filtro.value = AFormataHoraDecimal.getHoraStringDeFloat(filtro.value.substr(1, 5)); 
            }
        });
    };
    
    this.validateHorasEntradaSaida = function(args, save, antes, message) {
        var widget = ABUtilController.checkWidget(args);
        try{
            var hrSaida = widget.currentRow.HRSAIDA;
            var hrEntrada = widget.currentRow.HRENTRADA;
            var idDiaOcorSaida = widget.currentRow.IDDIAOCORRESAIDA;
            var idDiaOcorEntrada = widget.currentRow.IDDIAOCORREENTRADA;

            hrEntrada = AFormataHoraDecimal.getHoraFloatDeString(hrEntrada);
            hrSaida = AFormataHoraDecimal.getHoraFloatDeString(hrSaida);
            if(Util.isEmptyOrBlank(save)){
                save = 'N';
            }

            if(Util.isEmptyOrBlank(antes)){
                save = false;
            }

            if ((idDiaOcorEntrada === DIA_CORRENTE && (idDiaOcorSaida === DIA_SEGUINTE || idDiaOcorSaida === FORCA_DIA_SEGUINTE)) ||
                (idDiaOcorEntrada === DIA_ANTERIOR && (idDiaOcorSaida === DIA_SEGUINTE || idDiaOcorSaida === FORCA_DIA_SEGUINTE || idDiaOcorSaida === DIA_CORRENTE || idDiaOcorSaida === FORCA_DIA_CORRENTE)) ||
                (idDiaOcorEntrada === FORCA_DIA_CORRENTE && (idDiaOcorSaida === DIA_SEGUINTE || idDiaOcorSaida === FORCA_DIA_SEGUINTE)) ||
                (idDiaOcorEntrada === FORCA_DIA_ANTERIOR && (idDiaOcorSaida === DIA_SEGUINTE || idDiaOcorSaida === FORCA_DIA_SEGUINTE || idDiaOcorSaida === DIA_CORRENTE || idDiaOcorSaida === FORCA_DIA_CORRENTE))
            ) {
                if (save === 'S') {
                    //throw 'A hora de Saída deve ser posterior a de Entrada';
                } else {
                    //throw 'A hora de Saída deve ser posterior a de Entrada';
                }
            }

            if ((!Util.isEmptyOrBlank(hrEntrada) && hrEntrada !== '') && (!Util.isEmptyOrBlank(hrSaida) && hrSaida !== '')) {
                if (antes && hrEntrada > hrSaida &&
                    (((idDiaOcorEntrada === DIA_CORRENTE || idDiaOcorEntrada === FORCA_DIA_CORRENTE) && (idDiaOcorSaida === DIA_CORRENTE || idDiaOcorSaida === FORCA_DIA_CORRENTE)) ||
                        ((idDiaOcorEntrada === DIA_ANTERIOR || idDiaOcorEntrada === FORCA_DIA_ANTERIOR) && (idDiaOcorSaida === DIA_ANTERIOR || idDiaOcorSaida === FORCA_DIA_ANTERIOR)) ||
                        ((idDiaOcorEntrada === DIA_SEGUINTE || idDiaOcorEntrada === FORCA_DIA_SEGUINTE) && (idDiaOcorSaida === DIA_SEGUINTE || idDiaOcorSaida === FORCA_DIA_SEGUINTE))
                    ) && save === 'N') {
                    HRINVALIDA = true;
                    throw 'O campo de entrada deve ser anterior ao campo de saída';
                }
                else if(antes && (hrEntrada > hrSaida) &&
                    (((idDiaOcorEntrada === DIA_CORRENTE || idDiaOcorEntrada === FORCA_DIA_CORRENTE) && (idDiaOcorSaida === DIA_CORRENTE || idDiaOcorSaida === FORCA_DIA_CORRENTE)) ||
                        ((idDiaOcorEntrada === DIA_ANTERIOR || idDiaOcorEntrada === FORCA_DIA_ANTERIOR) && (idDiaOcorSaida === DIA_ANTERIOR || idDiaOcorSaida === FORCA_DIA_ANTERIOR)) ||
                        ((idDiaOcorEntrada === DIA_SEGUINTE || idDiaOcorEntrada === FORCA_DIA_SEGUINTE) && (idDiaOcorSaida === DIA_SEGUINTE || idDiaOcorSaida === FORCA_DIA_SEGUINTE))
                    ) && save === 'S') {
                    HRINVALIDA = true;
                    throw 'O campo de entrada deve ser anterior ao campo de saída';
                }
                else if((antes === false) && (hrSaida < hrEntrada) &&
                    (((idDiaOcorEntrada === DIA_CORRENTE || idDiaOcorEntrada === FORCA_DIA_CORRENTE) && (idDiaOcorSaida === DIA_CORRENTE || idDiaOcorSaida === FORCA_DIA_CORRENTE)) ||
                        ((idDiaOcorEntrada === DIA_ANTERIOR || idDiaOcorEntrada === FORCA_DIA_ANTERIOR) && (idDiaOcorSaida === DIA_ANTERIOR || idDiaOcorSaida === FORCA_DIA_ANTERIOR)) ||
                        ((idDiaOcorEntrada === DIA_SEGUINTE || idDiaOcorEntrada === FORCA_DIA_SEGUINTE) && (idDiaOcorSaida === DIA_SEGUINTE || idDiaOcorSaida === FORCA_DIA_SEGUINTE))
                    ) && save === 'N') {
                    HRINVALIDA = true;
                    throw 'O campo de saida deve ser posterior ao campo de entrada';
                }
            }
        } catch(e){
            if(!Util.isEmptyOrBlank(message) && message){
                ScreenService.alertNotification(e, 10000);
            } else {
                throw e;
            }
        }
    };

    /*this.validateNucleo = function(args){
        var intervValido = true;
        var widget = args.owner.widget;

        var dataAtual = getLocalVar("HCM_DATA_ATUAL");
        var hrSaida   = AFormataHoraDecimal.getHoraFloatDeString(widget.currentRow.HRSAIDA);
        var hrEntrada = AFormataHoraDecimal.getHoraFloatDeString(widget.currentRow.HRENTRADA);
        var idDiaOcorSaida   = widget.currentRow.IDDIAOCORRESAIDA;
        var idDiaOcorEntrada = widget.currentRow.IDDIAOCORREENTRADA;
        var dtHrEntrada = this.retornaDataDiaOcorrencia(widget.currentRow.HRENTRADA,dataAtual,idDiaOcorEntrada);
        var dtHrSaida   = this.retornaDataDiaOcorrencia(widget.currentRow.HRSAIDA,dataAtual,idDiaOcorSaida);

        var hrIniNucleo = AFormataHoraDecimal.getHoraFloatDeString(widget.currentRow.HRINICIONUCLEO);
        var hrFimNucleo = AFormataHoraDecimal.getHoraFloatDeString(widget.currentRow.HRFIMNUCLEO);

        var dtHrIniNucleo = this.retornaDataDiaOcorrencia(AFormataHoraDecimal.getHoraStringDeFloat(hrIniNucleo),
            dataAtual, idDiaOcorEntrada);
        var dtHrFimNucleo = this.retornaDataDiaOcorrencia(AFormataHoraDecimal.getHoraStringDeFloat(hrFimNucleo),
            dataAtual, idDiaOcorSaida);
        try {
            if(hrIniNucleo < hrEntrada){
                if(idDiaOcorEntrada == DIA_SEGUINTE || idDiaOcorEntrada == FORCA_DIA_SEGUINTE ||
                    idDiaOcorEntrada == DIA_CORRENTE || idDiaOcorEntrada == FORCA_DIA_CORRENTE){
                    diaOcorrencia = DIA_ANTERIOR;
                }else{
                    diaOcorrencia = idDiaOcorEntrada;
                }
                dtHrIniNucleo = this.retornaDataDiaOcorrencia(AFormataHoraDecimal.getHoraStringDeFloat(hrIniNucleo),
                    dataAtual, diaOcorrencia);

                if(this.comparaDatas(dtHrIniNucleo, dtHrSaida, DEPOIS)){
                    intervValido = false;
                }
            }

            if(hrFimNucleo > hrSaida){
                if(idDiaOcorSaida == DIA_ANTERIOR || idDiaOcorSaida == FORCA_DIA_ANTERIOR ||
                    idDiaOcorSaida == DIA_CORRENTE || idDiaOcorSaida == FORCA_DIA_CORRENTE){
                    diaOcorrencia = DIA_SEGUINTE;
                }else{
                    diaOcorrencia = idDiaOcorEntrada;
                }
                dtHrFimNucleo = this.retornaDataDiaOcorrencia(AFormataHoraDecimal.getHoraStringDeFloat(hrFimNucleo),
                    dataAtual, diaOcorrencia);

                if(this.comparaDatas(dtHrFimNucleo, dtHrEntrada, ANTES)){
                    intervValido = false;
                }
            }

            if(intervValido){
                if(this.comparaDatas(dtHrIniNucleo, dtHrFimNucleo, DEPOIS)){
                    intervValido = false;
                }
            }

            if(!intervValido){
                throw 'Intervalo inválido para o núcleo';
            }
        } catch (e){
            return e;
        }
    };*/
    this.setSerialWidget = function(args){
        var widget = ABUtilController.checkWidget(args);
        if(!Util.isEmptyOrBlank(widget.dataSource.data[0].MAXNRSEQINTERVHORARIO)){
            widget.currentRow.NRSEQINTERVHORARIO = widget.dataSource.data[0].MAXNRSEQINTERVHORARIO;
        } else {
            widget.currentRow.NRSEQINTERVHORARIO = 1;
        }
    };
    
    this.validateFormatHora = function (args, campo){
        var widget = ABUtilController.checkWidget(args);
        var hora = widget.currentRow[campo];    
            if(hora.split(":")[0]>=24 || hora.split(":")[1]>=60 ){
                ScreenService.showMessage("Formato de Hora inválido!");
                widget.currentRow[campo] = "";
            }else if(HRINVALIDA){
                //widget.currentRow[campo] = "";
                HRINVALIDA = false;
            }
    };
    
    this.horaFiltro = function (args){
        var widget = templateManager.container.getActiveWidget();
        if(widget.currentRow.HRINICOLETAMARCACAO){
            widget.currentRow.HRINICOLETAMARCACAO = widget.currentRow.HRINICOLETAMARCACAO.replace(":","");
        }
    };
    
    this.applyDefaultFilterValues = function() {
        var widget = templateManager.container.getActiveWidget();
        widget.getField('DTMESCOMPETENC').defaultValue = getLocalVar('HCM_DTCOMPETENCIA');
    };
    
    /**
     *  Rotina responsável por validar se o horário a ser inserido é válido, considerando as informações de IDDIAOCORRENCIA.
     * 
     *  Esquema de funcionamento:
     *      Se [SAIDA ULTIMO INTERVALO JÁ CADASTRADO] existir e for [DA, FA] [ENTRADA INTERVALO ATUAL] só pode ser [DA, FA]
     *      Se [ENTRADA INTERVALO ATUAL] for [DC, FC] [SAIDA ULTIMO INTERVALO CADASTRADO] só pode ser [FC, DC], se existir
     * 
     *      Se [SAIDA INTERVALO ATUAL] for [DA, FA] [ENTRADA INTERVALO ATUAL] só pode ser [DA, FA]
     *      Se [ENTRADA INTERVALO ATUAL] for [DC, FC] [SAIDA INTERVALO ATUAL] só pode ser [FC, DC]
     * 
     *  @param  widget  [Widget]
     * 
     */
    this.checkNewHorarioIntervalos = function (widget) {
        
        const widgetData = widget.dataSource.data.slice(0, -1);
        const currentData = widget.currentRow;
        
        // Ordena widget data pra buscar o último horário cadastrado
        widgetData.sort((item1, item2) => {
            const valueSum = {DA: 2400, FA: 2400, DS: -2400, FS: -2400, DC: 0, FC: 0};
            return (item1.ENTRADA ? item1.ENTRADA  + (valueSum[item1.IDDIAOCORREENTRADA] ? valueSum[item1.IDDIAOCORREENTRADA] : 0) : 0) - (item2.ENTRADA ? item2.ENTRADA  + (valueSum[item2.IDDIAOCORREENTRADA] ? valueSum[item2.IDDIAOCORREENTRADA] : 0) : 0);
        });
        
        const invalidSaidaFA = ['DA', 'FA'].includes(currentData.IDDIAOCORREENTRADA) && !(['DA', 'FA'].includes(currentData.IDDIAOCORRESAIDA));
        const invalidSaidaFS = !(['DS', 'FS'].includes(currentData.IDDIAOCORREENTRADA)) && ['DS', 'FS'].includes(currentData.IDDIAOCORRESAIDA);
        
        if (invalidSaidaFA || invalidSaidaFS) {
            return false;
        }
        
        const lastOrderedIntervalo = widgetData.slice(-1).pop();
        if (!lastOrderedIntervalo) {
            return true;
        }
        
        const invalidEntradaFA = ['DA', 'FA'].includes(lastOrderedIntervalo.IDDIAOCORRESAIDA) && !(['DA', 'FA'].includes(currentData.IDDIAOCORREENTRADA));
        const invalidEntradaFS = !(['DS', 'FS'].includes(lastOrderedIntervalo.IDDIAOCORRESAIDA)) && ['DS', 'FS'].includes(currentData.IDDIAOCORREENTRADA);
        
        
        if (invalidEntradaFA || invalidEntradaFS) {
            return false;
        }
        
        return true;
    };

}

Configuration(function(ContextRegister) {
    ContextRegister.register('HorarioController', HorarioController);
});

// FILE: assets/js/controllers/ImportacaoRemessaCcBbController.js
function ImportacaoRemessaCcBbController (ScreenService, templateManager, ABUtilController, localStorageEngine, ZhUtil, restEngine, Messages, RelatoriosHcmConfig) {
/**
 * Importa a remessa de retorno de contas correntes do banco do Brasil.
 */
    this.importar = function(widget) {
        if (widget.isValid()) {
            if (this.validaArquivo(widget.currentRow.DSPATH[0].name)) {
                restEngine.post('product#/ImportacaoRemessaCcBb', {
                    'requestType': 'DataSet',
                    'dataset': [widget.currentRow]
                }).
                then(function(data) {
                    if(data.messages){
                        ScreenService.showMessage(data.messages[0].message, data.messages[0].type);
                    }
                    if (data.notifications[0].type === "success") {
                        ScreenService.successNotification(Messages.IMPORTACAO_SUCCESS, 10000);
                        ScreenService.closePopup(true);
                        if(data.dataset.getMessage != ''){
                            var popUp = templateManager.container.getWidget('mensagens');
                            popUp.dataSource.data = data.dataset.getMessage[0];
                            ABUtilController.masterDetailOpenPopup(popUp);
                        }
                        widget.reload();
                    } else {
                        ScreenService.showMessage(Messages.IMPORTACAO_ERROR);
                    }
                    
                }).
                catch(function(e) {
                    var error;
                    if (e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;

                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
            }
        }
    };
    
    this.validaArquivo = function(filePath) {
        var extension = filePath.split('.').pop().toUpperCase();
        if (extension !== 'TXT') {
            ScreenService.showMessage('Formato de arquivo inválido');
            return false;
        } else {
            return true;
        }
    };
    
}

Configuration(function(ContextRegister) {
    ContextRegister.register('ImportacaoRemessaCcBbController', ImportacaoRemessaCcBbController);
});

// FILE: assets/js/controllers/ImportacaoXmlEsocialController.js
/*jshint esversion: 6*/
function ImportacaoXmlEsocialController (ScreenService, metaDataFactory, templateManager, localStorageEngine, ZhUtil, restEngine,Messages, $window, ABUtilController,HcmConsts, General) {
    
    var self = this;
    var parentWidget;
    var popupWidget;
    
/* ------------------- FUNÇÕES PARA INSERIR UMA WIDGET NO JSON ------------------- */    
    /* Funções de abertura de widgets que não se encontram em
     * templateManager.containers
    */
    this.getFactoredWidget = function(container, nmContainerCadastro, nmWidCadastro, pushInContainer){
        return this.getWidgetMetadata(nmContainerCadastro).then(function(containerPopup){
                var widget = containerPopup.widgets[ABUtilController.retornaWidget(containerPopup, nmWidCadastro)];
                widget.container = container;
				var factoredWidget = metaDataFactory.widgetFactory(widget, container);
				if(pushInContainer){
					container.widgets.push(factoredWidget);
				}
				return factoredWidget;
			});  
    };
    
    this.getWidgetMetadata = function(nmWidCadastro){
        return restEngine.requestMetaData(nmWidCadastro).then(function(metadata){
			return metadata.data;
		});
    };
    
/* ------------------- FUNÇÕES DE TRANSÇÃO (POPUP <-> TELA) ------------------- */
    
    /*Salva a widget principal*/
    this.getWidgetRetorno = function(nameWidget){
         var widget = templateManager.container.getWidget(nameWidget);
         parentWidget = widget;
    };
    
    /* nmWidCadastro = popup de cadastro
     * nmContainerCadastro = widget que está sendo utilizada (product#json/containers/hcm09010_eso_importacaoXmlEsocial.json)
    */
    this.openCadastro = function(args, nmWidCadastro, nmContainerCadastro){
        var widget = ABUtilController.checkWidget(args);
        parentWidget = widget;
        this.getFactoredWidget(widget.container, nmContainerCadastro, nmWidCadastro, true).then(function(widgetCadastro) {
            this.validaCamposPopup(widgetCadastro);
            ABUtilController.masterDetailOpenPopup(widgetCadastro);
            widgetCadastro.parent = parentWidget;
            // widgetCadastro.currentRow = {};
            widgetCadastro.newRow();
            popupWidget = widgetCadastro; 
        }.bind(this));
    };
    
    /*Fecha o popup e ativa a widget anterior*/
    this.closeModal = function(){
		var parent = popupWidget.parent;
		ScreenService.closePopup();
		parent.activate();
	};
	
/* ------------------- AÇÕES DO POPUP ------------------- */	

    this.validaCamposPopup = function(widgetCadastro){
        var evento = widgetCadastro.getField('NMEVENTO');
        var inscricao = widgetCadastro.getField('NRINSCRICAO');
        var idoptsimples = widgetCadastro.getField('IDOPTSIMPLES');
        var tipovinculo = widgetCadastro.getField('NRTIPOVINCULOM');
        if(parentWidget.name == 'estrutura'){
            inscricao.isVisible = true;
            idoptsimples.isVisible = true;
            tipovinculo.isVisible = false;
            evento.dataSource.data = [
                                        {
                                            "NMEVENTO": "S-1000",
                                            "DSEVENTO": "S-1000 - Informações do Empregador/Contribuinte/Órgão Público"
                                        },
                                        {
                                            "NMEVENTO": "S-1005",
                                            "DSEVENTO": "S-1005 - Tabela de Estabelecimentos, Obras ou Unidades de Órgãos Públicos"
                                        },
                                        {
                                            "NMEVENTO": "S-1020",
                                            "DSEVENTO": "S-1020 - Tabela de Lotações Tributárias"
                                        }
                                    ];
        }else if(parentWidget.name == 'Ocupacao'){
            inscricao.isVisible = false;
            idoptsimples.isVisible = false;
            tipovinculo.isVisible = false;
            evento.dataSource.data = [
                                        {
                                            "NMEVENTO": "S-1030",
                                            "DSEVENTO": "S-1030 - Tabela de Cargos/Empregos Públicos"
                                        },
                                        {
                                            "NMEVENTO": "S-1040",
                                            "DSEVENTO": "S-1040 - Tabela de Funções/Cargos em Comissão"
                                        }
                                    ];
        }else if(parentWidget.name == 'horario'){
            inscricao.isVisible = false;
            idoptsimples.isVisible = false;
            tipovinculo.isVisible = false;
            evento.dataSource.data = [
                                        {
                                            "NMEVENTO": "S-1050",
                                            "DSEVENTO": "S-1050 - Tabela de Horários/Turnos de Trabalho"
                                        }
                                    ];
        }else if(parentWidget.name == 'vinculo'){
            inscricao.isVisible = false;
            idoptsimples.isVisible = false;
            tipovinculo.isVisible = true;
            evento.dataSource.data = [
                                        {
                                            "NMEVENTO": "S-2200",
                                            "DSEVENTO": "S-2200 - Cadastramento Inicial do Vínculo e Admissão/Ingresso de Trabalhador"
                                        },
                                        {
                                            "NMEVENTO": "S-2205",
                                            "DSEVENTO": "S-2205 - Alteração de Dados Cadastrais do Trabalhador"
                                        },
                                        {
                                            "NMEVENTO": "S-2206",
                                            "DSEVENTO": "S-2206 - Alteração de Contrato de Trabalho"
                                        },
                                        {
                                            "NMEVENTO": "S-2230",
                                            "DSEVENTO": "S-2230 - Afastamento Temporário"
                                        },
                                        {
                                            "NMEVENTO": "S-2300",
                                            "DSEVENTO": "S-2300 - Trabalhador Sem Vínculo de Emprego/Estatutário - Início"
                                        },
                                        {
                                            "NMEVENTO": "S-2306",
                                            "DSEVENTO": "S-2306 - Trabalhador Sem Vínculo de Emprego/Estatutário - Alteração Contratual"
                                        }
                                    ];
        }  
        // widgetCadastro.redraw();
    };
    
    this.importarXmlEsocial = function(){
        var widget = templateManager.container.getActiveWidget();
        var popUpMensagens = templateManager.container.getWidget("mensagens");
        if(widget.isValid() && this.validaInscricao(widget)){
            restEngine.post('product#/importarXmlEsocial', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                    then(function (data) {
                        if(!Util.isUndefined(data.messages)){
                            ScreenService.showMessage(data.messages[0].message, data.messages[0].type);
                            this.closePopupImportXmlEsocial();
                            if(!Util.isUndefined(data.dataset.importarXml)){
                                popUpMensagens.dataSource.data = data.dataset.importarXml;
                                ABUtilController.masterDetailOpenPopup(popUpMensagens);
                            }
                        }
                    }.bind(this)).
                    catch(function(e) {
                        var error;
                        if(e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;
                            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    });
        }
    };
    
    this.validaInscricao = function(widget){
        if(widget.currentRow.NMEVENTO == 'S-1000' && Util.isEmptyOrBlank(widget.currentRow.NRINSCRICAO)){
            ScreenService.showMessage('É necessário informar a inscrição do empregador (matriz) para realizar a importação!', 'error');
            return false;
        }else if(widget.currentRow.NMEVENTO == 'S-1020' && Util.isEmptyOrBlank(widget.currentRow.NRINSCRICAO)){
            ScreenService.showMessage('É necessário informar a inscrição do empregador (matriz) ou da lotação para realizar a importação!', 'error');
            return false;
        }else{
            return true;
        }
    };
        
    this.closePopupImportXmlEsocial = function(){
        var popup = templateManager.container.getWidget('popupImportacaoXmlEsocial');
        // popup.currentRow = {};
        ScreenService.closePopup(true);
        popup.deactivate();
        popup.parent.currentWidget = popup.parentWidget;
        popup.parent.activate();
        popup.parent.reload();
    };
    
    
    
    
}

Configuration(function(ContextRegister) {
    ContextRegister.register('ImportacaoXmlEsocialController', ImportacaoXmlEsocialController);
});

// FILE: assets/js/controllers/IncidenciaEventoController.js
function IncidenciaEventoController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, General,Messages) {

    this.adicionarRow = function(args) {
        var widget = args.owner.widget;
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
    };

	this.setIncidenciaEvento = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
                if (!widget.backupRow) {
                    widget.currentRow.__is_new = true;
                } else {
                    widget.currentRow.__is_new = false;
                }
                restEngine.post('product#/setIncidenciaEvento', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                    then(function (data) {
                        if (data.notifications[0].type === "success") {
                            ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                            if (widget.currentRow.__is_new) {
                                ABUtilController.masterDetailVoltarList(widget);
                                widget.reload();
                            } else {
                                ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                                widget.backupRow = null;
                                widget.view();
                            }
                        } else {
                            ScreenService.showMessage('Não foi possível salvar o registro! O evento já existe para esta incidência.', 'ERROR');
                        }
                    }).
                    catch(function(e) {
                        var error;
                        if(e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;
                            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    });
            }
    };
    
    this.deleteIncidenciaEvento = function(args) {
    ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
        var widget = args.owner.widget;
        widget.currentRow.__is_new = false;
        restEngine.post('product#/deleteIncidenciaEvento', {'requestType':'DataSet','dataset':[widget.currentRow]}).
            then(function(data){
                if(data.notifications[0].type === "success"){
                    ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                    ABUtilController.masterDetailVoltarList(widget);
                    widget.reload();
                } else {
                    ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                }
            }).
            catch(function(e) {
                var error;
                if(e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
        }, null);
    };
    
    this.openPopupCadAutomatico = function(args) {
        var widgetFilter = templateManager.container.getWidget('cadAutIncideEvento');
        widgetFilter.applyDefaultValue();
        ScreenService.openPopup(widgetFilter);
    };
    
    this.closeMensagemErro = function(args){
        ScreenService.closePopup();
        ScreenService.closePopup();
        templateManager.container.getWidget('incidenciaEvento').reload();
        templateManager.container.getWidget('incidenciaEvento').activate();
    };
    
    this.cadAutoIncEvt = function(args) {
        var widget = args.owner.widget;
        var mensagemErro = templateManager.container.getWidget("mensagens");
        if (widget.isValid()) {
            restEngine.post('product#/cadAutoIncEvt', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                then(function (data) {
                    if(data.notifications[0].type){
                        if(data.notifications[0].type === "success"){
                            ScreenService.showMessage(Messages.CADASTRO_AUTOMATICO_SUCCESS, 'SUCCESS');
                            ScreenService.closePopup();
                            templateManager.container.getWidget('incidenciaEvento').reload();
                            templateManager.container.getWidget('incidenciaEvento').activate();
                        } else if(data.notifications[0].type === "alert") {
                            mensagemErro.dataSource.data = data.dataset.msgDeErro;
                            ABUtilController.masterDetailOpenPopup(mensagemErro);
                            ScreenService.showMessage('Cadastro automático finalizado com advertências', 'ALERT');
                        } else if(data.notifications[0].type === "error"){
                            mensagemErro.dataSource.data = data.dataset.msgDeErro;
                            ABUtilController.masterDetailOpenPopup(mensagemErro);
                        } else {
                            ScreenService.showMessage(Messages.SAVE_ROW_ERROR, 'ERROR');
                        }
                    }
                }).
                catch(function(e) {
                    var error;
                    if(e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;

                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
        }
    };
    
}

Configuration(function(ContextRegister) {
    ContextRegister.register('IncidenciaEventoController', IncidenciaEventoController);
});

// FILE: assets/js/controllers/IncidenciaFgtsController.js
function IncidenciaFgtsController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, General,Messages) {

    this.adicionarRow = function(args) {
        var widget = args.owner.widget;
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
    };


	this.setIncidenciaFgts = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
                if (!widget.backupRow) {
                    widget.currentRow.__is_new = true;
                } else {
                    widget.currentRow.__is_new = false;
                }
                restEngine.post('product#/setIncidenciaFgts', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                    then(function (data) {
                        if (data.notifications[0].type === "success") {
                            ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                            if (widget.currentRow.__is_new) {
                                ABUtilController.masterDetailVoltarList(widget);
                                widget.reload();
                            } else {
                                ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                                widget.backupRow = null;
                                widget.reload();
                                widget.view();
                            }
                        } else {
                            ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                        }
                    }).
                    catch(function(e) {
                        var error;
                        if(e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;
                            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    });
            }
    };
    
    this.deleteIncidenciaFgts = function(args) {
        var widget = args.owner.widget;
        widget.currentRow.__is_new = false;
        restEngine.post('product#/deleteIncidenciaFgts', {'requestType':'DataSet','dataset':[widget.currentRow]}).
            then(function(data){
                if(data.notifications[0].type === "success"){
                    ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                    ABUtilController.masterDetailVoltarList(widget);
                    widget.reload();
                } else {
                    ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                }
            }).
            catch(function(e) {
                var error;
                if(e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('IncidenciaFgtsController', IncidenciaFgtsController);
});

// FILE: assets/js/controllers/IncidenciaInssController.js
function IncidenciaInssController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, General,Messages) {

    this.adicionarRow = function(args) {
        var widget = args.owner.widget;
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
    };

	this.setIncidenciaInss = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
                if (!widget.backupRow) {
                    widget.currentRow.__is_new = true;
                } else {
                    widget.currentRow.__is_new = false;
                }
                restEngine.post('product#/setIncidenciaInss', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                    then(function (data) {
                        if (data.notifications[0].type === "success") {
                            ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                            if (widget.currentRow.__is_new) {
                                ABUtilController.masterDetailVoltarList(widget);
                                widget.reload();
                            } else {
                                ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                                widget.backupRow = null;
                                widget.reload();
                                widget.view();
                            }
                        } else {
                            ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                        }
                    }).
                    catch(function(e) {
                        var error;
                        if(e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;
                            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    });
            }
    };
    
    this.deleteIncidenciaInss = function(args) {
        var widget = args.owner.widget;
        widget.currentRow.__is_new = false;
        restEngine.post('product#/deleteIncidenciaInss', {'requestType':'DataSet','dataset':[widget.currentRow]}).
            then(function(data){
                if(data.notifications[0].type === "success"){
                    ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                    ABUtilController.masterDetailVoltarList(widget);
                    widget.reload();
                } else {
                    ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                }
            }).
            catch(function(e) {
                var error;
                if(e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('IncidenciaInssController', IncidenciaInssController);
});

// FILE: assets/js/controllers/IncidenciaIrffController.js
function IncidenciaIrrfController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, General,Messages) {

    this.adicionarRow = function(args) {
        var widget = args.owner.widget;
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
    };

	this.setIncidenciaIrrf = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
                if (!widget.backupRow) {
                    widget.currentRow.__is_new = true;
                } else {
                    widget.currentRow.__is_new = false;
                }
                restEngine.post('product#/setIncidenciaIrrf', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                    then(function (data) {
                        if (data.notifications[0].type === "success") {
                            ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                            if (widget.currentRow.__is_new) {
                                ABUtilController.masterDetailVoltarList(widget);
                                widget.reload();
                            } else {
                                ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                                widget.backupRow = null;
                                widget.reload();
                                widget.view();
                            }
                        } else {
                            ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                        }
                    }).
                    catch(function(e) {
                        var error;
                        if(e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;
                            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    });
            }
    };
    
    this.deleteIncidenciaIrrf = function(args) {
        var widget = args.owner.widget;
        widget.currentRow.__is_new = false;
        restEngine.post('product#/deleteIncidenciaIrrf', {'requestType':'DataSet','dataset':[widget.currentRow]}).
            then(function(data){
                if(data.notifications[0].type === "success"){
                    ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                    ABUtilController.masterDetailVoltarList(widget);
                    widget.reload();
                } else {
                    ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                }
            }).
            catch(function(e) {
                var error;
                if(e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('IncidenciaIrrfController', IncidenciaIrrfController);
});

// FILE: assets/js/controllers/IncidenciaSindicatoController.js
function IncidenciaSindicatoController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, General,Messages) {

    this.adicionarRow = function(args) {
        var widget = args.owner.widget;
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
    };

	this.setIncidenciaSindicato = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
                if (!widget.backupRow) {
                    widget.currentRow.__is_new = true;
                } else {
                    widget.currentRow.__is_new = false;
                }
                restEngine.post('product#/setIncidenciaSindicato', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                    then(function (data) {
                        if (data.notifications[0].type === "success") {
                            ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                            if (widget.currentRow.__is_new) {
                                ABUtilController.masterDetailVoltarList(widget);
                                widget.reload();
                            } else {
                                ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                                widget.backupRow = null;
                                widget.reload();
                                widget.view();
                            }
                        } else {
                            ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                        }
                    }).
                    catch(function(e) {
                        var error;
                        if(e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;
                            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    });
            }
    };
    
    this.deleteIncidenciaSindicato = function(args) {
        var widget = args.owner.widget;
        widget.currentRow.__is_new = false;
        restEngine.post('product#/deleteIncidenciaSindicato', {'requestType':'DataSet','dataset':[widget.currentRow]}).
            then(function(data){
                if(data.notifications[0].type === "success"){
                    ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                    ABUtilController.masterDetailVoltarList(widget);
                    widget.reload();
                } else {
                    ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                }
            }).
            catch(function(e) {
                var error;
                if(e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('IncidenciaSindicatoController', IncidenciaSindicatoController);
});

// FILE: assets/js/controllers/IndicadoresController.js
function IndicadoresController (ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, $window) {

    this.itemClick = function(widget) {
        if (widget) {
            var event;
            if(widget.onDashboardClick) {
                event = widget.onDashboardClick();
            }
            if ((!event || !event.isDefaultPrevented()) && widget.windowName) {
                ScreenService.openWindow('product#'+widget.windowName);
            }
        }
    };
    
    this.changeColorLastChartBar = function(name){
        $(document).ready(function() {
            var element = angular.element(name);
            element.find("g.bars").last().find("rect").attr("fill","#5eb43c");
            element.find("g.bars").last().find("text").attr("fill","#5eb43c");

            // adiciona classe css para minipulação do grid
            $('.dashboard-table-container').addClass('hcm-overflow-grid');
            $('#masonry-item-14 th').addClass('hcm-padding-grid');
        });        
    };

    this.iniciaFiltro = function(args){
        var widget = templateManager.container.getWidget("indicadores");
        var nrorg = getLocalVar("HCM_NRORG_TRAB");
        var dtcompetencia = getLocalVar("HCM_DTCOMPETENCIA_OPER");
        widget.dataSourceFilter.push({operator: "=", name : "P_NRORG", value : nrorg});
        widget.dataSourceFilter.push({operator: "=", name : "P_DTMESCOMPETENC", value : dtcompetencia});
    };
    
    this.iniciaWidgets = function(args){
        var widget = templateManager.container.getWidget("indicadores");
        
        var widgetquantiFunc  = templateManager.container.getWidget('quantiFunc');
        var widgetsalMedio    = templateManager.container.getWidget('salMedio');
        var widgetmaiorSala   = templateManager.container.getWidget('maiorSala');
        var widgetmenorSala   = templateManager.container.getWidget('menorSala');
        
        
        var widgetGenero   = templateManager.container.getWidget('generoEstrutura');
        var widgetOcupacao   = templateManager.container.getWidget('ocupacaoEstrutura');
        var widgetsalariosMes   = templateManager.container.getWidget('salariosMes');
        var widgetsalariosAno   = templateManager.container.getWidget('salariosAno');
        
        widgetGenero.dataSourceFilter = widget.dataSourceFilter;
        widgetOcupacao.dataSourceFilter = widget.dataSourceFilter;
        widgetsalariosMes.dataSourceFilter = widget.dataSourceFilter;
        widgetsalariosAno.dataSourceFilter = widget.dataSourceFilter;
        
        
        
        restEngine.post("product#/getIndicadorEstrutura", {
            requestType: "FilterData",
                filter: widget.dataSourceFilter }).
        then(function (data) {
            widgetquantiFunc.highlight = data.dataset.getIndicadorEstrutura[0].QUANT;
            widgetsalMedio.highlight  = "R$"+Number((data.dataset.getIndicadorEstrutura[0].MEDIA || 0 )).toFixed(2).replace('.', ',').replace(/(\d)(?=(\d{3})+(?!\d))/g, '$1.');
            widgetmaiorSala.highlight = "R$"+Number((data.dataset.getIndicadorEstrutura[0].MAXI || 0)).toFixed(2).replace('.', ',').replace(/(\d)(?=(\d{3})+(?!\d))/g, '$1.');
            widgetmenorSala.highlight = "R$"+Number((data.dataset.getIndicadorEstrutura[0].MINI || 0)).toFixed(2).replace('.', ',').replace(/(\d)(?=(\d{3})+(?!\d))/g, '$1.');
            widgetquantiFunc.reload();
            widgetsalMedio.reload();
            widgetmaiorSala.reload();
            widgetmaiorSala.reload();
            widgetGenero.reload();
            widgetOcupacao.reload();
            widgetsalariosMes.reload();
            widgetsalariosAno.reload();
        }).catch(function(e) {
            var error;
            if(e.data.error === undefined)
                error = e;
            else 
                error = e.data.error;
            
            ScreenService.showMessage('Ocorreu um erro inesperado, contate o administrador informando o trecho abaixo: <br><br>' + error + '<br><br>', 'ERROR');
        });
    };
    
    this.iniciaFiltroVinculo = function(args){
        var widget = templateManager.container.getWidget("indicadoresVinculo");
        var nrorg = getLocalVar("HCM_NRORG_TRAB");
        var dtcompetencia = getLocalVar("HCM_DTCOMPETENCIA_OPER");
        widget.dataSourceFilter.push({operator: "=", name : "P_NRORG", value : nrorg});
        widget.dataSourceFilter.push({operator: "=", name : "P_DTMESCOMPETENC", value : dtcompetencia});
    };
    
    this.iniciaWidgetsVinculo = function(args){
        var widget = templateManager.container.getWidget("indicadoresVinculo");
        var widgetVinculo = templateManager.container.getWidget("vincFiltro");
        if(widget.dataSourceFilter[widget.dataSourceFilter.length-1].name == "P_NRVINCULOM"){
            widget.dataSourceFilter.pop();
        }
        widget.dataSourceFilter.push({operator: "=", name : "P_NRVINCULOM", value : widgetVinculo.currentRow.NRVINCULOM});
         
        var widgetSalIni  = templateManager.container.getWidget('salIni');
        var widgetSalAtual    = templateManager.container.getWidget('salAtual');
        var widgetCargoIni   = templateManager.container.getWidget('cargoIni');
        var widgetCargoAtual   = templateManager.container.getWidget('cargoAtual');
        
        
        var widgetEvolSalarial   = templateManager.container.getWidget('evolSalarial');
        var widgetevolOcup   = templateManager.container.getWidget('evolOcup');
        
        widgetEvolSalarial.dataSourceFilter = widget.dataSourceFilter;
        widgetevolOcup.dataSourceFilter = widget.dataSourceFilter;
        
        restEngine.post("product#/getSalarioVincIndic", {
            requestType: "FilterData",
                filter: widget.dataSourceFilter }).
        then(function (data) {
            widgetSalIni.highlight  = "R$"+Number((data.dataset.getSalarioVincIndic[0].SALAINI || 0 )).toFixed(2).replace('.', ',').replace(/(\d)(?=(\d{3})+(?!\d))/g, '$1.');
            widgetSalAtual.highlight = "R$"+Number((data.dataset.getSalarioVincIndic[0].SALATUAL || 0)).toFixed(2).replace('.', ',').replace(/(\d)(?=(\d{3})+(?!\d))/g, '$1.');
            widgetEvolSalarial.reload();
        }).catch(function(e) {
            var error;
            if(e.data.error === undefined)
                error = e;
            else 
                error = e.data.error;
            
            ScreenService.showMessage('Ocorreu um erro inesperado, contate o administrador informando o trecho abaixo: <br><br>' + error + '<br><br>', 'ERROR');
        });
        
        
        restEngine.post("product#/getOcupacaoHistVinc", {
            requestType: "FilterData",
                filter: widget.dataSourceFilter }).
        then(function (data) {
            widgetCargoIni.highlight  = data.dataset.getOcupacaoHistVinc[0].NMOCUPACAOH;
            widgetCargoAtual.highlight =  data.dataset.getOcupacaoHistVinc[data.dataset.getOcupacaoHistVinc.length-1].NMOCUPACAOH;
            widgetevolOcup.reload();
        }).catch(function(e) {
            var error;
            if(e.data.error === undefined)
                error = e;
            else 
                error = e.data.error;
            
            ScreenService.showMessage('Ocorreu um erro inesperado, contate o administrador informando o trecho abaixo: <br><br>' + error + '<br><br>', 'ERROR');
        });
    };

}

Configuration(function(ContextRegister) {
    ContextRegister.register('IndicadoresController', IndicadoresController);
});

// FILE: assets/js/controllers/InfluenciaGerencialController.js
function InfluenciaGerencialController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, General,Messages) {

    this.adicionarRow = function(args) {
        var widget = args.owner.widget;
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
    };
    
	this.setInfluenciaGeren = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
                if (!widget.backupRow) {
                    widget.currentRow.__is_new = true;
                } else {
                    widget.currentRow.__is_new = false;
                }
                restEngine.post('product#/setInfluenciaGeren', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                    then(function (data) {
                        if (data.notifications[0].type === "success") {
                            ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                            if (widget.currentRow.__is_new) {
                                ABUtilController.masterDetailVoltarList(widget);
                                widget.reload();
                            } else {
                                ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                                widget.backupRow = null;
                                widget.view();
                            }
                        } else {
                            ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                        }
                    }).
                    catch(function(e) {
                        var error;
                        if(e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;
                            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    });
            }
    };
    
    this.deleteInfluenciaGeren = function(args) {
    ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
        
        var widget = args.owner.widget;
        widget.currentRow.__is_new = false;
        restEngine.post('product#/deleteInfluenciaGeren', {'requestType':'DataSet','dataset':[widget.currentRow]}).
            then(function(data){
                if(data.notifications[0].type === "success"){
                    ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                    ABUtilController.masterDetailVoltarList(widget);
                    widget.reload();
                } else {
                    ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                }
            }).
            catch(function(e) {
                var error;
                if(e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
        
        
    }, null);
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('InfluenciaGerencialController', InfluenciaGerencialController);
});

// FILE: assets/js/controllers/IntegracaoDigitalCertisignController.js
function IntegracaoDigitalCertisignController (ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, $window, ABUtilController, Messages) {
    
    
    this.adicionarRow = function(args) {
        var widget = args.owner.widget;
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
    };

    this.salvarAssinaturaEletronica = function(){
        var widget = templateManager.container.getWidget("integracaoDigitalCertisign");
        if (widget.isValid()) {
            if (!widget.backupRow) {
                widget.currentRow.__is_new = true;
            } else {
                widget.currentRow.__is_new = false;
            }
            restEngine.post('product#/setAssinaturaEletronica', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
            then(function (data) {
                if (data.notifications[0].type === "success") {
                    ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                    if (widget.currentRow.__is_new) {
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    } else {
                        ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                        widget.backupRow = null;
                        widget.view();
                    }
                } else {
                    ScreenService.showMessage('Erro ao salvar o registro.', 'ERROR');
                }
            }).
            catch(function(e) {
                var error;
                if(e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
        }
    };
    
    this.deleteAssinaturaEletronica = function(args) {
        ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
        
            var widget = args.owner.widget;
            widget.currentRow.__is_new = false;
            restEngine.post('product#/deleteAssinaturaEletronica', {'requestType':'DataSet','dataset':[widget.currentRow]}).
                then(function(data){
                    if(data.notifications[0].type === "success"){
                        ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    } else {
                        ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                    }
                }).
                catch(function(e) {
                    var error;
                    if(e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;
                        ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
            
        }, null);
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('IntegracaoDigitalCertisignController', IntegracaoDigitalCertisignController);
});

// FILE: assets/js/controllers/IntegracaoValeTransporteController.js
function IntegracaoValeTransporteController(ScreenService, templateManager, restEngine, ABUtilController, Messages, General) {

    var NMIMPORTACAO = null;

    this.setDataUltUtilizacao = function(field) {
        var dtUltUtil = new Date();
        dtUltUtil.setDate(dtUltUtil.getDate() - 1);
        field.widget.getField('DTULTUTILIZACAO').setValue(moment(dtUltUtil).format('DD/MM/YYYY'));
    };

    this.salvar = function(args) {
        
        var widget = templateManager.container.getWidget('integracaoValeTransporte');
        if (widget.isValid()) {
            if (ABUtilController.validaDtIniMenorIgualDtFin(widget.currentRow.DTINIVALIDADEINTEG, widget.currentRow.DTFINVALIDADEINTEG)) {
                widget.currentRow.VRSALDOULTCONSULTA = General.valueToFloat(widget.currentRow.VRSALDOULTCONSULTA);
                if(widget.currentRow.NRTIPOLINHAVINC == undefined)
                    widget.currentRow.NRTIPOLINHAVINC = '';
                ABUtilController.saveMasterDetailMasterHistory(widget);
            }else{
                ScreenService.showMessage("A data inicial deve ser anterior a data final");
            }
        }
    };

    this.remover = function(args) {
        ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
            var widget = templateManager.container.getWidget('integracaoValeTransporte');
            if (widget.isValid()) {
            widget.currentRow.__is_new = false;
            restEngine.post('product#/deleteIntegtransp', {
                'requestType': 'DataSet',
                'dataset': [widget.currentRow]
            }).
            then(function(data) {
                if (data.notifications[0].type === "success") {
                    ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                    ABUtilController.masterDetailVoltarList(widget);
                    widget.reload();
                } else {
                    ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                }
            }).
            catch(function(e) {
                var error;
                if (e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;

                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
        }
        }, null);
    };

    this.openPopupImportacao = function(widget, action) {
        NMIMPORTACAO = action;
        var widgetPopupImportacao = templateManager.container.getWidget('popupImportacao');
        widgetPopupImportacao.currentRow.DSPATH = [];
        ScreenService.openPopup(widgetPopupImportacao);
    };

    this.validaArquivo = function(filePath) {
        var valido = false;	
        var extension = filePath.split('.').pop().toUpperCase();
        var formats = 'XLSX|XLSM|XLTX|XLTM|XLS|XLT|ODS|OTS|SLK|XML'.split('|');	 
	 
        formats.forEach(function(format){	 
            if(extension == format) valido = true;	 
        });	 
	 
        if(!valido) ScreenService.showMessage('Formato de arquivo inválido');	 
        	 
        return valido;
    };

    this.importar = function(widget) {
        if (widget.isValid()) {
            if (this.validaArquivo(widget.currentRow.DSPATH[0].name)) {
                widget.currentRow.NMINTEGRACAO = NMIMPORTACAO;
                restEngine.post('product#/importaIntegtransp', {
                    'requestType': 'DataSet',
                    'dataset': [widget.currentRow]
                }).
                then(function(data) {
                    if (data.notifications[0].type === "success") {
                        ScreenService.successNotification(Messages.IMPORTACAO_SUCCESS, 10000);
                        ScreenService.closePopup(true);
                        if(data.dataset.getMessage != ''){
                            var popUp = templateManager.container.getWidget('mensagens_integraçãoValeTransporte');
                            popUp.dataSource.data = data.dataset.getMessage[0];
                            ABUtilController.masterDetailOpenPopup(popUp);
                        }
                        templateManager.container.getWidget('integracaoValeTransporte').reload();
                        templateManager.container.getWidget('integracaoValeTransporte').activate();
                        widget.reload();
                    } else {
                        ScreenService.showMessage(Messages.IMPORTACAO_ERROR);
                    }
                    
                }).
                catch(function(e) {
                    var error;
                    if (e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;

                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
            }
        }
    };

}

Configuration(function(ContextRegister) {
    ContextRegister.register('IntegracaoValeTransporteController', IntegracaoValeTransporteController);
});


// FILE: assets/js/controllers/IntervaloTrabalhoController.js
function IntervaloTrabalhoController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, General,Messages) {

    this.adicionarRow = function(args) {
        var widget = args.owner.widget;
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
    };

	this.setIntervaloTrabalho = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
                if (!widget.backupRow) {
                    widget.currentRow.__is_new = true;
                } else {
                    widget.currentRow.__is_new = false;
                }
                restEngine.post('product#/setIntervaloTrabalho', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                    then(function (data) {
                        if (data.notifications[0].type === "success") {
                            ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                            if (widget.currentRow.__is_new) {
                                ABUtilController.masterDetailVoltarList(widget);
                                widget.reload();
                            } else {
                                ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                                widget.backupRow = null;
                                widget.view();
                            }
                        } else {
                            ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                        }
                    }).
                    catch(function(e) {
                        var error;
                        if(e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;
                            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    });
            }
    };
    
    this.deleteIntervaloTrabalho = function(args) {
        var widget = args.owner.widget;
        widget.currentRow.__is_new = false;
        restEngine.post('product#/deleteIntervaloTrabalho', {'requestType':'DataSet','dataset':[widget.currentRow]}).
            then(function(data){
                if(data.notifications[0].type === "success"){
                    ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                    ABUtilController.masterDetailVoltarList(widget);
                    widget.reload();
                } else {
                    ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                }
            }).
            catch(function(e) {
                var error;
                if(e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('IntervaloTrabalhoController', IntervaloTrabalhoController);
});

// FILE: assets/js/controllers/ItemAvaliacaoController.js
function ItemAvaliacaoController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, General,Messages) {
    
    var self = this;
    
    this.adicionarRow = function(args) {
        var widget = args.owner.widget;
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
    };
    this.widgetsvisibletrue = function(widget){
        widget.widgets.forEach(function(index) {
            index.showAsTab = true;
        });
    };

	this.setItemAvaliacao = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
            if (ABUtilController.validaDtIniMenorIgualDtFin(widget.currentRow.DTINIVIGENCIA, widget.currentRow.DTFIMVIGENCIA)) {
                if (!widget.backupRow) {
                    widget.currentRow.__is_new = true;
                } else {
                    widget.currentRow.__is_new = false;
                }
                restEngine.post('product#/setItemAvaliacao', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                    then(function (data) {
                        if (data.notifications[0].type === "success") {
                            ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                            if (widget.currentRow.__is_new) {
                                ABUtilController.masterDetailVoltarList(widget);
                                self.widgetsvisibletrue(args.owner.widget);
                                widget.reload();
                            } else {
                                ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                                widget.backupRow = null;
                                widget.view();
                            }
                        } else {
                            ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                        }
                    }).
                    catch(function(e) {
                        var error;
                        if(e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;
                            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    });
            }else{
                ScreenService.showMessage(Messages.DTINI_POST_DTFIM_ERROR);
                return false;
            }        
        }
        // templateManager.container.getWidget('itemAvaliacao').reload();
    };
    
    this.deleteItemAvaliacao = function(args) {
        ScreenService.confirmMessage(Messages.DELETE_ROW, 'CONFIRMATION',function(){
            var widget = templateManager.container.getActiveWidget();
            if (widget.isValid()) {
                widget.currentRow.__is_new = false;
                restEngine.post('product#/deleteItemAvaliacao', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                    then(function (data) {
                        if (data.messages) {
                            ScreenService.showMessage(Messages.REMOVE_ROW_ERROR + '. ' + data.messages[0].message, data.messages[0].type);
                        } else {
                            ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                            ABUtilController.masterDetailVoltarList(widget);
                            widget.reload();
                        }
                    }).
                    catch(function(e) {
                        var error;
                        if(e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;
    
                        ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    });
            }
            templateManager.container.getWidget('itemAvaliacao').reload();
        });
    };
    

}

Configuration(function(ContextRegister) {
    ContextRegister.register('ItemAvaliacaoController', ItemAvaliacaoController);
});

// FILE: assets/js/controllers/ItemDeCalculoController.js
/* jshint esversion: 6 */
function ItemDeCalculoController(ScreenService, templateManager, restEngine, ABUtilController, Messages, General, ESocialController) {

    this.filtraWidgetMain = false;
    this.idFiltrarWidgetMain = '';
    this.nmFiltrarWidgetMain = '';
    this.nomeVerifica = '';
    this.nrvinculom = '';
    this.nmvinculom = '';
    this.nreventom = '';
    this.nmeventoh = '';
    this.idrefevalorcalc = '';
    this.valueReturnFilter = '';

    // this.alteraFiltro = function(){
    //     var widget = templateManager.container.getActiveWidget();
    //     if (this.nmFiltrarWidgetMain === 'Itens do Movimento de Benefício') {
    //         widget.getField('NMESTRUTLEGAL').filterProperties.class = 4;
    //         widget.getField('NMESTRUTGEREN').filterProperties.class = 4;
    //         widget.getField('NMESTRUTURA_BENEFICIO').filterProperties.isVisible = true;
    //     }else{
            
    //         widget.getField('NMESTRUTLEGAL').filterProperties.class = 6;
    //         widget.getField('NMESTRUTGEREN').filterProperties.class = 6;
    //         widget.getField('NMESTRUTURA_BENEFICIO').filterProperties.isVisible = false;
    //     }
        
    // };


    this.filtrarWidgetMain = function(widgetLancamentos = null) {
        var widget = templateManager.container.getWidget('fpaItecalcfolha');
        if(Util.isEmptyOrBlank(widget) && !Util.isEmptyOrBlank(widgetLancamentos)){
            widget = widgetLancamentos;
        }
        if (this.nmFiltrarWidgetMain) {
            if (this.nmFiltrarWidgetMain === 'Itens do Movimento de Benefício') {
                //widget.getAction('exportar_lote').isVisible = true;
                widget.getAction('exportar_lote_listas').isVisible = true;
                widget.getAction('importacao_unimed').isVisible = true;
                widget.getField('NRTPBENEFICIO_LIST').isVisible = true;
                widget.getField('NRBENEFICIOM_LIST').isVisible = true;
                
                // widget.getField('NMESTRUTLEGAL').class = 3;
                // widget.getField('NMESTRUTGEREN').class = 3;
                // widget.getField('NMESTRUTSIND').class = 3;
                // widget.getField('NMESTRUTURA_BENEFICIO').class = 3;
                // widget.getField('NMESTRUTURA_BENEFICIO').isVisible = true;
                
                widget.widgets[0].getField('NMESTRUTLEGAL').class = 6;
                widget.widgets[0].getField('NMESTRUTGEREN').class = 6;
                // widget.widgets[0].getField('NMESTRUTURA_BENEFICIO').isVisible = true;
                
                // widget.getField('NMESTRUTLEGAL').filterProperties.class = 3;
                // widget.getField('NMESTRUTGEREN').filterProperties.class = 3;
                // widget.getField('NMESTRUTSIND').filterProperties.class = 3;
                // widget.getField('NMESTRUTURA_BENEFICIO').filterProperties.isVisible = true;
                // widget.getField('NMESTRUTURA_BENEFICIO').filterProperties.class = 3;
                
            } else {
    
                // widget.getField('NMESTRUTLEGAL').class = 4;
                // widget.getField('NMESTRUTGEREN').class = 4;
                // widget.getField('NMESTRUTSIND').class = 4;
                // widget.getField('NMESTRUTURA_BENEFICIO').isVisible = false;
    
                widget.widgets[0].getField('NMESTRUTLEGAL').class = 6;
                widget.widgets[0].getField('NMESTRUTGEREN').class = 6;
                // widget.widgets[0].getField('NMESTRUTURA_BENEFICIO').isVisible = false;
                
                // widget.getField('NMESTRUTLEGAL').filterProperties.class = 4;
                // widget.getField('NMESTRUTGEREN').filterProperties.class = 4;
                // widget.getField('NMESTRUTSIND').filterProperties.class = 4;
                // widget.getField('NMESTRUTURA_BENEFICIO').filterProperties.isVisible = false;
            
                if (widget.getAction('exportar_lote'))
                    widget.getAction('exportar_lote').isVisible = false;
                if (widget.getAction('exportar_lote_listas'))
                    widget.getAction('exportar_lote_listas').isVisible = false;
                if (widget.getAction('importacao_unimed'))
                    widget.getAction('importacao_unimed').isVisible = false;
                
                if (widget.getField('NRTPBENEFICIO_LIST') && widget.getField('NRBENEFICIOM_LIST')) {
                    widget.getField('NRTPBENEFICIO_LIST').isVisible = false;
                    widget.getField('NRBENEFICIOM_LIST').isVisible = false;
                }
                
            }
            
            widget.widgets[0].redraw();
            
            if (this.idFiltrarWidgetMain) {
                widget.dataSourceFilter[2].value = this.idFiltrarWidgetMain;
            }
    
            if (this.nmFiltrarWidgetMain === 'Lançamentos de Rescisão') {
                widget.dataSourceFilter[3].value = 'S';
                widget.getField('NMVINCULOM').dataSource.name = '/getVinculosRescindidosGeral';
                widget.getField('NMVINCULOM').dataSourceFilter = [];
            }else if (this.nmFiltrarWidgetMain === 'Lançamentos de PLR' || this.nmFiltrarWidgetMain === 'Itens do Movimento de Benefício') {
                widget.dataSourceFilter[3].value = 'T';
                widget.getField('NMVINCULOM').dataSource.name = '/getVinculoAtivosRescindidos';
                widget.getField('NMVINCULOM').dataSourceFilter = [];
            }else {
                widget.dataSourceFilter[3].value = 'N';
                widget.getField('NMVINCULOM').dataSource.name = '/getVinculosAtivosCompetencia';
                widget.getField('NMVINCULOM').dataSourceFilter = [];
            }
            
            if (this.nmFiltrarWidgetMain !== this.nomeVerifica) {
                widget.dataSource.data = [];
                if(this.filtraWidgetMain){    
                    ABUtilController.applyDefaultFilterOnEnter(widget);
                    this.filtraWidgetMain = false;
                }
                this.nomeVerifica = this.nmFiltrarWidgetMain;
            }
            
            templateManager.containers['product#hcm01001_fpa_itemDeCalculo'].label = this.nmFiltrarWidgetMain;
                      
            if(this.filtraWidgetMain){
                ABUtilController.applyDefaultFilterOnEnter(widget);
                this.filtraWidgetMain = false;
            }
        } else {
            ScreenService.closePopup(true);
            ScreenService.openWindow('product#dashboard');
        }
    };
    
    // this.filtraVinculo = function(args){
    //     var filterRow = args.e.preference.FILTER_ROW;
    //     var widget = args.owner;
    //     var dados = [];
        
    //     if(filterRow.NRVINCULOM){
    //         if(ABUtilController.retornaFiltro(widget.dataSourceFilter, 'NRVINCULOM')){
    //             widget.dataSourceFilter[ABUtilController.retornaFiltro(widget.dataSourceFilter, 'NRVINCULOM')].value = filterRow.NRVINCULOM;
    //         }else{
    //             widget.dataSourceFilter.push({
    //                                             "name": "NRVINCULOM",
    //                                             "operator": "=",
    //                                             "value": filterRow.NRVINCULOM
    //                                         });
    //         }
    //     }else{
    //         widget.dataSourceFilter.forEach(function(filtro){
    //             if(filtro.name != 'NRVINCULOM'){
    //                 dados.push(filtro);
    //             }
    //         });
    //         widget.dataSourceFilter = dados;
    //     }
        
    // };
    
    this.filterName = function(widget, fieldName, filterName, filterValue, datasetName, globalValue){
        var field = widget.getField(fieldName);
        var filterIndex = ABUtilController.retornaFiltro(field.dataSourceFilter, filterName); 
        var oldDataSourceFilter = [];
        
        if(filterIndex){
            field.dataSourceFilter[filterIndex].value = filterValue;
            field.dataSourceFilter.forEach(function(filter, index){
                if(index != filterIndex){
                    oldDataSourceFilter.push(filter);
                }
            });
        }else{
            oldDataSourceFilter = angular.copy(field.dataSourceFilter); 
            field.dataSourceFilter.push({
                                            "name": filterName,
                                            "operator": "=",
                                            "value": filterValue
                                        });
        }
        
        field.reload().then(function(data){
            this[globalValue] = data.dataset[datasetName][0] ? data.dataset[datasetName][0][fieldName] : '';
            field.dataSourceFilter = oldDataSourceFilter;
            field.reload();
        }.bind(this));
    
    };
    
    this.ParametrofiltrarWidgetMain = function(id, nm, filtra = true) {
        this.idFiltrarWidgetMain = id;
        this.nmFiltrarWidgetMain = nm;
        this.filtraWidgetMain = filtra;
        if (templateManager.containers['product#hcm01001_fpa_itemDeCalculo']) {
            var widget = templateManager.containers['product#hcm01001_fpa_itemDeCalculo'].getWidget('fpaItecalcfolha');
            this.filtrarWidgetMain(widget);
        }
    };

    this.habilitaCampos = function(widget) {
        var vinculo = widget.currentRow.NRVINCULOM;
        if(widget.getField('NMVINCULOM')){
            if (vinculo) {
                widget.getField('NMVINCULOM').readOnly = true;
            } else {
                widget.getField('NMVINCULOM').readOnly = false;
            }
        }
    };

    this.salvar = function(args) {
        var widget = templateManager.container.getActiveWidget();
        if (widget.parent) {
            widget.currentRow.NRTIPOVINCULOM = widget.parent.parent.currentRow.NRTIPOVINCULOM ? widget.parent.parent.currentRow.NRTIPOVINCULOM : '';
            widget.currentRow.NMVINCULOM = widget.parent.parent.currentRow.NMVINCULOM ? widget.parent.parent.currentRow.NMVINCULOM : '';
        }
        if (widget.isValid()) {
            if (!widget.backupRow) {
                widget.currentRow.__is_new = true;
            } else {
                widget.currentRow.__is_new = false;
            }
            widget.currentRow.NRTIPOMOVIMENT = this.idFiltrarWidgetMain;
            widget.currentRow.VRREFFOLHA = General.valueToFloat(widget.currentRow.VRREFFOLHA);
            widget.currentRow.VREVENTOFOLHA = General.valueToFloat(widget.currentRow.VREVENTOFOLHA);
            restEngine.post('product#/setItecalcfolha', {
                'requestType': 'DataSet',
                'dataset': [widget.currentRow]
            }).
            then(function(data) {
                if (data.dataset && data.dataset.msg) {
                    widget.reload();
                    openPopupMensagens(data.dataset.msg);
                } else if (data.messages) {
                    ScreenService.showMessage(data.messages[0].message, data.messages[0].type);
                } else if (data.notifications[0].type === "success") {
                    ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                    if (widget.currentRow.__is_new) {
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    } else {
                        ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                        widget.backupRow = null;
                        widget.view();
                    }
                } else {
                    ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                }
            }).
            catch(function(e) {
                var error;
                if (e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;

                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
        }
    };

    this.remover = function(widget) {
        ScreenService.confirmMessage(Messages.DELETE_ROW, null, function() {
            widget.currentRow.__is_new = false;
            restEngine.post('product#/deleteItecalcfolha', {
                'requestType': 'DataSet',
                'dataset': [widget.currentRow]
            }).
            then(function(data) {
                if (data.notifications[0].type === "success") {
                    ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                    ABUtilController.masterDetailVoltarList(widget);
                    widget.reload();
                } else if (data.notifications[0].type === 'error') {
                    ScreenService.errorNotification(data.notifications[0].message, 10000);
                } else {
                    ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                }
            }).
            catch(function(e) {
                var error;
                if (e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;

                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
        }, null);
    };
    
    this.preencheCampo = function(args){
        var widget = ABUtilController.checkWidget(args);
        var filter = args.e.preference.FILTER_ROW;
        
        this.nrvinculom = filter.NRVINCULOM;
        if((Util.isArray(filter.NRVINCULOM) && filter.NRVINCULOM.length == 1)){	 
            this.nrvinculom = filter.NRVINCULOM[0];	 
            this.nmvinculom = !Util.isEmptyOrBlank(filter.NMVINCULOM) ? filter.NMVINCULOM[0] : this.preencheVinculo(widget, filter.NRVINCULOM[0]); 	 
        }else if(!Util.isArray(filter.NRVINCULOM) && !Util.isEmptyOrBlank(filter.NRVINCULOM)){	 
            this.nrvinculom = filter.NRVINCULOM;	 
            this.nmvinculom = !Util.isEmptyOrBlank(filter.NMVINCULOM) ? filter.NMVINCULOM : this.preencheVinculo(widget, filter.NRVINCULOM); 	 
        }else{	 
            this.nrvinculom = '';	 
            this.nmvinculom = '';
        }
        
        this.nreventom = filter.NREVENTOM;
        if(!Util.isEmptyOrBlank(filter.NMEVENTOH) && !Util.isEmptyOrBlank(filter.NREVENTOM)){
            this.nmeventoh = filter.NMEVENTOH;
        }else if(!Util.isEmptyOrBlank(filter.NREVENTOM)){
            this.filterName(widget, 'NMEVENTOH', 'NREVENTOM', filter.NREVENTOM, 'fpa_evento_ativo_get', 'nmeventoh');
        }
        this.idrefevalorcalc = filter.IDREFEVALORCALC;
    };
    
    this.filtraWidgetESocial = function(args) {
        var url = new URL (window.location.href);
        var idItemCalculo = url.searchParams.get('idItemCalculo');
        var widgetItemCalculo = url.searchParams.get('widgetItemCalculo');
        
        if(idItemCalculo && widgetItemCalculo){
            // ESocialController.idItemCalculo = null;
            // ESocialController.widgetItemCalculo = null;
            // ESocialController.filtrarFilhasPorESocial(args);
    
        this.ParametrofiltrarWidgetMain(idItemCalculo, widgetItemCalculo, false);
        ESocialController.widgetFilterOnEnterOnceEsocial('fpaItecalcfolha', 'NRPESSOA');
        }else{	 
            this.filtrarWidgetMain(ABUtilController.checkWidget(args));
        }
    };
    
    this.AdicionarNovoLancamento = function(widget) {
        
        ABUtilController.mudarVisibilidadeWidgets(widget.widgets, false);
        widget.newRow();
        
        if(!Util.isEmptyOrBlank(this.nmvinculom) && !Util.isEmptyOrBlank(this.nrvinculom)){
            widget.currentRow.NRVINCULOM = this.nrvinculom;
            widget.currentRow.NMVINCULOM = this.nmvinculom;
        }else{
            widget.currentRow.NRVINCULOM = '';
            widget.currentRow.NMVINCULOM = '';
        }
        
        if(!Util.isEmptyOrBlank(this.nmeventoh) && !Util.isEmptyOrBlank(this.nreventom)){
            widget.currentRow.NREVENTOM = this.nreventom;
            widget.currentRow.NMEVENTOH = this.nmeventoh;
        }else{
            widget.currentRow.NREVENTOM = '';
            widget.currentRow.NMEVENTOH = '';
        }
        
        if (!Util.isUndefined(this.idrefevalorcalc) && this.idrefevalorcalc !== '') {
            widget.currentRow.IDREFEVALORCALC = this.idrefevalorcalc;
        } else {
            widget.currentRow.IDREFEVALORCALC = 'NORMAL';
        }
    };
    
    var openPopupMensagens = function(msg) {
        var widgetMensagens = templateManager.container.getWidget('mensagensCalculo');
        widgetMensagens.dataSource.data = msg;
        ScreenService.openPopup(widgetMensagens);
    };

    this.preencheVinculo = function (widget, filterNr){	 
        var field = widget.getField('NMVINCULOM');	 
        var datasetName = '';	 
        if(field.dataSource.name == '/getVinculosAtivosCompetencia'){	 
            datasetName = 'gpe_vinculosAtivosCompetencia_get';	 
        }else if(field.dataSource.name == '/getVinculosRescindidosGeral'){	 
            datasetName = 'retornaRescindidosGeral';	 
        }	 
        this.filterName(widget, 'NMVINCULOM', 'NRVINCULOM', filterNr, datasetName, 'nmvinculom');	 
    };

    this.excluirCheckedRow = (widget) => {
      var checkedRows = widget.getCheckedRows();
      restEngine
        .post("product#/deleteMultiplosIteCalcFolha", {
          requestType: "DataSet",
          dataset: checkedRows,
        })
        .then((data) => {
          if (data.dataset) {
            showMensagensMultiplasExclusoes(data.dataset.mensagensExclusao);
            widget.reload();
          } else {
            ScreenService.showMessage(data.messages[0].message);
            widget.reload();
          }
        })
        .catch((e) => {
          var error;
          if (e.data.error === undefined) error = e;
          else error = e.data.error;

          ScreenService.showMessage(
            Messages.CATCH_EXCEPTION_ERROR(error),
            "ERROR"
          );
        });
    };

    const showMensagensMultiplasExclusoes = function(msg) {
      var mensagensExclusao = templateManager.container.getWidget('mensagensMultiplasExclusoes');

      mensagensExclusao.dataSource.data = msg;

      ScreenService.openPopup(mensagensExclusao);
  };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('ItemDeCalculoController', ItemDeCalculoController);
});

// FILE: assets/js/controllers/ItensMovimentoBeneficioController.js
function ItensMovimentoBeneficioController(ScreenService, templateManager, restEngine, ABUtilController, Messages) {

    this.setarFlagDiferenciadorExportacao = function(widget){
        if (widget.name == 'filterProcessaLancamentosListas') {
            widget.currentRow.ITENS_LANCAMENTO_BENEFICIO_LISTAS = true;
        } else {
            widget.currentRow.ITENS_LANCAMENTO_BENEFICIO = true;
        }
    };

}

Configuration(function(ContextRegister) {
    ContextRegister.register('ItensMovimentoBeneficioController', ItensMovimentoBeneficioController);
});

// FILE: assets/js/controllers/JornadaTrabalhoController.js
function JornadaTrabalhoController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, General,Messages) {

    this.adicionarRow = function(args) {
        var widget = args.owner.widget;
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
    };

	this.setJornadaTrabalho = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
                if (!widget.backupRow) {
                    widget.currentRow.__is_new = true;
                } else {
                    widget.currentRow.__is_new = false;
                }
                restEngine.post('product#/setJornadaTrabalho', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                    then(function (data) {
                        if (data.notifications[0].type === "success") {
                            ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                            if (widget.currentRow.__is_new) {
                                ABUtilController.masterDetailVoltarList(widget);
                                widget.reload();
                            } else {
                                ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                                widget.backupRow = null;
                                widget.view();
                            }
                        } else {
                            ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                        }
                    }).
                    catch(function(e) {
                        var error;
                        if(e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;
                            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    });
            }
    };
    
    this.deleteJornadaTrabalho = function(args) {
        var widget = args.owner.widget;
        widget.currentRow.__is_new = false;
        restEngine.post('product#/deleteJornadaTrabalho', {'requestType':'DataSet','dataset':[widget.currentRow]}).
            then(function(data){
                if(data.notifications[0].type === "success"){
                    ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                    ABUtilController.masterDetailVoltarList(widget);
                    widget.reload();
                } else {
                    ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                }
            }).
            catch(function(e) {
                var error;
                if(e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('JornadaTrabalhoController', JornadaTrabalhoController);
});

// FILE: assets/js/controllers/LancamentoBeneficioController.js
function LancamentoBeneficioController(ScreenService, templateManager, restEngine, ABUtilController, Messages, General, HcmConsts) {

    var selectedAction = '';
    var objActions = {
        'gravar_total': {
            'name':'gravar_total',
            'label': 'Calcular',
            'fields': [
                "DSBENEFICIO",
                "DSTPBENEFICIO",
                "NMESTRUTLEGAL",
                "NMESTRUTGEREN",
                "NRVINCULOM_LIST"
            ],
            'nullable': [
                "DSBENEFICIO",
                "DSTPBENEFICIO",
                "NMESTRUTLEGAL",
                "NMESTRUTGEREN",
                "NRVINCULOM_LIST"
            ]
        },
        'gravar_parcial': {
            'name':'gravar_parcial',
            'label': 'Calcular Parcial',
            'fields': [
                "DSBENEFICIO",
                "DSTPBENEFICIO",
                "NMESTRUTLEGAL",
                "NMESTRUTGEREN",
                "NRVINCULOM_LIST"
            ],
            'nullable': [
                "DSBENEFICIO",
                "DSTPBENEFICIO",
                "NMESTRUTLEGAL",
                "NMESTRUTGEREN",
                "NRVINCULOM_LIST"
            ]
        },
        'retroceder_itens': {
            'name':'retroceder_itens',
            'label': 'Retroceder Somente Itens',
            'fields': [
                "DSBENEFICIO",
                "DSTPBENEFICIO",
                "NMESTRUTLEGAL",
                "NMESTRUTGEREN",
                "NRVINCULOM_LIST"
            ],
            'nullable': [
                "DSBENEFICIO",
                "DSTPBENEFICIO",
                "NMESTRUTLEGAL",
                "NMESTRUTGEREN",
                "NRVINCULOM_LIST"
            ]
        },
        'exportar_lote': {
            'name':'exportar_lote',
            'label': 'Exportar Lote',
            'fields': [
                "DSBENEFICIO",
                "DSTPBENEFICIO",
                "NMESTRUTLEGAL",
                "NMESTRUTGEREN",
                "NMESTRUTURA_BENEFICIO",
                "NRVINCULOM_LIST"
            ],
            'nullable': [
                "DSBENEFICIO",
                "DSTPBENEFICIO",
                "NMESTRUTLEGAL",
                "NMESTRUTGEREN",
                "NMESTRUTURA_BENEFICIO",
                "NRVINCULOM_LIST"
            ]
        },
        'exportar_lote_listas': {
            'name':'exportar_lote',
            'label': 'Exportar Lote',
            'fields': [
                "NRESTRUTLEGAL_LIST",
                "NRESTRUTGEREN_LIST",
                "NRESTRUTSIND_LIST",
                "NRVINCULOM_LIST",
                "NRESTRUTBENEF_LIST",
                "NRTPBENEFICIO_LIST",
                "NRBENEFICIOM_LIST",
                "NREVENTOM_LIST"
            ],
            'nullable': [
                "NRESTRUTLEGAL_LIST",
                "NRESTRUTGEREN_LIST",
                "NRESTRUTSIND_LIST",
                "NRVINCULOM_LIST",
                "NRESTRUTBENEF_LIST",
                "NRTPBENEFICIO_LIST",
                "NRBENEFICIOM_LIST",
                "NREVENTOM_LIST"
            ]
        },
        'cadastro_dias': {
            'name':'cadastro_dias',
            'label': 'Acrescentar/Descontar Dias',
            'fields': [
                "DSBENEFICIO",
                "DSTPBENEFICIO",
                "NMESTRUTLEGAL",
                "NMESTRUTGEREN",
                "NRVINCULOM_LIST",
                "QTDIASACRE",
                "QTDIASDESC"
            ],
            'nullable': [
                "DSBENEFICIO",
                "DSTPBENEFICIO",
                "NMESTRUTLEGAL",
                "NMESTRUTGEREN",
                "NRVINCULOM_LIST"
            ]
        },
        
    };
    
    var currentRowFilterAfterApply = {
            NMESTRUTLEGAL: null, 
            NRESTRUTLEGAL: null, 
            NMESTRUTGEREN: null, 
            NRESTRUTGEREN: null , 
            NMESTRUTURA_BENEFICIO: null, 
            NRESTRUTURA_BENEFICIO: null
    };
    
    var eventoAux = null;
    

    this.setActionsVisibility = function(widget) {
        for (var name in objActions) {
            widget.getAction(name).isVisible = (widget.dataSource.data[0] !== undefined);
        }
    };

    this.getValorTotal = function(row) {
        var vrTotal = (row.VRBENEFICIO * row.QTAPURBENEF * (row.QTDIASBENEF - row.QTDIASFALTAS - row.QTDIASAFASTA - row.QTDIASFERIAS - row.QTDIASAVISO)) - row.VRDEDUCAOBENEF;
        return vrTotal < 0 ? 0 : vrTotal;
    };

    this.salvar = function(args) {
        var widget = templateManager.container.getActiveWidget();
        if (widget.isValid()) {
            if (!widget.backupRow) {
                widget.currentRow.__is_new = true;
            } else {
                widget.currentRow.__is_new = false;
            }
            widget.currentRow.VRBENEFICIO = General.valueToFloat(widget.currentRow.VRBENEFICIO);
            widget.currentRow.VRDEDUCAOBENEF = General.valueToFloat(widget.currentRow.VRDEDUCAOBENEF);
            widget.currentRow.VRTOTALBENEF = this.getValorTotal(widget.currentRow);
            widget.currentRow.VRTOTALBENEF = General.valueToFloat(widget.currentRow.VRTOTALBENEF);
            restEngine.post('product#/setHistbenefvinc', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                then(function (data) {
                    if (data.messages) {
                        ScreenService.showMessage(data.messages[0].message, data.messages[0].type);
                    }
                    else if (data.notifications[0].type === "success") {
                        ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                        ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                        if (widget.currentRow.__is_new) {
                            ABUtilController.masterDetailVoltarList(widget);
                            widget.reload();
                        } else {
                            widget.backupRow = null;
                            widget.view();
                        }
                    } else {
                        ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                    }
                }).
                catch(function(e) {
                    var error;
                    if(e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;

                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
        }
    };

    this.remover = function(widget) {
        ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
            widget.currentRow.__is_new = false;
            restEngine.post('product#/deleteHistbenefvinc', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                then(function (data) {
                    if (data.messages) {
                        ScreenService.showMessage(data.messages[0].message, data.messages[0].type);
                    }
                    else if (data.notifications[0].type === "success") {
                        ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    } else {
                        ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                    }
                }).
                catch(function (e) {
                    var error;
                    if (e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;
    
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
        }, null);
    };

    this.openPopupProcessaLancamentos = function(widget, action) {
        var widgetName = (action == 'exportar_lote_listas' ? 'filterProcessaLancamentosListas' : 'filterProcessaLancamentos');
        var widgetFilter = templateManager.container.getWidget(widgetName);
        selectedAction = action;
        widgetFilter.label = objActions[action].label;
        var actionObj = objActions[action];
        widgetFilter.fields.forEach(function(field) {
            if (actionObj.fields.indexOf(field.name) >= 0) {
                widgetFilter.getField(field.name).isVisible = true;
                if (actionObj.nullable.indexOf(field.name) >= 0) {
                    widgetFilter.getField(field.name).validations = {};
                } else {
                    widgetFilter.getField(field.name).validations = {"required": true};
                }
            } else {
                widgetFilter.getField(field.name).isVisible = false;
            }
        });
        ScreenService.openPopup(widgetFilter);
    };

    this.processarLancamentos = function(widget) {
        if (widget.isValid()) {
            widget.currentRow.action = selectedAction;
            if (!Util.isUndefined(widget.getField('NRVINCULOM_LIST')) && widget.getField('NRVINCULOM_LIST').dataSource.getCheckedRows().length === 0) {
                widget.getField('NRVINCULOM_LIST').setValue('A');
            }
            if (!Util.isUndefined(widget.getField('NRESTRUTLEGAL_LIST')) && widget.getField('NRESTRUTLEGAL_LIST').dataSource.getCheckedRows().length === 0) {
                widget.getField('NRESTRUTLEGAL_LIST').setValue('A');
            }
            if (!Util.isUndefined(widget.getField('NRESTRUTGEREN_LIST')) && widget.getField('NRESTRUTGEREN_LIST').dataSource.getCheckedRows().length === 0) {
                widget.getField('NRESTRUTGEREN_LIST').setValue('A');
            }
            if (!Util.isUndefined(widget.getField('NRESTRUTSIND_LIST')) && widget.getField('NRESTRUTSIND_LIST').dataSource.getCheckedRows().length === 0) {
                widget.getField('NRESTRUTSIND_LIST').setValue('A');
            }
            if (!Util.isUndefined(widget.getField('NRESTRUTBENEF_LIST')) && widget.getField('NRESTRUTBENEF_LIST').dataSource.getCheckedRows().length === 0) {
                widget.getField('NRESTRUTBENEF_LIST').setValue('A');
            }
            if (!Util.isUndefined(widget.getField('NRTPBENEFICIO_LIST')) && widget.getField('NRTPBENEFICIO_LIST').dataSource.getCheckedRows().length === 0) {
                widget.getField('NRTPBENEFICIO_LIST').setValue('A');
            }
            if (!Util.isUndefined(widget.getField('NRBENEFICIOM_LIST')) && widget.getField('NRBENEFICIOM_LIST').dataSource.getCheckedRows().length === 0) {
                widget.getField('NRBENEFICIOM_LIST').setValue('A');
            }
            if (!Util.isUndefined(widget.getField('NREVENTOM_LIST')) && widget.getField('NREVENTOM_LIST').dataSource.getCheckedRows().length === 0) {
                widget.getField('NREVENTOM_LIST').setValue('A');
            }
            restEngine.post('product#/processaLancamentoBeneficio', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                then(function (data) {
                    if (data.messages) {
                        ScreenService.showMessage(data.messages[0].message, data.messages[0].type);
                    }
                    else {
                        if (selectedAction == 'exportar_lote' || selectedAction == 'exportar_lote_listas') {
                            ScreenService.showMessage(Messages.EXPORTACAO_SUCCESS, 'SUCCESS');
                        }
                        else if (selectedAction == 'retroceder_itens') {
                            ScreenService.showMessage(Messages.RETROCESSO_SUCCESS, 'SUCCESS');
                        }
                        else if(selectedAction == 'cadastro_dias'){
                            ScreenService.showMessage(Messages.OPERACAO_SUCESSO, 'SUCCESS');
                            templateManager.container.getWidget('histbenefvinc').reload();
                        }
                        else {
                            ScreenService.showMessage(Messages.CALCULO_SUCCESS, 'SUCCESS');
                        }
                    }
                    ScreenService.closePopup(true);
                    if(templateManager.container.getWidget('histbenefvinc')) templateManager.container.getWidget('histbenefvinc').activate();	 
                    if(templateManager.container.getWidget('fpaItecalcfolha')) templateManager.container.getWidget('fpaItecalcfolha').activate();
                }).
                catch(function(e) {
                    var error;
                    if(e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;

                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
        }
    };

    this.filtrarItens = function(widget) {
        templateManager.container.getWidget("fpa_itecalcfolha").dataSourceFilter = [];
        templateManager.container.getWidget("fpa_itecalcfolha").dataSourceFilter.push(
            {
                "name": "P_NRORG",
                "operator": "=",
                "value": getLocalVar('HCM_NRORG_TRAB')
            }
        );
        templateManager.container.getWidget("fpa_itecalcfolha").dataSourceFilter.push(
            {
                "name": "P_NRTIPOMOVIMENT",
                "operator": "=",
                "value": HcmConsts.TP_MOV_BENEFICIO
            }
        );
        templateManager.container.getWidget("fpa_itecalcfolha").dataSourceFilter.push(
            {
                "name": "NRVINCULOM",
                "operator": "=",
                "value": widget.currentRow.NRVINCULOM
            }
        );
        templateManager.container.getWidget("fpa_itecalcfolha").dataSourceFilter.push(
            {
                "name": "P_RESCISAO",
                "operator": "=",
                "value": 'N'
            }
        );
    };
    
    this.defineFiltroExportarLote = function(args){
        var filter = args.e.preference.FILTER_ROW;
        var widgetMain = templateManager.container.getWidget('fpaItecalcfolha');

        currentRowFilterAfterApply.NMESTRUTLEGAL = filter.NMESTRUTLEGAL;
        currentRowFilterAfterApply.NRESTRUTLEGAL = filter.NRESTRUTLEGAL;

        currentRowFilterAfterApply.NMESTRUTGEREN = filter.NMESTRUTGEREN;
        currentRowFilterAfterApply.NRESTRUTGEREN = filter.NRESTRUTGEREN;
        
        // Se a class for 4, então a configuração do container é para Itens do Movimento de Benefífio
        if(widgetMain.getField('NMESTRUTGEREN').class == 4){  
            currentRowFilterAfterApply.NMESTRUTURA_BENEFICIO = filter.NMESTRUTURA_BENEFICIO;
            currentRowFilterAfterApply.NRESTRUTURA_BENEFICIO = filter.NRESTRUTURA_BENEFICIO;
        }

    };
    
    this.setarFiltroLancamentoWidgetOnEnter = function(){
        var widgetProcessaLancamento = templateManager.container.getWidget('filterProcessaLancamentos');
        var indiceDoEventoAExcluir = null;

        
        for(var k in widgetProcessaLancamento.events){
            if(widgetProcessaLancamento.events[k].id === '13582916863238365093845'){
                indiceDoEventoAExcluir = k;
                eventoAux = widgetProcessaLancamento.events[k];
            }
        }
        
        // realiza a exclusao do evento e seta a currentRow de acordo com o filtro da widget principal
        if(indiceDoEventoAExcluir){
            
            // exclusão
            var length = widgetProcessaLancamento.events.length;
            widgetProcessaLancamento.events[indiceDoEventoAExcluir] = widgetProcessaLancamento.events[length-1];
            widgetProcessaLancamento.events.pop();
            
            // seta a currentRow
            widgetProcessaLancamento.currentRow.NMESTRUTLEGAL = currentRowFilterAfterApply.NMESTRUTLEGAL;
            widgetProcessaLancamento.currentRow.NRESTRUTLEGAL = currentRowFilterAfterApply.NRESTRUTLEGAL;
    
            widgetProcessaLancamento.currentRow.NMESTRUTGEREN = currentRowFilterAfterApply.NMESTRUTGEREN;
            widgetProcessaLancamento.currentRow.NRESTRUTGEREN = currentRowFilterAfterApply.NRESTRUTGEREN;
            
            // Se a class for 4, então a configuração do container é para Itens do Movimento de Benefífio
            if(templateManager.container.getWidget('fpaItecalcfolha').getField('NMESTRUTGEREN').class == 4){
                widgetProcessaLancamento.currentRow.NMESTRUTURA_BENEFICIO = currentRowFilterAfterApply.NMESTRUTURA_BENEFICIO;
                widgetProcessaLancamento.currentRow.NRESTRUTURA_BENEFICIO = currentRowFilterAfterApply.NRESTRUTURA_BENEFICIO;
            }
        }    

    };
    
    this.restaurarEventoExcluidoNoOnEnter = function(){
        
        var widgetProcessaLancamento = templateManager.container.getWidget('filterProcessaLancamentos');
        var existeEvento = false;

        widgetProcessaLancamento.events.forEach(function(event){
            if(event.id === '13582916863238365093845')
                existeEvento = true;
        });
        
        if(!existeEvento){
            widgetProcessaLancamento.events.push(eventoAux);
        }

    };
    
    this.testeOnEnter = function(){
        var a = 1;
        a++;
    };
    
    this.validaFieldOnChangeFilterEstrutraLegalGerencial = function(args){
        var field = args.owner.field;
        var popup = args.owner.field.widget;
        
        if( field.name == 'NMESTRUTGEREN' && (!popup.currentRow.NMESTRUTGEREN || popup.currentRow.NMESTRUTGEREN == "") ) 
            popup.currentRow.NRESTRUTGEREN = "";

        if( field.name == 'NMESTRUTLEGAL' && (!popup.currentRow.NMESTRUTLEGAL || popup.currentRow.NMESTRUTLEGAL == "") ) 
            popup.currentRow.NRESTRUTLEGAL = "";
    };
    
    this.importar = function(widget) {
        if (widget.isValid()) {
            if (this.validaArquivo(widget.currentRow.DSPATH[0].name)) {
                restEngine.post('product#/importaUnimed', {
                    'requestType': 'DataSet',
                    'dataset': [widget.currentRow]
                }).
                then(function(data) {
                    if (data.notifications[0].type === "success") {
                        ScreenService.successNotification(Messages.IMPORTACAO_SUCCESS, 10000);
                        ScreenService.closePopup(true);
                        if(data.dataset.getMessage != ''){
                            var popUp = templateManager.container.getWidget('mensagens_importacaoUnimed');
                            popUp.dataSource.data = data.dataset.getMessage[0];
                            ABUtilController.masterDetailOpenPopup(popUp);
                        }
                        templateManager.container.getWidget('histbenefvinc').reload();
                        templateManager.container.getWidget('histbenefvinc').activate();
                        widget.reload();
                    } else {
                        ScreenService.showMessage(Messages.IMPORTACAO_ERROR);
                    }
                    
                }).
                catch(function(e) {
                    var error;
                    if (e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;

                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
            }
        }
    };
    
    this.validaArquivo = function(filePath) {
        var extension = filePath.split('.').pop().toUpperCase();
        if (extension !== 'XLS' && extension !== 'XLSX') {
            ScreenService.showMessage('Formato de arquivo inválido');
            return false;
        } else {
            return true;
        }
    };
    
     this.openPopupImportacao = function() {
        var widgetPopupImportacao = templateManager.container.getWidget('popupImportacao');
        ScreenService.openPopup(widgetPopupImportacao);
    };

}

Configuration(function(ContextRegister) {
    ContextRegister.register('LancamentoBeneficioController', LancamentoBeneficioController);
});

// FILE: assets/js/controllers/LancamentoEstruturaController.js
function LancamentoEstruturaController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, General,Messages) {
    
    self = this;
    
    this.adicionarRow = function(args) {
        var widget = args.owner.widget;
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
    };
    
    this.salvar = function(args) {
        var widget = templateManager.container.getActiveWidget();
        if (widget.isValid()) {
            self.validaDataOcorrenciaEEventosInseridos(widget);
            if (!widget.backupRow) {
                widget.currentRow.__is_new = true;
            } else {
                widget.currentRow.__is_new = false;
            }
            widget.currentRow.NRTIPOMOVIMENT = this.idFiltrarWidgetMain;
            widget.currentRow.VRLANCESTRUTURA = General.valueToFloat(widget.currentRow.VRLANCESTRUTURA);
            
            restEngine.post('product#/setLancamentoEstrutura', {
                'requestType': 'DataSet',
                'dataset': [widget.currentRow]
            }).
            then(function(data) {
                if (data.messages) {
                    ScreenService.showMessage(data.messages[0].message, data.messages[0].type);
                } else if (data.notifications[0].type === "success") {
                    ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                    if (widget.currentRow.__is_new) {
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    } else {
                        ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                        widget.backupRow = null;
                        widget.view();
                    }
                } else {
                    ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                }
            }).
            catch(function(e) {
                var error;
                if (e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;

                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
        }
    };
    
    this.remover = function(widget) {
        ScreenService.confirmMessage(Messages.DELETE_ROW, null, function() {
            if (widget.isValid()) {
                widget.currentRow.__is_new = false;
                restEngine.post('product#/deleteLancamentoEstrutura', {
                    'requestType': 'DataSet',
                    'dataset': [widget.currentRow]
                }).
                then(function(data) {
                    if (data.notifications[0].type === "success") {
                        ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    } else if (data.notifications[0].type === 'error') {
                        ScreenService.errorNotification(data.notifications[0].message, 10000);
                    } else {
                        ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                    }
                }).
                catch(function(e) {
                    var error;
                    if (e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;

                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
            }
        }, null);
    };
    
    this.openPopupCadAuto = function() {
        var widgetPopup = templateManager.container.getWidget('popupCadAutoEstrut');
        ABUtilController.masterDetailOpenPopup(widgetPopup);
    };

    this.validaFieldEstruturaOnTpEstrutChange = function(args){
        var widget = args.owner.field.widget;
        if(widget.currentRow.NMTIPOESTRUTURA == "" || !widget.currentRow.NMTIPOESTRUTURA){
            widget.currentRow.NRESTRUTURAM = "";
            widget.currentRow.NMESTRUTURAM = "";
        }
    };
    
    this.setNrTipoEstrutura = function(args){
        var widgetPopUp = ABUtilController.checkWidget(args);
        var fieldEstrutura;
        if(widgetPopUp.name=="popupCadAutoEstrut"){
            fieldEstrutura = widgetPopUp.getField("NRESTRUTURAM");
        } else {
            fieldEstrutura = widgetPopUp.getField("NMESTRUTURAM");
        }
        widgetPopUp.currentRow.NMESTRUTURAM = '';
        widgetPopUp.currentRow.NRESTRUTURAM = '';
        if(!Util.isEmptyOrBlank(widgetPopUp.currentRow.NRTIPOESTRUTURA)){
            fieldEstrutura.dataSourceFilter.forEach(function(filters){
                if(filters.name === 'NRTIPOESTRUTURA'){
                    fieldEstrutura.dataSourceFilter.pop();
                }
            });
            fieldEstrutura.dataSourceFilter.push(
                {
                    "name": "NRTIPOESTRUTURA",
                    "operator": "=",
                    "value": widgetPopUp.currentRow.NRTIPOESTRUTURA
                }
            );
            fieldEstrutura.reload();
        } else {
            fieldEstrutura.dataSourceFilter.pop();
            fieldEstrutura.reload();
        }
    };
    
    
    
    this.cadAutoLancEstrutura = function(args) {
        var widget = ABUtilController.checkWidget(args);
        if (widget.isValid()) {
            widget.currentRow.__is_new = true;
            restEngine.post("product#/cadAutoLancEstrutura", {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                then(function (data) {
                if(data.notifications[0].type === "success"){
                    ScreenService.showMessage(Messages.CADASTRO_AUTOMATICO_SUCCESS, 'SUCCESS');
                    ScreenService.closePopup();
                    templateManager.container.getWidget('lancamentoEstrutura').activate();
                    templateManager.container.getWidget('lancamentoEstrutura').reload();
                }else if(data.notifications[0].message === 'HCM01077_FPA_VALOR_NULO')
                    ScreenService.showMessage(Messages.HCM01077_FPA_VALOR_NULO, 'ERROR');
                else
                    ScreenService.showMessage(Messages.SAVE_ROW_ERROR); 
            }).
                catch(function (e) {
                    var error;
                    if (e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;

                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
        }
    };
    
    this.setDefultPercentual = function(args){
        var widget = templateManager.container.getWidget('popupCadAutoEstrut');
        widget.currentRow.VRPERCENTINCID = 100;
    };
    
    this.habilitaAcoesEvento = function(widget){
        if(widget.currentRow.NREVENTOM == 3035 || widget.currentRow.NREVENTOM == 3036){
            widget.getAction("editar").isVisible = false;
            //widget.getAction("excluir").isVisible = false;
        } else{
            widget.getAction("editar").isVisible = true;
            //widget.getAction("excluir").isVisible = true;
        }
    };
    
    this.validaDataOcorrenciaEEventosInseridos = function(widget){
        var dataOcorrencia = ABUtilController.retornaObjetoDateComString(widget.currentRow.DTOCORRENCIA);  
        var eventosRelacionados = ["1060", "1065", "1070", "1075"];
        var dataAtual = new Date();
        ABUtilController.truncateObjetoDate(dataAtual);
        var nmeventom = widget.currentRow.NREVENTOM;
        var dataSeteFevereiro = new Date();
        dataSeteFevereiro.setDate(7);
        dataSeteFevereiro.setMonth(1);
        
        if(dataOcorrencia.getMonth() != 0 && (dataAtual.getTime() > dataSeteFevereiro.getTime()) && (eventosRelacionados.find(function(evento){return evento == nmeventom;}))){
            ScreenService.showMessage(Messages.AVISO_ESO_PENSALIDADE_CONTRIBUICAO_SINDICAL);
        }
    };
    
}

Configuration(function(ContextRegister) {
    ContextRegister.register('LancamentoEstruturaController', LancamentoEstruturaController);
});

// FILE: assets/js/controllers/LancamentoEventoController.js
function LancamentoEventoController (ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, $window, ABUtilController, Messages, General) {
    
    this.rowToBeSetLancamentoEvento = {'IDREFEVALORCALC': 'NORMAL',
                                       'NRTIPOMOVIMENT': 1,
                                       'NMTIPOMOVIMENT': 'MENSAL',
                                       'DTOCORRENCIA': ''};
    
    this.setDtCompetenciaDefaultFilter = function(){
        this.rowToBeSetLancamentoEvento.DTOCORRENCIA = getLocalVar('HCM_DTCOMPETENCIA_OPER');
    };
    
    this.validaFiltro = function (args) {
        var row = args.e.preference.FILTER_ROW;
        if(!row.NRVINCULOM_LIST && !row.LIST_NRESTRUTLEGAL && !row.LIST_NRESTRUTGEREN && !row.LIST_NRESTRUTSIND){
            ScreenService.showMessage("É necessário preencher o campo 'Vínculo', 'Estrutura Legal', 'Estrutura Gerencial' ou 'Estrutura Sindical' para realizar o filtro.");
            args.e.preventDefault();
        } else {
            if (row.NRVINCULOM_LIST && row.NRVINCULOM_LIST.length > 1000) {
                ScreenService.showMessage("Favor selecionar um máximo de 1000 vínculos na lista ou usar outro filtro como por exemplo por estrutura legal.");
                args.e.preventDefault();
            }
            if ((row.LIST_NRESTRUTLEGAL && row.LIST_NRESTRUTLEGAL.length > 1000) || (row.LIST_NRESTRUTGEREN && row.LIST_NRESTRUTGEREN.length > 1000) || (row.LIST_NRESTRUTSIND && row.LIST_NRESTRUTSIND.length > 1000)) {
                ScreenService.showMessage("Favor selecionar um máximo de 1000 estruturas na lista.");
                args.e.preventDefault();
            }
        }
    };
    
    this.habilitaCampos = function(widget) {
        var vinculo = widget.currentRow.NRVINCULOM;
        var evento = widget.currentRow.NREVENTOM;
        var movimento = widget.currentRow.NRTIPOMOVIMENT;
        if ((vinculo)) {
            widget.getField('NRVINCULOM').readOnly = true;
        } else {
            widget.getField('NRVINCULOM').readOnly = false;
        }
        if (evento) {
            widget.getField('NMEVENTOH').readOnly = true;
        } else {
            widget.getField('NMEVENTOH').readOnly = false;
        }
        if (movimento){
            widget.getField('NMTIPOMOVIMENT').readOnly = true;
        }else{
            widget.getField('NMTIPOMOVIMENT').readOnly = false;
        }
    };
    
    this.deleteItemCalculoFolha = function(args) {
        ScreenService.confirmMessage('Deseja realmente excluir o(s) item(ns) selecionado(s)?', 'CONFIRMATION', 
            function(){
                var widget = args.owner.widget;
                restEngine.post('product#/deleteItemCalculoFolha', {'requestType':'DataSet','dataset':[widget.getCheckedRows()]}).
                    then(function(data){
                        if(data.messages){
                            ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                            widget.reload();
                        } else {
                            ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                        }
                    }).
                    catch(function(e) {
                        var error;
                        if(e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;
                            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    }
                );
            }
        );
    };

    this.popupLancValorGeral = function(args) {
        var widgetFilter = templateManager.container.getWidget('LANCAMENTOVALORGERAL');
        var widget = templateManager.container.getWidget('lancFolhaEvento');
        widgetFilter.applyDefaultValue();
        ScreenService.openPopup(widgetFilter);
    };
    
    this.lancaValorGeral = function(args) {
        var widgetMain = templateManager.container.getWidget('LANCAMENTOVALORGERAL');
        var widget = templateManager.container.getWidget('lancFolhaEvento');
        var row = [];
        widget.mode = "inline_edit";
        widget.editing = true;
        if(widgetMain.currentRow.VRGERAL === "" && widgetMain.currentRow.VRREFERENCIAGERAL === "" && widgetMain.currentRow.IDFREFVALORGERAL === ""){
            ScreenService.showMessage('Algum campo precisa ser preenchido');
        } else {
            for(var k in widget.dataSource.data){
                widget.dataSource.data[k].__is_new = false;
                if(widgetMain.currentRow.VRGERAL != ""){
                    widget.dataSource.data[k].VREVENTOFOLHA = widgetMain.currentRow.VRGERAL;
                    widget.dataSource.data[k].changed_VREVENTOFOLHA = widget.dataSource.data[k].VREVENTOFOLHA;
                }
                if(widgetMain.currentRow.VRREFERENCIAGERAL != ""){
                    widget.dataSource.data[k].VRREFFOLHA = widgetMain.currentRow.VRREFERENCIAGERAL;
                    widget.dataSource.data[k].changed_VRREFFOLHA = widget.dataSource.data[k].VRREFFOLHA;
                }
                if(widgetMain.currentRow.IDFREFVALORGERAL != ""){
                    widget.dataSource.data[k].IDREFEVALORCALC = widgetMain.currentRow.IDFREFVALORGERAL;
                    widget.dataSource.data[k].changed_IDREFEVALORCALC = widgetMain.currentRow.IDFREFVALORGERAL;
                }
                row.push(widget.dataSource.data[k]);
                widget.dataSource.data[k].changed = true;
            }
            ScreenService.closePopup();
            widget.lastInlineEditingElement = widget.getField('VREVENTOFOLHA').element;
        }
    };
    
    this.setItemCalcFolha = function(args){
        var dataset = args.dataSource;
        var widget = ABUtilController.checkWidget(args);
        var row = [];
        for(var k in widget.dataSource.data){
            widget.dataSource.data[k].__is_new = false;
            if(widget.dataSource.data[k].changed){
                widget.dataSource.data[k].VRREFFOLHA = General.valueToFloat(widget.dataSource.data[k].VRREFFOLHA);
                widget.dataSource.data[k].VREVENTOFOLHA = General.valueToFloat(widget.dataSource.data[k].VREVENTOFOLHA);
                row.push(widget.dataSource.data[k]);
            }
        }
        var data = widget.dataSource.data;
        restEngine.post('product#/setItemCalculoFolha', {'requestType': 'DataSet', 'dataset':[row]}).
            then(function(data){
                if (data.messages) {
                    ScreenService.showMessage(data.messages[0].message, data.messages[0].type);
                    if(data.messages[1] && data.messages[1].type == 'E'){
                        ScreenService.errorNotification(data.messages[1].message, 1000);
                    }
                } else if (data.notifications && data.notifications[0].type === "success") {
                    ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                } else {
                    ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                }
                widget.list();
                widget.activate();
                widget.reload();
            }).catch(function(e){
                var error;
                    if(e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;
                        ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
    
    };
    
    this.adicionaItemCalcFolha = function(args){
        var widgetMain = templateManager.container.getWidget('lancFolhaEvento');
        var row = [];
        ScreenService.confirmMessage('Deseja realmente salvar o item?', 'CONFIRMATION', 
            function(){
                var widget = args.owner.widget;
                if (!widget.backupRow) {
                    widget.currentRow.__is_new = true;
                } else {
                    widget.currentRow.__is_new = false;
                }
                widget.currentRow.VRREFFOLHA = General.valueToFloat(widget.currentRow.VRREFFOLHA);
                widget.currentRow.VREVENTOFOLHA = General.valueToFloat(widget.currentRow.VREVENTOFOLHA);
                row.push(widget.currentRow);
                restEngine.post('product#/adicionaItemCalcFolha', {'requestType': 'DataSet', 'dataset':[widget.currentRow]}).
                    then(function(data){
                        if(data.messages){
                            ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                        }else{
                            ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                        }
                        ScreenService.closeSwipe();
                        widgetMain.list();
                    }).catch(function(e){
                        var error;
                            if(e.data.error === undefined)
                                error = e;
                            else
                                error = e.data.error;
                                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    });   
        });
    };   
    
    
}
Configuration(function(ContextRegister) {
    ContextRegister.register('LancamentoEventoController', LancamentoEventoController);
});

// FILE: assets/js/controllers/LancamentoValeTransporteController.js
function LancamentoValeTransporteController(ScreenService, templateManager, restEngine, ABUtilController, Messages, General, HcmConsts) {

    this.objActions = {
        'gravar_total': {
            'name':'gravar_total',
            'label': 'Calcular',
            'fields': [
                "NRESTRUTSIND",
                "NRESTRUTLEGAL",
                "NRESTRUTGEREN",
                "NRVINCULOM_LIST",
                "DSTIPOLINHAVINC",
                "DTPGTOVALE"
            ],
            'nullable': [
                "NRESTRUTSIND",
                "NRESTRUTLEGAL",
                "NRESTRUTGEREN",
                "NRVINCULOM_LIST",
                "DSTIPOLINHAVINC"
            ]
        },
        'gravar_parcial': {
            'name':'gravar_parcial',
            'label': 'Calcular Parcial',
            'fields': [
                "NRESTRUTSIND",
                "NRESTRUTLEGAL",
                "NRESTRUTGEREN",
                "NRVINCULOM_LIST",
                "DSTIPOLINHAVINC",
                "DTPGTOVALE"
            ],
            'nullable': [
                "NRESTRUTSIND",
                "NRESTRUTLEGAL",
                "NRESTRUTGEREN",
                "NRVINCULOM_LIST",
                "DSTIPOLINHAVINC"
            ]
        },
        'retroceder_parcial': {
            'name':'retroceder_parcial',
            'label': 'Retroceder Somente Itens',
            'fields': [
                "NRESTRUTSIND",
                "NRESTRUTLEGAL",
                "NRESTRUTGEREN",
                "NRVINCULOM_LIST",
                "DSTIPOLINHAVINC"
            ],
            'nullable': [
                "NRESTRUTSIND",
                "NRESTRUTLEGAL",
                "NRESTRUTGEREN",
                "NRVINCULOM_LIST",
                "DSTIPOLINHAVINC"
            ]
        },
        'retroceder_total': {
            'name':'retroceder_total',
            'label': 'Retroceder Total',
            'fields': [
                "NRESTRUTSIND",
                "NRESTRUTLEGAL",
                "NRESTRUTGEREN",
                "NRVINCULOM_LIST",
                "DSTIPOLINHAVINC"
            ],
            'nullable': [
                "NRESTRUTSIND",
                "NRESTRUTLEGAL",
                "NRESTRUTGEREN",
                "NRVINCULOM_LIST",
                "DSTIPOLINHAVINC"
            ]
        },
        'cadastro_dias': {
            'name':'cadastro_dias',
            'label': 'Acrescentar/Descontar Dias',
            'fields': [
                "NRVINCULOM_LIST",
                "DSTIPOLINHAVINC",
                "QTDIASACRE",
                "QTDIASDESC"
            ],
            'nullable': [
                "NRVINCULOM_LIST",
                "DSTIPOLINHAVINC"
            ]
        },
        'cadastro_automatico': {
            'name':'cadastro_automatico',
            'label': 'Cadastro Automático',
            'fields': [
                "NRVINCULOM_LIST",
                "DSLINHATRANSP",
                "DSTIPOLINHAVINC",
                "DSSENTIDOLINHA",
                "VRTARIFA",
                "QTAPURVALE",
                "QTDIASVALE",
                "DTPGTOVALE",
                "DTINIAPURVALE",
                "DTFINAPURVALE"
            ],
            'nullable': []
        },
        'exportar': {
            'name':'exportar',
            'label': 'Exportar para Folha',
            'fields': [
                "NRESTRUTSIND",
                "NRESTRUTLEGAL",
                "NRESTRUTGEREN",
                "NRVINCULOM_LIST"
            ],
            'nullable': [
                "NRESTRUTSIND",
                "NRESTRUTLEGAL",
                "NRESTRUTGEREN",
                "NRVINCULOM_LIST"
            ]
        }
    };

    this.selectedAction = '';

    this.setActionsVisibility = function(widget) {
        for (var name in this.objActions) {
            if (name !== 'cadastro_automatico') {
                widget.getAction(name).isVisible = (widget.dataSource.data[0] !== undefined);
            }
        }
    };

    this.salvar = function(args) {
        var widget = templateManager.container.getActiveWidget();
        if (widget.isValid()) {
            if (!widget.backupRow) {
                widget.currentRow.__is_new = true;
            } else {
                widget.currentRow.__is_new = false;
            }
            widget.currentRow.VRDEDUCAOVALE = General.valueToFloat(widget.currentRow.VRDEDUCAOVALE);
            restEngine.post('product#/setHistvalevinc', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                then(function (data) {
                    if (data.notifications[0].type === "success") {
                        ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                        if (widget.currentRow.__is_new) {
                            ABUtilController.masterDetailVoltarList(widget);
                            widget.reload();
                        } else {
                            ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                            widget.backupRow = null;
                            widget.view();
                        }
                    } else {
                        ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                    }
                }).
                catch(function(e) {
                    var error;
                    if(e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;

                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
        }
    };

    this.remover = function(widget) {
        ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
            if (widget.isValid()) {
                widget.currentRow.__is_new = false;
                restEngine.post('product#/deleteHistvalevinc', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                    then(function (data) {
                        if (data.notifications[0].type === "success") {
                            ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                            ABUtilController.masterDetailVoltarList(widget);
                            widget.reload();
                        } else {
                            ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                        }
                    }).
                    catch(function (e) {
                        var error;
                        if (e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;

                        ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    });
            }
        }, null);
    };

    this.openPopupProcessaLancamentos = function(widget, action) {
        var widgetFilter = templateManager.container.getWidget('filterProcessaLancamentos');
        widgetFilter.isVisible = true;
        this.selectedAction = action;
        widgetFilter.label = this.objActions[action].label;
        var actionObj = this.objActions[action];
        widgetFilter.fields.forEach(function(field) {
            if (actionObj.fields.indexOf(field.name) >= 0) {
                widgetFilter.getField(field.name).isVisible = true;
                if (actionObj.nullable.indexOf(field.name) >= 0) {
                    widgetFilter.getField(field.name).validations = {};
                } else {
                    widgetFilter.getField(field.name).validations = {"required": true};
                }
            } else {
                widgetFilter.getField(field.name).isVisible = false;
            }
        });
        ScreenService.openPopup(widgetFilter);
    };

    this.processarLancamentos = function(widget) {
        if (widget.isValid()) {
            var action = this.selectedAction;
            widget.currentRow.action = this.selectedAction;
            if (widget.getField('NRVINCULOM_LIST').dataSource.getCheckedRows().length === 0) {
                widget.getField('NRVINCULOM_LIST').setValue('A');
            }
            restEngine.post('product#/processaLancamentoValeTransporte', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                then(function (data) {
                    if (data.messages) {
                        ScreenService.showMessage(data.messages[0].message, data.messages[0].type);
                    }
                    else {
                        ScreenService.showMessage(Messages.CALCULO_SUCCESS, 'SUCCESS');
                    }
                    ScreenService.closePopup();
                    if (action === 'cadastro_dias' || action === 'cadastro_automatico' || action === 'retroceder_total') {
                        templateManager.container.getWidget('histvalevinc').reload();
                    }
                    templateManager.container.getWidget('histvalevinc').activate();
                }).
                catch(function(e) {
                    var error;
                    if(e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;

                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
        }
    };

    this.filtrarItens = function(widget) {
        templateManager.container.getWidget("fpa_itecalcfolha").dataSourceFilter = [];
        templateManager.container.getWidget("fpa_itecalcfolha").dataSourceFilter.push(
            {
                "name": "P_NRORG",
                "operator": "=",
                "value": getLocalVar('HCM_NRORG_TRAB')
            }
        );
        templateManager.container.getWidget("fpa_itecalcfolha").dataSourceFilter.push(
            {
                "name": "P_NRTIPOMOVIMENT",
                "operator": "=",
                "value": HcmConsts.TP_MOV_VALE_TRANSPORTE
            }
        );
        templateManager.container.getWidget("fpa_itecalcfolha").dataSourceFilter.push(
            {
                "name": "NRVINCULOM",
                "operator": "=",
                "value": widget.currentRow.NRVINCULOM
            }
        );
        templateManager.container.getWidget("fpa_itecalcfolha").dataSourceFilter.push(
            {
                "name": "P_DTMESCOMPETENC",
                "operator": "=",
                "value": getLocalVar('HCM_DTCOMPETENCIA_OPER') ? getLocalVar('HCM_DTCOMPETENCIA_OPER') : ''
            }
        );
        templateManager.container.getWidget("fpa_itecalcfolha").dataSourceFilter.push(
            {
                "name": "P_RESCISAO",
                "operator": "=",
                "value": 'N'
            }
        );
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('LancamentoValeTransporteController', LancamentoValeTransporteController);
});

// FILE: assets/js/controllers/LinhadetransporteController.js
function LinhadetransporteController(ScreenService, templateManager, restEngine, ABUtilController, Messages) {
    
    this.validaPeriodo = function(dtIni, dtFin) {
        if (moment(dtIni, 'DD/MM/YYYY').unix() > moment(dtFin, 'DD/MM/YYYY').unix() || moment(dtFin, 'DD/MM/YYYY').unix() < moment(dtIni, 'DD/MM/YYYY').unix()) {
            return false;
        }
        else {
            return true;
        }
    };
    
    this.numFornecedor = function () {
        var widget = templateManager.container.getActiveWidget();
	    var fornecedor = templateManager.container.getWidget("empresatransporte").currentRow.CDFORNECED;
        widget.getField("CDFORNECED").setValue(fornecedor);
	};
    
    this.filtrarLinha = function(){
        
        var codigo = templateManager.container.getWidget("empresatransporte").currentRow.CDFORNECED;
        var linha = templateManager.container.getWidget("linha");
        
        linha.dataSourceFilter[2] = 
			{
				"name": "CDFORNECED",
				"operator": "=",
				"value": codigo
			}
		;
    };
    
    this.salvarLinhadetransporte = function(args) {
        var widget = templateManager.container.getActiveWidget();
        if (widget.isValid()) {
            if (this.validaPeriodo(widget.currentRow.DTINILINHA, widget.currentRow.DTFIMLINHA)) {
                if (!widget.backupRow) {
                    widget.currentRow.__is_new = true;
                } else {
                    widget.currentRow.__is_new = false;
                }
                restEngine.post('product#/setLinhatransporte', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                    then(function (data) {
                        if (data.notifications[0].type === "success") {
                            ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                            if (widget.currentRow.__is_new) {
                                ABUtilController.masterDetailVoltarList(widget);
                                ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                                widget.reload();
                            } else {
                                ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                                widget.backupRow = null;
                                widget.view();
                            }
                        } else {
                            ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                        }
                    }).
                    catch(function(e) {
                        var error;
                        if(e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;
    
                        ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    });
            }
            else {
                ScreenService.showMessage('A data final deve ser posterior à data inicial.');
                return false;
            }
        }
    };

    this.removerLinhadetransporte = function(args) {
        var widget = templateManager.container.getActiveWidget();
        ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
        if (widget.isValid()) {
            widget.currentRow.__is_new = false;
            restEngine.post('product#/deleteLinhatransporte', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                then(function (data) {
                    if (data.messages) {
                        ScreenService.showMessage(Messages.REMOVE_ROW_ERROR + '. ' + data.messages[0].message, data.messages[0].type);
                    } else {
                        ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    }
                }).
                catch(function(e) {
                    var error;
                    if(e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;

                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
        }
        }, null);
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('LinhadetransporteController', LinhadetransporteController);
});

// FILE: assets/js/controllers/LinhatarifaController.js
function LinhatarifaController(ScreenService, templateManager, restEngine, ABUtilController, Messages, $window) {
    
    this.validaPeriodo = function(dtIni, dtFin) {
        if (moment(dtIni, 'DD/MM/YYYY').unix() > moment(dtFin, 'DD/MM/YYYY').unix() || moment(dtFin, 'DD/MM/YYYY').unix() < moment(dtIni, 'DD/MM/YYYY').unix()) {
            return false;
        }
        else {
            return true;
        }
    };
    
	this.numLinha = function () {
        var widget = templateManager.container.getActiveWidget();
	    var linha = templateManager.container.getWidget("linha").currentRow.NRLINHATRANSP;
        widget.getField("NRLINHATRANSP").setValue(linha);
	};
	
	this.selectVr = function (widget) {
	    var valor = widget.currentRow.VRTARIFA;
	    var tarifa = templateManager.container.getWidget("tarifa");
	    tarifa.getField("VRTARIFA").setValue(valor);
	};
	
	this.filtrarTarifa = function() {
        
        var numero = templateManager.container.getWidget("linha").currentRow.NRLINHATRANSP;
        var tarifa = templateManager.container.getWidget("tarifa");
        
        tarifa.dataSourceFilter[2] =
			{
				"name": "NRLINHATRANSP",
				"operator": "=",
				"value": numero
			}
		;
    };
    
    this.salvarLinhatarifa = function(args) {
        var widget = templateManager.container.getActiveWidget();
        if (widget.isValid()) {
            if (this.validaPeriodo(widget.currentRow.DTINILINHATARIFA, widget.currentRow.DTFIMLINHATARIFA)) {
                if (!widget.backupRow) {
                    widget.currentRow.__is_new = true;
                } else {
                    widget.currentRow.__is_new = false;
                }
                restEngine.post('product#/setLinhatarifa', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                    then(function (data) {
                        if (data.notifications[0].type === "success") {
                            ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                            if (widget.currentRow.__is_new) {
                                ABUtilController.masterDetailVoltarList(widget);
                                widget.reload();
                            } else {
                                ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                                widget.backupRow = null;
                                widget.view();
                            }
                        } else {
                            ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                        }
                    }).
                    catch(function(e) {
                        var error;
                        if(e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;
    
                        ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    });
            }
            else {
                ScreenService.showMessage('A data final deve ser posterior à data inicial.');
                return false;
            }
        }
    };

    this.removerLinhatarifa = function(args) {
        var widget = templateManager.container.getActiveWidget();
        ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
            if (widget.isValid()) {
            widget.currentRow.__is_new = false;
            restEngine.post('product#/deleteLinhatarifa', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                then(function (data) {
                    if (data.notifications[0].type === "success") {
                        ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    } else {
                        ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                    }
                }).
                catch(function(e) {
                    var error;
                    if(e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;

                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
        }
        }, null);
    };
    
   /*Planilhas - Geral*/
   
    this.openPopup = function(popupName) {
        var widgetPopup = templateManager.container.getWidget(popupName);
        widgetPopup.currentRow.DSPATH = [];
        ScreenService.openPopup(widgetPopup);
    };
    
    this.closePopup = function(widgetName) {
        ScreenService.closePopup();
        templateManager.container.getWidget(widgetName).activate();
    };
    
    this.validaArquivo = function(filePath) {
        var extension = filePath.split('.').pop().toUpperCase();
        if (extension !== 'XLS' && extension !== 'XLSX') {
            ScreenService.showMessage('Formato de arquivo inválido');
            return false;
        } else {
            return true;
        }
    };
    
    var openPopupMensagens = function(msg, nmPopupMsg) {
        var widgetMensagens = templateManager.container.getWidget(nmPopupMsg);
        widgetMensagens.dataSource.data = msg;
        ScreenService.openPopup(widgetMensagens);
    };
    
    this.geraPlanilhaTemplete = function() {
        restEngine.post('product#/baixarPlanilhaLinhatarifa', {
            'requestType': 'DataSet',
            'dataset': []
            }).then(function(data) {
                ScreenService.closePopup();
                if(data.dataset && data.dataset.arquivo){
                    $window.open($window.serviceUrl + "/abrirArquivo?requestType=DataSet&dataset[0][CMARQUIVO]=" + data.dataset.arquivo.NMARQUIVO);
                }
            }).catch(function(e) {
                var error;
                if (e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
    };
    
    this.importarPlanilhaLinhatarifa = function() {
        var widgetPop = templateManager.container.getActiveWidget();
        var widgetPai = templateManager.container.getWidget('empresatransporte');
        if(widgetPop.isValid()){
            if(this.validaArquivo(widgetPop.currentRow.DSPATH[0].name)) {
                restEngine.post('product#/importarPlanilhaLinhatarifa', {'requestType': 'DataSet', 'dataset': [widgetPop.currentRow]}).
                then(function(data) {
                    if (data.messages) {
                        ScreenService.closePopup(true);
                        ScreenService.showMessage(data.messages[0].message, data.messages[0].type);
                        if (data.dataset && data.dataset.msg) {
                            openPopupMensagens(data.dataset.msg, 'messagesImportacaoLinhatarifa');
                        } else {
                            widgetPai.activate();
                        }
                        widgetPai.reload();
                    } else
                        ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                }).
                catch(function(e) {   
                    var error;
                    if (e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    
                });
            }
        }
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('LinhatarifaController', LinhatarifaController);
});

// FILE: assets/js/controllers/LocalAvaliacaoController.js
function LocalAvaliacaoController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, General,Messages) {
    
    var self = this;
    
    this.adicionarRow = function(args) {
        var widget = args.owner.widget;
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
    };

	this.setLocalAvaliacao = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
            if (ABUtilController.validaDtIniMenorIgualDtFin(widget.currentRow.DTINIVIGENCIA, widget.currentRow.DTFIMVIGENCIA)) {
                if (!widget.backupRow) {
                    widget.currentRow.__is_new = true;
                } else {
                    widget.currentRow.__is_new = false;
                }
                restEngine.post('product#/setLocalAvaliacao', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                    then(function (data) {
                        if (data.notifications[0].type === "success") {
                            ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                            if (widget.currentRow.__is_new) {
                                ABUtilController.masterDetailVoltarList(widget);
                                widget.reload();
                            } else {
                                widget.backupRow = null;
                                widget.view();
                            }
                        } else {
                            ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                        }
                    }).
                    catch(function(e) {
                        var error;
                        if(e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;
                            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    });
            }else{
                ScreenService.showMessage(Messages.DTINI_POST_DTFIM_ERROR);
                return false;
            }        
        }
        // templateManager.container.getWidget('localAvaliacao').reload();    
    };
    
    this.deleteLocalAvaliacao = function(args) {
        ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
            var widget = templateManager.container.getActiveWidget();
            if (widget.isValid()) {
                widget.currentRow.__is_new = false;
                restEngine.post('product#/deleteLocalAvaliacao', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                    then(function (data) {
                        if (data.messages) {
                            ScreenService.showMessage(Messages.REMOVE_ROW_ERROR + '. ' + data.messages[0].message, data.messages[0].type);
                        } else {
                            ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                            ABUtilController.masterDetailVoltarList(widget);
                            widget.reload();
                        }
                    }).
                    catch(function(e) {
                        var error;
                        if(e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;
    
                        ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    });
                }
        }, null);
    };
    

}

Configuration(function(ContextRegister) {
    ContextRegister.register('LocalAvaliacaoController', LocalAvaliacaoController);
});

// FILE: assets/js/controllers/LocalCatController.js
function LocalCatController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, General,Messages) {

    this.adicionarRow = function(args) {
        var widget = args.owner.widget;
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
    };

	this.setLocalCat = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
                if (!widget.backupRow) {
                    widget.currentRow.__is_new = true;
                } else {
                    widget.currentRow.__is_new = false;
                }
                restEngine.post('product#/setLocalCat', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                    then(function (data) {
                        if (data.notifications[0].type === "success") {
                            ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                            if (widget.currentRow.__is_new) {
                                ABUtilController.masterDetailVoltarList(widget);
                                widget.reload();
                            } else {
                                ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                                widget.backupRow = null;
                                widget.view();
                            }
                        } else {
                            ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                        }
                    }).
                    catch(function(e) {
                        var error;
                        if(e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;
                            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    });
            }
    };
    
    this.deleteLocalCat = function(args) {
        var widget = args.owner.widget;
        widget.currentRow.__is_new = false;
        restEngine.post('product#/deleteLocalCat', {'requestType':'DataSet','dataset':[widget.currentRow]}).
            then(function(data){
                if(data.notifications[0].type === "success"){
                    ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                    ABUtilController.masterDetailVoltarList(widget);
                    widget.reload();
                } else {
                    ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                }
            }).
            catch(function(e) {
                var error;
                if(e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('LocalCatController', LocalCatController);
});

// FILE: assets/js/controllers/LocalidadeController.js
function LocalidadeController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, General, Messages) {

    var self = this;

    this.adicionarRow = function(args) {
        var widget = args.owner.widget;
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
    };

    this.setPais = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
            if (!widget.backupRow) {
                widget.currentRow.__is_new = true;
            }
            else {
                widget.currentRow.__is_new = false;
            }
            widget.currentRow.NRORG = 0;
            restEngine.post('product#/setPais', {
                'requestType': 'DataSet',
                'dataset': [widget.currentRow]
            }).
            then(function(data) {
                if (data.notifications && data.notifications[0].type === "success") {
                    ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                    if (widget.currentRow.__is_new) {
                        ABUtilController.masterDetailVoltarList(widget);
                        ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                        widget.reload();
                        widget.view();
                    }
                    else {
                        ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                        widget.backupRow = null;
                        widget.reload();
                        widget.view();
                    }
                }else if(data.messages){
                    ScreenService.showMessage(data.messages[0].message, data.messages[0].type);
                }else {
                    ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                }
            }).
            catch(function(e) {
                var error;
                if (e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });

        }
    };

    this.deletePais = function(args) {
        var widget = templateManager.container.getActiveWidget();
        if (widget.isValid()) {
            widget.currentRow.__is_new = false;
            restEngine.post('product#/deletePais', {
                'requestType': 'DataSet',
                'dataset': [widget.currentRow]
            }).
            then(function(data) {
                if (data.messages) {
                    ScreenService.showMessage(data.messages[0].message, data.messages[0].type);
                }
                else {
                    ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                    ABUtilController.masterDetailVoltarList(widget);
                    widget.reload();
                }
            }).
            catch(function(e) {
                var error;
                if (e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;

                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
        }
    };
    
    this.setEstado = function(args) {
        var widget = args.owner.widget;
        var widgetMain = templateManager.container.getWidget('localidade');
        widget.currentRow.CDPAIS = widgetMain.currentRow.CDPAIS;
        widget.currentRow.NRORG = 0;
        if (widget.isValid()) {
            if (!widget.backupRow) {
                widget.currentRow.__is_new = true;
            }
            else {
                widget.currentRow.__is_new = false;
            }
            restEngine.post('product#/setEstado', {
                'requestType': 'DataSet',
                'dataset': [widget.currentRow]
            }).
            then(function(data) {
                if (data.notifications && data.notifications[0].type === "success") {
                    ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                    if (widget.currentRow.__is_new) {
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    }
                    else {
                        ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                        widget.backupRow = null;
                        widget.reload();
                        widget.view();
                    }
                }else if(data.messages){
                    ScreenService.showMessage(data.messages[0].message, data.messages[0].type);
                }else {
                    ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                }
            }).
            catch(function(e) {
                var error;
                if (e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });

        }
    };

    this.deleteEstado = function(args) {
        var widget = templateManager.container.getActiveWidget();
        if (widget.isValid()) {
            widget.currentRow.__is_new = false;
            restEngine.post('product#/deleteEstado', {
                'requestType': 'DataSet',
                'dataset': [widget.currentRow]
            }).
            then(function(data) {
                if (data.messages) {
                    ScreenService.showMessage(data.messages[0].message, data.messages[0].type);
                }
                else {
                    ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                    ABUtilController.masterDetailVoltarList(widget);
                    widget.reload();
                }
            }).
            catch(function(e) {
                var error;
                if (e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;

                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
        }
    };    
    
    this.setMunicipio = function(widget) {
        var widgetMain = templateManager.container.getWidget('localidade');
        var widgetEstado = templateManager.container.getWidget('estado');
        widget.currentRow.CDPAIS = widgetMain.currentRow.CDPAIS;
        widget.currentRow.SGESTADO = widgetEstado.currentRow.SGESTADO;
        widget.currentRow.NRORG = 0;
        if (widget.isValid()) {
            if (!widget.backupRow) {
                widget.currentRow.__is_new = true;
            }
            else {
                widget.currentRow.__is_new = false;
            }
            restEngine.post('product#/setMunicipio', {
                'requestType': 'DataSet',
                'dataset': [widget.currentRow]
            }).
            then(function(data) {
                if (data.notifications && data.notifications[0].type === "success") {
                    ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                    if (widget.currentRow.__is_new) {
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    }
                    else {
                        ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.backupRow = null;
                        widget.reload();
                        widget.view();
                    }
                }else if(data.messages){
                    ScreenService.showMessage(data.messages[0].message, data.messages[0].type);
                }else {
                    ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                }
            }).
            catch(function(e) {
                var error;
                if (e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });

        }
    };
   
    this.deleteMunicipio = function(args) {
        var widget = templateManager.container.getActiveWidget();
        if (widget.isValid()) {
            widget.currentRow.__is_new = false;
            restEngine.post('product#/deleteMunicipio', {
                'requestType': 'DataSet',
                'dataset': [widget.currentRow]
            }).
            then(function(data) {
                if (data.messages) {
                    ScreenService.showMessage(Messages.REMOVE_ROW_ERROR + '. ' + data.messages[0].message, data.messages[0].type);
                }
                else {
                    ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                    ABUtilController.masterDetailVoltarList(widget);
                    widget.reload();
                }
            }).
            catch(function(e) {
                var error;
                if (e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;

                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
        }
    };    


    this.setDataSourceFilterEstado = function(widgetMain){
        var widgetEstado = templateManager.container.getWidget('estado');
        widgetEstado.dataSourceFilter[0].value = widgetMain.currentRow.CDPAIS;
    };
    
    this.setDataSourceFilterMunicipio = function(widgetEstado){
        var widgetMunicipio = templateManager.container.getWidget('municipio');
        widgetMunicipio.dataSourceFilter[0].value = widgetEstado.currentRow.CDPAIS;
        widgetMunicipio.dataSourceFilter[1].value = widgetEstado.currentRow.SGESTADO;
    };
    
    this.readOnlyCodigoNomeSigla = function(widget, action){

        switch(widget){
            case 'pais':
                var widgetPais = templateManager.container.getWidget('localidade');
                if(action === 'add')
                    widgetPais.getField('CDPAIS').readOnly = false;
                else 
                    widgetPais.getField('CDPAIS').readOnly = true;
                break;
            
            case 'estado':
                var widgetEstado = templateManager.container.getWidget('estado');
                if(action === 'add')
                    widgetEstado.getField('SGESTADO').readOnly = false;
                else 
                    widgetEstado.getField('SGESTADO').readOnly = true;
                break;

            case 'municipio':
                var widgetMunicipio = templateManager.container.getWidget('municipio');
                if(action === 'add')
                    widgetMunicipio.getField('CDMUNICIPIO').readOnly = false;
                else 
                    widgetMunicipio.getField('CDMUNICIPIO').readOnly = true;
                break;
        }
        
    };

    this.setarVisibilidadeWidgMunicipio = function(widgetMunicipio, event){
        switch(event){
            case 'actionAdd':
                widgetMunicipio.isVisible = false;
                break;
            
            case 'moveRow':
                widgetMunicipio.isVisible = true;
                break;
        }
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('LocalidadeController', LocalidadeController);
});


// FILE: assets/js/controllers/LogRetrocessoCalculoController.js
function LogRetrocessoCalculoController(ScreenService, templateManager, restEngine, ABUtilController, Messages) {

    var fieldsDados = {
        ORDENS:{
            ESTRUT_ALFABETICA_TPVINC:[
                {
                    name: "DSINICIO", 
                    label: "Estrut. Legal"
                },    
                {
                    name: "DSFIM", 
                    label: "Estrut. Gerencial"
                },    
                {
                    name: "DSINICIO2", 
                    label: "Nome Inicial"
                },    
                {
                    name: "DSFIM2", 
                    label: "Nome Final"
                },    
                {
                    name: "DSINICIO3", 
                    label: "Tp. Vínculo"
                }    
            ],
            ESTRUTURA:[
                {
                    name: "DSINICIO", 
                    label:"Estrut. Legal",
                },
                {
                    name: "DSFIM", 
                    label:"Estrut. Gerencial"
                }
            ],
            LISTA_ESTRUTURA:[
                {
                    name: "DSINICIO", 
                    label: "Lista Estrut. Legal"
                },    
                {
                    name: "DSFIM", 
                    label: "Lista Estrut. Gerencial"
                }    
            ],
            LISTA_NRESTRUTSIND:[
                {
                    name: "DSINICIO", 
                    label: "Estrutura Legal"
                },    
                {
                    name: "DSFIM", 
                    label: "Lista Estrutura Sindical"
                }    
            ],
            MATRICULA:[
                {
                    name: "DSINICIO", 
                    label: "Matrícula Inicial"
                },    
                {
                    name: "DSFIM", 
                    label: "Matrícula Final"
                }    
            ],
            DATA_ADMISSAO:[
                {
                    name: "DSINICIO", 
                    label: "Admissão Inicial"
                },
                {
                    name: "DSFIM", 
                    label: "Admissão Final"
                }
            ],
            ALFABETICA:[
                {
                    name: "DSINICIO", 
                    label: "Nome Inicial"
                },
                {
                    name: "DSFIM", 
                    label: "Nome Final"
                }
            ],
            LISTA_VINCULO:[
                {
                    name: "DSINICIO", 
                    label: "Lista de Vínculos"
                }
            ]
        },
        CALC_FERIAS: [
            {
                name: "QTDIAGOZOFERIAS", 
                label: "Dias de férias"
            },
            {
                name: "DTPAGAMENTO", 
                label: "Dt. pagamento"
            },
            {
                name: "DTAVISOFERIAS", 
                label: "Data de aviso"
            },
            {
                name: "DTINIGOZOFERIAS", 
                label: "Início gozo"
            },
            {
                name: "DTFIMGOZOFERIAS", 
                label: "Fim gozo"
            },
            {
                name: "IDULTPGTOMES", 
                label: "Último Pagto Mês",
                "class": 6
            },
            {
                name: "IDMEMORIACALC", 
                label: "Mémoria de Cálculo",
                "class": 6
            },
            {
                name: "IDADIANT13SALAR", 
                label: "Adiantar 13 Salário",
                "class": 6
            }
        ],
        CALC_RESCISAO: [
            {
                name: "DTPAGAMENTO", 
                label: "Dt. pagamento"
            },
            {
                name: "DTRESCISAOINI", 
                label: "Início Rescisão",
            },    
            {
                name: "DTRESCISAOFIM", 
                label: "Fim Rescisão"
            },
            {
                name: "IDULTPGTOMES", 
                label: "Último Pagto Mês",
                "class": 6
            },    
            {
                name: "IDMEMORIACALC", 
                label: "Mémoria de Cálculo",
                "class": 6
            },    
        ],
        CALC_FOLHA:[
            {
                name: "DTPAGAMENTO", 
                label: "Dt. pagamento"
            },
            {
                name: "IDULTPGTOMES", 
                label: "Último Pagto Mês",
                "class": 6
            },    
            {
                name: "IDMEMORIACALC", 
                label: "Mémoria de Cálculo",
                "class": 6
            },    
            {
                name: "IDDIFSAL", 
                label: "Diferença Salarial",            
                "class": 6
            },    
            {
                name: "IDDIFFERIAS", 
                label: "Diferença Férias",
                "class": 6
            },    
        ],
        CALC_PLR:[
            {
                name: "DTPAGAMENTO", 
                label: "Dt. pagamento"
            },
            {
                name: "IDULTPGTOMES", 
                label: "Último Pagto Mês",
                "class": 6
            },    
            {
                name: "IDMEMORIACALC", 
                label: "Mémoria de Cálculo",
                "class": 6
            },    
            {
                name: "IDDIFSAL", 
                label: "Diferença Salarial",            
                "class": 6
            },    
            {
                name: "IDDIFFERIAS", 
                label: "Diferença Férias",
                "class": 6
            },    
        ],
        CALC_ADIANTAMENTO:[
            {
                name: "DTPAGAMENTO", 
                label: "Dt. pagamento"
            },
            {
                name: "IDULTPGTOMES", 
                label: "Último Pagto Mês",
                "class": 6
            },    
            {
                name: "IDMEMORIACALC", 
                label: "Mémoria de Cálculo",
                "class": 6
            },    
            {
                name: "IDDIFSAL", 
                label: "Diferença Salarial",
                "class": 6
            },    
            {
                name: "IDDIFFERIAS", 
                label: "Diferença Férias",
                "class": 6
            }    
        ],
        CALC_ADIANT_13SAL:[
            {
                name: "DTPAGAMENTO", 
                label: "Dt. pagamento"
            },
            {
                name: "IDULTPGTOMES", 
                label: "Último Pagto Mês",
                "class": 6
            },    
            {
                name: "IDMEMORIACALC", 
                label: "Mémoria de Cálculo",
                "class": 6
            },    
            {
                name: "IDDIFSAL", 
                label: "Diferença Salarial",            
                "class": 6
            },    
            {
                name: "IDDIFFERIAS", 
                label: "Diferença Férias",
                "class": 6
            }    
        ],    
        CALC_13SAL:[
            {
                name: "DTPAGAMENTO", 
                label: "Dt. pagamento"
            },
            {
                name: "IDULTPGTOMES", 
                label: "Último Pagto Mês",
                "class": 6
            },    
            {
                name: "IDMEMORIACALC", 
                label: "Mémoria de Cálculo",
                "class": 6
            },    
            {
                name: "IDDIFSAL", 
                label: "Diferença Salarial",            
                "class": 6
            },    
            {
                name: "IDDIFFERIAS", 
                label: "Diferença Férias",
                "class": 6
            }    
        ],
        CALC_CONTAB:[
            {
                name: "DSINICIO2", 
                label: "Tipo Movimento"
            },
            {
                name: "DSFIM2", 
                label: "Ocorrência"
            },    
            {
                name: "DSINICIO3", 
                label: "Forma de Contabilização"
            }
        ],
        CALC_BENEFICIO:[
            {
                name: "DTPAGAMENTO", 
                label: "Dt. pagamento"
            },
            {
                name: "DSTPBENEFICIO", 
                label: "Tipo Benefício"
            },    
            {
                name: "TPPERIODOBENEF", 
                label: "Tipo Período Benefício"
            },    
            {
                name: "DTINICIOVALE", 
                label: "Dt. Inicial"
            },    
            {
                name: "DTFINALVALE", 
                label: "Dt. Final"
            }    
        ],
        CALC_VT:[
            {
                name: "DTPAGAMENTO", 
                label: "Dt. pagamento"
            },
            {
                name: "DSTIPOLINHAVINC", 
                label: "Tipo de Linha"
            },    
            {
                name: "DTINICIOVALE", 
                label: "Dt. Inicial"
            },    
            {
                name: "DTFINALVALE", 
                label: "Dt. Final"
            }    
        ]
    };
    
    this.setarCampos = function(widget){
        this.esconderFieldsAux(widget);
        popularFields(fieldsDados.ORDENS[widget.currentRow.DSORDEM], fieldsDados[widget.currentRow.IDTPFORMCALCULO], widget);
    };
    
    this.esconderFieldsAux = function(widget){
        widget.fields.forEach(function(field){
            if(field.used){
                field.used = "N";
                field.class = "12";
                field.isVisible = false;
            }
        });
    };
    
    var popularFields = function(camposOrdem, camposTemplate, widget){

        camposOrdem.forEach(function(campoOrdem){
            var campoOrdemInserido = false;
            widget.fields.forEach(function(field){
                if(!campoOrdemInserido && field.used && field.used == 'N'){
                    field.name = campoOrdem.name;
                    field.label = campoOrdem.label;
                    field.isVisible = true;
                    field.used = 'S';
                    campoOrdemInserido = true;
                }
            });
        });

        camposTemplate.forEach(function(campoTemplate){
            var campoTemplateInserido = false;
            widget.fields.forEach(function(field){
                if(!campoTemplateInserido && field.used && field.used == 'N'){
                    field.name = campoTemplate.name;
                    field.label = campoTemplate.label;
                    field.isVisible = true;
                    field.used = 'S';
                    if(campoTemplate.class) field.class = campoTemplate.class;
                    campoTemplateInserido = true;
                }
            });
        });
        
        widget.redraw();
    };

}

Configuration(function(ContextRegister) {
    ContextRegister.register('LogRetrocessoCalculoController', LogRetrocessoCalculoController);
});

// FILE: assets/js/controllers/LoginProductController.js
function LoginProductController(eventAggregator, Query, HcmRepository, RepositoryFactory, ScreenService, localStorageEngine, DashboardController, ABUtilController)
{
    var self = this;
    
    eventAggregator.subscribe('authSuccessProduct', function(session)
    {
        var user = session.user;
        var OperadoresRepository = RepositoryFactory.factory('product#/getOperadores', 'LOCAL', 1, 30000);
        var QueryOperadores = Query.build().where('nrorg').equals(user.nrorgtrab);

        setLocalVar("HCM_NMOPERADOR", user.nmoperador);
        setLocalVar("HCM_CDOPERADOR", user.cdoperador);
        setLocalVar("HCM_NRORG_OPER", user.nrorgoper);
        setLocalVar("HCM_NRORG_TRAB", user.nrorgtrab);
        setLocalVar("HCM_DSEMAILOPER", user.dsemailoper);
        setLocalVar('CDOPERADOR', user.cdoperador);
        setLocalVar('NMOPERADOR', user.nmoperador);
        setLocalVar('CDFILIAL', user.cdfilialselecionada);
        setLocalVar('NMFILIAL', user.nmfilialselecionada);
        setLocalVar('NRORG', user.nrorg);
        setLocalVar('NRORGTRAB', user.nrorgtrab);

        /* Zeedhi Access Control */
        localStorageEngine.setLocalVar("userId", user.cdoperador);
        localStorageEngine.setLocalVar("accessProfiles", user.perfilDeAcesso);
        //localStorageEngine.setLocalVar("productIdLoginUrl", Config.loginProductId);

        HcmRepository.hcmFactory(user.cdoperador).then(function(data)
        {
            ABUtilController.setLocalStorageHCM(data);
            self.loadGraficosDashboard();
            HcmRepository.buildUserDataAndHeaderInfo(data);
            ScreenService.openWindow('product#dashboard');
        });

        QueryOperadores.limit(1000);
        OperadoresRepository.download(QueryOperadores);

    });

    eventAggregator.subscribe('setParamsProduct', function(session)
    {
        var user = session.user;

        var OperadoresRepository = RepositoryFactory.factory('product#/getOperadores', 'LOCAL', 1, 30000);
        var QueryOperadores = Query.build().where('nrorg').equals(user.nrorgtrab);

        HcmRepository.hcmFactory(user.cdoperador).then(function(data)
        {
            ABUtilController.setLocalStorageHCM(data);
            HcmRepository.buildUserDataAndHeaderInfo(data);
            self.loadGraficosDashboard();
        });

        QueryOperadores.limit(1000);
        OperadoresRepository.download(QueryOperadores);
    });
    
    this.loadGraficosDashboard = function(){
        var args;
        DashboardController.getTotalProcessos(args);
        DashboardController.getTotalCurriculos(args);
        DashboardController.getProcessosMes(args);
        DashboardController.getProcessosCancelados(args);
        DashboardController.getAdmissoesPeriodo(args);
        DashboardController.getProcessosSuspensos(args);
        DashboardController.reloadCharts();
    };
}

Configuration(function(ContextRegister)
{
    ContextRegister.register('LoginProductController', LoginProductController);
});


// FILE: assets/js/controllers/LogradouroController.js
function LogradouroController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, General,Messages) {

    this.adicionarRow = function(args) {
        var widget = args.owner.widget;
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
    };

	this.setLogradouro = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
                if (!widget.backupRow) {
                    widget.currentRow.__is_new = true;
                } else {
                    widget.currentRow.__is_new = false;
                }
                restEngine.post('product#/setLogradouro', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                    then(function (data) {
                        if (data.notifications && data.notifications[0].type === "success") {
                            ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                            if (widget.currentRow.__is_new) {
                                ABUtilController.masterDetailVoltarList(widget);
                                widget.reload();
                            } else {
                                ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                                widget.backupRow = null;
                                widget.view();
                            }
                        }else if(data.messages){
                            ScreenService.showMessage(data.messages[0].message, data.messages[0].type);
                        }else {
                            ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                        }
                    }).
                    catch(function(e) {
                        var error;
                        if(e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;
                            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    });
            }
    };
    
    this.deleteLogradouro = function(args) {
        var widget = args.owner.widget;
        widget.currentRow.__is_new = false;
        restEngine.post('product#/deleteLogradouro', {'requestType':'DataSet','dataset':[widget.currentRow]}).
            then(function(data){
                if(data.notifications && data.notifications[0].type === "success"){
                    ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                    ABUtilController.masterDetailVoltarList(widget);
                    widget.reload();
                } else {
                    ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                }
            }).
            catch(function(e) {
                var error;
                if(e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('LogradouroController', LogradouroController);
});

// FILE: assets/js/controllers/LoteLancEventoController.js
/* jshint esversion: 6 */
function LoteLancEventoController (ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, $window, ABUtilController, Messages, General) {
    
    var self = this;
    
    this.NMIMPORTACAO = null;
    
    this.adicionarRow = function(args) {
        var widget = args.owner.widget;
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
    };
    
    this.widgetsvisiblefalse = function(args) {
        var widget = args.owner.widget;
        widget.widgets[0].showAsTab = false;
    };

    this.widgetsvisibletrue = function(args) {
        var widget = args.owner.widget;
        widget.widgets[0].showAsTab = true;
    };
    
    
    this.openPopUpGeraItemLote = function(args) {
        var widgetPopup = templateManager.container.getWidget('gerarItemLote');
        ABUtilController.masterDetailOpenPopup(widgetPopup);
    };
    
    this.geraItemLote = function(args) {
        var widget = ABUtilController.checkWidget(args);
        var widgetMain = templateManager.container.getWidget('itemLoteLanc');
        var widgetLote = templateManager.container.getWidget("loteLancEvento");
        widget.currentRow.NRLOTELANCEVENTO = widgetLote.currentRow.NRLOTELANCEVENTO;
        if(widget.isValid()){
            ScreenService.confirmMessage('Deseja realmente gerar items?', 'CONFIRMATION', 
                function(){
                    restEngine.post("product#/geraItemLote",
                            {'requestType':'DataSet','dataset':[ZhUtil.clearRow(widget.currentRow)]},
                        function(data) {
                            if(data.messages){
                                ScreenService.successNotification(data.messages[0].message);
                                ScreenService.closePopup();
                                ScreenService.closePopup();
                            }
                            widgetMain.activate();
                            widgetMain.reload();
                            ScreenService.closePopup(true);
                            if (data.dataset && data.dataset.msg) {
                                widget.reload();
                                openPopupMensagens(data.dataset.msg);
                            }
                        }.bind(this),undefined,
                        function(e) {
                            var error;
                            if(e.data.error === undefined)
                                error = e;
                            else 
                                error = e.data.error;
                            if(e.data.errorCode == '10')
                                ScreenService.showMessage(error, 'ALERT');
                            else
                                ScreenService.showMessage('Ocorreu um erro inesperado, contate o administrador informando o trecho abaixo: <br><br>' + error + '<br><br>', 'ERROR');
                        }
                    );
                }.bind(this)
            );
        }
    };
    
    this.deleteLote = function(args) {
        ScreenService.confirmMessage('Deseja realmente excluir o lote?', 'CONFIRMATION', 
            function(){
                var widget = args.owner.widget;
                widget.currentRow.__is_new = false;
                restEngine.post('product#/deleteLote', {'requestType':'DataSet','dataset':[widget.currentRow]}).
                    then(function(data){
                        if(data.messages){
                            ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                            ABUtilController.masterDetailVoltarList(widget);
                            widget.reload();
                        } else {
                            ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                        }
                    }).
                    catch(function(e) {
                        var error;
                        if(e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;
                            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    }
                );
            }
        );
    };
    
    this.cancelarLote = function(args){
        ScreenService.confirmMessage('Deseja realmente cancelar o lote ?', 'CONFIRMATION', 
            function(){
                var widget = ABUtilController.checkWidget(args);
                widget.currentRow.CDOPERADOR_LOG = getLocalVar("HCM_CDOPERADOR");
                widget.currentRow.NRORGTRAB = getLocalVar("HCM_NRORG_TRAB");
                widget.currentRow.NRORGPADRAO = getLocalVar("HCM_NRORG_PADRAO");
                widget.currentRow.DTATUAL = getLocalVar("HCM_DATA_ATUAL");
                widget.currentRow.DTMESCOMPETEC = getLocalVar("HCM_DTCOMPETENCIA_OPER");
                restEngine.post("product#/cancelarLote",
                        {'requestType':'DataSet','dataset':[widget.currentRow]}
                ).then(
                    function(data){
                        var msgTypeMessage = '';
                        var msgTypeAlert = '';
                        
                        if(data.messages){
                            data.messages.forEach(function(obj){
                                if(obj.type == 'M') msgTypeMessage += obj.message + ' \n\n';
                                if(obj.type == 'W') msgTypeAlert += obj.message + ' \n\n';
                            });
                        }
                        
                        if (msgTypeAlert.length > 0){ 
                            ScreenService.showMessage(msgTypeMessage+msgTypeAlert, 'W');
                            ScreenService.closePopup();
                            ABUtilController.masterDetailVoltarList(widget);
                            widget.reload();
                        }
                        else if (data.notifications && data.notifications[0].type === "success") {
                            ScreenService.showMessage(msgTypeMessage+Messages.HCM01020_EXPORTACAO_LOTE_CANCELADA_SUCCESS, 'SUCCESS');
                            ScreenService.closePopup();
                            ABUtilController.masterDetailVoltarList(widget);
                            widget.reload();
                        }else {
                            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR('ERROR'), 'ERROR');
                        }
                                                    
                                    
                        if(data.dataset && data.dataset.cancelarExportLoteLancEventos && data.dataset.cancelarExportLoteLancEventos.length > 0){
                            var popUp = templateManager.container.getWidget('mensagens_loteLancEventos');
                            popUp.dataSource.data = data.dataset.cancelarExportLoteLancEventos;
                            ABUtilController.masterDetailOpenPopup(popUp);
                        }
                }).catch(function(e) {
                        var error;
                        if(!e.data || e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;
        
                        ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
            }
        );
    };
    
    this.deleteItemLoteChecked = function(args) {
        ScreenService.confirmMessage('Deseja realmente excluir os itens?', 'CONFIRMATION', 
            function(){
                var widget = args.owner.widget;
                restEngine.post('product#/deleteItensLoteChecked', {'requestType':'DataSet','dataset':[widget.getCheckedRows()]}).
                    then(function(data){
                        if(data.messages){
                            ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                            widget.reload();
                        } else {
                            ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                        }
                    }).
                    catch(function(e) {
                        var error;
                        if(e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;
                            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    }
                );
            }
        );
    };

    this.deleteItemLoteEvento = function(args) {
        var widget = ABUtilController.checkWidget(args);
        var data = {}; 
        ScreenService.confirmMessage(Messages.DELETE_ROW, 'CONFIRMATION', 
            function(){
                widget.dataSource.remove(widget.currentRow).then(function (data){
                    if(data.dataset.fpaItemLoteLanc_setItemLoteLanc.type === "success"){
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                        ScreenService.showMessage(Messages.REMOVE_ROW_SUCCESS); 
                    } else {
                        ScreenService.showMessage(Messages.REMOVE_ROW_ERROR); 
                    }
                }.bind(this));
            }.bind(this)
        );
    };

    this.edit = function(args){
        var widget = ABUtilController.checkWidget(args);
        ABUtilController.masterDetailEdit(args.owner.widget);
        this.enableObservacao(args);
    };


    this.enableObservacao = function(args){
        var widget = ABUtilController.checkWidget(args);
        if(widget.currentRow.IDSTATUSLOTELANC == 'REPROVADO'){
            widget.getField("DSOBSLOTELANC").readOnly = false;
            widget.getField("DSOBSLOTELANC").validations = {
                "required": true
            };
        } else {
            widget.getField("DSOBSLOTELANC").readOnly = true;
            widget.getField("DSOBSLOTELANC").validations = {};
        }
    };

    this.exportarLote = function(args){
        ScreenService.confirmMessage('Deseja realmente exportar o lote para a folha ?', 'CONFIRMATION', 
            function(){
                var widget = ABUtilController.checkWidget(args);
                var widgetItemLote = templateManager.container.getWidget("itemLoteLanc");
                widgetItemLote.reload().then(function(){
                    widget.currentRow.CDOPERADOR_LOG = getLocalVar("HCM_CDOPERADOR");
                    widget.currentRow.NRORGTRAB = getLocalVar("HCM_NRORG_TRAB");
                    widget.currentRow.NRORGPADRAO = getLocalVar("HCM_NRORG_PADRAO");
                    widget.currentRow.DTATUAL = getLocalVar("HCM_DATA_ATUAL");
                    widget.currentRow.DTMESCOMPETEC = getLocalVar("HCM_DTCOMPETENCIA_OPER");
                    widget.currentRow.__is_new = true;
                    var saveData = Object.assign({}, widget.currentRow, {
                        "ITEM": widgetItemLote.dataSource.data
                    });
                    restEngine.post("product#/exportarLote",
                            {'requestType':'DataSet','dataset':[saveData]}
                    ).then( function(data) {

                        if (data.messages){ 
                            ScreenService.showMessage(data.messages[0].message, data.messages[0].type);
                            ScreenService.closePopup();
                            ABUtilController.masterDetailVoltarList(widget);
                            widget.reload();
                        }
                        else if (data.notifications && data.notifications[0].type === "success") {
                            ScreenService.showMessage(Messages.HCM01020_EXPORTACAO_LOTE_SUCCESS, 'SUCCESS');
                            ScreenService.closePopup();
                            ABUtilController.masterDetailVoltarList(widget);
                            widget.reload();
                        }else {
                            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR('ERROR'), 'ERROR');
                        }
                                                    
                                    
                        if(data.dataset && data.dataset.exportarLoteLancEventos && data.dataset.exportarLoteLancEventos.length > 0){
                            var popUp = templateManager.container.getWidget('mensagens_loteLancEventos');
                            popUp.dataSource.data = data.dataset.exportarLoteLancEventos;
                            ABUtilController.masterDetailOpenPopup(popUp);
                        }
                            
                    }).catch(function(e) {
                        var error;
                        if(!e.data || e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;
        
                        ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    });
                });
            }
        );
    };
    
    this.setItemLoteEventoInline = function(args){
        var widget = ABUtilController.checkWidget(args);
        var widgetLote = templateManager.container.getWidget("loteLancEvento");
        var row = [];
        if(widget.isValid())  {
            
            widget.currentRow.NRLOTELANCEVENTO = widgetLote.currentRow.NRLOTELANCEVENTO;
            
            for(var k in widget.dataSource.data){
                if(widget.dataSource.data[k].changed){
                    widget.dataSource.data[k].__is_new = false;
                    widget.dataSource.data[k].VRREFFOLHA = General.valueToFloat(widget.dataSource.data[k].VRREFFOLHA);
                    widget.dataSource.data[k].VREVENTOFOLHA = General.valueToFloat(widget.dataSource.data[k].VREVENTOFOLHA);
                    row.push(widget.dataSource.data[k]);
                }
            }
            restEngine.post('product#/setIteLoteInline', {
                'requestType': 'DataSet',
                'dataset': [row]
            }).then(function (data){
                if (data.messages) {
                    ScreenService.showMessage(data.messages[0].message, data.messages[0].type);
                } else if (data.notifications[0].type === "success") {
                    ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                } else {
                    ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                }
                widget.list();
                widget.activate();
                widget.reload();
            }.bind(this)).catch(function(e) {
                var error;
                if(e.data.error === undefined)
                    error = e;
                else 
                    error = e.data.error;
                
                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error));
            });
        }
    };
    
    this.setItemLoteEvento = function(args){
        var widget = ABUtilController.checkWidget(args);
        var widgetLote = templateManager.container.getWidget("loteLancEvento");
        if(widget.isValid())  {
            
            if (!widget.backupRow) {
                widget.currentRow.__is_new = true;
            } else {
                widget.currentRow.__is_new = false;
            }
            widget.currentRow.NRLOTELANCEVENTO = widgetLote.currentRow.NRLOTELANCEVENTO;
            widget.currentRow.CDOPERADOR_LOG = getLocalVar("HCM_CDOPERADOR");
            widget.currentRow.NRORGTRAB = getLocalVar("HCM_NRORG_TRAB");
            widget.currentRow.NRORGPADRAO = getLocalVar("HCM_NRORG_PADRAO");
            widget.currentRow.DTATUAL = getLocalVar("HCM_DATA_ATUAL");
            
            if(widget.currentRow.VRREFFOLHALOTE && typeof widget.currentRow.VRREFFOLHALOTE === "string")
                widget.currentRow.VRREFFOLHALOTE.replace(",", ".");
            
            restEngine.post('product#/setItemLoteLanc', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).then(function (data) {
                if (data.dataset && data.dataset.msg) {
                    widget.reload();
                    ScreenService.closeSwipe();
                    openPopupMensagens(data.dataset.msg);
                } else if (data.notifications[0].type === "success") {
                    if (widget.currentRow.__is_new) {
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    } else {
                        ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                        widget.backupRow = null;
                        widget.view();
                    }
                } else {
                    ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                }
                
            }.bind(this)).catch(function(e) {
                var error;
                if(e.data.error === undefined)
                    error = e;
                else 
                    error = e.data.error;
                if(e.data.errorCode == '10')
                    ScreenService.showMessage(error, 'ALERT');
                else
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error));
            });
        }
    };

    this.setLoteLancEvento = function(args){
        var widget = ABUtilController.checkWidget(args);
        if(widget.isValid())  {
            
            if (!widget.backupRow) {
                widget.currentRow.__is_new = true;
            } else {
                widget.currentRow.__is_new = false;
            }
            return widget.saveRow().then(function (data){
                if (data.notifications[0].type === "success") {
                    if (widget.currentRow.__is_new) {
                        self.widgetsvisibletrue(args);
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    } else {
                        ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                        widget.backupRow = null;
                        widget.view();
                    }
                    self.mudaVisibilidadeActionsLote();
                } else {
                    ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                }
            }.bind(this)).catch(function(e) {
                var error;
                if(e.data.error === undefined)
                    error = e;
                else 
                    error = e.data.error;
                if(e.data.errorCode == '10')
                    ScreenService.showMessage(error, 'ALERT');
                else
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error));
            });
        }
    };
    
    this.deleteItensZeradosLote = function(args){
        ScreenService.confirmMessage('Deseja realmente deletar os itens zerados do lote?', 'CONFIRMATION', 
            function(){
                var widget = ABUtilController.checkWidget(args);
                var widgetLote = templateManager.container.getWidget("loteLancEvento");
                    restEngine.post('product#/deleteItensZeradosLote', {
                    'requestType': 'DataSet',
                    'dataset': [widgetLote.currentRow]
                }).then(function (data){
                    if (data.messages) {
                        ScreenService.showMessage(data.messages[0].message, data.messages[0].type);
                    }
                    widget.reload();
                }.bind(this)).catch(function(e) {
                    var error;
                    if(e.data.error === undefined)
                        error = e;
                    else 
                        error = e.data.error;
                    
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error));
                });
            }
        );    
    };

    this.setNrlotelancevento = function(args){
        var widget = ABUtilController.checkWidget(args);
        var widgetItemLote = templateManager.container.getWidget("itemLoteLanc");
        widgetItemLote.dataSourceFilter.forEach(function(filter){
            if(filter.name === 'NRLOTELANCEVENTO'){
                filter.value = widget.currentRow.NRLOTELANCEVENTO;
            }
        });

    };
    
    this.openPopupImportacao = function(widget, action) {
        this.NMIMPORTACAO = action;
        var widgetPopupImportacao = templateManager.container.getWidget('popupImportacao');
        widgetPopupImportacao.currentRow.DSPATH = [];
        ScreenService.openPopup(widgetPopupImportacao);
    };
    
    this.openPopupExportacao = function(widget, action) {
        this.NMIMPORTACAO = action;
        var widgetPopupExportacao = templateManager.container.getWidget('popupGeracaoPlanilha');
        widgetPopupExportacao.currentRow.DSPATH = [];
        ScreenService.openPopup(widgetPopupExportacao);
    };

    this.validaArquivo = function(filePath) {
        var extension = filePath.split('.').pop().toUpperCase();
        if (extension !== 'XLS' && extension !== 'XLSX' && extension !== 'ACJ' && extension !== 'txt' && extension !== 'TXT') {
            ScreenService.showMessage('Formato de arquivo inválido');
            return false;
        } else {
            return true;
        }
    };

    this.importar = function(widget) {
        if (widget.isValid()) {
            if (this.validaArquivo(widget.currentRow.DSPATH[0].name)) {
                widget.currentRow.NMIMPORTACAO = this.NMIMPORTACAO;
                restEngine.post('product#/importaArquivoParaLote', {
                    'requestType': 'DataSet',
                    'dataset': [widget.currentRow]
                }).
                then(function(data) {
                    var mensagem;
                    widget.reload();
                    if(data.dataset && data.dataset.erros.length > 0){
                        var popUp = templateManager.container.getWidget("mensagens_loteLancEventos");
                        popUp.dataSource.data = data.dataset.erros;
                        self.abrirPopUpMensagensSomenteDescricao(popUp);
                        
                        if(data.messages && data.messages[0].message){
                            for(mensagem in data.messages[0].message){
                                ScreenService.successNotification(data.messages[0].message[mensagem], 10000);
                            }
                        }
                        templateManager.container.getWidget("loteLancEvento").reload();
                        
                    }else{
                        if (data.messages && data.messages[0].message) {
                            for(mensagem in data.messages[0].message){
                                ScreenService.successNotification(data.messages[0].message[mensagem], 10000);
                            }
                            ABUtilController.masterDetailClosePopup(templateManager.container.getWidget("mensagens_loteLancEventos"));
                            templateManager.container.getWidget("loteLancEvento").reload();
                        } else {
                            ScreenService.showMessage(Messages.IMPORTACAO_ERROR);
                        }
                    }
                    
                }).
                catch(function(e) {   
                    var error;
                    if (e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    
                });
            }
        }
    };
    
    this.abrirPopUpMensagensSomenteDescricao = function(popUp){
        ABUtilController.masterDetailOpenPopup(popUp);
        popUp.getField('NRMSGCALC').isVisible = false;
        popUp.getField('NRVINCULOM').isVisible = false;
        popUp.getField('IDTIPOMSG').isVisible = false;
        popUp.getField('DTINCLUSAO').isVisible = false;
    };
    
    this.exportarTemplate = function(widget) {
        if(widget.isValid()){
            if(!widget.currentRow.NMESTRUTLEGAL && !widget.currentRow.NMESTRUTGEREN && !widget.currentRow.NMESTRUTSIND && !widget.currentRow.NMTIPOHIERARQORG){
                ScreenService.showMessage('Favor inserir uma estrutura ou um tipo de hierarquia para realizar a exportação');
            } else {
                widget.currentRow.DTMESCOMPENTEC = getLocalVar("HCM_DTCOMPETENCIA_OPER");
                widget.currentRow.NRORGTRAB = getLocalVar("HCM_NRORG_TRAB");
                if(!widget.currentRow.NRTIPOHIERARQORG){
                    widget.currentRow.NRTIPOHIERARQORG='';
                }
                restEngine.post('product#/exportarTemplate', {
                    'requestType': 'DataSet',
                    'dataset': [widget.currentRow]
                }).then(function(data) {
                    if(data.dataset && data.dataset.erros){
                        var popUp = templateManager.container.getWidget("mensagens_loteLancEventos");
                        popUp.dataSource.data = data.dataset.erros;
                        ABUtilController.masterDetailOpenPopup(popUp);
                    }else{
                        if(data.dataset && data.dataset.arquivo){
                            $window.open($window.serviceUrl + "/abrirArquivo?requestType=DataSet&dataset[0][CMARQUIVO]=" + data.dataset.arquivo.NMARQUIVO);
                            ABUtilController.masterDetailClosePopup(templateManager.container.getWidget("mensagens_loteLancEventos"));
                            templateManager.container.getWidget("loteLancEvento").reload();
                        }
                        else 
                            if (data.messages && data.messages[0].message) {
                                ScreenService.successNotification(Messages.IMPORTACAO_SUCCESS, 10000);
                                ABUtilController.masterDetailClosePopup(templateManager.container.getWidget("mensagens_loteLancEventos"));
                                templateManager.container.getWidget("loteLancEvento").reload();
                            } else {
                                ScreenService.showMessage(Messages.EXPORTACAO_ERROR);
                            }
                    }
                    
                }).catch(function(e) {
                    var error;
                    if (e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
            }
        }
        
    };
    
    this.mudaVisibilidadeEstruturaHierarquica = function(){
        var widget = templateManager.container.getWidget('popupGeracaoPlanilha');
        var estruturaHierarquica = widget.getField('NRESTRUTHIERARQ');
        var tipoHierarquia = widget.getField('NMTIPOHIERARQORG');
        widget.currentRow.NRESTRUTHIERARQ = '';

        if(!tipoHierarquia.value()){
            estruturaHierarquica.readOnly = true;
        }
        else
            estruturaHierarquica.readOnly = false;
            
    };
    
    this.mudaVisibilidadeActionsLote = function(){
        var widget = templateManager.container.getWidget("loteLancEvento");
        var VisibilidadeCancelarLote = false;
        var VisibilidadeExportar = true;
        
        
        if(widget.currentRow.IDSTATUSLOTELANC === "APROVADO"){
            VisibilidadeCancelarLote = true;
            VisibilidadeExportar = false;
        } else if(widget.currentRow.IDSTATUSLOTELANC === "REPROVADO"){
            VisibilidadeCancelarLote = false;
            VisibilidadeExportar = false;
        }
            
        widget.getAction("cancelarLote").isVisible = VisibilidadeCancelarLote;
        widget.getAction("exportar").isVisible = VisibilidadeExportar;
    };
    
    this.montaDataSourceFilterEstrutura = function(){
        var widget = templateManager.container.getWidget('popupGeracaoPlanilha');
        var field = widget.getField('NRESTRUTHIERARQ');
        field.dataSourceFilter[ABUtilController.retornaFiltro(field.dataSourceFilter, 'NRTIPOESTRUTURA')].value = widget.currentRow.NRTIPOESTRUTSUP;
    };
    
    this.aprovaLote = function(args){
        ScreenService.confirmMessage('Deseja realmente confirmar o lote?', 'CONFIRMATION', 
            function(){
                var widget = ABUtilController.checkWidget(args);
                if(widget.isValid())  {
                    widget.currentRow.__is_new = false;
                    widget.currentRow.IDSTATUSLOTELANC = 'PENDENTE';
                    return widget.saveRow().then(function (data){
                        ABUtilController.masterDetailVoltarList(widget);
                        ScreenService.showMessage('Lote confirmado com sucesso');
                        widget.reload();
                    }.bind(this)).catch(function(e) {
                        var error;
                        if(e.data.error === undefined)
                            error = e;
                        else 
                            error = e.data.error;
                        
                        ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error));
                    });
                }
            }
        );    
    };
    
    var openPopupMensagens = function(msg) {
        var widgetMensagens = templateManager.container.getWidget('mensagensCalculo');
        widgetMensagens.dataSource.data = msg;
        ScreenService.openPopup(widgetMensagens);
   };
   
    /**
     *  Rotina que altera o filtro passado por url antes de sua aplicacao ao dataSource da widget
     * 
     *  @param  widget  [Widget]
     * 
     */
    this.beforeApplyUrlDataSourceFilterCallback = function(widget) {
        const dsLoteLancEventoFilter = widget.dataSourceFilter.find((item) => item.name == 'DSLOTELANCEVENTO');
        if (!dsLoteLancEventoFilter) {
            return;
        }
       
        dsLoteLancEventoFilter.operator = 'LIKE_I';
        dsLoteLancEventoFilter.value = '%' + dsLoteLancEventoFilter.value + '%';
   };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('LoteLancEventoController', LoteLancEventoController);
});

// FILE: assets/js/controllers/MarcacaoPontoController.js
/* jshint esversion: 6 */
function MarcacaoPontoController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, ABUtilController, AFormataHoraDecimal, Messages) {
    const self = this;
    var Nrvinculo;
    var Nmvinculo;
    
    const CADAUTO_MARC = {
        WIDGET_NAMES: {
            FILTERS:    'cadastroAutomaticoMarcacoesPopUpFilters',
            ITEMS:      'cadastroAutomaticoMarcacoesPopUpInsert',
            MAIN:       'cadastroAutomaticoMarcacoesPopUp',
        },
        DEFAULT_INTERVAL_ROW_INSERT: {
            DSCOLETOR: 'Marcação digitada.',
            NRCOLETOR: 24,
            IDDIAOCORRENCIA_ENTRADA: 'FC',
            IDDIAOCORRENCIA_SAIDA: 'FC',
            SAIDA_ALMOCO: "N",
        },
        ACTION_DESCANSO: {
            CURRENT_MODE: 'DEFINE_DESCANSO',
            MODES: {
                DEFINE_DESCANSO: {
                    NAME: 'DEFINE_DESCANSO',
                    ICON: 'silverware',
                    ACTION_TO_CALL: 'defineDescansoMarcacoesCadastroAutomatico'
                },
                REMOVE_DESCANSO: {
                    NAME: 'REMOVE_DESCANSO',
                    ICON: 'close-x2',
                    ACTION_TO_CALL: 'removeDescansoMarcacoesCadastroAutomatico',
                },
            },
            NAME: 'cadastroAutomaticoMarcacoesPopUp_alomco',
        },
        FILTERS_REQUIRED_AT_LEAST_ONE: ['NRVINCULOM_LIST', 'NRESTRUTLEGAL_LIST', 'NRESTRUTGEREN_LIST'],
        FILTERS_REQUIRED: ['MARC_DAYS'],
    };
    
    const MARCACAO_IMPORTADA_REP = 26;
    
    // Descreve quais campos serão 'read-only' quando determinado coletor estiver relacionado à marcação, no momento da ediação do registro
    const TIPOS_MARCACAO_CAMPOS_BLOQUEADOS = {
        [MARCACAO_IMPORTADA_REP]: ['DSCOLETOR', 'DTHRMARCACAOPONTO_DATA', 'DTHRMARCACAOPONTO_HORA'],
    };

    this.setNrvinculo = function(argsRow, isFiltro = false) {
        setLocalVar('HCM_PTO_NRVINCULOM', argsRow.NRVINCULOM);
        if(argsRow.NRVINCULOM){
            Nrvinculo = argsRow.NRVINCULOM;
            Nmvinculo = argsRow.NMVINCULOM;
        }else if(!argsRow.NRVINCULOM && isFiltro === true){
            Nrvinculo = '';
            Nmvinculo = '';
        }
    };
    
    this.habilitajustificativa = function(args){
        var widget = ABUtilController.checkWidget(args);
        if (widget.currentRow.IDDIAOCORRENCIA !== null){
            widget.getField('DSJUSTIFICATIVA').readOnly = false;
        }else{
            widget.getField('DSJUSTIFICATIVA').readOnly = true;
        }
    };
    
    this.openImportacaoREP = function(args){
        var widgetPopupImportacao = templateManager.container.getWidget('popupImportacao');
        widgetPopupImportacao.currentRow.DSPATH = [];
        ScreenService.openPopup(widgetPopupImportacao);
    };
    
    this.openLancamentodeOcorrencia = function(args){
        const widgetPopUpLancOcorrencia = templateManager.container.getWidget('popupLancOcorrencia');
        const widgetPrincipal = templateManager.container.getWidget("ocorrencias");
        
        if(widgetPrincipal.getCheckedRows() <= 0) {
            ScreenService.showMessage('É necessário selecionar um ou mais dias para prosseguir com o cadastro das ocorrências!');
            return;
        }
        
        widgetPopUpLancOcorrencia.currentRow = {};
        ScreenService.openPopup(widgetPopUpLancOcorrencia);
    };
    
    this.editarMarcacaoWidgetPrincipal = function (args) {
        const widget = args.owner.widget;
        this.validaCamposEdicaoMarcacao(widget);
        ABUtilController.masterDetailEdit(widget);
    };
    
    /**
     *  Rotina responsável por fazer validações nas propriedades dos campos da widget principal da tela de marcações, antes da edição de um registro
     */
    this.validaCamposEdicaoMarcacao = function(widget) {
        const widgetMarcPonto = widget || templateManager.container.getWidget('MarcPonto');
        const nrColetor = widgetMarcPonto.currentRow.NRCOLETOR;
        const camposBloquear = TIPOS_MARCACAO_CAMPOS_BLOQUEADOS[nrColetor] || [];
        
        // Clear read-only
        ABUtilController.clearReadOnlyAllWidgetFields(widgetMarcPonto);
        
        // Caso não existam campos a terem read-only alterados
        if (!camposBloquear || (Array.isArray(camposBloquear) && camposBloquear.length < 1)) {
            return;
        }
        
        // Seta read-only true para campos parametrizados
        for (const field of camposBloquear) {
            const widgetField = widgetMarcPonto.getField(field);
            if (widgetField) {
                widgetField.readOnly = true;
            }
        }
    };
    
    this.validaArquivo = function(filePath) {
        var extension = filePath.split('.').pop().toUpperCase();
        if (extension !== 'TXT') {
            ScreenService.showMessage('Formato de arquivo inválido');
            return false;
        } else {
            return true;
        }
    };
    
    this.filtraPeriodoApuracao = function(args){
        var widget = ABUtilController.checkWidget(args);
        var periodo = widget.getField('DSPERIODOAPURACAO');
            
        if(widget.currentRow.NRTIPOPERIODOAPURACAO){
            periodo.dataSourceFilter[ABUtilController.retornaFiltro(periodo.dataSourceFilter, 'NRTIPOPERIODOAPURACAO')].value = widget.currentRow.NRTIPOPERIODOAPURACAO;
            periodo.reload();
        }else{
            widget.currentRow.NRPERIODOAPURACAO = '';
            widget.currentRow.DSPERIODOAPURACAO = '';
            periodo.dataSourceFilter[ABUtilController.retornaFiltro(periodo.dataSourceFilter, 'NRTIPOPERIODOAPURACAO')].value = '';
            periodo.reload();
        }
    };
    
    this.importar = function(widget) {
        if (widget.isValid()) {
            if (this.validaArquivo(widget.currentRow.DSPATH[0].name)) {
                restEngine.post('product#/importaArquivoParaMarcacao', {
                    'requestType': 'DataSet',
                    'dataset': [widget.currentRow]
                }).
                then(function(data) {
                    if (data.messages && data.messages[0].message) {
                        if(data.messages[0].type === 'E'){
                            ScreenService.errorNotification(data.messages[0].message, 1000);
                            if(data.messages[1] && data.messages[1].type == 'S'){
                                ScreenService.successNotification(data.messages[1].message, 10000);
                            }
                        }else{
                            ScreenService.successNotification(data.messages[0].message, 1000);
                        }
                        ScreenService.closePopup(true);
                        templateManager.container.getWidget('MarcPonto').activate();
                        templateManager.container.getWidget("MarcPonto").reload();
                    }else {
                        ScreenService.showMessage(Messages.IMPORTACAO_ERROR);
                    }
                    
                }).
                catch(function(e) {
                    var error;
                    if (e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;

                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
            }
        }
    };
    
    this.openAdicionar = function(args){
        var widget = args.owner.widget;
        widget.backupRow = undefined;
        widget.currentRow = {};
        widget.newRow();
        widget.currentRow.DSCOLETOR = 'Marcação digitada.';
        widget.currentRow.NRCOLETOR = 24;
        this.habilitajustificativa(args);
        widget.currentRow.NRVINCULOM = Nrvinculo;
        widget.currentRow.NMVINCULOM = Nmvinculo;
    };
    
    this.setMarcacaoPonto = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
                var isNew;
                if (!widget.backupRow) {
                    widget.currentRow.__is_new = true;
                    isNew = true;
                }
                else {
                    widget.currentRow.__is_new = false;
                    isNew = false;
                }
                var saveData = Object.assign({}, widget.currentRow, {
                    "NRORG": getLocalVar("HCM_NRORG_TRAB")
                }, {
                    "CDOPERADOR_LOG": getLocalVar("HCM_CDOPERADOR")
                });
                restEngine.post('product#/setMarcacaoPonto', {
                    'requestType': 'DataSet',
                    'dataset': [saveData]
                }).
                then(function(data) {
                    if (data.notifications[0].type === "success") {
                        ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 1000);
                        if(isNew){
                            widget.reload();
                            ABUtilController.blockCheckbox(args.owner.widget.id, false);
                            ABUtilController.masterDetailVoltarList(widget);
                        } else {
                            widget.reload().then(function() {
                                // Atualiza currentRow com os valores atualizados
                                var currentNrmarcacao = data.dataset && data.dataset.GpeMarcacaoponto_setMarcacaoPonto.length > 0 ? data.dataset.GpeMarcacaoponto_setMarcacaoPonto[0].NRMARCACAOPONTO : null;
                                if (!currentNrmarcacao) {
                                    return;
                                }
                                widget.currentRow = widget.dataSource.data.find(function(row) { return row.NRMARCACAOPONTO == currentNrmarcacao; });
                            });
                            widget.view();
                            
                            // Clear read-only
                            ABUtilController.clearReadOnlyAllWidgetFields(widget);
                        }
                        
                    }
                    else {
                        ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                    }
                }).catch(function(e) {
                    var error;
                    if (e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
            }
    };

    this.removeMarcacaoPonto = function(args) {
         ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
                var widget = args.owner.widget;
                widget.currentRow.__is_new = false;
                var removeData = Object.assign({}, widget.currentRow, {
                    "NRORG": getLocalVar("HCM_NRORG_TRAB")
                }, {
                    "CDOPERADOR_LOG": getLocalVar("HCM_CDOPERADOR")
                });
                restEngine.post('product#/removeMarcacaoPonto', {
                    'requestType': 'DataSet',
                    'dataset': [removeData]
                }).
                then(function(data) {
                    if (data.notifications[0].type === "success") {
                        ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 1000);
                        ABUtilController.blockCheckbox(args.owner.widget.id, false);
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    }
                    else {
                        ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                    }
                }).catch(function(e) {
                    var error;
                    if (e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error; ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
            }
        );
    };
    
    /*FUNÇÕES DO CADASTRO AUTOMÁTICO DE MARCAÇÕES*/
    /* jshint ignore:start */
    this.openPopUpCadastroAutomaticoMarcacoesItems = function (args) {
        // Widget principal, onde os filtros e as widgets estão
        const widget = ABUtilController.checkWidget(args);
        
        // Widget onde as marcações são cadastradas
        const widgetInserirMarcacoes = widget.widgets.find(function (anWidget) {
            return anWidget.name === CADAUTO_MARC.WIDGET_NAMES.ITEMS;
        });
        
        widgetInserirMarcacoes.currentRow = { ...CADAUTO_MARC.DEFAULT_INTERVAL_ROW_INSERT };
        
        ScreenService.openPopup(widgetInserirMarcacoes);
    };
    /* jshint ignore:end */
    
    /**
     *  Rotina que realiza o cadastro de marcações, apenas no frontend, para que depois sejam inseridas de acordo com os filtros
     * 
     *  @param  args
     */
    /* jshint ignore:start */
    this.setMarcacoesCadastroAutomatico = function (args) {
        const widget = ABUtilController.checkWidget(args);
        if (!widget.isValid()) {
            return;
        }
        
        const widgetCadastroAutomatico = widget.parent;
        
        const widgetMarcacoes = widgetCadastroAutomatico.widgets.find(function (anWidget) {
            return anWidget.name === CADAUTO_MARC.WIDGET_NAMES.FILTERS;
        });
        
        if (!widgetMarcacoes) {
            return;
        }
        
        const rowToAdd = { ...widget.currentRow };
        rowToAdd.id = Array.isArray(widgetMarcacoes.dataSource.data) && widgetMarcacoes.dataSource.data.length > 0 ?
            Math.max(...widgetMarcacoes.dataSource.data.map(item => item.id)) + 1 :
            0;
        
        widgetMarcacoes.dataSource.data.push(rowToAdd);
        widget.currentRow = {};
        
        ScreenService.closePopup();
    };
    /* jshint ignore:end */
    
    /**
     *  Rotina que realiza a remoção de marcações, apenas no frontend, para que depois sejam inseridas marcações de acordo com os filtros
     * 
     *  @param  args
     */
    this.removeMarcacoesCadastroAutomatico = function (args) {
        const widget = ABUtilController.checkWidget(args);
        if (!widget.currentRow) {
            return;
        }
        
        const rowIndexToRemove = widget.dataSource.data.findIndex((item) => item.id == widget.currentRow.id);
        if (widget.dataSource.data[rowIndexToRemove] && widget.dataSource.data[rowIndexToRemove].SAIDA_ALMOCO == 'S') {
            this.setActionDescansoMarcacoesCadastroAutomaticoStatus(CADAUTO_MARC.ACTION_DESCANSO.MODES.DEFINE_DESCANSO.NAME);
        }
        
        widget.dataSource.data.splice(rowIndexToRemove, 1);
        widget.redraw();
    };
    
    this.alterDescansoMarcacoesCadastroAutomatico = function (args) {
        const widget = ABUtilController.checkWidget(args);
        if (!widget.currentRow) {
            return;
        }
        
        const currentActionMode = this.getActionDescansoMarcacoesCadastroAutomaticoMode();
        if (currentActionMode) {
            const action = CADAUTO_MARC.ACTION_DESCANSO.MODES[currentActionMode].ACTION_TO_CALL;
            this[action](args);
        }
    };
    
    this.getActionDescansoMarcacoesCadastroAutomaticoMode = function () {
        return CADAUTO_MARC.ACTION_DESCANSO.CURRENT_MODE;
    };
    
    this.defineDescansoMarcacoesCadastroAutomatico = function (args) {
        const widget = ABUtilController.checkWidget(args);
        if (!widget.currentRow) {
            return;
        }
        
        const hasRowsSetted = widget.dataSource.data.filter((item) => item.SAIDA_ALMOCO == "S").length > 0;
        if (hasRowsSetted) {
            ScreenService.showMessage(Messages.HCM07003_PTO_MARCACAOPONTO_APENAS_UM_DESCANSO_PERMITIDO);
            return;
        }
        
        const row = widget.dataSource.data.find((item) => item.id == widget.currentRow.id);
        if (!row) {
            return;
        }
        
        row.SAIDA_ALMOCO = "S";
        this.setActionDescansoMarcacoesCadastroAutomaticoStatus(CADAUTO_MARC.ACTION_DESCANSO.MODES.REMOVE_DESCANSO.NAME, widget);
    };
    
    this.removeDescansoMarcacoesCadastroAutomatico = function (args) {
        const widget = ABUtilController.checkWidget(args);
        if (!widget.currentRow) {
            return;
        }
        
        const row = widget.dataSource.data.find((item) => item.id == widget.currentRow.id);
        if (!row || row.SAIDA_ALMOCO != "S") {
            return;
        }
        
        row.SAIDA_ALMOCO = "N";
        this.setActionDescansoMarcacoesCadastroAutomaticoStatus(CADAUTO_MARC.ACTION_DESCANSO.MODES.DEFINE_DESCANSO.NAME, widget);
    };
    
    this.setActionDescansoMarcacoesCadastroAutomaticoStatus = function (mode, widget = null) {
        const actionMode = CADAUTO_MARC.ACTION_DESCANSO.MODES[mode];
        if (!actionMode) {
            return false;
        }
        
        widget = widget ? widget : templateManager.container.getWidget(CADAUTO_MARC.WIDGET_NAMES.FILTERS);
        
        const field = widget.getAction(CADAUTO_MARC.ACTION_DESCANSO.NAME);
        if (!field) {
            return false;
        }
        
        field.icon = actionMode.ICON;
        CADAUTO_MARC.ACTION_DESCANSO.CURRENT_MODE = mode;
    };
    
    this.setCadastroAutomaticoOnClick = function(args) {
        const widget = ABUtilController.checkWidget(args);
        if (!widget.isValid()) {
            return;
        }
    
        const widgetMarcacoes = widget.widgets.find(function (anWidget) {
            return anWidget.name === CADAUTO_MARC.WIDGET_NAMES.FILTERS;
        });
        
        // Valida se filtros estão preenchidos
        if (!this.validaFiltroCadastroAutomatico(widget)) {
            ScreenService.showMessage(Messages.HCM07003_PTO_MARCACAOPONTO_CADAUTO_PREENCHER_FILTERS);
            return;
        }
        
        // Valida se há marcações
        if (Array.isArray(widgetMarcacoes.dataSource.data) && widgetMarcacoes.dataSource.data.length < 1) {
            ScreenService.showMessage(Messages.HCM07003_PTO_MARCACAOPONTO_CADAUTO_PREENCHER_ITEMS);
            return;
        }
        
        ScreenService.confirmMessage(Messages.HCM07003_PTO_MARCACAOPONTO_CADAUTO_CONFIRMATION_QUESTION, 'CONFIRMATION', function() {
            this.setCadastroAutomatico(args);
        }.bind(this));
    };
    
    /* jshint ignore:start */
    this.setCadastroAutomatico = async function (args) {
        const widget = ABUtilController.checkWidget(args);
    
        const widgetMarcacoes = widget.widgets.find(function (anWidget) {
            return anWidget.name === CADAUTO_MARC.WIDGET_NAMES.FILTERS;
        });
        
        const marcacoes = [ ...widgetMarcacoes.dataSource.data ];
        marcacoes.forEach((item) => item.__rightActions = null);
        
        widget.currentRow.MARCACAO_LIST = marcacoes;
        
        try {
            const response = await restEngine.post('product#/setMarcacoesCadastroAutomatico', {
                'requestType': 'Row',
                'row': widget.currentRow
            });
            
            const success = response.dataset.data && response.dataset.data.success;
            if (success) {
                ScreenService.successNotification(Messages.HCM07003_PTO_MARCACAOPONTO_CADAUTO_CONFIRMATION_SUCCESS);
                
                ScreenService.closePopup();
                this.setActionDescansoMarcacoesCadastroAutomaticoStatus(CADAUTO_MARC.ACTION_DESCANSO.MODES.DEFINE_DESCANSO.NAME);
                return;
            }
            
            ScreenService.errorNotification(Messages.SAVE_ROW_ERROR);
        } catch (error) {
            const message = error.data ? (error.data.errorCode == Messages.ALERT_MESSAGE_CODE ? error.data.error : Messages.CATCH_EXCEPTION_ERROR(error.data.error)) : Messages.SAVE_ROW_ERROR;
            ScreenService.showMessage(message, 'ERROR');
        }
    };
    /* jshint ignore:end */
    
    this.validaFiltroCadastroAutomatico = function (widget) {
        for (const field of CADAUTO_MARC.FILTERS_REQUIRED) {
            if (!widget.currentRow[field] ||
                (Array.isArray(widget.currentRow[field]) && widget.currentRow[field].length > 0) ||
                ((widget.currentRow[field].hasOwnProperty('start') && !widget.currentRow[field].start) || widget.currentRow[field].hasOwnProperty('end') && !widget.currentRow[field].end))
            {
                return false;
            }
        }
        
        for (const field of CADAUTO_MARC.FILTERS_REQUIRED_AT_LEAST_ONE) {
            if (widget.currentRow[field] && Array.isArray(widget.currentRow[field]) && widget.currentRow[field].length > 0) {
                return true;
            }
        }
        
        return false;
    };
    
    this.setExtraFilterFields = function () {
        const importacaoWidget = templateManager.container.getWidget('popupImportacao');
        const dtInicialPeriodo = importacaoWidget.currentRow.DTINICIALAPURACAO;
        const dtFinalPeriodo = importacaoWidget.currentRow.DTFINALAPURACAO;
        
        importacaoWidget.currentRow.DTINICIALAPURACAOFILTRO = dtInicialPeriodo  ? dtInicialPeriodo.substring(0, 10) : '';
        importacaoWidget.currentRow.DTFIMAPURACAOFILTRO     = dtFinalPeriodo    ? dtFinalPeriodo.substring(0, 10)   : '';
    };
    /*-------------------------------------------*/

}

Configuration(function(ContextRegister) {
    ContextRegister.register('MarcacaoPontoController', MarcacaoPontoController);
});

// FILE: assets/js/controllers/MensagensPadraoController.js
/**
 * Created by larafranca
 */
function MensagensPadraoController (ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, ProcessosServices, ABUtilController) {

    this.confirmDeleteMensage = function(args) {
        var widget = args.owner.widget;
        ScreenService.showCustomDialog('Deseja realmente excluir esta mensagem? ', 'CONFIRMATION', null, [{
            label: ScreenService.i18n("Sim"),
            code: function(e, deferred) {
                this.deleteMensagem(args);
            }.bind(this)
        },{
            label: ScreenService.i18n("Não"),
            code: function(e, deferred) {
                deferred.reject(e);
            }
        }]);
    };

    this.changeOperadorLog = function(args) {
        var widget = ABUtilController.checkWidget(args);
        widget.currentRow.DSEMAILOPERLOG = null;
        if(widget.currentRow.IDOPERADORLOG == 'S'){
            widget.currentRow.DSEMAILOPERLOG = getLocalVar("HCM_DSEMAILOPER");
        } else {
            widget.currentRow.DSEMAILOPERLOG = null;
        }
    };

    this.deleteMensagem = function(args) {
        var widget = args.owner.widget;
        var data = {};
        widget.dataSource.checkedRows = widget.currentRow;
        widget.removeCheckedRows();
        widget.reload();
        ABUtilController.masterDetailVoltarList(widget);
        ScreenService.showMessage("Mensagem excluída com sucesso");
    };

    this.enviarDemonstrativo = function(){
        var widgetMensagens = templateManager.container.getWidget("mensagens");

        save = Object.assign({},{"MENSAGEM":  widgetMensagens.currentRow}, {"CDOPERADOR_LOG": getLocalVar("HCM_CDOPERADOR")}, {"NRORG": getLocalVar("HCM_NRORG_TRAB")});
        restEngine.post("product#/enviarMensagem",
            {'requestType':'DataSet','dataset':[save]}
        ).then(
            function(data){
                if(data.dataset.enviarMensagem[0] === undefined) {
                    ScreenService.showMessage('Erro ao enviar o email');
                    //ABUtilController.masterDetailClosePopup(widgetProcessos);
                } else {
                    ScreenService.showMessage('Email enviado com sucesso');
                    //ABUtilController.masterDetailClosePopup(widgetProcessos);
                }
            }
        ).catch(function(e) {
            var error;
            if(e.data.error === undefined)
                error = e;
            else 
                error = e.data.error;
            
            ScreenService.showMessage('Ocorreu um erro inesperado, contate o administrador informando o trecho abaixo: <br><br>' + error + '<br><br>', 'ERROR');
        });
    };

    this.onEnter = function(){
        var widgetMensagens = templateManager.container.getWidget("mensagens");
        widgetMensagens.getField("DSMENSAGEM").placeholder = "Mnemônicos aceitos:" +
                                                            '\n\n' +
                                                            "[NOME_CANDIDATO] = Nome do candidado" +
                                                            '\n' +
                                                            "[NOME_PROCESSO] = Nome do processo" +
                                                            '\n' +
                                                            "[ESTRUTURA_PROCESSO] = Nome da empresa relacionada ao processo" +
                                                            '\n' +
                                                            "[COMPETENCIA] = Competência do operador logado";
    };

    this.openAdicionarMensagens = function() {
        var widget = templateManager.container.getWidget('mensagens');
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
    };

    this.openPopupProcessos = function() {
        var widget = templateManager.container.getWidget('processosCadastrados');
        widget.isVisible = true;
        ABUtilController.masterDetailOpenPopup(widget);
    };

    this.salvarMensagens = function(){
        var nrorg = getLocalVar("HCM_NRORG_TRAB"); 
        var widgetMensagens = templateManager.container.getWidget("mensagens");
        var tipo = false ;
        if(widgetMensagens.isValid()){
            if(!widgetMensagens.backupRow){
                widgetMensagens.currentRow.__is_new = true;
                tipo = true;
            } else {
                widgetMensagens.currentRow.__is_new = false;
            }
            saveData = Object.assign({},{"__is_new": widgetMensagens.currentRow.__is_new}, {"NRORG": nrorg} , {"DSMENSAGEM": widgetMensagens.currentRow.DSMENSAGEM}, {"DSTITULOMENSAGEM": widgetMensagens.currentRow.DSTITULOMENSAGEM}, {"CDOPERADOR_LOG": getLocalVar("HCM_CDOPERADOR")}, widgetMensagens.currentRow);
            
            restEngine.post("product#/salvarMensagemPadrao",
                {'requestType':'DataSet','dataset':[saveData]}
            ).then(
                function(data){
                    if(data.dataset.des_mensagenspadrao[0] === undefined) {
                        ScreenService.showMessage('Erro ao salvar a mensagem');
                    } else{
                        if(tipo){
                            ABUtilController.masterDetailVoltarList(widgetMensagens);
                            widgetMensagens.reload();
                        } else {
                            ScreenService.closePopup(true);
                            widgetMensagens.view();
                            widgetMensagens.reload();
                        }
                        ScreenService.showMessage('Mensagem salva com sucesso');
                    }
                }
            ).catch(function(e) {
                var error;
                if(e.data.error === undefined)
                    error = e;
                else 
                    error = e.data.error;
                
                ScreenService.showMessage('Ocorreu um erro inesperado, contate o administrador informando o trecho abaixo: <br><br>' + error + '<br><br>', 'ERROR');
            });
        }
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('MensagensPadraoController', MensagensPadraoController);
});

// FILE: assets/js/controllers/MetodoTreinamentoController.js
function MetodoTreinamentoController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, General, Messages) {

    var self = this;

    this.adicionarRow = function(args) {
        var widget = args.owner.widget;
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
    };

    this.setMetodoTreinamento = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
            if (ABUtilController.validaDtIniMenorIgualDtFin(widget.currentRow.DTINIVIGENCIA, widget.currentRow.DTFIMVIGENCIA)) {
                if (!widget.backupRow) {
                    widget.currentRow.__is_new = true;
                }
                else {
                    widget.currentRow.__is_new = false;
                }
                restEngine.post('product#/setMetodoTreinamento', {
                    'requestType': 'DataSet',
                    'dataset': [widget.currentRow]
                }).
                then(function(data) {
                    if (data.notifications[0].type === "success") {
                        ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                        templateManager.container.getWidget('metodoTreinamento').reload();
                        if (widget.currentRow.__is_new) {
                            ABUtilController.masterDetailVoltarList(widget);
                            self.widgetsvisibletrue(args);
                        }
                        else {
                            ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                            widget.backupRow = null;
                            widget.view();
                        }
                    }
                    else {
                        ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                    }
                }).
                catch(function(e) {
                    var error;
                    if (e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
            }
            else {
                ScreenService.showMessage(Messages.DTINI_POST_DTFIM_ERROR);
                return false;
            }
        }
    };

    this.deleteMetodoTreinamento = function(args) {
    ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
        var widget = templateManager.container.getActiveWidget();
        if (widget.isValid()) {
            widget.currentRow.__is_new = false;
            restEngine.post('product#/deleteMetodoTreinamento', {
                'requestType': 'DataSet',
                'dataset': [widget.currentRow]
            }).
            then(function(data) {
                if (data.messages) {
                    ScreenService.showMessage(Messages.REMOVE_ROW_ERROR + '. ' + data.messages[0].message, data.messages[0].type);
                }
                else {
                    ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                    ABUtilController.masterDetailVoltarList(widget);
                    templateManager.container.getWidget('metodoTreinamento').reload();
                }
            }).
            catch(function(e) {
                var error;
                if (e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;

                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
            }
        }, null);
    };


}

Configuration(function(ContextRegister) {
    ContextRegister.register('MetodoTreinamentoController', MetodoTreinamentoController);
});


// FILE: assets/js/controllers/MigracaoFichaFinanceiraController.js
function MigracaoFichaFinanceiraController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, General, Messages, $window) {
    
    this.adicionarRow = function(args) {
        var widget = args.owner.widget;
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
    };
    
    this.validaArquivo = function(filePath) {
        var extension = filePath.split('.').pop().toUpperCase();
        if (extension !== 'XLS' && extension !== 'XLSX') {
            ScreenService.showMessage('Formato de arquivo inválido');
            return false;
        } else {
            return true;
        }
    };
    
    this.openPopupMensagens = function(msg) {
        var widgetMensagens = templateManager.container.getWidget('mensagensEventoDePara');
        widgetMensagens.dataSource.data = msg;
        ScreenService.openPopup(widgetMensagens);
    };
    
    this.habilitaLoteFichaFinanceira = function(){
        var widget = templateManager.container.getActiveWidget();
        var widgetLote = templateManager.container.getWidget('loteFichaFinanceira');
        
        if(widget.dataSource.data.length == 0){
            widgetLote.isVisible = false;    
        }else{
            widgetLote.isVisible = true;    
        }
    };
    
    this.setNrlotelancevento = function(){
        var widgetLote = templateManager.container.getWidget('loteFichaFinanceira');
        var widgetItem = templateManager.container.getWidget('itemLoteFicha');
        var filtroLoteItem = ABUtilController.retornaFiltro(widgetItem.dataSourceFilter, 'NRLOTELANCEVENTO');
        
        if(!Util.isEmptyOrBlank(widgetLote.currentRow.NRLOTELANCEVENTO) && !Util.isEmptyOrBlank(filtroLoteItem)){
            widgetItem.dataSourceFilter[filtroLoteItem].value = widgetLote.currentRow.NRLOTELANCEVENTO;
        }
    }; 
    
    this.openPopupImportacao = function(tela){
        var widgetPopup = templateManager.container.getWidget('popupImportacaoPlanilha' + tela);
        ABUtilController.masterDetailOpenPopup(widgetPopup);
    };
    
    this.ableActionsViewRow = function(){
        var widgetLote = templateManager.container.getWidget('loteFichaFinanceira');
        var actionExportaLancamentoFolha = widgetLote.getAction('exportaLancamentoFolha');
        var actionCancelarLote = widgetLote.getAction('cancelarLote');
        
        if(widgetLote.currentRow.IDSTATUSLOTELANC == 'PENDENTE'){
            actionExportaLancamentoFolha.isVisible = true;
        }else{
            actionExportaLancamentoFolha.isVisible = false;
        }
        
        if(widgetLote.currentRow.IDSTATUSLOTELANC == 'APROVADO'){
            actionCancelarLote.isVisible = true;
        }else{
            actionCancelarLote.isVisible = false;
        }
        
        widgetLote.redraw();
    };
    
    this.editLoteFichaFinanceira = function(){
        var widget = templateManager.container.getActiveWidget();
        ABUtilController.masterDetailEdit(widget);
        this.enableObservacao(widget);
    };

    this.enableObservacao = function(widget){
        widget = Util.isEmptyOrBlank(widget) ? templateManager.container.getActiveWidget() : widget;
        if(widget.currentRow.IDSTATUSLOTELANC == 'REPROVADO'){
            widget.getField("DSOBSLOTELANC").readOnly = false;
            widget.getField("DSOBSLOTELANC").validations = {
                "required": true
            };
        } else {
            widget.getField("DSOBSLOTELANC").readOnly = true;
            widget.getField("DSOBSLOTELANC").validations = {};
        }
    };
    
    this.baixarPlanilhaTemplateEventosDePara = function(action) {
        var widget = templateManager.container.getActiveWidget();
        ScreenService.confirmMessage("Deseja fazer o download da Planilha Template?", null, function () {
            widget.currentRow.NMIMPORTACAO = action;
            restEngine.post('product#/baixarPlanilhaTemplateEventosDePara', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                then(function(data) {
                    ScreenService.closePopup();
                    if(data.dataset && data.dataset.arquivo){
                        $window.open($window.serviceUrl + "/abrirArquivo?requestType=DataSet&dataset[0][CMARQUIVO]=" + data.dataset.arquivo.NMARQUIVO);
                        ABUtilController.masterDetailClosePopup(templateManager.container.getWidget("mensagensEventoDePara"));
                        ScreenService.successNotification(Messages.EXPORTACAO_SUCCESS, 10000);                        
                        templateManager.container.getWidget("deparaEventos").reload();
                    }else if(data.dataset && data.dataset.erros){
                        var popUp = templateManager.container.getWidget("mensagensEventoDePara");
                        popUp.dataSource.data = data.dataset.erros;
                        ABUtilController.masterDetailOpenPopup(popUp);
                    }else{
                        ScreenService.showMessage(Messages.EXPORTACAO_ERROR);
                    }
                    
                }).catch(function(e) {
                    var error;
                    if (e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;
                    
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
            },null);
        
    };
    
    this.baixarPlanilhaTemplateLoteFicha = function(action) {
        var widget = templateManager.container.getActiveWidget();
        ScreenService.confirmMessage("Deseja fazer o download da Planilha Template?", null, function () {
            widget.currentRow.NMIMPORTACAO = action;
            restEngine.post('product#/baixarPlanilhaTemplateLoteFicha', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                then(function(data) {
                    ScreenService.closePopup();
                    if(data.dataset && data.dataset.arquivo){
                        $window.open($window.serviceUrl + "/abrirArquivo?requestType=DataSet&dataset[0][CMARQUIVO]=" + data.dataset.arquivo.NMARQUIVO);
                        ABUtilController.masterDetailClosePopup(templateManager.container.getWidget("mensagensLoteFicha"));
                        ScreenService.successNotification(Messages.EXPORTACAO_SUCCESS, 10000);                        
                        templateManager.container.getWidget("loteFichaFinanceira").reload();
                    }else if(data.dataset && data.dataset.erros){
                        var popUp = templateManager.container.getWidget("mensagensLoteFicha");
                        popUp.dataSource.data = data.dataset.erros;
                        ABUtilController.masterDetailOpenPopup(popUp);
                    } else{
                        ScreenService.showMessage(Messages.EXPORTACAO_ERROR);
                        
                    }
                    
                }).catch(function(e) {
                    var error;
                    if (e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
            },null);
        
    };
    
    this.importarPlanilhaEventoDePara = function(){
        var widget = templateManager.container.getActiveWidget();
        if(widget.isValid()){
            var widgetPai = templateManager.container.getWidget('deparaEventos');
            if (this.validaArquivo(widget.currentRow.DSPATH[0].name)) {
                restEngine.post('product#/importarPlanilhaEventoDePara', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                then(function(data) {
                    if (data.messages) {
                        ScreenService.closePopup(true);
                        ScreenService.showMessage(data.messages[0].message, data.messages[0].type);
                        if (data.dataset && data.dataset.msg) {
                            this.openPopupMensagens(data.dataset.msg);
                        } else {
                            widgetPai.activate();
                            widgetPai.reload();
                        }
                    } else
                        ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                }.bind(this)).
                catch(function(e) {  
                    var error;
                    if (e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error; 
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
            }
        }
    };
    
    this.importarPlanilhaLoteFicha = function(){
        var widget = templateManager.container.getActiveWidget();
        if(widget.isValid()){
            var widgetPai = templateManager.container.getWidget('loteFichaFinanceira');
            if (this.validaArquivo(widget.currentRow.DSPATH[0].name)) {
                restEngine.post('product#/importarPlanilhaLoteFicha', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                then(function(data) {
                    if (data.messages) {
                        ScreenService.closePopup(true);
                        ScreenService.showMessage(data.messages[0].message, data.messages[0].type);
                        if (data.dataset && data.dataset.msg) {
                            this.openPopupMensagens(data.dataset.msg);
                        } else {
                            widgetPai.activate();
                            widgetPai.reload();
                        }
                    } else
                        ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                }.bind(this)).
                catch(function(e) {  
                    var error;
                    if (e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error; 
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
            }
        }
    };
    
    this.exportarLoteFicha = function(){
        var widget = templateManager.container.getActiveWidget();
        if(widget.isValid()){
            var widgetPai = templateManager.container.getWidget('loteFichaFinanceira');
            
            restEngine.post('product#/exportarLoteFicha', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
            then(function(data) {
                if (data.messages) {
                    ScreenService.closeSwipe();
                    ScreenService.showMessage(data.messages[0].message, data.messages[0].type);
                    widgetPai.reload();
                    
                } else if (data.dataset && data.dataset.msg) {
                    this.openPopupMensagens(data.dataset.msg);
                }else{
                    ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                }
            }.bind(this)).
            catch(function(e) {  
                var error;
                if (e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error; 
                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
        }
    };
    
    this.cancelarLoteFichaFinanceira = function(){
        ScreenService.confirmMessage('Deseja realmente cancelar o lote ?', 'CONFIRMATION', 
            function(){
                var widget = templateManager.container.getWidget('loteFichaFinanceira');
                
                restEngine.post("product#/cancelarLoteFichaFinanceira",
                        {'requestType':'DataSet','dataset':[widget.currentRow]}
                ).then(function(data){
                    if(data.messages){
                        ScreenService.showMessage(data.messages[0].message, data.messages[0].type);
                        ScreenService.closePopup(true);
                        ScreenService.closeSwipe();
                        widget.activate();
                        widget.reload();
                    }else if(data.dataset && data.dataset.mensagens){
                        var popUp = templateManager.container.getWidget('mensagensLoteFicha');
                        popUp.dataSource.data = data.dataset.mensagens;
                        ABUtilController.masterDetailOpenPopup(popUp);
                        ScreenService.alertNotification("Não foi possível concluir o cancelamento do lote.", 10000);                        
                    }else {
                        ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR('ERROR'), 'ERROR');
                    }
                }).catch(function(e) {
                    var error;
                    if(!e.data || e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;
    
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
            }
        );
    };
    
    this.setEventoDeParaFicha = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
            if (!widget.backupRow) {
                widget.currentRow.__is_new = true;
            }
            else {
                widget.currentRow.__is_new = false;
            }
            restEngine.post('/setEventoDeParaFicha', {
                'requestType': 'DataSet',
                'dataset': [widget.currentRow]
            }).
            then(function(data) {
                if (data.notifications && data.notifications[0].type === "success") {
                    ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                    if (widget.currentRow.__is_new) {
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    }
                    else {
                        widget.backupRow = null;
                        widget.view();
                    }
                }else if(data.messages && data.messages[0].type == 'M'){
                    ScreenService.showMessage(data.messages[0].message);
                }else{
                    ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                }
            }).
            catch(function(e) {
                var error;
                if (e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
        }
    };
    
    this.setLoteLancEvento = function(args){
        var widget = templateManager.container.getActiveWidget();
        if(widget.isValid())  {
            
            if (!widget.backupRow) {
                widget.currentRow.__is_new = true;
            } else {
                widget.currentRow.__is_new = false;
            }
            restEngine.post('/setLoteFichaFinanceira', {
                'requestType': 'DataSet',
                'dataset': [widget.currentRow]
            }).then(function (data){
                if (data.notifications[0].type === "success") {
                    if (widget.currentRow.__is_new) {
                        self.widgetsvisibletrue(args);
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    } else {
                        ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                        widget.backupRow = null;
                        widget.view();
                    }
                    self.mudaVisibilidadeActionsLote();
                } else {
                    ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                }
            }.bind(this)).catch(function(e) {
                var error;
                if(e.data.error === undefined)
                    error = e;
                else 
                    error = e.data.error;
                if(e.data.errorCode == '10')
                    ScreenService.showMessage(error, 'ALERT');
                else
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error));
            });
        }
    };
    
    this.setItemLoteEvento = function(args){
        var widget = ABUtilController.checkWidget(args);
        var widgetLote = templateManager.container.getWidget("loteFichaFinanceira");
        if(widget.isValid())  {
            
            if (!widget.backupRow) {
                widget.currentRow.__is_new = true;
            } else {
                widget.currentRow.__is_new = false;
            }
            widget.currentRow.NRLOTELANCEVENTO = widgetLote.currentRow.NRLOTELANCEVENTO;
            widget.currentRow.CDOPERADOR_LOG = getLocalVar("HCM_CDOPERADOR");
            widget.currentRow.NRORGTRAB = getLocalVar("HCM_NRORG_TRAB");
            widget.currentRow.NRORGPADRAO = getLocalVar("HCM_NRORG_PADRAO");
            widget.currentRow.DTATUAL = getLocalVar("HCM_DATA_ATUAL");
            
            if(widget.currentRow.VRREFFOLHALOTE && typeof widget.currentRow.VRREFFOLHALOTE === "string")
                widget.currentRow.VRREFFOLHALOTE.replace(",", ".");
            
            restEngine.post('product#/setItemLoteLanc', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).then(function (data) {
                if (data.dataset && data.dataset.msg) {
                    widget.reload();
                    ScreenService.closeSwipe();
                    this.openPopupMensagens(data.dataset.msg);
                } else if (data.notifications[0].type === "success") {
                    if (widget.currentRow.__is_new) {
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    } else {
                        ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                        widget.backupRow = null;
                        widget.view();
                    }
                } else {
                    ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                }
                
            }.bind(this)).catch(function(e) {
                var error;
                if(e.data.error === undefined)
                    error = e;
                else 
                    error = e.data.error;
                if(e.data.errorCode == '10')
                    ScreenService.showMessage(error, 'ALERT');
                else
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error));
            });
        }
    };

    
    this.deleteEventoDePara = function(args) {
        ScreenService.confirmMessage('Deseja realmente excluir o arquivo ?', 'CONFIRMATION',
            function() {
                var widget = args.owner.widget;
                widget.currentRow.__is_new = false;
                restEngine.post('/deleteEventoDePara', {
                    'requestType': 'DataSet',
                    'dataset': [widget.currentRow]
                }).
                then(function(data) {
                    if (data.messages) {
                        ScreenService.showMessage(data.messages[0].message);
                    }
                    else {
                        if (data.notifications[0].type === "success") {
                            ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                            ABUtilController.masterDetailVoltarList(widget);
                            widget.reload();
                        }
                        else {
                            ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                        }
                    }
                }).
                catch(function(e) {
                    var error;
                    if (e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
            });
    };
    
    this.deleteLote = function(args) {
        ScreenService.confirmMessage('Deseja realmente excluir o lote?', 'CONFIRMATION', 
            function(){
                var widget = args.owner.widget;
                widget.currentRow.__is_new = false;
                restEngine.post('product#/deleteLote', {'requestType':'DataSet','dataset':[widget.currentRow]}).
                    then(function(data){
                        if(data.messages){
                            ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                            ABUtilController.masterDetailVoltarList(widget);
                            widget.reload();
                        } else {
                            ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                        }
                    }).
                    catch(function(e) {
                        var error;
                        if(e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;
                            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    }
                );
            }
        );
    };
    
    this.deleteItemLoteEvento = function(args) {
        var widget = ABUtilController.checkWidget(args);
        var data = {}; 
        ScreenService.confirmMessage(Messages.DELETE_ROW, 'CONFIRMATION', 
            function(){
                widget.dataSource.remove(widget.currentRow).then(function (data){
                    if(data.dataset.fpaItemLoteLanc_setItemLoteLanc.type === "success"){
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                        ScreenService.showMessage(Messages.REMOVE_ROW_SUCCESS); 
                    } else {
                        ScreenService.showMessage(Messages.REMOVE_ROW_ERROR); 
                    }
                }.bind(this));
            }.bind(this)
        );
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('MigracaoFichaFinanceiraController', MigracaoFichaFinanceiraController);
});

// FILE: assets/js/controllers/MigracaoPlanilhaController.js
/* jshint esversion: 6 */
function MigracaoPlanilhaController(
  ScreenService,
  templateManager,
  localStorageEngine,
  ZhUtil,
  restEngine,
  HcmRepository,
  ABUtilController,
  General,
  Messages,
  HcmConsts
) {
  const FILE_EXTENSIONS_SUPPORTED = ["xlsx", "xls", "csv"];
  const CHILD_WIDGETS_FILTERED = ["logMigracaoPlanilha"];
  const ALL_CHILD_WIDGETS = ["logMigracaoPlanilha"];
  const MAIN_WIDGET_CHILDS_FILTER_NAME = "NRMIGRACAO";

  this.getMainWidget = () => {
    return templateManager.container.getWidget("migracaoPlanilha");
  };

  this.getUploadPopupWidget = () => {
    return templateManager.container.getWidget("popupAdicionarArquivo");
  };

  this.openAdicionarArquivoPopup = () => {
    const widgetPopup = this.getUploadPopupWidget();
    const mainWidget = this.getMainWidget();
    widgetPopup.currentRow.DSPATH = [];
    widgetPopup.currentRow = Util.extend(
      widgetPopup.currentRow,
      mainWidget.currentRow
    );
    ScreenService.openPopup(widgetPopup);
  };

  this.uploadMigracaoPlanilhaOnClick = () => {
    const widgetPopup = this.getUploadPopupWidget();
    if (!widgetPopup.isValid()) return;

    const pathFieldExists = widgetPopup.currentRow.DSPATH && widgetPopup.currentRow.DSPATH[0];
    const fileName = pathFieldExists ? widgetPopup.currentRow.DSPATH[0].name : null;

    if (!this.isFileExtensionValid(fileName)) {
      ScreenService.showMessage(this.getInvalidExtensionMessage());
      return;
    }

    this.uploadMigracaoPlanilha();
  };

  /* jshint ignore:start */
  this.uploadMigracaoPlanilha = async () => {
    const widgetPopup = this.getUploadPopupWidget();
    const mainWidget = this.getMainWidget();
    const cleanCurrentRow = ABUtilController.deleteCircularProperties(
      widgetPopup.currentRow
    );

    try {
      const response = await restEngine.post("/uploadMigracaoPlanilha", {
        requestType: "Row",
        row: cleanCurrentRow,
      });

      if (response.messages && response.messages[0]) {
        ScreenService.showMessage(response.messages[0].message, "ERROR");
        return;
      }

      const uri = response.dataset.uploadMigracaoPlanilha.path;
      if (!uri) {
        throw new Error();
      }

      mainWidget.reload();
      ScreenService.closePopup();
    } catch (e) {
      ScreenService.showMessage(Messages.FILE_UPLOAD_FAIL, "ERROR");
    }
  };
  /* jshint ignore:end */

  /* jshint ignore:start */
  this.downloadMigracaoPlanilha = async () => {
    const mainWidget = this.getMainWidget();
    const cleanCurrentRow = ABUtilController.deleteCircularProperties(
      mainWidget.currentRow
    );

    try {
      const response = await restEngine.post("/getMigracaoPlanilhaLink", {
        requestType: "Row",
        row: cleanCurrentRow,
      });

      if (response.messages && response.messages[0]) {
        ScreenService.showMessage(response.messages[0].message, "ERROR");
        return;
      }

      const uri = response.dataset.getMigracaoPlanilhaLink.path;
      if (!uri) {
        ScreenService.showMessage(Messages.REGISTER_FILE_NOT_FOUND, "WARNING");
        return;
      }

      ABUtilController.openLink(uri);
    } catch (e) {
      ScreenService.showMessage(Messages.FILE_DOWNLOAD_FAIL, "ERROR");
    } finally {
      mainWidget.reload();
    }
  };
  /* jshint ignore:end */

  /* jshint ignore:start */
  this.downloadModeloPlanilha = async () => {
    const mainWidget = this.getMainWidget();
    const cleanCurrentRow = ABUtilController.deleteCircularProperties(
      mainWidget.currentRow
    );

    try {
      const response = await restEngine.post("/getModeloPlanilhaLink", {
        requestType: "Row",
        row: cleanCurrentRow,
      });

      if (response.messages && response.messages[0]) {
        ScreenService.showMessage(response.messages[0].message, "ERROR");
        return;
      }

      const uri = response.dataset.getModeloPlanilhaLink.path;
      if (!uri) {
        ScreenService.showMessage(
          Messages.HCM_MIG_MODEL_FILE_NOT_FOUND,
          "WARNING"
        );
        return;
      }

      ABUtilController.openLink(uri);
    } catch (e) {
      ScreenService.showMessage(Messages.FILE_DOWNLOAD_FAIL, "ERROR");
    } finally {
      mainWidget.reload();
    }
  };
  /* jshint ignore:end */

  this.deleteMigracaoPlanilhaOnClick = () => {
    ScreenService.showCustomDialog(
      Messages.REMOVE_FILE_CONFIRMATION,
      "CONFIRMATION",
      null,
      [
        {
          label: ScreenService.i18n("Sim"),
          code: function (e, deferred) {
            this.deleteMigracaoPlanilha();
          }.bind(this),
        },
        {
          label: ScreenService.i18n("Não"),
          code: function (e, deferred) {},
        },
      ]
    );
  };

  /* jshint ignore:start */
  this.deleteMigracaoPlanilha = async () => {
    const mainWidget = this.getMainWidget();
    const cleanCurrentRow = ABUtilController.deleteCircularProperties(
      mainWidget.currentRow
    );

    try {
      const response = await restEngine.post("/deleteMigracaoPlanilha", {
        requestType: "Row",
        row: cleanCurrentRow,
      });

      if (response.messages && response.messages[0]) {
        ScreenService.showMessage(response.messages[0].message, "ERROR");
        return;
      }

      const success = response.dataset.deleteMigracaoPlanilha;
      if (!success) {
        throw new Error();
      }
    } catch (e) {
      ScreenService.showMessage(Messages.REMOVE_FILE_FAIL, "ERROR");
    } finally {
      mainWidget.reload();
    }
  };
  /* jshint ignore:end */

  this.resetMigracaoPlanilhaOnClick = () => {
    ScreenService.showCustomDialog(
      'Deseja realmente reiniciar os arquivos e logs de importação?',
      "CONFIRMATION",
      null,
      [
        {
          label: ScreenService.i18n("Sim"),
          code: function (e, deferred) {
            this.resetMigracaoPlanilha();
          }.bind(this),
        },
        {
          label: ScreenService.i18n("Não"),
          code: function (e, deferred) {},
        },
      ]
    );
  };

  /* jshint ignore:start */
  this.resetMigracaoPlanilha = async () => {
    const mainWidget = this.getMainWidget();
    const cleanCurrentRow = ABUtilController.deleteCircularProperties(
      mainWidget.currentRow
    );

    try {
      const response = await restEngine.post("/resetMigracaoPlanilha", {
        requestType: "Row",
        row: cleanCurrentRow,
      });

      if (response.messages && response.messages[0]) {
        ScreenService.showMessage(response.messages[0].message, "ERROR");
        return;
      }

      const success = response.dataset.resetMigracaoPlanilha;
      if (!success) {
        throw new Error();
      }
    } catch (e) {
      ScreenService.showMessage('Não foi possível resetar os arquivos e logs da importação!', "ERROR");
    } finally {
      mainWidget.reload();
    }
  };
  /* jshint ignore:end */

  this.iniciarMigracaoPlanilhaOnClick = () => {
    ScreenService.showCustomDialog(
      Messages.HCM_MIG_START_CONFIRMATION,
      "CONFIRMATION",
      null,
      [
        {
          label: ScreenService.i18n("Sim"),
          code: function (e, deferred) {
            this.iniciarMigracaoPlanilha();
          }.bind(this),
        },
        {
          label: ScreenService.i18n("Não"),
          code: function (e, deferred) {},
        },
      ]
    );
  };

  /* jshint ignore:start */
  this.iniciarMigracaoPlanilha = async () => {
    const mainWidget = this.getMainWidget();
    const cleanCurrentRow = ABUtilController.deleteCircularProperties(
      mainWidget.currentRow
    );

    try {
      const response = await restEngine.post("/iniciarMigracaoPlanilha", {
        requestType: "Row",
        row: cleanCurrentRow,
      });

      if (response.messages && response.messages[0]) {
        ScreenService.showMessage(response.messages[0].message, "ERROR");
        return;
      }

      const success =
        response.dataset && response.dataset.iniciarMigracaoPlanilha;
      if (!success) {
        throw new Error();
      }
    } catch (e) {
      ScreenService.showMessage(Messages.HCM_MIG_START_FAIL, "ERROR");
    } finally {
      mainWidget.reload();
    }
  };
  /* jshint ignore:end */

  this.setFilterWidgetsFilhas = () => {
    const mainWidget = this.getMainWidget();
    for (const widgetName of CHILD_WIDGETS_FILTERED) {
      const childWidget =
        templateManager.container.getWidget(widgetName) || null;
      if (!childWidget) continue;
      const childWidgetFilter =
        childWidget.dataSourceFilter.find(
          (filter) => filter.name === MAIN_WIDGET_CHILDS_FILTER_NAME
        ) || {};
      childWidgetFilter.value =
        mainWidget.currentRow[MAIN_WIDGET_CHILDS_FILTER_NAME];
    }
  };

  this.isFileExtensionValid = (fileName) => {
    return ABUtilController.isFileExtensionValid(
      fileName,
      FILE_EXTENSIONS_SUPPORTED
    );
  };

  this.validFileExtensionsToString = () => {
    return FILE_EXTENSIONS_SUPPORTED.join(", ");
  };

  this.getInvalidExtensionMessage = () => {
    return (
      Messages.FILE_EXTENSION_INVALID +
      Messages.FILE_SUPORTED_LIST +
      this.validFileExtensionsToString() +
      "."
    );
  };

  this.limitFilePathFieldToOneItem = () => {
    const widgetPopup = this.getUploadPopupWidget();
    return ABUtilController.limitFilePathFieldToOneItem(widgetPopup, "DSPATH");
  };

  this.closeWidgetsFilhasSecundarias = () => {
    ABUtilController.closeWidgetsFilhasSecundarias(ALL_CHILD_WIDGETS, null);
  };

  /* jshint ignore:start */
  this.importarPlanilha = async (errorsIgnore = false) => {
    const mainWidget = this.getMainWidget();
    const cleanCurrentRow = ABUtilController.deleteCircularProperties(
      mainWidget.currentRow
    );

    cleanCurrentRow.errorsIgnore = errorsIgnore;

    try {
      const response = await restEngine.post("/importarPlanilha", {
        requestType: "Row",
        row: cleanCurrentRow,
      });

      const success = response.dataset && response.dataset.importarPlanilha;

      if (success) {
        ScreenService.showMessage("Importado com sucesso!", "SUCCESS");

        return;
      }

      const errosImportacao = response.dataset && response.dataset.errosImportacao;

      if (errosImportacao && !errorsIgnore) {
        ScreenService.errorNotification(
          response.notifications[0].message,
          10000
        );

        showProsseguirImportacaoDialog();

        return;
      }

      const hasMessages = response.messages ? response.messages.length > 0 : false;

      if (hasMessages) {
        ScreenService.showMessage(response.messages[0].message, "ERROR");

        return;
      }
      
      ScreenService.showMessage("Importação concluída, porém há pendências que precisam de sua atenção!", "ALERT");
    } catch (e) {
      ScreenService.showMessage(Messages.HCM_MIG_START_FAIL, "ERROR");
    } finally {
      mainWidget.reload();
    }
  };
  /* jshint ignore:end */

  const showProsseguirImportacaoDialog = () => {
    ScreenService.showCustomDialog(
      "Há pendências! deseja prosseguir com a importação?",
      "CONFIRMATION",
      "question",
      [
        {
          label: ScreenService.i18n("Sim"),
          code: function (e, deferred) {
            this.importarPlanilha(true);
          }.bind(this),
        },
        {
          label: ScreenService.i18n("Ver pendências"),
          code: function (e, deferred) {
            openLogImportacao();
          },
        },
      ]
    );
  };

  let openLogImportacao = () => {
    let widget = templateManager.container.getWidget("logMigracaoPlanilha");

    let nrMigracao = templateManager.container.getWidget("migracaoPlanilha").currentRow.NRMIGRACAO;

    ScreenService.openPopup(widget);

    widget.dataSourceFilter[0].value = nrMigracao;

    widget.reload();
  };

  /* jshint ignore:start */
  this.getLogImportacao = async () => {
    const widget = templateManager.container.getWidget("logMigracaoPlanilha");
    const row = ABUtilController.deleteCircularProperties(widget.currentRow);

    try {
      const response = await restEngine.post("/downloadLogImportacao", {
        requestType: "Row",
        row,
      });

      const success =
        response.dataset && response.dataset.downloadLogImportacao;

      if (success) {
        dataErros = response.dataset.downloadLogImportacao[0];

        this.downloadLog();
      } else {
        ScreenService.showMessage(response.messages[0].message, "ERROR");
      }
    } catch (e) {
      ScreenService.showMessage(e, "ERROR");
    }
  };
  /* jshint ignore:end */

  var dataErros = "";

  this.downloadLog = () => {
    const blob = new Blob([dataErros], { type: "text/plain" });
    const url = window.URL.createObjectURL(blob);
    const link = document.createElement("a");
    link.href = url;
    link.download = "ErrosImportacao.txt";
    link.click();
    link.remove();
  };
  
  this.backLogTab = () => {
    const mainWidget = this.getMainWidget() || {};
    const isMainTabInViewMode = mainWidget.inViewMode();
    if (isMainTabInViewMode) {
      ScreenService.goBack();
    } else {
      ScreenService.closePopup();
    }
    
    mainWidget.activate();
  };
}

Configuration(function (ContextRegister) {
  ContextRegister.register(
    "MigracaoPlanilhaController",
    MigracaoPlanilhaController
  );
});


// FILE: assets/js/controllers/MigracaoXmlController.js
/*global Util*/
function MigracaoXmlController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, Messages) {
    
    this.openPopupNovaMigracao = function(){
        var widgetPopup = templateManager.container.getWidget('popupNovaMigracao');
        widgetPopup.currentRow.DSPATH = [];
        ABUtilController.masterDetailOpenPopup(widgetPopup);
    };
    
    this.setArquivosMigracaoXml = function(){
        var widget = templateManager.container.getActiveWidget();
        if(widget.isValid()){
            var widgetPai = templateManager.container.getWidget('migracaoXml');
            restEngine.post('product#/setArquivosMigracaoXml', {'requestType': 'Row', 'row': widget.currentRow}).
                then(function(data) {
                    if (data.dataset.setArquivosMigracaoXml[0] === true) {
                        ScreenService.closePopup(true);
                        ScreenService.showMessage(Messages.OPERACAO_SUCESSO, 'SUCCESS');
                        widgetPai.activate();
                        widgetPai.reload();
                    } else {
                        ScreenService.showMessage(Messages.PROCESSO_ERROR, 'ERROR');
                    }
                    
                    if (data && data.messages) {
                        this.openPopupMensagens(data.messages);
                    }
                }.bind(this)).
                catch(function(e) {  
                    var error;
                    if (e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error; 
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
        }
    };
    
    this.openPopupMensagens = function(mensagens) {
        var widgetMensagens = templateManager.container.getWidget('mensagens');
        widgetMensagens.dataSource.data = mensagens;
        ScreenService.openPopup(widgetMensagens);
    };
    
    this.getDataSetMigracaoFromTree = function() {
        var widget = templateManager.container.getWidget('migracaoXml');
        var dataset = [];
        
        if(widget.currentRow.NRMIGRACAOXML == 0){
            widget.dataSource.data.forEach(function(row){
                if(!Util.isNull(row.NMREGISTROPAI) && row.NMREGISTROPAI == widget.currentRow.NMREGISTRO){
                    dataset.push(
                        {
                            '__is_new': false,
                            'NRORG': row.NRORG,
                            'NRMIGRACAOXML': row.NRMIGRACAOXML
                        }
                    );
                }
            });
        } else {
            dataset = [
                {
                    '__is_new': false,
                    'NRORG': widget.currentRow.NRORG,
                    'NRMIGRACAOXML': widget.currentRow.NRMIGRACAOXML
                }
            ];
        }
        
        if (dataset.length == 0) {
            dataset = [
                {
                    '__is_new': false,
                    'NRORG': widget.currentRow.NRORG,
                    'NMEVENTO': widget.currentRow.NMEVENTO
                }
            ];
        }
        
        return dataset;
    };
    
    this.deleteMigracaoXml = function() {
        var widget = templateManager.container.getWidget('migracaoXml');
        
        if (widget.currentRow.NRMIGRACAOXML == 0 && widget.currentRow.QTPENDENTES == 0){
            ScreenService.showMessage('Não existem arquivos pendentes a serem excluídos');
            return;
        }
        
        ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
            var dataset;
            
            dataset = this.getDataSetMigracaoFromTree();
            
            restEngine.post('product#/deleteMigracaoXml', {'requestType':'DataSet','dataset':dataset}).
                then(function(data){
                    if(data.notifications[0].type === "success"){
                        ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    } else {
                        ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                    }
                }).
                catch(function(e) {
                    var error;
                    if(e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;
                        ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
        }.bind(this), null);
    };
    
    this.setFilterWidgetsFilhas = function() {
        var widgetMigracao = templateManager.container.getWidget('migracaoXml');
        var widgetEvento = templateManager.container.getWidget('migracaoXmlEvento');
        var widgetLog = templateManager.container.getWidget('logMigracaoXml');
        
        widgetEvento.dataSourceFilter.forEach(function(filter) {
            if (filter.name == 'NMEVENTO') {
                filter.value = widgetMigracao.currentRow.NMEVENTO;
            }
        });
        
        widgetLog.dataSourceFilter.forEach(function(filter) {
            if (filter.name == 'NMEVENTO') {
                filter.value = widgetMigracao.currentRow.NMEVENTO;
            }
        });
    };
    
    this.importarMigracaoXml = function() {
        var widget = templateManager.container.getWidget('migracaoXml');
        var confirmMsg;
        
        if (widget.currentRow.NRMIGRACAOXML == 0 && widget.currentRow.QTPENDENTES == 0){
            ScreenService.showMessage('Não existem arquivos pendentes a serem importados');
            return;
        }
        
        if (Util.isNull(widget.currentRow.NMREGISTROPAI)) {
            confirmMsg = "Será realizada a importação dos arquivos do evento " + widget.currentRow.NMEVENTO;
        } else {
            confirmMsg = "Será realizada a importação do arquivo " + widget.currentRow.NMARQUIVOXML;
        }
        
        ScreenService.confirmMessage(confirmMsg, null, function () {
            var row = {
                'NMREGISTROPAI': widget.currentRow.NMREGISTROPAI,
                'NMEVENTO': widget.currentRow.NMEVENTO,
                'NRMIGRACAOXML': widget.currentRow.NRMIGRACAOXML
            };
            restEngine.post('product#/importarMigracaoXml', {'requestType':'Row','row':row}).
                then(function(data){
                    if (data.dataset.importarMigracaoXml[0] === true) {
                        ScreenService.showMessage('Importação finalizada', 'SUCCESS');
                        widget.reload();
                    } else {
                        ScreenService.showMessage('Importação não realizada', 'ERROR');
                    }
                    
                    if (data && data.messages) {
                        this.openPopupMensagens(data.messages);
                    }
                }.bind(this)).
                catch(function(e) {
                    var error;
                    if(e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;
                        ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
        }.bind(this), null);
    };
    
    this.agendarMigracaoXml = function() {
        var widget = templateManager.container.getWidget('migracaoXml');
        var confirmMsg;
        
        if (widget.currentRow.NRMIGRACAOXML == 0 && widget.currentRow.QTPENDENTES == 0){
            ScreenService.showMessage('Não existem arquivos pendentes a serem importados');
            return;
        }
        
        if (Util.isNull(widget.currentRow.NMREGISTROPAI)) {
            confirmMsg = "Será realizada a importação dos arquivos do evento " + widget.currentRow.NMEVENTO;
        } else {
            confirmMsg = "Será realizada a importação do arquivo " + widget.currentRow.NMARQUIVOXML;
        }
        
        ScreenService.confirmMessage(confirmMsg, null, function () {
            var row = {
                'NMREGISTROPAI': widget.currentRow.NMREGISTROPAI,
                'NMEVENTO': widget.currentRow.NMEVENTO,
                'NRMIGRACAOXML': widget.currentRow.NRMIGRACAOXML
            };
            restEngine.post('product#/agendarMigracaoXml', {'requestType':'Row','row':row}).
                then(function(data){
                    if (data.dataset.agendarMigracaoXml[0] === true) {
                        ScreenService.showMessage(data.messages[0].message, data.messages[0].type);
                        widget.reload();
                    } else {
                        ScreenService.showMessage('Importação não realizada', 'ERROR');
                    }
                }).
                catch(function(e) {
                    var error;
                    if(e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;
                        ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
        }.bind(this), null);
    };
    
    this.deleteMigracaoXmlEvento = function() {
        var widget = templateManager.container.getWidget('migracaoXmlEvento');
        
        if (widget.currentRow.IDSTATUS == 'C'){
            ScreenService.showMessage('Arquivos já importados não podem ser excluídos');
            return;
        }
        
        ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
            var row = {
                '__is_new': widget.currentRow.__is_new,
                'NRORG': widget.currentRow.NRORG,
                'NRMIGRACAOXML': widget.currentRow.NRMIGRACAOXML
            };
            restEngine.post('product#/deleteMigracaoXml', {'requestType':'DataSet','dataset':[row]}).
                then(function(data){
                    if(data.notifications[0].type === "success"){
                        ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                        widget.reload();
                    } else {
                        ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                    }
                }).
                catch(function(e) {
                    var error;
                    if(e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;
                        ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
        }.bind(this), null);
    };
    
    this.importarMigracaoXmlEvento = function() {
        var widget = templateManager.container.getWidget('migracaoXmlEvento');
        
        if (widget.currentRow.IDSTATUS == 'C'){
            ScreenService.showMessage('O arquivo já foi importado');
            return;
        }
        
        ScreenService.confirmMessage("Será realizada a importação do arquivo " + widget.currentRow.NMARQUIVOXML, null, function () {
            var row = {
                'NMREGISTROPAI': widget.currentRow.NMEVENTO,
                'NMEVENTO': widget.currentRow.NMEVENTO,
                'NRMIGRACAOXML': widget.currentRow.NRMIGRACAOXML
            };
            restEngine.post('product#/importarMigracaoXml', {'requestType':'Row','row':row}).
                then(function(data){
                    if (data.dataset.importarMigracaoXml[0] === true) {
                        ScreenService.showMessage('Importação finalizada com sucesso.', 'SUCCESS');
                        if (data && data.messages) {
                            data.messages.forEach(function(msg){
                                ScreenService.successNotification(msg.message);
                            });
                        }
                        widget.reload();
                        widget.getParent().reload();
                    } else {
                        ScreenService.showMessage('Importação não realizada. Favor verificar o log.', 'ERROR');
                    }
                }.bind(this)).
                catch(function(e) {
                    var error;
                    if(e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;
                        ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
        }.bind(this), null);
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('MigracaoXmlController', MigracaoXmlController);
});

// FILE: assets/js/controllers/MnemonicoController.js
function MnemonicoController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, General, Messages) {

    this.adicionarRow = function(args) {
        var widget = args.owner.widget;
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
    };

	this.setMnemonico = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
                if (!widget.backupRow) {
                    widget.currentRow.__is_new = true;
                } else {
                    widget.currentRow.__is_new = false;
                }
                restEngine.post('product#/setMnemonico', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                    then(function (data) {
                        if (data.notifications[0].type === "success") {
                            ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                            if (widget.currentRow.__is_new) {
                                ABUtilController.masterDetailVoltarList(widget);
                                widget.reload();
                            } else {
                                ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                                widget.backupRow = null;
                                widget.view();
                            }
                        } else {
                            ScreenService.showMessage(data.notifications[0].message ? data.notifications[0].message : 'Não foi possível salvar o registro!', 'ERROR');
                        }
                    }).
                    catch(function(e) {
                        var error;
                        if(e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;
                            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    });
            }
    };
    
    this.deleteMnemonico = function(args) {
    ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
        var widget = args.owner.widget;
        widget.currentRow.__is_new = false;
        restEngine.post('product#/deleteMnemonico', {'requestType':'DataSet','dataset':[widget.currentRow]}).
            then(function(data){
                if(data.notifications[0].type === "success"){
                    ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                    ABUtilController.masterDetailVoltarList(widget);
                    widget.reload();
                } else {
                    ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                }
            }).
            catch(function(e) {
                var error;
                if(e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
        }, null);
    };
    
}

Configuration(function(ContextRegister) {
    ContextRegister.register('MnemonicoController', MnemonicoController);
});

// FILE: assets/js/controllers/ModalidadeSalarialController.js
function ModalidadeSalarialController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, General,Messages) {

    this.adicionarRow = function(args) {
        var widget = args.owner.widget;
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
    };

	this.setModalidadeSalarial = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
                if (!widget.backupRow) {
                    widget.currentRow.__is_new = true;
                } else {
                    widget.currentRow.__is_new = false;
                }
                restEngine.post('product#/setModalidadeSalarial', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                    then(function (data) {
                        if (data.notifications[0].type === "success") {
                            ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                            if (widget.currentRow.__is_new) {
                                ABUtilController.masterDetailVoltarList(widget);
                                widget.reload();
                            } else {
                                ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                                widget.backupRow = null;
                                widget.view();
                            }
                        } else {
                            ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                        }
                    }).
                    catch(function(e) {
                        var error;
                        if(e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;
                            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    });
            }
    };
    
    this.deleteModalidadeSalarial = function(args) {
    ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
        var widget = args.owner.widget;
        widget.currentRow.__is_new = false;
        restEngine.post('product#/deleteModalidadeSalarial', {'requestType':'DataSet','dataset':[widget.currentRow]}).
            then(function(data){
                if(data.notifications[0].type === "success"){
                    ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                    ABUtilController.masterDetailVoltarList(widget);
                    widget.reload();
                } else {
                    ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                }
            }).
            catch(function(e) {
                var error;
                if(e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
        }, null);
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('ModalidadeSalarialController', ModalidadeSalarialController);
});

// FILE: assets/js/controllers/ModeloaprovsoliController.js
function ModeloaprovsoliController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, General, Messages) {

    this.adicionarRow = function(args) {
        var widget = args.owner.widget;
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
        widget.widgets.forEach(function(widgetFilha){
            widgetFilha.isVisible = false;
        });
    };
    

	this.setModeloaprovsoli = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
            if (!widget.backupRow) {
                widget.currentRow.__is_new = true;
            } else {
                widget.currentRow.__is_new = false;
            }
            restEngine.post('product#/setModeloaprovsoli', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
            then(function (data) {
                if (data.notifications[0].type === "success") {
                    ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                    if (widget.currentRow.__is_new) {
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    } else {
                        widget.backupRow = null;
                        widget.view();
                    }
                    ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                } else {
                    ScreenService.showMessage(data.notifications[0].message ? data.notifications[0].message : 'Não foi possível salvar o registro!', 'ERROR');
                }
            }).
            catch(function(e) {
                var error;
                if(e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
        }
    };

    this.setFasesFilter = function() {
        var widgetModelo = templateManager.container.getWidget("modelo");
        var widgetFase = templateManager.container.getWidget("fases");
        widgetFase.dataSourceFilter.forEach(function(filter){
            if (filter.name === 'NRMODELOAPROVSOLI') {
                filter.value = widgetModelo.currentRow.NRMODELOAPROVSOLI;
            }
        });
    };

    this.adicionarFase = function(args) {
        var widget = args.owner.widget;
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
        widget.widgets.forEach(function(widgetFilha){
            widgetFilha.isVisible = false;
        });

        var maiorOrdem = 0;
        widget.dataSource.data.forEach(function(fase){
            if (parseInt(fase.NRORDEM) > maiorOrdem) maiorOrdem = parseInt(fase.NRORDEM);
        });
        widget.currentRow.NRORDEM = maiorOrdem + 1;
    };
    
    this.setFaseaprovsoli = function(args) {
        var widget = args.owner.widget;
        var widgetPai = templateManager.container.getWidget("modelo");
        if(widgetPai != undefined && widgetPai != null){
            widget.currentRow.NRMODELOAPROVSOLI = widgetPai.currentRow.NRMODELOAPROVSOLI;
        }
        if (widget.isValid()) {
            if (!widget.backupRow) {
                widget.currentRow.__is_new = true;
            } else {
                widget.currentRow.__is_new = false;
            }
            restEngine.post('product#/setFaseaprovsoli', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
            then(function (data) {
                if (data.notifications[0].type === "success") {
                    ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                    if (widget.currentRow.__is_new) {
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    } else {
                        ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                        widget.backupRow = null;
                        widget.view();
                    }
                }
                else {
                    ScreenService.showMessage(data.notifications[0].message ? data.notifications[0].message : 'Não foi possível salvar o registro!', 'ERROR');
                }
            }).
            catch(function(e) {
                var error;
                if(e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
        }
    };
    
    this.deleteModeloaprov = function(args) {
        ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
        var widget = args.owner.widget;
        widget.currentRow.__is_new = false;
        restEngine.post('product#/deleteModeloaprov', {'requestType':'DataSet','dataset':[widget.currentRow]}).
            then(function(data){
                if(data.notifications[0].type === "success"){
                    ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                    ABUtilController.masterDetailVoltarList(widget);
                    widget.reload();
                } else {
                    if(data.notifications[0].type === "error"){
                        ScreenService.showMessage(data.notifications[0].message);
                    } else {
                        ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                    }
                }
            }).
            catch(function(e) {
                var error;
                if(e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
        }, null);
    };
    
    this.deleteFasesaprov = function(args) {
        ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
            var widget = args.owner.widget;
            widget.currentRow.__is_new = false;
            restEngine.post('product#/deleteFasesaprov', {'requestType':'DataSet','dataset':[widget.currentRow]}).
                then(function(data){
                    if(data.notifications[0].type === "success"){
                        ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                        widget.currentRow = null;
                    } else {
                        if(data.notifications[0].type === "error"){
                            ScreenService.showMessage(data.notifications[0].message);
                        } else {
                            ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                        }
                    }
                }).
                catch(function(e) {
                    var error;
                    if(e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;
                        ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
        }, null);
    };
    
}

Configuration(function(ContextRegister) {
    ContextRegister.register('ModeloaprovsoliController', ModeloaprovsoliController);
});

// FILE: assets/js/controllers/MonitCalculoController.js
function MonitCalculoController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, General, Messages) {

    this.deleteMonitCalc = function(args) {
        var widget = templateManager.container.getActiveWidget();
        ScreenService.confirmMessage(Messages.DELETE_ROW, null, function() {
            if (widget.isValid()) {
                widget.currentRow.__is_new = false;
                restEngine.post('product#/deleteMonitCalc', {
                    'requestType': 'DataSet',
                    'dataset': [widget.currentRow]
                }).
                then(function(data) {
                    if (data.messages) {
                        ScreenService.showMessage(Messages.REMOVE_ROW_ERROR + '. ' + data.messages[0].message, data.messages[0].type);
                    } else {
                        ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.relaod();
                    }
                }).
                catch(function(e) {
                    var error;
                    if (e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;

                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
            }

        }, null);
    };

}

Configuration(function(ContextRegister) {
    ContextRegister.register('MonitCalculoController', MonitCalculoController);
});


// FILE: assets/js/controllers/MotivoAdmissaoController.js
function MotivoAdmissaoController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, General,Messages) {

    this.adicionarRow = function(args) {
        var widget = args.owner.widget;
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
    };

	this.setMotivoAdmissao = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
                if (!widget.backupRow) {
                    widget.currentRow.__is_new = true;
                } else {
                    widget.currentRow.__is_new = false;
                }
                restEngine.post('product#/setMotivoAdmissao', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                    then(function (data) {
                        if (data.notifications[0].type === "success") {
                            ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                            if (widget.currentRow.__is_new) {
                                ABUtilController.masterDetailVoltarList(widget);
                                widget.reload();
                            } else {
                                ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                                widget.backupRow = null;
                                widget.view();
                            }
                        } else {
                            ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                        }
                    }).
                    catch(function(e) {
                        var error;
                        if(e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;
                            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    });
            }
    };
    
    this.deleteMotivoAdmissao = function(args) {
    ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
        var widget = args.owner.widget;
        widget.currentRow.__is_new = false;
        restEngine.post('product#/deleteMotivoAdmissao', {'requestType':'DataSet','dataset':[widget.currentRow]}).
            then(function(data){
                if(data.notifications[0].type === "success"){
                    ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                    ABUtilController.masterDetailVoltarList(widget);
                    widget.reload();
                } else {
                    ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                }
            }).
            catch(function(e) {
                var error;
                if(e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
        }, null);
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('MotivoAdmissaoController', MotivoAdmissaoController);
});

// FILE: assets/js/controllers/MotivoAfastamentoController.js
function MotivoAfastamentoController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, General,Messages) {

    this.adicionarRow = function(args) {
        var widget = args.owner.widget;
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
    };

	this.setMotivoAfastamento = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
                if (!widget.backupRow) {
                    widget.currentRow.__is_new = true;
                } else {
                    widget.currentRow.__is_new = false;
                }
                restEngine.post('product#/setMotivoAfastamento', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                    then(function (data) {
                        if (data.notifications[0].type === "success") {
                            ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                            if (widget.currentRow.__is_new) {
                                ABUtilController.masterDetailVoltarList(widget);
                                widget.reload();
                            } else {
                                ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                                widget.backupRow = null;
                                widget.view();
                            }
                        } else {
                            ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                        }
                    }).
                    catch(function(e) {
                        var error;
                        if(e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;
                            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    });
            }
    };
    
    this.deleteMotivoAfastamento = function(args) {
    ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
        var widget = args.owner.widget;
        widget.currentRow.__is_new = false;
        restEngine.post('product#/deleteMotivoAfastamento', {'requestType':'DataSet','dataset':[widget.currentRow]}).
            then(function(data){
                if(data.notifications[0].type === "success"){
                    ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                    ABUtilController.masterDetailVoltarList(widget);
                    widget.reload();
                } else {
                    ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                }
            }).
            catch(function(e) {
                var error;
                if(e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
        }, null);
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('MotivoAfastamentoController', MotivoAfastamentoController);
});

// FILE: assets/js/controllers/MotivoAusenciaFMController.js
function MotivoAusenciaFMController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, General,Messages) {

    this.adicionarRow = function(args) {
        var widget = args.owner.widget;
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
    };
    
	this.setMotivoAusenciaFM = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
                if (!widget.backupRow) {
                    widget.currentRow.__is_new = true;
                } else {
                    widget.currentRow.__is_new = false;
                }
                restEngine.post('product#/setMotivoAusenciaFM', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                    then(function (data) {
                        if (data.notifications[0].type === "success") {
                            ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                            if (widget.currentRow.__is_new) {
                                ABUtilController.masterDetailVoltarList(widget);
                                widget.reload();
                            } else {
                                ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                                widget.backupRow = null;
                                widget.view();
                            }
                        } else {
                            ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                        }
                    }).
                    catch(function(e) {
                        var error;
                        if(e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;
                            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    });
            }
    };
    
    this.deleteMotivoAusenciaFM = function(args) {
    ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
        var widget = args.owner.widget;
        widget.currentRow.__is_new = false;
        restEngine.post('product#/deleteMotivoAusenciaFM', {'requestType':'DataSet','dataset':[widget.currentRow]}).
            then(function(data){
                if(data.notifications[0].type === "success"){
                    ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                    ABUtilController.masterDetailVoltarList(widget);
                    widget.reload();
                } else {
                    ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                }
            }).
            catch(function(e) {
                var error;
                if(e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
        },null);
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('MotivoAusenciaFMController', MotivoAusenciaFMController);
});

// FILE: assets/js/controllers/MotivoDevolucaoEPIController.js
function MotivoDevolucaoEPIController(ScreenService, templateManager, restEngine, ABUtilController, Messages) {

	this.salvar = function(args) {
        var widget = templateManager.container.getActiveWidget();
        if (widget.isValid()) {
            if (!widget.backupRow) {
                widget.currentRow.__is_new = true;
            } else {
                widget.currentRow.__is_new = false;
            }
            restEngine.post('product#/setMotivoDevolucaoEpi', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                then(function (data) {
                    if (data.notifications[0].type === "success") {
                        ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                        if (widget.currentRow.__is_new) {
                            ABUtilController.masterDetailVoltarList(widget);
                            widget.reload();
                        } else {
                            ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                            widget.backupRow = null;
                            widget.view();
                        }
                    } else {
                        ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                    }
                }).
                catch(function(e) {
                    var error;
                    if(e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;

                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
        }
    };

    this.remover = function(args) {
    ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
        var widget = templateManager.container.getActiveWidget();
        if (widget.isValid()) {
            widget.currentRow.__is_new = false;
            restEngine.post('product#/deleteMotivoDevolucaoEpi', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                then(function (data) {
                    if (data.notifications[0].type === "success") {
                        ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    } else {
                        ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                    }
                }).
                catch(function(e) {
                    var error;
                    if(e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;

                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
            }
        },null);
    };

}

Configuration(function(ContextRegister) {
    ContextRegister.register('MotivoDevolucaoEPIController', MotivoDevolucaoEPIController);
});

// FILE: assets/js/controllers/MotivoEstabilidadeController.js
function MotivoEstabilidadeController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, General,Messages) {

    this.adicionarRow = function(args) {
        var widget = args.owner.widget;
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
    };

	this.setMotivoEstabilidade = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
                if (!widget.backupRow) {
                    widget.currentRow.__is_new = true;
                } else {
                    widget.currentRow.__is_new = false;
                }
                restEngine.post('product#/setMotivoEstabilidade', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                    then(function (data) {
                        if (data.notifications[0].type === "success") {
                            ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                            if (widget.currentRow.__is_new) {
                                ABUtilController.masterDetailVoltarList(widget);
                                widget.reload();
                            } else {
                                ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                                widget.backupRow = null;
                                widget.view();
                            }
                        } else {
                            ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                        }
                    }).
                    catch(function(e) {
                        var error;
                        if(e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;
                            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    });
            }
    };
    
    this.deleteMotivoEstabilidade = function(args) {
        var widget = args.owner.widget;
        widget.currentRow.__is_new = false;
        restEngine.post('product#/deleteMotivoEstabilidade', {'requestType':'DataSet','dataset':[widget.currentRow]}).
            then(function(data){
                if(data.notifications[0].type === "success"){
                    ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                    ABUtilController.masterDetailVoltarList(widget);
                    widget.reload();
                } else {
                    ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                }
            }).
            catch(function(e) {
                var error;
                if(e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('MotivoEstabilidadeController', MotivoEstabilidadeController);
});

// FILE: assets/js/controllers/MotivoOcorrenciaFrequenciaController.js
/**
 * Created by lara loures on 02/09/2016.
 */
function MotivoOcorrenciaFrequenciaController (ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, ABUtilController, AFormataHoraDecimal, Messages) {
 
     this.openAdicionarMotivo = function(args) {
        var widget = ABUtilController.checkWidget(args);
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
    };

    this.deleteMotivoOcorrencia = function(args) {
        var widget = args.owner.widget;
        var data = {}; 
        ScreenService.confirmMessage(Messages.DELETE_ROW, 'CONFIRMATION', 
            function(){
                widget.dataSource.checkedRows = widget.currentRow;
                widget.removeCheckedRows();
                widget.reload();
                ABUtilController.masterDetailVoltarList(widget);
                ScreenService.showMessage(Messages.REMOVE_ROW_SUCCESS);
            }.bind(this)
        );
    };

    this.salvarMotivoOcorrencia = function(argsRow){
        var widget = templateManager.container.getWidget("motivoOcorrenciaFrequencia");
        if(widget.isValid())  {
            widget.currentRow.CDOPERLOG = getLocalVar("HCM_CDOPERADOR");
            widget.currentRow.NRORGTRAB = getLocalVar("HCM_NRORG_TRAB");
            widget.currentRow.DTATUAL = getLocalVar("HCM_DATA_ATUAL");
            return widget.saveRow().then(function(){
                widget.currentRow.changed = false;
                widget.currentRow.__is_new = false;
                ScreenService.showMessage(Messages.SAVE_ROW_SUCCESS);
                ABUtilController.masterDetailVoltarList(widget);
                widget.reload();
            }).catch(function(e) {
                var error;
                if(e.data.error === undefined)
                    error = e;
                else 
                    error = e.data.error;
                
                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error));
            });
        }
    };

}

Configuration(function(ContextRegister) {
    ContextRegister.register('MotivoOcorrenciaFrequenciaController', MotivoOcorrenciaFrequenciaController);
});

// FILE: assets/js/controllers/MotivoOcupacaoController.js
function MotivoOcupacaoController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, General,Messages) {

    this.adicionarRow = function(args) {
        var widget = args.owner.widget;
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
    };

	this.setMotivoOcupacao = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
                if (!widget.backupRow) {
                    widget.currentRow.__is_new = true;
                } else {
                    widget.currentRow.__is_new = false;
                }
                restEngine.post('product#/setMotivoOcupacao', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                    then(function (data) {
                        if (data.notifications[0].type === "success") {
                            ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                            if (widget.currentRow.__is_new) {
                                ABUtilController.masterDetailVoltarList(widget);
                                widget.reload();
                            } else {
                                ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                                widget.backupRow = null;
                                widget.view();
                            }
                        } else {
                            ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                        }
                    }).
                    catch(function(e) {
                        var error;
                        if(e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;
                            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    });
            }
    };
    
    this.deleteMotivoOcupacao = function(args) {
    ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
        var widget = args.owner.widget;
        widget.currentRow.__is_new = false;
        restEngine.post('product#/deleteMotivoOcupacao', {'requestType':'DataSet','dataset':[widget.currentRow]}).
            then(function(data){
                if(data.notifications[0].type === "success"){
                    ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                    ABUtilController.masterDetailVoltarList(widget);
                    widget.reload();
                } else {
                    ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                }
            }).
            catch(function(e) {
                var error;
                if(e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
        }, null);
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('MotivoOcupacaoController', MotivoOcupacaoController);
});

// FILE: assets/js/controllers/MotivoRescisaoController.js
function MotivoRescisaoController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, General,Messages) {

    this.adicionarRow = function(args) {
        var widget = args.owner.widget;
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
    };

	this.setMotivoRescisao = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
                if (!widget.backupRow) {
                    widget.currentRow.__is_new = true;
                } else {
                    widget.currentRow.__is_new = false;
                }
                restEngine.post('product#/setMotivoRescisao', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                    then(function (data) {
                        if (data.notifications[0].type === "success") {
                            ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                            if (widget.currentRow.__is_new) {
                                ABUtilController.masterDetailVoltarList(widget);
                                widget.reload();
                            } else {
                                ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                                widget.backupRow = null;
                                widget.view();
                            }
                        } else {
                            ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                        }
                    }).
                    catch(function(e) {
                        var error;
                        if(e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;
                            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    });
            }
    };
    
    this.deleteMotivoRescisao = function(args) {
    ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
        var widget = args.owner.widget;
        widget.currentRow.__is_new = false;
        restEngine.post('product#/deleteMotivoRescisao', {'requestType':'DataSet','dataset':[widget.currentRow]}).
            then(function(data){
                if(data.notifications[0].type === "success"){
                    ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                    ABUtilController.masterDetailVoltarList(widget);
                    widget.reload();
                } else {
                    ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                }
            }).
            catch(function(e) {
                var error;
                if(e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
        }, null);
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('MotivoRescisaoController', MotivoRescisaoController);
});

// FILE: assets/js/controllers/MotivoSituFuncController.js
function MotivoSituFuncController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, ABUtilController, Messages, HcmConsts) {

    var self = this;
    
    this.openAdicionarMotivo = function(args) {
        var widget = ABUtilController.checkWidget(args);
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
    };
    
     this.setMotivoSituFunc = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
                if (!widget.backupRow) {
                    widget.currentRow.__is_new = true;
                } else {
                    widget.currentRow.__is_new = false;
                }
                restEngine.post('product#/setMotivoSituFunc', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                    then(function (data) {
                        if (data.notifications[0].type === "success") {
                            ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                            if (widget.currentRow.__is_new) {
                                ABUtilController.masterDetailVoltarList(widget);
                                widget.reload();
                            } else {
                                ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                                widget.backupRow = null;
                                widget.view();
                            }
                        } else {
                            ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                        }
                    }).
                    catch(function(e) {
                        var error;
                        if(e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;
                            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    });
            }
    };
    
    this.remover = function(widget) {
        ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
            if (widget.isValid()) {
                widget.currentRow.__is_new = false;
                restEngine.post('product#/deleteMotivoSitufunc', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                        then(function (data) {
                            if (data.messages) {
                            ScreenService.showMessage(Messages.REMOVE_ROW_ERROR + '. ' + data.messages[0].message, data.messages[0].type);
                        } else {
                            ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                            ABUtilController.masterDetailVoltarList(widget);
                            widget.reload();
                        }
                    }).
                    catch(function(e) {
                        var error;
                        if(e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;

                        ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    });
            }
        }, null);
    };
    
}

Configuration(function(ContextRegister) {
    ContextRegister.register('MotivoSituFuncController', MotivoSituFuncController);
});


// FILE: assets/js/controllers/MotivoTransferenciaController.js
function MotivoTransferenciaController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, General,Messages) {

    this.adicionarRow = function(args) {
        var widget = args.owner.widget;
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
    };

	this.setMotivoTransferencia = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
                if (!widget.backupRow) {
                    widget.currentRow.__is_new = true;
                } else {
                    widget.currentRow.__is_new = false;
                }
                restEngine.post('product#/setMotivoTransferencia', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                    then(function (data) {
                        if (data.notifications[0].type === "success") {
                            ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                            if (widget.currentRow.__is_new) {
                                ABUtilController.masterDetailVoltarList(widget);
                                widget.reload();
                            } else {
                                ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                                widget.backupRow = null;
                                widget.view();
                            }
                        } else {
                            ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                        }
                    }).
                    catch(function(e) {
                        var error;
                        if(e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;
                            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    });
            }
    };
    
    this.deleteMotivoTransferencia = function(args) {
    ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
        var widget = args.owner.widget;
        widget.currentRow.__is_new = false;
        restEngine.post('product#/deleteMotivoTransferencia', {'requestType':'DataSet','dataset':[widget.currentRow]}).
            then(function(data){
                if(data.notifications[0].type === "success"){
                    ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                    ABUtilController.masterDetailVoltarList(widget);
                    widget.reload();
                } else {
                    ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                }
            }).
            catch(function(e) {
                var error;
                if(e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
        }, null);
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('MotivoTransferenciaController', MotivoTransferenciaController);
});

// FILE: assets/js/controllers/MovimentacaoController.js
/**
 * Created by felipesantos on 16/12/2016.
 */
/* jshint esversion: 6 */
function MovimentacaoController (ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, ABUtilController, Messages, HcmConsts) {

    var self = this;
    var nrtipoestrutura = '';
    var nmtipoestrutura = '';
    this.camposData = ['DTINIMOVIMENT', 'DTFIMMOVIMENT', 'DTMOVIMENTRETRO'];

    this.setEditFields = function(idReadOnly) {
        var widgetMovimentacao = templateManager.container.getWidget('movimentacao');
        if(widgetMovimentacao.parent && widgetMovimentacao.parent.name == "vinculo")
            widgetMovimentacao.getField('NMVINCULOM').readOnly = true;
        else    
            widgetMovimentacao.getField('NMVINCULOM').readOnly = idReadOnly;
        widgetMovimentacao.getField('NMTIPOTRANSFER').readOnly = idReadOnly;
        widgetMovimentacao.getField('NMTPMOVTRANSFH').readOnly = idReadOnly;
        widgetMovimentacao.getField('NMMOTIVOTRANSF').readOnly = idReadOnly;
        widgetMovimentacao.getField('IDATUALIZAACERTO').readOnly = idReadOnly;
        widgetMovimentacao.getField('NMTIPOESTRUTURA').readOnly = idReadOnly;
        widgetMovimentacao.getField('NMESTRUTURAH').readOnly = idReadOnly;
        widgetMovimentacao.getField('DTMOVIMENTRETRO').readOnly = idReadOnly;
    };
    
    this.setFiltroEstrutura = function(widget) {
        var alteraEstrutura = false;
        if(nrtipoestrutura != widget.currentRow.NRTIPOESTRUTURA){
            alteraEstrutura = true;
        }
        nrtipoestrutura = widget.currentRow.NRTIPOESTRUTURA;
        nmtipoestrutura = widget.currentRow.NMTIPOESTRUTURA;
        if (nmtipoestrutura === '') {
            widget.currentRow.NRTIPOESTRUTURA = null;
            nrtipoestrutura = '';
            widget.getField('NMESTRUTURAH').dataSourceFilter = [
                { "name": "NRORG", "operator": "=", "value": "@getLocalVar('HCM_NRORG_TRAB') ? getLocalVar('HCM_NRORG_TRAB') : '' @" },
                { "name": "NRORG_PADRAO", "operator": "=", "value": "@getLocalVar('HCM_NRORG_PADRAO') ? getLocalVar('HCM_NRORG_PADRAO') : '' @" },
                { "name": "DTMESCOMPETENC", "operator": "=", "value": "@getLocalVar('HCM_DTCOMPETENCIA_OPER') ? getLocalVar('HCM_DTCOMPETENCIA_OPER') : '' @" }
            ];
            widget.currentRow.NMESTRUTURAH = '';
            widget.currentRow.NRESTRUTURAM = '';
        } else {
            widget.getField('NMESTRUTURAH').dataSourceFilter = [
                { "name": "NRORG", "operator": "=", "value": "@getLocalVar('HCM_NRORG_TRAB') ? getLocalVar('HCM_NRORG_TRAB') : '' @" },
                { "name": "NRORG_PADRAO", "operator": "=", "value": "@getLocalVar('HCM_NRORG_PADRAO') ? getLocalVar('HCM_NRORG_PADRAO') : '' @" },
                { "name": "DTMESCOMPETENC", "operator": "=", "value": "@getLocalVar('HCM_DTCOMPETENCIA_OPER') ? getLocalVar('HCM_DTCOMPETENCIA_OPER') : '' @" },
                { "name": "NRTIPOESTRUTURA", "operator": "=", "value": nrtipoestrutura }
            ];
            if(alteraEstrutura){
                widget.currentRow.NMESTRUTURAH = '';
                widget.currentRow.NRESTRUTURAM = '';
            }
        }
        
        ABUtilController.loadFieldAutoComplete(widget.getField('NMESTRUTURAH'));
    };

    this.setFiltroEstruturaOrig = function(widget) {
        nrtipoestrutura = widget.currentRow.NRTIPOESTRUTURAORIG;
        nmtipoestrutura = widget.currentRow.NMTIPOESTRUTURAORIG;
        if (nrtipoestrutura === '') {
            widget.getField('NMESTRUTURAHORIG').dataSourceFilter = [
                { "name": "NRORG", "operator": "=", "value": "@getLocalVar('HCM_NRORG_TRAB') ? getLocalVar('HCM_NRORG_TRAB') : '' @" },
                { "name": "NRORG_PADRAO", "operator": "=", "value": "@getLocalVar('HCM_NRORG_PADRAO') ? getLocalVar('HCM_NRORG_PADRAO') : '' @" },
                { "name": "DTMESCOMPETENC", "operator": "=", "value": "@getLocalVar('HCM_DTCOMPETENCIA_OPER') ? getLocalVar('HCM_DTCOMPETENCIA_OPER') : '' @" }
            ];
        } else {
            widget.getField('NMESTRUTURAHORIG').dataSourceFilter = [
                { "name": "NRORG", "operator": "=", "value": "@getLocalVar('HCM_NRORG_TRAB') ? getLocalVar('HCM_NRORG_TRAB') : '' @" },
                { "name": "NRORG_PADRAO", "operator": "=", "value": "@getLocalVar('HCM_NRORG_PADRAO') ? getLocalVar('HCM_NRORG_PADRAO') : '' @" },
                { "name": "DTMESCOMPETENC", "operator": "=", "value": "@getLocalVar('HCM_DTCOMPETENCIA_OPER') ? getLocalVar('HCM_DTCOMPETENCIA_OPER') : '' @" },
                { "name": "NRTIPOESTRUTURA", "operator": "=", "value": nrtipoestrutura }
            ];
        }
        ABUtilController.loadFieldAutoComplete(widget.getField('NMESTRUTURAHORIG'));
    };

    this.validaDtMovimentacaoCompetencia = function(dtInimoviment) {
        var dtCompetencia = getLocalVar('HCM_DTCOMPETENCIA_OPER');
        if(dtInimoviment.substring(3) === dtCompetencia.substring(3)){
            return true;
        } else {
            ScreenService.alertNotification(Messages.DATAINI_MES_COMPETENC_ERROR, 10000);
            return false;
        }
    };

    this.validaDataTpTransf = function(nrTpMovTransfm, dtFimmoviment) {
        if (nrTpMovTransfm === HcmConsts.GpeTpmovtransfm.TRANSFERENCIA_SAIDA && (dtFimmoviment === '' || !dtFimmoviment)) {
            ScreenService.alertNotification(Messages.HCM00000_GPE_MOVIMENTACAO_DTFIM_TRANSF_SAIDA_ERROR, 10000);
            return false;
        }
        return true;
    };

    this.salvarMovimentacao = function(args, ESocialController, verificaEnvioEsocialDescentralizado = true) {
        var widget = templateManager.container.getActiveWidget();
        var tipovinculo = '';
        var dtinimoviment = widget.currentRow.DTINIMOVIMENT;
        var dtfimmoviment = widget.currentRow.DTFIMMOVIMENT;
        var nrtpmovtransfm = widget.currentRow.NRTPMOVTRANSFM;
        var idutilizamatriz = widget.currentRow.IDUTILIZAMATRIC;
        var nrtpestrutura = widget.currentRow.NRTIPOESTRUTURA;
        var nrtipotransfer = widget.currentRow.NRTIPOTRANSFER;
        var mensagem = null;
        
        if(!Util.isEmptyOrBlank(widget.currentRow.NRTIPOVINCULOM)){
            tipovinculo = widget.currentRow.NRTIPOVINCULOM;
        }else{
            tipovinculo = templateManager.container.getWidget('vinculo') ? templateManager.container.getWidget('vinculo').currentRow.NRTIPOVINCULOM : null;
        }
        
        if (widget.isValid()) {
            if (!widget.backupRow) {
                widget.currentRow.__is_new = true;
            } else {
                widget.currentRow.__is_new = false;
            }
            if(verificaEnvioEsocialDescentralizado && nrtipotransfer == 1 && nrtpmovtransfm == 8 && widget.currentRow.__is_new == true){
                if(tipovinculo == 1){
                    ESocialController.envioEsocialDescentralizado(widget.currentRow, 'S-22', widget.currentRow.NRVINCULOM, widget.currentRow.NRVINCULOM, self.salvarMovimentacao, args);
                }else{
                    ESocialController.envioEsocialDescentralizado(widget.currentRow, 'S-23', widget.currentRow.NRVINCULOM, widget.currentRow.NRVINCULOM, self.salvarMovimentacao, args);
                }   
            }else{
                
                //if(ABUtilController.validaDtIniMenorIgualDtFin(dtinimoviment, dtfimmoviment)) {
                    if(((widget.currentRow.__is_new && self.validaDtMovimentacaoCompetencia(dtinimoviment)) || !widget.currentRow.__is_new) && self.validaDataTpTransf(nrtpmovtransfm, dtfimmoviment)) {
                        restEngine.post('product#/setMovimentacao', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                            then(function (data) {
                                if (!Util.isUndefined(data.notifications) && data.notifications[0].type === "success") {
                                    ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                                    if(data.dataset && data.dataset.retornoEsocial && !Util.isEmptyOrBlank(data.dataset.retornoEsocial)){
                                        /*var*/ mensagem = '';
                                        // data.dataset.retornoEsocial.valueOf().forEach(function(retorno, index){
                                        //     mensagem += index + ':<br>' + retorno.MSG + '<br>';
                                        // });
                                        if(data.dataset.retornoEsocial['S-2206']){
                                            mensagem += 'S-2206:<br>' + data.dataset.retornoEsocial['S-2206'].MSG + '<br>';
                                        }
                                        if(data.dataset.retornoEsocial['S-2299']){
                                            mensagem += 'S-2299:<br>' + data.dataset.retornoEsocial['S-2299'].MSG + '<br>';
                                        }
                                        if(data.dataset.retornoEsocial['S-2200']){
                                            mensagem += 'S-2200:<br>' + data.dataset.retornoEsocial['S-2200'].MSG + '<br>';
                                        }
                                        
                                        //ScreenService.showMessage(mensagem);
                                    }
                                    if (data.notifications.length > 1) {
                                        data.notifications.shift();
                                        data.notifications.forEach(function (notification) {
                                            ScreenService.notificationMessage(notification.message, 10000);
                                        });
                                    }
                                    if (!Util.isUndefined(data.messages)) {
                                        ScreenService.showMessage(data.messages[0].message, data.messages[0].type);
                                    }
                                    if(data.dataset.MatriculaESocial && nrtpestrutura == getLocalVar('HCM_NRTIPOESTRUTLEGAL')){
                                        var widgetVinculo = templateManager.container.getWidget('vinculo');
                                        if(widgetVinculo){
                                            widgetVinculo.currentRow.CDMATRICULAESOCIAL = data.dataset.MatriculaESocial.NOVO;
                                            // if(idutilizamatriz == 'S'){
                                            //     widgetVinculo.getField('CDMATRICULAESOCIAL').readOnly = false;    
                                            // }else{
                                            //     widgetVinculo.getField('CDMATRICULAESOCIAL').readOnly = true;    
                                            // }
                                        }
                                    }
                                    if (widget.currentRow.__is_new) {
                                        ABUtilController.masterDetailVoltarList(widget);
                                        widget.reload();
                                    } else {
                                        ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                                        self.setEditFields(false);
                                        widget.backupRow = null;
                                        widget.view();
                                    }
                                    self.verificaHistoricoPosterior(widget.currentRow.NRVINCULOM, getLocalVar('HCM_DTCOMPETENCIA_OPER'), mensagem);
                                } else if (!Util.isUndefined(data.messages)) {
                                    ScreenService.showMessage(data.messages[0].message, data.messages[0].type);
                                } else {
                                    ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                                }
                            }).
                            catch(function (e) {
                                var error;
                                if (e.data.error === undefined)
                                    error = e;
                                else
                                    error = e.data.error;
    
                                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                            });
                    }
                /*}else{
                    ScreenService.showMessage(Messages.DTINI_POST_DTFIM_ERROR);
                }*/
            }
        }
    };

    this.deleteMovimentacao = function(args) {
        var widget = templateManager.container.getActiveWidget();
        var nrtipoestrutura = widget.currentRow.NRTIPOESTRUTURA;
        if (widget.isValid()) {
            widget.currentRow.__is_new = false;
            
            ScreenService.confirmMessage(Messages.DELETE_ROW, 'CONFIRMATION', function(){
                    
                restEngine.post('product#/deleteMovimentacao', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                    then(function (data) {
                        if (data.notifications && data.notifications[0].type === "success") {
                            ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                            ABUtilController.masterDetailVoltarList(widget);
                            widget.reload();
                            if(data.dataset.MatriculaESocial && nrtipoestrutura == getLocalVar('HCM_NRTIPOESTRUTLEGAL')){
                                var widgetVinculo = templateManager.container.getWidget('vinculo');
                                if(widgetVinculo){
                                    widgetVinculo.currentRow.CDMATRICULAESOCIAL = data.dataset.MatriculaESocial.ANTIGA;
                                }
                            }
                        } else {
                            ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                        }
                        self.verificaHistoricoPosterior(widget.currentRow.NRVINCULOM, getLocalVar('HCM_DTCOMPETENCIA_OPER'));
                    }).
                    catch(function(e) {
                        var error;
                        if(e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;
    
                        ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    });
                
            }.bind(this));
        }
    };

    this.openPopupCadAuto = function(action) {
        var widgetPopup = templateManager.container.getWidget('popupCadAutomatico');
        ABUtilController.masterDetailOpenPopup(widgetPopup);
    };

    this.gerarMovimentacoes = function(widgetCadAuto) {
        if (widgetCadAuto.isValid()) {
            var dtinimoviment = widgetCadAuto.currentRow.DTINIMOVIMENT;
            var dtfimmoviment = widgetCadAuto.currentRow.DTFIMMOVIMENT;
            var nrtpmovtransfm = widgetCadAuto.currentRow.NRTPMOVTRANSFM;
            if (this.validaDtMovimentacaoCompetencia(dtinimoviment) && this.validaDataTpTransf(nrtpmovtransfm, dtfimmoviment)) {
                ScreenService.showCustomDialog('Deseja gerar as manutenções das movimentações conforme os dados informados?', 'CONFIRMATION', null, [
                    {
                        label: ScreenService.i18n("Sim"),
                        code: function (e, deferred) {
                            this.executaCadAuto(widgetCadAuto);
                            deferred.resolve(e);
                        }.bind(this)
                    },
                    {
                        label: ScreenService.i18n("Não"),
                        code: function (e, deferred) {
                            deferred.reject(e);
                        }
                    }
                ]);
            }
        }
    };

    this.executaCadAuto = function(widget) {
        restEngine.post("product#/gerarMovimentacoes", {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
            then(function (data) {
                if (data.messages) {
                    var textMessage = '';
                    data.messages.forEach(function(objMsg) {
                        textMessage += '-' + objMsg.message + '<br>';
                    });
                    ScreenService.showMessage(textMessage);
                }

                if (data.notifications[0].type === "error") {
                    ScreenService.alertNotification(Messages.CADASTRO_AUTOMATICO_ERRO, 10000);
                } else {
                    ScreenService.successNotification(Messages.CADASTRO_AUTOMATICO_SUCCESS, 10000);
                    ABUtilController.masterDetailClosePopup(widget);
                    templateManager.container.getWidget('movimentacao').activate();
                    templateManager.container.getWidget('movimentacao').reload();
                }
            }).
            catch(function (e) {
                var error;
                if (e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;

                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
    };
    
    this.setValorTipoMovimentacao = function() {
        var widget = templateManager.container.getActiveWidget();
        widget.getField('IDATUALIZAACERTO').setValue("0");
    };
    
    this.setValorTipoEstrutura = function(widget) {
        var nmestruturah = widget.currentRow.NMESTRUTURAH;
        if (nrtipoestrutura){
            if (nmestruturah === '') {
                widget.currentRow.NRTIPOESTRUTURA = nrtipoestrutura;
                widget.currentRow.NMTIPOESTRUTURA = nmtipoestrutura;
            } else {
                nrtipoestrutura = widget.currentRow.NRTIPOESTRUTURA;
                nmtipoestrutura = widget.currentRow.NMTIPOESTRUTURA;
            }
        } else {
            if (nmestruturah === '') {
                widget.currentRow.NRTIPOESTRUTURA = nrtipoestrutura;
                widget.currentRow.NMTIPOESTRUTURA = nmtipoestrutura;
            } else {
                nrtipoestrutura = widget.currentRow.NRTIPOESTRUTURA;
                nmtipoestrutura = widget.currentRow.NMTIPOESTRUTURA;
                this.setFiltroEstrutura(widget);
            }
        }     
    };
    
    this.setCompetenciaEmDtInicio = function(){

        var filtro = templateManager.container.getActiveWidget();

        filtro.currentRow.DTINIMOVIMENT = {};

        if(filtro.currentRow.IDSOMENTECOMPET && filtro.currentRow.IDSOMENTECOMPET == 'S'){
            filtro.currentRow.DTINIMOVIMENT.start = getLocalVar('HCM_DTCOMPETENCIA_OPER');
            filtro.currentRow.DTINIMOVIMENT.formattedStart = getLocalVar('HCM_DTCOMPETENCIA_OPER');
            filtro.currentRow.DTINIMOVIMENT.end = getLocalVar('HCM_FIM_DTCOMPETENCIA_OPER');
            filtro.currentRow.DTINIMOVIMENT.formattedEnd = getLocalVar('HCM_FIM_DTCOMPETENCIA_OPER');
        }else{
            filtro.currentRow.DTINIMOVIMENT.start = "";
            filtro.currentRow.DTINIMOVIMENT.formattedStart = "__/__/____";
            filtro.currentRow.DTINIMOVIMENT.end = "";
            filtro.currentRow.DTINIMOVIMENT.formattedEnd = "__/__/____";
        }
    };
    
    /**
     * Verifica se há históricos posteriores ao vínculo editado, se houver este indaga ao operador se quer atualiza-los também
     */
    this.verificaHistoricoPosterior = function($nrvinculom, $dtmescompetenc, eSocialMessage) {
        var info = [$nrvinculom, $dtmescompetenc];
        var msg;
        
        /*Função: Atualiza os históricos posteriores do vínculo*/
        var atualizaHistoricos = function(historicos, dados) {
            var infos = [historicos, dados];
            restEngine.post('product#/setVinculoHistoricoPosterior', {'requestType': 'DataSet', 'dataset': [infos]})
                .then(function(response) {
                    if(response.messages) {
                        if(response.messages[0].message.length > 0) {
                            msg = 'Competência(s) alteradas:<br>' + response.messages[0].message.join(",<br>");
                            ScreenService.showMessage(msg, response.messages[0].type);
                        } else {
                            ScreenService.showMessage("Nenhuma competência foi alterada.");
                        }
                    }
                }).catch(function(e) {
                    var error;
                    if(e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
        };
        
        /*Função: Verifica se há históricos para atualizar e lança mensagem na tela*/
        var verificaHistoricos = function(response) {
            if(response.dataset.historicos.length > 0) {
                ScreenService.showCustomDialog(
                    'Vínculo possui históricos posteriores à esta competência. Deseja atualizar esses históricos?',
                    'CONFIRMATION',
                    null,
                    [
                        {
                            label: ScreenService.i18n("Sim"),
                            code: function (e, deferred) {
                                atualizaHistoricos(response.dataset.historicos, info);
                                deferred.reject(e);
                            }.bind(this)
                        },
                        {
                            label: ScreenService.i18n("Não"),
                            code: function (e, deferred) {
                                deferred.resolve(e);
                            }.bind(this)
                        }
                    ]);
            }
        };
        
        /*Requisição ao backend para consultar possíveis históricos*/
        var consultaHistoricos = function() {
            restEngine.post('product#/getVinculoHistoricoPosterior', {'requestType': 'DataSet', 'dataset': [info]})
                    .then(verificaHistoricos);
        };
        
        /*Exibe as mensagens do eSocial (se houver) e aciona a rotina de verificação de existência de históricos posteriores*/
        if(eSocialMessage != null)
            ScreenService.showMessage(eSocialMessage).then(consultaHistoricos);
        else
            consultaHistoricos();
            
    };
    
    this.exibeInclusaoAutomaticaMovSaida = function(tela) {
        var widget = templateManager.container.getActiveWidget();
        var isEstruturaMovimentacaoLegal = false;
        var isTipoTransferenciaEmpresaFilial = (widget.currentRow.NMTIPOESTRUTURA === "EMPRESA" || widget.currentRow.NMTIPOESTRUTURA === "FILIAL") && 
                                               (widget.currentRow.NMTIPOESTRUTURAORIG === "EMPRESA" || widget.currentRow.NMTIPOESTRUTURAORIG === "FILIAL");
        if( tela == "telaMovimentacao" ){
            isEstruturaMovimentacaoLegal = widget.currentRow.NMTIPOTRANSFER === "Movimentação Legal";
        } else {
            isEstruturaMovimentacaoLegal = widget.currentRow.NMTIPOTRANSFERDEST === "Movimentação Legal" && widget.currentRow.NMTIPOTRANSFERORIG === "Movimentação Legal";
        }
        
        if( isEstruturaMovimentacaoLegal && isTipoTransferenciaEmpresaFilial ){
            widget.getField('INCLUSAOAUTOMATICAMOVSAIDA').isVisible = true;
            widget.currentRow.INCLUSAOAUTOMATICAMOVSAIDA = 'S';
        } else {
            widget.getField('INCLUSAOAUTOMATICAMOVSAIDA').isVisible = false;
            widget.currentRow.INCLUSAOAUTOMATICAMOVSAIDA = 'N';
        }
    };
    
    this.verificaInclusaoAutomaticaMovSaida = function() {
        var widget = templateManager.container.getActiveWidget();
        if( widget.currentRow.NMTIPOTRANSFER === "Movimentação Legal" && (widget.currentRow.NMTIPOESTRUTURA === "EMPRESA" || widget.currentRow.NMTIPOESTRUTURA === "FILIAL") ){
            widget.currentRow.INCLUSAOAUTOMATICAMOVSAIDA = 'S';
        } else {
            widget.currentRow.INCLUSAOAUTOMATICAMOVSAIDA = 'N';
        }
    };
    
    this.baixarPlanilhaMovimentacao = function() {
        restEngine.post(
            'product#/baixarPlanilhaMovimentacao', {
                'requestType': 'DataSet',
                'dataset': [] 
            }
        )
        .then(function(data) {
            ScreenService.closePopup();
            if(data.dataset && data.dataset.arquivo){
                window.open(window.serviceUrl + "/abrirArquivo?requestType=DataSet&dataset[0][CMARQUIVO]=" + data.dataset.arquivo.NMARQUIVO);
            }
        })
        .catch(function(e) {
            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(e.data.error), 'ERROR');
        });
    };
    
    this.importarPlanilhaMovimentacao = function() {
        var widgetPop = templateManager.container.getActiveWidget();
        if(widgetPop.isValid()){
            restEngine.post('product#/importarPlanilhaMovimentacao', {'requestType': 'DataSet', 'dataset': [widgetPop.currentRow]}).
            then(function(data) {
                if (data.messages) {
                    ScreenService.closePopup(templateManager.container.getWidget('popupImportacaoPlanilha'));
                    ScreenService.showMessage(data.messages[0].message, data.messages[0].type);
                    if (data.dataset && data.dataset.msg) {
                        openPopupMensagens(data.dataset.msg, 'messagesImportacaoPlanilha');
                    }
                } else {
                    ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                }
            }).
            catch(function(e) {
                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(e.data.error), 'ERROR');
            });
        }
    };
    
    var openPopupMensagens = function(msg, nmPopupMsg) {
        var widgetMensagens = templateManager.container.getWidget(nmPopupMsg);
        widgetMensagens.dataSource.data = msg;
        ScreenService.openPopup(widgetMensagens);
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('MovimentacaoController', MovimentacaoController);
});

// FILE: assets/js/controllers/MovimentacaoTransferenciaController.js
function MovimentacaoTransferenciaController(ScreenService, templateManager, restEngine, ABUtilController, Messages, General) {
    
    this.adicionarRow = function(args) {
        var widget = args.owner.widget;
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
    };
    
    this.salvar = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
            if(ABUtilController.validaDtIniMenorIgualDtFin(widget.currentRow.DTINIVIGENCIA,widget.currentRow.DTFIMVIGENCIA)){
                ABUtilController.saveMasterDetailMasterHistory(widget);
            }else{
                ScreenService.showMessage(Messages.DTINI_POST_DTFIM_ERROR);
                return false;
            }    
        }
    };

    this.remover = function(args) {
    ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
        var widget = args.owner.widget;
        if (widget.isValid()) {
            widget.currentRow.__is_new = false;
            restEngine.post('product#/deleteMovimentacaoTransferencia', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                then(function (data) {
                    if (data.notifications[0].type === "success") {
                        ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    } else {
                        ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                    }
                }).
                catch(function(e) {
                    var error;
                    if(e.data.error === undefined){
                        error = e;
                    }    
                    else{
                        error = e.data.error;
                        ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    }    
                });
        }
      }, null);
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('MovimentacaoTransferenciaController', MovimentacaoTransferenciaController);
});

// FILE: assets/js/controllers/NacionalidadeController.js
function NacionalidadeController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, General,Messages) {

    this.adicionarRow = function(args) {
        var widget = args.owner.widget;
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
    };

	this.setNacionalidade = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
                if (!widget.backupRow) {
                    widget.currentRow.__is_new = true;
                } else {
                    widget.currentRow.__is_new = false;
                }
                restEngine.post('product#/setNacionalidade', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                    then(function (data) {
                        if (data.notifications[0].type === "success") {
                            ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                            if (widget.currentRow.__is_new) {
                                ABUtilController.masterDetailVoltarList(widget);
                                widget.reload();
                            } else {
                                ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                                widget.backupRow = null;
                                widget.view();
                            }
                        } else {
                            ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                        }
                    }).
                    catch(function(e) {
                        var error;
                        if(e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;
                            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    });
            }
    };
    
    this.deleteNacionalidade = function(args) {
    ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
        var widget = args.owner.widget;
        widget.currentRow.__is_new = false;
        restEngine.post('product#/deleteNacionalidade', {'requestType':'DataSet','dataset':[widget.currentRow]}).
            then(function(data){
                if(data.notifications[0].type === "success"){
                    ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                    ABUtilController.masterDetailVoltarList(widget);
                    widget.reload();
                } else {
                    ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                }
            }).
            catch(function(e) {
                var error;
                if(e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
        }, null);
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('NacionalidadeController', NacionalidadeController);
});

// FILE: assets/js/controllers/NaturezaExameController.js
function NaturezaExameController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, General,Messages) {

    this.adicionarRow = function(args) {
        var widget = args.owner.widget;
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
    };
    
	this.setNaturezaExame = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
                if (!widget.backupRow) {
                    widget.currentRow.__is_new = true;
                } else {
                    widget.currentRow.__is_new = false;
                }
                restEngine.post('product#/setNaturezaExame', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                    then(function (data) {
                        if (data.notifications[0].type === "success") {
                            ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                            if (widget.currentRow.__is_new) {
                                ABUtilController.masterDetailVoltarList(widget);
                                widget.reload();
                            } else {
                                ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                                widget.backupRow = null;
                                widget.view();
                            }
                        } else {
                            ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                        }
                    }).
                    catch(function(e) {
                        var error;
                        if(e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;
                            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    });
            }
    };
    
    this.deleteNaturezaExame= function(args) {
    ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
        var widget = args.owner.widget;
        widget.currentRow.__is_new = false;
        restEngine.post('product#/deleteNaturezaExame', {'requestType':'DataSet','dataset':[widget.currentRow]}).
            then(function(data){
                if(data.notifications[0].type === "success"){
                    ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                    ABUtilController.masterDetailVoltarList(widget);
                    widget.reload();
                } else {
                    ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                }
            }).
            catch(function(e) {
                var error;
                if(e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
        }, null);
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('NaturezaExameController', NaturezaExameController);
});

// FILE: assets/js/controllers/NaturezaOcorrenciaController.js
function NaturezaOcorrenciaController(ScreenService, templateManager, restEngine, ABUtilController, Messages) {

	this.salvar = function(args) {
        var widget = templateManager.container.getActiveWidget();
        if (widget.isValid()) {
            if (!widget.backupRow) {
                widget.currentRow.__is_new = true;
            } else {
                widget.currentRow.__is_new = false;
            }
            restEngine.post('product#/setNatureza', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                then(function (data) {
                    if (data.notifications[0].type === "success") {
                        ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                        if (widget.currentRow.__is_new) {
                            ABUtilController.masterDetailVoltarList(widget);
                            widget.reload();
                        } else {
                            ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                            widget.backupRow = null;
                            widget.view();
                        }
                    } else {
                        ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                    }
                }).
                catch(function(e) {
                    var error;
                    if(e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;

                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
        }
    };

    this.remover = function(args) {
    ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
        var widget = templateManager.container.getActiveWidget();
        if (widget.isValid()) {
            widget.currentRow.__is_new = false;
            restEngine.post('product#/deleteNatureza', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                then(function (data) {
                    if (data.notifications[0].type === "success") {
                        ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    } else {
                        ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                    }
                }).
                catch(function(e) {
                    var error;
                    if(e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;

                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
            }
        },null);
    };

}

Configuration(function(ContextRegister) {
    ContextRegister.register('NaturezaOcorrenciaController', NaturezaOcorrenciaController);
});

// FILE: assets/js/controllers/NaturezaRubricaController.js
function NaturezaRubricaController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, General,Messages) {

    this.adicionarRow = function(args) {
        var widget = args.owner.widget;
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
    };

	this.setNaturezaRubrica = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
                if (!widget.backupRow) {
                    widget.currentRow.__is_new = true;
                } else {
                    widget.currentRow.__is_new = false;
                }
                restEngine.post('product#/setNaturezaRubrica', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                    then(function (data) {
                        if (data.notifications[0].type === "success") {
                            ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                            if (widget.currentRow.__is_new) {
                                ABUtilController.masterDetailVoltarList(widget);
                                widget.reload();
                            } else {
                                ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                                widget.backupRow = null;
                                widget.view();
                            }
                        } else {
                            ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                        }
                    }).
                    catch(function(e) {
                        var error;
                        if(e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;
                            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    });
            }
    };
    
    this.deleteNaturezaRubrica = function(args) {
      ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
        var widget = args.owner.widget;
        widget.currentRow.__is_new = false;
        restEngine.post('product#/deleteNaturezaRubrica', {'requestType':'DataSet','dataset':[widget.currentRow]}).
            then(function(data){
                if(data.notifications[0].type === "success"){
                    ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                    ABUtilController.masterDetailVoltarList(widget);
                    widget.reload();
                } else {
                    ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                }
            }).
            catch(function(e) {
                var error;
                if(e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
         }, null);
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('NaturezaRubricaController', NaturezaRubricaController);
});

// FILE: assets/js/controllers/NivelAvaliacaoController.js
function NivelAvaliacaoController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, General,Messages) {

    this.adicionarRow = function(args) {
        var widget = args.owner.widget;
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
    };

   

	this.setQuestao = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
                if (!widget.backupRow) {
                    widget.currentRow.__is_new = true;
                } else {
                    widget.currentRow.__is_new = false;
                }
                restEngine.post('product#/setQuestaoPorNivelAval', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                    then(function (data) {
                        if (data.notifications[0].type === "success") {
                            ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                            if (widget.currentRow.__is_new) {
                                ABUtilController.masterDetailVoltarList(widget);
                                widget.reload();
                            } else {
                                widget.backupRow = null;
                                widget.view();
                            }
                        } else {
                            ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                        }
                    }).
                    catch(function(e) {
                        var error;
                        if(e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;
                            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    });
            }
    };
    
    this.deleteQuestao = function(args) {
        
        ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
        var widget = args.owner.widget;
        widget.currentRow.__is_new = false;
            restEngine.post('product#/deleteQuestaoPorNivelAval', {'requestType':'DataSet','dataset':[widget.currentRow]}).
                then(function(data){
                    if(data.notifications[0].type === "success"){
                        ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    } else {
                        ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                    }
                }).
                catch(function(e) {
                    var error;
                    if(e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;
                        ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
        }, null);
    };
    
    	this.setNivel = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
                if (!widget.backupRow) {
                    widget.currentRow.__is_new = true;
                } else {
                    widget.currentRow.__is_new = false;
                }
                restEngine.post('product#/setNivelAvaliacao', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                    then(function (data) {
                        if (data.notifications[0].type === "success") {
                            ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                            if (widget.currentRow.__is_new) {
                                ABUtilController.masterDetailVoltarList(widget);
                                widget.reload();
                            } else {
                                widget.backupRow = null;
                                widget.view();
                            }
                        } else {
                            ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                        }
                    }).
                    catch(function(e) {
                        var error;
                        if(e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;
                            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    });
            }
            
    };
    
    this.deleteNivel = function(args) {
    ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
        var widget = args.owner.widget;
        if (widget.isValid()) {
            widget.currentRow.__is_new = false;
            restEngine.post('product#/deleteNivelAvaliacao', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                then(function (data) {
                    if (data.messages) {
                        ScreenService.showMessage(Messages.REMOVE_ROW_ERROR + '. ' + data.messages[0].message, data.messages[0].type);
                    } else {
                        ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    }
                }).
                catch(function(e) {
                    var error;
                    if(e.data.error === undefined){
                        error = e;
                    }    
                    else{
                        error = e.data.error;
                        ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    }    
                });
            }
        }, null);
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('NivelAvaliacaoController', NivelAvaliacaoController);
});

// FILE: assets/js/controllers/NivelQuestaoController.js
function NivelQuestaoController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, General,Messages) {
    
    var self = this;
    var idFiltrarWidgetMain;
    var nmFiltrarWidgetMain;
    var nomeVerifica;
    
    
    this.adicionarRow = function(args) {
        var widget = args.owner.widget;
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
    };
    
    this.filtrarWidgetMain = function(widget){
        
        widget.activate();
        widget.reload();
        
        
    };

    
    this.setNivelQuestao = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
            if (ABUtilController.validaDtIniMenorIgualDtFin(widget.currentRow.DTINIVIGENCIA, widget.currentRow.DTFIMVIGENCIA)) {
                if (!widget.backupRow) {
                    widget.currentRow.__is_new = true;
                } else {
                    widget.currentRow.__is_new = false;
                }
                restEngine.post('product#/setNivelQuestao', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                    then(function (data) {
                        if (data.notifications[0].type === "success") {
                            ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                            if (widget.currentRow.__is_new) {
                                ABUtilController.masterDetailVoltarList(widget);
                                widget.reload();
                            } else {
                                widget.backupRow = null;
                                widget.view();
                            }
                        } else {
                            ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                        }
                    }).
                    catch(function(e) {
                        var error;
                        if(e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;
                            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    });
            }else{
                ScreenService.showMessage(Messages.DTINI_POST_DTFIM_ERROR);
                return false;
            }        
        }
        // widget.reload();     
    };

    this.deleteNivelQuestao = function(args) {
    ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
        var widget = args.owner.widget;
        widget.currentRow.__is_new = false;
        restEngine.post('product#/deleteNivelQuestao', {
            'requestType': 'DataSet',
            'dataset': [widget.currentRow]
        }).
        then(function(data) {
            if (data.notifications[0].type === "success") {
                ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                ABUtilController.masterDetailVoltarList(widget);
                widget.reload();
            }
            else {
                ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
            }
        }).
        catch(function(e) {
            var error;
            if (e.data.error === undefined)
                error = e;
            else
                error = e.data.error;
            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
        });
    }, null);
            
    
    };
    
}

Configuration(function(ContextRegister) {
    ContextRegister.register('NivelQuestaoController', NivelQuestaoController);
});

// FILE: assets/js/controllers/NormaClausulaController.js
function NormaClausulaController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, General,Messages) {

    this.adicionarRow = function(args) {
        var widget = args.owner.widget;
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
    };
    
    this.filtrarWidgetPorNorma = function(args){
        var widget = args.owner;
        templateManager.container.getWidget("clausula").dataSourceFilter[2].value = widget.currentRow.CDNORMA;
    };
    
    this.widgetsvisiblefalse = function(args) {
        var widget = args.owner.widget;
        widget.widgets[0].showAsTab = false;
        
    };

    this.widgetsvisibletrue = function(args) {
        var widget = args.owner.widget;
        widget.widgets[0].showAsTab = true;
    };
    
	this.setNormaClausula = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
                if (!widget.backupRow) {
                    widget.currentRow.__is_new = true;
                } else {
                    widget.currentRow.__is_new = false;
                }
                restEngine.post('product#/setNormaClausula', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                    then(function (data) {
                        if (data.notifications[0].type === "success") {
                            ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                            if (widget.currentRow.__is_new) {
                                ABUtilController.masterDetailVoltarList(widget);
                                widget.reload();
                            } else {
                                ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                                widget.backupRow = null;
                                widget.view();
                            }
                        } else {
                            ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                        }
                    }).
                    catch(function(e) {
                        var error;
                        if(e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;
                            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    });
            }
    };
    
    this.deleteNormaClausula = function(args) {
    ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
        var widget = templateManager.container.getActiveWidget();
        if (widget.isValid()) {
            widget.currentRow.__is_new = false;
            restEngine.post('product#/deleteNormaClausula', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                then(function (data) {
                    if (data.messages) {
                        ScreenService.showMessage(Messages.REMOVE_ROW_ERROR + '. ' + data.messages[0].message, data.messages[0].type);
                    } else {
                        ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    }
                }).
                catch(function(e) {
                    var error;
                    if(e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;

                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
            }
        }, null);
    };
    
	this.setClausula = function(args) {
        var widget = args.owner.widget;
        var widgetMain = templateManager.container.getWidget("norma");
        if (widget.isValid()) {
            if (!widget.backupRow) {
                widget.currentRow.__is_new = true;
            } else {
                widget.currentRow.__is_new = false;
            }
            widget.currentRow.CDNORMA = widgetMain.currentRow.CDNORMA;
            restEngine.post('product#/setClausula', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                then(function (data) {
                    if (data.notifications[0].type === "success") {
                        ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                        if (widget.currentRow.__is_new) {
                            ABUtilController.masterDetailVoltarList(widget);
                            widget.reload();
                        } else {
                            ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                            widget.backupRow = null;
                            widget.view();
                        }
                    } else {
                        ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                    }
                }).
                catch(function(e) {
                    var error;
                    if(e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;
                        ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
        }
    };
    
    this.deleteClausula = function(args) {
    ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
        var widget = args.owner.widget;
        widget.currentRow.__is_new = false;
        restEngine.post('product#/deleteClausula', {'requestType':'DataSet','dataset':[widget.currentRow]}).
            then(function(data){
                if(data.notifications[0].type === "success"){
                    ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                    ABUtilController.masterDetailVoltarList(widget);
                    widget.reload();
                } else {
                    ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                }
            }).
            catch(function(e) {
                var error;
                if(e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
        }, null);
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('NormaClausulaController', NormaClausulaController);
});

// FILE: assets/js/controllers/OcorrenciaController.js
/* jshint esversion: 6 */
function OcorrenciaController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, ESocialController, General, Messages) {

    var self = this;
    this.adicionarRow = function(args) {
        var widget = args.owner.widget;
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
    };

    this.filtrarWidgetsPorOcorrencia = function(args) {
        var widget = args.owner;
        templateManager.container.getWidget("vitima").dataSourceFilter[2].value = widget.currentRow.NROCORRENCIA;
        templateManager.container.getWidget("parteatingida").dataSourceFilter[2].value = widget.currentRow.NROCORRENCIA;
    };

    this.filtrarEstadoMunicipioPorPais = function(args) {
        var widget = args.owner.field.widget;
        widget.getField('SGESTADO').dataSourceFilter[0].value = widget.currentRow.CDPAIS;
        widget.getField('NMMUNICIPIO').dataSourceFilter[0].value = widget.currentRow.CDPAIS;
        widget.getField('NMMUNICIPIO').dataSourceFilter[1].value = widget.currentRow.SGESTADO;
        if (!widget.currentRow.NMPAIS) {
            widget.currentRow.SGESTADO = "";
            widget.currentRow.NMMUNICIPIO = "";
        }
        if (!widget.currentRow.SGESTADO) {
            widget.currentRow.NMMUNICIPIO = "";
        }
    };

    this.afterMoveRowVitima = function(args) {
        var widget = args.owner;
        templateManager.container.getWidget("parteatingida").dataSourceFilter[3].value = widget.currentRow.NRVITIMA;
        this.OnChangeAcidenteFatal(widget);
        this.OnchangeRegistroPolicial(widget);
    };

    this.widgetsvisiblefalse = function(args) {
        var widget = args.owner.widget;
        widget.widgets[0].showAsTab = false;
        if (widget.widgets.length > 1) {
            widget.widgets[1].showAsTab = false;
        }
    };

    this.widgetsvisibletrue = function(args) {
        var widget = args.owner.widget;
        widget.widgets[0].showAsTab = true;
        if (widget.widgets.length > 1) {
            widget.widgets[1].showAsTab = true;
        }
    };

    this.OnChangeAcidenteFatal = function(widget) {
        if (widget.currentRow.IDTIPOCAT === '3') {
            widget.getField('DTOBITO').readOnly = false;
            widget.getField('DTOBITO').validations = {
                "required": true
            };
            widget.getField('IDINCAPACITADO').readOnly = true;
            widget.currentRow.IDINCAPACITADO = "N";
            widget.getField('IDAFASTAMENTO').readOnly = true;
            widget.currentRow.IDAFASTAMENTO = "N";
            widget.getField('IDINTERNACAO').readOnly = true;
            widget.currentRow.IDINTERNACAO = "N";
        } else {
            widget.getField('DTOBITO').readOnly = true;
            widget.currentRow.DTOBITO = "";
            widget.getField('DTOBITO').validations = {};
            widget.getField('IDINCAPACITADO').readOnly = false;
            widget.getField('IDAFASTAMENTO').readOnly = false;
            widget.getField('IDINTERNACAO').readOnly = false;
        }
    };

    this.OnchangeRegistroPolicial = function(widget) {
        if (widget.currentRow.IDREGPOLICIAL === 'S') {
            widget.getField('NRREGPOLICIAL').readOnly = false;
        } else {
            widget.getField('NRREGPOLICIAL').readOnly = true;
            widget.currentRow.NRREGPOLICIAL = "";
        }
    };

    this.validaPeriodo = function(dtIni, dtFin) {
        if (moment(dtIni, 'DD/MM/YYYY').unix() > moment(dtFin, 'DD/MM/YYYY').unix() || moment(dtFin, 'DD/MM/YYYY').unix() < moment(dtIni, 'DD/MM/YYYY').unix()) {

            return false;
        } else {
            return true;
        }
    };

    this.setOcorrencia = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
            if (this.validaPeriodo(widget.currentRow.DTHROCORRENCIA, widget.currentRow.DTHRRELATOOCORRE)) {
                if (!widget.backupRow) {
                    widget.currentRow.__is_new = true;
                } else {
                    widget.currentRow.__is_new = false;
                }
                restEngine.post('product#/setOcorrencia', {
                    'requestType': 'DataSet',
                    'dataset': [widget.currentRow]
                }).
                then(function(data) {
                    if (data.notifications[0].type === "success") {
                        ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                        if (widget.currentRow.__is_new) {
                            ABUtilController.masterDetailVoltarList(widget);
                            self.widgetsvisibletrue(args);
                            widget.reload();
                        } else {
                            ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                            widget.backupRow = null;
                            widget.view();
                        }
                        
                        if(data.messages){
                            var mensagens = '';
                            data.messages.forEach(function(){
                                mensagens += data.messages[0].message + ',';
                            });
                            mensagens = mensagens.substr(0, mensagens.length-1);
                            ScreenService.showMessage(mensagens);
                        }
                    } else {
                        ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                    }
                }).
                catch(function(e) {
                    var error;
                    if (e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
            } else {
                ScreenService.showMessage('O campo "Data-Hora do Relato" deve ser igual ou posterior à "Data-Hora"');
                return false;
            }
        }
    };

    this.deleteOcorrencia = function(args) {
        ScreenService.confirmMessage(Messages.DELETE_ROW, 'CONFIRMATION',
            function() {
                var widget = templateManager.container.getActiveWidget();
                if (widget.isValid()) {
                    widget.currentRow.__is_new = false;
                    restEngine.post('product#/deleteOcorrencia', {
                        'requestType': 'DataSet',
                        'dataset': [widget.currentRow]
                    }).
                    then(function(data) {
                        if (data.messages) {
                            ScreenService.showMessage(Messages.REMOVE_ROW_ERROR + '. ' + data.messages[0].message, data.messages[0].type);
                        } else {
                            ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                            ABUtilController.masterDetailVoltarList(widget);
                            widget.reload();
                        }
                    }).
                    catch(function(e) {
                        var error;
                        if (e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;

                        ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    });
                }
            });
    };

    this.setVitima = function(args) {
        var widget = args.owner.widget;
        var widgetMain = templateManager.container.getWidget("ocorrencia");
        if (widget.isValid()) {
            if (this.validaPeriodo(widget.currentRow.DTHRINICATEND, widget.currentRow.DTHRFIMATEND)) {
                if (!widget.backupRow) {
                    widget.currentRow.__is_new = true;
                } else {
                    widget.currentRow.__is_new = false;
                }
                widget.currentRow.NROCORRENCIA = widgetMain.currentRow.NROCORRENCIA;
                if (widget.currentRow.QTHRATEINICATEND) {
                    widget.currentRow.QTHRATEINICATEND = widget.currentRow.QTHRATEINICATEND.replace(":", "");
                }
                if (widget.currentRow.QTHRATENDIMENTO) {
                    widget.currentRow.QTHRATENDIMENTO = widget.currentRow.QTHRATENDIMENTO.replace(":", "");
                }
                if (widget.currentRow.QTHRAPOSINICTRAB) {
                    widget.currentRow.QTHRAPOSINICTRAB = widget.currentRow.QTHRAPOSINICTRAB.replace(":", "");
                }
                if (widget.currentRow.QTHRPERDIDAS) {
                    widget.currentRow.QTHRPERDIDAS = widget.currentRow.QTHRPERDIDAS.replace(":", "");
                }
                if (widget.currentRow.DTHRINICATEND) {
                    widget.currentRow.DTHRINICATEND = widget.currentRow.DTHRINICATEND.substring(0, 16);
                }
                if (widget.currentRow.DTHRFIMATEND) {
                    widget.currentRow.DTHRFIMATEND = widget.currentRow.DTHRFIMATEND.substring(0, 16);
                }
                restEngine.post('product#/setVitima', {
                    'requestType': 'DataSet',
                    'dataset': [widget.currentRow]
                }).
                then(function(data) {
                    if (data.notifications[0].type === "success") {
                        ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                        if (widget.currentRow.__is_new) {
                            ABUtilController.masterDetailVoltarList(widget);
                            self.widgetsvisibletrue(args);
                            widget.reload();
                        } else {
                            ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                            widget.backupRow = null;
                            widget.view();
                        }
                        
                        data.messages.forEach(function(m){
                            if( typeof m.message == 'string' && m.message.length > 15 && m.message.substring(0, 15) == 'QTHRATENDIMENTO' ){
                                var hora = m.message.split("_")[1];
                                widget.currentRow.QTHRATENDIMENTO =  hora.substring(0, 2)+":"+hora.substring(2, 4);
                            }
                        });
                        
                    } else {
                        ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                    }
                }).
                catch(function(e) {
                    var error;
                    if (e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
            } else {
                ScreenService.showMessage('O campo "Data-Hora Inicio" deve ser igual ou posterior à "Data-Hora Fim"');
                return false;
            }
        }
    };
    
    this.validaQthratendimentoAfterMoveRow = function(nameWidget){
        var widget = templateManager.container.getWidget(nameWidget);
        
        if(typeof widget.currentRow.QTHRATENDIMENTO == 'string' && widget.currentRow.QTHRATENDIMENTO.length == 4) 
            widget.currentRow.QTHRATENDIMENTO = widget.currentRow.QTHRATENDIMENTO.substring(0, 2)+":"+widget.currentRow.QTHRATENDIMENTO.substring(2, 4);
    };

    this.deleteVitima = function(args) {
         ScreenService.confirmMessage(Messages.DELETE_ROW, 'CONFIRMATION',
            function() {
                var widgetMain = templateManager.container.getWidget("ocorrencia");
                var widget = args.owner.widget;
                widget.currentRow.__is_new = false;
                restEngine.post('product#/deleteVitima', {
                    'requestType': 'DataSet',
                    'dataset': [widget.currentRow]
                }).
                then(function(data) {
                    if (data.messages) {
                        ScreenService.showMessage(Messages.REMOVE_ROW_ERROR + '. ' + data.messages[0].message, data.messages[0].type);
                    } else {
                        ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload().then(function() {
                            widgetMain.reload().then(function() {
                                widgetMain.dataSource.reload().then(function() {
                                    widgetMain.moveToPrev();
                                    widgetMain.redraw();
                                });
                            });
                        });
        
                    }
                }).
                catch(function(e) {
                    var error;
                    if (e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
            });
    };

    this.setParteAtingidaOcorrencia = function(args) {
        var widget = args.owner.widget;
        var widgetMain = templateManager.container.getWidget("ocorrencia");
        var widgetVitima = templateManager.container.getWidget("vitima");
        if (widget.isValid()) {
            if (!widget.backupRow) {
                widget.currentRow.__is_new = true;
            } else {
                widget.currentRow.__is_new = false;
            }
            widget.currentRow.NROCORRENCIA = widgetMain.currentRow.NROCORRENCIA;
            widget.currentRow.NRVITIMA = widgetVitima.currentRow.NRVITIMA;
            restEngine.post('product#/setParteAtingidaOcorrencia', {
                'requestType': 'DataSet',
                'dataset': [widget.currentRow]
            }).
            then(function(data) {
                if (data.notifications[0].type === "success") {
                    ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                    if (widget.currentRow.__is_new) {
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    } else {
                        ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                        widget.backupRow = null;
                        widget.view();
                    }
                } else {
                    ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                }
            }).
            catch(function(e) {
                var error;
                if (e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
        }
    };

    this.deleteParteAtingindaOcorrencia = function(args) {
        ScreenService.confirmMessage(Messages.DELETE_ROW, 'CONFIRMATION',
            function() {
                var widget = templateManager.container.getActiveWidget();
                if (widget.isValid()) {
                widget.currentRow.__is_new = false;
                restEngine.post('product#/deleteParteAtingindaOcorrencia', {
                    'requestType': 'DataSet',
                    'dataset': [widget.currentRow]
                }).
                then(function(data) {
                    if (data.messages) {
                        ScreenService.showMessage(Messages.REMOVE_ROW_ERROR + '. ' + data.messages[0].message, data.messages[0].type);
                    } else {
                        ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    }
                }).
                catch(function(e) {
                    var error;
                    if (e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;
    
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
            }
        });
    };
    
    this.validaDataOcorrenciaESocial = function(args){
        var widget = ABUtilController.checkWidget(args);
        
        var dataHoraOcorrencia = widget.currentRow.DTHROCORRENCIA;//date-time
        dataHoraOcorrencia = ABUtilController.retornaObjetoDateComString(dataHoraOcorrencia.split(' ')[0]); 
        
        var dataAtual = new Date();
        ABUtilController.truncateObjetoDate(dataAtual);
        var mensagem = 'Atenção! Registro com data sujeita a penalidade do eSocial conforme Art. 22 da CLT – Lei 8.213/91';
        
        //data atual tem que ser o primero dia util apos a data de ocorrencia
        
        //como obtenho o dia ulti? eterno problema da programação : (
    };

    this.verificaValoresDataHora = (fieldName) => {
        let currentRow = templateManager.container.getActiveWidget().currentRow;

        let data = currentRow[fieldName].substring(0, 10);
        let hora = currentRow[fieldName].substring(11, 16);

        if (!isValidDate(data) && data !== '') {
            currentRow[fieldName] = null;
            ScreenService.alertNotification('Data inválida', 10000);
        }

        if (!isValidTime(hora) && hora !== '') {
            currentRow[fieldName] = null;
            ScreenService.alertNotification('Hora inválida', 10000);
        }
    };

    this.verificaValoresHora = (fieldName) => {
        let currentRow = templateManager.container.getActiveWidget().currentRow;

        let hora = currentRow[fieldName];

        if (!isValidTime(hora) && hora !== '') {
            currentRow[fieldName] = null;
            ScreenService.alertNotification('Hora inválida', 10000);
        }
    };

    const regexToValidDate = /^(?:(?:31(\/|-|\.)(?:0?[13578]|1[02]))\1|(?:(?:29|30)(\/|-|\.)(?:0?[1,3-9]|1[0-2])\2))(?:(?:1[6-9]|[2-9]\d)?\d{2})$|^(?:29(\/|-|\.)0?2\3(?:(?:(?:1[6-9]|[2-9]\d)?(?:0[48]|[2468][048]|[13579][26])|(?:(?:16|[2468][048]|[3579][26])00))))$|^(?:0?[1-9]|1\d|2[0-8])(\/|-|\.)(?:(?:0?[1-9])|(?:1[0-2]))\4(?:(?:1[6-9]|[2-9]\d)?\d{2})$/g;
    const regexToValidTime = /^([0-1]?[\d]|2[0-3]):[0-5][\d]$/g;

    let isValidDate = (date) => {
        return date.match(regexToValidDate);
    };

    let isValidTime = (time) => {
        return time.match(regexToValidTime);
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('OcorrenciaController', OcorrenciaController);
});


// FILE: assets/js/controllers/OcorrenciaFaseController.js
function OcorrenciaFaseController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController,Messages) {

    this.salvarOcorrenciaFase = function(args) {
        var widget = templateManager.container.getActiveWidget();
        
        if (widget.isValid()) {
            if (ABUtilController.validaDtIniMenorIgualDtFin(widget.currentRow.DTINICIOOCORRENCIA, widget.currentRow.DTFIMOCORRENCIA)) {
                if (!widget.backupRow) {
                widget.currentRow.__is_new = true;
                } else {
                widget.currentRow.__is_new = false;
            }
                restEngine.post('product#/setOcorrenciaFase', {
                'requestType': 'DataSet',
                'dataset': [widget.currentRow]
            }).
                then(function(data) {
                if (data.notifications[0].type === "success") {
                        ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                    if (widget.currentRow.__is_new) {
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    } else {
                        ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                        widget.backupRow = null;
                        widget.view();
                    }
                } else {
                    ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                }
            }).
                catch(function(e) {
                var error;
                if (e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;

                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
            }else{
                ScreenService.showMessage('A data final deve ser posterior à data inicial.');   
            }
        }
    };

    this.deleteOcorrenciaFase = function(args) {
        ScreenService.confirmMessage(Messages.DELETE_ROW, 'CONFIRMATION',
            function() {

                var widget = templateManager.container.getActiveWidget();
                widget.currentRow.__is_new = false;
                restEngine.post('product#/deleteOcorrenciaFase', {
                    'requestType': 'DataSet',
                    'dataset': [widget.currentRow]
                }).
                then(function(data) {
                    if (data.notifications[0].type === "success") {
                        ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    } else {
                         ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                    }
                }).
                catch(function(e) {
                    var error;
                    if (e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;

                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });

            });
    };

}

Configuration(function(ContextRegister) {
    ContextRegister.register('OcorrenciaFaseController', OcorrenciaFaseController);
});


// FILE: assets/js/controllers/OcorrenciaFrequenciaAdmissaoController.js
function OcorrenciaFrequenciaAdmissaoController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, ABUtilController, AFormataHoraDecimal, Messages) {
    
    this.newRow = function(){
        var widget = templateManager.container.getActiveWidget();
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
    };
    
    this.saveOcorrenciaAdmissao = function(){
        var widget = templateManager.container.getActiveWidget();
        if(widget.isValid()){
            if (!widget.backupRow) {
                widget.currentRow.__is_new = true;
            }else {
                widget.currentRow.__is_new = false;
            }
            restEngine.post('product#/setOcorrenciaFrequenciaAdmissao', {
                'requestType': 'DataSet',
                'dataset': [widget.currentRow]
            }).
            then(function(data) {
                if (data.notifications[0].type === "success") {
                    ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 1000);
                    if(widget.currentRow.__is_new){
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    } else {
                        widget.reload();
                        widget.view();
                    }
                }
                else {
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                }
            }).catch(function(e) {
                var error;
                if (e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });    
        }
    };
    
    this.deleteOcorrenciaAdmissao = function(){
        var widget =  templateManager.container.getActiveWidget();
        ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
            widget.currentRow.__is_new = false;
            restEngine.post('product#/deleteOcorrenciaFrequenciaAdmissao', {
                    'requestType': 'DataSet',
                    'dataset': [widget.currentRow]
                }).
                then(function(data) {
                    if (data.notifications[0].type === "success") {
                        ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 1000);
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    }
                    else {
                        ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                    }
                }).catch(function(e) {
                    var error;
                    if (e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;
                        ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                }); 
        }, null);
    };
    
}
Configuration(function(ContextRegister) {
    ContextRegister.register('OcorrenciaFrequenciaAdmissaoController', OcorrenciaFrequenciaAdmissaoController);
});

// FILE: assets/js/controllers/OcorrenciaFrequenciaController.js
/* jshint esversion: 6 */
function OcorrenciaFrequenciaController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, ABUtilController, AFormataHoraDecimal, Messages) {
    
    const self = this;
    
    this.setNrvinculo = function(argsRow) {
        setLocalVar('HCM_PTO_NRVINCULOM', argsRow.NRVINCULOM);
    };
    
    this.filtrarSaida = function(args) {
        var widget = templateManager.container.getWidget("ocorrenciaFrequencia");
        var NRHORDIAM = widget.currentRow.NRHORDIAM;
        var field = widget.getField("DSINTERVALOPROJETADO");
        field.dataSourceFilter = [
            {
                "name": "NRORG",
                "operator": "=",
                "value": "@getLocalVar('HCM_NRORG_TRAB') ? getLocalVar('HCM_NRORG_TRAB') : '' @"
            },
            {
                "name": "NRORGPADRAO",
                "operator": "=",
                "value": "@getLocalVar('HCM_NRORG_PADRAO') ? getLocalVar('HCM_NRORG_PADRAO') : '' @"
            },
            {
                "name": "DTMESCOMPETENC",
                "operator": "=",
                "value": "@getLocalVar('HCM_DTCOMPETENCIA_OPER') ? getLocalVar('HCM_DTCOMPETENCIA_OPER') : '' @"
            },
            {
                "name": "NRHORDIAM",
                "operator": "=",
                "value": NRHORDIAM
            }
        ];
        field.reload();
    };
    
    this.salvarLancOcorrencia = function() {
        const widgetPrincipal = templateManager.container.getWidget("ocorrencias");
        const widgetPopup   = templateManager.container.getWidget("popupLancOcorrencia");
        const fullRow = [];
        const IDATIVO = [];
        const IDPROGOCORCONFIRMADA = [];
        if(widgetPrincipal.getCheckedRows() <= 0){
            ScreenService.showMessage('Não foram selecionados vínculos para o lançamento de ocorrências', 'ERROR');
        }else{
            for (const row of widgetPrincipal.getCheckedRows()) {
                /* jshint ignore:start */
                fullRow.push({ ...row, ...widgetPopup.currentRow, ...{ DTINICIOPROGOCOR: row.DATA_INICIO, DTFIMPROGOCOR: row.DATA_INICIO, 
                IDATIVO: row.IDATIVO    = "S",
                IDPROGOCORCONFIRMADA: row.IDPROGOCORCONFIRMADA = "S",
                IDDIASSEMANA: '1111111',
                __is_new: true,
                }});
                /* jshint ignore:end */
            }
            if(widgetPopup.getField("NMTIPOPROGOCORRENCIA").value() == ""){
             ScreenService.showMessage('Não é possível realizar o  lançamento de ocorrências sem selecionar um identificador', 'ERROR');
             return;
            }
            if (!widgetPopup.isValid()) {
                return;
            }
            restEngine.post('/setLancOcorrencia', {'requestType':'DataSet', 'dataset':fullRow}).
            then(function(data){
                if(data.notifications[0].type === "success"){
                    ScreenService.showMessage("Lançamentos de ocorrências realizados com sucesso");
                    ScreenService.closePopup(widgetPopup);
                    templateManager.container.getWidget("ocorrencias").activate();
                    templateManager.container.getWidget("ocorrencias").reload();
                } else {
                    ScreenService.showMessage(Messages.PROCESSO_ERROR);
                }
            }).
            catch(function(e) {
                var error;
                if(e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
        }
    };
    
    this.setIdentificador = function(){
        var widgetPrincipal = templateManager.container.getWidget("ocorrencias");
        var widgetPopup   = templateManager.container.getWidget("popupLancOcorrencia");
        
        var tpOcorr = widgetPrincipal.getCheckedRows().reduce((accumulator, row) => accumulator && accumulator == row.TIPO_OCORRENCIA ? row.TIPO_OCORRENCIA : false, 
        widgetPrincipal.getCheckedRows()[0] ? widgetPrincipal.getCheckedRows()[0].TIPO_OCORRENCIA : false );
        
        if( tpOcorr == "FALTA")
        {
            widgetPopup.getField("NMTIPOPROGOCORRENCIA").value("Abonar falta");
            widgetPopup.getField("NRTIPOPROGOCORRENCIA").value(5);
        }
        if( tpOcorr == "EXTRA")
        {
            widgetPopup.getField("NMTIPOPROGOCORRENCIA").value("Autorizar hora extra");
            widgetPopup.getField("NRTIPOPROGOCORRENCIA").value(1);
        }
        if( tpOcorr == "ATRASO")
        {
            widgetPopup.getField("NMTIPOPROGOCORRENCIA").value("Abonar atraso / saída");
            widgetPopup.getField("NRTIPOPROGOCORRENCIA").value(4);
        }
    };
    
    this.filtroNrmarcacaoponto = function(args) {
        var widget = templateManager.container.getWidget("ocorrenciaFrequencia");
        var field = widget.getField("DTHRMARCACAOPONTO");
        field.dataSourceFilter = [
            {
                "name": "P_NRORG",
                "operator": "=",
                "value": "@getLocalVar('HCM_NRORG_TRAB') ? getLocalVar('HCM_NRORG_TRAB') : '' @"
            },
            {
                "name": "P_NRVINCULOM",
                "operator": "=",
                "value": widget.currentRow.NRVINCULOM
            },
            {
                "name": "P_DTAPURACAOPONTO",
                "operator": "=",
                "value": widget.currentRow.DTINICIOPROGOCOR
            }
        ];
        field.reload();
    };
    
    this.verificaCampos = function(args){
        var widget = args.owner;
        var NMTIPOPROGOCORRENCIA = widget.currentRow.NMTIPOPROGOCORRENCIA;
        var NRHORDIAM = widget.currentRow.NRHORDIAM;
        var DTINI = widget.currentRow.DTINICIOPROGOCOR;
        if(NMTIPOPROGOCORRENCIA === 'Identificar intervalo'){
            widget.getField('DSINTERVALOPROJETADO').isVisible = true;
            widget.getField('DTHRMARCACAOPONTO').isVisible = true;
            widget.getField('DSSITUFREQUENCIA').readOnly = true;
            widget.getField('QTMINIMAPROGOCOR').readOnly = true;
            widget.getField('QTMAXIMAPROGOCOR').readOnly = true;
            widget.getField('DSSITUFREQGATILHO').readOnly = true;
            widget.getField('QTMINGATILHOPROGOCOR').readOnly = true;
            widget.getField('QTMAXGATILHOPROGOCOR').readOnly = true;
            widget.getField('VRCOEFICIENTEACRESCIMO').readOnly = true;
        }else{
            widget.getField('DSINTERVALOPROJETADO').isVisible = false;
            widget.getField('DTHRMARCACAOPONTO').isVisible = false;
            widget.getField('DSSITUFREQUENCIA').readOnly = false;
            widget.getField('QTMINIMAPROGOCOR').readOnly = false;
            widget.getField('QTMAXIMAPROGOCOR').readOnly = false;
            widget.getField('DSSITUFREQGATILHO').readOnly = false;
            widget.getField('QTMINGATILHOPROGOCOR').readOnly = false;
            widget.getField('QTMAXGATILHOPROGOCOR').readOnly = false;
            widget.getField('VRCOEFICIENTEACRESCIMO').readOnly = false;
        }
        if(NRHORDIAM === undefined || NRHORDIAM === null){
            widget.getField('DSINTERVALOPROJETADO').readOnly = true;
            widget.currentRow.DSINTERVALOPROJETADO = "";
        }else{
            widget.getField('DSINTERVALOPROJETADO').readOnly = false;
        }
        if(DTINI === undefined || DTINI === null){
            widget.getField('DTHRMARCACAOPONTO').readOnly = true;
        }else{
            widget.getField('DTHRMARCACAOPONTO').readOnly = false;
        }
    };
    
    this.habilitacampos = function(args){
        var widget = templateManager.container.getActiveWidget();
        var NMTIPOPROGOCORRENCIA = widget.currentRow.NMTIPOPROGOCORRENCIA;
        if(NMTIPOPROGOCORRENCIA === 'Identificar intervalo'){
            widget.getField('DSINTERVALOPROJETADO').readOnly = false;
            widget.getField('DTHRMARCACAOPONTO').readOnly = false;
            widget.getField('DSSITUFREQUENCIA').readOnly = true;
            widget.getField('QTMINIMAPROGOCOR').readOnly = true;
            widget.getField('QTMAXIMAPROGOCOR').readOnly = true;
            widget.getField('DSSITUFREQGATILHO').readOnly = true;
            widget.getField('QTMINGATILHOPROGOCOR').readOnly = true;
            widget.getField('QTMAXGATILHOPROGOCOR').readOnly = true;
            widget.getField('VRCOEFICIENTEACRESCIMO').readOnly = true;
        }else{
            widget.getField('DSINTERVALOPROJETADO').readOnly = true;
            widget.getField('DTHRMARCACAOPONTO').readOnly = true;
            widget.getField('DSSITUFREQUENCIA').readOnly = false;
            widget.getField('QTMINIMAPROGOCOR').readOnly = false;
            widget.getField('QTMAXIMAPROGOCOR').readOnly = false;
            widget.getField('DSSITUFREQGATILHO').readOnly = false;
            widget.getField('QTMINGATILHOPROGOCOR').readOnly = false;
            widget.getField('QTMAXGATILHOPROGOCOR').readOnly = false;
            widget.getField('VRCOEFICIENTEACRESCIMO').readOnly = false;
        }
    };
    
    this.habiDesaSaida = function(args){
        var widget = args.owner.field.widget;
        var NRHORDIAM = widget.currentRow.NRHORDIAM;
        if(NRHORDIAM !== ""){
            widget.getField('DSINTERVALOPROJETADO').readOnly = false;
            widget.getField('DSINTERVALOPROJETADO').dataSourceFilter[3].value = widget.currentRow.NRHORDIAM;
        }else{
            widget.getField('DSINTERVALOPROJETADO').readOnly = true;
            widget.getField('DSINTERVALOPROJETADO').dataSourceFilter[3].value = "";
            widget.currentRow.DSINTERVALOPROJETADO = "";
        }
    };
    
    this.habilitaMarcacaoPonto = function(args){
        var widget = args.owner.field.widget;
        var DTINI = widget.currentRow.DTINICIOPROGOCOR;
        var DTFIM = widget.currentRow.DTFIMPROGOCOR;
        var DTHRMARCACAOPONTO = widget.getField('DTHRMARCACAOPONTO');
        var NMTIPOPROGOCORRENCIA = widget.currentRow.NMTIPOPROGOCORRENCIA;
        //HabilitaMarcaçãoPonto
        if(NMTIPOPROGOCORRENCIA === 'Identificar intervalo'){
            if(DTINI !== "" && DTFIM !== ""){
                if(this.PeriodoIdentificarIntervalo(DTINI,DTFIM)){
                  
                }else{
                    ScreenService.showMessage('O campo "Data Início" deve ser igual ao campo "Data Fim".');
                    widget.currentRow.DTINICIOPROGOCOR = "";
                }
            }
            if(DTINI !== ""){
                DTHRMARCACAOPONTO.readOnly = false;
                this.filtroNrmarcacaoponto(args);
            }else{
                DTHRMARCACAOPONTO.readOnly = true;
            }
        }    
    };
    
    this.validadatafim = function(args){
        var widget = args.owner.field.widget;
        var DTINI = widget.currentRow.DTINICIOPROGOCOR;
        var DTFIM = widget.currentRow.DTFIMPROGOCOR;
        var NMTIPOPROGOCORRENCIA = widget.currentRow.NMTIPOPROGOCORRENCIA;
        var DTHRMARCACAOPONTO = widget.getField('DTHRMARCACAOPONTO');
        //HabilitaMarcaçãoPonto
        if(NMTIPOPROGOCORRENCIA === 'Identificar intervalo'){
            if(DTINI !== "" && DTFIM !== ""){
                if(this.PeriodoIdentificarIntervalo(DTINI,DTFIM)){
                }else{
                    ScreenService.showMessage('O campo "Data Fim" deve ser igual ao campo "Data Início".');
                    widget.currentRow.DTFIMPROGOCOR = "";
                }
            }
        }
    };
    
    this.validarPeriodoIdentificarIntervalo = function(args){
        var widget = args.owner.field.widget;
        var DTINI = widget.currentRow.DTINICIOPROGOCOR;
        var DTFIM = widget.currentRow.DTFIMPROGOCOR;
        var DTHRMARCACAOPONTO = widget.getField('DTHRMARCACAOPONTO');
        if(this.PeriodoIdentificarIntervalo(DTINI,DTFIM)){
            if(DTINI === ""){
                ScreenService.showMessage('Informe a Data Início".');
                ScreenService.closePopup();
            }
        }else{
            ScreenService.showMessage('O campo "Data Início" deve ser igual ao campo "Data Fim".');
            ScreenService.closePopup();
        }    
    };  
    
    this.openAdicionarOcorrencia = function(args){
        var widget = args.owner.widget;
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
    };
    
    this.PeriodoIdentificarIntervalo = function(dtIni, dtFin) {
        if (moment(dtIni, 'DD/MM/YYYY').unix() === moment(dtFin, 'DD/MM/YYYY').unix() || moment(dtFin, 'DD/MM/YYYY').unix() === moment(dtIni, 'DD/MM/YYYY').unix()) {
            return true;
        }
        else {
            return false;
        }
    };
    
    this.setDiasSemana = function(args) {
        var widget = args.owner;
        var value = [];
        if(widget.currentRow.IDDIASSEMANA){
            var dados = widget.currentRow.IDDIASSEMANA.split("");
            if (dados[0] === "1") {
                value.push(0); 
            }
            if (dados[1] === "1") {
                value.push(1);
            }
            if (dados[2] === "1") {
                value.push(2);
            }
            if (dados[3] === "1") {
                value.push(3); 
            }
            if (dados[4] === "1") {
                value.push(4); 
            }
            if (dados[5] === "1") {
                value.push(5); 
            }
            if (dados[6] === "1") {
                value.push(6); 
            }
            widget.currentRow.NMDIASSEMANA = value;
        }
    };
    
    this.setOcorrencia = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
            if (this.validatevalues(widget.currentRow.QTMINIMAPROGOCOR, widget.currentRow.QTMAXIMAPROGOCOR)) {
                if (this.validatevalues(widget.currentRow.QTMINGATILHOPROGOCOR, widget.currentRow.QTMAXGATILHOPROGOCOR)) {
                    if (this.validaPeriodo(widget.currentRow.DTINICIOPROGOCOR, widget.currentRow.DTFIMPROGOCOR)) {
                        var checkboxs = [0,0,0,0,0,0,0];
                        var arraysemana = widget.currentRow.NMDIASSEMANA;
                        for(var k in arraysemana){
                            if(arraysemana[k] === 0){
                             checkboxs[0] = 1;    
                            }
                            if(arraysemana[k] === 1){
                             checkboxs[1] = 1;    
                            }
                            if(arraysemana[k] === 2){
                             checkboxs[2] = 1;    
                            }
                            if(arraysemana[k] === 3){
                             checkboxs[3] = 1;    
                            }
                            if(arraysemana[k] === 4){
                             checkboxs[4] = 1;    
                            }
                            if(arraysemana[k] === 5){
                             checkboxs[5] = 1;    
                            }
                            if(arraysemana[k] === 6){
                             checkboxs[6] = 1;    
                            }
                        }
                        widget.currentRow.IDDIASSEMANA = checkboxs.join('');
                        var isNew;
                        if (!widget.backupRow) {
                            widget.currentRow.__is_new = true;
                            isNew = true;
                        }
                        else {
                            widget.currentRow.__is_new = false;
                            isNew = false;
                        }
                        var saveData = Object.assign({}, widget.currentRow, {
                            "NRORG": getLocalVar("HCM_NRORG_TRAB")
                        }, {
                            "CDOPERADOR_LOG": getLocalVar("HCM_CDOPERADOR")
                        });
                        restEngine.post('product#/setOcorrenciaFrequencia', {
                            'requestType': 'DataSet',
                            'dataset': [saveData]
                        }).
                        then(function(data) {
                            if (data.notifications[0].type === "success") {
                                ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 1000);
                                if(isNew){
                                    ABUtilController.masterDetailVoltarList(widget);
                                    widget.reload();
                                } else {
                                    widget.reload();
                                    widget.view();
                                }
                            }
                            else {
                                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                            }
                        }).catch(function(e) {
                            var error;
                            if (e.data.error === undefined)
                                error = e;
                            else
                                error = e.data.error;
                                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                        });
                    }
                    else {
                        ScreenService.showMessage('O campo "Fim Vigência" deve ser igual ou posterior ao campo "Início Vigência".');
                        return false;
                    }
                }
                else {
                    ScreenService.showMessage('O campo "Qtd. Máxima do Gatilho" deve ser igual ou posterior ao campo "Qtd. Mínima do Gatilho".');
                    return false;
                }
            }
            else {
                ScreenService.showMessage('O campo "Qtd. Máxima" deve ser igual ou posterior ao campo "Qtd. Mínima".');
                return false;
            }
        }
    };

    this.validatevalues = function(valor1, valor2) {
        if (valor1 !== null && valor2 !== null) {
            if (valor2 < valor1) {
                return false;
            }
            else {
                return true;
            }
        }
        else {
            return true;
        }
    };

    this.validaPeriodo = function(dtIni, dtFin) {
        if (moment(dtIni, 'DD/MM/YYYY').unix() > moment(dtFin, 'DD/MM/YYYY').unix() || moment(dtFin, 'DD/MM/YYYY').unix() < moment(dtIni, 'DD/MM/YYYY').unix()) {
            return false;
        }
        else {
            return true;
        }
    };
    
    this.verificarSemanas = function(args) {
        var widget = args.owner;
        var arraydiasdasemana = [];
        if(widget.currentRow.DIASSEMANA){
            var diasdasemana = widget.currentRow.DIASSEMANA.split(",");
            for (var k in diasdasemana) {
                if (diasdasemana[k] === "0") {
                     arraydiasdasemana.push(0); 
                }
                if (diasdasemana[k] === "1") {
                    arraydiasdasemana.push(1);
                }
                if (diasdasemana[k] === "2") {
                    arraydiasdasemana.push(2);
                }
                if (diasdasemana[k] === "3") {
                    arraydiasdasemana.push(3);
                }
                if (diasdasemana[k] === "4") {
                    arraydiasdasemana.push(4);
                }
                if (diasdasemana[k] === "5") {
                    arraydiasdasemana.push(5);
                }
                if (diasdasemana[k] === "6") {
                    arraydiasdasemana.push(6);
                }
            }
            widget.currentRow.DIASDASEMANA = arraydiasdasemana;
        }
    };

    this.removeOcorrencia = function(args) {
    ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
                var widget = args.owner.widget;
                widget.currentRow.__is_new = false;
                var removeData = Object.assign({}, widget.currentRow, {
                    "NRORG": getLocalVar("HCM_NRORG_TRAB")
                }, {
                    "CDOPERADOR_LOG": getLocalVar("HCM_CDOPERADOR")
                });
                restEngine.post('product#/removeOcorrencia', {
                    'requestType': 'DataSet',
                    'dataset': [removeData]
                }).
                then(function(data) {
                    if (data.notifications[0].type === "success") {
                        ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 1000);
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    }
                    else {
                        ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                    }
                }).catch(function(e) {
                    var error;
                    if (e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');

                });
            }, null);
    };
    
    /**
     *  Rotina que valida a seleção de registros e identifica quais rows vão ser enviadas para a rotina de envio. Para isso, há a identificação de dois modos da widget:
     * 1. List: A rotina identifica as rows que foram selecionadas através do checkbox e as envia para a rotina de criação das ocorrências;
     * 2. View: A rotina envia a currentRow para a rotina de criação das ocorrências
     * 
     *  @param  args
     */
    this.definirOcorrenciaOnClick = function (args) {
        const widget = ABUtilController.checkWidget(args);
        const widgetInListMode = widget.inListMode();
        let rowsToSend = [widget.currentRow];
        
        if (widgetInListMode && !ABUtilController.widgetHasSelectedRows(args)) {
            ScreenService.showMessage(Messages.SELECT_AT_LEAST_ONE_REGISTER_WARNING);
            return;
        }
        
        if (widgetInListMode) {
            rowsToSend = widget.getCheckedRows();
        }
        
        ScreenService.confirmMessage(Messages.HCM07003_PTO_MARCACAOPONTO_INSERT_OCORRENCIA_QUESTION, 'CONFIRMATION', function() {
            this.geraOcorrenciaAlmoco(rowsToSend, args);
        }.bind(this));
    };
    
    /* jshint ignore:start */
    this.geraOcorrenciaAlmoco = async function (rowsToSend, args) {
        if (!Array.isArray(rowsToSend) || rowsToSend.length < 1) {
            ScreenService.showMessage(Messages.SELECT_AT_LEAST_ONE_REGISTER_WARNING);
            return;
        }
        
        const widget = ABUtilController.checkWidget(args);
        
        try {
            const response = await restEngine.post('product#/geraOcorrenciaAlmoco', {
                'requestType': 'DataSet',
                'dataset': rowsToSend
            });
            
            if (response.messages) {
                const message = response.messages[0].message;
                ScreenService.showMessage(message);
                return;
            }
            
            // Montar tratamento aqui
            const success = response.dataset.data && response.dataset.data.success;
            if (success) {
                // mudar mensagem
                ScreenService.successNotification(Messages.PTO_PROGOCORRENCIA_OCOR_ALMOCO_SUCESS);
                
                ScreenService.closePopup();
                widget.unSelectAll();
                return;
            }
            
            ScreenService.errorNotification(Messages.SAVE_ROW_ERROR);
        } catch (error) {
            const message = error.data ? Messages.CATCH_EXCEPTION_ERROR(error.data.error) : Messages.SAVE_ROW_ERROR;
            ScreenService.showMessage(message);
        }
        
    };
    /* jshint ignore:end */
    
    this.onCancelClick = function(args) {
        var widget = ABUtilController.checkWidget(args);
        var blockCheckbox = !widget.currentRow.__is_new;
        ABUtilController.blockCheckbox(args.owner.widget.id, blockCheckbox);
    };
    
    this.syncRowQntValue = function(args, fieldNameToSync) {
        const actionToReplaceTimeFormat = function (value) { return value ? parseInt(value.replace(':', ''), 10) : null; };
        ABUtilController.syncRowFieldValue(args, fieldNameToSync, actionToReplaceTimeFormat);
    };
    
    this.openPopupCadastroAutomatico = function(){
        var popup = templateManager.container.getWidget('cadastroAutomatico');
        popup.applyDefaultValue();
        this.verificaTipoCadastroAutomatico();
        ScreenService.openPopup(popup);
    };
    
    this.verificaTipoCadastroAutomatico = function() {
        var widget = templateManager.container.getWidget('cadastroAutomatico');
        
        if (widget.currentRow.NRVINCULOM.length > 0) {
            widget.getField('NRESTRUTLEGAL_LIST').validations = {};
            widget.getField('NRESTRUTLEGAL_LIST').readOnly = true;
            widget.getField('NRESTRUTGEREN_LIST').validations = {};
            widget.getField('NRESTRUTGEREN_LIST').readOnly = true;
        } else if (widget.currentRow.NRESTRUTLEGAL_LIST.length > 0) {
            widget.getField('NRVINCULOM').validations = {};
            widget.getField('NRVINCULOM').readOnly = true;
            widget.getField('NRESTRUTGEREN_LIST').validations = {};
        } else if (widget.currentRow.NRESTRUTGEREN_LIST.length > 0) {
            widget.getField('NRVINCULOM').validations = {};
            widget.getField('NRVINCULOM').readOnly = true;
            widget.getField('NRESTRUTLEGAL_LIST').validations = {};
        } else {
            widget.getField('NRVINCULOM').validations = {required: true};
            widget.getField('NRVINCULOM').readOnly = false;
            widget.getField('NRESTRUTLEGAL_LIST').validations = {required: true};
            widget.getField('NRESTRUTLEGAL_LIST').readOnly = false;
            widget.getField('NRESTRUTGEREN_LIST').validations = {required: true};
            widget.getField('NRESTRUTGEREN_LIST').readOnly = false;
        }
    };
    
    this.montaArrayDiasSemana = function(widget) {
        var checkboxs = [0,0,0,0,0,0,0];
        var arraysemana = widget.currentRow.NMDIASSEMANA;
        for(var k in arraysemana){
            if(arraysemana[k] === 0){
             checkboxs[0] = 1;    
            }
            if(arraysemana[k] === 1){
             checkboxs[1] = 1;    
            }
            if(arraysemana[k] === 2){
             checkboxs[2] = 1;    
            }
            if(arraysemana[k] === 3){
             checkboxs[3] = 1;    
            }
            if(arraysemana[k] === 4){
             checkboxs[4] = 1;    
            }
            if(arraysemana[k] === 5){
             checkboxs[5] = 1;    
            }
            if(arraysemana[k] === 6){
             checkboxs[6] = 1;    
            }
        }
        return checkboxs;
    };
    
    this.efetuaCadastroAutomaticoOcorrencia = function(args) {
        var widgetPrincipal = templateManager.container.getWidget("ocorrenciaFrequencia");
        var widget = args.owner.widget;
        
        var diasSemana = this.montaArrayDiasSemana(widget);
        widget.currentRow.IDDIASSEMANA = diasSemana.join('');
        widget.currentRow.__is_new = true;
        
        if (widget.isValid()) {
            restEngine.post('product#/setCadastroAutomaticoOcorrencia', { 'requestType': 'DataSet', 'dataset': [widget.currentRow] })
            .then(function(data) {
                if (data.notifications[0].type === "success") {
                    ScreenService.successNotification(data.notifications[0].message, 1000);
                    widgetPrincipal.reload().then(() => {
                        ScreenService.closePopup();
                        ScreenService.closePopup();
                    });
                } else {
                    ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                }
            })
            .catch(function(e) {
                var error;
                if (e.data.error === undefined) {
                    error = e;
                } else {
                    error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
               }
           });
        }
    };
    
    this.atualizaFeriadoOnClick = function () {
        ScreenService.confirmMessage('Atenção!<br><br>Será feito o cadastro de ocorrências do tipo "Abonar falta" para todos os feriados, cadastrados nas estruturas legais dos vínculos, a partir da competência anterior à atual do sistema.<br><br>Deseja continuar?', null,
            function () {
                self.atualizaFeriado();
            },
            null
        );
        return;
    };
    
    /* jshint ignore:start */
    this.atualizaFeriado = async function () {
        try {
            
            const response = await restEngine.post('product#/atualizaFeriado', {
                'requestType': 'Row',
                'row': []
            });
            
            if (response.messages) {
                const message = response.messages[0].message;
                ScreenService.showMessage(message);
                return;
            }
            
            const success = response.dataset.data && response.dataset.data.success;
            if (success) {
                ScreenService.showMessage('As ocorrências foram inseridas com sucesso!', 'SUCCESS');
                ScreenService.closePopup();
                return;
            }
            
            ScreenService.errorNotification(Messages.SAVE_ROW_ERROR);
        } catch (error) {
            const message = error.data ? Messages.CATCH_EXCEPTION_ERROR(error.data.error) : Messages.SAVE_ROW_ERROR;
            ScreenService.showMessage(message);
        }
    };
    /* jshint ignore:end */

}

Configuration(function(ContextRegister) {
    ContextRegister.register('OcorrenciaFrequenciaController', OcorrenciaFrequenciaController);
});

// FILE: assets/js/controllers/OcupacaoController.js
function OcupacaoController(ScreenService, templateManager, restEngine, ABUtilController, Messages, General) {
    this.OCUPACAO_CAMPO = ['NMOCUPACAOH'];
    
    this.CAMPOS_SELECT_MULT = ['NROCUPACAOH', 'NRESCALATRABM', 'NRSITUFUNCM', 'NRTPDEMISSAO', 'NREVENTOM'];
    
    this.adicionarRow = function(args) {
        var widget = args.owner.widget;
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
    };
    
    this.salvar = function(args) {
        var widget = ABUtilController.checkWidget(args);
        if (widget.isValid()) {
            widget.currentRow.DSOBJETIVOCARGO = widget.currentRow.DSOBJETIVOCARGO ? widget.currentRow.DSOBJETIVOCARGO : null;
            widget.currentRow.DSATIVIDADESCARGO = widget.currentRow.DSATIVIDADESCARGO ? widget.currentRow.DSATIVIDADESCARGO : null;
            widget.currentRow.DSCONDTRABALHO = widget.currentRow.DSCONDTRABALHO ? widget.currentRow.DSCONDTRABALHO : null;
            widget.currentRow.NRTEMPOEXPANO = widget.currentRow.NRTEMPOEXPANO ? widget.currentRow.NRTEMPOEXPANO : null;
            widget.currentRow.NRTEMPOEXPMES = widget.currentRow.NRTEMPOEXPMES ? widget.currentRow.NRTEMPOEXPMES : null;
            widget.currentRow.DSOBJETIVOCARGO = widget.currentRow.DSOBJETIVOCARGO ? widget.currentRow.DSOBJETIVOCARGO : null;
            widget.currentRow.IDVERIFICAVIGENCIAESO = 'S';
            widget.currentRow.NMEVENTO = 'S-1030,S-1040';
            widget.currentRow.NRCHAVE = widget.currentRow.NROCUPACAOM;
            if(ABUtilController.validaDtIniMenorIgualDtFin(widget.currentRow.DTINIVIGENCIA,widget.currentRow.DTFIMVIGENCIA)){
                ABUtilController.saveMasterDetailMasterHistory(widget);
            }else{
                ScreenService.showMessage(Messages.DTINI_POST_DTFIM_ERROR);
                return false;
            }    
        }
    };
    
    this.remover = function(args) {
    ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
        var widget = args.owner.widget;
        if (widget.isValid()) {
            widget.currentRow.__is_new = false;
            restEngine.post('product#/deleteOcupacao', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                then(function (data) {
                    if (data.messages) {
                        ScreenService.showMessage(Messages.REMOVE_ROW_ERROR + '. ' + data.messages[0].message, data.messages[0].type);
                    } else {
                        ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    }
                }).
                catch(function(e) {
                    var error;
                    if(e.data.error === undefined){
                        error = e;
                    }    
                    else{
                        error = e.data.error;
                        ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    }    
                });
            }
        }, null);
    };


}

Configuration(function(ContextRegister) {
    ContextRegister.register('OcupacaoController', OcupacaoController);
});

// FILE: assets/js/controllers/OcupacaoEventoController.js
function OcupacaoEventoController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, General,Messages) {

    this.adicionarRow = function(args) {
        var widget = args.owner.widget;
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
    };
    
    this.validaFiltro = function(args){
        var widget = args.owner;
        if(args.e.preference.FILTER_ROW.IDTIPOMOVIMENTO === 0){
            widget.dataSourceFilter.push(
                {
                    "name": "IDTIPOMOVIMENTO",
                    "operator": "=",
                    "value":"0"
                }    
            );
        }else{
            widget.dataSourceFilter.forEach(function(filtro, index){
                if(filtro.name === 'IDTIPOMOVIMENTO' && filtro.value === '0'){
                    widget.dataSourceFilter.splice(index, 1);
                }
            });
        }
    };
    
	this.setOcupacaoEvento = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
            if (ABUtilController.validaDtIniMenorIgualDtFin(widget.currentRow.DTINIVIGENCIA, widget.currentRow.DTFIMVIGENCIA)) {
                if (!widget.backupRow) {
                    widget.currentRow.__is_new = true;
                } else {
                    widget.currentRow.__is_new = false;
                }
                restEngine.post('product#/setOcupacaoEvento', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                    then(function (data) {
                        if (data.messages){ 
                            ScreenService.showMessage(data.messages[0].message, data.messages[0].type);
                        }
                        if (data.notifications[0].type === "success") {
                            ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                            if (widget.currentRow.__is_new) {
                                ABUtilController.masterDetailVoltarList(widget);
                                widget.reload();
                            } else {
                                ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                                widget.backupRow = null;
                                widget.view();
                            }
                        } else {
                            ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                        }
                    }).
                    catch(function(e) {
                        var error;
                        if(e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;
                            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    });
                }else {
                    ScreenService.showMessage(Messages.DTINI_POST_DTFIM_ERROR);
                    return false;
                }
            }
    };
    
    this.deleteOcupacaoEvento = function(args) {
    ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
        var widget = args.owner.widget;
        widget.currentRow.__is_new = false;
        restEngine.post('product#/deleteOcupacaoEvento', {'requestType':'DataSet','dataset':[widget.currentRow]}).
            then(function(data){
                if(data.notifications[0].type === "success"){
                    ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                    ABUtilController.masterDetailVoltarList(widget);
                    widget.reload();
                } else {
                    ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                }
            }).
            catch(function(e) {
                var error;
                if(e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
        }, null);
    };
    
    this.validaParcela = function(args){
        var widget = templateManager.container.getActiveWidget();
        if(widget.getField('IDREFGERAR').value() == "PARCELA" ){
            if(widget.currentRow.DTFIMVIGENCIA  == "" || widget.currentRow.DTFIMVIGENCIA  == null) 
            {
                ScreenService.showMessage("Para inserir um Tipo de Referência cujo valor seja igual a Parcela, favor selecionar uma data de Início e Fim de Vigência.");
                return;
            }else{
                this.setOcupacaoEvento(args);
            }
        }else{
            this.setOcupacaoEvento(args);
        }
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('OcupacaoEventoController', OcupacaoEventoController);
});

// FILE: assets/js/controllers/OcupacaoGestaoController.js
function OcupacaoGestaoController(ScreenService, templateManager, restEngine, ABUtilController, Messages, General) {
    this.OCUPACAO_CAMPO = ['NMOCUPACAOH'];
    
    this.CAMPOS_SELECT_MULT = ['NROCUPACAOH', 'NRESCALATRABM', 'NRSITUFUNCM', 'NRTPDEMISSAO', 'NREVENTOM'];
    
    this.setNrocupacaoDatasourcefilter = function(args){
        var widget = args.owner;
        var widPontua = widget.widgets[ABUtilController.retornaWidget(widget, 'pontuacaoOcupa')];
        var widFormacao = widget.widgets[ABUtilController.retornaWidget(widget, 'formacao')];
        var widPerfilProf = widget.widgets[ABUtilController.retornaWidget(widget, 'PerfilProfi')];
        var widPerfilCurso = widget.widgets[ABUtilController.retornaWidget(widget, 'perfilCurso')];
        var widFatorRisco = widget.widgets[ABUtilController.retornaWidget(widget, 'fatorRisco')];
        var widAvalOcupa = widget.widgets[ABUtilController.retornaWidget(widget, 'avaliacaoOcupacao')];
        
        widFatorRisco.dataSourceFilter[ABUtilController.retornaFiltro(widFatorRisco.dataSourceFilter, 'NROCUPACAOM')].value = widget.currentRow.NROCUPACAOM;
        widPerfilCurso.dataSourceFilter[ABUtilController.retornaFiltro(widPerfilCurso.dataSourceFilter, 'NROCUPACAOM')].value = widget.currentRow.NROCUPACAOM;
        widAvalOcupa.dataSourceFilter[ABUtilController.retornaFiltro(widAvalOcupa.dataSourceFilter, 'P_NROCUPACAOM')].value = widget.currentRow.NROCUPACAOM;
        widPerfilProf.dataSourceFilter[ABUtilController.retornaFiltro(widPerfilProf.dataSourceFilter, 'P_NROCUPACAOM')].value = widget.currentRow.NROCUPACAOM;
        widFormacao.dataSourceFilter[ABUtilController.retornaFiltro(widFormacao.dataSourceFilter, 'P_NROCUPACAOM')].value = widget.currentRow.NROCUPACAOM;
        widPontua.dataSourceFilter[ABUtilController.retornaFiltro(widPontua.dataSourceFilter, 'P_NROCUPACAOM')].value = widget.currentRow.NROCUPACAOM;
        widPontua.dataSourceFilter[ABUtilController.retornaFiltro(widPontua.dataSourceFilter, 'P_NMOCUPACAOH')].value = widget.currentRow.NMOCUPACAOH;
    };
    
    this.adicionarRow = function(args) {
        var widget = args.owner.widget;
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
    };
    
    this.setPontuaOcupacao = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
                if (!widget.backupRow) {
                    widget.currentRow.__is_new = true;
                } else {
                    widget.currentRow.__is_new = false;
                }
                restEngine.post('product#/setPontuaOcupacao', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                    then(function (data) {
                        if (data.notifications[0].type === "success") {
                            ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                            if (widget.currentRow.__is_new) {
                                ABUtilController.masterDetailVoltarList(widget);
                                widget.reload();
                            } else {
                                ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                                widget.backupRow = null;
                                widget.view();
                            }
                        } else {
                            ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                        }
                    }).
                    catch(function(e) {
                        var error;
                        if(e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;
                            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    });
            }
    };
    
    this.selecionaOcupacao = function(args){
        //var container = templateManager.container;
        //var widget = container.getWidget('pontuacaoOcupa');
        var widget = ABUtilController.checkWidget(args);
        var widgetPai = widget.parent ? widget.parent.parent : null; 
        
        widget.currentRow.NROCUPACAOM = widgetPai.currentRow.NROCUPACAOM;
        widget.currentRow.NMOCUPACAOH = widgetPai.currentRow.NMOCUPACAOH;
    };
    
    this.deletePontuaOcupacao = function(args) {
         ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
         var widget = args.owner.widget;
        widget.currentRow.__is_new = false;
        restEngine.post('product#/deletePontuaOcupacao', {'requestType':'DataSet','dataset':[widget.currentRow]}).
            then(function(data){
                if(data.notifications[0].type === "success"){
                    ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                    ABUtilController.masterDetailVoltarList(widget);
                    widget.reload();
                } else {
                    ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                }
            }).
            catch(function(e) {
                var error;
                if(e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
         }, null);
    };
    
    this.setPontuaOcupacaoGrid = function(args){
        var widget = ABUtilController.checkWidget(args);
        var row = [];
        for(var k in widget.dataSource.data){
            if(widget.dataSource.data[k].changed){
                row.push(widget.dataSource.data[k]);
            }
        }
        restEngine.post('product#/setPontuaOcupacao', {'requestType': 'DataSet', 'dataset': row}).
            then(function(data){
                if (data.messages) {
                    ScreenService.showMessage(data.messages[0].message, data.messages[0].type);
                } else if (data.notifications[0].type === "success") {
                    ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                } else {
                    ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                }
                widget.list();
                widget.activate();
                // widget.reload();
            }).catch(function(e){
                var error;
                    if(e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;
                        ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
    
    };
    
    this.setFormacaoOcupa = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
                if (!widget.backupRow) {
                    widget.currentRow.__is_new = true;
                } else {
                    widget.currentRow.__is_new = false;
                }
                restEngine.post('product#/setFormacaoOcupa', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                    then(function (data) {
                        if (data.notifications[0].type === "success") {
                            ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                            if (widget.currentRow.__is_new) {
                                ABUtilController.masterDetailVoltarList(widget);
                                widget.reload();
                            } else {
                                ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                                widget.backupRow = null;
                                widget.view();
                            }
                        } else {
                            ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                        }
                    }).
                    catch(function(e) {
                        var error;
                        if(e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;
                            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    });
            }
    };

    this.deleteFormacaoOcupa = function(args) {
         ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
         var widget = args.owner.widget;
        widget.currentRow.__is_new = false;
        restEngine.post('product#/deleteFormacaoOcupa', {'requestType':'DataSet','dataset':[widget.currentRow]}).
            then(function(data){
                if(data.notifications[0].type === "success"){
                    ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                    ABUtilController.masterDetailVoltarList(widget);
                    widget.reload();
                } else {
                    ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                }
            }).
            catch(function(e) {
                var error;
                if(e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
         }, null);
    };
    
    this.setPerfilCurso = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
                if (!widget.backupRow) {
                    widget.currentRow.__is_new = true;
                } else {
                    widget.currentRow.__is_new = false;
                }
                restEngine.post('product#/setPerfilCursoOcupa', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                    then(function (data) {
                        if (data.notifications[0].type === "success") {
                            ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                            if (widget.currentRow.__is_new) {
                                ABUtilController.masterDetailVoltarList(widget);
                                widget.reload();
                            } else {
                                ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                                widget.backupRow = null;
                                widget.view();
                            }
                        } else {
                            ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                        }
                    }).
                    catch(function(e) {
                        var error;
                        if(e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;
                            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    });
            }
    };

    this.deletePerfilCurso = function(args) {
         ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
         var widget = args.owner.widget;
        widget.currentRow.__is_new = false;
        restEngine.post('product#/deletePerfilCursoOcupa', {'requestType':'DataSet','dataset':[widget.currentRow]}).
            then(function(data){
                if(data.notifications[0].type === "success"){
                    ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                    ABUtilController.masterDetailVoltarList(widget);
                    widget.reload();
                } else {
                    ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                }
            }).
            catch(function(e) {
                var error;
                if(e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
         }, null);
    };
    
    this.mudarTipoFormacao = function() {
        var widget = templateManager.container.getActiveWidget();

        widget.getField('DSCURSO').isVisible = true;
        widget.getField('NMAREAFORMACAO').isVisible = true;
        widget.getField('NMCURSO').readOnly = false;
        widget.getField('NMAREAFORMACAO').readOnly = false;

        if (widget.currentRow.NRTIPOFORMACAO == 1) { // academica

            widget.currentRow.CDIDIOM = '';
            widget.currentRow.IDNVIDIOMA = '';

            widget.getField('NMIDIOMA').isVisible = false;
            widget.getField('IDNVIDIOMA').isVisible = false;
            widget.getField('NMCURSO').readOnly = false;
            widget.getField('NMAREAFORMACAO').readOnly = false;
            if (widget.currentRow.NMCURSO == 'Linguagens') {
                widget.currentRow.NMCURSO = '';
                widget.currentRow.NRCURSO = null;
            }
            if (widget.currentRow.NMAREAFORMACAO == 'Idiomas') {
                widget.currentRow.NMAREAFORMACAO = '';
                widget.currentRow.NRAREAFORMACAO = null;
            }

        } else if (widget.currentRow.NRTIPOFORMACAO == 2) { // idioma

            widget.getField('NMIDIOMA').isVisible = true;
            widget.getField('IDNVIDIOMA').isVisible = true;
            widget.getField('NMCURSO').readOnly = true;
            widget.getField('NMAREAFORMACAO').readOnly = true;
            widget.getField('DSCURSO').readOnly = true;
            widget.getField('DSCURSO').validations = {};
            widget.currentRow.DSCURSO = '';
            widget.currentRow.NMCURSO = 'Linguagens';
            widget.currentRow.NRCURSO = 3;
            widget.currentRow.NMAREAFORMACAO = 'Idiomas';
            widget.currentRow.NRAREAFORMACAO = 3;

        } else if (widget.currentRow.NRTIPOFORMACAO == 3) { // extracurricular

            widget.getField('NMIDIOMA').isVisible = false;
            widget.getField('IDNVIDIOMA').isVisible = false;
            widget.getField('NMCURSO').readOnly = false;
            widget.getField('NMAREAFORMACAO').readOnly = false;
            if (widget.currentRow.NMCURSO == 'Linguagens') {
                widget.currentRow.NMCURSO = '';
                widget.currentRow.NRCURSO = null;
            }
            if (widget.currentRow.NMAREAFORMACAO == 'Idiomas') {
                widget.currentRow.NMAREAFORMACAO = '';
                widget.currentRow.NRAREAFORMACAO = null;
            }

        } else {
        widget.getField('NMCURSO').readOnly = false;
        widget.getField('NMAREAFORMACAO').readOnly = false;
            widget.getField('NMIDIOMA').isVisible = false;
            widget.getField('IDNVIDIOMA').isVisible = false;
            if (widget.currentRow.NMCURSO == 'Linguagens') {
                widget.currentRow.NMCURSO = '';
                widget.currentRow.NRCURSO = null;
            }
            if (widget.currentRow.NMAREAFORMACAO == 'Idiomas') {
                widget.currentRow.NMAREAFORMACAO = '';
                widget.currentRow.NRAREAFORMACAO = null;
            }
        }
    };

    this.setAvaliaOcupa = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
                if (!widget.backupRow) {
                    widget.currentRow.__is_new = true;
                } else {
                    widget.currentRow.__is_new = false;
                }
                restEngine.post('product#/setAvaliaOcupa', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                    then(function (data) {
                        if (data.notifications[0].type === "success") {
                            ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                            if (widget.currentRow.__is_new) {
                                ABUtilController.masterDetailVoltarList(widget);
                                widget.reload();
                            } else {
                                ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                                widget.backupRow = null;
                                widget.view();
                            }
                        } else {
                            ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                        }
                    }).
                    catch(function(e) {
                        var error;
                        if(e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;
                            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    });
            }
    };

    this.deleteAvaliaOcupa = function(args) {
         ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
         var widget = args.owner.widget;
        widget.currentRow.__is_new = false;
        restEngine.post('product#/deleteAvaliaOcupa', {'requestType':'DataSet','dataset':[widget.currentRow]}).
            then(function(data){
                if(data.notifications[0].type === "success"){
                    ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                    ABUtilController.masterDetailVoltarList(widget);
                    widget.reload();
                } else {
                    ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                }
            }).
            catch(function(e) {
                var error;
                if(e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
         }, null);
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('OcupacaoGestaoController', OcupacaoGestaoController);
});

// FILE: assets/js/controllers/OperacaodetransporteController.js
function OperacaodetransporteController(ScreenService, templateManager, localStorageEngine, ZhUtil,Messages ,restEngine, HcmRepository, ABUtilController) {

    this.salvarOperacaodetransporte = function(args) {
        var widget = templateManager.container.getActiveWidget();
        if (widget.isValid()) {
            if (!widget.backupRow) {
                widget.currentRow.__is_new = true;
            } else {
                widget.currentRow.__is_new = false;
            }
            restEngine.post('product#/setOperacaotransporte', {
                'requestType': 'DataSet',
                'dataset': [widget.currentRow]
            }).
            then(function(data) {
                if (data.notifications[0].type === "success") {
                    ScreenService.successNotification('Operação de transporte salva com sucesso', 10000);
                    if (widget.currentRow.__is_new) {
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    } else {
                        ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                        widget.backupRow = null;
                        widget.view();
                    }
                } else {
                    ScreenService.showMessage('Erro ao salvar a operação de transporte');
                }
            }).
            catch(function(e) {
                var error;
                if (e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;

                ScreenService.showMessage('Ocorreu um erro inesperado, contate o administrador informando o trecho abaixo: <br><br>' + error + '<br><br>', 'ERROR');
            });
        }
    };

    this.removerOperacaodetransporte = function(args) {
        ScreenService.confirmMessage(Messages.DELETE_ROW, 'CONFIRMATION',
            function() {
                var widget = templateManager.container.getActiveWidget();
                widget.currentRow.__is_new = false;
                restEngine.post('product#/deleteOperacaotransporte', {
                    'requestType': 'DataSet',
                    'dataset': [widget.currentRow]
                }).
                then(function(data) {
                    if (data.notifications[0].type === "success") {
                        ScreenService.successNotification('Operação de transporte excluída com sucesso', 10000);
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    } else {
                        ScreenService.showMessage('Erro ao excluir a operação de transporte');
                    }
                }).
                catch(function(e) {
                    var error;
                    if (e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;

                    ScreenService.showMessage('Ocorreu um erro inesperado, contate o administrador informando o trecho abaixo: <br><br>' + error + '<br><br>', 'ERROR');
                });
            });
    };

}

Configuration(function(ContextRegister) {
    ContextRegister.register('OperacaodetransporteController', OperacaodetransporteController);
});


// FILE: assets/js/controllers/OrigemAcaoController.js
function OrigemAcaoController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, General,Messages) {

    this.adicionarRow = function(args) {
        var widget = args.owner.widget;
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
    };

	this.setOrigemAcao = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
                if (!widget.backupRow) {
                    widget.currentRow.__is_new = true;
                } else {
                    widget.currentRow.__is_new = false;
                }
                restEngine.post('product#/setOrigemAcao', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                    then(function (data) {
                        if (data.notifications[0].type === "success") {
                            ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                            if (widget.currentRow.__is_new) {
                                ABUtilController.masterDetailVoltarList(widget);
                                widget.reload();
                            } else {
                                ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                                widget.backupRow = null;
                                widget.view();
                            }
                        } else {
                            ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                        }
                    }).
                    catch(function(e) {
                        var error;
                        if(e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;
                            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    });
            }
    };
    
    this.deleteOrigemAcao = function(args) {
    ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
        var widget = args.owner.widget;
        widget.currentRow.__is_new = false;
        restEngine.post('product#/deleteOrigemAcao', {'requestType':'DataSet','dataset':[widget.currentRow]}).
            then(function(data){
                if(data.notifications[0].type === "success"){
                    ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                    ABUtilController.masterDetailVoltarList(widget);
                    widget.reload();
                } else {
                    ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                }
            }).
            catch(function(e) {
                var error;
                if(e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
        }, null);
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('OrigemAcaoController', OrigemAcaoController);
});

// FILE: assets/js/controllers/ParamOrgController.js
/**
 * Created by lara on 15/06/2016.
 */
function ParamOrgController (ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, $window, ABUtilController) {

    var templateWidget;
    var nrorgTeknisa = 20;

    this.backParamOrg = function() {
        var widgetParam = templateManager.container.getWidget("parametrosOrg");
        widgetParam.template = templateWidget;
        templateManager.updateTemplate();
        if(widgetParam.currentRow.__is_new) {
            var indexOfCurrentRow = widgetParam.dataSource.data.indexOf(widgetParam.currentRow);
            if(indexOfCurrentRow !== -1) {
                widgetParam.dataSource.data.pop();
            }
            widgetParam.list();
            ScreenService.closeSwipe();
            widgetParam.activate();
        }
        else {
            Util.extend(widgetParam.currentRow, widgetParam.backupRow);
            widgetParam.list();
        }
    };

    this.getNumberArrayOfString = function(arrayString){
        arrayString.forEach(function(string, index){
            arrayString[index] = parseInt(string); 
        });  
        
        return arrayString;
    };
    
    this.editParamOrg = function () {
        var widgetParam = templateManager.container.getWidget("parametrosOrg");
        templateWidget = widgetParam.template;
        widgetParam.template = widgetParam.templateToForm; 
        templateManager.updateTemplate();
        ABUtilController.masterDetailEdit(widgetParam);
    };

    this.salvarParamOrg = function(argsRow){
        var widgetParam = templateManager.container.getWidget("parametrosOrg");
        if(widgetParam.isValid())  {   
            widgetParam.currentRow.changed = true;     
            widgetParam.currentRow.__is_new = false;
            widgetParam.currentRow.CDOPERLOG = getLocalVar("HCM_CDOPERADOR");
            widgetParam.currentRow.NRORGOPERLOG = getLocalVar("HCM_NRORG_TRAB");
            widgetParam.currentRow.DTATUAL = getLocalVar("HCM_DATA_ATUAL");
            return widgetParam.saveRow().then(function(){
                widgetParam.currentRow.changed = false;
                widgetParam.currentRow.__is_new = false;
                widgetParam.template = templateWidget;
                setLocalVar("HCM_IDREALIZACONTAB", widgetParam.currentRow.IDREALIZACONTAB);
                setLocalVar("HCM_IDREALIZADESPESA", widgetParam.currentRow.IDREALIZADESPESA);
                setLocalVar("HCM_NRTIPOESTRUTOMADOR", widgetParam.currentRow.NRTPESTRUTOMADOR ? widgetParam.currentRow.NRTPESTRUTOMADOR : null);
                templateManager.updateTemplate();
                widgetParam.list();
                widgetParam.reload();
            }).catch(function(e) {
                ScreenService.showMessage('Ocorreu um erro inesperado, contate o administrador informando o trecho abaixo: <br><br>' + e.data.error + '<br><br>', 'ERROR');
            });
        }
    };

    this.setParametros = function(){
        var widgetParam = templateManager.container.getWidget("parametrosOrg");        
        widgetParam.moveToFirst();
    };
    
     this.validaValidacaoQuadroVagas = function(){
        var widgetParam = templateManager.container.getWidget("parametrosOrg");
        var campo1 = widgetParam.getField('IDVALIDQVAGAS');
        if (widgetParam.currentRow.NRTPESTRUTQVAGAS) {
            campo1.validations = { required: {} };
        } else {
            campo1.validations = {};
        }
    };

}

Configuration(function(ContextRegister) {
    ContextRegister.register('ParamOrgController', ParamOrgController);
});

// FILE: assets/js/controllers/ParametrizacaoSindicatoController.js
function ParametrizacaoSindicatoController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, General,Messages, HcmConsts) {
    
    this.afterMovRowEstrutura = function(){
        var widgetEstrutura = templateManager.container.getWidget("estrutura");
        var widgetEndereco = templateManager.container.getWidget("enderecoParc");
        var widgetComunica = templateManager.container.getWidget("formaComunicacaoParc");
        var widgetParametro = templateManager.container.getWidget("parametroSindicato");
        var widgetCCT = templateManager.container.getWidget("CCT");
        var widgetCCTItem = templateManager.container.getWidget("ItensCCT");
        var widgetCCTBeneficio = templateManager.container.getWidget("BeneficioCCT");
        var widgetEvento = templateManager.container.getWidget("eventoEstrutura");
        var widgetBeneficio = templateManager.container.getWidget("Beneficio");
        
        ABUtilController.changeVisibilityOrgTrab(widgetEstrutura.currentRow.NRORG, widgetEndereco, ['new'], []);
        ABUtilController.changeVisibilityOrgTrab(widgetEstrutura.currentRow.NRORG, widgetComunica, ['new'], []);
        ABUtilController.changeVisibilityOrgTrab(widgetEstrutura.currentRow.NRORG, widgetComunica, ['cadastro_automatico'], []);
        ABUtilController.changeVisibilityOrgTrab(widgetEstrutura.currentRow.NRORG, widgetParametro, ['new'], []);
        ABUtilController.changeVisibilityOrgTrab(widgetEstrutura.currentRow.NRORG, widgetCCT, ['new'], []);
        ABUtilController.changeVisibilityOrgTrab(widgetEstrutura.currentRow.NRORG, widgetCCTItem, ['new'], []);
        ABUtilController.changeVisibilityOrgTrab(widgetEstrutura.currentRow.NRORG, widgetCCTBeneficio, ['adicionar'], []);
        ABUtilController.changeVisibilityOrgTrab(widgetEstrutura.currentRow.NRORG, widgetEvento, ['new'], []);
        ABUtilController.changeVisibilityOrgTrab(widgetEstrutura.currentRow.NRORG, widgetBeneficio, ['new'], []);
    };
    
    this.setFiltroWidgetsFilhasEstrutura = function(args){
        var widget = templateManager.container.getWidget("estrutura");
        var widgetEndereco = templateManager.container.getWidget("enderecoParc");
        var widgetComunica = templateManager.container.getWidget("formaComunicacaoParc");
        var widgetParametro = templateManager.container.getWidget("parametroSindicato");
        var widgetCCT = templateManager.container.getWidget("CCT");
        var widgetCCTItem = templateManager.container.getWidget("ItensCCT");
        var widgetCCTBeneficio = templateManager.container.getWidget("BeneficioCCT");
        var widgetEvento = templateManager.container.getWidget("eventoEstrutura");
        var widgetBeneficio = templateManager.container.getWidget("Beneficio");
        
        if(!Util.isUndefined(widgetEndereco)) {
            widgetEndereco.dataSourceFilter[0].value = widget.currentRow.NRPARCNEGOCIO;
            widgetEndereco.dataSourceFilter[1].value = widget.currentRow.NRORG;
        }
        if(!Util.isUndefined(widgetComunica)) {
            widgetComunica.dataSourceFilter[0].value = widget.currentRow.NRPARCNEGOCIO;
            widgetComunica.dataSourceFilter[1].value = widget.currentRow.NRORG;
        }
        if(!Util.isUndefined(widgetParametro)) {
            widgetParametro.dataSourceFilter[0].value = widget.currentRow.NRORG;
            widgetParametro.dataSourceFilter[2].value = widget.currentRow.NRESTRUTURAM;
            widgetParametro.getField("NRESTRUTURAM").defaultValue = widget.currentRow.NRESTRUTURAM;
        }
        if(!Util.isUndefined(widgetCCT)) {
            widgetCCT.dataSourceFilter[0].value = widget.currentRow.NRORG;
            widgetCCT.dataSourceFilter[3].value = widget.currentRow.NRESTRUTURAM;
            widgetCCT.getField("NRESTRUTURAM").defaultValue = widget.currentRow.NRESTRUTURAM;
        }
        if(!Util.isUndefined(widgetCCTItem)) {
            widgetCCTItem.dataSourceFilter[1].value = widget.currentRow.NRORG;
        }
        if(!Util.isUndefined(widgetCCTBeneficio)) {
            widgetCCTBeneficio.dataSourceFilter[0].value = widget.currentRow.NRORG;
        }
        if(!Util.isUndefined(widgetEvento)) {
            widgetEvento.dataSourceFilter[1].value = widget.currentRow.NRORG;
            widgetEvento.dataSourceFilter[3].value = widget.currentRow.NRESTRUTURAM;
            widgetEvento.getField("NRESTRUTURAM").defaultValue = widget.currentRow.NRESTRUTURAM;
        }
        if(!Util.isUndefined(widgetBeneficio)) {
            widgetBeneficio.dataSourceFilter[0].value = widget.currentRow.NRORG;
            widgetBeneficio.dataSourceFilter[4].value = widget.currentRow.NRESTRUTURAM;
            widgetBeneficio.getField("NRESTRUTSIND").defaultValue = widget.currentRow.NRESTRUTURAM;
        }
    };
    
    this.widgetsvisiblefalse = function(args) {
        var widget = args.owner.widget;
        widget.widgets[ABUtilController.retornaWidget(widget, 'enderecoParc')].showAsTab = false;
        widget.widgets[ABUtilController.retornaWidget(widget, 'formaComunicacaoParc')].showAsTab = false;
        widget.widgets[ABUtilController.retornaWidget(widget, 'parametroSindicato')].showAsTab = false;
        widget.widgets[ABUtilController.retornaWidget(widget, 'CCT')].showAsTab = false;
        widget.widgets[ABUtilController.retornaWidget(widget, 'eventoEstrutura')].showAsTab = false;
        widget.widgets[ABUtilController.retornaWidget(widget, 'Beneficio')].showAsTab = false;
    };

    this.widgetsvisibletrue = function(args) {
        var widget = args.owner.widget;
        widget.widgets[ABUtilController.retornaWidget(widget, 'enderecoParc')].showAsTab = true;
        widget.widgets[ABUtilController.retornaWidget(widget, 'formaComunicacaoParc')].showAsTab = true;
        widget.widgets[ABUtilController.retornaWidget(widget, 'parametroSindicato')].showAsTab = true;
        widget.widgets[ABUtilController.retornaWidget(widget, 'CCT')].showAsTab = true;
        widget.widgets[ABUtilController.retornaWidget(widget, 'eventoEstrutura')].showAsTab = true;
        widget.widgets[ABUtilController.retornaWidget(widget, 'Beneficio')].showAsTab = true;
    };
    
    this.selectRow = function() {
        var widget = templateManager.container.getWidget("estrutura");
        var idEnable = (widget.getCheckedRows().length > 0);
        widget.getCheckedRows().forEach(function(row){
            if (row.NRORG != 0) {
                idEnable = false;
            }
        });
        if (idEnable == false) {
            ScreenService.showMessage('Só é possível importar sindicatos de organização padrão');
        }
        this.enableActionImportarSindicato(idEnable);
    };
    
    this.unselectRow = function() {
        var widget = templateManager.container.getWidget("estrutura");
        var idEnable = (widget.getCheckedRows().length > 0);
        widget.getCheckedRows().forEach(function(row){
            if (row.NRORG != 0) {
                idEnable = false;
            }
        });
        this.enableActionImportarSindicato(idEnable);
    };
    
    this.enableActionImportarSindicato = function(idEnable) {
        var widget = templateManager.container.getWidget("estrutura");
        widget.getAction('importarSindicato').isVisible = idEnable;
    };
    
    this.importarSindicato = function() {
        var widget = templateManager.container.getWidget("estrutura");
        var count = widget.getCheckedRows().length;
        ScreenService.confirmMessage('Será realiza a importação de '+count+' sindicato(s). Deseja continuar?', 'CONFIRMATION',
            function(){
                restEngine.post('/importarSindicatoPadrao', {'requestType': 'DataSet', 'dataset': widget.getCheckedRows()}).
                    then(function(data) {
                        if (!Util.isUndefined(data.notifications) && data.notifications[0].type === "success") {
                            ScreenService.successNotification(Messages.IMPORTACAO_SUCCESS, 10000);
                            widget.dataSource.clearCheckedRows();
                            this.unselectRow();
                            widget.reload();
                        } else if (!Util.isUndefined(data.messages)) {
                            ScreenService.showMessage(Util.isUndefined(Messages[data.messages[0].message]) ? data.messages[0].message : Messages[data.messages[0].message], data.messages[0].type);
                        } else {
                            ScreenService.showMessage(Messages.IMPORTACAO_ERROR);
                        }
                    }.bind(this)).
                    catch(function(e) {
                        var error;
                        if(Util.isUndefined(e.data) && Util.isUndefined(e.data.error) && Util.isUndefined(e.message))
                            error = e;
                        else if(!Util.isUndefined(e.message))
                            error = e.message;
                        else
                            error = e.data.error;
                        ScreenService.showMessage(Util.isUndefined(Messages[error]) ? error : Messages[error], 'ERROR');
                    });
            }.bind(this),
            function(){
                //nothing to do
            }
        );
    };
    
}

Configuration(function(ContextRegister) {
    ContextRegister.register('ParametrizacaoSindicatoController', ParametrizacaoSindicatoController);
});

// FILE: assets/js/controllers/ParametroEstruturaController.js
function ParametroEstruturaController(ScreenService, templateManager, restEngine, ABUtilController, Messages, General) {
    
    this.adicionarRow = function(args) {
        var widget = args.owner.widget;
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
    };
    
    this.salvar = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
            if(ABUtilController.validaDtIniMenorIgualDtFin(widget.currentRow.DTINIVIGENCIA,widget.currentRow.DTFIMVIGENCIA)){
                ABUtilController.saveMasterDetailMasterHistory(widget);
            }else{
                ScreenService.showMessage(Messages.DTINI_POST_DTFIM_ERROR);
                return false;
            }    
        }
    };

    this.remover = function(args) {
    ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
        var widget = args.owner.widget;
        if (widget.isValid()) {
            widget.currentRow.__is_new = false;
            restEngine.post('product#/deleteParametroEstrutura', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                then(function (data) {
                    if (data.notifications[0].type === "success") {
                        ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    } else {
                        ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                    }
                }).
                catch(function(e) {
                    var error;
                    if(e.data.error === undefined){
                        error = e;
                    }    
                    else{
                        error = e.data.error;
                        ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    }    
                });
            }
        }, null);
    };

}

Configuration(function(ContextRegister) {
    ContextRegister.register('ParametroEstruturaController', ParametroEstruturaController);
});

// FILE: assets/js/controllers/ParametroFeriasController.js
function ParametroFeriasController(ScreenService, templateManager, restEngine, ABUtilController, Messages, General) {
    
    this.adicionarRow = function(args) {
        var widget = args.owner.widget;
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
    };
    
    this.salvar = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
            if(ABUtilController.validaDtIniMenorIgualDtFin(widget.currentRow.DTINIVIGENCIA,widget.currentRow.DTFIMVIGENCIA)){
                ABUtilController.saveMasterDetailMasterHistory(widget);
            }else{
                ScreenService.showMessage(Messages.DTINI_POST_DTFIM_ERROR);
                return false;
            }    
        }
    };

    this.remover = function(args) {
    ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
        var widget = args.owner.widget;
        if (widget.isValid()) {
            widget.currentRow.__is_new = false;
            restEngine.post('product#/deleteParametroFerias', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                then(function (data) {
                    if (data.notifications[0].type === "success") {
                        ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    } else {
                        ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                    }
                }).
                catch(function(e) {
                    var error;
                    if(e.data.error === undefined){
                        error = e;
                    }    
                    else{
                        error = e.data.error;
                        ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    }    
                });
            }
        }, null);
    };

}

Configuration(function(ContextRegister) {
    ContextRegister.register('ParametroFeriasController', ParametroFeriasController);
});

// FILE: assets/js/controllers/ParametroFolhaController.js
function ParametroFolhaController(ScreenService, templateManager, restEngine, ABUtilController, Messages, General) {
    
    this.adicionarRow = function(args) {
        var widget = args.owner.widget;
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
    };
    
    this.alteraCamposPorcentagem = function(row){
        row.VRPERCENTADIANT = !Util.isEmptyOrBlank(row.VRPERCENTADIANT) ? General.valueToFloat(row.VRPERCENTADIANT)  : null;
        row.VRENC1FERIAS = !Util.isEmptyOrBlank(row.VRENC1FERIAS) ? General.valueToFloat(row.VRENC1FERIAS)  : null;
        row.VRENC1AVISO = !Util.isEmptyOrBlank(row.VRENC1AVISO) ? General.valueToFloat(row.VRENC1AVISO)  : null;
        row.VRENC1DEC = !Util.isEmptyOrBlank(row.VRENC1DEC) ? General.valueToFloat(row.VRENC1DEC)  : null;
        row.VRENC2FERIAS = !Util.isEmptyOrBlank(row.VRENC2FERIAS) ? General.valueToFloat(row.VRENC2FERIAS)  : null;
        row.VRENC2AVISO = !Util.isEmptyOrBlank(row.VRENC2AVISO) ? General.valueToFloat(row.VRENC2AVISO)  : null;
        row.VRENC2DEC = !Util.isEmptyOrBlank(row.VRENC2DEC) ? General.valueToFloat(row.VRENC2DEC)  : null;
    };
    
    this.salvar = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
            this.alteraCamposPorcentagem(widget.currentRow);
            if(ABUtilController.validaDtIniMenorIgualDtFin(widget.currentRow.DTINIVIGENCIA,widget.currentRow.DTFIMVIGENCIA)){
                restEngine.post('product#/validaSalvar',{'requestType':'DataSet','dataset':[widget.currentRow]}).
                then(function(data){
                if(data.length!=0){
                    ScreenService.showMessage("Grupo de Incidência não poderá ser utilizado. Existe um ou mais itens de incidência sem o evento informado.");
                    return false;
                }
                if(widget.currentRow.NRGRPINCIDE===undefined){
                    widget.currentRow.NRGRPINCIDE="";
                }
                ABUtilController.saveMasterDetailMasterHistory(widget);
                });
            }else{
                ScreenService.showMessage(Messages.DTINI_POST_DTFIM_ERROR);
                return false;
            }    
        }
    };

    this.remover = function(args) {
    ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
        var widget = args.owner.widget;
        if (widget.isValid()) {
            widget.currentRow.__is_new = false;
            restEngine.post('product#/deleteParametroFolha', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                then(function (data) {
                    if (data.notifications[0].type === "success") {
                        ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    } else {
                        ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                    }
                }).
                catch(function(e) {
                    var error;
                    if(e.data.error === undefined){
                        error = e;
                    }    
                    else{
                        error = e.data.error;
                        ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    }    
                });
            }
        }, null);
    };

}

Configuration(function(ContextRegister) {
    ContextRegister.register('ParametroFolhaController', ParametroFolhaController);
});

// FILE: assets/js/controllers/ParametroFolhaPagamentoCentralizada.js
function ParametroFolhaPagamentoCentralizada(ScreenService, templateManager, restEngine, ABUtilController, ParametroEstruturaController, Messages, General, ZhUtil) {
    
    var self = this;
    
    this.parametroFolhaCentralizadaMasterDetailEdit = function(widget){
        this.alternaIsVisibleWidgets(widget.getParent(), widget, false);
        if(widget.currentRow.__is_new){
            this.setDefaultValues(widget.name);
        }
        ABUtilController.masterDetailEdit();
    };
    this.openReplicacaoPopup = function(args) {
        var widgetFilter = templateManager.container.getWidget('replicacao');
        widgetFilter.applyDefaultValue();
        ScreenService.openPopup(widgetFilter);
    };
    this.replicaParametroFolha = function(widget) {
        if (widget.isValid()) {
            var currentRow = templateManager.container.getWidget('paramEstrutura').currentRow;
            currentRow.NRESTRUTURAM_ALVO = widget.currentRow.NRESTRUTURAM;
            restEngine.post('product#/replicaParametroFolha', {'requestType': 'DataSet', 'dataset': [currentRow]}).
                then(function (data) {
                    data.notifications.forEach(function(val){
                        if (val.type!="success"){
                            ScreenService.alertNotification(val.message, 10000);
                        }else{
                            ScreenService.successNotification(val.message, 10000);
                        }
                    });
               
                    ScreenService.closePopup();
                    templateManager.container.getWidget('paramEstrutura').activate();
                    ABUtilController.masterDetailVoltarList(templateManager.container.getWidget('paramEstrutura'));
                    templateManager.container.getWidget('paramEstrutura').reload();
                }).
                catch(function(e) {
                    var error;
                    if(e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;

                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
        }
    };
    
    this.parametroEstruturaMasterDetailEdit = function(){
        var widgetParamEstrutura  = templateManager.container.getWidget('paramEstrutura');
        
        if(!widgetParamEstrutura.currentRow.NRPARAMFOLHAM){
            widgetParamEstrutura.currentRow.__is_new = true;
            widgetParamEstrutura.getField('DTMESCOMPETENC').validations = {};
            widgetParamEstrutura.getField('DTMESCOMPETENC').value(getLocalVar('HCM_DTCOMPETENCIA'));
            widgetParamEstrutura.getField('NRORG').value(getLocalVar('HCM_NRORG_TRAB'));
        } else {
            widgetParamEstrutura.getField('DTMESCOMPETENC').validations = {"required": {}};
        }
        
        ABUtilController.masterDetailEdit();  
    };
    
    this.parametroEstruturaMasterDetailCancelaEdicao = function(widget){
        Util.extend(widget.currentRow, widget.backupRow);
        this.alternaIsVisibleWidgets(widget, widget, true);
        // declara promessa pra permitir que a widget entre em modo view para depois alterar os valores  
        var promise = new Promise(
            function(resolve, reject){
                widget.view();
                resolve();
            }
        );
        
        widget.activate();
        
        if(!widget.currentRow.NRPARAMFOLHAM){
            promise.then(function(){
                widget.getField('DTMESCOMPETENC').value(0);
                widget.getField('NRORG').value("");
            });
        }
    };
    
    
    this.parametroFolhaCentralizadaMasterDetailCancelaEdicao = function(widget){
        this.alternaIsVisibleWidgets(widget.getParent(), widget, true);
        Util.extend(widget.currentRow, widget.backupRow);
        widget.list();
    };
    
    this.salvarEstrutura = function(args){
        var widget = args.owner.widget;
        if (widget.isValid()) {
            if(ABUtilController.validaDtIniMenorIgualDtFin(widget.currentRow.DTINIVIGENCIA,widget.currentRow.DTFIMVIGENCIA)){
                if(widget.currentRow.__is_new){
                    widget.backupRow = null;
                }
                this.saveMasterDetailMasterHistory(widget);
                
            }else{
                ScreenService.showMessage(Messages.DTINI_POST_DTFIM_ERROR);
                return false;
            }    
        }
    };
    
    this.setIsVisibleBotaoExcluir = function(widget){
        var botaoExcluirEstrutura = widget.getAction('excluir');
        if(botaoExcluirEstrutura){
            if(widget.currentRow && !widget.currentRow.NRPARAMESTRUTM){
                botaoExcluirEstrutura.isVisible = false;
            } else {
                botaoExcluirEstrutura.isVisible = true;
            }
        }
    };
    
    this.alternaIsVisibleWidgets = function(widgetPrincipal, widgetAtual, isVisble){
        if(widgetAtual){
            widgetPrincipal.widgets.forEach(function(widget){
               if(widget.name != widgetAtual.name){
                   widget.isVisible = isVisble;
               } 
            }); 
        }
        widgetPrincipal.enabled = isVisble;
    };
    
    this.abrePopUpCadastroIncidencias = function(){
        var nomeWidgetPopUp = 'popUpCadastroGrupoIncidencias';
        var widgetPopUp = templateManager.container.getWidget(nomeWidgetPopUp);
        widgetPopUp.activate();
        ABUtilController.masterDetailOpenPopup(widgetPopUp);
    };
    
    this.fechaPopUpCadastroIncidencias = function(){
        ScreenService.closePopup();
        templateManager.container.getWidget('paramFolha').activate();
    };
    
    this.atualizaValidacaoEventoAutonomo = function(args){
        var widget = templateManager.container.getWidget('popUpCadastroGrupoIncidencias');
        var campoEvento = widget.getField('NMEVENTOH');
        if(widget.currentRow.INSSPARTEEMPRESAAUTONOMO){
            campoEvento.validations = {"required": {}};
        } else {
            campoEvento.validations = null;
        }
    };
    
    this.selecionaGrupoIncidenciaCadastrado = function(nrgrpincide, nmgrpincide){
        var widget = templateManager.container.getWidget('paramFolha');
        widget.currentRow.NRGRPINCIDE = nrgrpincide;
        widget.getField('NMGRPINCIDE').setValue(nmgrpincide);
    };
    
    this.setValoresINSS = function(row){
        var widgetParamFolha = templateManager.container.getWidget('paramFolha');
        var vrenc1ferias = widgetParamFolha.getField('VRENC1FERIAS');
        var vrenc1aviso = widgetParamFolha.getField('VRENC1AVISO');
        var vrenc1dec = widgetParamFolha.getField('VRENC1DEC');
        var soma = row.INSSTERCEIROS + row.INSSEMPRESA + row.INSSSAT;
        
        if(!vrenc1ferias.value()){
            vrenc1ferias.value(soma);
        }
        
        if(!vrenc1aviso.value()){
            vrenc1aviso.value(soma);
        }
        
        if(!vrenc1dec.value()){
            vrenc1dec.value(soma);
        }  
    };
    
    this.salvaIncidencia = function(widget){
        if (widget.isValid()) {
            if (ABUtilController.validaDtIniMenorIgualDtFin(widget.currentRow.DTINIVIGENCIA, widget.currentRow.DTFIMVIGENCIA)) {
                widget.currentRow.__is_new = true;
                restEngine.post('product#/setGrupoIncidenciaPopUpParametroFolha', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                    then(function (data) {
                        if (data.notifications[0].type === "success") {
                            ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                            self.fechaPopUpCadastroIncidencias();
                            self.selecionaGrupoIncidenciaCadastrado(data.dataset.NRGRPINCIDE[0], widget.currentRow.NMGRPINCIDE);
                            self.setValoresINSS(widget.currentRow);
                            self.clearFields(widget, []);
                            widget.reload();
                        } else {
                            ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                        }
                    }).
                    catch(function(e) {
                        var error;
                        if(e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;
                            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    });
            }else{
                ScreenService.showMessage(Messages.DTINI_POST_DTFIM_ERROR);
                return false;
            }        
        }
    };
    
    this.setVisibilidadeBotaoNovaIncidencia = function(widget){
        if(widget.inListMode()){
            widget.getField('NMGRPINCIDE').class = '12';
            widget.getField('novoGrupoIncidencia').isVisible = false;
        } else if(widget.inEditMode()){
            widget.getField('NMGRPINCIDE').class = '8';
            widget.getField('novoGrupoIncidencia').isVisible = true;
        }
    };
    
    this.setNrparamestrutm = function(widget){
        var widgetFolha = templateManager.container.getWidget('paramFolha');
        var widgetFerias = templateManager.container.getWidget('paramFerias');
        var nrparamestrutm = widget.currentRow.NRPARAMESTRUTM ? widget.currentRow.NRPARAMESTRUTM : null;
        
        widgetFolha.getField('NRPARAMESTRUTM').value(nrparamestrutm);
        widgetFerias.getField('NRPARAMESTRUTM').value(nrparamestrutm);
    };
    
    this.widgetRedraw = function(widget){
        widget.redraw();
    };
    
    this.setDefaultValues = function(nomeWidget){
        var widget = templateManager.container.getWidget(nomeWidget);
        widget.fields.forEach(function(field){
            field.applyDefaultValue();
        });
    };
    
    this.clearFields = function(widget, camposForcarValorVazio){
        var fields = widget.fields;
        if(widget.currentRow){
            for (var fieldRow in widget.currentRow){
                var field = fields.find(function(fieldWidget){
                    return fieldWidget.name == this; 
                }, fieldRow);
                if(field){
                    var campoForcarValorVazio = camposForcarValorVazio.find(function(fieldForcar){
                        return fieldForcar == this.name;
                    }, field);
                    if(!!campoForcarValorVazio){
                        if(field.template == "field/number.html" || field.template == "field/calendar.html"){
                            field.value('');  
                        } else {
                            field.value(' ');  
                        }
                    } else {
                        if(!field.defaultValue && field.template == "field/checkbox.html"){
                            field.value('N');
                        }
                        field.applyDefaultValue();
                    }
                } 
            }
        }
    };
    
    this.clearFieldsParamFolha = function(){
        var widget = templateManager.container.getWidget('paramFolha');
        var fieldsForcarValor = ['NRCTRLADMISSAO', 'NRCTRLAFAST', 'NRCTRLFERIAS', 'VRENC2AVISO', 'VRENC2DEC', 'VRENC2FERIAS'];
        this.clearFields(widget, fieldsForcarValor);     
    };
    
    this.clearFieldsParamFerias = function(){
        var widget = templateManager.container.getWidget('paramFerias');
        var fieldsForcarValor = ['VRPEADIANT13SAL', 'NRDIASFERIAPROV', 'VRPEPROVISAO'];
        this.clearFields(widget, fieldsForcarValor);     
    };
    
    this.clearWidgetCurrentRow = function(widget){
        var fieldsForcarValor = ['NRCTRLADMISSAO', 'NRCTRLAFAST', 'NRCTRLFERIAS', 'VRENC2AVISO', 'VRENC2DEC', 'VRENC2FERIAS'];
        if(widget.dataSource.data.length == 0){
            if(widget.name == 'paramFolha' || widget.name == 'paramFerias'){
                widget.currentRow.__is_new = true;
                this.alternaIsVisibleCamposNrorgCompetencia(widget, false);
            }
            this.clearFields(widget, fieldsForcarValor);
        } else {
            this.alternaIsVisibleCamposNrorgCompetencia(widget, true);
        }
    };
    
    this.alternaIsVisibleCamposNrorgCompetencia = function(widget, isVisible){
        widget.getField('NRORG').isVisible = isVisible;
        widget.getField('DTMESCOMPETENC').isVisible = isVisible;
    };
    
    this.cancelarClearFieldsCurrentRow = function(widget){
        if(widget.currentRow.__is_new){
            if(widget.name == 'paramFolha'){
                this.clearFieldsParamFolha();
            } else if(widget.name == 'paramFerias'){
                this.clearFieldsParamFerias();
            }
        }
    };
    
    this.salvaParamFolha = function(widget){
        var widgetParamEstrutura = templateManager.container.getWidget('paramEstrutura');
        if(widget.isValid()){
            if(ABUtilController.validaDtIniMenorIgualDtFin(widget.currentRow.DTINIVIGENCIA,widget.currentRow.DTFIMVIGENCIA)){
                restEngine.post('product#/validaSalvar',{'requestType':'DataSet','dataset':[widget.currentRow]}).
                then(function(data){
                    if(data.length!=0){
                        ScreenService.showMessage("Grupo de Incidência não poderá ser utilizado. Existe um ou mais itens de incidência sem o evento informado.");
                        return false;
                    }
                    if(widget.currentRow.NRGRPINCIDE===undefined){
                        widget.currentRow.NRGRPINCIDE="";
                    }
                    if(widget.currentRow.__is_new){
                        widget.backupRow = false;
                    }
                    widget.currentRow.NRESTRUTURAM = widgetParamEstrutura.currentRow.NRESTRUTURAM;
                    widget.currentRow.NRPARAMESTRUTM = widgetParamEstrutura.currentRow.NRPARAMESTRUTM;
                    var closeSwipeDepoisIncusao = widget.currentRow.__is_new;
                    this.saveMasterDetailMasterHistory(widget, closeSwipeDepoisIncusao);
                }.bind(this));
            }else{
                ScreenService.showMessage(Messages.DTINI_POST_DTFIM_ERROR);
                return false;
            }    
        }
    };
    
    this.parametroFolhaCentralizadaVoltarList = function(widget, closeSwipe){
        if(widget.name == 'paramEstrutura'){
            widget.view();
        } else {
            widget.list();
        }
        self.alternaIsVisibleWidgets(widget.getParent(), widget, true);
        if(closeSwipe){
            var widgetParamEstrutura = templateManager.container.getWidget('paramEstrutura');
            ScreenService.closeSwipe(0);
            setTimeout(function(){
                widgetParamEstrutura.reload();
            },  500);
        }
    };
    
    this.salvaParamFerias = function(widget){
        var widgetParamEstrutura = templateManager.container.getWidget('paramEstrutura');
        var nrparamfolham = widgetParamEstrutura.currentRow.NRPARAMFOLHAM;
        if(nrparamfolham){
            if(widget.isValid()){
                if(ABUtilController.validaDtIniMenorIgualDtFin(widget.currentRow.DTINIVIGENCIA,widget.currentRow.DTFIMVIGENCIA)){
                    if(widget.currentRow.__is_new){
                        widget.backupRow = false;
                    }
                    widget.currentRow.NRESTRUTURAM = widgetParamEstrutura.currentRow.NRESTRUTURAM;
                    widget.currentRow.NRPARAMESTRUTM = widgetParamEstrutura.currentRow.NRPARAMESTRUTM;
                    this.saveMasterDetailMasterHistory(widget, widget.currentRow.__is_new);
                }else{
                    ScreenService.showMessage(Messages.DTINI_POST_DTFIM_ERROR);
                    return false;
                }    
            }
        } else {
            ScreenService.showMessage(Messages.AVISO_GER_PREENCHIMENTO_PARAM_FOLHA);
        }
    };
    
    this.prepareSaveMasterHistory = function(widget) {
        var paramsNewCode = widget.paramsNewCode;
        var saveHistoryTable = widget.saveHistoryTable;
        var columnsToSave = widget.__columns_to_return;
        var historyField = saveHistoryTable.__table_competenc.toUpperCase();

        if (paramsNewCode && paramsNewCode.__is_new_code) {
            widget.currentRow.__new_code_pk = paramsNewCode.__new_code_pk;
            widget.currentRow.__table_pk = paramsNewCode.__table_pk;
            widget.currentRow.__new_code_length = paramsNewCode.__new_code_length || 5;
        }
        if (!Util.isUndefined(paramsNewCode.__use_org_padrao) && paramsNewCode.__use_org_padrao) {
            widget.currentRow.__nrorgpadrao = getLocalVar('HCM_NRORG_PADRAO');
        }

        if (paramsNewCode) {
            widget.currentRow.saveHistoryTable = saveHistoryTable;
        }

        if (columnsToSave) {
            widget.currentRow.__columns_to_return = columnsToSave;
        }

        if (!widget.backupRow) {
            widget.currentRow.__is_new = true;
        } else {
            widget.currentRow.__is_new = false;
            widget.currentRow[historyField] = getLocalVar('HCM_DTCOMPETENCIA_OPER');
        }

        return widget;
    };

    this.saveMasterDetailMasterHistory = function(widget, closeSwipe) {

        var preparedWidget = this.prepareSaveMasterHistory(widget);
        var masterTable = preparedWidget.paramsNewCode.__new_code_pk;

        restEngine.post('product#/saveCrud', {
            'requestType': 'DataSet',
            'dataset': [preparedWidget.currentRow]
        }).
        then(function(data) {
            if (data.dataset.columnsToReturn) {
                ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                if (preparedWidget.currentRow.__is_new) {
                    preparedWidget.reload();
                    
                    self.parametroFolhaCentralizadaVoltarList(preparedWidget, closeSwipe);
                    self.alternaIsVisibleCamposNrorgCompetencia(widget, true);
                    ABUtilController.mudarVisibilidadeWidgets(preparedWidget.widgets, true);
                     if(data.dataset.columnsToReturn && data.dataset.columnsToReturn[0].NRPARAMESTRUTM && !preparedWidget.currentRow.NRPARAMESTRUTM ) {
                        preparedWidget.currentRow.NRPARAMESTRUTM = data.dataset.columnsToReturn[0].NRPARAMESTRUTM; 
                    }
                } else {
                    ABUtilController.mudarVisibilidadeWidgets(preparedWidget.widgets, true);
                    var tableHistoryPk = preparedWidget.saveHistoryTable.__table_history_pk.toUpperCase();
                    if (preparedWidget.currentRow[tableHistoryPk]) {
                        for (var i = 0; i < data.dataset.columnsToReturn.length; i++) {
                            if (!Util.isUndefined(data.dataset.columnsToReturn[i][tableHistoryPk])) {
                                preparedWidget.currentRow[tableHistoryPk] = data.dataset.columnsToReturn[i][tableHistoryPk];
                            }
                        }
                    }
                    
                    ABUtilController.mudarVisibilidadeWidgets(preparedWidget.widgets, true);
                    preparedWidget.backupRow = null;
                    self.parametroFolhaCentralizadaVoltarList(preparedWidget, closeSwipe);
                    self.alternaIsVisibleCamposNrorgCompetencia(widget, true);
                }
            } else {
                ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
            }
        }.bind(this)).
        catch(function(e) {
            var error;
            if (e.data.error === undefined)
                error = e;
            else
                error = e.data.error;

            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
        });
    };
    
}

Configuration(function(ContextRegister) {
    ContextRegister.register('ParametroFolhaPagamentoCentralizada', ParametroFolhaPagamentoCentralizada);
});

// FILE: assets/js/controllers/ParametroSindicatoController.js
function ParametroSindicatoController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, General,Messages) {
    
    /* Controller utilizado também na tela hcm00118_gpe_parametrizacaoSindicado */

    this.adicionarRow = function(args) {
        var widget = args.owner.widget;
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
    };

    this.openReplicacaoPopup = function(args) {
        var widgetFilter = templateManager.container.getWidget('replicacao');
        widgetFilter.applyDefaultValue();
        ScreenService.openPopup(widgetFilter);
    };
    
    
     this.replicaParametroSindicato = function(widget) {
        if (widget.isValid()) {
            var currentRow = templateManager.container.getWidget('ParametroSindicato').currentRow;
            currentRow.NRESTRUTURAM = widget.currentRow.NRESTRUTSINDICAL;
            restEngine.post('product#/replicaParametroSindicato', {'requestType': 'DataSet', 'dataset': [currentRow]}).
                then(function (data) {
                    data.notifications.forEach(function(val){
                        if (val.type!="success"){
                            ScreenService.alertNotification(val.message, 10000);
                        }else{
                            ScreenService.successNotification(val.message, 10000);
                        }
                    });
               
                    ScreenService.closePopup();
                    templateManager.container.getWidget('ParametroSindicato').activate();
                    ABUtilController.masterDetailVoltarList(templateManager.container.getWidget('ParametroSindicato'));
                    templateManager.container.getWidget('ParametroSindicato').reload();
                }).
                catch(function(e) {
                    var error;
                    if(e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;

                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
        }
    };
       
	this.setParametroSindicato = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
            if(ABUtilController.validaDtIniMenorIgualDtFin(widget.currentRow.DTINICIOVIGENCIA,widget.currentRow.DTFIMVIGENCIA)){
                widget.currentRow.VRPERDESCVALE = General.valueToFloat(widget.currentRow.VRPERDESCVALE);
                if (!widget.backupRow) {
                    widget.currentRow.__is_new = true;
                } else {
                    widget.currentRow.__is_new = false;
                }
                restEngine.post('product#/setParametroSindicato', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                    then(function (data) {
                        if (data.notifications[0].type === "success") {
                            ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                            if (widget.currentRow.__is_new) {
                                ABUtilController.masterDetailVoltarList(widget);
                                widget.reload();
                            } else {
                                ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                                widget.backupRow = null;
                                widget.view();
                            }
                        } else {
                            ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                        }
                    }).
                    catch(function(e) {
                        var error;
                        if(e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;
                            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    });
            }else{
                ScreenService.showMessage(Messages.DTINI_POST_DTFIM_ERROR);
                return false;
            }     
        }
    };
    
    this.deleteParametroSindicato = function(args) {
        ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
            var widget = args.owner.widget;
            widget.currentRow.__is_new = false;
            restEngine.post('product#/deleteParametroSindicato', {'requestType':'DataSet','dataset':[widget.currentRow]}).
                then(function(data){
                    if(data.notifications[0].type === "success"){
                        ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    } else {
                        ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                    }
                }).
                catch(function(e) {
                    var error;
                    if(e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;
                        ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
        }, null);
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('ParametroSindicatoController', ParametroSindicatoController);
});

// FILE: assets/js/controllers/ParamoperController.js
/**
 * Created by leonardocarvalho on 28/03/2016.
 */
function ParamoperController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController) {

	this.salvar = function(args, isNew) {
		var widget = ABUtilController.checkWidget(args);
		var data = args.row;
		data.__is_new = isNew;

		if (widget.isValid()) {
			return localStorageEngine.setDataSource('product#/crud/gpe_paramoper', data).then(function() {
				return localStorageEngine.saveInServer('product#/crud/gpe_paramoper').then(function(result) {
					if (isNew === false) {
						widget.reload().then(function() {
							// atualiza a nrorgtrab do operador
							restEngine.post("product#/updateNrorgtrabalhoOper", {
								requestType: "DataSet",
								dataset: [data]
							}).then(function(result) {
								if (!Util.isUndefined(result.dataset.updateNrorgtrabalhoOper)) {
									HcmRepository.hcmFactory(data.CDOPERADOR).then(function(dataOperador) {
										ABUtilController.setLocalStorageHCM(dataOperador);
										HcmRepository.buildUserDataAndHeaderInfo(dataOperador);
										ABUtilController.changeTemplateToView(args);
										ABUtilController.closeContainers(["zeedhi_project", "product#dashboard", "product#hcm00001_gpe_paramoper"]);
										ABUtilController.closeContainer(null, null, true);
									}).catch(function(e) {
										var error;
										if (e.data.error === undefined)
											error = e;
										else
											error = e.data.error;

										ScreenService.showMessage('Ocorreu um erro inesperado, contate o administrador informando o trecho abaixo: <br><br>' + error + '<br><br>', 'ERROR');
									});
								}
							}).catch(function(e) {
								ScreenService.showMessage("Erro ao atualizar operador: " + e.data.error);
								ABUtilController.changeTemplateToView(args);
							});
						});
					}
				}).catch(function(e) {
					ScreenService.showMessage("Erro ao atualizar operador: " + e.data.error);
				});
			});
		}
	};

}

Configuration(function(ContextRegister) {
	ContextRegister.register('ParamoperController', ParamoperController);
});


// FILE: assets/js/controllers/ParceiroNegocioController.js
/* jshint esversion: 6 */
function ParceiroNegocioController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, General,Messages, HcmConsts, $window) {
    
    
    /* Controller utilizado também na tela hcm00118_gpe_parametrizacaoSindicado */
    
    var cdbanco;
    this.pais = '';
    this.estado = '';
    
    this.adicionarRow = function(args) {
        var widget = args.owner.widget;
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
    };
    
    this.adicionarPais = function(args){
        var widget = ABUtilController.checkWidget(args);
        if(widget.currentRow.NMPAIS)
            this.pais = widget.currentRow.NMPAIS;
    };
    
    this.setPeriodoDeOcorrencia = function(){
        var widget = templateManager.container.getActiveWidget();
        if(!Util.isEmptyOrBlank(widget.currentRow.DTOCORRENCIA)){
            widget.currentRow.DTOCORRENCIA = widget.currentRow.DTRESCISAOVINC;
        }
    };
    
    this.filtrarEstadoMunicipioPorPais = function(args){
        var widget = args.owner.field.widget;
        var estado;
        if (!Util.isUndefined(widget.getField('SGESTADO'))) {
            estado = widget.getField('SGESTADO');
        } else {
            estado = widget.getField('NMESTADO');
        }
        var municipio = widget.getField('NMMUNICIPIO');

        estado.dataSourceFilter[ABUtilController.retornaFiltro(estado.dataSourceFilter, 'CDPAIS')].value = widget.currentRow.CDPAIS;
        municipio.dataSourceFilter[ABUtilController.retornaFiltro(municipio.dataSourceFilter, 'CDPAIS')].value = widget.currentRow.CDPAIS;
        municipio.dataSourceFilter[ABUtilController.retornaFiltro(municipio.dataSourceFilter, 'SGESTADO')].value = widget.currentRow.SGESTADO;
        estado.dataSourceFilter[ABUtilController.retornaFiltro(estado.dataSourceFilter, 'CDPAIS')].operator = "=";
        municipio.dataSourceFilter[ABUtilController.retornaFiltro(municipio.dataSourceFilter, 'CDPAIS')].operator = "=";
        municipio.dataSourceFilter[ABUtilController.retornaFiltro(municipio.dataSourceFilter, 'SGESTADO')].operator = "=";
        if(!widget.currentRow.NMPAIS){
            estado.dataSourceFilter[ABUtilController.retornaFiltro(estado.dataSourceFilter, 'CDPAIS')].value = "0";
            estado.dataSourceFilter[ABUtilController.retornaFiltro(estado.dataSourceFilter, 'CDPAIS')].operator = ">";
        }
        if(!widget.currentRow.SGESTADO){
            widget.currentRow.NMMUNICIPIO = "";
            municipio.dataSourceFilter[ABUtilController.retornaFiltro(municipio.dataSourceFilter, 'CDPAIS')].value = "0";
            municipio.dataSourceFilter[ABUtilController.retornaFiltro(municipio.dataSourceFilter, 'SGESTADO')].value = "0";
            municipio.dataSourceFilter[ABUtilController.retornaFiltro(municipio.dataSourceFilter, 'CDPAIS')].operator = ">";
            municipio.dataSourceFilter[ABUtilController.retornaFiltro(municipio.dataSourceFilter, 'SGESTADO')].operator = ">";
        }
        if(widget.currentRow.NMPAIS !== this.pais){
            widget.currentRow.SGESTADO = "";
            widget.currentRow.NMMUNICIPIO = "";
        }
        this.pais = widget.currentRow.NMPAIS;
    };
    
    this.pesquisaEstadoMunicipioPorPais = function(args){
        var widget = args.owner.field.widget;
        
        var reloadEstado = true;
        var reloadMunicipio = true;
        
        var estado = widget.getField('NMESTADO');
        var municipio = widget.getField('NMMUNICIPIO');
        
        var filterPaisEstado = estado.dataSourceFilter[ABUtilController.retornaFiltro(estado.dataSourceFilter, 'CDPAIS')];
        var filterPaisMunicipio = municipio.dataSourceFilter[ABUtilController.retornaFiltro(estado.dataSourceFilter, 'CDPAIS')];
        var filterEstadoMunicipio = municipio.dataSourceFilter[ABUtilController.retornaFiltro(municipio.dataSourceFilter, 'SGESTADO')];
        
        // verifica se deve recarregar os dados dos campos
        if(filterPaisEstado.value != widget.currentRow.CDPAIS){
            reloadEstado = true;
        }else{
            reloadEstado = false;
        }
        if(filterPaisMunicipio.value != widget.currentRow.CDPAIS|| filterEstadoMunicipio.value != widget.currentRow.SGESTADO){
            reloadMunicipio = true;
        }else{
            reloadMunicipio = false;
        }

        // setando os novos valores para os campos
        filterPaisEstado.value = widget.currentRow.CDPAIS;
        filterPaisEstado.operator = "=";
        filterPaisMunicipio.value = widget.currentRow.CDPAIS;
        filterPaisMunicipio.operator = "=";
        filterEstadoMunicipio.value = widget.currentRow.SGESTADO;
        filterEstadoMunicipio.operator = "=";
        
        // alteração do dataSource nos casos em que país e estado são excluídos
        if(!widget.currentRow.NMPAIS){
            filterPaisEstado.value = "0";
            filterPaisEstado.operator = ">";
        }
        if(!widget.currentRow.SGESTADO){
            filterPaisMunicipio.value = "0";
            filterPaisMunicipio.operator = ">";
            filterEstadoMunicipio.value = "0";
            filterEstadoMunicipio.operator = ">";
        }
        
        // validaçao para os casos em que há a mudança de país e estado
        if(widget.currentRow.NMPAIS !== this.pais || (widget.currentRow.NMPAIS == '' && this.pais == '')){
            widget.currentRow.NMESTADO = "";
            widget.currentRow.SGESTADO = "";
            widget.currentRow.NMMUNICIPIO = "";
            widget.currentRow.CDMUNICIPIO = "";
        }
        if(widget.currentRow.SGESTADO !== this.estado || (widget.currentRow.SGESTADO == '' && this.estado == '')){
            widget.currentRow.NMMUNICIPIO = "";
            widget.currentRow.CDMUNICIPIO = "";
        }
        this.pais = widget.currentRow.NMPAIS;
        this.estado = widget.currentRow.SGESTADO;
        
        // validação dos momentos em que deve recarregar os dados
        if(reloadEstado){
            estado.reload();
        }
        if(reloadMunicipio){
            municipio.reload();
        }
    };
    
    
    
    this.alteraDataSourceFilter = function(filtro, field, currentRow){
        if(currentRow[filtro]){
            field.dataSourceFilter[ABUtilController.retornaFiltro(field.dataSourceFilter, filtro)].value = currentRow[filtro];
            field.dataSourceFilter[ABUtilController.retornaFiltro(field.dataSourceFilter, filtro)].operator = '=';
        } else{
            field.dataSourceFilter[ABUtilController.retornaFiltro(field.dataSourceFilter, filtro)].value = "0";
            field.dataSourceFilter[ABUtilController.retornaFiltro(field.dataSourceFilter, filtro)].operator = '>';
        } 
    };
    
    this.alteraCamposPaisEstadoMunicípio = function(currentRow, field){
        if(!currentRow[field]){
            currentRow.CDMUNICIPIO = '';
            currentRow.SGESTADO = this.sgestado;
            currentRow.CDPAIS = this.nrpais;
        }
        
    };
    
    this.filtrarWidgetsPorParcNegocio = function(args){
        var widget = args.owner;
        if(!Util.isUndefined(templateManager.container.getWidget("enderecoParc"))) {
            templateManager.container.getWidget("enderecoParc").dataSourceFilter[0].value = widget.currentRow.NRPARCNEGOCIO;
        }
        if(!Util.isUndefined(templateManager.container.getWidget("formaComunicacaoParc"))) {
            templateManager.container.getWidget("formaComunicacaoParc").dataSourceFilter[0].value = widget.currentRow.NRPARCNEGOCIO;
        }
        if(!Util.isUndefined(templateManager.container.getWidget("contaCorrenteParc"))) {
            templateManager.container.getWidget("contaCorrenteParc").dataSourceFilter[0].value = widget.currentRow.NRPARCNEGOCIO;
        }
    };
    
	this.limpaCamposCep = function(currentRow){
        currentRow.CDPAIS = "";
        currentRow.NMPAIS = "";
        currentRow.SGESTADO = "";
        currentRow.NMESTADO = "";
        currentRow.CDMUNICIPIO = "";
        currentRow.NMMUNICIPIO = "";
        currentRow.CDBAIRRO = "";
        currentRow.DSBAIRAGEN = ""; 
        currentRow.DSENDEAGEN = "";
    };
    
    this.buscarCep = function(args) {
        var currentRow = args.owner.field.widget.currentRow;

        if(currentRow.NRCEPENDERECO){
            var cep = currentRow.NRCEPENDERECO;
            cep = cep.replace(/[\.-]/g, '');
            if (cep.length === 8) { 
                restEngine.post('product#/lib_findAddress',
                {'requestType':'Row','row':{'CEP': cep, 'NRORG': getLocalVar('HCM_NRORG_TRAB')}},
                function(array) {
                    if(array && array.dataset){
                        var data = array.dataset.ENDERECO;
                        if(data) {
                            if(data.CDPAIS) {
                                currentRow.CDPAIS = data.CDPAIS;
                                currentRow.NMPAIS = data.NMPAIS;
                                currentRow.SGESTADO = data.SGESTADO;
                                currentRow.NMESTADO = data.NMESTADO;
                                if((data.CDMUNICIPIO)) {
                                    currentRow.CDMUNICIPIO = data.CDMUNICIPIO;
                                    currentRow.NMMUNICIPIO = data.NMMUNICIPIO;
                                    if((data.NMBAIRRO)) {
                                        currentRow.NMBAIRROENDERECO = data.NMBAIRRO.toUpperCase();
                                        currentRow.DSLOGRADOURO = data.DSENDERECO.split(" ")[0].toUpperCase();
                                        currentRow.CDLOGRADOURO = data.CDLOGRADOURO;
                                        currentRow.DSENDERECO = retornaEnderecoCompleto(data.DSENDERECO);
                                    }
                                }
                            }
                        }
                    }else{
                        ScreenService.showMessage(array.error);
                        if(currentRow.NRCEPENDERECO) currentRow.NRCEPENDERECO = "";
                    }
                }, undefined, 
                function(error) {
                    ScreenService.showMessage(error);
                    self.limpaCamposCep(currentRow);
                });
            } 
        } else {
            ScreenService.showMessage('Favor digitar um CEP');
            this.limpaCamposCep(currentRow);
        }  
    };

    var retornaEnderecoCompleto = function(endereco){
        var retorno = "";
        endereco = endereco.split(" ");
        endereco.splice(0, 1); // Retirar a parte que refere se é Rua ou Avenida.
        endereco.forEach(function(e){
            retorno += e+' ';
        });
        retorno = retorno.toUpperCase();
        return retorno.substr(0, retorno.length-1);
    };
    
    this.setEnderecoParc = function(args,nameWidgetPrincipal) {
        var widget = args.owner.widget;
        var widgetPrincipal = templateManager.container.getWidget(nameWidgetPrincipal);
        widget.currentRow.NRPARCNEGOCIO = widgetPrincipal.currentRow.NRPARCNEGOCIO;
        //Retira a mascara do CEP
        var cep = widget.currentRow.NRCEPENDERECO;
        widget.currentRow.NRCEPENDERECO = cep.replace(/[\.-]/g, '');
        //
        if (widget.isValid()) {
                if (!widget.backupRow) {
                    widget.currentRow.__is_new = true;
                } else {
                    widget.currentRow.__is_new = false;
                }
                restEngine.post('product#/setEnderecoParc', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                    then(function (data) {
                        if (data.notifications[0].type === "success") {
                            ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                            if (widget.currentRow.__is_new) {
                                ABUtilController.masterDetailVoltarList(widget);
                                widget.reload();
                            } else {
                                ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                                widget.backupRow = null;
                                widget.view();
                            }
                        }else if(data.notifications[0].type === "alert" && data.notifications[0].variables == "registroExistente") {
                            ScreenService.showMessage(data.notifications[0].message);
                        }else {
                            ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                        }
                    }).
                    catch(function(e) {
                        var error;
                        if(e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;
                            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    });
            }
    };
    
    this.deleteEnderecoParc = function(args) {
        ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
        var widget = args.owner.widget;
        widget.currentRow.__is_new = false;
        restEngine.post('product#/deleteEnderecoParc', {'requestType':'DataSet','dataset':[widget.currentRow]}).
            then(function(data){
                if(data.notifications[0].type === "success"){
                    ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                    ABUtilController.masterDetailVoltarList(widget);
                    widget.reload();
                } else {
                    ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                }
            }).
            catch(function(e) {
                var error;
                if(e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
        }, null);    
    };
    
    this.setFormaComunicacaoParc = function(args,nameWidgetPrincipal) {
        var widget = args.owner.widget;
        var widgetPrincipal = templateManager.container.getWidget(nameWidgetPrincipal);
        widget.currentRow.NRPARCNEGOCIO = widgetPrincipal.currentRow.NRPARCNEGOCIO;
        if (widget.isValid()) {
                if (!widget.backupRow) {
                    widget.currentRow.__is_new = true;
                } else {
                    widget.currentRow.__is_new = false;
                }
                restEngine.post('product#/setFormaComunicacaoParc', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                    then(function (data) {
                        if (data.notifications[0].type === "success") {
                            ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                            if (widget.currentRow.__is_new) {
                                ABUtilController.masterDetailVoltarList(widget);
                                widget.reload();
                            } else {
                                ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                                widget.backupRow = null;
                                widget.view();
                            }
                        }else if(data.notifications[0].type === "alert" && data.notifications[0].variables == "registroExistente") {
                            ScreenService.showMessage(data.notifications[0].message);
                        }else {
                            ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                        }
                    }).
                    catch(function(e) {
                        var error;
                        if(e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;
                            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    });
            }
    };
    
    this.deleteFormaComunicacaoParc = function(args) {
        ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
        var widget = args.owner.widget;
        widget.currentRow.__is_new = false;
        restEngine.post('product#/deleteFormaComunicacaoParc', {'requestType':'DataSet','dataset':[widget.currentRow]}).
            then(function(data){
                if(data.notifications[0].type === "success"){
                    ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                    ABUtilController.masterDetailVoltarList(widget);
                    widget.reload();
                } else {
                    ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                }
            }).
            catch(function(e) {
                var error;
                if(e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
        }, null);
    };
    
    this.openPopupCadAutomatico = function(args) {
        var widgetFilter = templateManager.container.getWidget('cadAutoFormaComu');
        widgetFilter.applyDefaultValue();
        ScreenService.openPopup(widgetFilter);
    };
    
    this.cadAutoFormaComu = function(args,nameWidgetPrincipal) {
        var widget = args.owner.widget;
        var widgetPrincipal = templateManager.container.getWidget(nameWidgetPrincipal);
        widget.currentRow.NRPARCNEGOCIO = widgetPrincipal.currentRow.NRPARCNEGOCIO;
        if (widget.isValid()) {
            var rowCad = this.constructRowCadFormaComu(widget);
            restEngine.post('product#/cadAutoFormaComu', {'requestType': 'DataSet', 'dataset': [rowCad]}).
                then(function (data) {
                    ScreenService.showMessage(Messages.CADASTRO_AUTOMATICO_SUCCESS, 'SUCCESS');
                    ScreenService.closePopup();
                    templateManager.container.getWidget('formaComunicacaoParc').activate();
                    templateManager.container.getWidget('formaComunicacaoParc').reload();
                }).
                catch(function(e) {
                    var error;
                    if(e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;

                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
        }
    };
    
    this.constructRowCadFormaComu = function(widget){
        var rowCad = [];
        var currentRow = widget.currentRow;
        if(currentRow.TELPRINCIPAL){
            rowCad.push({
                'CDCOMUNICAPARC':currentRow.TELPRINCIPAL,
                'CDPREFIXCOMUPARC':currentRow.PREFTELPRINCIPAL,
                'CDFORMACOMU': HcmConsts.FormaComu.TELPRINCIPAL,
                'NRPARCNEGOCIO': currentRow.NRPARCNEGOCIO
            });
        }
        if(currentRow.TELRESIDEN){
            rowCad.push({
                'CDCOMUNICAPARC':currentRow.TELRESIDEN,
                'CDPREFIXCOMUPARC':currentRow.PREFTELRESIDEN,
                'CDFORMACOMU': HcmConsts.FormaComu.TELRESIDEN,
                'NRPARCNEGOCIO': currentRow.NRPARCNEGOCIO
            });
        }
        if(currentRow.TELCOMERC){
            rowCad.push({
                'CDCOMUNICAPARC':currentRow.TELCOMERC,
                'CDPREFIXCOMUPARC':currentRow.PREFTELCOMERC,
                'CDFORMACOMU': HcmConsts.FormaComu.TELCOMERC,
                'NRPARCNEGOCIO': currentRow.NRPARCNEGOCIO
            });
        }
        if(currentRow.CELPARTIC){
            rowCad.push({
                'CDCOMUNICAPARC':currentRow.CELPARTIC,
                'CDPREFIXCOMUPARC':currentRow.PREFCELPARTIC,
                'CDFORMACOMU': HcmConsts.FormaComu.CELPARTIC,
                'NRPARCNEGOCIO': currentRow.NRPARCNEGOCIO
            });
        }
        if(currentRow.CELCOMERC){
            rowCad.push({
                'CDCOMUNICAPARC':currentRow.CELCOMERC,
                'CDPREFIXCOMUPARC':currentRow.PREFCELCOMERC,
                'CDFORMACOMU': HcmConsts.FormaComu.CELCOMERC,
                'NRPARCNEGOCIO': currentRow.NRPARCNEGOCIO
            });
        }
        if(currentRow.FAX){
            rowCad.push({
                'CDCOMUNICAPARC':currentRow.FAX,
                'CDPREFIXCOMUPARC':currentRow.PREFFAX,
                'CDFORMACOMU': HcmConsts.FormaComu.FAX,
                'NRPARCNEGOCIO': currentRow.NRPARCNEGOCIO
            });
        }
        if(currentRow.EMAIL){
            rowCad.push({
                'CDCOMUNICAPARC':currentRow.EMAIL,
                'CDPREFIXCOMUPARC': null,
                'CDFORMACOMU': HcmConsts.FormaComu.EMAIL,
                'NRPARCNEGOCIO': currentRow.NRPARCNEGOCIO
            });
        }
        return rowCad;
    }; 
    
    this.requiredTrueOnChangePrefixo = function(args){
        var widget = args.owner.field.widget;
        var currentRow = widget.currentRow;
        
        if(currentRow.PREFTELPRINCIPAL){
            widget.getField('TELPRINCIPAL').validations = {required: true};
        }else{
            widget.getField('TELPRINCIPAL').validations = {};
        }
        if(currentRow.PREFTELRESIDEN){
            widget.getField('TELRESIDEN').validations = {required: true};
        }else{
            widget.getField('TELRESIDEN').validations = {};
        }
        if(currentRow.PREFTELCOMERC){
            widget.getField('TELCOMERC').validations = {required: true};
        }else{
            widget.getField('TELCOMERC').validations = {};
        }
        if(currentRow.PREFCELPARTIC){
            widget.getField('CELPARTIC').validations = {required: true};
        }else{
            widget.getField('CELPARTIC').validations = {};
        }
        if(currentRow.PREFCELCOMERC){
            widget.getField('CELCOMERC').validations = {required: true};
        }else{
            widget.getField('CELCOMERC').validations = {};
        }
        if(currentRow.PREFFAX){
            widget.getField('FAX').validations = {required: true};
        }else{
            widget.getField('FAX').validations = {};
        }
    };
    
    this.validaAgencia =  function(widget){
        if(widget.currentRow.CDBANCO != ''){
            widget.getField('NMAGENCIA').readOnly = false;
            widget.getField('NMAGENCIA').dataSourceFilter[ABUtilController.retornaFiltro(widget.getField('NMAGENCIA').dataSourceFilter, 'CDBANCO')].value = widget.currentRow.CDBANCO;
        }else{
             widget.getField('NMAGENCIA').readOnly = true;
            widget.getField('NMAGENCIA').dataSourceFilter[ABUtilController.retornaFiltro(widget.getField('NMAGENCIA').dataSourceFilter, 'CDBANCO')].value = '';
        }
    };
    
    this.filtrarAgenciaPorBanco = function(args){
        var widget = ABUtilController.checkWidget(args);
        var currentRow = widget.currentRow;
        var agenciaField = widget.getField('NMAGENCIA');
        if(currentRow.CDBANCO && cdbanco !== currentRow.CDBANCO || cdbanco === currentRow.CDBANCO){
            agenciaField.dataSourceFilter[0].value = currentRow.CDBANCO;
            agenciaField.readOnly = false;
            cdbanco = currentRow.CDBANCO;
        } else {
            agenciaField.dataSourceFilter[0].value = "";
            agenciaField.readOnly = true;
            currentRow.NMAGENCIA = '';
            currentRow.CDAGENCIA = '';  
        }
    };
    
    this.setContaCorrenteParc = function(args,nameWidgetPrincipal) {
        var widget = args.owner.widget;
        var widgetPrincipal = templateManager.container.getWidget(nameWidgetPrincipal);
        widget.currentRow.NRPARCNEGOCIO = widgetPrincipal.currentRow.NRPARCNEGOCIO;
        if (widget.isValid()) {
                if (!widget.backupRow) {
                    widget.currentRow.__is_new = true;
                } else {
                    widget.currentRow.__is_new = false;
                }
                restEngine.post('product#/setContaCorrenteParc', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                    then(function (data) {
                        if (data.notifications[0].type === "success") {
                            ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                            if (widget.currentRow.__is_new) {
                                ABUtilController.masterDetailVoltarList(widget);
                                widget.reload();
                            } else {
                                ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                                widget.backupRow = null;
                                widget.view();
                            }
                        } else {
                            ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                        }
                    }).
                    catch(function(e) {
                        var error;
                        if(e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;
                            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    });
            }
    };
    
    this.deleteContaCorrenteParc = function(args) {
        ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
        var widget = args.owner.widget;
        widget.currentRow.__is_new = false;
        restEngine.post('product#/deleteContaCorrenteParc', {'requestType':'DataSet','dataset':[widget.currentRow]}).
            then(function(data){
                if(data.notifications[0].type === "success"){
                    ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                    ABUtilController.masterDetailVoltarList(widget);
                    widget.reload();
                } else {
                    ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                }
            }).
            catch(function(e) {
                var error;
                if(e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
        }, null);
    };
    
    /*Planilhas - Geral*/
    this.openPopup = function(popupName) {
        var widgetPopup = templateManager.container.getWidget(popupName);
        widgetPopup.currentRow.DSPATH = [];
        ScreenService.openPopup(widgetPopup);
    };
    
    this.closePopup = function(widgetName) {
        ScreenService.closePopup();
        templateManager.container.getWidget(widgetName).activate();
    };
    
    this.validaArquivo = function(filePath) {
        var extension = filePath.split('.').pop().toUpperCase();
        if (extension !== 'XLS' && extension !== 'XLSX') {
            ScreenService.showMessage('Formato de arquivo inválido');
            return false;
        } else {
            return true;
        }
    };
    
    var openPopupMensagens = function(msg, nmPopupMsg) {
        var widgetMensagens = templateManager.container.getWidget(nmPopupMsg);
        widgetMensagens.dataSource.data = msg;
        ScreenService.openPopup(widgetMensagens);
    };
    
    /*Planilhas - Forma de Comunicação*/
    this.geraPlanilhaTemplete = function() {
        restEngine.post('product#/baixarPlanilhaFormaComunicacao', {
            'requestType': 'DataSet',
            'dataset': []
            }).then(function(data) {
                ScreenService.closePopup();
                if(data.dataset && data.dataset.arquivo){
                    $window.open($window.serviceUrl + "/abrirArquivo?requestType=DataSet&dataset[0][CMARQUIVO]=" + data.dataset.arquivo.NMARQUIVO);
                }
            }).catch(function(e) {
                var error;
                if (e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
    };
    
    this.importarPlanilhaFormaComunicacao = function() {
        var widgetPop = templateManager.container.getActiveWidget();
        var widgetPai = templateManager.container.getWidget('formaComunicacaoParc');
        if(widgetPop.isValid()){
            if(this.validaArquivo(widgetPop.currentRow.DSPATH[0].name)) {
                restEngine.post('product#/importarPlanilhaFormaComunicacao', {'requestType': 'DataSet', 'dataset': [widgetPop.currentRow]}).
                then(function(data) {
                    if (data.messages) {
                        ScreenService.closePopup(true);
                        ScreenService.showMessage(data.messages[0].message, data.messages[0].type);
                        if (data.dataset && data.dataset.msg) {
                            openPopupMensagens(data.dataset.msg, 'messagesImportacaoFormaComunicacao');
                        } else {
                            widgetPai.activate();
                        }
                        widgetPai.reload();
                    } else
                        ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                }).
                catch(function(e) {   
                    var error;
                    if (e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    
                });
            }
        }
    };
    
}

Configuration(function(ContextRegister) {
    ContextRegister.register('ParceiroNegocioController', ParceiroNegocioController);
});

// FILE: assets/js/controllers/ParteAtingidaController.js
function ParteAtingidaController(ScreenService, templateManager, restEngine, ABUtilController, Messages) {

	this.salvar = function(args) {
        var widget = templateManager.container.getActiveWidget();
        if (widget.isValid()) {
            if (!widget.backupRow) {
                widget.currentRow.__is_new = true;
            } else {
                widget.currentRow.__is_new = false;
            }
            restEngine.post('product#/setParteatingida', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                then(function (data) {
                    if (data.notifications[0].type === "success") {
                        ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                        if (widget.currentRow.__is_new) {
                            ABUtilController.masterDetailVoltarList(widget);
                            widget.reload();
                        } else {
                            ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                            widget.backupRow = null;
                            widget.view();
                        }
                    } else {
                        ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                    }
                }).
                catch(function(e) {
                    var error;
                    if(e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;

                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
        }
    };

    this.remover = function(args) {
    ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
        var widget = templateManager.container.getActiveWidget();
        if (widget.isValid()) {
            widget.currentRow.__is_new = false;
            restEngine.post('product#/deleteParteatingida', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                then(function (data) {
                    if (data.notifications[0].type === "success") {
                        ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    } else {
                        ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                    }
                }).
                catch(function(e) {
                    var error;
                    if(e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;

                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
            }
        }, null);
    };

}

Configuration(function(ContextRegister) {
    ContextRegister.register('ParteAtingidaController', ParteAtingidaController);
});

// FILE: assets/js/controllers/ParteCorpoAtingidaController.js
function ParteCorpoAtingidaController(ScreenService, templateManager, restEngine, ABUtilController, Messages) {

	this.salvar = function(args) {
        var widget = templateManager.container.getActiveWidget();
        if (widget.isValid()) {
            if (!widget.backupRow) {
                widget.currentRow.__is_new = true;
            } else {
                widget.currentRow.__is_new = false;
            }
            restEngine.post('product#/setPartatingesoc', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                then(function (data) {
                    if (data.notifications[0].type === "success") {
                        ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                        if (widget.currentRow.__is_new) {
                            ABUtilController.masterDetailVoltarList(widget);
                            widget.reload();
                        } else {
                            ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                            widget.backupRow = null;
                            widget.view();
                        }
                    } else {
                        ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                    }
                }).
                catch(function(e) {
                    var error;
                    if(e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;

                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
        }
    };

    this.remover = function(args) {
        var widget = templateManager.container.getActiveWidget();
        if (widget.isValid()) {
            widget.currentRow.__is_new = false;
            restEngine.post('product#/deletePartatingesoc', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                then(function (data) {
                    if (data.notifications[0].type === "success") {
                        ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    } else {
                        ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                    }
                }).
                catch(function(e) {
                    var error;
                    if(e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;

                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
        }
    };

}

Configuration(function(ContextRegister) {
    ContextRegister.register('ParteCorpoAtingidaController', ParteCorpoAtingidaController);
});

// FILE: assets/js/controllers/PensaoController.js
function PensaoController(ScreenService, templateManager, restEngine, ABUtilController, Messages, General) {

    this.salvar = function(args) {
        var widget = templateManager.container.getActiveWidget();
        if (widget.isValid()) {
            if (!widget.backupRow) {
                widget.currentRow.__is_new = true;
            } else {
                widget.currentRow.__is_new = false;
            }
            widget.currentRow.VRPISOEVENTO = General.valueToFloat(widget.currentRow.VRPISOEVENTO);
            widget.currentRow.VRTETOEVENTO = General.valueToFloat(widget.currentRow.VRTETOEVENTO);
            widget.currentRow.VRPERCENT = General.valueToFloat(widget.currentRow.VRPERCENT);
            widget.currentRow.VRMULTIPLIC = General.valueToFloat(widget.currentRow.VRMULTIPLIC);
            widget.currentRow.VRDIVIDE = General.valueToFloat(widget.currentRow.VRDIVIDE);
            widget.currentRow.VREVENTOFIXO = General.valueToFloat(widget.currentRow.VREVENTOFIXO);
            widget.currentRow.VRREFFIXO = General.valueToFloat(widget.currentRow.VRREFFIXO);
            restEngine.post('product#/setVincEvento', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                then(function (data) {
                    if (data.messages) {
                        ScreenService.showMessage(data.messages[0].message, data.messages[0].type);
                    } else if (data.notifications[0].type === "success") {
                        ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                        if (widget.currentRow.__is_new) {
                            ABUtilController.masterDetailVoltarList(widget);
                            widget.reload();
                        } else {
                            ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                            widget.backupRow = null;
                            widget.view();
                        }
                    } else {
                        ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                    }
                }).
                catch(function(e) {
                    var error;
                    if(e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;

                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
        }
    };
    
    this.desabilitaReferencia = function(args){
        var widget = ABUtilController.checkWidget(args);
        var row = widget.currentRow;
        if(row.NMTIPOINCIDE){
            widget.getField('DSREFERENCIA').readOnly = true;
        }else{
            widget.getField('DSREFERENCIA').readOnly = false;
        }
    };
    
    this.desabilitaTpIncidencia = function(args){
        var widget = ABUtilController.checkWidget(args);
        var row = widget.currentRow;
        if(row.DSREFERENCIA){
            widget.getField('NMTIPOINCIDE').readOnly = true;
        }else{
            widget.getField('NMTIPOINCIDE').readOnly = false;
        }
    };

    this.remover = function(widget) {
        ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
            if (widget.isValid()) {
                widget.currentRow.__is_new = false;
                restEngine.post('product#/deleteVincEvento', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                    then(function (data) {
                        if (data.notifications[0].type === "success") {
                            ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                            ABUtilController.masterDetailVoltarList(widget);
                            widget.reload();
                        } else if (data.notifications[0].type === 'error') {
                            ScreenService.errorNotification(data.notifications[0].message, 10000);
                        } else {
                            ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                        }
                    }).
                    catch(function (e) {
                        var error;
                        if (e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;

                        ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    });
            }
        }, null);
    };

}

Configuration(function(ContextRegister) {
    ContextRegister.register('PensaoController', PensaoController);
});

// FILE: assets/js/controllers/PerfilAcessoController.js
function PerfilAcessoController(ScreenService, PerfilAcessoService) {

    var self = this;

    self.onRemoveProfile = function(widget) {
        widget.removeCheckedRows();
	};

    self.saveValidation = function(widget) {
		if(widget.isValid()) {
            widget.saveRow().then(
				function(callback){
                    var id = callback.dataset.perfilacesso[0].NRPERFILACESSO;
                    self.setVisibleWidgets(widget.widgets, true);
                    widget.currentRow.NRPERFILACESSO = id;
                    widget.currentRow.__is_new = false;
                    widget.currentRow.changed = false;
                    widget.view();
                    self.setChildFilters(widget);
				},
				function(callback){
					ScreenService.errorNotification(callback.data.error);
				}
			);
		}
		else{
			ScreenService.showMessage('O(s) campo(s) obrigatório(s) devem ser preenchidos.', "", "exclamation");
		}

	};

    self.onAddProfile = function(widget) {
        self.setVisibleWidgets(widget.widgets, false);
        widget.edit();
		widget.newRow();
		ScreenService.openSwipe(widget);
	};

    self.onEdit = function (widget) {
        if (!widget.isNewRow()) {
            widget.backupRow = angular.copy(widget.currentRow);
            widget.edit();
        }
    };

    self.onCancel = function (widget) {
        if (widget.isNewRow()) {
            widget.dataSource.data.pop();
            widget.list();
            ScreenService.closeSwipe();
            self.setVisibleWidgets(widget.widgets, true);
        }
        else {
            if (widget.inEditMode()) {
                Util.extend(widget.currentRow, widget.backupRow);
                widget.currentRow.__is_new = false;
                widget.currentRow.changed = false;
                widget.view();
            }
            else {
                widget.list();
                ScreenService.closeSwipe();
                widget.activate();
            }
        }
    };

    self.mainWidgetDeactivate = function (widget) {
        if (widget.inEditMode()) {
            Util.extend(widget.currentRow, widget.backupRow);
            widget.view();
        }
    };

    self.setChildFilters = function (widget) {
        var operadorWidget = widget.container.getWidget("OPERADOR");
        var elementsWidget = widget.container.getWidget("ELEMENTOS");
        operadorWidget.dataSourceFilter[0].value = getLocalVar('HCM_NRORG_TRAB');
        operadorWidget.dataSourceFilter[1].value = widget.currentRow.NRPERFILACESSO;
        elementsWidget.dataSourceFilter[0].value = widget.currentRow.NRPERFILACESSO;
        elementsWidget.dataSourceFilter[1].value = window.projectId;
        widget.activate();
    };

    self.setAddOperadorFilter = function (widget) {
        var addOperadorWidget = widget.container.getWidget("ADD_OPERADOR");
        var dados = widget.dataSource.data;
        var cdOperadores = [];
        addOperadorWidget.dataSourceFilter = [
            {
                "name": "NRORG",
                "operator": "=",
                "value": "@getLocalVar('NRORGTRAB')@"
            }
        ];
        if (dados.length !== 0) {
            dados.forEach(
                function (element) {
                    cdOperadores.push(element.CDOPERADOR);
                }
            );
            addOperadorWidget.dataSourceFilter.push(
                {
                    "name": "CDOPERADOR",
                    "operator": "NOT_IN",
                    "value": cdOperadores
                }
            );
        }
    };

    self.setVisibleWidgets = function (arrayWidgets, visibility) {
        arrayWidgets.forEach(
            function (element) {
                element.isVisible = visibility;
            }
        );
    };

    self.addPerfAcessParc = function (widget) {
        var parentWidget = widget.parent.parent;
        var operadores = widget.getCheckedRows();

        operadores.forEach(
            function (element) {
                parentWidget.newRow();
                parentWidget.currentRow.NRPERFILACESSO = widget.parent.parent.currentRow.NRPERFILACESSO;
                parentWidget.currentRow.NRPARCNEGOCIO = element.NRPARCNEGOCIO;
                parentWidget.currentRow.__is_new = true;
                parentWidget.currentRow.changed = true;
            }
        );
        parentWidget.saveRow().then(
            function () {
                parentWidget.reload();
                ScreenService.closePopup();
                parentWidget.list();
                parentWidget.activate();
            },
            function () {
                ScreenService.errorNotification("Falha ao relacionar os operadores selecionados a este perfil");
                parentWidget.reload();
                ScreenService.closePopup();
                parentWidget.list();
                parentWidget.activate();
            }
        );
    };

    self.setRule = function (widget, action) {
        var widgetCurrentRow = widget.currentRow;
        var actualRule = widgetCurrentRow.RULE;
        var actionName = action.name;

        if (actionName == 'VIEW') {
            if (actualRule == 'I') {
                widgetCurrentRow.RULE = 'R';
            }
            else {
                widgetCurrentRow.RULE = 'I';
            }
        }
        else if (actionName == 'EDIT') {
            if (actualRule == 'A') {
                widgetCurrentRow.RULE = 'R';
            }
            else {
                widgetCurrentRow.RULE = 'A';
            }
        }

        if (widgetCurrentRow.GROUP_ID === undefined || widgetCurrentRow.GROUP_ID === null) {
            widget.currentRow.GROUP_ID =  widget.parent.parent.currentRow.NRPERFILACESSO;
        }

        widget.saveRow().then(
            function (callback) {
                widgetCurrentRow.changed = false;
                if (!widgetCurrentRow.ID) {
                    widgetCurrentRow.ID = callback.dataset.zhu_access_control_element_rules[0].ID;
                }
                if (!callback.dataset.zhu_access_control_element_rules[0].ID) {
                    widget.reload();
                }
            }
        );
    };

    self.syncElements = function (widget) {
        PerfilAcessoService.sync( widget.parent.parent.currentRow).then(
            function () {
                widget.reload();
            }
        );
    };

    self.findPerfilAcessoById = function (widget, id) {
        var data = widget.dataSource.data;
        var perfilAcessoToReturn;
        data.forEach(
            function (element) {
                if (element.NRPERFILACESSO == id) {
                    perfilAcessoToReturn = element;
                }
            }
        );
        return perfilAcessoToReturn;
    };
}

Configuration(function(ContextRegister) {
	ContextRegister.register('PerfilAcessoController', PerfilAcessoController);
});

// FILE: assets/js/controllers/PerfilCursoController.js
function PerfilCursoController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, General, Messages) {

    var self = this;

    this.adicionarRow = function(args) {
        var widget = args.owner.widget;
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
        this.widgetsvisiblefalse(args);
    };

    this.widgetsvisibletrue = function(args) {
        var widget = args.owner.widget;
        widget.widgets.forEach(function(tab) {
            tab.showAsTab = true;
        });
        widget.reload();
    };

    this.widgetsvisiblefalse = function(args) {
        var widget = args.owner.widget;
        widget.widgets.forEach(function(tab) {
            tab.showAsTab = false;
        });
        widget.reload();
    };

    this.perfilCursoAfterMoveRow = function(args) {
        var widget = args.owner;
        widget.widgets.forEach(function(tab) {
            tab.dataSourceFilter[0].value = templateManager.container.getWidget('perfilCurso').currentRow.NRPERFILCURSO;
        });
    };



    this.setPerfilCurso = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
            if (!widget.backupRow) {
                widget.currentRow.__is_new = true;
            }
            else {
                widget.currentRow.__is_new = false;
            }
            restEngine.post('product#/setPerfilCurso', {
                'requestType': 'DataSet',
                'dataset': [widget.currentRow]
            }).
            then(function(data) {
                if (data.notifications[0].type === "success") {
                    ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                    if (widget.currentRow.__is_new) {
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.widgets.forEach(function(tab) {
                            tab.showAsTab = true;
                        });
                        widget.reload();
                    }
                    else {
                        ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                        widget.backupRow = null;
                        widget.view();
                        widget.widgets.forEach(function(tab) {
                            tab.showAsTab = true;
                        });
                        widget.reload();
                    }


                }
                else {
                    ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                }
            }).
            catch(function(e) {
                var error;
                if (e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });


        }
    };

    this.deletePerfilCurso = function(args) {
    ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
        var widget = templateManager.container.getActiveWidget();
        if (widget.isValid()) {
            widget.currentRow.__is_new = false;
            restEngine.post('product#/deletePerfilCurso', {
                'requestType': 'DataSet',
                'dataset': [widget.currentRow]
            }).
            then(function(data) {
                if (data.messages) {
                    ScreenService.showMessage(data.messages[0].message, data.messages[0].type);
                }
                else {
                    ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                    ABUtilController.masterDetailVoltarList(widget);
                    widget.reload();
                }
            }).
            catch(function(e) {
                var error;
                if (e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;

                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
        }
            templateManager.container.getWidget('perfilCurso').reload();
        }, null);
    };

    this.setItemPerfilCurso = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
            if (!widget.backupRow) {
                widget.currentRow.__is_new = true;
            }
            else {
                widget.currentRow.__is_new = false;
            }
            widget.currentRow.NRPERFILCURSO = templateManager.container.getWidget('perfilCurso').currentRow.NRPERFILCURSO;
            restEngine.post('product#/setItemPerfilCurso', {
                'requestType': 'DataSet',
                'dataset': [widget.currentRow]
            }).
            then(function(data) {
                if (data.notifications[0].type === "success") {
                    ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                    if (widget.currentRow.__is_new) {
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    }
                    else {
                        ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                        widget.backupRow = null;
                        widget.view();
                    }
                }
                else {
                    ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                }
            }).
            catch(function(e) {
                var error;
                if (e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });


        }
    };

    this.deleteItemPerfilCurso = function(args) {
        var widget = templateManager.container.getActiveWidget();
        if (widget.isValid()) {
            widget.currentRow.__is_new = false;
            restEngine.post('product#/deleteItemPerfilCurso', {
                'requestType': 'DataSet',
                'dataset': [widget.currentRow]
            }).
            then(function(data) {
                if (data.messages) {
                    ScreenService.showMessage(Messages.REMOVE_ROW_ERROR + '. ' + data.messages[0].message, data.messages[0].type);
                }
                else {
                    ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                    ABUtilController.masterDetailVoltarList(widget);
                    widget.reload();
                }
            }).
            catch(function(e) {
                var error;
                if (e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;

                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
        }
        templateManager.container.getWidget('perfilCurso').reload();
    };

}

Configuration(function(ContextRegister) {
    ContextRegister.register('PerfilCursoController', PerfilCursoController);
});


// FILE: assets/js/controllers/PerfilCursoEstrutController.js
function PerfilCursoEstrutController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, General, Messages) {

    var self = this;

    this.adicionarRow = function(args) {
        var widget = args.owner.widget;
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
        widget.reload();
    };

    this.setPerfilCursoEstrut = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
            if (ABUtilController.validaDtIniMenorIgualDtFin(widget.currentRow.DTINIVIGENCIA, widget.currentRow.DTFIMVIGENCIA)) {
                if (!widget.backupRow) {
                    widget.currentRow.__is_new = true;
                }
                else {
                    widget.currentRow.__is_new = false;
                }
                restEngine.post('product#/setPerfilCursoEstrut', {
                    'requestType': 'DataSet',
                    'dataset': [widget.currentRow]
                }).
                then(function(data) {
                    if (data.notifications[0].type === "success") {
                        ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                        templateManager.container.getWidget('perfilCursoEstrut').reload();
                        if (widget.currentRow.__is_new) {
                            ABUtilController.masterDetailVoltarList(widget);
                            self.widgetsvisibletrue(args);
                        }
                        else {
                            ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                            widget.backupRow = null;
                            widget.view();
                        }
                    }
                    else {
                        ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                    }
                }).
                catch(function(e) {
                    var error;
                    if (e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
            }
            else {
                ScreenService.showMessage(Messages.DTINI_POST_DTFIM_ERROR);
                return false;
            }
        }
    };

    this.deletePerfilCursoEstrut = function(args) {
    ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
        var widget = templateManager.container.getActiveWidget();
        if (widget.isValid()) {
            widget.currentRow.__is_new = false;
            restEngine.post('product#/deletePerfilCursoEstrut', {
                'requestType': 'DataSet',
                'dataset': [widget.currentRow]
            }).
            then(function(data) {
                if (data.messages) {
                    ScreenService.showMessage(Messages.REMOVE_ROW_ERROR + '. ' + data.messages[0].message, data.messages[0].type);
                }
                else {
                    ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                    ABUtilController.masterDetailVoltarList(widget);
                    templateManager.container.getWidget('perfilCursoEstrut').reload();
                }
            }).
            catch(function(e) {
                var error;
                if (e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;

                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
            }
        }, null);
    };


}

Configuration(function(ContextRegister) {
    ContextRegister.register('PerfilCursoEstrutController', PerfilCursoEstrutController);
});


// FILE: assets/js/controllers/PerfilCursoOcupaController.js
function PerfilCursoOcupaController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, General, Messages) {

    var self = this;

    this.adicionarRow = function(args) {
        var widget = args.owner.widget;
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
    };

    this.setPerfilCursoOcupa = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
            if (ABUtilController.validaDtIniMenorIgualDtFin(widget.currentRow.DTINIVIGENCIA, widget.currentRow.DTFIMVIGENCIA)) {
                if (!widget.backupRow) {
                    widget.currentRow.__is_new = true;
                }
                else {
                    widget.currentRow.__is_new = false;
                }
                restEngine.post('product#/setPerfilCursoOcupa', {
                    'requestType': 'DataSet',
                    'dataset': [widget.currentRow]
                }).
                then(function(data) {
                    if (data.notifications[0].type === "success") {
                        ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                        templateManager.container.getWidget('perfilCursoOcupa').reload();
                        if (widget.currentRow.__is_new) {
                            ABUtilController.masterDetailVoltarList(widget);
                            self.widgetsvisibletrue(args);
                        }
                        else {
                            ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                            widget.backupRow = null;
                            widget.view();
                        }
                    }
                    else {
                        ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                    }
                }).
                catch(function(e) {
                    var error;
                    if (e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
            }
            else {
                ScreenService.showMessage(Messages.DTINI_POST_DTFIM_ERROR);
                return false;
            }
        }
    };

    this.deletePerfilCursoOcupa = function(args) {
    ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
        var widget = templateManager.container.getActiveWidget();
        if (widget.isValid()) {
            widget.currentRow.__is_new = false;
            restEngine.post('product#/deletePerfilCursoOcupa', {
                'requestType': 'DataSet',
                'dataset': [widget.currentRow]
            }).
            then(function(data) {
                if (data.messages) {
                    ScreenService.showMessage(Messages.REMOVE_ROW_ERROR + '. ' + data.messages[0].message, data.messages[0].type);
                }
                else {
                    ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                    ABUtilController.masterDetailVoltarList(widget);
                    templateManager.container.getWidget('perfilCursoOcupa').reload();
                }
            }).
            catch(function(e) {
                var error;
                if (e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;

                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
            }
        }, null);
    };


}

Configuration(function(ContextRegister) {
    ContextRegister.register('PerfilCursoOcupaController', PerfilCursoOcupaController);
});


// FILE: assets/js/controllers/PerfilCursoVincController.js
function PerfilCursoVincController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, General, Messages) {

    var self = this;

    this.adicionarRow = function(args) {
        var widget = args.owner.widget;
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
        widget.reload();
    };

    this.setPerfilCursoVinc = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
            if (ABUtilController.validaDtIniMenorIgualDtFin(widget.currentRow.DTINIVIGENCIA, widget.currentRow.DTFIMVIGENCIA)) {
                if (!widget.backupRow) {
                    widget.currentRow.__is_new = true;
                }
                else {
                    widget.currentRow.__is_new = false;
                }
                restEngine.post('product#/setPerfilCursoVinc', {
                    'requestType': 'DataSet',
                    'dataset': [widget.currentRow]
                }).
                then(function(data) {
                    if (data.notifications[0].type === "success") {
                        ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                        templateManager.container.getWidget('perfilCursoVinc').reload();
                        if (widget.currentRow.__is_new) {
                            ABUtilController.masterDetailVoltarList(widget);
                            self.widgetsvisibletrue(args);
                        }
                        else {
                            ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                            widget.backupRow = null;
                            widget.view();
                        }
                    }
                    else {
                        ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                    }
                }).
                catch(function(e) {
                    var error;
                    if (e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
            }
            else {
                ScreenService.showMessage(Messages.DTINI_POST_DTFIM_ERROR);
                return false;
            }
        }
    };

    this.deletePerfilCursoVinc = function(args) {
    ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
        var widget = templateManager.container.getActiveWidget();
        if (widget.isValid()) {
            widget.currentRow.__is_new = false;
            restEngine.post('product#/deletePerfilCursoVinc', {
                'requestType': 'DataSet',
                'dataset': [widget.currentRow]
            }).
            then(function(data) {
                if (data.messages) {
                    ScreenService.showMessage(Messages.REMOVE_ROW_ERROR + '. ' + data.messages[0].message, data.messages[0].type);
                }
                else {
                    ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                    ABUtilController.masterDetailVoltarList(widget);
                    templateManager.container.getWidget('perfilCursoVinc').reload();
                }
            }).
            catch(function(e) {
                var error;
                if (e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;

                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
            }
        }, null);
    };


}

Configuration(function(ContextRegister) {
    ContextRegister.register('PerfilCursoVincController', PerfilCursoVincController);
});


// FILE: assets/js/controllers/PerfilEpiController.js
function PerfilEpiController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, General, Messages) {
    
    this.adicionarRow = function(args) {
        var widget = args.owner.widget;
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
    };

    this.validaPeriodo = function(dtIni, dtFin) {
        if (moment(dtIni, 'DD/MM/YYYY').unix() > moment(dtFin, 'DD/MM/YYYY').unix() || moment(dtFin, 'DD/MM/YYYY').unix() < moment(dtIni, 'DD/MM/YYYY').unix()) {
            return false;
        } else {
            return true;
        }
    };

    this.filtrarWidgetPorPerfilEpi = function(args) {
        var widget = args.owner;
        templateManager.container.getWidget("itens").dataSourceFilter[2].value = widget.currentRow.NRPERFILEPI;
    };

    this.widgetsvisiblefalse = function(args) {
        var widget = args.owner.widget;
        widget.widgets[0].showAsTab = false;

    };

    this.widgetsvisibletrue = function(args) {
        var widget = args.owner.widget;
        widget.widgets[0].showAsTab = true;
    };

    this.setPerfilEpi = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
            if (this.validaPeriodo(widget.currentRow.DTINIVIGENCIA, widget.currentRow.DTFIMVIGENCIA)) {
                if (!widget.backupRow) {
                    widget.currentRow.__is_new = true;
                } else {
                    widget.currentRow.__is_new = false;
                }
                restEngine.post('product#/setPerfilEpi', {
                    'requestType': 'DataSet',
                    'dataset': [widget.currentRow]
                }).
                then(function(data) {
                    if (data.notifications[0].type === "success") {
                        ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                        if (widget.currentRow.__is_new) {
                            ABUtilController.masterDetailVoltarList(widget);
                            widget.reload();
                        } else {
                            ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                            widget.backupRow = null;
                            widget.view();
                        }
                    } else {
                        ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                    }
                }).
                catch(function(e) {
                    var error;
                    if (e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
            } else {
                ScreenService.showMessage(Messages.DTINI_POST_DTFIM_ERROR);
                return false;
            }
        }
    };

    this.deletePerfilEpi = function(args) {
        ScreenService.confirmMessage(Messages.DELETE_ROW, 'CONFIRMATION',
            function() {
                var widget = templateManager.container.getActiveWidget();
                if (widget.isValid()) {
                    widget.currentRow.__is_new = false;
                    restEngine.post('product#/deletePerfilEpi', {
                        'requestType': 'DataSet',
                        'dataset': [widget.currentRow]
                    }).
                    then(function(data) {
                        if (data.messages) {
                            ScreenService.showMessage(Messages.REMOVE_ROW_ERROR + '. ' + data.messages[0].message, data.messages[0].type);
                        } else {
                            ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                            ABUtilController.masterDetailVoltarList(widget);
                            widget.reload();
                        }
                    }).
                    catch(function(e) {
                        var error;
                        if (e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;

                        ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    });
                }
            });
    };

    this.setItemPerfil = function(args) {
        var widget = args.owner.widget;
        var widgetMain = templateManager.container.getWidget("perfil");
        if (widget.isValid()) {
            if (this.validaPeriodo(widget.currentRow.DTINIVIGENCIA, widget.currentRow.DTFIMVIGENCIA)) {
                if (!widget.backupRow) {
                    widget.currentRow.__is_new = true;
                } else {
                    widget.currentRow.__is_new = false;
                }
                widget.currentRow.NRPERFILEPI = widgetMain.currentRow.NRPERFILEPI;
                restEngine.post('product#/setItemPerfil', {
                    'requestType': 'DataSet',
                    'dataset': [widget.currentRow]
                }).
                then(function(data) {
                    if (data.notifications[0].type === "success") {
                        ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                        if (widget.currentRow.__is_new) {
                            ABUtilController.masterDetailVoltarList(widget);
                            widget.reload();
                        } else {
                            ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                            widget.backupRow = null;
                            widget.view();
                        }
                    } else {
                        ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                    }
                }).
                catch(function(e) {
                    var error;
                    if (e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
            } else {
                ScreenService.showMessage(Messages.DTINI_POST_DTFIM_ERROR);
                return false;
            }
        }
    };

    this.deleteItemPerfil = function(args) {
        var widget = args.owner.widget;
        widget.currentRow.__is_new = false;
        ScreenService.confirmMessage(Messages.DELETE_ROW, 'CONFIRMATION', function(){
            restEngine.post('product#/deleteItemPerfil', {
                'requestType': 'DataSet',
                'dataset': [widget.currentRow]
            }).
            then(function(data) {
                if (data.notifications[0].type === "success") {
                    ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                    ABUtilController.masterDetailVoltarList(widget);
                    widget.reload();
                } else {
                    ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                }
            }).
            catch(function(e) {
                var error;
                if (e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
        }.bind(this));
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('PerfilEpiController', PerfilEpiController);
});


// FILE: assets/js/controllers/PerfilEpiEstruturaController.js
function PerfilEpiEstruturaController(ScreenService, templateManager, restEngine, ABUtilController, Messages) {

    this.validaPeriodo = function(dtIni, dtFin) {
        if (moment(dtIni, 'DD/MM/YYYY').unix() > moment(dtFin, 'DD/MM/YYYY').unix() || moment(dtFin, 'DD/MM/YYYY').unix() < moment(dtIni, 'DD/MM/YYYY').unix()) {
            return false;
        }
        else {
            return true;
        }
    };

	this.salvar = function(args) {
        var widget = templateManager.container.getActiveWidget();
        if (widget.isValid()) {
            if (this.validaPeriodo(widget.currentRow.DTINIVIGENCIA, widget.currentRow.DTFIMVIGENCIA)) {
                if (!widget.backupRow) {
                    widget.currentRow.__is_new = true;
                } else {
                    widget.currentRow.__is_new = false;
                }
                restEngine.post('product#/setPerfilepiestrutura', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                    then(function (data) {
                        if (data.notifications[0].type === "success") {
                            ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                            if (widget.currentRow.__is_new) {
                                ABUtilController.masterDetailVoltarList(widget);
                                widget.reload();
                            } else {
                                ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                                widget.backupRow = null;
                                widget.view();
                            }
                        } else {
                            ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                        }
                    }).
                    catch(function(e) {
                        var error;
                        if(e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;
    
                        ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    });
            }
            else {
                ScreenService.showMessage('A data final deve ser posterior à data inicial.');
                return false;
            }
        }
    };

    this.remover = function(args) {
    ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
        var widget = templateManager.container.getActiveWidget();
        if (widget.isValid()) {
            widget.currentRow.__is_new = false;
            restEngine.post('product#/deletePerfilepiestrutura', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                then(function (data) {
                    if (data.notifications[0].type === "success") {
                        ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    } else {
                        ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                    }
                }).
                catch(function(e) {
                    var error;
                    if(e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;

                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
            }
        },null);
    };

}

Configuration(function(ContextRegister) {
    ContextRegister.register('PerfilEpiEstruturaController', PerfilEpiEstruturaController);
});

// FILE: assets/js/controllers/PerfilEpiOcupacaoController.js
function PerfilEpiOcupacaoController(ScreenService, templateManager, restEngine, ABUtilController, Messages) {

    this.validaPeriodo = function(dtIni, dtFin) {
        if (moment(dtIni, 'DD/MM/YYYY').unix() > moment(dtFin, 'DD/MM/YYYY').unix() || moment(dtFin, 'DD/MM/YYYY').unix() < moment(dtIni, 'DD/MM/YYYY').unix()) {
            return false;
        }
        else {
            return true;
        }
    };

	this.salvar = function(args) {
        var widget = templateManager.container.getActiveWidget();
        if (widget.isValid()) {
            if (this.validaPeriodo(widget.currentRow.DTINIVIGENCIA, widget.currentRow.DTFIMVIGENCIA)) {
                if (!widget.backupRow) {
                    widget.currentRow.__is_new = true;
                } else {
                    widget.currentRow.__is_new = false;
                }
                restEngine.post('product#/setPerfilepiocupacao', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                    then(function (data) {
                        if (data.notifications[0].type === "success") {
                            ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                            if (widget.currentRow.__is_new) {
                                ABUtilController.masterDetailVoltarList(widget);
                                widget.reload();
                            } else {
                                ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                                widget.backupRow = null;
                                widget.view();
                            }
                        } else {
                            ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                        }
                    }).
                    catch(function(e) {
                        var error;
                        if(e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;
    
                        ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    });
            }
            else {
                ScreenService.showMessage('A data final deve ser posterior à data inicial.');
                return false;
            }
        }
    };

    this.remover = function(args) {
    ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
        var widget = templateManager.container.getActiveWidget();
        if (widget.isValid()) {
            widget.currentRow.__is_new = false;
            restEngine.post('product#/deletePerfilepiocupacao', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                then(function (data) {
                    if (data.notifications[0].type === "success") {
                        ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    } else {
                        ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                    }
                }).
                catch(function(e) {
                    var error;
                    if(e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;

                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
            }
        },null);
    };

}

Configuration(function(ContextRegister) {
    ContextRegister.register('PerfilEpiOcupacaoController', PerfilEpiOcupacaoController);
});

// FILE: assets/js/controllers/PerfilEpiVinculoController.js
function PerfilEpiVinculoController(ScreenService, templateManager, restEngine, ABUtilController, Messages) {

    this.validaPeriodo = function(dtIni, dtFin) {
        if (moment(dtIni, 'DD/MM/YYYY').unix() > moment(dtFin, 'DD/MM/YYYY').unix() || moment(dtFin, 'DD/MM/YYYY').unix() < moment(dtIni, 'DD/MM/YYYY').unix()) {
            return false;
        }
        else {
            return true;
        }
    };

	this.salvar = function(args) {
        var widget = templateManager.container.getActiveWidget();
        if (widget.isValid()) {
            if (this.validaPeriodo(widget.currentRow.DTINIVIGENCIA, widget.currentRow.DTFIMVIGENCIA)) {
                if (!widget.backupRow) {
                    widget.currentRow.__is_new = true;
                } else {
                    widget.currentRow.__is_new = false;
                }
                restEngine.post('product#/setPerfilepivinculo', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                    then(function (data) {
                        if (data.notifications[0].type === "success") {
                            ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                            if (widget.currentRow.__is_new) {
                                ABUtilController.masterDetailVoltarList(widget);
                                widget.reload();
                            } else {
                                ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                                widget.backupRow = null;
                                widget.view();
                            }
                        } else {
                            ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                        }
                    }).
                    catch(function(e) {
                        var error;
                        if(e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;
    
                        ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    });
            }
            else {
                ScreenService.showMessage('A data final deve ser posterior à data inicial.');
                return false;
            }
        }
    };

    this.remover = function(args) {
    ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
        var widget = templateManager.container.getActiveWidget();
        if (widget.isValid()) {
            widget.currentRow.__is_new = false;
            restEngine.post('product#/deletePerfilepivinculo', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                then(function (data) {
                    if (data.notifications[0].type === "success") {
                        ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    } else {
                        ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                    }
                }).
                catch(function(e) {
                    var error;
                    if(e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;

                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
            }
        },null);
    };

}

Configuration(function(ContextRegister) {
    ContextRegister.register('PerfilEpiVinculoController', PerfilEpiVinculoController);
});

// FILE: assets/js/controllers/PerfilExameController.js
function PerfilExameController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, General,Messages) {

    var self = this;
    
    this.adicionarRow = function(args) {
        var widget = args.owner.widget;
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
    };
    
    this.validaPeriodo = function(dtIni, dtFin) {
        if (moment(dtIni, 'DD/MM/YYYY').unix() > moment(dtFin, 'DD/MM/YYYY').unix() || moment(dtFin, 'DD/MM/YYYY').unix() < moment(dtIni, 'DD/MM/YYYY').unix()) {
            return false;
        }
        else {
            return true;
        }
    };
    
    this.validaQuantidade = function(qtIni,qtFim){
        if(parseFloat(qtIni) > parseFloat(qtFim)){
            return false;
        }else{
            return true;
        }
    };
    
    this.filtrarWidgetPorPerfilExame = function(args){
        var widget = args.owner;
        templateManager.container.getWidget("itemperfilexame").dataSourceFilter[2].value = widget.currentRow.NRPERFILEXAME;
    };
    
    this.widgetsvisiblefalse = function(args) {
        var widget = args.owner.widget;
        widget.widgets[0].showAsTab = false;
    };

    this.widgetsvisibletrue = function(args) {
        var widget = args.owner.widget;
        widget.widgets[0].showAsTab = true;
    };
    
	this.setPerfilExame = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
            if (this.validaPeriodo(widget.currentRow.DTINIVIGENCIA, widget.currentRow.DTFIMVIGENCIA)) {
                if (!widget.backupRow) {
                    widget.currentRow.__is_new = true;
                } else {
                    widget.currentRow.__is_new = false;
                }
                restEngine.post('product#/setPerfilExame', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                    then(function (data) {
                        if (data.notifications[0].type === "success") {
                            ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                            if (widget.currentRow.__is_new) {
                                ABUtilController.masterDetailVoltarList(widget);
                                self.widgetsvisibletrue(args);
                                widget.reload();
                            } else {
                                ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                                widget.backupRow = null;
                                widget.view();
                            }
                        } else {
                            ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                        }
                    }).
                    catch(function(e) {
                        var error;
                        if(e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;
                            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    });
            }else{
                ScreenService.showMessage(Messages.DTINI_POST_DTFIM_ERROR);
                return false;
            }        
        }
    };
    
    this.deletePerfilExame = function(args) {
    ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
        var widget = templateManager.container.getActiveWidget();
        if (widget.isValid()) {
            widget.currentRow.__is_new = false;
            restEngine.post('product#/deletePerfilExame', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                then(function (data) {
                    if (data.messages) {
                        ScreenService.showMessage(Messages.REMOVE_ROW_ERROR + '. ' + data.messages[0].message, data.messages[0].type);
                    } else {
                        ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    }
                }).
                catch(function(e) {
                    var error;
                    if(e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;

                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
            }
        }, null);
    };
    
	this.setItemPerfilExame = function(args) {
        var widget = args.owner.widget;
        var widgetMain = templateManager.container.getWidget("perfilexame");
        if (widget.isValid()) {
            if (this.validaPeriodo(widget.currentRow.DTINIVIGENCIA, widget.currentRow.DTFIMVIGENCIA)) {
                if (this.validaQuantidade(widget.currentRow.QTINIFAIXAETARIA, widget.currentRow.QTFIMFAIXAETARIA)){
                    if (!widget.backupRow) {
                        widget.currentRow.__is_new = true;
                    } else {
                        widget.currentRow.__is_new = false;
                    }
                    widget.currentRow.NRPERFILEXAME = widgetMain.currentRow.NRPERFILEXAME;
                    restEngine.post('product#/setItemPerfilExame', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                        then(function (data) {
                            if (data.notifications[0].type === "success") {
                                ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                                if (widget.currentRow.__is_new) {
                                    ABUtilController.masterDetailVoltarList(widget);
                                    widget.reload();
                                } else {
                                    ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                                    widget.backupRow = null;
                                    widget.view();
                                }
                            } else {
                                ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                            }
                        }).
                        catch(function(e) {
                            var error;
                            if(e.data.error === undefined)
                                error = e;
                            else
                                error = e.data.error;
                                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                        });
                }else{
                    ScreenService.showMessage(Messages.QTINI_POST_QTFIM_ERROR);
                    return false;
                }    
            }else{
                ScreenService.showMessage(Messages.DTINI_POST_DTFIM_ERROR);
                return false;
            }         
        }
    };
    
    this.deleteItemPerfilExame = function(args) {
        ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
        
        var widget = args.owner.widget;
        widget.currentRow.__is_new = false;
        restEngine.post('product#/deleteItemPerfilExame', {'requestType':'DataSet','dataset':[widget.currentRow]}).
            then(function(data){
                if(data.notifications[0].type === "success"){
                    ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                    ABUtilController.masterDetailVoltarList(widget);
                    widget.reload();
                } else {
                    ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                }
            }).
            catch(function(e) {
                var error;
                if(e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
    
        
    
        }, null);
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('PerfilExameController', PerfilExameController);
});

// FILE: assets/js/controllers/PerfilExameEstruturaController.js
function PerfilExameEstruturaController(ScreenService, templateManager, restEngine, ABUtilController, Messages) {

    this.validaPeriodo = function(dtIni, dtFin) {
        if (moment(dtIni, 'DD/MM/YYYY').unix() > moment(dtFin, 'DD/MM/YYYY').unix() || moment(dtFin, 'DD/MM/YYYY').unix() < moment(dtIni, 'DD/MM/YYYY').unix()) {
            return false;
        }
        else {
            return true;
        }
    };

    this.adicionarRow = function(args) {
        var widget = args.owner.widget;
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
    };
    
	this.salvar = function(args) {
        var widget = templateManager.container.getActiveWidget();
        if (widget.isValid()) {
            if (this.validaPeriodo(widget.currentRow.DTINIVIGENCIA, widget.currentRow.DTFIMVIGENCIA)) {
                if (!widget.backupRow) {
                    widget.currentRow.__is_new = true;
                } else {
                    widget.currentRow.__is_new = false;
                }
                restEngine.post('product#/setPerfilExameEstrutura', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                    then(function (data) {
                        if (data.notifications[0].type === "success") {
                            ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                            if (widget.currentRow.__is_new) {
                                ABUtilController.masterDetailVoltarList(widget);
                                widget.reload();
                            } else {
                                ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                                widget.backupRow = null;
                                widget.view();
                            }
                        } else {
                            ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                        }
                    }).
                    catch(function(e) {
                        var error;
                        if(e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;
    
                        ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    });
            }
            else {
                ScreenService.showMessage(Messages.DTINI_POST_DTFIM_ERROR);
                return false;
            }
        }
    };

    this.remover = function(args) {
        var widget = templateManager.container.getActiveWidget();
        if (widget.isValid()) {
            widget.currentRow.__is_new = false;
            restEngine.post('product#/deletePerfilExameEstrutura', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                then(function (data) {
                    if (data.notifications[0].type === "success") {
                        ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    } else {
                        ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                    }
                }).
                catch(function(e) {
                    var error;
                    if(e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;

                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
        }
    };

}

Configuration(function(ContextRegister) {
    ContextRegister.register('PerfilExameEstruturaController', PerfilExameEstruturaController);
});

// FILE: assets/js/controllers/PerfilExameOcupacaoController.js
function PerfilExameOcupacaoController(ScreenService, templateManager, restEngine, ABUtilController, Messages) {

    this.validaPeriodo = function(dtIni, dtFin) {
        if (moment(dtIni, 'DD/MM/YYYY').unix() > moment(dtFin, 'DD/MM/YYYY').unix() || moment(dtFin, 'DD/MM/YYYY').unix() < moment(dtIni, 'DD/MM/YYYY').unix()) {
            return false;
        }
        else {
            return true;
        }
    };

    this.adicionarRow = function(args) {
        var widget = args.owner.widget;
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
    };
    
	this.salvar = function(args) {
        var widget = templateManager.container.getActiveWidget();
        if (widget.isValid()) {
            if (this.validaPeriodo(widget.currentRow.DTINIVIGENCIA, widget.currentRow.DTFIMVIGENCIA)) {
                if (!widget.backupRow) {
                    widget.currentRow.__is_new = true;
                } else {
                    widget.currentRow.__is_new = false;
                }
                restEngine.post('product#/setPerfilExameOcupacao', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                    then(function (data) {
                        if (data.notifications[0].type === "success") {
                            ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                            if (widget.currentRow.__is_new) {
                                ABUtilController.masterDetailVoltarList(widget);
                                widget.reload();
                            } else {
                                ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                                widget.backupRow = null;
                                widget.view();
                            }
                        } else {
                            ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                        }
                    }).
                    catch(function(e) {
                        var error;
                        if(e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;
    
                        ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    });
            }
            else {
                ScreenService.showMessage(Messages.DTINI_POST_DTFIM_ERROR);
                return false;
            }
        }
    };

    this.remover = function(args) {
        ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
            var widget = templateManager.container.getActiveWidget();
            if (widget.isValid()) {
                widget.currentRow.__is_new = false;
                restEngine.post('product#/deletePerfilExameOcupacao', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                    then(function (data) {
                        if (data.notifications[0].type === "success") {
                            ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                            ABUtilController.masterDetailVoltarList(widget);
                            widget.reload();
                        } else {
                            ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                        }
                    }).
                    catch(function(e) {
                        var error;
                        if(e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;
    
                        ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    });
            }
        }, null);
    };

}

Configuration(function(ContextRegister) {
    ContextRegister.register('PerfilExameOcupacaoController', PerfilExameOcupacaoController);
});

// FILE: assets/js/controllers/PerfilExameVinculoController.js
function PerfilExameVinculoController(ScreenService, templateManager, restEngine, ABUtilController, Messages) {

    this.validaPeriodo = function(dtIni, dtFin) {
        if (moment(dtIni, 'DD/MM/YYYY').unix() > moment(dtFin, 'DD/MM/YYYY').unix() || moment(dtFin, 'DD/MM/YYYY').unix() < moment(dtIni, 'DD/MM/YYYY').unix()) {
            return false;
        }
        else {
            return true;
        }
    };

    this.adicionarRow = function(args) {
        var widget = args.owner.widget;
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
    };
    
	this.salvar = function(args) {
        var widget = templateManager.container.getActiveWidget();
        if (widget.isValid()) {
            if (this.validaPeriodo(widget.currentRow.DTINIVIGENCIA, widget.currentRow.DTFIMVIGENCIA)) {
                if (!widget.backupRow) {
                    widget.currentRow.__is_new = true;
                } else {
                    widget.currentRow.__is_new = false;
                }
                restEngine.post('product#/setPerfilExameVinculo', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                    then(function (data) {
                        if (data.notifications[0].type === "success") {
                            ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                            if (widget.currentRow.__is_new) {
                                ABUtilController.masterDetailVoltarList(widget);
                                widget.reload();
                            } else {
                                ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                                widget.backupRow = null;
                                widget.view();
                            }
                        } else {
                            ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                        }
                    }).
                    catch(function(e) {
                        var error;
                        if(e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;
    
                        ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    });
            }
            else {
                ScreenService.showMessage(Messages.DTINI_POST_DTFIM_ERROR);
                return false;
            }
        }
    };

    this.remover = function(args) {
        var widget = templateManager.container.getActiveWidget();
        if (widget.isValid()) {
            widget.currentRow.__is_new = false;
            restEngine.post('product#/deletePerfilExameVinculo', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                then(function (data) {
                    if (data.notifications[0].type === "success") {
                        ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    } else {
                        ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                    }
                }).
                catch(function(e) {
                    var error;
                    if(e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;

                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
        }
    };

}

Configuration(function(ContextRegister) {
    ContextRegister.register('PerfilExameVinculoController', PerfilExameVinculoController);
});

// FILE: assets/js/controllers/PerfilpppController.js
function PerfilpppController(ScreenService, templateManager, restEngine, ABUtilController, Messages) {

	this.salvar = function(args) {
        var widget = templateManager.container.getActiveWidget();
        if (widget.isValid()) {
            if (!widget.backupRow) {
                widget.currentRow.__is_new = true;
            } else {
                widget.currentRow.__is_new = false;
            }
            restEngine.post('product#/setPerfilppp', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                then(function (data) {
                    if (data.notifications[0].type === "success") {
                        ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                        if (widget.currentRow.__is_new) {
                            ABUtilController.masterDetailVoltarList(widget);
                            widget.reload();
                        } else {
                            ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                            widget.backupRow = null;
                            widget.view();
                        }
                    } else {
                        ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                    }
                }).
                catch(function(e) {
                    var error;
                    if(e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;

                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
        }
    };

    this.remover = function(args) {
    ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
        var widget = templateManager.container.getActiveWidget();
        if (widget.isValid()) {
            widget.currentRow.__is_new = false;
            restEngine.post('product#/deletePerfilppp', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                then(function (data) {
                    if (data.notifications[0].type === "success") {
                        ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    } else {
                        ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                    }
                }).
                catch(function(e) {
                    var error;
                    if(e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;

                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
            }
        }, null);
    };

}

Configuration(function(ContextRegister) {
    ContextRegister.register('PerfilpppController', PerfilpppController);
});

// FILE: assets/js/controllers/PerfilpppEstruturaController.js
function PerfilpppEstruturaController(ScreenService, templateManager, restEngine, ABUtilController, Messages) {

    this.validaPeriodo = function(dtIni, dtFin) {
        if (moment(dtIni, 'DD/MM/YYYY').unix() > moment(dtFin, 'DD/MM/YYYY').unix() || moment(dtFin, 'DD/MM/YYYY').unix() < moment(dtIni, 'DD/MM/YYYY').unix()) {
            return false;
        }
        else {
            return true;
        }
    };

	this.salvar = function(args) {
        var widget = templateManager.container.getActiveWidget();
        if (widget.isValid()) {
            if (this.validaPeriodo(widget.currentRow.DTINIVIGENCIA, widget.currentRow.DTFIMVIGENCIA)) {
                if (!widget.backupRow) {
                    widget.currentRow.__is_new = true;
                } else {
                    widget.currentRow.__is_new = false;
                }
                restEngine.post('product#/setRelacestrutppp', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                    then(function (data) {
                        if (data.notifications[0].type === "success") {
                            ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                            if (widget.currentRow.__is_new) {
                                ABUtilController.masterDetailVoltarList(widget);
                                widget.reload();
                            } else {
                                ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                                widget.backupRow = null;
                                widget.view();
                            }
                        } else {
                            ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                        }
                    }).
                    catch(function(e) {
                        var error;
                        if(e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;
    
                        ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    });
            }
            else {
                ScreenService.showMessage('A data final deve ser posterior à data inicial.');
                return false;
            }
        }
    };

    this.remover = function(args) {
    ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
        var widget = templateManager.container.getActiveWidget();
        if (widget.isValid()) {
            widget.currentRow.__is_new = false;
            restEngine.post('product#/deleteRelacestrutppp', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                then(function (data) {
                    if (data.notifications[0].type === "success") {
                        ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    } else {
                        ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                    }
                }).
                catch(function(e) {
                    var error;
                    if(e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;

                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
            }
        }, null);
    };

}

Configuration(function(ContextRegister) {
    ContextRegister.register('PerfilpppEstruturaController', PerfilpppEstruturaController);
});

// FILE: assets/js/controllers/PerfilpppOcupacaoController.js
function PerfilpppOcupacaoController(ScreenService, templateManager, restEngine, ABUtilController, Messages) {

    this.validaPeriodo = function(dtIni, dtFin) {
        if (moment(dtIni, 'DD/MM/YYYY').unix() > moment(dtFin, 'DD/MM/YYYY').unix() || moment(dtFin, 'DD/MM/YYYY').unix() < moment(dtIni, 'DD/MM/YYYY').unix()) {
            return false;
        }
        else {
            return true;
        }
    };

	this.salvar = function(args) {
        var widget = templateManager.container.getActiveWidget();
        if (widget.isValid()) {
            if (this.validaPeriodo(widget.currentRow.DTINIVIGENCIA, widget.currentRow.DTFIMVIGENCIA)) {
                if (!widget.backupRow) {
                    widget.currentRow.__is_new = true;
                } else {
                    widget.currentRow.__is_new = false;
                }
                restEngine.post('product#/setRelacocupappp', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                    then(function (data) {
                        if (data.notifications[0].type === "success") {
                            ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                            if (widget.currentRow.__is_new) {
                                ABUtilController.masterDetailVoltarList(widget);
                                widget.reload();
                            } else {
                                ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                                widget.backupRow = null;
                                widget.view();
                            }
                        } else {
                            ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                        }
                    }).
                    catch(function(e) {
                        var error;
                        if(e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;
    
                        ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    });
            }
            else {
                ScreenService.showMessage('A data final deve ser posterior à data inicial.');
                return false;
            }
        }
    };

    this.remover = function(args) {
    ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
        var widget = templateManager.container.getActiveWidget();
        if (widget.isValid()) {
            widget.currentRow.__is_new = false;
            restEngine.post('product#/deleteRelacocupappp', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                then(function (data) {
                    if (data.notifications[0].type === "success") {
                        ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    } else {
                        ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                    }
                }).
                catch(function(e) {
                    var error;
                    if(e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;

                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
            }
        }, null);
    };

}

Configuration(function(ContextRegister) {
    ContextRegister.register('PerfilpppOcupacaoController', PerfilpppOcupacaoController);
});

// FILE: assets/js/controllers/PerfilpppVinculoController.js
function PerfilpppVinculoController(ScreenService, templateManager, restEngine, ABUtilController, Messages) {

    this.validaPeriodo = function(dtIni, dtFin) {
        if (moment(dtIni, 'DD/MM/YYYY').unix() > moment(dtFin, 'DD/MM/YYYY').unix() || moment(dtFin, 'DD/MM/YYYY').unix() < moment(dtIni, 'DD/MM/YYYY').unix()) {
            return false;
        }
        else {
            return true;
        }
    };

	this.salvar = function(args) {
        var widget = templateManager.container.getActiveWidget();
        if (widget.isValid()) {
            if (this.validaPeriodo(widget.currentRow.DTINIVIGENCIA, widget.currentRow.DTFIMVIGENCIA)) {
                if (!widget.backupRow) {
                    widget.currentRow.__is_new = true;
                } else {
                    widget.currentRow.__is_new = false;
                }
                restEngine.post('product#/setRelacvincppp', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                    then(function (data) {
                        if (data.notifications[0].type === "success") {
                            ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                            if (widget.currentRow.__is_new) {
                                ABUtilController.masterDetailVoltarList(widget);
                                widget.reload();
                            } else {
                                ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                                widget.backupRow = null;
                                widget.view();
                            }
                        } else {
                            ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                        }
                    }).
                    catch(function(e) {
                        var error;
                        if(e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;
    
                        ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    });
            }
            else {
                ScreenService.showMessage('A data final deve ser posterior à data inicial.');
                return false;
            }
        }
    };

    this.remover = function(args) {
    ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
        var widget = templateManager.container.getActiveWidget();
        if (widget.isValid()) {
            widget.currentRow.__is_new = false;
            restEngine.post('product#/deleteRelacvincppp', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                then(function (data) {
                    if (data.notifications[0].type === "success") {
                        ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    } else {
                        ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                    }
                }).
                catch(function(e) {
                    var error;
                    if(e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;

                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
          }
        }, null);
    };

}

Configuration(function(ContextRegister) {
    ContextRegister.register('PerfilpppVinculoController', PerfilpppVinculoController);
});

// FILE: assets/js/controllers/PeriodoApuracaoController.js
function PeriodoApuracaoController (ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, $window, ABUtilController, Messages) {
    
    this.nrTipoVinculom = null;
    this.nrTipoPeriodo = null;
    
    this.deletePeriodoApuracao = function(args) {
        var widget = args.owner.widget;
        var data = {}; 
        ScreenService.confirmMessage(Messages.DELETE_ROW, 'CONFIRMATION', 
            function(){
                widget.dataSource.remove(widget.currentRow).then(function (data){
                    if(data.dataset.ptoPeriodoApuracao_setPeriodo.type === "success"){
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();  
                        ScreenService.showMessage(Messages.REMOVE_ROW_SUCCESS); 
                    } else {
                        ScreenService.showMessage(Messages.REMOVE_ROW_ERROR); 
                    }
                });
            }.bind(this)
        );
    };

    this.deleteTipoPeriodoApuracao = function(args) {
        var widget = args.owner.widget;
        var data = {}; 
        ScreenService.confirmMessage(Messages.DELETE_ROW, 'CONFIRMATION', 
            function(){
                widget.dataSource.remove(widget.currentRow).then(function (data){
                    if(data.dataset.ptoTipoPeriodoApuracao_setTipoPeriodoApuracao.type === "success"){
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                        ScreenService.showMessage(Messages.REMOVE_ROW_SUCCESS); 
                    } else {
                        ScreenService.showMessage(Messages.REMOVE_ROW_ERROR); 
                    }
                });
            }.bind(this)
        );
    };

    this.salvarPeriodoApuracao = function(argsRow){
        var widget = templateManager.container.getWidget("periodoApuracao");
        var widgetTipoPeriodo = templateManager.container.getWidget("tipoPeriodoApuracao");
        if(widget.isValid())  {
            
            if (!widget.backupRow) {
                widget.currentRow.__is_new = true;
            } else {
                widget.currentRow.__is_new = false;
            }
            widget.currentRow.NRTIPOPERIODOAPURACAO = widgetTipoPeriodo.currentRow.NRTIPOPERIODOAPURACAO;
            widget.currentRow.CDOPERADOR_LOG = getLocalVar("HCM_CDOPERADOR");
            widget.currentRow.NRORGTRAB = getLocalVar("HCM_NRORG_TRAB");
            widget.currentRow.NRORGPADRAO = getLocalVar("HCM_NRORG_PADRAO");
            widget.currentRow.DTATUAL = getLocalVar("HCM_DATA_ATUAL");
            return widget.saveRow().then(function (data){
                if (data.notifications[0].type === "success") {
                    ScreenService.showMessage(Messages.SAVE_ROW_SUCCESS);
                    if (widget.currentRow.__is_new) {
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    } else {
                        ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                        widget.backupRow = null;
                        widget.view();
                    }
                } else {
                    ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                }
            }).catch(function(e) {
                var error;
                if(e.data.error === undefined)
                    error = e;
                else 
                    error = e.data.error;
                
                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error));
            });
        }
    };

    this.salvarTipoPeriodoApuracao = function(argsRow){
        var widget = templateManager.container.getWidget("tipoPeriodoApuracao");
        var widgetTipoVinculo = templateManager.container.getWidget("tipoVinculo");
        if(widget.isValid())  {
            
            if (!widget.backupRow) {
                widget.currentRow.__is_new = true;
            } else {
                widget.currentRow.__is_new = false;
            }
            widget.currentRow.NRTIPOVINCULOM = widgetTipoVinculo.currentRow.NRTIPOVINCULOM;
            widget.currentRow.CDOPERADOR_LOG = getLocalVar("HCM_CDOPERADOR");
            widget.currentRow.NRORGTRAB = getLocalVar("HCM_NRORG_TRAB");
            widget.currentRow.NRORGPADRAO = getLocalVar("HCM_NRORG_PADRAO");
            widget.currentRow.DTATUAL = getLocalVar("HCM_DATA_ATUAL");
            return widget.saveRow().then(function (data){
                if (data.notifications[0].type === "success") {
                    ScreenService.showMessage(Messages.SAVE_ROW_SUCCESS);
                    if (widget.currentRow.__is_new) {
                        ABUtilController.masterDetailVoltarList(widget);
                        ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                        widget.reload();
                    } else {
                        ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                        widget.backupRow = null;
                        widget.view();
                    }
                } else {
                    ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                }
            }).catch(function(e) {
                var error;
                if(e.data.error === undefined)
                    error = e;
                else 
                    error = e.data.error;
                
                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error));
            });
        }
    };

    this.setNrTipoVinculoM = function(args){
        var widget = ABUtilController.checkWidget(args);
        var widgetTipoPeriodoApuracao = templateManager.container.getWidget("tipoPeriodoApuracao");
        
        widgetTipoPeriodoApuracao.currentRow.NRTIPOVINCULOM = widget.currentRow.NRTIPOVINCULOM;
        this.nrTipoVinculom = widget.currentRow.NRTIPOVINCULOM; 
    };

    this.setNrTipoPerido = function(args){
        var widget = ABUtilController.checkWidget(args);
        var widgetPeriodoApuracao  = templateManager.container.getWidget("periodoApuracao");
        
        widgetPeriodoApuracao.currentRow.NRTIPOPERIODOAPURACAO = widget.currentRow.NRTIPOPERIODOAPURACAO;
        this.nrTipoPeriodo = widget.currentRow.NRTIPOPERIODOAPURACAO; 
    };

    this.setMinDate = function(args){
        var widget = ABUtilController.checkWidget(args);
        widget.getField('DTFINALAPURACAO').minDate = widget.currentRow.DTINICIALAPURACAO;
        widget.currentRow.DTFINALAPURACAO = null;
    };

}

Configuration(function(ContextRegister) {
    ContextRegister.register('PeriodoApuracaoController', PeriodoApuracaoController);
});

// FILE: assets/js/controllers/PessoaController.js
/* jshint esversion: 6 */
function PessoaController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, General, Messages, HcmConsts, ParceiroNegocioController, $window) {

    var self = this;
    var mensagem = '';
    this.rowToBeSetPessoa = {'EXISTE_VINCULOS': 'S'};
    
    this.openPopupImportacoes = function(widget, action) {
        this.NMIMPORTACAO = action;
        var widgetPopupImportacao = templateManager.container.getWidget('popupImportacao');
        widgetPopupImportacao.currentRow.DSPATH = [];
        ScreenService.openPopup(widgetPopupImportacao);
    };
    this.setNrPessoa = function() {
        var widgetPai =  templateManager.container.getWidget('Pessoa');
        var widgetFilho = templateManager.container.getWidget('RelacionamentoParc');
        widgetFilho.currentRow.NRPESSOA = widgetPai.currentRow.NRPESSOA;
    };
    this.geraPlanilhaTemplete = function() {
    restEngine.post('product#/baixarPlanilhaContaCorrente', {
        'requestType': 'DataSet',
        'dataset': []
        }).then(function(data) {
            ScreenService.closePopup();
            if(data.dataset && data.dataset.arquivo){
                $window.open($window.serviceUrl + "/abrirArquivo?requestType=DataSet&dataset[0][CMARQUIVO]=" + data.dataset.arquivo.NMARQUIVO);
            }
        }).catch(function(e) {
            var error;
            if (e.data.error === undefined)
                error = e;
            else
                error = e.data.error;
            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
        });
            
    };
    
    this.importarPlanilhaContaCorrente = function() {
        var widgetPop = templateManager.container.getActiveWidget();
        var widgetPai = templateManager.container.getWidget('Pessoa');
        if(widgetPop.isValid()){
            if(this.validaArquivo(widgetPop.currentRow.DSPATH[0].name)) {
                restEngine.post('product#/importarPlanilhaContaCorrente', {'requestType': 'DataSet', 'dataset': [widgetPop.currentRow]}).
                then(function(data) {
                    if (data.messages) {
                        ScreenService.closePopup(true);
                        ScreenService.showMessage(data.messages[0].message, data.messages[0].type);
                        if (data.dataset && data.dataset.msg) {
                            openPopupMensagens(data.dataset.msg);
                        } else {
                            widgetPai.activate();
                        }
                        widgetPai.reload();
                    } else
                        ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                }).
                catch(function(e) {   
                    var error;
                    if (e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    
                });
            }
        }
    };
    
    this.validaArquivo = function(filePath) {
        var extension = filePath.split('.').pop().toUpperCase();
        if (extension !== 'XLS' && extension !== 'XLSX') {
            ScreenService.showMessage('Formato de arquivo inválido');
            return false;
        } else {
            return true;
        }
    };
    
    var openPopupMensagens = function(msg) {
        var widgetMensagens = templateManager.container.getWidget('messagesImportacaoContaCorrente');
        widgetMensagens.dataSource.data = msg;
        ScreenService.openPopup(widgetMensagens);
    };
    
    this.popupImportacaoContaCorrenteVoltar = function() {
        ScreenService.closePopup();
        templateManager.container.getWidget('popupImportacao').activate();
    };
    
    this.adicionarRow = function(args) {
        var widget = args.owner.widget;
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
    };

    this.filtrarDependentePorParcNegocio = function(args) {
        var widget = args.owner;
        templateManager.container.getWidget("RelacionamentoParc").dataSourceFilter[0].value = widget.currentRow.NRPARCNEGOCIO;
        templateManager.container.getWidget("formacao").dataSourceFilter[0].value = widget.currentRow.NRPARCNEGOCIO;
    };

    this.widgetsvisiblefalse = function(args) {
        var widget = args.owner.widget;
        widget.widgets[0].showAsTab = false;
        widget.widgets[1].showAsTab = false;
        widget.widgets[2].showAsTab = false;
        widget.widgets[3].showAsTab = false;
        widget.widgets[4].showAsTab = false;
        widget.widgets[5].showAsTab = false;
    };

    this.widgetsvisibletrue = function(args) {
        var widget = args.owner.widget;
        widget.widgets[0].showAsTab = true;
        widget.widgets[1].showAsTab = true;
        widget.widgets[2].showAsTab = true;
        widget.widgets[3].showAsTab = true;
        widget.widgets[4].showAsTab = true;
        widget.widgets[5].showAsTab = true;
    };

    this.mudarTipoFormacao = function() {
        var widget = templateManager.container.getActiveWidget();

        widget.getField('NMINSTITUICAOPARC').isVisible = true;
        widget.getField('DSCURSO').isVisible = true;
        widget.getField('DTFIM').isVisible = true;
        widget.getField('NRCARGAHORARIA').isVisible = true;
        widget.getField('NMAREAFORMACAO').isVisible = true;
        widget.getField('DES_AREAFORMACAO_NRORG').isVisible = true;
        widget.getField('DSOBSERVACAO').isVisible = true;
        widget.getField('NMCURSO').readOnly = false;
        widget.getField('NMAREAFORMACAO').readOnly = false;

        if (widget.currentRow.NRTIPOFORMACAO == 1) { // academica

            widget.currentRow.CDIDIOM = '';
            widget.currentRow.IDNVIDIOMA = '';

            widget.getField('NMIDIOMA').isVisible = false;
            widget.getField('IDNVIDIOMA').isVisible = false;
            widget.getField('NMCURSO').readOnly = false;
            widget.getField('NMAREAFORMACAO').readOnly = false;
            if (widget.currentRow.NMCURSO == 'Linguagens') {
                widget.currentRow.NMCURSO = '';
                widget.currentRow.NRCURSO = null;
            }
            if (widget.currentRow.NMAREAFORMACAO == 'Idiomas') {
                widget.currentRow.NMAREAFORMACAO = '';
                widget.currentRow.NRAREAFORMACAO = null;
            }

        } else if (widget.currentRow.NRTIPOFORMACAO == 2) { // idioma

            widget.getField('NMIDIOMA').isVisible = true;
            widget.getField('IDNVIDIOMA').isVisible = true;
            widget.getField('NMCURSO').readOnly = true;
            widget.getField('NMAREAFORMACAO').readOnly = true;
            widget.getField('DES_AREAFORMACAO_NRORG').readOnly = true;
            widget.getField('DSCURSO').readOnly = true;
            widget.getField('DSCURSO').validations = {};
            widget.getField('DES_AREAFORMACAO_NRORG').validations = {};
            widget.currentRow.DSCURSO = '';
            widget.currentRow.NMCURSO = 'Linguagens';
            widget.currentRow.NRCURSO = 3;
            widget.currentRow.NMAREAFORMACAO = 'Idiomas';
            widget.currentRow.NRAREAFORMACAO = 3;
            widget.currentRow.DES_AREAFORMACAO_NRORG = '';

        } else if (widget.currentRow.NRTIPOFORMACAO == 3) { // extracurricular

            widget.getField('NMIDIOMA').isVisible = false;
            widget.getField('IDNVIDIOMA').isVisible = false;
            widget.getField('NMCURSO').readOnly = false;
            widget.getField('NMAREAFORMACAO').readOnly = false;
            if (widget.currentRow.NMCURSO == 'Linguagens') {
                widget.currentRow.NMCURSO = '';
                widget.currentRow.NRCURSO = null;
            }
            if (widget.currentRow.NMAREAFORMACAO == 'Idiomas') {
                widget.currentRow.NMAREAFORMACAO = '';
                widget.currentRow.NRAREAFORMACAO = null;
            }

        } else {
        widget.getField('NMCURSO').readOnly = false;
        widget.getField('NMAREAFORMACAO').readOnly = false;
            widget.getField('NMIDIOMA').isVisible = false;
            widget.getField('IDNVIDIOMA').isVisible = false;
            if (widget.currentRow.NMCURSO == 'Linguagens') {
                widget.currentRow.NMCURSO = '';
                widget.currentRow.NRCURSO = null;
            }
            if (widget.currentRow.NMAREAFORMACAO == 'Idiomas') {
                widget.currentRow.NMAREAFORMACAO = '';
                widget.currentRow.NRAREAFORMACAO = null;
            }
        }
    };

    this.setParcNegocioAndPessoa = function(args, ESocialController, verificaEnvioEsocialDescentralizado = false) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
            if (!widget.backupRow || Util.isEmptyOrBlank(widget.currentRow.NRVINCULOM)) {
                verificaEnvioEsocialDescentralizado = false;
            } 
            if(verificaEnvioEsocialDescentralizado){
                ESocialController.envioEsocialDescentralizado(widget.currentRow, 'S-2205', widget.currentRow.NRVINCULOM, widget.currentRow.NRVINCULOM, this.setParcNegocioAndPessoa, args);
            }else{
                if (ABUtilController.validaDtIniMenorIgualDtFin(widget.currentRow.DTINIVIGENCIA, widget.currentRow.DTFIMVIGENCIA)) {
                    var preparedWidget = ABUtilController.prepareSaveMasterHistory(widget);
                    if (widget.currentRow.DTNASCPESSOA && ABUtilController.validaDataIgualPosteriorDtAtual(widget.currentRow.DTNASCPESSOA)) {
                        ScreenService.showMessage(Messages.DT_NASC_ERROR);
                        return false;
                    }
                    if (ABUtilController.validaDataIgualPosteriorDtAtual(widget.currentRow.DTEXRGPESSOA) && widget.currentRow.DTEXRGPESSOA )  
                            return ScreenService.showMessage("A "+ widget.getField('DTEXRGPESSOA').label +" deve ser anterior à data atual");
                    if (ABUtilController.validaDataIgualPosteriorDtAtual(widget.currentRow.DTHABCARTPES) && widget.currentRow.DTHABCARTPES)
                            return ScreenService.showMessage("A "+ widget.getField('DTHABCARTPES').label +" deve ser anterior à data atual");
                    if (ABUtilController.validaDataIgualPosteriorDtAtual(widget.currentRow.DTCASAPESSOA) && widget.currentRow.DTCASAPESSOA)
                            return ScreenService.showMessage("A "+ widget.getField('DTCASAPESSOA').label +" deve ser anterior à data atual");
                    if (ABUtilController.validaDataIgualPosteriorDtAtual(widget.currentRow.DTCTPSPESSOA) && widget.currentRow.DTCTPSPESSOA)
                            return ScreenService.showMessage("A "+ widget.getField('DTCTPSPESSOA').label +" deve ser anterior à data atual");
                    if (ABUtilController.validaDataIgualPosteriorDtAtual(widget.currentRow.DTCHEGADAPAIS) && widget.currentRow.DTCHEGADAPAIS)
                            return ScreenService.showMessage("A "+ widget.getField('DTCHEGADAPAIS').label +" deve ser anterior à data atual");
                    if (ABUtilController.validaDataIgualPosteriorDtAtual(widget.currentRow.DTNATURALIZAPES) && widget.currentRow.DTNATURALIZAPES)
                            return ScreenService.showMessage("A "+ widget.getField('DTNATURALIZAPES').label +" deve ser anterior à data atual");
                    if (ABUtilController.validaDataIgualPosteriorDtAtual(widget.currentRow.DADOSCOMPLEMENTARES) && widget.currentRow.DADOSCOMPLEMENTARES)
                            return ScreenService.showMessage("A "+ widget.getField('DADOSCOMPLEMENTARES').label +" deve ser anterior à data atual");
                    if (ABUtilController.validaDataIgualPosteriorDtAtual(widget.currentRow.DTCERTRESEPES) && widget.currentRow.DTCERTRESEPES)
                            return ScreenService.showMessage("A "+ widget.getField('DTCERTRESEPES').label +" deve ser anterior à data atual");
                    
                    if (widget.currentRow.NRCPFPESSOA) {
                        if (!ABUtilController.validaCPF(preparedWidget.currentRow.NRCPFPESSOA)) {
                            ScreenService.showMessage(Messages.CPF_ERROR);
                            return false;
                        }
                    }
                    if (widget.currentRow.NRPISPASEPPES) {
                        if (!ABUtilController.validaPIS(preparedWidget.currentRow.NRPISPASEPPES)) {
                            ScreenService.showMessage(Messages.PIS_PASEP_ERROR);
                            return false;
                        }
                    }
                    if (preparedWidget.currentRow.DSNACIONALIDADE === 'Brasileira') {
                        preparedWidget.currentRow.NRNACIONALID = 1;
                    }
                     if (preparedWidget.currentRow.NMRACAPESSOA === 'Não informado') {
                        preparedWidget.currentRow.NRRACAPESSOA = 6;
                    }
                    if (preparedWidget.currentRow.DSPATH) {
                        delete preparedWidget.currentRow.DSPATH;
                    }
                    if(preparedWidget.currentRow.DTCHEGADAPAIS){
                        preparedWidget.currentRow.NRANOCHEGAPAIS = preparedWidget.currentRow.DTCHEGADAPAIS.substr(6,4);
                    }
                    if (preparedWidget.currentRow.DTCHEGADAPAIS === "") {
                        preparedWidget.currentRow.NRANOCHEGAPAIS = "";
                    }
                    preparedWidget.currentRow.CDTIPOINSCRICAO = 'CPF';
                    preparedWidget.currentRow.CDTIPOPARCPRINCIPAL = 'PESSOA';
                    preparedWidget.currentRow.DTNASCIFUNDPARC = preparedWidget.currentRow.DTNASCPESSOA;
                    preparedWidget.currentRow.NRINSCRICAOPARC = preparedWidget.currentRow.NRCPFPESSOA;
                    preparedWidget.currentRow.IDPESSOAFISICA = 'S';
                    preparedWidget.currentRow.IDATIVO = 'S';
                    preparedWidget.currentRow.IDINSTITUICAO = 'N';
                    preparedWidget.currentRow.IDPARCFUNDIDO = 'N';
                    preparedWidget.currentRow.NMPRINCIPALPARC = preparedWidget.currentRow.NMPESSOA;
                    preparedWidget.currentRow.NMSECUNDARIPARC = preparedWidget.currentRow.NMPESSOA;
                    restEngine.post('product#/setPessoa', {
                        'requestType': 'DataSet',
                        'dataset': [preparedWidget.currentRow]
                    }).
                    then(function(data) {
                        if(data.dataset && data.dataset.retornoEsocial && data.dataset.retornoEsocial.length > 0){
                            var mensagem = 'S-2205: ';
                            data.dataset.retornoEsocial.forEach(function(retorno){
                                mensagem += retorno.MSG + '<br>';
                            });
                            ScreenService.showMessage(mensagem);
                        }
                        if (data.messages) {
                            ScreenService.showMessage(data.messages[0].message, data.messages[0].type);
                        }
                        if(data.notifications){
                            data.notifications.forEach(function(notification){
                                if(notification.type === 'alert'){
                                    ScreenService.alertNotification(notification.message, 10000);
                                }
                            });
                        }
                        if (data.dataset && data.dataset.columnsToReturn) {
                            ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                            self.widgetsvisibletrue(args);
                            if (preparedWidget.currentRow.__is_new) {
                                ABUtilController.masterDetailVoltarList(preparedWidget);
                                ABUtilController.mudarVisibilidadeWidgets(preparedWidget.widgets, true);
                                preparedWidget.reload();
                            } else {
                                ABUtilController.mudarVisibilidadeWidgets(preparedWidget.widgets, true);
                                var tableHistoryPk = preparedWidget.saveHistoryTable.__table_history_pk.toUpperCase();
                                if (preparedWidget.currentRow[tableHistoryPk]) {
                                    for (var i = 0; i < data.dataset.columnsToReturn.length; i++) {
                                        if (!Util.isUndefined(data.dataset.columnsToReturn[i][tableHistoryPk])) {
                                            preparedWidget.currentRow[tableHistoryPk] = data.dataset.columnsToReturn[i][tableHistoryPk];
                                        }
                                    }
                                }
                                preparedWidget.backupRow = null;
                                preparedWidget.view();
                            }
        
                        } else {
                            if(data.messages){
                                var mensagemFinal = '';
                                data.messages.forEach(function(mensagem){
                                    mensagemFinal += mensagemFinal ? '<br />' + mensagem.message : mensagem.message;
                                });
                                ScreenService.showMessage(mensagemFinal);
                            } else {
                                ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                            }
                        }
                    }).
                    catch(function(e) {
                        
                        // Tratativa quando o processo de envio descentralizado para o eSocial falha, mas a pessoa é salva com sucesso
                        
                        let mensagem = false;
                        if (e.data.messages) {
                            mensagem = e.data.messages[0].message;
                        }
                        
                        if(e.data.notifications){
                            e.data.notifications.forEach(function(notification){
                                if(notification.type === 'alert'){
                                    ScreenService.alertNotification(notification.message, 10000);
                                }
                            });
                        }
                        
                        if (e.data.dataset && e.data.dataset.columnsToReturn) {
                            self.widgetsvisibletrue(args);
                            if (preparedWidget.currentRow.__is_new) {
                                ABUtilController.masterDetailVoltarList(preparedWidget);
                                ABUtilController.mudarVisibilidadeWidgets(preparedWidget.widgets, true);
                                preparedWidget.reload();
                            } else {
                                ABUtilController.mudarVisibilidadeWidgets(preparedWidget.widgets, true);
                                var tableHistoryPk = preparedWidget.saveHistoryTable.__table_history_pk.toUpperCase();
                                if (preparedWidget.currentRow[tableHistoryPk]) {
                                    for (var i = 0; i < e.data.dataset.columnsToReturn.length; i++) {
                                        if (!Util.isUndefined(e.data.dataset.columnsToReturn[i][tableHistoryPk])) {
                                            preparedWidget.currentRow[tableHistoryPk] = e.data.dataset.columnsToReturn[i][tableHistoryPk];
                                        }
                                    }
                                }
                                preparedWidget.backupRow = null;
                                preparedWidget.view();
                            }
                        }
                        
                        // Fim da tratativa
                        
                        var error;
                        if (e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;
                            
                        if (Messages[error]) {
                            error = Messages[error];
                        }
                        
                        if (mensagem) {
                            error += '. ' + mensagem;
                        }
        
                        ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    });
                } else {
                    ScreenService.showMessage(Messages.DTINI_POST_DTFIM_ERROR);
                    return false;
                }
            }
        }
    };

    this.validaRelacionaParc = function(widget, widgetPrincipal) {

        var dtNascPessoa = widgetPrincipal.currentRow.DTNASCPESSOA;
        var dtNascParceiro = widget.currentRow.DTNASCIFUNDPARC;
        var tipoRelaciona = widget.currentRow.NRTIPORELACIONA;
        if (widget.currentRow.NRPARCNEGRELAC === widgetPrincipal.currentRow.NRPARCNEGOCIO) {
            mensagem = Messages.HCM00000_GER_PESSOA_IGUAL_PESSOARELAC_ERROR;
            return false;
        }
        if (!dtNascPessoa) {
            mensagem = Messages.HCM00000_GER_PESSOA_DTNASC_PESSOA_PRINCIPAL_ERROR;
            return false;
        }
        /* ----- Dependente não deve ter data de nascimento obrigatória
        if (!dtNascParceiro) {
            mensagem = Messages.HCM00000_GER_PESSOA_DTNASC_PESSOARELAC_ERROR;
            return false;
        }  ----- */
        if (tipoRelaciona === HcmConsts.RelacionaParc.FILHO) {
            if (!ABUtilController.validaDtIniMenorIgualDtFin(dtNascPessoa, dtNascParceiro)) {
                mensagem = Messages.HCM00000_GER_PESSOA_DTNASC_MAIOR_ERROR;
                return false;
            }
        }
        if (tipoRelaciona === HcmConsts.RelacionaParc.PAI || tipoRelaciona === HcmConsts.RelacionaParc.MAE || tipoRelaciona === HcmConsts.RelacionaParc.AVO) {
            if (!ABUtilController.validaDtIniMenorIgualDtFin(dtNascParceiro, dtNascPessoa)) {
                mensagem = Messages.HCM00000_GER_PESSOA_DTNASC_MAIOR_ERROR;
                return false;
            }
        }
        return true;
    };
    
    this.paisOnchange = function(widget) {
        var estado;
        if (!Util.isUndefined(widget.getField('SGESTADO'))) {
            estado = widget.getField('SGESTADO');
        } else {
            estado = widget.getField('NMESTADO');
        }
        if (widget.currentRow.NMPAIS.length > 0)
            estado.readOnly = false;
        else {
            estado.readOnly = true;
            widget.getField('NMMUNICIPIO').readOnly = true;
            widget.getField('NMMUNICIPIO').validations = {};
        }
    };
    
    this.validacaoEstado = function(widget) {
        var estado;

        if (!Util.isUndefined(widget.getField('SGESTADO'))) {
            estado = widget.getField('SGESTADO');
        } else {
            estado = widget.getField('NMESTADO');
        }
        if(widget.currentRow.CDPAIS)
            estado.validations = {"required": true};
        else
            estado.validations = {};
    };

    this.estadoOnchange = function(args) {
        var widget = ABUtilController.checkWidget(args);
        if (widget.currentRow.SGESTADO && widget.currentRow.SGESTADO.length > 0){
            widget.getField('NMMUNICIPIO').readOnly = false;
        }else{
            widget.getField('NMMUNICIPIO').readOnly = true;
            widget.currentRow.NMMUNICIPIO = '';
            widget.currentRow.NRMUNICIPIO = '';
        }   
        
        // if (widget.currentRow.CDPAIS == '0055')
        //     widget.getField('NMMUNICIPIO').validations = {required: true};
        // else 
        //     widget.getField('NMMUNICIPIO').validations = {};
    };


    this.setRelacionamentoParc = function(args, nameWidgetPrincipal) {
        var widget = args.owner.widget;
        var widgetPrincipal = templateManager.container.getWidget(nameWidgetPrincipal);
        widget.currentRow.NRPARCNEGOCIO = widgetPrincipal.currentRow.NRPARCNEGOCIO;
        widget.currentRow.NRPESSOA = widgetPrincipal.currentRow.NRPESSOA;
        if (widget.isValid()) {
            if (!widget.backupRow) {
                widget.currentRow.__is_new = true;
            } else {
                widget.currentRow.__is_new = false;
            }
            if (!this.validaRelacionaParc(widget, widgetPrincipal)) {
                ScreenService.showMessage(mensagem);
                return false;
            }
            restEngine.post('product#/setRelacionamentoParc', {
                'requestType': 'DataSet',
                'dataset': [widget.currentRow]
            }).
            then(function(data) {
                if (data.notifications[0].type === "success") {
                    ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                    if (widget.currentRow.__is_new) {
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    } else {
                        ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                        widget.backupRow = null;
                        widget.view();
                    }
                }else if(data.notifications[0].type === "alert" && data.notifications[0].variables == "registroExistente") {
                    ScreenService.showMessage(data.notifications[0].message);
                }else {
                    ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                }
            }).
            catch(function(e) {
                var error;
                if (e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
        }
    };

    this.deleteRelacionamentoParc = function(args) {
        var widget = args.owner.widget;
        ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
            widget.currentRow.__is_new = false;
            restEngine.post('product#/deleteRelacionamentoParc', {
                'requestType': 'DataSet',
                'dataset': [widget.currentRow]
            }).
            then(function(data) {
                if (data.notifications[0].type === "success") {
                    ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                    ABUtilController.masterDetailVoltarList(widget);
                    widget.reload();
                } else {
                    ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                }
            }).
            catch(function(e) {
                var error;
                if (e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
        }, null);
    };

    this.setFormacaoParc = function(args) {
        var widget = args.owner.widget;
        var widgetPrincipal = templateManager.container.getWidget('Pessoa');
        widget.currentRow.NRPARCNEGOCIO = widgetPrincipal.currentRow.NRPARCNEGOCIO;
        if (widget.isValid()) {
            if (!widget.backupRow) {
                widget.currentRow.__is_new = true;
            } else {
                widget.currentRow.__is_new = false;
            }
            restEngine.post('product#/setFormacaoParc', {
                'requestType': 'DataSet',
                'dataset': [widget.currentRow]
            }).
            then(function(data) {
                if (data.notifications[0].type === "success") {
                    ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                    if (widget.currentRow.__is_new) {
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    } else {
                        ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                        widget.backupRow = null;
                        widget.view();
                    }
                } else {
                    ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                }
            }).
            catch(function(e) {
                var error;
                if (e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
        }
    };

    this.deleteFormacaoParc = function(args) {
        var widget = args.owner.widget;
        ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
            widget.currentRow.__is_new = false;
            restEngine.post('product#/deleteFormacaoParc', {
                'requestType': 'DataSet',
                'dataset': [widget.currentRow]
            }).
            then(function(data) {
                if (data.notifications[0].type === "success") {
                    ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                    ABUtilController.masterDetailVoltarList(widget);
                    widget.reload();
                } else {
                    ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                }
            }).
            catch(function(e) {
                var error;
                if (e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
        }, null);
    };

    this.habilitarCampoAreaOutros = function() {
        var widget = templateManager.container.getActiveWidget();
        if (widget.currentRow.NMAREAFORMACAO == "Outra") {
            widget.getField('DES_AREAFORMACAO_NRORG').readOnly = false;
            widget.getField('DES_AREAFORMACAO_NRORG').validations = {"required":{}};
        } else {
            widget.getField('DES_AREAFORMACAO_NRORG').readOnly = true;
            widget.getField('DES_AREAFORMACAO_NRORG').validations = {};
            widget.currentRow.DES_AREAFORMACAO_NRORG = '';

        }
    };

    this.habilitarCampoCursoOutros = function() {
        var widget = templateManager.container.getActiveWidget();
        if (widget.currentRow.NMCURSO == "Outro") {
            widget.getField('DSCURSO').readOnly = false;
            widget.getField('DSCURSO').validations = {"required":{}};
        } else {
            widget.getField('DSCURSO').readOnly = true;
            widget.getField('DSCURSO').validations = {};
            widget.currentRow.DSCURSO = '';
        }
    };
    
    this.validaDtCNH_OnAddOnEdit = function(){
        var widgetPessoa = templateManager.container.getWidget('Pessoa');
        if(widgetPessoa.currentRow.NRCARTHABPES)
            widgetPessoa.getField('DTHABCARTPES').validations = {required: true};
        else
            widgetPessoa.getField('DTHABCARTPES').validations = {};
    };
    
    this.validaInstituicaoOnChange = function(){
        var widget = templateManager.container.getActiveWidget();
        
        if(widget.currentRow.NMINSTITUICAOPARC)
            widget.getField('DSINSTITUICAO').setValue(widget.currentRow.NMINSTITUICAOPARC);
        else 
            widget.getField('DSINSTITUICAO').setValue("");
        
        
    };
    
    this.obrigaDataChegada = function(args) {
        var widget = ABUtilController.checkWidget(args);
        if (widget.currentRow.NRCLASSESTRANG === 6 || widget.currentRow.NRCLASSESTRANG === "" || widget.currentRow.NRCLASSESTRANG === null){
                widget.getField('DTCHEGADAPAIS').validations = {};
        }   else{
                widget.getField('DTCHEGADAPAIS').validations = {required: true};
            }
    };
    
    this.habilitarCamposVinculo = function(args) {
        var widget = templateManager.container.getWidget('Pessoa');
        var estado;
        if (!Util.isUndefined(widget.getField('SGESTADO'))) {
            estado = widget.getField('SGESTADO');
        } else {
            estado = widget.getField('NMESTADO');
        }
        if (widget.currentRow.NRVINCULOM != null|| widget.currentRow.NRVINCULOM != undefined){
            widget.getField('NMESTACIVIL').validations = {required: true};
            widget.getField('NMRACAPESSOA').validations = {required: true};
            widget.getField('NMGRAUINSTR').validations = {required: true};
            widget.getField('NMPAIS').validations = {required: true};
            estado.validations = {required: true};
            widget.getField('NRRGPESSOA').validations = {required: true};
            widget.getField('CDEXRGPESSOA').validations = {required: true};
            widget.getField('DSNACIONALIDADE').validations = {required: true};
            widget.getField('NRCPFPESSOA').validations = {required: true};
        }   else{
            widget.getField('NMESTACIVIL').validations = {};
            widget.getField('NMRACAPESSOA').validations = {};
            widget.getField('NMGRAUINSTR').validations = {};
            widget.getField('NMPAIS').validations = {};
            estado.validations = {};
            widget.getField('NRRGPESSOA').validations = {};
            widget.getField('CDEXRGPESSOA').validations = {};
            widget.getField('DSNACIONALIDADE').validations = {};
            widget.getField('NRCPFPESSOA').validations = {};
        }
    };
    
    this.onChangeAdmissaoPreliminar = function() {
        var widgetPessoa = templateManager.container.getWidget('Pessoa');
        
        if (!Util.isEmptyOrBlank(widgetPessoa.currentRow.DTADMISSAOPRE) || !Util.isEmptyOrBlank(widgetPessoa.currentRow.CDRECIBOADMPRE)) {
            widgetPessoa.getField('DTNASCPESSOA').validations = {required: true};
            widgetPessoa.getField('NRCPFPESSOA').validations = {required: true};
        } else {
            widgetPessoa.getField('DTNASCPESSOA').validations = {};
            widgetPessoa.getField('NRCPFPESSOA').validations = {};
        }
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('PessoaController', PessoaController);
});


// FILE: assets/js/controllers/PontoRegraController.js
function PontoRegraController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, General,Messages) {

    this.adicionarRow = function(args) {
        var widget = args.owner.widget;
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
    };

	this.setPontoRegra = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
                if (!widget.backupRow) {
                    widget.currentRow.__is_new = true;
                } else {
                    widget.currentRow.__is_new = false;
                }
                restEngine.post('product#/setPontoRegra', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                    then(function (data) {
                        if (data.notifications[0].type === "success") {
                            ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                            if (widget.currentRow.__is_new) {
                                ABUtilController.masterDetailVoltarList(widget);
                                widget.reload();
                            } else {
                                ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                                widget.backupRow = null;
                                widget.view();
                            }
                        } else {
                            ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                        }
                    }).
                    catch(function(e) {
                        var error;
                        if(e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;
                            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    });
            }
    };
    
    this.deletePontoRegra = function(args) {
    ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
        var widget = args.owner.widget;
        widget.currentRow.__is_new = false;
        restEngine.post('product#/deletePontoRegra', {'requestType':'DataSet','dataset':[widget.currentRow]}).
            then(function(data){
                if(data.notifications[0].type === "success"){
                    ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                    ABUtilController.masterDetailVoltarList(widget);
                    widget.reload();
                } else {
                    ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                }
            }).
            catch(function(e) {
                var error;
                if(e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
         }, null);
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('PontoRegraController', PontoRegraController);
});

// FILE: assets/js/controllers/PontosAcessoController.js
function PontosAcessoController (ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, $window, ABUtilController, Messages) {

    this.deleteColetorPontoAcesso = function(args) {
        var widget = ABUtilController.checkWidget(args);
        var data = {}; 
        ScreenService.confirmMessage(Messages.DELETE_ROW, 'CONFIRMATION', 
            function(){
                widget.dataSource.remove(widget.currentRow).then(function (data){
                    if(data.dataset.gpeColetor_setColetorPontoAcesso.type === "success"){
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                        ScreenService.showMessage(Messages.REMOVE_ROW_SUCCESS); 
                    } else {
                        ScreenService.showMessage(Messages.REMOVE_ROW_ERROR); 
                    }
                }.bind(this));
            }.bind(this)
        );
    };

    this.deletePontoAcesso = function(args) {
        var widget = ABUtilController.checkWidget(args);
        var data = {}; 
        ScreenService.confirmMessage(Messages.DELETE_ROW, 'CONFIRMATION', 
            function(){
                widget.dataSource.remove(widget.currentRow).then(function (data){
                    if(data.dataset.gpePontoAcesso_setPontosAcesso.type === "success"){
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                        ScreenService.showMessage(Messages.REMOVE_ROW_SUCCESS); 
                    } else {
                        ScreenService.showMessage(Messages.REMOVE_ROW_ERROR); 
                    }
                }.bind(this));
            }.bind(this)
        );
    };

    this.salvarColetorPontoAcesso = function(argsrRow){
        var widget = templateManager.container.getWidget("coletoresAcesso");
        var widgetPontoAcesso = templateManager.container.getWidget("pontosAcesso");
        if(widget.isValid())  {
            if (!widget.backupRow) {
                widget.currentRow.__is_new = true;
            } else {
                widget.currentRow.__is_new = false;
            }
            widget.currentRow.CDOPERADOR_LOG = getLocalVar("HCM_CDOPERADOR");
            widget.currentRow.NRORGTRAB = getLocalVar("HCM_NRORG_TRAB");
            widget.currentRow.NRORGPADRAO = getLocalVar("HCM_NRORG_PADRAO");
            widget.currentRow.DTATUAL = getLocalVar("HCM_DATA_ATUAL");
            widget.currentRow.NRPONTOACESSO = widgetPontoAcesso.currentRow.NRPONTOACESSO;
            return widget.saveRow().then(function (data){
                if (data.notifications[0].type === "success") {
                    if (widget.currentRow.__is_new) {
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    } else {
                        ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                        widget.backupRow = null;
                        widget.view();
                    }
                } else {
                    ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                }
            }.bind(this)).catch(function(e) {
                var error;
                if(e.data.error === undefined)
                    error = e;
                else 
                    error = e.data.error;
                
                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error));
            });
        }
    };

    this.salvarPontoAcesso = function(argsrRow){
        var widget = templateManager.container.getWidget("pontosAcesso");
        var widgetEstrutura = templateManager.container.getWidget("estruturas");
        if(widget.isValid())  {
            if (!widget.backupRow) {
                widget.currentRow.__is_new = true;
            } else {
                widget.currentRow.__is_new = false;
            }
            widget.currentRow.CDOPERADOR_LOG = getLocalVar("HCM_CDOPERADOR");
            widget.currentRow.NRORGTRAB = getLocalVar("HCM_NRORG_TRAB");
            widget.currentRow.NRORGPADRAO = getLocalVar("HCM_NRORG_PADRAO");
            widget.currentRow.DTATUAL = getLocalVar("HCM_DATA_ATUAL");
            widget.currentRow.NRESTRUTURAM = widgetEstrutura.currentRow.NRESTRUTURAM;
            return widget.saveRow().then(function (data){
                if (data.notifications[0].type === "success") {
                    if (widget.currentRow.__is_new) {
                        ABUtilController.masterDetailVoltarList(widget);
                        ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                        widget.reload();
                    } else {
                        ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                        widget.backupRow = null;
                        widget.view();
                    }
                } else {
                    ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                }
            }.bind(this)).catch(function(e) {
                var error;
                if(e.data.error === undefined)
                    error = e;
                else 
                    error = e.data.error;
                
                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error));
            });
        }
    };

    this.setNrEstrutura = function(args){
        var widgetEstrutura = ABUtilController.checkWidget(args);
        var widgetPontoAcesso = templateManager.container.getWidget("pontosAcesso");
        widgetPontoAcesso.dataSourceFilter.forEach(function(filters){
            if(filters.name === 'NRESTRUTURAM'){
                filters.value = widgetEstrutura.currentRow.NRESTRUTURAM;
            }
        });
    };

    this.setNrTipoEstrutura = function(args){
        var widgetPopUp = ABUtilController.checkWidget(args);
        var fieldEstrutura = widgetPopUp.getField("NMESTRUTURAH");
        widgetPopUp.currentRow.NMESTRUTURAM = {};
        widgetPopUp.currentRow.NRESTRUTURAM = {};
        if(!Util.isEmptyOrBlank(widgetPopUp.currentRow.NRTIPOESTRUTURA)){
            fieldEstrutura.dataSourceFilter.forEach(function(filters){
                if(filters.name === 'NRTIPOESTRUTURA'){
                    fieldEstrutura.dataSourceFilter.pop();
                }
            });
            fieldEstrutura.dataSourceFilter.push(
                {
                    "name": "NRTIPOESTRUTURA",
                    "operator": "=",
                    "value": widgetPopUp.currentRow.NRTIPOESTRUTURA
                }
            );
            fieldEstrutura.reload();
        } else {
            fieldEstrutura.dataSourceFilter.pop();
            fieldEstrutura.reload();
        }
    };

    this.setNrPontoAcesso = function(args){
        var widgetPontoAcesso = ABUtilController.checkWidget(args);
        var widgetColetorPontoAcesso = templateManager.container.getWidget("coletoresAcesso");
        widgetColetorPontoAcesso.dataSourceFilter.forEach(function(filters){
            if(filters.name === 'NRPONTOACESSO'){
                filters.value = widgetPontoAcesso.currentRow.NRPONTOACESSO;
            }
        });
    };
    
    this.obrigaTipoPonto = function(args){
        var widgetPontoAcesso = templateManager.container.getWidget("pontosAcesso");
        var widgetEstrutura = templateManager.container.getWidget("estruturas");
        var estruturaLegal = getLocalVar("HCM_NRTIPOESTRUTLEGAL");
        if (widgetEstrutura.currentRow.NRTIPOESTRUTURA=== estruturaLegal)
            widgetPontoAcesso.getField('DSTPREGIPONTO').validations.required = true;
        else
            widgetPontoAcesso.getField('DSTPREGIPONTO').validations = {};
        widgetPontoAcesso.reload();
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('PontosAcessoController', PontosAcessoController);
});

// FILE: assets/js/controllers/PopupCadastroController.js
/*jshint esversion: 6*/
function PopupCadastroController (ScreenService, metaDataFactory, templateManager, localStorageEngine, ZhUtil, restEngine,Messages, $window, ABUtilController,HcmConsts, EscalaTrabalhoController, General) {
    
    var self = this;
    var widgetAtual;
    var nrEscalatrbm;
    var nrEscalatrbh;
    var nrTurno;
    var parentWidget;
    var entraWidget = true;
    this.afterSuccessSaveCallback = function() {};
    
    /* Funções de abertura de widgets que não se encontram em
     * templateManager.containers
    */
    this.getFactoredWidget = function(container, nmContainerCadastro, nmWidCadastro, pushInContainer){
        return this.getWidgetMetadata(nmContainerCadastro).then(function(containerPopup){
                var widget = containerPopup.widgets[ABUtilController.retornaWidget(containerPopup, nmWidCadastro)];
                widget.container = container;
				var factoredWidget = metaDataFactory.widgetFactory(widget, container);
				if(pushInContainer){
					container.widgets.push(factoredWidget);
				}
				return factoredWidget;
			});  
    };
    
    this.getWidgetMetadata = function(nmWidCadastro){
        return restEngine.requestMetaData(nmWidCadastro).then(function(metadata){
			return metadata.data;
		});
    };
    
    /* Funções para reconhecimento de tabs do modal
     * Evita que select de uma tab após ser fechado abra a widget parent
    */
    
    this.widgetTabbedOnEnter = function(){
        var widgetTabbed = templateManager.container.getWidget('cadastroEscalaTabbed');
        if(entraWidget){    
            widgetTabbed.widgets.forEach(function(widget){
                widget.newRow();
            });
            widgetTabbed.widgets[ABUtilController.retornaWidget(widgetTabbed, 'cadastroEscala')].activate();
            entraWidget = false;
        }else if(!entraWidget && widgetAtual){
            widgetAtual.activate();
        }
    };
    
    this.setWidget = function(args){
        var widget = ABUtilController.checkWidget(args);
        widgetAtual = widget;
    };
    
    this.getWidgetRetorno = function(args){
         var widget = ABUtilController.checkWidget(args);
         parentWidget = widget;
    };
    
    /* nmWidCadastro = popup de cadastro
     * nmContainerCadastro = widget que está sendo utilizada (product#json/containers/hcm00113_ger_popupCadastro.json)
    */
    this.openCadastro = function(args, nmWidCadastro, nmContainerCadastro, afterSuccessSaveCallback = function() {}){
        var widget = ABUtilController.checkWidget(args);
        this.afterSuccessSaveCallback = afterSuccessSaveCallback;
        this.getFactoredWidget(widget.container, nmContainerCadastro, nmWidCadastro, true).then(function(widgetCadastro) {
            if(nmWidCadastro === 'perfilCurso'){
                widgetCadastro.template = 'widget/form.html';
                widgetCadastro.showAsModal = true;
            }
            if(nmWidCadastro === 'situacaoVinculoEsocial'){
                widgetCadastro.dataSourceFilter.forEach(function(filter){
                    if (filter.name == 'P_NRVINCULOM') {
                        filter.value = widget.currentRow.NRVINCULOM;
                    }
                });
                widgetCadastro.label2 = widget.currentRow.NRVINCULOM + ' - ' + widget.currentRow.NMVINCULOM;
                ABUtilController.masterDetailOpenPopup(widgetCadastro);
                widgetCadastro.parent = parentWidget;
            }else{
                ABUtilController.masterDetailOpenPopup(widgetCadastro);
                widgetCadastro.parent = parentWidget;
                widgetCadastro.currentRow = {};
                widgetCadastro.newRow();
            }
            setTimeout(()=>{
                 if (nmWidCadastro === 'cadastroAgencia'){ 
                    widgetCadastro.currentRow.CDBANCO = parentWidget.currentRow.CDBANCO;
                    widgetCadastro.currentRow.NMBANCO = parentWidget.currentRow.NMBANCO;
                }
            }, 100);
        });
    };
    
    /* Widget de popup com tab
    */
    this.openTab = function(args){
        var widget = ABUtilController.checkWidget(args);
        widget.newRow();
        self.validaParametriza(args);
    };
    
//---------FUNÇÔES GERAIS PARA POPUP DE CADASTRO-----------//
    
    /* Função geral pra fechar o modal
    */
    this.closeModal = function(args){
		var widget = args.owner.widget;
		var parent = widget.parent.parent ? widget.parent.parent : widget.parent;
		ScreenService.closePopup();
		parent.activate();
		entraWidget = !entraWidget ? true : entraWidget; 
	};
	
    
    /* Função para setar o registro adicionado no campo
    */
    
    this.selecionaRegistro = function(widget, dsCampo, valueCampo, filter, valueFilter, nomeData){
        var widgetParent = widget.parent;
        var field = widgetParent.getField(dsCampo);
        if(dsCampo === 'NMOCUPACAOH' || dsCampo === 'NMPESSOA'){
             field.itemsPerPage = 50000000;
        }
        field.dataSourceFilter.push({"name": valueCampo,
                                     "operator": '=',
                                     "value": valueFilter});
         field.reload().then(function(response){
            var data = field.dataSource.data[0];
            widgetParent.currentRow[dsCampo] = data[dsCampo];
            widgetParent.currentRow[valueCampo] = data[valueCampo];
            widgetParent.activate();
            if(field.dataSourceFilter[field.dataSourceFilter.length - 1].name == valueCampo){
                field.dataSourceFilter.pop();
                field.reload();
            }
        }.bind(this));
        if(dsCampo === 'NMOCUPACAOH'){
             widgetParent.getField(dsCampo).itemsPerPage = 15;
        }
        return true;
    };
    
    /*Função para botoes de VALIDAROW 
     *Para exibir e considerar os campos na currentRow
     *Exemplo: popup de cadastro tela de admissão campo escala de trabalho tab parametrizações e turno/horário*/
    this.validaParametriza = function(args){
        var widget = ABUtilController.checkWidget(args); 
        widget.fields.forEach(function(campo){
            if(widget.currentRow.VALIDAROW == 'Y'){
                if(campo.name != 'VALIDAROW'){
                    campo.isVisible = false;
                    campo.validations = {};
                    widget.currentRow = {'VALIDAROW': 'Y'};
                }
            }else if(widget.currentRow.VALIDAROW == 'N'){
                if(campo.name != 'VALIDAROW'){
                    campo.isVisible = true;
                    campo.validations = campo.showOnForm === true ? {"required": true} : {};
                    widget.newRow();
                    widget.currentRow.VALIDAROW = 'N';
                } 
            }        
        });
    };

    this.validaPeriodo = function(dtIni, dtFin) {
        if (moment(dtIni, 'DD/MM/YYYY').unix() > moment(dtFin, 'DD/MM/YYYY').unix() || moment(dtFin, 'DD/MM/YYYY').unix() < moment(dtIni, 'DD/MM/YYYY').unix()) {
            return false;
        } else {
            return true;
        }
    };
    
// ------ POPUP DE CADASTRO DE AGÊNCIA ------- //
    
    this.cadastroAgencia = function(args){
        var widget = ABUtilController.checkWidget(args);
        if (widget.isValid()) {
            widget.currentRow.__is_new = true;
            restEngine.post('product#/setAgencia', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                    then(function (data) {
                        if((data.messages && data.messages[0].type == 'M') || (data.notifications && data.notifications[0].type === "success")){
                            ScreenService.showMessage(data.messages[0].message);
                            ScreenService.closePopup(true);
                            var cdagencia = data.dataset.agencia[0].CDAGENCIA;
                            this.selecionaRegistro(widget, 'NMAGENCIA', 'CDAGENCIA', 'CDAGENCIA', cdagencia, 'agencia');
                        } else {
                            ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                        }
                    }.bind(this)).
                    catch(function(e) {
                        var error;
                        if(e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;
                            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    });
            
        }
    };
    
// ------ POPUP DE CADASTRO ESCALA DE TRABALHO ------- // 
    
        
    this.validaTurnoHorario = function(widget){
        var rowTurno = angular.copy(widget.currentRow);
        var rowHorario = angular.copy(widget.currentRow);
        
        widget.fields.forEach(function(field){
            if(field.fieldGroup === 'HORARIO' ){
                delete rowTurno[field.name];
                field.validations = {};
            }else if(field.fieldGroup === 'TURNO' ){
                delete rowHorario[field.name];
                field.validations = {};
            }
        });

        rowTurno.NRESCALATRABM = nrEscalatrbm;
        rowTurno.__is_new = true;
        rowTurno.IDATIVO = 'S';
        rowTurno.CDOPERADOR_LOG = getLocalVar("HCM_CDOPERADOR");
        rowTurno.NRESCALATRABM = nrEscalatrbm;
        rowTurno.NRORGTRAB = getLocalVar("HCM_NRORG_TRAB");
        rowTurno.DTATUAL = getLocalVar("HCM_DATA_ATUAL");
        rowHorario.IDATIVO = rowTurno.IDATIVO;
        
        widget.currentRow = rowTurno;
        self.setTurno(rowTurno);
        if(nrTurno){
            rowHorario.NRTURNO = nrTurno;
            var horarios = self.separaHorario(rowHorario);
            self.setHorario(horarios);
        }    
            
        return true;
    };
    
    this.changeDiaVariavel = function(args){
        var widgetTurno = ABUtilController.checkWidget(args);
        var field = args.owner.owner;
        var indice = field.name.substring(field.name.length - 1);
        var nrDia;
        var semana = [];
        semana[0]='Dia Variável';
        semana[1]='Sábado';
        semana[2]='Domingo';
        semana[3]='Segunda-Feira';
        semana[4]='Terça-Feira';
        semana[5]='Quarta-Feira';
        semana[6]='Quinta-Feira';
        semana[7]='Sexta-Feira';
        
        if(widgetTurno.currentRow[field.name] === 'S'){
            nrDia = 0;
        }else{
            nrDia = widgetTurno.getField('NRSEQHORARIO'+ indice).value();
        }
        
        widgetTurno.currentRow['DIASEMANA'+ indice] = semana[nrDia];
    };
    
    this.cadastroEscala = function(args){
        var widget = templateManager.container.getWidget('cadastroEscalaTabbed');
        var widgetEscala = templateManager.container.getWidget('cadastroEscala');
        var widgetParam = templateManager.container.getWidget('cadastroTrabalhoParametrizacao');
        var widgetTurno = templateManager.container.getWidget('cadastroTrabalhoTurno');
        var currentEscala = angular.copy(widgetEscala.currentRow);
        var fieldTurno = parentWidget.getField('DSTURNO');
        var filterTurno = fieldTurno.dataSourceFilter[ABUtilController.retornaFiltro( fieldTurno.dataSourceFilter, 'P_NRESCALATRABM')];
        if(widgetEscala.isValid() && widgetParam.isValid() && widgetTurno.isValid()){
            self.setEscalaTrabalho(widgetEscala).then(function(escala){
                nrEscalatrbm = escala.dataset.columnsToReturn[0].NRESCALATRABM;
                nrEscalatrbh = escala.dataset.columnsToReturn[0].NRESCALATRABH;
                if(filterTurno){
                    filterTurno.value = nrEscalatrbm;
                }else{
                    fieldTurno.dataSourceFilter.push({"name": "P_NRESCALATRABM",
                                                 "operator": "=",
                                                 "value": nrEscalatrbm});
                }
                widgetParam.dataSourceFilter[ABUtilController.retornaFiltro(widgetParam.dataSourceFilter, 'NRESCALATRABM')].value = nrEscalatrbm;
                if(widgetParam.currentRow.VALIDAROW != "Y" && widgetParam.currentRow.VALIDAROW){
                    widgetParam.currentRow = Object.assign(widgetParam.currentRow, currentEscala);
                    widgetParam.currentRow.NRESCALATRABM = nrEscalatrbm;
                    widgetParam.currentRow.NRESCALATRABH = nrEscalatrbh;
                    self.setEscalaTrabalho(widgetParam);
                }
                if(widgetTurno.currentRow.VALIDAROW != "Y" && widgetTurno.currentRow.VALIDAROW){
                    self.validaTurnoHorario(widgetTurno);
                    parentWidget.getField('DSTURNO').readOnly = false;
                }
                ScreenService.closePopup(true);
                self.selecionaRegistro(widget, 'NMESCALATRABH', 'NRESCALATRABM', 'NRESCALATRABM', nrEscalatrbm, 'getEscalastrab');
            });
        }else{
            ScreenService.showMessage('Campo obrigatório não preenchido em uma das abas.');
        }
    };
    
    this.cadastroTomadorEstrutGerencial = function(args){
        var popupTomador = ABUtilController.prepareSaveMasterHistory(args.owner.widget);
        popupTomador.currentRow.NRTIPOESTRUTURA = parseInt(getLocalVar('HCM_NRTIPOESTRUTOMADOR')) > 0 ? parseInt(getLocalVar('HCM_NRTIPOESTRUTOMADOR')) : 7;
        
        var currentRow = Util.clone(popupTomador.currentRow);
        currentRow = {};
        currentRow.TIPO_MULTIPLAS_ESTRUTURAS = 'TOMADOR/GERENCIAL';
        currentRow.ETRUTURA_TOMADOR = popupTomador.currentRow;
        currentRow.ESTRUTURA_GERENCIAL = popupTomador.parent.currentRow;
        currentRow.__is_new = true;
        
        popupTomador.currentRow = currentRow;
        
        restEngine.post('product#/setMultiplasEstruturas', {'requestType': 'DataSet', 'dataset': [popupTomador.currentRow]}).
            then(function (data) {
                if (data.dataset.sucesso) {

                    ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);

                    ABUtilController.masterDetailCancelaEdicao(popupTomador.parent);
                    popupTomador.parent.widgets[ABUtilController.retornaWidget(popupTomador.parent, 'enderecoParc')].showAsTab = true;
                    popupTomador.parent.widgets[ABUtilController.retornaWidget(popupTomador.parent, 'formaComunicacaoParc')].showAsTab = true;
                    popupTomador.parent.widgets[ABUtilController.retornaWidget(popupTomador.parent, 'contaCorrenteParc')].showAsTab = true;
                    popupTomador.parent.widgets[ABUtilController.retornaWidget(popupTomador.parent, 'WidgetUploadFoto')].showAsTab = true;
                    popupTomador.parent.widgets[ABUtilController.retornaWidget(popupTomador.parent, 'estruturasRelacionadas')].showAsTab = true;
                    popupTomador.parent.widgets[ABUtilController.retornaWidget(popupTomador.parent, 'estruturasSup')].showAsTab = true;

                    popupTomador.parent.reload();

                    this.closeModal(args);

                } else {
                    ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                }
            }.bind(this)).catch(function(e) {
                var error;
                if(e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
    
                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });        
    };

    this.cadastroEstrutLegalEstrutsGeren = function(args){
        var popupEstrutLegal = ABUtilController.prepareSaveMasterHistory(args.owner.widget);
        if (!popupEstrutLegal.isValid()) {
            return;
        }
        
        popupEstrutLegal.currentRow.NRTIPOESTRUTURA = parseInt(getLocalVar('HCM_NRTIPOESTRUTLEGAL'));
        
        var currentRow = Util.clone(popupEstrutLegal.currentRow);
        currentRow = {};
        currentRow.TIPO_MULTIPLAS_ESTRUTURAS = 'LEGAL/GERENCIAIS';
        currentRow.ESTRUTURA_LEGAL = popupEstrutLegal.parent.currentRow;
        currentRow.ETRUTURAS_GERENCIAIS = popupEstrutLegal.currentRow;
        currentRow.ETRUTURAS_GERENCIAIS.NRTIPOESTRUTURA = parseInt(getLocalVar('HCM_NRTIPOESTRUTGEREN'));
        currentRow.__is_new = true;
        
        popupEstrutLegal.currentRow = currentRow;
        
        restEngine.post('product#/setMultiplasEstruturas', {'requestType': 'DataSet', 'dataset': [popupEstrutLegal.currentRow]}).
            then(function (data) {
                if (data.dataset.sucesso) {

                    ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);

                    ABUtilController.masterDetailCancelaEdicao(popupEstrutLegal.parent);
                    popupEstrutLegal.parent.widgets[ABUtilController.retornaWidget(popupEstrutLegal.parent, 'enderecoParc')].showAsTab = true;
                    popupEstrutLegal.parent.widgets[ABUtilController.retornaWidget(popupEstrutLegal.parent, 'formaComunicacaoParc')].showAsTab = true;
                    popupEstrutLegal.parent.widgets[ABUtilController.retornaWidget(popupEstrutLegal.parent, 'contaCorrenteParc')].showAsTab = true;
                    popupEstrutLegal.parent.widgets[ABUtilController.retornaWidget(popupEstrutLegal.parent, 'WidgetUploadFoto')].showAsTab = true;
                    popupEstrutLegal.parent.widgets[ABUtilController.retornaWidget(popupEstrutLegal.parent, 'estruturasRelacionadas')].showAsTab = true;
                    popupEstrutLegal.parent.widgets[ABUtilController.retornaWidget(popupEstrutLegal.parent, 'estruturasSup')].showAsTab = true;
                    
                    popupEstrutLegal.parent.reload();

                    this.closeModal(args);

                } else {
                    ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                }
            }.bind(this)).catch(function(e) {
                var error;
                if(e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
    
                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });        
    };
    this.cadastroEstrutTomadorEstrutsGeren = function(args){
        var popupEstrutLegal = ABUtilController.prepareSaveMasterHistory(args.owner.widget);
        popupEstrutLegal.currentRow.NRTIPOESTRUTURA = parseInt(getLocalVar('HCM_NRTIPOESTRUTOMADOR')) > 0 ? parseInt(getLocalVar('HCM_NRTIPOESTRUTOMADOR')) : 7;
        
        var currentRow = Util.clone(popupEstrutLegal.currentRow);
        currentRow = {};
        currentRow.TIPO_MULTIPLAS_ESTRUTURAS = 'TOMADOR/GERENCIAIS';
        currentRow.ESTRUTURA_TOMADOR = popupEstrutLegal.parent.currentRow;
        currentRow.ETRUTURAS_GERENCIAIS = popupEstrutLegal.currentRow;
        currentRow.ETRUTURAS_GERENCIAIS.NRTIPOESTRUTURA = parseInt(getLocalVar('HCM_NRTIPOESTRUTGEREN'));
        currentRow.__is_new = true;
        
        popupEstrutLegal.currentRow = currentRow;
        
        restEngine.post('product#/setMultiplasEstruturas', {'requestType': 'DataSet', 'dataset': [popupEstrutLegal.currentRow]}).
            then(function (data) {
                if (data.dataset.sucesso) {

                    ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);

                    ABUtilController.masterDetailCancelaEdicao(popupEstrutLegal.parent);
                    popupEstrutLegal.parent.widgets[ABUtilController.retornaWidget(popupEstrutLegal.parent, 'enderecoParc')].showAsTab = true;
                    popupEstrutLegal.parent.widgets[ABUtilController.retornaWidget(popupEstrutLegal.parent, 'formaComunicacaoParc')].showAsTab = true;
                    popupEstrutLegal.parent.widgets[ABUtilController.retornaWidget(popupEstrutLegal.parent, 'contaCorrenteParc')].showAsTab = true;
                    popupEstrutLegal.parent.widgets[ABUtilController.retornaWidget(popupEstrutLegal.parent, 'WidgetUploadFoto')].showAsTab = true;
                    popupEstrutLegal.parent.widgets[ABUtilController.retornaWidget(popupEstrutLegal.parent, 'estruturasRelacionadas')].showAsTab = true;
                    popupEstrutLegal.parent.widgets[ABUtilController.retornaWidget(popupEstrutLegal.parent, 'estruturasSup')].showAsTab = true;

                    popupTomador.parent.reload();
                    
                    this.closeModal(args);

                } else {
                    ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                }
            }.bind(this)).catch(function(e) {
                var error;
                if(e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
    
                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });        
    };

    this.setEscalaTrabalho = function(widget){
        
        var message = '';
        widget.currentRow.CDOPERADOR_LOG = getLocalVar("HCM_CDOPERADOR");
        widget.currentRow.NRORGTRAB = getLocalVar("HCM_NRORG_TRAB");
        widget.currentRow.DTATUAL = getLocalVar("HCM_DATA_ATUAL");
        if(widget.currentRow.QTHRLIMITESEPHEXTRA)widget.currentRow.QTHRLIMITESEPHEXTRA = EscalaTrabalhoController.formataHora(widget.currentRow.QTHRLIMITESEPHEXTRA);
        if(widget.currentRow.QTHRPROJETAINTERVALO)widget.currentRow.QTHRPROJETAINTERVALO = EscalaTrabalhoController.formataHora(widget.currentRow.QTHRPROJETAINTERVALO);
        if(widget.currentRow.HRFIMPERIODONOTURNO)widget.currentRow.HRFIMPERIODONOTURNO = EscalaTrabalhoController.formataHora(widget.currentRow.HRFIMPERIODONOTURNO);
        if(widget.currentRow.HRINIPERIODONOTURNO)widget.currentRow.HRINIPERIODONOTURNO = EscalaTrabalhoController.formataHora(widget.currentRow.HRINIPERIODONOTURNO);
        widget = ABUtilController.prepareSaveMasterHistory(widget);
        if (widget.name === 'cadastroTrabalhoParametrizacao'){
            message = "Parametrizações adicionadas com sucesso!";
            widget.currentRow.__is_new = false;
        }else{
            message = "Escala adicionada com sucesso!";
            widget.currentRow.__is_new = true;
        }
        return restEngine.post('product#/getEscalaTrab/save', {'requestType': 'DataSet', 'dataset': [widget.currentRow]})
            .then(function (data){
            if (data.dataset.columnsToReturn) {
                ScreenService.successNotification(message);
                return data;
            } else {
                ScreenService.errorNotification(Messages.SAVE_ROW_ERROR);
            }
        }).catch(function(e) {
            var error;
            if(e.data.error === undefined)
                error = e;
            else 
                error = e.data.error;
            
            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error));
        });
    };

    this.setTurno = function(currentRow){
        
        return restEngine.post('product#/getTurno/save', {    
            'requestType': 'DataSet',
            'dataset': [currentRow]
        }).then(function (data){
            if (data.dataset.gpeTurno_setTurno[0]) {
                ScreenService.successNotification("Turno adicionado com sucesso!");
                nrTurno = data.dataset.gpeTurno_setTurno[0].NRTURNO;
                self.selecionaRegistro(templateManager.container.getWidget('cadastroEscalaTabbed'), 'DSTURNO', 'NRTURNO', 'NRTURNO', nrTurno, 'gpeTurno_getTurno');
            } else {
                ScreenService.errorNotification(Messages.SAVE_ROW_ERROR);
            }
        }).catch(function(e) {
            var error;
            if(e.data.error === undefined)
                error = e;
            else 
                error = e.data.error;
            
            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error));
        });

    };
    
    this.separaHorario = function(currentRow){
        var obj = {"__is_new": true,
            "NRHORARIOTURNO": null,
            "NRTURNO" : null,
            "NRHORDIAM": null,
            "NRSEQHORARIO": null,
            "IDDIAVARIAVEL": null,
            "IDATIVO": null,
            "NRORGTRAB": null,
            "DTATUAL": null
        };
        var horarios = [];
        
        for(var i = 1; i<= 7; i++){
            var horario = angular.copy(obj); 
            
            horario.NRORGTRAB = getLocalVar("HCM_NRORG_TRAB");
            horario.DTATUAL = getLocalVar("HCM_DATA_ATUAL");
            horario.CDOPERADOR_LOG = getLocalVar("HCM_CDOPERADOR");
            horario.NRTURNO = currentRow.NRTURNO;
            horario.NRHORDIAM = currentRow['NRHORDIAM'.concat(i)];
            horario.NRSEQHORARIO = currentRow['NRSEQHORARIO'.concat(i)];
            horario.IDDIAVARIAVEL = currentRow['IDDIAVARIAVEL'.concat(i)];
            horario.IDATIVO = currentRow.IDATIVO;
            
            horarios.push(horario);
        }
        return horarios;
    };
    
    this.setHorario = function(currentRow){
        
        return restEngine.post('product#/getHorarioTurno/save', {
            'requestType': 'DataSet',
            'dataset': currentRow
        }).then(function(data){
            if (data.dataset.gpeHorarioTurno_setHorarioTurno[0]) {
                ScreenService.successNotification("Horário adicionado com sucesso!");
            } else {
                ScreenService.errorNotification(Messages.SAVE_ROW_ERROR);
            }
        }).catch(function(e) {
            var error;
            if(e.data.error === undefined)
                error = e;
            else 
                error = e.data.error;
            
            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error));
        });
    };

// ------- POPUP DE CADASTRO DE OCUPAÇÂO ------ //
    
    this.cadastroOcupacao = function(args){
        var widget = ABUtilController.checkWidget(args);
        widget = ABUtilController.prepareSaveMasterHistory(widget);
        var masterTable = widget.paramsNewCode.__new_code_pk;
        
        widget.currentRow.DSOBJETIVOCARGO = widget.currentRow.DSOBJETIVOCARGO ? widget.currentRow.DSOBJETIVOCARGO : null;
        widget.currentRow.DSATIVIDADESCARGO = widget.currentRow.DSATIVIDADESCARGO ? widget.currentRow.DSATIVIDADESCARGO : null;
        widget.currentRow.DSCONDTRABALHO = widget.currentRow.DSCONDTRABALHO ? widget.currentRow.DSCONDTRABALHO : null;
        widget.currentRow.NRTEMPOEXPANO = widget.currentRow.NRTEMPOEXPANO ? widget.currentRow.NRTEMPOEXPANO : null;
        widget.currentRow.NRTEMPOEXPMES = widget.currentRow.NRTEMPOEXPMES ? widget.currentRow.NRTEMPOEXPMES : null;
        widget.currentRow.DSOBJETIVOCARGO = widget.currentRow.DSOBJETIVOCARGO ? widget.currentRow.DSOBJETIVOCARGO : null;
        widget.currentRow.IDVERIFICAVIGENCIAESO = 'S';
        widget.currentRow.NMEVENTO = 'S-1030,S-1040';
        widget.currentRow.NRCHAVE = widget.currentRow.NROCUPACAOM;
    
        restEngine.post('product#/saveCrud', {
            'requestType': 'DataSet',
            'dataset': [widget.currentRow]
        }).
        then(function(data) {
            if (data.dataset.columnsToReturn) {
                ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                self.selecionaRegistro(widget, 'NMOCUPACAOH', 'NROCUPACAOM', 'NROCUPACAOM', data.dataset.columnsToReturn[0].NROCUPACAOM, 'getOcupacao');
            }else{
                ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                parentWidget.activate();
            }
            ScreenService.closePopup(true);
        }).
        catch(function(e) {
            var error;
            if (e.data.error === undefined)
                error = e;
            else
                error = e.data.error;

            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
        });
        
    };
    
// ------- POPUP DE CADASTRO DE TAREFA ------ //

    this.cadastroTarifa = function(args){
        var widget = ABUtilController.checkWidget(args);
        if (widget.isValid()) {
            if (this.validaPeriodo(widget.currentRow.DTINITARIFA, widget.currentRow.DTFIMTARIFA)) {
                widget.currentRow.__is_new = true;
                widget.currentRow.VRTARIFA = General.valueToFloat(widget.currentRow.VRTARIFA);

                restEngine.post('product#/setTarifatransporte', {
                    'requestType': 'DataSet',
                    'dataset': [widget.currentRow]
                }).
                then(function(data) {
                    if (data.notifications[0].type === "success") {
                        ScreenService.successNotification('Tarifa de transporte salva com sucesso', 10000);
                        ScreenService.closePopup(true);
                         parentWidget.currentRow.VRTARIFA = data.dataset.setTarifatransporte.VRTARIFA;
                         parentWidget.currentRow.NRTARIFA = data.dataset.setTarifatransporte.NRTARIFA;
                         parentWidget.currentRow.DSTARIFA = data.dataset.setTarifatransporte.DSTARIFA;
                         parentWidget.activate();
                    } else {
                        ScreenService.showMessage('Erro ao salvar a tarifa de transporte');
                    }
                }).
                catch(function(e) {
                    var error;
                    if (e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;

                    ScreenService.showMessage('Ocorreu um erro inesperado, contate o administrador informando o trecho abaixo: <br><br>' + error + '<br><br>', 'ERROR');
                });
            } else {
                ScreenService.showMessage('A data final deve ser posterior à data inicial.');
                return false;
            }
        }
        
    };
    
// ------- POPUP DE CADASTRO DE MÈDICO ------- //
    this.verificaCPF = function(){
        var widget = templateManager.container.getActiveWidget();
        var cpf = widget.currentRow.NRCPFPESSOA;
        if(cpf){
            if(!ABUtilController.validaCPF(cpf)){
                ScreenService.showMessage('O CPF inserido não é valido!');
                cpf = '';
            }
        }
    };
    
    this.preparaWidget = function(widget){
        var preparedWidget = ABUtilController.prepareSaveMasterHistory(widget);
            preparedWidget.currentRow.CDTIPOINSCRICAO = 'CPF';
            preparedWidget.currentRow.CDTIPOPARCPRINCIPAL = 'PESSOA';
            preparedWidget.currentRow.DTNASCIFUNDPARC = '';
            preparedWidget.currentRow.NRINSCRICAOPARC = preparedWidget.currentRow.NRCPFPESSOA;
            preparedWidget.currentRow.IDPESSOAFISICA = 'S';
            preparedWidget.currentRow.IDATIVO = 'S';
            preparedWidget.currentRow.IDINSTITUICAO = 'N';
            preparedWidget.currentRow.IDPARCFUNDIDO = 'N';
            preparedWidget.currentRow.NMPRINCIPALPARC = preparedWidget.currentRow.NMPESSOA;
            preparedWidget.currentRow.NMSECUNDARIPARC = preparedWidget.currentRow.NMPESSOA;
            preparedWidget.currentRow.DTCHEGADAPAIS = '';
            preparedWidget.currentRow.NRANOCHEGAPAIS = '';
            preparedWidget.currentRow.NRDOCUESTRANG = '';
            preparedWidget.currentRow.IDPOSVISTOPERM = '';
            preparedWidget.currentRow.DTPERMAVISTO = '';
            preparedWidget.currentRow.IDPESNATURALIZA = '';
            preparedWidget.currentRow.DTNATURALIZAPES = '';
            preparedWidget.currentRow.NRREGCTPSPES = '';
            preparedWidget.currentRow.NRCTPSPESSOA = '';
            preparedWidget.currentRow.NRSERIECTPSPES = '';
            preparedWidget.currentRow.DTCTPSPESSOA = '';
            preparedWidget.currentRow.NRPISPASEPPES = '';
            preparedWidget.currentRow.DTINSCPISPASEP = '';
            preparedWidget.currentRow.NRINSCINSSPES = '';
            preparedWidget.currentRow.NRINSCISSPES = '';
            preparedWidget.currentRow.NRCERTNASCPES = '';
            preparedWidget.currentRow.NRCERTCASAPES = '';
            preparedWidget.currentRow.DTCASAPESSOA = '';
            preparedWidget.currentRow.IDISENTITUELEI = '';
            preparedWidget.currentRow.NRTITUELEIPES = '';
            preparedWidget.currentRow.NRSECAELEIPES = '';
            preparedWidget.currentRow.NRZONAELEIPES = '';
            preparedWidget.currentRow.NRCARTHABPES = '';
            preparedWidget.currentRow.DTHABCARTPES = '';
            preparedWidget.currentRow.DTVALHABCARTPES = '';
            preparedWidget.currentRow.DSCATEGHABCART = '';
            preparedWidget.currentRow.NRCERTRESEPES = '';
            preparedWidget.currentRow.DSCATEGCERTRESE = '';
            preparedWidget.currentRow.DTCERTRESEPES = '';
            preparedWidget.currentRow.CDEXCERTRESEPES = '';
            preparedWidget.currentRow.IDGRUPSANGUPES = '';
            preparedWidget.currentRow.IDFATORRHPES = '';
            preparedWidget.currentRow.SGESTADO = '';
            preparedWidget.currentRow.DTNASCPESSOA = '';
            preparedWidget.currentRow.IDSEXOPESSOA = '';
            preparedWidget.currentRow.NRRGPESSOA = '';
            preparedWidget.currentRow.CDEXRGPESSOA = '';
            preparedWidget.currentRow.DSLOCALEXRGPES = '';
            preparedWidget.currentRow.DTEXRGPESSOA = '';
            preparedWidget.currentRow.NRNACIONALID = '';
            preparedWidget.currentRow.DSCOMPLCERTNASC = '';
            preparedWidget.currentRow.NRLIVROCERTNASC = '';
            preparedWidget.currentRow.NRFOLHACERTNASC = '';
            preparedWidget.currentRow.DSPRONOMETRAT = '';
            preparedWidget.currentRow.DSAPELIDOPESS = '';
            preparedWidget.currentRow.NRCERTOBITO = '';
    
    };
    
    this.cadastroMedico = function(args){
        var widget = ABUtilController.checkWidget(args);
        if(widget.isValid()){
            this.preparaWidget(widget);
            restEngine.post('product#/setPessoa', {
                'requestType': 'DataSet',
                'dataset': [widget.currentRow]
            }).then(function(data) {
                if (data.dataset && data.dataset.columnsToReturn) {
                    ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                    self.selecionaRegistro(widget, 'NMPESSOA', 'NRPESSOA', 'NRPESSOA', data.dataset.columnsToReturn[0].NRPESSOA, 'getPessoa');
                    ScreenService.closePopup(true);
                    parentWidget.activate();
                    
                    if (self.afterSuccessSaveCallback) {
                        self.afterSuccessSaveCallback(data.dataset.columnsToReturn);
                    }
                }else if(data.messages && data.messages[0].type == 'E'){
                    ScreenService.showMessage(data.messages[0].message);
                }else{
                    ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                    ScreenService.closePopup(true);
                    parentWidget.activate();
                }
            }).
            catch(function(e) {
                var error;
                if (e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;

                ScreenService.showMessage('Ocorreu um erro inesperado, contate o administrador informando o trecho abaixo: <br><br>' + error + '<br><br>', 'ERROR');
            });
        }
    };


// ------- POPUP DE CADASTRO DE PERFIL PROFISSIOGRÁFICO ------- //
    this.salvarPerfilppp = function(args) {
        var widget = templateManager.container.getActiveWidget();
        if (widget.isValid()) {
            if (!widget.backupRow) {
                widget.currentRow.__is_new = true;
            } else {
                widget.currentRow.__is_new = false;
            }
            restEngine.post('product#/setPerfilppp', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                then(function (data) {
                    if (data.notifications[0].type === "success") {
                        ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                        self.selecionaRegistro(widget, 'NMPERFILPPP', 'NRPERFILPPP', 'NRPERFILPPP', data.dataset.sst_perfilppp[0].NRPERFILPPP, 'getPerfilppp');
                        ScreenService.closePopup(true);
                        parentWidget.activate();
                    } else {
                        ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                    }
                }).
                catch(function(e) {
                    var error;
                    if(e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;

                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
        }
    };
    
// ------- POPUP DE CADASTRO DE HORARIO ------- //
    this.salvarNovoHorario = function(args){
        var widget = templateManager.container.getActiveWidget();
        widget.currentRow.HRINICOLETAMARCACAO = widget.currentRow.HRINICOLETAMARCACAO.replace(/[\:-]/g, '');
        widget.currentRow.DTMESCOMPETENC = getLocalVar("HCM_DTCOMPETENCIA_OPER");
        widget.currentRow.NRHORDIAH = "";
        if (widget.isValid()) {
            var preparedWidget = ABUtilController.prepareSaveMasterHistory(widget);
    
            restEngine.post('product#/saveCrud', {
                'requestType': 'DataSet',
                'dataset': [preparedWidget.currentRow]
            }).
            then(function(data) {
                if (data.dataset.columnsToReturn) {
                    ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                    self.selecionaRegistro(widget, 'NMHORDIAH', 'NRHORDIAM', 'NRHORDIAM', data.dataset.columnsToReturn[0].NRHORDIAM, 'getHorario');
                    ScreenService.closePopup(true);
                    if(parentWidget.getTemplateSimpleName() == "form.html")    
                        ABUtilController.masterDetailOpenPopup(parentWidget);
                    parentWidget.activate();
                } else {
                    ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                }
            }).
            catch(function(e) {
                var error;
                if (e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
    
                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
        }
    };
    
    // ------- POPUP DE CADASTRO DE PERFIL DO CURSO ------- //
    this.salvarPerfilCurso = function(args) {
        var widget = templateManager.container.getActiveWidget();
        if (widget.isValid()) {
            if (!widget.backupRow) {
                widget.currentRow.__is_new = true;
            } else {
                widget.currentRow.__is_new = false;
            }
            restEngine.post('product#/setPerfilCurso', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                then(function (data) {
                    if (data.notifications[0].type === "success") {
                        ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                        self.selecionaRegistro(widget, 'NMPERFILCURSO', 'NRPERFILCURSO', 'NRPERFILCURSO', data.dataset.getPerfilCurso[0].NRPERFILCURSO, 'getPerfilppp');
                        ScreenService.closePopup(true);
                        parentWidget.activate();
                    } else {
                        ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                    }
                }).
                catch(function(e) {
                    var error;
                    if(e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;

                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
        }
    };
    
    // ------- POPUP DE CADASTRO DE FATOR DE RISCO ------- //
    this.salvarFatorRisco = function(args) {
        var widget = templateManager.container.getActiveWidget();
        if (widget.isValid()) {
            if (!widget.backupRow) {
                widget.currentRow.__is_new = true;
            } else {
                widget.currentRow.__is_new = false;
            }
            restEngine.post('product#/setFatorrisco', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                then(function (data) {
                    if (data.notifications[0].type === "success") {
                        ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                        self.selecionaRegistro(widget, 'NMFATORRISCO', 'NRFATORRISCO', 'NRFATORRISCO', data.dataset.sst_fatorrisco[0].NRFATORRISCO, 'getFatorrisco');
                        ScreenService.closePopup(true);
                        parentWidget.activate();
                    } else {
                        ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                    }
                }).
                catch(function(e) {
                    var error;
                    if(e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;

                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
        }
    };
    
    
    // ------- POPUP DE CADASTRO DE CPF ADMISSAO ------- //
    
    /*Função para abrir popUp
    */
    this.openCadastroAdmissao = function(args){
        var widget = templateManager.container.getWidget('cpfPessoaTabbed');
        if(!Util.isEmptyOrBlank(widget)){
            widget.widgets[0].dataSource.data = [];
            widget.widgets[0].unSelectAll();
            ABUtilController.masterDetailOpenPopup(widget);
            widget.parent = parentWidget;
            widget.currentRow = {};
            widget.newRow();
        }else{
            this.openCadastro(args, 'cpfPessoaTabbed', 'product#json/containers/hcm00113_ger_popupCadastro.json');
        }
    };
    
    
    /* Função geral pra fechar o modal
    */
    this.closeModalAdmissao = function(){
		var widget = templateManager.container.getWidget('cpfPessoaTabbed');
		var parent = widget.parent.parent ? widget.parent.parent : widget.parent;
		if(parent.name === 'admissaoMenu'){
    		entraWidget = !entraWidget ? true : entraWidget; 
    		ScreenService.closePopup();
		    ScreenService.openWindow('product#dashboard');
		}else{
    		ScreenService.closePopup();
    		parent.activate();
    		entraWidget = !entraWidget ? true : entraWidget; 
		}
	};
    
    this.changeActions = function(){
        var widgetCPF = templateManager.container.getWidget('cpfPessoaTabbed');
        var widgetPessoa = templateManager.container.getWidget('pessoaAdmissao');
        
        
        if(widgetPessoa.getCheckedRows().length > 0){
            widgetCPF.getAction('admissao_pessoa').isVisible = true;
            widgetCPF.getAction('admissao_nova').isVisible = false;
            widgetCPF.getAction('admissao_preliminar_simplificada').isVisible = true;
            widgetCPF.activate();
            widgetCPF.redraw();
        }else{
            widgetCPF.getAction('admissao_pessoa').isVisible = false;
            widgetCPF.getAction('admissao_nova').isVisible = true;
            widgetCPF.getAction('admissao_preliminar_simplificada').isVisible = true;
            widgetCPF.activate();
            widgetCPF.redraw();
        }  
    };
    
    
    // ------- POPUP DE SITUACAO DO VÍNCULO NO ESOCIAL ------- //
    
    /*Função para abrir popUp
    */
    this.openSituacaoVinculoEsocial = function(args){
        var widget = templateManager.container.getWidget('situacaoVinculoEsocial');
        if(!Util.isEmptyOrBlank(widget)){
            widget.dataSource.data = [];
            widget.unSelectAll();
            var widgetOrig = ABUtilController.checkWidget(args);
            widget.dataSourceFilter.forEach(function(filter){
                    if (filter.name == 'P_NRVINCULOM') {
                        filter.value = widgetOrig.currentRow.NRVINCULOM;
                    }
                });
            widget.label2 = widgetOrig.currentRow.NRVINCULOM + ' - ' + widgetOrig.currentRow.NMVINCULOM;
            ABUtilController.masterDetailOpenPopup(widget);
            widget.parent = parentWidget;
        }else{
            this.openCadastro(args, 'situacaoVinculoEsocial', 'product#json/containers/hcm00113_ger_popupCadastro.json');
        }
    };
    
    this.onEnterSituacaoVinculoEsocial = function(args){
        var widget = ABUtilController.checkWidget(args);
        widget.reload();
    };
    
    this.setSituacaoVinculoEsocial = function(args){
        var widget = ABUtilController.checkWidget(args);
        widget.label = widget.label1 + ' (' + widget.label2 + ')';
        widget.setCurrentRow(widget.dataSource.data[0]);
    };
    
    
    /* Função geral pra fechar o modal
    */
    this.closeModalSituacaoVinculoEsocial = function(){
		var widget = templateManager.container.getWidget('situacaoVinculoEsocial');
		var parent = widget.getParent();
		ScreenService.closePopup();
		entraWidget = !entraWidget ? true : entraWidget; 
	};
    

}

Configuration(function(ContextRegister) {
    ContextRegister.register('PopupCadastroController', PopupCadastroController);
});

// FILE: assets/js/controllers/PreFechamentoDctfWebController.js
/* jshint esversion: 6 */
function PreFechamentoDctfWebController(ScreenService, templateManager, restEngine, Messages) {
    const contribuicaoPrevidenciariaSegurado = new ContribuicaoPrevidenciariaSegurado(templateManager, ScreenService, restEngine, Messages);
    const informacoesSinteticas = new InformacoesSinteticas(templateManager, ScreenService, restEngine, Messages);
    const informacoesSobreBasesCalculo = new InformacoesSobreBasesCalculo(templateManager, ScreenService, restEngine, Messages);
    
    this.states = {
        isNewContribuicaoSegurado: true,
        isNewInformacoesSinteticas: true,
        isNewInformacoesBasescalculo: true
    };
    
    this.activeWidget = 'stripe';
    
    this.applyDefaultParametros = function() {
        templateManager.container.getWidget('parametros').applyDefaultValue();
    };
    
    this.openPopupParametros = function() {
        this.activeWidget = templateManager.container.getActiveWidget().name;
        
        this.states.isNewContribuicaoSegurado = true;
        this.states.isNewInformacoesSinteticas = true;
        this.states.isNewInformacoesBasescalculo = true;
        
        ScreenService.openPopup( templateManager.container.getWidget('parametros') );
    };
    
    this.filtrarParametros = function() {
        var parametros = templateManager.container.getWidget('parametros');
        
        ajustaCamposStripe(parametros);
        
        if (this.activeWidget == 'informacoesSinteticas') {
            this.getInformacoesSinteticas();
        
            this.states.isNewContribuicaoSegurado = true;
            this.states.isNewInformacoesBasescalculo = true;
            
            templateManager.container.getWidget("informacoesSinteticas").activate();
        } else if (this.activeWidget == 'informacoesSobreBasesCalculo') {
            this.getInformacoesSobreBasesCalculo();
        
            this.states.isNewContribuicaoSegurado = true;
            this.states.isNewInformacoesSinteticas = true;
            
            templateManager.container.getWidget("informacoesSobreBasesCalculo").activate();
        } else {
            this.getContribuicaoPrevidenciariaSegurado();
        
            this.states.isNewInformacoesSinteticas = true;
            this.states.isNewInformacoesBasescalculo = true;
        }
    };
    
    var ajustaCamposStripe = function(parametros) {
        var stripe = templateManager.container.getWidget('stripe');
        
        stripe.getField('FIELDSTRIPE1').setValue(parametros.currentRow.DATACOMPETENCIAINICIAL);
        stripe.getField('FIELDSTRIPE2').setValue(parametros.currentRow.APURACAO == "1" ? "Mensal" : (parametros.currentRow.APURACAO == "4" ? "13º" : "Mensal/13º"));
        stripe.getField('FIELDSTRIPE3').setValue(parametros.currentRow.NRESTRUTLEGAL_LIST == "" ? "Todas" : parametros.currentRow.NRESTRUTLEGAL_LIST);
    };
    
    this.getContribuicaoPrevidenciariaSegurado = function(atualizar = false) {
        if (this.states.isNewContribuicaoSegurado === true || atualizar === true) {
            this.states.isNewContribuicaoSegurado = false;
            return contribuicaoPrevidenciariaSegurado.getContribuicaoPrevidenciariaSegurado();
        }else if(this.states.isNewContribuicaoSegurado === false || atualizar === true){
            return contribuicaoPrevidenciariaSegurado.getContribuicaoPrevidenciariaSegurado();
        }
    };
    
    this.getEventosApuradosVinculo = function(args) {
        contribuicaoPrevidenciariaSegurado.getEventosApuradosVinculo(args);
    };
    
    this.getInformacoesSinteticas = function(atualizar = false) {
        if (this.states.isNewInformacoesSinteticas === true || atualizar === true) {
            this.states.isNewInformacoesSinteticas = false;
            return informacoesSinteticas.getInformacoesSinteticas();
        }else if(this.states.isNewInformacoesSinteticas === false || atualizar === true){
            return informacoesSinteticas.getInformacoesSinteticas();
        }
    };
    
    this.getInformacoesSobreBasesCalculo = function(atualizar = false) {
        if (this.states.isNewInformacoesBasescalculo === true || atualizar === true) {
            this.states.isNewInformacoesBasescalculo = false;
            return informacoesSobreBasesCalculo.getInformacoesSobreBasesCalculo();
        }else if(this.states.isNewInformacoesBasescalculo === false || atualizar === true){
            return informacoesSobreBasesCalculo.getInformacoesSobreBasesCalculo();
        }
    };
    
    this.setStripeInformacoesSobreBasesCalculo = function() {
        var stripe = templateManager.container.getWidget('stripe');
        stripe.getField('FIELDSTRIPE4').setValue("Valores de FPAS, RAT e Terceiros cálculados de acordo com os dados da estrutura lotação");
        stripe.getField('FIELDSTRIPE4').isVisible = true;
        stripe.getField('FIELDSTRIPE4').showOnForm = true;
        stripe.getField('FIELDSTRIPE4').showOnView = true;
        stripe.getField('FIELDSTRIPE4').showOnList = true;
    };

}

class ContribuicaoPrevidenciariaSegurado {
    
    constructor(templateManager, ScreenService, restEngine, Messages) {
        this.templateManager = templateManager;
        this.screenService = ScreenService;
        this.restEngine = restEngine;
        this.messages = Messages;
    }
    
    getContribuicaoPrevidenciariaSegurado() {
        var widget = this.templateManager.container.getWidget("contribuicaoPrevidenciariaSegurado");
        var parametros = this.templateManager.container.getWidget('parametros');
        if (parametros.isValid()) {
            this.restEngine.post('product#/getContribuicaoPrevidenciariaSegurado', {'requestType': 'DataSet', 'dataset': [parametros.currentRow]})
            .then((data) => {
                widget.dataSource.data = data.dataset.dataset;
                this.screenService.closePopup();
                this.templateManager.container.getWidget("contribuicaoPrevidenciariaSegurado").activate();
            })
            .catch((e) => {
                var error = e.data.error === undefined ? e : e.data.error;
                this.screenService.showMessage(this.messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
        }
    }
    
    getEventosApuradosVinculo(args) {
        var row = args.owner.currentRow;
        this.restEngine.post('product#/getEventosApuradosVinculo', {'requestType': 'DataSet', 'dataset': [row]})
        .then((data) => {
            this.showEventosApuradosVinculo(data.dataset.dataset);
        })
        .catch((e) => {
            var error = e.data.error === undefined ? e : e.data.error;
            this.screenService.showMessage(this.messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
        });
    }
    
    hasObservacoesEventosApurados(eventos) {
        for(let evento of eventos) {
            if(evento.OBSERVACAO !== undefined) {
                return true;
            }
        }
    }
    
    visibilityStripeObservacao(eventos) {
        if(this.hasObservacoesEventosApurados(eventos) === true) {
            this.templateManager.container.getWidget('stripeEventosApuradosVinculo').isVisible = true;
            this.templateManager.container.getWidget('stripeEventosApuradosVinculo').template = 'widget/stripe.html';
            return true;
        } else {
            this.templateManager.container.getWidget('stripeEventosApuradosVinculo').isVisible = false;
            this.templateManager.container.getWidget('stripeEventosApuradosVinculo').template = 'widget/grid.html';
            return false;
        }
    }
    
    mountArrayEventosApurados(eventos) {
        if (this.visibilityStripeObservacao(eventos)) {
            eventos.push({'VALOR': ''});
        }
        return eventos;
    }
    
    showEventosApuradosVinculo(eventos) {
        var eventosApuradosVinculo = this.templateManager.container.getWidget('eventosApuradosVinculo');
        
        eventosApuradosVinculo.dataSource.data = this.mountArrayEventosApurados(eventos);
        
        this.screenService.openPopup(eventosApuradosVinculo);
    }
    
}

class InformacoesSinteticas {
    
    constructor(templateManager, ScreenService, restEngine, Messages) {
        this.templateManager = templateManager;
        this.screenService = ScreenService;
        this.restEngine = restEngine;
        this.messages = Messages;
    }
    
    getInformacoesSinteticas() {
        var widget = this.templateManager.container.getWidget("informacoesSinteticas");
        var parametros = this.templateManager.container.getWidget('parametros');
        if (parametros.isValid()) {
            this.restEngine.post('product#/getInformacoesSinteticas', {'requestType': 'DataSet', 'dataset': [parametros.currentRow]})
            .then((data) => {
                widget.dataSource.data = data.dataset.dataset;
                this.screenService.closePopup();
            })
            .catch((e) => {
                var error = e.data.error === undefined ? e : e.data.error;
                this.screenService.showMessage(this.messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
        }
    }
}

class InformacoesSobreBasesCalculo {
    
    constructor(templateManager, ScreenService, restEngine, Messages) {
        this.templateManager = templateManager;
        this.screenService = ScreenService;
        this.restEngine = restEngine;
        this.messages = Messages;
    }
    
    getInformacoesSobreBasesCalculo() {
        var widget = this.templateManager.container.getWidget("informacoesSobreBasesCalculo");
        var parametros = this.templateManager.container.getWidget('parametros');
        if (parametros.isValid()) {
            this.restEngine.post('product#/getInformacoesSobreBasesCalculo', {'requestType': 'DataSet', 'dataset': [parametros.currentRow]})
            .then((data) => {
                widget.dataSource.data = data.dataset.dataset;
                this.screenService.closePopup();
            })
            .catch((e) => {
                var error = e.data.error === undefined ? e : e.data.error;
                this.screenService.showMessage(this.messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
        }
    }
}

Configuration(function(ContextRegister) {
    ContextRegister.register('PreFechamentoDctfWebController', PreFechamentoDctfWebController);
});

// FILE: assets/js/controllers/PreFechamentoFgtsController.js
/* jshint esversion: 6 */
function PreFechamentoFgtsController(ScreenService, templateManager, restEngine, Messages) {
    const conferenciaFgts = new ConferenciaFgts(templateManager, ScreenService, restEngine, Messages);
    const informacoesSinteticasFgts = new InformacoesSinteticasFgts(templateManager, ScreenService, restEngine, Messages);
    const informacoesSobreBasesCalculoFgts = new InformacoesSobreBasesCalculoFgts(templateManager, ScreenService, restEngine, Messages);
    
    this.states = {
        isNewConferenciaFgts: true,
        isNewInformacoesSinteticasFgts: true,
        isNewInformacoesBasescalculoFgts: true,
    };
    
    this.activeWidget = 'stripe';
    
    this.applyDefaultParametros = function() {
        templateManager.container.getWidget('parametros').applyDefaultValue();
    };
    
    this.openPopupParametros = function() {
        this.activeWidget = templateManager.container.getActiveWidget().name;
        
        ScreenService.openPopup( templateManager.container.getWidget('parametros') );
    };
    
    this.filtrarParametros = function() {
        var parametros = templateManager.container.getWidget('parametros');
        
        ajustaCamposStripe(parametros);
        
        this.states.isNewConferenciaFgts = true;
        this.states.isNewInformacoesSinteticasFgts = true;
        this.states.isNewInformacoesBasescalculoFgts = true;
        
        this.getConferenciaFgts();
    };
    
    var ajustaCamposStripe = function(parametros) {
        var stripe = templateManager.container.getWidget('stripe');
        
        stripe.getField('FIELDSTRIPE1').setValue(parametros.currentRow.DATACOMPETENCIAINICIAL);
        stripe.getField('FIELDSTRIPE2').setValue(parametros.currentRow.APURACAO == "1" ? "Mensal" : (parametros.currentRow.APURACAO == "4" ? "13º" : "Mensal/13º"));
        stripe.getField('FIELDSTRIPE3').setValue(parametros.currentRow.NRESTRUTLEGAL_LIST == "" ? "Todas" : parametros.currentRow.NRESTRUTLEGAL_LIST);
    };
    
    this.getConferenciaFgts = function() {
        
        if (this.states.isNewConferenciaFgts) {
            this.states.isNewConferenciaFgts = false;
            return conferenciaFgts.getConferenciaFgts();
        }
            
    };
    
    this.getInformacoesSinteticasFgts = function() {
        
        if (this.states.isNewInformacoesSinteticasFgts) {
            this.states.isNewInformacoesSinteticasFgts = false;
            return informacoesSinteticasFgts.getInformacoesSinteticasFgts();
        }
    };
    
    this.getInformacoesSobreBasesCalculoFgts = function() {
        
        if (this.states.isNewInformacoesBasescalculoFgts) {
            this.states.isNewInformacoesBasescalculoFgts = false;
            return informacoesSobreBasesCalculoFgts.getInformacoesSobreBasesCalculoFgts();
        }        
    };
    
    this.atualizarConferenciaFgts = function() {
        this.states.isNewConferenciaFgts = true;
        
        this.getConferenciaFgts();
    };
    
    this.atualizarInformacoesSinteticasFgts = function() {
        this.states.isNewInformacoesSinteticasFgts = true;
        
        this.getInformacoesSinteticasFgts();
    };
    
    this.atualizarInformacoesSobreBasesCalculoFgts = function() {
        this.states.isNewInformacoesBasescalculoFgts = true;
        
        this.getInformacoesSobreBasesCalculoFgts();
    };
    
    this.setStripeInformacoesSobreBasesCalculoFgts = function() {
        var stripe = templateManager.container.getWidget('stripe');
        stripe.getField('FIELDSTRIPE4').setValue("Valores de FPAS, RAT e Terceiros cálculados de acordo com os dados da estrutura lotação");
        stripe.getField('FIELDSTRIPE4').isVisible = true;
        stripe.getField('FIELDSTRIPE4').showOnForm = true;
        stripe.getField('FIELDSTRIPE4').showOnView = true;
        stripe.getField('FIELDSTRIPE4').showOnList = true;
    };
}

class ConferenciaFgts {
    
    constructor(templateManager, ScreenService, restEngine, Messages) {
        this.templateManager = templateManager;
        this.screenService = ScreenService;
        this.restEngine = restEngine;
        this.messages = Messages;
    }
    
    getConferenciaFgts() {
        var widget = this.templateManager.container.getWidget("conferenciaFgts");
        var parametros = this.templateManager.container.getWidget('parametros');
        
        if (parametros.isValid()) {
            this.restEngine.post('product#/getConferenciaFgts', {'requestType': 'DataSet', 'dataset': [parametros.currentRow]})
            .then((data) => {
                widget.dataSource.data = data.dataset.dataset;
                
                this.screenService.closePopup();
                this.templateManager.container.getWidget("conferenciaFgts").activate();
            })
            .catch((e) => {
                this.screenService.showMessage(this.messages.CATCH_EXCEPTION_ERROR(e.data.error), 'ERROR');
            });
        }
    }
}

class InformacoesSinteticasFgts {
    
    constructor(templateManager, ScreenService, restEngine, Messages) {
        this.templateManager = templateManager;
        this.screenService = ScreenService;
        this.restEngine = restEngine;
        this.messages = Messages;
    }
    
    getInformacoesSinteticasFgts() {
        var widget = this.templateManager.container.getWidget("informacoesSinteticasFgts");
        var parametros = this.templateManager.container.getWidget('parametros');
        
        if (parametros.isValid()) {
            this.restEngine.post('product#/getInformacoesSinteticasFgts', {'requestType': 'DataSet', 'dataset': [parametros.currentRow]})
            .then((data) => {
                widget.dataSource.data = data.dataset.dataset;
                
                this.screenService.closePopup();
            })
            .catch((e) => {
                this.screenService.showMessage(this.messages.CATCH_EXCEPTION_ERROR(e.data.error), 'ERROR');
            });
        }
    }
}

class InformacoesSobreBasesCalculoFgts {
    
    constructor(templateManager, ScreenService, restEngine, Messages) {
        this.templateManager = templateManager;
        this.screenService = ScreenService;
        this.restEngine = restEngine;
        this.messages = Messages;
    }
    
    getInformacoesSobreBasesCalculoFgts() {
        var widget = this.templateManager.container.getWidget("informacoesSobreBasesCalculoFgts");
        var parametros = this.templateManager.container.getWidget('parametros');
        
        if (parametros.isValid()) {
            this.restEngine.post('product#/getInformacoesSobreBasesCalculoFgts', {'requestType': 'DataSet', 'dataset': [parametros.currentRow]})
            .then((data) => {
                widget.dataSource.data = data.dataset.dataset;
                this.screenService.closePopup();
            })
            .catch((e) => {
                this.screenService.showMessage(this.messages.CATCH_EXCEPTION_ERROR(e.data.error), 'ERROR');
            });
        }
    }
}

Configuration(function(ContextRegister) {
    ContextRegister.register('PreFechamentoFgtsController', PreFechamentoFgtsController);
});

// FILE: assets/js/controllers/PrioridadeController.js
/**
 * Created by lara on 14/07/2016.
 */
function PrioridadeController (ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, $window, ABUtilController, Messages) {

    this.deletePrioridade = function(args) {
    ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
        var widget = args.owner.widget;
        var data = {};
        widget.dataSource.checkedRows = widget.currentRow;
        widget.removeCheckedRows().then(function(){
            widget.reload();
            ABUtilController.masterDetailVoltarList(widget);
            ScreenService.showMessage(Messages.REMOVE_ROW_SUCCESS);
        }).catch(function(e) {
            var error;
            if(e.data.error === undefined)
                error = e;
            else 
                error = e.data.error;
             
            ScreenService.showMessage(CATCH_EXCEPTION_ERROR(error));
            });
        }, null);
    };

    this.openAdicionarPrioridade = function(args) {
        var widget = args.owner.widget;
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
    };

    this.salvarPrioridade = function(argsRow){
        var widget = templateManager.container.getWidget("prioridade");
        if(widget.isValid())  {
            widget.currentRow.CDOPERLOG = getLocalVar("HCM_CDOPERADOR");
            widget.currentRow.NRORGTRAB = getLocalVar("HCM_NRORG_TRAB");
            widget.currentRow.DTATUAL = getLocalVar("HCM_DATA_ATUAL");
            return widget.saveRow().then(function(){
                ScreenService.showMessage(Messages.SAVE_ROW_SUCCESS);
                if (widget.currentRow.__is_new) {
                    ABUtilController.masterDetailVoltarList(widget);
                    widget.reload();
                } else {
                    ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                    widget.backupRow = null;
                    widget.view();
                }
            }).catch(function(e) {
                var error;
                if(e.data.error === undefined)
                    error = e;
                else 
                    error = e.data.error;
                
                ScreenService.showMessage(CATCH_EXCEPTION_ERROR(error));
            });
        }
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('PrioridadeController', PrioridadeController);
});

// FILE: assets/js/controllers/ProcessoAdmJudController.js
/* jshint esversion: 6 */
function ProcessoAdmJudController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, General, Messages) {

    var self = this;

    this.mudarVisibilidadeWidgets = function(widgets, value) {
        widgets.forEach(function(widget) {
            widget.isVisible = value;
        });
    };

    this.ProcessoAfterMoveRow = function(widget) {
        widget.widgets[0].dataSourceFilter[0].value = widget.currentRow.NRPROCESSADMJUD;
    };


    this.adicionarRow = function(args) {
        var widget = args.owner.widget;
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
    };

    this.filtrarEstadoMunicipioPorPais = function(args) {
        var widget = args.owner.field.widget;
        widget.getField('NMMUNICIPIO').dataSourceFilter.find(x=>x.name == 'SGESTADO').value = widget.currentRow.SGESTADO;
        widget.getField('NMMUNICIPIO').dataSourceFilter.find(x=>x.name == 'SGESTADO').operator = "=";
        widget.currentRow.NMMUNICIPIO = "";
        if (!widget.currentRow.SGESTADO) {
            widget.getField('NMMUNICIPIO').dataSourceFilter.find(x=>x.name == 'SGESTADO').value = "0";
            widget.getField('NMMUNICIPIO').dataSourceFilter.find(x=>x.name == 'SGESTADO').operator = ">";
        }
    };

    this.setProcesso = function(widget) {
        if (widget.isValid()) {
            if (ABUtilController.validaDtIniMenorIgualDtFin(widget.currentRow.DTINIVIGENCIA, widget.currentRow.DTFIMVIGENCIA)) {
                if (!widget.backupRow) {
                    widget.currentRow.__is_new = true;
                } else {
                    widget.currentRow.__is_new = false;
                }
                restEngine.post('product#/setProcessoAdmJud', {
                    'requestType': 'DataSet',
                    'dataset': [widget.currentRow]
                }).
                then(function(data) {
                    if (data.notifications[0].type === "success") {
                        ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                        if (widget.currentRow.__is_new) {
                            ABUtilController.masterDetailVoltarList(widget);
                            widget.reload();
                        } else {
                            widget.backupRow = null;
                            widget.view();
                        }
                        self.mudarVisibilidadeWidgets(widget.widgets, true);
                    } else {
                        ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                    }
                }).
                catch(function(e) {
                    var error;
                    if (e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;

                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });

            } else {
                ScreenService.showMessage(Messages.DTINI_POST_DTFIM_ERROR);
                return false;
            }
        }
    };

    this.deleteProcesso = function(args) {
        var widget = args.owner.widget;
        ScreenService.confirmMessage(Messages.DELETE_ROW, 'CONFIRMATION',
            function() {
                restEngine.post('product#/deleteProcessoAdmJud', {
                    'requestType': 'DataSet',
                    'dataset': [widget.currentRow]
                }).
                then(function(data) {
                    if (data.notifications[0].type === "success") {
                        ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    } else {
                        ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                    }
                }).
                catch(function(e) {
                    var error;
                    if (e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;

                    ScreenService.showMessage(error, 'ERROR');
                });
            }
        );
    };

    this.setItemProcesso = function(widget) {
        if (widget.isValid()) {
            if (ABUtilController.validaDtIniMenorIgualDtFin(widget.currentRow.DTINIVIGENCIAProcesso, widget.currentRow.DTFINVIGENCIAProcesso)) {
                if (!widget.backupRow) {
                    widget.currentRow.__is_new = true;
                } else {
                    widget.currentRow.__is_new = false;
                }
                widget.currentRow.NRPROCESSADMJUD = templateManager.container.getWidget('procAdminJud').currentRow.NRPROCESSADMJUD;
                restEngine.post('product#/setItemProcessoAdmJud', {
                    'requestType': 'DataSet',
                    'dataset': [widget.currentRow]
                }).
                then(function(data) {
                    if (data.notifications[0].type === "success") {
                        ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                        if (widget.currentRow.__is_new) {
                            ABUtilController.masterDetailVoltarList(widget);
                            widget.reload();
                        } else {
                            ABUtilController.masterDetailVoltarList(widget);
                            widget.reload();
                        }
                    } else {
                        ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                    }
                }).
                catch(function(e) {
                    var error;
                    if (e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;

                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });

            } else {
                ScreenService.showMessage(Messages.DTINI_POST_DTFIM_ERROR);
                return false;
            }
        }
    };

    this.deleteItemProcesso = function(args) {
        var widget = args.owner.widget;
        ScreenService.confirmMessage(Messages.DELETE_ROW, 'CONFIRMATION',
            function() {
                restEngine.post('product#/deleteItemProcessoAdmJud', {
                    'requestType': 'DataSet',
                    'dataset': [widget.currentRow]
                }).
                then(function(data) {
                    if (data.notifications[0].type === "success") {
                        ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    } else {
                        ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                    }
                }).
                catch(function(e) {
                    var error;
                    if (e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
            }
        );
    };

}

Configuration(function(ContextRegister) {
    ContextRegister.register('ProcessoAdmJudController', ProcessoAdmJudController);
});


// FILE: assets/js/controllers/ProcessoController.js
function ProcessoController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, General,Messages) {

    this.adicionarRow = function(args) {
        var widget = args.owner.widget;
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
    };

	this.setProcesso = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
                if (!widget.backupRow) {
                    widget.currentRow.__is_new = true;
                } else {
                    widget.currentRow.__is_new = false;
                }
                restEngine.post('product#/setProcesso', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                    then(function (data) {
                        if (data.notifications[0].type === "success") {
                            ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                            if (widget.currentRow.__is_new) {
                                ABUtilController.masterDetailVoltarList(widget);
                                widget.reload();
                            } else {
                                ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                                widget.backupRow = null;
                                widget.view();
                            }
                        } else {
                            ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                        }
                    }).
                    catch(function(e) {
                        var error;
                        if(e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;
                            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    });
            }
    };
    
    this.deleteProcesso = function(args) {
    ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
        var widget = args.owner.widget;
        widget.currentRow.__is_new = false;
        restEngine.post('product#/deleteProcesso', {'requestType':'DataSet','dataset':[widget.currentRow]}).
            then(function(data){
                if(data.notifications[0].type === "success"){
                    ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                    ABUtilController.masterDetailVoltarList(widget);
                    widget.reload();
                } else {
                    ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                }
            }).
            catch(function(e) {
                var error;
                if(e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
        }, null);
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('ProcessoController', ProcessoController);
});

// FILE: assets/js/controllers/ProcessoSeletivoController.js
/**
 * Created by leonardocarvalho on 29/02/2016.
 */
/* jshint esversion: 6 */
function ProcessoSeletivoController (ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, ABUtilController, CandidatosController, AdmissaoController) {
    
    var aprovado = 'N';
    var reprovado = 'S';
    var self = this;

    this.admitirCandidato = function(){
        ScreenService.confirmMessage('Deseja realmente admitir o candidato ?', 'CONFIRMATION', 
                function() {
                    this.verificaPontuacao();
                }.bind(this)
            );
    };

    this.buscaDadosCanditado = function(){
        var nrorg = getLocalVar("HCM_NRORG_TRAB");   
        var widget = templateManager.container.getWidget("processos");
        var widgetFase = templateManager.container.getWidget("fases");
        var widgetCandidatos = templateManager.container.getWidget("candidados_fase");
        restEngine.post("product#/buscaDadosCanditado",
            {
                requestType: "FilterData",
                filter: [{ operator: "=", name: "NRORG", value: nrorg}, { operator: "=", name: "NRPROCESSO", value: widget.currentRow.NRPROCESSO}, { operator: "=", name: "NRORDEM", value: widgetFase.currentRow.NRORDEM}, { operator: "=", name: "NRPARCNEGOCIO", value: widgetCandidatos.currentRow.NRPARCNEGOCIOCAND} ]
            }
        ).then(
            function(data){
                if(data.dataset.des_participafase_buscaDelete[0] === undefined) {
                    ScreenService.showMessage("Erro ao buscar dados");
                } else {
                    this.removerCandidatos(data.dataset.des_participafase_buscaDelete);
                }
            }.bind(this)
        ).catch(function(e) {
                var error;
                if(e.data.error === undefined)
                    error = e;
                else 
                    error = e.data.error;
                
                ScreenService.showMessage('Ocorreu um erro inesperado, contate o administrador informando o trecho abaixo: <br><br>' + error + '<br><br>', 'ERROR');
            });
    };

    this.buscarCandidatos = function(){
        var nrorg = getLocalVar("HCM_NRORG_TRAB");   
        var widget = templateManager.container.getWidget("processos");
        restEngine.post("product#/buscarCandidatos",
            {
                requestType: "FilterData",
                filter: [{ operator: "=", name: "NRORG", value: nrorg}, { operator: "=", name: "NRPROCESSO", value: widget.getField("NRPROCESSO").value()}, { operator: "=", name: "NRPARCNEGOCIO", value: null}]
            }
        ).then(
            function(data){
                if(data.dataset.candidatos_fase[0] === undefined) {
                    ScreenService.showMessage('Não há candidados participantes no processo.');
                } else {
                    templateManager.container.getWidget("candidados_fase").currentRow.__is_old_new = templateManager.container.getWidget("candidados_fase").currentRow.__is_new;
                    templateManager.container.getWidget("candidados_fase").currentRow.__is_new = true;
                    this.salvarCandidatos(data.dataset.candidatos_fase, true);
                }
            }.bind(this)
        ).catch(function(e) {
                var error;
                if(e.data.error === undefined)
                    error = e;
                else 
                    error = e.data.error;
                
                ScreenService.showMessage('Ocorreu um erro inesperado, contate o administrador informando o trecho abaixo: <br><br>' + error + '<br><br>', 'ERROR');
            });
    };

    this.calculaMediaPercentual = function(){
        var widgetProcessos = templateManager.container.getWidget("processos");
        var nrorg = getLocalVar("HCM_NRORG_TRAB");
        restEngine.post("product#/buscarPontuacoesUsuario",
            {
                requestType: "FilterData",
                filter: [{ operator: "=", name: "NRORG", value: nrorg}, {operator: "=", name: "NRPROCESSO", value: widgetProcessos.currentRow.NRPROCESSO}]
            }
        ).then(function(data){
            var widgetCandidatosFases = templateManager.container.getWidget("candidados_fase");
            if(data){
                if(widgetCandidatosFases.dataSource.data !== '[]')
                    ScreenService.showMessage('Média calculada com sucesso');
                else 
                    ScreenService.showMessage('Não há candidatos na fase para calcular a média'); 
            } else {
                ScreenService.showMessage('Não foi possivél calcular a média');
            }
            widgetCandidatosFases.reload();
        }).catch(function(e) {
                var error;
                if(e.data.error === undefined)
                    error = e;
                else 
                    error = e.data.error;
                
                ScreenService.showMessage('Ocorreu um erro inesperado, contate o administrador informando o trecho abaixo: <br><br>' + error + '<br><br>', 'ERROR');
            });
    };
    
    this.calculoDaPontuacaoCandidato = function(args){
        var widget = ABUtilController.checkWidget(args);
        var widget1 = templateManager.container.getWidget("fases");
        var nrorg = getLocalVar("HCM_NRORG_TRAB");
        restEngine.post("product#/calculaPontuacaoCandidato",
            {
                requestType: "FilterData",
                filter: [{ operator: "=", name: "NRORG", value: nrorg}, {operator: "=", name: "NRCRITERIORESUL", value: widget1.currentRow.NRCRITERIORESUL}]
            }
        ).then(
            function(data){
                if(data.dataset.faixacritresult_busca[0] === undefined) {
                    ScreenService.showMessage('Não há critério de pontuação para esta fase');
                } else {
                    var vrFase      = parseFloat(widget1.currentRow.VRFASE);
                    if(vrFase === null){
                        ScreenService.showMessage('Não há valor parametrizado para esta fase');
                    } else {
                        var vrPontuacao = parseFloat(widget.currentRow.NRPONTUACAO);
                        var criterios   = data.dataset.faixacritresult_busca;

                        var resultadoPercentual = Math.round((vrPontuacao * 100) / vrFase);
                        var cdtiporesultado;
                        var nmtiporesultado;
                        var dsstatus;
                        var cdstatus;
                        var inapto;

                        $.each(criterios, function(key, value) {
                            var vrinifaixaresul = parseFloat(criterios[key].VRINIFAIXARESUL);
                            var vrfinfaixaresul = parseFloat(criterios[key].VRFINFAIXARESUL);
                            
                            switch(criterios[key].IDFAIXACRIRESUL) {
                                case 'MAIOR_QUE':
                                    if (resultadoPercentual >= vrinifaixaresul) {
                                        inapto = criterios[key].IDINAPTODOAC;
                                        cdtiporesultado = criterios[key].CDTIPORESU;
                                        nmtiporesultado = criterios[key].NMTIPORESU;
                                        if(inapto === aprovado){
                                            dsstatus = 'Aprovado';
                                            cdstatus = 5;
                                        } else if(inapto === reprovado){ 
                                            dsstatus = 'Reprovado';
                                            cdstatus = 8;
                                        }
                                    } 

                                    break;
                                case 'MENOR_QUE':
                                    if (resultadoPercentual <= vrinifaixaresul) {
                                        cdtiporesultado = criterios[key].CDTIPORESU;
                                        nmtiporesultado = criterios[key].NMTIPORESU;
                                        inapto = criterios[key].IDINAPTODOAC;
                                        if(inapto === aprovado){
                                            dsstatus = 'Aprovado';
                                            cdstatus = 5;
                                        } else if(inapto === reprovado){ 
                                            dsstatus = 'Reprovado';
                                            cdstatus = 8;
                                        }
                                    }

                                    break;
                                case 'ENTRE':
                                    if (resultadoPercentual >= vrinifaixaresul && resultadoPercentual <= vrfinfaixaresul) {
                                        cdtiporesultado = criterios[key].CDTIPORESU;
                                        nmtiporesultado = criterios[key].NMTIPORESU;
                                        inapto = criterios[key].IDINAPTODOAC;
                                        if(inapto === aprovado){
                                            dsstatus = 'Aprovado';
                                            cdstatus = 5;
                                        } else if(inapto === reprovado){ 
                                            dsstatus = 'Reprovado';
                                            cdstatus = 8;
                                        }
                                    } else {
                                        cdtiporesultado = '02';
                                        nmtiporesultado = 'Reprovado';
                                        dsstatus = 'Reprovado';
                                        cdstatus = 8;
                                    }

                                    break;
                                case 'IGUAL':
                                    if (resultadoPercentual == vrinifaixaresul) {
                                        cdtiporesultado = criterios[key].CDTIPORESU;
                                        nmtiporesultado = criterios[key].NMTIPORESU;
                                        inapto = criterios[key].IDINAPTODOAC;
                                        if(inapto === aprovado){
                                            dsstatus = 'Aprovado';
                                            cdstatus = 5;
                                        } else if(inapto === reprovado){ 
                                            dsstatus = 'Reprovado';
                                            cdstatus = 8;
                                        }
                                    }

                                    break;
                                default:
                                    ScreenService.showMessage('Critério de resultado não identificado.');
                            }
                        });

                        widget.currentRow.CDTIPORESU = cdtiporesultado;
                        widget.currentRow.NMTIPORESU = nmtiporesultado;
                        widget.currentRow.NRPERCENTUAL = resultadoPercentual + '%';
                        widget.currentRow.CDSTATUS = cdstatus;
                        widget.currentRow.DSSTATUS = dsstatus;
                    }

                }
            }.bind(this)
        ).catch(function(e) {
            var error;
            if(e.data.error === undefined)
                error = e;
            else 
                error = e.data.error;
            
            ScreenService.showMessage('Ocorreu um erro inesperado, contate o administrador informando o trecho abaixo: <br><br>' + error + '<br><br>', 'ERROR');
        });
    };

    this.cancelarEdicao = function(args){
        var widget = ABUtilController.checkWidget(args);
        if(!Util.isUndefinedOrNull(widget.widgets[0]))
            widget.widgets[0].isVisible = true;

        if(widget.currentRow.__is_new) {
            var indexOfCurrentRow = widget.dataSource.data.indexOf(widget.currentRow);
            if(indexOfCurrentRow !== -1) {
                widget.dataSource.data.pop();
            }
            widget.list();
            ScreenService.closeSwipe();
            widget.activate();
        }
        else {
            Util.extend(widget.currentRow, widget.backupRow);
            widget.view();
        }
        if( widget.parent.parent.name !== 'candidatos'){
            this.setIdTipoComentario(args);
        }
    };

    this.closePopupMensagens = function(){
        var widgetMensagens = templateManager.container.getWidget('mensagens');
        widgetMensagens.currentRow = {};
        ABUtilController.masterDetailClosePopup(widgetMensagens);
    };

    this.confimarImportacao = function(){
        ScreenService.confirmMessage('Deseja importar os candidados participantes do processo ?', 'CONFIRMATION', 
                function() {
                    this.buscarCandidatos();
                }.bind(this)
            );
    };

    this.enableIdParecerFinal = function(args){
        var widget = ABUtilController.checkWidget(args);
        widget.currentRow.IDPARECERFINAL = null;
        widget.currentRow.DSENTPSICOLOGICA = null;
        widget.currentRow.DSRESULTESTES = null;
        if(!Util.isEmptyOrBlank(widget.backupRow)){
            if(widget.backupRow.IDTIPOCOMENTARIO == 'LAUDO'){
                widget.currentRow.DELETEPARECERFINAL = true;
            } else {
                widget.currentRow.DELETEPARECERFINAL = false;
            }
        }
        
        if(widget.currentRow.IDTIPOCOMENTARIO == 'LAUDO'){
            widget.getField("IDPARECERFINAL").isVisible = true;
            widget.getField("DSENTPSICOLOGICA").isVisible = true;
            widget.getField("DSRESULTESTES").isVisible = true;
            widget.getField("DSRESULTESTES").validations = {"required": {}};
            widget.getField("DSENTPSICOLOGICA").validations = {"required": {}};

        } else {
            widget.getField("IDPARECERFINAL").isVisible = false;
            widget.getField("DSENTPSICOLOGICA").isVisible = false;
            widget.getField("DSRESULTESTES").isVisible = false;
            widget.getField("DSRESULTESTES").validations = {};
            widget.getField("DSENTPSICOLOGICA").validations = {};
        }
    };

    this.enviarMensagem = function(){
        var widgetMensagens = templateManager.container.getWidget("mensagens");
        var widgetCandidatosFases = templateManager.container.getWidget("candidados_fase");
        var widgetProcessos = templateManager.container.getWidget("processos");
        if(widgetMensagens.isValid()){
            save = Object.assign({},{"CANDIDATOS": widgetCandidatosFases.dataSource.checkedRows}, {"MENSAGEM":  widgetMensagens.currentRow}, {"PROCESSO":  widgetProcessos.currentRow});
            restEngine.post("product#/enviarMensagem",
                {'requestType':'DataSet','dataset':[save]}
            ).then(
                function(data){
                    if(data.dataset.enviarMensagem[0] === undefined) {
                        ScreenService.showMessage('Erro ao enviar a mensagem');
                        ABUtilController.masterDetailClosePopup(widgetMensagens);
                    } else {
                        ScreenService.showMessage('Mensagem enviada com sucesso');
                        ABUtilController.masterDetailClosePopup(widgetMensagens);
                        widgetCandidatosFases.unSelectAll();
                    }
                    widgetMensagens.currentRow = {};
                }
            ).catch(function(e) {
                var error;
                if(e.data.error === undefined)
                    error = e;
                else 
                    error = e.data.error;
                
                ScreenService.showMessage('Ocorreu um erro inesperado, contate o administrador informando o trecho abaixo: <br><br>' + error + '<br><br>', 'ERROR');
            });
        }
    };

    this.enviarQuestionarios = function(args){
        var widget = ABUtilController.checkWidget(args);
        var widgetProcessos = templateManager.container.getWidget("processos");
        var params = {};
        if(widget.isValid()){
            widget.currentRow.NMESTRUTURAM = widgetProcessos.currentRow.NMESTRUTURAM;
            widget.currentRow.NMPROCESSO   = widgetProcessos.currentRow.NMPROCESSO;
            widget.currentRow.CDOPERADOR_LOG = getLocalVar("HCM_CDOPERADOR");
            widget.currentRow.NRORGOPERADOR = getLocalVar("HCM_NRORG_TRAB");
             widget.parent.parent.dataSource.data.forEach(function(candidato){
                if(Util.isEmptyOrBlank(candidato.NRCOMBQUESTAVAL)){
                    candidato.NRCOMBQUESTAVAL = null;
                }
                if(Util.isEmptyOrBlank(candidato.DTEXECUCAOAVAL)){
                    candidato.DTEXECUCAOAVAL = getLocalVar("HCM_DATA_ATUAL");
                }
                params.NRORG = candidato.NRORG;
                params.NRAVALIACAO = widget.currentRow.NRAVALIACAO;
                params.NRPARCEXECAVAL = candidato.NRPARCNEGOCIOCAND;
                params.NRPARCAVALIADO = candidato.NRPARCNEGOCIOCAND;
                params.DTEXECUCAOAVAL = candidato.DTEXECUCAOAVAL;
                params.NRCOMBQUESTAVAL = candidato.NRCOMBQUESTAVAL;
                candidato.linkQuestionario = ABUtilController.generateLink("https://hcmmobile.pebbian.com/#/hcm03000_avl_avaliacao_questionario", params);
            });
            save = Object.assign({}, widget.currentRow, {"CANDIDATOS":  widget.parent.parent.dataSource.data}, {"NRORGCANDIDATO": getLocalVar("HCM_NRORG_PADRAO")}, {"DATAATUAL": getLocalVar("HCM_DATA_ATUAL")});
            restEngine.post("product#/sendLinkQuestionario",
                {'requestType':'DataSet','dataset':[save]}
            ).then(
                function(data){
                    if(data) {
                        ScreenService.showMessage('Questionário enviado com sucesso');
                        ABUtilController.masterDetailClosePopup(widget);
                    } else {
                        ScreenService.showMessage('Erro: ' + data);
                        ABUtilController.masterDetailClosePopup(widget);
                    }
                }.bind(this)
            );
        }
    };

    this.finalizarFase = function(){
        ScreenService.confirmMessage('Deseja finalizar esta fase do processo ?', 'CONFIRMATION', 
            function() {
                this.verificaInativaProcesso(true);
            }.bind(this)
        );
    };

    this.finalizarFaseCandidato = function(){
        var widget = templateManager.container.getWidget("candidados_fase");
        var widget1 = templateManager.container.getWidget("processos");
        var widget2 = templateManager.container.getWidget("fases");
        var dados;
        restEngine.post("product#/verificarCandidatosAprovados",
            {
                requestType: "FilterData",
                filter: [{ operator: "=", name: "NRORDEM", value: widget2.currentRow.NRORDEM}, 
                         { operator: "=", name: "NRFASE", value: widget2.getField("NRFASE").value()}, 
                         { operator: "=", name: "NRORG", value: getLocalVar("HCM_NRORG_TRAB")}, 
                         { operator: "=", name: "NRPROCESSO", value: widget1.getField("NRPROCESSO").value()},
                         { operator: "=", name: "NRTEMPLATE", value: widget1.getField("NRTEMPLATE").value()}]
            }
        ).then(
            function(data){
                if(data.dataset.des_participafase_verifica[0] === undefined){
                     ScreenService.showMessage('Não há candidatos aprovados nesta fase ou todos já foram para próxima fase.');
                     ScreenService.closePopup();
                } else {
                    if(widget2.currentRow.IDOBRIGATORIO === 'S'){
                        dados = data.dataset.des_participafase_verifica;
                    } else {
                        dados = widget.dataSource.data;
                    }
                    save = Object.assign({},{"CANDIDATOS": dados}, {"NRORDEM":  widget2.currentRow.NRORDEM}, {"NRTEMPLATE": widget1.getField("NRTEMPLATE").value()}, {"NRORG": getLocalVar("HCM_NRORG_TRAB")}, {"CDOPERADOR_LOG": getLocalVar("HCM_CDOPERADOR")});
                    restEngine.post("product#/salvarCandidatosFase",
                        {'requestType':'DataSet','dataset':[save]}
                    ).then(
                        function(data){
                            if(data.dataset.des_participafase[0] === undefined) {
                                ScreenService.showMessage('Não há candidatos aprovados nesta fase.');
                                ScreenService.closePopup();
                            } else {
                                ScreenService.showMessage('Fase finalizada com sucesso.');
                                ScreenService.closePopup();
                            }
                        }
                    );
                }
            }
        ).catch(function(e) {
            var error;
            if(e.data.error === undefined)
                error = e;
            else 
                error = e.data.error;
            
            ScreenService.showMessage('Ocorreu um erro inesperado, contate o administrador informando o trecho abaixo: <br><br>' + error + '<br><br>', 'ERROR');
        });
    };

    this.finalizarProcesso = function(args){
        var widgetCandidatos = args.owner.widget;
        var widgetProcessos = templateManager.container.getWidget("processos");
        var widgetFases = templateManager.container.getWidget("fases");
        var dtatual = getLocalVar("HCM_DATA_ATUAL");
        if(widgetFases.currentRow.IDOBRIGATORIO === 'N' || (widgetFases.currentRow.IDOBRIGATORIO === 'S' && widgetCandidatos.dataSource.data[0] !== undefined)) {
            ScreenService.confirmMessage('Deseja realmente finalizar este processo?', 'CONFIRMATION', 
                function() {
                    restEngine.post("product#/setDtConclusaoProcesso",
                        {
                            requestType: "FilterData",
                            filter: [{ operator: "=", name: "NRORG", value: widgetProcessos.currentRow.NRORG}, { operator: "=", name: "NRPROCESSO", value: widgetProcessos.currentRow.NRPROCESSO}, { operator: "=", name: "DTATUAL", value: dtatual}]
                        }
                    ).then(
                        function(data){
                            if(data.dataset.setDtConclusaoProcesso[0] === false) {
                                ScreenService.showMessage('Erro finalizar o processo');
                            } else {
                                widgetProcessos.reload();
                                this.verificaConclusaoProcesso(args);
                                ScreenService.closePopup();
                                ScreenService.closeSwipe().then(function(){
                                    ScreenService.closeSwipe();
                                });
                                widgetCandidatos.reload();
                            }
                        }.bind(this)
                    ).catch(function(e) {
                        var error;
                        if(e.data.error === undefined)
                            error = e;
                        else 
                            error = e.data.error;
                        
                        ScreenService.showMessage('Ocorreu um erro inesperado, contate o administrador informando o trecho abaixo: <br><br>' + error + '<br><br>', 'ERROR');
                    });
                }.bind(this)
            );
        } else {
            ScreenService.showMessage('Não foi possivel finalizar o processo. A última fase é obrigátoria e está sem candidatos relacionados.');
        }
    };

    this.habilitarAdmissaoCandidatos = function(){
        var widgetFases = templateManager.container.getWidget("fases");
        var widgetCandidatosFases = templateManager.container.getWidget("candidados_fase");
        restEngine.post("product#/buscaNrOrdemMax",
            {
                requestType: "FilterData",
                filter: [{ operator: "=", name: "NRORG", value: getLocalVar("HCM_NRORG_TRAB")}, {operator: "=", name: "NRTEMPLATE", value: widgetFases.currentRow.NRTEMPLATE}]
            }
        ).then(
            function(data){
                widgetCandidatosFases.getAction('pontuarCandidatos').isVisible = true;
                if(widgetFases.currentRow.NRORDEM === data.dataset.maxNrOrdem[0].MNNRORDEM){
                    widgetCandidatosFases.getAction('admitirCandidato').isVisible = true;
                    widgetCandidatosFases.getAction('calcular').isVisible = true;
                    widgetCandidatosFases.getAction('finalizar').isVisible = false;
                    widgetCandidatosFases.getAction('finalizarProcesso').isVisible = true;
                    widgetCandidatosFases.getAction('pontuarCandidatos').showOnList = true;
                } else {
                    widgetCandidatosFases.getAction('admitirCandidato').isVisible = false;
                    widgetCandidatosFases.getAction('calcular').isVisible = false;
                    widgetCandidatosFases.getAction('finalizar').isVisible = true;
                    widgetCandidatosFases.getAction('finalizarProcesso').isVisible = false;
                    widgetCandidatosFases.getAction('pontuarCandidatos').showOnList = false;
                }
            }
        ).catch(function(e) {
            var error;
            if(e.data.error === undefined)
                error = e;
            else 
                error = e.data.error;
            
            ScreenService.showMessage('Ocorreu um erro inesperado, contate o administrador informando o trecho abaixo: <br><br>' + error + '<br><br>', 'ERROR');
        });
    };

    this.habilitarImportacaoCandidatos = function(){
        var widgetFases = templateManager.container.getWidget("fases");
        var widgetCandidatosFases = templateManager.container.getWidget("candidados_fase");
        restEngine.post("product#/buscaNrOrdemMin",
            {
                requestType: "FilterData",
                filter: [{ operator: "=", name: "NRORG", value: getLocalVar("HCM_NRORG_TRAB")}, {operator: "=", name: "NRTEMPLATE", value: widgetFases.currentRow.NRTEMPLATE}]
            }
        ).then(
            function(data){
                if(widgetFases.currentRow.NRORDEM === data.dataset.minNrOrdem[0].MNNRORDEM){
                    widgetCandidatosFases.getAction('importar').isVisible = true;
                } else {
                    widgetCandidatosFases.getAction('importar').isVisible = false;
                }
            }
        ).catch(function(e) {
            var error;
            if(e.data.error === undefined)
                error = e;
            else 
                error = e.data.error;
            
            ScreenService.showMessage('Ocorreu um erro inesperado, contate o administrador informando o trecho abaixo: <br><br>' + error + '<br><br>', 'ERROR');
        });
    };

    this.inserirPontuacoes = function(args){
        var widget = ABUtilController.checkWidget(args);
        if(widget.isValid()){
            var nrorg = getLocalVar("HCM_NRORG_TRAB"); 
            var candidatos = [];
            var widgetCandidatos = templateManager.container.getWidget("candidados_fase");
            var widgetProcessos = templateManager.container.getWidget("processos");
            var widgetFases = templateManager.container.getWidget("fases");
             widget.parent.parent.dataSource.checkedRows.forEach(function(candidato){
                candidato.NRPONTUACAO = widget.currentRow.NRPONTUACAO;
                candidato.NRPERCENTUAL = widget.currentRow.NRPERCENTUAL;
                candidato.NMTIPORESU = widget.currentRow.NMTIPORESU;
                candidato.CDTIPORESU = widget.currentRow.CDTIPORESU;
                candidato.CDSTATUS = widget.currentRow.CDSTATUS;
                widgetCandidatos.backupRow = true;
                candidatos.push(candidato);
            });
            saveData = Object.assign({}, {"NRORG": nrorg} , {"CANDIDATOS": candidatos}, {"CDOPERADOR_LOG": getLocalVar("HCM_CDOPERADOR")}, {"NRPROCESSO": widgetProcessos.getField("NRPROCESSO").value()}, {"NRFASE": widgetFases.getField("NRFASE").value()}, {"NRTEMPLATE": widgetProcessos.getField("NRTEMPLATE").value()}, {"__is_new": false});
            restEngine.post("product#/salvarCandidatosFaseTemplate",
            {'requestType':'DataSet','dataset':[saveData]}
        ).then(
            function(data){
                if(data.dataset.des_participafase[0] === undefined) {
                    ScreenService.showMessage('Erro ao inserir pontuações.');
                }else {
                    ScreenService.showMessage('Pontuações inseridas com sucesso.');
                    ABUtilController.masterDetailClosePopup(widget);
                }
            }
        ).catch(function(e) {
            var error;
            if(e.data.error === undefined)
                error = e;
            else 
                error = e.data.error;
            
            ScreenService.showMessage('Ocorreu um erro inesperado, contate o administrador informando o trecho abaixo: <br><br>' + error + '<br><br>', 'ERROR');
        });
            
        }
    };

    this.newRowComentarios = function(args){
        var widgetComentarios = templateManager.container.getWidget("comentarios_candidato");
        ABUtilController.newRow(args);
        widgetComentarios.currentRow.DTCOMENTARIO = getLocalVar("HCM_DATA_ATUAL");
        widgetComentarios.currentRow.NMOPERADOR = getLocalVar("HCM_NMOPERADOR");
        if(!Util.isUndefinedOrNull(templateManager.container.getWidget("fases"))){
            this.setIdTipoComentario(args);
            widgetComentarios.getField("IDPARECERFINAL").isVisible = false;
        } else {
            widgetComentarios.getField("IDTIPOCOMENTARIO").readOnly = true;
            widgetComentarios.getField("IDPARECERFINAL").isVisible = false;
            widgetComentarios.getField("NMFASE").readOnly = true;
        }
    };

    this.onEnter = function(){
        var widgetMensagens = templateManager.container.getWidget("mensagens");
        widgetMensagens.getField("DSMENSAGEM").placeholder = "Mnemônicos aceitos:" +
                                                            '\n\n' +
                                                            "[NOME_CANDIDATO] = Nome do candidado" +
                                                            '\n' +
                                                            "[NOME_PROCESSO] = Nome do processo" +
                                                            '\n' +
                                                            "[ESTRUTURA_PROCESSO] = Nome da empresa relacionada ao processo";
    };

    this.onEnterQuestionario = function(args){
        var widget = ABUtilController.checkWidget(args);
        widget.getField("DSMENSAGEM").placeholder = "Mnemônicos aceitos:" +
                                                            '\n\n' +
                                                            "[NOME_CANDIDATO] = Nome do candidado" +
                                                            '\n' +
                                                            "[NOME_PROCESSO] = Nome do processo" +
                                                            '\n' +
                                                            "[ESTRUTURA_PROCESSO] = Nome da empresa relacionada ao processo" +
                                                            '\n' +
                                                            "[LINK_QUESTIONARIO] = Link para o questionário";
    };

    this.openCandidatos = function(args){
        var widget = templateManager.container.getWidget("processos");
        var widget1 = templateManager.container.getWidget("fases");
        var nrprocesso = widget.getField("NRPROCESSO").value();
        var nrfase = widget1.getField("NRFASE").value();
        var widget2 = templateManager.container.getWidget("candidados_fase");
        var fasesDataSourceFilter = widget2.dataSourceFilter;
        widget2.getAction('reprovar').isVisible = true;
        widget2.getAction('liberarQuestionario').isVisible = true;
        ScreenService.openSwipe(templateManager.container.getWidget("tabbedCandidatos"));
        fasesDataSourceFilter[1].value = nrprocesso;
        fasesDataSourceFilter[2].value = nrfase;
        widget2.reload();
        if(this.verificaConclusaoProcesso(args)){
            this.habilitarImportacaoCandidatos();
            this.habilitarAdmissaoCandidatos();
        }
    };

    this.openComentarios = function(args){
        var widgetComentarios = templateManager.container.getWidget("comentarios_candidato");
        var comentarioDataSourceFilter = widgetComentarios.dataSourceFilter;

        comentarioDataSourceFilter[1].value = templateManager.container.getWidget("processos").currentRow.NRPROCESSO;
        comentarioDataSourceFilter[2].value = templateManager.container.getWidget("candidados_fase").currentRow.NRPARCNEGOCIOCAND;
        comentarioDataSourceFilter[3].value = templateManager.container.getWidget("fases").currentRow.NRFASE;

        widgetComentarios.reload();
    };

    this.openPopupMensagem = function(){
        var widget = templateManager.container.getWidget('mensagens');
        widget.isVisible = true;
        ABUtilController.masterDetailOpenPopup(widget);
    };

    this.reprovarCandidatos = function(args){
        ScreenService.confirmMessage('Deseja reprovar os candidados sem notas da fase ?', 'CONFIRMATION', 
                function() {
                    var widgetFase = templateManager.container.getWidget("fases");
                    var widgetProcesso = templateManager.container.getWidget("processos");
                    restEngine.post("product#/setReprovados",
                        {
                            requestType: "FilterData",
                            filter: [{ operator: "=", name: "NRPROCESSO", value: widgetProcesso.currentRow.NRPROCESSO}, { operator: "=", name: "NRORG", value: widgetFase.currentRow.NRORG}, { operator: "=", name: "NRFASE", value: widgetFase.currentRow.NRFASE}]
                        }
                    ).then(function(data){
                        args.owner.widget.reload();
                        ScreenService.closePopup();
                    });
                }.bind(this)
            );
    };

    this.salvarCandidatos = function(dados, tipo = false){
        var nrorg = getLocalVar("HCM_NRORG_TRAB"); 
        var widget = templateManager.container.getWidget("processos");
        var widget1 = templateManager.container.getWidget("fases");
        var widget2 = templateManager.container.getWidget("candidados_fase");
        widget2.widgets[0].isVisible = true;
        if(Util.isEmptyOrBlank(widget2.currentRow.__is_old_new)){
            if(!widget2.backupRow){
                widget2.currentRow.__is_new = true;
                tipo = true;
            } else {
                widget2.currentRow.__is_new = false;
                dados = new Array(dados); 
            }
        }
        saveData = Object.assign({}, {"NRORG": nrorg} , {"CANDIDATOS": dados}, {"CDOPERADOR_LOG": getLocalVar("HCM_CDOPERADOR")}, {"NRPROCESSO": widget.getField("NRPROCESSO").value()}, {"NRFASE": widget1.getField("NRFASE").value()}, {"NRTEMPLATE": widget.getField("NRTEMPLATE").value()}, {"__is_new": widget2.currentRow.__is_new});
        restEngine.post("product#/salvarCandidatosFaseTemplate",
            {'requestType':'DataSet','dataset':[saveData]}
        ).then(
            function(data){
                if(!Util.isEmptyOrBlank(widget2.currentRow.__is_old_new)){
                    widget2.currentRow.__is_new = widget2.currentRow.__is_old_new;
                }   

                if(data.dataset.des_participafase[0] === undefined) {
                    ScreenService.showMessage('Erro ao importar candidados');
                } else {
                    if(tipo){
                        widget2.reload().then(function() {
                            ScreenService.showMessage('Candidados importados com sucesso.');
                            ScreenService.closePopup();
                        });
                    } else {
                        widget2.view();
                        widget2.reload();
                    }
                }
            }
        ).catch(function(e) {
            var error;
            if(e.data.error === undefined)
                error = e;
            else 
                error = e.data.error;
            
            ScreenService.showMessage('Ocorreu um erro inesperado, contate o administrador informando o trecho abaixo: <br><br>' + error + '<br><br>', 'ERROR');
        });
    };

    this.salvarComentarios = function(){
        var widgetComentarios = templateManager.container.getWidget("comentarios_candidato");
        var widgetCandidatos = templateManager.container.getWidget("candidados_fase");

        if(widgetComentarios.isValid()) {
            widgetComentarios.currentRow.NRPARCNEGOCIOCAND = widgetCandidatos.currentRow.NRPARCNEGOCIOCAND;
            widgetComentarios.currentRow.NRORG             = getLocalVar("HCM_NRORG_TRAB");
            widgetComentarios.currentRow.CDOPERRESPONSAVEL = getLocalVar("HCM_CDOPERADOR"); 
            widgetComentarios.currentRow.NRFASE            = templateManager.container.getWidget("fases").currentRow.NRFASE;
            widgetComentarios.currentRow.NRPROCESSO        = widgetCandidatos.currentRow.NRPROCESSO; 

            if(widgetComentarios.backupRow === undefined || !widgetComentarios.backupRow.DSCOMENTARIO){
                widgetComentarios.currentRow.__is_new = true;        
            } else {
                widgetComentarios.currentRow.__is_new = false;      
            }
            return widgetComentarios.saveRow().then(function(){
               if (widgetComentarios.currentRow.__is_new) {
                    ABUtilController.masterDetailVoltarList(widgetComentarios);
                    widgetComentarios.reload();
                } else {
                    ABUtilController.mudarVisibilidadeWidgets(widgetComentarios.widgets, true);
                    widgetComentarios.backupRow = null;
                    widgetComentarios.view();
                }
            }).catch(function(e) {
                var error;
                if(e.data.error === undefined)
                    error = e;
                else 
                    error = e.data.error;
                
                ScreenService.showMessage('Ocorreu um erro inesperado, contate o administrador informando o trecho abaixo: <br><br>' + error + '<br><br>', 'ERROR');
            });   
        }
    };

    this.setCampoTitulo = function(){
        var widgetMensagens = templateManager.container.getWidget("mensagens");
        widgetMensagens.currentRow.DSTITULOMENSAGEM = widgetMensagens.currentRow.DSASSUNTOMENSAGEM;
    };

    this.setIdTipoComentario = function(args){
        var widgetFase = templateManager.container.getWidget("fases");
        var widget = ABUtilController.checkWidget(args);
        if(widgetFase.currentRow.NRORDEM == widgetFase.currentRow.MAXNRORDEM){
            if(widget.dataSource.data[0] && Util.toBoolean(widget.dataSource.data[0].EXISTSLAUDO)){
                widget.getField("IDTIPOCOMENTARIO").readOnly = true;
                if(widget.currentRow.IDTIPOCOMENTARIO){
                    if (widget.currentRow.IDTIPOCOMENTARIO == 'LAUDO'){
                        widget.getField("IDPARECERFINAL").isVisible = true;
                        widget.getField("DSENTPSICOLOGICA").isVisible = true;
                        widget.getField("DSRESULTESTES").isVisible = true;
                        widget.getField("IDTIPOCOMENTARIO").readOnly = false;
                        widget.getField("DSRESULTESTES").validations = {"required": {}};
                        widget.getField("DSENTPSICOLOGICA").validations = {"required": {}};

                    } else {
                        widget.getField("IDPARECERFINAL").isVisible = false;
                        widget.getField("DSENTPSICOLOGICA").isVisible = false;
                        widget.getField("DSRESULTESTES").isVisible = false;
                        widget.getField("IDTIPOCOMENTARIO").readOnly = true;
                        widget.getField("DSRESULTESTES").validations = {};
                        widget.getField("DSENTPSICOLOGICA").validations = {};
                    }
                }
            } else {
                widget.getField("IDTIPOCOMENTARIO").readOnly = false;
            }
        } else {
            widget.getField("IDTIPOCOMENTARIO").readOnly = true;
        }
    };

    this.setNrAvaliacao = function(args){
        var widget = ABUtilController.checkWidget(args);
        if(widget.isValid()){
            save = Object.assign({}, widget.currentRow, {"CANDIDATOS":  widget.parent.parent.dataSource.data});
            restEngine.post("product#/setNrAvaliacao",
                {'requestType':'DataSet','dataset':[save]}
            ).then(
                function(data){
                    if(Util.isEmptyOrBlank(data)) {
                        this.enviarQuestionarios(args);
                    } else {
                        ScreenService.showMessage('Erro: ' + data);
                        ABUtilController.masterDetailClosePopup(widget);
                    }
                }.bind(this)
            );
        }
    };

    this.removeComentarios = function () {
        var widgetComentarios = templateManager.container.getWidget('comentarios_candidato');
        if(widgetComentarios.currentRow.CDOPERRESPONSAVEL === getLocalVar("HCM_CDOPERADOR")){
            var data = {};
            widgetComentarios.dataSource.checkedRows = widgetComentarios.currentRow;
            widgetComentarios.removeCheckedRows();
            ABUtilController.masterDetailVoltarList(widgetComentarios);
            widgetComentarios.reload();
            ScreenService.showMessage("Mensagem excluída com sucesso");

        } else {
            ScreenService.showMessage("Não foi possivel remover o comentário");
        }
    };

    this.removerCandidatos = function(saveData){
        var widgetCandidatos = templateManager.container.getWidget("candidados_fase");
        restEngine.post('product#/removeCandidatosFaseTemplate', {'requestType':'DataSet','dataset':[saveData]}).
            then(function(data){
                if(data.notifications[0].type === "success"){
                    ScreenService.showMessage('Candidato removido com sucesso');
                    ABUtilController.masterDetailVoltarList(widgetCandidatos);
                    widgetCandidatos.reload();
                } else {
                    ScreenService.showMessage('Erro ao remover o candidato');
                }
            }).catch(function(e) {
                var error;
                if(e.data.error === undefined)
                    error = e;
                else 
                    error = e.data.error;
                
                ScreenService.showMessage('Ocorreu um erro inesperado, contate o administrador informando o trecho abaixo: <br><br>' + error + '<br><br>', 'ERROR');
            });
    };
    
    this.removeComentarios = function () {
        var widgetComentarios = templateManager.container.getWidget('comentarios_candidato');
        if(widgetComentarios.currentRow.CDOPERRESPONSAVEL === getLocalVar("HCM_CDOPERADOR")){
            var data = {};
            widgetComentarios.dataSource.checkedRows = widgetComentarios.currentRow;
            widgetComentarios.removeCheckedRows();
            ABUtilController.masterDetailVoltarList(widgetComentarios);
            widgetComentarios.reload();
            ScreenService.showMessage("Comentário excluído com sucesso");

        } else {
            ScreenService.showMessage("Não foi possivel remover o comentário");
        }
    };

    this.retiraDataSourceFilter = function(){
        var widget = templateManager.container.getWidget("processos");
        var candidatosDataSourceFilter = widget.dataSourceFilter;
        if(!!candidatosDataSourceFilter[1])
            candidatosDataSourceFilter[1].value = null;
    };

    this.verificaConclusaoProcesso = function(args){
        var widgetProcessos = templateManager.container.getWidget("processos");
        var widgetCandidatos = templateManager.container.getWidget("candidados_fase");
        var ret;
        var ignoreActions = Array('back_list', 'back_view', 'checked_rows', 'back_edit');

        if(widgetProcessos.currentRow.DTCONCLUSAO !== null && widgetProcessos.currentRow.DTCONCLUSAO !== undefined && !Util.toBoolean(widgetProcessos.currentRow.VAGAS_DISPONIVEIS)) {
            ret = false;
        } else {
            ret = true;
        }
        widgetCandidatos.actions.forEach(function(action){
            if(ignoreActions.indexOf(action.showAsAction) > 0){
                action.isVisible = ret;
            }
        });
        return ret;
    };

    this.verificaDelete = function(){
        ScreenService.confirmMessage('O candidato será excluído também das fases seguintes. Deseja continuar?', 'CONFIRMATION', 
                function() {
                    this.buscaDadosCanditado();
                }.bind(this)
            );
    };

    this.verificaInativaProcesso = function(tela){
        var widgetFase = templateManager.container.getWidget("fases");
        var widgetProcessos = templateManager.container.getWidget("processos");

        if(widgetFase.currentRow.IDINATIVARPROCESSO === 'S'){
            restEngine.post("product#/alterarIdPublicaVaga",
                {
                    requestType: "FilterData",
                    filter: [{ operator: "=", name: "P_NRPROCESSO", value: widgetProcessos.currentRow.NRPROCESSO}]
                }
            ).then(
                function(data){
                    if(tela){
                        this.finalizarFaseCandidato();
                    } else {
                        this.calculaMediaPercentual();
                    }
                }.bind(this)
            ).catch(function(e) {
                var error;
                if(e.data.error === undefined)
                    error = e;
                else 
                    error = e.data.error;
                
                ScreenService.showMessage('Ocorreu um erro inesperado, contate o administrador informando o trecho abaixo: <br><br>' + error + '<br><br>', 'ERROR');
            });
        } else {
            if(tela){
                this.finalizarFaseCandidato();
            } else {
                this.calculaMediaPercentual();
            }
        }
    };

    this.verificaPontuacao = function(){
        var widgetProcessoSeletivo = templateManager.container.getWidget("candidados_fase");
            if(widgetProcessoSeletivo.currentRow.NMTIPORESU === undefined){
                ScreenService.showMessage("Candidato sem pontuação");
            } else if(widgetProcessoSeletivo.currentRow.NMTIPORESU === "Aprovado"){
                this.verificaVinculo(widgetProcessoSeletivo.currentRow.NRCPFPESSOA, widgetProcessoSeletivo.currentRow.NRPARCNEGOCIOCAND);
            } else {
                ScreenService.showMessage("Candidato não aprovado no processo");
            }
    };

    this.verificaRemoverComentario = function(){
        ScreenService.confirmMessage('Deseja realmente excluir?', 'CONFIRMATION', 
                function() {
                    this.removeComentarios();
                }.bind(this)
            );
    };

    this.verificaTemplate = function(args){
        var widget = templateManager.container.getWidget("processos");
        var nrtemplate = widget.getField("NRTEMPLATE").value();
        if(nrtemplate === null || nrtemplate === undefined){
            ScreenService.showMessage('Não há template parametrizado para este processo.');
            ScreenService.closeSwipe();
        } else {
            ScreenService.openSwipe(templateManager.container.getWidget("tabbedFases"));
            var widget1 = templateManager.container.getWidget("fases");
            var fasesDataSourceFilter = widget1.dataSourceFilter;
            fasesDataSourceFilter[1].value = nrtemplate;
            widget1.reload();
        }
        setLocalVar("HCM_NRPROCESSO", widget.currentRow.NRPROCESSO);
    };

    this.verificaVinculo = function(cpf, nrparcnegocio){
        var nrorg = getLocalVar("HCM_NRORG_TRAB");
        setLocalVar('BTL_NRPARCNEGOCIOCAND', nrparcnegocio);
        restEngine.post("product#/verificaVinculo",
        {
            requestType: "FilterData",
            filter: [{operator: "=", name: "NRCPFPESSOA", value: cpf},{ operator: "=", name: "NRORG", value: nrorg}]
        },
        function(data){
            if(data.dataset.verificaVinculo[0] !== undefined) {
                ScreenService.showMessage('Candidato já admitido');
            } else {
                
                ScreenService.showCustomDialog("Qual tipo de admissão deseja realizar?", "CONFIRMATION", "question", [
                    {
            			label: "Admissão Completa",
            			code: function(e, deferred) {
            				ScreenService.openWindow('product#hcm04002_btl_processo_admissao');
            				deferred.resolve(e);
            			}
        		    },
        		    {
            			label: "Admissão Simplificada",
            			code: function(e, deferred) {
            			    var nrparcnegocio = getLocalVar("BTL_NRPARCNEGOCIOCAND");
                            var nrorg = getLocalVar("HCM_NRORG_PADRAO");
                            var dadosCandidato;
                            
                            restEngine.post("product#/dadosPessoaisCandidato", {
                                requestType: "FilterData",
                                filter: [{
                                    operator: "=",
                                    name: "NRPARCNEGOCIO",
                                    value: nrparcnegocio
                                }, {
                                    operator: "=",
                                    name: "NRORG",
                                    value: nrorg
                                }]
                            }).
                            then(function(data) {
                                if (data.dataset.dadosPessoaisCandidato[0]) {
                                    dadosCandidato = data.dataset.dadosPessoaisCandidato[0];
                                    
                    				AdmissaoController.setValidaIniciaContinuaAdmissao(true);
                                    AdmissaoController.setPessoaCadastrada(true);
                    				AdmissaoController.setDadosAdmissao(dadosCandidato.NRCPFPESSOA, dadosCandidato.NRPESSOA, dadosCandidato.NMOPERADOR.toUpperCase(), dadosCandidato.DTNASCPESSOA, 'UNICO');
                                    
                    				ScreenService.openWindow('product#hcm09015_eso_admissaoPreliminarSimplificada');
                                }
                            }).catch(function(e) {
                                var error;
                                if (e.data.error === undefined)
                                    error = e;
                                else
                                    error = e.data.error;
                    
                                ScreenService.showMessage('Ocorreu um erro inesperado, contate o administrador informando o trecho abaixo: <br><br>' + error + '<br><br>', 'ERROR');
                            });

            				deferred.resolve(e);
            			}
        		    },
        		    {
            			label: "Cancelar",
            			code: function(e, deferred) {
            				deferred.reject(e);
            				return;
            			}
        		    }
        		]);
            }
        });
    };
    
    this.resetActions = function(){
        var widget = templateManager.container.getWidget("candidados_fase");
        widget.getAction('admitirCandidato').isVisible = false;
        widget.getAction('calcular').isVisible = false;
        widget.getAction('finalizar').isVisible = false;
        widget.getAction('finalizarProcesso').isVisible = false;
        widget.getAction('pontuarCandidatos').isVisible = false;
        widget.getAction('importar').isVisible = false;
        widget.getAction('reprovar').isVisible = false;
        widget.getAction('liberarQuestionario').isVisible = false;
    };
    
    this.applyDefaultFilterValues = function() {
        var widget = templateManager.container.getActiveWidget();
        widget.getField('DTSOLICITA').defaultValue = getLocalVar('HCM_DTCOMPETENCIA_DIACORRENTE');
        widget.getField('DTLIMSOLICITA').defaultValue = getLocalVar('HCM_DATA_ULTIMO_DIACORRENTE');
    };

}

Configuration(function(ContextRegister) {
    ContextRegister.register('ProcessoSeletivoController', ProcessoSeletivoController);
});

// FILE: assets/js/controllers/ProcessosController.js
/**
 * Created by leonardocarvalho on 29/02/2016.
 */
function ProcessosController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, ProcessosServices, ABUtilController, RepositoryFactory, Query, Messages,General) {

    var self = this;
    var repositoryName;
    var repository;
    var templateBeforeFilter;
    var naoIniciado = 'Não iniciado';
    
    this.processosOnEnter = function(widgetProcessos){
        widgetProcessos.activate();

        var filtroProcessosDashboard = sessionStorage.getItem("filtroProcessosDashboard");
    
        if( typeof filtroProcessosDashboard == 'string' && filtroProcessosDashboard.length > 0){
            widgetProcessos.dataSourceFilter.forEach(function(filtro){
                if(filtro.name === 'FILTRO'){
                    filtro.value = filtroProcessosDashboard;
                }
            });
            widgetProcessos.reload();
        }
        else
            setFiltro(widgetProcessos);
    };
    
    this.alterarSessionStorageMenuOnClick = function(){
        sessionStorage.setItem("filtroProcessosDashboard", "");
    };
    
    this.adicionarCandidatoProcesso = function(args) {
        var widgetParticipantes = templateManager.container.getWidget('candidatosParticipantes');
        args.row.NRPROCESSO = getLocalVar('BTL_NRPROCESSO');

        if (args.owner.widget.isValid()) {
            restEngine.post("product#/adicionarCandidatoProcesso", {
                requestType: "DataSet",
                dataset: [args.row]
            }).then(function(data) {
                if (!Util.isUndefined(data.dataset.save)) {
                    ScreenService.successNotification("Candidato Adicionado com Sucesso", 10000);
                    widgetParticipantes.reload().then(function() {
                        ScreenService.closePopup();
                        widgetParticipantes.activate();
                    });
                }
            }).catch(function(e) {
                ScreenService.showMessage("Erro: " + e.data.error);
            });
        }
    };

    this.adicionarProcesso = function(args) {
        var widget = args.owner.widget;
        args.row.VRSALARIO = General.valueToFloat(args.row.VRSALARIO);
        if (widget.isValid()) {
            args.row.update = false;
            ProcessosServices.adicionarUpdateProcesso(args.row).then(function() {
                var widgetProcessos = templateManager.container.getWidget('processos');
                ScreenService.closeSwipe();
                args.owner. widget.parent.parent.currentWidget = args.owner.widget.parent.parent;
                widgetProcessos.activate();
                widgetProcessos.list();
                widget.isVisible = false;
                 widget.parent.parent.widgets[1].isVisible = true;
                 widget.parent.parent.showAsTab = true;
                 widget.parent.parent.reload();

                // this.closePopupAdicionarProcesso(args);
            }).catch(function(e) {
                var error;
                if (Util.isUndefined(e.data))
                    error = e;
                else
                    error = e.data.error;

                ScreenService.showMessage('Ocorreu um erro inesperado, contate o administrador informando o trecho abaixo: <br><br>' + error + '<br><br>', 'ERROR');
            });
        }
    };

    this.changeView = function(args) {
        var widget = args.owner;
        var fieldCandidatos = ['DSEMAILOPER', 'IDSEXOPESSOA', 'CDESTACIVIL', 'NMGRAUINSTR', 'NMPAIS', 'SGESTADO', 'NMMUNICIPIO'];
        $.each(fieldCandidatos, function(key, value) {
            widget.getField(value).showOnView = true;
        });
        templateManager.updateTemplate();
    };

    this.closePopupAdicionarProcesso = function(args) {
        templateManager.container.getWidget('processos').activate();
        ScreenService.closeSwipe();
        if (args.owner.widget.currentRow.__is_new) {
            var indexOfCurrentRow = args.owner. widget.parent.parent.dataSource.data.indexOf(args.owner.widget.currentRow);
            if (indexOfCurrentRow !== -1) {
                args.owner. widget.parent.parent.dataSource.data.pop();
            }
            args.owner. widget.parent.parent.list();
            args.owner. widget.parent.parent.currentWidget = args.owner.widget.parent.parent;
            args.owner. widget.parent.parent.activate();
        } else {
            Util.extend(args.owner.widget.currentRow, args.owner.widget.backupRow);
            args.owner. widget.parent.parent.view();
        }
        args.owner.widget.isVisible = false;
        args.owner. widget.parent.parent.widgets[1].isVisible = true;
        args.owner. widget.parent.parent.showAsTab = true;
        args.owner. widget.parent.parent.reload();
    };

    this.deleteProcesso = function(args) {
        ScreenService.confirmMessage(Messages.DELETE_ROW, 'CONFIRMATION',
            function() {

                var widget = args.owner.widget;
                restEngine.post("product#/deleteProcessos", {
                    requestType: "DataSet",
                    dataset: [args.row]
                }).then(function(data) {
                    if (!Util.isUndefined(data.dataset.delete)) {
                        ScreenService.successNotification("Processo removido com sucesso");
                        widget.reload().then(function() {
                            ScreenService.closeSwipe();
                            widget.list();
                        });
                    }
                }).catch(function(e) {
                    ScreenService.showMessage("Erro ao excluir o processo: " + e.data.error);
                });

            });
    };

    this.gerarCurriculo = function(argsRow) {
        setLocalVar('BTL_NRPARCNEGOCIOCAND', argsRow.NRPARCNEGOCIO);
        ABUtilController.gerarRelatorio('curriculo_candidato');
    };

    this.getLocalidadeEstrutura = function(args) {
        var widget = args.owner.owner.widget;

        restEngine.post("product#/getLocalidadeEstrutura", {
            requestType: "FilterData",
            filter: [{
                operator: "=",
                name: "P_NRORG",
                value: getLocalVar("HCM_NRORG_TRAB")
            }, {
                operator: "=",
                name: "P_NRESTRUTURAM",
                value: args.row.NRESTRUTURAM
            }]
        }).then(function(data) {
            if (!Util.isUndefined(data.dataset.getLocalidadeEstrutura)) {
                widget.currentRow.LOCALIDADE = data.dataset.getLocalidadeEstrutura[0].LOCALIDADE;
            }
        }).catch(function(e) {
            ScreenService.alertNotification("Erro ao buscar as vagas: " + e);
        });
    };

    this.getInformacoesCandidato = function(args) {
        var widget = args.owner.widget;
        var nrorg = getLocalVar("HCM_NRORG_TRAB");
        restEngine.post("product#/buscarCandidatos", {
            requestType: "FilterData",
            filter: [{
                operator: "=",
                name: "NRORG",
                value: nrorg
            }, {
                operator: "=",
                name: "NRPROCESSO",
                value: getLocalVar("BTL_NRPROCESSO")
            }, {
                operator: "=",
                name: "NRPARCNEGOCIO",
                value: widget.currentRow.NRPARCNEGOCIO
            }]
        }).then(
            function(data) {
                if (data.dataset.candidatos_fase[0] === undefined) {
                    ScreenService.showMessage('Candidato já associado ao processo seletivo');
                } else {
                    var dadosCandidatos = Array(data.dataset.candidatos_fase[0]);
                    this.getNrFase(args, dadosCandidatos);
                }
            }.bind(this)
        ).catch(function(e) {
            var error;
            if (Util.isUndefined(e.data))
                error = e;
            else
                error = e.data.error;

            ScreenService.showMessage('Ocorreu um erro inesperado, contate o administrador informando o trecho abaixo: <br><br>' + error + '<br><br>', 'ERROR');
        });
    };

    this.getNrFase = function(args, informacoes) {
        var widget = args.owner.widget;
        var nrorg = getLocalVar("HCM_NRORG_TRAB");
        restEngine.post("product#/getNrfase", {
            requestType: "FilterData",
            filter: [{
                operator: "=",
                name: "NRORG",
                value: nrorg
            }, {
                operator: "=",
                name: "NRPROCESSO",
                value: getLocalVar("BTL_NRPROCESSO")
            }]
        }).then(
            function(data) {
                if (data.dataset.getMinNrFase[0].MINNRFASE === null) {
                    ScreenService.showMessage("Este processo não possui template");
                } else {
                    this.importarCandidato(args, data.dataset.getMinNrFase[0].MINNRFASE, informacoes);
                }
            }.bind(this)
        ).catch(function(e) {
            var error;
            if (Util.isUndefined(e.data))
                error = e;
            else
                error = e.data.error;

            ScreenService.showMessage('Ocorreu um erro inesperado, contate o administrador informando o trecho abaixo: <br><br>' + error + '<br><br>', 'ERROR');
        });
    };

    this.habilitaTemplate = function(args) {
        var widget = args.owner;
        if (widget.currentRow.NMFASE === naoIniciado) {
            widget.getField("NMTEMPLATE").readOnly = false;
        } else {
            widget.getField("NMTEMPLATE").readOnly = true;
        }
    };

    this.importarCandidato = function(args, nrfase, dados) {
        var nrorg = getLocalVar("HCM_NRORG_TRAB");
        var widgetCandidatos = args.owner.widget;
        var widgetProcessos = templateManager.container.getWidget("processos");
        saveData = Object.assign({}, {
            "NRORG": nrorg
        }, {
            "CANDIDATOS": dados
        }, {
            "CDOPERADOR_LOG": getLocalVar("HCM_CDOPERADOR")
        }, {
            "NRPROCESSO": getLocalVar("BTL_NRPROCESSO")
        }, {
            "NRFASE": nrfase
        }, {
            "NRTEMPLATE": widgetProcessos.currentRow.NRTEMPLATE
        }, {
            "__is_new": true
        }, {
            "DSSTATUS": true
        });
        restEngine.post("product#/salvarCandidatosFaseTemplate", {
            'requestType': 'DataSet',
            'dataset': [saveData]
        }).then(
            function(data) {
                if (data.dataset.des_participafase[0] === undefined) {
                    ScreenService.showMessage('Erro ao importar candidato');
                } else {
                    ScreenService.showMessage('Candidato associado com sucesso.');
                    ABUtilController.masterDetailVoltarList(widgetCandidatos);
                }
            }
        ).catch(function(e) {
            var error;
            if (Util.isUndefined(e.data.error))
                error = e;
            else
                error = e.data.error;

            ScreenService.showMessage('Ocorreu um erro inesperado, contate o administrador informando o trecho abaixo: <br><br>' + error + '<br><br>', 'ERROR');
        });
    };

    /*this.onChangeStatus = function(args){
        var widget = args.owner.field.widget;
        if(args.row.CDSTATUS === '9'){
            widget.getField("DTSUSPENSAO").readOnly = false;
            widget.getField("DTSUSPENSAO").validations = {required: true};

        } else if(args.row.CDSTATUS === '7'){
            widget.getField("DTCANCELAMENTO").readOnly = false;
            widget.getField("DTCANCELAMENTO").validations = {required: true};

        } else if((widget.currentRow.DTSUSPENSAO !== undefined || widget.currentRow.DTCANCELAMENTO !== undefined) && (args.row.CDSTATUS === '7' || args.row.CDSTATUS === '9')) {
            widget.getField("DTRETORNO").readOnly = false;
            widget.getField("DTRETORNO").validations = {required: true};

        } else {
            widget.getField("DTSUSPENSAO").validations = {};
            widget.getField("DTCANCELAMENTO").validations = {};
            widget.getField("DTCANCELAMENTO").validations = {};
            widget.getField("DTCANCELAMENTO").readOnly = true;
            widget.getField("DTRETORNO").readOnly = true;
            widget.getField("DTSUSPENSAO").readOnly = true;

        }
    };*/

    this.openAdicionarProcesso = function() {
        var widget = templateManager.container.getWidget('adicionarProcesso');
        widget.isVisible = true;
        widget.currentRow = {};
        widget.currentRow.__is_new = true;
        //  widget.parent.parent.newRow();
        ScreenService.openSwipe(widget);
         widget.parent.parent.widgets[1].isVisible = false;
         widget.parent.parent.showAsTab = false;
        widget.showAsTab = true;
        widget.activate();
        widget.edit();
        // templateManager.updateTemplate();
        //ScreenService.openPopup(widget);
        // ScreenService.closeSwipe(1);
    };

    this.openEditProcessos = function(args) {
        var widget = args.owner.widget;
        /*if(args.row.CDSTATUS === '9'){
            widget.getField("DTSUSPENSAO").readOnly = false;
            widget.getField("DTSUSPENSAO").validations = {required: true};

        } else if(args.row.CDSTATUS === '7'){
            widget.getField("DTCANCELAMENTO").readOnly = false;
            widget.getField("DTCANCELAMENTO").validations = {required: true};

        } else if(widget.currentRow.DTSUSPENSAO !== undefined || widget.currentRow.DTCANCELAMENTO !== undefined) {
            widget.getField("DTRETORNO").readOnly = false;
            widget.getField("DTRETORNO").validations = {required: true};

        } else {
            widget.getField("DTSUSPENSAO").validations = {};
            widget.getField("DTCANCELAMENTO").validations = {};
            widget.getField("DTCANCELAMENTO").validations = {};
            widget.getField("DTCANCELAMENTO").readOnly = true;
            widget.getField("DTRETORNO").readOnly = true;
            widget.getField("DTSUSPENSAO").readOnly = true;

        }*/
        widget.edit();
    };

    this.openFiltroCandidatos = function() {
        var widget = templateManager.container.getWidget('filtroCandidatos');
        templateManager.updateTemplate();
        widget.activate();
        ABUtilController.masterDetailOpenPopup(widget);
    };

    this.openPopupAdicionarCandidatoProcesso = function() {
        var widget = templateManager.container.getWidget('candidatosCadastrados');
        ScreenService.openPopup(widget);
    };

    this.removerCandidatoProcesso = function(args) {
        var widgetParticipantes = templateManager.container.getWidget('candidatosParticipantes');
        var widget = templateManager.container.getActiveWidget();
        var data = [];
        data.NRPROCESSO = widget.currentRow.NRPROCESSO;
        data.NRPARCNEGOCIO = widget.currentRow.NRPARCNEGOCIO;
        
        var saveData = Object.assign({}, data, {
                        "NRORG": getLocalVar("HCM_NRORG_TRAB")
                    });

        if (args.owner.widget.isValid()) {
            restEngine.post("product#/removerCandidatoProcesso", {
                'requestType': "DataSet",
                'dataset': [saveData]
            }).then(function(data) {
                if (!Util.isUndefined(data.dataset.delete)) {
                    ScreenService.successNotification("Candidato(s) Removido(s) com Sucesso", 10000);
                    ABUtilController.masterDetailVoltarList(widgetParticipantes);
                    widgetParticipantes.reload().then(function() {
                        widgetParticipantes.activate();
                    });
                }
            }).catch(function(e) {
                ScreenService.showMessage("Erro: " + e.data.error);
            });
        }
    };

    this.removerCandidatoProcessoConfirm = function(args) {
        ScreenService.confirmMessage('Deseja remover o(s) candidatos(s) ?', null, function() {
            self.removerCandidatoProcesso(args);
        }, null);
    };

    this.salvarAlteracoesProcesso = function(args) {
        var widget = args.owner.widget;
        args.row.VRSALARIO = General.valueToFloat(args.row.VRSALARIO);
        if (widget.isValid()) {
            if (ABUtilController.validaDtIniMenorIgualDtFin(widget.currentRow.DTSOLICITA, widget.currentRow.DTLIMSOLICITA)) {
                args.row.update = true;
                ProcessosServices.adicionarUpdateProcesso(args.row).then(function() {
                    var widgetProcessos = templateManager.container.getWidget('processos');
                    widgetProcessos.widgets[1].isVisible = true;
                    widgetProcessos.view();
                }).catch(function(e) {
                    var error;
                    if (Util.isUndefined(e.data))
                        error = e;
                    else
                        error = e.data.error;
    
                    ScreenService.showMessage('Ocorreu um erro inesperado, contate o administrador informando o trecho abaixo: <br><br>' + error + '<br><br>', 'ERROR');
                });
            }else{
                ScreenService.showMessage(Messages.DTINI_POST_DTFIM_ERROR);
                return false;
            } 
        }
    };

    this.setDataSourceFilter = function(args, value) {
        var widget = args.owner;
        widget.dataSourceFilter[0].value = getLocalVar('HCM_NRORG_PADRAO');
        widget.dataSourceFilter[1].value = getLocalVar('BTL_NRPROCESSO');
        widget.dataSourceFilter[2].value = value;
    };

    var setFiltro = function(widgetProcessos) {
        //var widgetProcessos = templateManager.container.getWidget('processos');
        widgetProcessos.dataSourceFilter.forEach(function(filtro) {
            if (filtro.name === 'FILTRO') {
                filtro.value = '';
            }
        });
        widgetProcessos.reload();
    };

    this.setLocalidade = function(args) {
        var widgetProcessos = args.owner.field.widget;
        if(widgetProcessos.name != "filterPopup")
        widgetProcessos.currentRow.LOCALIDADE = (widgetProcessos.currentRow.NMMUNICIPIO + "/" + widgetProcessos.currentRow.SGESTADO);
    };

    this.setNomeProcesso = function() {
        var widget = templateManager.container.getActiveWidget();
        widget.currentRow.NMPROCESSO = widget.currentRow.NMOCUPACAOH;
    };

    this.setProcesso = function(argsRow) {
        setLocalVar('BTL_NRPROCESSO', argsRow.NRPROCESSO);
        var widgetCandidatos = templateManager.container.getWidget("candidatosParticipantes");
        widgetCandidatos.dataSourceFilter = [{
            name: "P_NRORG",
            operator: "=",
            value: getLocalVar('HCM_NRORG_PADRAO') ? getLocalVar('HCM_NRORG_PADRAO') : ''
        }, {
            name: "P_NRPROCESSO",
            operator: "=",
            value: getLocalVar('BTL_NRPROCESSO') ? getLocalVar('BTL_NRPROCESSO') : ''
        }, {
            name: "FILTRO",
            operator: "=",
            value: "false"
        }];
    };

    this.voltarView = function(args) {
        var widget = args.owner.widget;
        widget.widgets[1].isVisible = true;
        widget.view();
        widget.reload();
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('ProcessosController', ProcessosController);
});


// FILE: assets/js/controllers/ProdutoController.js
function ProdutoController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, General, Messages, $window) {
    
    
    
    this.adicionarRow = function(args) {
        var widget = args.owner.widget;
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
    };

    this.setProduto = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
            if (!widget.backupRow) {
                widget.currentRow.__is_new = true;
            }
            else {
                widget.currentRow.__is_new = false;
            }
            restEngine.post('/setProduto', {
                'requestType': 'DataSet',
                'dataset': [widget.currentRow]
            }).
            then(function(data) {
                if (data.notifications[0].type === "success") {
                    ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                    if (widget.currentRow.__is_new) {
                        ABUtilController.masterDetailVoltarList(widget);
                        ScreenService.closePopup();
                        widget.activate();
                        widget.reload();
                        widget.parent.activate();
                        widget.parent.reload();
                    /*    
                        this.dados = new Array();
                        this.dados['NMPRODUTO'] = widget.currentRow.NMPRODUTO;
                        this.dados['CDPRODUTO'] = data.dataset.produto[0].CDPRODUTO;
                    */    
                    }
                    else {
                        widget.backupRow = null;
                        widget.view();
                    }
                }
                else {
                    ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                }
            }).
            catch(function(e) {
                var error;
                if (e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
        }
    };

    this.setProdutoPopUp = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
            if (!widget.backupRow) {
                widget.currentRow.__is_new = true;
            }
            else {
                widget.currentRow.__is_new = false;
            }
            restEngine.post('/setProduto', {
                'requestType': 'DataSet',
                'dataset': [widget.currentRow]
            }).
            then(function(data) {
                if (data.notifications[0].type === "success") {
                    ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                    if (widget.currentRow.__is_new) {
                        ScreenService.closePopup();
                        widget.activate();
                        widget.reload();
                        widget.parent.activate();
                        widget.parent.reload();
                    /*    
                        this.dados = new Array();
                        this.dados['NMPRODUTO'] = widget.currentRow.NMPRODUTO;
                        this.dados['CDPRODUTO'] = data.dataset.produto[0].CDPRODUTO;
                    */    
                    }
                    else {
                        widget.backupRow = null;
                        widget.view();
                    }
                }
                else {
                    ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                }
            }).
            catch(function(e) {
                var error;
                if (e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
        }
    };

    this.deleteProduto = function(args) {
        ScreenService.confirmMessage('Deseja realmente excluir o arquivo ?', 'CONFIRMATION',
            function() {
                var widget = args.owner.widget;
                widget.currentRow.__is_new = false;
                restEngine.post('/deleteProduto', {
                    'requestType': 'DataSet',
                    'dataset': [widget.currentRow]
                }).
                then(function(data) {
                    if (data.messages) {
                        ScreenService.showMessage(data.messages[0].message);
                    }
                    else {
                        if (data.notifications[0].type === "success") {
                            ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                            ABUtilController.masterDetailVoltarList(widget);
                            widget.reload();
                        }
                        else {
                            ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                        }
                    }
                }).
                catch(function(e) {
                    var error;
                    if (e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
            });
    };


}
Configuration(function(ContextRegister) {
    ContextRegister.register('ProdutoController', ProdutoController);
});


// FILE: assets/js/controllers/ProgEntregaEPIController.js
function ProgEntregaEPIController(ScreenService, templateManager, restEngine, ABUtilController, Messages) {

    this.ALFABETICA_CAMPOS = ['NMINIVINCULOM', 'NMFIMVINCULOM'];
    this.ESTRUTURA_CAMPOS = ['NMESTRUTLEGAL', 'NMESTRUTGEREN'];
    this.DATA_ADMISSAO_CAMPOS = ['DTINIADMISSAO', 'DTFIMADMISSAO'];
    this.MATRICULA_CAMPOS = ['CDINIMATRICULA', 'CDFIMMATRICULA'];

    this.GRAVAR = 'gravar';
    this.SIMULAR = 'simular';

    this.habilitaCamposOrdem = function(widget, arrayCampos) {
        this.ALFABETICA_CAMPOS.concat(this.ESTRUTURA_CAMPOS,this.DATA_ADMISSAO_CAMPOS,this.MATRICULA_CAMPOS).forEach(function(campo) {
            if(arrayCampos.indexOf(campo) >= 0) {
                widget.getField(campo).isVisible = true;
                widget.getField(campo).validations = {"required": true};
            } else {
                widget.getField(campo).isVisible = false;
                widget.getField(campo).validations = {};
            }
        });
    };

    this.limpaOutrosCampos = function(widget, arrayCampos) {
        this.ALFABETICA_CAMPOS.concat(this.ESTRUTURA_CAMPOS,this.DATA_ADMISSAO_CAMPOS,this.MATRICULA_CAMPOS).forEach(function(campo) {
            if(arrayCampos.indexOf(campo) < 0) {
                widget.getField(campo).setValue('');
            }
        });
    };

    this.validaDataPostDtAtual = function(fieldDate) {
        var dateValue = fieldDate.value();
        if (dateValue !== "") {
            if (!ABUtilController.validaDataIgualPosteriorDtAtual(dateValue)) {
                ScreenService.alertNotification(Messages.DATA_POST_DTATUAL_ERROR);
            }
        }
    };

	this.salvar = function(args) {
        var widget = templateManager.container.getActiveWidget();
        if (widget.isValid()) {
            if (ABUtilController.validaDataIgualPosteriorDtAtual(widget.currentRow.DTINICIAL)) {
                if (ABUtilController.validaDataIgualPosteriorDtAtual(widget.currentRow.DTFINAL)) {
                    if (ABUtilController.validaDtIniMenorIgualDtFin(widget.currentRow.DTINICIAL, widget.currentRow.DTFINAL)) {
                        if (!widget.backupRow) {
                            widget.currentRow.__is_new = true;
                        } else {
                            widget.currentRow.__is_new = false;
                        }
                        widget.currentRow.QTHRDIAENTREPI = widget.currentRow.QTHRDIAENTREPI.replace(':','');
                        restEngine.post('product#/setFormprogepi', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                            then(function (data) {
                                if (data.notifications[0].type === "success") {
                                    ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                                    if (widget.currentRow.__is_new) {
                                        ABUtilController.masterDetailVoltarList(widget);
                                        widget.reload();
                                    } else {
                                        ABUtilController.mudarVisibilidadeWidgets(widget.widgets, false);
                                        widget.backupRow = null;
                                        widget.view();
                                    }
                                } else {
                                    ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                                }
                            }).
                            catch(function (e) {
                                var error;
                                if (e.data.error === undefined)
                                    error = e;
                                else
                                    error = e.data.error;

                                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                            });
                    } else {
                        ScreenService.alertNotification(Messages.DTINI_POST_DTFIM_ERROR);
                    }
                } else {
                    ScreenService.alertNotification(Messages.DATA_POST_DTATUAL_ERROR.replace('Data',widget.getField('DTFINAL').label));
                }
            } else {
                ScreenService.alertNotification(Messages.DATA_POST_DTATUAL_ERROR.replace('Data',widget.getField('DTINICIAL').label));
            }
        }
    };

    this.remover = function(args) {
    ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
        var widget = templateManager.container.getActiveWidget();
        if (widget.isValid()) {
            widget.currentRow.__is_new = false;
            restEngine.post('product#/deleteFormprogepi', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                then(function (data) {
                    if (data.notifications[0].type === "success") {
                        ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    } else {
                        ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                    }
                }).
                catch(function(e) {
                    var error;
                    if(e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;

                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
        }
        }, null);
    };

    this.setVisibilidadeCampos = function(widget) {
        var ordem = widget.currentRow.DSORDEM;

        switch(ordem) {
            case 'ALFABETICA':
                this.habilitaCamposOrdem(widget, this.ALFABETICA_CAMPOS);
                break;
            case 'MATRICULA':
                this.habilitaCamposOrdem(widget, this.MATRICULA_CAMPOS);
                break;
            case 'DATA_ADMISSAO':
                this.habilitaCamposOrdem(widget, this.DATA_ADMISSAO_CAMPOS);
                break;
            case 'ESTRUTURA':
                this.habilitaCamposOrdem(widget, this.ESTRUTURA_CAMPOS);
                widget.getField('NMESTRUTGEREN').validations = {};
                break;
            default :
                this.habilitaCamposOrdem(widget, []);
                break;
        }
    };

    this.setValorCamposBeforeSave = function(widget) {
        var ordem = widget.currentRow.DSORDEM;

        switch(ordem) {
            case 'ALFABETICA':
                widget.getField('DSINICIO').setValue(widget.currentRow.NMINIVINCULOM);
                widget.getField('DSFIM').setValue(widget.currentRow.NMFIMVINCULOM);
                this.limpaOutrosCampos(widget, this.ALFABETICA_CAMPOS);
                break;
            case 'MATRICULA':
                widget.getField('DSINICIO').setValue(widget.currentRow.CDINIMATRICULA);
                widget.getField('DSFIM').setValue(widget.currentRow.CDFIMMATRICULA);
                this.limpaOutrosCampos(widget, this.MATRICULA_CAMPOS);
                break;
            case 'DATA_ADMISSAO':
                widget.getField('DSINICIO').setValue(widget.currentRow.DTINIADMISSAO);
                widget.getField('DSFIM').setValue(widget.currentRow.DTFIMADMISSAO);
                this.limpaOutrosCampos(widget, this.DATA_ADMISSAO_CAMPOS);
                break;
            case 'ESTRUTURA':
                //widget.getField('DSINICIO').setValue(widget.currentRow.NRESTRUTLEGAL);
                widget.getField('DSFIM').setValue(widget.currentRow.NMESTRUTGEREN ? widget.currentRow.DSFIM : '');
                this.limpaOutrosCampos(widget, this.ESTRUTURA_CAMPOS);
                break;
        }
    };

    this.setDescricaoSelecionada = function(widget) {
        var ordem = widget.currentRow.DSORDEM;

        switch(ordem) {
            case 'ALFABETICA':
                widget.getField('NMINIVINCULOM').setValue(widget.currentRow.DSINICIO);
                widget.getField('NMFIMVINCULOM').setValue(widget.currentRow.DSFIM);
                break;
            case 'MATRICULA':
                widget.getField('CDINIMATRICULA').setValue(widget.currentRow.DSINICIO);
                widget.getField('CDFIMMATRICULA').setValue(widget.currentRow.DSFIM);
                break;
            case 'DATA_ADMISSAO':
                widget.getField('DTINIADMISSAO').setValue(widget.currentRow.DSINICIO);
                widget.getField('DTFIMADMISSAO').setValue(widget.currentRow.DSFIM);
                break;
            case 'ESTRUTURA':
                //widget.getField('NRESTRUTLEGAL').setValue(widget.currentRow.DSINICIO);
                //widget.getField('NRESTRUTGEREN').setValue(widget.currentRow.DSFIM);
                break;
        }
    };

    this.simularEntregaEPI = function(widget) {
        var widgetSimulacao = templateManager.container.getWidget('simulacao');
        widgetSimulacao.dataSourceFilter = [
            { name:'DSORDEM', operator:'=', value:widget.currentRow.DSORDEM },
            { name:'DSINICIO', operator:'=', value:widget.currentRow.DSINICIO },
            { name:'DSFIM', operator:'=', value:widget.currentRow.DSFIM },
            { name:'DTINICIAL', operator:'=', value:widget.currentRow.DTINICIAL },
            { name:'DTFINAL', operator:'=', value:widget.currentRow.DTFINAL },
            { name:'QTMINATENDMEDIO', operator:'=', value:widget.currentRow.QTMINATENDMEDIO },
            { name:'QTATENDENTREPI', operator:'=', value:widget.currentRow.QTATENDENTREPI },
            { name:'QTHRDIAENTREPI', operator:'=', value:widget.currentRow.QTHRDIAENTREPI }
        ];
        widgetSimulacao.reload();
    };

    this.habilitaWidgetSimulacao = function(widget){
        if (widget.dataSource.data.length > 0) {
            widget.isVisible = true;
            widget.activate();
            ScreenService.showMessage(Messages.SIMULACAO_SUCCESS, 'SUCCESS');
            ScreenService.closePopup();
        }
    };

    this.gravarEntregaEPI = function(args) {
        var widget = templateManager.container.getWidget('formProgEpi');
        restEngine.post('product#/gravarProgramacaoEntregaEpi', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
            then(function (data) {
                if (data.messages) {
                    ScreenService.showMessage(data.messages[0].message, data.messages[0].type);
                }
                else if (data.notifications && data.notifications[0].type === "success") {
                    ScreenService.showMessage(Messages.PROGRAMACAO_SUCCESS, 'SUCCESS');
                    ScreenService.closePopup();
                }
                else {
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR('ERROR'), 'ERROR');
                }
            }).
            catch(function(e) {
                var error;
                if(e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;

                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
    };

}

Configuration(function(ContextRegister) {
    ContextRegister.register('ProgEntregaEPIController', ProgEntregaEPIController);
});

// FILE: assets/js/controllers/ProgExamePeriodController.js
function ProgExamePeriodController(ScreenService, templateManager, restEngine, ABUtilController, Messages) {

    this.ALFABETICA_CAMPOS = ['NMINIVINCULOM', 'NMFIMVINCULOM'];
    this.ESTRUTURA_CAMPOS = ['NMESTRUTLEGAL', 'NMESTRUTGEREN'];
    this.DATA_ADMISSAO_CAMPOS = ['DTINIADMISSAO', 'DTFIMADMISSAO'];
    this.MATRICULA_CAMPOS = ['CDINIMATRICULA', 'CDFIMMATRICULA'];

    this.GRAVAR = 'gravar';
    this.SIMULAR = 'simular';

    this.habilitaCamposOrdem = function(widget, arrayCampos) {
        this.ALFABETICA_CAMPOS.concat(this.ESTRUTURA_CAMPOS,this.DATA_ADMISSAO_CAMPOS,this.MATRICULA_CAMPOS).forEach(function(campo) {
            if(arrayCampos.indexOf(campo) >= 0) {
                widget.getField(campo).isVisible = true;
                widget.getField(campo).validations = {"required": true};
            } else {
                widget.getField(campo).isVisible = false;
                widget.getField(campo).validations = {};
            }
        });
    };

    this.limpaOutrosCampos = function(widget, arrayCampos) {
        this.ALFABETICA_CAMPOS.concat(this.ESTRUTURA_CAMPOS,this.DATA_ADMISSAO_CAMPOS,this.MATRICULA_CAMPOS).forEach(function(campo) {
            if(arrayCampos.indexOf(campo) < 0) {
                widget.getField(campo).setValue('');
            }
        });
    };

    this.validaDataPostDtAtual = function(fieldDate) {
        var dateValue = fieldDate.value();
        if (dateValue !== "") {
            if (!ABUtilController.validaDataIgualPosteriorDtAtual(dateValue)) {
                ScreenService.alertNotification(Messages.DATA_POST_DTATUAL_ERROR);
            }
        }
    };

	this.salvar = function(args) {
        var widget = templateManager.container.getActiveWidget();
        if (widget.isValid()) {
            if (ABUtilController.validaDataIgualPosteriorDtAtual(widget.currentRow.DTINICIAL)) {
                if (ABUtilController.validaDataIgualPosteriorDtAtual(widget.currentRow.DTFINAL)) {
                    if (ABUtilController.validaDtIniMenorIgualDtFin(widget.currentRow.DTINICIAL, widget.currentRow.DTFINAL)) {
                        if (!widget.backupRow) {
                            widget.currentRow.__is_new = true;
                        } else {
                            widget.currentRow.__is_new = false;
                        }
                        widget.currentRow.QTHRDIAAVALIACAO = widget.currentRow.QTHRDIAAVALIACAO.replace(':','');
                        restEngine.post('product#/setFormprogexames', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                            then(function (data) {
                                if (data.notifications[0].type === "success") {
                                    ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                                    if (widget.currentRow.__is_new) {
                                        ABUtilController.masterDetailVoltarList(widget);
                                        widget.reload();
                                    } else {
                                        ABUtilController.mudarVisibilidadeWidgets(widget.widgets, false);
                                        widget.backupRow = null;
                                        widget.view();
                                    }
                                } else {
                                    ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                                }
                            }).
                            catch(function (e) {
                                var error;
                                if (e.data.error === undefined)
                                    error = e;
                                else
                                    error = e.data.error;

                                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                            });
                    } else {
                        ScreenService.alertNotification(Messages.DTINI_POST_DTFIM_ERROR);
                    }
                } else {
                    ScreenService.alertNotification(Messages.DATA_POST_DTATUAL_ERROR.replace('Data',widget.getField('DTFINAL').label));
                }
            } else {
                ScreenService.alertNotification(Messages.DATA_POST_DTATUAL_ERROR.replace('Data',widget.getField('DTINICIAL').label));
            }
        }
    };

    this.remover = function(args) {
    ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
        var widget = templateManager.container.getActiveWidget();
        if (widget.isValid()) {
            widget.currentRow.__is_new = false;
            restEngine.post('product#/deleteFormprogexames', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                then(function (data) {
                    if (data.notifications[0].type === "success") {
                        ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    } else {
                        ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                    }
                }).
                catch(function(e) {
                    var error;
                    if(e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;

                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
            }
        }, null);
    };

    this.setVisibilidadeCampos = function(widget) {
        var ordem = widget.currentRow.DSORDEM;

        switch(ordem) {
            case 'ALFABETICA':
                this.habilitaCamposOrdem(widget, this.ALFABETICA_CAMPOS);
                break;
            case 'MATRICULA':
                this.habilitaCamposOrdem(widget, this.MATRICULA_CAMPOS);
                break;
            case 'DATA_ADMISSAO':
                this.habilitaCamposOrdem(widget, this.DATA_ADMISSAO_CAMPOS);
                break;
            case 'ESTRUTURA':
                this.habilitaCamposOrdem(widget, this.ESTRUTURA_CAMPOS);
                widget.getField('NMESTRUTGEREN').validations = {};
                break;
            default :
                this.habilitaCamposOrdem(widget, []);
                break;
        }
    };

    this.setValorCamposBeforeSave = function(widget) {
        var ordem = widget.currentRow.DSORDEM;

        switch(ordem) {
            case 'ALFABETICA':
                widget.getField('DSINICIO').setValue(widget.currentRow.NMINIVINCULOM);
                widget.getField('DSFIM').setValue(widget.currentRow.NMFIMVINCULOM);
                this.limpaOutrosCampos(widget, this.ALFABETICA_CAMPOS);
                break;
            case 'MATRICULA':
                widget.getField('DSINICIO').setValue(widget.currentRow.CDINIMATRICULA);
                widget.getField('DSFIM').setValue(widget.currentRow.CDFIMMATRICULA);
                this.limpaOutrosCampos(widget, this.MATRICULA_CAMPOS);
                break;
            case 'DATA_ADMISSAO':
                widget.getField('DSINICIO').setValue(widget.currentRow.DTINIADMISSAO);
                widget.getField('DSFIM').setValue(widget.currentRow.DTFIMADMISSAO);
                this.limpaOutrosCampos(widget, this.DATA_ADMISSAO_CAMPOS);
                break;
            case 'ESTRUTURA':
                //widget.getField('DSINICIO').setValue(widget.currentRow.NRESTRUTLEGAL);
                widget.getField('DSFIM').setValue(widget.currentRow.NMESTRUTGEREN ? widget.currentRow.DSFIM : '');
                this.limpaOutrosCampos(widget, this.ESTRUTURA_CAMPOS);
                break;
        }
    };

    this.setDescricaoSelecionada = function(widget) {
        var ordem = widget.currentRow.DSORDEM;

        switch(ordem) {
            case 'ALFABETICA':
                widget.getField('NMINIVINCULOM').setValue(widget.currentRow.DSINICIO);
                widget.getField('NMFIMVINCULOM').setValue(widget.currentRow.DSFIM);
                break;
            case 'MATRICULA':
                widget.getField('CDINIMATRICULA').setValue(widget.currentRow.DSINICIO);
                widget.getField('CDFIMMATRICULA').setValue(widget.currentRow.DSFIM);
                break;
            case 'DATA_ADMISSAO':
                widget.getField('DTINIADMISSAO').setValue(widget.currentRow.DSINICIO);
                widget.getField('DTFIMADMISSAO').setValue(widget.currentRow.DSFIM);
                break;
            case 'ESTRUTURA':
                //widget.getField('NRESTRUTLEGAL').setValue(widget.currentRow.DSINICIO);
                //widget.getField('NRESTRUTGEREN').setValue(widget.currentRow.DSFIM);
                break;
        }
    };

    this.simularProgExames = function(widget) {
        var widgetSimulacao = templateManager.container.getWidget('simulacao');
        widgetSimulacao.dataSourceFilter = [
            { name:'DSORDEM', operator:'=', value:widget.currentRow.DSORDEM },
            { name:'DSINICIO', operator:'=', value:widget.currentRow.DSINICIO },
            { name:'DSFIM', operator:'=', value:widget.currentRow.DSFIM },
            { name:'DTINICIAL', operator:'=', value:widget.currentRow.DTINICIAL },
            { name:'DTFINAL', operator:'=', value:widget.currentRow.DTFINAL },
            { name:'QTMINATENDMEDIO', operator:'=', value:widget.currentRow.QTMINATENDMEDIO },
            { name:'QTATENDAVALIACAO', operator:'=', value:widget.currentRow.QTATENDAVALIACAO },
            { name:'QTHRDIAAVALIACAO', operator:'=', value:widget.currentRow.QTHRDIAAVALIACAO }
        ];
        widgetSimulacao.reload();
    };

    this.habilitaWidgetSimulacao = function(widget){
        if (widget.dataSource.data.length > 0) {
            widget.isVisible = true;
            widget.activate();
            ScreenService.showMessage(Messages.SIMULACAO_SUCCESS, 'SUCCESS');
            ScreenService.closePopup();
        }
    };

    this.gravarProgExames = function(args) {
        var widget = templateManager.container.getWidget('formprogexames');
        restEngine.post('product#/gravarProgramacaoExames', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
            then(function (data) {
                if (data.messages) {
                    ScreenService.showMessage(data.messages[0].message, data.messages[0].type);
                }
                else if (data.notifications && data.notifications[0].type === "success") { 
                    ScreenService.showMessage(Messages.PROGRAMACAO_SUCCESS, 'SUCCESS');
                    ScreenService.closePopup();
                }
                else {
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR('ERROR'), 'ERROR');
                }
            }).
            catch(function(e) {
                var error;
                if(e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;

                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
    };

}

Configuration(function(ContextRegister) {
    ContextRegister.register('ProgExamePeriodController', ProgExamePeriodController);
});

// FILE: assets/js/controllers/ProgramBancoHorasController.js
function ProgramBancoHorasController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, ABUtilController, AFormataHoraDecimal, Messages) {
   
    this.setProgBancoHoras = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
            if (this.validatevalues(widget.currentRow.QTMINIMAPROGBHORAS, widget.currentRow.QTMAXIMAPROGBHORAS)) {
                if (this.validatevalues(widget.currentRow.QTMINGATILHOPROGBHORAS, widget.currentRow.QTMAXGATILHOPROGBHORAS)) {
                    if (this.validaPeriodo(widget.currentRow.DTINICIOPROGBHORAS, widget.currentRow.DTFIMPROGBHORAS)) {
                        var checkboxs = [0,0,0,0,0,0,0];
                        var arraysemana = widget.currentRow.NMDIASSEMANA;
                        for(var k in arraysemana){
                            if(arraysemana[k] === 0){
                             checkboxs[0] = 1;    
                            }
                            if(arraysemana[k] === 1){
                             checkboxs[1] = 1;    
                            }
                            if(arraysemana[k] === 2){
                             checkboxs[2] = 1;    
                            }
                            if(arraysemana[k] === 3){
                             checkboxs[3] = 1;    
                            }
                            if(arraysemana[k] === 4){
                             checkboxs[4] = 1;    
                            }
                            if(arraysemana[k] === 5){
                             checkboxs[5] = 1;    
                            }
                            if(arraysemana[k] === 6){
                             checkboxs[6] = 1;    
                            }
                        }
                        widget.currentRow.IDDIASSEMANA = checkboxs.join('');
                        widget.currentRow.NRBANCOHORAS = templateManager.container.getWidget("banco_horas").currentRow.NRBANCOHORAS;
                        var tipo = false;
                        if (!widget.backupRow) {
                            widget.currentRow.__is_new = true;
                            tipo = true;
                        }
                        else {
                            widget.currentRow.__is_new = false;
                        }
                        var saveData = Object.assign({}, widget.currentRow, {
                            "NRORG": getLocalVar("HCM_NRORG_TRAB")
                        }, {
                            "CDOPERADOR_LOG": getLocalVar("HCM_CDOPERADOR")
                        });
                        restEngine.post('product#/setProgBancoHoras', {
                            'requestType': 'DataSet',
                            'dataset': [saveData]
                        }).
                        then(function(data) {
                            if (data.notifications[0].type === "success") {
                                ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 1000);
                                if(tipo){
                                    ABUtilController.masterDetailVoltarList(widget);
                                    widget.reload();
                                } else {
                                    widget.reload();
                                    widget.view();
                                    widget.activate();
                                }
                            }
                            else {
                                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                            }
                        }).catch(function(e) {
                            var error;
                            if (e.data.error === undefined)
                                error = e;
                            else
                                error = e.data.error;
                                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                        });
                    }
                    else {
                        ScreenService.showMessage('O campo "Fim Vigência" deve ser igual ou posterior ao campo "Início Vigência".');
                        return false;
                    }
                }
                else {
                    ScreenService.showMessage('O campo "Qtd. Máxima do Gatilho" deve ser igual ou posterior ao campo "Qtd. Mínima do Gatilho".');
                    return false;
                }
            }
            else {
                ScreenService.showMessage('O campo "Qtd. Máxima" deve ser igual ou posterior ao campo "Qtd. Mínima".');
                return false;
            }
        }
    };

    this.setFilterBancoHoras = function(argsRow){
        var widgetProgramacao = templateManager.container.getWidget("ProgBancoHoras");
        widgetProgramacao.dataSourceFilter[0].value = argsRow.NRBANCOHORAS;
    };

    this.validatevalues = function(valor1, valor2) {
        if (valor1 !== null && valor2 !== null) {
            if (valor2 < valor1) {
                return false;
            }
            else {
                return true;
            }
        }
        else {
            return true;
        }
    };

    this.validaPeriodo = function(dtIni, dtFin) {
        if (moment(dtIni, 'DD/MM/YYYY').unix() > moment(dtFin, 'DD/MM/YYYY').unix() || moment(dtFin, 'DD/MM/YYYY').unix() < moment(dtIni, 'DD/MM/YYYY').unix()) {
            return false;
        }
        else {
            return true;
        }
    };

    this.openAdicionarProgramacao = function(args){
        var widget = args.owner.widget;
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
    };

    this.setDiasSemana = function(args) {
        var widget = args.owner;
        var value = [];
        if(widget.currentRow.IDDIASSEMANA){
            var dados = widget.currentRow.IDDIASSEMANA.split("");
            if (dados[0] === "1") {
                value.push(0); 
            }
            if (dados[1] === "1") {
                value.push(1);
            }
            if (dados[2] === "1") {
                value.push(2);
            }
            if (dados[3] === "1") {
                value.push(3); 
            }
            if (dados[4] === "1") {
                value.push(4); 
            }
            if (dados[5] === "1") {
                value.push(5); 
            }
            if (dados[6] === "1") {
                value.push(6); 
            }
            widget.currentRow.NMDIASSEMANA = value;
        }
    };

    this.removeProgBancohoras = function(args) {
        ScreenService.confirmMessage(Messages.DELETE_ROW, 'CONFIRMATION', 
            function() {
                var widget = args.owner.widget;
                widget.currentRow.__is_new = false;
                var removeData = Object.assign({}, widget.currentRow, {
                    "NRORG": getLocalVar("HCM_NRORG_TRAB")
                }, {
                    "CDOPERADOR_LOG": getLocalVar("HCM_CDOPERADOR")
                });
                restEngine.post('product#/removeProgBancohoras', {
                    'requestType': 'DataSet',
                    'dataset': [removeData]
                }).
                then(function(data) {
                    if (data.notifications[0].type === "success") {
                        ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 1000);
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    }
                    else {
                        ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                    }
                }).catch(function(e) {
                    var error;
                    if (e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
            }
        );
    };
}
Configuration(function(ContextRegister) {
    ContextRegister.register('ProgramBancoHorasController', ProgramBancoHorasController);
});

// FILE: assets/js/controllers/ProgramacaoFeriasController.js
/* jshint esversion: 6 */
function ProgramacaoFeriasController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, $window, ABUtilController, Messages, RelatoriosHcmService) {
    
    this.openPopup = function(msg) {
        var widgetGozo = templateManager.container.getWidget('mensagensGozo');
        widgetGozo.dataSource.data = msg;
        ScreenService.openPopup(widgetGozo);
    };
    
    this.habilitarFiltros = function(args){
        args.owner.list();
    };
    
     this.gerarRelatorio_Prog = function(args, nmReport = null){  
        var widget = ABUtilController.checkWidget(args);
        var widgetVinculo = templateManager.container.getWidget("vinculos");
        var widgetFiltro = templateManager.container.getWidget("filtroProgFerias");
        
        /*Verifica se os campos requeridos estão preenchidos*/
        if(widget.isValid() || !!nmReport){
            if(!nmReport){
            nmReport = widget.NMREPORT;   
            }
            
            var vinculos = [];
            widgetVinculo.getCheckedRows().forEach(function(row){
                vinculos.push(row.NRVINCULOM);     
            }); 
            
            if(vinculos.length < 1){
                    ScreenService.showMessage('Para emitir o relatorio é preciso selecionar os vínculos');
                    return;
            }else{
                widget.currentRow.NRVINCULOM = vinculos.join(',');    
            }
            
            widget.currentRow.MESCOMPETENCIA = (widget.currentRow.DTMESCOMPETENC || getLocalVar('HCM_DTCOMPETENCIA_OPER'));
            
            var res = RelatoriosHcmService.gerarRelatorio_RCB(widget, getLocalVar('HCM_NRORG_TRAB'), getLocalVar('HCM_NRORG_PADRAO'), "RCB", nmReport, ABUtilController);
            if(res !== true){
                ScreenService.showMessage(res, 'ALERT');
            }
            ScreenService.closePopup();
        } else
            ScreenService.showMessage('ALERT');
    };
    
    this.openPopUpRelat = function(args, nmRelatorio, vinculo = false, nrtipomovimento = false){
        var widgetForm = templateManager.container.getWidget('formRelatorio');
        
        if(nrtipomovimento){
            widgetForm.tipomovimento = nrtipomovimento;
        }
        widgetForm.getField('DTMESCOMPETENC').isVisible = true;
        widgetForm.getField('DTMESCOMPETENC').validations = {required: true};
        widgetForm.currentRow.DTMESCOMPETENC = getLocalVar("HCM_DTCOMPETENCIA_OPER");
        switch(nmRelatorio){
            case 'aviso_previo_ferias':{
                widgetForm.label = "Aviso previo ferias";
                widgetForm.NMREPORT = 'aviso_previo_ferias';
                widgetForm.getField('DTINICIO').label = "Data Inicial de Gozo de Férias";
                widgetForm.getField('DTFIM').label = "Data Final de Gozo de Férias";
                
                widgetForm.getField('NUMBER1').isVisible = false;
                widgetForm.getField('NUMBER2').isVisible = false;
                widgetForm.getField('NUMBER3').isVisible = false;
                widgetForm.getField('NUMBER4').isVisible = false;
                widgetForm.getField('DATA1').isVisible = false;
                widgetForm.getField('DATA2').isVisible = false;
                widgetForm.getField('NMABREV').isVisible = false;
                widgetForm.getField('NMOPCOES1').isVisible = false;
                widgetForm.getField('NMOPCOES2').isVisible = false;
                widgetForm.getField('NMOPCOES3').isVisible = false;
                widgetForm.getField('NMOPCOES4').isVisible = false;
                widgetForm.getField('NMOPCOES5').isVisible = false;
                widgetForm.getField('NMOPCOES6').isVisible = false;
                widgetForm.getField('NMOPCOES7').isVisible = false;
                widgetForm.getField('NMOPCOES8').isVisible = false;
                widgetForm.getField('NMTIPOESTRUTURA').isVisible = false;
                widgetForm.getField('NMTIPOINCIDE').isVisible = false;
                widgetForm.getField('TEXTO1').isVisible = false;
                widgetForm.getField('DTINICIO').isVisible = true;
                widgetForm.getField('DTFIM').isVisible = true;
                widgetForm.getField('NMEVENTOH').isVisible = false;
                widgetForm.getField('DSOBSERVACAO').isVisible = false;
                widgetForm.getField('DTDOCUMENTO').isVisible = false;
                widgetForm.getField('NUMBER1').validations = {};
                widgetForm.getField('NUMBER2').validations = {};
                widgetForm.getField('DATA1').validations = {};
                widgetForm.getField('DATA2').validations = {};
                widgetForm.getField('NMEVENTOH').validations = {};
                widgetForm.getField('NMTIPOESTRUTURA').validations = {};
                widgetForm.getField('DTINICIO').validations = {};
                widgetForm.getField('DTFIM').validations = {};
                break;
            }
            case 'recibo_ferias':{
                widgetForm.label = "Recibo de ferias";
                widgetForm.NMREPORT = 'recibo_ferias';
                widgetForm.getField('DATA1').label = "Data Recibo/Lim. Prev. Fér.";
                widgetForm.getField('DTINICIO').label = "Data Inicial de Gozo de Férias";
                widgetForm.getField('DTFIM').label = "Data Final de Gozo de Férias";
                widgetForm.getField('NMOPCOES2').label = "2 Vias (Recibo de Férias)";
                widgetForm.getField('NMOPCOES3').label = "Somente Vínculos Ativos (Recibo de Férias)";
                
                widgetForm.getField('NUMBER1').isVisible = false;
                widgetForm.getField('NUMBER2').isVisible = false;
                widgetForm.getField('NUMBER3').isVisible = false;
                widgetForm.getField('NUMBER4').isVisible = false;
                widgetForm.getField('DATA1').isVisible = true;
                widgetForm.getField('DATA2').isVisible = false;
                widgetForm.getField('NMABREV').isVisible = false;
                widgetForm.getField('NMOPCOES1').isVisible = false;
                widgetForm.getField('NMOPCOES2').isVisible = true;
                widgetForm.getField('NMOPCOES3').isVisible = true;
                widgetForm.getField('NMOPCOES4').isVisible = false;
                widgetForm.getField('NMOPCOES5').isVisible = false;
                widgetForm.getField('NMOPCOES6').isVisible = false;
                widgetForm.getField('NMOPCOES7').isVisible = false;
                widgetForm.getField('NMOPCOES8').isVisible = false;
                widgetForm.getField('NMTIPOESTRUTURA').isVisible = false;
                widgetForm.getField('NMTIPOINCIDE').isVisible = false;
                widgetForm.getField('TEXTO1').isVisible = false;
                widgetForm.getField('DTINICIO').isVisible = true;
                widgetForm.getField('DTFIM').isVisible = true;
                widgetForm.getField('NMEVENTOH').isVisible = false;
                widgetForm.getField('DSOBSERVACAO').isVisible = false;
                widgetForm.getField('DTDOCUMENTO').isVisible = false;
                widgetForm.getField('NUMBER1').validations = {};
                widgetForm.getField('NUMBER2').validations = {};
                widgetForm.getField('DATA1').validations = {};
                widgetForm.getField('DATA2').validations = {};
                widgetForm.getField('NMEVENTOH').validations = {};
                widgetForm.getField('NMTIPOESTRUTURA').validations = {};
                widgetForm.getField('DTINICIO').validations = {};
                widgetForm.getField('DTFIM').validations = {};
                break;
            }
        }
        
        ScreenService.openPopup(widgetForm);
    };
    
    this.getVinculosProgFerias = function(){
        
        var widgetVinculo = templateManager.container.getWidget("vinculos");
        var widgetFiltro = templateManager.container.getWidget("filtroProgFerias");
        var currentRow = widgetFiltro.currentRow;
        var nrorg = getLocalVar("HCM_NRORG_TRAB");
        var dtcompetencia = getLocalVar("HCM_DTCOMPETENCIA_OPER");
        var vinculos = null;
        
        if(currentRow.NRVINCULOM_LIST){
            vinculos = currentRow.NRVINCULOM_LIST.join(',');    
        }
        
        var filtro = [
            {operator: "=", name : "P_NRORG", value : nrorg}, 
            {operator: "=", name : "P_DTMESCOMPETENC", value : dtcompetencia},
            {operator: "=", name : "P_NRVINCULOM", value : vinculos},
            {operator: "=", name : "P_NRESTRUTLEGAL", value : currentRow.NRESTRUTLEGAL},
            {operator: "=", name : "P_NRESTRUTGEREN", value : currentRow.NRESTRUTGEREN}
        ];
        
        restEngine.post("product#/getVinculosProgFerias", {
            requestType: "FilterData",
                filter: filtro}).
        then(function (data) {
            widgetVinculo.dataSource.data = data.dataset.getVinculosProgFerias;
        }).catch(function(e) {
            var error;
            if(e.data.error === undefined)
                error = e;
            else 
                error = e.data.error;
            
            ScreenService.showMessage('Ocorreu um erro inesperado, contate o administrador informando o trecho abaixo: <br><br>' + error + '<br><br>', 'ERROR');
        });
        
    };
    
    this.getItecalcfolhaProgFerias = function(){
        
        var widgetFiltro = templateManager.container.getWidget("filtroProgFerias");
        var currentRow = widgetFiltro.currentRow;
        var widgetFerias = templateManager.container.getWidget("ferias");
        var nrorg = getLocalVar("HCM_NRORG_TRAB");
        var dtcompetencia = getLocalVar("HCM_DTCOMPETENCIA_OPER");
        var vinculos = null;
        
        if(currentRow.NRVINCULOM_LIST){
            vinculos = currentRow.NRVINCULOM_LIST.join(',');    
        }
        
        var filtro = [
            {operator: "=", name : "P_NRORG", value : nrorg}, 
            {operator: "=", name : "P_DTMESCOMPETENC", value : dtcompetencia},
            {operator: "=", name : "P_NRVINCULOM", value : vinculos},
            {operator: "=", name : "P_NRESTRUTLEGAL", value : currentRow.NRESTRUTLEGAL},
            {operator: "=", name : "P_NRESTRUTGEREN", value : currentRow.NRESTRUTGEREN},
            {operator: "=", name : "P_NRTIPOMOVIMENT", value : 2},
            {operator: "=", name : "P_RESCISAO", value : 'N'}
        ];
        
        restEngine.post("product#/getItecalcfolhaProgFerias", {
            requestType: "FilterData",
                filter: filtro}).
        then(function (data) {
            widgetFerias.dataSource.data = data.dataset.getItecalcfolhaProgFerias;
        }).catch(function(e) {
            var error;
            if(e.data.error === undefined)
                error = e;
            else 
                error = e.data.error;
            
            ScreenService.showMessage('Ocorreu um erro inesperado, contate o administrador informando o trecho abaixo: <br><br>' + error + '<br><br>', 'ERROR');
        });
        
    };
    
    this.setGozoFeriasInline = function(args){
        var widget = ABUtilController.checkWidget(args);
        var row = [];
        
        for(var k in widget.dataSource.data){
            if(widget.dataSource.data[k].changed){
                widget.dataSource.data[k].__is_new = false;
                row.push(widget.dataSource.data[k]);
            }
        }
        restEngine.post('product#/setGozoFeriasInline', {
            'requestType': 'DataSet',
            'dataset': [row]
        }).then(function (data){
            if (data.messages) {
                ScreenService.showMessage(data.messages[0].message, data.messages[0].type);
            } else if (data.notifications[0].type === "success") {
                ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
            } else {
                ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
            }
            widget.list();
            widget.activate();
            this.getVinculosProgFerias();
        }.bind(this)).catch(function(e) {
            var error;
            if(e.data.error === undefined)
                error = e;
            else 
                error = e.data.error;
            
            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error));
        });
        
    };
    
    this.salvarInline = function(args) {
        var widget = templateManager.container.getActiveWidget();
        var row = [];
        
        if (widget.isValid()) {
            for(var k in widget.dataSource.data){
                if(widget.dataSource.data[k].changed){
                    widget.dataSource.data[k].__is_new = false;
                    widget.dataSource.data[k].VRREFFOLHA = General.valueToFloat(widget.dataSource.data[k].VRREFFOLHA);
                    widget.dataSource.data[k].VREVENTOFOLHA = General.valueToFloat(widget.dataSource.data[k].VREVENTOFOLHA);
                    row.push(widget.dataSource.data[k]);
                }
            }
            restEngine.post('product#/setItecalcfolhaInline', {
                'requestType': 'DataSet',
                'dataset': [row]
            }).
            then(function(data) {
                if (data.messages) {
                    ScreenService.showMessage(data.messages[0].message, data.messages[0].type);
                } else if (data.notifications[0].type === "success") {
                    ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                } else {
                    ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                }
                widget.list();
                widget.activate();
                this.getItecalcfolhaProgFerias();
            }).
            catch(function(e) {
                var error;
                if (e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;

                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
        }
    };
    
    this.atualizaPeriodo = function(args) {
        var widget = ABUtilController.checkWidget(args);
        var dtini = widget.getField('DTINIGOZOFERIAS').value();
        var nrqtdias = widget.getField('DIASFERIAS').value();
        //var dtfim = widget.getField('DTFIMGOZOFERIAS').value();
        var dtfim = null;
        
        if (!ABUtilController.validaDtIniMenorIgualDtFin(dtini, dtfim)) {
            ScreenService.alertNotification(Messages.DTINI_POST_DTFIM_ERROR, 10000);
        } else {
            if (!Util.isEmptyOrBlank(dtini) && !isNaN(nrqtdias) && nrqtdias > 0) {
                nrqtdias--;
                dtfim = moment(dtini, 'DD/MM/YYYY').add(nrqtdias, 'day').format('DD/MM/YYYY');
                widget.getField('DTFIMGOZOFERIAS').setValue(dtfim);
                widget.getField('DTFIMGOZOFERIAS_inline').setValue(dtfim);
            }
            else if (!Util.isEmptyOrBlank(dtini) && !Util.isEmptyOrBlank(dtfim)) {
                nrqtdias = moment(dtfim, 'DD/MM/YYYY').diff(moment(dtini, 'DD/MM/YYYY'), 'day') + 1;
                widget.getField('DIASFERIAS').setValue(nrqtdias);
            }
        }
        
    };
    
    this.gravacaoDefinitiva = function(args, ESocialController, verificaEnvioEsocialDescentralizado = false) {
        var widget = ABUtilController.checkWidget(args);
        var row;
        if(verificaEnvioEsocialDescentralizado){
            ScreenService.confirmMessage('Deseja realmente gravar definitivamente o cálculo?', 'CONFIRMATION',
            function() {
                ESocialController.envioEsocialDescentralizado(widget.currentRow, 'S-2230', null, null, this.gravacaoDefinitiva, args);
            }.bind(this));
        }else{
                row = this.montaRowCalculo(widget, 'CALCULO');
                if(row.length < 1){
                    ScreenService.showMessage('Para realizar o calculo e preciso selecionar os vinculos');
                    return;
                }
                
                restEngine.post("product#/calculoProgramacaoFerias", {
                'requestType': 'DataSet',
                'dataset': [row]
            }).then(function(data) {
                if(data.dataset && data.dataset.retornoEsocial && data.dataset.retornoEsocial.length > 0){
                    var mensagem = 'S-2230:<br>';
                    data.dataset.retornoEsocial.forEach(function(retorno){
                        mensagem += retorno.MSG + '<br>';
                    });
                    ScreenService.showMessage(mensagem);
                }
                if (data.messages) {
                    ScreenService.successNotification(data.messages[0].message);
                    ScreenService.closePopup();
                }
                if (data.dataset && data.dataset.msgCalculo && data.dataset.msgCalculo.length > 0) {
                    var popUp = templateManager.container.getWidget("mensagens");
                    popUp.dataSource.data = data.dataset.msgCalculo;
                    ABUtilController.masterDetailOpenPopup(popUp);
                }
            }).catch(function(e) {
                var error;
                if (e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;

                ScreenService.showMessage('Ocorreu um erro inesperado, contate o administrador informando o trecho abaixo: <br><br>' + error + '<br><br>', 'ERROR');
            });
        }
    };

    this.gravacaoParcial = function(args) {
        var widget = ABUtilController.checkWidget(args);
        var row;
        ScreenService.confirmMessage('Deseja realmente gravar parcialmente o cálculo?', 'CONFIRMATION',
            function() {
                row = this.montaRowCalculo(widget, 'PARCIAL');
                if(row.length < 1){
                    ScreenService.showMessage('Para realizar o calculo e preciso selecionar os vinculos');
                    return;
                }
                
                restEngine.post("product#/calculoProgramacaoFerias", {
                    'requestType': 'DataSet',
                    'dataset': [row]
                }).then(function(data) {
                    if (data.messages) {
                        ScreenService.successNotification(data.messages[0].message);
                        ScreenService.closePopup();
                    }
                    if (data.dataset && data.dataset.msgCalculo && data.dataset.msgCalculo.length > 0) {
                        var popUp = templateManager.container.getWidget("mensagens");
                        popUp.dataSource.data = data.dataset.msgCalculo;
                        ABUtilController.masterDetailOpenPopup(popUp);
                    }
                }).catch(function(e) {
                    var error;
                    if (e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;

                    ScreenService.showMessage('Ocorreu um erro inesperado, contate o administrador informando o trecho abaixo: <br><br>' + error + '<br><br>', 'ERROR');
                });
            }.bind(this));
    };
    
    this.retrocesso = function(args) {
        var widget = ABUtilController.checkWidget(args);
        var self = this;
        ScreenService.confirmMessage('Deseja realmente retroceder o cálculo?', 'CONFIRMATION', function() {
            self.enviaRetrocesso(widget, false);
        });
    };
    
    this.enviaRetrocesso = function(widget, confirmacao){
        var self = this;
        var row = [];
        row = this.montaRowCalculo(widget, 'RETROCESSO');
        if(row.length < 1){
            ScreenService.showMessage('Para realizar o calculo e preciso selecionar os vinculos');
            return;
        }
        
        restEngine.post("product#/calculoProgramacaoFerias", {
            'requestType': 'DataSet',
            'dataset': [row]
        }).then(function(data) {
            if (data.messages) {
                if (data.messages[0].type == 'W') {
                    ScreenService.confirmMessage(data.messages[0].message, 'CONFIRMATION', function() {
                        self.enviaRetrocesso(widget, true);
                    });
                } else {
                    ScreenService.successNotification(data.messages[0].message);
                }
                ScreenService.closePopup();
            }
            if (data.dataset && data.dataset.msgCalculo && data.dataset.msgCalculo.length > 0) {
                var popUp = templateManager.container.getWidget("mensagens");
                popUp.dataSource.data = data.dataset.msgCalculo;
                ABUtilController.masterDetailOpenPopup(popUp);
            }
        }.bind(this)).catch(function(e) {
            var error;
            if (e.data.error === undefined)
                error = e;
            else
                error = e.data.error;

            ScreenService.showMessage('Ocorreu um erro inesperado, contate o administrador informando o trecho abaixo: <br><br>' + error + '<br><br>', 'ERROR');
        });
    };

    this.cancelamentoDeFerias = function(args) {
        var widget = ABUtilController.checkWidget(args);
        var row = [];
        ScreenService.confirmMessage('Deseja realmente cancelar o cálculo?', 'CONFIRMATION',
            function() {
                
                row = this.montaRowCalculo(widget, 'CANCELAMENTO');
                if(row.length < 1){
                    ScreenService.showMessage('Para realizar o calculo e preciso selecionar os vinculos');
                    return;
                }
                
                restEngine.post("product#/calculoProgramacaoFerias", {
                    'requestType': 'DataSet',
                    'dataset': [row]
                }).then(function(data) {
                    if (widget.currentRow.FORM_RECIBO) {
                        var widgetCalc = templateManager.container.getWidget(widget.currentRow.FORM_RECIBO);
                        widgetCalc.reload();
                        ScreenService.closePopup();
                    }
                    if (data.messages) {
                        ScreenService.successNotification(data.messages[0].message);
                        ScreenService.closePopup();
                    }
                    if (data.dataset && data.dataset.msgCalculo && data.dataset.msgCalculo.length > 0) {
                        var popUp = templateManager.container.getWidget("mensagens");
                        popUp.dataSource.data = data.dataset.msgCalculo;
                        ABUtilController.masterDetailOpenPopup(popUp);
                    }
                }).catch(function(e) {
                    var error;
                    if (e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;

                    ScreenService.showMessage('Ocorreu um erro inesperado, contate o administrador informando o trecho abaixo: <br><br>' + error + '<br><br>', 'ERROR');
                });
            }.bind(this));
    };
    
    this.montaRowCalculo = function(widget, tpprocessamento) {
        
        var rows = [];
        widget.getCheckedRows().forEach(function(row){
                var currentRow = Object.assign({}, widget.currentRow);
                currentRow.DTFIMAQUISICAO = row.DTFIMAQUISICAO;
                currentRow.DTFIMGOZOFERIAS = row.DTFIMGOZOFERIAS;
                currentRow.DTINIAQUISICAO = row.DTINIAQUISICAO;
                currentRow.DTINIGOZOFERIAS = row.DTINIGOZOFERIAS;
                currentRow.IDADIANT13SALAR = row.IDADIANT13SALAR;
                currentRow.IDCONTROLFERIAS = row.IDCONTROLFERIAS;
                currentRow.IDNAOPAGAADIC = row.IDNAOPAGAADIC;
                currentRow.NMVINCULOM = row.NMVINCULOM;
                currentRow.NRFERIAS = row.NRFERIAS;
                currentRow.NRGOZOFERIAS = row.NRGOZOFERIAS;
                currentRow.NRVINCULOM = row.NRVINCULOM;
                currentRow.DSINICIO = row.NRVINCULOM;
                currentRow.IDRETROCESSO = 'N';
                currentRow.DSFIM = null;
                currentRow.DSORDEM = 'LISTA_VINCULO';
                currentRow.TELA = 'PROGRAMACAO';
                currentRow.TP_PROCESSAMENTO = tpprocessamento;
                currentRow.TP_CALCULO = 2;
                
                rows.push(currentRow);
            });   
            
        return rows;
    };

}

Configuration(function(ContextRegister) {
    ContextRegister.register('ProgramacaoFeriasController', ProgramacaoFeriasController);
});


// FILE: assets/js/controllers/QuadroVagasController.js
/* jshint esversion: 6 */
function QuadroVagasController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, General, Messages, HcmConsts) {
    
    const self = this;
    
    const PRIMARY_KEY_NAME = 'NRQUADROVAGAS';
    
    this.getMainWidget = function () {
        return templateManager.container.getWidget('quadroVagas');  
    };
    
    this.onEditRow = function () {
        const widget = this.getMainWidget();
        widget.currentRow.QTD_VINC_ATIVOS_OCUPACAO = '';
        widget.currentRow.QTD_VAGAS = '';
    };
    
    this.setQuadroVagas = function() {
        const widget = self.getMainWidget();
        if (!widget.isValid()) {
            return;
        }
        
        restEngine.post('product#/setQuadroVagas', {
            'requestType': 'DataSet',
            'dataset': [widget.currentRow]
        }).then(function(data) {
            const messages = data.messages;
            if (messages) {
                ABUtilController.showResponseMessages(messages);
                return;
            }
            
            if (data.notifications[0].type === "success") {
                ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 1000);
                if(widget.currentRow.__is_new){
                    widget.reload();
                    self.masterDetailVoltarList(widget);
                    return;
                }
                
                ABUtilController.reloadAndUpdateWidgetCurrentRowAfterSave(widget, PRIMARY_KEY_NAME);
                return;
            }
            
            ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
        }).catch(function(e) {
            var error;
            if (e.data.error === undefined)
                error = e;
            else
                error = e.data.error;
            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
        });
    };
    
    this.deleteQuadroVagas = function() {
        const widget = this.getMainWidget();
        const rows = widget.hasCheckedRows() && widget.inListMode() ? widget.getCheckedRows() : [widget.currentRow];
        ScreenService.confirmMessage(Messages.SOFT_DELETE_ROW, null, function () {
            restEngine.post('product#/deleteQuadroVagas', {
                'requestType': 'DataSet',
                'dataset': rows
            }).
            then(function(data) {
                if (data.notifications[0].type === "success") {
                    ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 1000);
                    self.masterDetailVoltarList(widget);
                    widget.reload();
                }
                else {
                    ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                }
            }).catch(function(e) {
                var error;
                if (e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error; ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
        });
    };
    
    this.ativateQuadroVagas = function() {
        const widget = this.getMainWidget();
        const rows = widget.hasCheckedRows() && widget.inListMode() ? widget.getCheckedRows() : [widget.currentRow];
        ScreenService.confirmMessage(Messages.REACTIVATE_ROW, null, function () {
            restEngine.post('product#/ativateQuadroVagas', {
                'requestType': 'DataSet',
                'dataset': rows
            }).
            then(function(data) {
                if (data.notifications[0].type === "success") {
                    ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 1000);
                    self.masterDetailVoltarList(widget);
                    widget.reload();
                }
                else {
                    ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                }
            }).catch(function(e) {
                var error;
                if (e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error; ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
        });
    };
    
    this.applyActionsCondition = function () {
        this.applyActionsEditRemoveCondition();
        this.applyActionActivateCondition();
    };
    
    this.applyActionsEditRemoveCondition = function () {
        const idAtivoCondition = 'row.IDATIVO == \'S\'';
        const excluirActionName = ['excluir', 'editar'];
        return ABUtilController.applyConditionToWidgetAction(self.getMainWidget(), excluirActionName, idAtivoCondition);
    };
    
    this.applyActionActivateCondition = function () {
        const idAtivoCondition = 'row.IDATIVO == \'N\'';
        const excluirActionName = ['ativar'];
        return ABUtilController.applyConditionToWidgetAction(self.getMainWidget(), excluirActionName, idAtivoCondition);
    };
    
    this.updateGridCheckboxVisibility = function () {
        ABUtilController.updateGridCheckboxVisibility(self.getMainWidget());  
    };
    
    this.masterDetailVoltarList = function (widget) {
        ABUtilController.masterDetailVoltarList(widget);
        self.updateGridCheckboxVisibility();
    };
    
    this.masterDetailCancelaEdicao = function (widget) {
        ABUtilController.masterDetailCancelaEdicao(widget);
        self.updateGridCheckboxVisibility();
    };

}

Configuration(function (ContextRegister) {
  ContextRegister.register("QuadroVagasController", QuadroVagasController);
});


// FILE: assets/js/controllers/QueixaController.js
function QueixaController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, General,Messages) {

    this.adicionarRow = function(args) {
        var widget = args.owner.widget;
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
    };
    
	this.setQueixa = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
                if (!widget.backupRow) {
                    widget.currentRow.__is_new = true;
                } else {
                    widget.currentRow.__is_new = false;
                }
                restEngine.post('product#/setQueixa', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                    then(function (data) {
                        if (data.notifications[0].type === "success") {
                            ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                            if (widget.currentRow.__is_new) {
                                ABUtilController.masterDetailVoltarList(widget);
                                widget.reload();
                            } else {
                                ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                                widget.backupRow = null;
                                widget.view();
                            }
                        } else {
                            ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                        }
                    }).
                    catch(function(e) {
                        var error;
                        if(e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;
                            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    });
            }
    };
    
    this.deleteQueixa = function(args) {
    ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
        var widget = args.owner.widget;
        widget.currentRow.__is_new = false;
        restEngine.post('product#/deleteQueixa', {'requestType':'DataSet','dataset':[widget.currentRow]}).
            then(function(data){
                if(data.notifications[0].type === "success"){
                    ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                    ABUtilController.masterDetailVoltarList(widget);
                    widget.reload();
                } else {
                    ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                }
            }).
            catch(function(e) {
                var error;
                if(e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
        },null);
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('QueixaController', QueixaController);
});

// FILE: assets/js/controllers/QuestModeloController.js
function QuestModeloController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, General, Messages) {


    var self = this;
    this.objActions = {
        'cadastro_automatico': {
            'name': 'cadastro_automatico',
            'label': 'Cadastro Automático de Repostas',
            'fields': [
                "NRRESPOSTA",
                "NRQUESTAO",
                "DSRESPOSTA",
                "IDRESPOSCORRETA",
                "IDATIVO",
                "VRPESORESPOSTA",
                "NRORDENARESPOST",
                "CDINTEGRACAO",
                "NRPROXIMAQUESTAO"
            ],
            'nullable': [
                "NRPROXIMAQUESTAO",
                "CDINTEGRACAO",
                "NRQUESTAO"
            ]
        },
        'nova_questao': {
            'name': 'nova_questao',
            'label': 'Nova Questão',
            'fields': [
                "NRQUESTAO",
                "NRNIVELPADQUEST",
                "TXQUESTAO",
                "IDTIPOQUESTAO",
                "DTREVISAQUESTAO",
                "IDQUESTAOOBRIGA",
                "IDOPCAORESPOSTA",
                "IDATIVO"
            ],
            'nullable': [
                "DTREVISAQUESTAO"
            ]

        }
    };

    this.openPopup = function(widget, action) {
        var c_resposta = templateManager.container.getWidget('cadastro_resposta');
        var widgetMain = templateManager.container.getWidget('questmodelo');
        var c_questao = templateManager.container.getWidget('nova_questao');
        var actionObj = [];
        this.selectedAction = action;
        if (action == 'cadastro_automatico') {
            c_resposta.getField('NMCOMBQUESTPADR').dataSourceFilter[ABUtilController.retornaFiltro(c_resposta.getField('NMCOMBQUESTPADR').dataSourceFilter, 'P_NRPADRAVALIACAO')].value = widgetMain.currentRow.NRPADRAVALIACAO;
            c_resposta.getField('NMAGRUPQUESTPAD').dataSourceFilter[ABUtilController.retornaFiltro(c_resposta.getField('NMAGRUPQUESTPAD').dataSourceFilter, 'NRPADRAVALIACAO')].value = widgetMain.currentRow.NRPADRAVALIACAO;
            c_resposta.getField('NRQUESTAO').dataSourceFilter[ABUtilController.retornaFiltro(c_resposta.getField('NRQUESTAO').dataSourceFilter, 'NRPADRAVALIACAO')].value = widgetMain.currentRow.NRPADRAVALIACAO;
            c_resposta.getField('NMCOMBQUESTPADR').reload();
            c_resposta.getField('NMAGRUPQUESTPAD').reload();

            c_resposta.label = this.objActions[action].label;
            actionObj = this.objActions[action];
            c_resposta.fields.forEach(function(field) {
                if (actionObj.fields.indexOf(field.name) >= 0) {
                    c_resposta.getField(field.name).isVisible = true;
                    if (actionObj.nullable.indexOf(field.name) >= 0) {
                        c_resposta.getField(field.name).validations = {};
                    }
                    else {
                        c_resposta.getField(field.name).validations = {
                            "required": true
                        };
                    }
                }
                else {
                    c_resposta.getField(field.name).isVisible = true;
                }
            });

            c_resposta.fieldGroups[1].isVisible = true;
            ABUtilController.masterDetailOpenPopup(c_resposta);
            c_resposta.getField('NMCOMBQUESTPADR').dataSourceFilter[ABUtilController.retornaFiltro(c_resposta.getField('NMCOMBQUESTPADR').dataSourceFilter, 'P_NRPADRAVALIACAO')].value = widgetMain.currentRow.NRPADRAVALIACAO;
            c_resposta.getField('NMAGRUPQUESTPAD').dataSourceFilter[ABUtilController.retornaFiltro(c_resposta.getField('NMAGRUPQUESTPAD').dataSourceFilter, 'NRPADRAVALIACAO')].value = widgetMain.currentRow.NRPADRAVALIACAO;
            var i;
            c_resposta.reload();
            for (i = 0; i <= 5; i++) {
                c_resposta.fields[i].reload();
                c_resposta.fields[i].readOnly = false;
            }
            c_resposta.currentRow = {};
            c_resposta.currentRow.IDATIVO = 'S';
            c_resposta.currentRow.DSATIVO = 'Sim';
            c_resposta.currentRow.IDRESPOSCORRETA = 'N';
            c_resposta.currentRow.DSRESPOSCORRETA = 'Não';
            c_resposta.currentRow.VRPESORESPOSTA = 1;
        }
        else
        if (action == 'nova_questao') {
            c_questao.label = this.objActions[action].label;
            c_questao.fields.forEach(function(field) {
                field.isVisible = true;
            });
            c_resposta.fieldGroups[1].isVisible = true;

            ScreenService.openPopup(c_questao);
        }
    };

    this.closePopup = function(popup) {
        popup.currentRow = {};
        ScreenService.closePopup(true);
        popup.deactivate();
        popup.parent.parent.currentWidget.activate();

    };

    this.closePopupNovaQ = function(popup) {
        popup.currentRow = {};
        ScreenService.closePopup(true);
        popup.deactivate();
        templateManager.container.getWidget('questoes').activate();
    };

    this.widgetsvisibletrue = function(widget) {
        widget.widgets.forEach(function(wid) {
            if (wid.template != "widget/form.html")
                wid.showAsTab = true;
        });
    };

    this.cadastroAutomaticoResposta = function(widget) {
        widget.currentRow.NRPADRAVALIACAO = templateManager.container.getWidget('questmodelo').currentRow.NRPADRAVALIACAO;
        if (widget.isValid()) {
            widget.currentRow.__is_new = true;
            if ((typeof widget.currentRow.NMCOMBQUESTPADR === "undefined" || widget.currentRow.NMCOMBQUESTPADR === null) && (typeof widget.currentRow.NMAGRUPQUESTPAD === "undefined" || widget.currentRow.NMAGRUPQUESTPAD === null) && (typeof widget.currentRow.NRNIVELPADQUEST === "undefined" || widget.currentRow.NRNIVELPADQUEST === null) && (typeof widget.currentRow.NMTEMAANALISE === "undefined" || widget.currentRow.NMTEMAANALISE === null) && (isNaN(widget.currentRow.NRORDEQUESTPADR) || widget.currentRow.NRORDEQUESTPADR === null) && (typeof widget.currentRow.NRQUESTAO === "undefined" || widget.currentRow.NRQUESTAO[0] === null || typeof widget.currentRow.NRQUESTAO[0] === "undefined")) {
                ScreenService.confirmMessage(Messages.HCM03000_AVL_CADASTRO_AUTOMATICO_QUESTIONARIO, null, function() {
                    restEngine.post('product#/cadastroAutomaticoResposta', {
                        'requestType': 'DataSet',
                        'dataset': [widget.currentRow]
                    }).
                    then(function(data) {
                        if (data.messages) {
                            ScreenService.showMessage(data.messages[0].message);
                        }
                        else {
                            if (data.notifications) {
                                ScreenService.closePopup(true);
                                ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                            }

                        }
                    }).
                    catch(function(e) {
                        var error;
                        if (e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;
                        ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    });


                }, null);

            }
            else {
                restEngine.post('product#/cadastroAutomaticoResposta', {
                    'requestType': 'DataSet',
                    'dataset': [widget.currentRow]
                }).
                then(function(data) {
                    if (data.messages) {
                        ScreenService.showMessage(data.messages[0].message);
                    }
                    else {
                        if (data.notifications) {
                            ScreenService.closePopup(true);
                            ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                        }

                    }

                }).
                catch(function(e) {
                    var error;
                    if (e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });



            }

        }
    };

    this.setQuestao = function(widget) {
        if (widget.isValid()) {
            restEngine.post('product#/novaQuestao', {
                'requestType': 'DataSet',
                'dataset': [widget.currentRow]
            }).
            then(function(data) {
                console.log(data);
                var questoes = templateManager.container.getWidget('questoes');
                questoes.currentRow.NRQUESTAO = data.dataset.result[0][0];
                questoes.currentRow.TXQUESTAO = data.dataset.result[0][1];
                questoes.getField('TXQUESTAO').reload();
                ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 1000);
            }).
            catch(function(e) {
                var error;
                if (e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
        }
        widget.currentRow = {};
        ScreenService.closePopup(true);
        widget.deactivate();
        templateManager.container.getWidget('questoes').activate();
    };



    var questoesUpdateFields = function(args) {
        var questoes = templateManager.container.getWidget('questoes');
        switch (questoes.currentRow.IDSORTQUESTPADR) {
            case 'SEM_SORTEIO':
                questoes.getField('NMNIVELQUESTAO').readOnly = true;
                questoes.getField('TXQUESTAO').readOnly = false;
                questoes.getField('TXQUESTAO').validations.required = true;
                questoes.reload();
                break;
            case 'ABERTA':
                questoes.getField('NMNIVELQUESTAO').readOnly = false;
                questoes.getField('TXQUESTAO').readOnly = true;
                questoes.getField('TXQUESTAO').validations = {};
                questoes.reload();
                break;
            case 'FECHADA':
                questoes.getField('NMNIVELQUESTAO').readOnly = false;
                questoes.getField('TXQUESTAO').readOnly = true;
                questoes.getField('TXQUESTAO').validations = {};
                questoes.reload();
                break;
        }
    };

    this.questoesFieldOnChange = function(args) {
        questoesUpdateFields(args);
    };

    this.tipoAvaliacaoOnChange = function(args) {
        // templateManager.container.getWidget('questmodelo').fields[7].readOnly = false;
        var widget = ABUtilController.checkWidget(args);
        widget.getField('IDUTILIZACAOPADR').readOnly = false;
    };

    this.questoesFilterOnChange = function(args) {
        var cadastro_resposta = templateManager.container.getWidget('cadastro_resposta');
        var i = 0;
        if (cadastro_resposta.currentRow.NRQUESTAO.length === 0) {
            for (i = 0; i <= 4; i++) {
                cadastro_resposta.fields[i].readOnly = false;
                cadastro_resposta.fields[i].reload();
            }
        }
        else {
            for (i = 0; i <= 4; i++) {
                cadastro_resposta.fields[i].readOnly = true;
                cadastro_resposta.fields[i].reload();
            }
        }
        cadastro_resposta.reload();
    };



    this.questModeloAfterMoveRow = function(args) {
        templateManager.container.getWidget('questoes').dataSourceFilter[0].value = args.owner.currentRow.NRPADRAVALIACAO;
        templateManager.container.getWidget('combquestoes').dataSourceFilter[0].value = args.owner.currentRow.NRPADRAVALIACAO;
        templateManager.container.getWidget('agrupquestoes').dataSourceFilter[0].value = args.owner.currentRow.NRPADRAVALIACAO;
        templateManager.container.getWidget('tprelaquestionario').dataSourceFilter[0].value = args.owner.currentRow.NRPADRAVALIACAO;
    };

    this.questoesAfterMoveRow = function(args) {
        if(args.owner.currentRow.NRQUESTAO){
            templateManager.container.getWidget('respostas').dataSourceFilter[0].value = args.owner.currentRow.NRQUESTAO;
        }
    };
    
    this.adicionarRow = function(args) {
        var widget = args.owner.widget;
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
    };



    this.questoesOnNew = function(args) {
        var questoes = templateManager.container.getWidget('questoes');
        questoes.currentRow.IDSORTQUESTPADR = 'SEM_SORTEIO';
        questoes.getField('NMNIVELQUESTAO').readOnly = true;
        questoes.getField('TXQUESTAO').readOnly = false;
        questoes.getField('TXQUESTAO').validations.required = true;
        questoes.reload();
    };

    this.respostasOnNew = function(args) {
        var respostas = templateManager.container.getWidget('respostas');
        var questoes = templateManager.container.getWidget('questoes');
        respostas.currentRow.NRQUESTAO = questoes.currentRow.NRQUESTAO;
        respostas.reload();
    };

    this.relacOnNew = function(args) {
        var relac = templateManager.container.getWidget('tprelaquestionario');
        var main = templateManager.container.getWidget('questmodelo');
        relac.currentRow.NRPADRAVALIACAO = main.currentRow.NRPADRAVALIACAO;
        relac.reload();
    };

    this.widgetOnNew = function(widget) {
        var questmodelo = templateManager.container.getWidget('questmodelo');
        widget.currentRow.NRPADRAVALIACAO = questmodelo.currentRow.NRPADRAVALIACAO;
        widget.reload();
    };

    this.questoesOnNew = function(args) {
        var questoes = templateManager.container.getWidget('questoes');
        var questmodelo = templateManager.container.getWidget('questmodelo');
        questoes.currentRow.NRPADRAVALIACAO = questmodelo.currentRow.NRPADRAVALIACAO;
        questoes.getField('NMCOMBQUESTPADR').dataSourceFilter[ABUtilController.retornaFiltro(questoes.getField('NMCOMBQUESTPADR').dataSourceFilter, 'P_NRPADRAVALIACAO')].value = questmodelo.currentRow.NRPADRAVALIACAO;
        questoes.getField('NMAGRUPQUESTPAD').dataSourceFilter[ABUtilController.retornaFiltro(questoes.getField('NMAGRUPQUESTPAD').dataSourceFilter, 'NRPADRAVALIACAO')].value = questmodelo.currentRow.NRPADRAVALIACAO;
        questoesUpdateFields(args);
        questoes.reload();
        questoes.getField('NMCOMBQUESTPADR').reload();
        questoes.getField('NMAGRUPQUESTPAD').reload();
    };

    this.questoesOnEnter = function(args) {
        var questoes = templateManager.container.getWidget('questoes');
        var questmodelo = templateManager.container.getWidget('questmodelo');
        templateManager.container.getWidget('questoes').getField('TXQUESTAO').dataSourceFilter[0].value = questmodelo.currentRow.NRTIPOAVALIACAO;
        questoes.getField('NMCOMBQUESTPADR').dataSourceFilter[0].value = questmodelo.currentRow.NRPADRAVALIACAO;
        questoes.getField('NMAGRUPQUESTPAD').dataSourceFilter[0].value = questmodelo.currentRow.NRPADRAVALIACAO;
        //questoes.reload();
        //questoes.getField('NMCOMBQUESTPADR').reload();
        //questoes.getField('NMAGRUPQUESTPAD').reload();
        //questoes.getField('TXQUESTAO').reload();
    };

    this.tipoRelacOnEnter = function(args) {
    templateManager.container.getWidget('tprelaquestionario').fields[5].reload();
    };

    this.CombAfterMoveRow = function(args) {
        if (args.row.NRPADRAVALIACAO === null) {
            args.owner.actions[2].isVisible = false;
            args.owner.actions[3].isVisible = false;
        }
        else {
            args.owner.actions[2].isVisible = true;
            args.owner.actions[3].isVisible = true;
        }
    };

    this.setPadrAvaliacao = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
            if (widget.currentRow.QTMAXPARTICPADR >= widget.currentRow.QTMINPARTICPADR){
                
            if (!widget.backupRow) {
                widget.currentRow.__is_new = true;
            }
            else {
                widget.currentRow.__is_new = false;
            }
            restEngine.post('product#/setPadrAvaliacao', {
                'requestType': 'DataSet',
                'dataset': [widget.currentRow]
            }).
            then(function(data) {
                if (data.notifications[0].type === "success") {
                    templateManager.container.getWidget('questmodelo').reload();
                    ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                    if (widget.currentRow.__is_new) {
                        ScreenService.closeSwipe();
                    }
                    else {
                        ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                        widget.backupRow = null;
                        widget.view();
                    }
                    ABUtilController.mudarVisibilidadeWidgets(widget.widgets,true);
                }
                else {
                    ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                }
            }).
            catch(function(e) {
                var error;
                if (e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });


        
            }else{
                ScreenService.showMessage("A quantidade minima de participantes deve ser menor ou igual a maxima");
            } 
        }
    };

    this.setQuestPadrAval = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
            if (!widget.backupRow) {
                widget.currentRow.__is_new = true;
            }
            else {
                widget.currentRow.__is_new = false;
            }
            restEngine.post('product#/setQuestPadrAval', {
                'requestType': 'DataSet',
                'dataset': [widget.currentRow]
            }).
            then(function(data) {
                if (data.messages) {
                    ScreenService.showMessage(data.messages[0].message, data.messages[0].type);
                }
                if (data.notifications[0].type == "success") {
                    templateManager.container.getWidget('questoes').reload();
                    ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                    if (widget.currentRow.__is_new) {
                        ABUtilController.masterDetailVoltarList(widget);
                        self.widgetsvisibletrue(args.owner.widget);
                    }
                    else {
                        ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                        widget.backupRow = null;
                        widget.view();
                    }
                }
                else {
                    ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                }

            }).
            catch(function(e) {
                var error;
                if (e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
        }
    };

    this.setRespostaPadrAval = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {

            if (!widget.backupRow) {
                widget.currentRow.__is_new = true;
            }
            else {
                widget.currentRow.__is_new = false;
            }
            restEngine.post('product#/setRespostaPadrAval', {
                'requestType': 'DataSet',
                'dataset': [widget.currentRow]
            }).
            then(function(data) {
                if (data.notifications[0].type === "success") {
                    ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                    if (widget.currentRow.__is_new) {
                        templateManager.container.getWidget('respostas').reload();
                        ABUtilController.masterDetailVoltarList(widget);
                        self.widgetsvisibletrue(args.owner.widget);
                    }
                    else {
                        ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                        widget.backupRow = null;
                        widget.view();
                    }
                }
                else {
                    ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                }
            }).
            catch(function(e) {
                var error;
                if (e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
        }
    };

    this.setCombinacao = function(args) {
        var widget = args.owner.widget;

        if (widget.isValid()) {
            if (ABUtilController.validaDtIniMenorIgualDtFin(widget.currentRow.DTINIVIGENCIA, widget.currentRow.DTFIMVIGENCIA)) {
                if (!widget.backupRow) {
                    widget.currentRow.__is_new = true;
                }
                else {
                    widget.currentRow.__is_new = false;
                }
                widget.currentRow.NRPADRAVALIACAO = templateManager.container.getWidget('questmodelo').currentRow.NRPADRAVALIACAO;
                restEngine.post('product#/setCombinacao', {
                    'requestType': 'DataSet',
                    'dataset': [widget.currentRow]
                }).
                then(function(data) {
                    if (data.notifications[0].type === "success") {
                        templateManager.container.getWidget('combquestoes').reload();
                        ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                        if (widget.currentRow.__is_new) {
                            ABUtilController.masterDetailVoltarList(widget);
                            self.widgetsvisibletrue(args.owner.widget);
                        }
                        else {
                            ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                            widget.backupRow = null;
                            widget.view();
                        }
                    }
                    else {
                        ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                    }
                }).
                catch(function(e) {
                    var error;
                    if (e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
            }
            else {
                ScreenService.showMessage(Messages.DTINI_POST_DTFIM_ERROR);
                return false;
            }
        }
    };

    this.setAgrupamento = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
            if (ABUtilController.validaDtIniMenorIgualDtFin(widget.currentRow.DTINIVIGENCIA, widget.currentRow.DTFIMVIGENCIA)) {
                if (!widget.backupRow) {
                    widget.currentRow.__is_new = true;
                }
                else {
                    widget.currentRow.__is_new = false;
                }
                widget.currentRow.NRPADRAVALIACAO = templateManager.container.getWidget('questmodelo').currentRow.NRPADRAVALIACAO;
                restEngine.post('product#/setAgrupamento', {
                    'requestType': 'DataSet',
                    'dataset': [widget.currentRow]
                }).
                then(function(data) {
                    if (data.notifications[0].type === "success") {
                        templateManager.container.getWidget('agrupquestoes').reload();
                        ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                        if (widget.currentRow.__is_new) {
                            ABUtilController.masterDetailVoltarList(widget);
                            self.widgetsvisibletrue(args.owner.widget);
                        }
                        else {
                            ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                            widget.backupRow = null;
                            widget.view();
                        }
                    }
                    else {
                        ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                    }
                }).
                catch(function(e) {
                    var error;
                    if (e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
            }
            else {
                ScreenService.showMessage(Messages.DTINI_POST_DTFIM_ERROR);
                return false;
            }
        }
    };

    this.setTipoRelac = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
            if (!widget.backupRow) {
                widget.currentRow.__is_new = true;
            }
            else {
                widget.currentRow.__is_new = false;
            }
            restEngine.post('product#/setTipoRelac', {
                'requestType': 'DataSet',
                'dataset': [widget.currentRow]
            }).
            then(function(data) {
                if (data.messages) {
                    ScreenService.showMessage(data.messages[0].message, data.messages[0].type);
                }
                else if (data.notifications[0].type === "success") {
                    templateManager.container.getWidget('tprelaquestionario').reload();
                    ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                    if (widget.currentRow.__is_new) {
                        ABUtilController.masterDetailVoltarList(widget);
                        self.widgetsvisibletrue(args.owner.widget);
                    }
                    else {
                        ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                        widget.backupRow = null;
                        widget.view();
                    }
                }
                else {
                    ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                }
            }).
            catch(function(e) {
                var error;
                if (e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
        }
    };



    this.deletePadrAvaliacao = function(args) {
        ScreenService.confirmMessage(Messages.DELETE_ROW, null, function() {

            var widget = templateManager.container.getActiveWidget();
            if (widget.isValid()) {
                widget.currentRow.__is_new = false;
                restEngine.post('product#/deletePadrAvaliacao', {
                    'requestType': 'DataSet',
                    'dataset': [widget.currentRow]
                }).
                then(function(data) {
                    if (data.messages) {
                        ScreenService.showMessage(data.messages[0].message, data.messages[0].type);
                    }
                    else {
                        ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    }
                }).
                catch(function(e) {
                    var error;
                    if (e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
            }
        }, null);
    };

    this.deleteQuestPadrAval = function(args) {
        ScreenService.confirmMessage(Messages.DELETE_ROW, null, function() {

            var widget = templateManager.container.getActiveWidget();
            if (widget.isValid()) {
                widget.currentRow.__is_new = false;
                restEngine.post('product#/deleteQuestPadrAval', {
                    'requestType': 'DataSet',
                    'dataset': [widget.currentRow]
                }).
                then(function(data) {
                    if (data.messages) {
                        ScreenService.showMessage(Messages.REMOVE_ROW_ERROR + '. ' + data.messages[0].message, data.messages[0].type);
                    }
                    else {
                        ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    }
                }).
                catch(function(e) {
                    var error;
                    if (e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;

                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
            }

        }, null);
    };

    this.deleteRespostaPadrAval = function(args) {
        ScreenService.confirmMessage(Messages.DELETE_ROW, null, function() {

            var widget = templateManager.container.getActiveWidget();
            if (widget.isValid()) {
                widget.currentRow.__is_new = false;
                restEngine.post('product#/deleteRespostaPadrAval', {
                    'requestType': 'DataSet',
                    'dataset': [widget.currentRow]
                }).
                then(function(data) {
                    if (data.messages) {
                        ScreenService.showMessage(Messages.REMOVE_ROW_ERROR + '. ' + data.messages[0].message, data.messages[0].type);
                    }
                    else {
                        ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    }
                }).
                catch(function(e) {
                    var error;
                    if (e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;

                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
            }

        }, null);
    };

    this.deleteCombinacao = function(args) {
        ScreenService.confirmMessage(Messages.DELETE_ROW, null, function() {

            var widget = templateManager.container.getActiveWidget();
            if (widget.isValid()) {
                widget.currentRow.__is_new = false;
                restEngine.post('product#/deleteCombinacao', {
                    'requestType': 'DataSet',
                    'dataset': [widget.currentRow]
                }).
                then(function(data) {
                    if (data.messages) {
                        ScreenService.showMessage(Messages.REMOVE_ROW_ERROR + '. ' + data.messages[0].message, data.messages[0].type);
                    }
                    else {
                        ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    }
                }).
                catch(function(e) {
                    var error;
                    if (e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;

                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
            }

        }, null);
    };

    this.deleteAgrupamento = function(args) {
        ScreenService.confirmMessage(Messages.DELETE_ROW, null, function() {
            var widget = templateManager.container.getActiveWidget();
            if (widget.isValid()) {
                widget.currentRow.__is_new = false;
                restEngine.post('product#/deleteAgrupamento', {
                    'requestType': 'DataSet',
                    'dataset': [widget.currentRow]
                }).
                then(function(data) {
                    if (data.messages) {
                        ScreenService.showMessage(Messages.REMOVE_ROW_ERROR + '. ' + data.messages[0].message, data.messages[0].type);
                    }
                    else {
                        ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    }
                }).
                catch(function(e) {
                    var error;
                    if (e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;

                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
            }
        }, null);
    };

    this.deleteTipoRelac = function(args) {
        ScreenService.confirmMessage(Messages.DELETE_ROW, null, function() {
            var widget = templateManager.container.getActiveWidget();
            if (widget.isValid()) {
                widget.currentRow.__is_new = false;
                restEngine.post('product#/deleteTipoRelac', {
                    'requestType': 'DataSet',
                    'dataset': [widget.currentRow]
                }).
                then(function(data) {
                    if (data.messages) {
                        ScreenService.showMessage(Messages.REMOVE_ROW_ERROR + '. ' + data.messages[0].message, data.messages[0].type);
                    }
                    else {
                        ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    }
                }).
                catch(function(e) {
                    var error;
                    if (e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;

                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
            }
        }, null);
    };

}


Configuration(function(ContextRegister) {
    ContextRegister.register('QuestModeloController', QuestModeloController);
});


// FILE: assets/js/controllers/QuestionarioController.js
function QuestionarioController (ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, ABUtilController, Messages) {
    this.getParams = function(args){
        var widget = ABUtilController.checkWidget(args);
        var params = ABUtilController.getParamsUrl();
        var data = params.DTEXECUCAOAVAL.replace(/%2F/g, "/");
        setLocalVar("HCM_QUESTIONARIO_NRORG", params.NRORG);
        setLocalVar("HCM_QUESTIONARIO_CDOPERADOR", params.CDOPERADOR);
        setLocalVar("HCM_QUESTIONARIO_NRAVALIACAO", params.NRAVALIACAO);
        setLocalVar("HCM_QUESTIONARIO_NRPARCAVALIADO", params.NRPARCAVALIADO);
        setLocalVar("HCM_QUESTIONARIO_NRPARCEXECAVAL", params.NRPARCEXECAVAL);
        if(params.NRCOMBQUESTAVAL === "null"){
            params.NRCOMBQUESTAVAL = null;
        }
        setLocalVar("HCM_QUESTIONARIO_NRCOMBQUESTAVAL", params.NRCOMBQUESTAVAL);
        setLocalVar("HCM_QUESTIONARIO_DTEXECUCAOAVAL", data);
        widget.reload();
        widget.newRow();
    };

    this.redirect = function(){
        window.location.replace('https://talentos.teknisa.com/');
    };

    this.saveQuestionario = function(args){
        ScreenService.confirmMessage('Deseja realmente concluir o questionário ?', 'CONFIRMATION', 
            function(){
                var widget = ABUtilController.checkWidget(args);
                data = new Date();
                dia = data.getDate();
                mes = data.getMonth();
                ano = data.getFullYear();
                widget.currentRow.concluir = true;
                widget.currentRow.NRORG = getLocalVar("HCM_QUESTIONARIO_NRORG");
                widget.currentRow.CDOPERADOR = getLocalVar("HCM_QUESTIONARIO_CDOPERADOR");
                widget.currentRow.NRAVALIACAO = getLocalVar("HCM_QUESTIONARIO_NRAVALIACAO");
                widget.currentRow.NRPARCEXECAVAL = getLocalVar("HCM_QUESTIONARIO_NRPARCEXECAVAL");
                widget.currentRow.NRPARCAVALIADO = getLocalVar("HCM_QUESTIONARIO_NRPARCAVALIADO");
                widget.currentRow.NRCOMBQUESTAVAL = getLocalVar("HCM_QUESTIONARIO_NRCOMBQUESTAVAL");
                widget.currentRow.DTEXECUCAOAVAL = getLocalVar("HCM_QUESTIONARIO_DTEXECUCAOAVAL");
                widget.currentRow.changed = true;
                widget.currentRow.answers = args.owner.widget.dataSource.data[0].answer;
                restEngine.post("product#/setQuestionario",
                        {'requestType':'DataSet','dataset':[widget.currentRow]}
                ).then(
                    function(data){
                        if(!Util.isEmptyOrBlank(data)) {
                            ScreenService.showMessage('Erro ao concluir o questionário: ' + data);
                        } else {
                            ScreenService.confirmMessage('Deseja sair do questionário ?', 'CONFIRMATION', 
                                function(){
                                    ABUtilController.clearLocalStorage();
                                    this.redirect();
                                }.bind(this)
                            );
                        }
                    }.bind(this)
                ).catch(function(e) {
                    var error;
                    if(e.data.error === undefined)
                        error = e;
                    else 
                        error = e.data.error;
                    
                    ScreenService.showMessage('Ocorreu um erro inesperado, contate o administrador informando o trecho abaixo: <br><br>' + error + '<br><br>', 'ERROR');
                });
            }.bind(this)
        );
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('QuestionarioController', QuestionarioController);
});

// FILE: assets/js/controllers/RAISController.js
function RAISController(ScreenService, templateManager, localStorageEngine, ZhUtil, $window, restEngine, HcmRepository, ABUtilController, General, Messages) {

    var self = this;

    this.mudarVisibilidadeWidgets = function(widgets, value) {
        widgets.forEach(function(widget) {
            widget.isVisible = value;
        });
    };

    this.adicionarRow = function(args) {
        var widget = args.owner.widget;
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
    };
    this.geraRAIS = function(args) {
        ScreenService.confirmMessage("Deseja realmente gerar a Rais?", 'CONFIRMATION',
            function() {
                var widget = templateManager.container.getWidget('RAIS');
                restEngine.post('product#/geraRAIS', {
                    'requestType': 'DataSet',
                    'dataset': [widget.currentRow]
                }).
                then(function(data) {
                    if (data.dataset && data.dataset.arquivo) {
                        $window.open($window.serviceUrl + "/abrirArquivo?requestType=DataSet&dataset[0][CMARQUIVO]=" + data.dataset.arquivo[0].NMARQUIVO);
                    }
                    if (data.messages) {
                        ScreenService.showMessage(data.messages[0].message,data.messages[0].type);
                    }
                    if (data.notifications) {
                        if (data.notifications[0].type == 'success')
                            ScreenService.successNotification(data.notifications[0].message);
                        if (data.notifications[0].type == 'alert')
                            ScreenService.successNotification(data.notifications[0].message);
                    }
                    if (data.dataset && data.dataset.msgCalculo && data.dataset.msgCalculo.length > 0) {
                        var popUp = templateManager.container.getWidget("mensagens");
                        popUp.dataSource.data = data.dataset.msgCalculo;
                        ABUtilController.masterDetailOpenPopup(popUp);
                    }
                }).
                catch(function(e) {
                    var error;
                    if (e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;

                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
            }
        );
    };
    this.retrocede = function(args) {
        var widget = templateManager.container.getWidget('RAIS');
        restEngine.post('product#/retrocedeRAIS', {
            'requestType': 'DataSet',
            'dataset': [widget.currentRow]
        }).
        then(function(data) {
            ScreenService.successNotification(Messages.RETROCESSO_SUCCESS, 10000);
        }).
        catch(function(e) {
            var error;
            if (e.data.error === undefined)
                error = e;
            else
                error = e.data.error;

            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
        });
    };

    this.setRAIS = function(args) {
        var widget = args.owner.widget;
        
        if (widget.isValid()) {
            if (!widget.backupRow) {
                widget.currentRow.__is_new = true;
            } else {
                widget.currentRow.__is_new = false;
            }
            restEngine.post('product#/setRAIS', {
                'requestType': 'DataSet',
                'dataset': [widget.currentRow]
            }).
            then(function(data) {
                if (data.notifications[0].type === "success") {
                    ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                    if (widget.currentRow.__is_new) {
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    } else {
                        widget.backupRow = null;
                        widget.view();
                    }
                    self.mudarVisibilidadeWidgets(widget.widgets, true);
                } else {
                    ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                }
            }).
            catch(function(e) {
                var error;
                if (e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;

                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });

        }
    };

    this.deleteRAIS = function(args) {
        var widget = args.owner.widget;
        ScreenService.confirmMessage(Messages.DELETE_ROW, 'CONFIRMATION',
            function() {
                restEngine.post('product#/deleteRAIS', {
                    'requestType': 'DataSet',
                    'dataset': [widget.currentRow]
                }).
                then(function(data) {
                    if (data.notifications[0].type === "success") {
                        ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    } else {
                        ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                    }
                }).
                catch(function(e) {
                    var error;
                    if (e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;

                    ScreenService.showMessage(error, 'ERROR');
                });
            }
        );
    };

}

Configuration(function(ContextRegister) {
    ContextRegister.register('RAISController', RAISController);
});


// FILE: assets/js/controllers/RateioLancamentoVinculoController.js
function RateioLancamentoVinculoController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, General,Messages) {
    
    var self = this;
    var flagForm = false;
    var flagEdit = false;
    
    this.adicionarRow = function(args) {
        var widget = args.owner.widget;
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
    };
    
    this.adicionarRowItem = function(args) {
        var widget = args.owner.widget;
        var widgetMain = templateManager.container.getWidget("grupoRateio");
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
        widget.currentRow.NRRATEIOVINC = widgetMain.currentRow.NRRATEIOVINC;
    };
    
    this.openPopupCadAutomatico = function(args) {
        var widgetFilter = templateManager.container.getWidget('cadastroAutomatico');
        widgetFilter.applyDefaultValue();
        ScreenService.openPopup(widgetFilter);
    };
    
    this.filtrarWidgetPorRateio = function(args){
        var widget = args.owner;
        templateManager.container.getWidget("itensRateio").dataSourceFilter[0].value = widget.currentRow.NRRATEIOVINC;
    };
    
    this.widgetsvisiblefalse = function(args) {
        var widget = args.owner.widget;
        widget.widgets[0].showAsTab = false;
    };
    
    this.widgetsvisibletrue = function(args) {
        var widget = args.owner.widget;
        widget.widgets[0].showAsTab = true;
    };
    
    this.setRateioVinc = function(args) {
        var widget = args.owner.widget;
        if( widget.isValid() ){
            if( ABUtilController.validaDtIniMenorIgualDtFin(widget.currentRow.DTINIVIGENCIA, widget.currentRow.DTFIMVIGENCIA) ){
                if( !widget.backupRow ){
                    widget.currentRow.__is_new = true;
                } else {
                    widget.currentRow.__is_new = false;
                }
                restEngine.post('product#/setRateioVinc', {'requestType': 'DataSet', 'dataset': [widget.currentRow]})
                    .then(function (data) {
                        if( data.notifications[0].type === "success" ){
                            ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                            if( widget.currentRow.__is_new ){
                                ABUtilController.masterDetailVoltarList(widget);
                                self.widgetsvisibletrue(args);
                                widget.reload();
                            } else {
                                ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                                widget.backupRow = null;
                                widget.view();
                            }
                        } else if( data.notifications[0].type === "alert" ) {
                            ScreenService.showMessage(data.notifications[0].message);
                        } else {
                            ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                        }
                    })
                    .catch(function(e) {
                        var error;
                        if( e.data.error === undefined ){
                            error = e;
                        } else {
                            error = e.data.error;
                        }
                        ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    });
            } else {
                ScreenService.showMessage(Messages.DTINI_POST_DTFIM_ERROR);
                return false;
            }        
        }
    };
    
    this.setItemRateio = function(args) {
        var widget = args.owner.widget;
        if( widget.isValid() ){
            if( !widget.backupRow ){
                widget.currentRow.__is_new = true;
                
            } else {
                widget.currentRow.__is_new = false;
            }
            restEngine.post('product#/setItemRateio', {'requestType': 'DataSet', 'dataset': [widget.currentRow]})
            .then(function (data) {
                if( data.notifications[0].type === "success" ){
                    ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                    if( widget.currentRow.__is_new ){
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    } else {
                        ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                        widget.backupRow = null;
                        widget.view();
                        ScreenService.closeSwipe();
                        widget.reload();
                    }
                } else if( data.notifications[0].type === "alert" ) {
                    ScreenService.showMessage(data.notifications[0].message);
                } else {
                    ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                }
            })
            .catch(function(e) {
                var error;
                if( e.data.error === undefined ){
                    error = e;
                } else {
                    error = e.data.error;
                }
                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
        }
    };
    
    this.deleteRateioVinc = function(args) {
    ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
        var widget = templateManager.container.getActiveWidget();
        if( widget.isValid() ){
            widget.currentRow.__is_new = false;
            restEngine.post('product#/deleteRateioVinc', {'requestType': 'DataSet', 'dataset': [widget.currentRow]})
                .then(function (data) {
                    if( data.notifications[0].type === "error" ){
                        ScreenService.showMessage(Messages.REMOVE_ROW_ERROR + '. ' + data.messages[0].message, data.messages[0].type);
                    } else if( data.notifications[0].type === "alert" ) {
                        ScreenService.showMessage(data.notifications[0].message);
                    } else {
                        ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    }
                })
                .catch(function(e) {
                    var error;
                    if( e.data.error === undefined ) {
                        error = e;
                    } else {
                        error = e.data.error;
                    }
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
            }
        }, null);
    };
    
    this.deleteItemRateio = function(args) {
        var widget = args.owner.widget;
        widget.currentRow.__is_new = false;
        restEngine.post('product#/deleteItemRateio', {'requestType':'DataSet','dataset':[widget.currentRow]})
        .then(function(data){
            if( data.notifications[0].type === "success" ){
                ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                ABUtilController.masterDetailVoltarList(widget);
            } else {
                ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
            }
        })
        .catch(function(e) {
            var error;
            if( e.data.error === undefined ){
                error = e;
            } else {
                error = e.data.error;
            }
            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
        });
    };

    this.setFlag = function(flag){
        if( flag === 'Form' ){
            flagForm = true;
        }else if( flag === 'Edit' ){
            flagEdit = true;
        }
    };
    
    this.ajustaTamanhoItensView = function(args) {
        var widget = args.owner;
        
        if( flagEdit === true ){
            widget = args.owner.widget;
            flagEdit = false;
        }
        
        if( flagForm === false ){
            widget.getField('NRVINCULOM').class = widget.getField('NMVINCULOM').class = widget.getField('NRESTRUTURAM').class = widget.getField('NMESTRUTURAM').class = 4;
        }else if( flagForm === true ){
            widget.getField('NRVINCULOM').class = widget.getField('NMVINCULOM').class = widget.getField('NRESTRUTURAM').class = widget.getField('NMESTRUTURAM').class = 5;
            flagForm = false;
        }
    };
    
    this.atualizaEstruturasGrid = function(){
        var widgetForm = templateManager.container.getWidget("FormEstruturasGrid");
        var widgetGrid = templateManager.container.getWidget("gridCadastroAutomatico");
        var grid = [];
        for( var i in widgetForm.currentRow.NMESTRUTGEREN ){
            grid.push({
                NRPESO: widgetForm.currentRow.NRPESO,
                NMESTRUTGEREN: widgetForm.currentRow.NMESTRUTGEREN[i],
                NRESTRUTGEREN: widgetForm.currentRow.NRESTRUTGEREN_LIST[i]
            });
        }
        if( widgetForm.isValid() ){
            widgetGrid.dataSource.data = grid;
            ScreenService.closePopup();
        }
    };
    
    this.deleteEstruturaGrid = function(){
        var widgetGrid = templateManager.container.getWidget("gridCadastroAutomatico");
        
        for(var c in widgetGrid.getCheckedRows()){
          for(var i=0; i<widgetGrid.dataSource.data.length; i++){
            if(widgetGrid.dataSource.data[i].NMESTRUTGEREN ===  widgetGrid.getCheckedRows()[c].NMESTRUTGEREN){
               widgetGrid.dataSource.data.splice(i,1);
            }
          }
        }
        widgetGrid.updateCheckedRows();
    };
    
    this.adicionaEstruturasGrid = function(){
        var widgetFormEstruturas = templateManager.container.getWidget("FormEstruturasGrid");
        ScreenService.openPopup(widgetFormEstruturas);
    };
    
    this.ajustaPropriedadesCampos = function(){
        var widgetCadAuto = templateManager.container.getWidget("cadastroAutomatico");
        
        function setPropriedades(tipoBusca) {
            var vinculos = widgetCadAuto.getField('NRVINCULOM_LIST');
            var estruturaLegal = widgetCadAuto.getField('NRESTRUTLEGAL_LIST');
            var estruturaGerencial = widgetCadAuto.getField('NRESTRUTGEREN_LIST');
            
            if( tipoBusca === "vinculo"){
                estruturaLegal.readOnly = estruturaGerencial.readOnly  = true;
                estruturaLegal.validations = estruturaGerencial.validations = vinculos.validations = [];
            } else if( tipoBusca === "estrutura_legal" || tipoBusca === "estrutura_gerencial" ){
                vinculos.readOnly = true;
                vinculos.validations = estruturaGerencial.validations = estruturaLegal.validations = [];
            } else if( tipoBusca === "nenhum"){
                vinculos.readOnly = estruturaLegal.readOnly = estruturaGerencial.readOnly  = false;
                vinculos.validations.required = estruturaLegal.validations.required = estruturaGerencial.validations.required = true;
            }
        }
        
        if( widgetCadAuto.currentRow.NRVINCULOM_LIST.length > 0 ){
            setPropriedades("vinculo");
        } else if( widgetCadAuto.currentRow.NRESTRUTLEGAL_LIST.length > 0 ){
            setPropriedades("estrutura_legal");
        } else if( widgetCadAuto.currentRow.NRESTRUTGEREN_LIST.length > 0 ){
            setPropriedades("estrutura_gerencial");
        } else {
            setPropriedades("nenhum");
        }
    };
    
    this.setItensCadastroAutomatico = function(){
        var widget = templateManager.container.getWidget("cadastroAutomatico");
        var widgetMain = templateManager.container.getWidget("grupoRateio");
        var widgetItens = templateManager.container.getWidget("itensRateio");
        var widgetGridEstruturas = templateManager.container.getWidget("gridCadastroAutomatico");
        
        widget.currentRow.NRRATEIOVINC = widgetMain.currentRow.NRRATEIOVINC;
        widget.currentRow.NRORG = widgetMain.currentRow.NRORG;
        widget.currentRow.__is_new = true;
        widget.currentRow.ESTRUTURAS_CAD = widgetGridEstruturas.dataSource.data;
        widget.currentRow.VINCULOS = [];
        
        if( typeof(widget.currentRow.NRVINCULOM_LIST) !== "object" ){
            widget.currentRow.NRVINCULOM_LIST = [];
        } else {
            for(var i in widget.currentRow.NRVINCULOM_LIST){
                widget.currentRow.VINCULOS.push({"NRVINCULOM":widget.currentRow.NRVINCULOM_LIST[i],"NMVINCULOM":widget.currentRow.NMVINCULOM[i]});
            }
        }
        if( typeof(widget.currentRow.NRESTRUTLEGAL_LIST) !== "object" ){
            widget.currentRow.NRESTRUTLEGAL_LIST = null;
        }
        if( typeof(widget.currentRow.NRESTRUTGEREN_LIST) !== "object" ){
            widget.currentRow.NRESTRUTGEREN_LIST = null;
        }
        
        if( widget.isValid() ){
            if( widget.currentRow.ESTRUTURAS_CAD.length == 0 ){
                return ScreenService.showMessage('Alguma estrutura precisa ser inserida!');
            }
            restEngine.post('product#/setItensCadastroAutomatico', {'requestType': 'DataSet', 'dataset': [widget.currentRow]})
            .then(function (data) {
                if( data.notifications[0].type === "success" ){
                    ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                    ScreenService.closePopup();
                    widgetItens.reload();
                } else if( data.notifications[0].type === "alert" ){
                    ScreenService.closePopup();
                    widgetItens.reload();
                    var popUp = templateManager.container.getWidget("mensagens");
                    popUp.dataSource.data = data.dataset.alertCadastroAutomatico;
                    ScreenService.openPopup(popUp);
                } else if( data.notifications[0].type === "noneFound" ){
                    ScreenService.showMessage(data.notifications[0].message);
                } else {
                    ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                }
            })
            .catch(function(e) {
                var error;
                if( e.data.error === undefined ){
                    error = e;
                } else {
                    error = e.data.error;
                }
                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
        }
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('RateioLancamentoVinculoController', RateioLancamentoVinculoController);
});

// FILE: assets/js/controllers/ReajusteController.js
function ReajusteController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, General, Messages) {

    this.adicionarRow = function(args) {
        var widget = args.owner.widget;
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
        // this.ordemOnChange(widget);
        this.faixaOnChange(widget);
    };

    this.setReajuste = function(args) {
        var widget = args.owner.widget;

        if (widget.isValid()) {
            if (!widget.backupRow) {
                widget.currentRow.__is_new = true;
            } else {
                widget.currentRow.__is_new = false;
            }
            widget.currentRow.VRPISOSALARIO = General.valueToFloat(widget.currentRow.VRPISOSALARIO);
            widget.currentRow.VRTETOSALARIO = General.valueToFloat(widget.currentRow.VRTETOSALARIO);
            widget.currentRow.VRFAIXASALINI = General.valueToFloat(widget.currentRow.VRFAIXASALINI);
            widget.currentRow.VRFAIXASALFIM = General.valueToFloat(widget.currentRow.VRFAIXASALFIM);
            restEngine.post('product#/setReajusteSalarial', {
                'requestType': 'DataSet',
                'dataset': [widget.currentRow]
            }).
            then(function(data) {
                if (data.notifications[0].type === "success") {
                    ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                    if (widget.currentRow.__is_new) {
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    } else {
                        ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                        widget.backupRow = null;
                        widget.view();
                    }
                } else {
                    ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                }
            }).
            catch(function(e) {
                var error;
                if (e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
        }
    };

    this.deleteReajuste = function(args) {
        var widget = args.owner.widget;
        widget.currentRow.__is_new = false;
        ScreenService.confirmMessage(Messages.DELETE_ROW, 'CONFIRMATION',
            function() {
                restEngine.post('product#/deleteReajusteSalarial', {
                    'requestType': 'DataSet',
                    'dataset': [widget.currentRow]
                }).
                then(function(data) {
                    if (data.notifications[0].type === "success") {
                        ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    } else {
                        ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                    }
                }).
                catch(function(e) {
                    var error;
                    if (e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
            }
        );
        
    };

    this.reajustarSalario = function(idSimulacao) {
        var widget = templateManager.container.getWidget('reajuste');
        widget.currentRow.IDSIMULACAO = idSimulacao;
        if (!widget.backupRow) {
            widget.currentRow.__is_new = true;
        } else {
            widget.currentRow.__is_new = false;
        }
        restEngine.post('product#/reajustarSalario', {
            'requestType': 'DataSet',
            'dataset': [widget.currentRow]
        }).
        then(function(data) {
            if (idSimulacao) {
                var demo = templateManager.container.getWidget('demonstrativo');
                demo.dataSource.data = data.dataset.getDemonstrativo;
                ABUtilController.masterDetailOpenPopup(demo);
                demo.reload();
            } else {
                ScreenService.closePopup();
                ScreenService.showMessage("Reajuste realizado com sucesso. " + data.dataset.getDemonstrativo.length + " vinculo(s) afetado(s) ");
            }
        }).
        catch(function(e) {
            var error;
            if (e.data.error === undefined)
                error = e;
            else
                error = e.data.error;
            ScreenService.showMessage(error, 'ERROR');
        });
    };

    this.retrocederReajuste = function(args) {
        var widget = templateManager.container.getWidget('reajuste');
        if (!widget.backupRow) {
            widget.currentRow.__is_new = true;
        } else {
            widget.currentRow.__is_new = false;
        }
        restEngine.post('product#/retrocederReajusteSalario', {
            'requestType': 'DataSet',
            'dataset': [widget.currentRow]
        }).
        then(function(data) {
            ScreenService.showMessage("Retrocesso realizado com sucesso.");
            ScreenService.closePopup();
        }).
        catch(function(e) {
            var error;
            if (e.data.error === undefined)
                error = e;
            else
                error = e.data.error;
            ScreenService.showMessage(error, 'ERROR');
        });
    };

    this.faixaOnChange = function(widget) {
        widget.getField('VRPERCALTERA').isVisible = false;
        widget.getField('VRFAIXASALINI').isVisible = false;
        widget.getField('VRFAIXASALFIM').isVisible = false;
        widget.getField('NMTABELAFOLHA').isVisible = false;
        widget.getField('VRPERCALTERA').validations = {};
        widget.getField('NMTABELAFOLHA').validations = {};
        widget.getField('NRDIGARREDONDAM').class= "4";
        widget.getField('NRLIMARREDONDAM').class= "4";
        widget.getField('NMESTRUTSIND').class= "4";
        switch (widget.getField('IDTIPOFAIXA').value()) {
            case 'FAIXA':
                widget.getField('VRPERCALTERA').isVisible = true;
                widget.getField('VRFAIXASALINI').isVisible = true;
                widget.getField('VRFAIXASALFIM').isVisible = true;
                if(widget.label != "Filtro")
                widget.getField('VRPERCALTERA').validations = {
                    //"required": {}
                };
                else {
                    widget.getField('NRDIGARREDONDAM').class= "6";
                    widget.getField('NRLIMARREDONDAM').class= "6";
                    widget.getField('NMESTRUTSIND').class= "6";
                }
                break;
            case 'TABELA':
                widget.getField('NMTABELAFOLHA').isVisible = true;
                if(widget.label != "Filtro")
                widget.getField('NMTABELAFOLHA').validations = {
                    "required": {}
                };
                else {
                    widget.getField('NRDIGARREDONDAM').class= "6";
                    widget.getField('NRLIMARREDONDAM').class= "6";
                    widget.getField('NMESTRUTSIND').class= "6";
                }
                break;
        }
    };
    
    this.setFiltroNomeInicialNomeFinal = function(tipo){
        var widget = templateManager.container.getWidget('reajuste');
        
        if( (tipo === 'actionEdit' && widget.currentRow.NRTIPOVINC) || tipo === 'fieldOnChange') {
        
            // Nome inicial
            widget.getField('NMINIVINCULOM').dataSourceFilter.forEach(function(obj){
                if(obj.name === 'NRTIPOVINCULOM'){
                    obj.value = widget.currentRow.NRTIPOVINC;
                }
            });
            
            // Nome final
            widget.getField('NMFIMVINCULOM').dataSourceFilter.forEach(function(obj){
                if(obj.name === 'NRTIPOVINCULOM'){
                    obj.value = widget.currentRow.NRTIPOVINC;
                }
            });
        }
    };
    
    this.EditCriterioTipoHieraquia = function(){
        var widget = templateManager.container.getActiveWidget();
        
        if(widget.currentRow.DSORDEM == 'TIPO_HIERARQUIA' && widget.currentRow.NMTIPOHIERARQORG){
            widget.getField('LIST_NRESTRUTURAMSUP').readOnly = false;
            widget.getField('LIST_NRESTRUTURAMREL').readOnly = false;
        }else{
            widget.getField('LIST_NRESTRUTURAMSUP').readOnly = true;
            widget.getField('LIST_NRESTRUTURAMREL').readOnly = true;
        }  
    };
    
    
}

Configuration(function(ContextRegister) {
    ContextRegister.register('ReajusteController', ReajusteController);
});


// FILE: assets/js/controllers/ReciboPagamentoController.js
/* jshint esversion: 6 */
function ReciboPagamentoController(ScreenService,RelatoriosHcmService, templateManager, restEngine, ABUtilController, Messages, General, CalculoFolhaController, FeriasController, ESocialController, localStorageEngine) {
    
    this.newDataEventos = [];
    this.nrVinculom = null;
    this.nrEstruturam = null;
    this.nrEstruturamGerencial = null;
    this.nrTipoCalculo = null;
    this.nmTipoCalculo = null;
    this.NR_CALCULO_MENSAL = 1;
    this.NR_CALCULO_ADIANTAMENTO = 5;
    this.NR_CALCULO_ADIANTAMENTO_13SAL = 4;
    this.NR_CALCULO_13SAL = 3;
    this.NR_CALCULO_PROVISAO_CONTABIL = 8;
    this.NR_CALCULO_FECHAMENTO = 9;
    this.NR_CALCULO_FERIAS = 2;
    this.NR_CALCULO_RESCISAO = 6;
    this.SIMULACAO = 'SIMULACAO';
    this.CALCULO = 'CALCULO';
    this.PARCIAL = 'PARCIAL';
    this.RETROCESSO = 'RETROCESSO';
    this.CANCELAMENTO = 'CANCELAMENTO';
    this.CADGOZOFERIAS = 'CADGOZOFERIAS';
    this.GRAVARLOTE = 'GRAVARLOTE';
    this.GRAVARPARCIALLOTE = 'GRAVARPARCIALLOTE';
    this.dsOrdem = '';
    this.tpProcessamento = '';
    this.widgetCalculo = '';
    this.nrVinculomIdControl = null;
    this.dtrescisaoVinc = '';
    this.abriuRescisaoCondicao = false;
    
    this.closePopup = function(popup){
        var widgetAnterior = templateManager.container.getWidget(this.nmTipoCalculo);
        popup.currentRow = {};
        ScreenService.closePopup(true);
        widgetAnterior.activate();
        
    };
    
    this.setFormRescisao = function(args) {
        var widget = args.owner.widget;
        var competencia = localStorageEngine.getLocalVar('HCM_DTCOMPETENCIA_OPER');
        var fimcompetencia = localStorageEngine.getLocalVar('HCM_FIM_DTCOMPETENCIA_OPER');
        
        
        if(this.widgetCalculo == 'lancamentoRescisao' || this.widgetCalculo == 'rescisao'){
            if (widget.isValid()) {
                if (ABUtilController.validaCritSelecao(widget.currentRow)) {
                    
                    if(ABUtilController.validaDtIniMenorIgualDtFin(competencia, widget.currentRow.DTPAGAMENTO) === true && ABUtilController.validaDtIniMenorIgualDtFin(widget.currentRow.DTPAGAMENTO, fimcompetencia) === true){
                        this.executaCalculos(args);
                    }else{
                        ScreenService.confirmMessage('A data de pagamento está fora da competência.<br>Deseja realmente adicionar o registro?', 'CONFIRMATION',
                            function() {
                                this.executaCalculos(args);
                            }.bind(this)
                        );
                    }
                }
            }
        }else{
            this.executaCalculos(args);
        }
    };
    
    this.executaCalculos = function(args){
        var widget = ABUtilController.checkWidget(args);
        var widgetEstrutura = templateManager.container.getWidget('estrutura');
        var widgetVinculo = templateManager.container.getWidget('vinculo');
        if(widget.isValid()){
            widget.currentRow.DSORDEM = this.dsOrdem;
            widget.currentRow.TP_CALCULO1 = this.nrTipoCalculo;
            widget.currentRow.TP_PROCESSAMENTO = this.tpProcessamento;
            widget.currentRow.FORM_RECIBO = this.widgetCalculo;
            if(this.dsOrdem == 'ESTRUTURA'){
                widget.currentRow.DSINICIO = this.nrEstruturam;
                widget.currentRow.DSFIM = this.nrEstruturamGerencial;
            }else if(this.dsOrdem == 'LISTA_VINCULO'){
                widget.currentRow.DSINICIO = widgetVinculo.currentRow.NRVINCULOM;
            }else if(this.dsOrdem == 'ALFABETICA'){
                widget.currentRow.DSINICIO = widgetVinculo.currentRow.NMVINCULOM;
                widget.currentRow.DSFIM = widgetVinculo.currentRow.NMVINCULOM;
            }
            
            switch(this.nrTipoCalculo){
                case this.NR_CALCULO_MENSAL:
                    switch(this.tpProcessamento){
                        case this.SIMULACAO:
                            CalculoFolhaController.simularCalculo(args);
                            break;
                        case this.CALCULO:
                            CalculoFolhaController.gravacaoDefinitivaCalculo(args);
                            break;
                        case this.PARCIAL:
                            CalculoFolhaController.gravacaoParcialCalculo(args);
                            break;
                        case this.RETROCESSO:
                            CalculoFolhaController.retrocesso(args);
                            break;
                        case this.GRAVARLOTE:
                            CalculoFolhaController.gravacaoApolo(args);
                            break;
                        case this.GRAVARPARCIALLOTE:
                            CalculoFolhaController.gravacaoParcialApolo(args);
                            break;
                    }
                    break;
                case this.NR_CALCULO_ADIANTAMENTO:    
                    switch(this.tpProcessamento){
                        case this.SIMULACAO:
                            CalculoFolhaController.simularCalculo(args);
                            break;
                        case this.CALCULO:
                            CalculoFolhaController.gravacaoDefinitivaCalculo(args);
                            break;
                        case this.PARCIAL:
                            CalculoFolhaController.gravacaoParcialCalculo(args);
                            break;
                        case this.RETROCESSO:
                            CalculoFolhaController.retrocesso(args);
                            break;
                        case this.GRAVARLOTE:
                            CalculoFolhaController.gravacaoApolo(args);
                            break;
                        case this.GRAVARPARCIALLOTE:
                            CalculoFolhaController.gravacaoParcialApolo(args);
                            break;
                    }
                    break;
                    
                case this.NR_CALCULO_13SAL:    
                    switch(this.tpProcessamento){
                        case this.SIMULACAO:
                            CalculoFolhaController.simularCalculo(args);
                            break;
                        case this.CALCULO:
                            CalculoFolhaController.gravacaoDefinitivaCalculo(args);
                            break;
                        case this.PARCIAL:
                            CalculoFolhaController.gravacaoParcialCalculo(args);
                            break;
                        case this.RETROCESSO:
                            CalculoFolhaController.retrocesso(args);
                            break;
                        case this.GRAVARLOTE:
                            CalculoFolhaController.gravacaoApolo(args);
                            break;
                        case this.GRAVARPARCIALLOTE:
                            CalculoFolhaController.gravacaoParcialApolo(args);
                            break;
                    }
                    break;
                case this.NR_CALCULO_FERIAS:  
                    switch(this.tpProcessamento){  
                        case this.SIMULACAO:
                            FeriasController.simular(args);
                            break;
                        case this.CALCULO:
                            FeriasController.gravacaoDefinitiva(args, ESocialController, true);
                            break;
                        case this.PARCIAL:
                            FeriasController.gravacaoParcial(args);
                            break;
                        case this.RETROCESSO:
                            FeriasController.retrocesso(args);
                            break;
                        case this.CANCELAMENTO:
                            FeriasController.cancelamentoDeFerias(args);
                            break;
                        case this.CADGOZOFERIAS:
                            FeriasController.cadGozoFerias(args);
                        break;
                        case this.GRAVARLOTE:
                            FeriasController.gravacaoApolo(args);
                            break;
                        case this.GRAVARPARCIALLOTE:
                            FeriasController.gravacaoParcialApolo(args);
                            break;
                            
                    }
                    break;
                case this.NR_CALCULO_RESCISAO:   
                    switch(this.tpProcessamento){
                        case this.SIMULACAO:
                            FeriasController.simular(args);
                            break;
                        case this.CALCULO:
                            FeriasController.gravacaoDefinitiva(args, ESocialController, true, 'S-2299');
                            break;
                        case this.PARCIAL:
                            FeriasController.gravacaoParcial(args);
                            break;
                        case this.RETROCESSO:
                            FeriasController.retrocesso(args);
                            break;
                        case this.CANCELAMENTO:
                            FeriasController.cancelamentoDeFerias(args);
                            break;   
                        case this.GRAVARLOTE:
                            FeriasController.gravacaoApolo(args);
                            break;
                        case this.GRAVARPARCIALLOTE:
                            FeriasController.gravacaoParcialApolo(args);
                            break;
                    }      
                    break;
            }
        }
    };
    
    this.setNrvinculo = function(args){
        var widget = ABUtilController.checkWidget(args);
        this.nrVinculom = widget.currentRow.NRVINCULOM;
    };
    
    this.setNrestrutura = function(args){
        var widget = ABUtilController.checkWidget(args);
        this.nrEstruturam = widget.currentRow.NRESTRUTURAM;
        
        if(widget.currentRow.NRESTRUTSUP){
            this.nrEstruturam = widget.currentRow.NRESTRUTSUP;
            this.nrEstruturamGerencial = widget.currentRow.NRESTRUTURAM;
        }else{
            this.nrEstruturam = widget.currentRow.NRESTRUTURAM;
            this.nrEstruturamGerencial = null;
        }
        
    };
    
    this.reloadWidgetFilhas = function(){
        var widget =  templateManager.container.getActiveWidget();
        var nrvinculom = widget.dataSource.getFirstRow() ? widget.dataSource.getFirstRow().NRVINCULOM : null;
        if(nrvinculom != this.nrVinculom || !nrvinculom){
            widget.reload();
        }
    };
    
    this.montaRow = function(widget){
        var newDataTotal = [];
        this.newDataEventos = [];
        widget.dataSource.data.forEach(function(row){
            if(newDataTotal[row.NREVENTOM]){
                newDataTotal[row.NREVENTOM] = {
                    "VREVENTOFOLHA": newDataTotal[row.NREVENTOM].VREVENTOFOLHA + parseFloat(row.VREVENTOFOLHA),
                    "NREVENTOM": row.NREVENTOM,  
                    "IDTIPOEVENTO": row.IDTIPOEVENTO, 
                    "NMEVENTOH": row.NMEVENTOH,
                    "NMVINCULOM": row.NMVINCULOM,
                    "NRVINCULOM": row.NRVINCULOM
                };
            }else{
                newDataTotal[row.NREVENTOM] = {
                    "VREVENTOFOLHA": parseFloat(row.VREVENTOFOLHA),
                    "NREVENTOM": row.NREVENTOM, 
                    "IDTIPOEVENTO": row.IDTIPOEVENTO,
                    "NMEVENTOH": row.NMEVENTOH, 
                    "NMVINCULOM": row.NMVINCULOM,
                    "NRVINCULOM": row.NRVINCULOM
                };
                this.newDataEventos[row.NREVENTOM] = [];
            }
            this.newDataEventos[row.NREVENTOM].push(row);
        }.bind(this));
        
        widget.dataSource.data = [];
        
        newDataTotal.forEach(function(evento){
           widget.dataSource.data.push(evento);
        });
        
    };
    
    this.openDetalhamento = function(widget){
        var widgetDetalhada = templateManager.container.getWidget('lancamentoDetalhados');
        var widgetTabbed = templateManager.container.getWidget('lancamentoTabbed');
        
        widgetDetalhada.dataSource.data = this.newDataEventos[widget.row.NREVENTOM];
        
        ScreenService.openSwipe(widgetTabbed).then(
            function (success) {
			    widgetDetalhada.reload();
            }
		);
    };
    
    this.openPopUpCalculo = function(args, dsOrdem){
        var widget = ABUtilController.checkWidget(args);
        var widgetForm = templateManager.container.getWidget('formCalculo');
        
        widget.currentRow.NRVINCULOM = this.nrVinculom;
        widgetForm.currentRow.NRVINCULOM = this.nrVinculom;
        widgetForm.label = args.owner.label;
        this.tpProcessamento = args.owner.name;
        this.dsOrdem = dsOrdem;
        this.widgetCalculo = widget.name;
        switch(widget.name){
            case 'folha': 
            case 'lancamentoFolha': 
                this.nrTipoCalculo = 1;
                this.setVisibilidadeFields(widgetForm,widget.name);
                this.nmTipoCalculo = widget.name;
                break;    
            case 'ferias': 
            case 'lancamentoFerias': 
                this.setVisibilidadeFields(widgetForm,widget.name);
                this.nrTipoCalculo = 2;
                this.nmTipoCalculo = widget.name;
                break;   
            case 'rescisao': 
            case 'lancamentoRescisao': 
                this.setVisibilidadeFields(widgetForm,widget.name);
                this.nrTipoCalculo = 6;
                this.nmTipoCalculo = widget.name;
                break; 
            case 'adiantamento': 
            case 'lancamentoAdiantamento': 
                this.setVisibilidadeFields(widgetForm,widget.name);
                this.nrTipoCalculo = 5;
                this.nmTipoCalculo = widget.name;
                break; 
            case 'decimoTerceiroFinal': 
            case 'lancamentodecimoTerceiroFinal': 
                this.setVisibilidadeFields(widgetForm,widget.name);
                this.nrTipoCalculo = 3;
                this.nmTipoCalculo = widget.name;
                break;     
            default:
                
        }
        ScreenService.openPopup(widgetForm);
        
    };
    
    this.indisponivel = function(args){
        ScreenService.showMessage("Indisponivel");
    };
    
    this.setVisibilidadeFields = function(widget, nameCalculo){
        widget.getField('DTINIGOZOINI').validations = {required: true};
        widget.getField('DTINIGOZOFIM').validations = {required: true};
        widget.getField('DTPAGAMENTO').validations = {required: true};
        widget.getField('IDNAOPAGAADIC').isVisible = false;
        widget.getField('IDPAGAADIC').isVisible = true;
        widget.getField('IDPROPSAL').isVisible = true;
        widget.getField('IDCONSALREDUCAO').isVisible = false;
        widget.getField('IDCONSOLIDAINSS').isVisible = false;
        widget.getField('IDCONSVINCRESC').isVisible = false;
        widget.currentRow.IDPAGAADIC = 'N';
        
        switch(nameCalculo){
            case 'ferias': 
            case 'lancamentoFerias': 
                widget.getField('IDCONTROLFERIAS').isVisible = true;
                
                //Vinculo diferente do ultimo selecionado limpar os campos.
                if(this.nrVinculomIdControl !== this.nrVinculom){
                    widget.currentRow.IDCONTROLFERIAS = null;
                    widget.currentRow.NRFERIAS = null;
                    widget.currentRow.DTINIGOZOINI = null;
                    widget.currentRow.DIASFERIAS = null;
                    widget.currentRow.DTINIGOZOFIM = null;
                    widget.currentRow.QTDIASABONOFERI = null;
                    widget.currentRow.IDADIANT13SALAR = 'N';
                    widget.currentRow.IDNAOPAGAADIC = 'N';
                    
                }
                widget.getField('IDPROPSAL').isVisible = false;
                widget.getField('IDPAGAADIC').isVisible = false;
                this.nrVinculomIdControl = this.nrVinculom;
                widget.getField('IDNAOPAGAADIC').isVisible = true;
                widget.getField('DTINIGOZOINI').isVisible = true;
                widget.getField('DIASFERIAS').isVisible = true;
                widget.getField('DTINIGOZOFIM').isVisible = true;
                widget.getField('QTDIASABONOFERI').isVisible = true;
                widget.getField('IDADIANT13SALAR').isVisible = true;
                widget.getField('DTRESCISAOINI').isVisible = false;
                widget.getField('DTRESCISAOFIM').isVisible = false;
                if(this.dsOrdem == 'ESTRUTURA'){
                    widget.getField('IDCONTROLFERIAS').isVisible = false;
                    widget.getField('IDNAOPAGAADIC').isVisible = false;
                }

                if(this.tpProcessamento == 'RETROCESSO'){
                    widget.getField('DTINIGOZOINI').validations = {};
                    widget.getField('DTINIGOZOFIM').validations = {};
                    widget.getField('DTPAGAMENTO').validations = {};
                }else if(this.tpProcessamento == 'CANCELAMENTO'){
                    widget.getField('DTPAGAMENTO').validations = {};
                }    
                break;
                
            case 'rescisao': 
            case 'lancamentoRescisao': 
                widget.currentRow.IDPAGAADIC = 'S';
                widget.getField('IDCONTROLFERIAS').isVisible = false;
                widget.getField('DTINIGOZOINI').isVisible = false;
                widget.getField('DIASFERIAS').isVisible = false;
                widget.getField('DTINIGOZOFIM').isVisible = false;
                widget.getField('QTDIASABONOFERI').isVisible = false;
                widget.getField('IDADIANT13SALAR').isVisible = false;
                widget.getField('DTRESCISAOINI').isVisible = true;
                widget.getField('DTRESCISAOFIM').isVisible = true;
                
                if(nameCalculo == 'rescisao'){
                    if(this.dtrescisaoVinc == ''){
                        ScreenService.showMessage("Vínculo não possui data de rescisão informada.");
                        widget.newRow();
                    }else{
                        widget.newRow();
                    }
                }
                
                if(this.tpProcessamento == 'RETROCESSO') widget.getField('DTPAGAMENTO').validations = {};
                
                break; 
            case 'decimoTerceiroFinal':
            case 'lancamentodecimoTerceiroFinal':
                widget.getField('IDCONSALREDUCAO').isVisible = true;
                widget.getField('IDNAOPAGAADIC').isVisible = false;
                widget.getField('IDPAGAADIC').isVisible = false;
                widget.getField('IDPROPSAL').isVisible = false;
                widget.getField('IDCONTROLFERIAS').isVisible = false;
                widget.getField('DTINIGOZOINI').isVisible = false;
                widget.getField('DIASFERIAS').isVisible = false;
                widget.getField('DTINIGOZOFIM').isVisible = false;
                widget.getField('QTDIASABONOFERI').isVisible = false;
                widget.getField('IDADIANT13SALAR').isVisible = false;
                widget.getField('DTRESCISAOINI').isVisible = false;
                widget.getField('DTRESCISAOFIM').isVisible = false;
                widget.getField('IDCONSVINCRESC').isVisible = true;
                break; 
            default:
                widget.getField('IDCONTROLFERIAS').isVisible = false;
                widget.getField('DTINIGOZOINI').isVisible = false;
                widget.getField('DIASFERIAS').isVisible = false;
                widget.getField('DTINIGOZOFIM').isVisible = false;
                widget.getField('QTDIASABONOFERI').isVisible = false;
                widget.getField('IDADIANT13SALAR').isVisible = false;
                widget.getField('DTRESCISAOINI').isVisible = false;
                widget.getField('DTRESCISAOFIM').isVisible = false;
                widget.getField('IDCONSOLIDAINSS').isVisible = true;
        }
        
        if(nameCalculo == 'adiantamento' || nameCalculo == 'lancamentoAdiantamento'){
            widget.getField('IDCONSVINCRESC').isVisible = true;
        }
    };
    
    this.setDtrescisaovinc = function(args){
        var widget = ABUtilController.checkWidget(args);
        if(widget.currentRow.DTRESCISAOVINC){
            this.dtrescisaoVinc = widget.currentRow.DTRESCISAOVINC;
        }else{
            this.dtrescisaoVinc = '';
        }
    };
    
    this.salvarInline = function(args) {
        var widget = templateManager.container.getActiveWidget();
        var row = [];
        
    if (widget.isValid()) {
            for(var k in widget.dataSource.data){
                if(widget.dataSource.data[k].changed){
                    widget.dataSource.data[k].__is_new = false;
                    widget.dataSource.data[k].VRREFFOLHA = General.valueToFloat(widget.dataSource.data[k].VRREFFOLHA);
                    widget.dataSource.data[k].VREVENTOFOLHA = General.valueToFloat(widget.dataSource.data[k].VREVENTOFOLHA);
                    row.push(widget.dataSource.data[k]);
                }
            }
            restEngine.post('product#/setItecalcfolhaInline', {
                'requestType': 'DataSet',
                'dataset': [row]
            }).
            then(function(data) {
                if (data.messages) {
                    ScreenService.showMessage(data.messages[0].message, data.messages[0].type);
                } else if (data.notifications[0].type === "success") {
                    ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                } else {
                    ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                }
                widget.list();
                widget.activate();
                widget.reload();
            }).
            catch(function(e) {
                var error;
                if (e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;

                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
        }
    };
    
    this.openPopUpRelat = function(args, nmRelatorio, vinculo = false, nrtipomovimento = false){
        var widgetForm = templateManager.container.getWidget('formRelatorio');
        var widget = ABUtilController.checkWidget(args);
        var widgetPai = widget.parent.parent;
        if(widgetPai.name == "vinculo"){
            widgetForm.parent.currentRow.NRVINCULOM = widgetPai.currentRow.NRVINCULOM;
        } else {
            widgetForm.parent.currentRow.NRVINCULOM = "";
        }
        
        if(nrtipomovimento){
            widgetForm.tipomovimento = nrtipomovimento;
        }
        //RelatoriosHcmService.setExibicaoCampos_RCB(widget);
        widgetForm.getField('DTMESCOMPETENC').isVisible = true;
        widgetForm.getField('DTMESCOMPETENC').validations = {required: true};
        switch(nmRelatorio){
            case 'darf':
                widgetForm.label = "Formulário DARF";
                widgetForm.NMREPORT = 'darf';
                widgetForm.getField('NUMBER1').label = "Multa";
                widgetForm.getField('NUMBER2').label = "Juros e Encargos";
                widgetForm.getField('DATA1').label = "Data de Vencimento";
                widgetForm.getField('DATA2').label = "Período de Apuração";
                widgetForm.getField('NMOPCOES1').label = "Emissão de Guias por Vínculo";
                widgetForm.getField('NMOPCOES2').label = "Agrupar por Matriz";
                widgetForm.getField('NMOPCOES3').label = "Regime de Caixa";
                //Usar a DARF como base para inserção de novos campos
                widgetForm.getField('NUMBER1').isVisible = true;
                widgetForm.getField('NUMBER2').isVisible = true;
                widgetForm.getField('NUMBER3').isVisible = false;
                widgetForm.getField('NUMBER4').isVisible = false;
                widgetForm.getField('DATA1').isVisible = true;
                widgetForm.getField('DATA2').isVisible = true;
                widgetForm.getField('NMABREV').isVisible = true;
                widgetForm.getField('NMOPCOES1').isVisible = true;
                widgetForm.getField('NMOPCOES2').isVisible = true;
                widgetForm.getField('NMOPCOES3').isVisible = true;
                widgetForm.getField('NMOPCOES4').isVisible = false;
                widgetForm.getField('NMOPCOES5').isVisible = false;
                widgetForm.getField('NMOPCOES6').isVisible = false;
                widgetForm.getField('NMOPCOES7').isVisible = false;
                widgetForm.getField('NMOPCOES8').isVisible = false;
                widgetForm.getField('NMTIPOESTRUTURA').isVisible = false;
                widgetForm.getField('NMTIPOINCIDE').isVisible = false;
                widgetForm.getField('TEXTO1').isVisible = false;
                widgetForm.getField('DTINICIO').isVisible = false;
                widgetForm.getField('DTFIM').isVisible = false;
                widgetForm.getField('NMEVENTOH').isVisible = false;
                widgetForm.getField('DSOBSERVACAO').isVisible = false;
                widgetForm.getField('DTDOCUMENTO').isVisible = false;
                widgetForm.getField('NUMBER1').validations = {required: true};
                widgetForm.getField('NUMBER2').validations = {required: true};
                widgetForm.getField('DATA1').validations = {required: true};
                widgetForm.getField('DATA2').validations = {required: true};
                widgetForm.getField('NMEVENTOH').validations = {};
                widgetForm.getField('NMTIPOESTRUTURA').validations = {};
                widgetForm.getField('DTINICIO').validations = {};
                widgetForm.getField('DTFIM').validations = {};
                break;
            case 'seguro_desemprego':{
                widgetForm.label = "Seguro Desemprego (formulário contínuo)";
                widgetForm.NMREPORT = 'seguro_desemprego';
                widgetForm.getField('DTINICIO').label = "Data inicial da rescisão";
                widgetForm.getField('DTFIM').label = "Data final da rescisão";
                
                widgetForm.getField('NUMBER1').isVisible = false;
                widgetForm.getField('NUMBER2').isVisible = false;
                widgetForm.getField('NUMBER3').isVisible = false;
                widgetForm.getField('NUMBER4').isVisible = false;
                widgetForm.getField('DATA1').isVisible = false;
                widgetForm.getField('DATA2').isVisible = false;
                widgetForm.getField('NMABREV').isVisible = false;
                widgetForm.getField('NMOPCOES1').isVisible = false;
                widgetForm.getField('NMOPCOES2').isVisible = false;
                widgetForm.getField('NMOPCOES3').isVisible = false;
                widgetForm.getField('NMOPCOES4').isVisible = false;
                widgetForm.getField('NMOPCOES5').isVisible = false;
                widgetForm.getField('NMOPCOES6').isVisible = false;
                widgetForm.getField('NMOPCOES7').isVisible = false;
                widgetForm.getField('NMOPCOES8').isVisible = false;
                widgetForm.getField('NMTIPOESTRUTURA').isVisible = false;
                widgetForm.getField('NMTIPOINCIDE').isVisible = false;
                widgetForm.getField('TEXTO1').isVisible = false;
                widgetForm.getField('DTINICIO').isVisible = true;
                widgetForm.getField('DTFIM').isVisible = true;
                widgetForm.getField('NMEVENTOH').isVisible = false;
                widgetForm.getField('DSOBSERVACAO').isVisible = false;
                widgetForm.getField('DTDOCUMENTO').isVisible = false;
                widgetForm.getField('NUMBER1').validations = {};
                widgetForm.getField('NUMBER2').validations = {};
                widgetForm.getField('DATA1').validations = {};
                widgetForm.getField('DATA2').validations = {};
                widgetForm.getField('NMEVENTOH').validations = {};
                widgetForm.getField('NMTIPOESTRUTURA').validations = {};
                widgetForm.getField('DTINICIO').validations = {};
                widgetForm.getField('DTFIM').validations = {};
            }
            break;
            case 'seguro_desemprego_laser':{
                widgetForm.label = "Seguro Desemprego (laser modelo 1)";
                widgetForm.NMREPORT = 'seguro_desemprego_laser';
                widgetForm.getField('DTINICIO').label = "Data inicial da rescisão";
                widgetForm.getField('DTFIM').label = "Data final da rescisão";
               
                widgetForm.getField('NUMBER1').isVisible = false;
                widgetForm.getField('NUMBER2').isVisible = false;
                widgetForm.getField('NUMBER3').isVisible = false;
                widgetForm.getField('NUMBER4').isVisible = false;
                widgetForm.getField('DATA1').isVisible = false;
                widgetForm.getField('DATA2').isVisible = false;
                widgetForm.getField('NMABREV').isVisible = false;
                widgetForm.getField('NMOPCOES1').isVisible = false;
                widgetForm.getField('NMOPCOES2').isVisible = false;
                widgetForm.getField('NMOPCOES3').isVisible = false;
                widgetForm.getField('NMOPCOES4').isVisible = false;
                widgetForm.getField('NMOPCOES5').isVisible = false;
                widgetForm.getField('NMOPCOES6').isVisible = false;
                widgetForm.getField('NMOPCOES7').isVisible = false;
                widgetForm.getField('NMOPCOES8').isVisible = false;
                widgetForm.getField('NMTIPOESTRUTURA').isVisible = false;
                widgetForm.getField('NMTIPOINCIDE').isVisible = false;
                widgetForm.getField('TEXTO1').isVisible = false;
                widgetForm.getField('DTINICIO').isVisible = true;
                widgetForm.getField('DTFIM').isVisible = true;
                widgetForm.getField('NMEVENTOH').isVisible = false;
                widgetForm.getField('DSOBSERVACAO').isVisible = false;
                widgetForm.getField('DTDOCUMENTO').isVisible = false;
                widgetForm.getField('NUMBER1').validations = {};
                widgetForm.getField('NUMBER2').validations = {};
                widgetForm.getField('DATA1').validations = {};
                widgetForm.getField('DATA2').validations = {};
                widgetForm.getField('NMEVENTOH').validations = {};
                widgetForm.getField('NMTIPOESTRUTURA').validations = {};
                widgetForm.getField('DTINICIO').validations = {};
                widgetForm.getField('DTFIM').validations = {};
            }
            break;
            case 'seguro_desemprego_laser_2':{
                widgetForm.label = "Seguro Desemprego (laser modelo 2)";
                widgetForm.NMREPORT = 'seguro_desemprego_laser_2';
                widgetForm.getField('DTINICIO').label = "Data inicial da rescisão";
                widgetForm.getField('DTFIM').label = "Data final da rescisão";
                
                widgetForm.getField('NUMBER1').isVisible = false;
                widgetForm.getField('NUMBER2').isVisible = false;
                widgetForm.getField('NUMBER3').isVisible = false;
                widgetForm.getField('NUMBER4').isVisible = false;
                widgetForm.getField('DATA1').isVisible = false;
                widgetForm.getField('DATA2').isVisible = false;
                widgetForm.getField('NMABREV').isVisible = false;
                widgetForm.getField('NMOPCOES1').isVisible = false;
                widgetForm.getField('NMOPCOES2').isVisible = false;
                widgetForm.getField('NMOPCOES3').isVisible = false;
                widgetForm.getField('NMOPCOES4').isVisible = false;
                widgetForm.getField('NMOPCOES5').isVisible = false;
                widgetForm.getField('NMOPCOES6').isVisible = false;
                widgetForm.getField('NMOPCOES7').isVisible = false;
                widgetForm.getField('NMOPCOES8').isVisible = false;
                widgetForm.getField('NMTIPOESTRUTURA').isVisible = false;
                widgetForm.getField('NMTIPOINCIDE').isVisible = false;
                widgetForm.getField('TEXTO1').isVisible = false;
                widgetForm.getField('DTINICIO').isVisible = true;
                widgetForm.getField('DTFIM').isVisible = true;
                widgetForm.getField('NMEVENTOH').isVisible = false;
                widgetForm.getField('DSOBSERVACAO').isVisible = false;
                widgetForm.getField('DTDOCUMENTO').isVisible = false;
                widgetForm.getField('NUMBER1').validations = {};
                widgetForm.getField('NUMBER2').validations = {};
                widgetForm.getField('DATA1').validations = {};
                widgetForm.getField('DATA2').validations = {};
                widgetForm.getField('NMEVENTOH').validations = {};
                widgetForm.getField('NMTIPOESTRUTURA').validations = {};
                widgetForm.getField('DTINICIO').validations = {};
                widgetForm.getField('DTFIM').validations = {};
            }
            break;
            case 'requisicao_seguro_desemprego':{
                widgetForm.label = "Requisição de Seguro Desemprego";
                widgetForm.NMREPORT = 'requisicao_seguro_desemprego';
                widgetForm.getField('DTINICIO').label = "Data inicial da rescisão";
                widgetForm.getField('DTFIM').label = "Data final da rescisão";
                
                widgetForm.getField('NUMBER1').isVisible = false;
                widgetForm.getField('NUMBER2').isVisible = false;
                widgetForm.getField('NUMBER3').isVisible = false;
                widgetForm.getField('NUMBER4').isVisible = false;
                widgetForm.getField('DATA1').isVisible = false;
                widgetForm.getField('DATA2').isVisible = false;
                widgetForm.getField('NMABREV').isVisible = false;
                widgetForm.getField('NMOPCOES1').isVisible = false;
                widgetForm.getField('NMOPCOES2').isVisible = false;
                widgetForm.getField('NMOPCOES3').isVisible = false;
                widgetForm.getField('NMOPCOES4').isVisible = false;
                widgetForm.getField('NMOPCOES5').isVisible = false;
                widgetForm.getField('NMOPCOES6').isVisible = false;
                widgetForm.getField('NMOPCOES7').isVisible = false;
                widgetForm.getField('NMOPCOES8').isVisible = false;
                widgetForm.getField('NMTIPOESTRUTURA').isVisible = false;
                widgetForm.getField('NMTIPOINCIDE').isVisible = false;
                widgetForm.getField('TEXTO1').isVisible = false;
                widgetForm.getField('DTINICIO').isVisible = true;
                widgetForm.getField('DTFIM').isVisible = true;
                widgetForm.getField('NMEVENTOH').isVisible = false;
                widgetForm.getField('DSOBSERVACAO').isVisible = false;
                widgetForm.getField('DTDOCUMENTO').isVisible = false;
                widgetForm.getField('NUMBER1').validations = {};
                widgetForm.getField('NUMBER2').validations = {};
                widgetForm.getField('DATA1').validations = {};
                widgetForm.getField('DATA2').validations = {};
                widgetForm.getField('NMEVENTOH').validations = {};
                widgetForm.getField('NMTIPOESTRUTURA').validations = {};
                widgetForm.getField('DTINICIO').validations = {};
                widgetForm.getField('DTFIM').validations = {};
            }
            break;
            case 'demonstrativo_pagamento_via_unica':{
                widgetForm.label = "Demonstrativo Pagamento";
                widgetForm.NMREPORT = 'demonstrativo_pagamento_via_unica';
                if(widgetPai.name == "vinculo" && widgetPai.currentRow.NRTIPOVINCULOM == 10 ){
                    widgetForm.NMREPORT = 'demonstrativo_pagamento_rpa_laser';
                }
                widgetForm.getField('NMOPCOES1').label = "Ignorar Ocorrencias de Cálculo";
                widgetForm.getField('NMEVENTOH').label = "Apenas Recibos de Pagamentos com este evento:";
                
                widgetForm.getField('NUMBER1').isVisible = false;
                widgetForm.getField('NUMBER2').isVisible = false;
                widgetForm.getField('NUMBER3').isVisible = false;
                widgetForm.getField('NUMBER4').isVisible = false;
                widgetForm.getField('DATA1').isVisible = false;
                widgetForm.getField('DATA2').isVisible = false;
                widgetForm.getField('NMABREV').isVisible = false;
                widgetForm.getField('NMOPCOES1').isVisible = true;
                widgetForm.getField('NMOPCOES2').isVisible = false;
                widgetForm.getField('NMOPCOES3').isVisible = false;
                widgetForm.getField('NMOPCOES4').isVisible = false;
                widgetForm.getField('NMOPCOES5').isVisible = false;
                widgetForm.getField('NMOPCOES6').isVisible = false;
                widgetForm.getField('NMOPCOES7').isVisible = false;
                widgetForm.getField('NMOPCOES8').isVisible = false;
                widgetForm.getField('NMTIPOESTRUTURA').isVisible = false;
                widgetForm.getField('NMTIPOINCIDE').isVisible = false;
                widgetForm.getField('TEXTO1').isVisible = false;
                widgetForm.getField('DTINICIO').isVisible = false;
                widgetForm.getField('DTFIM').isVisible = false;
                widgetForm.getField('NMEVENTOH').isVisible = true;
                widgetForm.getField('DSOBSERVACAO').isVisible = true;
                widgetForm.getField('DTDOCUMENTO').isVisible = false;
                widgetForm.getField('NUMBER1').validations = {};
                widgetForm.getField('NUMBER2').validations = {};
                widgetForm.getField('DATA1').validations = {};
                widgetForm.getField('DATA2').validations = {};
                widgetForm.getField('NMEVENTOH').validations = {};
                widgetForm.getField('NMTIPOESTRUTURA').validations = {};
                widgetForm.getField('DTINICIO').validations = {};
                widgetForm.getField('DTFIM').validations = {};
                break;
            }
            case 'gps':{
                widgetForm.label = "GPS";
                widgetForm.NMREPORT = 'gps';
                widgetForm.getField('TEXTO1').label = "Código do Pagamento";
                widgetForm.getField('NUMBER1').label = "Identificador";
                widgetForm.getField('NUMBER2').label = "Valor do INSS";
                widgetForm.getField('NUMBER3').label = "Valor de Outras Entidades";
                widgetForm.getField('NUMBER4').label = "ATM/Multa e Juros";
                widgetForm.getField('NMOPCOES1').label = "Emissão de Guias por Vínculo";
                
                widgetForm.getField('NUMBER1').isVisible = true;
                widgetForm.getField('NUMBER2').isVisible = true;
                widgetForm.getField('NUMBER3').isVisible = true;
                widgetForm.getField('NUMBER4').isVisible = true;
                widgetForm.getField('DATA1').isVisible = false;
                widgetForm.getField('DATA2').isVisible = false;
                widgetForm.getField('NMABREV').isVisible = false;
                widgetForm.getField('NMOPCOES1').isVisible = true;
                widgetForm.getField('NMOPCOES2').isVisible = false;
                widgetForm.getField('NMOPCOES3').isVisible = false;
                widgetForm.getField('NMOPCOES4').isVisible = false;
                widgetForm.getField('NMOPCOES5').isVisible = false;
                widgetForm.getField('NMOPCOES6').isVisible = false;
                widgetForm.getField('NMOPCOES7').isVisible = false;
                widgetForm.getField('NMOPCOES8').isVisible = false;
                widgetForm.getField('NMTIPOESTRUTURA').isVisible = true;
                widgetForm.getField('NMTIPOINCIDE').isVisible = false;
                widgetForm.getField('TEXTO1').isVisible = false;
                widgetForm.getField('DTINICIO').isVisible = false;
                widgetForm.getField('DTFIM').isVisible = false;
                widgetForm.getField('NMEVENTOH').isVisible = false;
                widgetForm.getField('DSOBSERVACAO').isVisible = false;
                widgetForm.getField('DTDOCUMENTO').isVisible = false;
                widgetForm.getField('NUMBER1').validations = {};
                widgetForm.getField('NUMBER2').validations = {};
                widgetForm.getField('DATA1').validations = {};
                widgetForm.getField('DATA2').validations = {};
                widgetForm.getField('NMEVENTOH').validations = {};
                widgetForm.getField('NMTIPOESTRUTURA').validations = {required : true};
                widgetForm.getField('DTINICIO').validations = {};
                widgetForm.getField('DTFIM').validations = {};
                break;}
            case 'liquido':{
                widgetForm.label = "Liquido";
                widgetForm.NMREPORT = 'liquido';
                widgetForm.getField('DTINICIO').label = "Data de ocorrência/pagamento";
                widgetForm.getField('NMEVENTOH').label = "Evento do líquido (Ex.: 3030, 3040, 3050, etc.)";
                widgetForm.getField('NMOPCOES1').label = "Omitir Vínculos";
                widgetForm.getField('NMOPCOES2').label = "Omitir Agrupamento Gerencial";
                widgetForm.getField('NMOPCOES3').label = "Incluir Vínculos Demitidos";
                
                widgetForm.getField('NUMBER1').isVisible = false;
                widgetForm.getField('NUMBER2').isVisible = false;
                widgetForm.getField('NUMBER3').isVisible = false;
                widgetForm.getField('NUMBER4').isVisible = false;
                widgetForm.getField('DATA1').isVisible = false;
                widgetForm.getField('DATA2').isVisible = false;
                widgetForm.getField('NMABREV').isVisible = false;
                widgetForm.getField('NMOPCOES1').isVisible = true;
                widgetForm.getField('NMOPCOES2').isVisible = true;
                widgetForm.getField('NMOPCOES3').isVisible = true;
                widgetForm.getField('NMOPCOES4').isVisible = false;
                widgetForm.getField('NMOPCOES5').isVisible = false;
                widgetForm.getField('NMOPCOES6').isVisible = false;
                widgetForm.getField('NMOPCOES7').isVisible = false;
                widgetForm.getField('NMOPCOES8').isVisible = false;
                widgetForm.getField('NMTIPOESTRUTURA').isVisible = false;
                widgetForm.getField('NMTIPOINCIDE').isVisible = false;
                widgetForm.getField('TEXTO1').isVisible = false;
                widgetForm.getField('DTINICIO').isVisible = true;
                widgetForm.getField('DTFIM').isVisible = false;
                widgetForm.getField('NMEVENTOH').isVisible = true;
                widgetForm.getField('DSOBSERVACAO').isVisible = false;
                widgetForm.getField('DTDOCUMENTO').isVisible = false;
                widgetForm.getField('NUMBER1').validations = {};
                widgetForm.getField('NUMBER2').validations = {};
                widgetForm.getField('DATA1').validations = {};
                widgetForm.getField('DATA2').validations = {};
                widgetForm.getField('NMEVENTOH').validations = {required: true};
                widgetForm.getField('NMTIPOESTRUTURA').validations = {};
                widgetForm.getField('DTINICIO').validations = {};
                widgetForm.getField('DTFIM').validations = {};
                break;}
            case 'resumo_irrf':{
                widgetForm.label = "Resumo IRRF";
                widgetForm.NMREPORT = 'resumo_irrf';
                widgetForm.getField('NMOPCOES1').label = "Regime Caixa";
                widgetForm.getField('NMOPCOES2').label = "Omitir Agrupamento Gerencial";
                widgetForm.getField('NMOPCOES3').label = "Ignorar Ocorrencias de Cálculo";
                
                widgetForm.getField('NUMBER1').isVisible = false;
                widgetForm.getField('NUMBER2').isVisible = false;
                widgetForm.getField('NUMBER3').isVisible = false;
                widgetForm.getField('NUMBER4').isVisible = false;
                widgetForm.getField('DATA1').isVisible = false;
                widgetForm.getField('DATA2').isVisible = false;
                widgetForm.getField('NMABREV').isVisible = false;
                widgetForm.getField('NMOPCOES1').isVisible = true;
                widgetForm.getField('NMOPCOES2').isVisible = true;
                widgetForm.getField('NMOPCOES3').isVisible = true;
                widgetForm.getField('NMOPCOES4').isVisible = false;
                widgetForm.getField('NMOPCOES5').isVisible = false;
                widgetForm.getField('NMOPCOES6').isVisible = false;
                widgetForm.getField('NMOPCOES7').isVisible = false;
                widgetForm.getField('NMOPCOES8').isVisible = false;
                widgetForm.getField('NMTIPOESTRUTURA').isVisible = false;
                widgetForm.getField('NMTIPOINCIDE').isVisible = false;
                widgetForm.getField('TEXTO1').isVisible = false;
                widgetForm.getField('DTINICIO').isVisible = true;
                widgetForm.getField('DTFIM').isVisible = true;
                widgetForm.getField('NMEVENTOH').isVisible = false;
                widgetForm.getField('DSOBSERVACAO').isVisible = false;
                widgetForm.getField('DTDOCUMENTO').isVisible = false;
                widgetForm.getField('NUMBER1').validations = {};
                widgetForm.getField('NUMBER2').validations = {};
                widgetForm.getField('DATA1').validations = {};
                widgetForm.getField('DATA2').validations = {};
                widgetForm.getField('NMEVENTOH').validations = {};
                widgetForm.getField('NMTIPOESTRUTURA').validations = {};
                widgetForm.getField('DTINICIO').validations = {};
                widgetForm.getField('DTFIM').validations = {};
                break;}
            case 'resumo_impostos':{
                widgetForm.label = "Resumo de Impostos";
                widgetForm.NMREPORT = 'resumo_impostos';
                widgetForm.getField('NMOPCOES1').label = "Incluir 13º Sal. no movimento";
                widgetForm.getField('NMOPCOES2').label = "Omitir Agrupamento Gerencial";
                widgetForm.getField('NMOPCOES3').label = "Ignorar Ocorrencias de Cálculo";
                
                widgetForm.getField('NUMBER1').isVisible = false;
                widgetForm.getField('NUMBER2').isVisible = false;
                widgetForm.getField('NUMBER3').isVisible = false;
                widgetForm.getField('NUMBER4').isVisible = false;
                widgetForm.getField('DATA1').isVisible = false;
                widgetForm.getField('DATA2').isVisible = false;
                widgetForm.getField('NMABREV').isVisible = false;
                widgetForm.getField('NMOPCOES1').isVisible = true;
                widgetForm.getField('NMOPCOES2').isVisible = true;
                widgetForm.getField('NMOPCOES3').isVisible = true;
                widgetForm.getField('NMOPCOES4').isVisible = false;
                widgetForm.getField('NMOPCOES5').isVisible = false;
                widgetForm.getField('NMOPCOES6').isVisible = false;
                widgetForm.getField('NMOPCOES7').isVisible = false;
                widgetForm.getField('NMOPCOES8').isVisible = false;
                widgetForm.getField('NMTIPOESTRUTURA').isVisible = false;
                widgetForm.getField('NMTIPOINCIDE').isVisible = false;
                widgetForm.getField('TEXTO1').isVisible = false;
                widgetForm.getField('DTINICIO').isVisible = false;
                widgetForm.getField('DTFIM').isVisible = false;
                widgetForm.getField('NMEVENTOH').isVisible = false;
                widgetForm.getField('DSOBSERVACAO').isVisible = false;
                widgetForm.getField('DTDOCUMENTO').isVisible = false;
                widgetForm.getField('NUMBER1').validations = {};
                widgetForm.getField('NUMBER2').validations = {};
                widgetForm.getField('DATA1').validations = {};
                widgetForm.getField('DATA2').validations = {};
                widgetForm.getField('NMEVENTOH').validations = {};
                widgetForm.getField('NMTIPOESTRUTURA').validations = {};
                widgetForm.getField('DTINICIO').validations = {};
                widgetForm.getField('DTFIM').validations = {};
                break;
            }
            case 'folha_analitica_sintetico':{
                widgetForm.label = "Folha analitica sintetico";
                widgetForm.NMREPORT = 'folha_analitica_sintetico';
                widgetForm.getField('NMOPCOES1').label = "Omitir Vínculos";
                widgetForm.getField('NMOPCOES2').label = "Omitir Resumo Legal";
                widgetForm.getField('NMOPCOES3').label = "Incluir 13º Sal. no movimento";
                widgetForm.getField('NMOPCOES4').label = "Omitir Data de Rescisão";
                widgetForm.getField('NMOPCOES5').label = "Somente Vínculos Demitidos";
                widgetForm.getField('NMOPCOES6').label = "Omitir Resumo Gerencial";
                widgetForm.getField('NMOPCOES7').label = "Ignorar Ocorrencias de Cálculo";
                widgetForm.getField('NMOPCOES8').label = "Mostrar Eventos Demonstrativos";
                widgetForm.getField('NMTIPOINCIDE').label = "Eventos Ocultos do Tipo de Incidencia";
                
                widgetForm.getField('NUMBER1').isVisible = false;
                widgetForm.getField('NUMBER2').isVisible = false;
                widgetForm.getField('NUMBER3').isVisible = false;
                widgetForm.getField('NUMBER4').isVisible = false;
                widgetForm.getField('DATA1').isVisible = false;
                widgetForm.getField('DATA2').isVisible = false;
                widgetForm.getField('NMABREV').isVisible = false;
                widgetForm.getField('NMOPCOES1').isVisible = true;
                widgetForm.getField('NMOPCOES2').isVisible = true;
                widgetForm.getField('NMOPCOES3').isVisible = true;
                widgetForm.getField('NMOPCOES4').isVisible = true;
                widgetForm.getField('NMOPCOES5').isVisible = true;
                widgetForm.getField('NMOPCOES6').isVisible = true;
                widgetForm.getField('NMOPCOES7').isVisible = true;
                widgetForm.getField('NMOPCOES8').isVisible = true;
                widgetForm.getField('NMTIPOESTRUTURA').isVisible = false;
                widgetForm.getField('NMTIPOINCIDE').isVisible = true;
                widgetForm.getField('TEXTO1').isVisible = false;
                widgetForm.getField('DTINICIO').isVisible = false;
                widgetForm.getField('DTFIM').isVisible = false;
                widgetForm.getField('NMEVENTOH').isVisible = false;
                widgetForm.getField('DSOBSERVACAO').isVisible = false;
                widgetForm.getField('DTDOCUMENTO').isVisible = false;
                widgetForm.getField('NUMBER1').validations = {};
                widgetForm.getField('NUMBER2').validations = {};
                widgetForm.getField('DATA1').validations = {};
                widgetForm.getField('DATA2').validations = {};
                widgetForm.getField('NMEVENTOH').validations = {};
                widgetForm.getField('NMTIPOESTRUTURA').validations = {};
                widgetForm.getField('DTINICIO').validations = {};
                widgetForm.getField('DTFIM').validations = {};
                break;
            }
            case 'aviso_previo_ferias':{
                widgetForm.label = "Aviso previo ferias";
                widgetForm.NMREPORT = 'aviso_previo_ferias';
                widgetForm.getField('DTINICIO').label = "Data Inicial de Gozo de Férias";
                widgetForm.getField('DTFIM').label = "Data Final de Gozo de Férias";
                
                widgetForm.getField('NUMBER1').isVisible = false;
                widgetForm.getField('NUMBER2').isVisible = false;
                widgetForm.getField('NUMBER3').isVisible = false;
                widgetForm.getField('NUMBER4').isVisible = false;
                widgetForm.getField('DATA1').isVisible = false;
                widgetForm.getField('DATA2').isVisible = false;
                widgetForm.getField('NMABREV').isVisible = false;
                widgetForm.getField('NMOPCOES1').isVisible = false;
                widgetForm.getField('NMOPCOES2').isVisible = false;
                widgetForm.getField('NMOPCOES3').isVisible = false;
                widgetForm.getField('NMOPCOES4').isVisible = false;
                widgetForm.getField('NMOPCOES5').isVisible = false;
                widgetForm.getField('NMOPCOES6').isVisible = false;
                widgetForm.getField('NMOPCOES7').isVisible = false;
                widgetForm.getField('NMOPCOES8').isVisible = false;
                widgetForm.getField('NMTIPOESTRUTURA').isVisible = false;
                widgetForm.getField('NMTIPOINCIDE').isVisible = false;
                widgetForm.getField('TEXTO1').isVisible = false;
                widgetForm.getField('DTINICIO').isVisible = true;
                widgetForm.getField('DTFIM').isVisible = true;
                widgetForm.getField('NMEVENTOH').isVisible = false;
                widgetForm.getField('DSOBSERVACAO').isVisible = false;
                widgetForm.getField('DTDOCUMENTO').isVisible = false;
                widgetForm.getField('NUMBER1').validations = {};
                widgetForm.getField('NUMBER2').validations = {};
                widgetForm.getField('DATA1').validations = {};
                widgetForm.getField('DATA2').validations = {};
                widgetForm.getField('NMEVENTOH').validations = {};
                widgetForm.getField('NMTIPOESTRUTURA').validations = {};
                widgetForm.getField('DTINICIO').validations = {};
                widgetForm.getField('DTFIM').validations = {};
                break;
            }
            case 'recibo_ferias':{
                widgetForm.label = "Recibo de ferias";
                widgetForm.NMREPORT = 'recibo_ferias';
                widgetForm.getField('DATA1').label = "Data Recibo/Lim. Prev. Fér.";
                widgetForm.getField('DTINICIO').label = "Data Inicial de Gozo de Férias";
                widgetForm.getField('DTFIM').label = "Data Final de Gozo de Férias";
                widgetForm.getField('NMOPCOES2').label = "2 Vias (Recibo de Férias)";
                widgetForm.getField('NMOPCOES3').label = "Somente Vínculos Ativos (Recibo de Férias)";
                
                widgetForm.getField('NUMBER1').isVisible = false;
                widgetForm.getField('NUMBER2').isVisible = false;
                widgetForm.getField('NUMBER3').isVisible = false;
                widgetForm.getField('NUMBER4').isVisible = false;
                widgetForm.getField('DATA1').isVisible = true;
                widgetForm.getField('DATA2').isVisible = false;
                widgetForm.getField('NMABREV').isVisible = false;
                widgetForm.getField('NMOPCOES1').isVisible = false;
                widgetForm.getField('NMOPCOES2').isVisible = true;
                widgetForm.getField('NMOPCOES3').isVisible = true;
                widgetForm.getField('NMOPCOES4').isVisible = false;
                widgetForm.getField('NMOPCOES5').isVisible = false;
                widgetForm.getField('NMOPCOES6').isVisible = false;
                widgetForm.getField('NMOPCOES7').isVisible = false;
                widgetForm.getField('NMOPCOES8').isVisible = false;
                widgetForm.getField('NMTIPOESTRUTURA').isVisible = false;
                widgetForm.getField('NMTIPOINCIDE').isVisible = false;
                widgetForm.getField('TEXTO1').isVisible = false;
                widgetForm.getField('DTINICIO').isVisible = true;
                widgetForm.getField('DTFIM').isVisible = true;
                widgetForm.getField('NMEVENTOH').isVisible = false;
                widgetForm.getField('DSOBSERVACAO').isVisible = false;
                widgetForm.getField('DTDOCUMENTO').isVisible = false;
                widgetForm.getField('NUMBER1').validations = {};
                widgetForm.getField('NUMBER2').validations = {};
                widgetForm.getField('DATA1').validations = {};
                widgetForm.getField('DATA2').validations = {};
                widgetForm.getField('NMEVENTOH').validations = {};
                widgetForm.getField('NMTIPOESTRUTURA').validations = {};
                widgetForm.getField('DTINICIO').validations = {};
                widgetForm.getField('DTFIM').validations = {};
                break;
            }
            case 'medias_ferias': {
                widgetForm.label = "Media de Ferias";
                widgetForm.NMREPORT = 'medias_ferias';
                widgetForm.getField('NMOPCOES1').label = "Mostrar Simulação de Cálculo de Médias";
                widgetForm.getField('NMOPCOES2').label = "2 Vias (Recibo de Férias)";
                widgetForm.getField('DTINICIO').label = "Data Inicial de Gozo de Férias";
                widgetForm.getField('DTFIM').label = "Data Final de Gozo de Férias";
                
                widgetForm.getField('NUMBER1').isVisible = false;
                widgetForm.getField('NUMBER2').isVisible = false;
                widgetForm.getField('NUMBER3').isVisible = false;
                widgetForm.getField('NUMBER4').isVisible = false;
                widgetForm.getField('DATA1').isVisible = false;
                widgetForm.getField('DATA2').isVisible = false;
                widgetForm.getField('NMABREV').isVisible = false;
                widgetForm.getField('NMOPCOES1').isVisible = true;
                widgetForm.getField('NMOPCOES2').isVisible = true;
                widgetForm.getField('NMOPCOES3').isVisible = false;
                widgetForm.getField('NMOPCOES4').isVisible = false;
                widgetForm.getField('NMOPCOES5').isVisible = false;
                widgetForm.getField('NMOPCOES6').isVisible = false;
                widgetForm.getField('NMOPCOES7').isVisible = false;
                widgetForm.getField('NMOPCOES8').isVisible = false;
                widgetForm.getField('NMTIPOESTRUTURA').isVisible = false;
                widgetForm.getField('NMTIPOINCIDE').isVisible = false;
                widgetForm.getField('TEXTO1').isVisible = false;
                widgetForm.getField('DTINICIO').isVisible = true;
                widgetForm.getField('DTFIM').isVisible = true;
                widgetForm.getField('NMEVENTOH').isVisible = false;
                widgetForm.getField('DSOBSERVACAO').isVisible = false;
                widgetForm.getField('DTDOCUMENTO').isVisible = false;
                widgetForm.getField('NUMBER1').validations = {};
                widgetForm.getField('NUMBER2').validations = {};
                widgetForm.getField('DATA1').validations = {required: true};
                widgetForm.getField('DATA2').validations = {required: true};
                widgetForm.getField('NMEVENTOH').validations = {};
                widgetForm.getField('NMTIPOESTRUTURA').validations = {};
                widgetForm.getField('DTINICIO').validations = {};
                widgetForm.getField('DTFIM').validations = {};
                break;
            }
            case 'trct_qh': {
                widgetForm.label = "TRCT (Quitação/Homologação)";
                widgetForm.NMREPORT = 'trct_qh';
                
                widgetForm.getField('NUMBER1').isVisible = false;
                widgetForm.getField('NUMBER2').isVisible = false;
                widgetForm.getField('NUMBER3').isVisible = false;
                widgetForm.getField('NUMBER4').isVisible = false;
                widgetForm.getField('DATA1').isVisible = false;
                widgetForm.getField('DATA2').isVisible = false;
                widgetForm.getField('NMABREV').isVisible = false;
                widgetForm.getField('NMOPCOES1').isVisible = false;
                widgetForm.getField('NMOPCOES2').isVisible = false;
                widgetForm.getField('NMOPCOES3').isVisible = false;
                widgetForm.getField('NMOPCOES4').isVisible = false;
                widgetForm.getField('NMOPCOES5').isVisible = false;
                widgetForm.getField('NMOPCOES6').isVisible = false;
                widgetForm.getField('NMOPCOES7').isVisible = false;
                widgetForm.getField('NMOPCOES8').isVisible = false;
                widgetForm.getField('NMTIPOESTRUTURA').isVisible = false;
                widgetForm.getField('NMTIPOINCIDE').isVisible = false;
                widgetForm.getField('TEXTO1').isVisible = false;
                widgetForm.getField('DTINICIO').isVisible = false;
                widgetForm.getField('DTFIM').isVisible = false;
                widgetForm.getField('NMEVENTOH').isVisible = false;
                widgetForm.getField('DSOBSERVACAO').isVisible = false;
                widgetForm.getField('DTDOCUMENTO').isVisible = false;
                widgetForm.getField('NUMBER1').validations = {};
                widgetForm.getField('NUMBER2').validations = {};
                widgetForm.getField('DATA1').validations = {};
                widgetForm.getField('DATA2').validations = {};
                widgetForm.getField('NMEVENTOH').validations = {};
                widgetForm.getField('NMTIPOESTRUTURA').validations = {};
                widgetForm.getField('DTINICIO').validations = {};
                widgetForm.getField('DTFIM').validations = {};
                break;
            }
            case 'medias_rescisao_aviso_prev':{
                widgetForm.label = "Médias para Aviso Prévio na Rescisão";
                widgetForm.NMREPORT = 'medias_rescisao_aviso_prev';
                widgetForm.getField('DTINICIO').label = "Data inicial da rescisão";
                widgetForm.getField('DTFIM').label = "Data final da rescisão";
                
                widgetForm.getField('NUMBER1').isVisible = false;
                widgetForm.getField('NUMBER2').isVisible = false;
                widgetForm.getField('NUMBER3').isVisible = false;
                widgetForm.getField('NUMBER4').isVisible = false;
                widgetForm.getField('DATA1').isVisible = false;
                widgetForm.getField('DATA2').isVisible = false;
                widgetForm.getField('NMABREV').isVisible = false;
                widgetForm.getField('NMOPCOES1').isVisible = false;
                widgetForm.getField('NMOPCOES2').isVisible = false;
                widgetForm.getField('NMOPCOES3').isVisible = false;
                widgetForm.getField('NMOPCOES4').isVisible = false;
                widgetForm.getField('NMOPCOES5').isVisible = false;
                widgetForm.getField('NMOPCOES6').isVisible = false;
                widgetForm.getField('NMOPCOES7').isVisible = false;
                widgetForm.getField('NMOPCOES8').isVisible = false;
                widgetForm.getField('NMTIPOESTRUTURA').isVisible = false;
                widgetForm.getField('NMTIPOINCIDE').isVisible = false;
                widgetForm.getField('TEXTO1').isVisible = false;
                widgetForm.getField('DTINICIO').isVisible = true;
                widgetForm.getField('DTFIM').isVisible = true;
                widgetForm.getField('NMEVENTOH').isVisible = false;
                widgetForm.getField('DSOBSERVACAO').isVisible = false;
                widgetForm.getField('DTDOCUMENTO').isVisible = false;
                widgetForm.getField('NUMBER1').validations = {};
                widgetForm.getField('NUMBER2').validations = {};
                widgetForm.getField('DATA1').validations = {};
                widgetForm.getField('DATA2').validations = {};
                widgetForm.getField('NMEVENTOH').validations = {};
                widgetForm.getField('NMTIPOESTRUTURA').validations = {};
                widgetForm.getField('DTINICIO').validations = {};
                widgetForm.getField('DTFIM').validations = {};
                break;
            }
            case 'medias_rescisao_13': {
                widgetForm.label = "Médias para 13 Salário na Rescisão";
                widgetForm.NMREPORT = 'medias_rescisao_13';
                widgetForm.getField('DTINICIO').label = "Data inicial da rescisão";
                widgetForm.getField('DTFIM').label = "Data final da rescisão";
                
                widgetForm.getField('NUMBER1').isVisible = false;
                widgetForm.getField('NUMBER2').isVisible = false;
                widgetForm.getField('NUMBER3').isVisible = false;
                widgetForm.getField('NUMBER4').isVisible = false;
                widgetForm.getField('DATA1').isVisible = false;
                widgetForm.getField('DATA2').isVisible = false;
                widgetForm.getField('NMABREV').isVisible = false;
                widgetForm.getField('NMOPCOES1').isVisible = false;
                widgetForm.getField('NMOPCOES2').isVisible = false;
                widgetForm.getField('NMOPCOES3').isVisible = false;
                widgetForm.getField('NMOPCOES4').isVisible = false;
                widgetForm.getField('NMOPCOES5').isVisible = false;
                widgetForm.getField('NMOPCOES6').isVisible = false;
                widgetForm.getField('NMOPCOES7').isVisible = false;
                widgetForm.getField('NMOPCOES8').isVisible = false;
                widgetForm.getField('NMTIPOESTRUTURA').isVisible = false;
                widgetForm.getField('NMTIPOINCIDE').isVisible = false;
                widgetForm.getField('TEXTO1').isVisible = false;
                widgetForm.getField('DTINICIO').isVisible = true;
                widgetForm.getField('DTFIM').isVisible = true;
                widgetForm.getField('NMEVENTOH').isVisible = false;
                widgetForm.getField('DSOBSERVACAO').isVisible = false;
                widgetForm.getField('DTDOCUMENTO').isVisible = false;
                widgetForm.getField('NUMBER1').validations = {};
                widgetForm.getField('NUMBER2').validations = {};
                widgetForm.getField('DATA1').validations = {};
                widgetForm.getField('DATA2').validations = {};
                widgetForm.getField('NMEVENTOH').validations = {};
                widgetForm.getField('NMTIPOESTRUTURA').validations = {};
                widgetForm.getField('DTINICIO').validations = {};
                widgetForm.getField('DTFIM').validations = {};
                break;
            }
            case 'medias_rescisao_ferias': {
                widgetForm.label = "Médias para Férias na Rescisão";
                widgetForm.NMREPORT = 'medias_rescisao_ferias';
                widgetForm.getField('DTINICIO').label = "Data inicial da rescisão";
                widgetForm.getField('DTFIM').label = "Data final da rescisão";
                
                widgetForm.getField('NUMBER1').isVisible = false;
                widgetForm.getField('NUMBER2').isVisible = false;
                widgetForm.getField('NUMBER3').isVisible = false;
                widgetForm.getField('NUMBER4').isVisible = false;
                widgetForm.getField('DATA1').isVisible = false;
                widgetForm.getField('DATA2').isVisible = false;
                widgetForm.getField('NMABREV').isVisible = false;
                widgetForm.getField('NMOPCOES1').isVisible = false;
                widgetForm.getField('NMOPCOES2').isVisible = false;
                widgetForm.getField('NMOPCOES3').isVisible = false;
                widgetForm.getField('NMOPCOES4').isVisible = false;
                widgetForm.getField('NMOPCOES5').isVisible = false;
                widgetForm.getField('NMOPCOES6').isVisible = false;
                widgetForm.getField('NMOPCOES7').isVisible = false;
                widgetForm.getField('NMOPCOES8').isVisible = false;
                widgetForm.getField('NMTIPOESTRUTURA').isVisible = false;
                widgetForm.getField('NMTIPOINCIDE').isVisible = false;
                widgetForm.getField('TEXTO1').isVisible = false;
                widgetForm.getField('DTINICIO').isVisible = true;
                widgetForm.getField('DTFIM').isVisible = true;
                widgetForm.getField('NMEVENTOH').isVisible = false;
                widgetForm.getField('DSOBSERVACAO').isVisible = false;
                widgetForm.getField('DTDOCUMENTO').isVisible = false;
                widgetForm.getField('NUMBER1').validations = {};
                widgetForm.getField('NUMBER2').validations = {};
                widgetForm.getField('DATA1').validations = {};
                widgetForm.getField('DATA2').validations = {};
                widgetForm.getField('NMEVENTOH').validations = {};
                widgetForm.getField('NMTIPOESTRUTURA').validations = {};
                widgetForm.getField('DTINICIO').validations = {};
                widgetForm.getField('DTFIM').validations = {};
                break;
            }
            case 'aviso_previo_empregado': {
                widgetForm.label = "Aviso Prévio do Empregado";
                widgetForm.NMREPORT = 'aviso_previo_empregado';
                widgetForm.getField('DTDOCUMENTO').label = "Data do aviso prévio";
                
                widgetForm.getField('NUMBER1').isVisible = false;
                widgetForm.getField('NUMBER2').isVisible = false;
                widgetForm.getField('NUMBER3').isVisible = false;
                widgetForm.getField('NUMBER4').isVisible = false;
                widgetForm.getField('DATA1').isVisible = false;
                widgetForm.getField('DATA2').isVisible = false;
                widgetForm.getField('NMABREV').isVisible = false;
                widgetForm.getField('NMOPCOES1').isVisible = false;
                widgetForm.getField('NMOPCOES2').isVisible = false;
                widgetForm.getField('NMOPCOES3').isVisible = false;
                widgetForm.getField('NMOPCOES4').isVisible = false;
                widgetForm.getField('NMOPCOES5').isVisible = false;
                widgetForm.getField('NMOPCOES6').isVisible = false;
                widgetForm.getField('NMOPCOES7').isVisible = false;
                widgetForm.getField('NMOPCOES8').isVisible = false;
                widgetForm.getField('NMTIPOESTRUTURA').isVisible = false;
                widgetForm.getField('NMTIPOINCIDE').isVisible = false;
                widgetForm.getField('TEXTO1').isVisible = false;
                widgetForm.getField('DTINICIO').isVisible = false;
                widgetForm.getField('DTFIM').isVisible = false;
                widgetForm.getField('NMEVENTOH').isVisible = false;
                widgetForm.getField('DSOBSERVACAO').isVisible = false;
                widgetForm.getField('DTDOCUMENTO').isVisible = true;
                widgetForm.getField('NUMBER1').validations = {};
                widgetForm.getField('NUMBER2').validations = {};
                widgetForm.getField('DATA1').validations = {};
                widgetForm.getField('DATA2').validations = {};
                widgetForm.getField('NMEVENTOH').validations = {};
                widgetForm.getField('NMTIPOESTRUTURA').validations = {};
                widgetForm.getField('DTINICIO').validations = {};
                widgetForm.getField('DTFIM').validations = {};
                break;
            }
            case 'aviso_previo_empregador_indenizado': {
                widgetForm.label = "Aviso Prévio do Empregador";
                widgetForm.NMREPORT = 'aviso_previo_empregador_indenizado';
                widgetForm.getField('DTDOCUMENTO').label = "Data do aviso prévio";
                
                widgetForm.getField('NUMBER1').isVisible = false;
                widgetForm.getField('NUMBER2').isVisible = false;
                widgetForm.getField('NUMBER3').isVisible = false;
                widgetForm.getField('NUMBER4').isVisible = false;
                widgetForm.getField('DATA1').isVisible = false;
                widgetForm.getField('DATA2').isVisible = false;
                widgetForm.getField('NMABREV').isVisible = false;
                widgetForm.getField('NMOPCOES1').isVisible = false;
                widgetForm.getField('NMOPCOES2').isVisible = false;
                widgetForm.getField('NMOPCOES3').isVisible = false;
                widgetForm.getField('NMOPCOES4').isVisible = false;
                widgetForm.getField('NMOPCOES5').isVisible = false;
                widgetForm.getField('NMOPCOES6').isVisible = false;
                widgetForm.getField('NMOPCOES7').isVisible = false;
                widgetForm.getField('NMOPCOES8').isVisible = false;
                widgetForm.getField('NMTIPOESTRUTURA').isVisible = false;
                widgetForm.getField('NMTIPOINCIDE').isVisible = false;
                widgetForm.getField('TEXTO1').isVisible = false;
                widgetForm.getField('DTINICIO').isVisible = false;
                widgetForm.getField('DTFIM').isVisible = false;
                widgetForm.getField('NMEVENTOH').isVisible = false;
                widgetForm.getField('DSOBSERVACAO').isVisible = false;
                widgetForm.getField('DTDOCUMENTO').isVisible = true;
                widgetForm.getField('NUMBER1').validations = {};
                widgetForm.getField('NUMBER2').validations = {};
                widgetForm.getField('DATA1').validations = {};
                widgetForm.getField('DATA2').validations = {};
                widgetForm.getField('NMEVENTOH').validations = {};
                widgetForm.getField('NMTIPOESTRUTURA').validations = {};
                widgetForm.getField('DTINICIO').validations = {};
                widgetForm.getField('DTFIM').validations = {};
                break;
            }
            case 'aviso_previo_empregador_trabalhado': {
                widgetForm.label = "Aviso Prévio do Empregador";
                widgetForm.NMREPORT = 'aviso_previo_empregador_trabalhado';
                widgetForm.getField('DTDOCUMENTO').label = "Data do aviso prévio";
                
                widgetForm.getField('NUMBER1').isVisible = false;
                widgetForm.getField('NUMBER2').isVisible = false;
                widgetForm.getField('NUMBER3').isVisible = false;
                widgetForm.getField('NUMBER4').isVisible = false;
                widgetForm.getField('DATA1').isVisible = false;
                widgetForm.getField('DATA2').isVisible = false;
                widgetForm.getField('NMABREV').isVisible = false;
                widgetForm.getField('NMOPCOES1').isVisible = false;
                widgetForm.getField('NMOPCOES2').isVisible = false;
                widgetForm.getField('NMOPCOES3').isVisible = false;
                widgetForm.getField('NMOPCOES4').isVisible = false;
                widgetForm.getField('NMOPCOES5').isVisible = false;
                widgetForm.getField('NMOPCOES6').isVisible = false;
                widgetForm.getField('NMOPCOES7').isVisible = false;
                widgetForm.getField('NMOPCOES8').isVisible = false;
                widgetForm.getField('NMTIPOESTRUTURA').isVisible = false;
                widgetForm.getField('NMTIPOINCIDE').isVisible = false;
                widgetForm.getField('TEXTO1').isVisible = false;
                widgetForm.getField('DTINICIO').isVisible = false;
                widgetForm.getField('DTFIM').isVisible = false;
                widgetForm.getField('NMEVENTOH').isVisible = false;
                widgetForm.getField('DSOBSERVACAO').isVisible = false;
                widgetForm.getField('DTDOCUMENTO').isVisible = true;
                widgetForm.getField('NUMBER1').validations = {};
                widgetForm.getField('NUMBER2').validations = {};
                widgetForm.getField('DATA1').validations = {};
                widgetForm.getField('DATA2').validations = {};
                widgetForm.getField('NMEVENTOH').validations = {};
                widgetForm.getField('NMTIPOESTRUTURA').validations = {};
                widgetForm.getField('DTINICIO').validations = {};
                widgetForm.getField('DTFIM').validations = {};
                break;
            }
            case 'carta_referencia':{
                widgetForm.label = "Carta de Referência";
                widgetForm.NMREPORT = 'carta_referencia';
                
                widgetForm.getField('NUMBER1').isVisible = false;
                widgetForm.getField('NUMBER2').isVisible = false;
                widgetForm.getField('NUMBER3').isVisible = false;
                widgetForm.getField('NUMBER4').isVisible = false;
                widgetForm.getField('DATA1').isVisible = false;
                widgetForm.getField('DATA2').isVisible = false;
                widgetForm.getField('NMABREV').isVisible = false;
                widgetForm.getField('NMOPCOES1').isVisible = false;
                widgetForm.getField('NMOPCOES2').isVisible = false;
                widgetForm.getField('NMOPCOES3').isVisible = false;
                widgetForm.getField('NMOPCOES4').isVisible = false;
                widgetForm.getField('NMOPCOES5').isVisible = false;
                widgetForm.getField('NMOPCOES6').isVisible = false;
                widgetForm.getField('NMOPCOES7').isVisible = false;
                widgetForm.getField('NMOPCOES8').isVisible = false;
                widgetForm.getField('NMTIPOESTRUTURA').isVisible = false;
                widgetForm.getField('NMTIPOINCIDE').isVisible = false;
                widgetForm.getField('TEXTO1').isVisible = false;
                widgetForm.getField('DTINICIO').isVisible = false;
                widgetForm.getField('DTFIM').isVisible = false;
                widgetForm.getField('NMEVENTOH').isVisible = false;
                widgetForm.getField('DSOBSERVACAO').isVisible = false;
                widgetForm.getField('DTDOCUMENTO').isVisible = false;
                widgetForm.getField('NUMBER1').validations = {};
                widgetForm.getField('NUMBER2').validations = {};
                widgetForm.getField('DATA1').validations = {};
                widgetForm.getField('DATA2').validations = {};
                widgetForm.getField('NMEVENTOH').validations = {};
                widgetForm.getField('NMTIPOESTRUTURA').validations = {};
                widgetForm.getField('DTINICIO').validations = {};
                widgetForm.getField('DTFIM').validations = {};
                break;
            }
        }
        
        ScreenService.openPopup(widgetForm);
    };
    
    this.voltaView = function() {
        if ( this.abriuRescisaoCondicao === true ) {
            ScreenService.closeSwipe();
        }
        this.abriuRescisaoCondicao = false;
    };
    
    this.abriuRescisao = function() {
        this.abriuRescisaoCondicao = true;
    };
    
    this.setDefaultValues = function(args){
        var widget = ABUtilController.checkWidget(args);
        var nmReport = widget.NMREPORT;
        switch (nmReport) {
            case 'medias_ferias':
            case 'aviso_previo_ferias':
                widget.currentRow.DTINICIO = getLocalVar('HCM_DTCOMPETENCIA_OPER');
                widget.currentRow.DTFIM = getLocalVar('HCM_FIM_DTCOMPETENCIA_OPER');
                widget.reload();
            break;
        }
    };
    
    this.openGrrf = function() {
        ScreenService.confirmMessage("Deseja ser redirecionado para tela de GRRF?", null, function () {
            ScreenService.openWindow('product#hcm01068_fpa_GRRF');
        }, null);
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('ReciboPagamentoController', ReciboPagamentoController);
});

// FILE: assets/js/controllers/RegimePrevidenciaController.js
function RegimePrevidenciaController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, General,Messages) {

    this.adicionarRow = function(args) {
        var widget = args.owner.widget;
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
    };

	this.setRegimePrevidencia = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
                if (!widget.backupRow) {
                    widget.currentRow.__is_new = true;
                } else {
                    widget.currentRow.__is_new = false;
                }
                restEngine.post('product#/setRegimePrevidencia', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                    then(function (data) {
                        if (data.notifications[0].type === "success") {
                            ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                            if (widget.currentRow.__is_new) {
                                ABUtilController.masterDetailVoltarList(widget);
                                widget.reload();
                            } else {
                                ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                                widget.backupRow = null;
                                widget.view();
                            }
                        } else {
                            ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                        }
                    }).
                    catch(function(e) {
                        var error;
                        if(e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;
                            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    });
            }
    };
    
    this.deleteRegimePrevidencia = function(args) {
        var widget = args.owner.widget;
        widget.currentRow.__is_new = false;
        restEngine.post('product#/deleteRegimePrevidencia', {'requestType':'DataSet','dataset':[widget.currentRow]}).
            then(function(data){
                if(data.notifications[0].type === "success"){
                    ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                    ABUtilController.masterDetailVoltarList(widget);
                    widget.reload();
                } else {
                    ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                }
            }).
            catch(function(e) {
                var error;
                if(e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('RegimePrevidenciaController', RegimePrevidenciaController);
});

// FILE: assets/js/controllers/RegraController.js
function RegraController(ScreenService, templateManager, restEngine, ABUtilController, Messages, General) {

    this.adicionarRow = function(args) {
        var widget = args.owner.widget;
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
    };

    this.salvar = function(args) {
        var widget = args.owner.widget;
        if (!widget.currentRow.NREVENTOM) {
            widget.currentRow.NREVENTOM = null;
        }
        if (widget.isValid()) {
            if (ABUtilController.validaDtIniMenorIgualDtFin(widget.currentRow.DTINIVIGENCIA, widget.currentRow.DTFIMVIGENCIA)) {
                ABUtilController.saveMasterDetailMasterHistory(widget);
                ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
            } else {
                ScreenService.showMessage(Messages.DTINI_POST_DTFIM_ERROR);
                return false;
            }
        }
    };

    this.remover = function(args) {
        ScreenService.confirmMessage(Messages.DELETE_ROW, 'CONFIRMATION', function() {
            var widget = args.owner.widget;
            if (widget.isValid()) {
                widget.currentRow.__is_new = false;
                restEngine.post('product#/deleteRegra', {
                    'requestType': 'DataSet',
                    'dataset': [widget.currentRow]
                }).
                then(function(data) {
                    if (data.notifications[0].type === "success") {
                        ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    } else {
                        ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                    }
                }).
                catch(function(e) {
                    var error;
                    if (e.data.error === undefined) 
                        error = e;
                    else 
                        error = e.data.error;
                    
                    if(e.data.errorCode === 5){
                        ScreenService.showMessage(error, 'ERROR');
                    } else {
                        ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    }
                    
                });
            }
        });
    };

}

Configuration(function(ContextRegister) {
    ContextRegister.register('RegraController', RegraController);
});


// FILE: assets/js/controllers/RelacionamentoDependenteController.js
function RelacionamentoDependenteController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, General,Messages) {

    this.adicionarRow = function(args) {
        var widget = args.owner.widget;
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
    };

	this.setRelacionamentoDependente = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
                if (!widget.backupRow) {
                    widget.currentRow.__is_new = true;
                } else {
                    widget.currentRow.__is_new = false;
                }
                restEngine.post('product#/setRelacionamentoDependente', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                    then(function (data) {
                        if (data.notifications[0].type === "success") {
                            ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                            if (widget.currentRow.__is_new) {
                                ABUtilController.masterDetailVoltarList(widget);
                                widget.reload();
                            } else {
                                ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                                widget.backupRow = null;
                                widget.view();
                            }
                        } else {
                            ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                        }
                    }).
                    catch(function(e) {
                        var error;
                        if(e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;
                            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    });
            }
    };
    
    this.deleteRelacionamentoDependente = function(args) {
    ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
        var widget = args.owner.widget;
        widget.currentRow.__is_new = false;
        restEngine.post('product#/deleteRelacionamentoDependente', {'requestType':'DataSet','dataset':[widget.currentRow]}).
            then(function(data){
                if(data.notifications[0].type === "success"){
                    ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                    ABUtilController.masterDetailVoltarList(widget);
                    widget.reload();
                } else {
                    ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                }
            }).
            catch(function(e) {
                var error;
                if(e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
        }, null);
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('RelacionamentoDependenteController', RelacionamentoDependenteController);
});

// FILE: assets/js/controllers/RelatCustomAdmissaoController.js
function RelatCustomAdmissaoController(ScreenService, templateManager, localStorageEngine, restEngine, HcmRepository, ABUtilController, General, Messages) {

    this.relacaoRstruturaSuperior = [];
    this.relacaoRstruturaSuperior.NMESTRUTSUPERIORM1 = 'NMESTRUTSUPERIORM1';
    this.relacaoRstruturaSuperior.NMESTRUTSUPERIORM2 = 'NMESTRUTSUPERIORM2';
    this.relacaoRstruturaSuperior.NMESTRUTSUPERIORM3 = 'NMESTRUTSUPERIORM3';
    this.relacaoRstruturaSuperior.NMESTRUTSUPERIORM4 = 'NMESTRUTSUPERIORM4';
    this.relacaoRstruturaSuperior.NMESTRUTSUPERIORM5 = 'NMESTRUTSUPERIORM5';
    this.IDEXIBIRDEP = null;
    this.IDEXIBIRINFOACAD = "N";
    
    this.ativaDtPeriodo = function(args) {
        var filtro = args.row;
        var widget = ABUtilController.checkWidget(args);
        if( filtro.VINCULOSATIVOS == 'P' ){
            widget.getField('DTINIPERIODO').validations = widget.getField('DTFIMPERIODO').validations = {required: true};
            
        } else {
            widget.getField('DTINIPERIODO').validations = widget.getField('DTFIMPERIODO').validations = {};
        }
    };
    
    this.alteraNomesEstrutura = function(campo, nome){
        campo.isVisible = true;
        campo.label = nome;
        this.relacaoRstruturaSuperior[campo.name] = nome.toUpperCase().replace(/ /g,"_") + '_NM';
        campo.name = nome.toUpperCase().replace(/ /g,"_") + '_NM';
    };
    
    this.alteraCampos = function(args){
        var widget = templateManager.container.getWidget('relatCustomAdmissao');
        var filtro = args.e.preference.FILTER_ROW;
        
        if( filtro.NRTIPOESTRUTSUP ){
            filtro.NRTIPOESTRUTSUP = ABUtilController.arrayUnique(filtro.NRTIPOESTRUTSUP);
            filtro.NRTIPOESTRUTSUP.forEach(function(tipo, index){
                var nome = this.relacaoRstruturaSuperior['NMESTRUTSUPERIORM' + (index + 1)];
                this.alteraNomesEstrutura(widget.getField(nome), filtro.NMTIPOESTRUTSUP[index]);
            }.bind(this));  
        }else if( filtro.NRTIPOESTRUTURA ){
            filtro.NRTIPOESTRUTURA = ABUtilController.arrayUnique(filtro.NRTIPOESTRUTURA);
            filtro.NRTIPOESTRUTURA.forEach(function(tipo, index){
                var nome = this.relacaoRstruturaSuperior['NMESTRUTSUPERIORM' + (index + 1)];
                this.alteraNomesEstrutura(widget.getField(nome), filtro.NMTIPOESTRUTURA[index]);
            }.bind(this));
        } else {
            this.relacaoRstruturaSuperior.forEach(function(nome, index){
                widget.getField(nome).isVisible = false;
                this.alteraNomesEstrutura(widget.getField(nome), index);
            }.bind(this));
        }
    };
    
    this.validaEstruturaSuperior = function(args){
        var filtro = ABUtilController.checkWidget(args);
        var widget = templateManager.container.getWidget('relatCustomAdmissao');
        var tipoEstrutSuperiorNova = !Util.isEmptyOrBlank(filtro.currentRow.NRTIPOESTRUTSUP) ? angular.copy(filtro.currentRow.NRTIPOESTRUTSUP) : angular.copy(filtro.currentRow.NRTIPOESTRUTREL);
        var indexFiltro = ABUtilController.retornaFiltro(widget.getField('NMESTRUTSUPERIORM').dataSourceFilter, 'NRTIPOESTRUTURA');
        if(filtro.currentRow.NRTIPOHIERARQORG && filtro.currentRow.NRTIPOHIERARQORG.length > 0){
            var tipoEstrutSuperiorFiltro = widget.getField('NMESTRUTSUPERIORM').dataSourceFilter[indexFiltro];
            if( tipoEstrutSuperiorFiltro ){
                tipoEstrutSuperiorFiltro.value = tipoEstrutSuperiorNova;
            } else {
                widget.getField('NMESTRUTSUPERIORM').dataSourceFilter.push({"name": "NRTIPOESTRUTURA",
                                                                            "operator": "IN",
                                                                            "value": tipoEstrutSuperiorNova.join(',')
                                                                            });
            }
            widget.getField('NMESTRUTSUPERIORM').reload();
        } else {
            if( indexFiltro || indexFiltro === 0 ){
                widget.getField('NMESTRUTSUPERIORM').dataSourceFilter.splice(indexFiltro, 1);
                widget.getField('NMESTRUTSUPERIORM').reload();
            }
        }
    };
    
    this.validaTipoHierarquiaSelectAll = function(args){
        var dataSource = templateManager.container.getWidget('relatCustomAdmissao').getField('NRTIPOHIERARQORG').dataSource;
        if( dataSource.data.length > 5 ){
            dataSource.unSelectAll();
            ScreenService.showMessage("Você deve selecionar no máximo 5 tipos de hierarquia.");
        }
    };
    
    this.validaTipoHierarquia = function (args){
        var widget = templateManager.container.getWidget('relatCustomAdmissao');
        var dataSource = widget.getField('NRTIPOHIERARQORG').dataSource;
        if( dataSource.getCheckedRows().length > 5 ){
            var indexRow = -1;
            dataSource.getCheckedRows().forEach(function(row, index){
                indexRow = row.NRTIPOHIERARQORG == args.selectedRow.NRTIPOHIERARQORG ? index : indexRow;
            });
            if( indexRow > 0 ){
                ScreenService.showMessage("Você deve selecionar no máximo 5 tipos de hierarquia.");
                dataSource.removeCheckedRows(dataSource.getCheckedRows()[indexRow]);
            }
        }
    };
    
    this.validateDtFinal = function(args){
        var widget = ABUtilController.checkWidget(args);
        
        if( !Util.isEmptyOrBlank(widget.currentRow.DTFIMPERIODO) ){
            if( widget.currentRow.DTFIMPERIODO.split('/').reverse().join('') < widget.currentRow.DTINIPERIODO.split('/').reverse().join('') ){
                widget.currentRow.DTFIMPERIODO = null;
                ScreenService.showMessage("O campo de 'Dt. Fim Período' não pode ser menor que a data inicial do período");
            }
        }
    };

    this.validateDtInicial = function(args){
        var widget = ABUtilController.checkWidget(args);
        if( !Util.isEmptyOrBlank(widget.currentRow.DTINIPERIODO) && !Util.isEmptyOrBlank(widget.currentRow.DTFIMPERIODO) ){
            if( widget.currentRow.DTINIPERIODO.split('/').reverse().join('') > widget.currentRow.DTFIMPERIODO.split('/').reverse().join('') ){
                widget.currentRow.DTINIPERIODO = null;
                ScreenService.showMessage("O campo de 'Dt. Início Período' não pode ser maior que a data final do período");
            }
        }
    };
    
    this.setDefaultCampoIdexibirdep = function(widget) {
        this.IDEXIBIRDEP = widget.getField('IDEXIBIRDEP').defaultValue;
    };
    
    this.setValorCampoExibirDependentes = function(args) {
        var widget = ABUtilController.checkWidget(args);
        this.IDEXIBIRDEP = widget.currentRow.IDEXIBIRDEP;
    };
    
    this.setValExibirAcad = function(args) {
        var widget = ABUtilController.checkWidget(args);
        this.IDEXIBIRINFOACAD = widget.currentRow.IDEXIBIRINFOACAD;
        if( this.IDEXIBIRINFOACAD === 'S' ){
            widget.getField('DSTIPOFORMACAO').readOnly = false;
        } else {
            widget.getField('DSTIPOFORMACAO').readOnly = true;
            widget.currentRow.DSTIPOFORMACAO = widget.currentRow.NRTIPOFORMACAO = null;
        }
    };
    
    this.mudarVisibilidadeFieldsDependencia = function(widget){
        if (this.IDEXIBIRDEP === 'S') {
            widget.getField('NRPESSOA_DEP').isVisible = true;
            widget.getField('NMPESSOA_DEP').isVisible = true;
            widget.getField('NMTIPORELACIONA_DEP').isVisible = true;
            widget.getField('NMTIPODEPENDE_DEP').isVisible = true;
            widget.getField('DTNASCPESSOA_DEP').isVisible = true;
            widget.getField('NRCPFPESSOA_DEP').isVisible = true;
            widget.getField('IDSEXOPESSOA_DEP').isVisible = true;
        } else {
            widget.getField('NRPESSOA_DEP').isVisible = false;
            widget.getField('NMPESSOA_DEP').isVisible = false;
            widget.getField('DTNASCPESSOA_DEP').isVisible = false;
            widget.getField('NMTIPORELACIONA_DEP').isVisible = false;
            widget.getField('NMTIPODEPENDE_DEP').isVisible = false;
            widget.getField('NRCPFPESSOA_DEP').isVisible = false;
            widget.getField('IDSEXOPESSOA_DEP').isVisible = false;
        }
        widget.redraw();
    };
    
    this.setVisibilidadeInfoAcad = function(widget){
        if( this.IDEXIBIRINFOACAD === 'S' ){
            widget.getField('DSINSTITUICAO').isVisible = true;
        } else {
            widget.getField('DSINSTITUICAO').isVisible = false;
        }
        widget.redraw();
    };
    
    this.tipoRelacionamentoReadOnly = function(args) {
        var widget = ABUtilController.checkWidget(args);
        if( widget.currentRow.IDEXIBIRDEP === "S" ){
            widget.getField('NMTIPORELACIONA').readOnly = false;
        } else {
            widget.getField('NMTIPORELACIONA').readOnly = true;
            widget.currentRow.NRTIPORELACIONA = widget.currentRow.NMTIPORELACIONA = null;
        }
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('RelatCustomAdmissaoController', RelatCustomAdmissaoController);
});

// FILE: assets/js/controllers/RelatCustomFeriasController.js
function RelatCustomFeriasController(ScreenService, templateManager, localStorageEngine, restEngine, HcmRepository, ABUtilController, General,Messages) {
    
    this.rowToBeSetRelatCustomFerias =  {
                                            'IGNORAOCORRECAL' : 'N'
                                        };

    this.adicionarRow = function(args) {
        var widget = ABUtilController.checkWidget(args);
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('RelatCustomFeriasController', RelatCustomFeriasController);
});

// FILE: assets/js/controllers/RelatCustomMoviController.js
function RelatCustomMoviController(ScreenService, templateManager, localStorageEngine, restEngine, HcmRepository, ABUtilController, General, Messages) {
    

    this.relacaoRstruturaSuperior = [];
    this.relacaoRstruturaSuperior.NMESTRUTSUPERIORM1 = 'NMESTRUTSUPERIORM1';
    this.relacaoRstruturaSuperior.NMESTRUTSUPERIORM2 = 'NMESTRUTSUPERIORM2';
    this.relacaoRstruturaSuperior.NMESTRUTSUPERIORM3 = 'NMESTRUTSUPERIORM3';
    this.relacaoRstruturaSuperior.NMESTRUTSUPERIORM4 = 'NMESTRUTSUPERIORM4';
    this.relacaoRstruturaSuperior.NMESTRUTSUPERIORM5 = 'NMESTRUTSUPERIORM5';
    this.IDEXIBIRDEP = null;
    this.IDEXIBIRINFOACAD = "N";
    

    
    this.validaEstruturaSuperior = function(args, nomeWidget){
        var filtro = ABUtilController.checkWidget(args);
        var widget = templateManager.container.getWidget(nomeWidget);
        var tipoEstrutSuperiorNova = !Util.isEmptyOrBlank(filtro.currentRow.NRTIPOESTRUTSUP) ? angular.copy(filtro.currentRow.NRTIPOESTRUTSUP) : angular.copy(filtro.currentRow.NRTIPOESTRUTREL);
        var indexFiltro = ABUtilController.retornaFiltro(widget.getField('NMESTRUTSUPERIORM').dataSourceFilter, 'NRTIPOESTRUTURA');
        if(filtro.currentRow.NRTIPOHIERARQORG && filtro.currentRow.NRTIPOHIERARQORG.length > 0){
            var tipoEstrutSuperiorFiltro = widget.getField('NMESTRUTSUPERIORM').dataSourceFilter[indexFiltro];
            if( tipoEstrutSuperiorFiltro ){
                tipoEstrutSuperiorFiltro.value = tipoEstrutSuperiorNova;
            } else {
                widget.getField('NMESTRUTSUPERIORM').dataSourceFilter.push({"name": "NRTIPOESTRUTURA",
                                                                            "operator": "IN",
                                                                            "value": tipoEstrutSuperiorNova.join(',')
                                                                            });
            }
            widget.getField('NMESTRUTSUPERIORM').reload();
        } else {
            if( indexFiltro || indexFiltro === 0 ){
                widget.getField('NMESTRUTSUPERIORM').dataSourceFilter.splice(indexFiltro, 1);
                widget.getField('NMESTRUTSUPERIORM').reload();
            }
        }
    };
    
    this.validaTipoHierarquiaSelectAll = function(args, nomeWidget){
        var dataSource = templateManager.container.getWidget(nomeWidget).getField('NRTIPOHIERARQORG').dataSource;
        if( dataSource.data.length > 5 ){
            dataSource.unSelectAll();
            ScreenService.showMessage("Você deve selecionar no máximo 5 tipos de hierarquia.");
        }
    };
    
    this.validaTipoHierarquia = function (args, nomeWidget){
        var widget = templateManager.container.getWidget(nomeWidget);
        var dataSource = widget.getField('NRTIPOHIERARQORG').dataSource;
        if( dataSource.getCheckedRows().length > 5 ){
            var indexRow = -1;
            dataSource.getCheckedRows().forEach(function(row, index){
                indexRow = row.NRTIPOHIERARQORG == args.selectedRow.NRTIPOHIERARQORG ? index : indexRow;
            });
            if( indexRow > 0 ){
                ScreenService.showMessage("Você deve selecionar no máximo 5 tipos de hierarquia.");
                dataSource.removeCheckedRows(dataSource.getCheckedRows()[indexRow]);
            }
        }
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('RelatCustomMoviController', RelatCustomMoviController);
});

// FILE: assets/js/controllers/RelatCustomRescisaoController.js
function RelatCustomRescisaoController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, General,Messages, HcmConsts, $window) {
    
    this.setPeríodoDeOcorrencia = function(){
        var widget = templateManager.container.getActiveWidget();
        var data = null;
        if(!Util.isEmptyOrBlank(widget.currentRow.DTOCORRENCIA)){
            data = moment(widget.currentRow.DTADMISSAOVINC, 'DD/MM/YYYY');
            widget.currentRow.DTOCORRENCIA = data;
        }
    };
    
}

Configuration(function(ContextRegister) {
    ContextRegister.register('RelatCustomRescisaoController', RelatCustomRescisaoController);
});
    

// FILE: assets/js/controllers/RelatorioEscalaController.js
function RelatorioEscalaController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, General,Messages) {

    var dtinicontagem = null;
    
    this.setarDtinicontagemAfterFilter = function(args){
        dtinicontagem =  args.e.preference.FILTER_ROW.DTINICONTAGEM;
    };
    
    this.recuperaDtinicontagem = function(){
        var widgetPrincipal = templateManager.container.getWidget('relatorioEscala');
        widgetPrincipal.currentRow.DTINICONTAGEM = dtinicontagem;
    };

}

Configuration(function(ContextRegister) {
    ContextRegister.register('RelatorioEscalaController', RelatorioEscalaController);
});

// FILE: assets/js/controllers/RelatorioProcessoController.js
function RelatorioProcessoController(ScreenService, templateManager, restEngine, ABUtilController, Messages) {
    
    
}

Configuration(function(ContextRegister) {
    ContextRegister.register('RelatorioProcessoController', RelatorioProcessoController);
});

// FILE: assets/js/controllers/RelatoriosHcmController.js
/* jshint esversion: 6 */
function RelatoriosHcmController(ScreenService, templateManager, restEngine, ABUtilController, Messages, RelatoriosHcmService, CriterioSelecaoController){
/**
 * Created by Rafael Pickbrenner on 25/10/2016.
 * Funcionalidades para as telas dos relatórios do HCM, complemento do Services.
 * Utiliza o /hcm/mobile/assets/js/services/RelatoriosHcmService.js.
 * Funções de manipulação de show/hide, required/not required e validate dos fields da tela de relatórios.
 * ? Inclusões de outras funcionalidade. Desconhecido.
 */    

    this.nmTela      = null;
    this.nrOrg       = null;
    this.nrOrgPadrao = null;
    this.nmReport    = null;
    this.templateManager = templateManager;
    
    /*Ajusta o nome da tela para exibir apenas relatórios da tela correspondente*/
    this.setNmtela = function(windowName, args) {
        this.nmTela = windowName;           //Nome da tela (usado dentro de REPORTS)
        var name = args.owner.windowName;   //Nome do container
        if(this.templateManager.containers.hasOwnProperty(name)){   //Verifica se o cointainer já foi criado (se este já foi aberto no sistema)
            this.setDataSourceAndLabel(this.templateManager.containers[name].widgets[0]);   //Solicita a atualização da tela (label e lista de relatórios)
        }
    };
    
    /*Cria o data source do field NMRELATORIO de acordo com o container e as configurações do relatório e ajusta o label da tela de acordo com o menu que a solicitou*/
    this.setDataSourceAndLabel = function(owner){
        if(this.nmTela){
            this.nrOrg       = getLocalVar('HCM_NRORG_TRAB');
            this.nrOrgPadrao = getLocalVar('HCM_NRORG_PADRAO');
            owner.getField("DTMESCOMPETENCIA").value(getLocalVar('HCM_DTCOMPETENCIA_OPER'));
            owner.getField("NMOPCOES1").value('N');
            owner.getField("NMOPCOES2").value('N');
            owner.getField("NMOPCOES3").value('N');
            owner.getField("NMOPCOES4").value('N');
            owner.getField("NMOPCOES5").value('N');
            owner.getField("NMOPCOES6").value('N');
            owner.getField("NMOPCOES7").value('N');
            owner.getField("NMOPCOES8").value('N');
            owner.getField("NMOPCOES9").value('N');
            owner.getField("DSZEBRADO").value('N');
            
            var res = RelatoriosHcmService.setDataSourceAndLabel(owner, this.nrOrg, this.nrOrgPadrao, this.nmTela);
            if(res !== true){
                ScreenService.showMessage(res, 'ALERT');
            }
        }else{
            ScreenService.openWindow('product#dashboard');
        }
    };
    
    /*Ajusta a visibilidade, requerido ou não e o label de acordo com o relatório selecionado*/
    this.exibicaoCampos = function (args) {
        var widget = args.owner.owner.widget;
        this.nmReport   = widget.currentRow.NRRELATORIO;  //Nome/número do relatório
        
        var res = RelatoriosHcmService.setExibicaoCampos(widget, this.nrOrg, this.nrOrgPadrao, this.nmTela, this.nmReport);
        
        if(this.nmReport == "importa_remessa"){
            widget.getAction('importaRemessa').isVisible = true;
            widget.getAction('geraRelatorio').isVisible = false;
        }else{
            widget.getAction('importaRemessa').isVisible = false;
            widget.getAction('geraRelatorio').isVisible = true;
        }
        
        if(res !== true){
            ScreenService.showMessage(res, 'ALERT');
        }
        
        this.setFiltroNmcandidatoAvaliacaoPsi(args);
    };
    
    /*Gera o relatório*/
    this.gerarRelatorio = function(args, sendEmail){    
        sendEmail = sendEmail || false;
        var widget = (sendEmail) ? args : args.owner.widget;

        var res = RelatoriosHcmService.gerarRelatorio(widget, this.nrOrg, this.nrOrgPadrao, this.nmTela, this.nmReport, ABUtilController, sendEmail);
        if(res !== true){
            ScreenService.showMessage(res, 'ALERT');
        }
    };
    
    /*Gera relatorio tela de Recibo de Pagamento*/
    this.gerarRelatorio_RCB = function(args, nmReport = null){  
        var widget = ABUtilController.checkWidget(args);
        /*Verifica se os campos requeridos estão preenchidos*/
        if(widget.isValid() || !!nmReport){
            if(!nmReport){
            nmReport = widget.NMREPORT;   
            }            
            var widgetPai = widget.parent.parent;
            widgetPai.currentRow.NRVINCULOM = (widget.parent.currentRow.NRVINCULOM || "");
            widgetPai.currentRow.MESCOMPETENCIA = (widget.currentRow.DTMESCOMPETENC || getLocalVar('HCM_DTCOMPETENCIA_OPER'));
            if(widgetPai.currentRow.NMESTRUTURASUP == null || widgetPai.currentRow.NMESTRUTURASUP == ''){
                widgetPai.currentRow.NMESTRUTLEGAL = widgetPai.currentRow.NMESTRUTURAM;
                widgetPai.currentRow.NRESTRUTLEGAL = widgetPai.currentRow.NRESTRUTURAM;
            } else {
                widgetPai.currentRow.NMESTRUTLEGAL = widgetPai.currentRow.NMESTRUTURASUP;
                widgetPai.currentRow.NRESTRUTLEGAL = widgetPai.currentRow.NRESTRUTSUP;
                widgetPai.currentRow.NMESTRUTGEREN = widgetPai.currentRow.NMESTRUTURAM;
                widgetPai.currentRow.NRESTRUTGEREN = widgetPai.currentRow.NRESTRUTURAM;
                if(nmReport == 'extrato_esocial'){
                    widgetPai.currentRow.NMESTRUTURAM = widgetPai.currentRow.NMESTRUTLEGAL;
                    widgetPai.currentRow.NRESTRUTURAM = widgetPai.currentRow.NRESTRUTLEGAL;
                }
            }
            widget.getDataSourceFilter().forEach(function(filtro) {
                if(filtro.name == "P_NRTIPOMOVIMENT"){
                    widgetPai.currentRow.NRTIPOMOVIMENT = filtro.value;    
                }
            });
            switch(nmReport){
            case 'darf':
                //passar os parametros para o relatorio
                widgetPai.currentRow.NUMBER1 = widget.currentRow.NUMBER1;
                widgetPai.currentRow.NUMBER2 = widget.currentRow.NUMBER2;
                widgetPai.currentRow.DATA1 = widget.currentRow.DATA1;
                widgetPai.currentRow.DATA2 = widget.currentRow.DATA2;
                widgetPai.currentRow.NMABREV = widget.currentRow.NMABREV;
                widgetPai.currentRow.NMOPCOES1 = widget.currentRow.NMOPCOES1;
                widgetPai.currentRow.NMOPCOES2 = widget.currentRow.NMOPCOES2;
                widgetPai.currentRow.NMOPCOES3 = widget.currentRow.NMOPCOES3;
                break;
            case 'demonstrativo_pagamento_via_unica':
                widgetPai.currentRow.NRTIPOMOVIMENT = widget.tipomovimento;
                widgetPai.currentRow.NMOPCOES1 = widget.currentRow.NMOPCOES1;
                widgetPai.currentRow.NMEVENTOH = widget.currentRow.NMEVENTOH;
                widgetPai.currentRow.NREVENTOM = widget.currentRow.NREVENTOM;
                widgetPai.currentRow.DSOBSERVACAO = widget.currentRow.DSOBSERVACAO;
                break;
            case 'demonstrativo_pagamento_rpa_laser':
                widgetPai.currentRow.NRTIPOMOVIMENT = widget.tipomovimento;
                widgetPai.currentRow.NMOPCOES1 = widget.currentRow.NMOPCOES1;
                widgetPai.currentRow.NMEVENTOH = widget.currentRow.NMEVENTOH;
                widgetPai.currentRow.NREVENTOM = widget.currentRow.NREVENTOM;
                widgetPai.currentRow.DSOBSERVACAO = widget.currentRow.DSOBSERVACAO;
                break;
            case 'gps':
                widgetPai.currentRow.NRTIPOESTRUTURA = widget.currentRow.NRTIPOESTRUTURA;
                widgetPai.currentRow.NUMBER1 = widget.currentRow.NUMBER1;
                widgetPai.currentRow.NUMBER2 = widget.currentRow.NUMBER2;
                widgetPai.currentRow.NUMBER3 = widget.currentRow.NUMBER3;
                widgetPai.currentRow.NUMBER4 = widget.currentRow.NUMBER4;
                widgetPai.currentRow.TEXTO1 = widget.currentRow.TEXTO1;
                break;
            case 'liquido':
                widgetPai.currentRow.NRTIPOMOVIMENT = 1;
                widgetPai.currentRow.NMOPCOES1 = widget.currentRow.NMOPCOES1;
                widgetPai.currentRow.NMOPCOES2 = widget.currentRow.NMOPCOES2;
                widgetPai.currentRow.NMOPCOES3 = widget.currentRow.NMOPCOES3;
                widgetPai.currentRow.NMEVENTOH = widget.currentRow.NMEVENTOH;
                widgetPai.currentRow.DTINICIO = widget.currentRow.DTINICIO;
                break;
            case 'resumo_irrf':
                widgetPai.currentRow.DTINICIO = widget.currentRow.DTINICIO;
                widgetPai.currentRow.DTFIM = widget.currentRow.DTFIM;
                widgetPai.currentRow.NMOPCOES1 = widget.currentRow.NMOPCOES1;
                widgetPai.currentRow.NMOPCOES2 = widget.currentRow.NMOPCOES2;
                widgetPai.currentRow.NMOPCOES3 = widget.currentRow.NMOPCOES3;
                break;
            case 'resumo_impostos':
                widgetPai.currentRow.NMOPCOES1 = widget.currentRow.NMOPCOES1;
                widgetPai.currentRow.NMOPCOES2 = widget.currentRow.NMOPCOES2;
                widgetPai.currentRow.NMOPCOES3 = widget.currentRow.NMOPCOES3;
                break;
            case 'folha_analitica_sintetico':
                widgetPai.currentRow.NRTIPOMOVIMENT = 1;
                widgetPai.currentRow.NMOPCOES1 = widget.currentRow.NMOPCOES1;
                widgetPai.currentRow.NMOPCOES2 = widget.currentRow.NMOPCOES2;
                widgetPai.currentRow.NMOPCOES3 = widget.currentRow.NMOPCOES3;
                widgetPai.currentRow.NMOPCOES4 = widget.currentRow.NMOPCOES4;
                widgetPai.currentRow.NMOPCOES5 = widget.currentRow.NMOPCOES5;
                widgetPai.currentRow.NMOPCOES6 = widget.currentRow.NMOPCOES6;
                widgetPai.currentRow.NMOPCOES7 = widget.currentRow.NMOPCOES7;
                widgetPai.currentRow.NMOPCOES8 = widget.currentRow.NMOPCOES8;
                break;
            case 'medias_ferias':
                widgetPai.currentRow.NRTIPOMOVIMENT = 1;
                widgetPai.currentRow.NMOPCOES1 = widget.currentRow.NMOPCOES1;
                widgetPai.currentRow.NMOPCOES2 = widget.currentRow.NMOPCOES2;
                widgetPai.currentRow.DTINICIO = widget.currentRow.DTINICIO;
                widgetPai.currentRow.DTFIM = widget.currentRow.DTFIM;
                break;
            case 'recibo_ferias':
                widgetPai.currentRow.DATA1 = widget.currentRow.DATA1;
                widgetPai.currentRow.NMOPCOES2 = widget.currentRow.NMOPCOES2;
                widgetPai.currentRow.NMOPCOES3 = widget.currentRow.NMOPCOES3;
                widgetPai.currentRow.DTINICIO = widget.currentRow.DTINICIO;
                widgetPai.currentRow.DTFIM = widget.currentRow.DTFIM;
                break;
            case 'seguro_desemprego':
            case 'seguro_desemprego_laser':
            case 'seguro_desemprego_laser_2':
            case 'requisicao_seguro_desemprego':
                widgetPai.currentRow.NRTIPOMOVIMENT = 1;
                widgetPai.currentRow.DTINICIO = widget.currentRow.DTINICIO;
                widgetPai.currentRow.DTFIM = widget.currentRow.DTFIM;
                widgetPai.currentRow.NRVINCULOM_RESC = widgetPai.currentRow.NRVINCULOM;
                break;
            case 'medias_rescisao_aviso_prev':
            case 'aviso_previo_ferias':
            case 'medias_rescisao_13':
            case 'medias_rescisao_ferias':
                widgetPai.currentRow.DTINICIO = widget.currentRow.DTINICIO;
                widgetPai.currentRow.DTFIM = widget.currentRow.DTFIM;
                break;
            case 'aviso_previo_empregado':
            case 'aviso_previo_empregador_indenizado':
            case 'aviso_previo_empregador_trabalhado':
                widgetPai.currentRow.DTDOCUMENTO = widget.currentRow.DTDOCUMENTO;
                break;
            }
            if(nmReport == 'extrato_esocial'){
                widget.currentRow.NRESTRUTURAM = args.owner.widget.parent.parent.currentRow.NRESTRUTURAM;
            }
            
            var res = RelatoriosHcmService.gerarRelatorio_RCB(widgetPai, getLocalVar('HCM_NRORG_TRAB'), getLocalVar('HCM_NRORG_PADRAO'), "RCB", nmReport, ABUtilController);
            if(res !== true){
                ScreenService.showMessage(res, 'ALERT');
            }
            ScreenService.closePopup();
        } else
            ScreenService.showMessage('ALERT');
    };

    this.exibicaoCampos_RCB = function (args){
        this.nmReport   = args.currentRow.NMRELATORIO;  //Nome do relatório
        
        var res = RelatoriosHcmService.setExibicaoCampos_RCB(args, this.nrOrg, this.nrOrgPadrao, this.nmTela, this.nmReport);
        
        if(res !== true){
            ScreenService.showMessage(res, 'ALERT');
        }
    };    
    
    /*FILTROS ONCHANGE*/
    
    this.setFiltroNmcandidatoAvaliacaoPsi = function(args) {
        var widget = ABUtilController.checkWidget(args);
        var filterCand = [{
                "name": "P_PARECERFINAL",
                "operator": "=",
                "value": true
            }];
        
        //Apenas para o relatório de valaiação psicológica
        if(args.row.NMRELATORIO == "avaliacao_psicologica") {  //Este relatório deve trazer os candidatos que participam de um processo
            widget.getField("NMCANDIDATO").clearValue();
            widget.getField("NMCANDIDATO").dataSourceFilter = filterCand;
            widget.getField("NMCANDIDATO").reload();
        }
    };
    
    this.setFiltroEstrutSuperior = function(args) {
        var widget = ABUtilController.checkWidget(args);
        var tipos = widget.currentRow.NRTIPOESTRUTSUP;
        var filterTipo = [
                {
                    "name": "DTMESCOMPETENC",
                    "operator": "=",
                    "value": "@getLocalVar('HCM_DTCOMPETENCIA_OPER') ? getLocalVar('HCM_DTCOMPETENCIA_OPER') : '' @"
                },
                {
                    "name": "NRORG",
                    "operator": "=",
                    "value": "@getLocalVar('HCM_NRORG_TRAB') ? getLocalVar('HCM_NRORG_TRAB') : '' @"
                },
                {
                    "name": "NRORG_PADRAO",
                    "operator": "=",
                    "value": "@getLocalVar('HCM_NRORG_PADRAO') ? getLocalVar('HCM_NRORG_PADRAO') : '' @"
                },   
                {
                    "name": "NRTIPOESTRUTURA",
                    "operator": "IN",
                    "value": tipos
                }
            ];
            
        if(tipos.length > 0) {
            widget.getField("NRESTRUTSUPERIOR").readOnly = false;
        }   else {
            widget.getField("NRESTRUTSUPERIOR").readOnly = true;
        }
        
        widget.getField("NRESTRUTSUPERIOR").clearValue();
        widget.getField("NRESTRUTSUPERIOR").dataSourceFilter = filterTipo;
        widget.getField("NRESTRUTSUPERIOR").reload();
        widget.currentRow.NRESTRUTSUPERIOR = [];
        
        
    };
    
    this.setFiltroEstrutSuperiorUnic = function(args) {
        var widget = ABUtilController.checkWidget(args);
        var tipo = widget.currentRow.NRTIPOESTRUTSUP;
        var filterTipo = [
                {
                    "name": "DTMESCOMPETENC",
                    "operator": "=",
                    "value": "@getLocalVar('HCM_DTCOMPETENCIA_OPER') ? getLocalVar('HCM_DTCOMPETENCIA_OPER') : '' @"
                },
                {
                    "name": "NRORG",
                    "operator": "=",
                    "value": "@getLocalVar('HCM_NRORG_TRAB') ? getLocalVar('HCM_NRORG_TRAB') : '' @"
                },
                {
                    "name": "NRORG_PADRAO",
                    "operator": "=",
                    "value": "@getLocalVar('HCM_NRORG_PADRAO') ? getLocalVar('HCM_NRORG_PADRAO') : '' @"
                },   
                {
                    "name": "NRTIPOESTRUTURA",
                    "operator": "=",
                    "value": tipo
                }
            ];
            
        if(tipo != null && tipo != "") {
            widget.getField("NMESTRUTSUPERIOR").readOnly = false;
            widget.getField("NRESTRUTSUPERIOR").readOnly = false;
        }   else {
            widget.getField("NMESTRUTSUPERIOR").readOnly = true;
            widget.getField("NRESTRUTSUPERIOR").readOnly = true;
        }
        
        widget.getField("NMESTRUTSUPERIOR").clearValue();
        widget.getField("NMESTRUTSUPERIOR").dataSourceFilter = filterTipo;
        widget.getField("NMESTRUTSUPERIOR").reload();

        
        
        widget.getField("NRESTRUTSUPERIOR").clearValue();
        widget.getField("NRESTRUTSUPERIOR").dataSourceFilter = filterTipo;
        widget.getField("NRESTRUTSUPERIOR").reload();
        if(widget.getField("NRESTRUTSUPERIOR").isVisible){
            widget.currentRow.NRESTRUTSUPERIOR = [];
        }

        
    };
    
    this.setFiltroTipoDeVinculo = function(args) {
        var widget = ABUtilController.checkWidget(args);
        var tipo = widget.currentRow.NRTIPOVINCULOM;
        var filterTipo = [
                {
                    "name": "DTMESCOMPETENC",
                    "operator": "=",
                    "value": "@getLocalVar('HCM_DTCOMPETENCIA_OPER') ? getLocalVar('HCM_DTCOMPETENCIA_OPER') : '' @"
                },
                {
					"name": "NRORGPADRAO",
					"operator": "=",
					"value": "@getLocalVar('HCM_NRORG_PADRAO') ? getLocalVar('HCM_NRORG_PADRAO') : '' @"
				},
                {
                    "name": "NRORG",
                    "operator": "=",
                    "value": "@getLocalVar('HCM_NRORG_TRAB') ? getLocalVar('HCM_NRORG_TRAB') : '' @"
                },
                {
                    "name": "NRTIPOVINCULOM",
					"operator": "=",
					"value": tipo
                }
            ];
        if(tipo != null && tipo != "") {
            widget.getField("DSPERIODOAPURACAO").readOnly = false;
            widget.getField("DSPERIODOAPURACAO").showOnView = true;
            widget.getField("DSPERIODOAPURACAO").showOnForm = true;
        }   else {
            widget.getField("DSPERIODOAPURACAO").readOnly = true;
            widget.getField("DSPERIODOAPURACAO").showOnView = false;
            widget.getField("DSPERIODOAPURACAO").showOnForm = false;
        }
        
        widget.getField("DSPERIODOAPURACAO").value('');
        widget.getField("DSPERIODOAPURACAO").dataSourceFilter = filterTipo;
        widget.getField("DSPERIODOAPURACAO").reload();
        widget.currentRow.DSPERIODOAPURACAO = [];
        
    };
    
    this.setFiltroNmcandidato = function(args) {
        var widget = ABUtilController.checkWidget(args);
        var filterCand = [];
        var filterFase = [{
            "name": "NRORG",
            "operator": "=",
            "value": "@getLocalVar('HCM_NRORG_TRAB')? getLocalVar('HCM_NRORG_TRAB') : getLocalVar('HCM_NRORG_TRAB') @"
        }];
        var nrtemplate = args.row.NRTEMPLATE;
        var nrprocesso = args.row.NRPROCESSO;
        var nrfase     = args.row.NRFASE;
        
        //Filtro do field Fase
        if(args.owner.field.name != "NMFASE"){
            if(nrtemplate) {
                filterFase.push({
                    "name": "NRTEMPLATE",
                    "operator": "=",
                    "value": nrtemplate
                });
            }
            widget.getField("NMFASE").clearValue();
            widget.getField("NMFASE").dataSourceFilter = filterFase;
            widget.getField("NMFASE").reload();
        }
        
        //Filtro do field Candidato
        if(nrprocesso) { //Verifica se há algum processo selecionado
            filterCand.push({
                "name": "P_NRPROCESSO",
                "operator": "=",
                "value": nrprocesso
            });
        }
        if(nrfase) { //Verifica se há alguma fase selecionado
            filterCand.push({
                "name": "P_NRFASE",
                "operator": "=",
                "value": nrfase
            });
        }
        if(args.row.NMRELATORIO == "avaliacao_questionario") {  //Este relatório deve trazer os candidatos que participam de um processo
            filterCand.push({
                "name": "P_IDPARTIPAPROCESSO",
                "operator": "=",
                "value": true
            });
        }
        widget.getField("NMCANDIDATO").clearValue();
        widget.getField("NMCANDIDATO").dataSourceFilter = filterCand;
        widget.getField("NMCANDIDATO").reload();
    };

    this.changeDsOrdem = function(args) {
        var widget = ABUtilController.checkWidget(args);
        widget.currentRow.BKPDSINICIO = widget.currentRow.DSINICIO;
        widget.currentRow.BKPDSFIM = widget.currentRow.DSFIM;
        widget.currentRow.DSINICIO = null;
        widget.currentRow.DSFIM = null;
        CriterioSelecaoController.setVisibilidadeCampos(widget);
    };

    this.setAssuntoMensagem = function(args){
        var widgetMensagens = ABUtilController.checkWidget(args);
        widgetMensagens.currentRow.DSTITULOMENSAGEM = widgetMensagens.currentRow.DSASSUNTOMENSAGEM;
    };

    this.openWidgetEmail = function(args) {
        var widget = ABUtilController.checkWidget(args);

        if (widget.isValid()) {
            args.owner.widget.widgets[0].label = widget.currentRow.NMRELATORIO_LIST + " via E-mail";
            args.owner.widget.widgets[0].isVisible = true;
            ABUtilController.masterDetailOpenPopup(args.owner.widget.widgets[0]);
        } else {
            ScreenService.closePopup(true);
        }
    };
    
    this.setDtPeriodo = function(args) {
    var widget = ABUtilController.checkWidget(args);
    
        if(!!widget.currentRow.NRPERIODO){
            var comp = new Date(ABUtilController.convertStringFormatBRtoEUA(widget.currentRow.DTMESCOMPETENCIA));
            comp.setMonth(comp.getMonth() + 1);
            var dtini = new Date(comp.getTime());
            dtini.setMonth(dtini.getMonth() - widget.currentRow.NRPERIODO);
            comp.addDays(-1);
            widget.currentRow.DTFIM = comp.getDateBr(comp);
            widget.currentRow.DTINICIO = dtini.getDateBr(dtini);
            
        }
    };
    
    this.setRequiredFields = function(args) {
        var widget = ABUtilController.checkWidget(args);
    
        if(widget.currentRow.NMOPCOES9=='C'){
            widget.getField('DATA2').validations = {};
            widget.getField('NUMBER1').validations = {};
        }
        
        if(widget.currentRow.NMOPCOES9=='R'){
            widget.getField('DATA2').validations = {"required": true};
            widget.getField('NUMBER1').validations = {};
        }
        
        if(widget.currentRow.NMOPCOES9=='P'){
            widget.getField('DATA2').validations = {};
            widget.getField('NUMBER1').validations = {"required": true};
        }
    };
    
    this.bkpValue = "";
    
    this.adjustFieldEstruturaMovimentacao = function(args) {
        var tipoEstruturaIsEmpty = ABUtilController.checkWidget(args).currentRow.NMTIPOESTRUTURA_MOVIMENTACAO === "";
        
        if (this.bkpValue.length > 0) {
            setReadOnlyEstruturaMovimentacao(args);
        }

        if (tipoEstruturaIsEmpty) { 
            setReadOnlyEstruturaMovimentacao(args);
        } else {
            removeReadOnlyEstruturaMovimentacao(args);
        }
        
        this.bkpValue = ABUtilController.checkWidget(args).currentRow.NMTIPOESTRUTURA_MOVIMENTACAO;
    };

    function setReadOnlyEstruturaMovimentacao(args) {
        var widget = ABUtilController.checkWidget(args);

        widget.getField("NRESTRUTURAM_MOVIMENTACAO").readOnly = true;
        widget.currentRow.NRESTRUTURAM_MOVIMENTACAO = "";
    }

    function removeReadOnlyEstruturaMovimentacao(args) {
        var widget = ABUtilController.checkWidget(args);

        widget.getField("NRESTRUTURAM_MOVIMENTACAO").readOnly = false;
    }
    
    this.getFiltroTipoEstruturaMovimentacao = function(args) {
        if (existsFiltroTipoEstrutura(args)) {
            removeFiltroTipoEstrutura(args);
        }

        setFiltroTipoEstrutura(args);
    };

    function existsFiltroTipoEstrutura(args) {
        var widget = ABUtilController.checkWidget(args);
        var estruturaMovimentacao = widget.getField("NRESTRUTURAM_MOVIMENTACAO");

        return estruturaMovimentacao.dataSourceFilter[estruturaMovimentacao.dataSourceFilter.findIndex( filtro => filtro.name === 'NRTIPOESTRUTURA' )];
    }

    function removeFiltroTipoEstrutura(args) {
        var widget = ABUtilController.checkWidget(args);
        var estruturaMovimentacao = widget.getField("NRESTRUTURAM_MOVIMENTACAO");

        estruturaMovimentacao.dataSourceFilter.splice(estruturaMovimentacao.dataSourceFilter.findIndex( filtro => filtro.name === 'NRTIPOESTRUTURA' ), 1);
    }

    function setFiltroTipoEstrutura(args) {
        var widget = ABUtilController.checkWidget(args);
        var estruturaMovimentacao = widget.getField("NRESTRUTURAM_MOVIMENTACAO");

        estruturaMovimentacao.dataSourceFilter.push(
            {
                "name": "NRTIPOESTRUTURA",
                "operator": "=",
                "value": widget.currentRow.NRTIPOESTRUTURA_MOVIMENTACAO
            }
        );

        estruturaMovimentacao.reload();
    }
    
}

Configuration(function(ContextRegister) {
    ContextRegister.register('RelatoriosHcmController', RelatoriosHcmController);
});

// FILE: assets/js/controllers/RelatoriosLaudoController.js
function RelatoriosLaudoController (ScreenService, templateManager, ABUtilController, Messages) {
    this.NRRELATORIO = '1';

    this.enableCandidato = function(args){
        var widget = ABUtilController.checkWidget(args);
        if(widget.currentRow.NRRELATORIO === this.NRRELATORIO){
            widget.getField("NMPRINCIPALPARC").isVisible = true;
        } else {
            widget.getField("NMPRINCIPALPARC").isVisible = false;
        }
    };

    this.setValuesOnEnter = function(args){
        var widget = ABUtilController.checkWidget(args);
        widget.currentRow.DTMESCOMPETENC = getLocalVar("HCM_DTCOMPETENCIA_OPER");
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('RelatoriosLaudoController', RelatoriosLaudoController);
});

// FILE: assets/js/controllers/RescisaoComplementarController.js
function RescisaoComplementarController (ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, $window, ABUtilController, Messages, General) {
    
    this.setFormRescisao = function(args) {
        var widget = args.owner.widget;
        var competencia = localStorageEngine.getLocalVar('HCM_DTCOMPETENCIA_OPER');
        var fimcompetencia = localStorageEngine.getLocalVar('HCM_FIM_DTCOMPETENCIA_OPER');
        
        if (widget.isValid()) {
            if (ABUtilController.validaCritSelecao(widget.currentRow)) {
                
                if(ABUtilController.validaDtIniMenorIgualDtFin(competencia, widget.currentRow.DTPAGAMENTO) === true && ABUtilController.validaDtIniMenorIgualDtFin(widget.currentRow.DTPAGAMENTO, fimcompetencia) === true){
                    setFormResComp(widget);
                }else{
                    ScreenService.confirmMessage('A data de pagamento está fora da competência.<br>Deseja realmente adicionar o registro?', 'CONFIRMATION',
                        function() {
                            setFormResComp(widget);
                        }
                    );
                }
            }
        }
    };
    
    var setFormResComp = function(widget) {

        if (!widget.backupRow) {
            widget.currentRow.__is_new = true;
        }
        else {
            widget.currentRow.__is_new = false;
        }
        widget.currentRow.VRSALDISSIDIO = General.valueToFloat(widget.currentRow.VRSALDISSIDIO);
        restEngine.post('product#/setFormResComp', {
            'requestType': 'DataSet',
            'dataset': [widget.currentRow]
        }).
        then(function(data) {
            if (data.notifications[0].type === "success") {
                ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                if (widget.currentRow.__is_new) {
                    ABUtilController.masterDetailVoltarList(widget);
                    widget.reload();
                }
                else {
                    widget.backupRow = null;
                    widget.view();
                }
            }
            else {
                ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
            }
        }).
        catch(function(e) {
            var error;
            if (e.data.error === undefined)
                error = e;
            else
                error = e.data.error;
            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
        });
    
    };

    this.deleteFormResComp = function(args) {
        var widget = templateManager.container.getActiveWidget();
        if (widget.isValid()) {
            ScreenService.confirmMessage('Deseja realmente excluir esse formulário de cálculo?', 'CONFIRMATION',
            function() {
                widget.currentRow.__is_new = false;
                restEngine.post('product#/deleteFormResComp', {
                    'requestType': 'DataSet',
                    'dataset': [widget.currentRow]
                }).
                then(function(data) {
                    if (data.messages) {
                        ScreenService.showMessage(Messages.REMOVE_ROW_ERROR + '. ' + data.messages[0].message, data.messages[0].type);
                    }
                    else {
                        ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    }
                }).
                catch(function(e) {
                    var error;
                    if (e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;
    
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
            });
        }
    };
    
    this.gravacaoApolo = function(args) {
        var widget = ABUtilController.checkWidget(args);
        ScreenService.confirmMessage('Deseja realmente gravar definitivamente o cálculo?', 'CONFIRMATION',
            function() {
                widget.currentRow.TP_PROCESSAMENTO = 'CALCULO_APOLO_GRAVAR';
                widget.currentRow.TP_CALCULO = 7;
                restEngine.post("product#/calculoApolo", {
                    'requestType': 'DataSet',
                    'dataset': [widget.currentRow]
                }).then(function(data) {
                    if (data.messages) {
                        ScreenService.showMessage(data.messages[0].message);
                        ScreenService.closePopup();
                    }
                }).catch(function(e) {
                    var error;
                    if (e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;

                    ScreenService.showMessage('Ocorreu um erro inesperado, contate o administrador informando o trecho abaixo: <br><br>' + error + '<br><br>', 'ERROR');
                });
            }.bind(this));
    };
    
    this.gravacaoParcialApolo = function(args) {
        var widget = ABUtilController.checkWidget(args);
        ScreenService.confirmMessage('Deseja realmente gravar parcial o cálculo?', 'CONFIRMATION',
            function() {
                widget.currentRow.TP_PROCESSAMENTO = 'CALCULO_APOLO_GRAVAR_PARCIAL';
                widget.currentRow.TP_CALCULO = 7;
                restEngine.post("product#/calculoApolo", {
                    'requestType': 'DataSet',
                    'dataset': [widget.currentRow]
                }).then(function(data) {
                    if (data.messages) {
                        ScreenService.showMessage(data.messages[0].message);
                        ScreenService.closePopup();
                    }
                }).catch(function(e) {
                    var error;
                    if (e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;

                    ScreenService.showMessage('Ocorreu um erro inesperado, contate o administrador informando o trecho abaixo: <br><br>' + error + '<br><br>', 'ERROR');
                });
            }.bind(this));
    };
    
    this.gravacaoDefinitiva = function(args) {
        var widget = ABUtilController.checkWidget(args);
        ScreenService.confirmMessage('Deseja realmente gravar definitivamente o cálculo?', 'CONFIRMATION',
            function() {
                widget.currentRow.TP_PROCESSAMENTO = 'CALCULO';
                widget.currentRow.TP_CALCULO = 7;
                restEngine.post("product#/calculo", {
                    'requestType': 'DataSet',
                    'dataset': [widget.currentRow]
                }).then(function(data) {
                    if(data.dataset && data.dataset.retornoEsocial && data.dataset.retornoEsocial.length > 0){
                        var mensagem = '';
                        data.dataset.retornoEsocial.forEach(function(retorno){
                            mensagem += retorno + '<br>';
                        });
                        ScreenService.showMessage(mensagem);
                    }
                    if (data.messages) {
                        ScreenService.successNotification(data.messages[0].message);
                        ScreenService.closePopup();
                    }
                    if (data.dataset && data.dataset.memoriaCalculo && data.dataset.memoriaCalculo.length > 0) {
                        data.dataset.memoriaCalculo.forEach(function(nmArquivo){
                           ABUtilController.downloadArquivo(nmArquivo.ARQUIVOMEMORIA);
                        });
                    }
                    if (data.dataset && data.dataset.msgCalculo && data.dataset.msgCalculo.length > 0) {
                        var popUp = templateManager.container.getWidget("mensagens");
                        popUp.dataSource.data = data.dataset.msgCalculo;
                        ABUtilController.masterDetailOpenPopup(popUp);
                    }
                    if (widget.currentRow.FORM_RECIBO) {
                        var widgetCalc = templateManager.container.getWidget(widget.currentRow.FORM_RECIBO);
                        widgetCalc.reload();
                        ScreenService.closePopup();
                    }
                }).catch(function(e) {
                    var error;
                    if (e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;

                    ScreenService.showMessage('Ocorreu um erro inesperado, contate o administrador informando o trecho abaixo: <br><br>' + error + '<br><br>', 'ERROR');
                });
            }.bind(this));
    };

    this.gravacaoParcial = function(args) {
        var widget = ABUtilController.checkWidget(args);
        ScreenService.confirmMessage('Deseja realmente gravar parcialmente o cálculo?', 'CONFIRMATION',
            function() {
                widget.currentRow.TP_PROCESSAMENTO = 'PARCIAL';
                widget.currentRow.TP_CALCULO = 7;
                restEngine.post("product#/calculo", {
                    'requestType': 'DataSet',
                    'dataset': [widget.currentRow]
                }).then(function(data) {
                    if (data.messages) {
                        ScreenService.successNotification(data.messages[0].message);
                        ScreenService.closePopup();
                    }
                    if (data.dataset && data.dataset.memoriaCalculo && data.dataset.memoriaCalculo.length > 0) {
                        data.dataset.memoriaCalculo.forEach(function(nmArquivo){
                           ABUtilController.downloadArquivo(nmArquivo.ARQUIVOMEMORIA);
                        });
                    }
                    if (data.dataset && data.dataset.msgCalculo && data.dataset.msgCalculo.length > 0) {
                        var popUp = templateManager.container.getWidget("mensagens");
                        popUp.dataSource.data = data.dataset.msgCalculo;
                        ABUtilController.masterDetailOpenPopup(popUp);
                    }
                    if (widget.currentRow.FORM_RECIBO) {
                        var widgetCalc = templateManager.container.getWidget(widget.currentRow.FORM_RECIBO);
                        widgetCalc.reload();
                        ScreenService.closePopup();
                    }
                }).catch(function(e) {
                    var error;
                    if (e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;

                    ScreenService.showMessage('Ocorreu um erro inesperado, contate o administrador informando o trecho abaixo: <br><br>' + error + '<br><br>', 'ERROR');
                });
            }.bind(this));
    };

    this.retrocesso = function(args) {
        var widget = ABUtilController.checkWidget(args);
        var self = this;
        ScreenService.confirmMessage('Deseja realmente retroceder o cálculo?', 'CONFIRMATION', function() {
            self.enviaRetrocesso(widget, false);
        });
    };

    this.enviaRetrocesso = function(widget, confirmacao) {
        var self = this;
        widget.currentRow.TP_PROCESSAMENTO = 'RETROCESSO';
        widget.currentRow.TP_CALCULO = 7;
        widget.currentRow.RETROCESSO_CONFIRMADO = confirmacao;
        restEngine.post("product#/calculo", {
            'requestType': 'DataSet',
            'dataset': [widget.currentRow]
        }).then(function(data) {
            if (data.messages) {
                if (data.messages[0].type == 'W') {
                    ScreenService.confirmMessage(data.messages[0].message, 'CONFIRMATION', function() {
                        self.enviaRetrocesso(widget, true);
                    });
                } else {
                    ScreenService.successNotification(data.messages[0].message);
                }
                ScreenService.closePopup();
            }
            if (data.dataset && data.dataset.msgCalculo && data.dataset.msgCalculo.length > 0) {
                var popUp = templateManager.container.getWidget("mensagens");
                popUp.dataSource.data = data.dataset.msgCalculo;
                ABUtilController.masterDetailOpenPopup(popUp);
            }
            if (widget.currentRow.FORM_RECIBO) {
                var widgetCalc = templateManager.container.getWidget(widget.currentRow.FORM_RECIBO);
                widgetCalc.reload();
                ScreenService.closePopup();
            }
        }).catch(function(e) {
            var error;
            if (e.data.error === undefined)
                error = e;
            else
                error = e.data.error;

            ScreenService.showMessage('Ocorreu um erro inesperado, contate o administrador informando o trecho abaixo: <br><br>' + error + '<br><br>', 'ERROR');
        });
    };
    
    this.simular = function(args) {
        var widget = ABUtilController.checkWidget(args);
        ScreenService.confirmMessage('Deseja realmente simular o cálculo?', 'CONFIRMATION',
            function() {
                widget.currentRow.TP_PROCESSAMENTO = 'SIMULACAO';
                widget.currentRow.TP_CALCULO = 7;
                restEngine.post("product#/calculo", {
                        'requestType': 'DataSet',
                        'dataset': [widget.currentRow]
                    },
                    function(data) {
                        if (data.messages) {
                            ScreenService.successNotification(data.messages[0].message);
                            ScreenService.closePopup();
                        }
                        if (data.dataset && data.dataset.memoriaCalculo && data.dataset.memoriaCalculo.length > 0) {
                            data.dataset.memoriaCalculo.forEach(function(nmArquivo){
                               ABUtilController.downloadArquivo(nmArquivo.ARQUIVOMEMORIA);
                            });
                        }
                        if (data.dataset && data.dataset.msgCalculo && data.dataset.msgCalculo.length > 0) {
                            var popUp = templateManager.container.getWidget("mensagens");
                            popUp.dataSource.data = data.dataset.msgCalculo;
                            ABUtilController.masterDetailOpenPopup(popUp);
                        }
                        if (data.dataset && data.dataset.simulacao) {
                            var widgetSimu = this.preparaDemonstrativo(data.dataset.simulacao);
                            ABUtilController.masterDetailOpenPopup(widgetSimu);
                        }
                        if (widget.currentRow.FORM_RECIBO) {
                            var widgetCalc = templateManager.container.getWidget(widget.currentRow.FORM_RECIBO);
                            widgetCalc.reload();
                            ScreenService.closePopup();
                        }
                    }.bind(this), undefined,
                    function(e) {
                        var error;
                        if (e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;

                        ScreenService.showMessage('Ocorreu um erro inesperado, contate o administrador informando o trecho abaixo: <br><br>' + error + '<br><br>', 'ERROR');
                    }
                );
            }.bind(this));
    };
    
    this.preparaDemonstrativo = function(vinculos) {

        var widgetSimulacao = templateManager.container.getWidget("simulacao");
        widgetSimulacao.dataSource.data = [];
        vinculos.forEach(function(nrcalculofolha) {
            nrcalculofolha.SIMULACAO.forEach(function(itensCalcFolha) {
                widgetSimulacao.dataSource.data = widgetSimulacao.dataSource.data.concat(itensCalcFolha);
            });
        });
        return widgetSimulacao;
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('RescisaoComplementarController', RescisaoComplementarController);
});

// FILE: assets/js/controllers/RescisaoController.js
/* jshint esversion: 6 */
function RescisaoController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, $window, ABUtilController, Messages, HorarioController) {

    var self = this;

    this.openPopup = function(widget) {
        var widgetFilter = templateManager.container.getWidget('rescisaoColetiva');
        ScreenService.openPopup(widgetFilter);
    };

    this.adicionarRow = function(args) {
        var widget = ABUtilController.checkWidget(args);
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
    };
    
    this.setFiltroVinculos = function(args) {

        var widget = ABUtilController.checkWidget(args);
        var currentRow = widget.currentRow;

        if (currentRow.IDOPERACAO == 'I') {
            widget.getField('NRVINCULOM_LIST').dataSource.name = "product#/getVinculosAtivosCompetencia";
            widget.getField('DTRESCISAOVINC').validations = {
                "required": true
            };
            widget.getField('NMTPDEMISSAO').validations = {
                "required": true
            };
        } else {
            widget.getField('NRVINCULOM_LIST').dataSource.name = "product#/getVinculosRescindidosGeral";
            widget.getField('DTRESCISAOVINC').validations = {};
            widget.getField('NMTPDEMISSAO').validations = {};
        }
        widget.getField('NRVINCULOM_LIST').readOnly = false;
    };

    this.rescisaoColetiva = function(args) {
        var widget = ABUtilController.checkWidget(args);
        var msgconfirm = 'Serão excluídas as rescisões de todos os vínculos filtrados. Deseja continuar?';
        if (widget.currentRow.IDOPERACAO == 'I') {
            msgconfirm = 'Serão preenchidas as rescisões de todos os vínculos filtrados. Deseja continuar?';
        }
        ScreenService.confirmMessage(msgconfirm, 'CONFIRMATION',
            function() {
                restEngine.post("product#/rescisaoColetiva", {
                    'requestType': 'DataSet',
                    'dataset': [widget.currentRow]
                }).then(function(data) {
                    if (data.dataset.count[0] > 0) {
                        if (widget.currentRow.IDOPERACAO == 'I') {
                            ScreenService.showMessage("Foram preenchidas " + data.dataset.count[0] + " rescisões com sucesso!");
                        } else {
                            ScreenService.showMessage("Foram excluídas " + data.dataset.count[0] + " rescisões com sucesso!");
                        }
                        ScreenService.closePopup(true);
                    } else {
                        ScreenService.showMessage('Não foram encontrados vínculos para os filtros informados');
                        ScreenService.closePopup(true);
                    }
                }.bind(this)).catch(function(e) {
                    var error;
                    if (e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;

                    ScreenService.showMessage('Ocorreu um erro inesperado, contate o administrador informando o trecho abaixo: <br><br>' + error + '<br><br>', 'ERROR');
                });
            }.bind(this));
    };
    
    this.validaFiltroRescisao = function () {
        var widget = templateManager.container.getWidget('calculoRescisao');
        var resultado = false;
        if(!widget.getField('NRVINCULOM_LIST') && !widget.getField('LIST_NRESTRUTLEGAL') && !widget.getField('LIST_NRESTRUTGEREN') && !widget.getField('LIST_NRESTRUTSIND')){
            ScreenService.showMessage("É necessário preencher o campo 'Vínculo', 'Estrutura Legal', 'Estrutura Gerencial' ou 'Estrutura Sindical' para realizar o filtro.");

        } else {
            if ((widget.currentRow.NRVINCULOM_LIST && widget.currentRow.NRVINCULOM_LIST.length > 400)) {
                ScreenService.showMessage("Favor selecionar um máximo de 400 vínculos na lista ou usar outro filtro como por exemplo por estrutura legal.");
                resultado =  true;
            }
            if ((widget.currentRow.LIST_NRESTRUTLEGAL && widget.currentRow.LIST_NRESTRUTLEGAL.length > 400) || (widget.currentRow.LIST_NRESTRUTGEREN && widget.currentRow.LIST_NRESTRUTGEREN .length > 400) || (widget.currentRow.LIST_NRESTRUTGEREN  && widget.currentRow.LIST_NRESTRUTGEREN.length > 400)) {
                ScreenService.showMessage("Favor selecionar um máximo de 400 estruturas na lista.");
                resultado = true;
            }
            
        } 
        return resultado;
    };

    this.setFormRescisao = function(args) {
        var widget = args.owner.widget;
        var filtroResiao = this.validaFiltroRescisao();
        var competencia = localStorageEngine.getLocalVar('HCM_DTCOMPETENCIA_OPER');
        var fimcompetencia = localStorageEngine.getLocalVar('HCM_FIM_DTCOMPETENCIA_OPER');
        if (widget.isValid()) {
           
            if (ABUtilController.validaCritSelecao(widget.currentRow)) {
                
                if(ABUtilController.validaDtIniMenorIgualDtFin(competencia, widget.currentRow.DTPAGAMENTO) === true && ABUtilController.validaDtIniMenorIgualDtFin(widget.currentRow.DTPAGAMENTO, fimcompetencia) === true){
                    salvar(widget);
                }else{
                    if(filtroResiao == true){
                        return;
                    }
                    ScreenService.confirmMessage('A data de pagamento está fora da competência.<br>Deseja realmente adicionar o registro?', 'CONFIRMATION',
                        function() {
                            salvar(widget);
                        }
                    );
                }


            }
           
        }
    };
    
    var salvar = function(widget){
        if (!widget.backupRow) {
            widget.currentRow.__is_new = true;
        } else {
            widget.currentRow.__is_new = false;
        }
        restEngine.post('product#/setFormRescisao', {
            'requestType': 'DataSet',
            'dataset': [widget.currentRow]
        }).
        then(function(data) {
            if (data.notifications[0].type === "success") {
                ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                if (widget.currentRow.__is_new) {
                    ABUtilController.masterDetailVoltarList(widget);
                    widget.reload();
                } else {
                    widget.backupRow = null;
                    widget.view();
                }
            } else {
                ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
            }
        }).
        catch(function(e) {
            var error;
            if (e.data.error === undefined)
                error = e;
            else
                error = e.data.error;
            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
        });        
    };

    this.deleteFormRescisao = function(args) {
        var widget = templateManager.container.getActiveWidget();
        if (widget.isValid()) {
            ScreenService.confirmMessage('Deseja realmente excluir esse formulário de cálculo?', 'CONFIRMATION',
            function() {
                widget.currentRow.__is_new = false;
                restEngine.post('product#/deleteFormRescisao', {
                    'requestType': 'DataSet',
                    'dataset': [widget.currentRow]
                }).
                then(function(data) {
                    if (data.messages) {
                        ScreenService.showMessage(Messages.REMOVE_ROW_ERROR + '. ' + data.messages[0].message, data.messages[0].type);
                    } else {
                        ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    }
                }).
                catch(function(e) {
                    var error;
                    if (e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;
    
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
            });
        }
    };
    
    this.gravacaoApolo = function(args) {
        var widget = ABUtilController.checkWidget(args);
        ScreenService.confirmMessage('Deseja realmente gravar definitivamente o cálculo?', 'CONFIRMATION',
            function() {
                widget.currentRow.TP_PROCESSAMENTO = 'CALCULO_APOLO_GRAVAR';
                widget.currentRow.TP_CALCULO = 6;
                restEngine.post("product#/calculoApolo", {
                    'requestType': 'DataSet',
                    'dataset': [widget.currentRow]
                }).then(function(data) {
                    if (data.messages) {
                        ScreenService.showMessage(data.messages[0].message);
                        ScreenService.closePopup();
                    }
                }).catch(function(e) {
                    var error;
                    if (e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;

                    ScreenService.showMessage('Ocorreu um erro inesperado, contate o administrador informando o trecho abaixo: <br><br>' + error + '<br><br>', 'ERROR');
                });
            }.bind(this));
    };
    
    this.gravacaoParcialApolo = function(args) {
        var widget = ABUtilController.checkWidget(args);
        ScreenService.confirmMessage('Deseja realmente gravar parcial o cálculo?', 'CONFIRMATION',
            function() {
                widget.currentRow.TP_PROCESSAMENTO = 'CALCULO_APOLO_GRAVAR_PARCIAL';
                widget.currentRow.TP_CALCULO = 6;
                restEngine.post("product#/calculoApolo", {
                    'requestType': 'DataSet',
                    'dataset': [widget.currentRow]
                }).then(function(data) {
                    if (data.messages) {
                        ScreenService.showMessage(data.messages[0].message);
                        ScreenService.closePopup();
                    }
                }).catch(function(e) {
                    var error;
                    if (e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;

                    ScreenService.showMessage('Ocorreu um erro inesperado, contate o administrador informando o trecho abaixo: <br><br>' + error + '<br><br>', 'ERROR');
                });
            }.bind(this));
    };
    
    this.gravacaoDefinitiva = function(args, ESocialController, verificaEnvioEsocialDescentralizado = false) {
        var widget = ABUtilController.checkWidget(args);
        if(verificaEnvioEsocialDescentralizado){
            ScreenService.confirmMessage('Deseja realmente gravar definitivamente o cálculo?', 'CONFIRMATION',
                function() {
                    ESocialController.envioEsocialDescentralizado(widget.currentRow, 'S-2299', null, null, this.gravacaoDefinitiva, args);
                }.bind(this));
        }else{
            widget.currentRow.TP_PROCESSAMENTO = 'CALCULO';
            widget.currentRow.TP_CALCULO = 6;
            restEngine.post("product#/calculo", {
                'requestType': 'DataSet',
                'dataset': [widget.currentRow]
            }).then(function(data) {
                if(data.dataset && data.dataset.retornoEsocial && data.dataset.retornoEsocial.length > 0){
                    var mensagem = 'S-2299/S-2399:<br>';
                    data.dataset.retornoEsocial.forEach(function(retorno){
                        mensagem += retorno.MSG + '<br>';
                    });
                    ScreenService.showMessage(mensagem);
                }
                if (data.messages) {
                    ScreenService.successNotification(data.messages[0].message);
                    ScreenService.closePopup();
                }
                if (data.dataset && data.dataset.memoriaCalculo && data.dataset.memoriaCalculo.length > 0) {
                    data.dataset.memoriaCalculo.forEach(function(nmArquivo){
                       ABUtilController.downloadArquivo(nmArquivo.ARQUIVOMEMORIA);
                    });
                }
                if (data.dataset && data.dataset.msgCalculo && data.dataset.msgCalculo.length > 0) {
                    var popUp = templateManager.container.getWidget("mensagens");
                    popUp.dataSource.data = data.dataset.msgCalculo;
                    ABUtilController.masterDetailOpenPopup(popUp);
                }
                if (widget.currentRow.FORM_RECIBO) {
                    var widgetCalc = templateManager.container.getWidget(widget.currentRow.FORM_RECIBO);
                    widgetCalc.reload();
                    ScreenService.closePopup();
                }
            }).catch(function(e) {
                var error;
                if (e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;

                ScreenService.showMessage('Ocorreu um erro inesperado, contate o administrador informando o trecho abaixo: <br><br>' + error + '<br><br>', 'ERROR');
            });
        }
    };
    
    this.recalculoPatronal = function(args) {
        var widget = ABUtilController.checkWidget(args);
        ScreenService.confirmMessage('Deseja realmente recalcular os eventos patronais?', 'CONFIRMATION',
            function() {
                widget.currentRow.TP_PROCESSAMENTO = 'RECALCPATRONAL';
                widget.currentRow.TP_CALCULO = 6;
                restEngine.post("product#/calculo", {
                    'requestType': 'DataSet',
                    'dataset': [widget.currentRow]
                }).then(function(data) {
                    if (widget.currentRow.FORM_RECIBO) {
                        var widgetCalc = templateManager.container.getWidget(widget.currentRow.FORM_RECIBO);
                        widgetCalc.reload();
                        ScreenService.closePopup();
                    }
                    if (data.messages) {
                        ScreenService.successNotification(data.messages[0].message);
                        ScreenService.closePopup();
                    }
                    if (data.dataset && data.dataset.memoriaCalculo && data.dataset.memoriaCalculo.length > 0) {
                        data.dataset.memoriaCalculo.forEach(function(nmArquivo){
                           ABUtilController.downloadArquivo(nmArquivo.ARQUIVOMEMORIA);
                        });
                    }
                    if (data.dataset && data.dataset.msgCalculo && data.dataset.msgCalculo.length > 0) {
                        var popUp = templateManager.container.getWidget("mensagens");
                        popUp.dataSource.data = data.dataset.msgCalculo;
                        ABUtilController.masterDetailOpenPopup(popUp);
                    }
                }).catch(function(e) {
                    var error;
                    if (e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;

                    ScreenService.showMessage('Ocorreu um erro inesperado, contate o administrador informando o trecho abaixo: <br><br>' + error + '<br><br>', 'ERROR');
                });
            }.bind(this));
    };
    
    this.gravacaoParcial = function(args) {
        var widget = ABUtilController.checkWidget(args);
        ScreenService.confirmMessage('Deseja realmente gravar parcialmente o cálculo?', 'CONFIRMATION',
            function() {
                widget.currentRow.TP_PROCESSAMENTO = 'PARCIAL';
                widget.currentRow.TP_CALCULO = 6;
                restEngine.post("product#/calculo", {
                    'requestType': 'DataSet',
                    'dataset': [widget.currentRow]
                }).then(function(data) {
                    if (data.messages) {
                        ScreenService.successNotification(data.messages[0].message);
                        ScreenService.closePopup();
                    }
                    if (data.dataset && data.dataset.memoriaCalculo && data.dataset.memoriaCalculo.length > 0) {
                        data.dataset.memoriaCalculo.forEach(function(nmArquivo){
                           ABUtilController.downloadArquivo(nmArquivo.ARQUIVOMEMORIA);
                        });
                    }
                    if (data.dataset && data.dataset.msgCalculo && data.dataset.msgCalculo.length > 0) {
                        var popUp = templateManager.container.getWidget("mensagens");
                        popUp.dataSource.data = data.dataset.msgCalculo;
                        ABUtilController.masterDetailOpenPopup(popUp);
                    }
                    if (widget.currentRow.FORM_RECIBO) {
                        var widgetCalc = templateManager.container.getWidget(widget.currentRow.FORM_RECIBO);
                        widgetCalc.reload();
                        ScreenService.closePopup();
                    }
                }).catch(function(e) {
                    var error;
                    if (e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;

                    ScreenService.showMessage('Ocorreu um erro inesperado, contate o administrador informando o trecho abaixo: <br><br>' + error + '<br><br>', 'ERROR');
                });
            }.bind(this));
    };
    
    this.retrocesso = function(args) {
        var widget = ABUtilController.checkWidget(args);
        var self = this;
        ScreenService.confirmMessage('Deseja realmente retroceder o cálculo?', 'CONFIRMATION', function() {
            self.enviaRetrocesso(widget, false);
        });
    };

    this.enviaRetrocesso = function(widget, confirmacao) {
        var self = this;
        widget.currentRow.TP_PROCESSAMENTO = 'RETROCESSO';
        widget.currentRow.TP_CALCULO = 6;
        widget.currentRow.RETROCESSO_CONFIRMADO = confirmacao;
        restEngine.post("product#/calculo", {
            'requestType': 'DataSet',
            'dataset': [widget.currentRow]
        }).then(function(data) {
            if (data.messages) {
                if (data.messages[0].type == 'W') {
                    ScreenService.confirmMessage(data.messages[0].message, 'CONFIRMATION', function() {
                        self.enviaRetrocesso(widget, true);
                    });
                } else {
                    ScreenService.successNotification(data.messages[0].message);
                }
                ScreenService.closePopup();
            }
            if (data.dataset && data.dataset.msgCalculo && data.dataset.msgCalculo.length > 0) {
                var popUp = templateManager.container.getWidget("mensagens");
                popUp.dataSource.data = data.dataset.msgCalculo;
                ABUtilController.masterDetailOpenPopup(popUp);
            }
            if (widget.currentRow.FORM_RECIBO) {
                var widgetCalc = templateManager.container.getWidget(widget.currentRow.FORM_RECIBO);
                widgetCalc.reload();
                ScreenService.closePopup();
            }
        }).catch(function(e) {
            var error;
            if (e.data.error === undefined)
                error = e;
            else
                error = e.data.error;

            ScreenService.showMessage('Ocorreu um erro inesperado, contate o administrador informando o trecho abaixo: <br><br>' + error + '<br><br>', 'ERROR');
        });
    };

    this.simular = function(args) {
        var widget = ABUtilController.checkWidget(args);
        ScreenService.confirmMessage('Deseja realmente simular o cálculo?', 'CONFIRMATION',
            function() {
                widget.currentRow.TP_PROCESSAMENTO = 'SIMULACAO';
                widget.currentRow.TP_CALCULO = 6;
                restEngine.post("product#/calculo", {
                        'requestType': 'DataSet',
                        'dataset': [widget.currentRow]
                    },
                    function(data) {
                        if (data.messages) {
                            ScreenService.successNotification(data.messages[0].message);
                            ScreenService.closePopup();
                        }
                        if (data.dataset && data.dataset.memoriaCalculo && data.dataset.memoriaCalculo.length > 0) {
                            data.dataset.memoriaCalculo.forEach(function(nmArquivo){
                               ABUtilController.downloadArquivo(nmArquivo.ARQUIVOMEMORIA);
                            });
                        }
                        if (data.dataset && data.dataset.msgCalculo && data.dataset.msgCalculo.length > 0) {
                            var popUp = templateManager.container.getWidget("mensagens");
                            popUp.dataSource.data = data.dataset.msgCalculo;
                            ABUtilController.masterDetailOpenPopup(popUp);
                        }
                        if (data.dataset && data.dataset.simulacao) {
                            var widgetSimu = this.preparaDemonstrativo(data.dataset.simulacao);
                            ABUtilController.masterDetailOpenPopup(widgetSimu);
                        }
                        if (widget.currentRow.FORM_RECIBO) {
                            var widgetCalc = templateManager.container.getWidget(widget.currentRow.FORM_RECIBO);
                            widgetCalc.reload();
                            ScreenService.closePopup();
                        }
                    }.bind(this), undefined,
                    function(e) {
                        var error;
                        if (e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;

                        ScreenService.showMessage('Ocorreu um erro inesperado, contate o administrador informando o trecho abaixo: <br><br>' + error + '<br><br>', 'ERROR');
                    }
                );
            }.bind(this));
    };


    this.cancelamentoDeRescisao = function(args) {
        var widget = ABUtilController.checkWidget(args);
        ScreenService.confirmMessage('Deseja realmente cancelar o cálculo?', 'CONFIRMATION',
            function() {
                widget.currentRow.TP_PROCESSAMENTO = 'CANCELAMENTO';
                widget.currentRow.TP_CALCULO = 6;
                restEngine.post("product#/calculo", {
                    'requestType': 'DataSet',
                    'dataset': [widget.currentRow]
                }).then(function(data) {
                    if (data.messages) {
                        ScreenService.successNotification(data.messages[0].message);
                        ScreenService.closePopup();
                    }
                    if (data.dataset && data.dataset.msgCalculo && data.dataset.msgCalculo.length > 0) {
                        var popUp = templateManager.container.getWidget("mensagens");
                        popUp.dataSource.data = data.dataset.msgCalculo;
                        ABUtilController.masterDetailOpenPopup(popUp);
                    }
                    if (widget.currentRow.FORM_RECIBO) {
                        var widgetCalc = templateManager.container.getWidget(widget.currentRow.FORM_RECIBO);
                        widgetCalc.reload();
                        ScreenService.closePopup();
                    }
                }).catch(function(e) {
                    var error;
                    if (e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;

                    ScreenService.showMessage('Ocorreu um erro inesperado, contate o administrador informando o trecho abaixo: <br><br>' + error + '<br><br>', 'ERROR');
                });
            }.bind(this));
    };

    this.preparaDemonstrativo = function(vinculos) {

        var widgetSimulacao = templateManager.container.getWidget("simulacao");
        widgetSimulacao.dataSource.data = [];
        vinculos.forEach(function(nrcalculofolha) {
            nrcalculofolha.SIMULACAO.forEach(function(itensCalcFolha) {
                widgetSimulacao.dataSource.data = widgetSimulacao.dataSource.data.concat(itensCalcFolha);
            });
        });
        return widgetSimulacao;
    };
    
    this.setZerarCalculoRecisorio = function(args){
        var widget = ABUtilController.checkWidget(args);
        ScreenService.confirmMessage('Deseja realmente zerar verbas rescisórias devido a reclamatória trabalhista?', 'CONFIRMATION',
        function() {
        widget.currentRow.__is_new = false;
            restEngine.post('product#/zerarCalculoRecisorio', {
                'requestType': 'DataSet',
                'dataset': [widget.currentRow]
            }).
            then(function(data) {
                if (data.messages[0].type == 'M') {
                    ScreenService.showMessage(data.messages[0].message);
                    ScreenService.closePopup();
                    ABUtilController.masterDetailVoltarList(widget);
                    widget.reload();
                }
                else if(data.messages[0].type == 'E'){
                    ScreenService.showMessage(data.messages[0].message);
                    ScreenService.closePopup();
                    widget.reload();
                }else{
                    ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                }
            }).
            catch(function(e) {
                var error;
                if (e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;

                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
        });
    };

}

Configuration(function(ContextRegister) {
    ContextRegister.register('RescisaoController', RescisaoController);
});


// FILE: assets/js/controllers/ResultadoExameController.js
function ResultadoExameController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, General,Messages) {

    this.adicionarRow = function(args) {
        var widget = args.owner.widget;
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
    };
    
	this.setResultExame = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
                if (!widget.backupRow) {
                    widget.currentRow.__is_new = true;
                } else {
                    widget.currentRow.__is_new = false;
                }
                restEngine.post('product#/setResultExame', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                    then(function (data) {
                        if (data.notifications[0].type === "success") {
                            ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                            if (widget.currentRow.__is_new) {
                                ABUtilController.masterDetailVoltarList(widget);
                                widget.reload();
                            } else {
                                ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                                widget.backupRow = null;
                                widget.view();
                            }
                        } else {
                            ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                        }
                    }).
                    catch(function(e) {
                        var error;
                        if(e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;
                            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    });
            }
    };
    
    this.deleteResultExame = function(args) {
    ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
        var widget = args.owner.widget;
        widget.currentRow.__is_new = false;
        restEngine.post('product#/deleteResultExame', {'requestType':'DataSet','dataset':[widget.currentRow]}).
            then(function(data){
                if(data.notifications[0].type === "success"){
                    ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                    ABUtilController.masterDetailVoltarList(widget);
                    widget.reload();
                } else {
                    ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                }
            }).
            catch(function(e) {
                var error;
                if(e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
        }, null);
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('ResultadoExameController', ResultadoExameController);
});

// FILE: assets/js/controllers/ResumoContabilController.js
/**
 * Created by felipesantos on 23/12/2016.
 */
function ResumoContabilController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, ABUtilController, Messages, General) {

    this.salvarResumoctbl = function(widget) {
        if (widget.isValid()) {
            if (!widget.backupRow) {
                widget.currentRow.__is_new = true;
            } else {
                widget.currentRow.__is_new = false;
            }
            widget.currentRow.VRLANCAMENTO = General.valueToFloat(widget.currentRow.VRLANCAMENTO);
            restEngine.post('product#/setResumoctbl', {
                'requestType': 'DataSet',
                'dataset': [widget.currentRow]
            }).
            then(function(data) {
                if (!Util.isUndefined(data.notifications) && data.notifications[0].type === "success") {
                    ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                    if (data.notifications.length > 1) {
                        data.notifications.shift();
                        data.notifications.forEach(function(notification) {
                            ScreenService.notificationMessage(notification.message, 10000);
                        });
                    }
                    if (!Util.isUndefined(data.messages)) {
                        ScreenService.showMessage(data.messages[0].message, data.messages[0].type);
                    }
                    if (widget.currentRow.__is_new) {
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    } else {
                        ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                        widget.backupRow = null;
                        widget.view();
                    }
                } else if (!Util.isUndefined(data.messages)) {
                    ScreenService.showMessage(data.messages[0].message, data.messages[0].type);
                } else {
                    ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                }
            }).
            catch(function(e) {
                var error;
                if (e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;

                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
        }
    };

    this.deleteResumoctbl = function(widget) {
        ScreenService.confirmMessage(Messages.DELETE_ROW, 'CONFIRMATION',
            function() {
                if (widget.isValid()) {
                    widget.currentRow.__is_new = false;
                    restEngine.post('product#/deleteResumoctbl', {
                        'requestType': 'DataSet',
                        'dataset': [widget.currentRow]
                    }).
                    then(function(data) {
                        if (data.notifications[0].type === "success") {
                            ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                            ABUtilController.masterDetailVoltarList(widget);
                            widget.reload();
                        } else {
                            ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                        }
                    }).
                    catch(function(e) {
                        var error;
                        if (e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;

                        ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    });
                }
            });
    };

    this.openGerarLote = function(action) {
        var widgetPopup = templateManager.container.getWidget('popupGerarLote');
        ABUtilController.masterDetailOpenPopup(widgetPopup);
    };

    this.gerarLote = function(widgetCadAuto) {
        if (widgetCadAuto.isValid()) {
            restEngine.post("product#/gerarLotePadrao", {
                'requestType': 'DataSet',
                'dataset': [widgetCadAuto.currentRow]
            }).
            then(function(data) {
                if(data.dataset && data.dataset.arquivos) {
                    data.dataset.arquivos.forEach(function(arquivo) {
                       ABUtilController.downloadArquivo(arquivo.NMARQUIVO);
                    });
                }
                if (data.messages) {
                    var textMessage = '';
                    data.messages.forEach(function(objMsg) {
                        if(objMsg.type == 'W')
                            textMessage += objMsg.message + '<br>';
                    });
                    if(textMessage != '')
                        ScreenService.showMessage(textMessage);
                }

                if (data.notifications && data.notifications[0].type === "error") {
                    ScreenService.alertNotification(Messages.CADASTRO_AUTOMATICO_ERRO, 10000);
                } else {
                    ScreenService.successNotification(Messages.CADASTRO_AUTOMATICO_SUCCESS, 10000);
                    ABUtilController.masterDetailClosePopup(widgetCadAuto);
                    templateManager.container.getWidget('resumoctbl').activate();
                    templateManager.container.getWidget('resumoctbl').reload();
                }
            }).
            catch(function(e) {
                var error;
                if (e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;

                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
        }
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('ResumoContabilController', ResumoContabilController);
});


// FILE: assets/js/controllers/ResumoDespesasController.js
 function ResumoDespesasController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, Messages) {

     this.salvarResumoDespesas = function(args) {
         var widget = templateManager.container.getActiveWidget();
         if (widget.isValid()) {
             if (!widget.backupRow) {
                 widget.currentRow.__is_new = true;
             } else {
                 widget.currentRow.__is_new = false;
             }
             widget.currentRow.DTULTATUDADM = widget.currentRow.DTULTATU;
             restEngine.post('product#/setResumoDespesas', {
                 'requestType': 'DataSet',
                 'dataset': [widget.currentRow]
             }).
             then(function(data) {
                 if (data.notifications[0].type === "success") {
                     ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                     if (widget.currentRow.__is_new) {
                         ABUtilController.masterDetailVoltarList(widget);
                         widget.reload();
                     } else {
                         ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                         widget.backupRow = null;
                         widget.view();
                     }
                 } else
                     ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
             }).
             catch(function(e) {
                 var error;
                 if (e.data.error === undefined)
                     error = e;
                 else
                     error = e.data.error;

                 ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
             });
         }
     };

     this.removerResumoDespesas = function(args) {
         ScreenService.confirmMessage(Messages.DELETE_ROW, 'CONFIRMATION',
             function() {
                 var widget = templateManager.container.getActiveWidget();
                 widget.currentRow.__is_new = false;
                 restEngine.post('product#/deleteResumoDespesas', {
                     'requestType': 'DataSet',
                     'dataset': [widget.currentRow]
                 }).
                 then(function(data) {
                     if (data.notifications[0].type === "success") {
                         ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                         ABUtilController.masterDetailVoltarList(widget);
                         widget.reload();
                     } else
                         ScreenService.showMessage(Messages.REMOVE_ROW_ERROR, 'ERROR');
                 }).
                 catch(function(e) {
                     var error;
                     if (e.data.error === undefined)
                         error = e;
                     else
                         error = e.data.error;

                     ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                 });
             });
     };


     this.mostraCodigo = function(widget) {
         widget.getField('NRRESUMODRO').showOnForm = true;
     };

     this.escondeCodigo = function(widget) {
         widget.getField('NRRESUMODRO').showOnForm = false;
     };

 }

 Configuration(function(ContextRegister) {
     ContextRegister.register('ResumoDespesasController', ResumoDespesasController);
 });
 

// FILE: assets/js/controllers/ResumoSituacaoFrequenciaController.js
function ResumoSituacaoFrequenciaController (ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, $window, ABUtilController, Messages) {

    var NMVINCULOM;
    var NRVINCULOM;
    var DSPERIODOAPURACAO;
    var NRPERIODOAPURACAO;
    
    this.openAdicionarResumo = function(args) {
        var widget = args.owner.widget;
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
        widget.currentRow.NRVINCULOM = NRVINCULOM;
        widget.currentRow.NMVINCULOM = NMVINCULOM;
        widget.currentRow.NRPERIODOAPURACAO = NRPERIODOAPURACAO;
        widget.currentRow.DSPERIODOAPURACAO = DSPERIODOAPURACAO;
    };
    
    this.setApuracaoVinculo = function(args){
        var filterRow = args.e.preference.FILTER_ROW;
        NRVINCULOM = filterRow.NRVINCULOM; 
        NMVINCULOM = filterRow.NMVINCULOM;
        NRPERIODOAPURACAO = filterRow.NRPERIODOAPURACAO;
        DSPERIODOAPURACAO = filterRow.DSPERIODOAPURACAO;
    };

    this.deleteResumo = function(args) {
        var widget = args.owner.widget;
        var data = {}; 
        ScreenService.confirmMessage(Messages.DELETE_ROW, 'CONFIRMATION', 
            function(){
                widget.dataSource.checkedRows = widget.currentRow;
                widget.removeCheckedRows();
                widget.reload();
                ABUtilController.masterDetailVoltarList(widget);
                ScreenService.showMessage(Messages.REMOVE_ROW_SUCCESS);
            }.bind(this)
        );
    };

    this.salvarResumo = function(argsRow){
        var widget = templateManager.container.getWidget("resumoSitiuacaoFrequencia");
        if(widget.isValid())  {
            widget.currentRow.CDOPERLOG = getLocalVar("HCM_CDOPERADOR");
            widget.currentRow.NRORGTRAB = getLocalVar("HCM_NRORG_TRAB");
            widget.currentRow.DTATUAL = getLocalVar("HCM_DATA_ATUAL");
            return widget.saveRow().then(function(){
                widget.currentRow.changed = false;
                widget.currentRow.__is_new = false;
                ScreenService.showMessage(Messages.SAVE_ROW_SUCCESS);
                ABUtilController.masterDetailVoltarList(widget);
                widget.reload();
            }).catch(function(e) {
                var error;
                if(e.data.error === undefined)
                    error = e;
                else 
                    error = e.data.error;
                
                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error));
            });
        }
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('ResumoSituacaoFrequenciaController', ResumoSituacaoFrequenciaController);
});

// FILE: assets/js/controllers/ResumosGeraisApuracaoController.js
/* jshint esversion: 6 */
function ResumosGeraisApuracaoController(ScreenService, templateManager, restEngine, ABUtilController, Messages, AFormataHoraDecimal) {
    
    const self = this;
    
    this.trustContainerUrlParams = true;

    this.enableTipoPeriodo = function(args){
        var widget = args.owner.owner.widget;
        if(widget.currentRow.DSTIPOPERIODOAPURACAO === ""){
            widget.currentRow.DSPERIODOAPURACAO = null;
            widget.getField('DSPERIODOAPURACAO').readOnly = true;
            widget.getField('DSPERIODOAPURACAO').validations = {};
        }else{
            widget.getField('DSPERIODOAPURACAO').readOnly = false;
            widget.getField('DSPERIODOAPURACAO').validations = {"required": true};
            widget.getField('DSPERIODOAPURACAO').dataSourceFilter[ABUtilController.retornaFiltro(widget.getField('DSPERIODOAPURACAO').dataSourceFilter, 'NRTIPOPERIODOAPURACAO')].value = args.row.NRTIPOPERIODOAPURACAO;
            widget.getField('DSPERIODOAPURACAO').reload();
        }
    };

    this.enableTipoPeriodoApuracao = function(args){
        var widget = args.owner.owner.widget;
        if(widget.currentRow.NRTIPOVINCULOM === ""){
            widget.currentRow.DSPERIODOAPURACAO = null;
            widget.getField('DSPERIODOAPURACAO').readOnly = true;
            widget.getField('DSPERIODOAPURACAO').validations = {};
            widget.getField('DSTIPOPERIODOAPURACAO').validations = {};
            widget.currentRow.DSTIPOPERIODOAPURACAO = null;
            widget.getField('DSTIPOPERIODOAPURACAO').readOnly = true;
            
        }else{
            widget.getField('DSTIPOPERIODOAPURACAO').readOnly = false;
            widget.getField('DSTIPOPERIODOAPURACAO').validations = {"required": true};
            widget.getField('DSTIPOPERIODOAPURACAO').dataSourceFilter[ABUtilController.retornaFiltro(widget.getField('DSTIPOPERIODOAPURACAO').dataSourceFilter, 'NRTIPOVINCULOM')].value = args.row.NRTIPOVINCULOM;
            widget.getField('DSTIPOPERIODOAPURACAO').reload();
        }

    };
    
    /* jshint ignore:start */
    this.validaFiltro = async function (args) {
        // Caso parametros sejam passados via url, o comportamento do filtro deve ser sobrescrito
        const urlParamsApplied = await ABUtilController.urlParamsApplied();
        if (urlParamsApplied && this.trustContainerUrlParams) {
            return;
        }
        
        var filtro = args.e.preference.FILTER_ROW;
        if(!filtro.NRVINCULOM_LIST && !filtro.LIST_NRESTRUTLEGAL && !filtro.LIST_NRESTRUTGEREN){
            ScreenService.showMessage("Preencha pelo menos um dos três (Vínculo, Estrutura Legal, Estrutura Gerencial)").then(function(){
                if(args.dataSource.length > 0){
                    args.owner.dataSource.data = [];
                }
                ABUtilController.applyDefaultFilterOnEnter(args.owner);
            });
        }else{
            // Obtem widget
            var widget;
            if(Util.isUndefined(args.owner.widget)){
                widget = args.owner;
            } else {
                widget = args.owner.widget;
            }
            
            // Obtem row do filtro
            const filterRow = args.e.preference.FILTER_ROW;
            
            if(args.owner.name === 'resumosGeraisApuracaoDiario'){
                this.getResumosGeraisApuracaoDiario(widget, filterRow);
            }else if(args.owner.name === 'resumosGeraisApuracaoPeriodo'){
                this.getResumosGeraisApuracaoPeriodo(widget, filterRow);
            }
        }
    };
    /* jshint ignore:end */
    
    this.formatHoraDecimal = function(data) {
        var fields = {};
        var ignoreKeys = ['__notSelectable', '$$hashKey', '__isSelected', '__index', 'NRVINCULOM', 'NMVINCULOM', 'DSPERIODOAPURACAO', 
        'NRPERIODOAPURACAO', 'DTINICIALAPURACAO', 'DTFINALAPURACAO', 'DTAPURACAOSITUFREQ', 'DSTIPOPERIODOAPURACAO', 'NRTIPOPERIODOAPURACAO',
        'NRESTRUTGEREN', 'NMESTRUTGEREN', 'NRESTRUTGEREN__LABEL', 'NRESTRUTLEGAL', 'NRESTRUTLEGAL__LABEL', 'NRVINCULOM__LABEL', 'DSR_DESCONTADO', 'FALTAS_DIURNAS', 'FALTAS_NOTURNAS', 'FALTAS_TOTAL', 'NRPARCLIDER', 'NMPESSOA'];
        $.each(data, function(key, value) {
            if (ignoreKeys.indexOf(key) == -1)
                fields[key] = AFormataHoraDecimal.formataHoraDecimal(value);
            else
                fields[key] = value;
        });
        return fields;
    };

    this.getResumosGeraisApuracaoDiario = function(widget, filterRow) {
        const dados = Object.assign({}, filterRow, {"NRORGTRAB": getLocalVar("HCM_NRORG_TRAB")});
        return restEngine.post("product#/getResumosGeraisApuracaoDiario",
            {
                requestType: "DataSet",
                dataset: [dados]
            }
        ).then(function (data) {
            if (Util.isUndefined(data.dataset.getResumosGeraisApuracaoDiario) && !data.dataset.getResumosGeraisApuracaoDiario[0]) {
                ScreenService.showMessage("Erro ao buscar dados");
            } else {
                widget.dataSource.data = data.dataset.getResumosGeraisApuracaoDiario[0].map(this.formatHoraDecimal);
                widget.dataSourceFilter = [];
                widget.currentFiltro = filterRow;
            }
            widget.reload();     
        }.bind(this)
        ).catch(function(e) {
            var error;
            if(e.data.error === undefined)
                error = e;
            else  
                error = e.data.error;
            ScreenService.showMessage('Ocorreu um erro inesperado, contate o administrador informando o trecho abaixo: <br><br>' + error + '<br><br>', 'ERROR');
        });
    };

    this.getResumosGeraisApuracaoPeriodo = function(widget, filterRow) {
        const dados = Object.assign({}, filterRow, {"NRORGTRAB": getLocalVar("HCM_NRORG_TRAB")});
        return restEngine.post("product#/getResumosGeraisApuracaoPeriodo",
            {
                requestType: "DataSet",
                dataset: [dados]
            }
        ).then(function (data) {
            if (Util.isUndefined(data.dataset.getResumosGeraisApuracaoPeriodo) && !data.dataset.getResumosGeraisApuracaoPeriodo[0]) {
                ScreenService.showMessage("Erro ao buscar dados");
            } else {
                widget.dataSource.data = data.dataset.getResumosGeraisApuracaoPeriodo[0].map(this.formatHoraDecimal);
                widget.dataSourceFilter = [];
                widget.currentFiltro = filterRow;
            }
            widget.reload();     
        }.bind(this)
        ).catch(function(e) {
            var error;
            if(e.data.error === undefined)
                error = e;
            else  
                error = e.data.error;
            ScreenService.showMessage('Ocorreu um erro inesperado, contate o administrador informando o trecho abaixo: <br><br>' + error + '<br><br>', 'ERROR');
        });
    };
    
    this.getResumosGeraisApuracaoResponsavel = function(args) {
        var widget;
        if(Util.isUndefined(args.owner.widget)){
            widget = args.owner;
        } else {
            widget = args.owner.widget;
        }
        var widgetFiltro =args.e.preference.FILTER_ROW;
        dados = Object.assign({}, widgetFiltro, {"NRORGTRAB": getLocalVar("HCM_NRORG_TRAB")});
        return restEngine.post("product#/getResumosGeraisApuracaoResponsavel",
            {
                requestType: "DataSet",
                dataset: [dados]
            }
        ).then(function (data) {
            if (Util.isUndefined(data.dataset.getResumosGeraisApuracaoResponsavel) && !data.dataset.getResumosGeraisApuracaoResponsavel[0]) {
                ScreenService.showMessage("Erro ao buscar dados");
            } else {
                widget.dataSource.data = data.dataset.getResumosGeraisApuracaoResponsavel[0].map(this.formatHoraDecimal);
                widget.dataSourceFilter = [];
                widget.currentFiltro = widgetFiltro;
            }
            widget.reload();     
        }.bind(this)
        ).catch(function(e) {
            var error;
            if(e.data.error === undefined)
                error = e;
            else  
                error = e.data.error;
            
            if (e.data && e.data.errorCode === Messages.ERROR_MESSAGE_CODE) {
                ScreenService.showMessage(error, 'ERROR');
                return;
            }
            
            ScreenService.showMessage('Ocorreu um erro inesperado, contate o administrador informando o trecho abaixo: <br><br>' + error + '<br><br>', 'ERROR');
        });
    };
    
    /**
     *  Rotina que sobrescreve o comportamento 'applyDataSourceItemsDefaultCallback' padrao da rotina 'applyUrlParamsOnEnter'. Esse novo comportamento eh necessario devido ao dataSource das abas da tela 'Resumos Gerais da Apuração'.
     * 
     *  @param  dataSourceNewItems
     *  @param  widget              [Widget]
     * 
     */
    /* jshint ignore:start */
    this.applyDataSourceItemsDefaultCallback = async function(dataSourceNewItems, widget) {
        if (widget.name != 'resumosGeraisApuracaoPeriodo') {
            return;
        }
        
        const rowFromDataSourceFilter = ABUtilController.dataSourceFilterToRow(dataSourceNewItems);
        if (Util.isEmptyObject(rowFromDataSourceFilter)) {
            return;
        }
        
        self.trustContainerUrlParams = false;
        
        await self.getResumosGeraisApuracaoPeriodo(widget, rowFromDataSourceFilter);
        
        setTimeout(() => {
            ScreenService.closePopup();
        }, 3000);
    };
    /* jshint ignore:end */
}

Configuration(function(ContextRegister) {
    ContextRegister.register('ResumosGeraisApuracaoController', ResumosGeraisApuracaoController);
});

// FILE: assets/js/controllers/ReuniaoController.js
function ReuniaoController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, General, Messages) {

    this.objActions = {
        'cadastro_automatico': {
            'name': 'cadastro_automatico',
            'label': 'Cadastro Automático',
            'fields': [
                "NRPARCNEGOCIO_LIST",
                "IDPARTICIPCOMPARECEU"
            ],
            'nullable': []
        }
    };
    
    this.selectedAction = '';
    var geradeliberacao = false;
    var self = this;
    
    this.openPopupCadastroAutomatico = function(widget, action) {
        var widgetFilter = templateManager.container.getWidget('filterParticipantes');
        this.selectedAction = action;
        widgetFilter.label = this.objActions[action].label;
        var actionObj = this.objActions[action];
        widgetFilter.fields.forEach(function(field) {
            if (actionObj.fields.indexOf(field.name) >= 0) {
                widgetFilter.getField(field.name).isVisible = true;
                if (actionObj.nullable.indexOf(field.name) >= 0) {
                    widgetFilter.getField(field.name).validations = {};
                } else {
                    widgetFilter.getField(field.name).validations = {
                        "required": true
                    };
                }
            } else {
                widgetFilter.getField(field.name).isVisible = false;
            }
        });
        ABUtilController.masterDetailOpenPopup(widgetFilter);
    };

    this.cadastroAutomatico = function(widget) {
        var widgetmain = templateManager.container.getWidget("reuniao");
        if (widget.isValid()) {
            var action = this.selectedAction;
            widget.currentRow.action = this.selectedAction;
            widget.currentRow.NRREUNIAO = widgetmain.currentRow.NRREUNIAO;
            restEngine.post('product#/cadastroAutomaticoParticipanteReuniao', {
                'requestType': 'DataSet',
                'dataset': [widget.currentRow]
            }).
            then(function(data) {
                ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 1000);
                ABUtilController.masterDetailClosePopup(widget);
                widget.list();
                widget.reload();
            }).
            catch(function(e) {
                var error;
                if (e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
        }
    };

    this.adicionarRow = function(args) {
        var widget = args.owner.widget;
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
    };

    this.gerardeliberacao = function(args) {
        var widgetDeliberacao = templateManager.container.getWidget("deliberacao");
        widgetDeliberacao.backupRow = undefined;
        ScreenService.closeSwipe().then(function(callback) {
            widgetDeliberacao.activate();
            geradeliberacao = true;
        });
    };

    this.newRowGeraDeliberacao = function(args) {
        var widgetPauta = templateManager.container.getWidget("pauta");
        var widgetDeliberacao = templateManager.container.getWidget("deliberacao");
        if (geradeliberacao) {
            widgetDeliberacao.newRow();
            widgetDeliberacao.currentRow.NRORDEMITEM = widgetPauta.currentRow.NRORDEMITEM;
            widgetDeliberacao.currentRow.DSITEMREUNIAO = widgetPauta.currentRow.DSITEMREUNIAO;
            widgetDeliberacao.currentRow.NMPRINCIPALPARC = widgetPauta.currentRow.NMPRINCIPALPARC;
            widgetDeliberacao.currentRow.NRPARCNEGOCIO = widgetPauta.currentRow.NRPARCNEGOCIO;
        }
        geradeliberacao = false;
    };

    this.filtrarWidgetsPorReuniao = function(args) {
        var widget = args.owner;
        templateManager.container.getWidget("participareuniao").dataSourceFilter[2].value = widget.currentRow.NRREUNIAO;
        templateManager.container.getWidget("pauta").dataSourceFilter[2].value = widget.currentRow.NRREUNIAO;
        templateManager.container.getWidget("deliberacao").dataSourceFilter[2].value = widget.currentRow.NRREUNIAO;
    };

    this.widgetsvisiblefalse = function(args) {
        var widget = args.owner.widget;
        widget.widgets[0].showAsTab = false;
        if (widget.widgets.length > 1) {
            widget.widgets[1].showAsTab = false;
            widget.widgets[2].showAsTab = false;
        }
    };

    this.widgetsvisibletrue = function(args) {
        var widget = args.owner.widget;
        widget.widgets[0].showAsTab = true;
        if (widget.widgets.length > 1) {
            widget.widgets[1].showAsTab = true;
            widget.widgets[2].showAsTab = true;
        }
    };

    this.validaPeriodo = function(dtIni, dtFin) {
        if (moment(dtIni, 'DD/MM/YYYY').unix() > moment(dtFin, 'DD/MM/YYYY').unix() || moment(dtFin, 'DD/MM/YYYY').unix() < moment(dtIni, 'DD/MM/YYYY').unix()) {
            return false;
        } else {
            return true;
        }
    };

    this.setReuniao = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
            if (this.validaPeriodo(widget.currentRow.DTHRPREVINIREUNIAO, widget.currentRow.DTHRPREVFIMREUNIAO)) {
                if (this.validaPeriodo(widget.currentRow.DTHRINIREUNIAO, widget.currentRow.DTHRFIMREUNIAO)) {
                    if (!widget.backupRow) {
                        widget.currentRow.__is_new = true;
                    } else {
                        widget.currentRow.__is_new = false;
                    }
                    restEngine.post('product#/setReuniao', {
                        'requestType': 'DataSet',
                        'dataset': [widget.currentRow]
                    }).
                    then(function(data) {
                        if (data.notifications[0].type === "success") {
                            ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                            if (widget.currentRow.__is_new) {
                                ABUtilController.masterDetailVoltarList(widget);
                                self.widgetsvisibletrue(args);
                                widget.reload();
                            } else {
                                ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                                widget.backupRow = null;
                                widget.view();
                            }
                        } else {
                            ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                        }
                    }).
                    catch(function(e) {
                        var error;
                        if (e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;
                        ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    });
                } else {
                    ScreenService.showMessage(Messages.DTINI_POST_DTFIM_ERROR);
                    return false;
                }
            } else {
                ScreenService.showMessage(Messages.DTINI_POST_DTFIM_ERROR);
                return false;
            }
        }
    };

    this.deleteReuniao = function(args) {
        ScreenService.confirmMessage(Messages.DELETE_ROW, 'CONFIRMATION',
            function() {
                var widget = templateManager.container.getActiveWidget();
                if (widget.isValid()) {
                    widget.currentRow.__is_new = false;
                    restEngine.post('product#/deleteReuniao', {
                        'requestType': 'DataSet',
                        'dataset': [widget.currentRow]
                    }).
                    then(function(data) {
                        if (data.messages) {
                            ScreenService.showMessage(Messages.REMOVE_ROW_ERROR + '. ' + data.messages[0].message, data.messages[0].type);
                        } else {
                            ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                            ABUtilController.masterDetailVoltarList(widget);
                            widget.reload();
                        }
                    }).
                    catch(function(e) {
                        var error;
                        if (e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;

                        ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    });
                }
            });
    };

    this.setParticipaReuniao = function(args) {
        var widget = args.owner.widget;
        var widgetMain = templateManager.container.getWidget("reuniao");
        if (widget.isValid()) {
            if (!widget.backupRow) {
                widget.currentRow.__is_new = true;
            } else {
                widget.currentRow.__is_new = false;
            }
            widget.currentRow.NRREUNIAO = widgetMain.currentRow.NRREUNIAO;
            restEngine.post('product#/setParticipaReuniao', {
                'requestType': 'DataSet',
                'dataset': [widget.currentRow]
            }).
            then(function(data) {
                if (data.messages) {
                    ScreenService.showMessage('Esse Participante já está cadastrado');
                } else {
                    if (data.notifications[0].type === "success") {
                        ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                        if (widget.currentRow.__is_new) {
                            ABUtilController.masterDetailVoltarList(widget);
                            widget.reload();
                        } else {
                            ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                            widget.backupRow = null;
                            widget.view();
                        }
                    } else {
                        ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                    }
                }
            }).
            catch(function(e) {
                var error;
                if (e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
        }
    };

    this.deleteParticipaReuniao = function(args) {
        var widget = args.owner.widget;
        ScreenService.confirmMessage(Messages.DELETE_ROW, 'CONFIRMATION',
            function() {
                widget.currentRow.__is_new = false;
                restEngine.post('product#/deleteParticipaReuniao', {
                    'requestType': 'DataSet',
                    'dataset': [widget.currentRow]
                }).then(function(data) {
                        if (data.notifications[0].type === "success") {
                            ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                            ABUtilController.masterDetailVoltarList(widget);
                            widget.reload();
                        } else {
                            ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                        }
                    }).catch(function(e) {
                        var error;
                        if (e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;
                        ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    });
            });
    };

    this.setReuniaoItem = function(args) {
        var widget = args.owner.widget;
        var widgetMain = templateManager.container.getWidget("reuniao");
        if (widget.isValid()) {
            if (!widget.backupRow) {
                widget.currentRow.__is_new = true;
            } else {
                widget.currentRow.__is_new = false;
            }
            widget.currentRow.NRREUNIAO = widgetMain.currentRow.NRREUNIAO;
            restEngine.post('product#/setReuniaoItem', {
                'requestType': 'DataSet',
                'dataset': [widget.currentRow]
            }).
            then(function(data) {
                if (data.notifications[0].type === "success") {
                    ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                    if (widget.currentRow.__is_new) {
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    } else {
                        ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                        widget.backupRow = null;
                        widget.view();
                    }
                } else {
                    ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                }
            }).
            catch(function(e) {
                var error;
                if (e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
        }
    };

    this.deleteReuniaoItem = function(args) {
        var widget = templateManager.container.getActiveWidget();
        ScreenService.confirmMessage(Messages.DELETE_ROW, 'CONFIRMATION',
            function() {    
                if (widget.isValid()) {
                    widget.currentRow.__is_new = false;
                    restEngine.post('product#/deleteReuniaoItem', {
                        'requestType': 'DataSet',
                        'dataset': [widget.currentRow]
                    }).
                    then(function(data) {
                        if (data.messages) {
                            ScreenService.showMessage(Messages.REMOVE_ROW_ERROR + '. ' + data.messages[0].message, data.messages[0].type);
                        } else {
                            ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                            ABUtilController.masterDetailVoltarList(widget);
                            widget.reload();
                        }
                    }).
                    catch(function(e) {
                        var error;
                        if (e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;
        
                        ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    });
                }
            });
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('ReuniaoController', ReuniaoController);
});


// FILE: assets/js/controllers/RiscoAmbienteController.js
function RiscoAmbienteController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, General, Messages) {

    this.adicionarRow = function(args) {
        var widget = args.owner.widget;
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
    };

    this.setRiscoAmbiente = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
            if (!widget.backupRow) {
                widget.currentRow.__is_new = true;
            } else {
                widget.currentRow.__is_new = false;
            }
            restEngine.post('product#/setFatorRiscAmb', {
                'requestType': 'DataSet',
                'dataset': [widget.currentRow]
            }).
            then(function(data) {
                if (data.notifications[0].type === "success") {
                    ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                    if (widget.currentRow.__is_new) {
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    } else {
                        ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                        widget.backupRow = null;
                        widget.view();
                    }
                } else {
                    ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                }
            }).
            catch(function(e) {
                var error;
                if (e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
        }
    };

    this.deleteRiscoAmbiente = function(args) {
    ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
        var widget = args.owner.widget;
        widget.currentRow.__is_new = false;
        restEngine.post('product#/deleteFatorRiscAmb', {
            'requestType': 'DataSet',
            'dataset': [widget.currentRow]
        }).
        then(function(data) {
            if (data.notifications[0].type === "success") {
                ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                ABUtilController.masterDetailVoltarList(widget);
                widget.reload();
            } else {
                ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
            }
        }).
        catch(function(e) {
            var error;
            if (e.data.error === undefined)
                error = e;
            else
                error = e.data.error;
            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
          });
        }, null);
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('RiscoAmbienteController', RiscoAmbienteController);
});


// FILE: assets/js/controllers/RoteiroParamFrequenciaController.js
/* jshint esversion: 6 */
function RoteiroParamFrequenciaController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, General, Messages, HcmConsts, $window) {

    this.mainContainerName  = 'hcm07031_pto_roteiroParamFrequencia';
    this.step0WidgetName    = 'roteiroParamFrequencia_step0';
    this.step1WidgetName    = 'roteiroParamFrequencia_step1';
    this.step2WidgetName    = 'roteiroParamFrequencia_step2';
    this.step3WidgetName    = 'roteiroParamFrequencia_step3';
    this.step4WidgetName    = 'roteiroParamFrequencia_step4';
    
    const self = this;
    
    this.saveRoteiroParamFrequenciaOnClick = function(row, wizardCleanRows = function () {}) {
        ScreenService.showCustomDialog('Deseja realmente finalizar a realização do processo?', 'CONFIRMATION', null, [
            {
                label: ScreenService.i18n("Sim"),
                code: function () {
                    self.saveRoteiroParamFrequencia(row, wizardCleanRows);
                }
            },
            {
                label: ScreenService.i18n("Não"),
                code: function () {}
            }
        ]);
    };
    
    /* jshint ignore:start */
    this.saveRoteiroParamFrequencia = async function(row, wizardCleanRows = function () {}) {
        try {
            const response = await restEngine.post('product#/setRoteiroParamFrequencia', {
                'requestType': 'Row',
                row
            });
            
            if (response.messages) {
                const message = response.messages[0].message;
                ScreenService.showMessage(message);
                return;
            }
            
            const success = response.dataset.data && response.dataset.data.success;
            if (success) {
                ScreenService.showMessage('A parametrização foi realizada com sucesso!<br><br>A partir de agora, a apuração dos colaboradores informados considerará os parâmetros informados. É possível alterar as informações cadastradas dentro das telas do módulo a qualquer momento.', 'SUCCESS');
                wizardCleanRows(this.mainContainerName);
                ABUtilController.voltarDashboard();
                return;
            }
            
            ScreenService.errorNotification(Messages.SAVE_ROW_ERROR);
        } catch (e) {
            const message = e.data ? e.data.error : 'Não foi possível realizar a parametrização';
            ScreenService.showMessage('A parametrização foi cancelada devido à erros insesperados. Contate o administrador informando o trecho abaixo: <br><br>' + message + '<br><br>', 'ERROR');
        }
    };
    /* jshint ignore:end */
    
    this.buttonParamBancoHorasOnClick = function(args) {
        const fieldsLinked = ['DTINICIOPERIODOBHORAS', 'DTFIMPERIODOBHORAS', 'ADD_PERIODO_BUTTON'];
        const widget = args.owner.owner.getParent();
        const blockFields = widget.currentRow.CRIA_PARAM_BANCOHORA ? widget.currentRow.CRIA_PARAM_BANCOHORA == 'N' : false;
        
        for (const fieldName of fieldsLinked) {
            const field = widget.getField(fieldName);
            field.readOnly = blockFields;
        }
    };
    
    this.validationsStep1 = function(isWidgetValid, stageRow, fullRow, preventDefault, widgets) {
        const atLeastOneRequired = ['NMTIPOVINCULOH', 'NRVINCULOM_LIST', 'NRESTRUTLEGAL_LIST', 'NRESTRUTGEREN_LIST', 'NRESTRUTSIND_LIST'];
        if (!ABUtilController.checkAtLeastOneRequired(widgets[0], atLeastOneRequired, true)) {
            preventDefault();
            return false;
        }
        return true;
    };
    
    this.validationsStep2 = function(isWidgetValid, stageRow, fullRow, preventDefault, widgets) {
        if (!ABUtilController.checkFieldDatesGraterEqualThan(widgets[0], 'DTFIMBANCOHORAS', 'DTINICIOBANCOHORAS')) {
            preventDefault();
            return false;
        }
        return true;
    };
    
    this.validationsOnAddPeriodoStep3 = function(currentRow, widget) {
        return ABUtilController.checkFieldDatesGraterEqualThan(widget, 'DTFIMPERIODOBHORAS', 'DTINICIOPERIODOBHORAS');
    };
    
}
 
Configuration(function(ContextRegister) {
    ContextRegister.register('RoteiroParamFrequenciaController', RoteiroParamFrequenciaController);
});

// FILE: assets/js/controllers/RoteiroUsoFrequenciaController.js
/* jshint esversion: 6 */
function RoteiroUsoFrequenciaController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, General, Messages, HcmConsts, $window) {
    
    this.MAIN_WIDGET_NAME = 'roteiroUsoFrequenciaPeriodo';
    
    this.ACTION_REDIRECTON = {
        ACTION_PASSO_1: {
            staticParams: {},
        },
        ACTION_PASSO_2: {
            staticParams: {
                TIPO_OCORRENCIA: ['ABONO'],
            },
        },
        ACTION_PASSO_3: {
            staticParams: {
                TIPO_OCORRENCIA: ['FALTA', 'ATRASO'],
            },
        },
        ACTION_PASSO_4: {
            staticParams: {
                TIPO_OCORRENCIA: ['QTD_MARCACAOES_IMPAR'],
            },
        },
        ACTION_PASSO_5: {
            staticParams: {
                TIPO_OCORRENCIA: ['INTERJORNADA'],
            },
        },
        ACTION_PASSO_6: {
            staticParams: {
                TIPO_OCORRENCIA: ['INTRAJORNADA'],
            },
        },
        ACTION_PASSO_7: {
            staticParams: {
                TIPO_OCORRENCIA: ['EXTRA'],
            },
        },
        ACTION_PASSO_8: {
            staticParams: {},
        },
        ACTION_PASSO_9: {
            rowParams: ['NRTIPOVINCULOM'],
            staticParams: {},
        },
        ACTION_PASSO_11: {
            notUseDefaultParams: true,
            evalParams: {
                DSLOTELANCEVENTO: 'this.DTINICIALAPURACAO + " - " + this.DTFINALAPURACAO',
            },
        },
        DEFAULT: {
            defaultParams: {},
        },
        ALL_ACTIONS: {
            rowParams: ['NRPERIODOAPURACAO', 'DSPERIODOAPURACAO'],
            evalParams: {},
        },
    };

    /* jshint ignore:start */
    this.openNewTabRUF = async function (args) {
        const widget = ABUtilController.checkWidget(args);
        const currentRow = args.row;
        const mainWidget = templateManager.container.getWidget(this.MAIN_WIDGET_NAME);
        
        const compactRow = {
            NRPASSOSUSOFREQ: currentRow.NRPASSOSUSOFREQ,
            NRPERIODOAPURACAO: mainWidget.currentRow.NRPERIODOAPURACAO,
        };
        
        const isDtUltOperSinronized = await this.setUsoFreqDataUltOper(compactRow);
        if (!isDtUltOperSinronized) {
            return;
        }
        
        const configActionName = 'ACTION_PASSO_' + currentRow.NRPASSOSUSOFREQ;
        
        const actionRedirectionInfo = this.ACTION_REDIRECTON[configActionName] || this.ACTION_REDIRECTON.DEFAULT;
        if (!actionRedirectionInfo) {
            return;
        }
        
        const redirectInfo = {
            container: currentRow.DSREDIRECT,
            widget: currentRow.DSREDIRECTSECTION,
        };
        
        /* Obtem parametros da Row */
        
        const defaultRowParams = actionRedirectionInfo.notUseDefaultParams ? [] : this.ACTION_REDIRECTON.ALL_ACTIONS.rowParams;
        const rowParams = [ ...(actionRedirectionInfo.rowParams ? actionRedirectionInfo.rowParams : []), ...defaultRowParams ];
        
        let paramsNewTab = { widget: redirectInfo.widget };
        for (const param of rowParams) {
            paramsNewTab[param] = mainWidget.currentRow[param];
        }
        
        /* Obtem parametros a serem calculados dinamicamente */
        
        const defaultEvalParams = actionRedirectionInfo.notUseDefaultParams ? {} : this.ACTION_REDIRECTON.ALL_ACTIONS.evalParams;
        const evalParams = { ...(actionRedirectionInfo.evalParams ? actionRedirectionInfo.evalParams : {}), ...defaultEvalParams };
        
        for (const evalParamName in evalParams) {
            paramsNewTab[evalParamName] = ABUtilController.scopeEval(mainWidget.currentRow, evalParams[evalParamName]);
        }
        
        paramsNewTab = { ...paramsNewTab, ...actionRedirectionInfo.staticParams };
        
        ABUtilController.openNewTab(redirectInfo.container, paramsNewTab);
        
        if (widget.inViewMode()) {
            ScreenService.goBack();
        }
        
        widget.reload();
    };
    /* jshint ignore:end */
    
    /* jshint ignore:start */
    this.setUsoFreqDataUltOper = async function(row) {
        try {
            const response = await restEngine.post('product#/setUsoFreqDataUltOper', {
                'requestType': 'Row',
                row
            });
            
            if (response.messages) {
                const message = response.messages[0].message;
                ScreenService.showMessage(message);
                return false;
            }
            
            const success = response.dataset.data && response.dataset.data.success;
            if (success) {
                return true;
            }
            
            ScreenService.errorNotification('Não foi possível sincronizar a última operação realizada. Por favor, tente novamente mais tarde.');
            return false;
        } catch (e) {
            const message = e.data ? e.data.error : 'Não foi possível sincronizar a última operação realizada. Por favor, tente novamente mais tarde.';
            ScreenService.showMessage('A parametrização foi cancelada devido à erros insesperados. Contate o administrador informando o trecho abaixo: <br><br>' + message + '<br><br>', 'ERROR');
        }
    };
    /* jshint ignore:end */
}
 
Configuration(function(ContextRegister) {
    ContextRegister.register('RoteiroUsoFrequenciaController', RoteiroUsoFrequenciaController);
});

// FILE: assets/js/controllers/SEFIPController.js
function SEFIPController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, General, Messages) {

    var self = this;

    this.mudarVisibilidadeWidgets = function(widgets, value) {
        widgets.forEach(function(widget) {
            widget.isVisible = value;
        });
    };

    this.adicionarRow = function(args) {
        var widget = args.owner.widget;
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
    };
    
    this.geraSEFIP = function(args) {
        var widget = ABUtilController.checkWidget(args);
        ScreenService.confirmMessage('Deseja realmente gerar a SEFIP competência mensal?', 'CONFIRMATION', 
            function(){
                widget.currentRow.TP_PROCESSAMENTO = 'COMPETENCIA_MENSAL';
                restEngine.post("product#/geraSEFIP",
                        {'requestType':'DataSet','dataset':[widget.currentRow]},
                    function(data) {
                            if(data.dataset && data.dataset.arquivo){
                                ABUtilController.downloadArquivo(data.dataset.arquivo.NMARQUIVO);
                            }
                            if(data.messages){
                                if(data.messages[0].message.substring(0,4) == "http"){
                                    window.open(data.messages[0].message);
                                    if(data.messages[1]){
                                        ScreenService.successNotification(data.messages[1].message);
                                        ScreenService.closePopup();    
                                    }
                                } else {
                                    ScreenService.successNotification(data.messages[0].message);
                                    ScreenService.closePopup();
                                }
                            }
                            if(data.dataset && data.dataset.msgCalculo && data.dataset.msgCalculo.length > 0){
                                var popUp = templateManager.container.getWidget("mensagens");
                                popUp.dataSource.data = data.dataset.msgCalculo;
                                ABUtilController.masterDetailOpenPopup(popUp);
                            }
                            if(data.error){
                                ScreenService.errorNotification(data.error);
                                ScreenService.closePopup();
                            }
                        }.bind(this),undefined,
                    function(e) {
                        var error;
                        if(e.data.error === undefined)
                            error = e;
                        else 
                            error = e.data.error;
                        ScreenService.showMessage(error, 'ALERT');
                    }
                );
            }.bind(this)
        );
    };
    
    this.geraSEFIP13 = function(args) {
        var widget = ABUtilController.checkWidget(args);
        ScreenService.confirmMessage('Deseja realmente gerar a SEFIP competência 13º ?', 'CONFIRMATION', 
            function(){
                widget.currentRow.TP_PROCESSAMENTO = 'COMPETENCIA_13';
                restEngine.post("product#/geraSEFIP",
                        {'requestType':'DataSet','dataset':[widget.currentRow]},
                    function(data) {
                            if(data.dataset && data.dataset.arquivo){
                                ABUtilController.downloadArquivo(data.dataset.arquivo.NMARQUIVO);
                            }
                            if(data.messages){
                                if(data.messages[0].message.substring(0,4) == "http"){
                                    window.open(data.messages[0].message);
                                    if(data.messages[1]){
                                        ScreenService.successNotification(data.messages[1].message);
                                        ScreenService.closePopup();    
                                    }
                                } else {
                                    ScreenService.showMessage(data.messages[0].message, data.messages[0].type);
                                    ScreenService.closePopup();
                                }
                            }
                            if(data.dataset && data.dataset.msgCalculo && data.dataset.msgCalculo.length > 0){
                                var popUp = templateManager.container.getWidget("mensagens");
                                popUp.dataSource.data = data.dataset.msgCalculo;
                                ABUtilController.masterDetailOpenPopup(popUp);
                            }
                        }.bind(this),undefined,
                    function(e) {
                        var error;
                        if(e.data.error === undefined)
                            error = e;
                        else 
                            error = e.data.error;
                        ScreenService.showMessage(error, 'ALERT');    
                    }
                );
            }.bind(this)
        );
    };
    
    this.retrocede = function(args) {
        var widget = ABUtilController.checkWidget(args);
        ScreenService.confirmMessage('Deseja realmente retroceder a SEFIP ?', 'CONFIRMATION', 
            function(){
                widget.currentRow.TP_PROCESSAMENTO = 'RETROCESSO';
                restEngine.post("product#/geraSEFIP",
                        {'requestType':'DataSet','dataset':[widget.currentRow]},
                    function(data) {
                            if(data.dataset && data.dataset.arquivo){
                                ABUtilController.downloadArquivo(data.dataset.arquivo.NMARQUIVO);
                            }
                            if(data.messages){
                                ScreenService.successNotification(data.messages[0].message);
                                ScreenService.closePopup();
                            }
                            if(data.dataset && data.dataset.msgCalculo && data.dataset.msgCalculo.length > 0){
                                var popUp = templateManager.container.getWidget("mensagens");
                                popUp.dataSource.data = data.dataset.msgCalculo;
                                ABUtilController.masterDetailOpenPopup(popUp);
                            }
                        }.bind(this),undefined,
                    function(e) {
                        var error;
                        if(e.data.error === undefined)
                            error = e;
                        else 
                            error = e.data.error;
                        ScreenService.showMessage('Ocorreu um erro inesperado, contate o administrador informando o trecho abaixo: <br><br>' + error + '<br><br>', 'ERROR');
                    }
                );
            }.bind(this)
        );
    };

    this.setSEFIP = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
            if (!widget.backupRow) {
                widget.currentRow.__is_new = true;
            } else {
                widget.currentRow.__is_new = false;
            }
            restEngine.post('product#/setSEFIP', {
                'requestType': 'DataSet',
                'dataset': [widget.currentRow]
            }).
            then(function(data) {
                if (data.notifications[0].type === "success") {
                    ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                    if (widget.currentRow.__is_new) {
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    } else {
                        widget.backupRow = null;
                        widget.view();
                    }
                    self.mudarVisibilidadeWidgets(widget.widgets, true);
                } else {
                    ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                }
            }).
            catch(function(e) {
                var error;
                if (e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;

                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });

        }
    };

    this.deleteSEFIP = function(args) {
        var widget = args.owner.widget;
        ScreenService.confirmMessage(Messages.DELETE_ROW, 'CONFIRMATION',
            function() {
                restEngine.post('product#/deleteSEFIP', {
                    'requestType': 'DataSet',
                    'dataset': [widget.currentRow]
                }).
                then(function(data) {
                    if (data.notifications[0].type === "success") {
                        ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    } else {
                        ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                    }
                }).
                catch(function(e) {
                    var error;
                    if (e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;

                    ScreenService.showMessage(error, 'ERROR');
                });
            }
        );
    };

}

Configuration(function(ContextRegister) {
    ContextRegister.register('SEFIPController', SEFIPController);
});


// FILE: assets/js/controllers/SentidodalinhaController.js
function SentidodalinhaController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, Messages) {

    this.salvarSentidodalinha = function(args) {
        var widget = templateManager.container.getActiveWidget();
        if (widget.isValid()) {
            if (!widget.backupRow) {
                widget.currentRow.__is_new = true;
            } else {
                widget.currentRow.__is_new = false;
            }
            restEngine.post('product#/setSentidolinha', {
                'requestType': 'DataSet',
                'dataset': [widget.currentRow]
            }).
            then(function(data) {
                if (data.notifications[0].type === "success") {
                    ScreenService.successNotification('Sentido da linha salvo com sucesso', 10000);
                    if (widget.currentRow.__is_new) {
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    } else {
                        ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                        widget.backupRow = null;
                        widget.view();
                    }
                } else {
                    ScreenService.showMessage('Erro ao salvar o sentido da linha');
                }
            }).
            catch(function(e) {
                var error;
                if (e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;

                ScreenService.showMessage('Ocorreu um erro inesperado, contate o administrador informando o trecho abaixo: <br><br>' + error + '<br><br>', 'ERROR');
            });
        }
    };

    this.removerSentidodalinha = function(args) {
        ScreenService.confirmMessage(Messages.DELETE_ROW, 'CONFIRMATION',
            function() {
        
        var widget = templateManager.container.getActiveWidget();
        widget.currentRow.__is_new = false;
        restEngine.post('product#/deleteSentidolinha', {
            'requestType': 'DataSet',
            'dataset': [widget.currentRow]
        }).
        then(function(data) {
            if (data.notifications[0].type === "success") {
                ScreenService.successNotification('Sentido da linha excluído com sucesso', 10000);
                ABUtilController.masterDetailVoltarList(widget);
                widget.reload();
            } else {
                ScreenService.showMessage('Erro ao excluir o sentido da linha');
            }
        }).
        catch(function(e) {
            var error;
            if (e.data.error === undefined)
                error = e;
            else
                error = e.data.error;

            ScreenService.showMessage('Ocorreu um erro inesperado, contate o administrador informando o trecho abaixo: <br><br>' + error + '<br><br>', 'ERROR');
        });
    
            });
    };

}

Configuration(function(ContextRegister) {
    ContextRegister.register('SentidodalinhaController', SentidodalinhaController);
});


// FILE: assets/js/controllers/ServicoPATController.js
function ServicoPATController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, General,Messages) {
    
    var self = this;
    
    this.adicionarRow = function(args) {
        var widget = args.owner.widget;
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
    };
    
    this.adicionarRowVinculo = function(args) {
        var widget = args.owner.widget;
        var widgetMain = templateManager.container.getWidget("servpat");
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
        widget.currentRow.DSTIPOSERVPAT = widgetMain.currentRow.DSTIPOSERVPAT;
        widget.currentRow.NRTIPOSERVPAT = widgetMain.currentRow.NRTIPOSERVPAT;
    };
    
    this.filtrarWidgetPorServicoPAT = function(args){
        var widget = args.owner;
        templateManager.container.getWidget("vincPAT").dataSourceFilter[0].value = widget.currentRow.NRTIPOSERVPAT;
    };
    
    this.widgetsvisiblefalse = function(args) {
        var widget = args.owner.widget;
        widget.widgets[0].showAsTab = false;
    };

    this.widgetsvisibletrue = function(args) {
        var widget = args.owner.widget;
        widget.widgets[0].showAsTab = true;
    };
    
	this.setServicoPAT = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
            if (ABUtilController.validaDtIniMenorIgualDtFin(widget.currentRow.DTINIVIGENCIA, widget.currentRow.DTFIMVIGENCIA)) {
                if (!widget.backupRow) {
                    widget.currentRow.__is_new = true;
                } else {
                    widget.currentRow.__is_new = false;
                }
                restEngine.post('product#/setServicoPAT', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                    then(function (data) {
                        if (data.notifications[0].type === "success") {
                            ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                            if (widget.currentRow.__is_new) {
                                ABUtilController.masterDetailVoltarList(widget);
                                self.widgetsvisibletrue(args);
                                widget.reload();
                            } else {
                                ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                                widget.backupRow = null;
                                widget.view();
                            }
                        } else {
                            ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                        }
                    }).
                    catch(function(e) {
                        var error;
                        if(e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;
                            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    });
            }else{
                ScreenService.showMessage(Messages.DTINI_POST_DTFIM_ERROR);
                return false;
            }        
        }
    };
    
    this.deleteServicoPAT = function(args) {
    ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
        var widget = templateManager.container.getActiveWidget();
        if (widget.isValid()) {
            widget.currentRow.__is_new = false;
            restEngine.post('product#/deleteServicoPAT', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                then(function (data) {
                    if (data.messages) {
                        ScreenService.showMessage(Messages.REMOVE_ROW_ERROR + '. ' + data.messages[0].message, data.messages[0].type);
                    } else {
                        ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    }
                }).
                catch(function(e) {
                    var error;
                    if(e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;

                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
            }
        }, null);
    };
    
	this.setVinculoPAT = function(args) {
        var widget = args.owner.widget;
        var widgetMain = templateManager.container.getWidget("servpat");
        if (widget.isValid()) {
                if (!widget.backupRow) {
                    widget.currentRow.__is_new = true;
                } else {
                    widget.currentRow.__is_new = false;
                }
                widget.currentRow.NRTIPOSERVPAT = widgetMain.currentRow.NRTIPOSERVPAT;
                restEngine.post('product#/setVinculoPAT', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                    then(function (data) {
                        if(data.messages){
                            ScreenService.showMessage(data.messages[0].message);
                        }else{
                            if (data.notifications[0].type === "success") {
                                ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                                if (widget.currentRow.__is_new) {
                                    ABUtilController.masterDetailVoltarList(widget);
                                    widget.reload();
                                } else {
                                    ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                                    widget.backupRow = null;
                                    widget.view();
                                }
                            } else {
                                ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                            }
                        }    
                    }).
                    catch(function(e) {
                        var error;
                        if(e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;
                            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    });
        }
    };
    
    this.deleteVinculoPAT = function(args) {
        var widget = args.owner.widget;
        widget.currentRow.__is_new = false;
        restEngine.post('product#/deleteVinculoPAT', {'requestType':'DataSet','dataset':[widget.currentRow]}).
            then(function(data){
                if(data.notifications[0].type === "success"){
                    ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                    ABUtilController.masterDetailVoltarList(widget);
                    widget.reload();
                } else {
                    ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                }
            }).
            catch(function(e) {
                var error;
                if(e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('ServicoPATController', ServicoPATController);
});

// FILE: assets/js/controllers/SimulacaoController.js
function SimulacaoController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, Messages) {

    this.setValuesFilter = function(args){
        var widgetSimulacao = ABUtilController.checkWidget(args);
        var widgetIntervalo = templateManager.container.getWidget("intervalos");
        var widgetRegistro = templateManager.container.getWidget("registroPonto");
        var widgetTotalizacao = templateManager.container.getWidget("totalizacao");
        widgetTotalizacao.dataSourceFilter.forEach(function(filter){
            if(filter.name === 'NRVINCULOM'){
                filter.value = widgetSimulacao.currentRow.NRVINCULOM;
            }

            if(filter.name === 'DATA'){
                filter.value = widgetSimulacao.currentRow.DATA;
            }
        });
        widgetTotalizacao.reload();

        widgetIntervalo.dataSourceFilter.forEach(function(filter){
            if(filter.name === 'NRVINCULOM'){
                filter.value = widgetSimulacao.currentRow.NRVINCULOM;
            }

            if(filter.name === 'DATA'){
                filter.value = widgetSimulacao.currentRow.DATA;
            }
        });
        widgetIntervalo.reload();

        widgetRegistro.dataSourceFilter.forEach(function(filter){
            if(filter.name === 'NRVINCULOM'){
                filter.value = widgetSimulacao.currentRow.NRVINCULOM;
            }

            if(filter.name === 'DATA'){
                filter.value = widgetSimulacao.currentRow.DATA;
            }
        });
        widgetRegistro.reload();
    };

    this.efetivarApuracao = function(args){
        var widget = ABUtilController.checkWidget(args);
        ScreenService.confirmMessage('Deseja realmente efetivar apuração?', 'CONFIRMATION', 
            function(){
                var saveData = Object.assign({}, widget.currentRow, {
                        "NRORGTRAB": getLocalVar("HCM_NRORG_TRAB")
                    }, {
                        "DTCOMPETENCIA": getLocalVar("HCM_DTCOMPETENCIA_OPER")
                    }, {
                        "NRORGPADRAO": getLocalVar("HCM_NRORG_PADRAO")
                    });
                restEngine.post("product#/efetivarApuracaoSimulacao",
                        {'requestType':'DataSet','dataset':[saveData]}
                    ).then(function(data) {
                            if (Util.isEmptyOrBlank(data.messages[0].variables)) {
                                data.messages.forEach(function(mensagem){
                                    ScreenService.showMessage('Erro ao efetivar apuração: <br>' + mensagem.message);
                                });
                            } else {
                                data.messages.forEach(function(mensagem){
                                    ScreenService.showMessage('Apuração realizada com sucesso: <br>' + mensagem.message);
                                    ScreenService.openWindow('product#hcm07022_pto_apuracaoFrequencia');
                                });    
                                
                            }
                        }
                    ).catch(function(e) {
                        var error;
                        if(e.data.error === undefined)
                            error = e;
                        else 
                            error = e.data.error;
                        
                        ScreenService.showMessage('Ocorreu um erro inesperado, contate o administrador informando o trecho abaixo: <br><br>' + error + '<br><br>', 'ERROR');
                    });
            }.bind(this));
    };
   
}

Configuration(function(ContextRegister) {
    ContextRegister.register('SimulacaoController', SimulacaoController);
});

// FILE: assets/js/controllers/SituacaoEventoController.js
function SituacaoEventoController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, General,Messages) {

    this.adicionarRow = function(args) {
        var widget = args.owner.widget;
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
    };

	this.setSituacaoEvento = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
                if (!widget.backupRow) {
                    widget.currentRow.__is_new = true;
                } else {
                    widget.currentRow.__is_new = false;
                }
                restEngine.post('product#/setSituacaoEvento', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                    then(function (data) {
                        if (data.notifications[0].type === "success") {
                            ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                            if (widget.currentRow.__is_new) {
                                ABUtilController.masterDetailVoltarList(widget);
                                widget.reload();
                            } else {
                                ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                                widget.backupRow = null;
                                widget.view();
                            }
                        } else {
                            ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                        }
                    }).
                    catch(function(e) {
                        var error;
                        if(e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;
                            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    });
            }
    };
    
    this.deleteSituacaoEvento = function(args) {
    ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
        var widget = args.owner.widget;
        widget.currentRow.__is_new = false;
        restEngine.post('product#/deleteSituacaoEvento', {'requestType':'DataSet','dataset':[widget.currentRow]}).
            then(function(data){
                if(data.notifications[0].type === "success"){
                    ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                    ABUtilController.masterDetailVoltarList(widget);
                    widget.reload();
                } else {
                    ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                }
            }).
            catch(function(e) {
                var error;
                if(e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
        }, null);
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('SituacaoEventoController', SituacaoEventoController);
});

// FILE: assets/js/controllers/SituacaoFrequenciaController.js
/* jshint esversion: 6 */

function SituacaoFrequenciaController (ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, $window, ABUtilController, Messages) {
    this.deleteSituacaoFrequencia = function(args) {
        var widget = ABUtilController.checkWidget(args);
        var data = {}; 
        ScreenService.confirmMessage(Messages.DELETE_ROW, 'CONFIRMATION', 
            function(){
                widget.dataSource.remove(widget.currentRow).then(function (data){
                    if(data.dataset.ptoSituFreqParam_setSituacaoFrequencia.type === "success" && data.dataset.ptoSituFrequencia_setSituacaoFrequencia.type === "success"){
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                        ScreenService.showMessage(Messages.REMOVE_ROW_SUCCESS); 
                    } else {
                        ScreenService.showMessage(Messages.REMOVE_ROW_ERROR); 
                    }
                });
            }.bind(this)
        );
    };

    this.salvarSituacaoFrequencia = function(argsRow){
        var widget = templateManager.container.getWidget("situacaoFrequencia");
        if(widget.isValid())  {
            if (!widget.backupRow) {
                widget.currentRow.__is_new = true;
            } else {
                widget.currentRow.__is_new = false;
            }
            widget.currentRow.CDOPERADOR_LOG = getLocalVar("HCM_CDOPERADOR");
            widget.currentRow.NRORGTRAB = getLocalVar("HCM_NRORG_TRAB");
            widget.currentRow.NRORGPADRAO = getLocalVar("HCM_NRORG_PADRAO");
            widget.currentRow.DTATUAL = getLocalVar("HCM_DATA_ATUAL");
            return widget.saveRow().then(function (data){
                if (data.notifications[0].type === "success") {
                    ScreenService.showMessage(Messages.SAVE_ROW_SUCCESS);
                    ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                    if (widget.currentRow.__is_new) {
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    } else {
                        widget.backupRow = null;
                        widget.view();
                    }
                } else {
                    ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                }
            }).catch(function(e) {
                var error;
                if(e.data.error === undefined)
                    error = e;
                else 
                    error = e.data.error;
                
                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error));
            });
        }
    };

    this.setColor = function(row, element, widget){
        if(templateManager.container.getWidget(widget).mode == "list"){ 
            element.css("color", row.DSCORHEXADECIMAL ? row.DSCORHEXADECIMAL : "");
        }
    };
    
    this.parametrosSituacaoFrequenciaNewRow = function() {
        var parametrosSituFreqWidget = templateManager.container.getWidget("parametrosSituacaoFrequencia");
        
        ABUtilController.masterDetailNewRow(parametrosSituFreqWidget);
        parametrosSituFreqWidget.currentRow.NRSITUFREQUENCIA = this.getCurrentNrSituacaoFrequencia();
        parametrosSituFreqWidget.currentRow.NRORG = getLocalVar('HCM_NRORG_TRAB');
    };
    
    this.getCurrentNrSituacaoFrequencia = function() {
        var situFreqWidget = templateManager.container.getWidget("situacaoFrequencia");
        return parseInt(situFreqWidget.currentRow.NRSITUFREQUENCIA, 10);
    };
    
    this.setParamentrosSituacaoFrequenciaFilter = function() {
        var parametrosSituFreqWidget    = templateManager.container.getWidget("parametrosSituacaoFrequencia");
        
        var dataFilter                  = parametrosSituFreqWidget.dataSourceFilter;
        var nrSituFreqCurrentValue      = this.getCurrentNrSituacaoFrequencia();
        
        var nrSituFreqFilter = Array.isArray(dataFilter) ? dataFilter.find((filter) => filter.name === 'NRSITUFREQUENCIA') : false;
        nrSituFreqFilter.value = nrSituFreqCurrentValue;
    };
    
    this.deleteParametroSituacaoFrequencia = function() {
        var widget = templateManager.container.getWidget("parametrosSituacaoFrequencia");
        
        ScreenService.confirmMessage(Messages.DELETE_ROW, 'CONFIRMATION', 
            function(){
                widget.dataSource.remove(widget.currentRow).then(function (data){
                    if(data.dataset.ptoSituFreqParam_setParametrosSituacaoFrequencia.type === "success"){
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                        ScreenService.showMessage(Messages.REMOVE_ROW_SUCCESS); 
                    } else {
                        ScreenService.showMessage(Messages.REMOVE_ROW_ERROR); 
                    }
                });
            }.bind(this)
        );
    };

    this.salvarParametroSituacaoFrequencia = function(){
        var widget = templateManager.container.getWidget("parametrosSituacaoFrequencia");
        
        if (!widget.backupRow) {
            widget.currentRow.__is_new = true;
        } else {
            widget.currentRow.__is_new = false;
        }
        widget.currentRow.CDOPERADOR_LOG = getLocalVar("HCM_CDOPERADOR");
        widget.currentRow.NRORGTRAB = getLocalVar("HCM_NRORG_TRAB");
        widget.currentRow.NRORGPADRAO = getLocalVar("HCM_NRORG_PADRAO");
        widget.currentRow.DTATUAL = getLocalVar("HCM_DATA_ATUAL");
        
        return restEngine.post('product#/getParametrosSituacaoFrequencia/save',
        {
            requestType: 'DataSet',
            dataset: [ widget.currentRow ]
        }
        ).then(function (data){
            if (data.notifications[0].type === "success") {
                ScreenService.showMessage(Messages.SAVE_ROW_SUCCESS);
                if (widget.currentRow.__is_new) {
                    ABUtilController.masterDetailVoltarList(widget);
                    widget.reload();
                } else {
                    ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                    widget.backupRow = null;
                    widget.view();
                    widget.reload();
                }
            } else {
                ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
            }
        }).catch(function(e) {
            var error;
            if(e.data.error === undefined)
                error = e;
            else 
                error = e.data.error;
            
            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error));
        });
    };
    
    /**
     *  Rotina responsável por validar a inserção de um novo Parâmetro. Caso não sejam encontrados detalhes, a inserção é realizada
     * 
     */
    this.validationBeforeInsertParametro = function(widget) {
        const widgetParametrosSituacaoFrequencia = widget || templateManager.container.getWidget("parametrosSituacaoFrequencia");
        
        if(!widgetParametrosSituacaoFrequencia.isValid()) {
            return;
        }
        
        let itensWithNoFilters = 0;
        const itensWithNoFiltersLimit = 2;
        
        // Valida se foram cadastrados parametros sem filtros de vínculo (Estruturas Sindicais, Legais ou Gerenciais). Ao cadastrar mais de um registro desse tipo,
        // uma mensagem deve ser mostrada
        for (const dataSourceItem of widgetParametrosSituacaoFrequencia.dataSource.data) {
            const noFilterRegisterAlreadyAdded =
                (!dataSourceItem.NRESTRUTSIND   || (Array.isArray(dataSourceItem.NRESTRUTSIND)  && dataSourceItem.NRESTRUTSIND.length   < 1)) &&
                (!dataSourceItem.NRESTRUTLEGAL  || (Array.isArray(dataSourceItem.NRESTRUTLEGAL) && dataSourceItem.NRESTRUTLEGAL.length  < 1)) &&
                (!dataSourceItem.NRESTRUTGEREN  || (Array.isArray(dataSourceItem.NRESTRUTGEREN) && dataSourceItem.NRESTRUTGEREN.length  < 1));
                
            if (noFilterRegisterAlreadyAdded) {
                itensWithNoFilters++;
            }
            
            if (itensWithNoFilters >= itensWithNoFiltersLimit) {
                ScreenService.confirmMessage(Messages.HCM07014_PTO_SITUACAOFREQUENCIA_REGISTER_WITHOUT_FILTERS_ADDED_CONFIRMATION, 'CONFIRMATION', 
                    function(){
                        this.salvarParametroSituacaoFrequencia();
                    }.bind(this)
                );
                return;
            }
        }
        
        // Caso nada deva ser evidenciado, a rotina de inserção é chamada
        this.salvarParametroSituacaoFrequencia();
    };
    
    this.setAddVisibility = function() {
        var widget                  = templateManager.container.getWidget("parametrosSituacaoFrequencia");
        var addParameterButton      = widget.getAction("adicionar");
        
        var addButtonIsVisible = widget.isActive() && this.parametrosSituacaoDataSourceNaoPossuiRegistrosOrgCliente(widget);
        addParameterButton.isVisible = addButtonIsVisible;
    };
    
    this.parametrosSituacaoDataSourceNaoPossuiRegistrosOrgCliente = function(widget = null) {
        widget                      = widget || templateManager.container.getWidget("parametrosSituacaoFrequencia");
        var widgetDataSourceData    = widget.dataSource.data || [];
        var nrOrgPadrao             = getLocalVar('HCM_NRORG_PADRAO');
        
        var clientOrgItemsOnDataSource  = widgetDataSourceData.filter((dataSourceItem) => dataSourceItem.NRORG !== nrOrgPadrao);
        
        var addButtonIsVisible = widget.isActive() && clientOrgItemsOnDataSource.length === 0;
        return addButtonIsVisible;
    };

}

Configuration(function(ContextRegister) {
    ContextRegister.register('SituacaoFrequenciaController', SituacaoFrequenciaController);
});

// FILE: assets/js/controllers/SituacaoFuncionalController.js
function SituacaoFuncionalController(ScreenService, templateManager, restEngine, ABUtilController, Messages, General) {

    this.salvar = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {

            var dtIniVigencia = widget.currentRow.DTINIVIGENCIA;
            var dtFimVigencia = widget.currentRow.DTFIMVIGENCIA;
            if(dtIniVigencia && dtFimVigencia && moment(dtIniVigencia, 'DD/MM/YYYY').unix() > moment(dtFimVigencia, 'DD/MM/YYYY').unix()){
                ScreenService.showMessage(Messages.HCM02014_VAB_BENEFICIO_FIM_VIGENCIA_MENOR_INICIO_VIGENCIA);
                return;
            }
            
            if (!widget.backupRow) {
                widget.currentRow.__is_new = true;
            } else {
                widget.currentRow.__is_new = false;
            }
            var preparedWidget = ABUtilController.prepareSaveMasterHistory(widget);

            restEngine.post('product#/setSitufunc', {'requestType': 'DataSet', 'dataset': [preparedWidget.currentRow]}).
            then(function(data) {
                if (data.dataset.columnsToReturn) {
                    ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                    if (preparedWidget.currentRow.__is_new) {
                        ABUtilController.masterDetailVoltarList(preparedWidget);
                        preparedWidget.reload();
                    } else {
                        ABUtilController.mudarVisibilidadeWidgets(preparedWidget.widgets, true);
                        var tableHistoryPk = preparedWidget.saveHistoryTable.__table_history_pk.toUpperCase();
                        if (preparedWidget.currentRow[tableHistoryPk]) {
                            for (var i = 0; i < data.dataset.columnsToReturn.length; i++) {
                                if (!Util.isUndefined(data.dataset.columnsToReturn[i][tableHistoryPk])) {
                                    preparedWidget.currentRow[tableHistoryPk] = data.dataset.columnsToReturn[i][tableHistoryPk];
                                }
                            }
                        }
                        preparedWidget.backupRow = null;
                        preparedWidget.view();
                    }
                } else {
                    ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                }
            }).
            catch(function(e) {
                var error;
                if (e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
    
                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
        }
    };

    this.remover = function(widget) {
        ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
            if (widget.isValid()) {
                widget.currentRow.__is_new = false;
                restEngine.post('product#/deleteSitufunc', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                        then(function (data) {
                            if (data.messages) {
                            ScreenService.showMessage(Messages.REMOVE_ROW_ERROR + '. ' + data.messages[0].message, data.messages[0].type);
                        } else {
                            ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                            ABUtilController.masterDetailVoltarList(widget);
                            widget.reload();
                        }
                    }).
                    catch(function(e) {
                        var error;
                        if(e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;

                        ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    });
            }
        }, null);
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('SituacaoFuncionalController', SituacaoFuncionalController);
});

// FILE: assets/js/controllers/SituacaoGeradoraController.js
function SituacaoGeradoraController(ScreenService, templateManager, restEngine, ABUtilController, Messages) {

	this.salvar = function(args) {
        var widget = templateManager.container.getActiveWidget();
        if (widget.isValid()) {
            if (!widget.backupRow) {
                widget.currentRow.__is_new = true;
            } else {
                widget.currentRow.__is_new = false;
            }
            restEngine.post('product#/setSitugeradora', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                then(function (data) {
                    if (data.notifications[0].type === "success") {
                        ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                        if (widget.currentRow.__is_new) {
                            ABUtilController.masterDetailVoltarList(widget);
                            widget.reload();
                        } else {
                            ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                            widget.backupRow = null;
                            widget.view();
                        }
                    } else {
                        ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                    }
                }).
                catch(function(e) {
                    var error;
                    if(e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;

                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
        }
    };

    this.remover = function(args) {
        var widget = templateManager.container.getActiveWidget();
        if (widget.isValid()) {
            widget.currentRow.__is_new = false;
            restEngine.post('product#/deleteSitugeradora', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                then(function (data) {
                    if (data.notifications[0].type === "success") {
                        ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    } else {
                        ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                    }
                }).
                catch(function(e) {
                    var error;
                    if(e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;

                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
        }
    };

}

Configuration(function(ContextRegister) {
    ContextRegister.register('SituacaoGeradoraController', SituacaoGeradoraController);
});

// FILE: assets/js/controllers/SolicitacaoController.js
function SolicitacaoController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, Messages, SolicitacaoService, ABUtilController, AdmissaoController) {
    
    this.getTemplateManager = templateManager;
    this.tipoSolicitacaoAtual = "";
    this.bloquearInsercao = "";
    var TP_SOLI_FERIAS = 1;
    var TP_SOLI_MOVIM = 2;
    var TP_SOLI_SALARIO = 3;
    var TP_SOLI_TREINAMENTO = 4;
    var TP_SOLI_DESLIGAMENTO = 5;
    var TP_SOLI_PESSOAL = 6;
    var TP_SOLI_ALTERADADOS = 7;
    var TP_SOLI_ALTERAENDERECO = 8;
    var TP_SOLI_OCUPACAO = 9;
    var TP_SOLI_VTRANS = 10;
    var TP_SOLI_DEP = 11;
    var TP_SOLI_ALTESITU = 12;
    var TP_SOLI_PLANOSAUDE = 13;
    var TP_SOLI_ALTERAESCALA = 14;
    var TP_SOLI_ALTERACONTA = 15;
    var TP_SOLI_ALTERACOMU = 16;
    var TP_SOLI_ADMISSAO = 17;
    
    var cdbanco;
    var formasComunicacao = {};
    
    var nrVinculoAnterior = null;
    var nrvinculom = null;
    var nmvinculom = null;
   
   
       //Funções originais do ABUtilController -----------
    
    this.validaDtIniMenorIgualDtFin = function(dtIni, dtFin) {
        var today = new Date();
        return !(moment(dtIni, 'DD/MM/YYYY').unix() > moment(dtFin, 'DD/MM/YYYY').unix() || moment(dtFin, 'DD/MM/YYYY').unix() < moment(dtIni, 'DD/MM/YYYY').unix());
    };
    
    this.masterDetailVoltarList = function(widget) {
        if(widget.name == 'dadosList') {
            widget.parent.list();
            ScreenService.closeSwipe();
            widget.parent.activate();
        } else {
            widget.list();
            ScreenService.closeSwipe();
            widget.activate();
        }
    };

   
   
   this.idAprovStatus = function(){
       var widget = templateManager.container.getWidget("solicitacao");
       var widgetPopup = templateManager.container.getWidget("aprovacao");
       if(widget.currentRow.NRTIPOSOLICITACAO == "6"){
            widgetPopup.getField('DSSTATUS').isVisible = true;
       } else {
           widgetPopup.getField('DSSTATUS').isVisible = false;
       }
         
   };
    
    this.filtrarDadosList = function(widget) {
        //this.hideFieldGroups(widget);
        var nrsolicitacao = templateManager.container.getWidget("solicitacao").currentRow.NRSOLICITACAO;
        var widgetDadosList = templateManager.container.getWidget("dadosList");

        widgetDadosList.dataSourceFilter[1] = {
            "name": "NRSOLICITACAO",
            "operator": "=",
            "value": nrsolicitacao
        };
    };
    
    this.vinculoOnChange = function(args){
        var widget = templateManager.container.getWidget('solicitacao');
        
        if(widget.currentRow.NRVINCULOM) 
            widget.getField('NMTIPOSOLICITACAO').readOnly = false;
        else {
            widget.getField('NMTIPOSOLICITACAO').readOnly = true;
            SolicitacaoService.showWidgetDados();
        }    
        
        if(widget.currentRow.NRVINCULOM != nrVinculoAnterior) {
            widget.currentRow.NMTIPOSOLICITACAO = null;
            widget.currentRow.NRTIPOSOLICITACAO = null;
            if(nrVinculoAnterior){
                nrvinculom = widget.currentRow.NRVINCULOM;
                nmvinculom = widget.currentRow.NMVINCULOM;
                SolicitacaoService.showWidgetDados();   
                widget.currentRow.NRVINCULOM = nrvinculom;
                widget.currentRow.NMVINCULOM = nmvinculom;
            }
        }
        
        
        
        nrVinculoAnterior = widget.currentRow.NRVINCULOM;
    };
    
    /* Desabilitado por não usar mais níveis. Agora usa o modelo e fases
    this.setCamposOperador = function(widget) {
        var operAprovPri = false;
        var operAprovSec = false;

        widget.getField('NMOPERADORPRI').dataSource.data.forEach(function(data) {
            if (data.cdoperador == widget.currentRow.NMOPERADORPRI) {
                operAprovPri = true;
            }
        });
        if (operAprovPri === false) {
            if (widget.currentRow.NMOPERADORPRI == getLocalVar('CDOPERADOR')) {
                widget.getField('NMOPERADORPRI').dataSource.data.push({
                    "cdoperador": getLocalVar('CDOPERADOR'),
                    "nmoperador": getLocalVar('NMOPERADOR')
                });
            } else {
                widget.getField('NMOPERADORPRI').dataSource.data.push({
                    "cdoperador": widget.currentRow.CDOPERAPROVPRI,
                    "nmoperador": widget.currentRow.NMOPERADORPRI
                });
            }
        }

        widget.getField('NMOPERADORSEC').dataSource.data.forEach(function(data) {
            if (data.cdoperador == widget.currentRow.NMOPERADORSEC) {
                operAprovSec = true;
            }
        });
        if (operAprovSec === false) {
            if (widget.currentRow.NMOPERADORSEC == getLocalVar('CDOPERADOR')) {
                widget.getField('NMOPERADORSEC').dataSource.data.push({
                    "cdoperador": getLocalVar('CDOPERADOR'),
                    "nmoperador": getLocalVar('NMOPERADOR')
                });
            } else {
                widget.getField('NMOPERADORSEC').dataSource.data.push({
                    "cdoperador": widget.currentRow.NMOPERADORSEC,
                    "nmoperador": widget.currentRow.NMOPERADORSEC
                });
            }
        }
    };*/
    
    /* Desabilitado por não usar mais níveis. Agora usa o modelo e fases
    this.habilitaPerfacesAprov = function(args){
        var widget = templateManager.container.getWidget("perfacestiposoli");
        var perfil1 = widget.getField("NMPERFACESAPROVPRI");
        var perfil2 = widget.getField("NMPERFACESAPROVSEC");
        switch(widget.currentRow.NRNIVELAPROVASOLI){
            case "1":
                perfil1.readOnly = false;
                perfil1.validations = {"required":{}};
                perfil2.readOnly = true;
                perfil2.validations = {};
                widget.currentRow.NRPERFACESAPROVSEC = '';
                widget.currentRow.NMPERFACESAPROVSEC = '';
                break;
            case "2":
                perfil1.readOnly = false;
                perfil1.validations = {"required":{}};
                perfil2.readOnly = false;
                perfil2.validations = {"required":{}};
                break;
            case "4":
                perfil2.readOnly = false;
                perfil2.validations = {"required":{}};
                perfil1.readOnly = true;
                perfil1.validations = {};
                widget.currentRow.NRPERFACESAPROVSEC = '';
                widget.currentRow.NMPERFACESAPROVSEC = '';
                widget.currentRow.NRPERFACESAPROVPRI = '';
                widget.currentRow.NMPERFACESAPROVPRI = '';
                break;
            default:
                perfil1.readOnly = true;
                perfil1.validations = {};
                perfil2.readOnly = true;
                perfil2.validations = {};
                widget.currentRow.NRPERFACESAPROVPRI = '';
                widget.currentRow.NMPERFACESAPROVPRI = '';
                widget.currentRow.NRPERFACESAPROVSEC = '';
                widget.currentRow.NMPERFACESAPROVSEC = '';
        }
    };*/
    
    this.showAprovacaoSec = function(widget,value){
        widget.fieldGroups[2].isVisible = value;
        widget.getField('IDAPROVACAOSEC').isVisible = value; 
        widget.getField('DTAPROVACAOSEC').isVisible = value; 
        widget.getField('NMOPERADORSEC').isVisible = value; 
        widget.getField('DSOBSAPROVASEC').isVisible = value; 
        // widget.reload();
        widget.redraw();
    };
    
    /* Desabilitado por não usar mais níveis. Agora usa o modelo e fases
    this.showAprovacaoSecAprov = function(widget,value){
        widget.fieldGroups[2].isVisible = value;
        widget.getField('IDAPROVACAOSEC').isVisible = value; 
        widget.getField('DTAPROVACAOSEC').isVisible = value; 
        widget.getField('NMOPERADORSEC').isVisible = value; 
        widget.getField('DSOBSAPROVASEC').isVisible = value; 
    };*/
    
    this.abreAprovacao = function(args,idNivelAprov) {
        var widget = templateManager.container.getWidget('aprovacao');
        ScreenService.openPopup(widget);
        widget.currentRow = args.owner.widget.currentRow;
        widget.currentRow.IDNIVELAPROV = idNivelAprov;
        widget.getField("DSOBSAPROV").validations = {};
    };
    
    this.preencheNome = function(args) {
        var widget = args.owner.owner.widget;
        if(widget.currentRow.NRTIPOSOLICITACAO == TP_SOLI_ALTERADADOS){
            widget.currentRow.DSPESSOA = widget.currentRow.NMPESSOAVINC;
        }
        if(widget.currentRow.NRTIPOSOLICITACAO == TP_SOLI_PLANOSAUDE){
            widget.getField("NMPESSOA").readOnly = false;
        }
    };

    /* Desabilitado por não usar mais níveis. Agora usa o modelo e fases
    this.habilitaAprovacao = function(widget) {
        var nrNivelAprov = parseInt(widget.currentRow.NRNIVELAPROVASOLI, 10);
        if (nrNivelAprov == 1 || nrNivelAprov == 3)
            this.showAprovacaoSec(widget,false);
        else
            this.showAprovacaoSec(widget,true);
            
        var arrPerfOper = localStorageEngine.getLocalVar('accessProfiles');
        var idAprovPri = widget.getField('IDAPROVACAOPRI').value();
        var idAprovSec = widget.getField('IDAPROVACAOSEC').value();
        var nrPerfilPri = widget.currentRow.NRPERFACESAPROVPRI;
        var nrPerfilSec = widget.currentRow.NRPERFACESAPROVSEC;
        var operRespEstrut = widget.currentRow.IDRESPESTRUT;
        widget.getAction('abreAprov').isVisible = false;
        widget.getAction('abreAprovAdmissao').isVisible = false;

        if(widget.currentRow.NRTIPOSOLICITACAO == 17){
            widget.getAction('abreAprovAdmissao').isVisible = true;
        }else if(idAprovPri == 'P' && idAprovSec == 'P') {
            switch (nrNivelAprov) {
                case 1:
                    if(arrPerfOper.indexOf(nrPerfilPri) >= 0){
                        widget.getAction('abreAprov').isVisible = true;
                        widget.getAction('abreAprov').idNivelAprov = 2;
                    }
                    break;
                case 2:
                    if(arrPerfOper.indexOf(nrPerfilPri) >= 0){
                        widget.getAction('abreAprov').isVisible = true;
                        widget.getAction('abreAprov').idNivelAprov = 1;
                    }
                    break;
                case 3:
                    if(operRespEstrut == 'S'){
                        widget.getAction('abreAprov').isVisible = true;
                        widget.getAction('abreAprov').idNivelAprov = 2;
                    }
                    break;
                case 4:
                    if(operRespEstrut == 'S'){
                        widget.getAction('abreAprov').isVisible = true;
                        widget.getAction('abreAprov').idNivelAprov = 1;
                    }
                    break;
                default:
                    widget.getAction('abreAprov').isVisible = false;
                    widget.getAction('abreAprov').idNivelAprov = 0;
            }
        } else if(idAprovSec == 'P' && idAprovPri != 'R'){
            if((nrNivelAprov == 2 || nrNivelAprov == 4) && arrPerfOper.indexOf(nrPerfilSec) >= 0){
                widget.getAction('abreAprov').isVisible = true;
                widget.getAction('abreAprov').idNivelAprov = 2;
                
            }else{
                widget.getAction('abreAprov').isVisible = false;
                widget.getAction('abreAprov').idNivelAprov = 0;
            }
        }
    };*/
    this.habilitaAprovacao = function(widget) {
        if (widget.currentRow.IDAPROVACAOSEC == "P" || widget.currentRow.IDAPROVACAOSEC == "E") {
            widget.getAction('abreAprov').isVisible = true;
        } else {
            widget.getAction('abreAprov').isVisible = false;
        }
    };
    
    this.openAprovacaoAdmissao = function(args){
        var widget = ABUtilController.checkWidget(args);
        
        ScreenService.showCustomDialog('Deseja realmente aprovar a admissão deste vínculo?', 'CONFIRMATION', null, [
            {
                label: ScreenService.i18n("Sim"),
                code: function (e, deferred) {
                    ScreenService.openWindow('product#hcm00056_gpe_aprovacaoAdmissao');
                    deferred.resolve(e);
                }.bind(this)
            },
            {
                label: ScreenService.i18n("Não"),
                code: function (e, deferred) {}
            }
        ]);
    };
    

    this.adicionarRowSolicitacao = function(args) {
        var widget = args.owner.widget;
        widget.getField('NMTIPOSOLICITACAO').readOnly = true;
        SolicitacaoService.setInsertSolicitacaoView(widget);
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
        widget.currentRow.__is_new = true;
        
        var widgetDados = templateManager.container.getWidget("solicitacao");
        widgetDados.getField('NMTIPOSOLICITACAO').readyOnly = true;
        widgetDados.widgets[0].isVisible = false;
    };
    
    this.makeDadosListVisible = function() {
        var widgetDados = templateManager.container.getWidget("solicitacao");
        widgetDados.widgets[0].isVisible = true;
    };

    this.adicionarRow = function(args) {
        var widget = args.owner.widget;
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
    };

    this.cancelaInsercao = function(widget) {
        var currentRow = widget.currentRow;
        if (widget.currentRow.__is_new) {
            var indexOfCurrentRow = widget.dataSource.data.indexOf(widget.currentRow);
            if (indexOfCurrentRow !== -1) {
                widget.dataSource.data.pop();
            }
            ScreenService.closeSwipe();
            widget.activate();
        } else {
            Util.extend(widget.currentRow, widget.backupRow);
            widget.view();
        }
        SolicitacaoService.hideWidgetDados();
        SolicitacaoService.setShowSolicitacaoView(widget);
        currentRow.DTINIGOZOFERIAS = "";
        currentRow.QTDEDIASFERIAS = "";
        currentRow.DTFIMGOZOFERIAS = "";
        currentRow.ABONOPECUNIARIO = "";
    };
    
    /* Desabilitado por não usar mais níveis. Agora usa o modelo e fases
    this.hideFieldGroups = function(widget) {
        for(var i=0; i<widget.fieldGroups.length; i++) {
            var currentGroup = widget.fieldGroups[i];
            if(currentGroup.name != "TIPOSOLICITACAO" && currentGroup.name != "APROVACAOPRI" && currentGroup.name != "APROVACAOSEC"    && currentGroup.name != "AUDITORIA")
            widget.fieldGroups[i].isVisible = false;
        }
    };*/
    
    this.preencherDados = function(widget) {
        if (widget.isValid()) {
            this.changeTipoSolicitacao();
        }
    };    

    this.changeTipoSolicitacao = function() {
        var widget = templateManager.container.getWidget('solicitacao');
        var tipo = widget.currentRow.NRTIPOSOLICITACAO;

        nrvinculom = widget.currentRow.NRVINCULOM;
        nmvinculom = widget.currentRow.NMVINCULOM;

        
        if(tipo == TP_SOLI_ADMISSAO) {
            widget.getAction('salvar').isVisible = false;
            widget.getAction('abreAdmissao').isVisible = true;
        } else {
            widget.getAction('salvar').isVisible = true;
            widget.getAction('abreAdmissao').isVisible = false;
        }
        
        if(tipo == TP_SOLI_PLANOSAUDE){
            widget.getField("NMPESSOA").readOnly = true;
        }
        
        if(tipo == TP_SOLI_ALTERACOMU){
            this.getFormaComunicacao(widget);
        }
        
        if(tipo == TP_SOLI_FERIAS){
            widget.getField("CDPREFIXCOMUPARC").readOnly = true;
        }

        var TipoSolicitacao = {
            'NRTIPOSOLICITACAO': tipo,
            'NMTIPOSOLICITACAO': widget.currentRow.NMTIPOSOLICITACAO
        };
        
        SolicitacaoService.showWidgetDados(TipoSolicitacao);
    
        if(tipo == "") {
            SolicitacaoService.hideWidgetDados();
        } else {
            //Checa se existe perfil de Acesso pro Tipo de Solicitação
            restEngine.post("/checaPerfilAcesso",
                {
                    requestType: "FilterData",
                    filter: [{operator: "=", name: "NRVINCULOM",        value: nrvinculom},
                             {operator: "=", name: "NRTIPOSOLICITACAO", value: tipo},
                             {operator: "=", name: "DTCOMPETENCIA",     value: getLocalVar("HCM_DTCOMPETENCIA")}]
                }
            ).then(function(data) {
                    var containerSolicitacoes = this.getTemplateManager.containers.lancamentoSolicitacoes;
                    if(data.dataset.erro.Bloquear) {
                        ScreenService.showMessage(data.dataset.erro.Texto);
                        widget.currentRow.NRTIPOSOLICITACAO = "";
                        widget.currentRow.NMTIPOSOLICITACAO = "";
                        SolicitacaoService.hideWidgetDados();
                    } else {
                        //Checa se existe alguma Solicitação deste tipo já feita, em estado Pendente
                        this.tipoSolicitacaoAtual = widget.currentRow.NRTIPOSOLICITACAO;
                        restEngine.post("/getSolicitacao",
                            {
                                requestType: "FilterData",
                                filter: []
                            }
                        ).then(function(data) {
                            this.bloquearInsercao = false;
                            if(data.dataset.solicitacao && data.dataset.solicitacao[0]) {
                                for(var i=0; i<data.dataset.solicitacao.length; i++) {
                                    var solicitacaoAtual = data.dataset.solicitacao[i];
                                    if(this.tipoSolicitacaoAtual == solicitacaoAtual.NRTIPOSOLICITACAO && solicitacaoAtual.IDAPROVACAOPRI == "P") {
                                        this.bloquearInsercao = true;
                                    }
                                }
                            }
                            if(this.bloquearInsercao === true) {
                                ScreenService.showMessage("Já existe uma solicitação deste tipo com aprovação pendente.");
                                var containerSolicitacoes = this.getTemplateManager.containers.lancamentoSolicitacoes;
                                widget.currentRow.NRTIPOSOLICITACAO = "";
                                widget.currentRow.NMTIPOSOLICITACAO = "";
                                SolicitacaoService.hideWidgetDados();
                            } else this.getOperadorLogado(widget);
                        }.bind(this));
                    }
                    
            }.bind(this));
        }
        
        widget.currentRow.NRVINCULOM = nrvinculom;
        widget.currentRow.NMVINCULOM = nmvinculom;
        
    };
    
    this.getOperadorLogado = function(widgetDados) {
        var filtroVinculo = {
            "P_NRVINCULOM": widgetDados.currentRow.NRVINCULOM,
            "P_DTMESCOMPETENC": getLocalVar('HCM_DTCOMPETENCIA')
        };
        
        return restEngine.post("/getVinculoNr",
            {
                requestType: "DataSet",
                dataset: [filtroVinculo]
            }
        ).then(function(data) {
            if(data.dataset.vinculosAtivos[0]) {
                var dados = data.dataset.vinculosAtivos[0];

                widgetDados.currentRow.NMESTRUTLEGAL  = dados.NMESTRUTLEGAL;
                widgetDados.currentRow.NMESTRUTGEREN  = dados.NMESTRUTGEREN;
                widgetDados.currentRow.NRESTRUTGEREN  = dados.NRESTRUTGEREN;
                widgetDados.currentRow.NRPESSOAVINC   = dados.NRVINCULOM;
                widgetDados.currentRow.NRPESSOA       = dados.NRPESSOA;
                
                if(widgetDados.currentRow.NRPESSOA) 
                    widgetDados.getField('NMPESSOA').dataSourceFilter.forEach(function(filter){
                        if(filter.name == "NRPESSOA") filter.value = widgetDados.currentRow.NRPESSOA;
                    });
                    
                widgetDados.currentRow.NMPESSOA       = dados.NMPESSOA;
                widgetDados.currentRow.DTADMISSAOVINC = dados.DTADMISSAOVINC;
                widgetDados.currentRow.NRCPFPESSOA    = dados.NRCPFPESSOA;
                
                widgetDados.currentRow.DSPESSOA        = dados.NMPESSOA;
                widgetDados.currentRow.NMGRAUINSTR     = dados.NMGRAUINSTR;
                widgetDados.currentRow.NRCERTCASAPES   = dados.NRCERTCASAPES;
                widgetDados.currentRow.DTCASAPESSOA    = dados.DTCASAPESSOA;
                widgetDados.currentRow.NRCARTHABPES    = dados.NRCARTHABPES;
                widgetDados.currentRow.DTHABCARTPES    = dados.DTHABCARTPES;
                widgetDados.currentRow.DSCATEGHABCART  = dados.DSCATEGHABCART;
                widgetDados.currentRow.DTVALHABCARTPES = dados.DTVALHABCARTPES;
                
                widgetDados.currentRow.CDTIPOENDERECO   = dados.CDTIPOENDERECO;
                widgetDados.currentRow.NMTIPOENDERECO   = dados.CDTIPOENDERECO;
                widgetDados.currentRow.NRCEPENDERECO    = dados.NRCEPENDERECO;
                widgetDados.currentRow.NMPAIS           = dados.NMPAIS;
                widgetDados.currentRow.SGESTADO         = dados.SGESTADO;
                widgetDados.currentRow.NMMUNICIPIO      = dados.NMMUNICIPIO;
                widgetDados.currentRow.NMBAIRROENDERECO = dados.NMBAIRROENDERECO;
                widgetDados.currentRow.DSLOGRADOURO     = dados.CDLOGRADOURO;
                widgetDados.currentRow.DSENDERECO       = dados.DSENDERECO;
                widgetDados.currentRow.NRIMOVELENDERECO = dados.NRIMOVELENDERECO;
                widgetDados.currentRow.DSCOMPLEENDERECO = dados.DSCOMPLEENDERECO;
                widgetDados.currentRow.DSREFERENCIAENDE = dados.DSREFERENCIAENDE;
                
                widgetDados.currentRow.NMBANCO      = dados.NMBANCO;
                widgetDados.currentRow.CDBANCO      = dados.CDBANCO;
                widgetDados.currentRow.NMAGENCIA    = dados.NMAGENCIA;
                widgetDados.currentRow.CDAGENCIA    = dados.CDAGENCIA;
                if(dados.NMAGENCIA)widgetDados.getField('NMAGENCIA').readOnly = false;
                else widgetDados.getField('NMAGENCIA').readOnly = true;
                widgetDados.currentRow.NRTPCONTCORR = dados.NRTPCONTCORR;
                widgetDados.currentRow.DSTPCONTCORR = dados.DSTPCONTCORR;
                widgetDados.currentRow.CDCONTCORR   = dados.CDCONTCORR;
                
                widgetDados.currentRow.DSTURNO       = dados.DSTURNO;
                widgetDados.currentRow.NRTURNO       = dados.NRTURNO;
                if(dados.DSTURNO)widgetDados.getField('DSTURNO').readOnly = false;
                else widgetDados.getField('DSTURNO').readOnly = true;
                this.habilitaDesabilitaTurno();
                widgetDados.currentRow.DTINIESCALA   = dados.DTINIESCALA;
                widgetDados.currentRow.NMESCALATRABH = dados.NMESCALATRABH;
                widgetDados.currentRow.NRESCALATRABM = dados.NRESCALATRABM;
                
                widgetDados.currentRow.NMFORMACOMU      = dados.NMFORMACOMU;
                widgetDados.currentRow.NRFORMACOMU      = dados.NRFORMACOMU;
                widgetDados.currentRow.CDCOMUNICAPARC   = dados.CDCOMUNICAPARC;
                widgetDados.currentRow.CDPREFIXCOMUPARC = dados.CDPREFIXCOMUPARC;
                
                widgetDados.currentRow.IDTPSALARIO        = dados.IDTPSALARIO;
                widgetDados.currentRow.DTALTESALARIO      = dados.DTALTESALARIO;
                widgetDados.currentRow.DSTIPOSALARIO      = dados.DSTIPOSALARIO;
                widgetDados.currentRow.NRTPMODALIDSAL     = dados.NRTPMODALIDSAL;
                widgetDados.currentRow.NMOCUPACAOH_SAL    = dados.NMOCUPACAOH;
                widgetDados.currentRow.NOVOVALORSALARIO   = dados.VRSALARIO;
                widgetDados.currentRow.NMTPMODALIDSAL_SAL = dados.NMTPMODALIDSAL;
                
                widgetDados.currentRow.NMTPMODALIDSAL     = dados.NMTPMODALIDSAL;
                widgetDados.currentRow.NRMOTIVOOCUPA      = dados.NRMOTIVOOCUPA;
                widgetDados.currentRow.NMMOTIVOOCUPA      = dados.NMMOTIVOOCUPA;
                widgetDados.currentRow.DTINIOCUPACAO      = dados.DTINIOCUPACAO;
                widgetDados.currentRow.NROCUPACAOM        = dados.NROCUPACAOM;
                widgetDados.currentRow.NMOCUPACAOH_OCU    = dados.NMOCUPACAOH;
                widgetDados.currentRow.NMOCUPACAODESEJADA = dados.NMOCUPACAOH;
                widgetDados.currentRow.NRTIPOOCUPACAO     = dados.NRTIPOOCUPACAO;
                widgetDados.currentRow.NMTIPOOCUPACAO     = dados.NMTIPOOCUPACAO;
                
                
                this.setTipoBeneficio();
                widgetDados.getField('NMPESSOA').readOnly         = false;
                widgetDados.getField('IDTPBENEFICIARIO').readOnly = false;
            } else {
                ScreenService.showMessage("Houve um erro ao procurar informações do vínculo informado.");
            }
        }.bind(this));
    };
    
    this.getFormaComunicacao = function(widgetDados) {
        var filtroFormaComu = {
            "NRPARCNEGOCIO":  widgetDados.currentRow.NRPARCNEGOCIO,
            "P_NRORG":  getLocalVar('HCM_NRORG_TRAB') ? getLocalVar('HCM_NRORG_TRAB') : '',
            "P_NRORGPADRAO":  getLocalVar('HCM_NRORG_PADRAO') ? getLocalVar('HCM_NRORG_PADRAO') : '',
            "IDATIVO":  'S', 
        };

        return restEngine.post("product#/getFormaComunicacaoParc",
            {
                requestType: "FilterData",
                dataset: [filtroFormaComu]
            }
        ).then(function(data) {
            if(data.dataset.formaComuVinc[0]) {
                this.formasComunicacao = data.dataset.formaComuVinc;
                //widgetDados.currentRow.CDPREFIXCOMUPARC  = dados.CDPREFIXCOMUPARC;
                //widgetDados.currentRow.CDCOMUNICAPARC  = dados.CDCOMUNICAPARC;
            }
        }.bind(this));
    };
    
    this.loadFormaComunicacao = function() {
        var widgetDados = templateManager.container.getWidget('solicitacao');
        var formaComu = widgetDados.currentRow.NMFORMACOMU;
        var formaAtual;
        if(formaComu != null && formaComu != "") {
            for(var i=0; i<this.formasComunicacao.length; i++) {
                formaAtual = this.formasComunicacao[i];
                if(formaAtual.NMFORMACOMU == formaComu) {
                    widgetDados.currentRow.CDPREFIXCOMUPARC  = formaAtual.CDPREFIXCOMUPARC;
                    widgetDados.currentRow.CDCOMUNICAPARC    = formaAtual.CDCOMUNICAPARC;
                    break;
                }
                widgetDados.currentRow.CDPREFIXCOMUPARC  = "";
                widgetDados.currentRow.CDCOMUNICAPARC    = "";
            }
        } else {
            widgetDados.currentRow.CDPREFIXCOMUPARC  = "";
            widgetDados.currentRow.CDCOMUNICAPARC    = "";
        }
    };

    this.setQtdeDiasFerias = function(widget) {
        var miliSecMomentAtual = Date.now();
        var dtIniGozo = widget.getField('DTINIGOZOFERIAS').value();
        var dtFimGozo = widget.getField('DTFIMGOZOFERIAS').value();
        var nrQtdeDias = 0;
        var dtRetorno = null;
        widget.currentRow.QTDEDIASFERIAS = "";
        widget.getField('QTDEDIASFERIAS').readOnly = true;
        widget.currentRow.DTFIMGOZOFERIAS = "";
        // Valida se a data de início do gozo é retroativa 
        if (!Util.isEmptyOrBlank(dtIniGozo)) {
            if (!ABUtilController.validaDtIniMenorIgualDtFin(getLocalVar("DTMESCOMPETENC_ATUAL"), widget.getField('DTINIGOZOFERIAS').value().substr(0, 10))) {
                ScreenService.showMessage(Messages.INICIO_GOZO_RETROATIVO_ERROR, 'ERROR');
                widget.currentRow.DTINIGOZOFERIAS = "";
                widget.getField('QTDEDIASFERIAS').readOnly = true;
                return;
            } else {
                widget.getField('QTDEDIASFERIAS').readOnly = false;
                widget.getField('QTDEDIASFERIAS').reload();
            }
            templateManager.updateTemplate(widget);
        }
    };

    this.setSolicitacao = function(args) {
        var widget = args.owner.widget;
        var widgetSolicitacao = templateManager.container.getWidget('solicitacao');
        if (widget.isValid()) {
            var nrtiposolicitacao = widget.currentRow.NRTIPOSOLICITACAO;
            if ((!widget.currentRow.ABONOPECUNIARIO) && (nrtiposolicitacao == TP_SOLI_FERIAS))
                widget.currentRow.ABONOPECUNIARIO = "N";
            if (nrtiposolicitacao == TP_SOLI_SALARIO)
                widget.currentRow.NRTPMODALIDSAL = 1;
            if (nrtiposolicitacao == TP_SOLI_TREINAMENTO)
                if(!ABUtilController.validaDtIniMenorIgualDtFin(widget.currentRow.DTINIPLANEJADOTRE,widget.currentRow.DTFIMPLANEJADOTRE)){
                    ScreenService.showMessage("A data inicial deve ser anterior a final");
                    return false;
                }
            if (nrtiposolicitacao == TP_SOLI_VTRANS)
                if(!ABUtilController.validaDtIniMenorIgualDtFin(widget.currentRow.DTINILINHAVINC,widget.currentRow.DTFIMLINHAVINC)){
                    ScreenService.showMessage("A data inicial deve ser anterior a final");
                    return false;
                }
            if (!widget.backupRow) {
                widget.currentRow.__is_new = true;
            } else {
                widget.currentRow.__is_new = false;
            }
            
            widget.currentRow.DTCOMPETENCIA = getLocalVar('DTMESCOMPETENC_ATUAL');
            restEngine.post('/setSolicitacao', {
                'requestType': 'DataSet',
                'dataset': [widget.currentRow]
            }).
            then(function(data) {
                if (data.notifications[0].type === "success") {
                    widgetSolicitacao = templateManager.container.getWidget('solicitacao');
                    SolicitacaoService.hideWidgetDados();
                    SolicitacaoService.setShowSolicitacaoView(widgetSolicitacao);
                    ScreenService.successNotification("Registro salvo com sucesso", 10000);
                    if (widget.currentRow.__is_new) {
                        ABUtilController.masterDetailVoltarList(widgetSolicitacao);
                        widgetSolicitacao.reload();
                    } else {
                        //this.mudarVisibilidadeWidgets(widget.widgets, true);
                        widget.backupRow = null;
                        widget.view();
                    }
                } else {
                    if (data.notifications[0].type === "ERROR") {
                        ScreenService.showMessage(data.notifications[0].message);
                    }
                }
            }.bind(this));
        }
    };

    this.idAprovOnChange = function(args) {
        var widget = templateManager.container.getWidget('aprovacao');
        if(widget.getField("IDAPROVACAO").value() == "A"){
            widget.getField("DSOBSAPROV").validations = {};
        }else{
            widget.getField("DSOBSAPROV").validations = {"required":{}};
        }
        widget.reload();
    };

    this.setPerfacestiposoli = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
            if (!widget.backupRow) {
                widget.currentRow.__is_new = true;
            } else {
                widget.currentRow.__is_new = false;
            }
            restEngine.post('product#/setPerfacestiposoli', {
                'requestType': 'DataSet',
                'dataset': [widget.currentRow]
            }).
            then(function(data) {
                if (!Util.isUndefined(data.notifications) && data.notifications[0].type === "success") {
                    ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                    if (widget.currentRow.__is_new) {
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    } else {
                        widget.backupRow = null;
                        widget.view();
                    }
                } else {
                    if(!Util.isUndefined(data.messages)){
                        ScreenService.showMessage(data.messages[0].message);
                    } 
                    else
                        ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                }
            }).
            catch(function(e) {
                var error;
                if (Util.isUndefined(e.data) && Util.isUndefined(e.data.error) && Util.isUndefined(e.message))
                    error = e;
                else if (!Util.isUndefined(e.message))
                    error = e.message;
                else
                    error = e.data.error;
                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
        }
    };

    this.deletePerfacestiposoli = function(args) {
        ScreenService.confirmMessage(Messages.DELETE_ROW, 'CONFIRMATION',
            function() {
                var widget = args.owner.widget;
                widget.currentRow.__is_new = false;
                restEngine.post('product#/deletePerfacestiposoli', {
                    'requestType': 'DataSet',
                    'dataset': [widget.currentRow]
                }).
                then(function(data) {
                    if (data.notifications[0].type === "success") {
                        ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    } else {
                        if(data.notifications[0].type === "error"){
                            ScreenService.showMessage(data.notifications[0].message);
                        } else {
                            ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                        }
                    }
                }).
                catch(function(e) {
                    var error;
                    if (e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
            });
    };

    this.aprovaSolicitacao = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
            if((widget.currentRow.NRTIPOSOLICITACAO == TP_SOLI_DESLIGAMENTO || widget.currentRow.NRTIPOSOLICITACAO == TP_SOLI_ALTERAENDERECO || widget.currentRow.NRTIPOSOLICITACAO == TP_SOLI_ALTERACOMU) &&
               widget.currentRow.IDAPROVACAO && widget.currentRow.IDAPROVACAO == "A")
            {
                restEngine.post('product#/validaItemSolicitacao', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                then(function (data) {
                    if (data.messages){ 
                        ScreenService.confirmMessage(data.messages[0].message, null, function() {
                            restEngine.post('product#/aprovaSolicitacao', {
                                'requestType': 'DataSet',
                                'dataset': [widget.currentRow]
                            }).
                            then(function(data) {
                                if (!Util.isUndefined(data.notifications) && data.notifications[0].type === "success") {
                                    ScreenService.successNotification(data.notifications[0].message, 10000);
                                    ScreenService.closePopup(true);
                                    ABUtilController.masterDetailVoltarList(widget);
                                    widget = templateManager.container.getWidget('solicitacao');
                                    widget.reload();
                                    widget.activate();
                                } else if (!Util.isUndefined(data.messages)) {
                                    ScreenService.showMessage(data.messages[0].message, data.messages[0].type);
                                } else {
                                    ScreenService.showMessage("Erro ao aprovar/reprovar a solicitação");
                                }
                            }).
                            catch(function(e) {
                                var error;
                                if (Util.isUndefined(e.data) && Util.isUndefined(e.data.error) && Util.isUndefined(e.message))
                                    error = e;
                                else if (!Util.isUndefined(e.message))
                                    error = e.message;
                                else
                                    error = e.data.error;
                                ScreenService.showMessage(error, 'ERROR');
                            });
                        }, null);
                        
                    } else {
                        restEngine.post('product#/aprovaSolicitacao', {
                                'requestType': 'DataSet',
                                'dataset': [widget.currentRow]
                            }).
                            then(function(data) {
                                if (!Util.isUndefined(data.notifications) && data.notifications[0].type === "success") {
                                    ScreenService.successNotification(data.notifications[0].message, 10000);
                                    ScreenService.closePopup(true);
                                    ABUtilController.masterDetailVoltarList(widget);
                                    widget = templateManager.container.getWidget('solicitacao');
                                    widget.reload();
                                    widget.activate();
                                } else if (!Util.isUndefined(data.messages)) {
                                    ScreenService.showMessage(data.messages[0].message, data.messages[0].type);
                                } else {
                                    ScreenService.showMessage("Erro ao aprovar/reprovar a solicitação");
                                }
                            }).
                            catch(function(e) {
                                var error;
                                if (Util.isUndefined(e.data) && Util.isUndefined(e.data.error) && Util.isUndefined(e.message))
                                    error = e;
                                else if (!Util.isUndefined(e.message))
                                    error = e.message;
                                else
                                    error = e.data.error;
                                ScreenService.showMessage(error, 'ERROR');
                        });
                    }
                }).
                catch(function(e) {
                    var error;
                    if(!e.data || e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;

                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
            } else {
                if(widget.currentRow.NRTIPOSOLICITACAO == TP_SOLI_MOVIM)
                    widget.currentRow.NRTPESTRUTURAMLEGAL = getLocalVar('HCM_NRTIPOESTRUTLEGAL');
                
                restEngine.post('product#/aprovaSolicitacao', {
                    'requestType': 'DataSet',
                    'dataset': [widget.currentRow]
                }).
                then(function(data) {
                    if (!Util.isUndefined(data.notifications) && data.notifications[0].type === "success") {
                        ScreenService.successNotification(data.notifications[0].message, 10000);
                        ScreenService.closePopup(true);
                        ABUtilController.masterDetailVoltarList(widget);
                        widget = templateManager.container.getWidget('solicitacao');
                        widget.reload();
                        widget.activate();
                    } else if (!Util.isUndefined(data.messages)) {
                        ScreenService.showMessage(data.messages[0].message, data.messages[0].type);
                    } else {
                        ScreenService.showMessage("Erro ao aprovar/reprovar a solicitação");
                    }
                }).
                catch(function(e) {
                    var error;
                    if (Util.isUndefined(e.data) && Util.isUndefined(e.data.error) && Util.isUndefined(e.message))
                        error = e;
                    else if (!Util.isUndefined(e.message))
                        error = e.message;
                    else
                        error = e.data.error;
                    ScreenService.showMessage(error, 'ERROR');
                });
            }
        }    
    };

    this.niveisAprovacaoOnChange = function(widget, str) {
        var nrnivelaprovasoli = widget.getField('NRNIVELAPROVASOLI');
        var nrperfacesaprovpri = widget.getField('NRPERFACESAPROVPRI');
        var nrperfacesaprovsec = widget.getField('NRPERFACESAPROVSEC');

        switch (str) {
            case 'cancel':
                nrperfacesaprovpri.showOnForm = false;
                nrperfacesaprovsec.showOnForm = false;
                break;
            case ('plusOrEdit'):
                nrperfacesaprovpri.showOnForm = false;
                nrperfacesaprovsec.showOnForm = false;
                if (nrnivelaprovasoli.value() == 1) {
                    nrperfacesaprovpri.showOnForm = true;
                    nrperfacesaprovpri.validations = {
                        "required": {}
                    };
                    nrperfacesaprovsec.showOnForm = false;
                    nrperfacesaprovsec.validations = {};
                    widget.currentRow.NRPERFACESAPROVSEC = "";
                } else if (nrnivelaprovasoli.value() == 2) {
                    nrperfacesaprovpri.showOnForm = true;
                    nrperfacesaprovpri.validations = {
                        "required": {}
                    };
                    nrperfacesaprovsec.showOnForm = true;
                    nrperfacesaprovsec.validations = {
                        "required": {}
                    };
                } else if (nrnivelaprovasoli.value() == 3) {
                    nrperfacesaprovpri.showOnForm = false;
                    nrperfacesaprovpri.validations = {};
                    nrperfacesaprovsec.showOnForm = false;
                    nrperfacesaprovsec.validations = {};
                } else if (nrnivelaprovasoli.value() == 4) {
                    nrperfacesaprovpri.showOnForm = false;
                    nrperfacesaprovpri.validations = {};
                    nrperfacesaprovsec.showOnForm = true;
                    nrperfacesaprovsec.validations = {
                        "required": {}
                    };
                }
                break;
        }
        widget.redraw();
    };

    this.validaFimGozo = function(widget) {
        var abonoPecuniario = widget.getField('ABONOPECUNIARIO');
        var dtInicioGozo = widget.currentRow.DTINIGOZOFERIAS;
        var qtdeDiasGozo = widget.currentRow.QTDEDIASFERIAS;
        var dtFimGozo = moment(dtInicioGozo, 'DD/MM/YYYY').add((qtdeDiasGozo-1), 'day').format('DD/MM/YYYY');
        var dtRetorno = moment(dtFimGozo, 'DD/MM/YYYY').add(1, 'day').format('DD/MM/YYYY');
        widget.currentRow.DTFIMGOZOFERIAS = dtFimGozo;
        widget.currentRow.DTRETORNOFERIAS = dtRetorno;
        if (qtdeDiasGozo == 20) {
            abonoPecuniario.isVisible = true;
            widget.redraw();
        } else {
            if (qtdeDiasGozo === null) {
                widget.currentRow.DTFIMGOZOFERIAS = "";
                widget.currentRow.DTRETORNOFERIAS = "";
            }
            abonoPecuniario.isVisible = false;
            widget.redraw();
        }
    };

    this.validaDataRetroativa = function(widget) {
        var partesData = widget.currentRow.DTALTESALARIO.split("/");
        var dtaltesalario = new Date(partesData[2], partesData[1] - 1, partesData[0]);
        if (dtaltesalario < new Date()) {
            ScreenService.showMessage("A data da alteração salarial não pode ser retroativa", 'ERROR');
            widget.currentRow.DTALTESALARIO = "";
        }
    };

    this.validaDescriptionFieldDadosList = function(widget) {
        var cdpais_municipio;
        var sgestado;
        var banco_agencia;
        var nrescalaturno;

        widget.dataSource.data.forEach(function(obj) {
            switch(obj.DSCHAVEITEMSOLI){
               
                case "IDPUBLICAVAGA":
                case "IDADIANT13SALAR":
                case "ABONOPECUNIARIO":
                case "IDTREINAMENTOINT":
                    if (obj.DSVALORITEMSOLI === "N") {
                        obj.DSVALORITEMSOLI = "Não";
                    } else {
                        obj.DSVALORITEMSOLI = "Sim";
                    }
                    break;
                    
                case "NRTIPOALTERA":
                    var tipoAlteracao = templateManager.container.getWidget('dados').getField('NRTIPOALTERA');
                    tipoAlteracao.reload().then(function() {
                        tipoAlteracao.dataSource.data.forEach(function(obj2) {
                            if (obj.DSVALORITEMSOLI == obj2.NRTIPOALTERA)
                                obj.DSVALORITEMSOLI = obj2.NMTIPOALTERA;
                        });
                    });
                    break;
                    
                case "NRTPMODALIDSAL":
                    if(obj.DSVALORITEMSOLI == 1)
                        obj.DSVALORITEMSOLI = "Efetivo";
                    break;
                    
                case "NOVOVALORSALARIO":
                    var vlr = obj.DSVALORITEMSOLI;
                    var casaDecimal = vlr.split(".");
                    if (casaDecimal.length == 2) {
                        vlr = parseFloat(vlr).toFixed(2);
                        vlr = vlr.replace(/[^0-9]/g, '');
                        obj.DSVALORITEMSOLI = formatReal(vlr);
                    } else {
                        vlr += "00";
                        obj.DSVALORITEMSOLI = formatReal(vlr);
                    }
                    break;
                case "NROCUPACAOM":
                case "NROCUPACAOM_OCU":
                case "NROCUPACAOM_SAL":
                    var Ocupacao = templateManager.container.getWidget('dados').getField('NMOCUPACAOH_OCU');
                    Ocupacao.reload().then(function() {
                        Ocupacao.dataSource.data.forEach(function(obj2) {
                            if (obj.DSVALORITEMSOLI == obj2.NROCUPACAOM)
                                obj.DSVALORITEMSOLI = obj2.NMOCUPACAOH;
                        });
                    });
                    break;
                    
                case "NRTIPOOCUPACAO":
                    var TpOcupacao = templateManager.container.getWidget('dados').getField('NMTIPOOCUPACAO');
                    TpOcupacao.reload().then(function() {
                        TpOcupacao.dataSource.data.forEach(function(obj2) {
                            if (obj.DSVALORITEMSOLI == obj2.NRTIPOOCUPACAO)
                                obj.DSVALORITEMSOLI = obj2.NMTIPOOCUPACAO;
                        });
                    });
                    break;
                    
                case "NRMOTIVOOCUPA":
                    var MotivoOcupacao = templateManager.container.getWidget('dados').getField('NMMOTIVOOCUPA');
                    MotivoOcupacao.reload().then(function() {
                        MotivoOcupacao.dataSource.data.forEach(function(obj2) {
                            if (obj.DSVALORITEMSOLI == obj2.NRMOTIVOOCUPA)
                                obj.DSVALORITEMSOLI = obj2.NMMOTIVOOCUPA;
                        });
                    });
                    break;
                    
                case "NRCURSO":
                    var curso = templateManager.container.getWidget('dados').getField('NMCURSO');
                    curso.reload().then(function() {
                        curso.dataSource.data.forEach(function(obj2) {
                            if (obj.DSVALORITEMSOLI == obj2.NRCURSO)
                                obj.DSVALORITEMSOLI = obj2.NMCURSO;
                        });
                    });
                    break;
                    
                case "NRPERFACESAPROV":
                    var perfacesaprov = templateManager.container.getWidget('dados').getField('NMPERFACESAPROV');
                    perfacesaprov.reload().then(function() {
                        perfacesaprov.dataSource.data.forEach(function(obj2) {
                            if (obj.DSVALORITEMSOLI == obj2.NRPERFILACESSO)
                                obj.DSVALORITEMSOLI = obj2.NMPERFILACESSO;
                        });
                    });
                    break;
                    
                case "NRMETODOTRE":
                    var metodo = templateManager.container.getWidget('dados').getField('NMMETODOTRE');
                    metodo.reload().then(function() {
                        metodo.dataSource.data.forEach(function(obj2) {
                            if (obj.DSVALORITEMSOLI == obj2.NRMETODOTRE)
                                obj.DSVALORITEMSOLI = obj2.NMMETODOTRE;
                        });
                    });
                    break;
                    
                case "NRPERFACESEXEC":
                    var perfacesexec = templateManager.container.getWidget('dados').getField('NMPERFACESEXEC');
                    perfacesexec.reload().then(function() {
                        perfacesexec.dataSource.data.forEach(function(obj2) {
                            if (obj.DSVALORITEMSOLI == obj2.NRPERFILACESSO)
                                obj.DSVALORITEMSOLI = obj2.NMPERFILACESSO;
                        });
                    });
                    break;
                
                case "NRLINHATRANSP":
                    var nrlinhatransp = templateManager.container.getWidget('dados').getField('DSLINHATRANSP');
                    nrlinhatransp.reload().then(function() {
                        nrlinhatransp.dataSource.data.forEach(function(obj2) {
                            if (obj.DSVALORITEMSOLI == obj2.NRLINHATRANSP)
                                obj.DSVALORITEMSOLI = obj2.DSLINHATRANSP;
                        });
                    });
                    break;
                
                case "NRTIPOLINHAVINC":
                    var nrtipolinhavinc = templateManager.container.getWidget('dados').getField('DSTIPOLINHAVINC');
                    nrtipolinhavinc.reload().then(function() {
                        nrtipolinhavinc.dataSource.data.forEach(function(obj2) {
                            if (obj.DSVALORITEMSOLI == obj2.NRTIPOLINHAVINC)
                                obj.DSVALORITEMSOLI = obj2.DSTIPOLINHAVINC;
                        });
                    });
                    break;
                    
                case "NRSENTIDOLINHA":
                    var nrsentidolinha = templateManager.container.getWidget('dados').getField('DSSENTIDOLINHA');
                    nrsentidolinha.reload().then(function() {
                        nrsentidolinha.dataSource.data.forEach(function(obj2) {
                            if (obj.DSVALORITEMSOLI == obj2.NRSENTIDOLINHA)
                                obj.DSVALORITEMSOLI = obj2.DSSENTIDOLINHA;
                        });
                    });
                    break;
                    
                case "NRTIPOTRANSFER":
                    var nrtipotransfer = templateManager.container.getWidget('dados').getField('NMTIPOTRANSFER');
                    nrtipotransfer.reload().then(function() {
                        nrtipotransfer.dataSource.data.forEach(function(obj2) {
                            if (obj.DSVALORITEMSOLI == obj2.NRTIPOTRANSFER)
                                obj.DSVALORITEMSOLI = obj2.NMTIPOTRANSFER;
                        });
                    });
                    break;
                case "NRMOTIVOTRANSF":
                    var nrmotivotransf = templateManager.container.getWidget('dados').getField('NMMOTIVOTRANSF');
                    nrmotivotransf.reload().then(function() {
                        nrmotivotransf.dataSource.data.forEach(function(obj2) {
                            if (obj.DSVALORITEMSOLI == obj2.NRMOTIVOTRANSF)
                                obj.DSVALORITEMSOLI = obj2.NMMOTIVOTRANSF;
                        });
                    });
                    break;
                case "NRTPMOVTRANSFM":
                    var nrtpmovtransfm = templateManager.container.getWidget('dados').getField('NMTPMOVTRANSFH');
                    nrtpmovtransfm.reload().then(function() {
                        nrtpmovtransfm.dataSource.data.forEach(function(obj2) {
                            if (obj.DSVALORITEMSOLI == obj2.NRTPMOVTRANSFM)
                                obj.DSVALORITEMSOLI = obj2.NMTPMOVTRANSFH;
                        });
                    });
                    break;
                case "NRESTRUTGEREN":
                case "NRESTRUTURAM":
                    var nrestruturam = templateManager.container.getWidget('dados').getField('NMESTRUTURAH');
                    nrestruturam.reload().then(function() {
                        nrestruturam.dataSource.data.forEach(function(obj2) {
                            if (obj.DSVALORITEMSOLI == obj2.NRESTRUTURAM)
                                obj.DSVALORITEMSOLI = obj2.NMESTRUTURAH;
                        });
                    });
                    break;
                case "CDDIAGNOST":
                    var cddiagnost = templateManager.container.getWidget('dados').getField('NMDIAGNOST');
                    cddiagnost.reload().then(function() {
                        cddiagnost.dataSource.data.forEach(function(obj2) {
                            if (obj.DSVALORITEMSOLI == obj2.CDDIAGNOST)
                                obj.DSVALORITEMSOLI = obj2.NMDIAGNOST;
                        });
                    });
                    break;
                case "NRTIPORELACIONA":
                    var nrtiporelaciona = templateManager.container.getWidget('dados').getField('NMTIPORELACIONA');
                    nrtiporelaciona.reload().then(function() {
                        nrtiporelaciona.dataSource.data.forEach(function(obj2) {
                            if (obj.DSVALORITEMSOLI == obj2.NRTIPORELACIONA)
                                obj.DSVALORITEMSOLI = obj2.NMTIPORELACIONA;
                        });
                    });
                    break;
                case "NRSITUFUNCM":
                case "NRPROXSITUFUNC":
                    var nrsitufuncm = templateManager.container.getWidget('dados').getField('NMPROXSITUFUNC');
                    nrsitufuncm.reload().then(function() {
                        nrsitufuncm.dataSource.data.forEach(function(obj2) {
                            if (obj.DSVALORITEMSOLI == obj2.NRSITUFUNCM)
                                obj.DSVALORITEMSOLI = obj2.NMSITUFUNCH;
                        });
                    });
                    break;
                case "NRMOTIVOAFASTA":
                    var nrmotivoafasta = templateManager.container.getWidget('dados').getField('NMMOTIVOAFASTA');
                    nrmotivoafasta.reload().then(function() {
                        nrmotivoafasta.dataSource.data.forEach(function(obj2) {
                            if (obj.DSVALORITEMSOLI == obj2.NRMOTIVOAFASTA)
                                obj.DSVALORITEMSOLI = obj2.NMMOTIVOAFASTA;
                        });
                    });
                    break;
                case "IDSEXOPESSOA":
                    if (obj.DSVALORITEMSOLI === "M") {
                        obj.DSVALORITEMSOLI = "Masculino";
                    } else {
                        obj.DSVALORITEMSOLI = "Feminino";
                    }
                    break;
                case "NRBENEFICIOM":
                    var nrbeneficiom = templateManager.container.getWidget('dados').getField('DSBENEFICIO');
                    nrbeneficiom.reload().then(function() {
                        nrbeneficiom.dataSource.data.forEach(function(obj2) {
                            if (obj.DSVALORITEMSOLI == obj2.NRBENEFICIOM)
                                obj.DSVALORITEMSOLI = obj2.DSBENEFICIO;
                        });
                    });
                    break;
                case "NRPESSOA":
                    var NRPESSOA = templateManager.container.getWidget('dados').getField('NMPESSOA_GERAL');
                    NRPESSOA.reload().then(function() {
                        NRPESSOA.dataSource.data.forEach(function(obj2) {
                            if (obj.DSVALORITEMSOLI == obj2.NRPESSOA)
                                obj.DSVALORITEMSOLI = obj2.NMPESSOA;
                        });
                    });
                    NRPESSOA.dataSourceFilter = [];
                    break;
                case "IDTPBENEFICIARIO":
                    if (obj.DSVALORITEMSOLI === "T") {
                        obj.DSVALORITEMSOLI = "Titular";
                    } else {
                        obj.DSVALORITEMSOLI = "Dependente";
                    }
                    break;
                case "NRGRAUINSTR":
                    var nrgrauinstr = templateManager.container.getWidget('dados').getField('NMGRAUINSTR');
                    nrgrauinstr.reload().then(function() {
                        nrgrauinstr.dataSource.data.forEach(function(obj2) {
                            if (obj.DSVALORITEMSOLI == obj2.NRGRAUINSTR)
                                obj.DSVALORITEMSOLI = obj2.NMGRAUINSTR;
                        });
                    });
                    break;
                case "CDTIPOENDERECO":
                    var cdtipoendereco = templateManager.container.getWidget('dados').getField('NMTIPOENDERECO');
                    if (cdtipoendereco) {
                        cdtipoendereco.reload().then(function() {
                            cdtipoendereco.dataSource.data.forEach(function(obj2) {
                                if (obj.DSVALORITEMSOLI == obj2.CDTIPOENDERECO)
                                    obj.DSVALORITEMSOLI = obj2.NMTIPOENDERECO;
                            });
                        });
                    }
                    break;
                case "CDPAIS":
                    var cdpais = templateManager.container.getWidget('dados').getField('NMPAIS');
                    cdpais_municipio = obj.DSVALORITEMSOLI;
                    if (cdpais) {
                        cdpais.reload().then(function() {
                            cdpais.dataSource.data.forEach(function(obj2) {
                                if (obj.DSVALORITEMSOLI == obj2.CDPAIS)
                                    obj.DSVALORITEMSOLI = obj2.NMPAIS;
                                
                            });
                        });
                    }
                    break;
                case "SGESTADO":
                        sgestado = obj.DSVALORITEMSOLI;
                        break;
                case "CDMUNICIPIO":
                    var cdmunicipio = templateManager.container.getWidget('dados').getField('NMMUNICIPIO');
                    if (cdmunicipio) {
                        cdmunicipio.dataSourceFilter[0].value = cdpais_municipio;
                        cdmunicipio.dataSourceFilter[1].value = sgestado;
                        cdmunicipio.reload().then(function() {
                            cdmunicipio.dataSource.data.forEach(function(obj2) {
                                if (obj.DSVALORITEMSOLI == obj2.CDMUNICIPIO)
                                    obj.DSVALORITEMSOLI = obj2.NMMUNICIPIO;
                            });
                        });
                    }
                    break;
                case "CDLOGRADOURO":
                    var cdlogradouro = templateManager.container.getWidget('dados').getField('DSLOGRADOURO');
                    cdlogradouro.reload().then(function() {
                        cdlogradouro.dataSource.data.forEach(function(obj2) {
                            if (obj.DSVALORITEMSOLI == obj2.CDLOGRADOURO)
                                obj.DSVALORITEMSOLI = obj2.DSLOGRADOURO;
                        });
                    });
                    break;
                case "CDBANCO":
                    var cdbanco = templateManager.container.getWidget('dados').getField('NMBANCO');
                    banco_agencia = obj.DSVALORITEMSOLI;
                    cdbanco.reload().then(function() {
                        cdbanco.dataSource.data.forEach(function(obj2) {
                            if (obj.DSVALORITEMSOLI == obj2.CDBANCO)
                                obj.DSVALORITEMSOLI = obj2.NMBANCO;
                        });
                    });
                    break;
                case "CDAGENCIA":
                    var cdagencia = templateManager.container.getWidget('dados').getField('NMAGENCIA');
                    cdagencia.dataSourceFilter[0].value = banco_agencia;
                    cdagencia.reload().then(function() {
                        cdagencia.dataSource.data.forEach(function(obj2) {
                            if (obj.DSVALORITEMSOLI == obj2.CDAGENCIA)
                                obj.DSVALORITEMSOLI = obj2.NMAGENCIA;
                        });
                    });
                    break;
                case "CDFORMACOMU":
                    var cdformacomu = templateManager.container.getWidget('dados').getField('NMFORMACOMU');
                    ABUtilController.getConditionNrorgTrabPadrao(cdformacomu);
                    cdformacomu.reload().then(function() {
                        cdformacomu.dataSource.data.forEach(function(obj2) {
                            if (obj.DSVALORITEMSOLI == obj2.CDFORMACOMU)
                                obj.DSVALORITEMSOLI = obj2.NMFORMACOMU;
                        });
                    });
                    break;
                case "NRTPCONTCORR":
                    var nrtpcontcorr = templateManager.container.getWidget('dados').getField('DSTPCONTCORR');
                    nrtpcontcorr.reload().then(function() {
                        nrtpcontcorr.dataSource.data.forEach(function(obj2) {
                            if (obj.DSVALORITEMSOLI == obj2.NRTPCONTCORR)
                                obj.DSVALORITEMSOLI = obj2.DSTPCONTCORR;
                        });
                    });
                break;
                
                case "NRTEMPLATE":
                    var nrtemplate = templateManager.container.getWidget('dados').getField('NMTEMPLATE');
                        nrtemplate.reload().then(function() {
                            nrtemplate.dataSource.data.forEach(function(obj2) {
                                if (obj.DSVALORITEMSOLI == obj2.NRTEMPLATE)
                                    obj.DSVALORITEMSOLI = obj2.NMTEMPLATE;
                            });
                        });
                        break;
                case "NRTIPOPROCESSO":
                    var nrtipoprocesso = templateManager.container.getWidget('dados').getField('NMTIPOPROCESSO');
                        nrtipoprocesso.reload().then(function() {
                            nrtipoprocesso.dataSource.data.forEach(function(obj2) {
                                if (obj.DSVALORITEMSOLI == obj2.NRTIPOPROCESSO)
                                    obj.DSVALORITEMSOLI = obj2.NMTIPOPROCESSO;
                            });
                        });
                        break;
                case "NRPARCNEGOCIORESP":
                    var nrparcnegocioresp = templateManager.container.getWidget('dados').getField('NMPARCNEGOCIORESP');
                        nrparcnegocioresp.reload().then(function() {
                            nrparcnegocioresp.dataSource.data.forEach(function(obj2) {
                                if (obj.DSVALORITEMSOLI == obj2.NRPARCNEGOCIO)
                                    obj.DSVALORITEMSOLI = obj2.NMPRINCIPALPARC;
                            });
                        });
                        break;
                case "NRESCALATRABM":
                    var nrescalatrabh = templateManager.container.getWidget('dados').getField('NMESCALATRABH');
                        nrescalaturno = obj.DSVALORITEMSOLI;
                        nrescalatrabh.reload().then(function(){
                            nrescalatrabh.dataSource.data.forEach(function(obj2){
                                if(obj.DSVALORITEMSOLI == obj2.NRESCALATRABM)
                                    obj.DSVALORITEMSOLI = obj2.NMESCALATRABH;
                            });
                        });
                    break;
                case "NRTURNO":
                    var nrturno = templateManager.container.getWidget('dados').getField('DSTURNO');
                    nrturno.dataSourceFilter = [
                    {
                        "name": "NRORG",
                        "operator": "=",
                        "value": "@getLocalVar('HCM_NRORG_TRAB') ? getLocalVar('HCM_NRORG_TRAB') : '' @"
                    },
                    {
                        "name": "NRESCALATRABM",
                        "operator": "=",
                        "value": nrescalaturno
                    }];
                        nrturno.reload().then(function(){
                            nrturno.dataSource.data.forEach(function(obj2){
                                if(obj.DSVALORITEMSOLI == obj2.NRTURNO)
                                    obj.DSVALORITEMSOLI = obj2.DSTURNO;
                            });
                        });
                    break;
                case "NRMOTIVOESCALA":
                    var nrmotivoescala = templateManager.container.getWidget('dados').getField('NRMOTIVOESCALA');
                        nrmotivoescala.reload().then(function(){
                            nrmotivoescala.dataSource.data.forEach(function(obj2){
                                if(obj.DSVALORITEMSOLI == obj2.NRMOTIVOESCALA)
                                    obj.DSVALORITEMSOLI = obj2.NMMOTIVOESCALA;
                            });
                        });
                    break;
                case "NRTPAVIPRE":
                    var nrtpavipre = templateManager.container.getWidget('dados').getField('DSTPAVIPRE');
                        nrtpavipre.reload().then(function(){
                            nrtpavipre.dataSource.data.forEach(function(obj2){
                                if(obj.DSVALORITEMSOLI == obj2.NRTPAVIPRE)
                                    obj.DSVALORITEMSOLI = obj2.DSTPAVIPRE;
                            });
                        });
                    break;
                case "NRTPDEMISSAO":
                    var nrtpdemissao = templateManager.container.getWidget('dados').getField('NMTPDEMISSAO');
                        nrtpdemissao.reload().then(function(){
                            nrtpdemissao.dataSource.data.forEach(function(obj2){
                                if(obj.DSVALORITEMSOLI == obj2.NRTPDEMISSAO)
                                    obj.DSVALORITEMSOLI = obj2.NMTPDEMISSAO;
                            });
                        });
                    break;
                case "NRMOTIVORESC":
                    var nrmotivoresc = templateManager.container.getWidget('dados').getField('NMMOTIVORESC');
                        nrmotivoresc.reload().then(function(){
                            nrmotivoresc.dataSource.data.forEach(function(obj2){
                                if(obj.DSVALORITEMSOLI == obj2.NRMOTIVORESC)
                                    obj.DSVALORITEMSOLI = obj2.NMMOTIVORESC;
                            });
                        });
                    break;
            }
        });
    };

    var formatReal = function(int) {
        var tmp = int + '';
        tmp = tmp.replace(/([0-9]{2})$/g, ",$1");
        if (tmp.length > 6)
            tmp = tmp.replace(/([0-9]{3}),([0-9]{2}$)/g, ".$1,$2");
        if (tmp.length > 10)
            tmp = tmp.replace(/([0-9]{3}).([0-9]{3}),([0-9]{2}$)/g, ".$1.$2,$3");
        if (tmp.length > 14)
            tmp = tmp.replace(/([0-9]{3}).([0-9]{3}).([0-9]{3}),([0-9]{2}$)/g, ".$1.$2.$3,$4");
        if (tmp.length > 18)
            tmp = tmp.replace(/([0-9]{3}).([0-9]{3}).([0-9]{3}).([0-9]{3}),([0-9]{2}$)/g, ".$1.$2.$3.$4,$5");
        if (tmp.length > 22)
            tmp = tmp.replace(/([0-9]{3}).([0-9]{3}).([0-9]{3}).([0-9]{3}).([0-9]{3}),([0-9]{2}$)/g, ".$1.$2.$3.$4.$5,$6");
        if (tmp.length > 26)
            tmp = tmp.replace(/([0-9]{3}).([0-9]{3}).([0-9]{3}).([0-9]{3}).([0-9]{3}).([0-9]{3}),([0-9]{2}$)/g, ".$1.$2.$3.$4.$5.$6,$7");
        if (tmp.length > 30)
            tmp = tmp.replace(/([0-9]{3}).([0-9]{3}).([0-9]{3}).([0-9]{3}).([0-9]{3}).([0-9]{3}),([0-9]{2}$)/g, ".$1.$2.$3.$4.$5.$6.$7,$8");

        return tmp;
    };

    this.validaCurrentRowPreenchida = function(widget) {
        if (widget.currentRow.QTDEDIASFERIAS == 20) {
            widget.getField('ABONOPECUNIARIO').isVisible = true;
            widget.redraw();
        } else {
            widget.getField('ABONOPECUNIARIO').isVisible = false;
            widget.redraw();
        }
    };
    
    this.openAdmissao = function(args){
        AdmissaoController.openAdmissao(args);
        var widgetSolicitacao = templateManager.container.getWidget('solicitacao');
        SolicitacaoService.hideWidgetDados();
        SolicitacaoService.setShowSolicitacaoView(widgetSolicitacao);
    };

    this.formaComuOnChange = function(field){
        var widgetDados = templateManager.container.getWidget('solicitacao');
        if(!Util.isEmptyOrBlank(widgetDados.currentRow.CDFORMACOMU)){
            switch(widgetDados.currentRow.CDFORMACOMU){
                case "01":
                case "02":
                case "03":
                case "04":
                case "06":
                case "10":
                    widgetDados.getField('CDPREFIXCOMUPARC').readOnly = false;
                    break;
                default:
                widgetDados.currentRow.CDPREFIXCOMUPARC = null;
                widgetDados.getField('CDPREFIXCOMUPARC').readOnly = true;
                    break;
            }
        } else{
            widgetDados.currentRow.CDPREFIXCOMUPARC = null;
            widgetDados.getField('CDPREFIXCOMUPARC').readOnly = true;
            
        }
        widgetDados.reload();
        this.loadFormaComunicacao();
    };

    this.setTipoBeneficio = function(){
        var widget = templateManager.container.getWidget('solicitacao');
        var nrPessoa = widget.currentRow.NRPESSOA;
        if(nrPessoa){
             widget.currentRow.IDTPBENEFICIARIO = "T";
        }else{
            widget.currentRow.IDTPBENEFICIARIO = "";
        }    
    };
    
    this.setLocalidade = function(args) {
        var widgetProcessos = args.owner.field.widget;
        if(widgetProcessos.name != "filterPopup")
        widgetProcessos.currentRow.LOCALIDADE = (widgetProcessos.currentRow.NMMUNICIPIO + "/" + widgetProcessos.currentRow.SGESTADO);
    };
    
    this.filtrarEstadoMunicipioPorPais = function(args){
        var widget = args.owner.field.widget;
        widget.getField('SGESTADO').dataSourceFilter[0].value = widget.currentRow.CDPAIS;
        widget.getField('NMMUNICIPIO').dataSourceFilter[0].value = widget.currentRow.CDPAIS;
        widget.getField('NMMUNICIPIO').dataSourceFilter[1].value = widget.currentRow.SGESTADO;
        widget.getField('SGESTADO').dataSourceFilter[0].operator = "=";
        widget.getField('NMMUNICIPIO').dataSourceFilter[0].operator = "=";
        widget.getField('NMMUNICIPIO').dataSourceFilter[1].operator = "=";
        if(!widget.currentRow.NMPAIS){
            widget.getField('SGESTADO').readOnly = true;
            widget.getField('SGESTADO').dataSourceFilter[0].value = 0;
            widget.getField('SGESTADO').dataSourceFilter[0].operator = ">";
        }
        if(!widget.currentRow.SGESTADO){
            widget.currentRow.NMMUNICIPIO = "";
            widget.getField('NMMUNICIPIO').readOnly = true;
            widget.getField('NMMUNICIPIO').dataSourceFilter[0].value = 0;
            widget.getField('NMMUNICIPIO').dataSourceFilter[1].value = 0;
            widget.getField('NMMUNICIPIO').dataSourceFilter[0].operator = ">";
            widget.getField('NMMUNICIPIO').dataSourceFilter[1].operator = ">";
        }
        if(widget.currentRow.NMPAIS !== this.pais){
            widget.currentRow.SGESTADO = "";
            widget.currentRow.NMMUNICIPIO = "";
        }
        this.pais = widget.currentRow.NMPAIS;
    };
    
    this.buscarCep = function(args) {
        var messageError = "Um erro foi identificado! Favor verificar seu CEP ou sua conexão com a Internet";
        var currentRow = args.owner.field.widget.currentRow;
        this.limpaCamposCep(currentRow);
        if(currentRow.NRCEPENDERECO){
            var cep = currentRow.NRCEPENDERECO;
            cep = cep.replace(/[\.-]/g, '');
            if (cep.length === 8) { 
                restEngine.post('/findAddress',
                {'requestType':'Row','row':{'CEP': cep, 'NRORG': getLocalVar('HCM_NRORG_TRAB')}},
                function(array) {
                    if(array && array.dataset){
                        var data = array.dataset.ENDERECO;
                        if(data) {
                            if(data.CDPAIS) {
                                currentRow.CDPAIS = data.CDPAIS;
                                currentRow.NMPAIS = data.NMPAIS;
                                currentRow.SGESTADO = data.SGESTADO;
                                currentRow.NMESTADO = data.NMESTADO;
                                if((data.CDMUNICIPIO)) {
                                    currentRow.CDMUNICIPIO = data.CDMUNICIPIO;
                                    currentRow.NMMUNICIPIO = data.NMMUNICIPIO;
                                    if((data.CDBAIRRO)) {
                                        currentRow.NMBAIRROENDERECO = data.NMBAIRRO.toUpperCase();
                                        currentRow.DSLOGRADOURO = data.DSENDERECO.split(" ")[0].toUpperCase();
                                        currentRow.CDLOGRADOURO = data.CDLOGRADOURO;
                                        currentRow.DSENDERECO = this.retornaEnderecoCompleto(data.DSENDERECO);
                                    }
                                }
                            }
                        }
                    }else{
                        ScreenService.showMessage(messageError);
                        if(currentRow.NRCEPENDERECO) currentRow.NRCEPENDERECO = "";
                    }
                }.bind(this), undefined, 
                function(error) {
                    ScreenService.showMessage(messageError);
                    this.limpaCamposCep(currentRow);
                }.bind(this));
            } 
            else {
                ScreenService.showMessage(messageError);
                this.limpaCamposCep(currentRow);
            } 
        }else {
            ScreenService.showMessage('Favor digitar um CEP');
            this.limpaCamposCep(currentRow);
        }  
    };
    
    this.limpaCamposCep = function(currentRow){
        currentRow.CDPAIS = "";
        currentRow.NMPAIS = "";
        currentRow.SGESTADO = "";
        currentRow.NMESTADO = "";
        currentRow.CDMUNICIPIO = "";
        currentRow.NMMUNICIPIO = "";
        currentRow.CDBAIRRO = "";
        currentRow.NMBAIRROENDERECO = "";
        currentRow.DSLOGRADOURO = "";
        currentRow.DSENDERECO = "";
        currentRow.NRIMOVELENDERECO = "";
        currentRow.DSCOMPLEENDERECO = "";
        currentRow.DSREFERENCIAENDE = "";
        currentRow.DSBAIRAGEN = ""; 
        currentRow.DSENDEAGEN = "";
    };
    
    this.retornaEnderecoCompleto = function(endereco){
        var retorno = "";
        endereco = endereco.split(" ");
        endereco.splice(0, 1); // Retirar a parte que refere se é Rua ou Avenida.
        endereco.forEach(function(e){
            retorno += e+' ';
        });
        retorno = retorno.toUpperCase();
        return retorno.substr(0, retorno.length-1);
    };
    
    this.habilitaDesabilitaTurno = function(args){
        var widgetAlteEscala = args == undefined ? templateManager.container.getActiveWidget() : args.owner.owner.widget;
        var fieldEscala = widgetAlteEscala.getField('NMESCALATRABH');
        var fieldTurno = widgetAlteEscala.getField('DSTURNO');
        
        if (fieldEscala.value() !== "" & fieldEscala.value() != undefined) {
            fieldTurno.dataSourceFilter = [
                {
                    "name": "P_NRORG",
                    "operator": "=",
                    "value": "@getLocalVar('HCM_NRORG_TRAB') ? getLocalVar('HCM_NRORG_TRAB') : '' @"
                },
                {
                    "name": "P_NRESCALATRABM",
                    "operator": "=",
                    "value": widgetAlteEscala.currentRow.NRESCALATRABM
                },
                {
                    "name": "P_IDATIVO",
                    "operator": "=",
                    "value": "S"
                }
            ];
            fieldTurno.reload();
            fieldTurno.readOnly = false;
        } else {
            fieldTurno.dataSourceFilter = [
                {
                    "name": "P_NRORG",
                    "operator": "=",
                    "value": "@getLocalVar('HCM_NRORG_TRAB') ? getLocalVar('HCM_NRORG_TRAB') : '' @"
                },
                {
                    "name": "P_IDATIVO",
                    "operator": "=",
                    "value": "S"
                }
            ];
            fieldTurno.reload();
            fieldTurno.readOnly = true;
        }
    };
    
    this.limpaTurno = function(args){
        var widgetAlteEscala = args.owner.owner.widget;
        widgetAlteEscala.currentRow.DSTURNO = "";
        widgetAlteEscala.currentRow.NRTURNO = null;
    };
    
    this.filtrarAgenciaPorBanco = function(args){
        var widget = args.owner.field.widget;
        var currentRow = widget.currentRow;
        var agenciaField = widget.getField('NMAGENCIA');
        if(currentRow.CDBANCO && cdbanco !== currentRow.CDBANCO || cdbanco === currentRow.CDBANCO){
            agenciaField.dataSourceFilter[0].value = currentRow.CDBANCO;
            agenciaField.readOnly = false;
            if(cdbanco !== currentRow.CDBANCO){
                currentRow.NMAGENCIA = ''; 
                currentRow.CDAGENCIA = '';  
            }
            cdbanco = currentRow.CDBANCO;
        }else{
            agenciaField.dataSourceFilter[0].value = "";
            agenciaField.readOnly = true;
            currentRow.NMAGENCIA = '';
            currentRow.CDAGENCIA = '';  
        }
    };
    
    this.filtraPessoa = function(args) {
        var widget = args.owner.field.widget;
        var nrpessoafilter;
        var nrpessoas = [];
        var arraypessoas = [];
        if(widget.getField('NRVINCULOM_LIST')){
            nrpessoas = widget.getField('NRVINCULOM_LIST').dataSource.getCheckedRows();
            for(var row in nrpessoas){
                arraypessoas.push(nrpessoas[row].NRPESSOA);
            }
        }    
        if(nrpessoas.length > 0){
            nrpessoafilter = arraypessoas;
        }else{
            nrpessoafilter = widget.currentRow.NRPESSOAVINC;
        }
        widget.getField('NMPESSOA').dataSourceFilter = [{
            "name": "NRPESSOA",
            "operator": "=",
            "value": nrpessoafilter
        }];
        if(nrpessoafilter){
            widget.getField('NMPESSOA').reload();
        }
    };
    
    this.filtrarFaseTramSoli = function() {
        var nrsolicitacao = templateManager.container.getWidget("solicitacao").currentRow.NRSOLICITACAO;
        var widgetFasetramsoli = templateManager.container.getWidget("fasetramsoli");

        widgetFasetramsoli.dataSourceFilter[1] = {
            "name": "P_NRSOLICITACAO",
            "operator": "=",
            "value": nrsolicitacao
        };
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('SolicitacaoController', SolicitacaoController);
});

// FILE: assets/js/controllers/TabelaFolhaController.js
/* jshint esversion: 6 */
function TabelaFolhaController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, General, Messages) {

    var self = this;
    var idFiltrarWidgetMain;
    var nmFiltrarWidgetMain;
    var nomeVerifica;


    this.adicionarRow = function(args) {
        var widget = args.owner.widget;
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
        widget.currentRow.DTINIVIGENCIA = getLocalVar('HCM_DTCOMPETENCIA_OPER');
    };

    /* jshint ignore:start */
    this.filtrarWidgetMain = async function(widget) {
        // É definido variável lógica, para caso não exista o filtro 'IDATIVO',
        // ele seja montado
        var existe = false;
        
        if (!Util.isEmptyOrBlank(nmFiltrarWidgetMain)) {
            await widget.reload();
            
            await this.alteraDataSourceFilterTabelaFolha(widget, existe);
            
            await widget.reload();
            
            if (nmFiltrarWidgetMain != nomeVerifica) {
                ScreenService.closeSwipe();
                nomeVerifica = nmFiltrarWidgetMain;
            }
            if (nmFiltrarWidgetMain != 'Tabela de Referência' && nmFiltrarWidgetMain !='Tabela de Faixa Etária' && nmFiltrarWidgetMain) {
                widget.actions[0].isVisible = false;
                if (widget.container)
                    widget.container.label = 'Tabela de Referência - ' + nmFiltrarWidgetMain;
            } 
            else if (nmFiltrarWidgetMain == 'Tabela de Referência' || nmFiltrarWidgetMain != 'Tabela de Faixa Etária') {
                widget.actions[0].isVisible = true;
                if (widget.container)
                    widget.container.label = nmFiltrarWidgetMain;
            }
        }

    };
    /* jshint ignore:end */
    
    this.alteraDataSourceFilterTabelaFolha = function(widget, existe) {
        return new Promise((resolve, reject) => {
            try {
                let filter = widget.dataSourceFilter[ABUtilController.retornaFiltro(widget.dataSourceFilter, 'NRTABELAFOLHA')];
                
                // INSS
                if (idFiltrarWidgetMain && nmFiltrarWidgetMain == 'INSS') {
                    filter.value = Array.isArray(idFiltrarWidgetMain) ? idFiltrarWidgetMain : JSON.parse(idFiltrarWidgetMain);
                    filter.operator = "IN";
                }
                
                // irrf
                else if(idFiltrarWidgetMain){
                    filter.value = Array.isArray(idFiltrarWidgetMain) ? idFiltrarWidgetMain : JSON.parse(idFiltrarWidgetMain);
                    filter.operator = "IN";
                }
                
                // faixa etária
                else {
                    var filtro = 0; 
                    if (nmFiltrarWidgetMain == 'Tabela de Faixa Etária')
                        filtro = 5; // variável criada para excluir campos (IRRF, INSS, SF e IRRF_PLR) da tela tabela de faixa etária
                        
                    filter.value = filtro;
                    filter.operator = '>';
                }
        
                // Percorre o array dataSourceFilter, para identificar se existe filtro
                // para 'IDATIVO'.
                widget.dataSourceFilter.forEach(function(obj) {
                    if (obj.name == 'IDATIVO') {
                        existe = true;
                    }
                });
        
                if (!existe) {
                    var obj = {
                        "name": "IDATIVO",
                        "operator": "LIKE",
                        "static": true,
                        "value": "T"
                    };
                    widget.dataSourceFilter.push(obj);
                }
                
                resolve();
            } catch (e) {
                reject(e);
            }
        });
        
    };
    
    this.redirectToDashboard = function() {
        if (Util.isEmptyOrBlank(nmFiltrarWidgetMain)) {
            ScreenService.openWindow('product#dashboard');
        }
    };

    this.ParametrofiltrarWidgetMain = function(id, nm) {
        idFiltrarWidgetMain = id;
        nmFiltrarWidgetMain = nm;
        if (!Util.isEmptyOrBlank(templateManager.containers['product#hcm01003_fpa_tabelaReferencia'])) {
            var widget = templateManager.containers['product#hcm01003_fpa_tabelaReferencia'].getWidget('tabelafolha');
            this.filtrarWidgetMain(widget);
        }
    };

    this.adicionarRowTabela = function(args) {
        var widget = args.owner.widget;
        var widgetMain = templateManager.container.getWidget("tabelafolha");
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
        widget.currentRow.NMTABELAFOLHA = widgetMain.currentRow.NMTABELAFOLHA;
        widget.currentRow.NRTABELAFOLHA = widgetMain.currentRow.NRTABELAFOLHA;
        widget.currentRow.DTINIVIGENCIA = getLocalVar('HCM_DTCOMPETENCIA_OPER');
    };

    this.filtrarWidgetPorTabelaFolha = function(args) {
        var widget = args.owner;
        templateManager.container.getWidget("faixatabela").dataSourceFilter[0].value = widget.currentRow.NRTABELAFOLHA;
    };

    this.widgetsvisiblefalse = function(args) {
        var widget = ABUtilController.checkWidget(args);
        widget.widgets[1].showAsTab = false;
    };

    this.widgetsvisibletrue = function(widget) {
        widget.actions[0].isVisible = true;
        widget.widgets[1].showAsTab = true;
    };

    this.setTabelaFolha = function(args) {
        var widget = args.owner.widget;
        
         if (widget.currentRow.NMTABELAFOLHA == '') {
            ScreenService.showMessage("O Campo 'Nome' Deve Ser Informado.");
            return;
        }
        var route = '/setTabelaFolha';
        if (widget.isValid()) {
            if (ABUtilController.validaDtIniMenorIgualDtFin(widget.currentRow.DTINIVIGENCIA, widget.currentRow.DTFIMVIGENCIA)) {
                if (!widget.backupRow) {
                    widget.currentRow.__is_new = true;
                } else {
                    widget.currentRow.__is_new = false;
                }
                salvarFolha(widget, widget.currentRow, route, true);
            } else {
                ScreenService.showMessage(Messages.DTINI_POST_DTFIM_ERROR);
                return false;
            }
        }
    };

    /**
     * Função responsável por fazer a réplica de um registro da tabela folha, juntamente
     * com suas faixas. Apartir do 'NMTABELAFOLHA' e 'NRTABELAFOLHA'
     */
    this.replicarFolha = function(folhaWidget) {
        var route = '/setReplicarFolhaFaixas';
        var popupReplica = folhaWidget.widgets[0];
        var currentRow = {};
        var old_dtinivigencia = folhaWidget.currentRow.DTINIVIGENCIA;
        var old_nrtabelafolha = folhaWidget.currentRow.NRTABELAFOLHA;
        var new_nmtabelafolha = popupReplica.currentRow.NMTABELAFOLHA;
        var new_dtinivigencia = popupReplica.currentRow.DTINIVIGENCIA;
        var new_dtfimvigencia = popupReplica.currentRow.DTFIMVIGENCIA;
        // Antes de tudo, deve ser validado se foi setado o nome e a data de vigência
        if ((typeof(new_nmtabelafolha) === 'undefined') || (new_nmtabelafolha.length === 0)) {
            ScreenService.showMessage("O Campo 'Nome Nova Tabela' Deve Ser Informado.");
            return;
        }
        if ((typeof(new_dtinivigencia) === 'undefined') || (new_dtinivigencia.length === 0)) {
            ScreenService.showMessage("O Campo 'Início Vigência' Deve Ser Informado.");
            return;
        }
        // É atribuído à currentRow os valores do número do registro
        // e os novos valores: nome, data vigencia inicial e final
        currentRow.oldNRTABELAFOLHA = old_nrtabelafolha;
        currentRow.newNMTABELAFOLHA = new_nmtabelafolha;
        currentRow.oldDTINIVIGENCIA = old_dtinivigencia;
        currentRow.newDTINIVIGENCIA = new_dtinivigencia;
        currentRow.newDTFIMVIGENCIA = new_dtfimvigencia;
        currentRow.__is_new = false;
        currentRow._Sucesso = false;
        salvarFolha(folhaWidget, currentRow, route, false);
    };

    /**
     * Função auxiliar, responsável por fazer o salvamento comum de um registro, ou 
     * por fazer o salvamento de um que será replicado
     */
    var salvarFolha = function(widget, currentRow, route, logico) {
        restEngine.post(route, {
            'requestType': 'DataSet',
            'dataset': [currentRow]
        }).
        then(function(data) {
            if (logico) {
                if (data.notifications[0].type === "success") {
                    ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                    if (currentRow.__is_new) {
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                        self.widgetsvisibletrue(widget);
                    } else {
                        ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                        widget.backupRow = null;
                        widget.view();
                    }
                } else {
                    ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                }
            } else {
                // Caso lógico seja 'false', significa que de fato deu certo a réplica
                // do registro folha e suas faixas, isso porque essa prômisse é de sucesso. 
                // Portanto, não há mal em mostrar mensagem de sucesso para esse caso
                ScreenService.closePopup();
                ABUtilController.masterDetailVoltarList(widget);
                widget.reload();
                ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                currentRow._Sucesso = true;
            }
        }).
        catch(function(e) {
            var error;
            if (e.data.error === undefined)
                error = e;
            else
                error = e.data.error;
            // Validação especial para o update de faixas. Caso ele exista e seja falso,
            // é mostrada mensagem de erro
            if (currentRow._Sucesso === false)
                ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
        });
    };

    this.deleteTabelaFolha = function(args) {
        ScreenService.confirmMessage(Messages.DELETE_ROW, null, function() {
            
            var widget = templateManager.container.getActiveWidget();
            if (widget.isValid()) {
                widget.currentRow.__is_new = false;
                restEngine.post('product#/deleteTabelaFolha', {
                    'requestType': 'DataSet',
                    'dataset': [widget.currentRow]
                }).
                then(function(data) {
                    if (data.messages) {
                        ScreenService.showMessage(Messages.REMOVE_ROW_ERROR + '. ' + data.messages[0].message, data.messages[0].type);
                    } else {
                        ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    }
                }).
                catch(function(e) {
                    var error;
                    if (e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;

                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
            }
        
            
        }, null);
    };

    this.setFaixaTabela = function(args) {
        var widget = args.owner.widget;
        var widgetMain = templateManager.container.getWidget("tabelafolha");
        if (widget.isValid()) {
            if (!widget.backupRow) {
                widget.currentRow.__is_new = true;
            } else {
                widget.currentRow.__is_new = false;
            }
            widget.currentRow.NRTABELAFOLHA = widgetMain.currentRow.NRTABELAFOLHA;
            widget.currentRow.VRLIMITSUPFAIXA = General.valueToFloat(widget.currentRow.VRLIMITSUPFAIXA);
            widget.currentRow.VRPECALCULORESU = General.valueToFloat(widget.currentRow.VRPECALCULORESU);
            widget.currentRow.VRMAXRESULTCALC = General.valueToFloat(widget.currentRow.VRMAXRESULTCALC);
            widget.currentRow.VRAPLICARESULT = General.valueToFloat(widget.currentRow.VRAPLICARESULT);
            salvarFaixa(widget, widget.currentRow, true);
        }
    };

    this.deleteFaixaTabela = function(args) {
        ScreenService.confirmMessage(Messages.DELETE_ROW, null, function() {    
            
        
        
        var widget = args.owner.widget;
        widget.currentRow.__is_new = false;
        restEngine.post('product#/deleteFaixaTabela', {
            'requestType': 'DataSet',
            'dataset': [widget.currentRow]
        }).
        then(function(data) {
            if (data.notifications[0].type === "success") {
                ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                ABUtilController.masterDetailVoltarList(widget);
                widget.reload();
            } else {
                ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
            }
        }).
        catch(function(e) {
            var error;
            if (e.data.error === undefined)
                error = e;
            else
                error = e.data.error;
            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
        });
    
    
        }, null);    
    };

    /**
     * Função para realizar o reajuste de '% Calculo' de todas as faixas de um registro
     * de tabelaFolha
     */
    this.reajustarValores = function(widgetFaixaTabela, fieldPercentagem) {
        var currentRow = widgetFaixaTabela.currentRow;
        var vlrReajuste = fieldPercentagem.value();
        // Antes de tudo, deve ser validado se foi setado o fieldPercentagem
        if ((typeof(vlrReajuste) === 'undefined') || (vlrReajuste.length === 0)) {
            ScreenService.showMessage("O Campo 'Percentual de Reajuste (%)' Deve Ser Informado.");
            return;
        }
        // O valor é convertido para Float, a fim de evitar incompatibilidade
        currentRow.Reajuste = General.valueToFloat(vlrReajuste);
        currentRow.__is_new = false;
        currentRow._Sucesso = false;
        salvarFaixa(widgetFaixaTabela, currentRow, false);
    };

    /**
     * Função auxiliar, chamada para salvar alguma faixa ou atualizar um conjunto
     * de faixas
     */
    var salvarFaixa = function(widget, currentRow, logico) {
        restEngine.post('product#/setFaixaTabela', {
            'requestType': 'DataSet',
            'dataset': [currentRow]
        }).
        then(function(data) {
            // 'logico' é variável que identifica se tem uma inserção comum, ou se
            // é uma atualização de um conjunto de faixas
            if (logico) {
                // Caso 'logico' seja verdadeiro, significa que é uma inserção ou 
                // atualização comum
                if (data.notifications[0].type === "success") {
                    ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                    if (currentRow.__is_new) {
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    } else {
                        ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                        widget.backupRow = null;
                        widget.view();
                    }
                } else {
                    ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                }
            } else {
                // Caso lógico seja 'false', significa que de fato deu certo o update das
                // faixas, porque essa prômisse é de sucesso. Portanto, não há mal em 
                // mostrar mensagem de sucesso para esse caso
                templateManager.container.getWidget('faixatabela').reload();
                ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                currentRow._Sucesso = true;
            }

        }).
        catch(function(e) {
            var error;
            if (e.data.error === undefined)
                error = e;
            else
                error = e.data.error;
            // Validação especial para o update de faixas. Caso ele exista e seja falso,
            // é mostrada mensagem de erro
            if (currentRow._Sucesso === false)
                ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            return;
        });
    };

    /**
     * Função cujo único propósito, é impedir que seja aberta a widget como Tab e 
     * Popup ao mesmo tempo. A causa disso é desconhecida, mas existe essa solução para
     * contornar o problema
     */
    this.validaWidgetReplica = function(tipo, widget) {
        if (tipo === 'abrirPopup') {
            ScreenService.openPopup(templateManager.container.getWidget('replicar')).then(function() {
                templateManager.container.getWidget('replicar').showAsTab = false;
                widget.currentRow.DTINIVIGENCIA = getLocalVar('HCM_DTCOMPETENCIA_OPER');
                widget.redraw();
            });
        }
        if (tipo === 'fecharPopup') {
            ScreenService.closePopup();
            templateManager.container.getWidget('replicar').showAsTab = false;
        }
    };

    /**
     * A seguinte função, tem como objetivo anular a anomalia do botão Add desaparecer 
     * após o mesmo ser clicado.
     */
    this.validaActionAdd = function(widget) {
        var actionAdd = widget.getActions();
        actionAdd[0].isVisible = true;
    };
    

    this.desabilitaReajusteOrgPadrao = function(args, nrorg) {
        var widget = ABUtilController.checkWidget(args);
        var action = widget.getActions();
        action.map(function(action) {
            if(action.name == 'reajuste' && nrorg == 0) {
                action.isVisible = false;
            }
            else if (action.name == 'reajuste' && nrorg != 0) {
                action.isVisible = true;
            }
        });
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('TabelaFolhaController', TabelaFolhaController);
});


// FILE: assets/js/controllers/TabelaSalarialController.js
function TabelaSalarialController(ScreenService, templateManager, localStorageEngine, ZhUtil, $window, restEngine, HcmRepository, ABUtilController, General,Messages) {

    this.adicionarRow = function(args) {
        var widget = args.owner.widget;
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
    };

	this.setFaixaSalario = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
                if (!widget.backupRow) {
                    widget.currentRow.__is_new = true;
                } else {
                    widget.currentRow.__is_new = false;
                }
                widget.currentRow.VRPISOTABSALARIAL = General.valueToFloat(widget.currentRow.VRPISOTABSALARIAL);
                widget.currentRow.VRTETOTABSALARIAL = General.valueToFloat(widget.currentRow.VRTETOTABSALARIAL);
                widget.currentRow.VR1SALTABELA = General.valueToFloat(widget.currentRow.VR1SALTABELA);
                widget.currentRow.VR2SALTABELA = General.valueToFloat(widget.currentRow.VR2SALTABELA);
                widget.currentRow.VR3SALTABELA = General.valueToFloat(widget.currentRow.VR3SALTABELA);
                widget.currentRow.VR4SALTABELA = General.valueToFloat(widget.currentRow.VR4SALTABELA);
                widget.currentRow.VR5SALTABELA = General.valueToFloat(widget.currentRow.VR5SALTABELA);
                widget.currentRow.VR6SALTABELA = General.valueToFloat(widget.currentRow.VR6SALTABELA);
                widget.currentRow.VR7SALTABELA = General.valueToFloat(widget.currentRow.VR7SALTABELA);
                widget.currentRow.VR8SALTABELA = General.valueToFloat(widget.currentRow.VR8SALTABELA);
                widget.currentRow.VR9SALTABELA = General.valueToFloat(widget.currentRow.VR9SALTABELA);
                widget.currentRow.VR10SALTABELA = General.valueToFloat(widget.currentRow.VR10SALTABELA);
                restEngine.post('product#/setFaixaSalario', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                    then(function (data) {
                        if (data.notifications[0].type === "success") {
                            ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                            if (widget.currentRow.__is_new) {
                                ABUtilController.masterDetailVoltarList(widget);
                                widget.reload();
                            } else {
                                ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                                widget.backupRow = null;
                                widget.view();
                            }
                        } else {
                            ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                        }
                    }).
                    catch(function(e) {
                        var error;
                        if(e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;
                            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    });
            }
    };
	
	this.setFaixaSalarioGrid = function(args) {
       var widget = ABUtilController.checkWidget(args);
        var row = [];
        for(var k in widget.dataSource.data){
            if(widget.dataSource.data[k].changed){
                widget.dataSource.data[k].VRPISOTABSALARIAL = General.valueToFloat(widget.dataSource.data[k].VRPISOTABSALARIAL);
                widget.dataSource.data[k].VRTETOTABSALARIAL = General.valueToFloat(widget.dataSource.data[k].VRTETOTABSALARIAL);
                widget.dataSource.data[k].VR1SALTABELA = General.valueToFloat(widget.dataSource.data[k].VR1SALTABELA);
                widget.dataSource.data[k].VR2SALTABELA = General.valueToFloat(widget.dataSource.data[k].VR2SALTABELA);
                widget.dataSource.data[k].VR3SALTABELA = General.valueToFloat(widget.dataSource.data[k].VR3SALTABELA);
                widget.dataSource.data[k].VR4SALTABELA = General.valueToFloat(widget.dataSource.data[k].VR4SALTABELA);
                widget.dataSource.data[k].VR5SALTABELA = General.valueToFloat(widget.dataSource.data[k].VR5SALTABELA);
                widget.dataSource.data[k].VR6SALTABELA = General.valueToFloat(widget.dataSource.data[k].VR6SALTABELA);
                widget.dataSource.data[k].VR7SALTABELA = General.valueToFloat(widget.dataSource.data[k].VR7SALTABELA);
                widget.dataSource.data[k].VR8SALTABELA = General.valueToFloat(widget.dataSource.data[k].VR8SALTABELA);
                widget.dataSource.data[k].VR9SALTABELA = General.valueToFloat(widget.dataSource.data[k].VR9SALTABELA);
                widget.dataSource.data[k].VR10SALTABELA = General.valueToFloat(widget.dataSource.data[k].VR10SALTABELA);
                row.push(widget.dataSource.data[k]);
            }
        }
        restEngine.post('product#/setFaixaSalario', {'requestType': 'DataSet', 'dataset': row}).
            then(function (data) {
                if (data.notifications[0].type === "success") {
                    ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                    ABUtilController.masterDetailVoltarList(widget);
                    widget.reload();
                } else {
                    ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                }
            }).
            catch(function(e) {
                var error;
                if(e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
    
    };
    
    this.deleteFaixaSalario = function(args) {
         ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
         var widget = args.owner.widget;
        widget.currentRow.__is_new = false;
        restEngine.post('product#/deleteFaixaSalario', {'requestType':'DataSet','dataset':[widget.currentRow]}).
            then(function(data){
                if(data.notifications[0].type === "success"){
                    ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                    ABUtilController.masterDetailVoltarList(widget);
                    widget.reload();
                } else {
                    ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                }
            }).
            catch(function(e) {
                var error;
                if(e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
         }, null);
    };
    
    this.exportarTemplateSal = function(args) {
        var widget = args.owner.widget;
        if(widget.isValid()){
            restEngine.post('product#/exportarTemplateSal', {
                'requestType': 'DataSet',
                'dataset': [widget.currentRow]
            }).then(function(data) {
                if(data.dataset && data.dataset.arquivo){
                    $window.open($window.serviceUrl + "/abrirArquivo?requestType=DataSet&dataset[0][CMARQUIVO]=" + data.dataset.arquivo.NMARQUIVO);
                    ScreenService.successNotification(Messages.EXPORTACAO_SUCCESS, 10000);
                    ABUtilController.masterDetailClosePopup(templateManager.container.getWidget("importacaoTemplate"));
                    templateManager.container.getWidget("tabelasala").reload();
                }
                else {
                    ScreenService.showMessage(Messages.EXPORTACAO_ERROR);
                }
            }).catch(function(e) {
                var error;
                if (e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
        }
        
    };
    
    this.importarTemplateSal = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
            restEngine.post('product#/importarTemplateSal', {
                'requestType': 'DataSet',
                'dataset': [widget.currentRow]
            }).
            then(function(data) {
                if (data.notifications[0].type === "success") {
                    ScreenService.successNotification(Messages.IMPORTACAO_SUCCESS, 10000);
                    ScreenService.closePopup(true);
                    templateManager.container.getWidget('tabelasala').reload();
                    templateManager.container.getWidget('tabelasala').activate();
                    widget.reload();
                } else {
                    ScreenService.showMessage(Messages.IMPORTACAO_ERROR);
                }
                
            }).
            catch(function(e) {
                var error;
                if (e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;

                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
        }
    };
    
    this.reajustarSalario = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
            var rows = [];
            widget.parent.parent.dataSource.checkedRows.forEach(function(row){
                for (var i in widget.currentRow.TPVALOR){
                    if (row[widget.currentRow.TPVALOR[i]] != null) {
                        row[widget.currentRow.TPVALOR[i]] = (General.valueToFloat(row[widget.currentRow.TPVALOR[i]])*(parseFloat(widget.currentRow.VRPERCENT)+100)/100).toFixed(2);
                    }
                }
                rows.push(row);
            });
            
            restEngine.post('product#/setFaixaSalario', {'requestType': 'DataSet', 'dataset': rows}).
            then(function (data) {
                if (data.notifications[0].type === "success") {
                    ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                    ABUtilController.masterDetailClosePopup(widget);
                    templateManager.container.getWidget("tabelasala").reload();
                } else {
                    ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                }
            }).
            catch(function(e) {
                var error;
                if(e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
        }
    };
    
    this.copiarTabela = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
            var rows = [];
            widget.parent.parent.dataSource.checkedRows.forEach(function(row){
                if(row.DTINIVIGTABSALARIAL.substr(0,10) == widget.currentRow.DTINIVIGTABSALARIAL) {
                    ScreenService.showMessage("Data de início de vigência não pode ser igual nas duas tabelas!");
                    throw new Error('Data de início de vigência não pode ser igual nas duas tabelas!');
                }
                if(row.DTBASETABSALARIAL.substr(0,10) == widget.currentRow.DTBASETABSALARIAL) {
                    ScreenService.showMessage("Data base salarial não pode ser igual nas duas tabelas!");
                    throw new Error('Data base salarial não pode ser igual nas duas tabelas!');
                }
                
                row.DTINIVIGTABSALARIAL = widget.currentRow.DTINIVIGTABSALARIAL;
                row.DTBASETABSALARIAL   = widget.currentRow.DTBASETABSALARIAL;
                row.NRTABELASALARIAL    = '';
                row.__is_new = true;
                
                rows.push(row);
            });
            
            restEngine.post('product#/setFaixaSalario', {'requestType': 'DataSet', 'dataset': rows}).
            then(function (data) {
                if (data.notifications[0].type === "success") {
                    ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                    ABUtilController.masterDetailClosePopup(widget);
                    templateManager.container.getWidget("tabelasala").reload();
                } else {
                    ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                }
            }).
            catch(function(e) {
                var error;
                if(e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
        }
    };
    
}

Configuration(function(ContextRegister) {
    ContextRegister.register('TabelaSalarialController', TabelaSalarialController);
});

// FILE: assets/js/controllers/TagNameController.js
function TagNameController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, General,Messages) {
    
    this.adicionarRow = function(args) {
        var widget = args.owner.widget;
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
    };
    
	this.setTagName = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
            if (!widget.backupRow) {
                widget.currentRow.__is_new = true;
            } else {
                widget.currentRow.__is_new = false;
            }
            restEngine.post('product#/setEsoTagName', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                then(function (data) {
                    if (data.notifications[0].type === "success") {
                        ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                        if (widget.currentRow.__is_new) {
                            ABUtilController.masterDetailVoltarList(widget);
                            widget.reload();
                        } else {
                            ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                            widget.backupRow = null;
                            widget.view();
                        }
                    } else {
                        ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                    }
                }).
                catch(function(e) {
                    var error;
                    if(e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;
                        ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
        } else {
            //faz a verificação dos campos de código e nome das opções da tag para persistir a mensagem contruída na função ABUtilController.setMensagemDescricaoField
            if(!widget.currentRow.DSCDOPCTAG || !widget.currentRow.DSNMOPCTAG){
                var objetoAviso;
                if(!widget.currentRow.DSCDOPCTAG && widget.currentRow.DSNMOPCTAG){
                    objetoAviso = {DSCDOPCTAG: "Insira os códigos separados por ponto e vírgula"};
                } else if(widget.currentRow.DSCDOPCTAG && !widget.currentRow.DSNMOPCTAG){
                    objetoAviso = {DSNMOPCTAG: "Insira os nomes separados por ponto e vírgula"};
                } else {
                    objetoAviso = {DSCDOPCTAG: "Insira os códigos separados por ponto e vírgula", DSNMOPCTAG: "Insira os nomes separados por ponto e vírgula"};
                }
                ABUtilController.setMensagemDescricaoField(widget, objetoAviso);
            }
        }
    };
    
    this.deleteEsoTagName= function(args) {
    ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
        var widget = args.owner.widget;
        widget.currentRow.__is_new = false;
        restEngine.post('product#/deleteEsoTagName', {'requestType':'DataSet','dataset':[widget.currentRow]}).
            then(function(data){
                if(data.notifications[0].type === "success"){
                    ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                    ABUtilController.masterDetailVoltarList(widget);
                    widget.reload();
                } else {
                    ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                }
            }).
            catch(function(e) {
                var error;
                if(e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
        }, null);
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('TagNameController', TagNameController);
});

// FILE: assets/js/controllers/TarifadetransporteController.js
function TarifadetransporteController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, General, Messages) {

    this.validaPeriodo = function(dtIni, dtFin) {
        if (moment(dtIni, 'DD/MM/YYYY').unix() > moment(dtFin, 'DD/MM/YYYY').unix() || moment(dtFin, 'DD/MM/YYYY').unix() < moment(dtIni, 'DD/MM/YYYY').unix()) {
            return false;
        } else {
            return true;
        }
    };

    this.salvarTarifadetransporte = function(args) {
        var widget = templateManager.container.getActiveWidget();
        if (widget.isValid()) {
            if (this.validaPeriodo(widget.currentRow.DTINITARIFA, widget.currentRow.DTFIMTARIFA)) {
                if (!widget.backupRow) {
                    widget.currentRow.__is_new = true;
                } else {
                    widget.currentRow.__is_new = false;
                }

                widget.currentRow.VRTARIFA = General.valueToFloat(widget.currentRow.VRTARIFA);

                restEngine.post('product#/setTarifatransporte', {
                    'requestType': 'DataSet',
                    'dataset': [widget.currentRow]
                }).
                then(function(data) {
                    if (data.notifications[0].type === "success") {
                        ScreenService.successNotification('Tarifa de transporte salva com sucesso', 10000);
                        if (widget.currentRow.__is_new) {
                            ABUtilController.masterDetailVoltarList(widget);
                            widget.reload();
                        } else {
                            ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                            widget.backupRow = null;
                            widget.view();
                        }
                    } else {
                        ScreenService.showMessage('Erro ao salvar a tarifa de transporte');
                    }
                }).
                catch(function(e) {
                    var error;
                    if (e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;

                    ScreenService.showMessage('Ocorreu um erro inesperado, contate o administrador informando o trecho abaixo: <br><br>' + error + '<br><br>', 'ERROR');
                });
            } else {
                ScreenService.showMessage('A data final deve ser posterior à data inicial.');
                return false;
            }
        }
    };

    this.removerTarifadetransporte = function(args) {
        ScreenService.confirmMessage(Messages.DELETE_ROW, 'CONFIRMATION',
            function() {

                var widget = templateManager.container.getActiveWidget();
                widget.currentRow.__is_new = false;
                restEngine.post('product#/deleteTarifatransporte', {
                    'requestType': 'DataSet',
                    'dataset': [widget.currentRow]
                }).
                then(function(data) {
                    if (data.notifications[0].type === "success") {
                        ScreenService.successNotification('Tarifa de transporte excluída com sucesso', 10000);
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    } else {
                        ScreenService.showMessage('Erro ao excluir a tarifa de transporte');
                    }
                }).
                catch(function(e) {
                    var error;
                    if (e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;

                    ScreenService.showMessage('Ocorreu um erro inesperado, contate o administrador informando o trecho abaixo: <br><br>' + error + '<br><br>', 'ERROR');
                });
            });


    };

}

Configuration(function(ContextRegister) {
    ContextRegister.register('TarifadetransporteController', TarifadetransporteController);
});


// FILE: assets/js/controllers/TemplatesController.js
/**
 * Created by lara loures on 04/05/2016.
 */
function TemplatesController (ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, ABUtilController, ZHPromise, Messages) {
    
    var self = this;
    this.nrtemplate = null;
    
    this.widgetsvisiblefalse = function(widget) {
        widget.widgets[0].showAsTab = false;
    };

    this.widgetsvisibletrue = function(widget) {
        widget.widgets[0].showAsTab = true;
        widget.widgets[0].isVisible = true;
    };
    
    this.cancelaEdicao = function (widget) {
        if(widget.currentRow.__is_new) {
            var indexOfCurrentRow = widget.dataSource.data.indexOf(widget.currentRow);
            if(indexOfCurrentRow !== -1) {
                widget.dataSource.data.pop();
            }
            widget.list();
            ScreenService.closeSwipe();
            widget.activate();
        }
        else {
            Util.extend(widget.currentRow, widget.backupRow);
            widget.view();
        }
    };

    this.puxarCamposFase = function(){
        var widget = templateManager.container.getWidget("templates");
        var nrtemplate = widget.currentRow.NRTEMPLATE;
        var nrorg = getLocalVar("HCM_NRORG_TRAB");   
        restEngine.post("product#/des_fase", {
            requestType: "FilterData",
                filter: [{operator: "=", name: "NRTEMPLATE", value: nrtemplate}, {operator: "=", name : "NRORG", value : nrorg}]}).
        then(function (data) {
            if(data.dataset.buscarDadosFase){
                widget = templateManager.container.getActiveWidget();
                widget.dataSource.data = data.dataset.buscarDadosFase;
            }
        }).catch(function(e) {
            var error;
            if(e.data.error === undefined)
                error = e;
            else 
                error = e.data.error;
            
            ScreenService.showMessage('Ocorreu um erro inesperado, contate o administrador informando o trecho abaixo: <br><br>' + error + '<br><br>', 'ERROR');
        });
    };

    this.puxarCamposFaseTemplate = function(){        
        var widgetTemplate = templateManager.container.getWidget("templates");
        this.nrtemplate = widgetTemplate.currentRow.NRTEMPLATE;
        var widgetFase = templateManager.container.getWidget("fases");
        if(widgetTemplate.currentRow.IDPARTICIPAFASE === 'S'){
            widgetFase.getAction("excluir").isVisible = false;
            widgetFase.getAction("editar").isVisible = false;
        } else {
            widgetFase.getAction("excluir").isVisible = true;
            widgetFase.getAction("editar").isVisible = true;
        }  
    };

    this.puxarFase = function(){
        var widget = templateManager.container.getWidget("templates");
        var nrtemplate = widget.currentRow.NRTEMPLATE;
        widget = templateManager.container.getActiveWidget();
        var nrfase = widget.getField("NRFASE").value();
        var nrorg = getLocalVar("HCM_NRORG_TRAB");   
        restEngine.post("product#/getFases", {
            requestType: "FilterData",
                filter: [{operator: "=", name: "NRTEMPLATE", value: nrtemplate}, {operator: "=", name : "NRORG", value : nrorg}, {operator: "=", name: "NRFASE", value: nrfase}]}).
        then(function (data) {
            if(data.dataset.buscarFase){
                widget.getField("NMFASERELACIONADA").dataSource.data = data.dataset.buscarFase;
            }
        }).catch(function(e) {
            var error;
            if(e.data.error === undefined)
                error = e;
            else 
                error = e.data.error;
            
            ScreenService.showMessage('Ocorreu um erro inesperado, contate o administrador informando o trecho abaixo: <br><br>' + error + '<br><br>', 'ERROR');
        });
    };

    this.salvarDadosTemplate = function(){
        var widget = templateManager.container.getActiveWidget();
        if(!widget.backupRow){
            widget.currentRow.__is_new = true;        
        } else {
            widget.currentRow.__is_new = false;      
        }
        var saveData = Object.assign({}, widget.currentRow, {"NRORG": getLocalVar("HCM_NRORG_TRAB")}, {"CDOPERADOR_LOG": getLocalVar("HCM_CDOPERADOR")});
        restEngine.post('product#/saveTemplates', {'requestType':'DataSet','dataset':[saveData]}).
            then(function(data){
                if(data.notifications[0].type === "success"){
                    ScreenService.successNotification('Template salvo com sucesso', 1000);
                    if (widget.currentRow.__is_new) {
                        ABUtilController.masterDetailVoltarList(widget);
                        self.widgetsvisibletrue(widget);
                        widget.reload();
                    } else {
                        ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                        widget.backupRow = null;
                        widget.view();
                    }
                } else {
                    ScreenService.showMessage('Erro ao salvar o template');
                }
            }).catch(function(e) {
                var error;
                if(e.data.error === undefined)
                    error = e;
                else 
                    error = e.data.error;
                
                ScreenService.showMessage('Ocorreu um erro inesperado, contate o administrador informando o trecho abaixo: <br><br>' + error + '<br><br>', 'ERROR');
            });
    };

    this.salvarDadosFasesTemplate = function(){
        var widget = templateManager.container.getActiveWidget();
        var saveData;
        var save;

        if(!widget.backupRow){
            var widgetTemplate = templateManager.container.getWidget("templates");
            var widgetFase = templateManager.container.getWidget("fases");
            widgetTemplate.currentRow.__is_new = true;
            widget.currentRow.__is_new = true;
            saveData = Object.assign({}, widgetTemplate.currentRow, {"FASES": widget.dataSource.checkedRows}, {"NRORG": getLocalVar("HCM_NRORG_TRAB")}, {"CDOPERADOR_LOG": getLocalVar("HCM_CDOPERADOR")});
            save = true;
        } else {
            widget.currentRow.__is_new = false;  
            saveData = Object.assign({}, widget.currentRow, {"NRORG": getLocalVar("HCM_NRORG_TRAB")}, {"CDOPERADOR_LOG": getLocalVar("HCM_CDOPERADOR")});
            save = false;
        }
        restEngine.post('product#/salvarDadosFaseTemplate', {'requestType':'DataSet','dataset':[saveData]}).
            then(function(data){
                if(data.notifications[0].type === "success"){
                    ScreenService.successNotification('Fase(s) salva(s) com sucesso', 1000);
                    this.puxarCamposFaseTemplate();
                    if(save === true){
                        ABUtilController.masterDetailClosePopup(widget);
                    } else  if(save === false){
                        ABUtilController.masterDetailVoltarList(widget);
                    }
                } else {
                    ScreenService.showMessage('Erro ao salvar a(s) Fase(s)');
                }
                widgetFase.reload();
            }.bind(this)
            ).catch(function(e) {
                var error;
                if(e.data.error === undefined)
                    error = e;
                else 
                    error = e.data.error;
                
                ScreenService.showMessage('Ocorreu um erro inesperado, contate o administrador informando o trecho abaixo: <br><br>' + error + '<br><br>', 'ERROR');
            });
    };

    this.setDadosFase = function(){
        var widget = templateManager.container.getActiveWidget();
        var widget1 = templateManager.container.getWidget("templates");

        if(widget1.getField("NRTEMPLATE").value()){
            widget.getField("NRTEMPLATE").setValue(widget1.getField("NRTEMPLATE").value());
            widget.currentRow.NRTEMPLATE = widget1.getField("NRTEMPLATE").value();
        }
    };

    this.setPossiveisFasesRelacionadas = function(){
        var widget = templateManager.container.getActiveWidget();
        var relacionaDataSourceFilter = widget.getField('NMFASERELACIONADA').dataSourceFilter;
        var nrfase = widget.currentRow.NRFASE;
        if(nrfase == widget.currentRow.NRFASERELACIONADA) {
            widget.currentRow.NRFASERELACIONADA = null;
            widget.currentRow.NMFASERELACIONADA = "";
        }
        relacionaDataSourceFilter[0].value = nrfase;
        widget.getField("NMFASERELACIONADA").readOnly = false;
    };

    this.removerDadosTemplate = function(){
    ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
        var widget = templateManager.container.getActiveWidget();
        var widgetFase = templateManager.container.getWidget("fases");
        widget.currentRow.__is_new = false;
        
        if(widgetFase.dataSource.data.length >0){
            ScreenService.showMessage('Ainda existem fases no template. Deseja realmente exclui-lo?');
        } else {
            self.removeTemplate(widget, widgetFase.dataSource.data);
            }
        }, null);
    };

    this.removeTemplate = function(widget, dataSourceFases){
        var saveData = Object.assign({}, widget.currentRow, {"NRORG": getLocalVar("HCM_NRORG_TRAB")}, {"CDOPERADOR_LOG": getLocalVar("HCM_CDOPERADOR")}, {"FASES": dataSourceFases});
            restEngine.post('product#/removeTemplate', {'requestType':'DataSet','dataset':[saveData]}).
                then(function(data){
                    if(data.notifications[0].type === "success"){
                        ScreenService.successNotification('Template removido com sucesso', 1000);
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    } else {
                        ScreenService.showMessage('Erro ao remover o template');
                    }
                }).catch(function(e) {
                    var error;
                    if(e.data.error === undefined)
                        error = e;
                    else 
                        error = e.data.error;
                    
                    ScreenService.showMessage('Ocorreu um erro inesperado, contate o administrador informando o trecho abaixo: <br><br>' + error + '<br><br>', 'ERROR');
                });
    };

    this.removerDadosFaseTemplate = function(){
    ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
        var widget = templateManager.container.getActiveWidget();
        widget.currentRow.__is_new = false;
        var saveData = Object.assign({}, widget.currentRow, {"NRORG": getLocalVar("HCM_NRORG_TRAB")}, {"CDOPERADOR_LOG": getLocalVar("HCM_CDOPERADOR")});
        restEngine.post('product#/removeFaseTemplate', {'requestType':'DataSet','dataset':[saveData]}).
            then(function(data){
                if(data.notifications[0].type === "success"){
                    ScreenService.successNotification('Template removido com sucesso', 1000);
                    ABUtilController.masterDetailVoltarList(widget);
                    widget.reload();
                } else {
                    ScreenService.showMessage('Erro ao remover o template');
                }
            }).catch(function(e) {
                var error;
                if(e.data.error === undefined)
                    error = e;
                else 
                    error = e.data.error;
                
                ScreenService.showMessage('Ocorreu um erro inesperado, contate o administrador informando o trecho abaixo: <br><br>' + error + '<br><br>', 'ERROR');
            });
        }, null);
    };

    this.verificaIdInativo = function(){
        var widgetTemplate = templateManager.container.getWidget("templates");
        var widgetFase = templateManager.container.getWidget("fases");
        
        restEngine.post("product#/verificaIdInativo",
        {
            requestType: "FilterData",
            filter: [{operator: "=", name: "NRTEMPLATE", value: widgetTemplate.currentRow.NRTEMPLATE},{ operator: "=", name: "NRORG", value: widgetTemplate.currentRow.NRORG}]
        },
        function(data){
            for(var i=0; i<data.dataset.buscarIdAtivo.length;i++){
                if(data.dataset.buscarIdAtivo[i].IDINATIVARPROCESSO === 'S'){
                    if(data.dataset.buscarIdAtivo[i].NRFASE !== widgetFase.currentRow.NRFASE){
                        ScreenService.showMessage('Não é possivel ter mais de uma fase inativando o processo');
                        widgetFase.currentRow.IDINATIVARPROCESSO = 'N';
                    }
                }
            }
        });
    };
    
}

Configuration(function(ContextRegister) {
    ContextRegister.register('TemplatesController', TemplatesController);
});

// FILE: assets/js/controllers/TipoAcaoController.js
function TipoAcaoController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, General,Messages) {

    this.adicionarRow = function(args) {
        var widget = args.owner.widget;
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
    };
    
	this.setTipoAcao = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
                if (!widget.backupRow) {
                    widget.currentRow.__is_new = true;
                } else {
                    widget.currentRow.__is_new = false;
                }
                restEngine.post('product#/setTipoAcao', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                    then(function (data) {
                        if (data.notifications[0].type === "success") {
                            ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                            if (widget.currentRow.__is_new) {
                                ABUtilController.masterDetailVoltarList(widget);
                                widget.reload();
                            } else {
                                ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                                widget.backupRow = null;
                                widget.view();
                            }
                        } else {
                            ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                        }
                    }).
                    catch(function(e) {
                        var error;
                        if(e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;
                            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    });
            }
    };
    
    this.deleteTipoAcao = function(args) {
    ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
        var widget = args.owner.widget;
        widget.currentRow.__is_new = false;
        restEngine.post('product#/deleteTipoAcao', {'requestType':'DataSet','dataset':[widget.currentRow]}).
            then(function(data){
                if(data.notifications[0].type === "success"){
                    ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                    ABUtilController.masterDetailVoltarList(widget);
                    widget.reload();
                } else {
                    ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                }
            }).
            catch(function(e) {
                var error;
                if(e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
        }, null);
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('TipoAcaoController', TipoAcaoController);
});

// FILE: assets/js/controllers/TipoAcidenteController.js
function TipoAcidenteController(ScreenService, templateManager, restEngine, ABUtilController, Messages) {

	this.salvar = function(args) {
        var widget = templateManager.container.getActiveWidget();
        if (widget.isValid()) {
            if (!widget.backupRow) {
                widget.currentRow.__is_new = true;
            } else {
                widget.currentRow.__is_new = false;
            }
            restEngine.post('product#/setTipoacidente', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                then(function (data) {
                    if (data.notifications[0].type === "success") {
                        ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                        if (widget.currentRow.__is_new) {
                            ABUtilController.masterDetailVoltarList(widget);
                            widget.reload();
                        } else {
                            ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                            widget.backupRow = null;
                            widget.view();
                        }
                    }else if(data.notifications[0].message === 'DUPLICATE_PRIMARY_KEY_ERROR'){
                        ScreenService.showMessage(Messages.DUPLICATE_PRIMARY_KEY_ERROR);
                    }else {
                        ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                    }
                }).
                catch(function(e) {
                    var error;
                    if(e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;

                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
        }
    };

    this.remover = function(args) {
        var widget = templateManager.container.getActiveWidget();
        if (widget.isValid()) {
            widget.currentRow.__is_new = false;
            restEngine.post('product#/deleteTipoacidente', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                then(function (data) {
                    if (data.notifications[0].type === "success") {
                        ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    } else {
                        ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                    }
                }).
                catch(function(e) {
                    var error;
                    if(e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;

                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
        }
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('TipoAcidenteController', TipoAcidenteController);
});

// FILE: assets/js/controllers/TipoAdmissaoController.js
function TipoAdmissaoController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, General,Messages) {

    this.adicionarRow = function(args) {
        var widget = args.owner.widget;
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
    };

	this.setTipoAdmissao = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
                if (!widget.backupRow) {
                    widget.currentRow.__is_new = true;
                } else {
                    widget.currentRow.__is_new = false;
                }
                restEngine.post('product#/setTipoAdmissao', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                    then(function (data) {
                        if (data.notifications[0].type === "success") {
                            ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                            if (widget.currentRow.__is_new) {
                                ABUtilController.masterDetailVoltarList(widget);
                                widget.reload();
                            } else {
                                ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                                widget.backupRow = null;
                                widget.view();
                            }
                        } else {
                            ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                        }
                    }).
                    catch(function(e) {
                        var error;
                        if(e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;
                            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    });
            }
    };
    
    this.deleteTipoAdmissao = function(args) {
         ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
        var widget = args.owner.widget;
        widget.currentRow.__is_new = false;
        restEngine.post('product#/deleteTipoAdmissao', {'requestType':'DataSet','dataset':[widget.currentRow]}).
            then(function(data){
                if(data.notifications[0].type === "success"){
                    ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                    ABUtilController.masterDetailVoltarList(widget);
                    widget.reload();
                } else {
                    ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                }
            }).
            catch(function(e) {
                var error;
                if(e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
         }, null);
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('TipoAdmissaoController', TipoAdmissaoController);
});

// FILE: assets/js/controllers/TipoApuracaoFrequenciaController.js
function TipoApuracaoFrequenciaController (ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, $window, ABUtilController, Messages) {
    this.deleteTipoApuracaoFrequencia = function(args) {
        var widget = args.owner.widget;
        var data = {}; 
        ScreenService.confirmMessage(Messages.DELETE_ROW, 'CONFIRMATION', 
            function(){
                widget.dataSource.remove(widget.currentRow).then(function (data){
                    if(data.dataset.ptoTipoApuracaoFreq_setTipoApuracaoFreq.type === "success"){
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                        ScreenService.showMessage(Messages.REMOVE_ROW_SUCCESS); 
                    } else {
                        ScreenService.showMessage(Messages.REMOVE_ROW_ERROR); 
                    }
                });
            }.bind(this)
        );
    };

    this.salvarTipoApuracaoFrequencia = function(argsRow){
        var widget = templateManager.container.getWidget("tipoApuracaoFrequencia");
        if(widget.isValid())  {
            
            if (!widget.backupRow) {
                widget.currentRow.__is_new = true;
            } else {
                widget.currentRow.__is_new = false;
            }
            widget.currentRow.CDOPERADOR_LOG = getLocalVar("HCM_CDOPERADOR");
            widget.currentRow.NRORGTRAB = getLocalVar("HCM_NRORG_TRAB");
            widget.currentRow.DTATUAL = getLocalVar("HCM_DATA_ATUAL");
            return widget.saveRow().then(function (data){
                if (data.notifications[0].type === "success") {
                    ScreenService.showMessage(Messages.SAVE_ROW_SUCCESS);
                    if (widget.currentRow.__is_new) {
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    } else {
                        ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                        widget.backupRow = null;
                        widget.view();
                    }
                } else {
                    ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                }
            }).catch(function(e) {
                var error;
                if(e.data.error === undefined)
                    error = e;
                else 
                    error = e.data.error;
                
                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error));
            });
        }
    };

}

Configuration(function(ContextRegister) {
    ContextRegister.register('TipoApuracaoFrequenciaController', TipoApuracaoFrequenciaController);
});

// FILE: assets/js/controllers/TipoAssociacaoContabilController.js
function TipoAssociacaoContabilController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, General, Messages, $window) {

    
    this.adicionarRow = function(args) {
        var widget = args.owner.widget;
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
    };
    
    this.setTipoAssociacaoContabil = function() {
        var widget = templateManager.container.getWidget("tpssociacaoContabil");
        if (widget.isValid()) {
            if (!widget.backupRow) {
                widget.currentRow.__is_new = true;
            } else {
                widget.currentRow.__is_new = false;
            }
            restEngine.post('product#/setTipoAssociacaoContabil', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
             then(function(data){
                if (data.messages) {
                    ScreenService.showMessage(data.messages[0].message, data.messages[0].type);
                    if(data.messages[1] && data.messages[1].type == 'E'){
                        ScreenService.errorNotification(data.messages[1].message, 1000);
                    }
                } else if (data.notifications && data.notifications[0].type === "success") {
                    ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                    if (widget.currentRow.__is_new) {
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    } else {
                        ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                        widget.backupRow = null;
                        widget.view();
                    }
                } else {
                    ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                }
            }).catch(function(e){
                var error;
                    if(e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;
                        ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
        }
    };
    
    this.deleteTipodeAssociacao = function(args) {
    ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
        var widget = args.owner.widget;
        widget.currentRow.__is_new = false;
        restEngine.post('product#/deleteTipodeAssociacao', {'requestType':'DataSet','dataset':[widget.currentRow]}).
            then(function(data){
                if(data.notifications[0].type === "success"){
                    ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                    ABUtilController.masterDetailVoltarList(widget);
                    widget.reload();
                } else {
                    ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                }
            }).
            catch(function(e) {
                var error;
                if(e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
        }, null);
    };
    
}

Configuration(function(ContextRegister) {
    ContextRegister.register('TipoAssociacaoContabilController', TipoAssociacaoContabilController);
});

// FILE: assets/js/controllers/TipoAvaliacaoController.js
function TipoAvaliacaoController(ScreenService, templateManager, restEngine, ABUtilController, Messages, General) {
    
    var self = this;
    
    this.adicionarRow = function(args) {
        var widget = args.owner.widget;
        widget.currentRow = {};
        widget.backupRow = undefined;
        templateManager.container.getWidget('tabbedAvaliacao').isVisible = false;
        templateManager.container.getWidget('temaAnalise').isVisible = false;
        widget.newRow();
        
       
    };
    
    this.cancelaEdicao = function(args){
        if(args.currentRow.__is_new) {
            var indexOfCurrentRow = args.dataSource.data.indexOf(args.currentRow);
            if(indexOfCurrentRow !== -1) {
                args.dataSource.data.pop();
            }
            args.list();
            ScreenService.closeSwipe();
            args.activate();
        }
        else {
            Util.extend(args.currentRow, args.backupRow);
            args.view();
        }
        templateManager.container.getWidget('tabbedAvaliacao').isVisible = true;
        templateManager.container.getWidget('temaAnalise').isVisible = true;
    };
    
    this.salvar = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
            if (!widget.backupRow) {
                        widget.currentRow.__is_new = true;
                    } else {
                        widget.currentRow.__is_new = false;
                    }
                    restEngine.post('product#/setTipoAvaliacao', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                        then(function (data) {
                            if (!Util.isUndefined(data.notifications) && data.notifications[0].type === "success") {
                                ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                                if (data.notifications.length > 1) {
                                    data.notifications.shift();
                                    data.notifications.forEach(function (notification) {
                                        ScreenService.notificationMessage(notification.message, 10000);
                                    });
                                }
                                if (!Util.isUndefined(data.messages)) {
                                    ScreenService.showMessage(data.messages[0].message, data.messages[0].type);
                                }
                                if (widget.currentRow.__is_new) {
                                    ABUtilController.masterDetailVoltarList(widget);
                                    widget.reload();
                                } else {
                                    ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                                    widget.backupRow = null;
                                    widget.view();
                                }
                            } else if (!Util.isUndefined(data.messages)) {
                                ScreenService.showMessage(data.messages[0].message, data.messages[0].type);
                            } else {
                                ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                            }
                        }).
                        catch(function (e) {
                            var error;
                            if (e.data.error === undefined)
                                error = e;
                            else
                                error = e.data.error;

                            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                        });
        }
    templateManager.container.getWidget('tabbedAvaliacao').isVisible = true;
    };
    
    this.salvarQuestao = function(args) {
        var widget = args.owner.widget;
        widgetPai = templateManager.container.getWidget("tipoavaliacao");
        if (widget.isValid()) {
            widget.currentRow.NRTIPOAVALIACAO = widgetPai.currentRow.NRTIPOAVALIACAO;
            if (!widget.backupRow) {
                        widget.currentRow.__is_new = true;
                    } else {
                        widget.currentRow.__is_new = false;
                    }
                    restEngine.post('product#/setTipoAvaliacaoQuestao', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                        then(function (data) {
                            if (!Util.isUndefined(data.notifications) && data.notifications[0].type === "success") {
                                ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                                if (data.notifications.length > 1) {
                                    data.notifications.shift();
                                    data.notifications.forEach(function (notification) {
                                        ScreenService.notificationMessage(notification.message, 10000);
                                    });
                                }
                                if (!Util.isUndefined(data.messages)) {
                                    ScreenService.showMessage(data.messages[0].message, data.messages[0].type);
                                }
                                if (widget.currentRow.__is_new) {
                                    ABUtilController.masterDetailVoltarList(widget);
                                    widget.reload();
                                } else {
                                    ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                                    widget.backupRow = null;
                                    widget.view();
                                }
                            } else if (!Util.isUndefined(data.messages)) {
                                ScreenService.showMessage(data.messages[0].message, data.messages[0].type);
                            } else {
                                ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                            }
                        }).
                        catch(function (e) {
                            var error;
                            if (e.data.error === undefined)
                                error = e;
                            else
                                error = e.data.error;

                            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                        });
        }
    templateManager.container.getWidget('temaAnalise').isVisible = true;    
    templateManager.container.getWidget('tabbedAvaliacao').isVisible = true;
    };
    
    this.removerTipo = function(args) {
        var widget = args.owner.widget;
        widget.currentRow.__is_new = false;
            ScreenService.confirmMessage(Messages.DELETE_ROW, 'CONFIRMATION',
            function(){
                restEngine.post('product#/deleteTipoAvaliacao', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                    then(function (data) {
                        if(data.notifications && data.notifications[0].type === "success"){
                            ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                            ABUtilController.masterDetailVoltarList(widget);
                            widget.reload();
                        } else if(data.dataset){
                            ScreenService.confirmMessage(Messages.HCM03000_AVL_QUESTOES_TIPO_VINCULADAS, 'CONFIRMATION',
                            function(){
                                var questoes = data.dataset.questoes;
                                questoes.forEach(function(questao){
                                    questao.__is_new = false;
                                    if(questao.NRTIPOAVALIACAO === widget.currentRow.NRTIPOAVALIACAO){
                                        restEngine.post('product#/deleteTipoAvaliacaoQuestao', {'requestType':'DataSet','dataset':[questao]}).
                                        then(function(data){
                                            if(data.notifications[0].type != "success"){
                                                ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                                            }
                                        });
                                    }
                                });
                                widget.widgets[ABUtilController.retornaWidget(widget, 'tabbedAvaliacao')].dataSource.reload();
                                ScreenService.successNotification("Questões excluídas com sucesso.", 10000);
                                self.removerTipo(args);
                                
                            });
                        }else {
                            ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                        }
                    }).
                    catch(function(e) {
                        var error;
                        if (e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;

                        ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    });
            });
    };
    this.removerQuestao = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
            widget.currentRow.__is_new = false;
            ScreenService.confirmMessage(Messages.DELETE_ROW, 'CONFIRMATION',
            function(){
                restEngine.post('product#/deleteTipoAvaliacaoQuestao', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                    then(function (data) {
                        if (data.messages) {
                            ScreenService.showMessage(Messages.REMOVE_ROW_ERROR + '. ' + data.messages[0].message, data.messages[0].type);
                        } else {
                            ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                            ABUtilController.masterDetailVoltarList(widget);
                            widget.reload();
                        }
                    }).
                    catch(function(e) {
                        var error;
                        if(e.data.error === undefined){
                            error = e;
                        }    
                        else{
                            error = e.data.error;
                            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                        }    
                    });
            });
        }
    };

    this.filtraQuestao = function(widget){
        var widgetFilha = templateManager.container.getWidget('tabbedAvaliacao');
        var widgetTema = templateManager.container.getWidget('temaAnalise');
        widgetFilha.dataSourceFilter[1].value = widget.currentRow.NRTIPOAVALIACAO;
        widgetTema.dataSourceFilter[1].value = widget.currentRow.NRTIPOAVALIACAO;
    };
    
    this.salvarTemaAnalise = function(args) {
    var widget = args.owner.widget;
    widgetPai = templateManager.container.getWidget("tipoavaliacao");
    if (widget.isValid()) {
        widget.currentRow.NRTIPOAVALIACAO = widgetPai.currentRow.NRTIPOAVALIACAO;
        if (!widget.backupRow) {
                    widget.currentRow.__is_new = true;
                } else {
                    widget.currentRow.__is_new = false;
                }
                restEngine.post('product#/setTemaAnalise', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                    then(function (data) {
                        if (!Util.isUndefined(data.notifications) && data.notifications[0].type === "success") {
                            ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                            if (data.notifications.length > 1) {
                                data.notifications.shift();
                                data.notifications.forEach(function (notification) {
                                    ScreenService.notificationMessage(notification.message, 10000);
                                });
                            }
                            if (!Util.isUndefined(data.messages)) {
                                ScreenService.showMessage(data.messages[0].message, data.messages[0].type);
                            }
                            if (widget.currentRow.__is_new) {
                                ABUtilController.masterDetailVoltarList(widget);
                                widget.reload();
                            } else {
                                ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                                widget.backupRow = null;
                                widget.view();
                            }
                        } else if (!Util.isUndefined(data.messages)) {
                            ScreenService.showMessage(data.messages[0].message, data.messages[0].type);
                        } else {
                            ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                        }
                    }).
                    catch(function (e) {
                        var error;
                        if (e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;

                        ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    });
            }
    templateManager.container.getWidget('tabbedAvaliacao').isVisible = true;
    };
    
    this.removerTema = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
            widget.currentRow.__is_new = false;
            ScreenService.confirmMessage(Messages.DELETE_ROW, 'CONFIRMATION',
            function(){
                restEngine.post('product#/deleteTemaAnalise', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                    then(function (data) {
                        if (data.messages) {
                            ScreenService.showMessage(Messages.REMOVE_ROW_ERROR + '. ' + data.messages[0].message, data.messages[0].type);
                        } else {
                            ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                            ABUtilController.masterDetailVoltarList(widget);
                            widget.reload();
                        }
                    }).
                    catch(function(e) {
                        var error;
                        if(e.data.error === undefined){
                            error = e;
                        }    
                        else{
                            error = e.data.error;
                            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                        }    
                    });
            });
        }
    };
    
}

Configuration(function(ContextRegister) {
    ContextRegister.register('TipoAvaliacaoController', TipoAvaliacaoController);
});

// FILE: assets/js/controllers/TipoBeneficioController.js
function TipoBeneficioController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, General, Messages) {


    this.adicionarRow = function(args) {
        var widget = args.owner.widget;
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
    };

    this.salvarTipoBeneficio = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
            if (!widget.backupRow) {
                widget.currentRow.__is_new = true;
            } else {
                widget.currentRow.__is_new = false;
            }

            widget.currentRow.VRTARIFA = General.valueToFloat(widget.currentRow.VRTARIFA);

            restEngine.post('product#/setTipoBeneficio', {
                'requestType': 'DataSet',
                'dataset': [widget.currentRow]
            }).
            then(function(data) {
                if (data.notifications[0].type === "success") {
                    ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                    if (widget.currentRow.__is_new) {
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    } else {
                        ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                        widget.backupRow = null;
                        widget.view();
                    }
                } else {
                    ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                }
            }).
            catch(function(e) {
                var error;
                if (e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
        }

    };

    this.removerTipoBeneficio = function(args) {
        ScreenService.confirmMessage(Messages.DELETE_ROW, 'CONFIRMATION',
            function() {
                var widget = args.owner.widget;
                widget.currentRow.__is_new = false;
                restEngine.post('product#/removerTipoBeneficio', {
                    'requestType': 'DataSet',
                    'dataset': [widget.currentRow]
                }).
                then(function(data) {
                    if (data.notifications[0].type === "success") {
                        ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    } else {
                        ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                    }
                }).
                catch(function(e) {
                    var error;
                    if (e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
            });
    };

}

Configuration(function(ContextRegister) {
    ContextRegister.register('TipoBeneficioController', TipoBeneficioController);
});


// FILE: assets/js/controllers/TipoCalculoController.js
function TipoCalculoController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, General,Messages) {
    
    var self = this;
    
    this.adicionarRow = function(args) {
        var widget = args.owner.widget;
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
    };
    
    this.filtrarWidgetPorTipoCalculo = function(args){
        var widget = args.owner;
        templateManager.container.getWidget("calculoMovimento").dataSourceFilter[0].value = widget.currentRow.NRTIPOCALCULO;
    };
    
    this.widgetsvisiblefalse = function(args) {
        var widget = args.owner.widget;
        widget.widgets[0].showAsTab = false;
    };

    this.widgetsvisibletrue = function(args) {
        var widget = args.owner.widget;
        widget.widgets[0].showAsTab = true;
    };
    
	this.setTipoCalculo = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
            if (!widget.backupRow) {
                widget.currentRow.__is_new = true;
            } else {
                widget.currentRow.__is_new = false;
            }
            restEngine.post('product#/setTipoCalculo', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                then(function (data) {
                    if (data.notifications[0].type === "success") {
                        ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                        if (widget.currentRow.__is_new) {
                            ABUtilController.masterDetailVoltarList(widget);
                            self.widgetsvisibletrue(args);
                            widget.reload();
                        } else {
                            ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                            widget.backupRow = null;
                            widget.view();
                        }
                    } else {
                        ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                    }
                }).
                catch(function(e) {
                    var error;
                    if(e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;
                        ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
        }
    };
    
    this.deleteTipoCalculo = function(args) {
    ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
        var widget = templateManager.container.getActiveWidget();
        if (widget.isValid()) {
            widget.currentRow.__is_new = false;
            restEngine.post('product#/deleteTipoCalculo', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                then(function (data) {
                    if (data.messages) {
                        ScreenService.showMessage(Messages.REMOVE_ROW_ERROR + '. ' + data.messages[0].message, data.messages[0].type);
                    } else {
                        ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    }
                }).
                catch(function(e) {
                    var error;
                    if(e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;

                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
            }
        }, null);
    };
    
	this.setCalculoMovimento = function(args) {
        var widget = args.owner.widget;
        var widgetMain = templateManager.container.getWidget("tipoCalculo");
        if (widget.isValid()) {
                if (!widget.backupRow) {
                    widget.currentRow.__is_new = true;
                } else {
                    widget.currentRow.__is_new = false;
                }
                widget.currentRow.NRTIPOCALCULO = widgetMain.currentRow.NRTIPOCALCULO;
                restEngine.post('product#/setCalculoMovimento', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                    then(function (data) {
                        if(data.messages){
                            ScreenService.showMessage(data.messages[0].message);
                        }else{
                            if (data.notifications[0].type === "success") {
                                ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                                if (widget.currentRow.__is_new) {
                                    ABUtilController.masterDetailVoltarList(widget);
                                    widget.reload();
                                } else {
                                    ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                                    widget.backupRow = null;
                                    widget.view();
                                }
                            } else {
                                ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                            }
                        }    
                    }).
                    catch(function(e) {
                        var error;
                        if(e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;
                            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    });
        }
    };
    
    this.deleteCalculoMovimento = function(args) {
        var widget = args.owner.widget;
        widget.currentRow.__is_new = false;
        restEngine.post('product#/deleteCalculoMovimento', {'requestType':'DataSet','dataset':[widget.currentRow]}).
            then(function(data){
                if(data.notifications[0].type === "success"){
                    ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                    ABUtilController.masterDetailVoltarList(widget);
                    widget.reload();
                } else {
                    ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                }
            }).
            catch(function(e) {
                var error;
                if(e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('TipoCalculoController', TipoCalculoController);
});

// FILE: assets/js/controllers/TipoCalendarioController.js
function TipoCalendarioController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, General,Messages) {

    this.adicionarRow = function(args) {
        var widget = args.owner.widget;
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
    };

	this.setTipoCalendario = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
                if (!widget.backupRow) {
                    widget.currentRow.__is_new = true;
                } else {
                    widget.currentRow.__is_new = false;
                }
                restEngine.post('product#/setTipoCalendario', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                    then(function (data) {
                        if (data.notifications[0].type === "success") {
                            ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                            if (widget.currentRow.__is_new) {
                                ABUtilController.masterDetailVoltarList(widget);
                                widget.reload();
                            } else {
                                ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                                widget.backupRow = null;
                                widget.view();
                            }
                        } else {
                            ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                        }
                    }).
                    catch(function(e) {
                        var error;
                        if(e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;
                            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    });
            }
    };
    
    this.deleteTipoCalendario = function(args) {
             ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
        var widget = args.owner.widget;
        widget.currentRow.__is_new = false;
        restEngine.post('product#/deleteTipoCalendario', {'requestType':'DataSet','dataset':[widget.currentRow]}).
            then(function(data){
                if(data.notifications[0].type === "success"){
                    ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                    ABUtilController.masterDetailVoltarList(widget);
                    widget.reload();
                } else {
                    ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                }
            }).
            catch(function(e) {
                var error;
                if(e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
     }, null);

    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('TipoCalendarioController', TipoCalendarioController);
});

// FILE: assets/js/controllers/TipoComiteController.js
function TipoComiteController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, General,Messages) {

    var self = this;
    
    this.adicionarRow = function(args) {
        var widget = args.owner.widget;
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
    };
    
    this.filtrarWidgetsPorComite = function(args){
        var widget = args.owner;
        templateManager.container.getWidget("tiporeuniao").dataSourceFilter[2].value = widget.currentRow.NRTIPOCOMITE;
        templateManager.container.getWidget("ocupacao").dataSourceFilter[2].value = widget.currentRow.NRTIPOCOMITE;
    };
    
    this.estabilidadeHabilitaQtDias = function(){
        var widget = templateManager.container.getWidget("ocupacao");
        if(widget.currentRow.IDESTABILIDADE === 'S'){
            widget.getField('QTDIASESTABILIDADE').readOnly = false;
            
        }else{
            widget.getField('QTDIASESTABILIDADE').readOnly = true;
            widget.currentRow.QTDIASESTABILIDADE = "";
        }
    };
    
    this.ocupacaoAfterMoveRow = function(widget){
        if(widget.currentRow.IDESTABILIDADE === 'S'){
            widget.getField('QTDIASESTABILIDADE').readOnly = false;
            
        }else{
            widget.getField('QTDIASESTABILIDADE').readOnly = true;
            widget.currentRow.QTDIASESTABILIDADE = "";
        }
        templateManager.container.getWidget("tipodireitoocupacao").dataSourceFilter[0].value = widget.currentRow.NRTIPOCOMITEOCUP;
    };
    
    this.widgetsvisiblefalse = function(args) {
        var widget = args.owner.widget;
        widget.widgets[0].showAsTab = false;
        if(widget.widgets.length > 1){
            widget.widgets[1].showAsTab = false;
        }
    };

    this.widgetsvisibletrue = function(args) {
        var widget = args.owner.widget;
        widget.widgets[0].showAsTab = true;
        if(widget.widgets.length > 1){
            widget.widgets[1].showAsTab = true;
        }
    };
    
	this.setTipoComite = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
                if (!widget.backupRow) {
                    widget.currentRow.__is_new = true;
                } else {
                    widget.currentRow.__is_new = false;
                }
                restEngine.post('product#/setTipoComite', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                    then(function (data) {
                        if (data.notifications[0].type === "success") {
                            ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                            if (widget.currentRow.__is_new) {
                                ABUtilController.masterDetailVoltarList(widget);
                                self.widgetsvisibletrue(args);
                                widget.reload();
                            } else {
                                ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                                widget.backupRow = null;
                                widget.view();
                            }
                        } else {
                            ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                        }
                    }).
                    catch(function(e) {
                        var error;
                        if(e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;
                            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    });
            }
    };
    
    this.deleteTipoComite = function(args) {
    ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
        var widget = templateManager.container.getActiveWidget();
        if (widget.isValid()) {
            widget.currentRow.__is_new = false;
            restEngine.post('product#/deleteTipoComite', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                then(function (data) {
                    if (data.messages) {
                        ScreenService.showMessage(Messages.REMOVE_ROW_ERROR + '. ' + data.messages[0].message, data.messages[0].type);
                    } else {
                        ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    }
                }).
                catch(function(e) {
                    var error;
                    if(e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;

                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
            }
        }, null);
    };
    
	this.setTipoComiteReuniao = function(args) {
        var widget = args.owner.widget;
        var widgetMain = templateManager.container.getWidget("tipocomite");
        if (widget.isValid()) {
            if (!widget.backupRow) {
                widget.currentRow.__is_new = true;
            } else {
                widget.currentRow.__is_new = false;
            }
            widget.currentRow.NRTIPOCOMITE = widgetMain.currentRow.NRTIPOCOMITE;
            restEngine.post('product#/setTipoComiteReuniao', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                then(function (data) {
                    if (data.notifications[0].type === "success") {
                        ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                        if (widget.currentRow.__is_new) {
                            ABUtilController.masterDetailVoltarList(widget);
                            widget.reload();
                        } else {
                            ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                            widget.backupRow = null;
                            widget.view();
                        }
                    } else {
                        ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                    }
                }).
                catch(function(e) {
                    var error;
                    if(e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;
                        ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
        }
    };
    
    this.deleteTipoComiteReuniao = function(args) {
        var widget = args.owner.widget;
        ScreenService.confirmMessage(Messages.DELETE_ROW, 'CONFIRMATION',
            function() {    
                widget.currentRow.__is_new = false;
                restEngine.post('product#/deleteTipoComiteReuniao', {'requestType':'DataSet','dataset':[widget.currentRow]}).
                    then(function(data){
                        if(data.notifications[0].type === "success"){
                            ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                            ABUtilController.masterDetailVoltarList(widget);
                            widget.reload();
                        } else {
                            ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                        }
                    }).
                    catch(function(e) {
                        var error;
                        if(e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;
                            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    });
            });
    };
    
    this.setTipoComiteOcup = function(args) {
        var widget = args.owner.widget;
        var widgetMain = templateManager.container.getWidget("tipocomite");
        if (widget.isValid()) {
            if (!widget.backupRow) {
                widget.currentRow.__is_new = true;
            } else {
                widget.currentRow.__is_new = false;
            }
            widget.currentRow.NRTIPOCOMITE = widgetMain.currentRow.NRTIPOCOMITE;
            restEngine.post('product#/setTipoComiteOcup', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                then(function (data) {
                    if (data.notifications[0].type === "success") {
                        ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                        if (widget.currentRow.__is_new) {
                            ABUtilController.masterDetailVoltarList(widget);
                            self.widgetsvisibletrue(args);
                            widget.reload();
                        } else {
                            ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                            widget.backupRow = null;
                            widget.view();
                        }
                    } else {
                        ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                    }
                }).
                catch(function(e) {
                    var error;
                    if(e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;
                        ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
        }
    };
    
    this.deleteTipoComiteOcup = function(args) {
        var widget = templateManager.container.getActiveWidget();
        ScreenService.confirmMessage(Messages.DELETE_ROW, 'CONFIRMATION',
            function() {
                widget.currentRow.__is_new = false;
                restEngine.post('product#/deleteTipoComiteOcup', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                    then(function (data) {
                        if (data.messages) {
                            ScreenService.showMessage(Messages.REMOVE_ROW_ERROR + '. ' + data.messages[0].message, data.messages[0].type);
                        } else {
                            ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                            ABUtilController.masterDetailVoltarList(widget);
                            widget.reload();
                        }
                    }).
                    catch(function(e) {
                        var error;
                        if(e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;
    
                        ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    });
            });
    };
    
    this.setTipoDireitoOcup = function(args) {
        var widget = args.owner.widget;
        var widgetOcupacao = templateManager.container.getWidget("ocupacao");
        if (widget.isValid()) {
            if (!widget.backupRow) {
                widget.currentRow.__is_new = true;
            } else {
                widget.currentRow.__is_new = false;
            }
            widget.currentRow.NRTIPOCOMITEOCUP = widgetOcupacao.currentRow.NRTIPOCOMITEOCUP;
            restEngine.post('product#/setTipoDireitoOcup', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                then(function (data) {
                    if (data.notifications[0].type === "success") {
                        ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                        if (widget.currentRow.__is_new) {
                            ABUtilController.masterDetailVoltarList(widget);
                            widget.reload();
                        } else {
                            ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                            widget.backupRow = null;
                            widget.view();
                        }
                    } else {
                        ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                    }
                }).
                catch(function(e) {
                    var error;
                    if(e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;
                        ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
        }
    };
    
    this.deleteTipoDireitoOcup = function(args) {
        var widget = args.owner.widget;
        ScreenService.confirmMessage(Messages.DELETE_ROW, 'CONFIRMATION',
            function() {
                widget.currentRow.__is_new = false;
                restEngine.post('product#/deleteTipoDireitoOcup', {'requestType':'DataSet','dataset':[widget.currentRow]}).
                    then(function(data){
                        if(data.notifications[0].type === "success"){
                            ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                            ABUtilController.masterDetailVoltarList(widget);
                            widget.reload();
                        } else {
                            ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                        }
                    }).
                    catch(function(e) {
                        var error;
                        if(e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;
                            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    });
            });
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('TipoComiteController', TipoComiteController);
});

// FILE: assets/js/controllers/TipoComunicadoController.js
function TipoComunicadoController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, General,Messages) {

    this.adicionarRow = function(args) {
        var widget = args.owner.widget;
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
    };
    
	this.setTipoComuniocado = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
                if (!widget.backupRow) {
                    widget.currentRow.__is_new = true;
                } else {
                    widget.currentRow.__is_new = false;
                }
                restEngine.post('product#/setTipoComunicado', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                    then(function (data) {
                        if (data.notifications[0].type === "success") {
                            ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                            if (widget.currentRow.__is_new) {
                                ABUtilController.masterDetailVoltarList(widget);
                                widget.reload();
                            } else {
                                ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                                widget.backupRow = null;
                                widget.view();
                            }
                        } else {
                            ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                        }
                    }).
                    catch(function(e) {
                        var error;
                        if(e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;
                            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    });
            }
    };
    
    this.deleteTipoComunicado = function(args) {
    ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
        var widget = args.owner.widget;
        widget.currentRow.__is_new = false;
        restEngine.post('product#/deleteTipoComunicado', {'requestType':'DataSet','dataset':[widget.currentRow]}).
            then(function(data){
                if(data.notifications[0].type === "success"){
                    ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                    ABUtilController.masterDetailVoltarList(widget);
                    widget.reload();
                } else {
                    ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                }
            }).
            catch(function(e) {
                var error;
                if(e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
        }, null);
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('TipoComunicadoController', TipoComunicadoController);
});

// FILE: assets/js/controllers/TipoContaPagarController.js
var TipoContaPagarController = function(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, Messages){
	/**
	 * Função para a chamada da Action Salvar.
	 */
	var self = this;
    
    this.desabilitaCodigo = function(widget){
        widget.getField('CDTPCTPAGAR').readOnly = true;
    };
    
    this.habilitaCodigo = function(widget){
        widget.getField('CDTPCTPAGAR').readOnly = false;
    };       
    
	this.salvarTipoContaPagar = function(args) {
        var widget = templateManager.container.getActiveWidget();
        if (widget.isValid()) {
            if (!widget.backupRow) {
                widget.currentRow.__is_new = true;
            } else {
                widget.currentRow.__is_new = false;
            }
		    var cdtpctpagar = widget.currentRow.CDTPCTPAGAR;
		    cdtpctpagar = mascara(cdtpctpagar);
		    widget.currentRow.CDTPCTPAGAR = cdtpctpagar;
		    widget.currentRow.IDATIVO = "S";
		    widget.currentRow.IDCTBLCTPAG = "N";
		    widget.currentRow.IDUTLANCCPAG = "N";
		    widget.currentRow.IDCTBTPCNTBPAG = "N";
		    widget.currentRow.IDCTBTIPOOPERBX = "N";
		    widget.currentRow.IDGRUPOCADERORE = "INDEFINIDO";
            restEngine.post('product#/setTipoctpagar', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                then(function (data) {
                    if (data.notifications[0].type === "success") {
                        ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                        if (widget.currentRow.__is_new) {
                            ABUtilController.masterDetailVoltarList(widget);
                            widget.reload();
                        } else {
                            ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                            widget.backupRow = null;
                            widget.view(); 
                        }
                    } else if (data.notifications[0].message === 'DUPLICATE_PRIMARY_KEY_ERROR') {
                        ScreenService.showMessage(Messages.DUPLICATE_PRIMARY_KEY_ERROR, 'ERROR');
                    } else
                        ScreenService.showMessage(Messages.SAVE_ROW_ERROR); 
                }).
                catch(function(e) {
                    var error;
                    if(e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;

                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
        } 
    };

    this.removerTipoContaPagar = function(args) {
    ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
        var widget = templateManager.container.getActiveWidget();
        widget.currentRow.__is_new = false;
        restEngine.post('product#/deleteTipoctpagar', {'requestType':'DataSet','dataset':[widget.currentRow]}).
            then(function(data){
                if(data.notifications[0].type === "success"){
                    ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                    ABUtilController.masterDetailVoltarList(widget);
                    widget.reload();
                } else
                    ScreenService.showMessage(Messages.REMOVE_ROW_ERROR, 'ERROR');
            }).
            catch(function(e) {
                var error;
                if(e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;

                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
        }, null);
    };    

	/**
	 * Função auxiliar para aplicar máscara no código. 
	 */
	var mascara = function(codigo){
		if(codigo.length == 1){
			codigo = "00000".concat(codigo);
		}else{ 
			if(codigo.length == 2){
				codigo = "0000".concat(codigo);
			}else{
				if(codigo.length == 3){
					codigo = "000".concat(codigo);
				}else{
					if(codigo.length == 4){
						codigo = "00".concat(codigo);
					}else{
						if(codigo.length == 5)
							codigo = "0".concat(codigo);
					} 
				}
			}
		}
		return codigo;
	};
	 
	 
	 /**
	  * --------------- Algoritmo abaixo aplicado no ERP
	  * Função que desabilita o Campo 'Contabiliza por Tipo de Conta na Baixa' e atribui o valor Não 
	  * como descrição, caso o Campo 'Contabiliza Lançamento' esteja com o valor Sim. Caso este último
	  * esteja com o valor Não, o primeiro é habilitado.
	  *
	this.contabizaOnChange = function(conta){
		var valueContLanc = conta.currentRow.IDCTBLCTPAG;
		if(valueContLanc == 'S'){
			conta.currentRow.IDCTBTPCNTBPAG = 'N';
			conta.getField('IDCTBTPCNTBPAG').readOnly = true;
		}else{
			conta.getField('IDCTBTPCNTBPAG').readOnly = false;
		}
	};*/
};

Configuration(function (ContextRegister){
    ContextRegister.register('TipoContaPagarController', TipoContaPagarController);
});

// FILE: assets/js/controllers/TipoCursoController.js
function TipoCursoController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, General, Messages) {

    var self = this;

    this.adicionarRow = function(args) {
        var widget = args.owner.widget;
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
         widget.reload();
    };

    this.setTipoCurso = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
            if (ABUtilController.validaDtIniMenorIgualDtFin(widget.currentRow.DTINIVIGENCIA, widget.currentRow.DTFIMVIGENCIA)) {
                if (!widget.backupRow) {
                    widget.currentRow.__is_new = true;
                }
                else {
                    widget.currentRow.__is_new = false;
                }
                restEngine.post('product#/setTipoCurso', {
                    'requestType': 'DataSet',
                    'dataset': [widget.currentRow]
                }).
                then(function(data) {
                    if (data.notifications[0].type === "success") {
                        ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                        if (widget.currentRow.__is_new) {
                            ABUtilController.masterDetailVoltarList(widget);
                            self.widgetsvisibletrue(args);
                            widget.reload();
                        }
                        else {
                            ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                            widget.backupRow = null;
                            widget.view();
                        }
                    }
                    else {
                        ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                    }
                }).
                catch(function(e) {
                    var error;
                    if (e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
            }
            else {
                ScreenService.showMessage(Messages.DTINI_POST_DTFIM_ERROR);
                return false;
            }
        }
            templateManager.container.getWidget('tipoCurso').reload();

        
    };

    this.deleteTipoCurso = function(args) {
    ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
        var widget = templateManager.container.getActiveWidget();
        if (widget.isValid()) {
            widget.currentRow.__is_new = false;
            restEngine.post('product#/deleteTipoCurso', {
                'requestType': 'DataSet',
                'dataset': [widget.currentRow]
            }).
            then(function(data) {
                if (data.messages) {
                    ScreenService.showMessage(Messages.REMOVE_ROW_ERROR + '. ' + data.messages[0].message, data.messages[0].type);
                }
                else {
                    ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                    ABUtilController.masterDetailVoltarList(widget);
                    widget.reload();
                }
            }).
            catch(function(e) {
                var error;
                if (e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;

                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
        }
            templateManager.container.getWidget('TipoCurso').reload();
        }, null);
    };


}

Configuration(function(ContextRegister) {
    ContextRegister.register('TipoCursoController', TipoCursoController);
});


// FILE: assets/js/controllers/TipoCustoTreinamentoController.js
function TipoCustoTreinamentoController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, General, Messages) {

    var self = this;

    this.adicionarRow = function(args) {
        var widget = args.owner.widget;
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
    };

    this.setTipoCustoTreinamento = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
            if (!widget.backupRow) {
                widget.currentRow.__is_new = true;
            }
            else {
                widget.currentRow.__is_new = false;
            }
            restEngine.post('product#/setTipoCustoTreinamento', {
                'requestType': 'DataSet',
                'dataset': [widget.currentRow]
            }).
            then(function(data) {
                if (data.notifications[0].type === "success") {
                    ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                    widget.reload();
                    if (widget.currentRow.__is_new) {
                        ABUtilController.masterDetailVoltarList(widget);
                        self.widgetsvisibletrue(args);
                    }
                    else {
                        ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                        widget.backupRow = null;
                        widget.view();
                    }
                }
                else {
                    ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                }
            }).
            catch(function(e) {
                var error;
                if (e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });

        }
        templateManager.container.getWidget('tipoCusto').reload();
    };

    this.deleteTipoCustoTreinamento = function(args) {
    ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
        var widget = templateManager.container.getActiveWidget();
        if (widget.isValid()) {
            widget.currentRow.__is_new = false;
            restEngine.post('product#/deleteTipoCustoTreinamento', {
                'requestType': 'DataSet',
                'dataset': [widget.currentRow]
            }).
            then(function(data) {
                if (data.messages) {
                    ScreenService.showMessage(Messages.REMOVE_ROW_ERROR + '. ' + data.messages[0].message, data.messages[0].type);
                }
                else {
                    ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                    ABUtilController.masterDetailVoltarList(widget);
                    widget.reload();
                }
            }).
            catch(function(e) {
                var error;
                if (e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;

                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
          }
            templateManager.container.getWidget('tipoCusto').reload();
        }, null);
    };


}

Configuration(function(ContextRegister) {
    ContextRegister.register('TipoCustoTreinamentoController', TipoCustoTreinamentoController);
});


// FILE: assets/js/controllers/TipoDemissaoController.js
function TipoDemissaoController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, General,Messages) {

    this.adicionarRow = function(args) {
        var widget = args.owner.widget;
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
    };

	this.setTipoDemissao = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
                if (!widget.backupRow) {
                    widget.currentRow.__is_new = true;
                } else {
                    widget.currentRow.__is_new = false;
                }
                restEngine.post('product#/setTipoDemissao', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                    then(function (data) {
                        if (data.notifications[0].type === "success") {
                            ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                            if (widget.currentRow.__is_new) {
                                ABUtilController.masterDetailVoltarList(widget);
                                widget.reload();
                            } else {
                                ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                                widget.backupRow = null;
                                widget.view();
                            }
                        } else {
                            ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                        }
                    }).
                    catch(function(e) {
                        var error;
                        if(e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;
                            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    });
            }
    };
    
    this.deleteTipoDemissao = function(args) {
         ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
        var widget = args.owner.widget;
        widget.currentRow.__is_new = false;
        restEngine.post('product#/deleteTipoDemissao', {'requestType':'DataSet','dataset':[widget.currentRow]}).
            then(function(data){
                if(data.notifications[0].type === "success"){
                    ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                    ABUtilController.masterDetailVoltarList(widget);
                    widget.reload();
                } else {
                    ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                }
            }).
            catch(function(e) {
                var error;
                if(e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
         }, null);
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('TipoDemissaoController', TipoDemissaoController);
});

// FILE: assets/js/controllers/TipoDependenteController.js
function TipoDependenteController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, General, Messages) {

    this.adicionarRow = function(args) {
        var widget = args.owner.widget;
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
    };

	this.setTipoDependente = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
                if (!widget.backupRow) {
                    widget.currentRow.__is_new = true;
                } else {
                    widget.currentRow.__is_new = false;
                }
                restEngine.post('product#/setTipoDependente', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                    then(function (data) {
                        if (data.notifications[0].type === "success") {
                            ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                            if (widget.currentRow.__is_new) {
                                ABUtilController.masterDetailVoltarList(widget);
                                widget.reload();
                            } else {
                                ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                                widget.backupRow = null;
                                widget.view();
                            }
                        } else {
                            ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                        }
                    }).
                    catch(function(e) {
                        var error;
                        if(e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;
                            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    });
            }
    };
    
    this.deleteTipoDependente = function(args) {
    ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
        var widget = args.owner.widget;
        widget.currentRow.__is_new = false;
        restEngine.post('product#/deleteTipoDependente', {'requestType':'DataSet','dataset':[widget.currentRow]}).
            then(function(data){
                if(data.notifications[0].type === "success"){
                    ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                    ABUtilController.masterDetailVoltarList(widget);
                    widget.reload();
                } else {
                    ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                }
            }).
            catch(function(e) {
                var error;
                if(e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
        }, null);
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('TipoDependenteController', TipoDependenteController);
});

// FILE: assets/js/controllers/TipoDireitoComiteController.js
function TipoDireitoComiteController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, General,Messages) {

    this.adicionarRow = function(args) {
        var widget = args.owner.widget;
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
    };
    
	this.setTipoDireito = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
                if (!widget.backupRow) {
                    widget.currentRow.__is_new = true;
                } else {
                    widget.currentRow.__is_new = false;
                }
                restEngine.post('product#/setTipoDireitoComite', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                    then(function (data) {
                        if (data.notifications[0].type === "success") {
                            ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                            if (widget.currentRow.__is_new) {
                                ABUtilController.masterDetailVoltarList(widget);
                                widget.reload();
                            } else {
                                ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                                widget.backupRow = null;
                                widget.view();
                            }
                        } else {
                            ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                        }
                    }).
                    catch(function(e) {
                        var error;
                        if(e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;
                            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    });
            }
    };
    
    this.deleteTipoDireito = function(args) {
    ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
        var widget = args.owner.widget;
        widget.currentRow.__is_new = false;
        restEngine.post('product#/deleteTipoDireitoComite', {'requestType':'DataSet','dataset':[widget.currentRow]}).
            then(function(data){
                if(data.notifications && data.notifications[0].type === "success"){
                    ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                    ABUtilController.masterDetailVoltarList(widget);
                    widget.reload();
                }else if(data.messages && data.messages[0].type == 'W'){
                    ScreenService.showMessage(data.messages[0].message);
                }else {
                    ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                }
            }).
            catch(function(e) {
                var error;
                if(e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
        },null);
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('TipoDireitoComiteController', TipoDireitoComiteController);
});

// FILE: assets/js/controllers/TipoDireitoController.js
function TipoDireitoController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, General,Messages) {

    this.adicionarRow = function(args) {
        var widget = args.owner.widget;
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
    };

	this.setTipoDireito = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
                if (!widget.backupRow) {
                    widget.currentRow.__is_new = true;
                } else {
                    widget.currentRow.__is_new = false;
                }
                restEngine.post('product#/setTipoDireito', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                    then(function (data) {
                        if (data.notifications[0].type === "success") {
                            ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                            if (widget.currentRow.__is_new) {
                                ABUtilController.masterDetailVoltarList(widget);
                                widget.reload();
                            } else {
                                ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                                widget.backupRow = null;
                                widget.view();
                            }
                        } else {
                            ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                        }
                    }).
                    catch(function(e) {
                        var error;
                        if(e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;
                            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    });
            }
    };
    
    this.deleteTipoDireito = function(args) {
         ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
         var widget = args.owner.widget;
        widget.currentRow.__is_new = false;
        restEngine.post('product#/deleteTipoDireito', {'requestType':'DataSet','dataset':[widget.currentRow]}).
            then(function(data){
                if(data.notifications[0].type === "success"){
                    ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                    ABUtilController.masterDetailVoltarList(widget);
                    widget.reload();
                } else {
                    ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                }
            }).
            catch(function(e) {
                var error;
                if(e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
         }, null);
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('TipoDireitoController', TipoDireitoController);
});

// FILE: assets/js/controllers/TipoDocumentoController.js
function TipoDocumentoController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, General,Messages) {

    this.adicionarRow = function(args) {
        var widget = args.owner.widget;
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
    };
    
	this.setTipoDocumento = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
                if (!widget.backupRow) {
                    widget.currentRow.__is_new = true;
                } else {
                    widget.currentRow.__is_new = false;
                }
                restEngine.post('product#/setTipoDocumento', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                    then(function (data) {
                        if (data.notifications[0].type === "success") {
                            ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                            if (widget.currentRow.__is_new) {
                                ABUtilController.masterDetailVoltarList(widget);
                                widget.reload();
                            } else {
                                ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                                widget.backupRow = null;
                                widget.view();
                            }
                        } else {
                            ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                        }
                    }).
                    catch(function(e) {
                        var error;
                        if(e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;
                            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    });
            }
    };
    
    this.deleteTipoDocumento = function(args) {
    ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
        var widget = args.owner.widget;
        widget.currentRow.__is_new = false;
        restEngine.post('product#/deleteTipoDocumento', {'requestType':'DataSet','dataset':[widget.currentRow]}).
            then(function(data){
                if(data.notifications[0].type === "success"){
                    ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                    ABUtilController.masterDetailVoltarList(widget);
                    widget.reload();
                } else {
                    ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                }
            }).
            catch(function(e) {
                var error;
                if(e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
        },null);
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('TipoDocumentoController', TipoDocumentoController);
});

// FILE: assets/js/controllers/TipoEPIController.js
function TipoEPIController(ScreenService, templateManager, restEngine, ABUtilController, Messages) {

	this.salvar = function(args) {
        var widget = templateManager.container.getActiveWidget();
        if (widget.isValid()) {
            if (!widget.backupRow) {
                widget.currentRow.__is_new = true;
            } else {
                widget.currentRow.__is_new = false;
            }
            restEngine.post('product#/setTipoepi', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                then(function (data) {
                    if (data.notifications[0].type === "success") {
                        ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                        if (widget.currentRow.__is_new) {
                            ABUtilController.masterDetailVoltarList(widget);
                            widget.reload();
                        } else {
                            ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                            widget.backupRow = null;
                            widget.view();
                        }
                    } else {
                        ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                    }
                }).
                catch(function(e) {
                    var error;
                    if(e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;

                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
        }
    };

    this.remover = function(args) {
    ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
        var widget = templateManager.container.getActiveWidget();
        if (widget.isValid()) {
            widget.currentRow.__is_new = false;
            restEngine.post('product#/deleteTipoepi', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                then(function (data) {
                    if (data.notifications[0].type === "success") {
                        ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    } else {
                        ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                    }
                }).
                catch(function(e) {
                    var error;
                    if(e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;

                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
            }
        }, null);
    };

}

Configuration(function(ContextRegister) {
    ContextRegister.register('TipoEPIController', TipoEPIController);
});

// FILE: assets/js/controllers/TipoEstruturaController.js
function TipoEstruturaController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, General,Messages) {

    this.adicionarRow = function(args) {
        var widget = args.owner.widget;
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
    };

	this.setTipoEstrutura = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
                if (!widget.backupRow) {
                    widget.currentRow.__is_new = true;
                } else {
                    widget.currentRow.__is_new = false;
                }
                restEngine.post('product#/setTipoEstrutura', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                    then(function (data) {
                        if (data.notifications[0].type === "success") {
                            ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                            if (widget.currentRow.__is_new) {
                                ABUtilController.masterDetailVoltarList(widget);
                                widget.reload();
                            } else {
                                ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                                widget.backupRow = null;
                                widget.view();
                            }
                        } else {
                            ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                        }
                    }).
                    catch(function(e) {
                        var error;
                        if(e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;
                            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    });
            }
    };
    
    this.deleteTipoEstrutura = function(args) {
        ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
        var widget = args.owner.widget;
        widget.currentRow.__is_new = false;
        restEngine.post('product#/deleteTipoEstrutura', {'requestType':'DataSet','dataset':[widget.currentRow]}).
            then(function(data){
                if(data.notifications[0].type === "success"){
                    ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                    ABUtilController.masterDetailVoltarList(widget);
                    widget.reload();
                } else {
                    ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                }
            }).
            catch(function(e) {
                var error;
                if(e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
        }, null);
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('TipoEstruturaController', TipoEstruturaController);
});

// FILE: assets/js/controllers/TipoExameController.js
function TipoExameController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, General,Messages) {

    this.adicionarRow = function(args) {
        var widget = args.owner.widget;
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
    };
    
	this.setTipoExame = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
                if (!widget.backupRow) {
                    widget.currentRow.__is_new = true;
                } else {
                    widget.currentRow.__is_new = false;
                }
                restEngine.post('product#/setTipoExame', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                    then(function (data) {
                        if (data.notifications[0].type === "success") {
                            ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                            if (widget.currentRow.__is_new) {
                                ABUtilController.masterDetailVoltarList(widget);
                                widget.reload();
                            } else {
                                ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                                widget.backupRow = null;
                                widget.view();
                            }
                        } else {
                            ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                        }
                    }).
                    catch(function(e) {
                        var error;
                        if(e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;
                            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    });
            }
    };
    
    this.deleteTipoExame = function(args) {
    ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
        var widget = args.owner.widget;
        widget.currentRow.__is_new = false;
        restEngine.post('product#/deleteTipoExame', {'requestType':'DataSet','dataset':[widget.currentRow]}).
            then(function(data){
                if(data.notifications[0].type === "success"){
                    ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                    ABUtilController.masterDetailVoltarList(widget);
                    widget.reload();
                } else {
                    ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                }
            }).
            catch(function(e) {
                var error;
                if(e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
        }, null);
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('TipoExameController', TipoExameController);
});

// FILE: assets/js/controllers/TipoFaixaController.js
function TipoFaixaController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, General,Messages) {

    this.adicionarRow = function(args) {
        var widget = args.owner.widget;
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
    };

	this.setTipoFaixa = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
                if (!widget.backupRow) {
                    widget.currentRow.__is_new = true;
                } else {
                    widget.currentRow.__is_new = false;
                }
                restEngine.post('product#/setTipoFaixa', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                    then(function (data) {
                        if (data.notifications[0].type === "success") {
                            ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                            if (widget.currentRow.__is_new) {
                                ABUtilController.masterDetailVoltarList(widget);
                                widget.reload();
                            } else {
                                ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                                widget.backupRow = null;
                                widget.view();
                            }
                        } else {
                            ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                        }
                    }).
                    catch(function(e) {
                        var error;
                        if(e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;
                            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    });
            }
    };
    
    this.deleteTipoFaixa = function(args) {
         ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
         var widget = args.owner.widget;
        widget.currentRow.__is_new = false;
        restEngine.post('product#/deleteTipoFaixa', {'requestType':'DataSet','dataset':[widget.currentRow]}).
            then(function(data){
                if(data.notifications[0].type === "success"){
                    ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                    ABUtilController.masterDetailVoltarList(widget);
                    widget.reload();
                } else {
                    ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                }
            }).
            catch(function(e) {
                var error;
                if(e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
         }, null);
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('TipoFaixaController', TipoFaixaController);
});

// FILE: assets/js/controllers/TipoFaseController.js
function TipoFaseController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, Messages) {

     this.salvarTipoFase = function(args) {
         var widget = templateManager.container.getActiveWidget();
         if (widget.isValid()) {
             if (!widget.backupRow) {
                 widget.currentRow.__is_new = true;
             } else {
                 widget.currentRow.__is_new = false;
             }
             widget.currentRow.DTULTATUDADM = widget.currentRow.DTULTATU;
             restEngine.post('product#/setTipoFase', {
                 'requestType': 'DataSet',
                 'dataset': [widget.currentRow]
             }).
             then(function(data) {
                 if (data.notifications[0].type === "success") {
                     ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                     if (widget.currentRow.__is_new) {
                         ABUtilController.masterDetailVoltarList(widget);
                         widget.reload();
                     } else {
                         ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                         widget.backupRow = null;
                         widget.view();
                         ABUtilController.masterDetailVoltarList(widget);
                         widget.reload();
                     }
                 } else
                     ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
             }).
             catch(function(e) {
                 var error;
                 if (e.data.error === undefined)
                     error = e;
                 else
                     error = e.data.error;

                 ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
             });
         }
     };

     this.removerTipoFase = function(args) {
         ScreenService.confirmMessage(Messages.DELETE_ROW, 'CONFIRMATION',
             function() {

                 var widget = templateManager.container.getActiveWidget();
                 widget.currentRow.__is_new = false;
                 restEngine.post('product#/deleteTipoFase', {
                     'requestType': 'DataSet',
                     'dataset': [widget.currentRow]
                 }).
                 then(function(data) {
                     if (data.notifications[0].type === "success") {
                         ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                         ABUtilController.masterDetailVoltarList(widget);
                         widget.reload();
                     } else
                         ScreenService.showMessage(Messages.REMOVE_ROW_ERROR, 'ERROR');
                 }).
                 catch(function(e) {
                     var error;
                     if (e.data.error === undefined)
                         error = e;
                     else
                         error = e.data.error;

                     ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                 });

             });
     };
}

Configuration(function(ContextRegister) {
     ContextRegister.register('TipoFaseController', TipoFaseController);
});
 

// FILE: assets/js/controllers/TipoFeriasController.js
function TipoFeriasController(ScreenService, templateManager, restEngine, ABUtilController, Messages, General) {
    
    this.adicionarRow = function(args) {
        var widget = args.owner.widget;
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
    };
    
    this.salvar = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
            if(ABUtilController.validaDtIniMenorIgualDtFin(widget.currentRow.DTINIVIGENCIA,widget.currentRow.DTFIMVIGENCIA)){
                ABUtilController.saveMasterDetailMasterHistory(widget);
            }else{
                ScreenService.showMessage(Messages.DTINI_POST_DTFIM_ERROR);
                return false;
            }    
        }
    };

    this.remover = function(args) {
    ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
        var widget = args.owner.widget;
        if (widget.isValid()) {
            widget.currentRow.__is_new = false;
            restEngine.post('product#/deleteTipoFerias', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                then(function (data) {
                    if (data.notifications[0].type === "success") {
                        ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    } else {
                        ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                    }
                }).
                catch(function(e) {
                    var error;
                    if(e.data.error === undefined){
                        error = e;
                    }    
                    else{
                        error = e.data.error;
                        ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    }    
                });
            }
        }, null);
    };

}

Configuration(function(ContextRegister) {
    ContextRegister.register('TipoFeriasController', TipoFeriasController);
});

// FILE: assets/js/controllers/TipoFormaComuniController.js
function TipoFormaComuniController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, General, Messages, HcmConsts) {
    
    this.adicionarRow = function() {
        var widget = templateManager.container.getActiveWidget();
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
    };
    
    this.setTipoFormaComuni = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
            if (!widget.backupRow) {
                widget.currentRow.__is_new = true;
            } else {
                widget.currentRow.__is_new = false;
            }
            restEngine.post('product#/setTipoFormaComuni', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                then(function (data) {
                    if (data.notifications[0].type === "success") {
                        ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                        if (widget.currentRow.__is_new) {
                            ABUtilController.masterDetailVoltarList(widget);
                            widget.reload();
                        } else {
                            ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                            widget.backupRow = null;
                            widget.view();
                        }
                    }else if(data.notifications[0].message === 'HCM01037_FPA_REGISTRO_EXISTENTE')
                        ScreenService.showMessage(Messages.HCM01037_FPA_REGISTRO_EXISTENTE, 'ERROR');
                    else 
                        ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                }).
                catch(function(e) {
                    var error;
                    if(e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;
                        
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');

                });
            }
    };
    
    this.deleteTipoFormaComuni = function(args) {
    ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
        var widget = args.owner.widget;
        widget.currentRow.__is_new = false;
        restEngine.post('product#/deleteTipoFormaComuni', {'requestType':'DataSet','dataset':[widget.currentRow]}).
            then(function (data) {
                if (data.notifications[0].type === "success") {
                    ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                    ABUtilController.masterDetailVoltarList(widget);
                    widget.reload();
                } else {
                    ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                }
            }).
            catch(function(e) {
                var error;
                if(e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
                    
                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
        }, null);
    };
}
 
Configuration(function(ContextRegister) {
    ContextRegister.register('TipoFormaComuniController', TipoFormaComuniController);
});

// FILE: assets/js/controllers/TipoHierarquiaController.js
function TipoHierarquiaController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, General, Messages) {

    this.adicionarRow = function(args) {
        var widget = args.owner.widget;
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
    };

    this.setTipoHierarquia = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
            if (!widget.backupRow) {
                widget.currentRow.__is_new = true;
            } else {
                widget.currentRow.__is_new = false;
            }
            restEngine.post('product#/setTipoHierarquia', {
                'requestType': 'DataSet',
                'dataset': [widget.currentRow]
            }).
            then(function(data) {
                if (data.notifications[0].type === "success") {
                    ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                    if (widget.currentRow.__is_new) {
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    } else {
                        ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                        widget.backupRow = null;
                        widget.view();
                    }
                } else {
                    ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                }
            }).
            catch(function(e) {
                var error;
                if (e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
        }
    };

    this.deleteTipoHierarquia = function(args) {
        var widget = args.owner.widget;
        widget.currentRow.__is_new = false;
        restEngine.post('product#/deleteTipoHierarquia', {
            'requestType': 'DataSet',
            'dataset': [widget.currentRow]
        }).
        then(function(data) {
            if (data.notifications[0].type === "success") {
                ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                ABUtilController.masterDetailVoltarList(widget);
                widget.reload();
            } else {
                ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
            }
        }).
        catch(function(e) {
            var error;
            if (e.data.error === undefined)
                error = e;
            else
                error = e.data.error;
            ScreenService.showMessage(error, 'ERROR');
        });
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('TipoHierarquiaController', TipoHierarquiaController);
});


// FILE: assets/js/controllers/TipoIncidenciaController.js
function TipoIncidenciaController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, General,Messages) {

    this.adicionarRow = function(args) {
        var widget = args.owner.widget;
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
    };

	this.setTipoIncidencia = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
                if (!widget.backupRow) {
                    widget.currentRow.__is_new = true;
                } else {
                    widget.currentRow.__is_new = false;
                }
                restEngine.post('product#/setTipoIncidencia', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                    then(function (data) {
                        if (data.notifications[0].type === "success") {
                            ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                            if (widget.currentRow.__is_new) {
                                ABUtilController.masterDetailVoltarList(widget);
                                widget.reload();
                            } else {
                                ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                                widget.backupRow = null;
                                widget.reload();
                                widget.view();
                            }
                        } else {
                            ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                        }
                    }).
                    catch(function(e) {
                        var error;
                        if(e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;
                            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    });
            }
    };
    
    this.deleteTipoIncidencia = function(args) {
    ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
        var widget = args.owner.widget;
        widget.currentRow.__is_new = false;
        restEngine.post('product#/deleteTipoIncidencia', {'requestType':'DataSet','dataset':[widget.currentRow]}).
            then(function(data){
                if(data.notifications[0].type === "success"){
                    ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                    ABUtilController.masterDetailVoltarList(widget);
                    widget.reload();
                } else {
                    ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                }
            }).
            catch(function(e) {
                var error;
                if(e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
        }, null);
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('TipoIncidenciaController', TipoIncidenciaController);
});

// FILE: assets/js/controllers/TipoMedidaEPIController.js
function TipoMedidaEPIController(ScreenService, templateManager, restEngine, ABUtilController, Messages) {

	this.salvar = function(args) {
        var widget = templateManager.container.getActiveWidget();
        if (widget.isValid()) {
            if (!widget.backupRow) {
                widget.currentRow.__is_new = true;
            } else {
                widget.currentRow.__is_new = false;
            }
            restEngine.post('product#/setTipoMedidaEpi', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                then(function (data) {
                    if (data.notifications[0].type === "success") {
                        ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                        if (widget.currentRow.__is_new) {
                            ABUtilController.masterDetailVoltarList(widget);
                            widget.reload();
                        } else {
                            ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                            widget.backupRow = null;
                            widget.view();
                        }
                    } else {
                        ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                    }
                }).
                catch(function(e) {
                    var error;
                    if(e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;

                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
        }
    };

    this.remover = function(args) {
    ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
        var widget = templateManager.container.getActiveWidget();
        if (widget.isValid()) {
            widget.currentRow.__is_new = false;
            restEngine.post('product#/deleteTipoMedidaEpi', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                then(function (data) {
                    if (data.notifications[0].type === "success") {
                        ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    } else {
                        ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                    }
                }).
                catch(function(e) {
                    var error;
                    if(e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;

                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
            }
        }, null);
    };

}

Configuration(function(ContextRegister) {
    ContextRegister.register('TipoMedidaEPIController', TipoMedidaEPIController);
});

// FILE: assets/js/controllers/TipoMovimentoController.js
function TipoMovimentoController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, General,Messages) {
    
    var self = this;
    
    this.adicionarRow = function(args) {
        var widget = args.owner.widget;
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
    };
    
    this.filtrarWidgetPorTipoMovimento = function(args){
        var widget = args.owner;
        templateManager.container.getWidget("calculoFolha").dataSourceFilter[0].value = widget.currentRow.NRTIPOMOVIMENT;
    };
    
    this.widgetsvisiblefalse = function(args) {
        var widget = args.owner.widget;
        widget.widgets[0].showAsTab = false;
    };

    this.widgetsvisibletrue = function(args) {
        var widget = args.owner.widget;
        widget.widgets[0].showAsTab = true;
    };
    
	this.setTipoMovimento = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
            if (!widget.backupRow) {
                widget.currentRow.__is_new = true;
            } else {
                widget.currentRow.__is_new = false;
            }
            restEngine.post('product#/setTipoMovimento', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                then(function (data) {
                    if (data.notifications[0].type === "success") {
                        ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                        if (widget.currentRow.__is_new) {
                            ABUtilController.masterDetailVoltarList(widget);
                            self.widgetsvisibletrue(args);
                            widget.reload();
                        } else {
                            ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                            widget.backupRow = null;
                            widget.view();
                        }
                    } else {
                        ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                    }
                }).
                catch(function(e) {
                    var error;
                    if(e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;
                        ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
        }
    };
    
    this.deleteTipoMovimento = function(args) {
        var widget = templateManager.container.getActiveWidget();
        if (widget.isValid()) {
            widget.currentRow.__is_new = false;
            restEngine.post('product#/deleteTipoMovimento', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                then(function (data) {
                    if (data.messages) {
                        ScreenService.showMessage(Messages.REMOVE_ROW_ERROR + '. ' + data.messages[0].message, data.messages[0].type);
                    } else {
                        ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    }
                }).
                catch(function(e) {
                    var error;
                    if(e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;

                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
        }
    };
    
	this.setCalculoFolha = function(args) {
        var widget = args.owner.widget;
        var widgetMain = templateManager.container.getWidget("tipoMovimento");
        if (widget.isValid()) {
                if (!widget.backupRow) {
                    widget.currentRow.__is_new = true;
                } else {
                    widget.currentRow.__is_new = false;
                }
                widget.currentRow.NRTIPOMOVIMENT = widgetMain.currentRow.NRTIPOMOVIMENT;
                restEngine.post('product#/setCalculoFolha', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                    then(function (data) {
                        if(data.messages){
                            ScreenService.showMessage(data.messages[0].message);
                        }else{
                            if (data.notifications[0].type === "success") {
                                ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                                if (widget.currentRow.__is_new) {
                                    ABUtilController.masterDetailVoltarList(widget);
                                    widget.reload();
                                } else {
                                    ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                                    widget.backupRow = null;
                                    widget.view();
                                }
                            } else {
                                ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                            }
                        }    
                    }).
                    catch(function(e) {
                        var error;
                        if(e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;
                            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    });
        }
    };
    
    this.deleteCalculoFolha = function(args) {
        var widget = args.owner.widget;
        widget.currentRow.__is_new = false;
        restEngine.post('product#/deleteCalculoFolha', {'requestType':'DataSet','dataset':[widget.currentRow]}).
            then(function(data){
                if(data.notifications[0].type === "success"){
                    ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                    ABUtilController.masterDetailVoltarList(widget);
                    widget.reload();
                } else {
                    ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                }
            }).
            catch(function(e) {
                var error;
                if(e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('TipoMovimentoController', TipoMovimentoController);
});

// FILE: assets/js/controllers/TipoOcorrenciaController.js
function TipoOcorrenciaController(ScreenService, templateManager, restEngine, ABUtilController, Messages) {

	this.salvar = function(args) {
        var widget = templateManager.container.getActiveWidget();
        if (widget.isValid()) {
            if (!widget.backupRow) {
                widget.currentRow.__is_new = true;
            } else {
                widget.currentRow.__is_new = false;
            }
            restEngine.post('product#/setTipoocorrencia', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                then(function (data) {
                    if (data.notifications[0].type === "success") {
                        ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                        if (widget.currentRow.__is_new) {
                            ABUtilController.masterDetailVoltarList(widget);
                            widget.reload();
                        } else {
                            ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                            widget.backupRow = null;
                            widget.view();
                        }
                    } else {
                        ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                    }
                }).
                catch(function(e) {
                    var error;
                    if(e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;

                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
        }
    };

    this.remover = function(args) {
    ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
        var widget = templateManager.container.getActiveWidget();
        if (widget.isValid()) {
            widget.currentRow.__is_new = false;
            restEngine.post('product#/deleteTipoocorrencia', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                then(function (data) {
                    if (data.notifications[0].type === "success") {
                        ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    } else {
                        ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                    }
                }).
                catch(function(e) {
                    var error;
                    if(e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;

                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
            }
        },null);
    };

}

Configuration(function(ContextRegister) {
    ContextRegister.register('TipoOcorrenciaController', TipoOcorrenciaController);
});

// FILE: assets/js/controllers/TipoOcorrenciaFrequenciaController.js
function TipoOcorrenciaFrequenciaController (ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, $window, ABUtilController, Messages) {
    this.deleteTipoOcorrenciaFrequencia = function(args) {
        var widget = args.owner.widget;
        var data = {}; 
        ScreenService.confirmMessage(Messages.DELETE_ROW, 'CONFIRMATION', 
            function(){
                widget.dataSource.remove(widget.currentRow).then(function (data){
                    if(data.dataset.ptoTipoProgOcorrencia_setAssociacaoSituacaoFrequencia.type === "success"){
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                        ScreenService.showMessage(Messages.REMOVE_ROW_SUCCESS); 
                    } else {
                        ScreenService.showMessage(Messages.REMOVE_ROW_ERROR); 
                    }
                });
            }.bind(this)
        );
    };

    this.salvarTipoOcorrenciaFrequencia = function(argsRow){
        var widget = templateManager.container.getWidget("tipoOcorrenciaFrequencia");
        if(widget.isValid())  {
            
            if (!widget.backupRow) {
                widget.currentRow.__is_new = true;
            } else {
                widget.currentRow.__is_new = false;
            }
            widget.currentRow.CDOPERADOR_LOG = getLocalVar("HCM_CDOPERADOR");
            widget.currentRow.NRORGTRAB = getLocalVar("HCM_NRORG_TRAB");
            widget.currentRow.NRORGPADRAO = getLocalVar("HCM_NRORG_PADRAO");
            widget.currentRow.DTATUAL = getLocalVar("HCM_DATA_ATUAL");
            return widget.saveRow().then(function (data){
                if (data.notifications[0].type === "success") {
                    ScreenService.showMessage(Messages.SAVE_ROW_SUCCESS);
                    if (widget.currentRow.__is_new) {
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    } else {
                        ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                        widget.backupRow = null;
                        widget.view();
                    }
                } else {
                    ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                }
            }).catch(function(e) {
                var error;
                if(e.data.error === undefined)
                    error = e;
                else 
                    error = e.data.error;
                
                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error));
            });
        }
    };

}

Configuration(function(ContextRegister) {
    ContextRegister.register('TipoOcorrenciaFrequenciaController', TipoOcorrenciaFrequenciaController);
});

// FILE: assets/js/controllers/TipoProcessoController.js
function TipoProcessoController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController,Messages) {

    this.salvarTipoProcesso = function(args) {
        var widget = templateManager.container.getActiveWidget();
        if (widget.isValid()) {
            if (!widget.backupRow) {
                widget.currentRow.__is_new = true;
            } else {
                widget.currentRow.__is_new = false;
            }
            restEngine.post('product#/setTipoProcesso', {
                'requestType': 'DataSet',
                'dataset': [widget.currentRow]
            }).
            then(function(data) {
                if (data.notifications[0].type === "success") {
                        ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                    if (widget.currentRow.__is_new) {
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    } else {
                        ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                        widget.backupRow = null;
                        widget.view();
                    }
                } else {
                    ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                }
            }).
            catch(function(e) {
                var error;
                if (e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;

                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
        }
    };

    this.deleteTipoProcesso = function(args) {
        ScreenService.confirmMessage(Messages.DELETE_ROW, 'CONFIRMATION',
            function() {

                var widget = templateManager.container.getActiveWidget();
                widget.currentRow.__is_new = false;
                restEngine.post('product#/deleteTipoProcesso', {
                    'requestType': 'DataSet',
                    'dataset': [widget.currentRow]
                }).
                then(function(data) {
                    if (data.notifications[0].type === "success") {
                        ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    } else {
                         ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                    }
                }).
                catch(function(e) {
                    var error;
                    if (e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;

                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });

            });
    };

}

Configuration(function(ContextRegister) {
    ContextRegister.register('TipoProcessoController', TipoProcessoController);
});


// FILE: assets/js/controllers/TipoRelacionamentoAVLController.js
function TipoRelacionamentoAVLController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, General,Messages) {

    this.adicionarRow = function(args) {
        var widget = args.owner.widget;
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
    };

	this.setTipoRelacionamento = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
                if (!widget.backupRow) {
                    widget.currentRow.__is_new = true;
                } else {
                    widget.currentRow.__is_new = false;
                }
                restEngine.post('product#/setTipoRelacionamentoAVL', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                    then(function (data) {
                        if (data.notifications[0].type === "success") {
                            ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                            if (widget.currentRow.__is_new) {
                                ABUtilController.masterDetailVoltarList(widget);
                                widget.reload();
                            } else {
                                ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                                widget.backupRow = null;
                                widget.view();
                            }
                        } else {
                            ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                        }
                    }).
                    catch(function(e) {
                        var error;
                        if(e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;
                            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    });
            }
    };
    
    this.deleteTipoRelacionamento = function(args) {
    ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
        var widget = args.owner.widget;
        widget.currentRow.__is_new = false;
        restEngine.post('product#/deleteTipoRelacionamentoAVL', {'requestType':'DataSet','dataset':[widget.currentRow]}).
            then(function(data){
                if(data.notifications[0].type === "success"){
                    ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                    ABUtilController.masterDetailVoltarList(widget);
                    widget.reload();
                } else {
                    ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                }
            }).
            catch(function(e) {
                var error;
                if(e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
        }, null);
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('TipoRelacionamentoAVLController', TipoRelacionamentoAVLController);
});

// FILE: assets/js/controllers/TipoRelacionamentoController.js
function TipoRelacionamentoController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, General,Messages) {

    this.adicionarRow = function(args) {
        var widget = args.owner.widget;
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
    };

	this.setTipoRelacionamento = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
                if (!widget.backupRow) {
                    widget.currentRow.__is_new = true;
                } else {
                    widget.currentRow.__is_new = false;
                }
                restEngine.post('product#/setTipoRelacionamento', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                    then(function (data) {
                        if (data.notifications[0].type === "success") {
                            ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                            if (widget.currentRow.__is_new) {
                                ABUtilController.masterDetailVoltarList(widget);
                                widget.reload();
                            } else {
                                ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                                widget.backupRow = null;
                                widget.view();
                            }
                        } else {
                            ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                        }
                    }).
                    catch(function(e) {
                        var error;
                        if(e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;
                            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    });
            }
    };
    
    this.deleteTipoRelacionamento = function(args) {
    ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
        var widget = args.owner.widget;
        widget.currentRow.__is_new = false;
        restEngine.post('product#/deleteTipoRelacionamento', {'requestType':'DataSet','dataset':[widget.currentRow]}).
            then(function(data){
                if(data.notifications[0].type === "success"){
                    ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                    ABUtilController.masterDetailVoltarList(widget);
                    widget.reload();
                } else {
                    ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                }
            }).
            catch(function(e) {
                var error;
                if(e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
        }, null);
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('TipoRelacionamentoController', TipoRelacionamentoController);
});

// FILE: assets/js/controllers/TipoResultadoController.js
function TipoResultadoController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, General,Messages) {
    
    var self = this;
    var idFiltrarWidgetMain;
    var nmFiltrarWidgetMain;
    var nomeVerifica;
    
    
    
    this.adicionarRow = function(args) {
        var widget = args.owner.widget;
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
    };
    
	this.setTipoResultado = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
            if (ABUtilController.validaDtIniMenorIgualDtFin(widget.currentRow.DTINIVIGENCIA, widget.currentRow.DTFIMVIGENCIA)) {
                if (!widget.backupRow) {
                    widget.currentRow.__is_new = true;
                } else {
                    widget.currentRow.__is_new = false;
                }
                restEngine.post('product#/setTipoResultado', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                    then(function (data) {
                        if (data.notifications[0].type === "success") {
                            ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                            if (widget.currentRow.__is_new) {
                                ABUtilController.masterDetailVoltarList(widget);
                                widget.reload();
                            } else {
                                ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                                widget.backupRow = null;
                                widget.view();
                            }
                        } else {
                            ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                        }
                    }).
                    catch(function(e) {
                        var error;
                        if(e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;
                            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    });
            }else{
                ScreenService.showMessage(Messages.DTINI_POST_DTFIM_ERROR);
                return false;
            }        
        }
        // widget.reload();
    };
    
    this.deleteTipoResultado = function(args) {
    ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
        var widget = templateManager.container.getActiveWidget();
        if (widget.isValid()) {
            widget.currentRow.__is_new = false;
            restEngine.post('product#/deleteTipoResultado', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                then(function (data) {
                    if (data.messages) {
                        ScreenService.showMessage(Messages.REMOVE_ROW_ERROR + '. ' + data.messages[0].message, data.messages[0].type);
                    } else {
                        ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    }
                }).
                catch(function(e) {
                    var error;
                    if(e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;

                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
            }
        }, null);
    };
    

}

Configuration(function(ContextRegister) {
    ContextRegister.register('TipoResultadoController', TipoResultadoController);
});

// FILE: assets/js/controllers/TipoReuniaoController.js
function TipoReuniaoController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, General,Messages) {

    this.adicionarRow = function(args) {
        var widget = args.owner.widget;
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
    };
    
	this.setTipoReuniao = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
                if (!widget.backupRow) {
                    widget.currentRow.__is_new = true;
                } else {
                    widget.currentRow.__is_new = false;
                }
                restEngine.post('product#/setTipoReuniao', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                    then(function (data) {
                        if (data.notifications[0].type === "success") {
                            ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                            if (widget.currentRow.__is_new) {
                                ABUtilController.masterDetailVoltarList(widget);
                                widget.reload();
                            } else {
                                ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                                widget.backupRow = null;
                                widget.view();
                            }
                        } else {
                            ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                        }
                    }).
                    catch(function(e) {
                        var error;
                        if(e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;
                            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    });
            }
    };
    
    this.deleteTipoReuniao = function(args) {
    ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
        var widget = args.owner.widget;
        widget.currentRow.__is_new = false;
        restEngine.post('product#/deleteTipoReuniao', {'requestType':'DataSet','dataset':[widget.currentRow]}).
            then(function(data){
                if(data.notifications[0].type === "success"){
                    ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                    ABUtilController.masterDetailVoltarList(widget);
                    widget.reload();
                } else {
                    ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                }
            }).
            catch(function(e) {
                var error;
                if(e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
        }, null);
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('TipoReuniaoController', TipoReuniaoController);
});

// FILE: assets/js/controllers/TipoSalarioController.js
function TipoSalarioController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, General,Messages) {

    this.adicionarRow = function(args) {
        var widget = args.owner.widget;
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
    };

	this.setTipoSalario = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
                if (!widget.backupRow) {
                    widget.currentRow.__is_new = true;
                } else {
                    widget.currentRow.__is_new = false;
                }
                restEngine.post('product#/setTipoSalario', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                    then(function (data) {
                        if (data.notifications[0].type === "success") {
                            ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                            if (widget.currentRow.__is_new) {
                                ABUtilController.masterDetailVoltarList(widget);
                                widget.reload();
                            } else {
                                ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                                widget.backupRow = null;
                                widget.view();
                            }
                        } else {
                            ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                        }
                    }).
                    catch(function(e) {
                        var error;
                        if(e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;
                            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    });
            }
    };
    
    this.deleteTipoSalario = function(args) {
         ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
        var widget = args.owner.widget;
        widget.currentRow.__is_new = false;
        restEngine.post('product#/deleteTipoSalario', {'requestType':'DataSet','dataset':[widget.currentRow]}).
            then(function(data){
                if(data.notifications[0].type === "success"){
                    ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                    ABUtilController.masterDetailVoltarList(widget);
                    widget.reload();
                } else {
                    ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                }
            }).
            catch(function(e) {
                var error;
                if(e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
      }, null);
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('TipoSalarioController', TipoSalarioController);
});

// FILE: assets/js/controllers/TipoTransferenciaController.js
function TipoTransferenciaController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, General,Messages) {

    this.adicionarRow = function(args) {
        var widget = args.owner.widget;
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
    };
    
	this.setTipoTransferencia = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
                if (!widget.backupRow) {
                    widget.currentRow.__is_new = true;
                } else {
                    widget.currentRow.__is_new = false;
                }
                restEngine.post('product#/setTipoTransferencia', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                    then(function (data) {
                        if (data.notifications[0].type === "success") {
                            ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                            if (widget.currentRow.__is_new) {
                                ABUtilController.masterDetailVoltarList(widget);
                                widget.reload();
                            } else {
                                widget.backupRow = null;
                                widget.view();
                            }
                        } else {
                            ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                        }
                    }).
                    catch(function(e) {
                        var error;
                        if(e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;
                            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    });
            }
    };
    
    this.deleteTipoTransferencia = function(args) {
    ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
        var widget = args.owner.widget;
        widget.currentRow.__is_new = false;
        restEngine.post('product#/deleteTipoTransferencia', {'requestType':'DataSet','dataset':[widget.currentRow]}).
            then(function(data){
                if(data.notifications[0].type === "success"){
                    ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                    ABUtilController.masterDetailVoltarList(widget);
                    widget.reload();
                } else {
                    ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                }
            }).
            catch(function(e) {
                var error;
                if(e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
        }, null);
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('TipoTransferenciaController', TipoTransferenciaController);
});

// FILE: assets/js/controllers/TipoVerificacaoController.js
function TipoVerificacaoController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, General, Messages) {

    this.setTipoVerificacao = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
            if (!widget.backupRow) {
                widget.currentRow.__is_new = true;
            } else {
                widget.currentRow.__is_new = false;
            }
            restEngine.post('product#/setTipoverificacao', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                then(function (data) {
                    if (data.notifications[0].type === "success") {
                        ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                        if (widget.currentRow.__is_new) {
                            ABUtilController.masterDetailVoltarList(widget);
                            widget.reload();
                        } else {
                            ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                            widget.backupRow = null;
                            widget.view();
                        }
                    } else {
                        ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                    }
                }).
                catch(function(e) {
                    var error;
                    if(e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;
                        ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
        }
    };

    this.deleteTipoVerificacao = function(args) {
    ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
        var widget = args.owner.widget;
        widget.currentRow.__is_new = false;
        restEngine.post('product#/deleteTipoverificacao', {'requestType':'DataSet','dataset':[widget.currentRow]}).
            then(function(data){
                if(data.notifications[0].type === "success"){
                    ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                    ABUtilController.masterDetailVoltarList(widget);
                    widget.reload();
                } else {
                    ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                }
            }).
            catch(function(e) {
                var error;
                if(e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
      }, null);
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('TipoVerificacaoController', TipoVerificacaoController);
});

// FILE: assets/js/controllers/TipoVinculoController.js
function TipoVinculoController(ScreenService, templateManager, restEngine, ABUtilController, Messages, General) {
    
    var self = this;
    
    this.adicionarRow = function(args) {
        var widget = args.owner.widget;
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
    };
    
    this.salvar = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
            if(ABUtilController.validaDtIniMenorIgualDtFin(widget.currentRow.DTINIVIGENCIA,widget.currentRow.DTFIMVIGENCIA)){
                ABUtilController.saveMasterDetailMasterHistory(widget);
                self.widgetsvisibletrue(args);
            }else{
                ScreenService.showMessage(Messages.DTINI_POST_DTFIM_ERROR);
                return false;
            }    
        }
    };
    
    this.filtrarWidgetPorTipoVinculo = function(args){
        var widget = args.owner;
        templateManager.container.getWidget("vinculoProcesso").dataSourceFilter[0].value = widget.currentRow.NRTIPOVINCULOM;
    };
    
    this.widgetsvisiblefalse = function(args) {
        var widget = args.owner.widget;
        widget.widgets[0].showAsTab = false;
    };

    this.widgetsvisibletrue = function(args) {
        var widget = args.owner.widget;
        widget.widgets[0].showAsTab = true;
    };
    
    this.remover = function(args) {
        ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
            var widget = args.owner.widget;
            if (widget.isValid()) {
                widget.currentRow.__is_new = false;
                restEngine.post('product#/deleteTipoVinculo', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                    then(function (data) {
                        if (data.messages) {
                            ScreenService.showMessage(Messages.REMOVE_ROW_ERROR + '. ' + data.messages[0].message, data.messages[0].type);
                        } else {
                            ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                            ABUtilController.masterDetailVoltarList(widget);
                            widget.reload();
                        }
                    }).
                    catch(function(e) {
                        var error;
                        if(e.data.error === undefined){
                            error = e;
                        }    
                        else{
                            error = e.data.error;
                            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                        }    
                    });
            }
        }, null);
    };
    
	this.setVinculoProcesso = function(args) {
        var widget = args.owner.widget;
        var widgetMain = templateManager.container.getWidget("TipoVinculo");
        if (widget.isValid()) {
                if (!widget.backupRow) {
                    widget.currentRow.__is_new = true;
                } else {
                    widget.currentRow.__is_new = false;
                }
                widget.currentRow.NRTIPOVINCULOM = widgetMain.currentRow.NRTIPOVINCULOM;
                restEngine.post('product#/setVinculoProcesso', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                    then(function (data) {
                        if(data.messages){
                            ScreenService.showMessage(data.messages[0].message);
                        }else{
                            if (data.notifications[0].type === "success") {
                                ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                                if (widget.currentRow.__is_new) {
                                    ABUtilController.masterDetailVoltarList(widget);
                                    widget.reload();
                                } else {
                                    ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                                    widget.backupRow = null;
                                    widget.view();
                                }
                            } else {
                                ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                            }
                        }    
                    }).
                    catch(function(e) {
                        var error;
                        if(e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;
                            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    });
        }
    };
    
    this.deleteVinculoProcesso = function(args) {
        var widget = args.owner.widget;
        widget.currentRow.__is_new = false;
        restEngine.post('product#/deleteVinculoProcesso', {'requestType':'DataSet','dataset':[widget.currentRow]}).
            then(function(data){
                if(data.notifications[0].type === "success"){
                    ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                    ABUtilController.masterDetailVoltarList(widget);
                    widget.reload();
                } else {
                    ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                }
            }).
            catch(function(e) {
                var error;
                if(e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
    };

}

Configuration(function(ContextRegister) {
    ContextRegister.register('TipoVinculoController', TipoVinculoController);
});

// FILE: assets/js/controllers/TipodelinhaController.js
function TipodelinhaController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, Messages) {

    this.salvarTipodelinha = function(args) {
        var widget = templateManager.container.getActiveWidget();
        if (widget.isValid()) {
            if (!widget.backupRow) {
                widget.currentRow.__is_new = true;
            } else {
                widget.currentRow.__is_new = false;
            }
            restEngine.post('product#/setTipolinhavinc', {
                'requestType': 'DataSet',
                'dataset': [widget.currentRow]
            }).
            then(function(data) {
                if (data.notifications[0].type === "success") {
                    ScreenService.successNotification('Tipo de linha salvo com sucesso', 10000);
                    if (widget.currentRow.__is_new) {
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    } else {
                        ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                        widget.backupRow = null;
                        widget.view();
                    }
                } else {
                    ScreenService.showMessage('Erro ao salvar o tipo de linha');
                }
            }).
            catch(function(e) {
                var error;
                if (e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;

                ScreenService.showMessage('Ocorreu um erro inesperado, contate o administrador informando o trecho abaixo: <br><br>' + error + '<br><br>', 'ERROR');
            });
        }
    };

    this.removerTipodelinha = function(args) {
        ScreenService.confirmMessage(Messages.DELETE_ROW, 'CONFIRMATION',
            function() {
                var widget = templateManager.container.getActiveWidget();
                widget.currentRow.__is_new = false;
                restEngine.post('product#/deleteTipolinhavinc', {
                    'requestType': 'DataSet',
                    'dataset': [widget.currentRow]
                }).
                then(function(data) {
                    if (data.notifications[0].type === "success") {
                        ScreenService.successNotification('Tipo de linha excluído com sucesso', 10000);
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    } else {
                        ScreenService.showMessage('Erro ao excluir o tipo de linha');
                    }
                }).
                catch(function(e) {
                    var error;
                    if (e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;

                    ScreenService.showMessage('Ocorreu um erro inesperado, contate o administrador informando o trecho abaixo: <br><br>' + error + '<br><br>', 'ERROR');
                });

            });
    };

}

Configuration(function(ContextRegister) {
    ContextRegister.register('TipodelinhaController', TipodelinhaController);
});


// FILE: assets/js/controllers/TipodetransporteController.js
function TipodetransporteController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController,Messages) {

    this.salvarTipodetransporte = function(args) {
        var widget = templateManager.container.getActiveWidget();
        if (widget.isValid()) {
            if (!widget.backupRow) {
                widget.currentRow.__is_new = true;
            } else {
                widget.currentRow.__is_new = false;
            }
            restEngine.post('product#/setTipotransporte', {
                'requestType': 'DataSet',
                'dataset': [widget.currentRow]
            }).
            then(function(data) {
                if (data.notifications[0].type === "success") {
                    ScreenService.successNotification('Tipo de transporte salvo com sucesso', 10000);
                    if (widget.currentRow.__is_new) {
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    } else {
                        ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                        widget.backupRow = null;
                        widget.view();
                    }
                } else {
                    ScreenService.showMessage('Erro ao salvar o tipo de transporte');
                }
            }).
            catch(function(e) {
                var error;
                if (e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;

                ScreenService.showMessage('Ocorreu um erro inesperado, contate o administrador informando o trecho abaixo: <br><br>' + error + '<br><br>', 'ERROR');
            });
        }
    };

    this.removerTipodetransporte = function(args) {
        ScreenService.confirmMessage(Messages.DELETE_ROW, 'CONFIRMATION',
            function() {

                var widget = templateManager.container.getActiveWidget();
                widget.currentRow.__is_new = false;
                restEngine.post('product#/deleteTipotransporte', {
                    'requestType': 'DataSet',
                    'dataset': [widget.currentRow]
                }).
                then(function(data) {
                    if (data.notifications[0].type === "success") {
                        ScreenService.successNotification('Tipo de transporte excluído com sucesso', 10000);
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    } else {
                        ScreenService.showMessage('Erro ao excluir o tipo de transporte');
                    }
                }).
                catch(function(e) {
                    var error;
                    if (e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;

                    ScreenService.showMessage('Ocorreu um erro inesperado, contate o administrador informando o trecho abaixo: <br><br>' + error + '<br><br>', 'ERROR');
                });

            });
    };

}

Configuration(function(ContextRegister) {
    ContextRegister.register('TipodetransporteController', TipodetransporteController);
});


// FILE: assets/js/controllers/TpAlteracaoSalarialController.js
function TpAlteracaoSalarialController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, General,Messages) {

    this.adicionarRow = function(args) {
        var widget = args.owner.widget;
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
    };

	this.setTpAlteracaoSalarial = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
            if(ABUtilController.validaDtIniMenorIgualDtFin(widget.currentRow.DTINIVIGENCIA,widget.currentRow.DTFIMVIGENCIA)){    
                if (!widget.backupRow) {
                    widget.currentRow.__is_new = true;
                } else {
                    widget.currentRow.__is_new = false;
                }
                restEngine.post('product#/setTpAlteracaoSalarial', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                    then(function (data) {
                        if (data.notifications[0].type === "success") {
                            ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                            if (widget.currentRow.__is_new) {
                                ABUtilController.masterDetailVoltarList(widget);
                                widget.reload();
                            } else {
                                ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                                widget.backupRow = null;
                                widget.view();
                            }
                        } else {
                            ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                        }
                    }).
                    catch(function(e) {
                        var error;
                        if(e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;
                            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    });
            }else{
                ScreenService.showMessage(Messages.DTINI_POST_DTFIM_ERROR);
                return false;
            }          
        }
    };
    
    this.deleteTpAlteracaoSalarial = function(args) {
    ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
        var widget = args.owner.widget;
        widget.currentRow.__is_new = false;
        restEngine.post('product#/deleteTpAlteracaoSalarial', {'requestType':'DataSet','dataset':[widget.currentRow]}).
            then(function(data){
                if(data.notifications[0].type === "success"){
                    ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                    ABUtilController.masterDetailVoltarList(widget);
                    widget.reload();
                } else {
                    ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                }
            }).
            catch(function(e) {
                var error;
                if(e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
        }, null);
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('TpAlteracaoSalarialController', TpAlteracaoSalarialController);
});

// FILE: assets/js/controllers/TpAssociacaoEventoController.js
function TpAssociacaoEventoController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, General,Messages) {

    this.adicionarRow = function(args) {
        var widget = args.owner.widget;
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
    };

	this.setTpAssociacaoEvento = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
                if (!widget.backupRow) {
                    widget.currentRow.__is_new = true;
                } else {
                    widget.currentRow.__is_new = false;
                }
                restEngine.post('product#/setTpAssociacaoEvento', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                    then(function (data) {
                        if (data.notifications[0].type === "success") {
                            ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                            if (widget.currentRow.__is_new) {
                                ABUtilController.masterDetailVoltarList(widget);
                                widget.reload();
                            } else {
                                ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                                widget.backupRow = null;
                                widget.view();
                            }
                        } else {
                            ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                        }
                    }).
                    catch(function(e) {
                        var error;
                        if(e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;
                            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    });
            }
    };
    
    this.deleteTpAssociacaoEvento = function(args) {
    ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
        var widget = args.owner.widget;
        widget.currentRow.__is_new = false;
        restEngine.post('product#/deleteTpAssociacaoEvento', {'requestType':'DataSet','dataset':[widget.currentRow]}).
            then(function(data){
                if(data.notifications[0].type === "success"){
                    ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                    ABUtilController.masterDetailVoltarList(widget);
                    widget.reload();
                } else {
                    ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                }
            }).
            catch(function(e) {
                var error;
                if(e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
        }, null);
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('TpAssociacaoEventoController', TpAssociacaoEventoController);
});

// FILE: assets/js/controllers/TpAvisoPrevioController.js
function TpAvisoPrevioController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, General,Messages) {

    this.adicionarRow = function(args) {
        var widget = args.owner.widget;
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
    };

	this.setTpAvisoPrevio = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
                if (!widget.backupRow) {
                    widget.currentRow.__is_new = true;
                } else {
                    widget.currentRow.__is_new = false;
                }
                restEngine.post('product#/setTpAvisoPrevio', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                    then(function (data) {
                        if (data.notifications[0].type === "success") {
                            ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                            if (widget.currentRow.__is_new) {
                                ABUtilController.masterDetailVoltarList(widget);
                                widget.reload();
                            } else {
                                ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                                widget.backupRow = null;
                                widget.view();
                            }
                        } else {
                            ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                        }
                    }).
                    catch(function(e) {
                        var error;
                        if(e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;
                            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    });
            }
    };
    
    this.deleteTpAvisoPrevio = function(args) {
        var widget = args.owner.widget;
        widget.currentRow.__is_new = false;
        restEngine.post('product#/deleteTpAvisoPrevio', {'requestType':'DataSet','dataset':[widget.currentRow]}).
            then(function(data){
                if(data.notifications[0].type === "success"){
                    ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                    ABUtilController.masterDetailVoltarList(widget);
                    widget.reload();
                } else {
                    ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                }
            }).
            catch(function(e) {
                var error;
                if(e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('TpAvisoPrevioController', TpAvisoPrevioController);
});

// FILE: assets/js/controllers/TpEtapAcaoController.js
function TpEtapAcaoController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, General,Messages) {

    this.adicionarRow = function(args) {
        var widget = args.owner.widget;
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
    };
    
	this.setTpEtapAcao = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
                if (!widget.backupRow) {
                    widget.currentRow.__is_new = true;
                } else {
                    widget.currentRow.__is_new = false;
                }
                restEngine.post('product#/setTpEtapAcao', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                    then(function (data) {
                        if (data.notifications[0].type === "success") {
                            ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                            if (widget.currentRow.__is_new) {
                                ABUtilController.masterDetailVoltarList(widget);
                                widget.reload();
                            } else {
                                ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                                widget.backupRow = null;
                                widget.view();
                            }
                        } else {
                            ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                        }
                    }).
                    catch(function(e) {
                        var error;
                        if(e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;
                            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    });
            }
    };
    
    this.deleteTpEtapAcao = function(args) {
    ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
        var widget = args.owner.widget;
        widget.currentRow.__is_new = false;
        restEngine.post('product#/deleteTpEtapAcao', {'requestType':'DataSet','dataset':[widget.currentRow]}).
            then(function(data){
                if(data.notifications[0].type === "success"){
                    ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                    ABUtilController.masterDetailVoltarList(widget);
                    widget.reload();
                } else {
                    ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                }
            }).
            catch(function(e) {
                var error;
                if(e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
        }, null);
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('TpEtapAcaoController', TpEtapAcaoController);
});

// FILE: assets/js/controllers/TpFeriasxTpVinculoController.js
function TpFeriasxTpVinculoController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, General,Messages) {

    this.adicionarRow = function(args) {
        var widget = args.owner.widget;
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
    };

	this.setTpFeriasxTpVinculo = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
                if (!widget.backupRow) {
                    widget.currentRow.__is_new = true;
                } else {
                    widget.currentRow.__is_new = false;
                }
                restEngine.post('product#/setTpFeriasxTpVinculo', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                    then(function (data) {
                        if (data.notifications[0].type === "success") {
                            ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                            if (widget.currentRow.__is_new) {
                                ABUtilController.masterDetailVoltarList(widget);
                                widget.reload();
                            } else {
                                ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                                widget.backupRow = null;
                                widget.view();
                            }
                        } else {
                            ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                        }
                    }).
                    catch(function(e) {
                        var error;
                        if(e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;
                            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    });
            }
    };
    
    this.deleteTpFeriasxTpVinculo = function(args) {
        var widget = args.owner.widget;
        widget.currentRow.__is_new = false;
        restEngine.post('product#/deleteTpFeriasxTpVinculo', {'requestType':'DataSet','dataset':[widget.currentRow]}).
            then(function(data){
                if(data.notifications[0].type === "success"){
                    ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                    ABUtilController.masterDetailVoltarList(widget);
                    widget.reload();
                } else {
                    ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                }
            }).
            catch(function(e) {
                var error;
                if(e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('TpFeriasxTpVinculoController', TpFeriasxTpVinculoController);
});

// FILE: assets/js/controllers/TpItemCCTController.js
function TpItemCCTController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, General, Messages) {

    var self = this;

    this.adicionarRow = function(args) {
        var widget = args.owner.widget;
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
    };

    this.setTpItemCCT = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
            if (ABUtilController.validaDtIniMenorIgualDtFin(widget.currentRow.DTINIVIGENCIA, widget.currentRow.DTFIMVIGENCIA)) {
                if (!widget.backupRow) {
                    widget.currentRow.__is_new = true;
                } else {
                    widget.currentRow.__is_new = false;
                }
                restEngine.post('product#/setTpItemCCT', {
                    'requestType': 'DataSet',
                    'dataset': [widget.currentRow]
                }).
                then(function(data) {
                    if (data.notifications[0].type === "success") {
                        ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                        if (widget.currentRow.__is_new) {
                            ABUtilController.masterDetailVoltarList(widget);
                            widget.reload();
                        } else {
                            widget.backupRow = null;
                            widget.view();
                        }
                    } else {
                        ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                    }
                }).
                catch(function(e) {
                    var error;
                    if (e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
            } else {
                ScreenService.showMessage(Messages.DTINI_POST_DTFIM_ERROR);
                return false;
            }
        }
    };

    this.deleteTpItemCCT = function(args) {
        var widget = args.owner.widget;
        ScreenService.confirmMessage(Messages.DELETE_ROW, 'CONFIRMATION',
            function() {
                if (widget.isValid()) {
                    widget.currentRow.__is_new = false;
                    restEngine.post('product#/deleteTpItemCCT', {
                        'requestType': 'DataSet',
                        'dataset': [widget.currentRow]
                    }).
                    then(function(data) {
                        if (data.messages) {
                            ScreenService.showMessage(Messages.REMOVE_ROW_ERROR + '. ' + data.messages[0].message, data.messages[0].type);
                        } else {
                            ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                            ABUtilController.masterDetailVoltarList(widget);
                            widget.reload();
                        }
                    }).
                    catch(function(e) {
                        var error;
                        if (e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;

                        ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    });
                }
            }
        );
    };


}

Configuration(function(ContextRegister) {
    ContextRegister.register('TpItemCCTController', TpItemCCTController);
});


// FILE: assets/js/controllers/TpObsAcaoController.js
function TpObsAcaoController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, General,Messages) {

    this.adicionarRow = function(args) {
        var widget = args.owner.widget;
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
    };
    
	this.setTpObsAcao = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
                if (!widget.backupRow) {
                    widget.currentRow.__is_new = true;
                } else {
                    widget.currentRow.__is_new = false;
                }
                restEngine.post('product#/setTpObsAcao', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                    then(function (data) {
                        if (data.notifications[0].type === "success") {
                            ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                            if (widget.currentRow.__is_new) {
                                ABUtilController.masterDetailVoltarList(widget);
                                widget.reload();
                            } else {
                                ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                                widget.backupRow = null;
                                widget.view();
                            }
                        } else {
                            ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                        }
                    }).
                    catch(function(e) {
                        var error;
                        if(e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;
                            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    });
            }
    };
    
    this.deleteTpObsAcao = function(args) {
    ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
        var widget = args.owner.widget;
        widget.currentRow.__is_new = false;
        restEngine.post('product#/deleteTpObsAcao', {'requestType':'DataSet','dataset':[widget.currentRow]}).
            then(function(data){
                if(data.notifications[0].type === "success"){
                    ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                    ABUtilController.masterDetailVoltarList(widget);
                    widget.reload();
                } else {
                    ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                }
            }).
            catch(function(e) {
                var error;
                if(e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
        }, null);
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('TpObsAcaoController', TpObsAcaoController);
});

// FILE: assets/js/controllers/TreinamentoController.js
function TreinamentoController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, General, Messages, $window) {

    this.adicionarRow = function(args) {
        var widget = args.owner.widget;
        widget.currentRow = {};
        widget.backupRow = undefined;
        ABUtilController.mudarVisibilidadeWidgets(widget.widgets, false);
        widget.newRow();
    };

    this.adicionarRowFilha = function(args) {
        var main = templateManager.container.getWidget('treinamento');
        var widget = args.owner.widget;
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
        widget.currentRow.NRTREINAMENTO = main.currentRow.NRTREINAMENTO;
    };

    this.documentoFieldOnChange = function(args) {
        var widget = args.owner.widget;
    };

    this.setTreinamento_tre = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
            if (!ABUtilController.validaDtIniMenorIgualDtFin(widget.currentRow.DTINIPLANEJADOTRE, widget.currentRow.DTFIMPLANEJADOTRE)) {
                ScreenService.showMessage("O ínicio planejado deve ser anterior a final planejado");
                widget.currentRow.DTAVISOFERIAS = "";
                return;
            } 
            
            if (!widget.backupRow) {
                widget.currentRow.__is_new = true;
            }
            else {
                widget.currentRow.__is_new = false;
            }
            restEngine.post('/setTreinamento_tre', {
                'requestType': 'DataSet',
                'dataset': [widget.currentRow]
            }).
            then(function(data) {
                if (data.notifications[0].type === "success") {
                    ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                    if (widget.currentRow.__is_new) {
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                        ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                    }
                    else {
                        ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                        widget.backupRow = null;
                        widget.view();
                    }
                }
                else {
                    ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                }
            }).
            catch(function(e) {
                var error;
                if (e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
        }
    };

    this.deleteTreinamento_tre = function(args) {
        ScreenService.confirmMessage('Deseja realmente excluir o arquivo ?', 'CONFIRMATION',
            function() {
                var widget = args.owner.widget;
                widget.currentRow.__is_new = false;
                restEngine.post('/deleteTreinamento_tre', {
                    'requestType': 'DataSet',
                    'dataset': [widget.currentRow]
                }).
                then(function(data) {
                    if (data.messages) {
                        ScreenService.showMessage(data.messages[0].message);
                    }
                    else {
                        if (data.notifications[0].type === "success") {
                            ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                            ABUtilController.masterDetailVoltarList(widget);
                            widget.reload();
                        }
                        else {
                            ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                        }
                    }
                }).
                catch(function(e) {
                    var error;
                    if (e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
            });
    };

    this.setParticipantes_Treinamento = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
            if (!widget.backupRow) {
                widget.currentRow.__is_new = true;
            }
            else {
                widget.currentRow.__is_new = false;
            }
            restEngine.post('/setParticipantes_Treinamento', {
                'requestType': 'DataSet',
                'dataset': [widget.currentRow]
            }).
            then(function(data) {
                if (data.notifications){
                    if (data.notifications[0].type === "success") {
                        ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                        if (widget.currentRow.__is_new) {
                            ABUtilController.masterDetailVoltarList(widget);
                            widget.reload();
                        }
                        else {
                            ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                            widget.backupRow = null;
                            widget.view();
                        }
                    }
                } else if(data.messages){
                    ScreenService.showMessage(data.messages[0].message);
                }
                else {
                    ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                }
            }).
            catch(function(e) {
                var error;
                if (e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
        }
    };

    this.deletaTodosParticipantes = function(args) {
        ScreenService.confirmMessage('Deseja realmente excluir os participantes ?', 'CONFIRMATION',
            function() {
                var widget = args.owner.widget;
                var widgetPai = widget.parent.parent;
                restEngine.post('/deletaTodosParticipantes', {
                    'requestType': 'DataSet',
                    'dataset': [widgetPai.currentRow]
                }).then(function(data){
                    ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                    ScreenService.closePopup();ScreenService.closePopup();
                    widget.reload();
                });
            });
    };

    this.deleteParticipantes_Treinamento = function(args) {
        ScreenService.confirmMessage('Deseja realmente excluir o arquivo ?', 'CONFIRMATION',
            function() {
                var widget = args.owner.widget;
                widget.currentRow.__is_new = false;
                restEngine.post('/deleteParticipantes_Treinamento', {
                    'requestType': 'DataSet',
                    'dataset': [widget.currentRow]
                }).
                then(function(data) {
                    if (data.notifications[0].type === "success") {
                        ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    }
                    else {
                        ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                    }
                }).
                catch(function(e) {
                    var error;
                    if (e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
            });
    };

    this.deleteDocumentos_Treinamento = function(widget) {
        ScreenService.confirmMessage('Deseja realmente excluir o arquivo ?', 'CONFIRMATION',
            function() {
                restEngine.post("/deleteDocumentos_Treinamento", {
                    requestType: "DataSet",
                    dataset: [widget.row]
                }).then(function(data) {
                    if (data.notifications[0].type == "success") {
                        ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                        ScreenService.closeSwipe();
                        widget.activate();
                        widget.reload();
                    }
                    else {
                        ScreenService.showMessage('Falha ao apagar o arquivo', 'ALERT');
                        widget.reload();
                    }

                }).catch(function(e) {
                    var error;
                    if (e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;
                    ScreenService.showMessage('Ocorreu um erro inesperado, contate o administrador informando o trecho abaixo: <br><br>' + error + '<br><br>', 'ERROR');
                });
            }
        );
    };

    this.setDespesas_Treinamento = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
            if (!widget.backupRow) {
                widget.currentRow.__is_new = true;
            }
            else {
                widget.currentRow.__is_new = false;
            }
            restEngine.post('/setDespesas_Treinamento', {
                'requestType': 'DataSet',
                'dataset': [widget.currentRow]
            }).
            then(function(data) {
                if (data.notifications[0].type === "success") {
                    ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                    if (widget.currentRow.__is_new) {
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    }
                    else {
                        ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                        widget.backupRow = null;
                        widget.view();
                    }
                    data.notifications.forEach(function(obj){
                        var array = obj.message.split(":");
                        if(Array.isArray(array) && array.length == 2 && array[0] == 'TOTALDESPESASREAL')  widget.parent.parent.currentRow.VRCUSTOREALTREINAMENTO = array[1];
                        if(Array.isArray(array) && array.length == 2 && array[0] == 'TOTALDESPESASPLAN')  widget.parent.parent.currentRow.VRCUSTOPLATREINAMENTO = array[1];
                    });
                }
                else {
                    ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                }
            }).
            catch(function(e) {
                var error;
                if (e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
        }
    };

    this.deleteDespesas_Treinamento = function(args) {
        ScreenService.confirmMessage('Deseja realmente excluir o arquivo ?', 'CONFIRMATION',
            function() {
                var widget = args.owner.widget;
                widget.currentRow.__is_new = false;
                restEngine.post('/deleteDespesas_Treinamento', {
                    'requestType': 'DataSet',
                    'dataset': [widget.currentRow]
                }).
                then(function(data) {
                    if (data.notifications[0].type === "success") {
                        ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                        
                        data.notifications.forEach(function(obj){
                            var array = obj.message.split(":");
                            if(Array.isArray(array) && array.length == 2 && array[0] == 'TOTALDESPESASREAL')  widget.parent.parent.currentRow.VRCUSTOREALTREINAMENTO = array[1];
                            if(Array.isArray(array) && array.length == 2 && array[0] == 'TOTALDESPESASPLAN')  widget.parent.parent.currentRow.VRCUSTOPLATREINAMENTO = array[1];
                        });
                        
                    }
                    else {
                        ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                    }
                }).
                catch(function(e) {
                    var error;
                    if (e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
            });
    };

    this.setLocal_Treinamento = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
            if(ABUtilController.validaDtIniMenorIgualDtFin(widget.currentRow.DTINILOCALTREINAMETNO , widget.currentRow.DTFINLOCALTREINAMENTO)){
                if (!widget.backupRow) {
                    widget.currentRow.__is_new = true;
                }
                
                else {
                    widget.currentRow.__is_new = false;
                }
                restEngine.post('/setLocal_Treinamento', {
                    'requestType': 'DataSet',
                    'dataset': [widget.currentRow]
                }).
                then(function(data) {
                    if (data.notifications[0].type === "success") {
                        ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                        if (widget.currentRow.__is_new) {
                            ABUtilController.masterDetailVoltarList(widget);
                            widget.reload();
                        }
                        else {
                            ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                            widget.backupRow = null;
                            widget.view();
                        }
                    }
                    else {
                        ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                    }
                }).
                catch(function(e) {
                    var error;
                    if (e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;
                    
                    
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
        }else{
                ScreenService.showMessage(Messages.DTINI_POST_DTFIM_ERROR);
            }
        }
    };

    this.deleteLocal_Treinamento = function(args) {
        ScreenService.confirmMessage('Deseja realmente excluir o arquivo ?', 'CONFIRMATION',
            function() {
                var widget = args.owner.widget;
                widget.currentRow.__is_new = false;
                restEngine.post('/deleteLocal_Treinamento', {
                    'requestType': 'DataSet',
                    'dataset': [widget.currentRow]
                }).
                then(function(data) {
                    if (data.notifications[0].type === "success") {
                        ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    }
                    else {
                        ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                    }
                }).
                catch(function(e) {
                    var error;
                    if (e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
            });
    };

    this.setMaterial_Treinamento = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
            if(ABUtilController.validaDtIniMenorIgualDtFin(widget.currentRow.DTINIPRODUTOTRE , widget.currentRow.DTFINPRODUTOTRE)){
                
                if (!widget.backupRow) {
                    widget.currentRow.__is_new = true;
                }
                else {
                    widget.currentRow.__is_new = false;
                }
                restEngine.post('/setMaterial_Treinamento', {
                    'requestType': 'DataSet',
                    'dataset': [widget.currentRow]
                }).
                then(function(data) {
                    if (data.notifications[0].type === "success") {
                        ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                        if (widget.currentRow.__is_new) {
                            ABUtilController.masterDetailVoltarList(widget);
                            widget.reload();
                        }
                        else {
                            ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                            widget.backupRow = null;
                            widget.view();
                        }
                    }
                    else {
                        ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                    }
                }).
                catch(function(e) {
                    var error;
                    if (e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
            
            }else{
                ScreenService.showMessage(Messages.DTINI_POST_DTFIM_ERROR);
            }
        }
    };

    this.deleteMaterial_Treinamento = function(args) {
        ScreenService.confirmMessage('Deseja realmente excluir o arquivo ?', 'CONFIRMATION',
            function() {
                var widget = args.owner.widget;
                widget.currentRow.__is_new = false;
                restEngine.post('/deleteMaterial_Treinamento', {
                    'requestType': 'DataSet',
                    'dataset': [widget.currentRow]
                }).
                then(function(data) {
                    if (data.notifications[0].type === "success") {
                        ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    }
                    else {
                        ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                    }
                }).
                catch(function(e) {
                    var error;
                    if (e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
            });
    };

    this.setDocumentos_Treinamento = function(args) {
        var widget = args.owner.widget;
        var caracteresInvalidos = ["*", "%", "@", "#", "$", "¨", "&", "'"];
        var verificaNomeArquivo = !caracteresInvalidos.find(function(value) {
            return widget.currentRow.DSREFARQUIVOTRE[0].name.indexOf(value) !== -1;
        });
        if (verificaNomeArquivo) {
            if (widget.currentRow.DSREFARQUIVOTRE[0].name.split(".")[1] !== undefined) {
                if (widget.isValid()) {
                    return restEngine.post("/setDocumentos_Treinamento", {
                        requestType: "DataSet",
                        dataset: [widget.currentRow]
                    }).then(function(data) {
                        if (!Util.isUndefined(data.notifications) && data.notifications[0]) {
                            ScreenService.successNotification("Arquivo carregado com sucesso", 5000);
                            ABUtilController.masterDetailVoltarList(widget);
                            widget.reload();
                        }
                        else {
                            ScreenService.showMessage("Não foi possível realizar o upload do arquivo");
                        }
                        widget.reload();
                    }.bind(this)).catch(function(e) {
                        var error;
                        if (e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;
                        ScreenService.showMessage('Ocorreu um erro inesperado, contate o administrador informando o trecho abaixo: <br><br>' + error + '<br><br>', 'ERROR');
                    });
                }
            }
            else {
                ScreenService.showMessage('Extensão do arquivo não reconhecida');
            }
        }
        else {
            ScreenService.showMessage('Nome inválido para o arquivo');
        }
    };

    this.setProduto = function(widget) {
        if (widget.isValid()) {
            if (!widget.backupRow) {
                widget.currentRow.__is_new = true;
            }
            else {
                widget.currentRow.__is_new = false;
            }
            restEngine.post('/setProdutoTRE', {
                'requestType': 'DataSet',
                'dataset': [widget.currentRow]
            }).
            then(function(data) {
                if (data.notifications[0].type === "success") {
                    ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                    if (widget.currentRow.__is_new) {
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    }
                    else {
                        ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                        widget.backupRow = null;
                        widget.view();
                    }
                }
                else {
                    ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                }
            }).
            catch(function(e) {
                var error;
                if (e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
        }
    };

    this.baixarDocumento = function(args) {
        var path = ABUtilController.getBaseUrlFileServer() + args.row.DSREFARQUIVOTRE;
        $window.open($window.serviceUrl + "/abrirArquivo?requestType=DataSet&dataset[0][CMARQUIVO]=" + path);
    };

    this.aprovaTreinamento = function(args) {
        var main = templateManager.container.getWidget('treinamento');
        var widget = args.owner.widget;
        if (widget.isValid()) {
            switch (main.currentRow.IDSTATUSTREINAMENTO) {
                case widget.currentRow.IDAPROV:
                case "CONCLUIDO":
                    ScreenService.showMessage("O treinamento já foi " + main.currentRow.IDSTATUSTREINAMENTO.toLowerCase());
                    break;
                case "ANDAMENTO":
                    ScreenService.showMessage("O treinamento já está  em " + main.currentRow.IDSTATUSTREINAMENTO.toLowerCase());
                    break;
                default:
                    {
                        main.currentRow.IDAPROV = widget.currentRow.IDAPROV;
                        main.currentRow.OBSAPROV = widget.currentRow.DSOBSERVACOES;
                        main.currentRow.DSMENSAGEM = widget.currentRow.DSMENSAGEM;
                        main.currentRow.DSTITULOMENSAGEM = widget.currentRow.DSTITULOMENSAGEM;
                        main.currentRow.IDOPERADORLOG = widget.currentRow.IDOPERADORLOG;
                        restEngine.post('/aprovaTreinamento', {
                            'requestType': 'DataSet',
                            'dataset': [main.currentRow]
                        }).
                        then(function(data) {
                            if (data.messages[0].type === "M") {
                                ScreenService.showMessage(data.messages[0].message);
                                ScreenService.closePopup();
                                ScreenService.closePopup();
                                ScreenService.closeSwipe(0).then(function() {
                                    main.activate();
                                    main.list();
                                    main.reload();
                                }.bind(this));

                            }
                            else {
                                ScreenService.showMessage(data.messages[0].message);
                            }
                        }).
                        catch(function(e) {
                            var error;
                            if (e.data.error === undefined)
                                error = e;
                            else
                                error = e.data.error;
                            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                        });
                    }
                    break;
            }


        }
    };

    this.executaTreinamento = function(args) {
        var main = templateManager.container.getWidget('treinamento');
        var widget = args.owner.widget;
        switch (main.currentRow.IDSTATUSTREINAMENTO) {
            case "CONCLUIDO":
                ScreenService.showMessage("O treinamento já foi " + main.currentRow.IDSTATUSTREINAMENTO.toLowerCase());
                break;
            case "ANDAMENTO":
                ScreenService.showMessage("O treinamento já está  em " + main.currentRow.IDSTATUSTREINAMENTO.toLowerCase());
                break;
            case "APROVADO":
                {
                    main.currentRow.DSMENSAGEM = widget.currentRow.DSMENSAGEM;
                    main.currentRow.DSTITULOMENSAGEM = widget.currentRow.DSTITULOMENSAGEM;
                    main.currentRow.IDOPERADORLOG = widget.currentRow.IDOPERADORLOG;
                    restEngine.post('/executaTreinamento', {
                        'requestType': 'DataSet',
                        'dataset': [main.currentRow]
                    }).
                    then(function(data) {
                        if (data.messages) {
                            ScreenService.showMessage(data.messages[0].message);
                        }
                        else {
                            ScreenService.closePopup();
                            ScreenService.closePopup();
                            ScreenService.closeSwipe(0).then(function() {
                                    main.activate();
                                    main.list();
                                    main.reload();
                                }.bind(this));
                        }
                    }).
                    catch(function(e) {
                        var error;
                        if (e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;
                        ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    });
                }
                break;
            default:
                ScreenService.showMessage("O treinamento deve ser aprovado antes de sua execução");
                break;
        }
    };

    this.enviaConvites = function(args) {
        var main = templateManager.container.getWidget('treinamento');
        var widget = args.owner.widget;
        switch (main.currentRow.IDSTATUSTREINAMENTO) {
            case "CONCLUIDO":
                ScreenService.showMessage("O treinamento já foi " + main.currentRow.IDSTATUSTREINAMENTO.toLowerCase());
                break;
            case "ANDAMENTO":
            case "APROVADO":
                {
                    main.currentRow.DSMENSAGEM = widget.currentRow.DSMENSAGEM;
                    main.currentRow.DSTITULOMENSAGEM = widget.currentRow.DSTITULOMENSAGEM;
                    main.currentRow.IDOPERADORLOG = widget.currentRow.IDOPERADORLOG;
                    restEngine.post('/enviaConvitesTreinamento', {
                        'requestType': 'DataSet',
                        'dataset': [main.currentRow]
                    }).
                    then(function(data) {
                        if (data.messages[0].type === "M") {
                            ScreenService.showMessage(data.messages[0].message);
                            ScreenService.closePopup();
                            ScreenService.closePopup();
                            main.reload();
                            main.activate();
                        }
                        else {
                            ScreenService.showMessage(data.messages[0].message);
                        }
                    }).
                    catch(function(e) {
                        var error;
                        if (e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;
                        ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    });
                }
                break;
            default:
                ScreenService.showMessage("O treinamento deve ser aprovado para que os convites sejam enviados");
                break;
        }
    };

    this.cancelaTreinamento = function(args) {
        var main = templateManager.container.getWidget('treinamento');
        var widget = args.owner.widget;
        switch (main.currentRow.IDSTATUSTREINAMENTO) {
            case "CANCELADO":
            case "CONCLUIDO":
                ScreenService.showMessage("O treinamento já foi " + main.currentRow.IDSTATUSTREINAMENTO.toLowerCase());
                break;
            default:
                {
                    main.currentRow.DSMENSAGEM = widget.currentRow.DSMENSAGEM;
                    main.currentRow.DSTITULOMENSAGEM = widget.currentRow.DSTITULOMENSAGEM;
                    main.currentRow.IDOPERADORLOG = widget.currentRow.IDOPERADORLOG;
                    restEngine.post('/cancelaTreinamento', {
                        'requestType': 'DataSet',
                        'dataset': [main.currentRow]
                    }).
                    then(function(data) {
                        if (data.messages[0].type == 'E') {
                            ScreenService.showMessage(data.messages[0].message);
                        }
                        else {
                            ScreenService.showMessage(data.messages[0].message);
                            ScreenService.closePopup();
                            ScreenService.closePopup();
                            ScreenService.closeSwipe(0).then(function() {
                                    main.activate();
                                    main.list();
                                    main.reload();
                                }.bind(this));
                        }
                    }).
                    catch(function(e) {
                        var error;
                        if (e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;
                        ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    });
                }
                break;
        }
    };

    this.atestaEficacia = function(args) {
        var main = templateManager.container.getWidget('treinamento');
        var widget = args.owner.widget;
        if (widget.isValid()) {
            switch (main.currentRow.IDSTATUSTREINAMENTO) {
                case "CONCLUIDO":
                case "ANDAMENTO":
                    {
                        main.currentRow.IDEFIC = widget.currentRow.IDEFIC;
                        main.currentRow.OBSEFIC = widget.currentRow.DSOBSERVACOES;
                        main.currentRow.DSMENSAGEM = widget.currentRow.DSMENSAGEM;
                        main.currentRow.DSTITULOMENSAGEM = widget.currentRow.DSTITULOMENSAGEM;
                        main.currentRow.IDOPERADORLOG = widget.currentRow.IDOPERADORLOG;
                        restEngine.post('/atestaEficaciaTreinamento', {
                            'requestType': 'DataSet',
                            'dataset': [main.currentRow]
                        }).
                        then(function(data) {
                            if (data.messages) {
                                ScreenService.showMessage(data.messages[0].message);
                            }
                            else {
                                ScreenService.closePopup();
                                ScreenService.closePopup();
                                main.reload();
                                main.activate();
                            }
                        }).
                        catch(function(e) {
                            var error;
                            if (e.data.error === undefined)
                                error = e;
                            else
                                error = e.data.error;
                            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                        });
                    }
                    break;
                default:
                    ScreenService.showMessage("O treinamento deve estar em execução ou concluido antes de sua eficacia ser definida");
                    break;
            }
        }
    };

    this.eficaciaFieldOnchange = function(args) {

    };

    this.concluiTreinamento = function(args) {
        var main = templateManager.container.getWidget('treinamento');
        switch (main.currentRow.IDSTATUSTREINAMENTO) {
            case "CONCLUIDO":
                ScreenService.showMessage("O treinamento já foi " + main.currentRow.IDSTATUSTREINAMENTO.toLowerCase());
                break;
            case "ANDAMENTO":
                {
                    restEngine.post('/concluiTreinamento', {
                        'requestType': 'DataSet',
                        'dataset': [main.currentRow]
                    }).
                    then(function(data) {
                        if (data.messages[0].type == 'E') {
                            ScreenService.showMessage(data.messages[0].message);
                        }
                        else {
                            ScreenService.showMessage(data.messages[0].message);
                            ScreenService.closePopup();

                            ScreenService.closeSwipe(0).then(function() {
                                    main.activate();
                                    main.list();
                                    main.reload();
                                }.bind(this));
                        }
                    }).
                    catch(function(e) {
                        var error;
                        if (e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;
                        ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    });
                }
                break;
            default:
                ScreenService.showMessage("O treinamento deve estar em execução antes de ser concluido");
                break;
        }
    };

    this.treinamentoAfterMoveRow = function(widget) {
        widget.widgets.forEach(function(tab) {
            tab.dataSourceFilter[0].value = widget.currentRow.NRTREINAMENTO;
        });
        var participantes = templateManager.container.getWidget("participantes");
        var documentos = templateManager.container.getWidget("documentos");
        var despesas = templateManager.container.getWidget("despesas");
        var local = templateManager.container.getWidget("local");
        var material = templateManager.container.getWidget("material");
        if (widget.currentRow.__is_new) {
            {
                widget.getField("NMCURSO").readOnly = false;
                widget.getField("NMPERFACESAPROV").readOnly = false;
                widget.getField("NMMETODOTRE").readOnly = false;
                widget.getField("NMPERFACESEXEC").readOnly = false;
                widget.getField("NMPARCINSTRUTOR").readOnly = false;
                widget.getField("NMTREINAMENTO").readOnly = false;
                widget.getField("NMTPCUSTOTRE").readOnly = false;
                widget.getField("IDTREINAMENTOINT").readOnly = false;
                widget.getField("DTINIPLANEJADOTRE").readOnly = false;
                widget.getField("VRCUSTOPLATREINAMENTO").readOnly = false;
                widget.getField("DTFIMPLANEJADOTRE").readOnly = false;
                widget.getField("VRCUSTOREALTREINAMENTO").readOnly = true;
            }
        }
        else
            switch (widget.currentRow.IDSTATUSTREINAMENTO) {
                case 'CANCELADO':
                case 'REPROVADO':
                    widget.getField("NMCURSO").readOnly = false;
                    widget.getField("NMPERFACESAPROV").readOnly = false;
                    widget.getField("NMMETODOTRE").readOnly = false;
                    widget.getField("NMPERFACESEXEC").readOnly = false;
                    widget.getField("NMPARCINSTRUTOR").readOnly = false;
                    widget.getField("NMTREINAMENTO").readOnly = false;
                    widget.getField("NMTPCUSTOTRE").readOnly = false;
                    widget.getField("IDTREINAMENTOINT").readOnly = false;
                    widget.getField("DTINIPLANEJADOTRE").readOnly = false;
                    widget.getField("VRCUSTOPLATREINAMENTO").readOnly = false;
                    widget.getField("DTFIMPLANEJADOTRE").readOnly = false;
                    widget.getField("VRCUSTOREALTREINAMENTO").readOnly = true;
                    participantes.getAction("new").isVisible = true;
                    participantes.getAction("cadastroAutomatico").isVisible = true;
                    participantes.getAction("excluir").isVisible = true;
                    participantes.getAction("editar").isVisible = true;
                    documentos.getAction("new").isVisible = true;
                    documentos.getAction("excluir").isVisible = true;
                    despesas.getAction("new").isVisible = true;
                    despesas.getAction("excluir").isVisible = true;
                    despesas.getAction("editar").isVisible = true;
                    local.getAction("new").isVisible = true;
                    local.getAction("excluir").isVisible = true;
                    local.getAction("editar").isVisible = true;
                    material.getAction("new").isVisible = true;
                    material.getAction("excluir").isVisible = true;
                    material.getAction("editar").isVisible = true;
                    participantes.getField("NMPRINCIPALPARC").readOnly = false;
                    participantes.getField("VRNOTAPARTICIPATRE").readOnly = true;
                    participantes.getField("VRPERFREQUENCIATRE").readOnly = true;
                    despesas.getField("VRPLANEJADODESPTRE").readOnly = false;
                    despesas.getField("VRREALIZADODESPTRE").readOnly = true;
                    break;
                case 'APROVADO':
                    widget.getField("NMCURSO").readOnly = true;
                    widget.getField("NMPERFACESAPROV").readOnly = true;
                    widget.getField("NMMETODOTRE").readOnly = true;
                    widget.getField("NMPERFACESEXEC").readOnly = true;
                    widget.getField("NMPARCINSTRUTOR").readOnly = false;
                    widget.getField("NMTREINAMENTO").readOnly = true;
                    widget.getField("NMTPCUSTOTRE").readOnly = true;
                    widget.getField("IDTREINAMENTOINT").readOnly = true;
                    widget.getField("DTINIPLANEJADOTRE").readOnly = false;
                    widget.getField("VRCUSTOPLATREINAMENTO").readOnly = false;
                    widget.getField("DTFIMPLANEJADOTRE").readOnly = false;
                    widget.getField("VRCUSTOREALTREINAMENTO").readOnly = false;
                    widget.getAction("excluir").isVisible = true;
                    widget.getAction("editar").isVisible = true;
                    participantes.getAction("new").isVisible = true;
                    participantes.getAction("cadastroAutomatico").isVisible = true;
                    participantes.getAction("excluir").isVisible = true;
                    participantes.getAction("editar").isVisible = true;
                    documentos.getAction("new").isVisible = true;
                    documentos.getAction("excluir").isVisible = true;
                    despesas.getAction("new").isVisible = true;
                    despesas.getAction("excluir").isVisible = true;
                    despesas.getAction("editar").isVisible = true;
                    local.getAction("new").isVisible = true;
                    local.getAction("excluir").isVisible = true;
                    local.getAction("editar").isVisible = true;
                    material.getAction("new").isVisible = true;
                    material.getAction("excluir").isVisible = true;
                    material.getAction("editar").isVisible = true;
                    participantes.getField("NMPRINCIPALPARC").readOnly = false;
                    participantes.getField("VRNOTAPARTICIPATRE").readOnly = false;
                    participantes.getField("VRPERFREQUENCIATRE").readOnly = false;
                    despesas.getField("VRPLANEJADODESPTRE").readOnly = false;
                    despesas.getField("VRREALIZADODESPTRE").readOnly = false;
                    break;
                case 'PENDENTE':
                case 'ANDAMENTO':
                    widget.getField("NMCURSO").readOnly = true;
                    widget.getField("NMPERFACESAPROV").readOnly = true;
                    widget.getField("NMMETODOTRE").readOnly = false;
                    widget.getField("NMPERFACESEXEC").readOnly = true;
                    widget.getField("NMPARCINSTRUTOR").readOnly = false;
                    widget.getField("NMTREINAMENTO").readOnly = false;
                    widget.getField("NMTPCUSTOTRE").readOnly = true;
                    widget.getField("IDTREINAMENTOINT").readOnly = true;
                    widget.getField("DTINIPLANEJADOTRE").readOnly = true;
                    widget.getField("VRCUSTOPLATREINAMENTO").readOnly = true;
                    widget.getField("DTFIMPLANEJADOTRE").readOnly = true;
                    widget.getField("VRCUSTOREALTREINAMENTO").readOnly = false;
                    widget.getAction("excluir").isVisible = true;
                    widget.getAction("editar").isVisible = true;
                    participantes.getAction("new").isVisible = true;
                    participantes.getAction("cadastroAutomatico").isVisible = true;
                    participantes.getAction("excluir").isVisible = true;
                    participantes.getAction("editar").isVisible = true;
                    documentos.getAction("new").isVisible = true;
                    documentos.getAction("excluir").isVisible = true;
                    despesas.getAction("new").isVisible = true;
                    despesas.getAction("excluir").isVisible = true;
                    despesas.getAction("editar").isVisible = true;
                    local.getAction("new").isVisible = true;
                    local.getAction("excluir").isVisible = true;
                    local.getAction("editar").isVisible = true;
                    material.getAction("new").isVisible = true;
                    material.getAction("excluir").isVisible = true;
                    material.getAction("editar").isVisible = true;
                    participantes.getField("NMPRINCIPALPARC").readOnly = false;
                    participantes.getField("VRNOTAPARTICIPATRE").readOnly = false;
                    participantes.getField("VRPERFREQUENCIATRE").readOnly = false;
                    despesas.getField("VRPLANEJADODESPTRE").readOnly = false;
                    despesas.getField("VRREALIZADODESPTRE").readOnly = false;
                    break;
                case 'CONCLUIDO':
                case 'INVALIDO':
                    widget.getAction("excluir").isVisible = false;
                    widget.getAction("editar").isVisible = false;
                    participantes.getAction("new").isVisible = false;
                    participantes.getAction("cadastroAutomatico").isVisible = false;
                    participantes.getAction("excluir").isVisible = false;
                    participantes.getAction("editar").isVisible = false;
                    documentos.getAction("new").isVisible = false;
                    documentos.getAction("excluir").isVisible = false;
                    despesas.getAction("new").isVisible = false;
                    despesas.getAction("excluir").isVisible = false;
                    despesas.getAction("editar").isVisible = false;
                    local.getAction("new").isVisible = false;
                    local.getAction("excluir").isVisible = false;
                    local.getAction("editar").isVisible = false;
                    material.getAction("new").isVisible = false;
                    material.getAction("excluir").isVisible = false;
                    material.getAction("editar").isVisible = false;
                    participantes.getField("NMPRINCIPALPARC").readOnly = true;
                    participantes.getField("VRNOTAPARTICIPATRE").readOnly = true;
                    participantes.getField("VRPERFREQUENCIATRE").readOnly = true;
                    despesas.getField("VRPLANEJADODESPTRE").readOnly = true;
                    despesas.getField("VRREALIZADODESPTRE").readOnly = true;
                    break;
            }
    };

    this.setCampoTitulo = function(args) {
        var widgetMensagens = ABUtilController.checkWidget(args);
        widgetMensagens.currentRow.DSTITULOMENSAGEM = widgetMensagens.currentRow.DSASSUNTOMENSAGEM;
    };

    this.openPopupByName = function(name) {
        var widget = templateManager.container.getWidget(name);
        widget.currentRow = {};
        widget.isVisible = true;
        ABUtilController.masterDetailOpenPopup(widget);
    };

    this.cadastroAutomatico = function(args) {
        var main = templateManager.container.getWidget('treinamento');
        var widget = args.owner.widget;
        widget.currentRow.NRORG = main.currentRow.NRORG;
        widget.currentRow.NRTREINAMENTO = main.currentRow.NRTREINAMENTO;
        widget.currentRow.NRCURSO = main.currentRow.NRCURSO;
        restEngine.post('/cadastroAutomaticoTreinamento', {
            'requestType': 'DataSet',
            'dataset': [widget.currentRow]
        }).
        then(function(data) {
            ScreenService.showMessage(data.messages[0].message);
            ScreenService.closePopup();
            ScreenService.closePopup();
            templateManager.container.getWidget('participantes').reload();
            templateManager.container.getWidget('participantes').activate();
            main.reload();
            main.activate();
        }).
        catch(function(e) {
            var error;
            if (e.data.error === undefined)
                error = e;
            else
                error = e.data.error;
            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
        });


    };

    this.calculaResultado = function(args) {
        var main = templateManager.container.getWidget('treinamento');
        var widget = templateManager.container.getWidget('participantes');
        switch (main.currentRow.IDSTATUSTREINAMENTO) {
            case "CONCLUIDO":
                {
                    restEngine.post('/calculaResultadoTreinamento', {
                        'requestType': 'DataSet',
                        'dataset': [main.currentRow]
                    }).
                    then(function(data) {
                        if (data.messages) {
                            ScreenService.showMessage(data.messages[0].message);
                        }
                        else {
                            ScreenService.closePopup();
                            widget.reload();
                            widget.activate();
                        }
                    }).
                    catch(function(e) {
                        var error;
                        if (e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;
                        ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    });
                }
                break;
            default:
                ScreenService.showMessage("O treinamento deve ser concluido antes de dos resultados serem calculados");
                break;
        }
    };


}
Configuration(function(ContextRegister) {
    ContextRegister.register('TreinamentoController', TreinamentoController);
});


// FILE: assets/js/controllers/UploadFileController.js
function UploadFileController(metaDataFactory,ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, General,Messages, HcmConsts) {
    
    /* Controller utilizado também na tela hcm00118_gpe_parametrizacaoSindicado */
    
    this.setNrparcnegocioDatasourceFilter = function(args){
        var widget = ABUtilController.checkWidget(args);
        if (ABUtilController.retornaWidget(widget, 'WidgetUploadFoto')) {
            var widgetFoto = templateManager.container.getWidget('WidgetUploadFoto');
            widgetFoto.dataSourceFilter[0].value = widget.currentRow.NRPARCNEGOCIO;
        }
    };
    
    this.onEnterWidgetFoto = function(args){
        var widget = ABUtilController.checkWidget(args);
        widget.moveToFirst();
        if(!widget.currentRow.DSPATH){
            widget.currentRow.DSPATH = './assets/images/user.jpg';
        }
    };
    
    this.uploadFoto = function(args, nameWidgetPrin) {
        var widgetFoto = ABUtilController.checkWidget(args);
        if (widgetFoto.isValid()) {
            var widgetPrincipal = templateManager.container.getWidget(nameWidgetPrin);
            var caracteresInvalidos = ["*", "%", "@", "#", "$", "¨", "&", "'"];
            var verificaNomeArquivo = true;
            verificaNomeArquivo = !caracteresInvalidos.find(function(value) {
                return widgetFoto.currentRow.DSPATH[0].name ? widgetFoto.currentRow.DSPATH[0].name.indexOf(value) !== -1 : true;
            });
            widgetPrincipal.currentRow.DSPATH = widgetFoto.currentRow.DSPATH == './assets/images/user.jpg' ? [{'name': 'user', 'size': 20502, 'type': 'image/jpg','path': './assets/images/user.jpg'}] : widgetFoto.currentRow.DSPATH;
            widgetPrincipal.currentRow.IDFOTO = 'S';
            restEngine.post('product#/saveUploadFile', {'requestType': 'DataSet', 'dataset': [widgetPrincipal.currentRow]}).
                then(function (data) {
                    ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                    widgetFoto.list();
                    widgetFoto.activate();
                    widgetFoto.reload();
                }).
                catch(function(e) {
                    var error;
                    if(e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;
                        
                    widgetFoto.currentRow.DSPATH = '';
                    widgetFoto.currentRow.DSREFERENCIA = '';
                    widgetFoto.currentRow.DSURL = '';
                    widgetFoto.currentRow.DTINCLUSAO = '';
                    widgetFoto.currentRow.DTULTATU  = '';
                    widgetFoto.currentRow.IDFOTO = '';
                    widgetFoto.currentRow.IDTYPE = '';
                    widgetFoto.currentRow.NMANEXO = '';
                    widgetFoto.currentRow.NRANEXO = '';
                    widgetFoto.reload();
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
        }else{
            ScreenService.showMessage('Escolha uma foto');
        }
    };
    
    this.adicionarRowLogo = function() {
        var widget = templateManager.container.getWidget('WidgetUploadFoto');
        
        if(widget.currentRow.hasOwnProperty('NRANEXO')){
            ScreenService.showMessage(Messages.HCM00044_VERIFICA_LOGO_EXISTENTE);
        } else {
            widget.currentRow = {};
            widget.backupRow = undefined;
            widget.newRow();
        }
    };
    
    this.limpaDataSourceLogo = function() {
        var widget = templateManager.container.getWidget('WidgetUploadFoto');
        
        if( widget.dataSource.data.length == 0 )
            widget.currentRow = [];
    };
    
    this.deleteFoto = function(args) {
        ScreenService.confirmMessage('Deseja realmente excluir o arquivo ?', 'CONFIRMATION',
            function() {
                var widget = ABUtilController.checkWidget(args);
                if(widget.currentRow.hasOwnProperty('NRANEXO')) {
                    //var widget = ABUtilController.checkWidget(args);
                    restEngine.post('product#/apagarArquivos', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                        then(function (data) {
                            ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                            widget.currentRow.DSPATH = null;
                            delete widget.currentRow.NRANEXO;
                            widget.reload();
                        }).
                        catch(function(e) {
                            var error;
                            if(e.data.error === undefined)
                                error = e;
                            else
                                error = e.data.error;
                            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                        });
                }
            });
    };
    
    this.resetWidget = function(args) {
        var widget = templateManager.container.getWidget('WidgetUploadFoto');
        if (!Util.isUndefined(widget)) {
            widget.currentRow.DSPATH = '';
            widget.reload();
        }
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('UploadFileController', UploadFileController);
});

// FILE: assets/js/controllers/ValeTransporteController.js
function ValeTransporteController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, General,Messages, $window) {
    
    this.camposData = ['DTINILINHAVINC', 'DTFIMLINHAVINC'];
    
	this.salvarVale = function(args) {
        var widget = ABUtilController.checkWidget(args);
        if(widget.isValid())  {
            if (!widget.backupRow) {
                widget.currentRow.__is_new = true;
            } else {
                widget.currentRow.__is_new = false;
            }
            widget.currentRow.NRORGTRAB = getLocalVar("HCM_NRORG_TRAB");
            return widget.saveRow().then(function (data){
                if(data.notifications[0].type === "success"){
                    ScreenService.showMessage(Messages.SAVE_ROW_SUCCESS);
                } else {
                    ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                }
                
                if (widget.currentRow.__is_new) {
                    ABUtilController.masterDetailVoltarList(widget);
                    widget.reload();
                } else {
                    ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                    widget.backupRow = null;
                    widget.view();
                    
                    // As datas são colocadas no formato 'Y/m/d'. Neste formato é possível compará-las mesmo sendo String
                    var dtFim = widget.currentRow.DTFIMLINHAVINC;
                    dtFim = typeof(dtFim) == 'string' && dtFim.length > 0 ? dtFim.split("/") : null;
                    dtFim = dtFim && dtFim.length == 3 ? dtFim[2]+dtFim[1] : null;
                    var competencia = getLocalVar("HCM_DTCOMPETENCIA");
                    competencia = typeof(competencia) == 'string' && competencia.length > 0 ? competencia.split("/") : null;
                    competencia = competencia && competencia.length == 3 ? competencia[2]+competencia[1] : null;
                    
                    if(widget.currentRow.CDINTEGTRANSP && dtFim && competencia){
                        if(dtFim <= competencia) widget.currentRow.IDINTEGRESERVA = 'S';  
                        else widget.currentRow.IDINTEGRESERVA = 'N';  
                    }
                    else if(!dtFim) widget.currentRow.IDINTEGRESERVA = 'N';  
                    
                }
            }.bind(this)).catch(function(e) {
                var error;
                if(e.data.error === undefined)
                    error = e;
                else 
                    error = e.data.error;
                
                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error));
            });
        }
    };
    
    this.geraPlanilhaModelo = function() {
        restEngine.post('product#/baixarPlanilhaModelo', {
        'requestType': 'DataSet',
        'dataset': []
        }).then(function(data) {
            ScreenService.closePopup();
            if(data.dataset && data.dataset.arquivo){
                $window.open($window.serviceUrl + "/abrirArquivo?requestType=DataSet&dataset[0][CMARQUIVO]=" + data.dataset.arquivo.NMARQUIVO);
            }
        }).catch(function(e) {
            var error;
            if (e.data.error === undefined)
                error = e;
            else
                error = e.data.error;
            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
        });
            
    };
    this.openPopupModelo = function(widget, action) {
        this.NMIMPORTACAO = action;
        var widgetPopupImportacao = templateManager.container.getWidget('popupModelo');
        widgetPopupImportacao.currentRow.DSPATH = [];
        ScreenService.openPopup(widgetPopupImportacao);
    };
    
    var openPopupMensagensImportacao = function(msg) {
        var widgetMensagens = templateManager.container.getWidget('mensagensImportacao');
        widgetMensagens.dataSource.data = msg;
        ScreenService.openPopup(widgetMensagens);
    };
    
    this.popupImportacaoVoltar = function() {
        ScreenService.closePopup();
        templateManager.container.getWidget('valeTransporte').activate();
    };
    
    this.validaArquivo = function(filePath) {
        var extension = filePath.split('.').pop().toUpperCase();
        if (extension !== 'XLS' && extension !== 'XLSX' && extension !== 'ACJ' && extension !== 'txt' && extension !== 'TXT') {
            ScreenService.showMessage('Formato de arquivo inválido');
            return false;
        } else {
            return true;
        }
    };
    
    this.importaArquivoModelo = function() {
        var widgetPop = templateManager.container.getActiveWidget();
        var widgetPai = templateManager.container.getWidget('valeTransporte');
        if(widgetPop.isValid()){
            if(this.validaArquivo(widgetPop.currentRow.DSPATH[0].name)) {
                restEngine.post('product#/importaArquivoModelo', {'requestType': 'DataSet', 'dataset': [widgetPop.currentRow]}).
                then(function(data) {
                    if (data.messages) {
                        ScreenService.closePopup(true);
                        ScreenService.showMessage(data.messages[0].message, data.messages[0].type);
                        if (data.dataset && data.dataset.msg) {
                            openPopupMensagensImportacao(data.dataset.msg);
                        } else {
                            widgetPai.activate();
                        }
                        widgetPai.reload();
                    } else
                        ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                }).
                catch(function(e) {   
                    var error;
                    if (e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    
                });
            }
        }
    };
    
    this.deleteValeTransporte = function(args) {
        var widget = ABUtilController.checkWidget(args);
        ScreenService.confirmMessage('Deseja realmente excluir o vale?', 'CONFIRMATION', 
            function() {
                var data = {};
                widget.dataSource.checkedRows = widget.currentRow;
                widget.removeCheckedRows();
                widget.reload();
                ScreenService.showMessage(Messages.REMOVE_ROW_SUCCESS);
                ABUtilController.masterDetailVoltarList(widget);
            }.bind(this)
        );
    };
    
}

Configuration(function(ContextRegister) {
    ContextRegister.register('ValeTransporteController', ValeTransporteController);
});

// FILE: assets/js/controllers/ValidacaoSistemaController.js
function ValidacaoSistemaController(ScreenService, templateManager, restEngine, ABUtilController, Messages, General, ZhUtil) {
    
    var self = this;
    
    this.verificaVinculos = function(args){
        var widget = ABUtilController.checkWidget(args);
        if(!widget.currentRow.LIST_NRESTRUTLEGAL && !widget.currentRow.LIST_NRESTRUTGEREN && !widget.currentRow.NRVINCULOM_LIST){
            ScreenService.showMessage('Para realizar a validação é necessário selecionar estrutura legal, estrutura gerencial ou vínculo.', 'ERROR');
            return false;
        }else{
            return true;
        }
    };
    
    this.geraValidacao = function(args) {
        var widget = ABUtilController.checkWidget(args);
        var widgetMain = templateManager.container.getWidget('validacaoSistema');
        if(self.verificaVinculos(args)){
            if(widget.isValid()){
                ScreenService.confirmMessage('Deseja realmente gerar a Validação?', 'CONFIRMATION', 
                    function(){
                        restEngine.post("product#/geraValidacao",
                                {'requestType':'DataSet','dataset':[ZhUtil.clearRow(widget.currentRow)]},
                            function(data) {
                                    if(data.messages){
                                        ScreenService.successNotification(data.messages[0].message);
                                        ScreenService.closePopup(true);
                                    }
                                    widgetMain.reload();
                                }.bind(this),undefined,
                            function(e) {
                                var error;
                                if(e.data.error === undefined)
                                    error = e;
                                else 
                                    error = e.data.error;
                                ScreenService.showMessage('Ocorreu um erro inesperado, contate o administrador informando o trecho abaixo: <br><br>' + error + '<br><br>', 'ERROR');
                            }
                        );
                    }.bind(this)
                );
                
            }
        }
    };
    
    this.openPopUpGeraValidacao = function(args) {
        var widgetPopup = templateManager.container.getWidget('gerarValidacao');
        ABUtilController.masterDetailOpenPopup(widgetPopup);
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('ValidacaoSistemaController', ValidacaoSistemaController);
});

// FILE: assets/js/controllers/ValorReferenciaController.js
function ValorReferenciaController(ScreenService, templateManager, restEngine, ABUtilController, Messages, General) {
    
    this.adicionarRow = function(args) {
        var widget = args.owner.widget;
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
    };
    
    this.validaValorReferencia = function(args, currentRow){
        var widget = ABUtilController.checkWidget(args);
        var rows = widget.dataSource.data;
        var verifica = true;
        rows.forEach(function(row){
            if(row.DSREFERENCIA === currentRow.DSREFERENCIA && !row.__createdLocal && currentRow.__is_new){
                ScreenService.showMessage('Histórico da referência "' + row.DSREFERENCIA + '" encontrada! Favor alterar no registro já existente.');
                ABUtilController.masterDetailVoltarList(widget);
                verifica = false;
            }
        });
        return verifica;
    };
    
    this.salvar = function(args) {
        var widget = args.owner.widget;
        widget.currentRow.VRREFVALORREF = null;
        widget.currentRow.VRREFERENCIA = General.valueToFloat(widget.currentRow.VRREFERENCIA);
        if (widget.isValid()) {
            if(this.validaValorReferencia(args, widget.currentRow)){
                if(ABUtilController.validaDtIniMenorIgualDtFin(widget.currentRow.DTINIVIGENCIA,widget.currentRow.DTFIMVIGENCIA)){
                    ABUtilController.saveMasterDetailMasterHistory(widget);
                }else{
                    ScreenService.showMessage(Messages.DTINI_POST_DTFIM_ERROR);
                    return false;
                }  
            }
        }
    };

    this.remover = function(args) {
    ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
        var widget = args.owner.widget;
        if (widget.isValid()) {
            widget.currentRow.__is_new = false;
            restEngine.post('product#/deleteValorReferencia', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                then(function (data) {
                    if (data.notifications[0].type === "success") {
                        ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    } else {
                        ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                    }
                }).
                catch(function(e) {
                    var error;
                    if(e.data.error === undefined){
                        error = e;
                    }    
                    else{
                        error = e.data.error;
                        ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    }    
                });
            }
        }, null);
    };

}

Configuration(function(ContextRegister) {
    ContextRegister.register('ValorReferenciaController', ValorReferenciaController);
});

// FILE: assets/js/controllers/VerificacaoController.js
function VerificacaoController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, General, Messages) {

    this.afterMoveRowVerificacao = function(widget) {
        if (widget.currentRow.NRORG === getLocalVar('HCM_NRORG_TRAB')) {
            widget.getAction('ativar').isVisible = (widget.currentRow.IDATIVO === 'N');
            widget.getAction('desativar').isVisible = (widget.currentRow.IDATIVO === 'S');
        }

        var widgetParamverifica = templateManager.container.getWidget("paramverifica");
        var widgetPerfilverifica = templateManager.container.getWidget("perfilverifica");

        widgetParamverifica.getField('NRVERIFICACAO').defaultValue = widget.currentRow.NRVERIFICACAO;
        widgetParamverifica.dataSource.data = [];
        widgetParamverifica.dataSourceFilter = [
            {"name": "P_NRORG", "operator": "=", "value": getLocalVar('HCM_NRORG_TRAB')},
            {"name": "P_NRORG_PADRAO", "operator": "=", "value": getLocalVar('HCM_NRORG_PADRAO')},
            {"name": "NRVERIFICACAO", "operator": "=", "value": widget.currentRow.NRVERIFICACAO}
        ];

        widgetPerfilverifica.getField('NRVERIFICACAO').defaultValue = widget.currentRow.NRVERIFICACAO;
        widgetPerfilverifica.dataSource.data = [];
        widgetPerfilverifica.dataSourceFilter = [
            {"name": "P_NRORG", "operator": "=", "value": getLocalVar('HCM_NRORG_TRAB')},
            {"name": "P_NRORG_PADRAO", "operator": "=", "value": getLocalVar('HCM_NRORG_PADRAO')},
            {"name": "NRVERIFICACAO", "operator": "=", "value": widget.currentRow.NRVERIFICACAO}
        ];
    };

    this.setVerificacao = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
            if (!widget.backupRow) {
                widget.currentRow.__is_new = true;
            } else {
                widget.currentRow.__is_new = false;
            }
            widget.currentRow.DSCONSULTAVERIFICAAUX = widget.currentRow.DSCONSULTAVERIFICAAUX.toUpperCase();
            restEngine.post('product#/setVerificacao', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                then(function (data) {
                    if (data.notifications[0].type === "success") {
                        if (data.messages) {
                            ScreenService.showMessage(data.messages[0].message, data.messages[0].type);
                        } else {
                            ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                        }
                        if (widget.currentRow.__is_new) {
                            ABUtilController.masterDetailVoltarList(widget);
                            widget.reload();
                        } else {
                            widget.backupRow = null;
                            widget.view();
                        }
                        ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                    } else if (data.messages) {
                        ScreenService.showMessage(data.messages[0].message, data.messages[0].type);
                    } else {
                        ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                    }
                }).
                catch(function(e) {
                    var error;
                    if(e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;
                        ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
        }
    };

    this.setStatusVerificacao = function(args) {
        var widget = args.owner.widget;
        var action = args.owner.name;
        var route = (action === 'ativar' ? '/ativarVerificacao' : '/desativarVerificacao');
        restEngine.post(route, {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
            then(function (data) {
                if (data.notifications && data.notifications[0].type === "success") {
                    widget.currentRow.IDATIVO = (action === 'ativar' ? 'S' : 'N');
                    widget.getAction('ativar').isVisible = (widget.currentRow.IDATIVO === 'N');
                    widget.getAction('desativar').isVisible = (widget.currentRow.IDATIVO === 'S');
                    templateManager.container.getWidget("paramverifica").getAction('editar').isVisible = (widget.currentRow.IDATIVO === 'N');
                    ScreenService.successNotification(
                        (action === 'ativar' ? Messages.HCM00000_GER_VERIF_ACTIVATE_SUCCESS : Messages.HCM00000_GER_VERIF_DEACTIVATE_SUCCESS),
                        10000
                    );
                } else if (data.messages) {
                    ScreenService.showMessage(data.messages[0].message, data.messages[0].type);
                } else {
                    ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                }
            }).
            catch(function (e) {
                var error;
                if (e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
    };

    this.deleteVerificacao = function(args) {
    ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
        var widget = args.owner.widget;
        widget.currentRow.__is_new = false;

        restEngine.post('product#/deleteVerificacao', {'requestType':'DataSet','dataset':[widget.currentRow]}).
            then(function(data){
                if(data.notifications[0].type === "success"){
                    ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                    ABUtilController.masterDetailVoltarList(widget);
                    widget.reload();
                } else {
                    ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                }
            }).
            catch(function(e) {
                var error;
                if(e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
        }, null);
    };

    this.afterMoveRowParamverifica = function(widget) {
        var widgetVerificacao = templateManager.container.getWidget("verificacao");
        widget.getAction('editar').isVisible = (widgetVerificacao.currentRow.IDATIVO === 'N');
    };

    this.setParamverifica = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
            if (!widget.backupRow) {
                widget.currentRow.__is_new = true;
            } else {
                widget.currentRow.__is_new = false;
            }
            restEngine.post('product#/setParamverifica', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                then(function (data) {
                    if (data.notifications[0].type === "success") {
                        if (data.messages) {
                            ScreenService.showMessage(data.messages[0].message, data.messages[0].type);
                        } else {
                            ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                        }
                        if (widget.currentRow.__is_new) {
                            ABUtilController.masterDetailVoltarList(widget);
                            widget.reload();
                        } else {
                            ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                            widget.backupRow = null;
                            widget.view();
                        }
                    } else if (data.messages) {
                        ScreenService.showMessage(data.messages[0].message, data.messages[0].type);
                    } else {
                        ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                    }
                }).
                catch(function(e) {
                    var error;
                    if(e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
        }
    };

    this.setPerfilverifica = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
            if (!widget.backupRow) {
                widget.currentRow.__is_new = true;
            } else {
                widget.currentRow.__is_new = false;
            }
            restEngine.post('product#/setPerfilverifica', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                then(function (data) {
                    if (data.messages) {
                        ScreenService.showMessage(data.messages[0].message, data.messages[0].type);
                    } else if (data.notifications[0].type === "success") {
                        if (data.messages) {
                            ScreenService.showMessage(data.messages[0].message, data.messages[0].type);
                        } else {
                            ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                        }
                        if (widget.currentRow.__is_new) {
                            ABUtilController.masterDetailVoltarList(widget);
                            widget.reload();
                        } else {
                            ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                            widget.backupRow = null;
                            widget.view();
                        }
                    } else {
                        ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                    }
                }).
                catch(function(e) {
                    var error;
                    if(e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
        }
    };

    this.deletePerfilverifica = function(args) {
        var widget = args.owner.widget;
        widget.currentRow.__is_new = false;

        restEngine.post('product#/deletePerfilverifica', {'requestType':'DataSet','dataset':[widget.currentRow]}).
            then(function(data){
                if(data.notifications[0].type === "success"){
                    ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                    ABUtilController.masterDetailVoltarList(widget);
                    widget.reload();
                } else {
                    ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                }
            }).
            catch(function(e) {
                var error;
                if(e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('VerificacaoController', VerificacaoController);
});

// FILE: assets/js/controllers/VinculoBancoHorasController.js
/* jshint esversion: 6 */

function VinculoBancoHorasController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, ABUtilController, AFormataHoraDecimal, Messages) {

    this.openAdicionarAlteracao = function(args) {
        var widget = args.owner.widget;
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
    };

    this.setNrvinculo = function(argsRow) {
        setLocalVar('HCM_PTO_NRVINCULOM', argsRow.NRVINCULOM);
    };

    this.removeAlterBancohoras = function() {
        ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
                var widget = templateManager.container.getActiveWidget();
                widget.currentRow.__is_new = false;
                var removeData = Object.assign({}, widget.currentRow, {
                    "NRORG": getLocalVar("HCM_NRORG_TRAB")
                }, {
                    "CDOPERADOR_LOG": getLocalVar("HCM_CDOPERADOR")
                });
                restEngine.post('product#/removeAlterBancohoras', {
                    'requestType': 'DataSet',
                    'dataset': [removeData]
                }).
                then(function(data) {
                    if (data.notifications[0].type === "success") {
                        ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 1000);
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    }
                    else {
                        ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                    }
                }).catch(function(e) {
                    var error;
                    if (e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');

                });
        }, null);
    };

    this.setAlterBancoHoras = function() {
        var widget = templateManager.container.getActiveWidget();
        if (widget.isValid()) {
            if (this.validaPeriodo(widget.currentRow.DTINICIOALTEBHORAS, widget.currentRow.DTFIMALTEBHORAS)) {
                var tipo;
                if (!widget.backupRow) {
                    widget.currentRow.__is_new = true;
                    tipo = true;
                }
                else {
                    widget.currentRow.__is_new = false;
                    tipo = false;
                }
                var saveData = Object.assign({}, widget.currentRow, {
                    "NRORG": getLocalVar("HCM_NRORG_TRAB")
                }, {
                    "CDOPERADOR_LOG": getLocalVar("HCM_CDOPERADOR")
                });
                restEngine.post('product#/setAlterBancoHoras', {
                    'requestType': 'DataSet',
                    'dataset': [saveData]
                }).
                then(function(data) {
                    if (data.notifications[0].type === "success") {
                        ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 1000);
                        if(tipo){
                            ABUtilController.masterDetailVoltarList(widget);
                            widget.reload();
                        } else {
                            widget.reload();
                            widget.view();
                            templateManager.updateTemplate();                            
                        }
                    }
                    else {
                        ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                    }
                }).catch(function(e) {
                    var error;
                    if (e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });

            }
            else {
                ScreenService.showMessage('O campo "Fim Vigência" deve ser igual ou posterior ao campo "Início Vigência".');
                return false;
            }
        }
    };

    this.validaPeriodo = function(dtIni, dtFin) {
        if (moment(dtIni, 'DD/MM/YYYY').unix() > moment(dtFin, 'DD/MM/YYYY').unix() || moment(dtFin, 'DD/MM/YYYY').unix() < moment(dtIni, 'DD/MM/YYYY').unix()) {

            return false;
        }
        else {
            return true;
        }
    };
    
    this.openCadastroAutomaticoAlteracaoBancoPopUp = function() {
        var cadastroAutomaticoPopUpWidget = templateManager.container.getWidget('cadastroAutomaticoAlteracaoBanco');
        ScreenService.openPopup(cadastroAutomaticoPopUpWidget);
    };
    
    /* jshint ignore:start */
    this.setCadastroAutomaticoTipoVinculoFilter = function() {
        // Campo NRVINCULOM_LIST já é setado com filtro de tipo de vinculo como null, para que o tipo de vinculo seja preenchido primeiro
        
        var cadastroAutomaticoWidget = templateManager.container.getWidget('cadastroAutomaticoAlteracaoBanco');
        var fieldsFilteredByTipoVinculo = [
            'NRVINCULOM_LIST',
        ];
        
        var defaultTipoVinculoFilter = { name: "NRTIPOVINCULOM", operator: "=", value: "" };
        var tipoVinculoValue = cadastroAutomaticoWidget.currentRow.NRTIPOVINCULOM;
        
        for (var fieldName of fieldsFilteredByTipoVinculo) {
            var field = cadastroAutomaticoWidget.getField(fieldName);
            var dataSourceFilterTipoVinculoItem = field.dataSourceFilter.find(f => f.name === 'NRTIPOVINCULOM');
            if (!dataSourceFilterTipoVinculoItem) {
                dataSourceFilterTipoVinculoItem = { ...defaultTipoVinculoFilter };
                field.dataSourceFilter.push(dataSourceFilterTipoVinculoItem);
            }
            
            dataSourceFilterTipoVinculoItem.value = tipoVinculoValue;
            field.value([]);
            field.reload();
        }
    };
    /* jshint ignore:end */
    
    /* jshint ignore:start */
    this.saveCadastroAutomaticoAlteracaoBanco = async function() {
        const widget            = templateManager.container.getWidget('cadastroAutomaticoAlteracaoBanco');
        const originalWidget    = templateManager.container.getWidget('AltBancoHoras');
        
        if (!widget.isValid()) {
            return;
        }
        
        try {
            const response = await restEngine.post('product#/cadastroAutomaticoAlterBancoHoras', { requestType: 'Row', row: widget.currentRow });
            const success = response.dataset.cadastroAutomaticoAlterBancoHoras.success;
            
            if (success) {
                ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS);
                ScreenService.closePopup();

                originalWidget.reload();
                widget.currentRow = {};
                return;
            }
            
            ScreenService.errorNotification(Messages.SAVE_ROW_ERROR);
        } catch (error) {
            const message = error.data ? Messages.CATCH_EXCEPTION_ERROR(error.data.error) : Messages.SAVE_ROW_ERROR;
            ScreenService.showMessage(message);
        }
    };
    /* jshint ignore:end */

}

Configuration(function(ContextRegister) {
    ContextRegister.register('VinculoBancoHorasController', VinculoBancoHorasController);
});

// FILE: assets/js/controllers/VinculoController.js
/* jshint esversion: 6 */
function VinculoController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, General,Messages, HcmConsts, ESocialController, AdmissaoController, PessoaController, $window) {

    var self = this;
    var mensagem = '';
    var validaContratoVerdeAmarelo = false;
    var rescisaoAlterada;
    
    this.nmVinculoBeneficio = null;
    this.nrVinculoBeneficio = null;
    this.nrPessoaBeneficio = null;
    this.filtraPessoa = true;
    this.filtrarFilhasVinculo = false;
    this.naoFiltrarFilhasVinculo = false;
    this.adicionarDefaultVinculo = false;
    this.NRVINCULOM = null;
    this.NMVINCULOM = null;
    this.NRPESSOA = null;
    this.camposData = ['DTMESCOMPETENC', 'DTADMISSAOVINC', 'DTPRIMADMISSAO', 'DTEXAMEMEDICO', 'DTOPCAOFGTS', 'DTENTREGAEPI', 'DTAPOSENTAFGTS', 'DTFIMCONTRDETERMIN', 
                                'DTBASEFERIAS', 'DTEXRGPESSOA', 'DTNASCPESSOA', 'DTCTPSPESSOA', 'DTINSCPISPASEP', 'DTAVISOPREVIO', 'DTRESCISAOVINC', 'DTRESCISAOPROJETADA',
                                'DTCANCAVIPRE', 'DTRETORNO', 'DTEFEITOFINANCEIRO'];
    
    this.objActions = {
        'admissaoColetiva': {
            'name':'admissaoColetiva',
            'label': 'Admissão Coletiva',
            'route': '/admissaoColetivaVinc',
            'confirm': 'Deseja readimitir vínculos conforme os dados informados?'
        }
    };
    
    this.rowToBeSetFichaFinanceira = {'P_NRTPMODALIDCAL': 1,	 
                                      'P_NRTIPOMOVIMENT': 1,	 
                                      'NMTIPOMOVIMENT': 'MENSAL',	 
                                      'P_DTMESCOMPETENC': '',	 
                                      'P_NROCORRECAL': 1	 
                                      };
                                      
    this.openPopupImportacoes = function(widget, action) {
        this.NMIMPORTACAO = action;
        var widgetPopupImportacao = templateManager.container.getWidget('popupImportacao');
        widgetPopupImportacao.currentRow.DSPATH = [];
        ScreenService.openPopup(widgetPopupImportacao);
    };
    
    this.geraPlanilhaTemplate = function() {
    restEngine.post('product#/baixarPlanilhaSalarial', {
        'requestType': 'DataSet',
        'dataset': []
        }).then(function(data) {
            ScreenService.closePopup();
            if(data.dataset && data.dataset.arquivo){
                $window.open($window.serviceUrl + "/abrirArquivo?requestType=DataSet&dataset[0][CMARQUIVO]=" + data.dataset.arquivo.NMARQUIVO);
            }
        }).catch(function(e) {
            var error;
            if (e.data.error === undefined)
                error = e;
            else
                error = e.data.error;
            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
        });
            
    };
    
    this.importarPlanilhaSalarial = function() {
        var widgetPop = templateManager.container.getActiveWidget();
        var widgetPai = templateManager.container.getWidget('vinculo');
        if(widgetPop.isValid()){
            if(this.validaArquivo(widgetPop.currentRow.DSPATH[0].name)) {
                restEngine.post('product#/importarPlanilhaSalarial', {'requestType': 'DataSet', 'dataset': [widgetPop.currentRow]}).
                then(function(data) {
                    if (data.messages) {
                        ScreenService.closePopup(true);
                        ScreenService.showMessage(data.messages[0].message, data.messages[0].type);
                        if (data.dataset && data.dataset.msg) {
                            openPopupMensagens(data.dataset.msg);
                        } else {
                            widgetPai.activate();
                        }
                        widgetPai.reload();
                    } else
                        ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                }).
                catch(function(e) {   
                    var error;
                    if (e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    
                });
            }
        }
    };
    
    this.validaArquivo = function(filePath) {
        var extension = filePath.split('.').pop().toUpperCase();
        if (extension !== 'XLS' && extension !== 'XLSX') {
            ScreenService.showMessage('Formato de arquivo inválido');
            return false;
        } else {
            return true;
        }
    };
    
    var openPopupMensagens = function(msg) {
        var widgetMensagens = templateManager.container.getWidget('mensagensImportaSalarial');
        widgetMensagens.dataSource.data = msg;
        ScreenService.openPopup(widgetMensagens);
    };

    this.popupImportacaoPlanilhaVoltar = function() {
        ScreenService.closePopup();
        templateManager.container.getWidget('alteSalario').activate();
    };

    this.adicionarRow = function(args) {
        var widget = args.owner.widget;
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
    };
    
    this.filterNmSalarioFaixa = function(args) {
        var widget = templateManager.container.getWidget("vinculo");
        var nrvinculom = widget.currentRow.NRVINCULOM;
        
        widget = templateManager.container.getActiveWidget();
        var field = widget.getField("NMSALARIOFAIXA");
        
        field.dataSourceFilter.forEach( function(item) {
            if(item.name == "P_NRVINCULOM")
                item.value = nrvinculom; } );
    };
    
    this.adicionarRowBeneficioVinculo = function(){
        var widget = templateManager.container.getActiveWidget();
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
        widget.currentRow.NRVINCULOM = this.nrVinculoBeneficio;
        widget.currentRow.NMVINCULOM = this.nmVinculoBeneficio;
        widget.getField('NMPESSOA').readOnly = false;
        widget.getField('NMPESSOA').dataSourceFilter = [{
                                                            "name": "NRPESSOA",
                                                            "operator": "=",
                                                            "value": this.nrPessoaBeneficio
                                                        }];
        widget.getField('NMPESSOA').reload();                                                        
        widget.getField('DTCANCBENEFICIARIO').validations = {};
    };
    
    this.editarRowBeneficioVinculo = function(){
        var widget = templateManager.container.getActiveWidget();
        var pessoa = widget.getField('NMPESSOA');
        var cancelamento = widget.getField('DTCANCBENEFICIARIO');
        
        ABUtilController.masterDetailEdit(widget);
        
        
        if(widget.currentRow.TPPERIODOBENEF === 'DIARIO'){
            pessoa.readOnly = true;
            pessoa.dataSourceFilter = [{
                                            "name": "NRPESSOA",
                                            "operator": "=",
                                            "value": widget.currentRow.NRPESSOAVINC
                                        }];
        }else if(widget.currentRow.TPPERIODOBENEF === 'MENSAL'){
            pessoa.readOnly = false;
            pessoa.dataSourceFilter = [{
                                            "name": "NRPESSOA",
                                            "operator": "=",
                                            "value": widget.currentRow.NRPESSOAVINC
                                        }];
        }
        
        if(widget.currentRow.IDATIVO === 'N'){
            cancelamento.validations = {required:true};
        }else{
            cancelamento.validations = {};
        }
    };
    
    this.filtrarDependentePorVinculo = function(args){
        var widget = args.owner;
        templateManager.container.getWidget("alteSalario").dataSourceFilter[0].value = widget.currentRow.NRVINCULOM;
    };
    
    this.setDtCompetenciaDefaultFilter = function(){	 
        this.rowToBeSetFichaFinanceira.P_DTMESCOMPETENC = getLocalVar('HCM_DTCOMPETENCIA_OPER');	 
    };

    this.widgetsvisiblefalse = function(args) {
        var widget = args.owner.widget;
        widget.widgets[0].showAsTab = false;
    };
    
    this.reloadWidgetFilhas = function(){
        var widget =  templateManager.container.getActiveWidget();
        var nrvinculom = widget.dataSource.getFirstRow() ? widget.dataSource.getFirstRow().NRVINCULOM : null;
        if(nrvinculom != this.NRVINCULOM || !nrvinculom){
            widget.reload();
        }
    };
    
    this.validafiltro = function(args){
        var widget = ABUtilController.checkWidget(args);
        widget.dataSourceFilter.map(function(filtro){
            if(filtro.name === 'P_VINCULOSNAOAPROV'){
                if(filtro.value === '%N%'){
                    filtro.value = 'N';
                    widget.showCheckbox = false;
                }else{
                    filtro.value = 'S';
                    widget.showCheckbox = true;
                }
            }
        });
    };

    this.widgetsvisibletrue = function(name) {
        var widget = templateManager.container.getWidget(name);
        widget.widgets[0].showAsTab = true;
    };
    
    this.openFilhasVinculo = function(args,name){
        var widget = ABUtilController.checkWidget(args);
        ScreenService.openWindow('product#'+name);
        this.filtrarFilhasVinculo = true;
        this.filtraPessoa = false;
        this.NRVINCULOM = widget.currentRow.NRVINCULOM;
        this.NMVINCULOM = widget.currentRow.NMVINCULOM;
        this.NRPESSOA = widget.currentRow.NRPESSOA;
    };
    
    this.filtrarFilhasPorVinculo = function(args){
        var widget = ABUtilController.checkWidget(args);
        if(this.filtrarFilhasVinculo){
            widget.dataSourceFilter.push(
                {
                    "name": "NRPESSOA",
                    "operator": "=",
                    "value": this.NRPESSOA
                }
            );
            widget.reload().then(function(callBack){
                ScreenService.closePopup();
            });
            if(widget.dataSourceFilter[widget.dataSourceFilter.length-1].name == "NRPESSOA")
                widget.dataSourceFilter.pop();
            this.filtrarFilhasVinculo = false;
            this.adicionarDefaultVinculo = true;
        } else{
            this.adicionarDefaultVinculo = false;
            if(widget.name == "Pessoa" && this.filtraPessoa){
                ESocialController.widgetFilterOnEnterOnceEsocial('Pessoa','NRVINCULOM', PessoaController);
                this.filtraPessoa = false;
            }
        }
    };
    
    this.naoFiltrarPorVinculo = function(args){
        var widget = ABUtilController.checkWidget(args);
        if(this.naoFiltrarFilhasVinculo){
           widget.dataSource.data = [];
           var dataSourceFilter = widget.dataSourceFilter;
           for(var k in dataSourceFilter){
               if(dataSourceFilter[k].name === "NRVINCULOM"){
                   dataSourceFilter[k].operator = ">";
                   dataSourceFilter[k].value = 0;
               }
           }
            this.naoFiltrarFilhasVinculo = false;
        }
    };
    
    // this.abreFiltro = function(){
    //     if(!this.filtraPessoa){
    //         ESocialController.widgetFilterOnEnterOnceEsocial('Pessoa', 'NRPESSOA');
    //     }
    // };
    
    this.filtraVinculoEstrutura = function(args){
        var widget = ABUtilController.checkWidget(args);
        var row = widget.currentRow;
        if(row.NMESTRUTLEGAL !== row.nmestrut){
            widget.getField('NRVINCULOM').dataSourceFilter[0].value = row.NRESTRUTLEGAL;
            row.nmestrut = row.NMESTRUTLEGAL;
        }
    };
    
    this.onClickTela = function(args){
        this.naoFiltrarFilhasVinculo = true;
    };
    
    this.onChangeTipoVinculo = function(args){
        var widget = templateManager.container.getWidget("vinculo");
        var row = widget.currentRow;
        if(row.NRTIPOVINCULOM){
            switch (row.NRTIPOVINCULOM) {
                case HcmConsts.tipoVinculo.ESTAGIARIO:
                    row.IDREMUNERACAO = "ESTAGIO";
                    widget.getField('IDREMUNERACAO').readOnly = true;
                break;
                case HcmConsts.tipoVinculo.SOCIO:
                    row.IDREMUNERACAO = "SOCIO";
                    widget.getField('IDREMUNERACAO').readOnly = true;
                break;
                default:
                    widget.getField('IDREMUNERACAO').readOnly = false;
            }
        }
    };
    
    // valida se houve mudança do tipo de vínculo para CLT na edição do vínculo para validar documentos
    this.onChangeTipoVinculoPessoa = function(args){
        var widget = ABUtilController.checkWidget(args);
        if(widget.backupRow.NRTIPOVINCULOM != 1 && widget.currentRow.NRTIPOVINCULOM == 1){
            AdmissaoController.onChangeTipoVinculo();  
        }
    };
    
    this.atualizaPeriodo = function(args) {
        var widget = ABUtilController.checkWidget(args);
        var dtadmissao = widget.getField('DTADMISSAOVINC').value();
        var nrdias = parseInt(widget.getField('NRDIASCONTRATOEXP').value());
        var nrdiasprorr = parseInt(widget.getField('NRDIASCONTRATOEXPPRO').value());
        var dtfimcontrato = widget.getField('DTFIMCONTRDETERMIN').value();
        if (!ABUtilController.validaDtIniMenorIgualDtFin(dtadmissao, dtfimcontrato)) {
            ScreenService.alertNotification(Messages.DTINI_POST_DTFIM_ERROR, 10000);
        } else {
            if(isNaN(nrdias) && isNaN(nrdiasprorr)){
                widget.getField('DTFIMCONTRDETERMIN').clearValue(widget.getField('DTFIMCONTRDETERMIN'));
            }
            if (!Util.isEmptyOrBlank(dtadmissao) && (!isNaN(nrdias) && nrdias > 0 || !isNaN(nrdiasprorr) && nrdiasprorr > 0)) {
                if(!nrdias){
                    nrdias = 0;
                }
                if(!nrdiasprorr){
                    nrdiasprorr = 0;
                }
                var somaDias = nrdias + nrdiasprorr - 1;
                dtfimcontrato = moment(dtadmissao, 'DD/MM/YYYY').add(somaDias, 'day').format('DD/MM/YYYY');
                widget.getField('DTFIMCONTRDETERMIN').setValue(dtfimcontrato);
                
            }
        }
    };
    
    this.alteraVencContratExperien = function(){
        var widget = templateManager.container.getActiveWidget();
        var data = null;
        if(!Util.isEmptyOrBlank(widget.currentRow.DTADMISSAOVINC) && !Util.isEmptyOrBlank(widget.currentRow.NRDIASCONTRATOEXP)){
            data = moment(widget.currentRow.DTADMISSAOVINC, 'DD/MM/YYYY').add((widget.currentRow.NRDIASCONTRATOEXP - 1), 'days').format('DD/MM/YYYY');
            widget.currentRow.DTVENCCONTREXPER = data;
        }else{
            widget.currentRow.DTVENCCONTREXPER = null;
            widget.currentRow.DTFIMCONTRDETERMIN = null;
            widget.getField('DTVENCCONTREXPER').clearValue(widget.getField('DTVENCCONTREXPER'));
        }
    };
    
    this.cancelaAdmissao = function(args) {
        ScreenService.confirmMessage('Deseja realmente cancelar essa(s) admissão(ões)?', 'CONFIRMATION', function(){    
            var widget = ABUtilController.checkWidget(args);
            restEngine.post('product#/cancelaAdmissao', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                then(function (data) {
                    ScreenService.closePopup();
                    if (data.messages) {
                        ScreenService.showMessage(data.messages[0].message, data.messages[0].type);
                    } else {
                        ScreenService.successNotification(Messages.HCM00000_GER_VINCULO_CANCELAADMISSAO_SUCESS, 10000);
                        ABUtilController.masterDetailVoltarList(widget);
                        widget.reload();
                    }
                }).
                catch(function(e) {
                    var error;
                    if(e.data.error === undefined){
                        error = e;
                    }    
                    else{
                        error = e.data.error;
                        ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    }    
                });
        }.bind(this));
    };
    
    this.verificaSituacao = function(situacao,args){
        if(situacao[0]){
            ScreenService.showCustomDialog('A condição física da pessoa do vínculo é '+situacao[0]+'. Deseja continuar?', 'CONFIRMATION', null, [
                {
                    label: ScreenService.i18n("Sim"),
                    code: function (e, deferred) {
                        self.verificaEstabilidade(situacao,args);
                        deferred.resolve(e);
                    }.bind(this)
                },
                {
                    label: ScreenService.i18n("Não"),
                    code: function (e, deferred) {
                        deferred.reject(e);
                    }
                }
            ]);
        }else{
            self.verificaEstabilidade(situacao,args);
        }
    };
    
    this.verificaEstabilidade = function(situacao,args){
        if(situacao[1]){
            ScreenService.showCustomDialog('Você está rescindindo um colaborador com uma situação de estabilidade. Deseja continuar?', 'CONFIRMATION', null, [
                {
                    label: ScreenService.i18n("Sim"),
                    code: function (e, deferred) {
                        self.verificaDissidio(situacao,args);
                        deferred.resolve(e);
                    }.bind(this)
                },
                {
                    label: ScreenService.i18n("Não"),
                    code: function (e, deferred) {
                        deferred.reject(e);
                    }
                }
            ]);
        }else{
            self.verificaDissidio(situacao,args);
        }
    };
    
    this.verificaDissidio = function(situacao,args){
        if(situacao[2]){
            ScreenService.showCustomDialog('Você está rescindindo um colaborador em uma data próxima ao seu dissídio. Deseja continuar?', 'CONFIRMATION', null, [
                {
                    label: ScreenService.i18n("Sim"),
                    code: function (e, deferred) {
                        self.setVinculo(args);
                        deferred.resolve(e);
                    }.bind(this)
                },
                {
                    label: ScreenService.i18n("Não"),
                    code: function (e, deferred) {
                        deferred.reject(e);
                    }
                }
            ]);
        }else{
            self.setVinculo(args);
        }
    };
    
    this.validaCancelamento = function(args){
        var widget = ABUtilController.checkWidget(args);
        if(widget.currentRow.NRMOTIVOCANCAP){
            widget.getField('DTCANCAVIPRE').validations = {"required": true};
        }else{
            widget.getField('DTCANCAVIPRE').validations = {};
        }
    };
    
    this.validaCancAviso = function(args, infoCampos){
        var widget = ABUtilController.checkWidget(args);
        if((widget.currentRow.NRMOTIVOCANCAP || widget.currentRow.DTCANCAVIPRE) && (widget.currentRow.NRTPAVIPRE || widget.currentRow.DTAVISOPREVIO)){
            if(infoCampos == 'AVISO'){
                widget.currentRow.DTAVISOPREVIO = '';
                widget.currentRow.DSTPAVIPRE = '';
                widget.currentRow.NRTPAVIPRE = '';
                widget.getField('DTAVISOPREVIO').validations = {};
                widget.getField('DSTPAVIPRE').validations = {};
            }
            if(infoCampos =='CANCELAMENTO'){
                widget.currentRow.NMMOTIVOCANCAP = '';
                widget.currentRow.NRMOTIVOCANCAP = '';
                widget.currentRow.DTCANCAVIPRE = '';
                widget.currentRow.DSOBSCANCAVIPRE = '';
                widget.getField('DTCANCAVIPRE').validations = {};
            }
        }
    };
    
    // Evitar chamar varias funções no campo
    this.validaDtAvisoPrevio = function(args){
        var widget = templateManager.container.getActiveWidget();
        
        // Inclusão de data de rescisão
        this.calculoDataRecisao();
        // Verifica as situações de obrigatoriedades dos campos de data de aviso prévio, tipo de aviso prévio, tipo de demissão e data de demissão
        this.validaTipoDemissaoAviso();
        // Verifica as situações de inserção da data de rescisão projetada
        this.validaReadOnlyDtRescisaoProjetada();
        // Verifica Cancelamento de aviso para o caso de preencher a parte de cancelamento
        this.validaCancAviso(args, 'CANCELAMENTO');
        
    };
    
    this.validaAvisoPrevio = function(){
        var widget = templateManager.container.getActiveWidget();
        if(widget.currentRow.NRTPAVIPRE && !widget.currentRow.DTAVISOPREVIO){
            widget.getField('DSTPAVIPRE').validations = {};
            widget.getField('DTAVISOPREVIO').validations = {'required': true};
            widget.getField('DTAVISOPREVIO').readOnly = false;
        }else if(!widget.currentRow.NRTPAVIPRE && widget.currentRow.DTAVISOPREVIO){
            widget.getField('DTAVISOPREVIO').validations = {};
            widget.getField('DTAVISOPREVIO').readOnly = false;
            if(widget.currentRow.DTAVISOPREVIO == widget.currentRow.DTRESCISAOVINC)
                widget.getField('DSTPAVIPRE').validations = {};
            else 
                widget.getField('DSTPAVIPRE').validations = {'required': true};
        }else if(!widget.currentRow.NRTPAVIPRE && !widget.currentRow.DTAVISOPREVIO){
            widget.getField('DTAVISOPREVIO').validations = {};
            widget.getField('DTAVISOPREVIO').readOnly = false;
            widget.getField('DSTPAVIPRE').validations = {};
        }
    };
    
    
    this.calculoDataRecisao = function(){
        var widget = templateManager.container.getActiveWidget();
        var dtavisoprevio = widget.currentRow.DTAVISOPREVIO;
        var tipoaviso = widget.currentRow.NRTPAVIPRE;
        var dtadmissao = widget.currentRow.DTADMISSAOVINC;
        var arrayAviso = [1, 2, 4];
        if(dtavisoprevio && arrayAviso.indexOf(tipoaviso) !== 0) {
            var nrqtdias = moment(dtavisoprevio, 'DD/MM/YYYY').diff(moment(dtadmissao, 'DD/MM/YYYY'), 'day');
            widget.currentRow.DTRESCISAOVINC = moment(dtavisoprevio, 'DD/MM/YYYY').add(30, 'day').format('DD/MM/YYYY');
            widget.getField('NMTPDEMISSAO').validations = {required: true};
        }
    };
    
    this.validaTipoDemissaoAviso = function(){
        var widget = templateManager.container.getActiveWidget();
        if((widget.currentRow.NRTPDEMISSAO && (widget.currentRow.NRTPDEMISSAO === 2 || widget.currentRow.NRTPDEMISSAO === 45)) &&
           (widget.currentRow.DTAVISOPREVIO && widget.currentRow.DTRESCISAOVINC && widget.currentRow.DTAVISOPREVIO.substr(0, 10) === widget.currentRow.DTRESCISAOVINC.substr(0, 10))){
            widget.getField('DSTPAVIPRE').validations = {};
            widget.getField('DTAVISOPREVIO').readOnly = false;
        }else if(widget.currentRow.NRTPDEMISSAO === 3){
            widget.getField('DSTPAVIPRE').validations = {};
            widget.getField('DTAVISOPREVIO').readOnly = true;
        }else{
            this.validaAvisoPrevio();
        }
    };
    
    this.validaMatriculaESocial = function(){
        var widget = templateManager.container.getWidget('vinculo');
        if(widget.currentRow.IDUTILIZAMATRIC == 'S' || !Util.isNull(widget.currentRow.CDMATRICULAESOCIAL)){
            widget.getField('CDMATRICULAESOCIAL').readOnly = false;
        }else{
            widget.getField('CDMATRICULAESOCIAL').readOnly = true;
        }
    };
    
    this.changedRescisao = function() {
        rescisaoAlterada = true;
    };
    
    this.validaRescisao = function(args, ESocialController, verificaEnvioEsocialDescentralizado = false) {
        var widget = templateManager.container.getWidget('vinculo');
        var mensagens = null;
        
        var rescisaoFunc = function(rota) {
            if (widget.currentRow.CDMATRICULAESOCIAL != widget.backupRow.CDMATRICULAESOCIAL) {
                widget.currentRow.CDMATRICULAESOCIALANTE = widget.backupRow.CDMATRICULAESOCIAL;
            }
            var preparedWidget = ABUtilController.prepareSaveMasterHistory(widget);
            restEngine.post(rota, {'requestType': 'DataSet', 'dataset': [preparedWidget.currentRow]})
                .then(function (data) {
                    if (data.dataset && data.dataset.retornoEsocial && !Util.isEmptyOrBlank(data.dataset.retornoEsocial)) {
                        /*var*/ mensagens = '';
                        // data.dataset.retornoEsocial.forEach(function(retorno, index){
                        //     mensagens += widget.currentRow.NMEVENTO[index] + ':<br>' +retorno.MSG + '<br>';
                        // });
                        if (data.dataset.retornoEsocial['S-2206']) {
                            mensagens += 'S-2206:<br>' + data.dataset.retornoEsocial['S-2206'].MSG + '<br>';
                        }
                        if (data.dataset.retornoEsocial['S-2306']) {
                            mensagens += 'S-2306:<br>' + data.dataset.retornoEsocial['S-2306'].MSG + '<br>';
                        }
                        if (data.dataset.retornoEsocial['S-2250']) {
                            mensagens += 'S-2250:<br>' + data.dataset.retornoEsocial['S-2250'].MSG + '<br>';
                        }
                        //ScreenService.showMessage(mensagens);
                    }
                    if (data.messages && data.messages[0].type == 'E') {
                        ScreenService.showMessage(data.messages[0].message, data.messages[0].type);
                        widget.currentRow.CDMATRICULAESOCIAL = widget.backupRow.CDMATRICULAESOCIAL;
                        return false;
                    }
                    if (data.dataset && data.dataset.validacoes) {
                        var mensagem = '';
                        if (data.dataset.validacoes[0] || data.dataset.validacoes[1] || data.dataset.validacoes[2]) {
                            mensagem = 'Você realizou a rescisão de um vínculo em período de estabilidade, perto da convenção coletiva ou portador de deficiência.';
                            ScreenService.showMessage(mensagem);
                        }
                    }
                    if (data.dataset.columnsToReturn) {
                        ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                        self.widgetsvisibletrue('vinculo');
                        if (preparedWidget.currentRow.__is_new) {
                            ABUtilController.masterDetailVoltarList(preparedWidget);
                            ABUtilController.mudarVisibilidadeWidgets(preparedWidget.widgets, true);
                            preparedWidget.reload();
                        } else {
                            ABUtilController.mudarVisibilidadeWidgets(preparedWidget.widgets, true);
                            var tableHistoryPk = preparedWidget.saveHistoryTable.__table_history_pk.toUpperCase();
                            if (preparedWidget.currentRow[tableHistoryPk]) {
                                for (var i=0; i < data.dataset.columnsToReturn.length; i++) {
                                    if (!Util.isUndefined(data.dataset.columnsToReturn[i][tableHistoryPk])) {
                                        preparedWidget.currentRow[tableHistoryPk] = data.dataset.columnsToReturn[i][tableHistoryPk];
                                    }
                                }
                            }
                            preparedWidget.backupRow = null;
                            preparedWidget.reload().then(function(){
                                preparedWidget.view();
                            });
                        }
                    } else {
                        ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                    }
                    self.verificaHistoricoPosterior(widget.currentRow.NRVINCULOM, getLocalVar('HCM_DTCOMPETENCIA_OPER'), mensagens);
                })
                .catch(function(e) {
                    var error;
                    if(e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;
                    
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    
                });
        };
        
        if ( widget.currentRow.DTRESCISAOVINC === '' ) {
            mensagem = 'Deseja remover a data de cancelamento dos benefícios relaciondados?';
        } else if ( widget.currentRow.DTRESCISAOVINC !== null && widget.currentRow.DTRESCISAOVINC !== undefined ) {
            mensagem = 'Deseja proceder com o preenchimento da data de cancelamento dos benefícios relaciondados?';
        }
        
        if (widget.isValid()) {
            if (verificaEnvioEsocialDescentralizado) {
                if (widget.currentRow.NRTIPOVINCULOM == 1) {
                    ESocialController.envioEsocialDescentralizado(widget.currentRow, 'S-2206', widget.currentRow.NRVINCULOM, widget.currentRow.NRVINCULOM, this.validaRescisao, args);
                } else {
                    ESocialController.envioEsocialDescentralizado(widget.currentRow, 'S-2306', widget.currentRow.NRVINCULOM, widget.currentRow.NRVINCULOM, this.validaRescisao, args);
                }
            } else {
                if (rescisaoAlterada === true) {
                    ScreenService.showCustomDialog(mensagem, 'CONFIRMATION', null, [
                        {
                            label: ScreenService.i18n("Não"),
                            code: function (e, deferred) {
                                rescisaoFunc('product#/validaRescisao');
                                deferred.reject(e);
                            }.bind(this)
                        },
                        {
                            label: ScreenService.i18n("Sim"),
                            code: function (e, deferred) {
                                rescisaoFunc('product#/validaRescisaoComBeneficio');
                                deferred.resolve(e);
                            }.bind(this)
                        }
                    ]);
                } else {
                    rescisaoFunc('product#/validaRescisao');
                }
                rescisaoAlterada = false;
            }
        }
    };
    
    this.setVinculo = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
                var preparedWidget = ABUtilController.prepareSaveMasterHistory(widget);
                preparedWidget.currentRow.NMVINCULOM = preparedWidget.currentRow.NMPESSOA;
                restEngine.post('product#/setVinculo', {'requestType': 'DataSet', 'dataset': [preparedWidget.currentRow]}).
                    then(function (data) {
                        if (data.messages) {
                            ScreenService.showMessage(data.messages[0].message, data.messages[0].type);
                        }
                        if (data.dataset.columnsToReturn) {
                            ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                            self.widgetsvisibletrue('vinculo');
                            if (preparedWidget.currentRow.__is_new) {
                                ABUtilController.masterDetailVoltarList(preparedWidget);
                                ABUtilController.mudarVisibilidadeWidgets(preparedWidget.widgets, true);
                                preparedWidget.reload();
                            } else {
                                ABUtilController.mudarVisibilidadeWidgets(preparedWidget.widgets, true);
                                var tableHistoryPk = preparedWidget.saveHistoryTable.__table_history_pk.toUpperCase();
                                if (preparedWidget.currentRow[tableHistoryPk]) {
                                    for (var i=0; i < data.dataset.columnsToReturn.length; i++) {
                                        if (!Util.isUndefined(data.dataset.columnsToReturn[i][tableHistoryPk])) {
                                            preparedWidget.currentRow[tableHistoryPk] = data.dataset.columnsToReturn[i][tableHistoryPk];
                                        }
                                    }
                                }
                                preparedWidget.backupRow = null;
                                preparedWidget.view();
                            }
                            
                        } else {
                            ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                        }
                    }).
                    catch(function(e) {
                        var error;
                        if(e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;
            
                        ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    });
        }
    };
    
    this.AdmissaoColetiva = function(action) {
        var widgetPopup = templateManager.container.getWidget('popupCadAuto');
        this.selectedAction = action.name;
        widgetPopup.label = this.objActions[action.name].label;
        ABUtilController.masterDetailOpenPopup(widgetPopup);
    };
    
    this.openPopupAssocSind= function(action){
        if(action.widget.getCheckedRows().length == 0) 
            ScreenService.showMessage(Messages.VINCULO_NAO_SELECIONADO);
        else{
            var widgetPopup = templateManager.container.getWidget('popupVinculaSindicato');
            this.selectedAction = action.name;
            widgetPopup.label = action.label;
            ABUtilController.masterDetailOpenPopup(widgetPopup);
        }    
    };
    
    this.confirmarAssociacaoSind = function(popup){
        ScreenService.showCustomDialog(Messages.EXECUTAR_OPERACAO, 'CONFIRMATION', null, [
            {
                label: ScreenService.i18n("Sim"),
                code: function (e, deferred) {
                    var widgetPrincipal = popup.getParent();
                    var idSind = popup.currentRow.IDASSOCSINDICATO;
                    associarSindicato(widgetPrincipal, popup, idSind); 
                    deferred.resolve(e);
                }.bind(this)
            },
            {
                label: ScreenService.i18n("Não"),
                code: function (e, deferred) {
                    deferred.reject(e);
                }
            }
        ]);
    };
    
    var associarSindicato = function(widget, popup, id){
        if(widget.getCheckedRows().length == 0) 
            ScreenService.showMessage(Messages.VINCULO_NAO_SELECIONADO);
        else{
            var dataSet = widget.getCheckedRows();
            dataSet.push({'associarSindicato': id});
            restEngine.post('product#/associarSindicato', {'requestType': 'DataSet', 'dataset': [dataSet]}).
                then(function (data) {
                    ScreenService.successNotification(Messages.OPERACAO_SUCESSO, 10000);
                    ABUtilController.masterDetailClosePopup(popup);
                    templateManager.container.getWidget('vinculo').activate();
                    templateManager.container.getWidget('vinculo').reload();
                }).
                catch(function(e) {
                    var error;
                    if(e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;
        
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
        }
    };

    this.confirmaCadAuto = function(widget) {
        if (widget.isValid() && widget.currentRow.DTRESCISAOVINC_INICIO && widget.currentRow.DTRESCISAOVINC_FIM) {
            if (ABUtilController.validaDtIniMenorIgualDtFin(widget.currentRow.DTRESCISAOVINC_INICIO,widget.currentRow.DTRESCISAOVINC_FIM)) {
                ScreenService.showCustomDialog(this.objActions[this.selectedAction].confirm, 'CONFIRMATION', null, [
                    {
                        label: ScreenService.i18n("Sim"),
                        code: function (e, deferred) {
                            this.executaCadAuto(widget);
                            deferred.resolve(e);
                        }.bind(this)
                    },
                    {
                        label: ScreenService.i18n("Não"),
                        code: function (e, deferred) {
                            deferred.reject(e);
                        }
                    }
                ]);
            } else {
                ScreenService.showMessage(Messages.DTINI_POST_DTFIM_ERROR, 'ERROR');
            }
        }
    };

    this.executaCadAuto = function(widget) {
        var action = this.selectedAction;
        restEngine.post(this.objActions[this.selectedAction].route, {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
            then(function (data) {
                if (data.messages) {
                    var textMessage = '';
                    data.messages.forEach(function(objMsg) {
                        textMessage += '-' + objMsg.message + '<br>';
                    });
                    ScreenService.showMessage(textMessage);
                }

                if (data.notifications[0].type === "error") {
                    ScreenService.alertNotification(Messages.CADASTRO_AUTOMATICO_ERRO, 10000);
                } else {
                    ScreenService.successNotification(Messages.CADASTRO_AUTOMATICO_SUCCESS, 10000);
                    ABUtilController.masterDetailClosePopup(widget);
                    templateManager.container.getWidget('vinculo').activate();
                    templateManager.container.getWidget('vinculo').reload();
                }
            }).
            catch(function (e) {
                var error;
                if (e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;

                ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
    };
    
    this.reloadEmVinculosQuandoEstrutLegalOnChange = function(args){
        var widget = ABUtilController.checkWidget(args);
        widget.getField('NRVINCULOM').reload();
    };
    
    this.validaTipoDemissao = function() {
        var widget = templateManager.container.getWidget('vinculo');
        if(widget.currentRow.DTRESCISAOVINC && !widget.currentRow.NMTPDEMISSAO){
            widget.getField('NMTPDEMISSAO').validations = {required: true};
            widget.getField('DTRESCISAOVINC').validations = {};
        }else if(!widget.currentRow.DTRESCISAOVINC && widget.currentRow.NMTPDEMISSAO){
            widget.getField('NMTPDEMISSAO').validations = {};
            widget.getField('DTRESCISAOVINC').validations = {required: true};
        }else if(!widget.currentRow.DTRESCISAOVINC && !widget.currentRow.NMTPDEMISSAO){
            widget.getField('NMTPDEMISSAO').validations = {};
            widget.getField('DTRESCISAOVINC').validations = {};
        } 
    };
    
    this.filterVinculoPai = function(nomeWidget){
        var widget = templateManager.container.getWidget(nomeWidget);
        var widgetPai = widget.parent.parent;
        var dataSource = widget.dataSource;
        widget.dataSourceFilter[0].value = widgetPai.currentRow.NRVINCULOM;
        if(nomeWidget == 'beneficioVinculo'){
            this.nmVinculoBeneficio = widgetPai.currentRow.NMVINCULOM;
            this.nrVinculoBeneficio = widgetPai.currentRow.NRVINCULOM;
            this.nrPessoaBeneficio = widgetPai.currentRow.NRPESSOA;
        }
    };
    
    this.validaTipoBeneficiario = function(){
        var widget = templateManager.container.getActiveWidget();
        
        if(Util.isEmptyOrBlank(widget.currentRow.NRPESSOA)){
            widget.currentRow.IDTPBENEFICIARIO = '';
        }else if(widget.currentRow.NRPESSOA == this.nrPessoaBeneficio){
            widget.currentRow.IDTPBENEFICIARIO = 'T';
        }else{
            widget.currentRow.IDTPBENEFICIARIO = 'D';
        }
    };
    
    this.filterVinculoPaiUmaVez = function(){
        var widgetPaiVinculo = templateManager.container.getWidget('vinculo');
        var widgets = widgetPaiVinculo.widgets;
        var filtro;
        widgets.forEach(function(widget){
            
            if(widget.name == 'fichaFinanceira'){	 
                filtro = widget.dataSourceFilter[ABUtilController.retornaFiltro(widget.dataSourceFilter, 'P_NRVINCULOM')];	 
            }else{	 
                filtro = widget.dataSourceFilter[ABUtilController.retornaFiltro(widget.dataSourceFilter, 'NRVINCULOM')];	 
            }
            
            if(filtro){
                filtro.value = widgetPaiVinculo.currentRow.NRVINCULOM;   
            }
        });
        this.NRVINCULOM = widgetPaiVinculo.currentRow.NRVINCULOM;
    };

    
    this.defaultVinculo = function(args){
        var widget = templateManager.container.getActiveWidget();
        var widgetPai = widget.parent ? widget.parent.parent : null;
        
        if(widgetPai){
            if(widgetPai.currentRow.NRVINCULOM && widgetPai.currentRow.NMVINCULOM){
                widget.currentRow.NRVINCULOM = widgetPai.currentRow.NRVINCULOM;
                widget.currentRow.NMVINCULOM = widgetPai.currentRow.NMVINCULOM;
                if(widget.name == "dependenteVinc")
                    widget.currentRow.NRPESSOAVINC = widgetPai.currentRow.NRPESSOA;
                if(widget.name == "eventovinculo"){
                    widget.currentRow.NRESTRUTLEGAL = widgetPai.currentRow.NRESTRUTLEGAL;
                    widget.currentRow.NMESTRUTLEGAL = widgetPai.currentRow.NMESTRUTLEGAL;
                    widget.currentRow.NRESTRUTGEREN = widgetPai.currentRow.NRESTRUTGEREN;
                    widget.currentRow.NMESTRUTGEREN = widgetPai.currentRow.NMESTRUTGEREN;
                    widget.currentRow.NRTIPOVINCULOM = widgetPai.currentRow.NRTIPOVINCULOM;
                }
                if(widget.name == "folha"){
                    widget.currentRow.NRTIPOVINCULOM = widgetPai.currentRow.NRTIPOVINCULOM;
                }
            }
        }else if(this.adicionarDefaultVinculo) {
            widget.currentRow.NRVINCULOM = this.NRVINCULOM;
            widget.currentRow.NMVINCULOM = this.NMVINCULOM;
            if(widget.name == "dependenteVinc")
                widget.currentRow.NRPESSOAVINC = this.NRPESSOA;
        }
    };
    
    this.atualizaFimContratExp = function(args){
        var widget = ABUtilController.checkWidget(args);
        var dt = widget.currentRow.DTADMISSAOVINC;
        if(widget.currentRow.NRDIASCONTRATOEXP){
            dt  = moment(dt, 'DD/MM/YYYY').add(widget.currentRow.NRDIASCONTRATOEXP - 1, 'day').format('DD/MM/YYYY');
            widget.currentRow.DTFIMCONTREXP = dt; 
        }else{
            widget.currentRow.DTVENCCONTREXPER = null;
            widget.currentRow.DTFIMCONTRDETERMIN = null;
        }
    };
    
    this.validaReadOnlyDtRescisaoProjetada = function(args){
        var widgetVinculo = args != undefined ? args.owner.field.widget : templateManager.container.getActiveWidget();
        var dtRescisaoProjetada = "";
        
        if( widgetVinculo.currentRow.DTRESCISAOVINC && widgetVinculo.currentRow.DTRESCISAOVINC != "" && 
            widgetVinculo.currentRow.DTAVISOPREVIO && widgetVinculo.currentRow.DTAVISOPREVIO != "" 
          ){
            var dtAdmissao = widgetVinculo.currentRow.DTADMISSAOVINC;
            var dtRescisao = widgetVinculo.currentRow.DTRESCISAOVINC;
            var dtAviso = widgetVinculo.currentRow.DTAVISOPREVIO;
            
            var diasAviso = moment(dtRescisao, 'DD/MM/YYYY').diff(moment(dtAviso, 'DD/MM/YYYY'), 'day');
            var diasTrabalhados = moment(dtRescisao, 'DD/MM/YYYY').diff(moment(dtAdmissao, 'DD/MM/YYYY'), 'day');         
            var diasAdicionais = ( Math.floor(diasTrabalhados/365) * 3 ); // 3 dias para cada ano trabalhado
            if( diasAdicionais > 60){
                diasAdicionais = diasAdicionais - (diasAdicionais - 60);
            }
            
            if(widgetVinculo.currentRow.NRTPDEMISSAO == 2){
                
                if(diasAviso == 0){ // data de aviso igual à data de rescisão
                    if( 30 + diasAdicionais <= 90 )
                        dtRescisaoProjetada = moment(dtRescisao, 'DD/MM/YYYY').add(30 + diasAdicionais, 'day').format('DD/MM/YYYY');
                    else
                        dtRescisaoProjetada = moment(dtRescisao, 'DD/MM/YYYY').add(90, 'day').format('DD/MM/YYYY');
                }
                else if(diasAviso > 0){ // data de aviso menor que data de rescisão
                    if( diasAdicionais <= 90 )
                        dtRescisaoProjetada = moment(dtRescisao, 'DD/MM/YYYY').add(diasAdicionais, 'day').format('DD/MM/YYYY');
                    else
                        dtRescisaoProjetada = moment(dtRescisao, 'DD/MM/YYYY').add(90, 'day').format('DD/MM/YYYY');
                }
            }
        }

        widgetVinculo.currentRow.DTRESCISAOPROJETADA = dtRescisaoProjetada;

    };
    
    this.setFiltroDependente = function(args,fieldPessoa) {
        var widget = templateManager.container.getActiveWidget();
        var widgetPai = widget.parent.parent;
        if(widget.name == "popupCadAutoDepend")
            widgetPai = widgetPai.parent.parent;
        if(!!widgetPai){
            widget.getField(fieldPessoa).dataSourceFilter[0].value = widgetPai.currentRow.NRPESSOA;
        }
        widget.getField(fieldPessoa).reload();
    };
    
    this.defaultVinculoCadAuto = function(args){
        var widget = templateManager.container.getActiveWidget();
        var widgetPai =  widget.parent.parent.parent.parent;
        
        if(widgetPai != undefined && widgetPai != null){
            if(widgetPai.currentRow.NRVINCULOM && widgetPai.currentRow.NMVINCULOM){
                widget.currentRow.NRVINCULOM = widgetPai.currentRow.NRVINCULOM;
                widget.currentRow.NMVINCULOM = widgetPai.currentRow.NMVINCULOM;
                widget.currentRow.NRPESSOAVINC = widgetPai.currentRow.NRPESSOA;
            }
        }
    };
    
    this.saveSeguroVinculo = function(args){
        var widget = args.owner.widget;
        
        if (widget.isValid()) {
                restEngine.post('product#/setSeguroVinculo', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                    then(function (data) {
                        if (data.notifications[0].type === "success") {
                            ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                            ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                            widget.backupRow = null;
                            widget.view();
                        } else {
                            ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                        }
                    }).
                    catch(function(e) {
                        var error;
                        if(e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;
            
                        ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    });
        }
    };
    
    this.openWidgetFilha = function(args){
        var widget = ABUtilController.checkWidget(args);
        ScreenService.confirmMessage("Deseja ser redirecionado para tela de Ocupação?", null, function () {
            var url = new URL(window.location.href.split('hcm00052_gpe_vinculo')[0] + 'hcm00042_gpe_ocupacao');
            url.searchParams.set('value', widget.currentRow.NROCUPACAOM);
            window.open(url, '_blank');
        }, null);
    };
    
    this.validacaoRecisaoESocial = function(args, campoRecisaoNome){
        var widget = ABUtilController.checkWidget(args);
        var mensagem = '';
        
        // var dataAvisoPrevioField = widget.currentRow.DTAVISOPREVIO;
        var campoRecisao = widget.getField(campoRecisaoNome).value();
        
        if(!ABUtilController.validaDataIgualPosteriorDtAtual(campoRecisao) && campoRecisaoNome == 'DTAVISOPREVIO'){
            mensagem += 'Mensagens Geradas <br>  - Data de aviso prévio retroativa <br>';
        }
        
        
        if(campoRecisao){
            var dataAvisoPrevio = ABUtilController.retornaObjetoDateComString(campoRecisao);
            
            var dataAtual = new Date();
            ABUtilController.truncateObjetoDate(dataAtual);
            
            var dataLimiteAviso = self.retornaDataLimiteDataAvisoPrevioESocial(dataAtual);
            
            if(dataAvisoPrevio.getTime() <= dataLimiteAviso.getTime()){
                if(campoRecisaoNome == 'DTAVISOPREVIO'){
                    // mensagem = Messages.AVISO_ESO_PENSALIDADE_DATA_RETROATIVA_PRAZO_10_DIAS;
                } else if(campoRecisaoNome == 'DTRESCISAOVINC'){
                    mensagem += ' - ' + Messages.AVISO_ESO_PENSALIDADE_RECISAO_DATA_RETROATIVA;
                }
            } 
        }
        
        if(!Util.isEmptyOrBlank(mensagem)){
            ScreenService.showMessage(mensagem);
        }
    };
    
    this.retornaDataLimiteDataAvisoPrevioESocial = function(dataAtual){
        try {
            var dataLimite = new Date();
            ABUtilController.truncateObjetoDate(dataLimite);
            dataLimite.setDate(dataAtual.getDate() - 10);
            return dataLimite;
        } catch(e){
            return false;  
        }
    };
    
    // this.validaDataReintegracaoESocial = function(args){
    //     var widget = ABUtilController.checkWidget(args);
        
    //     var dataReintegracao = widget.currentRow.DTRETORNO;
        
    //     if(dataReintegracao){
    //         dataReintegracao = ABUtilController.retornaObjetoDateComString(dataReintegracao);
            
    //         if(ABUtilController.dataEhAnteriorACompetenciaAtual(dataReintegracao)){
    //             ScreenService.showMessage(Messages.AVISO_ESO_PENSALIDADE_REINTEGRACAO_DATA_RETROATIVA);
    //         }
            
    //     }
        
    // };
    
    this.onChangeReintegracao = function(){
        var widgetVinculo = templateManager.container.getWidget("vinculo");
        
        if (!Util.isEmptyOrBlank(widgetVinculo.currentRow.IDTPREINTEGRACAO) || !Util.isEmptyOrBlank(widgetVinculo.currentRow.DTRETORNO) || !Util.isEmptyOrBlank(widgetVinculo.currentRow.DTEFEITOFINANCEIRO)) {
            widgetVinculo.getField('IDTPREINTEGRACAO').validations = {"required": true};
            widgetVinculo.getField('DTRETORNO').validations = {"required": true};
            widgetVinculo.getField('DTEFEITOFINANCEIRO').validations = {"required": true};
        } else {
            widgetVinculo.getField('IDTPREINTEGRACAO').validations = {};
            widgetVinculo.getField('DTRETORNO').validations = {};
            widgetVinculo.getField('DTEFEITOFINANCEIRO').validations = {};
        }
    };
    
    this.habilitaIdpagpropfer13 = function(){
        var widget = templateManager.container.getActiveWidget();
        if(widget.currentRow.NRVINCULOEMPREG == 107 || widget.currentRow.NRVINCULOEMPREG == 108){
            validaContratoVerdeAmarelo = true;
            widget.getField('IDPAGPROPFER13').readOnly = false;
        }else{
            validaContratoVerdeAmarelo = false;
            widget.getField('IDPAGPROPFER13').readOnly = true;
            widget.currentRow.IDPAGPROPFER13 = '';
        }
    };
    
    this.verificaContratoVerdeAmarelo = function(){
        var widgetVinculo = templateManager.container.getWidget('vinculo');
        var widgetSalario = templateManager.container.getWidget('alteSalario');
        var indice = ABUtilController.retornaFiltro(widgetSalario.dataSourceFilter, 'NRVINCULOM');
        var dados = [];
        
        if(!Util.isEmptyOrBlank(indice)){
            widgetSalario.dataSourceFilter[indice].value = widgetVinculo.currentRow.NRVINCULOM;
        }
        
        if(widgetVinculo.currentRow.NRVINCULOEMPREG && (widgetVinculo.currentRow.NRVINCULOEMPREG == 107 || widgetVinculo.currentRow.NRVINCULOEMPREG == 108)){
            validaContratoVerdeAmarelo = true;
            widgetVinculo.getField('IDPAGPROPFER13').readOnly = false;
            widgetSalario.reload().then(function(){
                dados.DTNASCPESSOA = !Util.isEmptyOrBlank(widgetVinculo.currentRow.DTNASCPESSOA) ? widgetVinculo.currentRow.DTNASCPESSOA : null;
                dados.NRTPADMISSAO = !Util.isEmptyOrBlank(widgetVinculo.currentRow.NRTPADMISSAO) ? widgetVinculo.currentRow.NRTPADMISSAO : null;
                dados.DTFIMCONTRDETERMIN = !Util.isEmptyOrBlank(widgetVinculo.currentRow.DTFIMCONTRDETERMIN) ? widgetVinculo.currentRow.DTFIMCONTRDETERMIN : null;
                dados.DTADMISSAOVINC = !Util.isEmptyOrBlank(widgetVinculo.currentRow.DTADMISSAOVINC) ? widgetVinculo.currentRow.DTADMISSAOVINC : null;
                dados.VRSALARIO = !Util.isEmptyOrBlank(widgetSalario.dataSource.data) ? widgetSalario.dataSource.data[0].VRSALARIO : null;
                this.realizaValidacoesContratoVerdeAmarelo(dados);
            }.bind(this));
        }else{
            validaContratoVerdeAmarelo = false;
            widgetVinculo.getField('IDPAGPROPFER13').readOnly = true;
            widgetVinculo.currentRow.IDPAGPROPFER13 = '';
        }
        
        
    };
    
    this.verificaContratoVerdeAmareloCampos = function(campos, nomeWidget){
        if(validaContratoVerdeAmarelo){                    
            var currentRow = templateManager.container.getWidget(nomeWidget) ? templateManager.container.getWidget(nomeWidget).currentRow : null;
            var dados = [];
            dados.DTNASCPESSOA = null;
            dados.NRTPADMISSAO = null;
            dados.DTFIMCONTRDETERMIN = null;
            dados.DTADMISSAOVINC = null;
            dados.VRSALARIO = null;
            
            if(!Util.isEmptyOrBlank(currentRow) ){
                campos.forEach(function(campo){
                    dados[campo] = !Util.isEmptyOrBlank(currentRow[campo]) ? currentRow[campo] : null;
                });
            }
            
            this.realizaValidacoesContratoVerdeAmarelo(dados);
        }
    };
    
    this.realizaValidacoesContratoVerdeAmarelo = function(currentRow){
        var mensagem = '';
        if(!Util.isEmptyOrBlank(currentRow.DTNASCPESSOA)){
            var idade = ABUtilController.retornaIdade(currentRow.DTNASCPESSOA);
            if(idade > 29 || idade < 18){
                mensagem += Messages.HCMOOOOO_GER_ADMISSAO_CONTRATOVERAMAR_DATANASC + '<br>';
            }
        }
        if(!Util.isEmptyOrBlank(currentRow.NRTPADMISSAO) && currentRow.NRTPADMISSAO != 1){
            mensagem += Messages.HCMOOOOO_GER_ADMISSAO_CONTRATOVERAMAR_TPADMISSAO + '<br>';
        }
        if(!Util.isEmptyOrBlank(currentRow.DTFIMCONTRDETERMIN) && !Util.isEmptyOrBlank(currentRow.DTADMISSAOVINC)){
           var periodo = ABUtilController.retornaPeriodo(currentRow.DTADMISSAOVINC.substr(0,10)+' 00:00:00', currentRow.DTFIMCONTRDETERMIN.substr(0,10)+' 00:00:00');
           if(periodo > 24){
               mensagem += Messages.HCMOOOOO_GER_ADMISSAO_CONTRATOVERAMAR_PRAZO + '<br>';
           }
        }
        if(!Util.isEmptyOrBlank(currentRow.VRSALARIO)){
            var salariominimo = getLocalVar('HCM_SALARIO_MINIMO');
            var salario = currentRow.VRSALARIO.replace('.','').replace(',', '.');
            if(parseFloat(salario) > parseFloat(1.5*salariominimo)){
                mensagem += Messages.HCMOOOOO_GER_ADMISSAO_CONTRATOVERAMAR_SALARIO;
            }
        }
        
        if(!Util.isEmptyOrBlank(mensagem)){
            ScreenService.showMessage('Contrato Verde e Amarelo:<br>' + mensagem);
        }
    };
    
    this.confirmarEnvioEsocialDescentra = function(args, ESocialController){
        var widgetVinculo = templateManager.container.getWidget('vinculo');
        var widgetPopup = templateManager.container.getWidget('popupEnvioESocialDescentra');
        var eventos = [];
        
        if(widgetPopup.currentRow.EVENTO2206 == "S"){
            eventos.push('S-2206');
        }
        if(widgetPopup.currentRow.EVENTO2306 == "S"){
            eventos.push('S-2306');
        }
        if(widgetPopup.currentRow.EVENTO2250 == "S"){
            eventos.push('S-2250');
        }
        if(widgetPopup.currentRow.EVENTO2298 == "S"){
            eventos.push('S-2298');
        }
        
        if(!Util.isEmptyOrBlank(eventos)){
            widgetVinculo.currentRow.NMEVENTO = eventos;
            self.validaRescisao(args, ESocialController, false);
            ScreenService.closePopup();
            widgetVinculo.activate();
        }else{
            ScreenService.showMessage('Favor selecionar pelo menos um evento para enviar ao ESocial!');
        }
        
    };
    
    this.closePopupEsocial = function(args,EsocialController){
        var widgetVinculo = templateManager.container.getWidget('vinculo');
        
        ScreenService.closePopup();
        widgetVinculo.currentRow.IDENVIAESOCIAL = 'N';
        this.validaRescisao(args, ESocialController, false);
        
    };
    
    /**
     * Verifica se há históricos posteriores ao vínculo editado, se houver este indaga ao operador se quer atualiza-los também
     */
    this.verificaHistoricoPosterior = function($nrvinculom, $dtmescompetenc, eSocialMessage) {
        var info = [$nrvinculom, $dtmescompetenc];
        var msg;
        
        /*Função: Atualiza os históricos posteriores do vínculo*/
        var atualizaHistoricos = function(historicos, dados) {
            var infos = [historicos, dados];
            restEngine.post('product#/setVinculoHistoricoPosterior', {'requestType': 'DataSet', 'dataset': [infos]})
                .then(function(response) {
                    if(response.messages) {
                        if(response.messages[0].message.length > 0) {
                            msg = 'Competência(s) alteradas:<br>' + response.messages[0].message.join(",<br>");
                            ScreenService.showMessage(msg, response.messages[0].type);
                        } else {
                            ScreenService.showMessage("Nenhuma competência foi alterada.");
                        }
                    }
                }).catch(function(e) {
                    var error;
                    if(e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
        };
        
        /*Função: Verifica se há históricos para atualizar e lança mensagem na tela*/
        var verificaHistoricos = function(response) {
            if(response.dataset.historicos.length > 0) {
                ScreenService.showCustomDialog(
                    'Vínculo possui históricos posteriores à esta competência. Deseja atualizar esses históricos?',
                    'CONFIRMATION',
                    null,
                    [
                        {
                            label: ScreenService.i18n("Sim"),
                            code: function (e, deferred) {
                                atualizaHistoricos(response.dataset.historicos, info);
                                deferred.reject(e);
                            }.bind(this)
                        },
                        {
                            label: ScreenService.i18n("Não"),
                            code: function (e, deferred) {
                                deferred.resolve(e);
                            }.bind(this)
                        }
                    ]);
            }
        };
        
        /*Requisição ao backend para consultar possíveis históricos*/
        var consultaHistoricos = function() {
            restEngine.post('product#/getVinculoHistoricoPosterior', {'requestType': 'DataSet', 'dataset': [info]})
                    .then(verificaHistoricos);
        };
        
        /*Exibe as mensagens do eSocial (se houver) e aciona a rotina de verificação de existência de históricos posteriores*/
        if(eSocialMessage != null)
            ScreenService.showMessage(eSocialMessage).then(consultaHistoricos);
        else
            consultaHistoricos();
            
    };
    
    this.convocacaoTrabalhoIntermitente = function() {
        var popup = templateManager.container.getWidget('convocacaoTrabalhoIntermitente');
        ABUtilController.masterDetailOpenPopup(popup);
    };
    
    this.adicionarConvocacaoTrabalhoIntermitente = function() {
        var popupConvocacao = templateManager.container.getWidget('convocacaoTrabalhoIntermitente');
        var popupAdicionar = templateManager.container.getWidget('adicionarConvocacaoTrabalhoIntermitente');
        var nrorg = getLocalVar('HCM_NRORG_TRAB');
        var nrvinculom = popupConvocacao.dataSourceFilter[1].value.replace(/%/g, "");
        ABUtilController.masterDetailOpenPopup(popupAdicionar);
        popupAdicionar.currentRow.NRVINCULOM = nrvinculom;
        popupAdicionar.currentRow.NRORG = nrorg;
        popupAdicionar.currentRow.PERIODOANTIGO = 0;
    };
    
    this.editConvocacaoTrabalhoIntermitente = function(flag) {
        var widget = templateManager.container.getWidget('viewConvocacaoTrabalhoIntermitente');
        if( flag === "edit" ){
            widget.template = "widget/form-view-edit.html";
            widget.actions[0].isVisible = widget.actions[1].isVisible = widget.actions[4].isVisible = false;
            widget.actions[2].isVisible = widget.actions[3].isVisible = true;
        } else if( flag === "view" ){
            widget.template = "widget/form-view.html";
            widget.actions[0].isVisible = widget.actions[1].isVisible = widget.actions[4].isVisible = true;
            widget.actions[2].isVisible = widget.actions[3].isVisible = false;
        }
    };
    
    this.salvarEditConvocacaoTrabalhoIntermitente = function(args) {
        var widget = args.owner.widget;
        if( widget.isValid() ){
            if( this.setConvocacaoTrabalhoIntermitente(args) !== -1 ){
                this.editConvocacaoTrabalhoIntermitente('view');
            }
        }
    };
    
    this.viewConvocacaoTrabalhoIntermitente = function() {
        var vinculo = templateManager.container.getWidget('vinculo').currentRow;
        var convocacao = templateManager.container.getWidget('convocacaoTrabalhoIntermitente').currentRow;
        var view = templateManager.container.getWidget('viewConvocacaoTrabalhoIntermitente');
        view.currentRow.NRORG = convocacao.NRORG;
        view.currentRow.DSCONVOCACAO = convocacao.DSCONVOCACAO;
        view.currentRow.NRCONVOCACAO = convocacao.NRCONVOCACAO;
        view.currentRow.NRVINCULOM = convocacao.NRVINCULOM;
        view.currentRow.NMVINCULOM = vinculo.NMVINCULOM;
        view.currentRow.DTINICONVOCACAO = convocacao.DTINICONVOCACAO;
        view.currentRow.DTFIMCONVOCACAO = convocacao.DTFIMCONVOCACAO;
        view.currentRow.PERIODOANTIGO = view.currentRow.DTFIMCONVOCACAO.substring(0,10).split('/').reverse().join('') - view.currentRow.DTINICONVOCACAO.substring(0,10).split('/').reverse().join('');
        view.currentRow.DTINCLUSAO = convocacao.DTINCLUSAO;
        view.currentRow.DTULTATU = convocacao.DTULTATU;
        view.currentRow.NRORGINCLUSAO = convocacao.NRORGINCLUSAO;
        view.currentRow.CDOPERINCLUSAO = convocacao.CDOPERINCLUSAO;
        view.currentRow.NRORGULTATU = convocacao.NRORGULTATU;
        view.currentRow.CDOPERULTATU = convocacao.CDOPERULTATU;
        ABUtilController.masterDetailOpenPopup(view);
    };
    
    this.isPeriodoConvocacaoValid = function(args) {
        var widget = args.owner.widget;
        var dataInicio = widget.currentRow.DTINICONVOCACAO;
        var dataFim = widget.currentRow.DTFIMCONVOCACAO;
        if( dataFim.substring(0,10).split('/').reverse().join('') < dataInicio.substring(0,10).split('/').reverse().join('') ){
            ScreenService.showMessage('A data fim não pode ser menor que a data início');
            return false;
        }
        if( (dataInicio.split('/')[1] !== dataFim.split('/')[1]) || (dataInicio.split('/')[2].substring(0,4) !== dataFim.split('/')[2].substring(0,4)) ){
            ScreenService.showMessage('Período com meses diferentes!');
            return false;
        }
    };
    
    this.setConvocacaoTrabalhoIntermitente = function(args) {
        var widget = args.owner.widget;
        if( widget.isValid() ){
            if( this.isPeriodoConvocacaoValid(args) === false ){
                return -1;
            }
            if( !widget.backupRow ){
                widget.currentRow.__is_new = true;
            } else {
                widget.currentRow.__is_new = false;
            }
            restEngine.post('product#/setConvocacaoTrabalhoIntermitente', {'requestType': 'DataSet', 'dataset': [widget.currentRow]})
            .then(function (data){
                if( data.notifications[0].type === "success" ){
                    ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                    ScreenService.closePopup();
                    templateManager.container.getWidget('convocacaoTrabalhoIntermitente').activate();
                } else if( data.notifications[0].type === "error" ){
                    ScreenService.showMessage(data.notifications[0].message, 'ERROR');
                } else {
                    ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                }
            })
            .catch(function(e) {
                var error;
                if( e.data.error === undefined ){
                    error = e;
                } else {
                    error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                }
            });
        }
    };
    
    this.deleteConvocacaoTrabalhoIntermitente = function(args) {
        ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
            var widget = args.owner.widget;
            widget.currentRow.__is_new = false;
            restEngine.post('product#/deleteConvocacaoTrabalhoIntermitente', {'requestType':'DataSet','dataset':[widget.currentRow]})
            .then(function(data){
                if( data.notifications[0].type === "success" ){
                    ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                    ScreenService.closePopup();
                    templateManager.container.getWidget('convocacaoTrabalhoIntermitente').activate();
                } else {
                    ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                }
            })
            .catch(function(e) {
                var error;
                if( e.data.error === undefined ){
                    error = e;
                } else {
                    error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                }
            });
        }, null);
    };
    
    this.cadastroAutomaticoConvocacaoTrabalhoIntermitente = function() {
        var popup = templateManager.container.getWidget('cadastroAutomaticoConvocacaoTrabalhoIntermitente');
        ABUtilController.masterDetailOpenPopup(popup);
    };
    
    this.setCadastroAutomaticoConvocacaoTrabalhoIntermitente = function(args) {
        var widget = args.owner.widget;
        if( widget.isValid() ){
            if( this.isPeriodoConvocacaoValid(args) === false ){
                return -1;
            }
            if( !widget.backupRow ){
                widget.currentRow.__is_new = true;
            } else {
                widget.currentRow.__is_new = false;
            }
            widget.currentRow.NRORG = getLocalVar('HCM_NRORG_TRAB');
            restEngine.post('product#/setCadastroAutomaticoConvocacaoTrabalhoIntermitente', {'requestType': 'DataSet', 'dataset': [widget.currentRow]})
            .then(function (data){
                if( data.notifications[0].type === "success" ){
                    ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                    ScreenService.closePopup();
                    templateManager.container.getWidget('vinculo').activate();
                    templateManager.container.getWidget('vinculo').reload();
                } else if( data.notifications[0].type === "alert" ){
                    ScreenService.closePopup();
                    templateManager.container.getWidget('vinculo').activate();
                    templateManager.container.getWidget('vinculo').reload();
                    var alertas = templateManager.container.getWidget("alertas");
                    alertas.dataSource.data = data.dataset.alertasCadastroAutomatico;
                    ScreenService.openPopup(alertas);
                } else {
                    ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                }
            })
            .catch(function(e) {
                var error;
                if( e.data.error === undefined ){
                    error = e;
                } else {
                    error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                }
            });
        }
    };
}
 
Configuration(function(ContextRegister) {
    ContextRegister.register('VinculoController', VinculoController);
});

// FILE: assets/js/controllers/VinculoEmpregaticioController.js
function VinculoEmpregaticioController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, General,Messages) {

    this.adicionarRow = function(args) {
        var widget = args.owner.widget;
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
    };

	this.setVinculoEmpregaticio = function(args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
                if (!widget.backupRow) {
                    widget.currentRow.__is_new = true;
                } else {
                    widget.currentRow.__is_new = false;
                }
                restEngine.post('product#/setVinculoEmpregaticio', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                    then(function (data) {
                        if (data.notifications[0].type === "success") {
                            ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                            if (widget.currentRow.__is_new) {
                                ABUtilController.masterDetailVoltarList(widget);
                                widget.reload();
                            } else {
                                ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                                widget.backupRow = null;
                                widget.view();
                            }
                        } else {
                            ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                        }
                    }).
                    catch(function(e) {
                        var error;
                        if(e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;
                            ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    });
            }
    };
    
    this.deleteVinculoEmpregaticio = function(args) {
        var widget = args.owner.widget;
        widget.currentRow.__is_new = false;
        restEngine.post('product#/deleteVinculoEmpregaticio', {'requestType':'DataSet','dataset':[widget.currentRow]}).
            then(function(data){
                if(data.notifications[0].type === "success"){
                    ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                    ABUtilController.masterDetailVoltarList(widget);
                    widget.reload();
                } else {
                    ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                }
            }).
            catch(function(e) {
                var error;
                if(e.data.error === undefined)
                    error = e;
                else
                    error = e.data.error;
                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('VinculoEmpregaticioController', VinculoEmpregaticioController);
});

// FILE: assets/js/controllers/VinculoEventoController.js
function VinculoEventoController(ScreenService, templateManager, restEngine, ABUtilController, Messages, General) {

    this.camposData_vinculo = ['DTINIVIGENCIA', 'DTFIMVIGENCIA'];

    this.validaFiltro = function(args){
        var widget = args.owner;
        if(args.e.preference.FILTER_ROW.IDTIPOMOVIMENTO === 0){
            widget.dataSourceFilter.push(
                {
                    "name": "IDTIPOMOVIMENTO",
                    "operator": "=",
                    "value":"0"
                }    
            );
        }else{
            widget.dataSourceFilter.forEach(function(filtro, index){
                if(filtro.name === 'IDTIPOMOVIMENTO' && filtro.value === '0'){
                    widget.dataSourceFilter.splice(index, 1);
                }
            });
        }
    };

    this.salvar = function(args) {
        var widget = templateManager.container.getActiveWidget();
        if (widget.isValid()) {
            if (ABUtilController.validaDtIniMenorIgualDtFin(widget.currentRow.DTINIVIGENCIA, widget.currentRow.DTFIMVIGENCIA)) {
                
                if (!widget.backupRow) {
                    widget.currentRow.__is_new = true;
                } else {
                    widget.currentRow.__is_new = false;
                }
                widget.currentRow.VRPISOEVENTO = General.valueToFloat(widget.currentRow.VRPISOEVENTO);
                widget.currentRow.VRTETOEVENTO = General.valueToFloat(widget.currentRow.VRTETOEVENTO);
                widget.currentRow.VRPERCENT = General.valueToFloat(widget.currentRow.VRPERCENT);
                widget.currentRow.VRMULTIPLIC = General.valueToFloat(widget.currentRow.VRMULTIPLIC);
                widget.currentRow.VRDIVIDE = General.valueToFloat(widget.currentRow.VRDIVIDE);
                widget.currentRow.VREVENTOFIXO = General.valueToFloat(widget.currentRow.VREVENTOFIXO);
                widget.currentRow.VRREFFIXO = General.valueToFloat(widget.currentRow.VRREFFIXO);
                restEngine.post('product#/setVincEvento', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                    then(function (data) {
                        if (data.dataset && data.dataset.msg) {
                            widget.reload();
                            openPopupMensagens(data.dataset.msg);
                        } else if (data.messages) {
                            ScreenService.showMessage(data.messages[0].message, data.messages[0].type);
                        } else if (data.notifications[0].type === "success") {
                            ScreenService.successNotification(Messages.SAVE_ROW_SUCCESS, 10000);
                            if (widget.currentRow.__is_new) {
                                ABUtilController.masterDetailVoltarList(widget);
                                widget.reload();
                            } else {
                                ABUtilController.mudarVisibilidadeWidgets(widget.widgets, true);
                                widget.backupRow = null;
                                widget.view();
                            }
                        } else {
                            ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                        }
                    }).
                    catch(function(e) {
                        var error;
                        if(e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;
    
                        ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    });
            }   else {
                ScreenService.showMessage(Messages.DTINI_POST_DTFIM_ERROR);
                return false;
            }
        }
    };

    this.remover = function(widget) {
        ScreenService.confirmMessage(Messages.DELETE_ROW, null, function () {
            if (widget.isValid()) {
                widget.currentRow.__is_new = false;
                restEngine.post('product#/deleteVincEvento', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                    then(function (data) {
                        if (data.notifications[0].type === "success") {
                            ScreenService.successNotification(Messages.REMOVE_ROW_SUCCESS, 10000);
                            ABUtilController.masterDetailVoltarList(widget);
                            widget.reload();
                        } else if (undefined(data.notifications) && data.notifications[0].type === 'error') {
                            ScreenService.errorNotification(data.notifications[0].message, 10000);
                        } else if (undefined(data.messages)) {
                            ScreenService.showMessage(data.messages[0].message, 10000);
                        } else {
                            ScreenService.showMessage(Messages.REMOVE_ROW_ERROR);
                        }
                    }).
                    catch(function (e) {
                        var error;
                        if (e.data.error === undefined)
                            error = e;
                        else
                            error = e.data.error;

                        ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                    });
            }
        }, null);
    };

    this.openPopupCadAutomatico = function(args) {
        var widgetFilter = templateManager.container.getWidget('cadastroAutomatico');
        widgetFilter.applyDefaultValue();
        ScreenService.openPopup(widgetFilter);
    };

    this.cadastroAutomatico = function(widget) {
        if (widget.isValid()) {
            widget.currentRow.VRPISOEVENTO = General.valueToFloat(widget.currentRow.VRPISOEVENTO);
            widget.currentRow.VRTETOEVENTO = General.valueToFloat(widget.currentRow.VRTETOEVENTO);
            widget.currentRow.VRPERCENT = General.valueToFloat(widget.currentRow.VRPERCENT);
            widget.currentRow.VRMULTIPLIC = General.valueToFloat(widget.currentRow.VRMULTIPLIC);
            widget.currentRow.VRDIVIDE = General.valueToFloat(widget.currentRow.VRDIVIDE);
            widget.currentRow.VREVENTOFIXO = General.valueToFloat(widget.currentRow.VREVENTOFIXO);
            widget.currentRow.VRREFFIXO = General.valueToFloat(widget.currentRow.VRREFFIXO);
            if (widget.currentRow.NRVALORREFERENCIAM === "") {
                widget.currentRow.NRVALORREFERENCIAM = undefined;
            }
            if (widget.currentRow.NRESTRUTURAM === "") {
                widget.currentRow.NRESTRUTURAM = undefined;
            }
            restEngine.post('product#/cadAutoVincEvento', {'requestType': 'DataSet', 'dataset': [widget.currentRow]}).
                then(function (data) {
                    if (data.messages) {
                        ScreenService.showMessage(data.messages[0].message, data.messages[0].type);
                    }
                    else {
                        ScreenService.showMessage(Messages.CADASTRO_AUTOMATICO_SUCCESS, 'SUCCESS');
                        ScreenService.closePopup();
                        templateManager.container.getWidget('eventovinculo').activate();
                        templateManager.container.getWidget('eventovinculo').reload();
                    }
                }).
                catch(function(e) {
                    var error;
                    if(e.data.error === undefined)
                        error = e;
                    else
                        error = e.data.error;

                    ScreenService.showMessage(Messages.CATCH_EXCEPTION_ERROR(error), 'ERROR');
                });
        }
    };
    
    var openPopupMensagens = function(msg) {
        var widgetMensagens = templateManager.container.getWidget('mensagensCalculo');
        widgetMensagens.dataSource.data = msg;
        ScreenService.openPopup(widgetMensagens);
    };
    
    this.validaParcela = function(args){
        var widget = templateManager.container.getActiveWidget();
        if(widget.getField('IDREFGERAR').value() == "PARCELA" ){
            if(widget.currentRow.DTFIMVIGENCIA  == "" || widget.currentRow.DTFIMVIGENCIA  == null) 
            {
                ScreenService.showMessage("Para inserir um Tipo de Referência cujo valor seja igual a Parcela, favor selecionar uma data de Início e Fim de Vigência.");
                return;
            }else{
                this.salvar(args);
            }
        }else{
            this.salvar(args);
        }
    };

}

Configuration(function(ContextRegister) {
    ContextRegister.register('VinculoEventoController', VinculoEventoController);
});

// FILE: assets/js/controllers/WizardHcmController.js
/* jshint esversion: 6 */
function WizardHcmController(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, HcmRepository, ABUtilController, General, Messages, HcmConsts, $window) {
    
    /**
     *  Controller criado para o controle de funções básicas do tipo de widget 'wizard'
     *   
     * 
     */
     
    const self = this;
    
    this.enteredScreenAsStep = false;
    
    /**
     *  Default wizard on cancel
     * 
     *  @param args
     * 
     */
    this.wizardCancel = function (args, wizardMainWidgetName) {
        // Avoid the default Zeedhi redirect
        args.e.preventDefault();
        args.e.stopPropagation();
        
        ABUtilController.defaultConfirmationDialog(
            'Deseja realmente cancelar a realização do processo?',
            () => {
                ScreenService.openWindow('product#dashboard');
    		    this.enteredScreenAsStep = false;
    		    this.wizardCleanRows(wizardMainWidgetName);
            }
        );
    };
    
    /**
     *  Default wizard on finsh. Aciona uma callback passando a row das wigets de cada stage como parâmetro
     *  - Essa rotina considera para o retorno das rows, a definição do nome de cada widget dos passos na propriedade 'row_widgets' dentro de cada stage.
     *  - Essa rotina parte do pressuposto que a propriedade 'name' de cada stage é o mesmo 'name' do container de cada stage.
     * 
     * 
     *  @param  args
     *  @param  wizardMainWidgetName            [Nome da widget/container que define o wizard]
     *  @param  callBackAfterFinish
     *  @param  callBackLastStageValidations
     * 
     */
    this.wizardFinish = function (args, wizardMainWidgetName, callBackAfterFinish = function() {}, callBackLastStageValidations = function() { return true; }) {
        const wizardWidget = this.wizardGetWidget(wizardMainWidgetName);
        
        // Executa validações de proximo stage, considerando a ação está na última página
        const finishIsValid = this.wizardNextStage(args, wizardMainWidgetName, callBackLastStageValidations);
        if (!finishIsValid) {
            return false;
        }
        
        const row = this.wizardGetWidgetRows(wizardWidget);
        return callBackAfterFinish(row, this.wizardCleanRows);
    };
    
    /**
     *  Obtem as rows determinadas para cada stage. As rows são obtidas obtendo a widget informada no parâmetro 'row_widgets' de cada stage na widget principal.
     * 
     *  @param  wizardWidget    [Widget principal onde está definido o tipo 'wizard']
     * 
     */
    /* jshint ignore:start */
    this.wizardGetWidgetRows = function(wizardMainWidgetName) {
        const wizardWidgets = this.wizardGetWidgets(wizardMainWidgetName) || [];
        let row = {};
        
        for (const widget of wizardWidgets) {
            
            const widgetGridData = ABUtilController.isWidgetGrid(widget) ? widget.dataSource.data : [];
            if (widgetGridData.length > 0) {
                row = { ...row, [widget.name]: widgetGridData };
                
                // Delete circular properties
                for (const item of widgetGridData) {
                    item.__leftActions = null;
                    item.__rightActions = null;                
                }
                
                continue;
            }
            
            row = { ...row, ...(widget.currentRow ? widget.currentRow : {}) };
        }
        
        // Delete circular properties
        row.__leftActions = null;
        row.__rightActions = null;
        
        return row;
    };
    /* jshint ignore:end */
    
    /**
     *  Obtem as widgets para cada stage.
     * 
     *  @param  wizardWidget            [Widget principal onde está definido o tipo 'wizard']
     *  @param  filterWidgetCallback    [Callback que atua como filtro para as widgets buscadas]
     *      Parâmetros callback:
     *      @param  widget              [Widget]
     *      @param  wizardmainWidget    [Widget]
     * 
     */
    /* jshint ignore:start */
    this.wizardGetWidgets = function(wizardMainWidgetName, filterWidgetCallback = function() { return true; }) {
        const wizardWidget = this.wizardGetWidget(wizardMainWidgetName);
        const stages = wizardWidget.stages;
        if (!stages) {
            return false;
        }
        
        const widgets = [];
        
        for (const stageIndex in stages) {
            const stage = stages[stageIndex];
            const widgetNames = stage.row_widgets || [];
            for (const widgetName of widgetNames) {
                const container = templateManager.containers[stage.name];
                if (!container) {
                    continue;
                }
                
                const widget = container.getWidget(widgetName);
                if (!widget) {
                    continue;
                }
                
                if (!filterWidgetCallback(widget, stage)) {
                    continue;
                }
                
                widgets.push(widget);
            }
        }
        
        return widgets;
    };
    /* jshint ignore:end */
    
    /**
     *  Limpa as rows das widgets de cada stage.
     * 
     *  @param  wizardWidget    [Widget principal onde está definido o tipo 'wizard']
     * 
     */
    /* jshint ignore:start */
    this.wizardCleanRows = function(wizardMainWidgetName) {
        // Busca widgets definidas para serem limpas
        const wizardWidgets = self.wizardGetWidgets(
            wizardMainWidgetName,
            (widget, stage) => !stage.exclude_widgets_clear || !stage.exclude_widgets_clear.includes(widget.name)
        ) || [];
        
        for (const widget of wizardWidgets) {
            widget.currentRow = {};
            
            // Limpa data se grid
            if (ABUtilController.isWidgetGrid(widget)) {
                widget.dataSource.data = [];
            } else {
                // Apply default value nos Fields
                for (const field of widget.fields || []) {
                    field.applyDefaultValue();
                }
            }
        }
    };
    /* jshint ignore:end */
    
    /**
     *  Obtem a Widget/Container da widget. A rotina prevê que que a Widget principal do wizard pode ser um Container.
     * 
     *  @param  wizardWidget    [Widget principal onde está definido o tipo 'wizard']
     * 
     */
    this.wizardGetWidget = function(wizardMainWidgetName) {
        const containerName = 'product#' + wizardMainWidgetName;
        const wizardWidget = templateManager.containers[containerName] ? templateManager.containers[containerName] : templateManager.container.getWidget(wizardMainWidgetName);
        
        return wizardWidget;
    };
    
    /**
     *  Rotina que informa que a tela do stage foi acessada via tela principal. Isso impede que a tela de cada stage seja acessada individualmente.
     * 
     * 
     * 
     */
    this.setWizardEnteredAsStep = function() {
        this.enteredScreenAsStep = true;  
    };
    
    /**
     *  Rotina que checa se a tela de um stage foi acessada via tela principal ou individualemente, impedindo que a última condição seja possível.
     * 
     * 
     * 
     */
    this.wizardStepOnEnterCheck = function() {
        if (this.enteredScreenAsStep) {
            return;
        }
        
        ScreenService.openWindow('product#dashboard');
    };
    
    /**
     *  Default wizard on next stage. Rotina que faz a validação prévia de campos requeridos.
     *  - Essa rotina faz a validação dos campos requeridos e, por meio de uma callback, possibilita que demais validações também sejam feitas;
     *  - Essa rotina retorna uma callback que pode se utilizar dos seguintes parâmetros:
     *      @param  isWidgetValid   [Retorno do .isValid()]
     *      @param  stageRow        [Row do stage atual]
     *      @param  fullRow         [Row completa do wizard]
     *      @param  preventDefault  [Função que impede a passagem de stage]
     *      @param  widgets         [Array com as Widgets de cada stage]
     *      
     *  @param  args
     *  @param  wizardMainWidgetName
     *  @param  callBack
     * 
     */
    /* jshint ignore:start */
    this.wizardNextStage = function(args, wizardMainWidgetName, callBack = function() { return true; }) {
        const wizardWidget = this.wizardGetWidget(wizardMainWidgetName);
        const widgetNames = wizardWidget.currentStage.row_widgets;
        
        const widgets = [];
        
        let allWidgetsValid = true;
        let stageRow = {};
        
        for (const widgetName of widgetNames) {
            const widget = templateManager.container.getWidget(widgetName);
            if (!widget) {
                continue;
            }
            
            widgets.push(widget);
            
            // Widgets grid nao sao validadas
            const isWidgetValid = ABUtilController.isWidgetGrid(widget) || widget.isValid();
            
            // Impede que o stage seja passado se houverem campos required não preenchidos em uma das widgets
            if (!isWidgetValid) {
                args.e.preventDefault();
                allWidgetsValid = false;
            }
            
            // Obtem o data caso widget seja grid
            const widgetGridData = ABUtilController.isWidgetGrid(widget) ? widget.dataSource.data : [];
            if (widgetGridData.length > 0) {
                stageRow = { ...stageRow, [widget.name]: widgetGridData };
                continue;
            }
            
            stageRow = { ...stageRow, ...widget.currentRow };
        }
        
        if (!allWidgetsValid) {
            return false;
        }
        
        const fullRow = this.wizardGetWidgetRows(wizardMainWidgetName);
        
        return callBack(allWidgetsValid, stageRow, fullRow, args.e.preventDefault, widgets);
    };
    /* jshint ignore:end */
}
 
Configuration(function(ContextRegister) {
    ContextRegister.register('WizardHcmController', WizardHcmController);
});

// FILE: assets/js/decorators/ContainerDecorator.js
/**
 * Created by felipesantos on 08/11/2016.
 */
function ContainerDecorator(ZHPromise) {
    this.apply = function(containerName, container) {
        var defered = ZHPromise.defer();
        if (containerName && container && Util.isObject(container)) {
            var gridPreferencesTemplates = [
                "widget/master_detail/grid.html",
                "widget/grid.html"
            ];
            container.widgets.forEach(function(widget){
                if (gridPreferencesTemplates.indexOf(widget.template) >= 0 && Util.isUndefined(widget.floatingControl)) {
                    widget.floatingControl = {
                        "draggable": true,
                        "searchAction": true,
                        "customizationAction": {
                            "layout": true,
                            "filter": true,
                            "view" : true
                        }
                    };
                }
            });

            defered.resolve(container);
        }
        return defered.promise;
    };
}

Configuration(function(ContainerDecoratorProvider, ZHPromise) {
    ContainerDecoratorProvider.registerProvider(new ContainerDecorator(ZHPromise));
});

// FILE: assets/js/decorators/ContainerDecoratorFields.js
function ContainerDecoratorDeveloper(ZHPromise){
    var mappedFormats = {
        yy: 'YYYY',
        hh: 'hh',
        dd: 'DD',
        ii: 'mm',
        i: 'm',
        mm: 'MM',
        ss: 'ss',
        y: 'YYY',
        m: 'M',
        d: 'D',
        h: 'h',
        s: 's',
        H: 'H',
        D: 'ddd',
        M: 'MMM',
        DD: 'dddd',
        HH: 'HH',
        MM: 'MMMMM',
        a: 'a',
        A: 'A'
    };

    function translateZhDateToMobiscrollDate(input){
        Object.keys(mappedFormats).forEach(function(mobiFormat){
            input = input.replace(mappedFormats[mobiFormat], mobiFormat);
        });
        return input;
    }

    function getTemplateSimpleName(template){
        return template && template.split("/").pop();
    }

    function defineDatetimeProperty(field, propertyName){
        var datetimePropertyName = 'datetime-'.$propertyName;
        if(!field[datetimePropertyName] && field[propertyName]){
            field[datetimePropertyName] = translateZhDateToMobiscrollDate(field[propertyName]);
        }
    }
    
    function defineCalendarProperty(field, propertyName){
        if(!field[propertyName]){
            field[propertyName] = "DD/MM/YYYY";
        }
        /*
        if(field.filterProperties && field.filterProperties.template == "zh-interval-component#field/interval.html"){
            field.filterProperties.isVisible = false;
        }*/
    }
    
    function defineIntervalPropertyCaseCustom(field){
        field.template = "field/calendar.html";
        field.dateFormat = "DD/MM/YYYY";
        
        if(field.filterProperties == null || field.filterProperties == "")
            field.filterProperties = {template: "zh-interval-component#field/interval.html"};
        else
            field.filterProperties.template = "zh-interval-component#field/interval.html";
    }
    
    function defineCheckBoxProperty(field) {
        if(Util.isUndefined(field.valueToTrue)) {
            field.valueToTrue = "S";
            field.valueToFalse = "N";
        }
        
    }
    
    function defineAutoCompleteProperty(field, widget){
        var widgetName = ['envioCadastros', 'fpaItecalcfolha'];
        var events = []; 
        
        //alguns campos já tem um fieldBeforeSelectOpen; alguns dao reloads em outras funções
        
        if(widgetName.find(function(name){ return name == widget.name;})){
            events.push({
                          name: "FieldOnClick",
                          code: "ABUtilController.LoadDataAutoComplete(args.owner.field, false)"
                      });
        }else {
            events.push({
                            name: "FieldOnClick",
                            code: "ABUtilController.LoadDataAutoComplete(args.owner.field, true);"
                        },
                        {
                            name: 'FieldAfterSelectOpen',
                            code: 'ABUtilController.reactivateRefreshButton();'
                        },
                        {
                            name: 'WidgetPopUpOnCancel',
                            code: 'ABUtilController.deactivateRefreshButton();'
                        },
                        {
                            name: 'WidgetBeforeSelectRow',
                            code: 'ABUtilController.deactivateRefreshButton();'
                        });
        }
        
        if(!field.events || field.events.length === 0){
            field.events = events;
        }else{
            if(events.length >= 1){
                var eventsConcat = angular.copy(events);
                field.events.forEach(function(event){
                    if(event.name == 'FieldBeforeSelectOpen'){
                        event.code += ';' + events[0].code;
                        delete eventsConcat[0];
                    }else if(event.name == 'FieldAfterSelectOpen'){
                        event.code += ';' + events[1].code;
                        delete eventsConcat[1];
                    }else if (event.name == 'WidgetPopUpOnCancel'){
                        event.code += ';' + events[2].code;
                        delete eventsConcat[2];
                    }else if (event.name == 'WidgetBeforeSelectRow'){
                        event.code += ';' + events[3].code;
                        delete eventsConcat[3];
                    }
                });
                if(eventsConcat.length > 0){
                    eventsConcat.forEach(function(eventConcat){
                        field.events.push(eventConcat);
                    });
                }
            }else{
                var fieldFilter = field.events.find(function(ev){ return ev.name == 'FieldBeforeSelectOpen';}); 
                if(fieldFilter){
                    fieldFilter.code += ';' + events[0].code;
                } else {
                    field.events.push(event);
                }
            }
            // field.events.find(function(ev){ return ev.name == 'FieldBeforeSelectOpen';}) ? field.events.find(function(ev){ return ev.name == 'FieldBeforeSelectOpen';}).code += ';' + event.code : field.events.push(event);
        }
        
        if(!field.showSelectAs){
            field.showSelectAs = "grid";
        }
        
        field.defaultSearchField = "__ALL_MAP";
        field.itemsPerPage = 9999;
        field.hasPagination = false;
        field.searchWithPagination = false;
    }
    
    function defineMultipleProperty(field){
        
        field.defaultSearchField = "__ALL_MAP";
        field.itemsPerPage = 9999;
        field.hasPagination = false;
        field.searchWithPagination = false;
    }

    function correctDatetimeFields(widget){
        if(widget.fields){
            widget.fields.forEach(function(field){
                if(getTemplateSimpleName(field.template) == 'datetime.html'){
                    var w = widget;
                    defineDatetimeProperty(field, 'dateFormat');
                    defineDatetimeProperty(field, 'timeFormat');
                }
                if(getTemplateSimpleName(field.template) == 'calendar.html'){
                    defineCalendarProperty(field, 'dateFormat');
                }
                if(getTemplateSimpleName(field.template) == 'select-autocomplete.html'){
                    defineAutoCompleteProperty(field, widget);
                }
                if(getTemplateSimpleName(field.template) == 'select-multiple.html'){
                    defineMultipleProperty(field);
                }
                if(getTemplateSimpleName(field.template) == 'interval.html'){
                    defineIntervalPropertyCaseCustom(field);
                }
                if(getTemplateSimpleName(field.template) == 'checkbox.html'){
                    defineCheckBoxProperty(field);
                }
            }.bind(this));
        }
    }
    

    this.apply = function(containerName, container){
        var _eachWidget = function(widget, fn){
            fn(widget);
            widget.itemsPerPage = 9999;
            widget.hasPagination = false;
            widget.searchWithPagination = false;
            
            if(widget.widgets){
                widget.widgets.forEach(function(widget){
                    _eachWidget(widget, fn);
                });
            }
        };

        if(container.widgets){
            container.widgets.forEach(function(widget){
                _eachWidget(widget, correctDatetimeFields);
            });
        }

        return ZHPromise.when(container);
    };
}

ZeedhiApp.run(function(ContainerDecoratorProvider, ZHPromise){
    ContainerDecoratorProvider.registerProvider(new ContainerDecoratorDeveloper(ZHPromise));
});
